package ai;

import l2r.gameserver.ai.CtrlEvent;
import l2r.gameserver.ai.Fighter;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Spawn;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.tables.NpcTable;
import l2r.util.Rnd;

/**
 * @author Diamond
 */
public class AngerOfSplendor extends Fighter
{
	public AngerOfSplendor(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, int damage)
	{
		try
		{
			if(Rnd.chance(25))
			{
				L2Spawn spawn = new L2Spawn(NpcTable.getTemplate(21528));
				spawn.setLoc(_thisActor.getLoc());
				L2NpcInstance npc = spawn.doSpawn(true);
				npc.getAI().notifyEvent(CtrlEvent.EVT_ATTACKED, attacker, 100);
				_thisActor.decayMe();
				_thisActor.doDie(_thisActor);
				return;
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		super.onEvtAttacked(attacker, damage);
	}
}