package ai;

import l2r.extensions.scripts.Functions;
import l2r.gameserver.ai.Ranger;
import l2r.gameserver.model.L2Character;
import l2r.util.Rnd;

/**
 * AI для Delu Lizardman Special Agent ID: 21105
 *
 * @author Diamond
 */
public class DeluLizardmanSpecialAgent extends Ranger
{
	private boolean _firstTimeAttacked = true;

	public DeluLizardmanSpecialAgent(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, int damage)
	{
		if(_firstTimeAttacked)
		{
			_firstTimeAttacked = false;
			if(Rnd.chance(25))
				Functions.npcShout(_thisActor, "How dare you interrupt our fight! Hey guys, help!");
		}
		else if(Rnd.chance(10))
			Functions.npcShout(_thisActor, "Hey! Were having a duel here!");
		super.onEvtAttacked(attacker, damage);
	}

	@Override
	protected void onEvtDead()
	{
		_firstTimeAttacked = true;
		super.onEvtDead();
	}
}