package ai;

import l2r.extensions.scripts.Functions;
import l2r.gameserver.ai.DefaultAI;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.tables.SkillTable;
import l2r.util.Rnd;

public class EvilNpc extends DefaultAI
{
	private long _lastAction;
	private static String[] _txt = {
			"отстань!",
			"уймись!",
			"я тебе отомщу, потом будешь прощения просить!",
			"у тебя будут неприятности!",
			"я на тебя пожалуюсь, тебя арестуют!" };

	public EvilNpc(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, int damage)
	{
		if(attacker == null || attacker.getPlayer() == null)
			return;

		_actor.startAttackStanceTask();

		// Ругаемся и кастуем скилл не чаще, чем раз в 3 секунды
		if(System.currentTimeMillis() - _lastAction > 3000)
		{
			int chance = Rnd.get(0, 100);
			if(chance < 2)
			{
				attacker.getPlayer().setKarma(attacker.getPlayer().getKarma() + 5);
				attacker.sendChanges();
			}
			else if(chance < 4)
				_actor.doCast(SkillTable.getInstance().getInfo(4578, 1), attacker, true); // Petrification
			else
				_actor.doCast(SkillTable.getInstance().getInfo(4185, 7), attacker, true); // Sleep

			Functions.npcShout(_thisActor, attacker.getName() + ", " + _txt[Rnd.get(_txt.length)]);
			_lastAction = System.currentTimeMillis();
		}
	}
}