package ai;

import static l2r.gameserver.ai.CtrlIntention.AI_INTENTION_ACTIVE;
import l2r.extensions.scripts.Functions;
import l2r.gameserver.ai.CtrlIntention;
import l2r.gameserver.ai.Mystic;
import l2r.gameserver.geodata.network.geoclient.GeoClient;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Playable;

/**
 * AI охраны входа в Pagan Temple.<br>
 * <li>кидаются на всех игроков, у которых в кармане нету предмета 8064 или 8067
 * <li>не умеют ходить
 *
 * @author SYS
 */
public class GatekeeperZombie extends Mystic
{
	public GatekeeperZombie(L2Character actor)
	{
		super(actor);
		_actor.setImobilised(true);
	}

	@Override
	public void checkAggression(L2Character target)
	{
		if(!(target instanceof L2Playable))
			return;

		if(_intention != AI_INTENTION_ACTIVE)
			return;
		if(_globalAggro < 0)
			return;
		if(!_thisActor.isInRange(target, _thisActor.getAggroRange()))
			return;
		if(Math.abs(target.getZ() - _actor.getZ()) > 400)
			return;
		if(Functions.getItemCount((L2Playable) target, 8067) != 0 || Functions.getItemCount((L2Playable) target, 8064) != 0)
			return;
		if(!GeoClient.getInstance().canSeeTarget(_actor, target))
			return;
		target.addDamageHate(_thisActor, 0, 1);
		setIntention(CtrlIntention.AI_INTENTION_ATTACK, target);
	}

	@Override
	protected boolean randomWalk()
	{
		return false;
	}
}