package ai;

import javolution.util.FastList;

import l2r.gameserver.ai.Fighter;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Effect;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.tables.SkillTable;
import l2r.util.Rnd;

/**
 * AI for Hot Springs Nepenthes (id 21319)
 *
 * @author Diamond
 */
public class HotSpringsNepenthes extends Fighter
{
	private static final Integer DeBuff = 4552;

	public HotSpringsNepenthes(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, int damage)
	{
		if(attacker != null)
			if(Rnd.chance(10))
			{
				FastList<L2Effect> effect = attacker.getEffectsBySkillId(DeBuff);
				if(effect != null)
				{
					int level = effect.getFirst().getSkill().getLevel();
					if(level < 10)
					{
						effect.getFirst().exit();
						L2Skill skill = SkillTable.getInstance().getInfo(DeBuff, level + 1);
						skill.getEffects(_actor, attacker, false);
					}
				}
				else
				{
					L2Skill skill = SkillTable.getInstance().getInfo(DeBuff, 1);
					skill.getEffects(_actor, attacker, false);
				}
			}
		super.onEvtAttacked(attacker, damage);
	}
}