package ai;

import l2r.gameserver.ai.Mystic;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Playable;

/**
 * AI охраны в Pagan Temple.<br>
 * <li>Не умеют ходить
 * <li>Видит всех в режиме Silent Move
 * <li>Бьют физ атакой игроков, подошедших на расстояние удара
 * <li>Бьют магией, если были атакованы
 * <li>Социальны к собратьям, помогают атакуя магией
 * <li>В случае, если игрок вышел за пределы агро радиуса прекращают использовать дальнобойную магию
 *
 * @author SYS
 */
public class PaganGuard extends Mystic
{
	public PaganGuard(L2Character actor)
	{
		super(actor);
		_actor.setImobilised(true);
	}

	@Override
	protected boolean checkTarget(L2Character target, int range)
	{
		if(!_thisActor.isInRange(target, _thisActor.getAggroRange()))
		{
			target.removeFromHatelist(_thisActor);
			return false;
		}
		return super.checkTarget(target, range);
	}

	@Override
	protected boolean isSilentMoveNotVisible(L2Playable target)
	{
		return false;
	}

	@Override
	protected boolean randomWalk()
	{
		return false;
	}
}