package ai;

import l2r.gameserver.ai.CtrlEvent;
import l2r.gameserver.ai.Fighter;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Spawn;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.tables.NpcTable;

/**
 * AI полиморфного шамана ID: 21258, превращающегося в тигра ID: 21259 при ударе
 *
 * @author SYS
 */
public class PolimorphingShaman extends Fighter
{
	private static final int TIGER_ID = 21259;

	public PolimorphingShaman(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, int damage)
	{
		try
		{
			L2Spawn spawn = new L2Spawn(NpcTable.getTemplate(TIGER_ID));
			spawn.setLoc(_thisActor.getLoc());
			L2NpcInstance npc = spawn.doSpawn(true);
			npc.getAI().notifyEvent(CtrlEvent.EVT_ATTACKED, attacker, 100);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}

		_thisActor.decayMe();
		_thisActor.doDie(_thisActor);
	}
}