package ai;

import l2r.gameserver.ai.CtrlEvent;
import l2r.gameserver.geodata.network.geoclient.GeoClient;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Spawn;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.tables.NpcTable;
import l2r.util.Rnd;

/**
 * @author Diamond
 */
public class WailingOfSplendor extends RndTeleportFighter
{
	private boolean _spawned;
	
	public WailingOfSplendor(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, int damage)
	{
		try
		{
			if(!_spawned && Rnd.chance(25))
			{
				_spawned = true;
				L2Spawn spawn = new L2Spawn(NpcTable.getTemplate(21540));
				spawn.setLoc(GeoClient.getInstance().findPointToStay(_thisActor.getX(), _thisActor.getY(), _thisActor.getZ(), 100, 150));
				L2NpcInstance npc = spawn.doSpawn(true);
				npc.getAI().notifyEvent(CtrlEvent.EVT_ATTACKED, attacker, 100);
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		super.onEvtAttacked(attacker, damage);
	}
	
	@Override
	protected void onEvtDead()
	{
		_spawned = false;
		super.onEvtDead();
	}
}