package commands.admin;

import java.util.StringTokenizer;

import l2r.extensions.multilang.CustomMessage;
import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.ThreadPoolManager;
import l2r.gameserver.handler.AdminCommandHandler;
import l2r.gameserver.handler.IAdminCommandHandler;
import l2r.gameserver.loginservercon.LSConnection;
import l2r.gameserver.loginservercon.gspackets.ChangeAccessLevel;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2World;
import l2r.gameserver.tables.ReflectionTable;
import l2r.util.AutoBan;
import l2r.util.Location;

public class AdminBan implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = {
			"admin_ban",
			"admin_unban",
			"admin_chatban",
			"admin_ckarma",
			"admin_cban",
			"admin_chatunban",
			"admin_acc_ban",
			"admin_acc_unban",
			"admin_jail" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().CanBan)
			return false;

		if(command.startsWith("admin_ban"))
		{
			StringTokenizer st = new StringTokenizer(command);
			try
			{
				st.nextToken();

				String player = st.nextToken();

				int time = 0;
				String bmsg = "";
				String msg = "";

				if(st.hasMoreTokens())
					time = Integer.parseInt(st.nextToken());

				if(st.hasMoreTokens())
				{
					bmsg = "admin_ban " + player + " " + time + " ";
					msg = command.substring(bmsg.length(), command.length());
				}

				L2Player plyr = L2World.getPlayer(player);
				if(plyr != null)
				{
					plyr.sendMessage(new CustomMessage("scripts.commands.admin.AdminBan.YoureBannedByGM", plyr).addString(activeChar.getName()));
					plyr.setAccessLevel(-100);
					AutoBan.Banned(plyr, time, msg, activeChar.getName());
					plyr.logout(false, false, true);
					activeChar.sendMessage("You banned " + plyr.getName());
				}
				else if(AutoBan.Banned(player, -100, time, msg, activeChar.getName()))
					activeChar.sendMessage("You banned " + player);
				else
					activeChar.sendMessage("Can't find char: " + player);
			}
			catch(Exception e)
			{
				activeChar.sendMessage("Command syntax: //ban char_name period reason");
			}
		}
		else if(command.startsWith("admin_unban"))
		{
			StringTokenizer st = new StringTokenizer(command);
			if(st.countTokens() > 1)
			{
				st.nextToken();
				String player = st.nextToken();
				/*L2Player plyr = L2World.getPlayer(player);
				if(plyr != null)
				{
					LSConnection.getInstance().sendPacket(new ChangeAccessLevel(plyr.getAccountName(), 0, "command admin_unban", 0));
					activeChar.sendMessage("You unbanned " + player);
				}*/
				if(AutoBan.Banned(player, 0, 0, "", activeChar.getName()))
					activeChar.sendMessage("You unbanned " + player);
				else
					activeChar.sendMessage("Can't find char: " + player);
			}
		}
		else if(command.startsWith("admin_acc_ban"))
		{
			StringTokenizer st = new StringTokenizer(command);
			if(st.countTokens() > 1)
			{
				st.nextToken();
				int time = 0;
				String account = st.nextToken();
				if(st.hasMoreTokens())
					time = Integer.parseInt(st.nextToken());
				LSConnection.getInstance().sendPacket(new ChangeAccessLevel(account, -100, "command admin_unban", time));
				activeChar.sendMessage("You unbanned " + account);
			}
		}
		else if(command.startsWith("admin_acc_unban"))
		{
			StringTokenizer st = new StringTokenizer(command);
			if(st.countTokens() > 1)
			{
				st.nextToken();
				String account = st.nextToken();
				LSConnection.getInstance().sendPacket(new ChangeAccessLevel(account, 0, "command admin_acc_unban", 0));
				activeChar.sendMessage("You unbanned " + account);
			}
		}
		else if(command.startsWith("admin_chatban"))
		{
			StringTokenizer st = new StringTokenizer(command);
			try
			{
				st.nextToken();
				String player = st.nextToken();
				String srok = st.nextToken();
				String bmsg = "admin_chatban " + player + " " + srok + " ";
				String msg = command.substring(bmsg.length(), command.length());

				if(AutoBan.ChatBan(player, Integer.parseInt(srok), msg, activeChar.getName()))
					activeChar.sendMessage("You ban chat for " + player + ".");
				else
					activeChar.sendMessage("Can't find char " + player + ".");
			}
			catch(Exception e)
			{
				activeChar.sendMessage("Command syntax: //chatban char_name period reason");
				e.printStackTrace();
			}
		}
		else if(command.startsWith("admin_chatunban"))
		{
			StringTokenizer st = new StringTokenizer(command);
			try
			{
				st.nextToken();
				String player = st.nextToken();

				if(AutoBan.ChatUnBan(player, activeChar.getName()))
					activeChar.sendMessage("You unban chat for " + player + ".");
				else
					activeChar.sendMessage("Can't find char " + player + ".");
			}
			catch(Exception e)
			{
				activeChar.sendMessage("Command syntax: //chatunban char_name");
				e.printStackTrace();
			}
		}
		else if(command.startsWith("admin_jail"))
		{
			StringTokenizer st = new StringTokenizer(command);
			try
			{
				st.nextToken();
				String player = st.nextToken();
				String srok = st.nextToken();

				L2Player target = L2World.getPlayer(player);

				if(target != null)
				{
					target.setVar("jailedFrom", target.getX() + ";" + target.getY() + ";" + target.getZ() + ";" + target.getReflection());
					target._unjailTask = ThreadPoolManager.getInstance().scheduleGeneral(target.new TeleportTask(target.getLoc(), -3), Integer.parseInt(srok) * 60000);
					target.setVar("jailed", srok);
					target.teleToLocation(-114648, -249384, -2984);
					activeChar.sendMessage("You jailed " + player + ".");
				}
				else
					activeChar.sendMessage("Can't find char " + player + ".");
			}
			catch(Exception e)
			{
				activeChar.sendMessage("Command syntax: //jail char_name period");
				e.printStackTrace();
			}
		}
		else if(command.startsWith("admin_unjail"))
		{
			StringTokenizer st = new StringTokenizer(command);
			try
			{
				st.nextToken();
				String player = st.nextToken();

				L2Player target = L2World.getPlayer(player);

				if(target != null && target.getVar("jailed") != null)
				{
					String[] re = target.getVar("jailedFrom").split(";");
					target.teleToLocation(Integer.parseInt(re[0]), Integer.parseInt(re[1]), Integer.parseInt(re[2]));
					target.setReflection(re.length > 3 ? Integer.parseInt(re[3]) : 0);
					target._unjailTask.cancel(true);
					target.unsetVar("jailedFrom");
					target.unsetVar("jailed");
					activeChar.sendMessage("You unjailed " + player + ".");
				}
				else
					activeChar.sendMessage("Can't find char " + player + ".");
			}
			catch(Exception e)
			{
				activeChar.sendMessage("Command syntax: //unjail char_name");
				e.printStackTrace();
			}
		}
		else if(command.startsWith("admin_ckarma"))
		{
			StringTokenizer st = new StringTokenizer(command);
			try
			{
				st.nextToken();
				String player = st.nextToken();
				String srok = st.nextToken();
				String bmsg = "admin_ckarma " + player + " " + srok + " ";
				String msg = command.substring(bmsg.length(), command.length());

				L2Player plyr = L2World.getPlayer(player);
				if(plyr != null)
				{
					int newKarma = Integer.parseInt(srok) + plyr.getKarma();

					// update karma
					plyr.setKarma(newKarma);

					plyr.sendMessage("You get karma(" + srok + ") by GM " + activeChar.getName());
					AutoBan.Karma(plyr, Integer.parseInt(srok), msg, activeChar.getName());
					activeChar.sendMessage("You set karma(" + srok + ") " + plyr.getName());
				}
				else if(AutoBan.Karma(player, Integer.parseInt(srok), msg, activeChar.getName()))
					activeChar.sendMessage("You set karma(" + srok + ") " + player);
				else
					activeChar.sendMessage("Can't find char: " + player);
			}
			catch(Exception e)
			{
				activeChar.sendMessage("Command syntax: //ckarma char_name karma reason");
			}
		}
		else if(command.startsWith("admin_cban"))
			AdminHelpPage.showHelpPage(activeChar, "cban.htm");

		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
		// init jail reflection
		ReflectionTable.getInstance().getById(-3, true).setCore(new Location(-114648, -249384, -2984));
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] {
				"file://com_ban.htm",
				"file://com_unban.htm",
				"file://com_chatban.htm",
				"file://com_ckarma.htm",
				"file://com_cban.htm",
				"No help",
				"No help",
				"No help",
				"No help" };

	}

	public String[] getCommandGroup()
	{
		return new String[] {
				AdminCommandHandler.GROUP_BANS,
				AdminCommandHandler.GROUP_BANS,
				AdminCommandHandler.GROUP_BANS,
				AdminCommandHandler.GROUP_BANS,
				AdminCommandHandler.GROUP_BANS,
				AdminCommandHandler.GROUP_BANS,
				AdminCommandHandler.GROUP_BANS,
				AdminCommandHandler.GROUP_BANS,
				AdminCommandHandler.GROUP_BANS };
	}
}