package commands.admin;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.handler.AdminCommandHandler;
import l2r.gameserver.handler.IAdminCommandHandler;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2World;

/**
 * This class handles following admin commands: - invul = turns invulnerability
 * on/off
 */
public class AdminChangeAccessLevel implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = { "admin_changelvl" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().CanGmEdit)
			return false;
		handleChangeLevel(command, activeChar);
		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	private void handleChangeLevel(String command, L2Player admin)
	{
		String[] parts = command.split(" ");
		if(parts.length == 2)
		{
			int lvl = Integer.parseInt(parts[1]);
			if(admin.getTarget().isPlayer)
				((L2Player) admin.getTarget()).setAccessLevel(lvl);
		}
		else if(parts.length == 3)
		{
			int lvl = Integer.parseInt(parts[2]);
			L2Player player = L2World.getPlayer(parts[1]);
			if(player != null)
				player.setAccessLevel(lvl);
		}
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "file://com_changelvl.htm" };
	}

	public String[] getCommandGroup()
	{
		return new String[] { AdminCommandHandler.GROUP_EDITCHAR };
	}
}