package commands.admin;

import l2r.Config;
import l2r.extensions.multilang.CustomMessage;
import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.Announcements;
import l2r.gameserver.handler.AdminCommandHandler;
import l2r.gameserver.handler.IAdminCommandHandler;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2World;
import l2r.util.Log;

import java.util.StringTokenizer;

public class AdminNochannel implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = { "admin_nochannel" };
	private static Boolean announce_ = Config.MAT_ANNOUNCE;
	private static Boolean announce_nick_ = Config.MAT_ANNOUNCE_NICK;

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().CanBanChat)
			return false;

		if(command.startsWith("admin_nochannel"))
		{
			StringTokenizer st = new StringTokenizer(command);

			if(st.countTokens() > 1)
			{
				st.nextToken();
				String player = st.nextToken();
				L2Player plr = L2World.getPlayer(player);

				if(plr != null)
				{
					int timeval = 30; // if no args, then 30 min default.
					String reason = "не указана"; // if no args, then "не указана" default.

					if(st.countTokens() >= 1)
					{
						String time = st.nextToken();
						timeval = Integer.parseInt(time);
					}

					if(st.countTokens() >= 1)
					{
						reason = st.nextToken();
						while(st.hasMoreTokens())
							reason += " " + st.nextToken();
					}

					Announcements sys = new Announcements();
					if(timeval == 0)
					{
						if(announce_)
							if(!announce_nick_)
								sys.announceToAll(activeChar.getName() + " снял бан чата с игрока " + plr.getName() + ".");
							else
								sys.announceToAll("С игрока " + plr.getName() + " снят бан чата.");
						activeChar.sendMessage("Вы сняли бан чата с игрока " + plr.getName() + ".");
						Log.add(activeChar.getName() + " снял бан чата с игрока " + plr.getName() + ".", "banchat", activeChar);
					}
					else if(timeval < 0)
					{
						if(announce_)
							if(!announce_nick_)
								sys.announceToAll(activeChar.getName() + " забанил чат игроку " + plr.getName() + " на бессрочный период, причина: " + reason + ".");
							else
								sys.announceToAll("Забанен чат игроку " + plr.getName() + " на бессрочный период, причина: " + reason + ".");
						activeChar.sendMessage("Вы забанили чат игроку " + plr.getName() + " на бессрочный период, причина: " + reason + ".");
						Log.add(activeChar.getName() + " забанил чат игроку " + plr.getName() + " на бессрочный период, причина: " + reason + ".", "banchat", activeChar);
					}
					else
					{
						if(announce_)
							if(!announce_nick_)
								sys.announceToAll(activeChar.getName() + " забанил чат игроку " + plr.getName() + " на " + timeval + " минут, причина: " + reason + ".");
							else
								sys.announceToAll("Забанен чат игроку " + plr.getName() + " на " + timeval + " минут, причина: " + reason + ".");
						activeChar.sendMessage("Вы забанили чат игроку " + plr.getName() + " на " + timeval + " минут, причина: " + reason + ".");
						Log.add(activeChar.getName() + " забанил чат игроку " + plr.getName() + " на " + timeval + " минут, причина: " + reason + ".", "banchat", activeChar);
					}
					updateNoChannel(plr, timeval);
				}
				else
					activeChar.sendMessage("Игрок " + player + " не найден.");
			}
		}
		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	private void updateNoChannel(L2Player player, int time)
	{
		player.updateNoChannel(time * 60000);
		if(time == 0)
			player.sendMessage(new CustomMessage("common.ChatUnBanned", player));
		else if(time > 0)
			player.sendMessage(new CustomMessage("common.ChatBanned", player).addNumber(time));
		else
			player.sendMessage(new CustomMessage("common.ChatBannedPermanently", player));
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "admin_nochannel" };
	}

	public String[] getCommandGroup()
	{
		return new String[] { AdminCommandHandler.GROUP_EDITCHAR };
	}
}
