package commands.admin;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.cache.Msg;
import l2r.gameserver.handler.AdminCommandHandler;
import l2r.gameserver.handler.IAdminCommandHandler;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Object;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.serverpackets.MagicSkillUse;
import l2r.gameserver.serverpackets.SetupGauge;

import java.util.StringTokenizer;

public class AdminPolymorph implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = { "admin_polymorph", "admin_unpolymorph", "admin_poly", "admin_unpoly" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().CanPolymorph)
			return false;

		if(command.startsWith("admin_polymorph") || command.startsWith("admin_poly"))
		{
			StringTokenizer st = new StringTokenizer(command);

			try
			{
				st.nextToken();
				String id = st.nextToken();
				String type;

				if(st.hasMoreTokens())
					type = st.nextToken();
				else
					type = "npc";

				L2Object target = activeChar.getTarget();

				if(target != null)
				{
					target.setPolyInfo(type, id);
					if(target.isCharacter)
					{
						L2Character Char = (L2Character) target;
						Char.broadcastPacket(new MagicSkillUse(Char, Char, 1008, 1, 1000, 0));
						Char.sendPacket(new SetupGauge(0, 1000));
					}
					target.decayMe();
					target.spawnMe(target.getLoc());
				}
				else
					activeChar.sendPacket(Msg.INCORRECT_TARGET);
			}
			catch(Exception e)
			{}
		}
		else if(command.equals("admin_unpolymorph") || command.equals("admin_unpoly"))
		{
			L2Object target = activeChar.getTarget();

			if(target != null)
			{
				target.setPolyInfo(null, "0");
				if(target.isCharacter)
				{
					L2Character Char = (L2Character) target;
					Char.broadcastPacket(new MagicSkillUse(Char, Char, 1008, 1, 1000, 0));
					Char.sendPacket(new SetupGauge(0, 1000));
				}
				target.decayMe();
				target.spawnMe(target.getLoc());
			}
			else
				activeChar.sendPacket(Msg.INCORRECT_TARGET);
		}
		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "Описание команды polymorph", "Описание команды unpolymorph", "Описание команды poly", "Описание команды unpoly" };
	}

	public String[] getCommandGroup()
	{
		return new String[] {
				AdminCommandHandler.GROUP_MANAGESERVER4,
				AdminCommandHandler.GROUP_MANAGESERVER4,
				AdminCommandHandler.GROUP_MANAGESERVER4,
				AdminCommandHandler.GROUP_MANAGESERVER4 };
	}
}