package commands.admin;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.handler.AdminCommandHandler;
import l2r.gameserver.handler.IAdminCommandHandler;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.serverpackets.NpcHtmlMessage;

import java.io.File;
import java.io.FileInputStream;

/**
 * This class handles following admin commands: - help path = shows
 * /data/html/admin/path file to char, should not be used by GM's directly
 */
public class AdminRide implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = { "admin_ride" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().Menu)
			return false;

		if(command.startsWith("admin_ride"))
			try
			{
				String val = command.substring(11);
				showRide(activeChar, val);
			}
			catch(StringIndexOutOfBoundsException e)
			{
				// case of empty filename
			}

		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	// FIXME: implement method to send html to player in L2Player directly
	// PUBLIC & STATIC so other classes from package can include it directly
	public static void showRide(L2Player targetChar, String filename)
	{
		File file = new File("./", "data/html/admin/" + filename);
		FileInputStream fis = null;

		try
		{
			fis = new FileInputStream(file);
			byte[] raw = new byte[fis.available()];
			fis.read(raw);

			String content = new String(raw, "UTF-8");

			NpcHtmlMessage adminReply = new NpcHtmlMessage(5);

			adminReply.setHtml(content);
			targetChar.sendPacket(adminReply);
		}
		catch(Exception e)
		{
			// problem with adminride is ignored
		}
		finally
		{
			try
			{
				if(fis != null)
					fis.close();
			}
			catch(Exception e1)
			{
				// problems ignored
			}
		}
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "admin_ride" };
	}

	public String[] getCommandGroup()
	{
		return new String[] { AdminCommandHandler.GROUP_EDITCHAR };
	}
}