package commands.admin;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.handler.AdminCommandHandler;
import l2r.gameserver.handler.IAdminCommandHandler;
import l2r.gameserver.model.L2Player;

public class AdminRideWyvern implements IAdminCommandHandler, ScriptFile
{
	private static final String[] ADMIN_COMMANDS = {
			"admin_ride_wyvern",
			"admin_ride_strider",
			"admin_unride_wyvern",
			"admin_unride_strider",
			"admin_unride",
			"admin_wr",
			"admin_sr",
			"admin_ur" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().Rider)
			return false;

		if(command.startsWith("admin_ride_wyvern") || command.startsWith("admin_wr"))
		{
			if(activeChar.isMounted() || activeChar.getPet() != null)
			{
				activeChar.sendMessage("Already Have a Pet or Mounted.");
				return false;
			}
			activeChar.setMount(12621, 0);
		}
		else if(command.startsWith("admin_ride_strider") || command.startsWith("admin_sr"))
		{
			if(activeChar.isMounted() || activeChar.getPet() != null)
			{
				activeChar.sendMessage("Already Have a Pet or Mounted.");
				return false;
			}
			activeChar.setMount(12526, 0);
		}
		else if(command.startsWith("admin_unride") || command.startsWith("admin_ur"))
			activeChar.setMount(0, 0);

		return true;
	}

	public String[] getAdminCommandList()
	{
		return ADMIN_COMMANDS;
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] {
				"Описание команды ride_wyvern",
				"Описание команды ride_strider",
				"Описание команды unride_wyvern",
				"Описание команды unride_strider",
				"Описание команды unride",
				"Описание команды wr",
				"Описание команды sr",
				"Описание команды ur" };
	}

	public String[] getCommandGroup()
	{
		return new String[] {
				AdminCommandHandler.GROUP_EDITCHAR,
				AdminCommandHandler.GROUP_EDITCHAR,
				AdminCommandHandler.GROUP_EDITCHAR,
				AdminCommandHandler.GROUP_EDITCHAR,
				AdminCommandHandler.GROUP_EDITCHAR,
				AdminCommandHandler.GROUP_EDITCHAR,
				AdminCommandHandler.GROUP_EDITCHAR,
				AdminCommandHandler.GROUP_EDITCHAR };
	}
}
