package commands.admin;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.handler.AdminCommandHandler;
import l2r.gameserver.handler.IAdminCommandHandler;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.entity.SevenSigns;

import java.util.StringTokenizer;

public class AdminSS implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = { "admin_ssq_change", "admin_ssq_time" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().CanUseGMCommand)
			return false;

		if(command.startsWith("admin_ssq_change"))
		{
			StringTokenizer st = new StringTokenizer(command);

			if(st.countTokens() > 2)
			{
				st.nextToken();
				int period = Integer.parseInt(st.nextToken());
				int minutes = Integer.parseInt(st.nextToken());
				SevenSigns.getInstance().changePeriod(period, minutes * 60);
			}
			else if(st.countTokens() > 1)
			{
				st.nextToken();
				int period = Integer.parseInt(st.nextToken());
				SevenSigns.getInstance().changePeriod(period);
			}
			else
				SevenSigns.getInstance().changePeriod();
		}
		if(command.startsWith("admin_ssq_time"))
		{
			StringTokenizer st = new StringTokenizer(command);

			if(st.countTokens() > 1)
			{
				st.nextToken();
				int time = Integer.parseInt(st.nextToken());
				SevenSigns.getInstance().setTimeToNextPeriodChange(time);
			}
		}
		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "Описание команды ssq_change", "Описание команды ssq_time" };
	}

	public String[] getCommandGroup()
	{
		return new String[] { AdminCommandHandler.GROUP_MANAGESERVER6, AdminCommandHandler.GROUP_MANAGESERVER6 };
	}
}