package commands.admin;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.handler.AdminCommandHandler;
import l2r.gameserver.handler.IAdminCommandHandler;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.serverpackets.NpcHtmlMessage;

import java.io.File;
import java.io.FileInputStream;
import java.util.StringTokenizer;

/**
 * This class handles following admin commands: - help path = shows
 * /data/html/admin/path file to char, should not be used by GM's directly
 */
public class AdminServer implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = { "admin_server", "admin_gc", "admin_test" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().Menu)
			return false;

		if(command.startsWith("admin_server"))
			try
			{
				String val = command.substring(13);
				showHelpPage(activeChar, val);
			}
			catch(StringIndexOutOfBoundsException e)
			{
				// case of empty filename
			}
		else if(command.startsWith("admin_gc"))
		{
			try
			{
				System.gc();
				Thread.sleep(1000L);
				System.gc();
				Thread.sleep(1000L);
				System.gc();
			}
			catch(Exception e)
			{}
			activeChar.sendMessage("OK! - garbage collector called.");
		}
		else if(command.startsWith("admin_test"))
		{
			StringTokenizer st = new StringTokenizer(command);
			st.nextToken(); //skip command
			@SuppressWarnings("unused")
			String val1 = null;
			if(st.hasMoreTokens())
				val1 = st.nextToken();
			@SuppressWarnings("unused")
			String val2 = null;
			if(st.hasMoreTokens())
				val2 = st.nextToken();

			// Сюда пихать тестовый код
			/*try
			{
				activeChar.sendPacket(new SSQInfo(Integer.parseInt(val1), Integer.parseInt(val2)));
			}
			catch(NumberFormatException e)
			{
				e.printStackTrace();
			}
			// тут тестовый код кончается*/
			activeChar.sendMessage("Test.");
		}

		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	// FIXME: implement method to send html to player in L2Player directly
	// PUBLIC & STATIC so other classes from package can include it directly
	public static void showHelpPage(L2Player targetChar, String filename)
	{
		File file = new File("./", "data/html/admin/" + filename);
		FileInputStream fis = null;

		try
		{
			fis = new FileInputStream(file);
			byte[] raw = new byte[fis.available()];
			fis.read(raw);

			String content = new String(raw, "UTF-8");

			NpcHtmlMessage adminReply = new NpcHtmlMessage(5);

			adminReply.setHtml(content);
			targetChar.sendPacket(adminReply);
		}
		catch(Exception e)
		{
			// problem with adminserver is ignored
		}
		finally
		{
			try
			{
				if(fis != null)
					fis.close();
			}
			catch(Exception e1)
			{
				// problems ignored
			}
		}
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "Описание команды server", "Описание команды gc", "Описание команды test" };
	}

	public String[] getCommandGroup()
	{
		return new String[] { AdminCommandHandler.GROUP_MANAGESERVER5, AdminCommandHandler.GROUP_MANAGESERVER5, AdminCommandHandler.GROUP_MANAGESERVER5 };
	}
}