package commands.admin;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.TradeController;
import l2r.gameserver.handler.AdminCommandHandler;
import l2r.gameserver.handler.IAdminCommandHandler;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2TradeList;
import l2r.gameserver.model.L2World;
import l2r.gameserver.serverpackets.BuyList;

/**
 * This class handles following admin commands: - gmshop = shows menu - buy id =
 * shows shop with respective id
 */
public class AdminShop implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = { "admin_buy", "admin_gmshop", "admin_tax" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().UseGMShop)
			return false;

		if(command.startsWith("admin_buy"))
			try
			{
				handleBuyRequest(activeChar, command.substring(10));
			}
			catch(IndexOutOfBoundsException e)
			{
				activeChar.sendMessage("Please specify buylist.");
			}
		else if(command.equals("admin_gmshop"))
			AdminHelpPage.showHelpPage(activeChar, "gmshops.htm");
		else if(command.equals("admin_tax"))
			activeChar.sendMessage("TaxSum: " + L2World.getTaxSum());

		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	private void handleBuyRequest(L2Player activeChar, String command)
	{
		int val = -1;

		try
		{
			val = Integer.parseInt(command);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}

		L2TradeList list = TradeController.getInstance().getBuyList(val);

		if(list != null)
		{
			BuyList bl = new BuyList(list, activeChar.getAdena());
			activeChar.sendPacket(bl);
		}

		activeChar.sendActionFailed();
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "Описание команды buy", "Описание команды gmshop", "Описание команды tax" };
	}

	public String[] getCommandGroup()
	{
		return new String[] { AdminCommandHandler.GROUP_MANAGESERVER5, AdminCommandHandler.GROUP_MANAGESERVER5, AdminCommandHandler.GROUP_MANAGESERVER5 };
	}
}