package commands.admin;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.handler.AdminCommandHandler;
import l2r.gameserver.handler.IAdminCommandHandler;
import l2r.gameserver.model.L2Object;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2World;

/**
 * This class handles following admin commands: - target name = sets player with
 * respective name as target
 */
public class AdminTarget implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = { "admin_target" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().CanViewChar)
			return false;
		if(command.startsWith("admin_target"))
			handleTarget(command, activeChar);
		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	private void handleTarget(String command, L2Player activeChar)
	{
		try
		{
			String targetName = command.substring(13);
			L2Object obj = L2World.getPlayer(targetName);
			if(obj != null && obj.isPlayer)
				obj.onAction(activeChar);
			else
				activeChar.sendMessage("Player " + targetName + " not found");
		}
		catch(IndexOutOfBoundsException e)
		{
			activeChar.sendMessage("Please specify correct name.");
		}
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "Описание команды target" };
	}

	public String[] getCommandGroup()
	{
		return new String[] { AdminCommandHandler.GROUP_EDITCHAR };
	}
}