package commands.voiced;

import l2r.extensions.scripts.Functions;
import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.handler.IVoicedCommandHandler;
import l2r.gameserver.handler.VoicedCommandHandler;
import l2r.gameserver.model.L2Object;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.util.Files;

/**
 * @Author: Diamond
 * @Date: 10/07/2007
 * @Time: 15:07:08
 */
public class Lang extends Functions implements IVoicedCommandHandler, ScriptFile
{
	public static L2Object self;
	public static L2NpcInstance npc;

	private String[] _commandList = new String[] { "lang" };

	public boolean useVoicedCommand(String command, L2Player activeChar, String args)
	{
		if(command.equals("lang"))
		{
			if(args != null)
				if(args.equalsIgnoreCase("en"))
					activeChar.setVar("lang@", "en");
				else if(args.equalsIgnoreCase("ru"))
					activeChar.setVar("lang@", "ru");
		}

		String dialog = Files.read("data/scripts/commands/voiced/lang.htm", activeChar);

		if(activeChar.getVar("lang@").equalsIgnoreCase("en"))
			dialog = dialog.replaceFirst("%lang%", "EN");
		else
			dialog = dialog.replaceFirst("%lang%", "RU");

		show(dialog, activeChar);

		return true;
	}

	public String[] getVoicedCommandList()
	{
		return _commandList;
	}

	public void onLoad()
	{
		VoicedCommandHandler.getInstance().registerVoicedCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}
