package commands.voiced;

import l2r.Config;
import l2r.extensions.scripts.Functions;
import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.handler.IVoicedCommandHandler;
import l2r.gameserver.handler.VoicedCommandHandler;
import l2r.gameserver.loginservercon.LSConnection;
import l2r.gameserver.loginservercon.gspackets.LockAccountIP;
import l2r.gameserver.model.L2Object;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.util.Files;

/**
 * @Author: SYS
 * @Date: 10/4/2008
 */
public class Lock extends Functions implements IVoicedCommandHandler, ScriptFile
{
	public static L2Object self;
	public static L2NpcInstance npc;

	private String[] _commandList = new String[] { "lock" };

	private static String defaultPage = "data/scripts/commands/voiced/lock.html";

	public void onLoad()
	{
		VoicedCommandHandler.getInstance().registerVoicedCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	private void showDefaultPage(L2Player activeChar)
	{
		String html = Files.read(defaultPage, activeChar);
		html = html.replaceFirst("%IP%", activeChar.getIP());
		show(html, activeChar);
	}

	public static void lock_on()
	{
		L2Player activeChar = (L2Player) self;
		LSConnection.getInstance().sendPacket(new LockAccountIP(activeChar.getAccountName(), activeChar.getIP()));
		activeChar.sendMessage("Account locked.");
	}

	public static void lock_off()
	{
		L2Player activeChar = (L2Player) self;
		LSConnection.getInstance().sendPacket(new LockAccountIP(activeChar.getAccountName(), "*"));
		activeChar.sendMessage("Account unlocked.");
	}

	public boolean useVoicedCommand(String command, L2Player activeChar, String target)
	{
		if(!Config.SERVICES_LOCK_ACCOUNT_IP)
		{
			activeChar.sendMessage("Service turned off.");
			return true;
		}

		if(command.equals("lock") && (target == null || target.equals("")))
		{
			showDefaultPage(activeChar);
			return true;
		}

		if(target.equalsIgnoreCase("on"))
		{
			LSConnection.getInstance().sendPacket(new LockAccountIP(activeChar.getAccountName(), activeChar.getIP()));
			activeChar.sendMessage("Account locked.");
			return true;
		}

		if(target.equalsIgnoreCase("off"))
		{
			LSConnection.getInstance().sendPacket(new LockAccountIP(activeChar.getAccountName(), "*"));
			activeChar.sendMessage("Account unlocked.");
			return true;
		}

		showDefaultPage(activeChar);
		return true;
	}

	public String[] getVoicedCommandList()
	{
		return _commandList;
	}
}