package events.Bonus;

import java.sql.ResultSet;
import java.util.Calendar;

import l2r.Config;
import l2r.database.DatabaseUtils;
import l2r.database.FiltredPreparedStatement;
import l2r.database.L2DatabaseFactory;
import l2r.database.ThreadConnection;
import l2r.extensions.multilang.CustomMessage;
import l2r.extensions.scripts.Functions;
import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.cache.Msg;
import l2r.gameserver.instancemanager.ServerVariables;
import l2r.gameserver.model.L2Object;
import l2r.gameserver.model.L2Player;
import l2r.util.Files;
import l2r.util.Log;

public class bonus extends Functions implements ScriptFile
{
	public static L2Object self;
	public static L2Object npc;
	private static int BONUS_ITEM = Config.EVENT_BonusItemID;
	private static int BONUS_PRICE = Config.EVENT_BonusPrice;
	private static boolean _active = false;
	private static int bonus = Config.EVENT_BonusRate;
	private static int Bonus_Days = Config.EVENT_BonusDays;
	private static String bonus_class;

	private static boolean HaveBonus(String type)
	{
		L2Player player = (L2Player) self;
		ResultSet rs = null;
		ThreadConnection con = null;
		FiltredPreparedStatement offline = null;
		Calendar end_;
		end_ = Calendar.getInstance();
		try
		{
			con = L2DatabaseFactory.getInstance().getConnection();
			offline = con.prepareStatement("SELECT bonus_expire_time FROM bonus WHERE obj_id LIKE ? AND bonus_name = ?");
			offline.setInt(1, player.getObjectId());
			offline.setString(2, type);
			rs = offline.executeQuery();
			if(rs.next())
			{
				end_.setTimeInMillis(rs.getLong(1) * 1000);
				show(new CustomMessage("scripts.events.Bonus.bonus.alreadychar", player).addString(String.valueOf(end_.get(Calendar.DAY_OF_MONTH)) + "." + String.valueOf(end_.get(Calendar.MONTH) + 1) + "." + String.valueOf(end_.get(Calendar.YEAR))), player);
				return true;
			}
			return false;
		}
		catch(Exception e)
		{
			e.printStackTrace();
			show(new CustomMessage("common.Error", player), player);
			return false;
		}
		finally
		{
			DatabaseUtils.closeDatabaseCSR(con, offline, rs);
		}

	}

	private static boolean isActive()
	{
		return ServerVariables.getString("Bonus_event", "off").equalsIgnoreCase("on");
	}

	public void startEvent()
	{
		L2Player player = (L2Player) self;
		if(!player.getPlayerAccess().IsEventGm)
			return;
		if(!isActive())
		{
			ServerVariables.set("Bonus_event", "on");
			System.out.println("Event: Bonus started.");
		}
		else
			player.sendMessage("Event 'Bonus' already started.");
		_active = true;
		show(Files.read("data/html/admin/events.htm", player), player);
	}

	public void stopEvent()
	{
		L2Player player = (L2Player) self;
		if(!player.getPlayerAccess().IsEventGm)
			return;
		if(isActive())
		{
			ServerVariables.unset("Bonus_event");
			System.out.println("Event: Bonus stopped.");
		}
		else
			player.sendMessage("Event 'Bonus' not started.");

		_active = false;
		show(Files.read("data/html/admin/events.htm", player), player);
	}

	public static String DialogAppend_31757(Integer val)
	{
		if(val == 0 && _active)
		{
			String append = "";
			append += "[scripts_events.Bonus.bonus:buy" + " " + "1|";
			append += new CustomMessage("scripts.events.Bonus.bonus.buybonuscharexp", self).addNumber(Bonus_Days).addNumber(BONUS_PRICE).addItemName(BONUS_ITEM).addString(String.valueOf(bonus));
			append += "]<br>";
			append += "[scripts_events.Bonus.bonus:buy" + " " + "2|";
			append += new CustomMessage("scripts.events.Bonus.bonus.buybonuscharsp", self).addNumber(Bonus_Days).addNumber(BONUS_PRICE).addItemName(BONUS_ITEM).addString(String.valueOf(bonus));
			append += "]<br>";
			append += "[scripts_events.Bonus.bonus:buy" + " " + "3|";
			append += new CustomMessage("scripts.events.Bonus.bonus.buybonuschardrop", self).addNumber(Bonus_Days).addNumber(BONUS_PRICE).addItemName(BONUS_ITEM).addString(String.valueOf(bonus));
			append += "]<br>";
			append += "[scripts_events.Bonus.bonus:buy" + " " + "4|";
			append += new CustomMessage("scripts.events.Bonus.bonus.buybonuscharadena", self).addNumber(Bonus_Days).addNumber(BONUS_PRICE).addItemName(BONUS_ITEM).addString(String.valueOf(bonus));
			append += "]<br>";
			append += "[scripts_events.Bonus.bonus:buy" + " " + "5|";
			append += new CustomMessage("scripts.events.Bonus.bonus.buybonuscharspoil", self).addNumber(Bonus_Days).addNumber(BONUS_PRICE).addItemName(BONUS_ITEM).addString(String.valueOf(bonus));
			append += "]<br>";
			append += "[scripts_events.Bonus.bonus:buy" + " " + "6|";
			append += new CustomMessage("scripts.events.Bonus.bonus.buybonuscharquest", self).addNumber(Bonus_Days).addNumber(BONUS_PRICE).addItemName(BONUS_ITEM).addString(String.valueOf(bonus));
			append += "]";
			return append;
		}
		return "";
	}

	public static void buy(String[] args)
	{
		L2Player player = (L2Player) self;
		int bonus_type;
		bonus_type = Integer.valueOf(args[0]);
		switch(bonus_type)
		{
			case 1:
				// exp
				bonus_class = "RATE_XP";
				break;
			case 2:
				// sp
				bonus_class = "RATE_SP";
				break;
			case 3:
				//drop
				bonus_class = "RATE_DROP_ITEMS";
				break;
			case 4:
				//adena
				bonus_class = "RATE_DROP_ADENA";
				break;
			case 5:
				//spoil
				bonus_class = "RATE_DROP_SPOIL";
				break;
			case 6:
				//quest
				bonus_class = "RATE_QUESTS_REWARD";
				break;
		}
		if(HaveBonus(bonus_class))
			return;
		ThreadConnection con = null;
		FiltredPreparedStatement offline = null;
		Calendar bonus_expire = Calendar.getInstance();
		if(getItemCount(player, BONUS_ITEM) < BONUS_PRICE)
		{
			if(BONUS_ITEM == 57)
				player.sendPacket(Msg.YOU_DO_NOT_HAVE_ENOUGH_ADENA);
			else
				player.sendPacket(Msg.INCORRECT_ITEM_COUNT);
			return;
		}
		bonus_expire.add(Calendar.DAY_OF_MONTH, Bonus_Days);
		try
		{
			con = L2DatabaseFactory.getInstance().getConnection();
			offline = con.prepareStatement("INSERT INTO bonus(obj_id, bonus_name, bonus_value, bonus_expire_time) VALUES (?,?,?,?)");
			offline.setInt(1, player.getObjectId());
			offline.setString(2, bonus_class);
			offline.setInt(3, bonus);
			offline.setLong(4, bonus_expire.getTimeInMillis() / 1000);
			offline.executeUpdate();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			show(new CustomMessage("common.Error", player), player);
			return;
		}
		finally
		{
			DatabaseUtils.closeDatabaseCS(con, offline);
		}
		removeItem(player, BONUS_ITEM, BONUS_PRICE);
		Log.add("Character " + player.getName() + " buy bonus for char " + player.getName(), "bonus_event");
		show(new CustomMessage("scripts.events.Bonus.bonus.buyokchar", player).addString(bonus_class), player);
	}

	public void onLoad()
	{
		if(isActive())
		{
			_active = true;
			System.out.println("Loaded Event: Bonus [state: activated]");
		}
		else
			System.out.println("Loaded Event: Bonus [state: deactivated]");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}