package events.NPCBuffer;

import l2r.Config;
import l2r.extensions.multilang.CustomMessage;
import l2r.extensions.scripts.Functions;
import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.Announcements;
import l2r.gameserver.ThreadPoolManager;
import l2r.gameserver.cache.Msg;
import l2r.gameserver.instancemanager.ServerVariables;
import l2r.gameserver.instancemanager.TownManager;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.model.entity.siege.Siege;
import l2r.gameserver.model.entity.siege.SiegeUnit;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.serverpackets.MagicSkillLaunched;
import l2r.gameserver.serverpackets.MagicSkillUse;
import l2r.gameserver.tables.SkillTable;
import l2r.util.Files;
import l2r.util.Util;

public class Buffer extends Functions implements ScriptFile
{
	public static L2NpcInstance npc;
	private static boolean _active = false;

	/** Количество бафов в группе */
	private static int grpCount;

	// Количество бафов в 1 и второй группах должно быть одинаковое
	private static int buffs[][] = { // id, lvl, group
	// Chants
			{ 1251, 2, 5 }, // Chant of Fury
			{ 1252, 3, 5 }, // Chant of Evasion
			{ 1253, 3, 5 }, // Chant of Rage
			{ 1284, 3, 5 }, // Chant of Revenge
			{ 1308, 3, 5 }, // Chant of Predator
			{ 1309, 3, 5 }, // Chant of Eagle
			{ 1310, 4, 5 }, // Chant of Vampire
			{ 1362, 1, 5 }, // Chant of Spirit
			{ 1363, 1, 5 }, // Chant of Victory
			{ 1390, 3, 5 }, // War Chant
			{ 1391, 3, 5 }, // Earth Chant
			// Songs
			{ 264, 1, 4 }, // Song of Earth
			{ 265, 1, 4 }, // Song of Life
			{ 266, 1, 4 }, // Song of Water
			{ 267, 1, 4 }, // Song of Warding
			{ 268, 1, 4 }, // Song of Wind
			{ 269, 1, 4 }, // Song of Hunter
			{ 270, 1, 4 }, // Song of Invocation
			{ 304, 1, 4 }, // Song of Vitality
			{ 305, 1, 4 }, // Song of Vengeance
			{ 306, 1, 4 }, // Song of Flame Guard
			{ 308, 1, 4 }, // Song of Storm Guard
			{ 349, 1, 4 }, // Song of Renewal
			{ 363, 1, 4 }, // Song of Meditation
			{ 364, 1, 4 }, // Song of Champion
			// Dances
			{ 271, 1, 3 }, // Dance of Warrior
			{ 272, 1, 3 }, // Dance of Inspiration
			{ 273, 1, 3 }, // Dance of Mystic
			{ 274, 1, 3 }, // Dance of Fire
			{ 275, 1, 3 }, // Dance of Fury
			{ 276, 1, 3 }, // Dance of Concentration
			{ 277, 1, 3 }, // Dance of Light
			{ 307, 1, 3 }, // Dance of Aqua Guard
			{ 309, 1, 3 }, // Dance of Earth Guard
			{ 310, 1, 3 }, // Dance of Vampire
			{ 311, 1, 3 }, // Dance of Protection
			{ 365, 1, 3 }, // Dance of Siren
			// Группа для магов 2
			{ 7059, 1, 2 }, // Wild Magic
			{ 4356, 3, 2 }, // Empower
			{ 4355, 3, 2 }, // Acumen
			{ 4352, 1, 2 }, // Berserker Spirit
			{ 4346, 4, 2 }, // Mental Shield
			{ 4351, 6, 2 }, // Concentration
			{ 4342, 2, 2 }, // Wind Walk
			{ 4347, 6, 2 }, // Bless the Body
			{ 4348, 6, 2 }, // Bless the Soul
			{ 4344, 3, 2 }, // Shield
			{ 7060, 1, 2 }, // Clarity
			{ 4350, 4, 2 }, // Resist Shock
			// Группа для воинов 1
			{ 7057, 1, 1 }, // Greater Might
			{ 4345, 3, 1 }, // Might
			{ 4344, 3, 1 }, // Shield
			{ 4349, 2, 1 }, // Magic Barrier
			{ 4342, 2, 1 }, // Wind Walk
			{ 4347, 6, 1 }, // Bless the Body
			{ 4357, 2, 1 }, // Haste
			{ 4359, 3, 1 }, // Focus
			{ 4358, 3, 1 }, // Guidance
			{ 4360, 3, 1 }, // Death Whisper
			{ 4354, 4, 1 }, // Vampiric Rage
			{ 4346, 4, 1 } // Mental Shield
	};

	public void onLoad()
	{
		if(isActive())
		{
			_active = true;
			System.out.println("Loaded Event: NPCBuffer [state: activated]");
			for(int buff[] : buffs)
				if(buff[2] == 1)
					grpCount++;
		}
		else
			System.out.println("Loaded Event: NPCBuffer [state: deactivated]");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	/**
	 * Читает статус эвента из базы.
	 * @return status
	 */
	private static boolean isActive()
	{
		return ServerVariables.getString("NPCBuffer", "off").equalsIgnoreCase("on");
	}

	/**
	* Запускает эвент
	*/
	public void startEvent()
	{
		L2Player player = (L2Player) self;
		if(!player.getPlayerAccess().IsEventGm)
			return;

		if(!isActive())
		{
			ServerVariables.set("NPCBuffer", "on");
			_active = true;
			System.out.println("Event: NPCBuffer started.");
			Announcements.getInstance().announceByCustomMessage("scripts.events.NPCBuffer.AnnounceEventStarted", null);
		}
		else
			player.sendMessage("Event 'NPCBuffer' already started.");
		_active = true;
		show(Files.read("data/html/admin/events.htm", player), player);
	}

	/**
	* Останавливает эвент
	*/
	public void stopEvent()
	{
		L2Player player = (L2Player) self;
		if(!player.getPlayerAccess().IsEventGm)
			return;
		if(isActive())
		{
			ServerVariables.unset("NPCBuffer");
			System.out.println("Event: NPCBuffer stopped.");
			Announcements.getInstance().announceByCustomMessage("scripts.events.NPCBuffer.AnnounceEventStoped", null);
		}
		else
			player.sendMessage("Event 'NPCBuffer' not started.");
		_active = false;
		show(Files.read("data/html/admin/events.htm", player), player);
	}

	/**
	 * Бафает группу баффов, снимает плату за бафф, отображает диалог с кнопкой возврата к списку бафов
	 * @param args массив строк, где элемент 0 - id группы бафов
	 */
	public void doBuffGroup(String[] args)
	{
		L2Player player = (L2Player) self;

		if(!checkCondition(player))
			return;

		if(player.getAdena() < Config.EVENT_price * grpCount)
		{
			player.sendPacket(Msg.YOU_DO_NOT_HAVE_ENOUGH_ADENA);
			return;
		}
		player.reduceAdena(Config.EVENT_price * grpCount, true);

		int time = 0;
		L2Skill skill;
		for(int buff[] : buffs)
			if(buff[2] == Integer.valueOf(args[0]))
			{
				skill = SkillTable.getInstance().getInfo(buff[0], buff[1]);
				time += skill.getHitTime();
				ThreadPoolManager.getInstance().scheduleGeneral(new BeginBuff(npc, skill, player), time);
				time += 200;
			}
	}

	/**
	 * Бафает один бафф, снимает плату за бафф, отображает диалог с кнопкой возврата к списку бафов
	 * @param args массив строк: элемент 0 - id скида, элемент 1 - уровень скила
	 */
	public static void doBuff(String[] args)
	{
		L2Player player = (L2Player) self;

		if(!checkCondition(player))
			return;

		if(player.getAdena() < Config.EVENT_price)
		{
			player.sendPacket(Msg.YOU_DO_NOT_HAVE_ENOUGH_ADENA);
			return;
		}

		try
		{
			int skill_id = Integer.valueOf(args[0]);
			int skill_lvl = Integer.valueOf(args[1]);
			L2Skill skill = SkillTable.getInstance().getInfo(skill_id, skill_lvl);
			ThreadPoolManager.getInstance().scheduleGeneral(new BeginBuff(npc, skill, player), skill.getHitTime());
			player.reduceAdena(Config.EVENT_price, true);
		}
		catch(Exception e)
		{
			player.sendMessage("Invalid skill!");
		}

		show(Files.read("data/scripts/events/NPCBuffer/buffs-tolist.htm", player), player);
	}

	/**
	 * Проверяет возможность бафа персонажа.<BR>
	 * В случае невозможности бафа показывает игроку html с ошибкой и возвращает false.
	 * @param player персонаж
	 * @return true, если можно бафать персонажа
	 */
	public static boolean checkCondition(L2Player player)
	{
		if(!_active || player == null)
			return false;

		if(player.isActionsDisabled() || player.isSitting() || player.getLastNpc().getDistance(player) > 300)
			return false;

		String html;

		// Проверяем по уровню
		if(player.getLevel() > Config.EVENT_Max_lvl || player.getLevel() < Config.EVENT_Min_lvl)
		{
			html = Files.read("data/scripts/events/NPCBuffer/no-lvl.htm", player);
			html = html.replace("%min_lvl%", Integer.toString(Config.EVENT_Min_lvl));
			html = html.replace("%max_lvl%", Integer.toString(Config.EVENT_Max_lvl));
			show(html, player);
			return false;
		}

		//Можно ли юзать бафера во время осады?
		if(!Config.EVENT_Buffer_Siege)
		{
			SiegeUnit castle = TownManager.getInstance().getClosestTown(self).getCastle();
			Siege siege = castle.getSiege();
			if(siege != null && siege.isInProgress())
			{
				show(Files.read("data/scripts/events/NPCBuffer/no-siege.htm", player), player);
				return false;
			}
		}
		return true;
	}

	/**
	 * Показывает страницу с выбором возможных бафов
	 */
	public static void SelectBuffs()
	{
		L2Player player = (L2Player) self;

		if(!checkCondition(player))
			return;

		String html;
		html = Files.read("data/scripts/events/NPCBuffer/buffs.htm", player);
		html = html.replace("%grp_price%", Util.formatAdena(Config.EVENT_price * grpCount));
		html = html.replace("%price%", Util.formatAdena(Config.EVENT_price));
		show(html, player);
	}

	/**
	 * Генерит ссылку, которая в дальнейшем аппендится эвент менеждерам
	 * @return html код ссылки
	 */
	public static String OutDia()
	{
		if(!_active)
			return "";
		String append = "<br><a action=\"bypass -h scripts_events.NPCBuffer.Buffer:SelectBuffs\">";
		append += new CustomMessage("scripts.events.NPCBuffer.Buffer.selectBuffs", self);
		append += "</a>";
		return append;
	}

	// Далее идут аппенды диалогов эвент гейткиперам
	public static String DialogAppend_31212(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31213(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31214(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31215(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31216(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31217(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31218(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31219(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31220(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31221(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31222(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31223(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31224(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31767(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_32048(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31768(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static class BeginBuff implements Runnable
	{
		L2Character _buffer;
		L2Skill _skill;
		L2Player _target;

		public BeginBuff(L2Character buffer, L2Skill skill, L2Player target)
		{
			_buffer = buffer;
			_skill = skill;
			_target = target;
		}

		public void run()
		{
			if(_target.isInOlympiadMode())
				return;
			_buffer.broadcastPacket(new MagicSkillUse(_buffer, _target, _skill.getDisplayId(), _skill.getLevel(), _skill.getHitTime(), 0));
			ThreadPoolManager.getInstance().scheduleGeneral(new EndBuff(_buffer, _skill, _target), _skill.getHitTime());
		}
	}

	public static class EndBuff implements Runnable
	{
		L2Character _buffer;
		L2Skill _skill;
		L2Player _target;

		public EndBuff(L2Character buffer, L2Skill skill, L2Player target)
		{
			_buffer = buffer;
			_skill = skill;
			_target = target;
		}

		public void run()
		{
			_skill.getEffects(_buffer, _target, false);
			_buffer.broadcastPacket(new MagicSkillLaunched(_buffer.getObjectId(), _skill.getId(), _skill.getLevel(), _target));
		}
	}
}