package events.clanhall.fotressofresistance;

import l2r.gameserver.model.L2Spawn;
import l2r.gameserver.model.entity.CHSiege;
import l2r.gameserver.templates.L2NpcTemplate;
import l2r.gameserver.tables.NpcTable;
import l2r.gameserver.instancemanager.DayNightSpawnManager;
import l2r.extensions.scripts.ScriptFile;

public class FORSiege extends CHSiege implements ScriptFile
{
	private void fillMonsters()
	{
		addMonster(35369, 44505, 108867, -2020);
		addMonster(35369, 44545, 108867, -2020);
		addMonster(35370, 44485, 108867, -2020);
		addMonster(35370, 44497, 108839, -2020);
		addMonster(35370, 44497, 108895, -2020);
		addMonster(35370, 44525, 108827, -2020);
		addMonster(35370, 44535, 108895, -2020);
		addMonster(35370, 44553, 108839, -2020);
		addMonster(35370, 44553, 108895, -2020);
		addMonster(35370, 44565, 108867, -2020);
		addMonster(35371, 44515, 108850, -2020);
		addMonster(35371, 44515, 108884, -2020);
		addMonster(35371, 44535, 108850, -2020);
		addMonster(35371, 44535, 108884, -2020);
		addMonster(35372, 0, 0, 0, 0, 13, 15, 15);
		addMonster(35373, 44788, 109492, -1705);
		addMonster(35373, 45168, 109020, -1705);
		addMonster(35374, 44812, 109492, -1705);
		addMonster(35374, 45236, 108980, -1705);
	}

	@Override
	public void spawnBosses()
	{
		L2Spawn sp = null;
		try
		{
			L2NpcTemplate template = NpcTable.getTemplate(35368);//Bloody Lord Nurka
			sp = new L2Spawn(template);
			sp.setLocx(44525);
			sp.setLocy(108867);
			sp.setLocz(-2020);
			sp.setSiegeId(21);
			DayNightSpawnManager.getInstance().addNightMob(sp);
		}
		catch(ClassNotFoundException e)
		{
			e.printStackTrace();
		}
	}

	@Override
	public void spawnMessenger()
	{
		L2Spawn sp = null;
		try
		{
			L2NpcTemplate template = NpcTable.getTemplate(35382);//Brakel
			sp = new L2Spawn(template);
			sp.setLocx(50343);
			sp.setLocy(111282);
			sp.setLocz(-1970);
			sp.setSiegeId(21);
			sp.doSpawn(true);
		}
		catch(ClassNotFoundException e)
		{
			e.printStackTrace();
		}
	}

	public void load()
	{
		System.out.println("Fotress of Resistance siege loaded");
		_id = 21;
		_doors = new int[] {};
		register();
		fillMonsters();
	}

	public void onLoad()
	{
		load();
	}

	public void onReload()
	{
		if(_starttask != null && !_starttask.isDone())
			_starttask.cancel(true);
		if(_stoptask != null && !_stoptask.isDone())
			_stoptask.cancel(true);
	}

	public void onShutdown()
	{}
}
