package npc.model;

import javolution.util.FastMap;
import l2r.extensions.scripts.Functions;
import l2r.gameserver.instancemanager.CHSiegeManager;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.entity.CHSiege;
import l2r.gameserver.templates.L2NpcTemplate;

public class L2SiegeBossInstance extends L2SiegeMonsterInstance
{
	public L2SiegeBossInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	@Override
	public void doDie(L2Character killer)
	{
		L2Player player = killer.getPlayer();
		CHSiege siege = CHSiegeManager.getInstance().getSiege(player.getClan());
		if(getNpcId() == 35408)
			Functions.npcShout(this, "Has once more $$ln the defeat the shame.. But the tragedy had not ended...");
		else if(getNpcId() == 35409)
			Functions.npcShout(this, "Is this my boundary.. But does not have Gustave's permission, I can die in no way!");
		else if(getNpcId() == 35410)
		{
			Functions.npcShout(this, "Day.. Unexpectedly is defeated? But I certainly can again come back! Comes back takes your head!");
			player = getWinner(killer);
			siege.stopTask(player, 10);
		}
		else if(getNpcId() == 35368)
		{
			player = getWinner(killer);
			siege.stop(player);
		}
		deleteMe();
	}

	private L2Player getWinner(L2Character killer)
	{
		int mostdamage = 0;
		L2Player player = null;
		L2Player temp = null;
		FastMap<L2Player, Integer> damagemap = new FastMap<L2Player, Integer>();
		for(AggroInfo info : getAggroList().values())
		{
			killer = info.attacker;
			int damage = info.damage;
			if(killer.isPet || killer.isSummon)
				temp = killer.getOwner();
			else if(killer.isPlayer)
				temp = (L2Player) killer;

			if(temp == null || temp.getClan() == null)
				continue;
			if(!CHSiegeManager.getInstance().getSiege(getSpawn().getSiegeId()).getAttackers().contains(temp.getClan()))
				continue;

			if(!damagemap.containsKey(temp))
				damagemap.put(temp, damage);
			else
			{
				int dmg = damagemap.get(temp) + damage;
				damagemap.put(temp, dmg);
			}
		}

		for(L2Player pl : damagemap.keySet())
		{
			int damage = damagemap.get(pl);
			if(damage > mostdamage)
			{
				mostdamage = damage;
				player = pl;
			}
		}

		return player;
	}
}
