package npc.model;

import l2r.gameserver.instancemanager.ClanHallManager;
import l2r.gameserver.instancemanager.CHSiegeManager;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.entity.ClanHall;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.serverpackets.CastleSiegeInfo;
import l2r.gameserver.serverpackets.NpcHtmlMessage;
import l2r.gameserver.templates.L2NpcTemplate;
import l2r.gameserver.model.entity.CHSiege;

public class L2SiegeMessengerInstance extends L2NpcInstance
{
	@SuppressWarnings("unused")
	//private static final Logger _log = Logger.getLogger(L2SiegeMessengerInstance.class.getName());
	public L2SiegeMessengerInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	@Override
	public void showChatWindow(L2Player player, int val)
	{
		ClanHall ch = ClanHallManager.getInstance().getClanHall(getSpawn().getSiegeId());
		if(validateCondition())
			player.sendPacket(new CastleSiegeInfo(ch, CHSiegeManager.getInstance().getSiege(getSpawn().getSiegeId()).getStartTime()));
		else
			player.sendPacket(new NpcHtmlMessage(player, this, "data/html/chsiege/" + getTemplate().npcId + "-busy.htm", val));
	}

	@SuppressWarnings("unused")
	private boolean validateCondition()
	{
		CHSiege siege = CHSiegeManager.getInstance().getSiege(this);
		if(siege == null)
		{
			System.out.println("Can't find CHSiege for clanhall " + getSpawn().getSiegeId());
			return false;
		}
		if(siege.isInProgress())
			return false; // Busy because of siege
		if(!siege.isRegistrationAvailable())
			return false;
		return true;
	}
}
