package quests._013_ParcelDelivery;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

public class _013_ParcelDelivery extends Quest implements ScriptFile
{
	private static final int PACKAGE = 7263;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 013: Parcel Delivery");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _013_ParcelDelivery()
	{
		super(13, "_013_ParcelDelivery", "Parcel Delivery", false);

		addStartNpc(31274);

		addTalkId(31274);
		addTalkId(31539);

		addQuestItem(PACKAGE);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31274-2.htm"))
		{
			st.set("cond", "1");
			st.giveItems(PACKAGE, 1);
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("31539-2.htm"))
		{
			st.takeItems(PACKAGE, -1);
			st.giveItems(57, 82656);
			st.set("cond", "0");
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(false);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == 31274)
		{
			if(cond == 0)
				if(st.getPlayer().getLevel() >= 74)
					htmltext = "31274-1.htm";
				else
				{
					htmltext = "31274-00.htm";
					st.exitCurrentQuest(true);
				}
			else if(cond == 1)
				htmltext = "31274-2r.htm";
		}
		else if(npcId == 31539)
			if(cond == 1 && st.getQuestItemsCount(PACKAGE) == 1)
				htmltext = "31539-1.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		return null;
	}
}