package quests._014_WhereaboutsoftheArchaeologist;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

public class _014_WhereaboutsoftheArchaeologist extends Quest implements ScriptFile
{
	private static final int LETTER_TO_ARCHAEOLOGIST = 7253;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 014: Whereabouts of the Archaeologist");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _014_WhereaboutsoftheArchaeologist()
	{
		super(14, "_014_WhereaboutsoftheArchaeologist", "Whereabouts of the Archaeologist", false);

		addStartNpc(31263);

		addTalkId(31263);
		addTalkId(31538);

		addQuestItem(LETTER_TO_ARCHAEOLOGIST);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31263-2.htm"))
		{
			st.set("cond", "1");
			st.giveItems(LETTER_TO_ARCHAEOLOGIST, 1);
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("31538-2.htm"))
		{
			st.takeItems(LETTER_TO_ARCHAEOLOGIST, -1);
			st.giveItems(57, 113228);
			st.set("cond", "0");
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(false);
			return "31538-2.htm";
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == 31263)
		{
			if(cond == 0)
				if(st.getPlayer().getLevel() >= 74)
					htmltext = "31263-1.htm";
				else
				{
					htmltext = "31263-00.htm";
					st.exitCurrentQuest(true);
				}
			else if(cond == 1)
				htmltext = "31263-2.htm";
		}
		else if(npcId == 31538)
			if(cond == 1 && st.getQuestItemsCount(LETTER_TO_ARCHAEOLOGIST) == 1)
				htmltext = "31538-1.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		return null;
	}
}