package quests._018_MeetingwiththeGoldenRam;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

public class _018_MeetingwiththeGoldenRam extends Quest implements ScriptFile
{
	private static final int SUPPLY_BOX = 7245;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 018: Meeting with the Golden Ram");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _018_MeetingwiththeGoldenRam()
	{
		super(18, "_018_MeetingwiththeGoldenRam", "Meeting with the Golden Ram", false);

		addStartNpc(31314);

		addTalkId(31314);
		addTalkId(31315);
		addTalkId(31555);

		addQuestItem(SUPPLY_BOX);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equals("31314-2.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equals("31315-2.htm"))
		{
			st.set("cond", "2");
			st.giveItems(SUPPLY_BOX, 1);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equals("31555-2.htm"))
		{
			st.takeItems(SUPPLY_BOX, -1);
			st.giveItems(57, 15000);
			st.addExpAndSp(0, 50000);
			st.set("cond", "0");
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(false);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == 31314)
		{
			if(cond == 0)
				if(st.getPlayer().getLevel() >= 66)
					htmltext = "31314-1.htm";
				else
				{
					htmltext = "31314-00.htm";
					st.exitCurrentQuest(true);
				}
			else if(cond == 1)
				htmltext = "31314-2r.htm";
		}
		else if(npcId == 31315)
		{
			if(cond == 1)
				htmltext = "31315-1.htm";
			else if(cond == 2)
				htmltext = "31315-2r.htm";
		}
		else if(npcId == 31555)
			if(cond == 2 && st.getQuestItemsCount(SUPPLY_BOX) == 1)
				htmltext = "31555-1.htm";
		return htmltext;
	}
}