package quests._019_GoToThePastureland;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

public class _019_GoToThePastureland extends Quest implements ScriptFile
{
	int VLADIMIR = 31302;
	int TUNATUN = 31537;

	int BEAST_MEAT = 7547;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 019: Go To The Pastureland");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _019_GoToThePastureland()
	{
		super(19, "_019_GoToThePastureland", "Go To The Pastureland", false);

		addStartNpc(VLADIMIR);

		addTalkId(VLADIMIR);
		addTalkId(TUNATUN);

		addQuestItem(BEAST_MEAT);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equals("31302-1.htm"))
		{
			st.giveItems(BEAST_MEAT, 1);
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		if(event.equals("31537-1.htm"))
		{
			st.takeItems(BEAST_MEAT, -1);
			st.giveItems(57, 30000);
			st.unset("cond");
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(false);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == VLADIMIR)
		{
			if(cond == 0)
				if(st.getPlayer().getLevel() >= 63)
					htmltext = "31302-0.htm";
				else
				{
					htmltext = "31302-00.htm";
					st.exitCurrentQuest(true);
				}
			else
				htmltext = "31302-2.htm";
		}
		else if(npcId == TUNATUN)
			if(st.getQuestItemsCount(BEAST_MEAT) >= 1)
				htmltext = "31537-0.htm";
			else
			{
				htmltext = "31302-havent.htm";
				st.exitCurrentQuest(true);
			}
		return htmltext;
	}
}