package quests._022_TragedyInVonHellmannForest;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;
import l2r.util.Rnd;

public class _022_TragedyInVonHellmannForest extends Quest implements ScriptFile
{
	// Npc list
	public final int Well = 31527;
	public final int Tifaren = 31334;
	public final int Innocentin = 31328;
	public final int SoulofWell = 31217;
	public final int Ghostofpriest = 31528;
	public final int GhostofAdventurer = 31529;
	// ~~~~~~~~ Item list ~~~~~~~~
	public final int ReportBox = 7147;
	public final int LostSkullofElf = 7142;
	public final int CrossofEinhasad = 7141;
	public final int SealedReportBox = 7146;
	public final int LetterofInnocentin = 7143;
	public final int JewelofAdventurerRed = 7145;
	public final int JewelofAdventurerGreen = 7144;
	// ~~~~ Monster list: ~~~~
	int[] Mobs = {
			21547,
			21548,
			21549,
			21550,
			21551,
			21552,
			21553,
			21554,
			21555,
			21556,
			21557,
			21558,
			21559,
			21560,
			21561,
			21562,
			21563,
			21564,
			21565,
			21566,
			21567,
			21568,
			21569,
			21570,
			21571,
			21572,
			21573,
			21574,
			21575,
			21576,
			21577,
			21578 };

	public void onLoad()
	{
		System.out.println("Loaded Quest: 022: Tragedy In Von Hellmann Forest");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _022_TragedyInVonHellmannForest()
	{
		super(22, "_022_TragedyInVonHellmannForest", "Tragedy In Von Hellmann Forest", false);

		addStartNpc(Tifaren);

		addTalkId(Tifaren);
		addTalkId(Ghostofpriest);
		addTalkId(Innocentin);
		addTalkId(GhostofAdventurer);
		addTalkId(Well);

		addAttackId(SoulofWell);

		addKillId(SoulofWell);

		for(int npcId = 21547; npcId <= 21578; npcId++)
			addKillId(npcId);

		addQuestItem(LostSkullofElf);

		//for(npcId i = 21547; i <= 21578; i++)
		//{
		//	addKillId(SoulofWell[i]);
		//	STARTED.addQuestDrop([i], LostSkullofElf, 1);
		//}
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31334-03.htm"))
		{
			st.setState(STARTED);
			st.set("cond", "3");
			st.takeItems(CrossofEinhasad, -1);
		}
		else if(event.equalsIgnoreCase("31334-06.htm"))
			st.set("cond", "4");
		else if(event.equalsIgnoreCase("31334-09.htm"))
		{
			st.set("cond", "6");
			st.takeItems(LostSkullofElf, 1);
			st.getPcSpawn().addSpawn(Ghostofpriest, 120000);
		}
		else if(event.equalsIgnoreCase("31528-07.htm"))
			st.set("cond", "7");
		else if(event.equalsIgnoreCase("31328-06.htm"))
		{
			st.set("cond", "8");
			st.giveItems(LetterofInnocentin, 1);
		}
		else if(event.equalsIgnoreCase("31529-09.htm"))
		{
			st.set("cond", "9");
			st.takeItems(LetterofInnocentin, 1);
		}
		else if(event.equalsIgnoreCase("explore"))
		{
			st.getPcSpawn().addSpawn(SoulofWell);
			st.set("cond", "10");
			st.giveItems(JewelofAdventurerGreen, 1);
			htmltext = "<html><body>Attack Soul of Well but do not kill while stone will not change colour...</body></html>";
		}
		else if(event.equalsIgnoreCase("attack_timer"))
		{
			st.giveItems(JewelofAdventurerRed, 1);
			st.takeItems(JewelofAdventurerGreen, 1);
			st.set("cond", "11");
		}
		else if(event.equalsIgnoreCase("31328-08.htm"))
		{
			st.startQuestTimer("wait_timer", 600000);
			st.set("cond", "15");
			st.takeItems(ReportBox, 1);
		}
		else if(event.equalsIgnoreCase("wait_timer"))
		{
			st.set("cond", "16");
			htmltext = "<html><body>Innocentin wants with you to speak...</body></html>";
		}
		else if(event.equalsIgnoreCase("31328-16.htm"))
		{
			st.startQuestTimer("next_wait_timer", 300000);
			st.set("cond", "17");
		}
		else if(event.equalsIgnoreCase("next_wait_timer"))
			st.set("cond", "18");
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		String htmltext = "noquest";
		if(npcId == Tifaren)
		{
			if(cond == 0)
			{
				QuestState hiddenTruth = st.getPlayer().getQuestState("_021_HiddenTruth");
				if(hiddenTruth != null)
				{
					if(hiddenTruth.isCompleted())
						htmltext = "31334-01.htm";
					else
						htmltext = "<html><head><body>You not complite quest Hidden Truth...</body></html>";
				}
				else
					htmltext = "<html><head><body>You not complite quest Hidden Truth...</body></html>";
			}
			else if(cond == 3)
			{
				if(st.getQuestItemsCount(CrossofEinhasad) != 0)
					htmltext = "31334-04.htm";
				else
					htmltext = "You have no Cross of Einhasad! Are they Please returned to High Priest Innocentin...";
			}
			else if(cond == 4)
				htmltext = "31334-06.htm";
			else if(cond == 5)
			{
				if(st.getQuestItemsCount(LostSkullofElf) != 0)
					htmltext = "31334-07.htm";
				else
				{
					st.set("cond", "4");
					htmltext = "31334-06.htm";
				}
			}
			else if(cond == 6)
				htmltext = "31334-09.htm";
		}
		else if(npcId == Ghostofpriest)
		{
			if(cond == 6)
				htmltext = "31528-00.htm";
			else if(cond == 7)
				htmltext = "31528-07.htm";
		}
		else if(npcId == Innocentin)
		{
			if(cond == 0)
				htmltext = "31328-17.htm";
			if(cond == 7)
				htmltext = "31328-00.htm";
			else if(cond == 8)
				htmltext = "31328-06.htm";
			else if(cond == 14)
			{
				if(st.getQuestItemsCount(ReportBox) != 0)
					htmltext = "31328-07.htm";
				else
				{
					st.set("cond", "13");
					htmltext = "Go away!";
				}
			}
			else if(cond == 15)
				htmltext = "31328-09.htm";
			else if(cond == 16)
				htmltext = "31328-08a.htm";
			else if(cond == 17)
				htmltext = "31328-16a.htm";
			else if(cond == 18)
			{
				htmltext = "31328-17.htm";
				st.exitCurrentQuest(false);
			}
		}
		else if(npcId == GhostofAdventurer)
		{
			if(cond == 8)
			{
				if(st.getQuestItemsCount(LetterofInnocentin) != 0)
					htmltext = "31529-00.htm";
				else
					htmltext = "You have no Letter of Innocentin! Are they Please returned to High Priest Innocentin...";
			}
			else if(cond == 9)
				htmltext = "31529-09.htm";
			else if(cond == 11)
			{
				if(st.getQuestItemsCount(JewelofAdventurerRed) != 0)
				{
					htmltext = "31529-10.htm";
					st.takeItems(JewelofAdventurerRed, 1);
					st.set("cond", "12");
				}
				else
				{
					st.set("cond", "9");
					htmltext = "31529-09.htm";
				}
			}
			else if(cond == 13)
				if(st.getQuestItemsCount(SealedReportBox) != 0)
				{
					htmltext = "31529-11.htm";
					st.set("cond", "14");
					st.takeItems(SealedReportBox, 1);
					st.giveItems(ReportBox, 1);
				}
				else
				{
					st.set("cond", "12");
					htmltext = "31529-10.htm";
				}
		}
		else if(npcId == Well)
			if(cond == 9)
				htmltext = "31527-00.htm";
			else if(cond == 12)
			{
				htmltext = "31527-01.htm";
				st.set("cond", "13");
				st.giveItems(SealedReportBox, 1);
			}
		return htmltext;
	}

	@Override
	public String onAttack(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == SoulofWell)
			if(cond == 10)
				st.startQuestTimer("attack_timer", 300000);
		return "";
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == Mobs[1])
			if(cond == 4 && Rnd.chance(99))
			{
				st.giveItems(LostSkullofElf, 1);
				st.playSound(SOUND_MIDDLE);
				st.set("cond", "5");
			}
		if(npcId == SoulofWell)
			if(cond == 10)
			{
				st.set("cond", "9");
				st.takeItems(JewelofAdventurerGreen, 1);
				st.getQuestTimer("attack_timer").cancel();
			}
		return null;
	}
}
