package quests._025_HidingBehindTheTruth;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

/**
 * Ахтунг! Даный квест слизан с L2Emu, и по этому не вызывает доверия. Надо перепроверить.
 */
public class _025_HidingBehindTheTruth extends Quest implements ScriptFile
{
	// Список NPC
	private final int AGRIPEL = 31348;
	private final int BENEDICT = 31349;
	private final int BROKEN_BOOK_SHELF = 31534;
	private final int COFFIN = 31536;
	private final int MAID_OF_LIDIA = 31532;
	private final int MYSTERIOUS_WIZARD = 31522;
	private final int TOMBSTONE = 31531;

	// Список итемов
	private final int CONTRACT = 7066;
	private final int EARRING_OF_BLESSING = 874;
	private final int GEMSTONE_KEY = 7157;
	private final int LIDIAS_DRESS = 7155;
	private final int MAP_FOREST_OF_DEADMAN = 7063;
	private final int NECKLACE_OF_BLESSING = 936;
	private final int RING_OF_BLESSING = 905;
	private final int SUSPICIOUS_TOTEM_DOLL_1 = 7151;
	private final int SUSPICIOUS_TOTEM_DOLL_2 = 7156;
	private final int SUSPICIOUS_TOTEM_DOLL_3 = 7158;

	// Список мобов
	// Triol's Pawn
	private final int TRIOLS_PAWN = 27218;

	public _025_HidingBehindTheTruth()
	{
		super(25, "_025_HidingBehindTheTruth", "Hiding Behind The Truth", false);

		addStartNpc(BENEDICT);

		addTalkId(AGRIPEL);
		addTalkId(BENEDICT);
		addTalkId(BROKEN_BOOK_SHELF);
		addTalkId(COFFIN);
		addTalkId(MAID_OF_LIDIA);
		addTalkId(MYSTERIOUS_WIZARD);
		addTalkId(TOMBSTONE);

		addKillId(TRIOLS_PAWN);

		addQuestItem(SUSPICIOUS_TOTEM_DOLL_3);
	}

	@Override
	public String onEvent(String event, QuestState qs)
	{
		String htmltext = null;
		if(event.equalsIgnoreCase("StartQuest"))
		{
			QuestState qs_24 = qs.getPlayer().getQuestState("_024_InhabitantsOfTheForestOfTheDead");
			if(qs_24 != null)
			{
				if(qs_24.isCompleted())
				{
					if(qs.getQuestItemsCount(SUSPICIOUS_TOTEM_DOLL_1) != 0)
						htmltext = "31349-03.htm";
					else
						htmltext = "31349-03a.htm";
				}
				else
				{
					htmltext = "31349-02.htm";
					qs.set("cond", "1");
				}
			}
			else
			{
				htmltext = "31349-02.htm";
				qs.set("cond", "1");
			}
		}
		else if(event.equalsIgnoreCase("31349-05.htm"))
		{
			qs.set("cond", "2");
			qs.setState(STARTED);
			qs.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("31349-10.htm"))
			qs.set("cond", "4");
		else if(event.equalsIgnoreCase("31349-08.htm"))
		{
			if(qs.getInt("cond") == 4)
			{
				qs.set("cond", "5");
				if(qs.getQuestItemsCount(SUSPICIOUS_TOTEM_DOLL_1) != 0)
					qs.takeItems(SUSPICIOUS_TOTEM_DOLL_1, -1);
				if(qs.getQuestItemsCount(SUSPICIOUS_TOTEM_DOLL_2) != 0)
					qs.takeItems(SUSPICIOUS_TOTEM_DOLL_2, -1);
				if(qs.getQuestItemsCount(GEMSTONE_KEY) == 0)
					qs.giveItems(GEMSTONE_KEY, 1);
			}
			else if(qs.getInt("cond") == 5)
				htmltext = "31348-08a.htm";
		}
		else if(event.equalsIgnoreCase("31522-04.htm"))
		{
			qs.set("cond", "6");
			if(qs.getQuestItemsCount(MAP_FOREST_OF_DEADMAN) == 0)
				qs.giveItems(MAP_FOREST_OF_DEADMAN, 1);
		}
		else if(event.equalsIgnoreCase("31534-07.htm"))
		{
			L2Player player = qs.getPlayer();
			qs.getPcSpawn().addSpawn(TRIOLS_PAWN, player.getX() + 50, player.getY() + 50, player.getZ());
			qs.set("cond", "7");
		}
		else if(event.equalsIgnoreCase("31534-11.htm"))
		{
			qs.set("id", "8");
			qs.giveItems(CONTRACT, 1);
		}
		else if(event.equalsIgnoreCase("31532-07.htm"))
			qs.set("cond", "11");
		else if(event.equalsIgnoreCase("31531-01.htm"))
		{
			qs.set("cond", "12");
			L2Player player = qs.getPlayer();
			qs.getPcSpawn().addSpawn(COFFIN, player.getX() + 50, player.getY() + 50, player.getZ());
			qs.startQuestTimer("Coffin_Spawn", 120000);
		}
		else if(event.equalsIgnoreCase("Coffin_Spawn"))
		{
			qs.set("cond", "12");
			qs.getPcSpawn().removeSpawn(COFFIN);

			if(qs.getInt("cond") == 12)
				qs.set("cond", "11");
		}
		else if(event.equalsIgnoreCase("Lidia_wait"))
			qs.set("id", "14");
		else if(event.equalsIgnoreCase("31532-21.htm"))
			qs.set("cond", "15");
		else if(event.equalsIgnoreCase("31522-13.htm"))
			qs.set("cond", "16");
		else if(event.equalsIgnoreCase("31348-16.htm"))
			qs.set("cond", "17");
		else if(event.equalsIgnoreCase("31348-17.htm"))
			qs.set("cond", "18");
		else if(event.equalsIgnoreCase("31348-14.htm"))
			qs.set("id", "16");
		else if(event.equalsIgnoreCase("End1"))
		{
			if(qs.getInt("cond") == 17)
			{
				htmltext = "31532-25.htm";
				qs.giveItems(RING_OF_BLESSING, 2);
				qs.giveItems(EARRING_OF_BLESSING, 1);
				qs.addExpAndSp(1607062, 0);
				qs.exitCurrentQuest(false);
			}
			else
				htmltext = "31532-24.htm";
		}
		else if(event.equalsIgnoreCase("End2"))
			if(qs.getInt("cond") == 18)
			{
				htmltext = "31522-26.htm";
				qs.giveItems(NECKLACE_OF_BLESSING, 1);
				qs.giveItems(EARRING_OF_BLESSING, 1);
				qs.addExpAndSp(1607062, 0);
				qs.exitCurrentQuest(false);
			}
			else
				htmltext = "31522-15a.htm";
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		int IntId = st.getInt("id");
		switch(npcId)
		{
			case BENEDICT:
				if(cond == 0)
					htmltext = "31349-01.htm";
				else if(cond == 1)
					htmltext = "31349-01.htm";
				else if(cond == 2)
					htmltext = "31349-03a.htm";
				else if(cond == 3)
					htmltext = "31349-03.htm";
				else if(cond == 4)
					htmltext = "31349-11.htm";
				break;

			case MYSTERIOUS_WIZARD:

				if(cond == 2)
				{
					htmltext = "31522-01.htm";
					st.set("cond", "3");
					st.giveItems(SUSPICIOUS_TOTEM_DOLL_2, 1);
				}
				else if(cond == 3)
					htmltext = "31522-02.htm";
				else if(cond == 5)
					htmltext = "31522-03.htm";
				else if(cond == 6)
					htmltext = "31522-05.htm";
				else if(cond == 8)
				{
					if(IntId == 8)
					{
						htmltext = "31522-06.htm";
						st.set("cond", "9");
					}
					else
						htmltext = "31522-05.htm";
				}
				else if(cond == 15)
					htmltext = "31522-06a.htm";
				else if(cond == 16)
					htmltext = "31522-12.htm";
				break;

			case AGRIPEL:

				if(cond == 4)
					htmltext = "31348-01.htm";
				else if(cond == 5)
					htmltext = "31348-03.htm";
				else if(cond == 16)
				{
					if(IntId != 16)
						htmltext = "31348-09.htm";
					else
						htmltext = "31348-15.htm";
				}
				else if(17 <= cond && cond <= 18)
					htmltext = "31348-15.htm";
				break;

			case BROKEN_BOOK_SHELF:

				if(cond == 6)
					htmltext = "31534-01.htm";
				else if(cond == 7)
					htmltext = "31534-08.htm";
				else if(cond == 8)
					if(IntId != 8)
						htmltext = "31534-10.htm";
					else
						htmltext = "31534-06.htm";
				break;

			case MAID_OF_LIDIA:

				if(cond == 9)
				{
					if(st.getQuestItemsCount(CONTRACT) != 0)
						htmltext = "31532-01.htm";
					else
						htmltext = "You have no Contract...";
				}
				else if(11 <= cond && cond <= 12)
					htmltext = "31532-08.htm";
				else if(cond == 13)
				{
					if(st.getQuestItemsCount(LIDIAS_DRESS) != 0)
					{
						htmltext = "31532-09.htm";
						st.set("cond", "14");
						st.startQuestTimer("Lidia_wait", 60000);
						st.takeItems(LIDIAS_DRESS, 1);
					}
					else
						htmltext = "31532-08.htm";
				}
				else if(cond == 14)
				{
					if(IntId == 14)
						htmltext = "31532-10.htm";
					else
						htmltext = "31532-09.htm";
				}
				else if(cond == 17)
				{
					htmltext = "31532-10.htm";
					st.set("id", "17");
				}
				break;

			case TOMBSTONE:

				if(cond == 11)
					htmltext = "31531-01.htm";
				else if(cond == 12)
					htmltext = "31531-02.htm";
				else if(cond == 13)
					htmltext = "31531-03.htm";
				break;

			case COFFIN:

				if(cond == 12)
				{
					htmltext = "31536-01.htm";
					st.set("cond", "13");
					st.giveItems(LIDIAS_DRESS, 1);
				}
				else if(cond == 13)
					htmltext = "31531-03.htm";
				break;
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState qs)
	{
		if(qs == null)
			return null;

		if(qs.getState() != STARTED)
			return null;

		int npcId = npc.getNpcId();
		int cond = qs.getInt("cond");

		if(npcId == TRIOLS_PAWN && cond == 7)
		{
			qs.giveItems(SUSPICIOUS_TOTEM_DOLL_3, 1);
			qs.playSound(SOUND_MIDDLE);
			qs.set("cond", "8");
		}

		return null;
	}

	public void onLoad()
	{
		System.out.println("Loaded Quest: 025: Hiding Behind The Truth");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}