package quests._101_SwordOfSolidarity;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;
import l2r.util.Rnd;

public class _101_SwordOfSolidarity extends Quest implements ScriptFile
{
	int ROIENS_LETTER = 796;
	int HOWTOGO_RUINS = 937;
	int BROKEN_SWORD_HANDLE = 739;
	int BROKEN_BLADE_BOTTOM = 740;
	int BROKEN_BLADE_TOP = 741;
	int ALLTRANS_NOTE = 742;
	int SWORD_OF_SOLIDARITY = 738;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 101: Sword Of Solidarity");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _101_SwordOfSolidarity()
	{
		super(101, "_101_SwordOfSolidarity", "Sword Of Solidarity", false);

		addStartNpc(30008);
		addTalkId(30008);
		addTalkId(30283);

		addKillId(20361);
		addKillId(20362);

		addQuestItem(new int[] { ALLTRANS_NOTE, HOWTOGO_RUINS, BROKEN_BLADE_TOP, BROKEN_BLADE_BOTTOM, ROIENS_LETTER, BROKEN_SWORD_HANDLE });
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("30008-04.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
			st.giveItems(ROIENS_LETTER, 1);
		}
		else if(event.equalsIgnoreCase("30283-02.htm"))
		{
			st.set("cond", "2");
			st.takeItems(ROIENS_LETTER, -1);
			st.giveItems(HOWTOGO_RUINS, 1);
		}
		else if(event.equalsIgnoreCase("30283-07.htm"))
		{
			st.takeItems(BROKEN_SWORD_HANDLE, -1);
			st.giveItems(1060, 100);
			for(int item = 4412; item <= 4417; item++)
				st.giveItems(item, 10);
			if(st.getPlayer().getLevel() < 25)
				if(st.getPlayer().getClassId().isMage())
				{
					st.playTutorialVoice("tutorial_voice_027");
					st.giveItems(5790, 3000);
				}
				else
				{
					st.playTutorialVoice("tutorial_voice_026");
					st.giveItems(5789, 6000);
				}
			st.giveItems(SWORD_OF_SOLIDARITY, 1);
			st.set("cond", "0");
			st.exitCurrentQuest(true);
			st.playSound(SOUND_FINISH);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == 30008)
		{
			if(cond == 0)
			{

				if(st.getPlayer().getRace().ordinal() != 0)
					htmltext = "30008-00.htm";
				else if(st.getPlayer().getLevel() >= 9)
				{
					htmltext = "30008-02.htm";
					return htmltext;
				}
				else
				{
					htmltext = "30008-08.htm";
					st.exitCurrentQuest(true);
				}

			}
			else if(cond == 1 && st.getQuestItemsCount(ROIENS_LETTER) == 1)
				htmltext = "30008-05.htm";
			else if(cond >= 2 && st.getQuestItemsCount(ROIENS_LETTER) == 0 && st.getQuestItemsCount(ALLTRANS_NOTE) == 0)
			{
				if(st.getQuestItemsCount(BROKEN_BLADE_TOP) > 0 && st.getQuestItemsCount(BROKEN_BLADE_BOTTOM) > 0)
					htmltext = "30008-12.htm";
				if(st.getQuestItemsCount(BROKEN_BLADE_TOP) + st.getQuestItemsCount(BROKEN_BLADE_BOTTOM) <= 1)
					htmltext = "30008-11.htm";
				if(st.getQuestItemsCount(BROKEN_SWORD_HANDLE) > 0)
					htmltext = "30008-07.htm";
				if(st.getQuestItemsCount(HOWTOGO_RUINS) == 1)
					htmltext = "30008-10.htm";
			}
			else if(cond == 4 && st.getQuestItemsCount(ALLTRANS_NOTE) > 0)
			{
				htmltext = "30008-06.htm";
				st.set("cond", "5");
				st.takeItems(ALLTRANS_NOTE, -1);
				st.giveItems(BROKEN_SWORD_HANDLE, 1);
			}
		}
		else if(npcId == 30283)
			if(cond == 1 && st.getQuestItemsCount(ROIENS_LETTER) > 0)
				htmltext = "30283-01.htm";
			else if(cond >= 2 && st.getQuestItemsCount(HOWTOGO_RUINS) == 1)
			{
				if(st.getQuestItemsCount(BROKEN_BLADE_TOP) + st.getQuestItemsCount(BROKEN_BLADE_BOTTOM) == 1)
					htmltext = "30283-08.htm";
				else if(st.getQuestItemsCount(BROKEN_BLADE_TOP) + st.getQuestItemsCount(BROKEN_BLADE_BOTTOM) == 0)
					htmltext = "30283-03.htm";
				else if(st.getQuestItemsCount(BROKEN_BLADE_TOP) > 0 && st.getQuestItemsCount(BROKEN_BLADE_BOTTOM) > 0)
				{
					htmltext = "30283-04.htm";
					st.set("cond", "4");
					st.takeItems(HOWTOGO_RUINS, -1);
					st.takeItems(BROKEN_BLADE_TOP, -1);
					st.takeItems(BROKEN_BLADE_BOTTOM, -1);
					st.giveItems(ALLTRANS_NOTE, 1);
				}
				else if(cond == 4 && st.getQuestItemsCount(ALLTRANS_NOTE) > 0)
					htmltext = "30283-05.htm";
			}
			else if(cond == 5 && st.getQuestItemsCount(BROKEN_SWORD_HANDLE) > 0)
				htmltext = "30283-06.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		if((npcId == 20361 || npcId == 20362) && st.getQuestItemsCount(HOWTOGO_RUINS) > 0)
		{
			if(st.getQuestItemsCount(BROKEN_BLADE_TOP) == 0)
			{
				if(Rnd.chance(20))
				{
					st.giveItems(BROKEN_BLADE_TOP, 1);
					st.playSound(SOUND_MIDDLE);
				}
			}
			else if(st.getQuestItemsCount(BROKEN_BLADE_BOTTOM) == 0)
				if(Rnd.chance(20))
				{
					st.giveItems(BROKEN_BLADE_BOTTOM, 1);
					st.playSound(SOUND_MIDDLE);
				}
			if(st.getQuestItemsCount(BROKEN_BLADE_TOP) > 0 && st.getQuestItemsCount(BROKEN_BLADE_BOTTOM) > 0)
				st.set("cond", "3");
		}
		return null;
	}
}