package quests._121_PavelTheGiants;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;
import l2r.gameserver.model.quest.State;

public class _121_PavelTheGiants extends Quest implements ScriptFile
{
	//NPCs
	private static int NEWYEAR = 31961;
	private static int YUMI = 32041;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 121: Pavel The Giants");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _121_PavelTheGiants()
	{
		super(121, "_121_PavelTheGiants", "Pavel The Giants", false);

		addStartNpc(NEWYEAR);
		addTalkId(NEWYEAR);
		addTalkId(YUMI);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		if(event.equals("32041-2.htm"))
		{
			st.playSound(SOUND_FINISH);
			st.addExpAndSp(10000, 0);
			st.unset("cond");
			st.exitCurrentQuest(false);
		}
		return event;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		State id = st.getState();
		int cond = st.getInt("cond");

		if(cond == 0)
			htmltext = "completed";
		else if(id.equals(CREATED) && npcId == NEWYEAR)
		{
			if(st.getPlayer().getLevel() >= 46)
			{
				htmltext = "31961-1.htm";
				st.set("cond", "1");
				st.setState(STARTED);
				st.playSound(SOUND_ACCEPT);
			}
			else
			{
				htmltext = "31961-1a.htm";
				st.exitCurrentQuest(false);
			}
		}
		else if(id.equals(STARTED))
			if(npcId == YUMI && cond == 1)
				htmltext = "32041-1.htm";
			else
				htmltext = "31961-2.htm";
		return htmltext;
	}
}