package quests._124_MeetingTheElroki;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

public class _124_MeetingTheElroki extends Quest implements ScriptFile
{
	//NPC
	public final int Marquez = 32113;
	public final int Mushika = 32114;
	public final int Asamah = 32115;
	public final int Karakawei = 32117;
	public final int Mantarasa = 32118;
	//item
	public final int Mushika_egg = 8778;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 124 : Meeting The Elroki");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _124_MeetingTheElroki()
	{
		super(124, "_124_MeetingTheElroki", "Meeting The Elroki", false);

		addStartNpc(Marquez);
		addTalkId(Marquez);
		addTalkId(Mushika);
		addTalkId(Asamah);
		addTalkId(Karakawei);
		addTalkId(Mantarasa);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		int cond = st.getInt("cond");
		String htmltext = event;

		if(event.equals("32113-02.htm"))
			st.setState(STARTED);
		if(event.equals("32113-03.htm") && cond == 0)
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		if(event.equals("32113-04.htm") && cond == 1)
		{
			st.set("cond", "2");
			st.playSound(SOUND_ITEMGET);
		}
		if(event.equals("32114-02.htm") && cond == 2)
		{
			st.set("cond", "3");
			st.playSound(SOUND_ITEMGET);
		}
		if(event.equals("32115-04.htm") && cond == 3)
		{
			st.set("cond", "4");
			st.playSound(SOUND_ITEMGET);
		}
		if(event.equals("32117-02.htm") && cond == 4)
			st.set("id", "1");
		if(event.equals("32117-03.htm") && cond == 4)
		{
			st.set("cond", "5");
			st.playSound(SOUND_ITEMGET);
		}
		if(event.equals("32118-02.htm") && cond == 5)
		{
			st.giveItems(Mushika_egg, 1);
			st.set("cond", "6");
			st.playSound(SOUND_MIDDLE);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == Marquez)
		{
			if(cond == 0)
			{
				if(st.getPlayer().getLevel() < 75)
				{
					htmltext = "32113-01a.htm";
					st.exitCurrentQuest(true);
				}
				else
					htmltext = "32113-01.htm";
			}
			else if(cond == 1)
				htmltext = "32113-03.htm";
			else if(cond == 2)
				htmltext = "32113-04a.htm";
		}
		else if(npcId == Mushika && cond == 2)
			htmltext = "32114-01.htm";
		else if(npcId == Asamah)
		{
			if(cond == 3)
				htmltext = "32115-01.htm";
			else if(cond == 6)
			{
				htmltext = "32115-05.htm";
				st.takeItems(Mushika_egg, 1);
				st.giveItems(57, 71318);
				st.set("cond", "0");
				st.playSound(SOUND_FINISH);
			}
		}

		else if(npcId == Karakawei)
		{
			if(cond == 4)
			{
				htmltext = "32117-01.htm";

				if(st.getInt("id") == 1)
					htmltext = "32117-02.htm";
				else if(cond == 5)

					htmltext = "32117-04.htm";
			}
		}
		else if(npcId == Mantarasa && cond == 5)
			htmltext = "32118-01.htm";

		return htmltext;
	}
}