package quests._178_IconicTrinity;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;
import l2r.util.Files;

public class _178_IconicTrinity extends Quest implements ScriptFile
{
	//NPC
	private static final int Kekropus = 32138;
	private static final int IconOfThePast = 32255;
	private static final int IconOfThePresent = 32256;
	private static final int IconOfTheFuture = 32257;
	//Items
	private static final int EnchantD = 956;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 178: Iconic Trinity");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _178_IconicTrinity()
	{
		super(178, "_178_IconicTrinity", "Iconic Trinity", false);

		addStartNpc(Kekropus);
		addTalkId(IconOfThePast);
		addTalkId(IconOfThePresent);
		addTalkId(IconOfTheFuture);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("32138-02.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("32255-03.htm") || event.equalsIgnoreCase("32256-03.htm") || event.equalsIgnoreCase("32257-03.htm"))
			st.set("id", "");
		else if(event.equalsIgnoreCase("32255-09.htm"))
		{
			st.set("id", "");
			st.set("cond", "2");
			st.setState(STARTED);
		}
		else if(event.equalsIgnoreCase("32256-09.htm"))
		{
			st.set("id", "");
			st.set("cond", "3");
			st.setState(STARTED);
		}
		else if(event.equalsIgnoreCase("32257-06.htm"))
		{
			st.set("id", "");
			st.set("cond", "4");
			st.setState(STARTED);
		}
		else if(event.length() == 1)
		{
			int cond = st.getInt("cond");
			st.set("id", st.get("id") + event);
			int len = st.get("id").toString().length();
			if(len == 4 && (cond == 1 || cond == 2) || len == 5 && cond == 3)
			{
				if(cond == 1 && st.get("id") != null && st.get("id").toString().equalsIgnoreCase("CRTR"))
					htmltext = "32255-04.htm";
				else if(cond == 2 && st.get("id") != null && st.get("id").toString().equalsIgnoreCase("CNCL"))
					htmltext = "32256-04.htm";
				else if(cond == 3 && st.get("id") != null && st.get("id").toString().equalsIgnoreCase("CHAOS"))
					htmltext = "32257-04.htm";
				else
				{
					htmltext = "<html><body>Quest Failed</body></html>";
					st.exitCurrentQuest(true);
				}
			}
			else
			{
				if(cond == 1)
					htmltext = Files.read("data/scripts/quests/_178_IconicTrinity/32255-03.htm");
				else if(cond == 2)
					htmltext = Files.read("data/scripts/quests/_178_IconicTrinity/32256-03.htm");
				else
					htmltext = Files.read("data/scripts/quests/_178_IconicTrinity/32257-03.htm");
				if(len == 1)
					htmltext = htmltext.replace("%pass%", "*");
				else if(len == 2)
					htmltext = htmltext.replace("%pass%", "**");
				else if(len == 3)
					htmltext = htmltext.replace("%pass%", "***");
				else
					htmltext = htmltext.replace("%pass%", "****");
			}
		}
		else if(event.equalsIgnoreCase("32138-04.htm"))
		{
			st.giveItems(EnchantD, 1, true);
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(false);
		}
		if(event.equalsIgnoreCase("32255-07.htm") || event.equalsIgnoreCase("32255-09.htm") || event.equalsIgnoreCase("32256-07.htm") || event.equalsIgnoreCase("32256-08.htm") || event.equalsIgnoreCase("32256-09.htm") || event.equalsIgnoreCase("32257-06.htm"))
		{
			htmltext = Files.read("data/scripts/quests/_178_IconicTrinity/" + event);
			htmltext = htmltext.replace("%player_name%", st.getPlayer().getName());
		}

		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		String htmltext = "noquest";
		int cond = st.getInt("cond");
		if(npcId == Kekropus)
		{
			if(cond == 0)
			{
				if(st.getPlayer().getLevel() >= 17)
					htmltext = "32138-01.htm";
				else
				{
					htmltext = "32138-00.htm";
					st.exitCurrentQuest(true);
				}
			}
			else if(cond == 4)
				htmltext = "32138-03.htm";
		}
		else if(npcId == IconOfThePast && cond == 1)
			htmltext = "32255-01.htm";
		else if(npcId == IconOfThePresent && cond == 2)
			htmltext = "32256-01.htm";
		else if(npcId == IconOfTheFuture && cond == 3)
			htmltext = "32257-01.htm";
		return htmltext;
	}
}
