package quests._211_TrialOfChallenger;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.L2World;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;
import l2r.gameserver.model.quest.State;
import l2r.util.Rnd;

public class _211_TrialOfChallenger extends Quest implements ScriptFile
{
	public void onLoad()
	{
		System.out.println("Loaded Quest: 211: Trial Of Challenger");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	private static final int LETTER_OF_KASH_ID = 2628;
	private static final int SCROLL_OF_SHYSLASSY_ID = 2631;
	private static final int WATCHERS_EYE1_ID = 2629;
	private static final int BROKEN_KEY_ID = 2632;
	private static final int MITHRIL_SCALE_GAITERS_MATERIAL_ID = 2918;
	private static final int BRIGANDINE_GAUNTLET_PATTERN_ID = 2927;
	private static final int MANTICOR_SKIN_GAITERS_PATTERN_ID = 1943;
	private static final int GAUNTLET_OF_REPOSE_OF_THE_SOUL_PATTERN_ID = 1946;
	private static final int IRON_BOOTS_DESIGN_ID = 1940;
	private static final int TOME_OF_BLOOD_PAGE_ID = 2030;
	private static final int ELVEN_NECKLACE_BEADS_ID = 1904;
	private static final int WHITE_TUNIC_PATTERN_ID = 1936;
	private static final int ADENA_ID = 57;
	private static final int MARK_OF_CHALLENGER_ID = 2627;
	private static final int WATCHERS_EYE2_ID = 2630;
	private static final int RewardExp = 72394;
	private static final int RewardSP = 11250;

	public _211_TrialOfChallenger()
	{
		super(211, "_211_TrialOfChallenger", "Trial Of Challenger", false);

		addStartNpc(30644);

		addTalkId(30644);
		addTalkId(30644);
		addTalkId(30644);

		addTalkId(30535);
		for(int i = 30644; i < 30648; i++)
			addTalkId(i);
		for(int i = 27110; i < 27115; i++)
			addKillId(i);

		addQuestItem(new int[] { SCROLL_OF_SHYSLASSY_ID, LETTER_OF_KASH_ID, WATCHERS_EYE1_ID, BROKEN_KEY_ID, WATCHERS_EYE2_ID });
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("1"))
		{
			htmltext = "30644-05.htm";
			st.set("cond", "1");
			st.setState(STARTED);
			if(!st.getPlayer().getVarB("dd1"))
			{
				st.giveItems(7562, 64);
				st.getPlayer().setVar("dd1", "1");
			}
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("30644_1"))
			htmltext = "30644-04.htm";
		else if(event.equalsIgnoreCase("30645_1"))
		{
			htmltext = "30645-02.htm";
			st.takeItems(LETTER_OF_KASH_ID, 1);
			st.set("cond", "4");
		}
		else if(event.equalsIgnoreCase("30647_1"))
		{
			if(st.getQuestItemsCount(BROKEN_KEY_ID) > 0)
			{
				st.giveItems(SCROLL_OF_SHYSLASSY_ID, 1);
				if(Rnd.chance(22))
				{
					htmltext = "30647-03.htm";
					st.takeItems(BROKEN_KEY_ID, 1);
					st.playSound(SOUND_JACKPOT);
					int n = Rnd.get(100);
					if(n > 90)
					{
						st.giveItems(MITHRIL_SCALE_GAITERS_MATERIAL_ID, 1);
						st.giveItems(BRIGANDINE_GAUNTLET_PATTERN_ID, 1);
						st.giveItems(MANTICOR_SKIN_GAITERS_PATTERN_ID, 1);
						st.giveItems(GAUNTLET_OF_REPOSE_OF_THE_SOUL_PATTERN_ID, 1);
						st.giveItems(IRON_BOOTS_DESIGN_ID, 1);
					}
					else if(n > 70)
					{
						st.giveItems(TOME_OF_BLOOD_PAGE_ID, 1);
						st.giveItems(ELVEN_NECKLACE_BEADS_ID, 1);
					}
					else if(n > 40)
						st.giveItems(WHITE_TUNIC_PATTERN_ID, 1);
					else
						st.giveItems(IRON_BOOTS_DESIGN_ID, 1);
				}
				else
				{
					htmltext = "30647-02.htm";
					st.takeItems(BROKEN_KEY_ID, -1);
					st.giveItems(ADENA_ID, Rnd.get(1000) + 1);
				}
			}
			else
				htmltext = "30647-04.htm";
		}
		else if(event.equalsIgnoreCase("30646_1"))
			htmltext = "30646-02.htm";
		else if(event.equalsIgnoreCase("30646_2"))
			htmltext = "30646-03.htm";
		else if(event.equalsIgnoreCase("30646_3"))
		{
			htmltext = "30646-04.htm";
			st.set("cond", "8");
			st.takeItems(WATCHERS_EYE2_ID, 1);
		}
		else if(event.equalsIgnoreCase("30646_4"))
		{
			htmltext = "30646-06.htm";
			st.set("cond", "8");
			st.takeItems(WATCHERS_EYE2_ID, 1);
		}
		else if(event.equalsIgnoreCase("30646_Fail"))
		{
			L2NpcInstance isQuest = L2World.findNpcByNpcId(30646);
			if(isQuest != null)
				isQuest.deleteMe();
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		if(st.getQuestItemsCount(MARK_OF_CHALLENGER_ID) > 0)
		{
			st.exitCurrentQuest(true);
			return "completed";
		}
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		State id = st.getState();
		int cond = st.getInt("cond");
		if(id == CREATED)
		{
			st.set("cond", "0");
			if(npcId == 30644)
				if(st.getPlayer().getClassId().ordinal() == 0x01 || st.getPlayer().getClassId().ordinal() == 0x13 || st.getPlayer().getClassId().ordinal() == 0x20 || st.getPlayer().getClassId().ordinal() == 0x2d || st.getPlayer().getClassId().ordinal() == 0x2f)
					if(st.getPlayer().getLevel() >= 35)
						htmltext = "30644-03.htm";
					else
					{
						htmltext = "30644-01.htm";
						st.exitCurrentQuest(true);
					}
				else
				{
					htmltext = "30644-02.htm";
					st.exitCurrentQuest(true);
				}
		}
		else if(npcId == 30644 && cond == 1)
			htmltext = "30644-06.htm";
		else if(npcId == 30644 && cond == 2 && st.getQuestItemsCount(SCROLL_OF_SHYSLASSY_ID) == 1)
		{
			htmltext = "30644-07.htm";
			st.takeItems(SCROLL_OF_SHYSLASSY_ID, 1);
			st.giveItems(LETTER_OF_KASH_ID, 1);
			st.set("cond", "3");
		}
		else if(npcId == 30644 && cond == 1 && st.getQuestItemsCount(LETTER_OF_KASH_ID) == 1)
			htmltext = "30644-08.htm";
		else if(npcId == 30644 && cond >= 7)
			htmltext = "30644-09.htm";
		else if(npcId == 30645 && cond == 3 && st.getQuestItemsCount(LETTER_OF_KASH_ID) == 1)
			htmltext = "30645-01.htm";
		else if(npcId == 30645 && cond == 4 && st.getQuestItemsCount(WATCHERS_EYE1_ID) == 0)
			htmltext = "30645-03.htm";
		else if(npcId == 30645 && cond == 5 && st.getQuestItemsCount(WATCHERS_EYE1_ID) > 0)
		{
			htmltext = "30645-04.htm";
			st.takeItems(WATCHERS_EYE1_ID, 1);
			st.set("cond", "6");
		}
		else if(npcId == 30645 && cond == 6)
			htmltext = "30645-05.htm";
		else if(npcId == 30645 && cond >= 7)
			htmltext = "30645-06.htm";
		else if(npcId == 30647 && cond == 2)
			htmltext = "30647-01.htm";
		else if(npcId == 30646 && cond == 7 && st.getQuestItemsCount(WATCHERS_EYE2_ID) > 0)
			htmltext = "30646-01.htm";
		else if(npcId == 30646 && cond == 8)
			htmltext = "30646-06a.htm";
		else if(npcId == 30646 && cond == 10)
		{
			L2NpcInstance isQuest = L2World.findNpcByNpcId(30646);
			if(isQuest != null)
				isQuest.deleteMe();
			htmltext = "30646-07.htm";
			st.takeItems(BROKEN_KEY_ID, -1);
			st.giveItems(MARK_OF_CHALLENGER_ID, 1);
			if(!st.getPlayer().getVarB("q211"))
			{
				st.addExpAndSp(RewardExp, RewardSP, true);
				st.getPlayer().setVar("q211", "1");
			}
			st.playSound(SOUND_FINISH);
			st.unset("cond");
			st.exitCurrentQuest(false);
		}
		else if(npcId == 30535 && cond == 8)
			if(st.getPlayer().getLevel() >= 36)
			{
				htmltext = "30535-01.htm";
				st.addRadar(176560, -184969, -3729);
				st.set("cond", "9");
			}
			else
				htmltext = "30535-03.htm";
		else if(npcId == 30535 && cond == 9)
		{
			htmltext = "30535-02.htm";
			st.addRadar(176560, -184969, -3729);
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == 27110 && cond == 1 && st.getQuestItemsCount(SCROLL_OF_SHYSLASSY_ID) == 0 && st.getQuestItemsCount(BROKEN_KEY_ID) == 0)
		{
			st.giveItems(BROKEN_KEY_ID, 1);
			st.getPcSpawn().addSpawn(30647);
			st.playSound(SOUND_MIDDLE);
			st.set("cond", "2");
		}
		else if(npcId == 27112 && cond == 4 && st.getQuestItemsCount(WATCHERS_EYE1_ID) == 0)
		{
			st.giveItems(WATCHERS_EYE1_ID, 1);
			st.set("cond", "5");
			st.playSound(SOUND_MIDDLE);
		}
		else if(npcId == 27113 && cond == 6 && st.getQuestItemsCount(WATCHERS_EYE2_ID) == 0)
		{
			L2NpcInstance npcspawn = L2World.findNpcByNpcId(30646);
			if(npcspawn == null)
			{
				st.giveItems(WATCHERS_EYE2_ID, 1);
				st.playSound(SOUND_MIDDLE);
				st.set("cond", "7");
				st.getPcSpawn().addSpawn(30646);
				st.startQuestTimer("30646_Fail", 300000);
			}
		}
		else if(npcId == 27113 && cond == 7)
		{
			L2NpcInstance npcspawn = L2World.findNpcByNpcId(30646);
			if(npcspawn == null)
			{
				if(st.getQuestItemsCount(WATCHERS_EYE2_ID) == 0)
					st.giveItems(WATCHERS_EYE2_ID, 1);
				st.playSound(SOUND_MIDDLE);
				st.set("cond", "7");
				st.getPcSpawn().addSpawn(30646);
				st.startQuestTimer("30646_Fail", 300000);
			}
		}
		else if(npcId == 27114 && (cond == 9 || cond == 10))
		{
			L2NpcInstance npcspawn = L2World.findNpcByNpcId(30646);
			if(npcspawn == null)
			{
				st.set("cond", "10");
				st.playSound(SOUND_MIDDLE);
				st.getPcSpawn().addSpawn(30646);
				st.startQuestTimer("30646_Fail", 300000);
			}
		}
		return null;
	}
}