package quests._350_EnhanceYourWeapon;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;
import l2r.gameserver.model.quest.State;

public class _350_EnhanceYourWeapon extends Quest implements ScriptFile
{
	private static final int RED_SOUL_CRYSTAL0_ID = 4629;
	private static final int GREEN_SOUL_CRYSTAL0_ID = 4640;
	private static final int BLUE_SOUL_CRYSTAL0_ID = 4651;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 350: Enhance Your Weapon");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _350_EnhanceYourWeapon()
	{
		super(350, "_350_EnhanceYourWeapon", "Enhance Your Weapon", false);
		addStartNpc(30115);
		addTalkId(30115);
		addTalkId(30856);
		addTalkId(30856);
	}

	public boolean check(QuestState st)
	{
		return st.getQuestItemsCount(RED_SOUL_CRYSTAL0_ID) > 0 || st.getQuestItemsCount(GREEN_SOUL_CRYSTAL0_ID) > 0 || st.getQuestItemsCount(BLUE_SOUL_CRYSTAL0_ID) > 0;
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		if(event.equalsIgnoreCase("30115-04.htm") || event.equalsIgnoreCase("30856-04.htm") || event.equalsIgnoreCase("30856-04.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		if(event.equalsIgnoreCase("30115-09.htm") || event.equalsIgnoreCase("30856-09.htm") || event.equalsIgnoreCase("30856-09.htm"))
			st.giveItems(RED_SOUL_CRYSTAL0_ID, 1);
		if(event.equalsIgnoreCase("30115-10.htm") || event.equalsIgnoreCase("30856-10.htm") || event.equalsIgnoreCase("30856-10.htm"))
			st.giveItems(GREEN_SOUL_CRYSTAL0_ID, 1);
		if(event.equalsIgnoreCase("30115-11.htm") || event.equalsIgnoreCase("30856-11.htm") || event.equalsIgnoreCase("30856-11.htm"))
			st.giveItems(BLUE_SOUL_CRYSTAL0_ID, 1);
		if(event.equalsIgnoreCase("exit.htm"))
			st.exitCurrentQuest(true);
		return event;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String npcId = str(npc.getNpcId());
		String htmltext = "noquest";
		State id = st.getState();
		String id2 = st.getStateId();
		if(id == CREATED || id2.equalsIgnoreCase("Aborted"))
			st.set("cond", "0");
		if(st.getInt("cond") == 0)
			htmltext = npcId + "-01.htm";
		if(check(st))
			htmltext = npcId + "-03.htm";
		if(st.getQuestItemsCount(RED_SOUL_CRYSTAL0_ID) == 0 && st.getQuestItemsCount(GREEN_SOUL_CRYSTAL0_ID) == 0 && st.getQuestItemsCount(BLUE_SOUL_CRYSTAL0_ID) == 0)
			htmltext = npcId + "-21.htm";
		return htmltext;
	}
}
