package quests._375_WhisperOfDreams2;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;
import l2r.gameserver.model.quest.State;
import l2r.util.Rnd;

public class _375_WhisperOfDreams2 extends Quest implements ScriptFile
{
	private int ALT_RP_100 = 0; //alternative rewards ? o_O
	//NPCs
	private int MANAKIA = 30515;
	//Quest items
	private int MSTONE = 5887;
	private int K_HORN = 5888;
	private int CH_SKULL = 5889;
	//Quest collections
	private int[] REWARDS = { 5348, 5352, 5350 };

	//Mobs & Drop
	private int[][] DROPLIST = { { 20624, CH_SKULL }, { 20629, K_HORN } };

	//Messages
	private String _default = "noquest";

	public _375_WhisperOfDreams2()
	{
		super(375, "_375_WhisperOfDreams2", "Whisper Of Dreams 2", true);

		addStartNpc(MANAKIA);
		addKillId(20624);
		addKillId(20629);
		addQuestItem(new int[] { DROPLIST[0][1], DROPLIST[1][1] });
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		if(event.equalsIgnoreCase("30515-6.htm"))
		{
			st.takeItems(MSTONE, 1);
			st.setState(STARTED);
			st.set("cond", "1");
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("30515-7.htm"))
		{
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(true);
		}
		return event;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = _default;
		State id = st.getState();
		if(id.equals(CREATED))
		{
			st.set("cond", "0");
			htmltext = "30515-1.htm";
			if(st.getPlayer().getLevel() < 60)
			{
				htmltext = "30515-2.htm";
				st.exitCurrentQuest(true);
			}
			else if(st.getQuestItemsCount(MSTONE) < 1)
			{
				htmltext = "30515-3.htm";
				st.exitCurrentQuest(true);
			}
		}
		else if(id.equals(STARTED))
			if(st.getQuestItemsCount(CH_SKULL) == st.getQuestItemsCount(K_HORN) && st.getQuestItemsCount(CH_SKULL) == 100)
			{
				st.takeItems(CH_SKULL, -1);
				st.takeItems(K_HORN, -1);
				int item = REWARDS[Rnd.get(REWARDS.length)];
				if(ALT_RP_100 > 0)
					item += 1;
				st.giveItems(item, 1);
				htmltext = "30515-4.htm";
				st.exitCurrentQuest(true);
			}
			else
				htmltext = "30515-5.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int DROP_RATE = 20 * (int) st.getRateQuestsReward();
		if(DROP_RATE > 100)
			DROP_RATE = 100;

		int npcid = npc.getNpcId();
		int item = 0;
		for(int[] element : DROPLIST)
			if(npcid == element[0])
				item = element[1];
		long count = st.getQuestItemsCount(item);
		if(count < 100 && Rnd.chance(DROP_RATE))
		{
			st.giveItems(item, 1);
			if(count + 1 >= 100)
				st.playSound(SOUND_MIDDLE);
			else
				st.playSound(SOUND_ITEMGET);
		}
		return null;
	}

	public void onLoad()
	{
		System.out.println("Loaded Quest: 375: Whisper Of Dreams 2");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}