package quests._376_GiantsExploration1;

import l2r.Config;
import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;
import l2r.gameserver.model.quest.State;
import l2r.util.Rnd;

/**
 * Квест проверен и работает, рейты применены путем увеличения шанса выпадения квестовых вещей
 */
public class _376_GiantsExploration1 extends Quest implements ScriptFile
{
	public void onLoad()
	{
		System.out.println("Loaded Quest: 376: Giants Cave Exploration part 1");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	// Ancient parchment drop rate in %
	private static final int DROP_RATE = 5;
	// Mysterious Book drop rate in %
	private static final int DROP_RATE_2 = 8;

	// Quest items
	private static final int ANC_SCROLL = 5944;
	private static final int DICT1 = 5891;
	private static final int DICT2 = 5892; // Given as a proof for 2nd part
	private static final int MST_BK = 5890;

	private static final int[][] EXCHANGE = {
	// collection items list,     rnd_1, rnd_2
			{ 5937, 5938, 5939, 5940, 5941 },
			{ 5346, 5354 }, // medical theory, tallum_tunic,     tallum_hose
			{ 5932, 5933, 5934, 5935, 5936 },
			{ 5332, 5334 }, // architecture,   drk_crstl_leather,tallum_leather
			{ 5922, 5923, 5924, 5925, 5926 },
			{ 5416, 5418 }, // golem plans,    drk_crstl_breastp,tallum_plate
			{ 5927, 5928, 5929, 5930, 5931 },
			{ 5424, 5340 } // basics of magic,drk_crstl_gaiters,dark_crystal_legg
	};

	// Messages
	private static final String error_1 = "<html><head><body>Head Researcher Sobling:<br><br>I think it is too early for you to help me. Come back after you have gained some more experience. <br><font color=\"LEVEL\">(Quest for characters level 51 and above.)</font></body></html>";
	private static final String start = "<html><head><body>Head Researcher Sobling:<br><br>As leader of the research team i'm looking for experienced adventurers to join us. Actually we're searching for relics from the ancient Giants Culture. There are four scripts we can't find yet: <font color=\"LEVEL\">Plans for the construction of Golems, Basis of the Giant's Magic, Construction Technology Handbook and Giant's Medical Theory.</font><br><br>Given the value of the items we're looking for, there is no need to tell you how generous shall be my rewards.<br><br><a action=\"bypass -h Quest _376_GiantsExploration1 yes\">I will search for ancient items</a><br><a action=\"bypass -h Quest _376_GiantsExploration1 0\">I won't help you</a><br></body></html>";
	private static final String starting = "Starting.htm";
	private static final String checkout = "<html><head><body>Head Researcher Sobling:<br><br>Excellent! You came back! Was it difficult to collect ancient pieces?<br><br>Let me see what you've found thus far...<br><br><a action=\"bypass -h Quest _376_GiantsExploration1 show\">Show him the books you collected</a><br><a action=\"bypass -h Quest _376_GiantsExploration1 myst\">Show him another items you've found</a><br></body></html>";
	private static final String checkout2 = "<html><head><body>Head Researcher Sobling:<br><br>Excellent! You came back! Was it difficult to collect ancient pieces?<br><br>Hum... what is it? You have some ancient scrolls here, but those are of no use to me until you translate its contents, i have no time to do it on my own and that's why i gave you the dictionary. Anyway i can check any other ancient item you may have...<br><br><a action=\"bypass -h Quest _376_GiantsExploration1 show\">Show him the scrolls you collected</a><br><a action=\"bypass -h Quest _376_GiantsExploration1 myst\">Show him another items you've found</a><br></body></html>";
	private static final String no_items = "<html><head><body>Head Researcher Sobling:<br><br>Hum... I see no valuable items here, you should continue your research. I'm pretty sure you can do it better if you put more effort... what you think?<br><br><a action=\"bypass -h Quest _376_GiantsExploration1 Starting.htm\">I will continue</a><br><a action=\"bypass -h Quest _376_GiantsExploration1 0\">I will quit</a><br></body></html>";
	private static final String tnx4items = "<html><head><body>Head Researcher Sobling:<br><br>Amazing! These are the sort of items i was looking for... Take this rare recipes as a proof of my gratitude. Anyhow, I'm sure there are more ancient relics guarded by those monsters, would you like to search some more?<br><br><a action=\"bypass -h Quest _376_GiantsExploration1 Starting.htm\">I will continue</a><br><a action=\"bypass -h Quest _376_GiantsExploration1 0\">I will quit</a><br></body></html>";
	private static final String go_part2 = "<html><head><body>Head Researcher Sobling:<br><br>Interesting. What could this mysterious book be? I'm afraid we will not be able to figure out it's contents without assistance. But don't worry, i know who can help us, go now and talk with <font color=\"LEVEL\">Warehouse Freightman Cliff in Oren Castle Town</font>, show him the tome and he will probably know what to do with it.<br><br></body></html>";
	private static final String no_part2 = "<html><head><body>Head Researcher Sobling:<br><br>I don't find anything useful here... I'm aware already about some discoveries related to giant's living, but there is no archeological value in vane letters or drawings you may find. As i told you, we are in desperate search for <font color=\"LEVEL\">Plans for the construction of Golems, Basis of the Giant's Magic, Construction Technology and Giant's Medical Theory.</font> You must bring any of those books complete. Few we can do only with fragments.<br><br></body></html>";
	private static final String ok_part2 = "<html><head><body>Warehouse Freightman Cliff:<br><br>What is that book? Sobling told you to bring it to me? Well... It's written in a very ancient language.. yes.. Humm.. Take this \"Ancient Language Dictionary: Intermediate Level\" and meet <font color=\"LEVEL\">Sobling</font> again. With this he will be able to translate it. Leave now.</body></html>";
	private static final String gogogo_2 = "<html><head><body>Head Researcher Sobling:<br><br>Are you still there with the book? There is no way to read it's contents with our current knowledge. Take the book to <font color=\"LEVEL\">Warehouse Freightman Cliff in Oren Castle Town</font>.<br><br></body></html>";
	private static final String ext_msg = "Quest aborted";

	// NPCs
	private static final int HR_SOBLING = 31147;
	private static final int WF_CLIFF = 30182;

	// Mobs
	private static final int MOBS_START = 20647;
	private static final int MOBS_END = 20650;

	public _376_GiantsExploration1()
	{
		super(376, "_376_GiantsExploration1", "Giants Cave Exploration part 1", true);
		addStartNpc(HR_SOBLING);
		addTalkId(WF_CLIFF);

		for(int i = MOBS_START; i <= MOBS_END; i++)
			addKillId(i);

		addQuestItem(new int[] { DICT1, MST_BK, ANC_SCROLL });
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		int cond = st.getInt("cond");
		if(event.equalsIgnoreCase("yes"))
		{
			htmltext = starting;
			st.setState(STARTED);
			st.set("cond", "1");
			st.giveItems(DICT1, 1);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("0"))
		{
			htmltext = ext_msg;
			st.playSound(SOUND_FINISH);
			st.takeItems(DICT1, -1);
			st.takeItems(MST_BK, -1);
			st.exitCurrentQuest(true);
		}
		else if(event.equalsIgnoreCase("show"))
		{
			htmltext = no_items;
			for(int i = 0; i < EXCHANGE.length; i = i + 2)
			{
				long count = Long.MAX_VALUE;
				for(int j : EXCHANGE[i])
					count = Math.min(count, st.getQuestItemsCount(j));
				if(count >= 1)
				{
					htmltext = tnx4items;
					for(int j : EXCHANGE[i])
						st.takeItems(j, count);
					for(int l = 0; l < count; l++)
					{
						int item = EXCHANGE[i + 1][Rnd.get(EXCHANGE[i + 1].length)];
						if(Config.ALT_100_RECIPES)
							item += 1;
						st.giveItems(item, 1);
					}
				}
			}
		}
		else if(event.equalsIgnoreCase("myst"))
			if(st.getQuestItemsCount(MST_BK) > 0)
			{
				if(cond == 1)
				{
					st.setState(STARTED);
					st.set("cond", "2");
					htmltext = go_part2;
				}
				else if(cond == 2)
					htmltext = gogogo_2;
			}
			else
				htmltext = no_part2;
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		State id = st.getState();
		int cond = st.getInt("cond");
		if(npcId == HR_SOBLING)
		{
			if(id == CREATED)
			{
				htmltext = start;
				if(st.getPlayer().getLevel() < 51)
				{
					st.exitCurrentQuest(true);
					htmltext = error_1;
				}
			}
			else if(id == STARTED)
				if(st.getQuestItemsCount(ANC_SCROLL) == 0 && st.getQuestItemsCount(MST_BK) == 0)
					htmltext = checkout;
				else
					htmltext = checkout2;
		}
		else if(npcId == WF_CLIFF)
			if(cond == 2 & st.getQuestItemsCount(MST_BK) > 0)
			{
				htmltext = ok_part2;
				st.takeItems(MST_BK, 1);
				st.giveItems(DICT2, 1);
				st.set("cond", "3");
				st.playSound(SOUND_MIDDLE);
			}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		st.rollAndGive(ANC_SCROLL, 1, 1, DROP_RATE);
		if(st.getInt("cond") == 1)
			st.rollAndGive(MST_BK, 1, 1, 1, DROP_RATE_2);
		return null;
	}
}