package quests._383_SearchingForTreasure;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

public class _383_SearchingForTreasure extends Quest implements ScriptFile
{
	//Items
	//quest items
	private static final int TREASURE_MAP = 5915;
	//non-quest items
	//private static final int THIEF_KEY = 1661;
	//private static final int ADENA = 57;

	//NPC
	private static final int ESPEN = 30890;
	private static final int TREASURE_CHEST = 31148;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 383: Searching For Treasure");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _383_SearchingForTreasure()
	{
		super(383, "_383_SearchingForTreasure", "Searching For Treasure", false);

		addStartNpc(ESPEN);

		addTalkId(ESPEN);
		addTalkId(TREASURE_CHEST);

		addQuestItem(TREASURE_MAP);

	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("showmap"))
		{
			if(st.getQuestItemsCount(TREASURE_MAP) < 1)
				htmltext = "30890-havenot.htm";
			else
				htmltext = "30890-01-1.htm";

		}
		else if(event.equalsIgnoreCase("selled"))
		{
			htmltext = "30890-selled.htm";
			st.giveItems(57, 1000);
			st.set("cond", "0");
			st.setState(COMPLETED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("30890-04.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.takeItems(TREASURE_MAP, 1);
		}
		else if(event.equalsIgnoreCase("30890-07.htm"))
			st.set("cond", "2");
		else if(event.equalsIgnoreCase("openchest"))
			htmltext = "openchest";

		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		switch(npcId)
		{
			case ESPEN:
			{
				switch(cond)
				{
					case 0:
						if(st.getPlayer().getLevel() < 42)
						{
							htmltext = "30890-00.htm";
							st.exitCurrentQuest(true);
						}
						else if(st.getQuestItemsCount(TREASURE_MAP) < 1)
							htmltext = "30890-00-1.htm";
						else
							htmltext = "30890-01.htm";
						break;
					case 1:
						htmltext = "30890-03.htm";
						break;
					case 2:
						htmltext = "30890-03.htm";
						break;
				}
				break;
			}

			case TREASURE_CHEST:
			{
				if(cond == 2)
					htmltext = "31148-03.htm";
				break;
			}
		}

		return htmltext;
	}

}