package quests._605_AllianceWithKetraOrcs;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

public class _605_AllianceWithKetraOrcs extends Quest implements ScriptFile
{
	//ketra mobs
	private static final int[] KETRA_NPC_LIST = new int[19];

	// items
	private static final int MARK_OF_KETRA_ALLIANCE1 = 7211;
	private static final int MARK_OF_KETRA_ALLIANCE2 = 7212;
	private static final int MARK_OF_KETRA_ALLIANCE3 = 7213;
	private static final int MARK_OF_KETRA_ALLIANCE4 = 7214;
	private static final int MARK_OF_KETRA_ALLIANCE5 = 7215;
	private static final int VB_SOLDIER = 7216;
	private static final int VB_CAPTAIN = 7217;
	private static final int VB_GENERAL = 7218;
	private static final int TOTEM_OF_VALOR = 7219;
	private static final int TOTEM_OF_WISDOM = 7220;

	// hunt for soldier
	private static final int RECRUIT = 21350;
	private static final int FOOTMAN = 21351;
	private static final int SCOUT = 21353;
	private static final int HUNTER = 21354;
	private static final int SHAMAN = 21355;

	// hunt for captain
	private static final int PRIEST = 21357;
	private static final int WARRIOR = 21358;
	private static final int MEDIUM = 21360;
	private static final int MAGUS = 21361;
	private static final int OFFICIER = 21362;
	private static final int COMMANDER = 21369;
	private static final int ELITE_GUARD = 21370;

	// hunt for general
	private static final int GREAT_MAGUS = 21365;
	private static final int GENERAL = 21366;
	private static final int GREAT_SEER = 21368;
	private static final int VARKA_PROPHET = 21373;
	private static final int DISCIPLE_OF_PROPHET = 21375;
	private static final int PROPHET_GUARDS = 21374;
	private static final int HEAD_MAGUS = 21371;
	private static final int HEAD_GUARDS = 21372;
	private static final int Wahkan = 31371;

	public _605_AllianceWithKetraOrcs()
	{
		super(605, "_605_AllianceWithKetraOrcs", "Alliance With Ketra Orcs", true);

		addStartNpc(Wahkan);

		addTalkId(Wahkan);

		//ketra mobs
		KETRA_NPC_LIST[0] = 21324;
		KETRA_NPC_LIST[1] = 21325;
		KETRA_NPC_LIST[2] = 21327;
		KETRA_NPC_LIST[3] = 21328;
		KETRA_NPC_LIST[4] = 21329;
		KETRA_NPC_LIST[5] = 21331;
		KETRA_NPC_LIST[6] = 21332;
		KETRA_NPC_LIST[7] = 21334;
		KETRA_NPC_LIST[8] = 21335;
		KETRA_NPC_LIST[9] = 21336;
		KETRA_NPC_LIST[10] = 21338;
		KETRA_NPC_LIST[11] = 21339;
		KETRA_NPC_LIST[12] = 21340;
		KETRA_NPC_LIST[13] = 21342;
		KETRA_NPC_LIST[14] = 21343;
		KETRA_NPC_LIST[15] = 21344;
		KETRA_NPC_LIST[16] = 21345;
		KETRA_NPC_LIST[17] = 21346;
		KETRA_NPC_LIST[18] = 21347;
		addKillId(KETRA_NPC_LIST);

		//hunt for soldier
		addKillId(RECRUIT);
		addKillId(FOOTMAN);
		addKillId(SCOUT);
		addKillId(HUNTER);
		addKillId(SHAMAN);

		//hunt for captain
		addKillId(PRIEST);
		addKillId(WARRIOR);
		addKillId(MEDIUM);
		addKillId(MAGUS);
		addKillId(OFFICIER);
		addKillId(COMMANDER);
		addKillId(ELITE_GUARD);

		//hunt for general
		addKillId(GREAT_MAGUS);
		addKillId(GENERAL);
		addKillId(GREAT_SEER);
		addKillId(VARKA_PROPHET);
		addKillId(DISCIPLE_OF_PROPHET);
		addKillId(PROPHET_GUARDS);
		addKillId(HEAD_MAGUS);
		addKillId(HEAD_GUARDS);

		addQuestItem(VB_SOLDIER);
		addQuestItem(VB_CAPTAIN);
		addQuestItem(VB_GENERAL);
	}

	public boolean isKetraNpc(int npc)
	{
		for(int i : KETRA_NPC_LIST)
			if(npc == i)
				return true;
		return false;
	}

	public void onLoad()
	{
		System.out.println("Loaded Quest: 605: Alliance With Ketra Orcs");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	private String checkMarks(QuestState st)
	{
		if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE1) < 0 && st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2) < 0 && st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) < 0 && st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) < 0 && st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) < 0)
			return null;
		else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) > 0)
			st.set("cond", "6");
		else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) > 0)
			st.set("cond", "5");
		else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) > 0)
			st.set("cond", "4");
		else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2) > 0)
			st.set("cond", "3");
		else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE1) > 0)
			st.set("cond", "2");
		return null;
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		if(event.equalsIgnoreCase("first-2.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("first-have-2.htm"))
		{
			st.takeItems(VB_SOLDIER, 100);
			st.giveItems(MARK_OF_KETRA_ALLIANCE1, 1);
			st.set("cond", "2");
			st.getPlayer().setKetra(1);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("second-have-2.htm"))
		{
			st.takeItems(VB_SOLDIER, 200);
			st.takeItems(VB_CAPTAIN, 100);
			st.takeItems(MARK_OF_KETRA_ALLIANCE1, 1);
			st.giveItems(MARK_OF_KETRA_ALLIANCE2, 1);
			st.set("cond", "3");
			st.getPlayer().setKetra(2);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("third-have-2.htm"))
		{
			st.takeItems(VB_SOLDIER, 300);
			st.takeItems(VB_CAPTAIN, 200);
			st.takeItems(VB_GENERAL, 100);
			st.takeItems(MARK_OF_KETRA_ALLIANCE2, 1);
			st.giveItems(MARK_OF_KETRA_ALLIANCE3, 1);
			st.set("cond", "4");
			st.getPlayer().setKetra(3);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("fourth-have-2.htm"))
		{
			st.takeItems(VB_SOLDIER, 300);
			st.takeItems(VB_CAPTAIN, 300);
			st.takeItems(VB_GENERAL, 200);
			st.takeItems(TOTEM_OF_VALOR, 1);
			st.takeItems(MARK_OF_KETRA_ALLIANCE3, 1);
			st.giveItems(MARK_OF_KETRA_ALLIANCE4, 1);
			st.set("cond", "5");
			st.getPlayer().setKetra(4);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("fifth-have-2.htm"))
		{
			st.takeItems(VB_SOLDIER, 400);
			st.takeItems(VB_CAPTAIN, 400);
			st.takeItems(VB_GENERAL, 200);
			st.takeItems(TOTEM_OF_WISDOM, 1);
			st.takeItems(MARK_OF_KETRA_ALLIANCE4, 1);
			st.giveItems(MARK_OF_KETRA_ALLIANCE5, 1);
			st.set("cond", "6");
			st.getPlayer().setKetra(5);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("quit-2.htm"))
		{
			st.takeItems(MARK_OF_KETRA_ALLIANCE1, -1);
			st.takeItems(MARK_OF_KETRA_ALLIANCE2, -1);
			st.takeItems(MARK_OF_KETRA_ALLIANCE3, -1);
			st.takeItems(MARK_OF_KETRA_ALLIANCE4, -1);
			st.takeItems(MARK_OF_KETRA_ALLIANCE5, -1);
			st.set("cond", "0");
			st.getPlayer().setKetra(0);
			st.playSound(SOUND_MIDDLE);
			st.exitCurrentQuest(false);
		}
		return event;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		if(st.getPlayer().getVarka() > 0)
		{
			htmltext = "isvarka.htm";
			st.exitCurrentQuest(true);
			return htmltext;
		}
		String id = String.valueOf(st.getState());
		if(id.equals("CREATED"))
			st.set("cond", "0");
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		checkMarks(st);
		if(npcId == 31371)
		{
			if(cond == 0)
			{
				if(st.getPlayer().getLevel() >= 74)
					htmltext = "first.htm";
				else
				{
					htmltext = "no-level.htm";
					st.exitCurrentQuest(true);
				}
			}
			else
			{
				if(cond == 1)
				{
					if(st.getQuestItemsCount(VB_SOLDIER) >= 100)
						htmltext = "first-have.htm";
					else
						htmltext = "first-havenot.htm";
				}
				else if(cond == 2)
				{
					if(st.getQuestItemsCount(VB_SOLDIER) >= 200 && st.getQuestItemsCount(VB_CAPTAIN) >= 100)
						htmltext = "second-have.htm";
					else
						htmltext = "second.htm";
				}
				else if(cond == 3)
				{
					if(st.getQuestItemsCount(VB_SOLDIER) >= 300 && st.getQuestItemsCount(VB_CAPTAIN) >= 200 && st.getQuestItemsCount(VB_GENERAL) >= 100)
						htmltext = "third-have.htm";
					else
						htmltext = "third.htm";
				}
				else if(cond == 4)
				{
					if(st.getQuestItemsCount(VB_SOLDIER) >= 300 && st.getQuestItemsCount(VB_CAPTAIN) >= 200 && st.getQuestItemsCount(VB_GENERAL) >= 200 && st.getQuestItemsCount(TOTEM_OF_VALOR) == 1)
						htmltext = "fourth-have.htm";
					else
						htmltext = "fourth.htm";
				}
				else if(cond == 5)
				{
					if(st.getQuestItemsCount(VB_SOLDIER) >= 300 && st.getQuestItemsCount(VB_CAPTAIN) >= 200 && st.getQuestItemsCount(VB_GENERAL) >= 200 && st.getQuestItemsCount(TOTEM_OF_WISDOM) == 1)
						htmltext = "fifth-have.htm";
					else
						htmltext = "fifth.htm";
				}
				else if(cond == 6)
					htmltext = "high.htm";
				return htmltext;
			}
		}
		else
		{
			st.exitCurrentQuest(true);
			return htmltext;
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		if(isKetraNpc(npcId))
			if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) > 0)
			{
				st.takeItems(MARK_OF_KETRA_ALLIANCE5, -1);
				st.giveItems(MARK_OF_KETRA_ALLIANCE4, 1);
				st.getPlayer().setKetra(st.getPlayer().getKetra() - 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) > 0)
			{
				st.takeItems(MARK_OF_KETRA_ALLIANCE4, -1);
				st.giveItems(MARK_OF_KETRA_ALLIANCE3, 1);
				st.getPlayer().setKetra(st.getPlayer().getKetra() - 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) > 0)
			{
				st.takeItems(MARK_OF_KETRA_ALLIANCE3, -1);
				st.giveItems(MARK_OF_KETRA_ALLIANCE2, 1);
				st.getPlayer().setKetra(st.getPlayer().getKetra() - 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2) > 0)
			{
				st.takeItems(MARK_OF_KETRA_ALLIANCE2, -1);
				st.giveItems(MARK_OF_KETRA_ALLIANCE1, 1);
				st.getPlayer().setKetra(st.getPlayer().getKetra() - 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE1) > 0)
			{
				st.takeItems(MARK_OF_KETRA_ALLIANCE1, -1);
				st.getPlayer().setKetra(st.getPlayer().getKetra() - 1);
				st.exitCurrentQuest(true);
			}
		if(npcId == PRIEST || npcId == WARRIOR || npcId == MEDIUM || npcId == MAGUS || npcId == OFFICIER || npcId == COMMANDER || npcId == ELITE_GUARD)
		{
			if(st.getInt("cond") > 1)
			{
				st.giveItems(VB_CAPTAIN, 1);
				st.playSound(SOUND_MIDDLE);
			}
		}
		else if(npcId == RECRUIT || npcId == FOOTMAN || npcId == SCOUT || npcId == HUNTER || npcId == SHAMAN)
		{
			if(st.getInt("cond") > 0)
			{
				st.giveItems(VB_SOLDIER, 1);
				st.playSound(SOUND_MIDDLE);
			}
		}
		else if(npcId == GREAT_MAGUS || npcId == GENERAL || npcId == GREAT_SEER || npcId == VARKA_PROPHET || npcId == DISCIPLE_OF_PROPHET || npcId == PROPHET_GUARDS || npcId == HEAD_MAGUS || npcId == HEAD_GUARDS)
			if(st.getInt("cond") > 2)
			{
				st.giveItems(VB_GENERAL, 1);
				st.playSound(SOUND_MIDDLE);
			}
		return null;
	}
}