package quests._610_MagicalPowerofWater2;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

public class _610_MagicalPowerofWater2 extends Quest implements ScriptFile
{
	// NPC
	int ASEFA = 31372;
	int VARKAS_HOLY_ALTAR = 31560;
	int SOUL_OF_WATER_ASHUTAR = 25316;

	// Quest items
	int GREEN_TOTEM = 7238;
	int ICE_HEART_OF_ASHUTAR = 7239;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 610: Magical Power of Water (part 2)");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _610_MagicalPowerofWater2()
	{
		super(610, "_610_MagicalPowerofWater2", "Magical Power of Water (part 2)", false);

		addStartNpc(ASEFA);

		addTalkId(ASEFA);
		addTalkId(VARKAS_HOLY_ALTAR);

		addKillId(SOUL_OF_WATER_ASHUTAR);

		addQuestItem(ICE_HEART_OF_ASHUTAR);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31372-2.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("use_totem"))
		{
			if(st.getQuestItemsCount(GREEN_TOTEM) >= 1 && !st.getPcSpawn().isSpawnExists(25316))
			{
				st.takeItems(GREEN_TOTEM, -1);
				st.getPcSpawn().addSpawn(25316, 104825, -36926, -1136);
				st.getPcSpawn().addSpawn(25317, 104925, -36926, -1120);
				st.getPcSpawn().addSpawn(25318, 104725, -36926, -1120);
				st.playSound(SOUND_MIDDLE);
			}
			else
				htmltext = "31560-havenot.htm";
		}
		else if(event.equalsIgnoreCase("31372-4.htm"))
			if(st.getQuestItemsCount(ICE_HEART_OF_ASHUTAR) >= 1)
			{
				st.takeItems(ICE_HEART_OF_ASHUTAR, -1);
				st.set("cond", "0");
				st.playSound(SOUND_FINISH);
				htmltext = "31561-2.htm";
				st.exitCurrentQuest(false);
			}
			else
				htmltext = "31372-havenot.htm";
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == ASEFA)
		{
			if(cond == 0)
			{
				if(st.getPlayer().getLevel() >= 75)
				{
					if(st.getQuestItemsCount(GREEN_TOTEM) >= 1)
						htmltext = "31372-1.htm";
					else
					{
						htmltext = "31372-00.htm";
						st.exitCurrentQuest(true);
					}
				}
				else
				{
					htmltext = "31372-0.htm";
					st.exitCurrentQuest(true);
				}
			}
			else if(cond == 1)
				htmltext = "31372-2r.htm";
			else if(cond == 2)
				htmltext = "31372-2rr.htm";
			else if(cond == 3 && st.getQuestItemsCount(ICE_HEART_OF_ASHUTAR) == 1)
				htmltext = "31372-3.htm";
		}
		else if(npcId == VARKAS_HOLY_ALTAR)
			if(!npc.isBusy())
			{
				if(cond == 1)
					htmltext = "31560-1.htm";
				else if(cond == 2 && !st.getPcSpawn().isSpawnExists(25316))
				{
					st.getPcSpawn().addSpawn(25316, 104825, -36926, -1136);
					st.getPcSpawn().addSpawn(25317, 104925, -36926, -1120);
					st.getPcSpawn().addSpawn(25318, 104725, -36926, -1120);
					htmltext = "31560-3.htm";
				}
			}
			else
				htmltext = "31560-busy.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getQuestItemsCount(ICE_HEART_OF_ASHUTAR) == 0 && npc.getNpcId() == SOUL_OF_WATER_ASHUTAR)
		{
			st.giveItems(ICE_HEART_OF_ASHUTAR, 1);
			st.set("cond", "3");
			st.getPcSpawn().removeAllSpawn();
		}
		return null;
	}
}
