package quests._611_AllianceWithVarkaSilenos;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

public class _611_AllianceWithVarkaSilenos extends Quest implements ScriptFile
{
	public void onLoad()
	{
		System.out.println("Loaded Quest: 611: Alliance With Varka Silenos");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	//Varka mobs
	private final int[] VARKA_NPC_LIST = new int[20];

	// Items
	private final int MARK_OF_VARKA_ALLIANCE1 = 7221;
	private final int MARK_OF_VARKA_ALLIANCE2 = 7222;
	private final int MARK_OF_VARKA_ALLIANCE3 = 7223;
	private final int MARK_OF_VARKA_ALLIANCE4 = 7224;
	private final int MARK_OF_VARKA_ALLIANCE5 = 7225;
	private final int KB_SOLDIER = 7226;
	private final int KB_CAPTAIN = 7227;
	private final int KB_GENERAL = 7228;
	private final int TOTEM_OF_VALOR = 7229;
	private final int TOTEM_OF_WISDOM = 7230;

	//hunt for soldier
	private final int RAIDER = 21327;
	private final int FOOTMAN = 21324;
	private final int SCOUT = 21328;
	private final int WAR_HOUND = 21325;
	private final int SHAMAN = 2132;

	//hunt for captain
	private final int SEER = 21338;
	private final int WARRIOR = 21331;
	private final int LIEUTENANT = 21332;
	private final int ELITE_SOLDIER = 21335;
	private final int MEDIUM = 21334;
	private final int COMMAND = 21343;
	private final int ELITE_GUARD = 21344;
	private final int WHITE_CAPTAIN = 21336;

	//hunt for general
	private final int BATTALION_COMMANDER_SOLDIER = 21340;
	private final int GENERAL = 21339;
	private final int GREAT_SEER = 21342;
	private final int KETRA_PROPHET = 21347;
	private final int DISCIPLE_OF_PROPHET = 21375;
	private final int PROPHET_GUARDS = 21348;
	private final int PROPHET_AIDE = 21349;
	private final int HEAD_SHAMAN = 21345;
	private final int HEAD_GUARDS = 21346;

	public _611_AllianceWithVarkaSilenos()
	{
		super(611, "_611_AllianceWithVarkaSilenos", "Alliace With Varka Silenos", true);

		addStartNpc(31378);
		addTalkId(31378);

		VARKA_NPC_LIST[0] = 21350;
		VARKA_NPC_LIST[1] = 21351;
		VARKA_NPC_LIST[2] = 21353;
		VARKA_NPC_LIST[3] = 21354;
		VARKA_NPC_LIST[4] = 21355;
		VARKA_NPC_LIST[5] = 21357;
		VARKA_NPC_LIST[6] = 21358;
		VARKA_NPC_LIST[7] = 21360;
		VARKA_NPC_LIST[8] = 21361;
		VARKA_NPC_LIST[9] = 21362;
		VARKA_NPC_LIST[10] = 21364;
		VARKA_NPC_LIST[11] = 21365;
		VARKA_NPC_LIST[12] = 21366;
		VARKA_NPC_LIST[13] = 21368;
		VARKA_NPC_LIST[14] = 21369;
		VARKA_NPC_LIST[15] = 21370;
		VARKA_NPC_LIST[16] = 21371;
		VARKA_NPC_LIST[17] = 21372;
		VARKA_NPC_LIST[18] = 21373;
		VARKA_NPC_LIST[19] = 21374;

		for(int npcId : VARKA_NPC_LIST)
			addKillId(npcId);

		//hunt for soldier
		addKillId(RAIDER);
		addKillId(FOOTMAN);
		addKillId(SCOUT);
		addKillId(WAR_HOUND);
		addKillId(SHAMAN);

		//hunt for captain
		addKillId(SEER);
		addKillId(WARRIOR);
		addKillId(LIEUTENANT);
		addKillId(ELITE_SOLDIER);
		addKillId(MEDIUM);
		addKillId(COMMAND);
		addKillId(ELITE_GUARD);
		addKillId(WHITE_CAPTAIN);

		//hunt for general
		addKillId(BATTALION_COMMANDER_SOLDIER);
		addKillId(GENERAL);
		addKillId(GREAT_SEER);
		addKillId(KETRA_PROPHET);
		addKillId(PROPHET_AIDE);
		addKillId(PROPHET_GUARDS);
		addKillId(HEAD_SHAMAN);
		addKillId(HEAD_GUARDS);

		addQuestItem(KB_SOLDIER);
		addQuestItem(KB_CAPTAIN);
		addQuestItem(KB_GENERAL);
	}

	public boolean isVarkaNpc(int npc)
	{
		for(int i : VARKA_NPC_LIST)
			if(npc == i)
				return true;
		return false;
	}

	private String checkMarks(QuestState st)
	{
		if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE1) < 0 && st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) < 0 && st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) < 0 && st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) < 0 && st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) < 0)
			return null;
		else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE1) > 0)
			st.set("cond", "2");
		else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) > 0)
			st.set("cond", "3");
		else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) > 0)
			st.set("cond", "4");
		else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) > 0)
			st.set("cond", "5");
		else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) > 0)
			st.set("cond", "6");
		return null;
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		if(event.equalsIgnoreCase("first-2.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("first-have-2.htm"))
		{
			st.takeItems(KB_SOLDIER, 100);
			st.giveItems(MARK_OF_VARKA_ALLIANCE1, 1);
			st.set("cond", "2");
			st.getPlayer().setVarka(1);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("second-have-2.htm"))
		{
			st.takeItems(KB_SOLDIER, 200);
			st.takeItems(KB_CAPTAIN, 100);
			st.takeItems(MARK_OF_VARKA_ALLIANCE1, 1);
			st.giveItems(MARK_OF_VARKA_ALLIANCE2, 1);
			st.set("cond", "3");
			st.getPlayer().setVarka(2);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("third-have-2.htm"))
		{
			st.takeItems(KB_SOLDIER, 300);
			st.takeItems(KB_CAPTAIN, 200);
			st.takeItems(KB_GENERAL, 100);
			st.takeItems(MARK_OF_VARKA_ALLIANCE2, 1);
			st.giveItems(MARK_OF_VARKA_ALLIANCE3, 1);
			st.set("cond", "4");
			st.getPlayer().setVarka(3);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("fourth-have-2.htm"))
		{
			st.takeItems(KB_SOLDIER, 300);
			st.takeItems(KB_CAPTAIN, 300);
			st.takeItems(KB_GENERAL, 200);
			st.takeItems(TOTEM_OF_VALOR, 1);
			st.takeItems(MARK_OF_VARKA_ALLIANCE3, 1);
			st.giveItems(MARK_OF_VARKA_ALLIANCE4, 1);
			st.set("cond", "5");
			st.getPlayer().setVarka(4);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("fifth-have-2.htm"))
		{
			st.takeItems(KB_SOLDIER, 400);
			st.takeItems(KB_CAPTAIN, 400);
			st.takeItems(KB_GENERAL, 200);
			st.takeItems(TOTEM_OF_WISDOM, 1);
			st.takeItems(MARK_OF_VARKA_ALLIANCE4, 1);
			st.giveItems(MARK_OF_VARKA_ALLIANCE5, 1);
			st.set("cond", "6");
			st.getPlayer().setVarka(5);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("quit-2.htm"))
		{
			st.takeItems(MARK_OF_VARKA_ALLIANCE1, -1);
			st.takeItems(MARK_OF_VARKA_ALLIANCE2, -1);
			st.takeItems(MARK_OF_VARKA_ALLIANCE3, -1);
			st.takeItems(MARK_OF_VARKA_ALLIANCE4, -1);
			st.takeItems(MARK_OF_VARKA_ALLIANCE5, -1);
			st.set("cond", "0");
			st.getPlayer().setVarka(0);
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(false);
		}
		return event;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		if(st.getPlayer().getKetra() > 0)
		{
			htmltext = "ketra.htm";
			st.exitCurrentQuest(true);
			return htmltext;
		}
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		checkMarks(st);
		if(npcId == 31378)
		{
			if(cond == 0)
			{
				if(st.getPlayer().getLevel() >= 74)
					htmltext = "first.htm";
				else
				{
					htmltext = "no-level.htm";
					st.exitCurrentQuest(true);
				}
			}
			else if(cond == 1)
			{
				if(st.getQuestItemsCount(KB_SOLDIER) >= 100)
					htmltext = "first-have.htm";
				else
					htmltext = "first-havenot.htm";
			}
			else if(cond == 2)
			{
				if(st.getQuestItemsCount(KB_SOLDIER) >= 200 && st.getQuestItemsCount(KB_CAPTAIN) >= 100)
					htmltext = "second-have.htm";
				else
					htmltext = "second.htm";
			}
			else if(cond == 3)
			{
				if(st.getQuestItemsCount(KB_SOLDIER) >= 300 && st.getQuestItemsCount(KB_CAPTAIN) >= 200 && st.getQuestItemsCount(KB_GENERAL) >= 100)
					htmltext = "third-have.htm";
				else
					htmltext = "third.htm";
			}
			else if(cond == 4)
			{
				if(st.getQuestItemsCount(KB_SOLDIER) >= 300 && st.getQuestItemsCount(KB_CAPTAIN) >= 200 && st.getQuestItemsCount(KB_GENERAL) >= 200 && st.getQuestItemsCount(TOTEM_OF_VALOR) == 1)
					htmltext = "fourth-have.htm";
				else
					htmltext = "fourth.htm";
			}
			else if(cond == 5)
			{
				if(st.getQuestItemsCount(KB_SOLDIER) >= 400 && st.getQuestItemsCount(KB_CAPTAIN) >= 400 && st.getQuestItemsCount(KB_GENERAL) >= 200 && st.getQuestItemsCount(TOTEM_OF_WISDOM) == 1)
					htmltext = "fifth-have.htm";
				else
					htmltext = "fifth.htm";
			}
			else if(cond == 6)
				htmltext = "high.htm";
			return htmltext;
		}
		st.exitCurrentQuest(true);
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		if(isVarkaNpc(npcId))
			if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) > 0)
			{
				st.takeItems(MARK_OF_VARKA_ALLIANCE5, -1);
				st.giveItems(MARK_OF_VARKA_ALLIANCE4, 1);
				st.getPlayer().setVarka(st.getPlayer().getVarka() - 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) > 0)
			{
				st.takeItems(MARK_OF_VARKA_ALLIANCE4, -1);
				st.giveItems(MARK_OF_VARKA_ALLIANCE3, 1);
				st.getPlayer().setVarka(st.getPlayer().getVarka() - 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) > 0)
			{
				st.takeItems(MARK_OF_VARKA_ALLIANCE3, -1);
				st.giveItems(MARK_OF_VARKA_ALLIANCE2, 1);
				st.getPlayer().setVarka(st.getPlayer().getVarka() - 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) > 0)
			{
				st.takeItems(MARK_OF_VARKA_ALLIANCE2, -1);
				st.giveItems(MARK_OF_VARKA_ALLIANCE1, 1);
				st.getPlayer().setVarka(st.getPlayer().getVarka() - 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE1) > 0)
			{
				st.takeItems(MARK_OF_VARKA_ALLIANCE1, -1);
				st.getPlayer().setVarka(st.getPlayer().getVarka() - 1);
				st.exitCurrentQuest(true);
			}
		if(npcId == SEER || npcId == WARRIOR || npcId == LIEUTENANT || npcId == ELITE_SOLDIER || npcId == MEDIUM || npcId == COMMAND || npcId == ELITE_GUARD || npcId == WHITE_CAPTAIN)
		{
			if(st.getInt("cond") > 1)
			{
				st.giveItems(KB_CAPTAIN, 1);
				st.playSound(SOUND_MIDDLE);
			}
		}
		else if(npcId == RAIDER || npcId == FOOTMAN || npcId == SCOUT || npcId == WAR_HOUND || npcId == SHAMAN)
		{
			if(st.getInt("cond") > 0)
			{
				st.giveItems(KB_SOLDIER, 1);
				st.playSound(SOUND_MIDDLE);
			}

		}
		else if(npcId == BATTALION_COMMANDER_SOLDIER || npcId == GENERAL || npcId == GREAT_SEER || npcId == KETRA_PROPHET || npcId == DISCIPLE_OF_PROPHET || npcId == PROPHET_GUARDS || npcId == HEAD_SHAMAN || npcId == HEAD_GUARDS)
			if(st.getInt("cond") > 2)
			{
				st.giveItems(KB_GENERAL, 1);
				st.playSound(SOUND_MIDDLE);
			}
		return null;

	}
}