package quests._616_MagicalPowerofFire2;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.L2World;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

public class _616_MagicalPowerofFire2 extends Quest implements ScriptFile
{
	// NPC
	private final int KETRAS_HOLY_ALTAR = 31558;
	private final int UDAN = 31379;
	private final int SOUL_OF_FIRE_NASTRON = 25306;

	// Quest items
	private final short FIRE_HEART_OF_NASTRON = 7244;
	private final short RED_TOTEM = 7243;

	private final int[] VARKA_NPC_LIST = new int[20];

	public void onLoad()
	{
		System.out.println("Loaded Quest: 616: Magical Power of Fire 2");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _616_MagicalPowerofFire2()
	{
		super(616, "_616_MagicalPowerofFire2", "Magical Power of Fire 2", false);

		addStartNpc(UDAN);

		addTalkId(UDAN);
		addTalkId(KETRAS_HOLY_ALTAR);

		VARKA_NPC_LIST[0] = 21350;
		VARKA_NPC_LIST[1] = 21351;
		VARKA_NPC_LIST[2] = 21353;
		VARKA_NPC_LIST[3] = 21354;
		VARKA_NPC_LIST[4] = 21355;
		VARKA_NPC_LIST[5] = 21357;
		VARKA_NPC_LIST[6] = 21358;
		VARKA_NPC_LIST[7] = 21360;
		VARKA_NPC_LIST[8] = 21361;
		VARKA_NPC_LIST[9] = 21362;
		VARKA_NPC_LIST[10] = 21364;
		VARKA_NPC_LIST[11] = 21365;
		VARKA_NPC_LIST[12] = 21366;
		VARKA_NPC_LIST[13] = 21368;
		VARKA_NPC_LIST[14] = 21369;
		VARKA_NPC_LIST[15] = 21370;
		VARKA_NPC_LIST[16] = 21371;
		VARKA_NPC_LIST[17] = 21372;
		VARKA_NPC_LIST[18] = 21373;
		VARKA_NPC_LIST[19] = 21374;

		for(int npcId : VARKA_NPC_LIST)
			addKillId(npcId);

		addKillId(SOUL_OF_FIRE_NASTRON);
		addQuestItem(FIRE_HEART_OF_NASTRON);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31379-2.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("use_totem"))
			if(st.getQuestItemsCount(FIRE_HEART_OF_NASTRON) >= 1 && !st.getPcSpawn().isSpawnExists(25306))
			{
				st.takeItems(RED_TOTEM, -1);
				st.getPcSpawn().addSpawn(25306, 142528, -82528, -6496);
				st.getPcSpawn().addSpawn(25307, 142628, -82528, -6490);
				st.getPcSpawn().addSpawn(25308, 142428, -82528, -6490);
				st.playSound(SOUND_MIDDLE);
			}
			else
				htmltext = "31558-havenot.htm";
		else if(event.equalsIgnoreCase("31379-4.htm"))
			if(st.getQuestItemsCount(FIRE_HEART_OF_NASTRON) >= 1)
			{
				st.takeItems(FIRE_HEART_OF_NASTRON, -1);
				st.set("cond", "0");
				st.playSound(SOUND_FINISH);
				htmltext = "31379-2.htm";
				st.exitCurrentQuest(false);
			}
			else
				htmltext = "31379-havenot.htm";
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		L2NpcInstance isQuest = L2World.findNpcByNpcId(25306);
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		switch(npcId)
		{
			case UDAN:
				if(cond == 0)
					if(st.getPlayer().getLevel() >= 75)
						if(st.getQuestItemsCount(RED_TOTEM) == 1)
							htmltext = "31379-1.htm";
						else
						{
							htmltext = "31379-00.htm";
							st.exitCurrentQuest(true);
						}
					else
					{
						htmltext = "31379-0.htm";
						st.exitCurrentQuest(true);
					}
				else if(cond == 1)
					htmltext = "31379-2r.htm";
				else if(cond == 2)
					htmltext = "31379-2rr.htm";
				else if(cond == 3 && st.getQuestItemsCount(FIRE_HEART_OF_NASTRON) == 1)
					htmltext = "31379-3.htm";
				break;
			case KETRAS_HOLY_ALTAR:
				if(npc.isBusy())
					htmltext = "31558-busy.htm";
				else if(cond == 1)
					htmltext = "31558-1.htm";
				else if(cond == 2)
				{
					if (isQuest == null)
					{
						st.getPcSpawn().addSpawn(25306, 142528, -82528, -6496);
						st.getPcSpawn().addSpawn(25307, 142628, -82528, -6490);
						st.getPcSpawn().addSpawn(25308, 142428, -82528, -6490);
						htmltext = "31558-3.htm";
					}
					else 
						htmltext = "<html><body>Already in spawn.</body></html>";
				}
				break;
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getQuestItemsCount(FIRE_HEART_OF_NASTRON) == 0)
		{
			st.giveItems(FIRE_HEART_OF_NASTRON, 1);
			st.set("cond", "3");
			st.getPcSpawn().removeAllSpawn();
		}
		return null;
	}
}