package quests._617_GatherTheFlames;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;
import l2r.util.Rnd;

public class _617_GatherTheFlames extends Quest implements ScriptFile
{
	//npc
	private final static int VULCAN = 31539;
	private final static int HILDA = 31271;
	//items
	private final static int TORCH = 7264;
	//DROPLIST (MOB_ID, CHANCE)
	private final static int[][] DROPLIST = {
			{ 21376, 48 },
			{ 21377, 48 },
			{ 21378, 48 },
			{ 21652, 48 },
			{ 21380, 48 },
			{ 21381, 51 },
			{ 21653, 51 },
			{ 21383, 51 },
			{ 21394, 51 },
			{ 21385, 51 },
			{ 21386, 51 },
			{ 21388, 53 },
			{ 21655, 53 },
			{ 21387, 53 },
			{ 21390, 56 },
			{ 21656, 56 },
			{ 21395, 56 },
			{ 21389, 56 },
			{ 21391, 56 },
			{ 21392, 56 },
			{ 21393, 58 },
			{ 21657, 58 },
			{ 21382, 60 },
			{ 21379, 60 },
			{ 21654, 64 },
			{ 21384, 64 } };

	public void onLoad()
	{
		System.out.println("Loaded Quest: 617: Gather the Flames");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _617_GatherTheFlames()
	{
		super(617, "_617_GatherTheFlames", "Gather the Flames", true);

		addStartNpc(VULCAN);
		addStartNpc(HILDA);

		for(int[] element : DROPLIST)
			addKillId(element[0]);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31539-03.htm")) //VULCAN
		{
			if(st.getPlayer().getLevel() < 74)
				return "31539-02.htm";
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
			st.set("cond", "1");
		}
		else if(event.equalsIgnoreCase("31271-03.htm")) //HILDA
		{
			if(st.getPlayer().getLevel() < 74)
				return "31271-01.htm";
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
			st.set("cond", "1");
		}
		else if(event.equalsIgnoreCase("31539-08.htm"))
		{
			st.playSound(SOUND_FINISH);
			st.takeItems(TORCH, -1);
			st.exitCurrentQuest(true);
		}
		else if(event.equalsIgnoreCase("31539-07.htm"))
		{
			if(st.getQuestItemsCount(TORCH) < 1000)
				return "31539-05.htm";
			st.takeItems(TORCH, 1000);
			int item = Rnd.get(10);
			if(item == 0)
				st.giveItems(6881, 1);
			else if(item == 1)
				st.giveItems(6883, 1);
			else if(item == 2)
				st.giveItems(6885, 1);
			else if(item == 3)
				st.giveItems(6887, 1);
			else if(item == 4)
				st.giveItems(7580, 1);
			else if(item == 5)
				st.giveItems(6891, 1);
			else if(item == 6)
				st.giveItems(6893, 1);
			else if(item == 7)
				st.giveItems(6895, 1);
			else if(item == 8)
				st.giveItems(6897, 1);
			else if(item == 9)
				st.giveItems(6899, 1);
			st.playSound(SOUND_MIDDLE);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == VULCAN)
		{
			if(cond == 0)
			{
				if(st.getPlayer().getLevel() < 74)
				{
					htmltext = "31539-02.htm";
					st.exitCurrentQuest(true);
				}
				else
					htmltext = "31539-01.htm";
			}
			else
				htmltext = st.getQuestItemsCount(TORCH) < 1000 ? "31539-05.htm" : "31539-04.htm";
		}
		else if(npcId == HILDA)
			if(cond < 1)
				htmltext = st.getPlayer().getLevel() < 74 ? "31271-01.htm" : "31271-02.htm";
			else
				htmltext = "31271-04.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		for(int[] element : DROPLIST)
			if(npc.getNpcId() == element[0])
			{
				st.rollAndGive(TORCH, 1, element[1]);
				return null;
			}
		return null;
	}
}