package quests._629_CleanUpTheSwampOfScreams;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;
import l2r.util.Rnd;

public class _629_CleanUpTheSwampOfScreams extends Quest implements ScriptFile
{
	//NPC
	private static int CAPTAIN = 31553;
	private static int CLAWS = 7250;
	private static int COIN = 7251;

	//CHANCES
	private static int[][] CHANCE = {
			{ 21508, 50 },
			{ 21509, 43 },
			{ 21510, 52 },
			{ 21511, 57 },
			{ 21512, 74 },
			{ 21513, 53 },
			{ 21514, 53 },
			{ 21515, 54 },
			{ 21516, 55 },
			{ 21517, 56 } };

	public void onLoad()
	{
		System.out.println("Loaded Quest: 629: Clean up the Swamp of Screams");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _629_CleanUpTheSwampOfScreams()
	{
		super(629, "_629_CleanUpTheSwampOfScreams", "Clean up the Swamp of Screams", false);

		addStartNpc(CAPTAIN);

		for(int npcId = 21508; npcId < 21518; npcId++)
			addKillId(npcId);

		addQuestItem(CLAWS);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(st.getState() == null)
			return null;

		if(event.equalsIgnoreCase("31553-1.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("31553-3.htm"))
		{
			if(st.getQuestItemsCount(CLAWS) >= 100)
			{
				st.takeItems(CLAWS, -1);
				st.giveItems(COIN, 20);
				st.playSound(SOUND_FINISH);
				st.exitCurrentQuest(false);
			}
			else
				htmltext = "31553-3a.htm";
		}
		else if(event.equalsIgnoreCase("31553-5.htm"))
		{
			st.takeItems(CLAWS, -1);
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(true);
		}

		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		if(st.getState() == null)
			return htmltext;
		int cond = st.getInt("cond");

		if(st.getQuestItemsCount(7246) > 0 || st.getQuestItemsCount(7247) > 0)
		{
			if(cond == 0)
			{
				if(st.getPlayer().getLevel() >= 66)
					htmltext = "31553-0.htm";
				else
				{
					htmltext = "31553-0a.htm";
					st.exitCurrentQuest(true);
				}
			}
			else if(st.getState().equals(STARTED))
				if(st.getQuestItemsCount(CLAWS) >= 100)
					htmltext = "31553-2.htm";
				else
					htmltext = "31553-1a.htm";
		}
		else
		{
			htmltext = "31553-6.htm";
			st.exitCurrentQuest(true);
		}

		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getState() == null || st.getState() != STARTED)
			return null;
		int chance = CHANCE[npc.getNpcId() - 21508][1];

		if(Rnd.chance(chance))
		{
			st.giveItems(CLAWS, 1);

			if(st.getQuestItemsCount(CLAWS) < 100)
				st.playSound(SOUND_ITEMGET);
			else
				st.playSound(SOUND_MIDDLE);
		}

		return null;
	}
}