package quests._634_InSearchofDimensionalFragments;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;
import l2r.gameserver.model.quest.State;

public class _634_InSearchofDimensionalFragments extends Quest implements ScriptFile
{
	int DIMENSION_FRAGMENT_ID = 7079;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 634: In Search of Dimensional Fragments");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _634_InSearchofDimensionalFragments()
	{
		super(634, "_634_InSearchofDimensionalFragments", "In Search of Dimensional Fragments", true);

		for(int npcId = 31494; npcId < 31508; npcId++)
		{
			addTalkId(npcId);
			addStartNpc(npcId);
		}

		for(int mobs = 21208; mobs < 21256; mobs++)
			addKillId(mobs);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equals("1"))
		{
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
			htmltext = "4.htm";
			st.set("cond", "1");
		}
		else if(event.equals("2"))
		{
			htmltext = "5.htm";
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(true);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		State id = st.getState();
		if(id.equals(CREATED))
		{
			st.set("cond", "0");
			htmltext = "4.htm";
		}
		else if(id.equals(STARTED))
		{
			st.set("cond", "1");
			htmltext = "4.htm";
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		st.rollAndGive(DIMENSION_FRAGMENT_ID, 1, 60);
		return null;
	}
}