package quests._635_InTheDimensionalRift;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

public class _635_InTheDimensionalRift extends Quest implements ScriptFile
{
	private static final int DIMENSION_FRAGMENT = 7079;

	// Rift Posts should take you back to the place you came from
	private static final int[][] COORD = { {},// filler
			{ -41572, 209731, -5087 }, //Necropolis of Sacrifice
			{ 42950, 143934, -5381 }, //Catacomb of the Heretic
			{ 45256, 123906, -5411 }, //Pilgrim's Necropolis
			{ 46192, 170290, -4981 }, //Catacomb of the Branded
			{ 111273, 174015, -5437 }, //Necropolis of Worship
			{ 77637, 78399, -5125 }, //Catacomb of Apostate
			{ -21726, 77385, -5171 }, //Patriot's Necropolis
			{ 140405, 79679, -5427 }, //Catacomb of the Witch
			{ -52366, 79097, -4741 }, //Necropolis of Devotion (ex Ascetics)
			{ 118311, 132797, -4829 }, //Necropolis of Martyrdom
			{ 172185, -17602, -4901 }, //Disciple's Necropolis
			{ 83000, 209213, -5439 }, //Saint's Necropolis
			{ -19500, 13508, -4901 }, //Catacomb of Dark Omens
			{ 113865, 84543, -6541 } //Catacomb of the Forbidden Path
	};

	public void onLoad()
	{
		System.out.println("Loaded Quest: 635: In The Dimensional Rift");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _635_InTheDimensionalRift()
	{
		super(635, "_635_InTheDimensionalRift", "In The Dimensional Rift", false);

		for(int npcId = 31494; npcId < 31508; npcId++)
		{
			addTalkId(npcId);
			addStartNpc(npcId);
		}

		for(int npcId = 31488; npcId < 31494; npcId++)
			addTalkId(npcId);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		int id = st.getInt("id");
		int count = st.getInt("count");
		if(event.equals("5.htm"))
			if(id > 0)
			{
				if(count > 0)
					htmltext = "5a.htm";
				st.set("count", String.valueOf(count + 1));
				st.setState(STARTED);
				st.set("cond", "1");
				st.getPlayer().teleToLocation(-114790, -180576, -6781);
			}
			else
			{
				htmltext = "What are you trying to do?";
				st.exitCurrentQuest(true);
			}
		else if(event.equalsIgnoreCase("6.htm"))
			st.exitCurrentQuest(true);
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int loc = st.getInt("id");
		if(npcId >= 31494 && npcId <= 31508)
		{
			if(st.getPlayer().getLevel() < 20)
			{
				st.exitCurrentQuest(true);
				htmltext = "1.htm";
			}
			else if(st.getQuestItemsCount(DIMENSION_FRAGMENT) == 0)
				htmltext = "3.htm";
			else
			{
				String s = String.valueOf(npcId - 31493);
				st.set("id", s);
				htmltext = "4.htm";
			}
		}
		else if(loc > 0)
		{
			int[] coord = COORD[loc];
			st.getPlayer().teleToLocation(coord[0], coord[1], coord[2]);
			st.unset("cond");
			htmltext = "7.htm";
			st.exitCurrentQuest(true);
		}
		else
		{
			htmltext = "Where?";
			st.exitCurrentQuest(true);
		}
		return htmltext;
	}
}