package quests._637_ThroughOnceMore;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

public class _637_ThroughOnceMore extends Quest implements ScriptFile
{
	public void onLoad()
	{
		System.out.println("Loaded Quest: 637: Through Once More");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	//Drop rate
	private static final int Chance = 15;

	//Npc
	private static final int Flauron = 32010;

	//Items
	private static final int VisitorsMark = 8064;
	private static final int NecromancersHeart = 8066;
	private static final int PagansMark = 8067;
	//Mobs
	private static final int BoneAnimator = 21565;
	private static final int DevilBat = 21568;

	public _637_ThroughOnceMore()
	{
		super(637, "_637_ThroughOnceMore", "Through Once More", false);

		addStartNpc(Flauron);

		addKillId(BoneAnimator);
		addKillId(DevilBat);

		addQuestItem(NecromancersHeart);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		if(event.equals("32010-04.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.takeItems(VisitorsMark, 1);
			st.getPlayer().setVar("q637", "1");
			st.playSound(SOUND_ACCEPT);
		}
		return event;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int cond = st.getInt("cond");
		if(cond == 0)
		{
			if(st.getPlayer().getLevel() > 72 && (st.getQuestItemsCount(VisitorsMark) > 0) || st.getPlayer().getVarB("q637"))
				htmltext = "32010-02.htm";
			else
			{
				htmltext = "32010-01.htm";
				st.exitCurrentQuest(true);
			}
		}
		else if(cond == 1)
			htmltext = "32010-04.htm";
		else if(cond == 2)
		{
			st.getPlayer().unsetVar("q637");
			htmltext = "32010-05.htm";
			st.takeItems(NecromancersHeart, -1);
			st.giveItems(PagansMark, 1);
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(false);
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getInt("cond") == 1 && st.rollAndGive(NecromancersHeart, 1, 1, 10, Chance))
		{
			st.set("cond", "2");
			st.setState(STARTED);
		}
		return null;
	}
}