package quests._645_GhostsOfBatur;

import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

public class _645_GhostsOfBatur extends Quest implements ScriptFile
{
	//Npc
	private static final int Karuda = 32017;
	//Items
	private static final int CursedGraveGoods = 8089;
	//Rewards
	private static final int[][] REWARDS = { { 1878, 18 }, { 1879, 7 }, { 1880, 4 }, { 1881, 6 }, { 1882, 10 }, { 1883, 2 } };
	//Mobs
	private static final int[] MOBS = { 22007, 22009, 22010, 22011, 22012, 22013, 22014, 22015, 22016 };

	public void onLoad()
	{
		System.out.println("Loaded Quest:_645_GhostsOfBatur");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _645_GhostsOfBatur()
	{
		super(645, "_645_GhostsOfBatur", "Ghosts Of Batur", false);

		addStartNpc(Karuda);
		addTalkId(Karuda);
		for(int i : MOBS)
			addKillId(i);
		addQuestItem(CursedGraveGoods);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("32017-03.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(st.getInt("cond") == 2)
		{
			if(st.getQuestItemsCount(CursedGraveGoods) >= 180)
			{
				for(int i = 0; i < REWARDS.length; i++)
				{
					if(event.equalsIgnoreCase(String.valueOf(REWARDS[i][0])))
					{
						st.takeItems(CursedGraveGoods, -1);
						st.giveItems(REWARDS[i][0], REWARDS[i][1], true);
						htmltext = "32017-07.htm";
						st.playSound(SOUND_FINISH);
						st.exitCurrentQuest(true);
					}
				}
			}
			else
			{
				htmltext = "32017-04.htm";
				st.set("cond", "1");
			}
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int cond = st.getInt("cond");
		if(cond == 0)
		{
			if(st.getPlayer().getLevel() < 21 || st.getPlayer().getLevel() >= 31)
			{
				htmltext = "32017-02.htm";
				st.exitCurrentQuest(true);
			}
			else
				htmltext = "32017-01.htm";
		}
		else if(cond == 1)
			htmltext = "32017-04.htm";
		else if(cond == 2)
			if(st.getQuestItemsCount(CursedGraveGoods) >= 180)
				htmltext = "32017-05.htm";
			else
				htmltext = "32017-01.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getInt("cond") == 1 && st.getQuestItemsCount(CursedGraveGoods) < 180)
			if(st.rollAndGive(CursedGraveGoods, 1, 2, 180, 70))
			{
				st.set("cond", "2");
				st.setState(STARTED);
			}
		return null;
	}
}