package quests._654_JourneytoaSettlement;

import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.extensions.scripts.ScriptFile;
import l2r.util.Rnd;

public class _654_JourneytoaSettlement extends Quest implements ScriptFile
{
	//NPC
	private static int SPIRIT = 31453; //Nameless Spirit

	//TARGET
	private static int TARGET_1 = 21294; //Canyon Antelope
	private static int TARGET_2 = 21295; //Canyon Antelope Slave

	//ITEM
	private static int ITEM = 8072; //Antelope Skin

	//REWARD
	private static int SCROLL = 8073; //Frintezza's Magic Force Field Removal Scroll

	public void onLoad()
	{
		System.out.println("Loaded Quest: 654: Journey to a Settlement");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _654_JourneytoaSettlement()
	{
		super(654, "_654_JourneytoaSettlement", "Journey to a Settlement", false);

		addStartNpc(SPIRIT);
		addKillId(TARGET_1);
		addKillId(TARGET_2);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		if(event.equalsIgnoreCase("31453-2.htm"))
		{
			st.set("cond", "1");
			st.playSound(SOUND_ACCEPT);
		}
		if(event.equalsIgnoreCase("31453-3.htm"))
			st.set("cond", "2");
		if(event.equalsIgnoreCase("31453-5.htm"))
		{
			st.giveItems(SCROLL, 1);
			st.takeItems(ITEM, 1);
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(false);
		}
		return event;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int cond = st.getInt("cond");
		QuestState q = st.getPlayer().getQuestState("_119_LastImperialPrince");
		if(q == null)
			return htmltext;
		if(st.getPlayer().getLevel() < 74)
		{
			htmltext = "<html><body>Quest for characters level 74 and above.</body></html>";
			st.exitCurrentQuest(true);
			return htmltext;
		}
		else if(q.getState() != COMPLETED)
		{
			htmltext = "noquest";
			st.exitCurrentQuest(true);
			return htmltext;
		}
		int npcId = npc.getNpcId();
		if(npcId == SPIRIT)
		{
			if(cond == 0)
				return "31453-1.htm";
			if(cond == 1)
				return "31453-2.htm";
			if(cond == 3)
				return "31453-4.htm";
		}
		else
			htmltext = "noquest";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getInt("cond") == 2 && Rnd.chance(5))
		{
			st.set("cond", "3");
			st.giveItems(ITEM, 1);
			st.playSound(SOUND_MIDDLE);
		}
		return null;
	}
}