package services;

import l2r.extensions.scripts.Functions;
import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.model.L2Object;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2DoorInstance;
import l2r.gameserver.tables.DoorTable;

/**
 * Используется в локации Eastern Border Outpost
 * @Author: SYS
 */
public class BorderOutpostDoormans extends Functions implements ScriptFile
{
	public static L2Object self;
	public static L2Object npc;
	private static int DoorId = 24170001;

	public void onLoad()
	{
		System.out.println("Loaded Service: Border Outpost Doormans");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public static void openDoor()
	{
		L2Player player = (L2Player) self;

		if(player == null || player.isActionsDisabled() || player.isSitting() || player.getLastNpc().getDistance(player) > 300)
			return;

		L2DoorInstance door = DoorTable.getInstance().getDoor(DoorId);
		if(!door.isOpen())
			door.openMe();
	}

	public static void closeDoor()
	{
		L2Player player = (L2Player) self;

		if(player == null || player.isActionsDisabled() || player.isSitting() || player.getLastNpc().getDistance(player) > 300)
			return;

		L2DoorInstance door = DoorTable.getInstance().getDoor(DoorId);
		if(door.isOpen())
			door.closeMe();
	}
}