package services;

import l2r.Config;
import l2r.extensions.scripts.Functions;
import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.cache.Msg;
import l2r.gameserver.model.L2Object;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2ItemInstance;
import l2r.gameserver.serverpackets.SkillList;
import l2r.gameserver.serverpackets.SocialAction;
import l2r.gameserver.tables.ItemTable;
import l2r.gameserver.tables.SkillTable;
import l2r.gameserver.templates.L2Item;

public class NoblessSell extends Functions implements ScriptFile
{
	public static L2Object self;
	public static L2Object npc;

	public void get()
	{
		L2Player player = (L2Player) self;

		if(player.isNoble())
			return;

		if(player.getSubLevel() < 75)
		{
			player.sendMessage("You must make sub class level 75 first.");
			return;
		}

		L2Item item = ItemTable.getInstance().getTemplate(Config.SERVICES_NOBLESS_SELL_ITEM);
		L2ItemInstance pay = player.getInventory().getItemByItemId(item.getItemId());
		if(pay != null && pay.getCount() >= Config.SERVICES_NOBLESS_SELL_PRICE)
		{
			player.getInventory().destroyItem(pay, Config.SERVICES_NOBLESS_SELL_PRICE, true);
			player.setNoble(true);
			player.addSkill(SkillTable.getInstance().getInfo(1323, 1));
			player.addSkill(SkillTable.getInstance().getInfo(325, 1));
			player.addSkill(SkillTable.getInstance().getInfo(326, 1));
			player.addSkill(SkillTable.getInstance().getInfo(327, 1));
			player.addSkill(SkillTable.getInstance().getInfo(1324, 1));
			player.addSkill(SkillTable.getInstance().getInfo(1325, 1));
			player.addSkill(SkillTable.getInstance().getInfo(1326, 1));
			player.addSkill(SkillTable.getInstance().getInfo(1327, 1));
			player.sendPacket(new SkillList(player));
			player.broadcastPacket(new SocialAction(player.getObjectId(), 16));
			player.broadcastUserInfo();
		}
		else if(Config.SERVICES_NOBLESS_SELL_ITEM == 57)
			player.sendPacket(Msg.YOU_DO_NOT_HAVE_ENOUGH_ADENA);
		else
			player.sendPacket(Msg.INCORRECT_ITEM_COUNT);
	}

	public void onLoad()
	{
		System.out.println("Loaded Service: Nobless sell");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}