package services;

import l2r.Config;
import l2r.database.mysql;
import l2r.extensions.scripts.Functions;
import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.cache.Msg;
import l2r.gameserver.model.L2Object;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2ItemInstance;
import l2r.gameserver.tables.ItemTable;
import l2r.gameserver.templates.L2Item;
import l2r.util.Files;

public class RateBonus extends Functions implements ScriptFile
{
	public static L2Object self;
	public static L2Object npc;

	public void list()
	{
		L2Player player = (L2Player) self;
		String html;
		if(player.getNetConnection().getBonus() == 1)
		{
			html = Files.read("data/scripts/services/RateBonus.htm", player);
			html = html.replaceFirst("%count%", String.valueOf(Config.SERVICES_RATE_BONUS_PRICE));
			html = html.replaceFirst("%item%", ItemTable.getInstance().getTemplate(Config.SERVICES_RATE_BONUS_ITEM).getName());
			html = html.replaceFirst("%value%", String.valueOf((int) ((Config.SERVICES_RATE_BONUS_VALUE - 1) * 100)));
			html = html.replaceFirst("%days%", String.valueOf(Config.SERVICES_RATE_BONUS_DAYS));
		}
		else if(player.getNetConnection().getBonus() > 1)
		{
			Object endtime = mysql.get("SELECT FROM_UNIXTIME(`bonus_expire`) FROM `accounts` WHERE `login`='" + player.getAccountName() + "'");
			if(endtime != null)
				html = Files.read("data/scripts/services/RateBonusAlready.htm", player).replaceFirst("endtime", endtime.toString());
			else
				html = Files.read("data/scripts/services/RateBonusInfinite.htm", player);
		}
		else
			html = Files.read("data/scripts/services/RateBonusNo.htm", player);
		show(html, player);
	}

	public void get()
	{
		L2Player player = (L2Player) self;

		L2Item item = ItemTable.getInstance().getTemplate(Config.SERVICES_RATE_BONUS_ITEM);
		L2ItemInstance pay = player.getInventory().getItemByItemId(item.getItemId());
		if(pay != null && pay.getCount() >= Config.SERVICES_RATE_BONUS_PRICE)
		{
			player.getInventory().destroyItem(pay, Config.SERVICES_RATE_BONUS_PRICE, true);
			mysql.set("UPDATE `accounts` SET `bonus` = '" + Config.SERVICES_RATE_BONUS_VALUE + "',`bonus_expire` = UNIX_TIMESTAMP()+" + Config.SERVICES_RATE_BONUS_DAYS + "*24*60*60 WHERE `login` = '" + player.getAccountName() + "'");
			player.getNetConnection().setBonus(Config.SERVICES_RATE_BONUS_VALUE);
			show(Files.read("data/scripts/services/RateBonusGet.htm", player), player);
		}
		else if(Config.SERVICES_RATE_BONUS_ITEM == 57)
			player.sendPacket(Msg.YOU_DO_NOT_HAVE_ENOUGH_ADENA);
		else
			player.sendPacket(Msg.INCORRECT_ITEM_COUNT);
	}

	public void howtogetcol()
	{
		show("data/scripts/services/howtogetcol.htm", (L2Player) self);
	}

	public void onLoad()
	{
		System.out.println("Loaded Service: Rate bonus");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}