package services;

import java.sql.ResultSet;

import l2r.Config;
import l2r.database.DatabaseUtils;
import l2r.database.FiltredPreparedStatement;
import l2r.database.L2DatabaseFactory;
import l2r.database.ThreadConnection;
import l2r.extensions.multilang.CustomMessage;
import l2r.extensions.scripts.Functions;
import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.cache.Msg;
import l2r.gameserver.model.L2Object;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2World;
import l2r.util.Log;
import l2r.util.Util;

public class Rename extends Functions implements ScriptFile
{
	public static L2Object self;
	public static L2Object npc;
	private static int RENAME_ITEM = Config.SERVICES_CHANGE_NICK_ITEM;
	private static int RENAME_PRICE = Config.SERVICES_CHANGE_NICK_PRICE;

	public static void rename_page()
	{
		L2Player player = (L2Player) self;
		String append = "!Rename";
		append += "<br>";
		append += "<font color=\"LEVEL\">" + new CustomMessage("scripts.services.Rename.RenameFor", self).addString(Util.formatAdena(RENAME_PRICE)).addItemName(RENAME_ITEM) + "</font>";
		append += "<table>";
		append += "<tr><td>" + new CustomMessage("scripts.services.Rename.NewName", self) + ": <edit var=\"new_name\" width=80></td></tr>";
		append += "<tr><td><button value=\"" + new CustomMessage("scripts.services.Rename.RenameButton", self) + "\" action=\"bypass -h scripts_services.Rename:rename $new_name\" width=80 height=15></td></tr>";
		append += "</table>";
		show(append, player);
	}

	public static void rename(String[] args)
	{
		L2Player player = (L2Player) self;
		if(args.length != 1)
		{
			show(new CustomMessage("scripts.services.Rename.incorrectinput", player), player);
			return;
		}

		String name = args[0];
		if(!Util.isMatchingRegexp(name, Config.CNAME_TEMPLATE))
		{
			show(new CustomMessage("scripts.services.Rename.incorrectinput", player), player);
			return;
		}

		if(getItemCount(player, RENAME_ITEM) < RENAME_PRICE)
		{
			if(RENAME_ITEM == 57)
				player.sendPacket(Msg.YOU_DO_NOT_HAVE_ENOUGH_ADENA);
			else
				player.sendPacket(Msg.INCORRECT_ITEM_COUNT);
			return;
		}

		ThreadConnection con = null;
		FiltredPreparedStatement offline = null;
		ResultSet rs = null;

		try
		{
			con = L2DatabaseFactory.getInstance().getConnection();
			offline = con.prepareStatement("SELECT char_name FROM characters WHERE char_name LIKE ?");
			offline.setString(1, name);
			rs = offline.executeQuery();
			if(rs.next())
			{
				show(new CustomMessage("scripts.services.Rename.Thisnamealreadyexists", player), player);
				return;
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
			show(new CustomMessage("common.Error", player), player);
			return;
		}
		finally
		{
			DatabaseUtils.closeDatabaseCSR(con, offline, rs);
		}

		try
		{
			con = L2DatabaseFactory.getInstance().getConnection();
			offline = con.prepareStatement("UPDATE characters SET char_name = ? WHERE obj_Id = ?");
			offline.setString(1, name);
			offline.setInt(2, player.getObjectId());
			offline.executeUpdate();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			show(new CustomMessage("common.Error", player), player);
			return;
		}
		finally
		{
			DatabaseUtils.closeDatabaseCS(con, offline);
		}

		removeItem(player, RENAME_ITEM, RENAME_PRICE);

		String oldName = player.getName();
		L2World.removeObject(player);
		player.decayMe();
		player.setName(name);
		player.spawnMe();
		player.broadcastUserInfo();
		Log.add("Character " + oldName + " renamed to " + name, "renames");
		show(new CustomMessage("scripts.services.Rename.changedname", player).addString(oldName).addString(name), player);
	}

	public void onLoad()
	{
		System.out.println("Loaded Service: Nick change");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}