package services;

import l2r.extensions.scripts.Functions;
import l2r.extensions.scripts.ScriptFile;
import l2r.gameserver.cache.Msg;
import l2r.gameserver.instancemanager.SiegeManager;
import l2r.gameserver.model.L2Object;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.serverpackets.SetupGauge;
import l2r.gameserver.serverpackets.SystemMessage;

public class RideHire extends Functions implements ScriptFile
{
	public static L2Object self;
	public static L2Object npc;

	public static String DialogAppend_30827(Integer val)
	{
		if(val == 0)
		{
			L2Player player = (L2Player) self;
			String lang = player.getVar("lang@");
			if(lang == null)
				lang = "en";
			if(lang.equalsIgnoreCase("en"))
				return "<br>[scripts_services.RideHire:ride_prices|Ride hire mountable pet.]";
			return "<br>[scripts_services.RideHire:ride_prices|Взять на прокат ездовое животное.]";
		}
		return "";
	}

	public static void ride_prices()
	{
		show("data/scripts/services/ride-prices.htm", (L2Player) self);
	}

	public static void ride(String[] args)
	{
		L2Player player = (L2Player) self;
		String lang = player.getVar("lang@");
		if(lang == null)
			lang = "en";
		if(args.length != 3)
		{
			if(lang.equalsIgnoreCase("en"))
				show("Incorrect input", player);
			else
				show("Некорректные данные", player);
			return;
		}

		if(player.isActionsDisabled() || player.getLastNpc().getDistance(player) > 250)
			return;

		if(!SiegeManager.getCanRide())
		{
			if(lang.equalsIgnoreCase("en"))
				show("Can't ride while Siege in progress.", player);
			else
				show("Прокат не работает во время осады.", player);
			return;
		}

		if(player.getPet() != null || player.isMounted())
		{
			player.sendPacket(new SystemMessage(SystemMessage.YOU_ALREADY_HAVE_A_PET));
			return;
		}

		Integer npc_id = Integer.parseInt(args[0]);
		Integer time = Integer.parseInt(args[1]);
		Integer price = Integer.parseInt(args[2]);

		if(npc_id != 12621 && npc_id != 12526 && npc_id != 16030)
		{
			if(lang.equalsIgnoreCase("en"))
				show("Unknown pet.", player);
			else
				show("У меня нет таких питомцев!", player);
			return;
		}

		if(time > 1800)
		{
			if(lang.equalsIgnoreCase("en"))
				show("Too long time to ride.", player);
			else
				show("Слишком большое время.", player);
			return;
		}

		if(player.getAdena() < price)
		{
			player.sendPacket(Msg.YOU_DO_NOT_HAVE_ENOUGH_ADENA);
			return;
		}

		player.reduceAdena(price, true);

		doLimitedRide(player, npc_id, time);
	}

	public static void doLimitedRide(L2Player player, Integer npc_id, Integer time)
	{
		if(!ride(player, npc_id))
			return;
		player.sendPacket(new SetupGauge(3, time * 1000));
		executeTask(player, "services.RideHire", "rideOver", new Object[0], time * 1000);
	}

	public static void rideOver()
	{
		if(self == null)
			return;
		L2Player player = (L2Player) self;
		unRide(player);
		String lang = player.getVar("lang@");
		if(lang.equalsIgnoreCase("en"))
			show("Ride time is over.<br><br>Welcome back again!", player);
		else
			show("Время проката закончилось. Приходите еще!", player);
	}

	public void onLoad()
	{
		System.out.println("Loaded Service: Ride Hire");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}