/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
package l2r;

import java.lang.reflect.Method;
import java.util.concurrent.ScheduledFuture;
import java.util.logging.Logger;

import l2r.gameserver.network.L2GameClient;
import l2r.gameserver.serverpackets.GameGuardQuery;



/**
 * 
 * @author Nick
 */
public class Protection
{
    private static Logger _log = Logger.getLogger(Protection.class.getName());
	public static enum RestrictionType
	{
		RESTRICT_ENTER,RESTRICT_EVENT,RESTRICT_OLYMPIAD,RESTRICT_SIEGE
	}
	public class ProtectionAccessor
	{
		public ProtectionAccessor() {}
		public void setCheckGameGuardQuery(Method m)
		{
			Protection.this._checkGameGuardQuery = m;
		}

		public void setStartTask(Method m)
		{
			Protection.this._startTask = m;
		}

		public void setSendRequest(Method m)
		{
			Protection.this._sendRequest = m;
		}

		public void setCloseSession(Method m)
		{
			Protection.this._closeSession = m;
		}
		public void setSendGGQuery(Method m) {
			Protection.this._sendGGQuery = m;
		}

	}
	protected Method _checkGameGuardQuery = null;
	protected Method _startTask = null;
	protected Method _checkRestriction = null;
	protected Method _sendRequest = null;
	protected Method _closeSession = null;
	protected Method _sendGGQuery = null;
	private static Protection _instance = null;
	
	public static Protection getInstance()
	{
		if(_instance == null)
			_instance = new Protection();
		return _instance;
	}
	
	private Protection()
	{
		Class<?> clazz=null;
		try
		{	
			try {
				clazz = Class.forName("import of protection-later");
			} catch(ClassNotFoundException e) {
			}
			if(clazz!=null)
			{
				Method m = clazz.getMethod("init", ProtectionAccessor.class);
				if(m!=null)
					m.invoke(null, new ProtectionAccessor());
			}
		}
		catch (Exception e)
		{
			//e.printStackTrace();
	        _log.warning("[Protection] Error " + e.getMessage());
		}
		
	}
	
	public void sendGameGuardQuery(GameGuardQuery pkt) {
	    try {
	        if (this._sendGGQuery != null)
	          this._sendGGQuery.invoke(null, pkt);
	      }
	      catch (Exception e) {
	        //e.printStackTrace();
	        //_log.warning("[Protection] Error" + e.getMessage());
	      }
	}
	public boolean checkGameGuardRepy(L2GameClient cl, int [] reply)
	{
		try
		{
			if(_checkGameGuardQuery!=null)
				return (Boolean)_checkGameGuardQuery.invoke(null, cl,reply);
		}
		catch(Exception e)
		{
			//e.printStackTrace();
		}
		return true;
	}
	
	public ScheduledFuture<?> startTask(L2GameClient client)
	{
		try
		{
			if(_startTask != null)
				return (ScheduledFuture<?>)_startTask.invoke(null, client);
		}
		catch(Exception e)
		{
			//e.printStackTrace();
		}
		return null;
	}
	
	public void sendRequest(L2GameClient cl)
	{
		if(_sendRequest!=null)
			try
			{
				_sendRequest.invoke(null, cl);
			}
			catch(Exception e)
			{
				//e.printStackTrace();
			}
	}
	
	public void closeSession(L2GameClient cl)
	{
			if(_closeSession!=null)
				try
				{
					_closeSession.invoke(null, cl);
				}
				catch(Exception e)
				{
					//null
				}
	}
	
}
