package l2r.extensions;

import java.lang.reflect.Field;
import java.sql.ResultSet;
import java.sql.SQLException;

import l2r.Config;
import l2r.database.DatabaseUtils;
import l2r.database.FiltredStatement;
import l2r.database.L2DatabaseFactory;
import l2r.database.ThreadConnection;
import l2r.gameserver.model.L2Player;

public class Bonus
{
	L2Player _owner = null;
	/** Rate control */
	public float RATE_XP = 1;
	public float RATE_SP = 1;
	public float RATE_PARTY_XP = 1;
	public float RATE_PARTY_SP = 1;
	public float RATE_QUESTS_REWARD = 1;
	public float RATE_QUESTS_DROP = 1;
	public float RATE_DROP_ADENA = 1;
	public float RATE_DROP_ITEMS = 1;
	public float RATE_DROP_SPOIL = 1;
	public float LUCK_MULTIPLIER = 1;

	/** UNUSED */
	public float RATE_CONSUMABLE_COST = 1;
	/** UNUSED */
	public float RATE_KARMA_EXP_LOST = 1;
	/** UNUSED */
	public float RATE_SIEGE_GUARDS_PRICE = 1;

	public Bonus(L2Player player)
	{
		if(player == null || player.getNetConnection() == null) // игрок отвалился при входе
			return;

		_owner = player;
		restore();

		if(player.getNetConnection() == null)
			return;

		LUCK_MULTIPLIER *= player.getNetConnection().getBonus();
		if(LUCK_MULTIPLIER == 0)
			LUCK_MULTIPLIER = 1;

		RATE_XP *= LUCK_MULTIPLIER;
		RATE_SP *= LUCK_MULTIPLIER;
		RATE_DROP_ADENA *= LUCK_MULTIPLIER;
		RATE_DROP_ITEMS *= LUCK_MULTIPLIER;
		RATE_DROP_SPOIL *= LUCK_MULTIPLIER;

		LUCK_MULTIPLIER = LUCK_MULTIPLIER > 1 ? Config.SERVICES_RATE_BONUS_LUCK_EFFECT : 1;
	}

	private void restore()
	{
		ThreadConnection con = null;
		FiltredStatement statement = null;
		ResultSet rset = null;
		try
		{
			con = L2DatabaseFactory.getInstance().getConnection();
			statement = con.createStatement();
			rset = statement.executeQuery("SELECT bonus_name,bonus_value from bonus where obj_id='" + _owner.getObjectId() + "' and (bonus_expire_time='-1' or bonus_expire_time > " + System.currentTimeMillis() / 1000 + ")");
			while(rset.next())
			{
				String bonus_name = rset.getString("bonus_name");
				float bonus_value = rset.getFloat("bonus_value");
				Class cls = getClass();
				try
				{
					Field fld = cls.getField(bonus_name);
					try
					{
						fld.setFloat(this, bonus_value);
					}
					catch(IllegalArgumentException e)
					{
						e.printStackTrace();
					}
					catch(IllegalAccessException e)
					{
						e.printStackTrace();
					}
				}
				catch(SecurityException e)
				{
					e.printStackTrace();
				}
				catch(NoSuchFieldException e)
				{
					e.printStackTrace();
				}
			}
		}
		catch(SQLException e)
		{
			e.printStackTrace();
		}
		finally
		{
			DatabaseUtils.closeDatabaseCSR(con, statement, rset);
		}
	}
}