package l2r.extensions.listeners;

import l2r.extensions.listeners.events.MethodEvent;
import l2r.extensions.listeners.events.AbstractAI.AbstractAINotifyEvent;
import l2r.gameserver.ai.AbstractAI;
import l2r.gameserver.ai.CtrlEvent;

/**
 * @Author: Diamond
 * @Date: 08/11/2007
 * @Time: 7:17:24
 */
public abstract class AbstractAINotifyEventListener implements MethodInvokeListener, MethodCollection
{
	public final void methodInvoked(MethodEvent e)
	{
		AbstractAINotifyEvent event = (AbstractAINotifyEvent) e;
		AbstractAI ai = event.getOwner();
		CtrlEvent evt = (CtrlEvent) event.getArgs()[0];
		Object arg0 = event.getArgs()[1];
		Object arg1 = event.getArgs()[2];
		NotifyEvent(ai, evt, arg0, arg1);
	}

	public final boolean accept(MethodEvent event)
	{
		String method = event.getMethodName();
		return event instanceof AbstractAINotifyEvent && method.equals(AbstractAInotifyEvent);
	}

	public abstract void NotifyEvent(AbstractAI ai, CtrlEvent evt, Object arg0, Object arg1);
}
