package l2r.extensions.listeners;

import l2r.extensions.listeners.events.MethodEvent;
import l2r.gameserver.model.L2Character;

/**
 * User: Death
 * Date: 20 груд 2007
 * Time: 11:34:27
 */
public abstract class ReduceCurrentHpListener implements MethodInvokeListener
{
	public final void methodInvoked(MethodEvent e)
	{
		Object[] args = e.getArgs();
		onReduceCurrentHp((L2Character) e.getOwner(), (Double) args[0], (L2Character) args[1], (Boolean) args[2], (Boolean) args[3], (Boolean) args[4]);
	}

	/**
	 * Простенький фильтр. Фильтрирует по названии метода и аргументам.
	 * Ничто не мешает переделать при нужде :)
	 *
	 * @param event событие с аргументами
	 *
	 * @return true если все ок ;)
	 */
	public final boolean accept(MethodEvent event)
	{
		return event.getMethodName().equals(MethodCollection.ReduceCurrentHp);
	}

	public abstract void onReduceCurrentHp(L2Character actor, double damage, L2Character attacker, boolean awake, boolean standUp, boolean directHp);
}
