package l2r.extensions.network;

import java.nio.ByteBuffer;

import javolution.util.FastList;

public abstract class MMOClient<T extends MMOConnection>
{
	private T _connection;

	public boolean can_runImpl = true;
	public FastList<Object> client_packets = new FastList<Object>();

	@SuppressWarnings("unchecked")
	public MMOClient(T con)
	{
		this.setConnection(con);
		con.setClient(this);
	}

	public void setConnection(T con)
	{
		_connection = con;
	}

	public T getConnection()
	{
		return _connection;
	}

	public void closeNow(boolean error)
	{
		if(this.getConnection() != null)
			this.getConnection().closeNow(error);
	}

	public void closeLater()
	{
		this.getConnection().closeLater();
	}

	public abstract boolean decrypt(ByteBuffer buf, int size);

	public abstract boolean encrypt(ByteBuffer buf, int size);

	protected void onDisconnection()
	{}

	protected void onForcedDisconnection()
	{}
}
