package l2r.extensions.scripts;

import java.util.StringTokenizer;

import l2r.gameserver.handler.AdminCommandHandler;
import l2r.gameserver.handler.IAdminCommandHandler;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.quest.Quest;
import l2r.gameserver.model.quest.QuestState;

public class AdminScripts implements IAdminCommandHandler
{
	private static String[] _adminCommands = { "admin_scripts_reload", "admin_sreload", "admin_sqreload" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		/*if(Scripts.JAR)
		{
			activeChar.sendMessage(new CustomMessage("common.OnlyFullVersion", activeChar));
			return false;
		}*/
		if(!activeChar.getPlayerAccess().IsGM)
			return false;
		if(command.startsWith("admin_scripts_reload") || command.startsWith("admin_sreload"))
		{
			StringTokenizer st = new StringTokenizer(command);
			if(!st.hasMoreTokens())
				return false;
			st.nextToken();
			String param = st.nextToken();
			if(param.equalsIgnoreCase("all"))
			{
				activeChar.sendMessage("Scripts reload starting...");
				if(Scripts.getInstance().reload())
					activeChar.sendMessage("Scripts reloaded with errors. Loaded " + Scripts.getInstance().getClasses().size() + " classes.");
				else
					activeChar.sendMessage("Scripts successfully reloaded. Loaded " + Scripts.getInstance().getClasses().size() + " classes.");
			}
			else if(Scripts.getInstance().reloadClass(param))
				activeChar.sendMessage("Scripts reloaded with errors. Loaded " + Scripts.getInstance().getClasses().size() + " classes.");
			else
				activeChar.sendMessage("Scripts successfully reloaded. Loaded " + Scripts.getInstance().getClasses().size() + " classes.");
		}
		else if(command.startsWith("admin_sqreload"))
		{
			StringTokenizer st = new StringTokenizer(command, " ");
			st.nextToken();
			String quest = st.nextToken();
			if(Scripts.getInstance().reloadQuest(quest))
				activeChar.sendMessage("Quest '" + quest + "' reloaded with errors.");
			else
				activeChar.sendMessage("Quest '" + quest + "' successfully reloaded.");
			reloadQuestStates(activeChar);
		}
		return true;
	}

	private void reloadQuestStates(L2Player p)
	{
		for(QuestState qs : p.getAllQuestsStates())
			p.delQuestState(qs.getQuest().getName());

		Quest.playerEnter(p);
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	public String[] getDescription()
	{
		return new String[] { "Перезагрузка скриптов сервера на лету", "Перезагрузка скриптов сервера на лету", "Перезагрузка квестов на лету" };
	}

	public String[] getCommandGroup()
	{
		return new String[] { AdminCommandHandler.GROUP_MANAGESERVER, AdminCommandHandler.GROUP_MANAGESERVER, AdminCommandHandler.GROUP_MANAGESERVER };
	}
}