package l2r.extensions.scripts;

import java.util.logging.Logger;

import l2r.gameserver.model.L2Object;
import l2r.gameserver.model.L2Player;
import l2r.util.Strings;

public final class Events
{
	static Logger _log = Logger.getLogger(Events.class.getName());

	public static boolean onAction(L2Player player, L2Object obj)
	{
		String instance = obj.getL2ClassShortName();
		String handler = Scripts.onAction.get(instance);
		if(handler == null)
			return false;
		String[] list = handler.split(":");
		String _class = list[0];
		String _method = list[1];
		return Strings.parseBoolean(player.callScripts(_class, _method, new Object[] { player, obj }));
	}

	public static boolean onActionShift(L2Player player, L2Object obj)
	{
		String instance = obj.getL2ClassShortName();
		String handler = Scripts.onActionShift.get(instance);
		if(handler == null)
			return false;
		String[] list = handler.split(":");
		String _class = list[0];
		String _method = list[1];
		Object rez = player.callScripts(_class, _method, new Object[] { player, obj });
		return Strings.parseBoolean(rez);
	}
}
