package l2r.gameserver.ai;

import l2r.gameserver.model.L2Character;

public class SiegeGuardRanger extends SiegeGuard
{
	public SiegeGuardRanger(L2Character actor)
	{
		super(actor);
		_isMobile = false;
	}

	@Override
	protected boolean createNewTask()
	{
		// Удаляем все задания
		clearTasks();

		L2Character _temp_attack_target = _attack_target;

		// Новая цель исходя из агрессивности
		L2Character hated = _thisActor.isConfused() ? _temp_attack_target : _thisActor.getMostHated();

		if(hated != null && hated != _thisActor)
		{
			_attack_target = hated;
			_temp_attack_target = hated;
		}
		else
		{
			returnHome();
			return false;
		}

		// Добавить новое задание
		Task task = new Task();
		task.type = TaskType.ATTACK;
		task.target = _temp_attack_target;
		_task_list.add(task);
		_def_think = true;
		return true;
	}
}