package l2r.gameserver.cache;

import l2r.gameserver.serverpackets.*;

public abstract class Msg
{
	public static final SystemMessage GETTING_READY_TO_SHOOT_ARROWS = new SystemMessage(SystemMessage.GETTING_READY_TO_SHOOT_ARROWS);
	public static final SystemMessage CRITICAL_HIT = new SystemMessage(SystemMessage.CRITICAL_HIT);
	public static final SystemMessage PETS_CRITICAL_HIT = new SystemMessage(SystemMessage.PETS_CRITICAL_HIT);
	public static final SystemMessage THE_PET_IS_TOO_HIGH_LEVEL_TO_CONTROL = new SystemMessage(SystemMessage.THE_PET_IS_TOO_HIGH_LEVEL_TO_CONTROL);
	public static final SystemMessage SUMMONED_MONSTERS_CRITICAL_HIT = new SystemMessage(SystemMessage.SUMMONED_MONSTERS_CRITICAL_HIT);
	public static final SystemMessage INSTANT_KILL = new SystemMessage(SystemMessage.INSTANT_KILL);
	public static final SystemMessage YOU_HAVE_BEEN_STRUCK_BY_THE_INSTANT_KILL_SKILL = new SystemMessage(SystemMessage.YOU_HAVE_BEEN_STRUCK_BY_THE_INSTANT_KILL_SKILL);
	public static final SystemMessage MISSED_TARGET = new SystemMessage(SystemMessage.MISSED_TARGET);
	public static final SystemMessage SHIELD_DEFENSE_HAS_SUCCEEDED = new SystemMessage(SystemMessage.SHIELD_DEFENSE_HAS_SUCCEEDED);
	public static final SystemMessage YOUR_EXCELLENT_SHIELD_DEFENSE_WAS_A_SUCCESS = new SystemMessage(SystemMessage.YOUR_EXCELLENT_SHIELD_DEFENSE_WAS_A_SUCCESS);
	public static final SystemMessage ATTACK_FAILED = new SystemMessage(SystemMessage.ATTACK_FAILED);
	public static final SystemMessage CANNOT_SEE_TARGET = new SystemMessage(SystemMessage.CANNOT_SEE_TARGET);
	public static final SystemMessage TARGET_IS_INCORRECT = new SystemMessage(SystemMessage.TARGET_IS_INCORRECT);
	public static final SystemMessage THE_TARGET_IS_UNAVAILABLE_FOR_SEEDING = new SystemMessage(SystemMessage.THE_TARGET_IS_UNAVAILABLE_FOR_SEEDING);
	public static final SystemMessage THE_SEED_HAS_BEEN_SOWN = new SystemMessage(SystemMessage.THE_SEED_HAS_BEEN_SOWN);
	public static final SystemMessage INCORRECT_ITEM_COUNT = new SystemMessage(SystemMessage.INCORRECT_ITEM_COUNT);
	public static final SystemMessage THIS_SEED_MAY_NOT_BE_SOWN_HERE = new SystemMessage(SystemMessage.THIS_SEED_MAY_NOT_BE_SOWN_HERE);
	public static final SystemMessage THE_HARVEST_HAS_FAILED = new SystemMessage(SystemMessage.THE_HARVEST_HAS_FAILED);
	public static final SystemMessage THE_HARVEST_FAILED_BECAUSE_THE_SEED_WAS_NOT_SOWN = new SystemMessage(SystemMessage.THE_HARVEST_FAILED_BECAUSE_THE_SEED_WAS_NOT_SOWN);
	public static final SystemMessage INCORRECT_TARGET = new SystemMessage(SystemMessage.INCORRECT_TARGET);
	public static final SystemMessage YOUR_TARGET_IS_OUT_OF_RANGE = new SystemMessage(SystemMessage.YOUR_TARGET_IS_OUT_OF_RANGE);
	public static final SystemMessage YOU_CANNOT_MOVE_WHILE_SITTING = new SystemMessage(SystemMessage.YOU_CANNOT_MOVE_WHILE_SITTING);
	public static final SystemMessage YOU_CANNOT_ATTACK_IN_THE_PEACE_ZONE = new SystemMessage(SystemMessage.YOU_CANNOT_ATTACK_IN_THE_PEACE_ZONE);
	public static final SystemMessage ONLY_LEVEL_SUP_10_CAN_RECOMMEND = new SystemMessage(SystemMessage.ONLY_LEVEL_SUP_10_CAN_RECOMMEND);
	public static final SystemMessage YOU_CANNOT_RECOMMEND_YOURSELF = new SystemMessage(SystemMessage.YOU_CANNOT_RECOMMEND_YOURSELF);
	public static final SystemMessage NO_MORE_RECOMMENDATIONS_TO_HAVE = new SystemMessage(SystemMessage.NO_MORE_RECOMMENDATIONS_TO_HAVE);
	public static final SystemMessage YOU_NO_LONGER_RECIVE_A_RECOMMENDATION = new SystemMessage(SystemMessage.YOU_NO_LONGER_RECIVE_A_RECOMMENDATION);
	public static final SystemMessage THAT_CHARACTER_IS_RECOMMENDED = new SystemMessage(SystemMessage.THAT_CHARACTER_IS_RECOMMENDED);
	public static final SystemMessage NOT_WORKING_PLEASE_TRY_AGAIN_LATER = new SystemMessage(SystemMessage.NOT_WORKING_PLEASE_TRY_AGAIN_LATER);
	public static final SystemMessage YOU_CANNOT_ATTACK_THE_TARGET_IN_THE_PEACE_ZONE = new SystemMessage(SystemMessage.YOU_CANNOT_ATTACK_THE_TARGET_IN_THE_PEACE_ZONE);
	public static final SystemMessage ONLY_FISHING_SKILLS_ARE_AVAILABLE = new SystemMessage(SystemMessage.ONLY_FISHING_SKILLS_ARE_AVAILABLE);
	public static final SystemMessage YOU_CANNOT_SUMMON_A_BASE_BECAUSE_YOU_ARE_NOT_IN_BATTLE = new SystemMessage(SystemMessage.YOU_CANNOT_SUMMON_A_BASE_BECAUSE_YOU_ARE_NOT_IN_BATTLE);
	public static final SystemMessage THIS_ITEM_IS_NOT_AVAILABLE_FOR_THE_OLYMPIAD_EVENT = new SystemMessage(SystemMessage.THIS_ITEM_IS_NOT_AVAILABLE_FOR_THE_OLYMPIAD_EVENT);
	public static final SystemMessage NOT_ENOUGH_HP = new SystemMessage(SystemMessage.NOT_ENOUGH_HP);
	public static final SystemMessage NOT_ENOUGH_MP = new SystemMessage(SystemMessage.NOT_ENOUGH_MP);
	public static final SystemMessage NOT_ENOUGH_ARROWS = new SystemMessage(SystemMessage.NOT_ENOUGH_ARROWS);
	public static final SystemMessage THE_RECIPE_IS_INCORRECT = new SystemMessage(SystemMessage.THE_RECIPE_IS_INCORRECT);
	public static final SystemMessage PLEASE_REGISTER_A_RECIPE = new SystemMessage(SystemMessage.PLEASE_REGISTER_A_RECIPE);
	public static final SystemMessage YOU_DO_NOT_HAVE_ENOUGH_ADENA = new SystemMessage(SystemMessage.YOU_DO_NOT_HAVE_ENOUGH_ADENA);
	public static final SystemMessage YOUR_INVENTORY_IS_FULL = new SystemMessage(SystemMessage.YOUR_INVENTORY_IS_FULL);
	public static final SystemMessage YOU_HAVE_EXCEEDED_THE_WEIGHT_LIMIT = new SystemMessage(SystemMessage.YOU_HAVE_EXCEEDED_THE_WEIGHT_LIMIT);
	public static final SystemMessage NOT_ENOUGH_MATERIALS = new SystemMessage(SystemMessage.NOT_ENOUGH_MATERIALS);
	public static final SystemMessage PROTOCOL_VERSION_IS_DIFFERENT_PLEASE_QUIT_THE_PROGRAM = new SystemMessage(SystemMessage.PROTOCOL_VERSION_IS_DIFFERENT_PLEASE_QUIT_THE_PROGRAM);
	public static final SystemMessage PROGRESS_IN_A_QUEST_IS_POSSIBLE_ONLY_WHEN_YOUR_INVENTORYS_WEIGHT_AND_VOLUME_ARE_LESS_THAN_80_PERCENT_OF_CAPACITY = new SystemMessage(SystemMessage.PROGRESS_IN_A_QUEST_IS_POSSIBLE_ONLY_WHEN_YOUR_INVENTORYS_WEIGHT_AND_VOLUME_ARE_LESS_THAN_80_PERCENT_OF_CAPACITY);
	public static final SystemMessage NO_FURTHER_RECIPES_MAY_BE_REGISTERED = new SystemMessage(SystemMessage.NO_FURTHER_RECIPES_MAY_BE_REGISTERED);
	public static final SystemMessage CREATE_ITEM_LEVEL_IS_TOO_LOW_TO_REGISTER_THIS_RECIPE = new SystemMessage(SystemMessage.CREATE_ITEM_LEVEL_IS_TOO_LOW_TO_REGISTER_THIS_RECIPE);
	public static final SystemMessage THAT_RECIPE_IS_ALREADY_REGISTERED = new SystemMessage(SystemMessage.THAT_RECIPE_IS_ALREADY_REGISTERED);
	public static final SystemMessage YOU_ARE_NOT_AUTHORIZED_TO_REGISTER_A_RECIPE = new SystemMessage(SystemMessage.YOU_ARE_NOT_AUTHORIZED_TO_REGISTER_A_RECIPE);
	public static final SystemMessage ITEMS_LEFT_AT_THE_CLAN_HALL_WAREHOUSE_CAN_ONLY_BE_RETRIEVED_BY_THE_CLAN_LEADER_DO_YOU_WANT_TO_CONTINUE = new SystemMessage(SystemMessage.ITEMS_LEFT_AT_THE_CLAN_HALL_WAREHOUSE_CAN_ONLY_BE_RETRIEVED_BY_THE_CLAN_LEADER_DO_YOU_WANT_TO_CONTINUE);
	public static final SystemMessage YOU_ARE_NOT_AUTHORIZED_TO_HARVEST = new SystemMessage(SystemMessage.YOU_ARE_NOT_AUTHORIZED_TO_HARVEST);
	public static final SystemMessage THE_MANOR_SYSTEM_IS_CURRENTLY_UNDER_MAINTENANCE = new SystemMessage(SystemMessage.THE_MANOR_SYSTEM_IS_CURRENTLY_UNDER_MAINTENANCE);
	public static final SystemMessage WAREHOUSE_IS_TOO_FAR = new SystemMessage(SystemMessage.WAREHOUSE_IS_TOO_FAR);
	public static final SystemMessage YOUR_WAREHOUSE_IS_FULL = new SystemMessage(SystemMessage.YOUR_WAREHOUSE_IS_FULL);
	public static final SystemMessage YOU_LACK_THE_FUNDS_NEEDED_TO_PAY_FOR_THIS_TRANSACTION = new SystemMessage(SystemMessage.YOU_LACK_THE_FUNDS_NEEDED_TO_PAY_FOR_THIS_TRANSACTION);
	public static final SystemMessage THAT_PLAYER_IS_NOT_CURRENTLY_ONLINE = new SystemMessage(SystemMessage.THAT_PLAYER_IS_NOT_CURRENTLY_ONLINE);
	public static final SystemMessage ONLY_THE_CREATOR_OF_A_CHANNEL_CAN_ISSUE_A_GLOBAL_COMMAND = new SystemMessage(SystemMessage.ONLY_THE_CREATOR_OF_A_CHANNEL_CAN_ISSUE_A_GLOBAL_COMMAND);
	public static final SystemMessage YOU_WERE_DISMISSED_FROM_THE_COMMAND_CHANNEL = new SystemMessage(SystemMessage.YOU_WERE_DISMISSED_FROM_THE_COMMAND_CHANNEL);
	public static final SystemMessage CONGRATULATIONS_YOU_WILL_NOW_GRADUATE_FROM_THE_CLAN_ACADEMY_AND_LEAVE_YOUR_CURRENT_CLAN_AS_A_GRADUATE_OF_THE_ACADEMY_YOU_CAN_IMMEDIATELY_JOIN_A_CLAN_AS_A_REGULAR_MEMBER_WITHOUT_BEING_SUBJECT_TO_ANY_PENALTIES = new SystemMessage(SystemMessage.CONGRATULATIONS_YOU_WILL_NOW_GRADUATE_FROM_THE_CLAN_ACADEMY_AND_LEAVE_YOUR_CURRENT_CLAN_AS_A_GRADUATE_OF_THE_ACADEMY_YOU_CAN_IMMEDIATELY_JOIN_A_CLAN_AS_A_REGULAR_MEMBER_WITHOUT_BEING_SUBJECT_TO_ANY_PENALTIES);
	public static final SystemMessage SINCE_THE_CLAN_REPUTATION_SCORE_HAS_DROPPED_TO_0_OR_LOWER_YOUR_CLAN_SKILLS_WILL_BE_DE_ACTIVATED = new SystemMessage(SystemMessage.SINCE_THE_CLAN_REPUTATION_SCORE_HAS_DROPPED_TO_0_OR_LOWER_YOUR_CLAN_SKILLS_WILL_BE_DE_ACTIVATED);
	public static final SystemMessage THE_CLAN_SKILL_WILL_BE_ACTIVATED_BECAUSE_THE_CLANS_REPUTATION_SCORE_HAS_REACHED_TO_0_OR_HIGHER = new SystemMessage(SystemMessage.THE_CLAN_SKILL_WILL_BE_ACTIVATED_BECAUSE_THE_CLANS_REPUTATION_SCORE_HAS_REACHED_TO_0_OR_HIGHER);
	public static final SystemMessage YOUR_CLAN_HAS_ALREADY_ESTABLISHED_A_CLAN_ACADEMY = new SystemMessage(SystemMessage.YOUR_CLAN_HAS_ALREADY_ESTABLISHED_A_CLAN_ACADEMY);
	public static final SystemMessage THE_CLAN_REPUTATION_SCORE_IS_TOO_LOW = new SystemMessage(SystemMessage.THE_CLAN_REPUTATION_SCORE_IS_TOO_LOW);
	public static final SystemMessage YOU_HAVE_INCREASED_YOUR_LEVEL = new SystemMessage(SystemMessage.YOU_HAVE_INCREASED_YOUR_LEVEL);
	public static final SystemMessage NO_SLOT_EXISTS_TO_DRAW_THE_SYMBOL = new SystemMessage(SystemMessage.NO_SLOT_EXISTS_TO_DRAW_THE_SYMBOL);
	public static final SystemMessage BETTER_RESURRECTION_HAS_BEEN_ALREADY_PROPOSED = new SystemMessage(SystemMessage.BETTER_RESURRECTION_HAS_BEEN_ALREADY_PROPOSED);
	public static final SystemMessage SINCE_THE_MASTER_WAS_IN_THE_PROCESS_OF_BEING_RESURRECTED_THE_ATTEMPT_TO_RESURRECT_THE_PET_HAS_BEEN_CANCELLED = new SystemMessage(SystemMessage.SINCE_THE_MASTER_WAS_IN_THE_PROCESS_OF_BEING_RESURRECTED_THE_ATTEMPT_TO_RESURRECT_THE_PET_HAS_BEEN_CANCELLED);
	public static final SystemMessage WHILE_A_PET_IS_ATTEMPTING_TO_RESURRECT_IT_CANNOT_HELP_IN_RESURRECTING_ITS_MASTER = new SystemMessage(SystemMessage.WHILE_A_PET_IS_ATTEMPTING_TO_RESURRECT_IT_CANNOT_HELP_IN_RESURRECTING_ITS_MASTER);
	public static final SystemMessage IT_IS_IMPOSSIBLE_TO_BE_RESSURECTED_IN_BATTLEFIELDS_WHERE_SIEGE_WARS_ARE_IN_PROCESS = new SystemMessage(SystemMessage.IT_IS_IMPOSSIBLE_TO_BE_RESSURECTED_IN_BATTLEFIELDS_WHERE_SIEGE_WARS_ARE_IN_PROCESS);
	public static final SystemMessage BAITS_HAVE_BEEN_LOST_BECAUSE_THE_FISH_GOT_AWAY = new SystemMessage(SystemMessage.BAITS_HAVE_BEEN_LOST_BECAUSE_THE_FISH_GOT_AWAY);
	public static final SystemMessage ENDS_FISHING = new SystemMessage(SystemMessage.ENDS_FISHING);
	public static final SystemMessage CASTING_HAS_BEEN_INTERRUPTED = new SystemMessage(SystemMessage.CASTING_HAS_BEEN_INTERRUPTED);
	public static final SystemMessage YOU_HAVE_BEEN_PLAYING_FOR_AN_EXTENDED_PERIOD_OF_TIME_PLEASE_CONSIDER_TAKING_A_BREAK = new SystemMessage(SystemMessage.YOU_HAVE_BEEN_PLAYING_FOR_AN_EXTENDED_PERIOD_OF_TIME_PLEASE_CONSIDER_TAKING_A_BREAK);
	public static final SystemMessage ONLY_THE_LEADER_CAN_GIVE_OUT_INVITATIONS = new SystemMessage(SystemMessage.ONLY_THE_LEADER_CAN_GIVE_OUT_INVITATIONS);
	public static final SystemMessage WAITING_FOR_ANOTHER_REPLY = new SystemMessage(SystemMessage.WAITING_FOR_ANOTHER_REPLY);
	public static final SystemMessage THE_USER_WHO_REQUESTED_TO_BECOME_FRIENDS_IS_NOT_FOUND_IN_THE_GAME = new SystemMessage(SystemMessage.THE_USER_WHO_REQUESTED_TO_BECOME_FRIENDS_IS_NOT_FOUND_IN_THE_GAME);
	public static final SystemMessage YOU_CANNOT_ADD_YOURSELF_TO_YOUR_OWN_FRIEND_LIST = new SystemMessage(SystemMessage.YOU_CANNOT_ADD_YOURSELF_TO_YOUR_OWN_FRIEND_LIST);
	public static final SystemMessage WHILE_OPERATING_A_PRIVATE_STORE_OR_WORKSHOP_YOU_CANNOT_DISCARD_DESTROY_OR_TRADE_AN_ITEM = new SystemMessage(SystemMessage.WHILE_OPERATING_A_PRIVATE_STORE_OR_WORKSHOP_YOU_CANNOT_DISCARD_DESTROY_OR_TRADE_AN_ITEM);
	public static final SystemMessage NOTHING_HAPPENED = new SystemMessage(SystemMessage.NOTHING_HAPPENED);
	public static final SystemMessage YOU_CANNOT_DO_THAT_WHILE_FISHING = new SystemMessage(SystemMessage.YOU_CANNOT_DO_THAT_WHILE_FISHING);
	public static final SystemMessage THAT_ITEM_CANNOT_BE_DISCARDED = new SystemMessage(SystemMessage.THAT_ITEM_CANNOT_BE_DISCARDED);
	public static final SystemMessage THIS_ITEM_CANNOT_BE_DISCARDED = new SystemMessage(SystemMessage.THIS_ITEM_CANNOT_BE_DISCARDED);
	public static final SystemMessage TOO_FAR_TO_DISCARD = new SystemMessage(SystemMessage.TOO_FAR_TO_DISCARD);
	public static final SystemMessage HERO_WEAPONS_CANNOT_BE_DESTROYED = new SystemMessage(SystemMessage.HERO_WEAPONS_CANNOT_BE_DESTROYED);
	public static final SystemMessage YOU_CANNOT_DESTROY_IT_BECAUSE_THE_NUMBER_IS_INCORRECT = new SystemMessage(SystemMessage.YOU_CANNOT_DESTROY_IT_BECAUSE_THE_NUMBER_IS_INCORRECT);
	public static final SystemMessage THE_PET_HAS_BEEN_SUMMONED_AND_CANNOT_BE_DELETED = new SystemMessage(SystemMessage.THE_PET_HAS_BEEN_SUMMONED_AND_CANNOT_BE_DELETED);
	public static final SystemMessage THE_ITEM_HAS_BEEN_SUCCESSFULLY_CRYSTALLIZED = new SystemMessage(SystemMessage.THE_ITEM_HAS_BEEN_SUCCESSFULLY_CRYSTALLIZED);
	public static final SystemMessage THIS_ACCOUNT_CANOT_USE_PRIVATE_STORES = new SystemMessage(SystemMessage.THIS_ACCOUNT_CANOT_USE_PRIVATE_STORES);
	public static final SystemMessage A_PRIVATE_STORE_MAY_NOT_BE_OPENED_IN_THIS_AREA = new SystemMessage(SystemMessage.A_PRIVATE_STORE_MAY_NOT_BE_OPENED_IN_THIS_AREA);
	public static final SystemMessage A_PRIVATE_STORE_MAY_NOT_BE_OPENED_WHILE_USING_A_SKILL = new SystemMessage(SystemMessage.A_PRIVATE_STORE_MAY_NOT_BE_OPENED_WHILE_USING_A_SKILL);
	public static final SystemMessage WHILE_YOU_ARE_ENGAGED_IN_COMBAT_YOU_CANNOT_OPERATE_A_PRIVATE_STORE_OR_PRIVATE_WORKSHOP = new SystemMessage(SystemMessage.WHILE_YOU_ARE_ENGAGED_IN_COMBAT_YOU_CANNOT_OPERATE_A_PRIVATE_STORE_OR_PRIVATE_WORKSHOP);
	public static final SystemMessage A_DEAD_PET_CANNOT_BE_SENT_BACK = new SystemMessage(SystemMessage.A_DEAD_PET_CANNOT_BE_SENT_BACK);
	public static final SystemMessage A_PET_CANNOT_BE_SENT_BACK_DURING_BATTLE = new SystemMessage(SystemMessage.A_PET_CANNOT_BE_SENT_BACK_DURING_BATTLE);
	public static final SystemMessage YOU_CANNOT_RESTORE_HUNGRY_PETS = new SystemMessage(SystemMessage.YOU_CANNOT_RESTORE_HUNGRY_PETS);
	public static final SystemMessage A_STRIDER_CANNOT_BE_RIDDEN_WHEN_DEAD = new SystemMessage(SystemMessage.A_STRIDER_CANNOT_BE_RIDDEN_WHEN_DEAD);
	public static final SystemMessage A_DEAD_STRIDER_CANNOT_BE_RIDDEN = new SystemMessage(SystemMessage.A_DEAD_STRIDER_CANNOT_BE_RIDDEN);
	public static final SystemMessage A_STRIDER_IN_BATTLE_CANNOT_BE_RIDDEN = new SystemMessage(SystemMessage.A_STRIDER_IN_BATTLE_CANNOT_BE_RIDDEN);
	public static final SystemMessage A_STRIDER_CANNOT_BE_RIDDEN_WHILE_IN_BATTLE = new SystemMessage(SystemMessage.A_STRIDER_CANNOT_BE_RIDDEN_WHILE_IN_BATTLE);
	public static final SystemMessage A_STRIDER_CAN_BE_RIDDEN_ONLY_WHEN_STANDING = new SystemMessage(SystemMessage.A_STRIDER_CAN_BE_RIDDEN_ONLY_WHEN_STANDING);
	public static final SystemMessage YOU_ARE_NOT_ALLOWED_TO_DISMOUNT_AT_THIS_LOCATION = new SystemMessage(SystemMessage.YOU_ARE_NOT_ALLOWED_TO_DISMOUNT_AT_THIS_LOCATION);
	public static final SystemMessage THIS_ACCOUNT_CANOT_TRADE_ITEMS = new SystemMessage(SystemMessage.THIS_ACCOUNT_CANOT_TRADE_ITEMS);
	public static final SystemMessage YOU_HAVE_BEEN_BLOCKED_FROM_THE_CONTACT_YOU_SELECTED = new SystemMessage(SystemMessage.YOU_HAVE_BEEN_BLOCKED_FROM_THE_CONTACT_YOU_SELECTED);
	public static final SystemMessage ALREADY_TRADING = new SystemMessage(SystemMessage.ALREADY_TRADING);
	public static final SystemMessage INAPPROPRIATE_ENCHANT_CONDITIONS = new SystemMessage(SystemMessage.INAPPROPRIATE_ENCHANT_CONDITIONS);
	public static final SystemMessage YOU_CANNOT_PRACTICE_ENCHANTING_WHILE_OPERATING_A_PRIVATE_STORE_OR_PRIVATE_MANUFACTURING_WORKSHOP = new SystemMessage(SystemMessage.YOU_CANNOT_PRACTICE_ENCHANTING_WHILE_OPERATING_A_PRIVATE_STORE_OR_PRIVATE_MANUFACTURING_WORKSHOP);
	public static final SystemMessage FAILED_IN_BLESSED_ENCHANT_THE_ENCHANT_VALUE_OF_THE_ITEM_BECAME_0 = new SystemMessage(SystemMessage.FAILED_IN_BLESSED_ENCHANT_THE_ENCHANT_VALUE_OF_THE_ITEM_BECAME_0);
	public static final SystemMessage YOUR_TITLE_CANNOT_EXCEED_16_CHARACTERS_IN_LENGHT = new SystemMessage(SystemMessage.YOUR_TITLE_CANNOT_EXCEED_16_CHARACTERS_IN_LENGHT);
	public static final SystemMessage TITLE_HAS_CHANGED = new SystemMessage(SystemMessage.TITLE_HAS_CHANGED);
	public static final SystemMessage TITLE_ENDOWMENT_IS_ONLY_POSSIBLE_WHEN_CLANS_SKILL_LEVELS_ARE_ABOVE_3 = new SystemMessage(SystemMessage.TITLE_ENDOWMENT_IS_ONLY_POSSIBLE_WHEN_CLANS_SKILL_LEVELS_ARE_ABOVE_3);
	public static final SystemMessage SYSTEM_ERROR = new SystemMessage(SystemMessage.SYSTEM_ERROR);
	public static final SystemMessage THIS_ITEM_CANNOT_BE_TRADED_OR_SOLD = new SystemMessage(SystemMessage.THIS_ITEM_CANNOT_BE_TRADED_OR_SOLD);
	public static final SystemMessage YOU_CANNOT_MOVE_ADDITIONAL_ITEMS_BECAUSE_TRADE_HAS_BEEN_CONFIRMED = new SystemMessage(SystemMessage.YOU_CANNOT_MOVE_ADDITIONAL_ITEMS_BECAUSE_TRADE_HAS_BEEN_CONFIRMED);
	public static final SystemMessage TARGET_IS_NOT_FOUND_IN_THE_GAME = new SystemMessage(SystemMessage.TARGET_IS_NOT_FOUND_IN_THE_GAME);
    public static final SystemMessage YOU_CANNOT_SUMMON_DURING_A_TRADE_OR_WHILE_USING_THE_PRIVATE_SHOPS = new SystemMessage(SystemMessage.YOU_CANNOT_SUMMON_DURING_A_TRADE_OR_WHILE_USING_THE_PRIVATE_SHOPS);
    public static final SystemMessage THE_COMMUNITY_SERVER_IS_CURRENTLY_OFFLINE = new SystemMessage(SystemMessage.THE_COMMUNITY_SERVER_IS_CURRENTLY_OFFLINE);
    public static final SystemMessage CONGRATULATIONS_YOU_HAVE_TRANSFERRED_TO_A_NEW_CLASS = new SystemMessage(SystemMessage.CONGRATULATIONS_YOU_HAVE_TRANSFERRED_TO_A_NEW_CLASS);
    public static final SystemMessage YOU_HAVE_COMPLETED_THE_QUEST_FOR_3RD_OCCUPATION_CHANGE_AND_MOVED_TO_ANOTHER_CLASS_CONGRATULATIONS = new SystemMessage(SystemMessage.YOU_HAVE_COMPLETED_THE_QUEST_FOR_3RD_OCCUPATION_CHANGE_AND_MOVED_TO_ANOTHER_CLASS_CONGRATULATIONS);
    public static final SystemMessage YOU_CANNOT_TELEPORT_TO_A_VILLAGE_THAT_IS_IN_A_SIEGE = new SystemMessage(SystemMessage.YOU_CANNOT_TELEPORT_TO_A_VILLAGE_THAT_IS_IN_A_SIEGE);

    public static final ActionFail ActionFail = new ActionFail();
	public static final ExMPCCOpen ExMPCCOpen = new ExMPCCOpen();
	public static final ExMPCCClose ExMPCCClose = new ExMPCCClose();
	public static final ExRestartClient ExRestartClient = new ExRestartClient();
	public static final ExShowQuestInfo ExShowQuestInfo = new ExShowQuestInfo();
	public static final ExShowVariationCancelWindow ExShowVariationCancelWindow = new ExShowVariationCancelWindow();
	public static final ExShowVariationMakeWindow ExShowVariationMakeWindow = new ExShowVariationMakeWindow();
	public static final GameGuardQuery GameGuardQuery = new GameGuardQuery();
	public static final LeaveWorld LeaveWorld = new LeaveWorld();
	public static final ServerClose ServerClose = new ServerClose();
	public static final ServerCloseSocket ServerCloseSocket = new ServerCloseSocket();
	public static final SunRise SunRise = new SunRise();
	public static final SunSet SunSet = new SunSet();
	public static final TradePressOtherOk TradePressOtherOk = new TradePressOtherOk();
	public static final TradePressOwnOk TradePressOwnOk = new TradePressOwnOk();
	public static final TutorialCloseHtml TutorialCloseHtml = new TutorialCloseHtml();
}