package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Object;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2World;
import l2r.gameserver.model.L2WorldRegion;
import l2r.gameserver.model.instances.L2ItemInstance;

public class Action extends L2GameClientPacket
{
	private static String ACTION__C__04 = "[C] 04 Action";

	// cddddc
	private int _objectId;
	@SuppressWarnings("unused")
	private int _originX;
	@SuppressWarnings("unused")
	private int _originY;
	@SuppressWarnings("unused")
	private int _originZ;
	private int _actionId;

	@Override
	public void readImpl()
	{
		_objectId = readD();
		_originX = readD();
		_originY = readD();
		_originZ = readD();
		_actionId = readC();// 0 for simple click  1 for shift click
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		if(System.currentTimeMillis() - activeChar.getLastPacket() < 100)
		{
			activeChar.sendActionFailed();
			return;
		}

		activeChar.setLastPacket();

		if(activeChar.isOutOfControl())
		{
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.inObserverMode())
		{
			L2WorldRegion[] neighbors = activeChar.getObservNeighbors();
			if(neighbors != null)
				for(L2WorldRegion region : neighbors)
					if(region != null && region.getObjectsSize() > 0)
						for(L2Object obj : region.getObjectsList(activeChar.getReflection()))
							if(obj != null && obj.getObjectId() == _objectId && activeChar.getTarget() != obj)
							{
								obj.onAction(activeChar);
								return;
							}
		}

		if(activeChar.getPrivateStoreType() != L2Player.STORE_PRIVATE_NONE)
		{
			activeChar.sendActionFailed();
			return;
		}

		L2Object obj = activeChar.getVisibleObject(_objectId);

		if(obj == null)
		{
			// Для провалившихся предметов, чтобы можно было все равно поднять
			obj = L2World.findObject(_objectId);
			if(obj == null || !(obj instanceof L2ItemInstance))
			{
				activeChar.sendActionFailed();
				return;
			}
		}

		switch(_actionId)
		{
			case 0:
				obj.onAction(activeChar);
				break;
			case 1:
				if(obj.isCharacter && ((L2Character) obj).isAlikeDead())
					obj.onAction(activeChar);
				else
					obj.onActionShift(activeChar);
		}
	}

	@Override
	public String getType()
	{
		return ACTION__C__04;
	}
}