package l2r.gameserver.clientpackets;

import l2r.gameserver.cache.Msg;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2TradeList;
import l2r.gameserver.model.L2Player.TransactionType;
import l2r.gameserver.serverpackets.SendTradeDone;
import l2r.gameserver.serverpackets.SystemMessage;
import l2r.gameserver.serverpackets.TradeStart;

public class AnswerTradeRequest extends L2GameClientPacket
{
	private static String _C__40_ANSWERTRADEREQUEST = "[C] 40 AnswerTradeRequest";
	// Format: cd
	private int _response;

	@Override
	public void readImpl()
	{
		_response = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		L2Player requestor = activeChar.getTransactionRequester();

		// trade partner logged off. trade is canceld
		if(requestor == null || requestor.getTransactionRequester() == null)
		{
			if(_response != 0)
			{
				activeChar.sendPacket(new SendTradeDone(0));
				activeChar.sendPacket(Msg.TARGET_IS_NOT_FOUND_IN_THE_GAME);
			}
			activeChar.setTransactionRequester(null);
			return;
		}

		if(activeChar.getTransactionType() != TransactionType.TRADE || activeChar.getTransactionType() != requestor.getTransactionType())
		{
			activeChar.setTransactionRequester(null);
			requestor.setTransactionRequester(null);
			return;
		}

		if(_response != 1 || activeChar.getPrivateStoreType() != L2Player.STORE_PRIVATE_NONE)
		{
			requestor.sendPacket(new SystemMessage(SystemMessage.S1_DENIED_YOUR_REQUEST_FOR_TRADE).addString(activeChar.getName()));
			requestor.setTransactionRequester(null);
			activeChar.setTransactionRequester(null);
			if(activeChar.getPrivateStoreType() != L2Player.STORE_PRIVATE_NONE)
				activeChar.sendPacket(new SystemMessage(SystemMessage.WHILE_OPERATING_A_PRIVATE_STORE_OR_WORKSHOP_YOU_CANNOT_DISCARD_DESTROY_OR_TRADE_AN_ITEM));
			return;
		}

		requestor.sendPacket(new SystemMessage(SystemMessage.BEGIN_TRADING_WITH_S1).addString(activeChar.getName()));
		requestor.sendPacket(new TradeStart(requestor));
		if(requestor.getTradeList() == null)
			requestor.setTradeList(new L2TradeList(0));

		activeChar.sendPacket(new SystemMessage(SystemMessage.BEGIN_TRADING_WITH_S1).addString(requestor.getName()));
		activeChar.sendPacket(new TradeStart(activeChar));
		if(activeChar.getTradeList() == null)
			activeChar.setTradeList(new L2TradeList((short) 0));

		activeChar.setTransactionRequester(requestor);
		requestor.setTransactionRequester(activeChar);
	}

	@Override
	public String getType()
	{
		return _C__40_ANSWERTRADEREQUEST;
	}
}
