package l2r.gameserver.clientpackets;

import l2r.gameserver.ThreadPoolManager;
import l2r.gameserver.ai.CtrlIntention;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2World;
import l2r.gameserver.serverpackets.UserInfo;

/**
 * Appearing Packet Handler<p>
 * <p>
 * 0000: 30 <p>
 * <p>
 */
public class Appearing extends L2GameClientPacket
{
	private static String _C__30_APPEARING = "[C] 30 Appearing";

	@Override
	public void readImpl()
	{}

	@Override
	public void runImpl()
	{
		final L2Player activeChar = getClient().getActiveChar();

		if(activeChar == null)
			return;

		if(activeChar.inObserverMode())
		{
			activeChar.appearObserverMode();
			return;
		}

		if(!activeChar.isTeleporting() && L2World.getAllPlayers().contains(activeChar))
		{
			activeChar.sendActionFailed();
			return;
		}

		// 15 секунд после телепорта на персонажа не агрятся мобы
		activeChar.setNonAggroTime(System.currentTimeMillis() + 15000);

		// Персонаж появляется только после полной прогрузки
		ThreadPoolManager.getInstance().scheduleGeneral(new Runnable(){
			public void run()
			{
				if(activeChar.isTeleporting())
					activeChar.onTeleported();
				else
					activeChar.spawnMe(activeChar.getLoc());

				sendPacket(new UserInfo(activeChar));
				activeChar.getAI().setIntention(CtrlIntention.AI_INTENTION_IDLE, null, null);
				if(activeChar.getPet() != null)
					activeChar.getPet().teleportToOwner();
			}
		}, 2000);

	}

	@Override
	public String getType()
	{
		return _C__30_APPEARING;
	}
}