package l2r.gameserver.clientpackets;

import java.util.logging.Logger;

import l2r.extensions.multilang.CustomMessage;
import l2r.gameserver.handler.IUserCommandHandler;
import l2r.gameserver.handler.UserCommandHandler;
import l2r.gameserver.model.L2Player;


public class BypassUserCmd extends L2GameClientPacket
{
	private static String _C__AA_BYPASSUSERCMD = "[C] AA BypassUserCmd";
	static Logger _log = Logger.getLogger(BypassUserCmd.class.getName());

	private int _command;

	/**
	 * packet type id 0xB3
	 * format:  cd
	 */
	@Override
	public void readImpl()
	{
		_command = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		IUserCommandHandler handler = UserCommandHandler.getInstance().getUserCommandHandler(_command);

		if(handler == null)
			activeChar.sendMessage(new CustomMessage("common.S1NotImplemented", activeChar).addString(String.valueOf(_command)));
		else
			handler.useUserCommand(_command, activeChar);
	}

	@Override
	public String getType()
	{
		return _C__AA_BYPASSUSERCMD;
	}
}