package l2r.gameserver.clientpackets;

import l2r.gameserver.ai.CtrlEvent;
import l2r.gameserver.model.L2Player;
import l2r.util.Location;

public class CannotMoveAnymore extends L2GameClientPacket
{
	private static String _C__47_STOPMOVE = "[C] 47 CannotMoveAnymore";
	private Location _loc = new Location(0, 0, 0);

	/**
	 * packet type id 0x47
	 *
	 * sample
	 *
	 * 36
	 * a8 4f 02 00 // x
	 * 17 85 01 00 // y
	 * a7 00 00 00 // z
	 * 98 90 00 00 // heading?
	 *
	 * format:		cdddd
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_loc.setX(readD());
		_loc.setY(readD());
		_loc.setZ(readD());
		_loc.h = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();

		if(activeChar == null)
			return;

		activeChar.getAI().notifyEvent(CtrlEvent.EVT_ARRIVED_BLOCKED, _loc, null);
	}

	@Override
	public String getType()
	{
		return _C__47_STOPMOVE;
	}
}