package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.serverpackets.StopMoveToLocationInVehicle;
import l2r.util.Location;

// format: cddddd
public class CannotMoveAnymoreInVehicle extends L2GameClientPacket
{
	private static String _C__76_CANTMOVEANYMOREVEHICLE = "[C] 76 CanNotMoveAnymore(Vehicle)";
	private Location _loc = new Location(0, 0, 0);
	private int _boatid;

	/**
	 * @param buf
	 * @param client
	 */
	@Override
	public void readImpl()
	{
		_boatid = readD();
		_loc.setX(readD());
		_loc.setY(readD());
		_loc.setZ(readD());
		_loc.h = readD();

	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		if(activeChar.isInBoat())
			if(activeChar.getBoat().getObjectId() == _boatid)
			{
				activeChar.setInBoatPosition(_loc);
				activeChar.setHeading(_loc.h);
				StopMoveToLocationInVehicle msg = new StopMoveToLocationInVehicle(activeChar, _boatid);
				activeChar.broadcastPacket(msg);
			}
	}

	@Override
	public String getType()
	{
		return _C__76_CANTMOVEANYMOREVEHICLE;
	}
}