package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;

/**
 * This class ...
 *
 * @version $Revision: 1.1.4.3 $ $Date: 2005/03/27 15:29:30 $
 */
public class ChangeMoveType2 extends L2GameClientPacket
{
	private static String _C__1C_CHANGEMOVETYPE2 = "[C] 1C ChangeMoveType2";

	private boolean _typeRun;

	/**
	 * packet type id 0x1c
	 *
	 * sample
	 *
	 * 1d
	 * 01 00 00 00 // type (0 = walk, 1 = run)
	 *
	 * format:		cd
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_typeRun = readD() == 1;
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		if(_typeRun)
			activeChar.setRunning();
		else
			activeChar.setWalking();
	}

	/* (non-Javadoc)
	 * @see l2r.gameserver.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__1C_CHANGEMOVETYPE2;
	}
}
