package l2r.gameserver.clientpackets;

import l2r.Config;
import l2r.gameserver.model.L2Player;

import java.util.logging.Logger;

/**
 * @author Dezmond_snz
 * Format: cddd
 */
public class DlgAnswer extends L2GameClientPacket
{
	private static String _C__C5_DLGANSWER = "[C] C5 DlgAnswer";
	static Logger _log = Logger.getLogger(DlgAnswer.class.getName());

	private int _messageId;
	private int _answer;
	private int _requestId;

	@Override
	public void readImpl()
	{
		_messageId = readD();
		_answer = readD();
		_requestId = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		if(Config.DEBUG)
			_log.fine(getType() + ": Answer acepted. Message ID " + _messageId + ", asnwer " + _answer + ", request Id " + _requestId);

		switch(_requestId)
		{
			case 1:
				activeChar.summonCharacterAnswer(_answer);
				break;
			case 2:
				activeChar.reviveAnswer(_answer);
				break;
			case 3:
				activeChar.scriptAnswer(_answer);
				break;
			case 4:
				if(Config.ALLOW_WEDDING && activeChar.isEngageRequest())
					activeChar.engageAnswer(_answer);
				break;
		}
	}

	@Override
	public String getType()
	{
		return _C__C5_DLGANSWER;
	}
}
