package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.serverpackets.FinishRotation;

public class FinishRotating extends L2GameClientPacket
{
	private static String _C__4B_FINISHROTATING = "[C] 4B FinishRotating";

	private int _degree;
	@SuppressWarnings("unused")
	private int _unknown;

	/**
	 * packet type id 0x5c
	 *
	 * sample
	 *
	 * 5c
	 * d // unknown
	 * d // unknown
	 *
	 * format:		cdd
	 */
	@Override
	public void readImpl()
	{
		_degree = readD();
		_unknown = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		activeChar.broadcastPacket(new FinishRotation(activeChar, _degree));
	}

	@Override
	public String getType()
	{
		return _C__4B_FINISHROTATING;
	}
}