package l2r.gameserver.clientpackets;

import java.util.logging.Logger;

import l2r.Config;
import l2r.Config.L2WalkerAllowed;
import l2r.gameserver.geodata.network.GeoConfig;
import l2r.gameserver.loginservercon.LSConnection;
import l2r.gameserver.loginservercon.gspackets.ChangeAccessLevel;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.network.L2GameClient;
import l2r.util.Location;
import l2r.util.Log;

// cdddddd(d)
public class MoveBackwardToLocation extends L2GameClientPacket
{
	private static Logger _log = Logger.getLogger(MoveBackwardToLocation.class.getName());
	private static String _C__01_MOVEBACKWARDTOLOC = "[C] 01 MoveBackwardToLoc";
	private Location _targetLoc = new Location(0, 0, 0);
	private Location _originLoc = new Location(0, 0, 0);
	private int _moveMovement;

	/**
	 * packet type id 0x0f
	 */
	@Override
	public void readImpl()
	{
		_targetLoc.setX(readD());
		_targetLoc.setY(readD());
		_targetLoc.setZ(readD());
		_originLoc.setX(readD());
		_originLoc.setY(readD());
		_originLoc.setZ(readD());
		L2GameClient client = getClient();
		L2Player activeChar = client.getActiveChar();
		if(activeChar == null)
			return;

		if(_buf.hasRemaining())
			_moveMovement = readD();
		else if(Config.allowL2Walker(activeChar))
		{
			activeChar.setIsBot(2);
			_moveMovement = 1;
			if(Config.ALLOW_L2WALKER_CLIENT == L2WalkerAllowed.Peace)
				activeChar.startBotCheck();
		}
		else
		{
			_log.warning("Incompatible client found: L2Walker? " + client.getLoginName() + "/" + client.getIpAddr());

			if(Config.L2WALKER_PUNISHMENT != 0)
			{
				Log.LogChar(activeChar, Log.L2WalkerFound, client.getLoginName());
				if(Config.L2WALKER_PUNISHMENT == 2)
				{
					LSConnection.getInstance().sendPacket(new ChangeAccessLevel(client.getLoginName(), -66, "Walker Autoban", -1));
					activeChar.setAccessLevel(-66);
				}
				activeChar.logout(false, false, true);
			}
		}
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();

		if(activeChar == null)
			return;

		/*if(_targetLoc.x == 0 || _targetLoc.y == 0 || _targetLoc.x == Integer.MAX_VALUE || _targetLoc.y == Integer.MAX_VALUE)
		{
			System.out.println("MoveBackwardToLocation: zero coords");
			return;
		}*/

		if(System.currentTimeMillis() - activeChar.getLastPacket() < 100)
		{
			activeChar.sendActionFailed();
			return;
		}

		activeChar.setLastPacket();

		/*if(Math.abs(_originLoc.z) > 0xFFFF || Math.abs(_targetLoc.y) > 0x40000)
		{
			System.out.println("MTL: too big range: " + _originLoc.toString() + " -> " + _targetLoc.toString());
			System.out.println("     " + activeChar.getName() + " server position: " + activeChar.getLoc().toString());
			return;
		}*/

		if(activeChar.inObserverMode() && activeChar.getOlympiadGameId() == -1)
		{
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isOutOfControl() && activeChar.getOlympiadGameId() == -1)
		{
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isInBoat())
			activeChar.setInBoat(false);

		if(activeChar.getTeleMode() > 0)
		{
			if(activeChar.getTeleMode() == 1)
				activeChar.setTeleMode(0);
			activeChar.sendActionFailed();
			activeChar.teleToLocation(_targetLoc);
			return;
		}

		if(_moveMovement == 0 && GeoConfig.GEODATA_MODE == 0)
		{
			activeChar.sendActionFailed();
			return;
		}

		activeChar.moveToLocation(_targetLoc, 0, (_moveMovement != 0));
	}

	@Override
	public String getType()
	{
		return _C__01_MOVEBACKWARDTOLOC;
	}
}