package l2r.gameserver.clientpackets;

import java.util.logging.Logger;

import l2r.Config;
import l2r.gameserver.cache.CrestCache;
import l2r.gameserver.serverpackets.AllianceCrest;

public class RequestAllyCrest extends L2GameClientPacket
{
	private static String _C__88_REQUESTALLYCREST = "[C] 88 RequestAllyCrest";
	// format: cd
	private static Logger _log = Logger.getLogger(RequestAllyCrest.class.getName());

	private int _crestId;

	@Override
	public void readImpl()
	{
		_crestId = readD();
	}

	@Override
	public void runImpl()
	{
		if(_crestId == 0)
			return;
		if(Config.DEBUG)
			_log.fine("allycrestid " + _crestId + " requested");
		byte[] data = CrestCache.getAllyCrest(_crestId);
		if(data != null)
		{
			AllianceCrest ac = new AllianceCrest(_crestId, data);
			sendPacket(ac);
		}
		else if(Config.DEBUG)
			_log.fine("allycrest is missing:" + _crestId);
	}

	@Override
	public String getType()
	{
		return _C__88_REQUESTALLYCREST;
	}
}