package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Alliance;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2Player.TransactionType;
import l2r.gameserver.serverpackets.SystemMessage;

/**
 *  sample
 *  5F
 *  01 00 00 00
 *
 *  format  cdd
 *
 *
 * @version $Revision: 1.7.4.2 $ $Date: 2005/03/27 15:29:30 $
 */
public class RequestAnswerJoinAlly extends L2GameClientPacket
{
	private static String _C__83_REQUESTANSWERJOINALLY = "[C] 83 RequestAnswerJoinAlly";
	// format: cd
	//private static Logger _log = Logger.getLogger(RequestAnswerJoinAlly.class.getName());

	private int _response;

	@Override
	public void readImpl()
	{
		if(_buf.hasRemaining())
			_response = readD();
		else
			_response = 0;
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar != null)
		{
			L2Player requestor = activeChar.getTransactionRequester();

			activeChar.setTransactionRequester(null);

			if(requestor == null)
				return;

			requestor.setTransactionRequester(null);

			if(requestor.getAlliance() == null)
				return;

			if(activeChar.getTransactionType() != TransactionType.ALLY || activeChar.getTransactionType() != requestor.getTransactionType())
				return;

			if(_response == 1)
			{
				L2Alliance ally = requestor.getAlliance();
				activeChar.sendPacket(new SystemMessage(SystemMessage.YOU_HAVE_ACCEPTED_THE_ALLIANCE));
				activeChar.getClan().setAllyId(requestor.getAllyId());
				activeChar.getClan().updateClanInDB();
				activeChar.getClan().broadcastClanStatus();
				ally.addAllyMember(activeChar.getClan(), true);
			}
			else
				requestor.sendPacket(new SystemMessage(SystemMessage.YOU_HAVE_FAILED_TO_INVITE_A_CLAN_INTO_THE_ALLIANCE));
		}
	}

	/* (non-Javadoc)
	 * @see l2r.gameserver.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__83_REQUESTANSWERJOINALLY;
	}
}
