package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2Player.TransactionType;
import l2r.gameserver.serverpackets.JoinParty;
import l2r.gameserver.serverpackets.PartyMemberPosition;
import l2r.gameserver.serverpackets.SystemMessage;

/**
 *  sample
 *  2a
 *  01 00 00 00
 *
 *  format  cdd
 *
 *
 * @version $Revision: 1.7.4.2 $ $Date: 2005/03/27 15:29:30 $
 */
public class RequestAnswerJoinParty extends L2GameClientPacket
{
	private static String _C__2A_REQUESTANSWERPARTY = "[C] 2A RequestAnswerJoinParty";
	//Format: cd
	//private static Logger _log = Logger.getLogger(RequestAnswerJoinParty.class.getName());

	private int _response;

	@Override
	public void readImpl()
	{
		if(_buf.hasRemaining())
			_response = readD();
		else
			_response = 0;
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		L2Player requestor = activeChar.getTransactionRequester();

		activeChar.setTransactionRequester(null);

		if(requestor == null)
			return;

		requestor.setTransactionRequester(null);

		if(requestor.getParty() == null)
			return;

		if(activeChar.getTransactionType() != TransactionType.PARTY || activeChar.getTransactionType() != requestor.getTransactionType())
			return;

		requestor.sendPacket(new JoinParty(_response));

		if(_response == 1)
		{
			if(requestor.getParty().getMemberCount() >= 9)
			{
				activeChar.sendPacket(new SystemMessage(SystemMessage.PARTY_IS_FULL));
				requestor.sendPacket(new SystemMessage(SystemMessage.PARTY_IS_FULL));
				return;
			}

			activeChar.joinParty(requestor.getParty());
			// force update party position
			activeChar.getParty().broadcastToPartyMembers(activeChar, new PartyMemberPosition(activeChar));
		}
		else
		{
			requestor.sendPacket(new SystemMessage(SystemMessage.THE_PLAYER_DECLINED_TO_JOIN_YOUR_PARTY));
			//activate garbage collection if there are no other members in party (happens when we were creating new one)
			if(requestor.getParty() != null && requestor.getParty().getMemberCount() == 1)
				requestor.setParty(null);
		}
	}

	@Override
	public String getType()
	{
		return _C__2A_REQUESTANSWERPARTY;
	}
}
