package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2Summon;
import l2r.gameserver.model.instances.L2ItemInstance;
import l2r.gameserver.model.instances.L2PetInstance;
import l2r.gameserver.serverpackets.SystemMessage;

public class RequestChangePetName extends L2GameClientPacket
{
	private static String REQUESTCHANGEPETNAME__C__89 = "[C] 89 RequestChangePetName";
	// format: cS
	//private static Logger _log = Logger.getLogger(RequestChangePetName.class.getName());

	private String _name;

	@Override
	public void readImpl()
	{
		_name = readS();
	}

	@Override
	public void runImpl()
	{
		L2Player cha = getClient().getActiveChar();
		L2Summon pet = cha.getPet();
		if(pet != null && pet.getName() == null)
		{
			if(_name.length() > 8)
			{
				sendPacket(new SystemMessage(SystemMessage.YOUR_PETS_NAME_CAN_BE_UP_TO_8_CHARACTERS));
				return;
			}
			pet.setName(_name);
			pet.broadcastPetInfo();

			if(pet instanceof L2PetInstance)
			{
				L2PetInstance _pet = (L2PetInstance) pet;
				L2ItemInstance controlItem = _pet.getControlItem();
				if(controlItem != null)
				{
					controlItem.setCustomType2(1);
					controlItem.setPriceToSell(0); // Костыль, иначе CustomType2 = 1 не пишется в базу
					controlItem.updateDatabase();
					_pet.InventoryUpdateControlItem();
				}
			}

		}
	}

	@Override
	public String getType()
	{
		return REQUESTCHANGEPETNAME__C__89;
	}
}
