package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2ItemInstance;
import l2r.gameserver.serverpackets.ExConfirmCancelItem;
import l2r.gameserver.serverpackets.SystemMessage;
import l2r.gameserver.templates.L2Item;

public class RequestConfirmCancelItem extends L2GameClientPacket
{
	private static final String _C__D0_20_REQUESTCONFIRMCANCELITEM = "[C] D0:20 RequestConfirmCancelItem";
	// format: (ch)d
	int _itemId;

	@Override
	public void readImpl()
	{
		_itemId = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		L2ItemInstance item = activeChar.getInventory().getItemByObjectId(_itemId);

		if(item == null)
		{
			activeChar.sendActionFailed();
			return;
		}

		if(!item.isAugmented())
		{
			activeChar.sendPacket(new SystemMessage(SystemMessage.AUGMENTATION_REMOVAL_CAN_ONLY_BE_DONE_ON_AN_AUGMENTED_ITEM));
			return;
		}

		int price = 0;
		switch(item.getItem().getItemGrade())
		{
			case L2Item.CRYSTAL_C:
				switch(item.getItem().getCrystalCount())
				{
					case 784:
					case 848:
					case 916:
					case 988:
					case 1148:
					case 1336:
						price = 95000;
						break;
					case 1528:
					case 1720:
					case 1912:
						price = 150000;
						break;
					case 2112:
					case 2452:
						price = 210000;
						break;
				}
				break;
			case L2Item.CRYSTAL_B:
				switch(item.getItem().getCrystalCount())
				{
					case 930:
					case 1044:
					case 1157:
					case 1273:
					case 1506:
						price = 240000;
						break;
					case 1746:
						price = 270000;
						break;
				}
				break;
			case L2Item.CRYSTAL_A:
				switch(item.getItem().getCrystalCount())
				{
					case 1464:
						price = 330000;
						break;
					case 1928:
						price = 390000;
						break;
					case 2160:
						price = 420000;
						break;
				}
				break;
			case L2Item.CRYSTAL_S:
				price = 480000;
				break;
			// any other item type is not augmentable
			default:
				return;
		}

		activeChar.sendPacket(new ExConfirmCancelItem(_itemId, price));
	}

	@Override
	public String getType()
	{
		return _C__D0_20_REQUESTCONFIRMCANCELITEM;
	}
}