package l2r.gameserver.clientpackets;

import l2r.gameserver.instancemanager.CastleManager;
import l2r.gameserver.model.L2Clan;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.entity.siege.SiegeUnit;
import l2r.gameserver.serverpackets.CastleSiegeDefenderList;
import l2r.gameserver.tables.ClanTable;

public class RequestConfirmSiegeWaitingList extends L2GameClientPacket
{
	private static String _C__A5_RequestConfirmSiegeWaitingList = "[C] A5 RequestConfirmSiegeWaitingList";
	// format: cddd
	//private static Logger _log = Logger.getLogger(RequestConfirmSiegeWaitingList.class.getName());

	private int _Approved;
	private int _CastleId;
	private int _ClanId;

	@Override
	public void readImpl()
	{
		_CastleId = readD();
		_ClanId = readD();
		_Approved = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		// Check if the player has a clan
		if(activeChar.getClan() == null)
			return;

		SiegeUnit castle = CastleManager.getInstance().getCastleByIndex(_CastleId);
		if(castle == null)
			return;

		// Check if leader of the clan who owns the castle?
		if(castle.getOwnerId() != activeChar.getClanId() || !activeChar.isClanLeader())
			return;

		L2Clan clan = ClanTable.getInstance().getClan(_ClanId);
		if(clan == null)
			return;

		if(!castle.getSiege().isRegistrationOver())
			if(_Approved == 1)
				if(castle.getSiege().checkIsDefenderWaiting(clan))
					castle.getSiege().approveSiegeDefenderClan(_ClanId);
				else
					return;
			else if(castle.getSiege().checkIsDefenderWaiting(clan) || castle.getSiege().checkIsDefender(clan))
				castle.getSiege().getDatabase().removeSiegeClan(_ClanId);

		//Update the defender list
		activeChar.sendPacket(new CastleSiegeDefenderList(castle));

	}

	@Override
	public String getType()
	{
		return _C__A5_RequestConfirmSiegeWaitingList;
	}
}
