package l2r.gameserver.clientpackets;

import java.util.List;

import javolution.util.FastList;
import l2r.gameserver.instancemanager.CursedWeaponsManager;
import l2r.gameserver.model.CursedWeapon;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.serverpackets.ExCursedWeaponLocation;
import l2r.gameserver.serverpackets.ExCursedWeaponLocation.CursedWeaponInfo;
import l2r.util.Location;

/**
 * Format: (ch)
 * @author  -Wooden-
 */
public class RequestCursedWeaponLocation extends L2GameClientPacket
{
	private static String _C__D0_2B_REQUESTCURSEDWEAPONLOCATION = "[C] D0:2B RequestCursedWeaponLocation";

	@Override
	public void readImpl()
	{}

	@Override
	public void runImpl()
	{
		L2Character activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		List<CursedWeaponInfo> list = new FastList<CursedWeaponInfo>();
		for(CursedWeapon cw : CursedWeaponsManager.getInstance().getCursedWeapons())
		{
			Location pos = cw.getWorldPosition();
			if(pos != null)
				list.add(new CursedWeaponInfo(pos, cw.getItemId(), cw.isActivated() ? 1 : 0));
		}

		//send the ExCursedWeaponLocation
		activeChar.sendPacket(new ExCursedWeaponLocation(list));
	}

	@Override
	public String getType()
	{
		return _C__D0_2B_REQUESTCURSEDWEAPONLOCATION;
	}
}