package l2r.gameserver.clientpackets;

import java.nio.ByteBuffer;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.entity.Duel;
import l2r.gameserver.network.L2GameClient;

public class RequestDuelSurrender extends L2GameClientPacket
{
	public RequestDuelSurrender(ByteBuffer buf, L2GameClient client)
	{
		_buf = buf;
		_client = client;
	}

	@Override
	public void readImpl()
	{}

	@Override
	public void runImpl()
	{
		L2Player p = getClient().getActiveChar();

		if(p == null)
			return;

		Duel d = p.getDuel();

		if(d == null)
			return;

		d.doSurrender(p);
	}

	/**
	 * just for information and debug purposes
	 * @return text for trace message
	 */
	@Override
	public String getType()
	{
		return "[C] D0:48 RequestDuelSurrender";
	}
}