package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2Player.TransactionType;
import l2r.gameserver.serverpackets.SystemMessage;

public class RequestExMPCCAcceptJoin extends L2GameClientPacket
{
	private static String _C__D0_07_REQUESTEXMPCCACCEPTJOIN = "[C] D0:07 RequestExMPCCAcceptJoin";
	private int _response;

	/**
	 * @param buf
	 * @param client
	 * format: chdd
	 */
	@Override
	public void readImpl()
	{
		if(_buf.hasRemaining())
			_response = readD();
		else
			_response = 0;
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		L2Player requestor = activeChar.getTransactionRequester();

		activeChar.setTransactionRequester(null);

		if(requestor == null)
			return;

		requestor.setTransactionRequester(null);

		if(activeChar.getTransactionType() != TransactionType.CHANNEL || activeChar.getTransactionType() != requestor.getTransactionType())
			return;

		if(!requestor.isInParty() || !activeChar.isInParty() || !requestor.getParty().isInCommandChannel() || activeChar.getParty().isInCommandChannel())
		{
			requestor.sendPacket(new SystemMessage(SystemMessage.NO_USER_HAS_BEEN_INVITED_TO_THE_COMMAND_CHANNEL));
			return;
		}

		if(_response == 1 && activeChar.isTeleporting())
		{
			activeChar.sendPacket(new SystemMessage(SystemMessage.YOU_CANNOT_JOIN_A_COMMAND_CHANNEL_WHILE_TELEPORTING));
			requestor.sendPacket(new SystemMessage(SystemMessage.NO_USER_HAS_BEEN_INVITED_TO_THE_COMMAND_CHANNEL));
			return;
		}

		if(_response == 1)
			requestor.getParty().getCommandChannel().addParty(activeChar.getParty());
		else
			requestor.sendPacket(new SystemMessage(SystemMessage.S1_HAS_DECLINED_THE_CHANNEL_INVITATION).addString(activeChar.getName()));
	}

	@Override
	public String getType()
	{
		return _C__D0_07_REQUESTEXMPCCACCEPTJOIN;
	}
}