package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2World;
import l2r.gameserver.serverpackets.ExMPCCShowPartyMemberInfo;

/**
 * Format: ch d
 * Пример пакета:
 * D0 2E 00 4D 90 00 10
 * @author SYS
 */
public class RequestExMPCCShowPartyMembersInfo extends L2GameClientPacket
{
	private static String _C__D0_2E_REQUESTEXMPCCSHOWPARTYMEMBERINFO = "[C] D0:2E RequestExMPCCShowPartyMembersInfo";
	private int _objectId;

	@Override
	public void readImpl()
	{
		_objectId = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();

		if(activeChar == null || !activeChar.isInParty() || !activeChar.getParty().isInCommandChannel())
			return;

		L2Player partyLeader = (L2Player) L2World.findObject(_objectId);
		if(partyLeader != null && partyLeader.getParty() != null)
			activeChar.sendPacket(new ExMPCCShowPartyMemberInfo(partyLeader));
	}

	@Override
	public String getType()
	{
		return _C__D0_2E_REQUESTEXMPCCSHOWPARTYMEMBERINFO;
	}
}