package l2r.gameserver.clientpackets;

import l2r.gameserver.instancemanager.BoatManager;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2BoatInstance;
import l2r.gameserver.serverpackets.GetOffVehicle;
import l2r.gameserver.serverpackets.VehicleInfo;

/**
 * @author Maktakien
 *
 */
public class RequestGetOffVehicle extends L2GameClientPacket
{
	private static String _C__54_GETOFFVEHICLE = "[C] 54 GetOffVehicle";
	// Format: cdddd
	private int _id, _x, _y, _z;

	@Override
	public void readImpl()
	{
		_id = readD();
		_x = readD();
		_y = readD();
		_z = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		L2BoatInstance boat = BoatManager.getInstance().GetBoat(_id);
		// Не даем слезть с лодки на ходу
		if(boat != null && boat.isMoving)
		{
			activeChar.sendActionFailed();
			return;
		}
		GetOffVehicle Gon = new GetOffVehicle(activeChar, boat, _x, _y, _z);
		activeChar.broadcastPacket(Gon);
		activeChar.sendPacket(new VehicleInfo(boat));
	}

	@Override
	public String getType()
	{
		return _C__54_GETOFFVEHICLE;
	}
}