package l2r.gameserver.clientpackets;

import l2r.gameserver.instancemanager.BoatManager;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2BoatInstance;
import l2r.gameserver.serverpackets.GetOnVehicle;
import l2r.util.Location;

public class RequestGetOnVehicle extends L2GameClientPacket
{
	private static String _C__53_GETONVEHICLE = "[C] 53 GetOnVehicle";

	private int _id, _x, _y, _z;

	/**
	 * packet type id 0x53
	 * format:      cdddd
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_id = readD();
		_x = readD();
		_y = readD();
		_z = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		L2BoatInstance boat = BoatManager.getInstance().GetBoat(_id);
		if(boat == null)
			return;
		GetOnVehicle Gon = new GetOnVehicle(activeChar, boat, _x, _y, _z);
		activeChar.setInBoatPosition(new Location(_x, _y, _z));
		activeChar.setXYZ(boat.getX(), boat.getY(), boat.getZ());
		activeChar.broadcastPacket(Gon);
	}

	@Override
	public String getType()
	{
		return _C__53_GETONVEHICLE;
	}
}