package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2HennaInstance;
import l2r.gameserver.serverpackets.HennaItemInfo;
import l2r.gameserver.tables.HennaTable;
import l2r.gameserver.templates.L2Henna;

public class RequestHennaItemInfo extends L2GameClientPacket
{
	private static String _C__C4_RequestHennaItemInfo = "[C] C4 RequestHennaItemInfo";
	// format  cd
	//private static Logger _log = Logger.getLogger(RequestHennaItemInfo.class.getName());
	private int SymbolId;

	@Override
	public void readImpl()
	{
		SymbolId = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		L2Henna template = HennaTable.getInstance().getTemplate(SymbolId);
		if(template != null)
			activeChar.sendPacket(new HennaItemInfo(new L2HennaInstance(template), activeChar));
	}

	/* (non-Javadoc)
	 * @see l2r.gameserver.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__C4_RequestHennaItemInfo;
	}
}
