package l2r.gameserver.clientpackets;

import l2r.extensions.multilang.CustomMessage;
import l2r.gameserver.instancemanager.CHSiegeManager;
import l2r.gameserver.instancemanager.CastleManager;
import l2r.gameserver.instancemanager.ClanHallManager;
import l2r.gameserver.instancemanager.FortressManager;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.entity.Castle;
import l2r.gameserver.model.entity.ClanHall;
import l2r.gameserver.model.entity.Fortress;
import l2r.gameserver.model.entity.siege.SiegeUnit;
import l2r.gameserver.serverpackets.CastleSiegeAttackerList;

public class RequestJoinSiege extends L2GameClientPacket
{
	private static String _C__AD_RequestJoinSiege = "[C] AD RequestJoinSiege";
	// format: cddd

	private int _id;
	private boolean _isAttacker;
	private boolean _isJoining;

	@Override
	public void readImpl()
	{
		_id = readD();
		_isAttacker = readD() == 1;
		_isJoining = readD() == 1;
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null || !activeChar.isClanLeader())
			return;

		SiegeUnit siegeUnit = CastleManager.getInstance().getCastleByIndex(_id);

		if(siegeUnit == null)
			siegeUnit = FortressManager.getInstance().getFortressByIndex(_id);

		ClanHall clanhall = ClanHallManager.getInstance().getClanHall(_id);

		if(siegeUnit != null)
		{
			if(_isJoining)
			{
				for(Castle temp : CastleManager.getInstance().getCastles().values())
					if(temp.getSiege().checkIsClanRegistered(activeChar.getClanId()))
					{
						activeChar.sendMessage(new CustomMessage("l2r.gameserver.clientpackets.RequestJoinSiege.AlreadyRegistered", activeChar).addString(temp.getName()));
						return;
					}

				for(Fortress temp : FortressManager.getInstance().getFortresses().values())
					if(temp.getSiege().checkIsClanRegistered(activeChar.getClanId()))
					{
						activeChar.sendMessage(new CustomMessage("l2r.gameserver.clientpackets.RequestJoinSiege.AlreadyRegistered", activeChar).addString(temp.getName()));
						return;
					}

				if(_isAttacker)
					siegeUnit.getSiege().registerAttacker(activeChar);
				else
					siegeUnit.getSiege().registerDefender(activeChar);
			}
			else
				siegeUnit.getSiege().removeSiegeClan(activeChar);

			siegeUnit.getSiege().listRegisterClan(activeChar);
		}
		else
		{
			if(_isJoining)
			{
				if(_isAttacker)
					CHSiegeManager.getInstance().getSiege(clanhall.getId()).addAttacker(activeChar.getClan(), true);
			}
			else
				CHSiegeManager.getInstance().getSiege(clanhall.getId()).removeAttacker(activeChar.getClan());

			activeChar.sendPacket(new CastleSiegeAttackerList(clanhall));
		}
	}

	@Override
	public String getType()
	{
		return _C__AD_RequestJoinSiege;
	}
}