package l2r.gameserver.clientpackets;

import java.util.logging.Logger;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.serverpackets.NpcHtmlMessage;

/**
 * @author zabbix
 * Lets drink to code!
 */
public class RequestLinkHtml extends L2GameClientPacket
{
	private static Logger _log = Logger.getLogger(RequestLinkHtml.class.getName());
	private static String REQUESTLINKHTML__C__22 = "[C] 22 RequestLinkHtml";
	//Format: cS
	private String _link;

	@Override
	public void readImpl()
	{
		_link = readS();
	}

	@Override
	public void runImpl()
	{
		L2Player actor = getClient().getActiveChar();
		if(actor == null)
			return;


		if(_link.contains("..") || !_link.contains(".htm"))
		{
			_log.warning("[RequestLinkHtml] hack? link contains prohibited characters: '" + _link + "', skipped");
			return;
		}

		NpcHtmlMessage msg = new NpcHtmlMessage(0);
		msg.setFile(_link);

		sendPacket(msg);
	}

	@Override
	public String getType()
	{
		return REQUESTLINKHTML__C__22;
	}
}
