package l2r.gameserver.clientpackets;

import l2r.gameserver.instancemanager.BoatManager;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2BoatInstance;
import l2r.gameserver.serverpackets.SystemMessage;
import l2r.util.Location;

public class RequestMoveToLocationInVehicle extends L2GameClientPacket
{
	private Location _pos = new Location(0, 0, 0);
	private Location _originPos = new Location(0, 0, 0);
	private int _boatId;
	private static String _C__75_MOVETOLOCATIONINVEHICLE = "[C] 75 MoveToLocationInVehicle";

	/**
	 * @param buf
	 * @param client
	 * format: cddddddd
	 */
	@Override
	public void readImpl()
	{
		_boatId = readD(); //objectId of boat
		_pos.setX(readD());
		_pos.setY(readD());
		_pos.setZ(readD());
		_originPos.setX(readD());
		_originPos.setY(readD());
		_originPos.setZ(readD());
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		if(activeChar.getPet() != null)
		{
			activeChar.sendPacket(new SystemMessage(SystemMessage.BECAUSE_PET_OR_SERVITOR_MAY_BE_DROWNED_WHILE_THE_BOAT_MOVES_PLEASE_RELEASE_THE_SUMMON_BEFORE_DEPARTURE));
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isMovementDisabled())
		{
			activeChar.sendActionFailed();
			return;
		}

		if(!activeChar.isInBoat())
			activeChar.setInBoat(true);

		L2BoatInstance boat = BoatManager.getInstance().GetBoat(_boatId);
		activeChar.setBoat(boat);
		activeChar.setInBoatPosition(_pos);
		activeChar.moveToInABoat(_pos, _originPos);
	}

	@Override
	public String getType()
	{
		return _C__75_MOVETOLOCATIONINVEHICLE;
	}
}