package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.entity.Olympiad;
import l2r.gameserver.serverpackets.NpcHtmlMessage;

/**
 * format ch
 * c: (id) 0xD0
 * h: (subid) 0x2F
 */
public class RequestOlympiadMatchList extends L2GameClientPacket
{
	private static String _C__D0_2F_REQUESTOLYMPIADMATCHLIST = "[C] D0:2F RequestOlympiadMatchList";

	@Override
	public void readImpl()
	{}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();

		if(!activeChar.inObserverMode())
			return;

		String[] matches = Olympiad.getInstance().getAllTitles();

		NpcHtmlMessage reply = new NpcHtmlMessage(0);
		StringBuffer replyMSG = new StringBuffer("<html><body>");
		replyMSG.append("<center><br>Grand Olympiad Game View");
		replyMSG.append("<table width=270 border=0 bgcolor=\"000000\">");
		replyMSG.append("<tr><td fixwidth=30>NO.</td><td>Status &nbsp; &nbsp; Player1 / Player2</td></tr>");

		for(int i = 0; i < matches.length; i++)
			replyMSG.append("<tr><td fixwidth=30><a action=\"bypass -h npc_0_Olympiad 3_" + i + "\">" + i + "</a></td><td>" + matches[i] + "</td></tr>");

		replyMSG.append("</table></center></body></html>");

		reply.setHtml(replyMSG.toString());
		activeChar.sendPacket(reply);
	}

	@Override
	public String getType()
	{
		return _C__D0_2F_REQUESTOLYMPIADMATCHLIST;
	}
}