package l2r.gameserver.clientpackets;

import l2r.Config;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.serverpackets.PackageSendableList;

/**
 * Format: cd
 *
 * Пример пакета с оффа:
 * 9E D0 33 08 00
 *
 * @author SYS
 */
public class RequestPackageSendableItemList extends L2GameClientPacket
{
	private static String _C__A7_REQUESTPACKAGESENDABLEITEMLIST = "[C] A7 RequestPackageSendableItemList";
	private int _characterObjectId;

	@Override
	public void readImpl()
	{
		_characterObjectId = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null || !activeChar.getPlayerAccess().UseWarehouse)
			return;

		activeChar.tempInvetoryDisable();

		if(Config.DEBUG)
			_log.fine("Showing items to freight");

		activeChar.sendPacket(new PackageSendableList(activeChar, _characterObjectId));
	}

	@Override
	public String getType()
	{
		return _C__A7_REQUESTPACKAGESENDABLEITEMLIST;
	}
}
