package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;

/**
 * This class ...
 *
 * @version $Revision: 1.1.4.2 $ $Date: 2005/03/27 15:29:30 $
 */

public class RequestPartyMatchConfig extends L2GameClientPacket
{
	private static String _C__6F_REQUESTPARTYMATCHCONFIG = "[C] 6F RequestPartyMatchConfig";
	//private static Logger _log = Logger.getLogger(RequestPartyMatchConfig.class.getName());

	private int _automaticRegistration;
	private int _showLevel;
	private int _showClass;
	private String _memo;

	/**
	 * packet type id 0x6f
	 *
	 * sample
	 *
	 * 6f
	 * 01 00 00 00
	 * 00 00 00 00
	 * 00 00 00 00
	 * 00 00
	 *
	 * format:		cdddS
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_automaticRegistration = readD();
		_showLevel = readD();
		_showClass = readD();

		/*
		 *  TODO: Check if this this part of the packet has been
		 *  removed by latest versions.
		 *
		 try
		 {
		 _memo                 = readS();
		 }
		 catch (BufferUnderflowException e)
		 {
		 _memo                 = "";
		 _log.warning("Memo field non existant in packet. Notify devs.");
		 e.printStackTrace();
		 }*/
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		activeChar.setPartyMatchingAutomaticRegistration(_automaticRegistration == 1);
		activeChar.setPartyMatchingShowLevel(_showLevel == 1);
		activeChar.setPartyMatchingShowClass(_showClass == 1);
		activeChar.setPartyMatchingMemo(_memo);
	}

	/* (non-Javadoc)
	 * @see l2r.gameserver.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__6F_REQUESTPARTYMATCHCONFIG;
	}
}
