package l2r.gameserver.clientpackets;

import java.util.logging.Logger;

import l2r.Config;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.serverpackets.ListPartyWaiting;

/**
 * This class ...
 *
 * @version $Revision: 1.1.4.4 $ $Date: 2005/03/27 15:29:30 $
 */

public class RequestPartyMatchList extends L2GameClientPacket
{
	private static String _C__70_REQUESTPARTYMATCHLIST = "[C] 70 RequestPartyMatchList";
	private static Logger _log = Logger.getLogger(RequestPartyMatchList.class.getName());

	private int _status;

	/**
	 * packet type id 0x70
	 *
	 * sample
	 *
	 * 70
	 * 01 00 00 00
	 *
	 * format:		cd
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_status = readD();
		/*_maxMembers = */readD();
		/*_minLevel = */readD();
		/*_maxLevel = */readD();
		/*_lootDist = */readD();
		/*_roomTitle = */readS();
	}

	@Override
	public void runImpl()
	{
		if(_status == 1)
		{
			// window is open fill the list
			// actually the client should get automatic updates for the list
			// for now we only fill it once
			//Collection<L2Player> players = L2World.getAllPlayers();
			//L2Player[] allPlayers = players.toArray(new L2Player[players.size()]);
			L2Player[] empty = new L2Player[] {};
			ListPartyWaiting matchList = new ListPartyWaiting(empty);

			//sendPacket(new PartyMatchList(allPlayers));
			sendPacket(matchList);
		}
		else if(_status == 3)
		{
			// client does not need any more updates
			if(Config.DEBUG)
				_log.fine("PartyMatch window was closed.");
		}
		else if(Config.DEBUG)
			_log.fine("party match status: " + _status);
	}

	/* (non-Javadoc)
	 * @see l2r.gameserver.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__70_REQUESTPARTYMATCHLIST;
	}
}
