package l2r.gameserver.clientpackets;

import l2r.gameserver.ai.CtrlIntention;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2World;
import l2r.gameserver.model.instances.L2ItemInstance;
import l2r.gameserver.model.instances.L2PetInstance;

public class RequestPetGetItem extends L2GameClientPacket
{
	//private static Logger _log = Logger.getLogger(RequestPetGetItem.class.getName());
	private static String _C__98_REQUESTPETGETITEM = "[C] 98 RequestPetGetItem";
	// format: cd
	private int _objectId;

	@Override
	public void readImpl()
	{
		_objectId = readD();
	}

	@Override
	public void runImpl()
	{
		L2ItemInstance item = (L2ItemInstance) L2World.findObject(_objectId);
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar.getPet() instanceof L2PetInstance)
		{
			L2PetInstance pet = (L2PetInstance) activeChar.getPet();
			if(pet == null || pet.isDead() || pet.isOutOfControl())
			{
				activeChar.sendActionFailed();
				return;
			}
			pet.getAI().setIntention(CtrlIntention.AI_INTENTION_PICK_UP, item, null);
		}
		else
		{
			activeChar.sendActionFailed();
			return;
		}
	}

	@Override
	public String getType()
	{
		return _C__98_REQUESTPETGETITEM;
	}

}
