package l2r.gameserver.clientpackets;

import java.util.logging.Logger;

import l2r.Config;
import l2r.gameserver.cache.CrestCache;
import l2r.gameserver.serverpackets.PledgeCrest;

public class RequestPledgeCrest extends L2GameClientPacket
{
	private static Logger _log = Logger.getLogger(RequestPledgeCrest.class.getName());
	private static String _C__67_REQUESTPLEDGECREST = "[C] 67 RequestPledgeCrest";
	// format: cd

	private int _crestId;

	@Override
	public void readImpl()
	{
		_crestId = readD();
	}

	@Override
	public void runImpl()
	{
		if(_crestId == 0)
			return;
		if(Config.DEBUG)
			_log.fine("crestid " + _crestId + " requested");
		byte[] data = CrestCache.getPledgeCrest(_crestId);
		if(data != null)
		{
			PledgeCrest pc = new PledgeCrest(_crestId, data);
			sendPacket(pc);
		}
		else if(Config.DEBUG)
			_log.fine("crest is missing:" + _crestId);
	}

	@Override
	public String getType()
	{
		return _C__67_REQUESTPLEDGECREST;
	}
}