package l2r.gameserver.clientpackets;

import java.util.logging.Logger;

import l2r.Config;
import l2r.gameserver.cache.CrestCache;
import l2r.gameserver.serverpackets.ExPledgeCrestLarge;

public class RequestPledgeCrestLarge extends L2GameClientPacket
{
	private static Logger _log = Logger.getLogger(RequestPledgeCrestLarge.class.getName());
	// format: chd
	private static String _C__D0_10_REQUESTPLEDGECRESTLARGE = "[C] D0:10 RequestPledgeCrestLarge";
	private int _crestId;

	@Override
	public void readImpl()
	{
		_crestId = readD();
	}

	@Override
	public void runImpl()
	{
		if(_crestId == 0)
			return;
		if(Config.DEBUG)
			_log.fine("largecrestid " + _crestId + " requested");
		byte[] data = CrestCache.getPledgeCrestLarge(_crestId);
		if(data != null)
		{
			ExPledgeCrestLarge pcl = new ExPledgeCrestLarge(_crestId, data);
			sendPacket(pcl);
		}
		else if(Config.DEBUG)
			_log.fine("largecrest file is missing:" + _crestId);
	}

	@Override
	public String getType()
	{
		return _C__D0_10_REQUESTPLEDGECRESTLARGE;
	}
}
