package l2r.gameserver.clientpackets;

import java.util.logging.Logger;

import l2r.gameserver.model.L2Clan;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.serverpackets.PledgeInfo;
import l2r.gameserver.tables.ClanTable;

/**
 * This class ...
 *
 * @version $Revision: 1.5.4.3 $ $Date: 2005/03/27 15:29:30 $
 */
public class RequestPledgeInfo extends L2GameClientPacket
{
	private static String _C__65_REQUESTPLEDGEINFO = "[C] 65 RequestPledgeInfo";
	private static Logger _log = Logger.getLogger(RequestPledgeInfo.class.getName());

	private int _clanId;

	/**
	 * packet type id 0x65
	 * format:		cd
	 * @param rawPacket
	 */
	@Override
	public void readImpl()
	{
		_clanId = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		// незнаю откуда именно 114...125, но факт остается. Возможно читеры...
		// задействовано как затычка
		if(_clanId > 113 && _clanId < 126)
			return;
		L2Clan clan = ClanTable.getInstance().getClan(_clanId);
		if(clan == null)
		{
			_log.warning("Clan data for clanId " + _clanId + " is missing");
			_log.warning("Host " + getClient().getIpAddr() + " possibly sends fake packets");
			return; // we have no clan data ?!? should not happen
		}

		activeChar.sendPacket(new PledgeInfo(clan));

	}

	/*
	 * (non-Javadoc)
	 *
	 * @see l2r.gameserver.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__65_REQUESTPLEDGEINFO;
	}
}
