package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2TradeList;
import l2r.gameserver.model.L2Zone;
import l2r.gameserver.model.TradeItem;
import l2r.gameserver.serverpackets.PrivateStoreManageListBuy;
import l2r.gameserver.serverpackets.SystemMessage;

import java.util.HashSet;
import java.util.concurrent.ConcurrentLinkedQueue;

public class RequestPrivateStoreBuyManage extends L2GameClientPacket
{
	private static String _C__90_REQUESTPRIVATESTOREBUYMANAGE = "[C] 90 RequestPrivateStoreBuyManage";

	//private static Logger _log = Logger.getLogger(RequestPrivateStoreBuyManage.class.getName());

	@Override
	public void readImpl()
	{}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		if(!activeChar.getPlayerAccess().UseTrade)
		{
			activeChar.sendPacket(new SystemMessage(SystemMessage.THIS_ACCOUNT_CANOT_USE_PRIVATE_STORES));
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isAlikeDead())
		{
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isActionBlocked(L2Zone.BLOCKED_ACTION_PRIVATE_STORE))
		{
			sendPacket(new SystemMessage(SystemMessage.A_PRIVATE_STORE_MAY_NOT_BE_OPENED_IN_THIS_AREA));
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isCastingNow())
		{
			sendPacket(new SystemMessage(SystemMessage.A_PRIVATE_STORE_MAY_NOT_BE_OPENED_WHILE_USING_A_SKILL));
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isInCombat())
		{
			activeChar.sendPacket(new SystemMessage(SystemMessage.WHILE_YOU_ARE_ENGAGED_IN_COMBAT_YOU_CANNOT_OPERATE_A_PRIVATE_STORE_OR_PRIVATE_WORKSHOP));
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isInOlympiadMode() || activeChar.getMountType() != 0)
		{
			activeChar.sendActionFailed();
			return;
		}

		switch(activeChar.getPrivateStoreType())
		{
			case L2Player.STORE_PRIVATE_NONE:
			{
				if(activeChar.isSitting())
				{
					activeChar.setPrivateStoreType(L2Player.STORE_PRIVATE_NONE);
					activeChar.standUp();
				}

				if(activeChar.getTradeList() == null)
					activeChar.setTradeList(new L2TradeList(0));

				if(activeChar.getBuyList() == null)
					activeChar.setBuyList(new ConcurrentLinkedQueue<TradeItem>());
				activeChar.getTradeList().updateBuyList(activeChar, activeChar.getBuyList());
				activeChar.setPrivateStoreType(L2Player.STORE_PRIVATE_NONE);
				activeChar.sendPacket(new PrivateStoreManageListBuy(getClient().getActiveChar()));
				break;
			}
			case L2Player.STORE_PRIVATE_BUY:
			{
				activeChar.setPrivateStoreType(L2Player.STORE_PRIVATE_BUY);
				activeChar.standUp();
				activeChar.sendPacket(new PrivateStoreManageListBuy(getClient().getActiveChar()));
				break;
			}
		}
	}

	@Override
	public String getType()
	{
		return _C__90_REQUESTPRIVATESTOREBUYMANAGE;
	}
}
