package l2r.gameserver.clientpackets;

import l2r.gameserver.instancemanager.QuestManager;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.quest.QuestState;
import l2r.gameserver.serverpackets.SystemMessage;

public class RequestQuestAbort extends L2GameClientPacket
{
	private static String _C__63_REQUESTQUESTABORT = "[C] 63 RequestQuestAbort";
	//private static Logger _log = Logger.getLogger(RequestQuestAbort.class.getName());

	private int _QuestID;

	/**
	 * packet type id 0x63
	 * format: cd
	 */
	@Override
	public void readImpl()
	{
		_QuestID = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null || QuestManager.getQuest(_QuestID) == null)
			return;
		QuestState qs = activeChar.getQuestState(QuestManager.getQuest(_QuestID).getName());
		if(qs != null)
		{
			qs.exitCurrentQuest(true);
			activeChar.sendPacket(new SystemMessage(SystemMessage.S1_IS_ABORTED).addString(QuestManager.getQuest(_QuestID).getDescr()));
		}
	}

	@Override
	public String getType()
	{
		return _C__63_REQUESTQUESTABORT;
	}
}