package l2r.gameserver.clientpackets;

import l2r.gameserver.RecipeController;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2RecipeList;
import l2r.gameserver.serverpackets.RecipeBookItemList;

public class RequestRecipeBookDestroy extends L2GameClientPacket
{
	private static String _C__AC_REQUESTRECIPEBOOKDESTROY = "[C] AD RequestRecipeBookDestroy";
	//private static Logger _log = Logger.getLogger(RequestSellItem.class.getName());

	private int _RecipeID;

	@Override
	public void readImpl()
	{
		_RecipeID = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		L2RecipeList rp = RecipeController.getInstance().getRecipeList(_RecipeID - 1);

		if(rp == null)
		{
			activeChar.sendActionFailed();
			return;
		}

		activeChar.unregisterRecipe(_RecipeID);

		RecipeBookItemList response = new RecipeBookItemList(rp.isDwarvenRecipe(), (int) activeChar.getCurrentMp());

		response.setRecipes(activeChar.getDwarvenRecipeBook());

		activeChar.sendPacket(response);
	}
	@Override
	public String getType()
	{
		return _C__AC_REQUESTRECIPEBOOKDESTROY;
	}
}