package l2r.gameserver.clientpackets;

import l2r.gameserver.RecipeController;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Player;

public class RequestRecipeShopMakeItem extends L2GameClientPacket
{
	private static String _C__B6_REQUESTRECIPESHOPMAKEITEM = "[C] B6 RequestRecipeShopMakeItem";

	private int _id;
	private int _recipeId;
	@SuppressWarnings("unused")
	private int _unknow;

	/**
	 * packet type id 0xac
	 * format:		cd
	 */
	@Override
	public void readImpl()
	{
		_id = readD();
		_recipeId = readD();
		_unknow = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		if(activeChar.getDuel() != null)
		{
			activeChar.sendActionFailed();
			return;
		}

		L2Player manufacturer = (L2Player) activeChar.getVisibleObject(_id);
		if(manufacturer == null || manufacturer.getPrivateStoreType() != L2Player.STORE_PRIVATE_MANUFACTURE || manufacturer.getDistance(activeChar) > L2Character.INTERACTION_DISTANCE)
			return;

		RecipeController.getInstance().requestManufactureItem(manufacturer, activeChar, _recipeId);
	}

	@Override
	public String getType()
	{
		return _C__B6_REQUESTRECIPESHOPMAKEITEM;
	}
}