package l2r.gameserver.clientpackets;

import java.util.logging.Logger;

import l2r.gameserver.cache.CrestCache;
import l2r.gameserver.model.L2Alliance;
import l2r.gameserver.model.L2Clan;
import l2r.gameserver.model.L2Player;

public class RequestSetAllyCrest extends L2GameClientPacket
{
	private static String _C__91_REQUESTSETALLYCREST = "[C] 91 RequestSetAllyCrest";
	// format: cdb
	static Logger _log = Logger.getLogger(RequestSetPledgeCrest.class.getName());

	private int _length;
	private byte[] _data;

	@Override
	public void readImpl()
	{
		_length = readD();
		if(_length > _buf.remaining() || _length > Short.MAX_VALUE || _length < 0)
		{
			_log.warning("Possibly server crushing packet: [C] 91 RequestSetAllyCrest with length " + _length);
			_buf.clear();
			return;
		}
		_data = new byte[_length];
		readB(_data);
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		L2Clan clan = activeChar.getClan();
		L2Alliance ally = activeChar.getAlliance();
		if(ally != null && activeChar.isAllyLeader())
		{
			if(ally.hasAllyCrest())
				CrestCache.removeAllyCrest(ally);

			if(_data.length != 0)
				CrestCache.saveAllyCrest(ally, _data);

			for(L2Clan temp : ally.getMembers())
			{
				for(L2Player member : temp.getOnlineMembers(""))
					member.broadcastUserInfo();
				clan.broadcastClanStatus();
			}
		}
	}

	@Override
	public String getType()
	{
		return _C__91_REQUESTSETALLYCREST;
	}
}