package l2r.gameserver.clientpackets;

import l2r.gameserver.instancemanager.CastleManager;
import l2r.gameserver.instancemanager.ClanHallManager;
import l2r.gameserver.instancemanager.FortressManager;
import l2r.gameserver.model.entity.ClanHall;
import l2r.gameserver.model.entity.Fortress;
import l2r.gameserver.model.entity.siege.SiegeUnit;
import l2r.gameserver.serverpackets.CastleSiegeAttackerList;

public class RequestSiegeAttackerList extends L2GameClientPacket
{
	private static String _C__AB_RequestSiegeAttackerList = "[C] AB RequestSiegeAttackerList";
	// format: cd
	//private static Logger _log = Logger.getLogger(RequestJoinParty.class.getName());

	private int _CastleId;
	
	@Override
	public void readImpl()
	{
		_CastleId = readD();
	}

	@Override
	public void runImpl()
	{
		SiegeUnit castle = CastleManager.getInstance().getCastleByIndex(_CastleId);
		ClanHall clanhall = ClanHallManager.getInstance().getClanHall(_CastleId);
		Fortress fort = FortressManager.getInstance().getFortressByIndex(_CastleId);
		
		if(castle != null)
			sendPacket(new CastleSiegeAttackerList(castle));
		else if(clanhall != null)
			sendPacket(new CastleSiegeAttackerList(clanhall));
		else if(fort != null)
			sendPacket(new CastleSiegeAttackerList(fort));
	}

	@Override
	public String getType()
	{
		return _C__AB_RequestSiegeAttackerList;
	}
}
