package l2r.gameserver.clientpackets;

import l2r.gameserver.instancemanager.CastleManager;
import l2r.gameserver.instancemanager.ClanHallManager;
import l2r.gameserver.instancemanager.FortressManager;
import l2r.gameserver.model.entity.ClanHall;
import l2r.gameserver.model.entity.Fortress;
import l2r.gameserver.model.entity.siege.SiegeUnit;
import l2r.gameserver.serverpackets.CastleSiegeDefenderList;

public class RequestSiegeDefenderList extends L2GameClientPacket
{
	private static String _C__a3_RequestSiegeDefenderList = "[C] a3 RequestSiegeDefenderList";

	private int _CastleId;

	@Override
	public void readImpl()
	{
		_CastleId = readD();
	}

	@Override
	public void runImpl()
	{
		SiegeUnit castle = CastleManager.getInstance().getCastleByIndex(_CastleId);
		ClanHall clanhall = ClanHallManager.getInstance().getClanHall(_CastleId);
		Fortress fort = FortressManager.getInstance().getFortressByIndex(_CastleId);
		
		if(castle != null)
			sendPacket(new CastleSiegeDefenderList(castle));
		else if(clanhall != null)
			sendPacket(new CastleSiegeDefenderList(clanhall));
		else if(fort != null)
			sendPacket(new CastleSiegeDefenderList(fort));
	}

	@Override
	public String getType()
	{
		return _C__a3_RequestSiegeDefenderList;
	}
}