package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2CubicInstance;

/**
 * This class ...
 *
 * @version $Revision: 1.3.4.2 $ $Date: 2005/03/27 15:29:30 $
 */
public class RequestTargetCanceld extends L2GameClientPacket
{
	private static String _C__48_REQUESTTARGETCANCELD = "[C] 48 RequestTargetCanceld";

	private int _unselect;

	/**
	 * packet type id 0x48
	 * format:		ch
     */
	@Override
	public void readImpl()
	{
		_unselect = readH();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		if(activeChar.getUnstuck() == 1)
		{
			activeChar.setUnstuck(0);
			activeChar.unblock();
		}

		for(L2CubicInstance cubic : activeChar.getCubics().values())
			if(cubic.getId() != L2CubicInstance.LIFE_CUBIC)
				cubic.stopAction();

		if(_unselect == 0)
		{
			if(activeChar.isCastingNow())
				activeChar.abortCast();
			else if(activeChar.getTarget() != null)
				activeChar.setTarget(null);
		}
		else if(activeChar.getTarget() != null)
			activeChar.setTarget(null);
	}

	/* (non-Javadoc)
	 * @see l2r.gameserver.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__48_REQUESTTARGETCANCELD;
	}
}
