package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2ItemInstance;
import l2r.gameserver.serverpackets.SystemMessage;
import l2r.gameserver.templates.L2Item;

public class RequestUnEquipItem extends L2GameClientPacket
{
	private static String _C__16_REQUESTUNEQUIPITEM = "[C] 16 RequestUnequipItem";
	private int _slot;

	/**
	 * packet type id 0x16
	 * format:		cd
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_slot = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		// Нельзя снимать проклятое оружие
		if(_slot == L2Item.SLOT_LR_HAND && activeChar.isCursedWeaponEquipped())
			return;
		
		L2ItemInstance weapon = activeChar.getActiveWeaponInstance();
		L2ItemInstance[] unequipped = activeChar.getInventory().unEquipItemInBodySlotAndRecord(_slot, null);

		for(L2ItemInstance uneq : unequipped)
		{
			if(uneq == null || uneq.isWear())
				continue;

			SystemMessage sm = null;

			if(uneq.getEnchantLevel() > 0)
			{
				sm = new SystemMessage(SystemMessage.EQUIPMENT_OF__S1_S2_HAS_BEEN_REMOVED);
				sm.addNumber(uneq.getEnchantLevel());
				sm.addItemName(uneq.getItemId());
			}
			else
				sm = new SystemMessage(SystemMessage.S1__HAS_BEEN_DISARMED).addItemName(uneq.getItemId());

			activeChar.sendPacket(sm);

			if(weapon != null && uneq == weapon)
			{
				uneq.setChargedSpiritshot(L2ItemInstance.CHARGED_NONE);
				uneq.setChargedSoulshot(L2ItemInstance.CHARGED_NONE);
				activeChar.abortAttack();
				activeChar.abortCast();
			}
		}

		activeChar.refreshExpertisePenalty();
		activeChar.broadcastUserInfo();
	}

	@Override
	public String getType()
	{
		return _C__16_REQUESTUNEQUIPITEM;
	}
}