package l2r.gameserver.clientpackets;

import java.util.logging.Logger;

import l2r.Config;
import l2r.extensions.multilang.CustomMessage;
import l2r.gameserver.handler.AdminCommandHandler;
import l2r.gameserver.handler.IAdminCommandHandler;
import l2r.gameserver.model.L2Player;

/**
 * This class handles all GM commands triggered by //command
 */
public class SendBypassBuildCmd extends L2GameClientPacket
{
	private static Logger _log = Logger.getLogger(SendBypassBuildCmd.class.getName());

	private static String _C__74_SENDBYPASSBUILDCMD = "[C] 74 SendBypassBuildCmd";
	// format: cS
	public static int GM_MESSAGE = 9;
	public static int ANNOUNCEMENT = 10;

	private String _command;

	@Override
	public void readImpl()
	{
		_command = readS();

		if(_command != null)
			_command = _command.trim();

	}

	@Override
	public void runImpl()
	{
		if(Config.DEBUG)
			_log.info("Got command '" + _command + "'");

		L2Player activeChar = getClient().getActiveChar();

		if(activeChar == null)
			return;

		String cmd = "admin_" + _command;
		IAdminCommandHandler ach = AdminCommandHandler.getInstance().getAdminCommandHandler(cmd);

		if(ach == null)
		{
			cmd = _command;
			ach = AdminCommandHandler.getInstance().getAdminCommandHandler(cmd);
		}

		if(ach != null)
		{
			if(!(activeChar.getPlayerAccess().IsGM || activeChar.getPlayerAccess().CanUseGMCommand))
			{
				activeChar.illegalAction(activeChar.getName() + " user use adm command admin_" + _command, 0);
				return;
			}
			try
			{
				ach.useAdminCommand(cmd, activeChar);
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
			return;
		}
		activeChar.sendMessage(new CustomMessage("l2r.gameserver.clientpackets.SendBypassBuildCmd.NoCommandOrAccess", activeChar).addString(_command));
	}

	@Override
	public String getType()
	{
		return _C__74_SENDBYPASSBUILDCMD;
	}
}