package l2r.gameserver.clientpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.serverpackets.StartRotating;

public class StartRotatingC extends L2GameClientPacket
{
	private static String _C__5B_STARTROTATING = "[C] 5b StartRotating";

	private int _degree;
	private int _side;

	/**
	 * packet type id 0x5b
	 *
	 * sample
	 *
	 * 5b
	 * fb 0f 00 00 // degree (goes from 0 to 65535)
	 * 01 00 00 00 // side (01 00 00 00 = right, ff ff ff ff = left)
	 *
	 * format:		cdd
	 */
	@Override
	public void readImpl()
	{
		_degree = readD();
		_side = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		activeChar.setHeading(_degree);
		activeChar.broadcastPacket(new StartRotating(activeChar, _degree, _side));
	}

	@Override
	public String getType()
	{
		return _C__5B_STARTROTATING;
	}
}