package l2r.gameserver.communitybbs.Manager;

import javolution.text.TextBuilder;
import l2r.Config;
import l2r.gameserver.cache.Msg;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2ItemInstance;
import l2r.gameserver.serverpackets.InventoryUpdate;
import l2r.gameserver.tables.ItemTable;
import l2r.gameserver.templates.L2EtcItem;
import l2r.gameserver.templates.L2Item;
import l2r.util.Files;
import l2r.util.Log;

import java.util.StringTokenizer;

public class EnchantBBSManager extends BaseBBSManager
{
	private static EnchantBBSManager _Instance = null;

	public static EnchantBBSManager getInstance()
	{
		if(_Instance == null)
		{
			_Instance = new EnchantBBSManager();
		}
		return _Instance;
	}

	@Override
	public void parsecmd(String command, L2Player activeChar)
	{
		if(command.equals("_bbsechant"))
		{
			String name = "None Name";
			name = ItemTable.getInstance().getTemplate(Config.ALT_CB_ENCH_ITEM).getName();
			TextBuilder sb = new TextBuilder();
			sb.append("<table width=400>");
			L2ItemInstance arr[] = activeChar.getInventory().getItems();
			int len = arr.length;
			for(int i = 0; i < len; i++)
			{
				L2ItemInstance _item = arr[i];
				if(_item == null || (_item.getItem() instanceof L2EtcItem) || !_item.isEquipped() || _item.isHeroItem() || _item.getItem().getCrystalType() == L2Item.CRYSTAL_NONE || _item.getItemId() >= 7816 && _item.getItemId() <= 7831 || _item.isShadowItem() || _item.isWear() || _item.getEnchantLevel() >= Config.ENCHANT_MAX_WEAPON + 1 || _item.getEnchantLevel() >= Config.ENCHANT_MAX_ARMOR + 1 || _item.getEnchantLevel() >= Config.ENCHANT_MAX_ACCESSORY + 1)
				{
					continue;
				}
				sb.append((new StringBuilder()).append("<tr><td><img src=icon.").append(_item.getItem().getIcon()).append(" width=32 height=32></td><td>").toString());
				sb.append((new StringBuilder()).append("<font color=\"LEVEL\">").append(_item.getItem().getName()).append(" ").append(_item.getEnchantLevel() <= 0 ? "" : (new StringBuilder()).append("</font><br1><font color=3293F3>Заточено на: +").append(_item.getEnchantLevel()).toString()).append("</font><br1>").toString());
				sb.append((new StringBuilder()).append("Заточка за: <font color=\"LEVEL\">").append(name).append("</font>").toString());
				sb.append("<img src=\"l2ui.squaregray\" width=\"170\" height=\"1\">");
				sb.append("</td><td>");
				sb.append((new StringBuilder()).append("<button value=\"Обычная\" action=\"bypass -h _bbsechant;enchlistpage;").append(_item.getObjectId()).append("\" width=75 height=18 back=\"L2UI_ct1.button_df\" fore=\"L2UI_ct1.button_df\">").toString());
				sb.append("</td><td>");
				sb.append((new StringBuilder()).append("<button value=\"Атрибут\" action=\"bypass -h _bbsechant;enchlistpageAtrChus;").append(_item.getObjectId()).append("\" width=75 height=18 back=\"L2UI_ct1.button_df\" fore=\"L2UI_ct1.button_df\">").toString());
				sb.append("</td></tr>");
			}
			sb.append("</table>");
			String content = Files.read("data/html/CommunityBoardPVP/90.htm", activeChar);
			content = content.replace("%enchanter%", sb.toString());
			separateAndSend(content, activeChar);
		}
		if(command.startsWith("_bbsechant;enchlistpage;"))
		{
			StringTokenizer st = new StringTokenizer(command, ";");
			st.nextToken();
			st.nextToken();
			int ItemForEchantObjID = Integer.parseInt(st.nextToken());
			int price = 0;
			double mod = 0;
			String name = "None Name";
			name = ItemTable.getInstance().getTemplate(Config.ALT_CB_ENCH_ITEM).getName();
			L2ItemInstance EhchantItem = activeChar.getInventory().getItemByObjectId(ItemForEchantObjID);
			if(EhchantItem.getItem().getCrystalType() ==  L2Item.CRYSTAL_D)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = 3;
					mod = 1.1;
				}
				else
				{
					price = 1;
					mod = 1.1;
				}
			}
			else if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_C)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = 6;
					mod = 1.2;
				}
				else
				{
					price = 2;
					mod = 1.2;
				}
			}
			else if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_B)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = 9;
					mod = 1.3;
				}
				else
				{
					price = 3;
					mod = 1.3;
				}
			}
			else if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_A)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = 12;
					mod = 1.4;
				}
				else
				{
					price = 4;
					mod = 1.4;
				}
			}
			else if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_S)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = 15;
					mod = 1.5;
				}
				else
				{
					price = 5;
					mod = 1.5;
				}
			}
			TextBuilder sb = new TextBuilder();
			sb.append("Для обычной заточки выбрана вещь:<br1><table width=300>");
			sb.append((new StringBuilder()).append("<tr><td width=32><img src=icon.").append(EhchantItem.getItem().getIcon()).append(" width=32 height=32> <img src=\"l2ui.squaregray\" width=\"32\" height=\"1\"></td><td width=236><center>").toString());
			sb.append((new StringBuilder()).append("<font color=\"LEVEL\">").append(EhchantItem.getItem().getName()).append(" ").append(EhchantItem.getEnchantLevel() <= 0 ? "" : (new StringBuilder()).append("</font><br1><font color=3293F3>Заточено на: +").append(EhchantItem.getEnchantLevel()).toString()).append("</font><br1>").toString());
			sb.append((new StringBuilder()).append("Заточка производится за: <font color=\"LEVEL\">").append(name).append("</font>").toString());
			sb.append("<img src=\"l2ui.squaregray\" width=\"236\" height=\"1\"><center></td>");
			sb.append((new StringBuilder()).append("<td width=32><img src=icon.").append(EhchantItem.getItem().getIcon()).append(" width=32 height=32> <img src=\"l2ui.squaregray\" width=\"32\" height=\"1\"></td>").toString());
			sb.append("</tr>");
			sb.append("</table>");
			sb.append("<br1>");
			sb.append("<br1>");
			if(EhchantItem.getEquipSlot() !=  13)
			{
				sb.append("<table border=0 width=400><tr><td width=200>");
				sb.append("<button value=\"На +5 (Цена:").append(String.valueOf((int) ((double) price * (mod + 5)))).append(" ").append(name).append(")\" action=\"bypass -h _bbsechant;enchantgo;5;").append(String.valueOf((int) ((double) price * (mod + 5)))).append(";").append(String.valueOf(ItemForEchantObjID)).append("\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\"На +6 (Цена:").append(String.valueOf((int) ((double) price * (mod + 6)))).append(" ").append(name).append(")\" action=\"bypass -h _bbsechant;enchantgo;6;").append(String.valueOf((int) ((double) price * (mod + 6)))).append(";").append(String.valueOf(ItemForEchantObjID)).append("\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\"На +7 (Цена:").append(String.valueOf((int) ((double) price * (mod + 7)))).append(" ").append(name).append(")\" action=\"bypass -h _bbsechant;enchantgo;7;").append(String.valueOf((int) ((double) price * (mod + 7)))).append(";").append(String.valueOf(ItemForEchantObjID)).append("\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\"На +8 (Цена:").append(String.valueOf((int) ((double) price * (mod + 8)))).append(" ").append(name).append(")\" action=\"bypass -h _bbsechant;enchantgo;8;").append(String.valueOf((int) ((double) price * (mod + 8)))).append(";").append(String.valueOf(ItemForEchantObjID)).append("\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\"На +9 (Цена:").append(String.valueOf((int) ((double) price * (mod + 9)))).append(" ").append(name).append(")\" action=\"bypass -h _bbsechant;enchantgo;9;").append(String.valueOf((int) ((double) price * (mod + 9)))).append(";").append(String.valueOf(ItemForEchantObjID)).append("\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\"На +10 (Цена:").append(String.valueOf((int) ((double) price * (mod + 10)))).append(" ").append(name).append(")\" action=\"bypass -h _bbsechant;enchantgo;10;").append(String.valueOf((int) ((double) price * (mod + 10)))).append(";").append(String.valueOf(ItemForEchantObjID)).append("\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\"На +11 (Цена:").append(String.valueOf((int) ((double) price * (mod + 11)))).append(" ").append(name).append(")\" action=\"bypass -h _bbsechant;enchantgo;11;").append(String.valueOf((int) ((double) price * (mod + 11)))).append(";").append(String.valueOf(ItemForEchantObjID)).append("\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("</td><td width=200>");
				sb.append("<button value=\"На +12 (Цена:").append(String.valueOf((int) ((double) price * (mod + 12)))).append(" ").append(name).append(")\" action=\"bypass -h _bbsechant;enchantgo;12;").append(String.valueOf((int) ((double) price * (mod + 12)))).append(";").append(String.valueOf(ItemForEchantObjID)).append("\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\"На +13 (Цена:").append(String.valueOf((int) ((double) price * (mod + 13)))).append(" ").append(name).append(")\" action=\"bypass -h _bbsechant;enchantgo;13;").append(String.valueOf((int) ((double) price * (mod + 13)))).append(";").append(String.valueOf(ItemForEchantObjID)).append("\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\"На +14 (Цена:").append(String.valueOf((int) ((double) price * (mod + 14)))).append(" ").append(name).append(")\" action=\"bypass -h _bbsechant;enchantgo;14;").append(String.valueOf((int) ((double) price * (mod + 14)))).append(";").append(String.valueOf(ItemForEchantObjID)).append("\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\"На +15 (Цена:").append(String.valueOf((int) ((double) price * (mod + 15)))).append(" ").append(name).append(")\" action=\"bypass -h _bbsechant;enchantgo;15;").append(String.valueOf((int) ((double) price * (mod + 15)))).append(";").append(String.valueOf(ItemForEchantObjID)).append("\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\"На +16 (Цена:").append(String.valueOf((int) ((double) price * (mod + 16)))).append(" ").append(name).append(")\" action=\"bypass -h _bbsechant;enchantgo;16;").append(String.valueOf((int) ((double) price * (mod + 16)))).append(";").append(String.valueOf(ItemForEchantObjID)).append("\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\"На +17 (Цена:").append(String.valueOf((int) ((double) price * (mod + 17)))).append(" ").append(name).append(")\" action=\"bypass -h _bbsechant;enchantgo;17;").append(String.valueOf((int) ((double) price * (mod + 17)))).append(";").append(String.valueOf(ItemForEchantObjID)).append("\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\"На +18 (Цена:").append(String.valueOf((int) ((double) price * (mod + 18)))).append(" ").append(name).append(")\" action=\"bypass -h _bbsechant;enchantgo;18;").append(String.valueOf((int) ((double) price * (mod + 18)))).append(";").append(String.valueOf(ItemForEchantObjID)).append("\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("</td></tr></table><br1>");
			}	
			else
			{
				sb.append("<table border=0 width=400><tr><td width=200>");
				sb.append("<br1>");
				sb.append("<br1>");
				sb.append("<br1>");
				sb.append("<br1>");
				sb.append("<center><font color=\"LEVEL\">Заточка данной вещи не возможна!</font></center>");
				sb.append("<br1>");
				sb.append("<br1>");
				sb.append("<br1>");
				sb.append("<br1>");
				sb.append("</td></tr></table><br1>");				
			}				
			sb.append("<button value=\"Назад\" action=\"bypass -h _bbsechant\" width=70 height=18 back=\"L2UI_ct1.button_df\" fore=\"L2UI_ct1.button_df\">");
			String content = Files.read("data/html/CommunityBoardPVP/90.htm", activeChar);
			content = content.replace("%enchanter%", sb.toString());
			separateAndSend(content, activeChar);
		}
		if(command.startsWith("_bbsechant;enchantgo;"))
		{
			StringTokenizer st = new StringTokenizer(command, ";");
			st.nextToken();
			st.nextToken();
			int EchantVal = Integer.parseInt(st.nextToken());
			int EchantPrice = Integer.parseInt(st.nextToken());
			int EchantObjID = Integer.parseInt(st.nextToken());
			L2Item item = ItemTable.getInstance().getTemplate(Config.ALT_CB_ENCH_ITEM);
			L2ItemInstance pay = activeChar.getInventory().getItemByItemId(item.getItemId());
			L2ItemInstance EhchantItem = activeChar.getInventory().getItemByObjectId(EchantObjID);
			if(pay != null && pay.getCount() >= EchantPrice && EchantVal <= 18)
			{
				activeChar.getInventory().destroyItem(pay, EchantPrice, true);
				activeChar.getInventory().unEquipItemInSlot(EhchantItem.getEquipSlot());
				EhchantItem.setEnchantLevel(EchantVal);
				activeChar.getInventory().equipItem(EhchantItem);
				activeChar.sendPacket(new InventoryUpdate().addModifiedItem(EhchantItem));
				activeChar.broadcastUserInfo();
				activeChar.sendMessage("" + EhchantItem.getItem().getName() + " было заточена до " + EchantVal + ". Спасибо.");
				Log.add(activeChar.getName() + " enchant item:" + EhchantItem.getItem().getName() + " val: " + EchantVal + "", "wmzSeller");
				parsecmd("_bbsechant", activeChar);
			}
			else
			{
				activeChar.sendPacket(Msg.INCORRECT_ITEM_COUNT);
			}
		}
	}

	@Override
	public void parsewrite(String ar1, String ar2, String ar3, String ar4, String ar5, L2Player activeChar)
	{
	}
}