package l2r.gameserver.communitybbs.Manager;

import java.sql.ResultSet;
import java.util.StringTokenizer;
import java.util.logging.Level;
import java.util.logging.LogRecord;
import java.util.logging.Logger;

import javolution.text.TextBuilder;
import l2r.Config;
import l2r.database.DatabaseUtils;
import l2r.database.FiltredPreparedStatement;
import l2r.database.L2DatabaseFactory;
import l2r.database.ThreadConnection;
import l2r.gameserver.clientpackets.Say2C;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2World;
import l2r.gameserver.serverpackets.Say2;
import l2r.gameserver.serverpackets.ShowBoard;
import l2r.gameserver.serverpackets.SystemMessage;
import l2r.util.Log;

public class FriendsBBSManager extends BaseBBSManager
{
	private static Logger _logChat = Logger.getLogger("chat");

	@Override
	public void parsecmd(String command, L2Player activeChar)
	{
		if(Config.COMMUNITYBOARDLOGGIN)
			Log.add("CommunityBoard|FriendsBBS|AccountName=" + activeChar.getAccountName() + "|CharName=" + activeChar.getName() + "|IP=" + activeChar.getIP() + "|Command=" + command, "CommunityBoard");
		if(command.equals("_bbsgetfav"))
			showFriendsList(activeChar);
		else if(command.startsWith("_bbsgetfav;playerdelete;"))
		{
			StringTokenizer st = new StringTokenizer(command, ";");
			st.nextToken();
			st.nextToken();
			String name = st.nextToken();

			deleteFriend(activeChar, name);
			showFriendsList(activeChar);
		}
		else if(command.startsWith("_bbsgetfav;playeradd;"))
		{
			StringTokenizer st = new StringTokenizer(command, ";");
			st.nextToken();
			st.nextToken();
			String name = st.nextToken();

			addFriend(activeChar, name);
			showFriendsList(activeChar);
		}
		else if(command.startsWith("_bbsgetfav;playerinfo;"))
		{
			StringTokenizer st = new StringTokenizer(command, ";");
			st.nextToken();
			st.nextToken();
			String name = st.nextToken();

			showFriendsPI(activeChar, name);
		}
		else
		{
			ShowBoard sb = new ShowBoard("<html><body><br><br><center>the command: " + command + " is not implemented yet</center><br><br></body></html>", "101");
			activeChar.sendPacket(sb);
			activeChar.sendPacket(new ShowBoard(null, "102"));
			activeChar.sendPacket(new ShowBoard(null, "103"));
		}
	}

	private void showFriendsPI(L2Player activeChar, String name)
	{
		TextBuilder htmlCode = new TextBuilder("<html><body><br>");
		htmlCode.append("<table border=0><tr><td FIXWIDTH=15></td><td align=center>L2 Rebellion Community Board<img src=\"sek.cbui355\" width=610 height=1></td></tr><tr><td FIXWIDTH=15></td><td>");
		L2Player player = L2World.getPlayer(name);

		if(player != null)
		{
			String sex = "Male";
			if(player.getSex() == 1)
				sex = "Female";
			String levelApprox = "low";
			if(player.getLevel() >= 60)
				levelApprox = "very high";
			else if(player.getLevel() >= 40)
				levelApprox = "high";
			else if(player.getLevel() >= 20)
				levelApprox = "medium";
			htmlCode.append("<table border=0><tr><td>" + player.getName() + " (" + sex + " " + player.getTemplate().className + "):</td></tr>");
			htmlCode.append("<tr><td>Level: " + levelApprox + "</td></tr>");
			htmlCode.append("<tr><td><br></td></tr>");

			int uptime = (int) player.getUptime() / 1000;
			int h = uptime / 3600;
			int m = (uptime - h * 3600) / 60;
			int s = uptime - h * 3600 - m * 60;

			htmlCode.append("<tr><td>Uptime: " + h + "h " + m + "m " + s + "s</td></tr>");
			htmlCode.append("<tr><td><br></td></tr>");

			if(player.getClan() != null)
			{
				htmlCode.append("<tr><td>Clan: " + player.getClan().getName() + "</td></tr>");
				htmlCode.append("<tr><td><br></td></tr>");
			}

			htmlCode.append("<tr><td><multiedit var=\"pm\" width=240 height=40><button value=\"Send PM\" action=\"Write Region PM " + player.getName() + " pm pm pm\" width=110 height=15 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\"></td></tr><tr><td><br><button value=\"Back\" action=\"bypass _bbsgetfav\" width=40 height=15 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\"></td></tr></table>");
			htmlCode.append("</td></tr></table>");
			htmlCode.append("</body></html>");
			separateAndSend(htmlCode.toString(), activeChar);
		}
		else
		{
			ShowBoard sb = new ShowBoard("<html><body><br><br><center>No player with name " + name + "</center><br><br></body></html>", "101");
			activeChar.sendPacket(sb);
			activeChar.sendPacket(new ShowBoard(null, "102"));
			activeChar.sendPacket(new ShowBoard(null, "103"));
		}
	}

	private void showFriendsList(L2Player activeChar)
	{
		TextBuilder htmlCode = new TextBuilder("<html><body><br>");

		ThreadConnection con = null;
		FiltredPreparedStatement statement = null;
		ResultSet rset = null;
		try
		{
			String sqlQuery = "SELECT friend_id, friend_name FROM character_friends WHERE char_id=" + activeChar.getObjectId() + " ORDER BY friend_name ASC";

			con = L2DatabaseFactory.getInstance().getConnection();
			statement = con.prepareStatement(sqlQuery);
			rset = statement.executeQuery();

			//add new friend
			htmlCode.append("<table border=0>");
			htmlCode.append("<tr><td>To add someone to your friendlist type '/friendinvite friendname'</td></tr>");
			htmlCode.append("<tr><td>You can remove someone from your friendlist only when your friend is online</td></tr>");
			htmlCode.append("</table><br>");
			//show friendlist
			htmlCode.append("<table border=0>");
			htmlCode.append("<tr><td align=left FIXWIDTH=150>Your Friends List</td></tr>");
			while(rset.next())
			{
				int friendId = rset.getInt("friend_id");
				String friendName = rset.getString("friend_name");

				L2Player friend = friendId != 0 ? (L2Player) L2World.findObject(friendId) : L2World.getPlayer(friendName);
				if(friend == null)
					htmlCode.append("<tr><td align=left valign=top FIXWIDTH=150>" + friendName + "</td><td>Offline</td></tr>");
				else
					htmlCode.append("<tr><td align=left valign=top FIXWIDTH=150><a action=\"bypass _bbsgetfav;playerinfo;" + friendName + "\">" + friendName + "</a></td><td>Online</td><td><a action=\"bypass _bbsgetfav;playerdelete;" + friendName + "\">delete</a></td></tr>");
			}
			htmlCode.append("</table>");
			htmlCode.append("</body></html>");
		}
		catch(Exception e)
		{
			htmlCode.append("Can`t show friends list, call to GM</body></html>");
		}
		finally
		{
			DatabaseUtils.closeDatabaseCSR(con, statement, rset);
		}
		separateAndSend(htmlCode.toString(), activeChar);
	}

	private void deleteFriend(L2Player activeChar, String name)
	{
		L2Player player = L2World.getPlayer(name);
		ThreadConnection con = null;
		FiltredPreparedStatement statement = null;
		try
		{
			String sqlQuery = "DELETE FROM character_friends WHERE (char_id=" + activeChar.getObjectId() + " AND friend_id=" + player.getObjectId() + ") OR (char_id=" + player.getObjectId() + " AND friend_id=" + activeChar.getObjectId() + ")";
			con = L2DatabaseFactory.getInstance().getConnection();
			statement = con.prepareStatement(sqlQuery);
			statement.execute();
		}
		catch(Exception e)
		{
			//ignore
		}
		finally
		{
			DatabaseUtils.closeDatabaseCS(con, statement);
		}
	}

	private void addFriend(L2Player activeChar, String name)
	{
		L2Player player = L2World.getPlayer(name);
		ThreadConnection con = null;
		FiltredPreparedStatement statement = null;
		FiltredPreparedStatement statement1 = null;
		ResultSet rset = null;
		try
		{
			String sqlQuery = "SELECT * FROM character_friends WHERE char_id=" + activeChar.getObjectId() + " AND friend_id=" + player.getObjectId();
			con = L2DatabaseFactory.getInstance().getConnection();
			statement = con.prepareStatement(sqlQuery);
			rset = statement.executeQuery(sqlQuery);
			if(!rset.next())
			{
				statement1 = con.prepareStatement("INSERT INTO character_friends (char_id, friend_id, friend_name) VALUES (?, ?, ?), (?, ?, ?)");
				statement1.setInt(1, activeChar.getObjectId());
				statement1.setInt(2, player.getObjectId());
				statement1.setString(3, player.getName());
				statement1.setInt(4, player.getObjectId());
				statement1.setInt(5, activeChar.getObjectId());
				statement1.setString(6, activeChar.getName());
				statement1.execute();

				SystemMessage msg = new SystemMessage(SystemMessage.YOU_HAVE_SUCCEEDED_IN_INVITING_A_FRIEND);
				activeChar.sendPacket(msg);

				//Player added to your friendlist
				msg = new SystemMessage(SystemMessage.S1_HAS_BEEN_ADDED_TO_YOUR_FRIEND_LIST);
				msg.addString(player.getName());
				activeChar.sendPacket(msg);

				//has joined as friend.
				msg = new SystemMessage(SystemMessage.S1_HAS_JOINED_AS_A_FRIEND);
				msg.addString(activeChar.getName());
				player.sendPacket(msg);
			}
		}
		catch(Exception e)
		{
			//ignore
		}
		finally
		{
			DatabaseUtils.closeStatement(statement1);
			DatabaseUtils.closeDatabaseCSR(con, statement, rset);
		}
	}

	@Override
	public void parsewrite(String ar1, String ar2, String ar3, String ar4, String ar5, L2Player activeChar)
	{
		if(activeChar == null)
			return;

		if(ar1.equals("PM"))
		{
			TextBuilder htmlCode = new TextBuilder("<html><body><br>");
			htmlCode.append("<table border=0><tr><td FIXWIDTH=15></td><td align=center>L2 Rebellion Community Board<img src=\"sek.cbui355\" width=610 height=1></td></tr><tr><td FIXWIDTH=15></td><td>");

			try
			{

				L2Player reciever = L2World.getPlayer(ar2);
				if(reciever == null)
				{
					htmlCode.append("Player not found!<br><button value=\"Back\" action=\"bypass _bbsgetfav;playerinfo;" + ar2 + "\" width=40 height=15 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
					htmlCode.append("</td></tr></table></body></html>");
					separateAndSend(htmlCode.toString(), activeChar);
					return;
				}

				if(activeChar.getNoChannel() != 0)
				{
					if(activeChar.getNoChannelRemained() > 0 || activeChar.getNoChannel() < 0)
					{
						if(activeChar.getNoChannel() > 0)
							htmlCode.append("You are banned in all chats, time remained " + Math.round(activeChar.getNoChannelRemained() / 60000) + " min.<br><button value=\"Back\" action=\"bypass _bbsgetfav;playerinfo;" + reciever.getName() + "\" width=40 height=15 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
						else
							htmlCode.append("You are banned in all chats permanently.<br><button value=\"Back\" action=\"bypass _bbsgetfav;playerinfo;" + reciever.getName() + "\" width=40 height=15 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
						htmlCode.append("</td></tr></table></body></html>");
						separateAndSend(htmlCode.toString(), activeChar);
						return;
					}
					activeChar.updateNoChannel(0);
				}

				if(Config.LOG_CHAT)
				{
					LogRecord record = new LogRecord(Level.INFO, ar3);
					record.setLoggerName("chat");
					record.setParameters(new Object[] { "TELL", "[" + activeChar.getName() + " to " + reciever.getName() + "]" });
					_logChat.log(record);
				}
				Say2 cs = new Say2(activeChar.getObjectId(), Say2C.TELL, activeChar.getName(), ar3);
				if(!reciever.getMessageRefusal())
				{
					reciever.sendPacket(cs);
					activeChar.sendPacket(cs);
					htmlCode.append("Message Sent<br><button value=\"Back\" action=\"bypass _bbsgetfav;playerinfo;" + reciever.getName() + "\" width=40 height=15 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
					htmlCode.append("</td></tr></table></body></html>");
					separateAndSend(htmlCode.toString(), activeChar);
				}
				else
				{
					SystemMessage sm = new SystemMessage(SystemMessage.THE_PERSON_IS_IN_A_MESSAGE_REFUSAL_MODE);
					activeChar.sendPacket(sm);
					parsecmd("_bbsgetfav;playerinfo;" + reciever.getName(), activeChar);
				}
			}
			catch(StringIndexOutOfBoundsException e)
			{
				// ignore
			}
		}
		else
		{
			ShowBoard sb = new ShowBoard("<html><body><br><br><center>the command: " + ar1 + " is not implemented yet</center><br><br></body></html>", "101");
			activeChar.sendPacket(sb);
			activeChar.sendPacket(new ShowBoard(null, "102"));
			activeChar.sendPacket(new ShowBoard(null, "103"));
		}

	}

	private static FriendsBBSManager _Instance = null;

	public static FriendsBBSManager getInstance()
	{
		if(_Instance == null)
			_Instance = new FriendsBBSManager();
		return _Instance;
	}
}
