package l2r.gameserver.communitybbs.Manager;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.StringTokenizer;
import java.util.TreeSet;

import javolution.text.TextBuilder;
import l2r.Config;
import l2r.gameserver.GameTimeController;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2World;
import l2r.gameserver.serverpackets.ShowBoard;
import l2r.gameserver.tables.FakePlayersTable;
import l2r.util.Log;

public class RegionBBSManager extends BaseBBSManager
{
	@Override
	public void parsecmd(String command, L2Player activeChar)
	{
		if(Config.COMMUNITYBOARDLOGGIN)
			Log.add("CommunityBoard|RegionBBS|AccountName=" + activeChar.getAccountName() + "|CharName=" + activeChar.getName() + "|IP=" + activeChar.getIP() + "|Command=" + command, "CommunityBoard");
		if(command.equals("_bbsloc"))
			showRegion(activeChar, 0);
		else if(command.startsWith("_bbsloc;page;"))
		{
			StringTokenizer st = new StringTokenizer(command, ";");
			st.nextToken();
			st.nextToken();
			int index = 0;
			try
			{
				index = Integer.parseInt(st.nextToken());
				showRegion(activeChar, index);
			}
			catch(NumberFormatException nfe)
			{
				ShowBoard sb = new ShowBoard("<html><body><br><br><center>Error!</center><br><br></body></html>", "101");
				activeChar.sendPacket(sb);
				activeChar.sendPacket(new ShowBoard(null, "102"));
				activeChar.sendPacket(new ShowBoard(null, "103"));
			}
		}
		else
		{
			ShowBoard sb = new ShowBoard("<html><body><br><br><center>the command: " + command + " is not implemented yet</center><br><br></body></html>", "101");
			activeChar.sendPacket(sb);
			activeChar.sendPacket(new ShowBoard(null, "102"));
			activeChar.sendPacket(new ShowBoard(null, "103"));
		}
	}

	private void showRegion(L2Player activeChar, int startIndex)
	{
		TextBuilder htmlCode = new TextBuilder("<html><body><br>");

		TreeSet<String> temp = new TreeSet<String>();

		for(L2Player player : L2World.getAllPlayers())
		{
			if(player == null || player.isInvisible() && player != activeChar && !activeChar.isGM())
				continue;
			temp.add(player.getName());
		}

		for(String name : FakePlayersTable.getActiveFakePlayers())
			temp.add(name);

		String[] player_names = temp.toArray(new String[temp.size()]);

		String tdClose = "</td>";
		String tdOpen = "<td align=left valign=top>";
		String trClose = "</tr>";
		String trOpen = "<tr>";
		String colSpacer = "<td FIXWIDTH=10></td>";

		htmlCode.append("<table>");

		SimpleDateFormat format = new SimpleDateFormat("H:mm");
		Calendar cal = Calendar.getInstance();
		int t = GameTimeController.getInstance().getGameTime();

		htmlCode.append(trOpen);
		htmlCode.append("<td>Server Time: " + format.format(cal.getTime()) + tdClose);
		htmlCode.append(colSpacer);
		cal.set(Calendar.HOUR_OF_DAY, t / 60);
		cal.set(Calendar.MINUTE, t % 60);
		htmlCode.append("<td>Game Time: " + format.format(cal.getTime()) + tdClose);
		htmlCode.append(trClose);

		htmlCode.append("</table>");

		htmlCode.append("<table>");

		htmlCode.append(trOpen);
		htmlCode.append("<td><img src=\"L2UI.SquareWhite\" width=625 height=1><br></td>");
		htmlCode.append(trClose);

		htmlCode.append(trOpen);
		htmlCode.append(tdOpen + player_names.length + " Player(s) Online:</td>");
		htmlCode.append(trClose);

		htmlCode.append("</table>");

		htmlCode.append("<table border=0>");
		htmlCode.append("<tr><td><table border=0>");

		int cell = 0;
		int n = startIndex;
		for(int i = startIndex; i < startIndex + Config.NAME_PAGE_SIZE_COMMUNITYBOARD; i++)
		{
			if(i >= player_names.length)
				break;

			String player = player_names[i]; // Get the current record

			cell++;

			if(cell == 1)
				htmlCode.append(trOpen);

			htmlCode.append("<td align=left valign=top FIXWIDTH=75>");

			htmlCode.append(player);

			htmlCode.append(tdClose);

			if(cell < Config.NAME_PER_ROW_COMMUNITYBOARD)
				htmlCode.append(colSpacer);

			if(cell == Config.NAME_PER_ROW_COMMUNITYBOARD)
			{
				cell = 0;
				htmlCode.append(trClose);
			}
			n++;
		}

		if(cell > 0 && cell < Config.NAME_PER_ROW_COMMUNITYBOARD)
			htmlCode.append(trClose);

		htmlCode.append("</table></td></tr>");

		if(player_names.length > Config.NAME_PAGE_SIZE_COMMUNITYBOARD)
		{
			htmlCode.append("<tr><td align=center valign=top>Displaying " + (startIndex + 1) + " - " + n + " player(s)</td></tr>");

			htmlCode.append("<tr><td align=center valign=top>");

			htmlCode.append("<table border=0 width=610><tr>");

			if(startIndex == 0)
				htmlCode.append("<td><button value=\"Prev\" width=50 height=15 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\"></td>");
			else
				htmlCode.append("<td><button value=\"Prev\" action=\"bypass _bbsloc;page;" + (startIndex - Config.NAME_PAGE_SIZE_COMMUNITYBOARD) + "\" width=50 height=15 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\"></td>");

			htmlCode.append(colSpacer);

			if(player_names.length <= startIndex + Config.NAME_PAGE_SIZE_COMMUNITYBOARD)
				htmlCode.append("<td><button value=\"Next\" width=50 height=15 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\"></td>");
			else
				htmlCode.append("<td><button value=\"Next\" action=\"bypass _bbsloc;page;" + (startIndex + Config.NAME_PAGE_SIZE_COMMUNITYBOARD) + "\" width=50 height=15 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\"></td>");

			htmlCode.append("</tr></table>");

			htmlCode.append("</td></tr>");
		}

		htmlCode.append("</table>");
		htmlCode.append("</body></html>");
		separateAndSend(htmlCode.toString(), activeChar);
	}

	@Override
	public void parsewrite(String ar1, String ar2, String ar3, String ar4, String ar5, L2Player activeChar)
	{
		if(activeChar == null)
			return;

		ShowBoard sb = new ShowBoard("<html><body><br><br><center>the command: " + ar1 + " is not implemented yet</center><br><br></body></html>", "101");
		activeChar.sendPacket(sb);
		activeChar.sendPacket(new ShowBoard(null, "102"));
		activeChar.sendPacket(new ShowBoard(null, "103"));
	}

	private static RegionBBSManager _Instance = null;

	public static RegionBBSManager getInstance()
	{
		if(_Instance == null)
			_Instance = new RegionBBSManager();
		return _Instance;
	}
}
