package l2r.gameserver.geodata.network;

import java.io.File;
import java.io.FileInputStream;
import java.util.Properties;

/**
 * @Author: Death
 * @Date: 23/11/2007
 * @Time: 10:59:06
 */
public class GeoConfig
{
	public static int GEODATA_MODE;

	public static String SERVER_BIND_HOST;
	public static String CLIENT_TARGET_HOST;
	public static int PORT;

	public static boolean PATH_CLEAN;

	public static boolean ALLOW_DOORS;

	public static boolean COMPACT_MODE;
	public static boolean SIMPLE_PATHFIND_FOR_MOBS;
	public static boolean ALLOW_FALL_FROM_WALLS;

	public static int PATHFIND_BOOST;
	public static int MAX_Z_DIFF;
	public static int WEIGHT0;
	public static int WEIGHT1;
	public static int WEIGHT2;

	public static String PATH_FIND_BUFFERS;

	public static void load() throws Exception
	{
		FileInputStream in = new FileInputStream(new File("config/geodata.properties"));

		Properties p = new Properties();
		p.load(in);
		in.close();

		SERVER_BIND_HOST = p.getProperty("GeoServerHost");
		CLIENT_TARGET_HOST = p.getProperty("GeoClientTargetHost");
		PORT = Integer.parseInt(p.getProperty("GeoPort"));

		GEODATA_MODE = Integer.parseInt(p.getProperty("GeoData", "0"));
		PATH_CLEAN = Boolean.parseBoolean(p.getProperty("PathClean", "True"));
		ALLOW_DOORS = Boolean.parseBoolean(p.getProperty("AllowDoors", "false"));

		COMPACT_MODE = Boolean.parseBoolean(p.getProperty("CompactMode", "false"));
		PATHFIND_BOOST = Integer.parseInt(p.getProperty("PathFindBoost", "2"));

		MAX_Z_DIFF = Integer.parseInt(p.getProperty("MaxZDiff", "32"));
		WEIGHT0 = Integer.parseInt(p.getProperty("Weight0", "1"));
		WEIGHT1 = Integer.parseInt(p.getProperty("Weight1", "8"));
		WEIGHT2 = Integer.parseInt(p.getProperty("Weight2", "4"));

		SIMPLE_PATHFIND_FOR_MOBS = Boolean.parseBoolean(p.getProperty("SimplePathFindForMobs", "True"));

		PATH_FIND_BUFFERS = p.getProperty("PathFindBuffers", "8x100;8x128;4x192;2x256");
	}
}
