package l2r.gameserver.geodata.network.geoserver;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Vector;

import l2r.gameserver.geodata.network.geoclient.GeoClientInterface;
import l2r.gameserver.model.L2Territory;
import l2r.gameserver.model.L2Object;
import l2r.util.Location;

/**
 * User: Death
 * Date: 14 груд 2007
 * Time: 12:47:53
 */
public interface GeoServerInterface extends Remote
{
	void addClient(GeoClientInterface client) throws RemoteException;

	short getType(GeoClientInterface client, int x, int y) throws RemoteException;

	int getHeight(GeoClientInterface client, int x, int y, int z) throws RemoteException;

	boolean canSeeCoord(GeoClientInterface client, int x, int y, int z, int tx, int ty, int tz) throws RemoteException;

	boolean canSeeTarget(GeoClientInterface client, L2Object actor, L2Object target) throws RemoteException;

	boolean canSeeCoord(GeoClientInterface client, L2Object actor, int tx, int ty, int tz) throws RemoteException;

	boolean canMoveToCoord(GeoClientInterface client, int x, int y, int z, int tx, int ty, int tz) throws RemoteException;

	boolean canMoveToCoordWithCollision(GeoClientInterface client, int x, int y, int z, int tx, int ty, int tz) throws RemoteException;

	short getNSWE(GeoClientInterface client, int x, int y, int z) throws RemoteException;

	Location moveCheck(GeoClientInterface client, int x, int y, int z, int tx, int ty) throws RemoteException;

	Location moveCheckForAI(GeoClientInterface client, Location loc1, Location loc2) throws RemoteException;

	Vector<Location> checkMovement(GeoClientInterface client, int x, int y, int z, Location target, boolean plyable) throws RemoteException;

	void openDoor(GeoClientInterface client, L2Territory pos) throws RemoteException;

	void closeDoor(GeoClientInterface client, L2Territory pos) throws RemoteException;

	Location moveInWaterCheck(GeoClientInterface client, int x, int y, int z, int tx, int ty, int tz) throws RemoteException;
}
