/*
 * coded by Balancer balancer@balancer.ru http://balancer.ru version 0.1,
 * 2005-10-31 version 0.2, 2008-01-23
 */

package l2r.gameserver.model;

import java.lang.ref.WeakReference;

public class BypassStorage
{
	private static final long MAX_STORAGE_TIME = 1200000; // 20 minutes

	private String code;
	private long time;
	private WeakReference<L2Player> player;
	private boolean useParams;

	public BypassStorage(L2Player _player, String _code, boolean _use_params)
	{
		setCode(_code);
		player = new WeakReference<L2Player>(_player);
		setUseParams(_use_params);
		setTime(System.currentTimeMillis() + MAX_STORAGE_TIME);
	}

	public L2Player getPlayer()
	{

		if(player == null)
			return null;

		L2Player p = player.get();
		if(p == null)
			player = null;

		return p;
	}

	public String getCode()
	{
		return code;
	}

	public void setCode(String code)
	{
		this.code = code;
	}

	public long getTime()
	{
		return time;
	}

	public void setTime(long time)
	{
		this.time = time;
	}

	public boolean isUseParams()
	{
		return useParams;
	}

	public void setUseParams(boolean useParams)
	{
		this.useParams = useParams;
	}
}
