package l2r.gameserver.model;

import java.util.concurrent.Future;

import l2r.gameserver.ThreadPoolManager;
import l2r.gameserver.skills.effects.EffectForce;
import l2r.gameserver.tables.SkillTable;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class ForceBuff
{
	static final Log _log = LogFactory.getLog(ForceBuff.class.getName());

	private L2Character _caster;
	private L2Character _target;
	private L2Skill _skill;
	private L2Skill _force;
	private Future _task;

	public L2Character getCaster()
	{
		return _caster;
	}

	public L2Character getTarget()
	{
		return _target;
	}

	public L2Skill getSkill()
	{
		return _skill;
	}

	public L2Skill getForce()
	{
		return _force;
	}

	public ForceBuff(L2Character caster, L2Character target, L2Skill skill)
	{
		_caster = caster;
		_target = target;
		_skill = skill;
		_force = SkillTable.getInstance().getInfo(skill.getForceId(), 1);

		for(L2Effect e : getTarget().getAllEffects())
			if(e.getSkill().getId() == getForce().getId())
			{
				EffectForce ef = (EffectForce) e;
				if(ef.forces >= 3)
					return;
			}

		Runnable r = new Runnable(){
			public void run()
			{
				int forceId = getForce().getId();
				boolean create = true;
				for(L2Effect e : getTarget().getAllEffects())
					if(e.getSkill().getId() == forceId)
					{
						((EffectForce) e).increaseForce();
						create = false;
						break;
					}

				if(create)
					getForce().getEffects(_caster, getTarget(), false);
			}
		};

		_task = ThreadPoolManager.getInstance().scheduleGeneral(r, 3300);
	}

	public void delete()
	{
		if(_task != null)
		{
			_task.cancel(false);
			_task = null;
		}

		int toDeleteId = getForce().getId();

		for(L2Effect e : _target.getAllEffects())
			if(e.getSkill().getId() == toDeleteId)
			{
				((EffectForce) e).decreaseForce();
				break;
			}

		_caster.setForceBuff(null);
	}
}