package l2r.gameserver.model;

import l2r.gameserver.model.base.Experience;

/**
 * Character Sub-Class Definition
 * <BR>
 * Used to store key information about a character's sub-class.
 *
 * @author Tempy
 */
public class L2SubClass
{
	private short _class = 0;
	private long _exp = Experience.LEVEL[40];
	private int _sp = 0;
	private byte _level = 40;
	private double _Hp = 1;
	private double _Mp = 1;
	private double _Cp = 1;
	private boolean _active = false;
	private boolean _isBase = false;
	private L2Player _player;
	private DeathPenalty _dp;

	public L2SubClass()
	{}

	public short getClassId()
	{
		return _class;
	}

	public long getExp()
	{
		return _exp;
	}

	public int getSp()
	{
		return _sp;
	}

	public byte getLevel()
	{
		return _level;
	}

	public void setClassId(final short classId)
	{
		_class = classId;
	}

	public void setExp(final long expValue)
	{
		_exp = expValue;
	}

	public void setSp(final int spValue)
	{
		_sp = spValue;
	}

	public void setHp(final double hpValue)
	{
		_Hp = hpValue;
	}

	public double getHp()
	{
		return _Hp;
	}

	public void setMp(final double mpValue)
	{
		_Mp = mpValue;
	}

	public double getMp()
	{
		return _Mp;
	}

	public void setCp(final double cpValue)
	{
		_Cp = cpValue;
	}

	public double getCp()
	{
		return _Cp;
	}

	public void setLevel(byte levelValue)
	{
		if(levelValue > Experience.LEVEL[Experience.MAX_LEVEL])
			levelValue = (byte) Experience.LEVEL[Experience.MAX_LEVEL];
		else if(levelValue < 40 && !_isBase)
			levelValue = 40;

		_level = levelValue;
	}

	public void incLevel()
	{
		if(_level > Experience.LEVEL[Experience.MAX_LEVEL])
			return;

		_level++;
	}

	public void decLevel()
	{
		if(_level == 40 && !_isBase)
			return;

		_level--;
	}

	public void setActive(final boolean active)
	{
		_active = active;
	}

	public boolean isActive()
	{
		return _active;
	}

	public void setBase(final boolean base)
	{
		_isBase = base;
	}

	public boolean isBase()
	{
		return _isBase;
	}

	public DeathPenalty getDeathPenalty()
	{
		if(_dp == null)
			_dp = new DeathPenalty(_player, (byte) 0);
		return _dp;
	}

	public void setDeathPenalty(DeathPenalty dp)
	{
		_dp = dp;
	}

	public void setPlayer(L2Player player)
	{
		_player = player;
	}
}