package l2r.gameserver.model;

import java.util.HashMap;

import l2r.gameserver.tables.SpawnTable;
import l2r.util.Location;

public class Reflection
{
	private int _id;
	private Location _core; // место, к которому кидает при использовании SoE/unstuck, иначе выбрасывает в основной мир
	private HashMap<Integer, L2Spawn> _spawns = new HashMap<Integer, L2Spawn>();
	private HashMap<Integer, L2Object> _objects = new HashMap<Integer, L2Object>();

	public Reflection(int id)
	{
		_id = id;
	}

	public void collapse()
	{
		for(L2Spawn s : _spawns.values())
		{
			s.despawnAll();
			SpawnTable.getInstance().deleteSpawn(s, false);
		}
		for(L2Object o : _objects.values())
		{
			o.decayMe();
			L2World.removeObject(o);
		}
	}

	public int getId()
	{
		return _id;
	}

	public void addObject(L2Object o)
	{
		_objects.put(o._objectId, o);
	}

	public void removeObject(int i)
	{
		_objects.remove(i);
	}

	public void setCore(Location l)
	{
		_core = l;
	}

	public Location getCore()
	{
		return _core;
	}
}