package l2r.gameserver.model.inventory.listeners;

import l2r.gameserver.model.Inventory;
import l2r.gameserver.model.instances.L2ItemInstance;
import l2r.gameserver.templates.L2Weapon.WeaponType;

public final class BowListener implements PaperdollListener
{
	Inventory _inv;

	public BowListener(Inventory inv)
	{
		_inv = inv;
	}

	public void notifyUnequipped(int slot, L2ItemInstance item)
	{
		if(slot != Inventory.PAPERDOLL_RHAND)
			return;
		if(item.getItemType() == WeaponType.BOW)
			_inv.setPaperdollItem(Inventory.PAPERDOLL_LHAND, null);
		if(item.getItemType() == WeaponType.CROSSBOW)
			_inv.setPaperdollItem(Inventory.PAPERDOLL_LHAND, null);
		if(item.getItemType() == WeaponType.ROD)
			_inv.setPaperdollItem(Inventory.PAPERDOLL_LHAND, null);
	}

	public void notifyEquipped(int slot, L2ItemInstance item)
	{
		if(slot != Inventory.PAPERDOLL_RHAND)
			return;
		if(item.getItemType() == WeaponType.BOW)
		{
			L2ItemInstance arrow = _inv.findArrowForBow(item.getItem());
			if(arrow != null)
				_inv.setPaperdollItem(Inventory.PAPERDOLL_LHAND, arrow);
		}
	}
}
