package l2r.gameserver.model.inventory.listeners;

import l2r.gameserver.model.Inventory;
import l2r.gameserver.model.instances.L2ItemInstance;

public final class StatsListener implements PaperdollListener
{
	Inventory _inv;

	public StatsListener(Inventory inv)
	{
		_inv = inv;
	}

	public void notifyUnequipped(int slot, L2ItemInstance item)
	{
		if(slot == Inventory.PAPERDOLL_LRHAND)
			return;
		_inv.getOwner().removeStatsOwner(item);
		_inv.getOwner().updateStats();
	}

	public void notifyEquipped(int slot, L2ItemInstance item)
	{
		if(slot == Inventory.PAPERDOLL_LRHAND)
			return;
		_inv.getOwner().addStatFuncs(item.getStatFuncs(_inv.getOwner()));
		_inv.getOwner().updateStats();
	}
}
