package l2r.gameserver.serverpackets;

import java.util.ArrayList;

import l2r.gameserver.model.L2Clan;
import l2r.gameserver.model.L2SkillLearn;
import l2r.gameserver.model.base.ClassId;
import l2r.gameserver.tables.SkillSpellbookTable;
import l2r.gameserver.tables.SkillTreeTable;

public class AcquireSkillInfo extends L2GameServerPacket
{
	private static final String _S__91_ACQUIRESKILLINFO = "[S] 91 AquireSkillInfo";
	private ArrayList<Req> _reqs;
	private int _id;
	private byte _level;
	private int _spCost;
	private int _mode;
	private ClassId _classId;
	private L2Clan _clan;

	class Req
	{
		public int id;
		public int count;
		public int type;
		public int unk;

		Req(int type, int id, int count, int unk)
		{
			this.id = id;//0
			this.type = type;//2
			this.count = count;//count spb
			this.unk = unk;//2
		}
	}

	public AcquireSkillInfo(int id, byte level, ClassId classid, L2Clan clan)
	{
		_reqs = new ArrayList<Req>();
		_id = id;
		_level = level;
		_classId = classid;
		_clan = clan;
	}

	private void fillRequirements()
	{
		L2SkillLearn SkillLearn = SkillTreeTable.getSkillLearn(_id, _level, _classId, _clan);
		if(SkillLearn == null)
			return;
		_spCost = _clan != null ? SkillLearn.getRepCost() : SkillLearn.getSpCost();
		if(SkillLearn.common)
			_mode = 1;
		else if(_clan != null)
			_mode = 2;
		else if(SkillLearn.transformation)
			_mode = 4;
		else
			_mode = 0;

		Short spb_id = SkillSpellbookTable._skillSpellbooks.get(SkillSpellbookTable.hashCode(new int[] { _id, _level }));

		if(spb_id != null)
			_reqs.add(new Req(SkillLearn.common ? 4 : _clan != null ? 2 : 99, spb_id.intValue(), SkillLearn.getItemCount(), SkillLearn.common || _clan != null ? 2 : 50));
	}

	@Override
	final public void runImpl()
	{
		fillRequirements();
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x8b);
		writeD(_id);
		writeD(_level);
		writeD(_spCost);
		writeD(_mode);

		writeD(_reqs.size());

		for(Req temp : _reqs)
		{
			writeD(temp.type);
			writeD(temp.id);
			writeD(temp.count);
			writeD(temp.unk);
		}
	}

	@Override
	public String getType()
	{
		return _S__91_ACQUIRESKILLINFO;
	}
}