package l2r.gameserver.serverpackets;

import java.util.logging.Logger;

import l2r.gameserver.model.L2Object;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2World;

/**
 * Пример:
 * 08
 * a5 04 31 48 ObjectId
 * 00 00 00 7c unk
 *
 * format  d
 */
public class DeleteObject extends L2GameServerPacket
{
	private static Logger _log = Logger.getLogger(DeleteObject.class.getName());

	private static final String _S__08_DELETEOBJECT = "[S] 08 DeleteObject";
	private int _objectId;

	public DeleteObject(L2Object obj)
	{
		_objectId = obj.getObjectId();
	}

	@Override
	final public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar != null && activeChar.getObjectId() == _objectId)
		{
			_log.warning("Try self.DeleteObject for " + getClient().getActiveChar());
			Thread.dumpStack();
			_objectId = 0;
			return;
		}
	}

	@Override
	protected final void writeImpl()
	{
		if(_objectId == 0)
			return;

		writeC(0x12);
		writeD(_objectId);
		writeD(0x00); // unknown
	}

	@Override
	public String getType()
	{
		return _S__08_DELETEOBJECT + " " + L2World.findObject(_objectId) + " (" + _objectId + ")";
	}
}