package l2r.gameserver.serverpackets;

import l2r.gameserver.model.instances.L2DoorInstance;

/**
 * 60
 * d6 6d c0 4b		door id
 * 8f 14 00 00 		x
 * b7 f1 00 00 		y
 * 60 f2 ff ff 		z
 * 00 00 00 00 		??
 *
 * format  dddd    rev 377  ID:%d X:%d Y:%d Z:%d
 *         ddddd   rev 419
 *
 * @version $Revision: 1.3.2.2.2.3 $ $Date: 2005/03/27 15:29:57 $
 */
public class DoorInfo extends L2GameServerPacket
{
	private static final String _S__4C_DOORINFO = "[S] 4C DoorInfo";
	private int obj_id, door_id, view_hp;

	public DoorInfo(L2DoorInstance door)
	{
		obj_id = door.getObjectId();
		door_id = door.getDoorId();
		view_hp = door.isHPVisible() ? 1 : 0;
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x4C);
		writeD(obj_id);
		writeD(door_id);
		writeD(view_hp); // отображать ли хп у двери или стены
	}

	@Override
	public String getType()
	{
		return _S__4C_DOORINFO;
	}
}
