package l2r.gameserver.serverpackets;

import l2r.util.Location;

/**
 * format   dddddd
 */
public class Earthquake extends L2GameServerPacket
{
	private static final String _S__d3_EARTHQUAKE = "[S] d3 Earthquake";
	private Location _loc;
	private int _intensity;
	private int _duration;

	public Earthquake(Location loc, int intensity, int duration)
	{
		_loc = loc;
		_intensity = intensity;
		_duration = duration;
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0xC4);
		writeD(_loc.getX());
		writeD(_loc.getY());
		writeD(_loc.getZ());
		writeD(_intensity);
		writeD(_duration);
		writeD(0x00); // Unknown
	}

	@Override
	public String getType()
	{
		return _S__d3_EARTHQUAKE;
	}
}