package l2r.gameserver.serverpackets;

import l2r.gameserver.model.L2Player;

/**
 * Format: (ch) dc
 * d: character object id
 * c: 1 if won 0 if failed
 */
public class ExFishingEnd extends L2GameServerPacket
{
	private static final String _S__FE_1F_EXFISHINGEND = "[S] FE:1f ExFishingEnd";
	private int char_obj_id;
	private boolean _win;

	public ExFishingEnd(boolean win, L2Player character)
	{
		_win = win;
		char_obj_id = character.getObjectId();
	}

	@Override
	protected final void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0x14);
		writeD(char_obj_id);
		writeC(_win ? 1 : 0);
	}

	@Override
	public String getType()
	{
		return _S__FE_1F_EXFISHINGEND;
	}
}