package l2r.gameserver.serverpackets;

import l2r.gameserver.model.L2Character;
import l2r.util.Location;

/**
 * Format (ch)ddddd
 */
public class ExFishingStart extends L2GameServerPacket
{
	private static final String _S__FE_1E_EXFISHINGSTART = "[S] FE:1e ExFishingStart";
	private int _charObjId;
	private Location _loc;
	private int _fishType;
	private boolean _isNightLure;

	public ExFishingStart(L2Character character, int fishType, Location loc, boolean isNightLure)
	{
		_charObjId = character.getObjectId();
		_fishType = fishType;
		_loc = loc;
		_isNightLure = isNightLure;
	}

	@Override
	protected final void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0x13);
		writeD(_charObjId);
		writeD(_fishType); // fish type
		writeD(_loc.getX()); // x poisson
		writeD(_loc.getY()); // y poisson
		writeD(_loc.getZ()); // z poisson
		writeC(_isNightLure ? 0x01 : 0x00); // 0 = day lure  1 = night lure
		writeC(0x00);
	}

	@Override
	public String getType()
	{
		return _S__FE_1E_EXFISHINGSTART;
	}
}