package l2r.gameserver.serverpackets;

public class ExShowScreenMessage extends L2GameServerPacket
{
	public static enum ScreenMessageAlign
	{
		TOP_LEFT,
		TOP_CENTER,
		TOP_RIGHT,
		MIDDLE_LEFT,
		MIDDLE_CENTER,
		MIDDLE_RIGHT,
		BOTTOM_CENTER,
		BOTTOM_RIGHT,
	}

	private static final String _S__FE_39_ExShowScreenMessage = "[S] FE:39 ExShowScreenMessage";
	private boolean _hide, _big_font;
	private ScreenMessageAlign _text_align;
	private int _time;
	private String _text;

	public ExShowScreenMessage(String text, int time, ScreenMessageAlign text_align, boolean big_font)
	{
		_hide = false;
		_text = text;
		_time = time;
		_text_align = text_align;
		_big_font = big_font;
	}

	public ExShowScreenMessage(String text, int time, ScreenMessageAlign text_align)
	{
		this(text, time, text_align, true);
	}

	public ExShowScreenMessage(String text, int time)
	{
		this(text, time, ScreenMessageAlign.MIDDLE_CENTER);
	}

	public ExShowScreenMessage()
	{
		_hide = true;
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0x39);

		writeD(_hide ? 0 : 1); // показать или спрятать
		if(_hide)
			return;
		writeD(-1);
		writeD(_text_align.ordinal() + 1); // размещение текста
		writeD(0);
		writeD(_big_font ? 0 : 1); // размер текста
		writeD(0);
		writeD(0);
		writeD(0);
		writeD(_time); // время отображения сообщения в милисекундах
		writeD(1);
		writeS(_text); // текст сообщения
	}

	@Override
	public String getType()
	{
		return _S__FE_39_ExShowScreenMessage;
	}
}
