package l2r.gameserver.serverpackets;

import l2r.gameserver.model.L2Character;
import l2r.util.Location;

public class FlyToLocation extends L2GameServerPacket
{
	private static final String _S_d4_FLYTOLOCATION = "[S] 0xd4 FlyToLocation";
	private int _chaObjId;
	private final FlyType _type;
	private Location _loc;
	private Location _destLoc;

	public enum FlyType
	{
		THROW_UP,
		THROW_HORIZONTAL,
		CHARGE,
		DUMMY,
		NONE
	}

	public FlyToLocation(L2Character cha, Location destLoc, FlyType type)
	{
		_destLoc = destLoc;
		_type = type;
		_chaObjId = cha.getObjectId();
		_loc = cha.getLoc();
	}

	@Override
	protected void writeImpl()
	{
		writeC(0xC5);
		writeD(_chaObjId);
		writeD(_destLoc.getX());
		writeD(_destLoc.getY());
		writeD(_destLoc.getZ());
		writeD(_loc.getX());
		writeD(_loc.getY());
		writeD(_loc.getZ());
	}

	@Override
	public String getType()
	{
		return _S_d4_FLYTOLOCATION;
	}
}