package l2r.gameserver.serverpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2ItemInstance;
import l2r.gameserver.model.instances.L2ItemInstance.ItemClass;
import l2r.gameserver.templates.L2Item;
import l2r.gameserver.templates.L2Weapon;

public class GMViewWarehouseWithdrawList extends L2GameServerPacket
{
	private static final String _S__9b_GMViewWarehouseWithdrawList = "[S] 9b GMViewWarehouseWithdrawList";
	private final L2ItemInstance[] _items;
	private String _charName;
	private int _charAdena;

	public GMViewWarehouseWithdrawList(L2Player cha)
	{
		_charName = cha.getName();
		_charAdena = cha.getAdena();
		_items = cha.getWarehouse().listItems(ItemClass.ALL);
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x95);
		writeS(_charName);
		writeD(_charAdena);
		writeH(_items.length);

		for(L2ItemInstance temp : _items)
		{
			writeH(temp.getItem().getType1());
			writeD(temp.getObjectId());
			writeD(temp.getItemId());
			writeD(temp.getIntegerLimitedCount());
			writeH(temp.getItem().getType2());
			writeH(temp.getCustomType1());
			switch(temp.getItem().getType2())
			{
				case L2Item.TYPE2_WEAPON:
					writeD(temp.getBodyPart()); // ? 
					writeH(temp.getEnchantLevel()); // enchant level -confirmed 
					writeH(((L2Weapon) temp.getItem()).getSoulShotCount()); // ? 
					writeH(((L2Weapon) temp.getItem()).getSpiritShotCount()); // ? 
					break;
				case L2Item.TYPE2_SHIELD_ARMOR:
				case L2Item.TYPE2_ACCESSORY:
					writeD(temp.getItem().getBodyPart()); // ? 
					writeH(temp.getEnchantLevel()); // enchant level -confirmed 
					writeH(0x00); // ? 
					writeH(0x00); // ? 
					break;
			}
			writeD(temp.getObjectId());
			if(temp.isAugmented())
			{
				writeH(0);
				writeD(temp.getAugmentation().getAugmentationId());
				writeH(0);
			}
			else
			{
				writeD(0);
				writeD(temp.getLifeTimeRemaining());
			}
		}
	}

	@Override
	public String getType()
	{
		return _S__9b_GMViewWarehouseWithdrawList;
	}
}