package l2r.gameserver.serverpackets;

import l2r.gameserver.model.instances.L2ItemInstance;
import l2r.util.Location;

/**
 * sample
 * 0000: 17  1a 95 20 48  9b da 12 40  44 17 02 00  03 f0 fc ff  98 f1 ff ff                                     .....
 *
 * format  ddddd
 */
public class GetItem extends L2GameServerPacket
{
	private static final String _S__17_GETITEM = "[S] 17 GetItem";
	private int _playerId, _itemObjId;
	private Location _loc;

	public GetItem(L2ItemInstance item, int playerId)
	{
		_itemObjId = item.getObjectId();
		_loc = item.getLoc();
		_playerId = playerId;
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x0D);
		writeD(_playerId);
		writeD(_itemObjId);
		writeD(_loc.getX());
		writeD(_loc.getY());
		writeD(_loc.getZ());
	}

	@Override
	public String getType()
	{
		return _S__17_GETITEM;
	}
}