package l2r.gameserver.serverpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2BoatInstance;

public class GetOffVehicle extends L2GameServerPacket
{
	private int _x, _y, _z, char_obj_id, boat_obj_id;

	/**
	 * @param activeChar
	 * @param boat
	 * @param x
	 * @param y
	 * @param z
	 */
	public GetOffVehicle(L2Player activeChar, L2BoatInstance boat, int x, int y, int z)
	{
		_x = x;
		_y = y;
		_z = z;
		char_obj_id = activeChar.getObjectId();
		boat_obj_id = boat.getObjectId();

		activeChar.setInBoat(false);
		activeChar.setBoat(null);
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x5D);
		writeD(char_obj_id);
		writeD(boat_obj_id);
		writeD(_x);
		writeD(_y);
		writeD(_z);
	}

	@Override
	public String getType()
	{
		return "[S] 6f GetOffVehicle";
	}
}