package l2r.gameserver.serverpackets;

import l2r.extensions.network.SendablePacket;
import l2r.gameserver.network.L2GameClient;

public abstract class L2GameServerPacket extends SendablePacket<L2GameClient>
{
	@Override
	protected void write()
	{
		try
		{
			writeImpl();
		}
		catch(Throwable t)
		{
			t.printStackTrace();
		}
	}

	@Override
	public void runImpl()
	{}

	protected abstract void writeImpl();

	/**
	 * @return A String with this packet name for debugging purposes
	 */
	public abstract String getType();

	protected final static int EXTENDED_PACKET = 0xFE;

	@Override
	protected int getHeaderSize()
	{
		return 2;
	}

	@Override
	protected void writeHeader(int dataSize)
	{
		writeH(dataSize + getHeaderSize());
	}
}