package l2r.gameserver.serverpackets;

import javolution.util.FastList;
import l2r.gameserver.model.L2Character;

public class MagicSkillLaunched extends L2GameServerPacket
{
	private static final String _S__54_MAGICSKILLLAUNCHED = "[S] 54 MagicSkillLaunched";
	private final int _casterId;
	private final int _skillId;
	private final int _skillLevel;
	private final FastList<L2Character> _targets;

	public MagicSkillLaunched(int casterId, int skillId, int skillLevel, L2Character target)
	{
		_casterId = casterId;
		_skillId = skillId;
		_skillLevel = skillLevel;
		_targets = new FastList<L2Character>();
		_targets.add(target);
	}

	public MagicSkillLaunched(int casterId, int skillId, int skillLevel, FastList<L2Character> targets)
	{
		_casterId = casterId;
		_skillId = skillId;
		_skillLevel = skillLevel;
		_targets = targets;
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x76);
		writeD(_casterId);
		writeD(_skillId);
		writeD(_skillLevel);
		writeD(_targets.size());
		for(L2Character target : _targets)
			if(target != null)
				writeD(target.getObjectId());
	}

	@Override
	public String getType()
	{
		return _S__54_MAGICSKILLLAUNCHED;
	}
}