package l2r.gameserver.serverpackets;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2Clan.RankPrivs;

public class ManagePledgePower extends L2GameServerPacket
{
	private static final String _S__2a_MANAGEPLEDGEPOWER = "[S] 2a ManagePledgePower";
	private int _action, _clanId, privs;

	public ManagePledgePower(L2Player player, int action, int rank)
	{
		_clanId = player.getClanId();
		_action = action;
		RankPrivs temp = player.getClan().getRankPrivs(rank);
		privs = temp == null ? 0 : temp.getPrivs();
		player.sendPacket(new PledgeReceiveUpdatePower(privs));
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x30);
		writeD(_clanId);
		writeD(_action);
		writeD(privs);
	}

	@Override
	public String getType()
	{
		return _S__2a_MANAGEPLEDGEPOWER;
	}
}
