package l2r.gameserver.serverpackets;

import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2BoatInstance;
import l2r.util.Location;
import l2r.util.Util;

public class MoveToLocationInVehicle extends L2GameServerPacket
{
	private static final String _S__7E_MOVETOLOCATIONINVEHICLE = "[S] 7E MoveToLocationInVehicle";
	private Location _origin, _destination;
	private int char_obj_id, boat_obj_id;
	private boolean can_writeimpl = false;

	/**
	 * @param actor
	 * @param destination
	 * @param origin
	 */
	public MoveToLocationInVehicle(L2Character actor, Location destination, Location origin)
	{
		if(actor == null)
			return;
		L2Player _char = (L2Player) actor;
		L2BoatInstance _boat = _char.getBoat();
		if(_boat == null)
		{
			Util.handleIllegalPlayerAction(_char, "MoveLocationInVehicle", " tried to move on non-exist boat. Maybe packet cheater.", 0);
			return;
		}

		char_obj_id = _char.getObjectId();
		boat_obj_id = _boat.getObjectId();
		_destination = destination;
		_origin = origin;
		can_writeimpl = true;
	}

	@Override
	protected final void writeImpl()
	{
		if(!can_writeimpl)
			return;

		writeC(0x71);
		writeD(char_obj_id);
		writeD(boat_obj_id);
		writeD(_destination.getX());
		writeD(_destination.getY());
		writeD(_destination.getZ());
		writeD(_origin.getX());
		writeD(_origin.getY());
		writeD(_origin.getZ());
	}

	@Override
	public String getType()
	{
		return _S__7E_MOVETOLOCATIONINVEHICLE;
	}
}