package l2r.gameserver.serverpackets;

import java.util.logging.Logger;

import l2r.gameserver.model.L2Character;

/**
 * 0000: 75  7a 07 80 49  63 27 00 4a  ea 01 00 00  c1 37 fe    uz..Ic'.J.....7. <p>
 * 0010: ff 9e c3 03 00 8f f3 ff ff                         .........<p>
 * <p>
 *
 * format   dddddd		(player id, target id, distance, startx, starty, startz)<p>
 */
public class MoveToPawn extends L2GameServerPacket
{
	private static Logger _log = Logger.getLogger(MoveToPawn.class.getName());

	private static final String _S__72_MOVETOPAWN = "[S] 72 MoveToPawn";
	private int _chaId;
	private int _targetId;
	private int _distance;
	private int _x, _y, _z;

	private L2Character cha;
	private L2Character target;

	public MoveToPawn(L2Character cha, L2Character target, int distance)
	{
		if(cha == target)
		{
			_log.warning("Try pawn to yourself!");
			Thread.dumpStack();
			_chaId = 0;
			return;
		}

		this.cha = cha;
		this.target = target;
		_chaId = cha.getObjectId();
		_targetId = target.getObjectId();
		_distance = distance;
		_x = cha.getX();
		_y = cha.getY();
		_z = cha.getZ();
	}

	@Override
	protected final void writeImpl()
	{
		if(_chaId == 0)
			return;

		writeC(0x60);

		writeD(_chaId);
		writeD(_targetId);
		writeD(_distance);

		writeD(_x);
		writeD(_y);
		writeD(_z);
	}

	@Override
	public String getType()
	{
		return _S__72_MOVETOPAWN + ": " + cha + ", target=" + target + "; dist=" + _distance;
	}
}