package l2r.gameserver.serverpackets;

import javolution.util.FastList;
import l2r.gameserver.model.L2Player;

public class PartyMemberPosition extends L2GameServerPacket
{
	private static final String _S__BA_PARTYMEMBERPOSITION = "[S] BA PartyMemberPosition";
	private FastList<PartyMemberpos> poses = new FastList<PartyMemberpos>();
	private int MemberCount;

	public PartyMemberPosition(L2Player actor)
	{
		MemberCount = actor.getParty().getMemberCount();
		for(L2Player pm : actor.getParty().getPartyMembers())
		{
			if(pm == null)
				continue;
			poses.add(new PartyMemberpos(pm.getObjectId(), pm.getX(), pm.getY(), pm.getZ()));
		}
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0xA7);
		writeD(MemberCount);
		for(PartyMemberpos _pos : poses)
		{
			writeD(_pos._id);
			writeD(_pos.x);
			writeD(_pos.y);
			writeD(_pos.z);
		}
	}

	@Override
	public String getType()
	{
		return _S__BA_PARTYMEMBERPOSITION;
	}

	static class PartyMemberpos
	{
		public int _id, x, y, z;

		public PartyMemberpos(int __id, int _x, int _y, int _z)
		{
			_id = __id;
			x = _x;
			y = _y;
			z = _z;
		}
	}
}