package l2r.gameserver.serverpackets;

import l2r.gameserver.model.L2Clan.RankPrivs;

public class PledgePowerGradeList extends L2GameServerPacket
{
	private static final String _S__FE_3C_PLEDGEPOWERGRADELIST = "[S] FE:3c PledgePowerGradeList";
	private RankPrivs[] _privs;

	public PledgePowerGradeList(RankPrivs[] privs)
	{
		_privs = privs;
	}

	@Override
	protected final void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0x3B);
		writeD(_privs.length);
		for(RankPrivs element : _privs)
		{
			writeD(element.getRank());
			writeD(element.getParty());
		}
	}

	@Override
	public String getType()
	{
		return _S__FE_3C_PLEDGEPOWERGRADELIST;
	}
}