package l2r.gameserver.serverpackets;

import javolution.util.FastList;
import l2r.gameserver.model.L2Clan;

public class PledgeReceiveWarList extends L2GameServerPacket
{
	private static final String _S__FE_3F_PLEDGERECEIVEWARLIST = "[S] FE:3f PledgeReceiveWarList";
	private FastList<WarInfo> infos = new FastList<WarInfo>();
	private static int _updateType;
	@SuppressWarnings("unused")
	private static int _page;

	public PledgeReceiveWarList(L2Clan clan, int type, int page)
	{
		_updateType = type;
		_page = page;
		infos.clear();
		if(_updateType == 1)
			for(L2Clan _clan : clan.getAttackerClans())
			{
				if(_clan == null)
					continue;
				infos.add(new WarInfo(_clan.getName(), 1, 0));
			}
		else if(_updateType == 0)
			for(L2Clan _clan : clan.getEnemyClans())
			{
				if(_clan == null)
					continue;
				infos.add(new WarInfo(_clan.getName(), 1, 0));
			}
	}

	@Override
	protected final void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0x3E);
		writeD(_updateType); //which type of war list sould be revamped by this packet
		writeD(-1); //page number goes here(_page ), made it static cuz not sure how many war to add to one page so TODO here
		writeD(infos.size());
		for(WarInfo _info : infos)
		{
			writeS(_info.clan_name);
			writeD(_info.unk1);
			writeD(_info.unk2); //filler ??
		}
	}

	@Override
	public String getType()
	{
		return _S__FE_3F_PLEDGERECEIVEWARLIST;
	}

	static class WarInfo
	{
		public String clan_name;
		public int unk1, unk2;

		public WarInfo(String _clan_name, int _unk1, int _unk2)
		{
			clan_name = _clan_name;
			unk1 = _unk1;
			unk2 = _unk2;
		}
	}
}