package l2r.gameserver.serverpackets;

import l2r.gameserver.model.L2Clan;

public class PledgeShowInfoUpdate extends L2GameServerPacket
{
	private static final String _S__8e_PLEDGESHOWINFOUPDATE = "[S] 8e PledgeShowInfoUpdate";
	private int clan_id, clan_level, clan_rank, clan_rep;
	private int HasCastle, HasHideout, HasFortress;

	public PledgeShowInfoUpdate(final L2Clan clan)
	{
		clan_id = clan.getClanId();
		clan_level = clan.getLevel();
		HasCastle = clan.getHasCastle();
		HasHideout = clan.getHasHideout();
		HasFortress = clan.getHasFortress();
		clan_rank = clan.getRank();
		clan_rep = clan.getReputationScore();
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x88);
		//sending empty data so client will ask all the info in response ;)
		writeD(clan_id);
		writeD(0);
		writeD(clan_level);
		writeD(HasCastle);
		writeD(HasHideout);
		writeD(HasFortress);
		writeD(clan_rank);// displayed in the "tree" view (with the clan skills)
		writeD(clan_rep);
		writeD(0);
		writeD(0);

		writeD(0); //c5
		writeS(""); //c5
		writeD(0); //c5
		writeD(0); //c5
	}

	@Override
	public String getType()
	{
		return _S__8e_PLEDGESHOWINFOUPDATE;
	}
}