package l2r.gameserver.serverpackets;

import l2r.gameserver.RecipeController;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2RecipeList;

/**
 * format ddddd
 */
public class RecipeItemMakeInfo extends L2GameServerPacket
{
	private static final String _S__dd_RECIPEITEMMAKEINFO = "[S] dd RecipeItemMakeInfo";
	private int _id;
	private int _status;
	private int _CurMP;
	private int _MaxMP;

	public RecipeItemMakeInfo(int id, L2Player pl, int status)
	{
		_id = id;
		_status = status;
		_CurMP = (int) pl.getCurrentMp();
		_MaxMP = pl.getMaxMp();
	}

	@Override
	protected final void writeImpl()
	{
		L2RecipeList recipeList = RecipeController.getInstance().getRecipeList(_id);
		if(recipeList == null)
			return;

		writeC(0xd7); //Точно: назначение пакета

		writeD(_id); //Точно: ID рецепта
		writeD(recipeList.isDwarvenRecipe() ? 0 : 1);
		writeD(_CurMP); //Точно: текущее состояние полоски Creator MP
		writeD(_MaxMP); //Точно: максимальное состояние полоски Creator MP
		writeD(_status); //Точно: итог крафта; 0xFFFFFFFF нет статуса, 0 удача, 1 провал
	}

	@Override
	public String getType()
	{
		return _S__dd_RECIPEITEMMAKEINFO;
	}
}