package l2r.gameserver.serverpackets;

import l2r.gameserver.model.L2Player;

public class RelationChanged extends L2GameServerPacket
{
	private static final String _S__CE_RELATIONCHANGED = "[S] CE RelationChanged";
	private boolean _isAutoAttackable;
	private int _relation, karma, pvp_flag;
	private int char_obj_id = 0;

	public RelationChanged(L2Player cha, boolean isAutoAttackable, int relation)
	{
		_isAutoAttackable = isAutoAttackable;
		_relation = relation;
		char_obj_id = cha.getObjectId();
		karma = cha.getKarma();
		pvp_flag = cha.getPvpFlag();
	}

	@Override
	protected final void writeImpl()
	{
		if(char_obj_id == 0)
			return;

		writeC(0xCE);
		writeD(char_obj_id);
		writeD(_relation);
		writeD(_isAutoAttackable ? 1 : 0);
		writeD(karma);
		writeD(pvp_flag);
	}

	@Override
	public String getType()
	{
		return _S__CE_RELATIONCHANGED;
	}
}