package l2r.gameserver.serverpackets;

import l2r.gameserver.model.entity.SevenSigns;
/**
 * Seven Signs Info
 *
 * packet id 0x73
 * format: cc
 *
 * Пример пакета с оффа (828 протокол):
 * 73 01 01
 *
 * Возможные варианты использования данного пакета:
 * 0 0 - Обычное небо???
 * 1 1 - Dusk Sky
 * 2 2 - Dawn Sky???
 * 3 3 - Небо постепенно краснеет (за 10 секунд)
 *
 * Возможно и другие вариации, эффект не совсем понятен.
 * 1 0
 * 0 1
 * @author SYS
 */
public class SSQInfo extends L2GameServerPacket
{

	private static final String _S__76_SSQInfo = "[S] fb SSQInfo";

	public SSQInfo()
	{
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0xF8);
		writeH(SevenSigns.getInstance().getSky());
	}

	@Override
	public String getType()
	{
		return _S__76_SSQInfo;
	}
}