package l2r.gameserver.serverpackets;

import java.util.ArrayList;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2ItemInstance;

public class SellList extends L2GameServerPacket
{
	private static final String _S__06_SELLLIST = "[S] 06 SellList";
	private int _money;
	private ArrayList<L2ItemInstance> _selllist = new ArrayList<L2ItemInstance>();

	/**
	 * Список вещей для продажи в обычный магазин
	 * @param player
	 */
	public SellList(L2Player player)
	{
		_money = player.getAdena();

		for(L2ItemInstance item : player.getInventory().getItems())
			if(!item.isEquipped() && item.getItem().isSellable() && item.canBeTraded(player))
				_selllist.add(item);
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x10);
		writeQ(_money);
		writeH(_selllist.size());

		for(L2ItemInstance item : _selllist)
		{
			writeH(item.getItem().getType1());
			writeD(item.getObjectId());
			writeD(item.getItemId());
			writeD(item.getIntegerLimitedCount());
			writeH(item.getItem().getType2());
			writeH(item.getCustomType1());
			writeD(item.getBodyPart());
			writeH(item.getEnchantLevel());
			writeH(item.getCustomType2());
			writeH(0x00); // unknown
			writeD(item.getItem().getReferencePrice() / 2);
		}
	}

	@Override
	public String getType()
	{
		return _S__06_SELLLIST;
	}
}