package l2r.gameserver.serverpackets;

import java.util.List;
import java.util.Map;

import javolution.util.FastList;
import javolution.util.FastMap;
import l2r.gameserver.instancemanager.CastleManager;
import l2r.gameserver.instancemanager.CastleManorManager.CropProcure;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.instances.L2ItemInstance;

@SuppressWarnings("unused")
public class SellListProcure extends L2GameServerPacket
{
	private static final String _S__ef_SELLLISTPROCURE = "[S] ef SellListProcure";
	private int _money;
	private Map<L2ItemInstance, Integer> _sellList = new FastMap<L2ItemInstance, Integer>();
	private List<CropProcure> _procureList = new FastList<CropProcure>();
	private int _castle;

	public SellListProcure(L2Player player, int castleId)
	{
		_money = player.getAdena();
		_castle = castleId;
		_procureList = CastleManager.getInstance().getCastleByIndex(_castle).getCropProcure(0);
		for(CropProcure c : _procureList)
		{
			L2ItemInstance item = player.getInventory().getItemByItemId(c.getId());
			if(item != null && c.getAmount() > 0)
				_sellList.put(item, c.getAmount());
		}
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0xe9);
		writeD(_money); // money
		writeD(0x00); // lease ?
		writeH(_sellList.size()); // list size

		for(L2ItemInstance item : _sellList.keySet())
		{
			writeH(item.getItem().getType1());
			writeD(item.getObjectId());
			writeD(item.getItemId());
			writeD(_sellList.get(item)); // count
			writeH(item.getItem().getType2());
			writeH(0); // unknown
			writeD(0); // price, u shouldnt get any adena for crops, only raw materials
		}
	}

	@Override
	public String getType()
	{
		return _S__ef_SELLLISTPROCURE;
	}
}
