package l2r.gameserver.serverpackets;

import javolution.util.FastComparator;
import javolution.util.FastTable;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2Skill;

/**
 * format   d (dddc)
 */
public class SkillList extends L2GameServerPacket
{
	private static final String _S__5f_SKILLLIST = "[S] 5f SkillList";
	private FastTable<L2Skill> _skills;

	public SkillList(L2Player p)
	{
		_skills = new FastTable<L2Skill>();
		_skills.addAll(p.getAllSkills());
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x58);
		writeD(_skills.size());

		for(L2Skill temp : _skills)
		{
			writeD(temp.isActive() || temp.isToggle() ? 0 : 1);
			writeD(temp.getDisplayLevel());
			writeD(temp.getDisplayId());
			writeC(0x00); // c5
		}
	}

	@Override
	public String getType()
	{
		return _S__5f_SKILLLIST;
	}

	public class SkillComparator extends FastComparator<L2Skill>
	{
		private static final long serialVersionUID = -1235017548845689754L;

		@Override
		public boolean areEqual(L2Skill arg0, L2Skill arg1)
		{
			return arg0.getDisplayId() == arg1.getDisplayId();
		}

		@Override
		public int compare(L2Skill arg0, L2Skill arg1)
		{
			return arg0.getDisplayId() - arg1.getDisplayId();
		}

		@Override
		public int hashCodeOf(L2Skill arg0)
		{
			return arg0.hashCode();
		}
	}
}