package l2r.gameserver.serverpackets;

import l2r.gameserver.model.L2Player;
import l2r.util.Location;

public class StopMoveToLocationInVehicle extends L2GameServerPacket
{
	private static final String _S__7F_STOPMOVEINVEHICLE = "[S] 7F StopMoveToLocationInVehicle";
	private int _boatid, char_obj_id, char_heading;
	private Location _loc;

	/**
	 * @param player
	 * @param boatid
	 */
	public StopMoveToLocationInVehicle(L2Player player, int boatid)
	{
		_boatid = boatid;
		char_obj_id = player.getObjectId();
		_loc = player.getInBoatPosition();
		char_heading = player.getHeading();
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x72);
		writeD(char_obj_id);
		writeD(_boatid);
		writeD(_loc.getX());
		writeD(_loc.getY());
		writeD(_loc.getZ());
		writeD(char_heading);
	}

	@Override
	public String getType()
	{
		return _S__7F_STOPMOVEINVEHICLE;
	}
}