package l2r.gameserver.serverpackets;

import l2r.gameserver.model.L2Character;
import l2r.util.Location;

/**
 * format  ddddd
 *
 * sample
 * 0000: 24  69 08 10 48  02 c1 00 00  f7 56 00 00  89 ea ff
 * 0010: ff  0c b2 d8 61  01 00 00 00
 */
public class TargetUnselected extends L2GameServerPacket
{
	private static final String _S__24_TARGETUNSELECTED = "[S] 24 TargetUnselected";
	private int _targetId;
	private Location _loc;

	/**
	 * @param character
	 */
	public TargetUnselected(L2Character cha)
	{
		_targetId = cha.getObjectId();
		_loc = cha.getLoc();
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x2A);
		writeD(_targetId);
		writeD(_loc.getX());
		writeD(_loc.getY());
		writeD(_loc.getZ());
		writeD(0x00);
	}

	@Override
	public String getType()
	{
		return _S__24_TARGETUNSELECTED;
	}
}