package l2r.gameserver.serverpackets;

import l2r.gameserver.model.L2Object;

/**
 * format  dddd
 *
 * sample
 * 0000: 3a  69 08 10 48  02 c1 00 00  f7 56 00 00  89 ea ff    :i..H.....V.....
 * 0010: ff  0c b2 d8 61                                     ....a
 */
public class TeleportToLocation extends L2GameServerPacket
{
	private static final String _S__22_TELEPORTTOLOCATION = "[S] 22 TeleportToLocation";
	private int _targetId;
	private int _x;
	private int _y;
	private int _z;

	public TeleportToLocation(L2Object cha, int x, int y, int z)
	{
		_targetId = cha.getObjectId();
		_x = x;
		_y = y;
		_z = z;
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x28);
		writeD(_targetId);
		writeD(_x);
		writeD(_y);
		writeD(_z);
	}

	@Override
	public String getType()
	{
		return _S__22_TELEPORTTOLOCATION;
	}
}