package l2r.gameserver.serverpackets;

import l2r.gameserver.model.instances.L2BoatInstance;
import l2r.util.Location;

public class VehicleDeparture extends L2GameServerPacket
{
	private static final String _S__6C_VEHICLEDEPARTURE = "[S] 6C VehicleDeparture";
	private int _moveSpeed, _rotationSpeed;
	private int _boatObjId;
	private Location _loc;

	/**
	 * @param _boat
	 * @param moveSpeed
	 * @param rotationSpeed
	 * @param loc
	 */
	public VehicleDeparture(L2BoatInstance boat, int moveSpeed, int rotationSpeed, Location loc)
	{
		_boatObjId = boat.getObjectId();
		_moveSpeed = moveSpeed;
		_rotationSpeed = rotationSpeed;
		_loc = loc;
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x5a);
		writeD(_boatObjId);
		writeD(_moveSpeed);
		writeD(_rotationSpeed);
		writeD(_loc.getX());
		writeD(_loc.getY());
		writeD(_loc.getZ());
	}

	@Override
	public String getType()
	{
		return _S__6C_VEHICLEDEPARTURE;
	}
}