package l2r.gameserver.serverpackets;

import java.util.ArrayList;

import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.Warehouse.WarehouseType;
import l2r.gameserver.model.instances.L2ItemInstance;
import l2r.gameserver.templates.L2Item;

public class WareHouseDepositList extends L2GameServerPacket
{
	private static final String _S__41_WAREHOUSEDEPOSITLIST = "[S] 41 WareHouseDepositList";
	private int _whtype, char_adena;
	private ArrayList<L2ItemInstance> _itemslist = new ArrayList<L2ItemInstance>();

	public WareHouseDepositList(L2Player cha, WarehouseType whtype)
	{
		_whtype = whtype.getPacketValue();
		char_adena = cha.getAdena();
		for(L2ItemInstance item : cha.getInventory().getItems())
			if(!item.isEquipped() && item.getItem().getType2() != L2Item.TYPE2_QUEST && (_whtype == 1 || item.canBeStored(cha)))
				_itemslist.add(item);
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x41);
		writeH(_whtype);
		writeD(char_adena);
		writeH(_itemslist.size());
		for(L2ItemInstance temp : _itemslist)
		{
			L2Item item = temp.getItem();
			writeH(item.getType1());
			writeD(temp.getObjectId());
			writeD(temp.getItemId());
			writeD(temp.getIntegerLimitedCount());
			writeH(item.getType2());
			writeH(temp.getCustomType1());
			writeD(temp.getBodyPart());
			writeH(temp.getEnchantLevel());
			writeH(temp.getCustomType2());
			writeH(0x00); // ? 200
			writeD(temp.getObjectId()); // return value for define item (object_id)
			writeD(temp.getAugmentationId() & 0x0000FFFF);
			writeD(temp.getAugmentationId() >> 16);;
			writeD(temp.getLifeTimeRemaining());
		}
	}

	@Override
	public String getType()
	{
		return _S__41_WAREHOUSEDEPOSITLIST;
	}
}