package l2r.gameserver.skills;

import java.util.NoSuchElementException;

public enum Stats
{
	MAX_HP("maxHp"),
	MAX_MP("maxMp"),
	MAX_CP("maxCp"),
	REGENERATE_HP_RATE("regHp"),
	REGENERATE_CP_RATE("regCp"),
	REGENERATE_MP_RATE("regMp"),
	RECHARGE_MP_RATE("gainMp"),

	RUN_SPEED("runSpd"),

	POWER_DEFENCE("pDef"),
	MAGIC_DEFENCE("mDef"),
	POWER_ATTACK("pAtk"),
	MAGIC_ATTACK("mAtk"),
	POWER_ATTACK_SPEED("pAtkSpd"),
	MAGIC_ATTACK_SPEED("mAtkSpd"),

	MAGIC_REUSE_RATE("mReuse"),
	PHYSIC_REUSE_RATE("pReuse"),
	ATK_REUSE("atkReuse"),

	PVP_PHYSICAL_DMG("pvpPhysDmg"),
	PVP_MAGICAL_DMG("pvpMagicalDmg"),
	PVP_PHYS_SKILL_DMG("pvpPhysSkillsDmg"),

	CRITICAL_DAMAGE("cAtk"),
	CRITICAL_DAMAGE_STATIC("cAtkStatic"),
	EVASION_RATE("rEvas"),
	ACCURACY_COMBAT("accCombat"),
	CRITICAL_RATE("rCritPercent"),
	CRITICAL_RATE_STATIC("rCrit"),
	MCRITICAL_RATE("mCritRate"),

	PHYSICAL_DAMAGE("physDamage"),
	MAGIC_DAMAGE("magicDamage"),

	CAST_INTERRUPT("concentration"),

	SHIELD_DEFENCE("sDef"),
	SHIELD_RATE("rShld"),
	SHIELD_ANGLE("shldAngle"),

	POWER_ATTACK_RANGE("pAtkRange"),
	MAGIC_ATTACK_RANGE("mAtkRange"),
	POLE_ATTACK_ANGLE("poleAngle"),
	POLE_TARGERT_COUNT("poleTargetCount"),

	STAT_STR("STR"),
	STAT_CON("CON"),
	STAT_DEX("DEX"),
	STAT_INT("INT"),
	STAT_WIT("WIT"),
	STAT_MEN("MEN"),

	BREATH("breath"),
	FALL("fall"),
	EXP_LOST("expLost"),

	BLEED_RECEPTIVE("bleedRcpt"),
	POISON_RECEPTIVE("poisonRcpt"),
	STUN_RECEPTIVE("stunRcpt"),
	ROOT_RECEPTIVE("rootRcpt"),
	MENTAL_RECEPTIVE("mentalRcpt"),
	SLEEP_RECEPTIVE("sleepRcpt"),
	PARALYZE_RECEPTIVE("paralyzeRcpt"),
	SILENCE_RECEPTIVE("silenceRcpt"),
	CANCEL_RECEPTIVE("cancelRcpt"),
	DEBUFF_RECEPTIVE("debuffRcpt"),
	DEATH_RECEPTIVE("deathRcpt"),

	BLEED_POWER("bleedPower"),
	POISON_POWER("poisonPower"),
	STUN_POWER("stunPower"),
	ROOT_POWER("rootPower"),
	MENTAL_POWER("mentalPower"),
	SLEEP_POWER("sleepPower"),
	PARALYZE_POWER("paralyzePower"),
	SILENCE_POWER("silencePower"),
	CANCEL_POWER("cancelPower"),
	DEBUFF_POWER("debuffPower"),
	FATALBLOW_RATE("blowRate"),

	FIRE_RECEPTIVE("fireRcpt"),
	WIND_RECEPTIVE("windRcpt"),
	WATER_RECEPTIVE("waterRcpt"),
	EARTH_RECEPTIVE("earthRcpt"),
	UNHOLY_RECEPTIVE("unholyRcpt"),
	SACRED_RECEPTIVE("sacredRcpt"),

	CRIT_DAMAGE_RECEPTIVE("critDamRcpt"),
	CRIT_CHANCE_RECEPTIVE("critChanceRcpt"),

	ATTACK_ELEMENT_FIRE("attackFire"),
	ATTACK_ELEMENT_WATER("attackWater"),
	ATTACK_ELEMENT_WIND("attackWind"),
	ATTACK_ELEMENT_EARTH("attackEarth"),
	ATTACK_ELEMENT_SACRED("attackSacred"),
	ATTACK_ELEMENT_UNHOLY("attackUnholy"),

	SWORD_WPN_RECEPTIVE("swordWpnRcpt"),
	DUAL_WPN_RECEPTIVE("dualWpnRcpt"),
	BLUNT_WPN_RECEPTIVE("bluntWpnRcpt"),
	DAGGER_WPN_RECEPTIVE("daggerWpnRcpt"),
	BOW_WPN_RECEPTIVE("bowWpnRcpt"),
	POLE_WPN_RECEPTIVE("poleWpnRcpt"),
	FIST_WPN_RECEPTIVE("fistWpnRcpt"),
	// Reflect Damage
	REFLECT_DAMAGE_PERCENT("reflectDam"),
	// Absorb HP
	ABSORB_DAMAGE_PERCENT("absorbDam"),
	//Absorb MP
	ABSORB_DAMAGEMP_PERCENT("absorbDamMp"),
	TRANSFER_DAMAGE_PERCENT("transferDam"),
	REFLECT_PHYSIC_SKILL("reflectPhysicSkill"),
	REFLECT_MAGIC_SKILL("reflectMagicSkill"),

	//Counter Attack
	COUNTER_ATTACK("counterAttack"),

	CANCEL_TARGET("cancelTarget"),

	HEAL_EFFECTIVNESS("hpEff"),
	HEAL_POWER("healPower"),
	MANAHEAL_EFFECTIVNESS("mpEff"),
	MP_MAGIC_SKILL_CONSUME("mpConsum"),
	MP_PHYSICAL_SKILL_CONSUME("mpConsumePhysical"),
	MP_DANCE_SKILL_CONSUME("mpDanceConsume"),
	MP_USE_BOW("cheapShot"),
	MP_USE_BOW_CHANCE("cheapShotChance"),
	SS_USE_BOW("miser"),
	ACTIVATE_RATE("activateRate"),

	MAX_LOAD("maxLoad"),
	INVENTORY_LIMIT("inventoryLimit"),
	STORAGE_LIMIT("storageLimit"),
	TRADE_LIMIT("tradeLimit"),
	COMMON_RECIPE_LIMIT("CommonRecipeLimit"),
	DWARVEN_RECIPE_LIMIT("DwarvenRecipeLimit"),
	BUFF_LIMIT("buffLimit"),
	SOULS_LIMIT("soulsLimit"),
	SOULS_CONSUME_EXP("soulsExp"),

	EXP_SP("ExpSpMultiplier");

	public static final int NUM_STATS = values().length;

	private String _value;

	public String getValue()
	{
		return _value;
	}

	private Stats(String s)
	{
		_value = s;
	}

	public static Stats valueOfXml(String name)
	{
		for(Stats s : values())
			if(s.getValue().equals(name))
				return s;

		throw new NoSuchElementException("Unknown name '" + name + "' for enum BaseStats");
	}

	@Override
	public String toString()
	{
		return _value;
	}
}