package l2r.gameserver.skills.effects;

import l2r.gameserver.geodata.network.geoclient.GeoClient;
import l2r.gameserver.model.L2Effect;
import l2r.gameserver.serverpackets.FlyToLocation;
import l2r.gameserver.serverpackets.FlyToLocation.FlyType;
import l2r.gameserver.skills.Env;
import l2r.util.Location;
import l2r.util.Util;

public class EffectBlink extends L2Effect
{
	private int x, y, z;

	public EffectBlink(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.BUFF;
	}

	@Override
	public void onStart()
	{
		int _radius = getSkill().getFlyRadius();
		double angle = Util.convertHeadingToDegree(getEffected().getHeading());
		double radian = Math.toRadians(angle);
		int x1 = (int) (Math.sin(radian) * _radius);
		int y1 = (int) (Math.cos(radian) * _radius);

		x = getEffected().getX() - x1;
		y = getEffected().getY() - y1;
		z = getEffected().getZ();

		Location destiny = GeoClient.getInstance().moveCheck(getEffected().getX(), getEffected().getY(), getEffected().getZ(), x, y, z);
		getEffected().broadcastPacket(new FlyToLocation(getEffected(), destiny, FlyType.CHARGE));
	}

	@Override
	public void onExit()
	{
		getEffected().setXYZ(x, y, z);
		//getEffected().broadcastPacket(new ValidateLocation(getEffected()));
	}

	@Override
	public boolean onActionTime()
	{
		return false;
	}
}
