package l2r.gameserver.skills.effects;

import l2r.gameserver.model.L2Effect;
import l2r.gameserver.model.L2Skill.SkillType;
import l2r.gameserver.skills.Env;

class EffectDamOverTimeLethal extends L2Effect
{
	public EffectDamOverTimeLethal(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.DMG_OVER_TIME_LETHAL;
	}

	@Override
	public boolean onActionTime()
	{
		if(_effected.isDead())
			return false;

		double damage = calc();

		if(getSkill().getSkillType() == SkillType.POISON || getSkill().getSkillType() == SkillType.BLEED)
			damage *= 2;

		_effected.reduceCurrentHp(damage, _effected.isPlayer ? _effected : _effector, !_effected.isNpc, !getSkill().isToggle(), _effector.isNpc || getSkill().isToggle() || _effected == _effector);

		return true;
	}
}