package l2r.gameserver.skills.effects;

import l2r.gameserver.model.L2Effect;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.skills.Env;
import l2r.gameserver.tables.SkillTable;
import l2r.util.Util;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class EffectForce extends L2Effect
{
	static final Log _log = LogFactory.getLog(EffectForce.class.getName());

	public int forces = 0;
	private int _range = -1;

	public EffectForce(Env env, EffectTemplate template)
	{
		super(env, template);
		forces = getSkill().getLevel();
		_range = getSkill().getCastRange();
	}

	@Override
	public boolean onActionTime()
	{
		if(!Util.checkIfInRange(_range, getEffector(), getEffected(), true))
			getEffector().abortCast();
		return true;
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.BUFF;
	}

	public void increaseForce()
	{
		if(forces < 3)
		{
			forces++;
			updateBuff();
		}
	}

	public void decreaseForce()
	{
		forces--;
		if(forces < 1)
			exit();
		else
			updateBuff();
	}

	public void updateBuff()
	{
		exit();
		L2Skill newSkill = SkillTable.getInstance().getInfo(getSkill().getId(), forces);
		newSkill.getEffects(getEffector(), getEffected(), false);
	}
}