package l2r.gameserver.skills.effects;

import l2r.gameserver.model.L2Effect;
import l2r.gameserver.serverpackets.SystemMessage;
import l2r.gameserver.skills.Env;
import l2r.gameserver.skills.Stats;

class EffectHealPercent extends L2Effect
{
	public EffectHealPercent(final Env env, final EffectTemplate template)
	{
		super(env, template);
		final double base = calc() * _effected.getMaxHp() / 100;
		final double newHp = base * _effected.calcStat(Stats.HEAL_EFFECTIVNESS, 100, null, null) / 100;
		_effected.sendPacket(new SystemMessage(SystemMessage.S1_HPS_HAVE_BEEN_RESTORED).addNumber((int) newHp));
		_effected.setCurrentHp(newHp + _effected.getCurrentHp());
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.HEAL_PERCENT;
	}

	@Override
	public boolean onActionTime()
	{
		return false;
	}
}