package l2r.gameserver.skills.effects;

import l2r.gameserver.model.L2Effect;
import l2r.gameserver.serverpackets.SystemMessage;
import l2r.gameserver.skills.Env;
import l2r.gameserver.skills.Stats;

class EffectManaHealPercent extends L2Effect
{
	public EffectManaHealPercent(final Env env, final EffectTemplate template)
	{
		super(env, template);
		final double base = calc() * _effected.getMaxMp() / 100;
		final double newMp = base * _effected.calcStat(Stats.MANAHEAL_EFFECTIVNESS, 100, null, null) / 100;
		_effected.sendPacket(new SystemMessage(SystemMessage.S1_MPS_HAVE_BEEN_RESTORED).addNumber((int) newMp));
		_effected.setCurrentMp(newMp + _effected.getCurrentMp());
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.MANAHEAL_PERCENT;
	}

	@Override
	public boolean onActionTime()
	{
		return false;
	}
}