package l2r.gameserver.skills.effects;

import l2r.extensions.listeners.MethodCollection;
import l2r.extensions.listeners.OblivionListener;
import l2r.gameserver.model.L2Effect;
import l2r.gameserver.skills.Env;

final class EffectOblivion extends L2Effect
{
	private static final OblivionListener listener = new OblivionListener();

	public EffectOblivion(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.BUFF;
	}

	/** Notify started */
	@Override
	public void onStart()
	{
		_effected.addMethodInvokeListener(MethodCollection.ReduceCurrentHp, listener);
	}

	/** Notify exited */
	@Override
	public void onExit()
	{
		_effected.removeMethodInvokeListener(MethodCollection.ReduceCurrentHp, listener);
	}

	@Override
	public boolean onActionTime()
	{
		// just stop this effect
		return false;
	}
}