package l2r.gameserver.skills.effects;

import l2r.gameserver.model.L2Effect;
import l2r.gameserver.serverpackets.StopMove;
import l2r.gameserver.skills.Env;

final class EffectPetrification extends L2Effect
{
	public EffectPetrification(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.PETRIFICATION;
	}

	@Override
	public void onStart()
	{
		if(_effected.paralyzeImmune())
		{
			exit();
			return;
		}

		_effected.abortCast();
		_effected.abortAttack();
		_effected.sendActionFailed();
		_effected.broadcastPacket(new StopMove(_effected));
		_effected.startAbnormalEffect(0x0800);
		_effected.setParalyzed(true);
		_effected.setIsInvul(true);
	}

	@Override
	public void onExit()
	{
		_effected.stopAbnormalEffect((short) 0x0800);
		_effected.setParalyzed(false);
		_effected.setIsInvul(false);
	}

	@Override
	public boolean onActionTime()
	{
		return false;
	}
}