package l2r.gameserver.skills.effects;

import l2r.gameserver.cache.Msg;
import l2r.gameserver.model.L2Effect;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.serverpackets.SystemMessage;
import l2r.gameserver.skills.Env;

class EffectRelax extends L2Effect
{
	public EffectRelax(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.RELAXING;
	}

	/** Notify started */
	@Override
	public void onStart()
	{
		if(((L2Player) _effected).isMounted())
		{
			exit();
			return;
		}
		setRelax(true);
		((L2Player) _effected).sitDown();
		super.onStart();
	}

	@Override
	public void onExit()
	{
		setRelax(false);
		super.onExit();
	}

	@Override
	public boolean onActionTime()
	{
		boolean retval = true;
		if(getEffected().isDead())
			retval = false;

		if(!((L2Player) _effected).isSitting())
			retval = false;

		if(_effected.getCurrentHp() >= getEffected().getMaxHp())
			if(getSkill().isToggle())
			{
				getEffected().sendPacket(new SystemMessage(SystemMessage.HP_WAS_FULLY_RECOVERED_AND_SKILL_WAS_REMOVED));
				retval = false;
			}

		double manaDam = calc();

		if(manaDam > _effected.getCurrentMp())
			if(getSkill().isToggle())
			{
				_effected.sendPacket(Msg.NOT_ENOUGH_MP);
				_effected.sendPacket(new SystemMessage(SystemMessage.THE_EFFECT_OF_S1_HAS_BEEN_REMOVED).addSkillName(getSkill().getId(), getSkill().getDisplayLevel()));
				retval = false;
			}

		if(!retval)
			setRelax(retval);
		else
			_effected.reduceCurrentMp(manaDam, null);

		return retval;
	}

	private void setRelax(boolean val)
	{
		((L2Player) _effected).setRelax(val);
	}
}
