package l2r.gameserver.skills.effects;

import l2r.extensions.listeners.MethodCollection;
import l2r.extensions.listeners.ThinSkinListener;
import l2r.gameserver.model.L2Effect;
import l2r.gameserver.skills.Env;

final class EffectThinSkin extends L2Effect
{
	private static final ThinSkinListener listeners[] = {
			new ThinSkinListener(1),
			new ThinSkinListener(2),
			new ThinSkinListener(3),
			new ThinSkinListener(4),
			new ThinSkinListener(5),
			new ThinSkinListener(6),
			new ThinSkinListener(7) };

	public EffectThinSkin(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.BUFF;
	}

	/** Notify started */
	@Override
	public void onStart()
	{
		_effected.addMethodInvokeListener(MethodCollection.ReduceCurrentHp, listeners[getLevel()]);
	}

	/** Notify exited */
	@Override
	public void onExit()
	{
		_effected.removeMethodInvokeListener(MethodCollection.ReduceCurrentHp, listeners[getLevel()]);
	}

	@Override
	public boolean onActionTime()
	{
		// just stop this effect
		return false;
	}
}