package l2r.gameserver.skills.effects;

import l2r.gameserver.model.L2Effect;
import l2r.gameserver.serverpackets.CharMoveToLocation;
import l2r.gameserver.skills.Env;

class EffectTurner extends L2Effect
{
	public EffectTurner(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.TURNER;
	}

	@Override
	public void onStart()
	{
		int posX = _effected.getX();
		int posY = _effected.getY();
		int posZ = _effected.getZ();
		int signx = -1;
		int signy = -1;
		if(_effected.getX() > _effector.getX())
			signx = 1;
		if(_effected.getY() > _effector.getY())
			signy = 1;

		_effected.setHeading(_effector, false);

		_effected.setRunning();

		_effected.setDestination(posX + signx * 20, posY + signy * 20, posZ);
		_effected.broadcastPacket(new CharMoveToLocation(_effected));

		_effected.sendMessage("You can feel Turner's effect");

		_effected.startStunning();
	}

	@Override
	public void onExit()
	{
		_effected.stopStunning();
	}

	@Override
	public boolean onActionTime()
	{
		return false;
	}
}