package l2r.gameserver.skills.funcs;

import java.lang.reflect.Constructor;

import l2r.gameserver.skills.Stats;

public class FuncFactory
{
	private final static FuncFactory _instance = new FuncFactory();

	private FuncFactory()
	{}

	public static FuncFactory getInstance()
	{
		return _instance;
	}

	public static Func createFunc(String func, Stats stat, int order, double lambdaValue) throws Exception
	{
		return createFunc(func, stat, order, lambdaValue, _instance);
	}

	@SuppressWarnings("unchecked")
	public static Func createFunc(String func, Stats stat, int order, double lambdaValue, Object owner) throws Exception
	{
		Class funcClass = Class.forName("l2r.gameserver.skills.funcs.Func" + func);
		Constructor funcConstructor = funcClass.getConstructor(new Class[] { Stats.class, Integer.TYPE, Object.class, Lambda.class });
		Lambda lambda = new LambdaConst(lambdaValue);
		return (Func) funcConstructor.newInstance(stat, order, owner, lambda);
	}
}
