package l2r.gameserver.skills.funcs;

import l2r.gameserver.skills.Env;

public final class LambdaCalc extends Lambda
{
	public Func[] _funcs = new Func[0];

	public LambdaCalc()
	{
		super(0);
	}

	@Override
	public double calc(Env env)
	{
		double saveValue = env.value;
		try
		{
			env.value = 0;
			for(Func f : _funcs)
				f.calc(env);
			return env.value;
		}
		finally
		{
			env.value = saveValue;
		}
	}

	public void addFunc(Func f)
	{
		int len = _funcs.length;
		Func[] tmp = new Func[len + 1];
		System.arraycopy(_funcs, 0, tmp, 0, len);
		tmp[len] = f;
		_funcs = tmp;
	}
}