package l2r.gameserver.skills.skillclasses;

import java.util.concurrent.ConcurrentLinkedQueue;

import javolution.util.FastList;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Effect;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.templates.L2Weapon;
import l2r.gameserver.templates.StatsSet;
import l2r.util.Rnd;

public class Cancel extends L2Skill
{
	private final String _dispelType;
	private final int _cancelRate;
        private final int _negateCount;

	public Cancel(StatsSet set)
	{
		super(set);
		_dispelType = set.getString("dispelType", "");
		_cancelRate = set.getInteger("cancelRate", 0);
                _negateCount = set.getInteger("negateCount", 5);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		if(isSSPossible())
			activeChar.unChargeShots(isMagic());

		L2Weapon weapon = activeChar.getActiveWeaponItem();
		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			if(_cancelRate > 0 && !Rnd.chance(_cancelRate))
				continue;

			L2Character target = n.getValue();
			if(target.checkReflectSkill(this))
				target = activeChar;
			byte counter = 0;

			if(_dispelType.equals(""))
			{
				byte antiloop = 24;
				while(counter < 5 && antiloop > 0)
				{
					ConcurrentLinkedQueue<L2Effect> eff = target.getAllEffects();
					if(eff.size() == 0)
					{
						counter = 5;
						continue;
					}
					L2Effect e = eff.toArray(new L2Effect[eff.size()])[Rnd.get(eff.size())];
					if(e.getSkill().isCancelable())
					{
						e.exit();
						counter++;
					}
					antiloop--;
				}
			}
			else
			{
				if(_dispelType.contains("negative"))
					for(L2Effect e : target.getAllEffects())
						if(e.getSkill().isOffensive())
							e.exit();

				if(_dispelType.contains("positive"))
					for(L2Effect e : target.getAllEffects())
						if(!e.getSkill().isOffensive())
							e.exit();
			}

			if(weapon != null)
				weapon.getEffect(false, activeChar, target, isOffensive());

			getEffects(activeChar, target, getActivateRate() > 0);
		}
	}
}