package l2r.gameserver.skills.skillclasses;

import javolution.util.FastList;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.serverpackets.SystemMessage;
import l2r.gameserver.skills.Formulas;
import l2r.gameserver.templates.StatsSet;

public class ChargeDmg extends L2Skill
{
	public ChargeDmg(final StatsSet set)
	{
		super(set);
	}

	@Override
	public void useSkill(final L2Character activeChar, final FastList<L2Character> targets)
	{
		L2Player player = (L2Player) activeChar;

		if(player.getIncreasedForce() < _numCharges || player.getIncreasedForce() < _condCharges)
			return;

		final boolean ss = activeChar.getChargedSoulShot() && isSSPossible();
		if(ss)
			activeChar.unChargeShots(false);

		double modifier = 0.3 * player.getIncreasedForce() + 0.7;

		player.setIncreasedForce(player.getIncreasedForce() - _numCharges);

		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			L2Character target = n.getValue();
			if(target.isDead())
				continue;

			target.doCounterAttack(this, activeChar);

			if(target.checkReflectSkill(this))
				target = activeChar;

			boolean shld = !getShieldIgnore() && Formulas.calcShldUse(activeChar, target);

			double damage = modifier * Formulas.calcPhysDam(activeChar, target, this, shld, false, false, ss);

			if(damage < 1)
				damage = 1;

			target.reduceCurrentHp(damage, activeChar, true, true, false);
			activeChar.sendPacket(new SystemMessage(SystemMessage.YOU_HIT_FOR_S1_DAMAGE).addNumber((int) damage));
			getEffects(activeChar, target, getActivateRate() > 0);
		}
	}
}