package l2r.gameserver.skills.skillclasses;

import javolution.util.FastList;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.serverpackets.SystemMessage;
import l2r.gameserver.templates.L2Weapon;
import l2r.gameserver.templates.StatsSet;

public class CombatPointHeal extends L2Skill
{
	public CombatPointHeal(StatsSet set)
	{
		super(set);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		if(isSSPossible())
			activeChar.unChargeShots(isMagic());
		L2Weapon weapon = activeChar.getActiveWeaponItem();
		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			L2Character target = n.getValue();
			target.setCurrentCp(_power + target.getCurrentCp());
			target.sendPacket(new SystemMessage(SystemMessage.S1_CPS_WILL_BE_RESTORED).addNumber((int) _power));
			if(weapon != null)
				weapon.getEffect(false, activeChar, target, isOffensive());

			getEffects(activeChar, target, getActivateRate() > 0);
		}
	}
}
