package l2r.gameserver.skills.skillclasses;

import javolution.util.FastList;
import l2r.gameserver.ai.CtrlIntention;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.templates.StatsSet;
import l2r.util.Rnd;

public class DeleteHate extends L2Skill
{
	private final boolean _cancelTarget;

	public DeleteHate(StatsSet set)
	{
		super(set);
		_cancelTarget = set.getBool("cancelTarget", false);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			L2Character target = n.getValue();

			if(target.isRaid)
				continue;

			if(!Rnd.chance(getActivateRate()))
				return;

			if(target instanceof L2NpcInstance)
			{
				L2NpcInstance npc = (L2NpcInstance) target;
				npc.clearAggroList();
				npc.setAttackTimeout(Integer.MAX_VALUE);
				npc.getAI().setAttackTarget(null);
				npc.getAI().setGlobalAggro(-10);
				npc.getAI().setIntention(CtrlIntention.AI_INTENTION_ACTIVE);
			}
			else if(_cancelTarget)
				target.setTarget(null);

			getEffects(activeChar, target, false);
		}
	}
}
