package l2r.gameserver.skills.skillclasses;

import javolution.util.FastList;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.model.L2Summon;
import l2r.gameserver.templates.StatsSet;
import l2r.util.Rnd;

public class DestroySummon extends L2Skill
{
	public DestroySummon(StatsSet set)
	{
		super(set);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		if(isSSPossible())
			activeChar.unChargeShots(isMagic());
		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			if(getActivateRate() > 0 && !Rnd.chance(getActivateRate()))
				continue;
			L2Character target = n.getValue();
			if(target.isSummon)
			{
				((L2Summon) target).unSummon();
				getEffects(activeChar, target, getActivateRate() > 0);
			}
		}
	}
}