package l2r.gameserver.skills.skillclasses;

import javolution.util.FastList;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.templates.L2Weapon;
import l2r.gameserver.templates.StatsSet;

public class Disablers extends L2Skill
{
	public Disablers(StatsSet set)
	{
		super(set);
	}

	@Override
	public boolean checkCondition(L2Character activeChar, L2Character target, boolean forceUse, boolean dontMove, boolean first)
	{
		if(target != null && getEffectTemplates()[0].isOverlay() && target.getEffectByResistType(getEffectTemplates()[0]._resistType) != null)
			return false;
		return super.checkCondition(activeChar, target, forceUse, dontMove, first);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		L2Weapon weapon = activeChar.getActiveWeaponItem();
		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			L2Character target = n.getValue();
			if(target.checkReflectSkill(this))
				target = activeChar;
			getEffects(activeChar, target, getActivateRate() > 0);
			if(weapon != null)
				weapon.getEffect(false, activeChar, target, isOffensive());
		}
		if(isSSPossible())
			activeChar.unChargeShots(isMagic());
	}
}