package l2r.gameserver.skills.skillclasses;

import javolution.util.FastList;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.model.instances.L2DoorInstance;
import l2r.gameserver.model.instances.L2SiegeHeadquarterquarterInstance;
import l2r.gameserver.serverpackets.SystemMessage;
import l2r.gameserver.skills.Stats;
import l2r.gameserver.templates.L2Weapon;
import l2r.gameserver.templates.StatsSet;

public class Heal extends L2Skill
{
	@Override
	public boolean checkCondition(L2Character activeChar, L2Character target, boolean forceUse, @SuppressWarnings("unused")
	boolean dontMove, boolean first)
	{
		if(target instanceof L2DoorInstance || target instanceof L2SiegeHeadquarterquarterInstance)
			return false;

		return super.checkCondition(activeChar, target, forceUse, dontMove, first);
	}

	public Heal(StatsSet set)
	{
		super(set);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		// Надо уточнить формулу.
		double hp = _power + 0.1 * _power * Math.sqrt(activeChar.getMAtk(null, null) / 333);

		int sps = isSSPossible() ? activeChar.getChargedSpiritShot() : 0;

		if(sps == 2)
		{
			hp *= 1.5;
			activeChar.unChargeShots(true);
		}
		else if(sps == 1)
		{
			hp *= 1.3;
			activeChar.unChargeShots(true);
		}
		L2Weapon weapon = activeChar.getActiveWeaponItem();

		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			L2Character target = n.getValue();
			if(target == null || target.isDead())
				continue;

			// Player holding a cursed weapon can't be healed and can't heal
			if(target != activeChar)
				if(target.isPlayer && target.isCursedWeaponEquipped())
					continue;
				else if(activeChar.isPlayer && activeChar.isCursedWeaponEquipped())
					continue;

			double newHp = hp * target.calcStat(Stats.HEAL_EFFECTIVNESS, 100, null, null) / 100;
			newHp *= activeChar.calcStat(Stats.HEAL_POWER, 100, null, null) / 100;
			target.setCurrentHp(newHp + target.getCurrentHp());
			if(target.isPlayer)
				target.sendPacket(new SystemMessage(SystemMessage.S1_HPS_HAVE_BEEN_RESTORED).addNumber((int) newHp));
			if(activeChar.isPlayer && activeChar != target)
				activeChar.sendPacket(new SystemMessage(SystemMessage.XS2S_HP_HAS_BEEN_RESTORED_BY_S1).addNumber((int) newHp).addString(target.getName()));
			getEffects(activeChar, target, getActivateRate() > 0);
			if(weapon != null)
				weapon.getEffect(false, activeChar, target, isOffensive());
		}
	}
}
