package l2r.gameserver.skills.skillclasses;

import javolution.util.FastList;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.model.instances.L2DoorInstance;
import l2r.gameserver.model.instances.L2SiegeHeadquarterquarterInstance;
import l2r.gameserver.serverpackets.SystemMessage;
import l2r.gameserver.templates.L2Weapon;
import l2r.gameserver.templates.StatsSet;

public class HealPercent extends L2Skill
{
	@Override
	public boolean checkCondition(L2Character activeChar, L2Character target, boolean forceUse, @SuppressWarnings("unused")
	boolean dontMove, boolean first)
	{
		if(target instanceof L2DoorInstance || target instanceof L2SiegeHeadquarterquarterInstance)
			return false;

		return super.checkCondition(activeChar, target, forceUse, dontMove, first);
	}

	public HealPercent(StatsSet set)
	{
		super(set);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		if(isSSPossible())
			activeChar.unChargeShots(isMagic());
		L2Weapon weapon = activeChar.getActiveWeaponItem();

		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			L2Character target = n.getValue();
			if(target.isDead())
				continue;

			double hp = target.getMaxHp() * _power / 100;

			target.stopEffect(_id);
			getEffects(activeChar, target, getActivateRate() > 0);

			target.setCurrentHp(hp + target.getCurrentHp());

			if(target.isPlayer)
				target.sendPacket(new SystemMessage(SystemMessage.S1_HPS_HAVE_BEEN_RESTORED).addNumber((int) hp));
			if(activeChar.isPlayer && activeChar != target)
				activeChar.sendPacket(new SystemMessage(SystemMessage.XS2S_HP_HAS_BEEN_RESTORED_BY_S1).addNumber((int) hp).addString(target.getName()));

			if(weapon != null)
				weapon.getEffect(false, activeChar, target, isOffensive());
		}
	}
}
