package l2r.gameserver.skills.skillclasses;

import javolution.util.FastList;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.skills.Formulas;
import l2r.gameserver.templates.L2Weapon;
import l2r.gameserver.templates.StatsSet;
import l2r.util.Rnd;

public class ManaDam extends L2Skill
{
	public ManaDam(StatsSet set)
	{
		super(set);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		int sps = isSSPossible() ? activeChar.getChargedSpiritShot() : 0;
		L2Weapon weapon = activeChar.getActiveWeaponItem();

		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			if(getActivateRate() > 0 && !Rnd.chance(getActivateRate()))
				continue;

			L2Character target = n.getValue();
			if(target.isDead())
				continue;

			if(target.checkReflectSkill(this))
				target = activeChar;

			double damage = _power;

			if(sps == 2)
				damage *= 1.5;
			else if(sps == 1)
				damage *= 1.3;

			boolean crit = Formulas.calcMCrit(activeChar.getCriticalMagic(target, this));

			target.reduceCurrentMp(crit ? damage * 4 : damage, activeChar);

			getEffects(activeChar, target, getActivateRate() > 0);

			if(weapon != null)
				weapon.getEffect(false, activeChar, target, isOffensive());
		}

		if(sps != 0)
			activeChar.unChargeShots(true);
	}
}