package l2r.gameserver.skills.skillclasses;

import javolution.util.FastList;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.serverpackets.SystemMessage;
import l2r.gameserver.templates.L2Weapon;
import l2r.gameserver.templates.StatsSet;

public class ManaHealPercent extends L2Skill
{
	public ManaHealPercent(StatsSet set)
	{
		super(set);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		if(isSSPossible())
			activeChar.unChargeShots(isMagic());
		L2Weapon weapon = activeChar.getActiveWeaponItem();

		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			L2Character target = n.getValue();
			if(target.isDead())
				continue;

			double mp = target.getMaxMp() * _power / 100;

			target.stopEffect(_id);
			getEffects(activeChar, target, getActivateRate() > 0);

			target.setCurrentMp(target.getCurrentMp() + mp);

			if(target.isPlayer)
				target.sendPacket(new SystemMessage(SystemMessage.S1_MPS_HAVE_BEEN_RESTORED).addNumber((int) mp));
			if(activeChar != target)
				activeChar.sendPacket(new SystemMessage(SystemMessage.XS2S_MP_HAS_BEEN_RESTORED_BY_S1).addNumber((int) mp).addString(target.getName()));

			if(weapon != null)
				weapon.getEffect(false, activeChar, target, isOffensive());
		}
	}
}