package l2r.gameserver.skills.skillclasses;

import javolution.util.FastList;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Effect;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.model.L2Effect.EffectType;
import l2r.gameserver.serverpackets.SystemMessage;
import l2r.gameserver.skills.effects.EffectSeed;
import l2r.gameserver.templates.StatsSet;

public class Seed extends L2Skill
{
	@Override
	public boolean checkCondition(L2Character activeChar, L2Character target, boolean forceUse, boolean dontMove, boolean first)
	{
		if(target == activeChar)
		{
			activeChar.sendPacket(new SystemMessage(SystemMessage.YOU_CANNOT_USE_THIS_ON_YOURSELF));
			return false;
		}
		return super.checkCondition(activeChar, target, forceUse, dontMove, first);
	}

	public Seed(StatsSet set)
	{
		super(set);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		if(isSSPossible())
			activeChar.unChargeShots(true);
		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			L2Character target = n.getValue();
			if(target.isDead())
				continue;

			L2Effect eff = target.getEffectByIndexAndType(_id, EffectType.SEED);
			if(eff == null)
			{
				getEffects(activeChar, target, getActivateRate() > 0);
				continue;
			}

			((EffectSeed) eff).increasePower();
			for(L2Effect e : target.getAllEffects())
				if(e.getEffectType() == EffectType.SEED)
					e.rescheduleEffectOnePeriod();
		}
	}
}
