package l2r.gameserver.skills.skillclasses;

import javolution.util.FastList;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Playable;
import l2r.gameserver.model.L2Player;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.model.L2World;
import l2r.gameserver.model.L2Character.HateInfo;
import l2r.gameserver.model.instances.L2NpcInstance;
import l2r.gameserver.templates.StatsSet;

public class ShiftAggression extends L2Skill
{
	public ShiftAggression(StatsSet set)
	{
		super(set);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		if(activeChar.getPlayer() == null)
			return;

		L2Playable playable = (L2Playable) activeChar;

		if(isSSPossible())
			activeChar.unChargeShots(isMagic());

		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			L2Character target = n.getValue();
			if(target == null || !target.isPlayer)
				continue;

			L2Player player_target = (L2Player) target;

			for(L2NpcInstance npc : L2World.getAroundNpc(activeChar, getSkillRadius(), 400))
			{
				HateInfo hateInfo = playable.getHateList().get(npc);
				if(hateInfo.hate <= 0)
					continue;
				player_target.addDamageHate(npc, 0, hateInfo.hate);
				hateInfo.hate = 0;
			}
		}
	}
}
