package l2r.gameserver.skills.skillclasses;

import javolution.util.FastList;
import l2r.gameserver.ThreadPoolManager;
import l2r.gameserver.model.L2Character;
import l2r.gameserver.model.L2Skill;
import l2r.gameserver.templates.StatsSet;

public class Turner extends L2Skill
{
	public Turner(StatsSet set)
	{
		super(set);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			L2Character target = n.getValue();
			if(target.isDead())
				continue;

			if(target.checkReflectSkill(this))
			{
				activeChar.setHeading(target, false);
				target = activeChar;
			}
			else
				target.setHeading(activeChar, false);

			target.setTarget(null);

			target.startFear();

			int posX = target.getX();
			int posY = target.getY();
			int posZ = target.getZ();
			int signx = -1;
			int signy = -1;

			if(target.getX() > activeChar.getX())
				signx = 1;
			if(target.getY() > activeChar.getY())
				signy = 1;

			target.setRunning();
			target.moveToLocation(posX + signx * 40, posY + signy * 40, posZ, 0, false);

			ThreadPoolManager.getInstance().scheduleGeneral(new StopFear(target), 1000);

			getEffects(activeChar, target, getActivateRate() > 0);
		}
	}

	public class StopFear implements Runnable
	{
		private L2Character _activeChar;

		public StopFear(L2Character activeChar)
		{
			_activeChar = activeChar;
		}

		public void run()
		{
			_activeChar.stopFear();
		}
	}
}
