package l2r.gameserver.tables;

import java.util.HashMap;

import l2r.gameserver.model.Reflection;

public class ReflectionTable
{
	private static ReflectionTable _instance;

	public static ReflectionTable getInstance()
	{
		if(_instance == null)
			_instance = new ReflectionTable();
		return _instance;
	}

	private HashMap<Integer, Reflection> _list = new HashMap<Integer, Reflection>();

	public void addReflection(Reflection r)
	{
		_list.put(r.getId(), r);
	}

	public void removeReflection(int id)
	{
		_list.remove(id);
	}

	public Reflection getById(int id, boolean CreateIfNonExist)
	{
		Reflection re = _list.get(id);
		if(CreateIfNonExist && re == null)
		{
			re = new Reflection(id);
			addReflection(re);
		}
		return re;
	}

	public Reflection getById(int id)
	{
		return _list.get(id);
	}
}