package l2r.gameserver.tables;

import java.util.ArrayList;

import l2r.gameserver.model.L2Skill;
import l2r.gameserver.skills.SkillsEngine;

@SuppressWarnings( { "nls", "unqualified-field-access", "boxing" })
public class SkillTable
{
	private static SkillTable _instance = new SkillTable();

	private L2Skill[] _skills;
	private ArrayList<L2Skill> _pledgeskills;
	private boolean _initialized = true;

	public static SkillTable getInstance()
	{
		return _instance;
	}

	private SkillTable()
	{
		_pledgeskills = new ArrayList<L2Skill>();
		_skills = new L2Skill[3000000];
		SkillsEngine.getInstance().loadAllSkills(_skills, _pledgeskills);
	}

	public void reload()
	{
		_instance = new SkillTable();
		SkillTreeTable.getInstance().reloadEnchant();
	}

	public boolean isInitialized()
	{
		return _initialized;
	}

	public L2Skill getInfo(int magicId, int level)
	{
		if(magicId > _skills.length || magicId <= 0 || level <= 0)
			return null;
		return _skills[magicId * 300 + level];
	}

	public L2Skill[] getPledgeSkills()
	{
		return _pledgeskills.toArray(new L2Skill[_pledgeskills.size()]);
	}

	public int getMaxLevel(int magicId, int curlevel)
	{
		int level = curlevel;

		while(level < 300)
		{
			level++;
			if(_skills[magicId * 300 + level] == null)
				return level - 1;
		}

		return level;
	}
	public static final int MAX_SKILL_COUNT = 26100;
	private int[] _baseLevels = new int[MAX_SKILL_COUNT];
	public int getBaseLevel(int magicId)
	{
		return _baseLevels[magicId];
	}
}