package l2r.loginserver.gameservercon.gspackets;

import java.security.MessageDigest;
import java.sql.ResultSet;
import java.util.logging.Logger;

import l2r.Base64;
import l2r.database.DatabaseUtils;
import l2r.database.FiltredPreparedStatement;
import l2r.database.L2DatabaseFactory;
import l2r.database.ThreadConnection;
import l2r.loginserver.gameservercon.AttGS;
import l2r.loginserver.gameservercon.lspackets.ChangePasswordResponse;

/**
 * @Author: Death
 * @Date: 8/2/2007
 * @Time: 15:33:15
 */
public class ChangePassword extends ClientBasePacket
{
	private static final Logger log = Logger.getLogger(ChangePassword.class.getName());

	public ChangePassword(byte[] decrypt, AttGS gameserver)
	{
		super(decrypt, gameserver);
	}

	@Override
	public void read()
	{
		String accname = readS();
		String oldPass = readS();
		String newPass = readS();

		String dbPassword = null;
		ThreadConnection con = null;
		FiltredPreparedStatement statement = null;
		ResultSet rs = null;
		try
		{
			con = L2DatabaseFactory.getInstance().getConnection();
			try
			{
				statement = con.prepareStatement("SELECT password FROM accounts WHERE login = ?");
				statement.setString(1, accname);
				rs = statement.executeQuery();
				if(rs.next())
					dbPassword = rs.getString("password");
			}
			catch(Exception e)
			{
				log.warning("Can't recive old password for account " + accname + ", exciption :" + e);
			}
			finally
			{
				DatabaseUtils.closeDatabaseSR(statement, rs);
			}

			//Encode old password and compare it to sended one, send packet to determine changed or not.
			try
			{
				MessageDigest md = MessageDigest.getInstance("SHA");
				byte[] op = oldPass.getBytes("UTF-8");
				op = md.digest(op);
				String oldP = Base64.encodeBytes(op);

				if(!oldP.equals(dbPassword))
				{
					ChangePasswordResponse cp1;
					cp1 = new ChangePasswordResponse(accname, false);
					sendPacket(cp1);
				}
				else
				{
					byte[] np = newPass.getBytes("UTF-8");
					np = md.digest(np);

					statement = con.prepareStatement("UPDATE accounts SET password = ? WHERE login = ?");
					statement.setString(1, Base64.encodeBytes(np));
					statement.setString(2, accname);
					statement.executeUpdate();

					ChangePasswordResponse cp1;
					cp1 = new ChangePasswordResponse(accname, true);
					sendPacket(cp1);
				}
			}
			catch(Exception e1)
			{
				e1.printStackTrace();
			}
			finally
			{
				DatabaseUtils.closeStatement(statement);
			}
		}
		catch(Exception e)
		{
			log.severe(e.getMessage());
		}
		finally
		{
			DatabaseUtils.closeConnection(con);
		}
	}
}
