#
# This ProGuard configuration file illustrates how to process ProGuard itself.
# Configuration files for typical applications will be very similar.
# Usage:
#     java -jar proguard.jar @proguard.pro
#

# Specify the input jars, output jars, and library jars.
# We'll filter out the Ant and WTK classes, keeping everything else.

-injars  ./build/lasteam-in.jar
-outjars ./build/lasteam.jar

-libraryjars <java.home>/lib/jce.jar
-libraryjars <java.home>/lib/resources.jar
-libraryjars <java.home>/lib/rt.jar

-libraryjars /lib/c3p0-0.9.1.2.jar
-libraryjars /lib/commons-lang.jar
-libraryjars /lib/commons-logging.jar
-libraryjars /lib/javax.servlet.jar
-libraryjars /lib/javolution.jar
-libraryjars /lib/jce.jar
-libraryjars /lib/mysql-connector-java-5.1.6-bin.jar
-libraryjars /lib/org.mortbay.jetty.jar
-libraryjars /lib/rrd4j-2.0.1.jar
-libraryjars /lib/tools.jar

# Write out an obfuscation mapping file, for de-obfuscating any stack traces
# later on, or for incremental obfuscation of extensions.

-printmapping proguard.map

# Allow methods with the same signature, except for the return type,
# to get the same obfuscation name.

-overloadaggressively

-useuniqueclassmembernames

# Put all obfuscated classes into the nameless root package.

-repackageclasses ''

-flattenpackagehierarchy  ''

# Allow classes and class members to be made public.

-allowaccessmodification

-mergeinterfacesaggressively

# -dontskipnonpubliclibraryclassmembers

# The entry point: L2GameServer and its main method.

-keep public class l2r.gameserver.GameServer {
    public static void main(java.lang.String[]);
}

-keep public class l2r.loginserver.L2LoginServer {
    public static void main(java.lang.String[]);
}

-keep public class l2r.accountmanager.SQLAccountManager {
    public static void main(java.lang.String[]);
}

-keep public class l2r.gsregistering.GameServerRegister {
    public static void main(java.lang.String[]);
}

-keep public class l2r.*Filter {
    public boolean isLoggable(java.util.logging.LogRecord);
}

# If you want to preserve the Ant task as well, you'll have to specify the
# main ant.jar.

#-libraryjars /usr/local/java/ant/lib/ant.jar
#-adaptresourcefilecontents proguard/ant/task.properties
#
#-keep,allowobfuscation class proguard.ant.*
#-keepclassmembers public class proguard.ant.* {
#    <init>(org.apache.tools.ant.Project);
#    public void set*(***);
#    public void add*(***);
#}

# If you want to preserve the WTK obfuscation plug-in, you'll have to specify
# the kenv.zip file.

#-libraryjars /usr/local/java/wtk2.1/wtklib/kenv.zip
#-keep public class proguard.wtk.ProGuardObfuscator
