CREATE TABLE IF NOT EXISTS `items` (
  `object_id` int(10) unsigned NOT NULL default '0',
  `owner_id` int(10) NOT NULL,
  `item_id` smallint(5) unsigned NOT NULL default '0',
  `name` VARCHAR(65) DEFAULT NULL,
  `count` BIGINT UNSIGNED NOT NULL default '0',
  `enchant_level` smallint(5) unsigned NOT NULL default '0',
  `class` ENUM('CONSUMABLE','MISC','EQUIPMENT','MATHERIALS','OTHER','PIECES','RECIPIES','SPELLBOOKS') NOT NULL DEFAULT 'OTHER',
  `loc` enum('CLANWH','CWH_BACK','FREIGHT','INVENTORY','LEASE','PAPERDOLL','PET','PET_EQUIP','VOID','WAREHOUSE','MONSTER') NOT NULL,
  `loc_data` int(11) default NULL,
  `price_sell` mediumint(8) unsigned NOT NULL default '0',
  `price_buy` mediumint(8) unsigned NOT NULL default '0',
  `time_of_use` mediumint(8) default NULL,
  `custom_type1` smallint(4) unsigned NOT NULL default '0',
  `custom_type2` smallint(4) unsigned NOT NULL default '0',
  `source` int(11) default NULL,
  `destination` int(11) default NULL,
  `create_type` varchar(255) default NULL,
  `create_time` int(11) default NULL,
  `shadow_life_time` smallint(5) NOT NULL default '0',
  `flags` int(11) NOT NULL default '0',
  PRIMARY KEY  (`object_id`),
  KEY `key_owner_id` (`owner_id`),
  KEY `key_loc` (`loc`),
  KEY `key_item_id` (`item_id`),
  KEY `key_class` (`class`),
  KEY `key_loc_data` (`loc_data`)
) TYPE=MyISAM;
