@echo off
TITLE Lasteam Setup
REM ######################################## Automatic updater for Lasteam - Do not edit !!!
goto answer%ERRORLEVEL%
:answerTrue
set fastend=yes
goto upgrade_db
:answer0
set fastend=no

set user=root
set pass=
set DBname=l2rdb
set DBHost=localhost

set Generaltables=accounts augmentations clanhall gameservers banned_ips loginserv_log character_friends character_hennas character_macroses character_quests character_recipebook character_shortcuts character_skills character_effects_save character_skills_save character_subclasses characters character_variables clanhall_bids clanhall_data clan_data clanhall_decorations_bids ally_data clan_wars items pets server_variables seven_signs seven_signs_festival siege_clans killcount dropcount craftcount game_log petitions seven_signs_status global_tasks raidboss_status manor_crop manor_seeds
set Ignore=--ignore-table=%DBname%.game_log --ignore-table=%DBname%.loginserv_log --ignore-table=%DBname%.petitions

REM ########################################
mysql.exe -h %DBHost% -u %user% --password=%pass% --execute="CREATE DATABASE IF NOT EXISTS %DBname%"
if not exist backup (
mkdir backup
)

REM ######################################## :main_menu
:main_menu
cls
echo.Lasteam Setup
echo.
echo.### Main Menu ###
echo.
echo.(1) Install Login Server
echo.(2) Install Game Server
echo.(3) Upgrade DB
echo.(4) Backup DB
echo.(5) Restore DB
echo.(6) Lost data in DB
echo.(7) Install option data
echo.(q) Quit
echo.
set button=x
set /p button=What do you want ?:
if /i %button%==1 goto Install_Login_Server_menu
if /i %button%==2 goto Install_Game_Server_menu
if /i %button%==3 goto upgrade_menu
if /i %button%==4 goto backup_menu
if /i %button%==5 goto restore_menu
if /i %button%==6 goto lost_data_menu
if /i %button%==7 goto install_option_data
if /i %button%==q goto end
goto main_menu

REM ######################################## :Install_Login_Server_menu
:Install_Login_Server_menu
cls
echo.Lasteam Setup
echo.
echo.### Install Login Server ###
echo.
echo.(i) Install Login Server. Warning !!! accounts, gameservers, banned_ips will be deleted !!!
echo.(m) Main menu
echo.(q) Quit
echo.
set button=x
set /p button=Your choice ?:
if /i %button%==i goto Install_Login_Server
if /i %button%==m goto main_menu
if /i %button%==q goto end
goto Install_Login_Server_menu

REM ######################################## :Install_Game_Server_menu
:Install_Game_Server_menu
cls
echo.Lasteam Setup
echo.
echo.### Install Game Server ###
echo.
echo.(i) Install Game Server. Warning !!! All Game Server Database will be deleted !!!
echo.(m) Main menu
echo.(q) Quit
echo.
set button=x
set /p button=Your choice ?:
if /i %button%==i goto Install_Game_Server
if /i %button%==m goto main_menu
if /i %button%==q goto end
goto Install_Game_Server_menu

REM ######################################## :upgrade_menu
:upgrade_menu
cls
echo.Lasteam Setup
echo.
echo.### Upgrade Menu ###
echo.
echo.(u) Upgrade Database
echo.(m) Main menu
echo.(q) Quit
echo.
set button=x
set /p button=Your choice ?:
if /i %button%==u goto upgrade_db
if /i %button%==m goto main_menu
if /i %button%==q goto end
goto upgrade_menu

REM ######################################## :backup_menu
:backup_menu
cls
echo.Lasteam Setup
echo.
echo.### Backup Menu ###
echo.
echo.(1) Full backup
echo.(2) General tables backup only
echo.(m) Main menu
echo.(q) Quit
echo.
set button=x
set /p button=Select backup type ?:
if /i %button%==1 goto full_backup
if /i %button%==2 goto general_backup
if /i %button%==m goto setup
if /i %button%==q goto end
goto backup_menu

REM ######################################## :restore_menu
:restore_menu
cls
echo.List all files in dir "/backup" !
echo.
dir backup /B /P
echo.
echo.Lasteam Setup
echo.
echo.### Restore Menu ###
echo.
echo.Enter a full filename do you want to restore to the database !
echo.(m) Main menu
echo.(q) Quit
echo.
set filename=x
set /p filename=Enter filename ?:
if /i %filename%==m goto main_menu
if /i %filename%==q goto end
if /i %filename%==%filename% goto restore_DB
goto restore_menu

REM ######################################## :lost_data_menu
:lost_data_menu
cls
echo.Lasteam Setup
echo.
echo.### Lost Data Menu ###
echo.
echo.(1) Show lost data
echo.(2) Delete lost data
echo.(m) Main menu
echo.(q) Quit
echo.
set button=x
set /p button=Select backup type ?:
if /i %button%==1 goto show_lost_data
if /i %button%==2 goto delete_lost_data
if /i %button%==m goto main_menu
if /i %button%==q goto end
goto lost_data_menu

:show_lost_data
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < tools/maintenance/lost_data_show.sql
pause
goto lost_data_menu

:delete_lost_data
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < tools/maintenance/lost_data_del.sql
echo.
echo.All lost data deleted !!!
echo.
pause
goto lost_data_menu

REM ######################################## :install_option_data
:install_option_data
cls
echo.Lasteam Setup
echo.
echo.### Install_option_data ###
echo.
echo.(1) Install TeleToGH SQL patch
echo.(m) Main menu
echo.(q) Quit
echo.
set button=x
set /p button=Your choice ?:
if /i %button%==1 goto Install_TeleToGH
if /i %button%==m goto main_menu
if /i %button%==q goto end
goto Install_TeleToGH

REM ######################################## :Install_TeleToGH
:Install_TeleToGH
echo.Installing TeleToGH SQL patch !!!
echo.
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < optional/teletogh/patch.sql
echo.
echo.TeleToGH SQL patch Installed !!!
echo.
pause
goto main_menu

REM ######################################## :Install_Login_Server
:Install_Login_Server
set ctime=%TIME:~0,2%
if "%ctime:~0,1%" == " " (
set ctime=0%ctime:~1,1%
)
set ctime=%ctime%'%TIME:~3,2%'%TIME:~6,2%
echo.
echo Making a full backup into %DATE%-%ctime%_backup_full.sql
echo.
mysqldump.exe %Ignore% --add-drop-table -h %DBHost% -u %user% --password=%pass% %DBname% > backup/%DATE%-%ctime%_backup_full.sql
echo.
echo.Installing Login Server !!!
echo.
echo  Table --   accounts.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < login/accounts.sql
echo  Table --   gameservers.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < login/gameservers.sql
echo  Table --   banned_ips.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < login/banned_ips.sql
echo  Table --   loginserv_log.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < login/loginserv_log.sql
echo.
echo.Login Server Installed !!!
echo.
pause
goto main_menu

REM ######################################## :Install_Game_Server
:Install_Game_Server
set ctime=%TIME:~0,2%
if "%ctime:~0,1%" == " " (
set ctime=0%ctime:~1,1%
)
set ctime=%ctime%'%TIME:~3,2%'%TIME:~6,2%
echo.
echo Making a full backup into %DATE%-%ctime%_backup_full.sql
echo.
mysqldump.exe %Ignore% --add-drop-table -h %DBHost% -u %user% --password=%pass% %DBname% > backup/%DATE%-%ctime%_backup_full.sql
echo.
echo.Installing general tables !!!
echo.
echo  Table --   castle.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/castle.sql
echo  Table --   siege_doorupgrade.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/siege_doorupgrade.sql
echo  Table --   siege_guards.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/siege_guards.sql
echo  Table --   character_friends.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_friends.sql
echo  Table --   character_blocklist.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_blocklist.sql
echo  Table --   character_hennas.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_hennas.sql
echo  Table --   character_macroses.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_macroses.sql
echo  Table --   chracter_quests.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_quests.sql
echo  Table --   character_recipebook.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_recipebook.sql
echo  Table --   character_shortcuts.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_shortcuts.sql
echo  Table --   character_skills.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_skills.sql
echo  Table --   character_effects_save.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_effects_save.sql
echo  Table --   character_skills_save.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_skills_save.sql
echo  Table --   character_subclasses.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_subclasses.sql
echo  Table --   characters.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/characters.sql
echo  Table --   character_variables.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/character_variables.sql
echo  Table --   clan_data.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/clan_data.sql
echo  Table --   chs_clans.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/chs_clans.sql
echo  Table --   ch_sieges.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/ch_sieges.sql
echo  Table --   cursed_weapons.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/cursed_weapons.sql
echo  Table --   ally_data.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/ally_data.sql
echo  Table --   clan_wars.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/clan_wars.sql
echo  Table --   clan_privs.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/clan_privs.sql
echo  Table --   clan_skills.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/clan_skills.sql
echo  Table --   clan_subpledges.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/clan_subpledges.sql
echo  Table --   items.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/items.sql
echo  Table --   augmentations.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/augmentations.sql
echo  Table --   items_delayed.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/items_delayed.sql
echo  Table --   pets.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/pets.sql
echo  Table --   server_variables.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/server_variables.sql
echo  Table --   seven_signs.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/seven_signs.sql
echo  Table --   seven_signs_festival.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/seven_signs_festival.sql
echo  Table --   siege_clans.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/siege_clans.sql
echo  Table --   killcount.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/killcount.sql
echo  Table --   dropcount.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/dropcount.sql
echo  Table --   craftcount.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/craftcount.sql
echo  Table --   game_log.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/game_log.sql
echo  Table --   petitions.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/petitions.sql
echo  Table --   seven_signs_status.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/seven_signs_status.sql
echo  Table --   global_tasks.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/global_tasks.sql
echo  Table --   raidboss_points.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/raidboss_points.sql
echo  Table --   raidboss_status.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/raidboss_status.sql
echo  Table --   forts.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/forts.sql
echo  Table --   forums.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/forums.sql
echo  Table --   posts.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/posts.sql
echo  Table --   topic.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/topic.sql
echo  Table --   manor_crop.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/manor_crop.sql
echo  Table --   manor_seeds.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/manor_seeds.sql
echo  Table --   kill_status.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/kill_status.sql
echo  Table --   bans.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/bans.sql
echo  Table --   bonus.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/bonus.sql
echo  Table --   auction.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/auction.sql
echo  Table --   auction_bid.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/auction_bid.sql
echo  Table --   clanhall.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/clanhall.sql
echo  Table --   clanhall_functions.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/clanhall_functions.sql
echo  Table --   couples.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/couples.sql
echo  Table --   olympiad_nobles.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/olympiad_nobles.sql
echo  Table --   castle_manor_procure.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/castle_manor_procure.sql
echo  Table --   castle_manor_production.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/castle_manor_production.sql
echo  Table --   tournament_table.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/tournament_table.sql
echo  Table --   tournament_teams.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/tournament_teams.sql
echo  Table --   tournament_variables.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < install/tournament_variables.sql

goto upgrade_db

REM ######################################## :upgrade_db
:upgrade_db
echo.
echo.Installing tables !!!
echo.
echo  Table --   ai_params.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/ai_params.sql
echo  Table --   armor.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/armor.sql
echo  Table --   armorsets.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/armorsets.sql
echo  Table --   siege_door.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/siege_door.sql
echo  Table --   char_templates.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/char_templates.sql
echo  Table --   class_list.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/class_list.sql
echo  Table --   doors.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/doors.sql
echo  Table --   droplist.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/droplist.sql
echo  Table --   etcitem.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/etcitem.sql
echo  Table --   enchant_skill_trees.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/enchant_skill_trees.sql
echo  Table --   henna.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/henna.sql
echo  Table --   henna_trees.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/henna_trees.sql
echo  Table --   locations.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/locations.sql
echo  Table --   lvlupgain.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/lvlupgain.sql
echo  Table --   mapregion.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/mapregion.sql
echo  Table --   merchant_areas_list.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/merchant_areas_list.sql
echo  Table --   minions.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/minions.sql
echo  Table --   nps.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/npc.sql
echo  Table --   npsskills.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/npcskills.sql
echo  Table --   pet_data.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/pet_data.sql
echo  Table --   skill_learn.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/skill_learn.sql
echo  Table --   skill_spellbooks.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/skill_spellbooks.sql
echo  Table --   skill_trees.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/skill_trees.sql
echo  Table --   spawnlist.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/spawnlist.sql
echo  Table --   weapon.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/weapon.sql
echo  Table --   zone.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/zone.sql
echo  Table --   zone_loc.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/zone_loc.sql
echo  Table --   random_spawn.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/random_spawn.sql
echo  Table --   random_spawn_loc.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/random_spawn_loc.sql
echo  Table --   recipes.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/recipes.sql
echo  Table --   recitems.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/recitems.sql
echo  Table --   fish.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/fish.sql
echo  Table --   fishreward.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/fishreward.sql
echo  Table --   auto_chat.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/auto_chat.sql
echo  Table --   auto_chat_text.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/auto_chat_text.sql
echo  Table --   heroes.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/heroes.sql
echo  Table --   dimensional_rift.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/dimensional_rift.sql
echo  Table --   tournament_class_list.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/tournament_class_list.sql
echo  Table --   updates.sql  .....Load
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < upgrade/updates.sql

echo.
echo.Complete !!!
echo.
if /I %fastend%==yes goto :EOF
pause
goto main_menu

REM ######################################## :full_backup
:full_backup
set ctime=%TIME:~0,2%
if "%ctime:~0,1%" == " " (
set ctime=0%ctime:~1,1%
)
set ctime=%ctime%'%TIME:~3,2%'%TIME:~6,2%
echo.
echo Making a full backup into %DATE%-%ctime%_backup_full.sql
echo.
mysqldump.exe %Ignore% --add-drop-table -h %DBHost% -u %user% --password=%pass% %DBname% > backup/%DATE%-%ctime%_backup_full.sql
goto end

REM ######################################## :general_backup
:general_backup
set ctime=%TIME:~0,2%
if "%ctime:~0,1%" == " " (
set ctime=0%ctime:~1,1%
)
set ctime=%ctime%'%TIME:~3,2%'%TIME:~6,2%
echo.
echo Making a general tables backup into %DATE%-%ctime%_backup_general.sql
echo.
mysqldump.exe %Ignore% --add-drop-table -h %DBHost% -u %user% --password=%pass% %DBname% %Generaltables% > backup/%DATE%-%ctime%_backup_general.sql
goto end

REM ######################################## :restore_DB
:restore_DB
if not exist backup/%filename% (
echo.
echo.File not found !
echo.
pause
goto restore_menu
)
cls
echo.
echo.Restore from file %filename% !
echo.
pause
mysql.exe -h %DBHost% -u %user% --password=%pass% -D %DBname% < backup/%filename%
goto end

REM ######################################## :not_working_now
:not_working_now
echo.
echo Not working NOW !!!
echo.
pause
goto main_menu

REM ######################################## :end
:end
