if [ -f mysql_pass.sh ]; then
        . mysql_pass.sh
else
        . mysql_pass.sh.default
fi

mysqldump --ignore-table=${DBNAME}.game_log --ignore-table=${DBNAME}.loginserv_log --ignore-table=${DBNAME}.petitions --add-drop-table -h $DBHOST -u $USER --password=$PASS $DBNAME > ${DBNAME}_upgrade_`date +%Y-%m-%d_%H:%M:%S`.sql

for tab in \
        upgrade/ai_params.sql \
		upgrade/armor.sql \
		upgrade/armorsets.sql \
		upgrade/siege_door.sql \
		upgrade/char_templates.sql \
		upgrade/class_list.sql \
		upgrade/doors.sql \
		upgrade/droplist.sql \
		upgrade/etcitem.sql \
		upgrade/enchant_skill_trees.sql \
		upgrade/henna.sql \
		upgrade/henna_trees.sql \
		upgrade/locations.sql \
		upgrade/lvlupgain.sql \
		upgrade/mapregion.sql \
		upgrade/merchant_areas_list.sql \
		upgrade/minions.sql \
		upgrade/npc.sql \
		upgrade/npcskills.sql \
		upgrade/pet_data.sql \
		upgrade/skill_learn.sql \
		upgrade/skill_spellbooks.sql \
		upgrade/skill_trees.sql \
		upgrade/spawnlist.sql \
		upgrade/weapon.sql \
		upgrade/zone.sql \
		upgrade/zone_loc.sql \
		upgrade/random_spawn.sql \
		upgrade/random_spawn_loc.sql \
		upgrade/recipes.sql \
		upgrade/recitems.sql \
		upgrade/fish.sql \
		upgrade/fishreward.sql \
		upgrade/auto_chat.sql \
		upgrade/auto_chat_text.sql \
		upgrade/heroes.sql \
		upgrade/dimensional_rift.sql \
		upgrade/tournament_class_list.sql \
		upgrade/updates.sql \
        ; do
                echo Loading $tab ...
                mysql -h $DBHOST -u $USER --password=$PASS -D $DBNAME < $tab
done

