DROP TABLE IF EXISTS `etcitem`;
CREATE TABLE `etcitem` (
  `item_id` smallint(4) unsigned NOT NULL default '0',
  `name` varchar(128) NOT NULL default '',
  `class` enum('CONSUMABLE','MISC','EQUIPMENT','MATHERIALS','OTHER','PIECES','RECIPIES','SPELLBOOKS') NOT NULL default 'OTHER',
  `crystallizable` enum('false','true') NOT NULL default 'false',
  `item_type` varchar(12) NOT NULL default '',
  `weight` int(11) NOT NULL default '0',
  `consume_type` varchar(12) NOT NULL default '',
  `material` varchar(12) NOT NULL default '',
  `crystal_type` enum('none','d','c','b','a','s') NOT NULL default 'none',
  `durability` int(11) NOT NULL default '0',
  `price` int(11) unsigned NOT NULL default '0',
  `crystal_count` int(11) NOT NULL default '0',
  `sellable` enum('false','true') NOT NULL default 'true',
  `skill_id` smallint(4) NOT NULL default '0',
  `skill_level` smallint(4) NOT NULL default '1',
  `icon` varchar(128) NOT NULL default '',
  `dropable` tinyint(1) NOT NULL default '1',
  `destroyable` tinyint(1) NOT NULL default '1',
  `tradeable` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`item_id`),
  KEY `class` (`class`)
) ENGINE=MyISAM;

INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(17,'Wooden Arrow','EQUIPMENT','false','arrow',6,'stackable','wood','none',0,2,0,'true',0,1,'etc_wooden_quiver_i00',1,1,1),
(57,'Adena','OTHER','false','none',0,'asset','gold','none',0,1,0,'false',0,1,'etc_adena_i00',1,1,1),
(65,'Red Potion','CONSUMABLE','false','potion',80,'stackable','liquid','none',0,40,0,'true',2001,1,'etc_potion_red_i00',1,1,1),
(686,'Chair','OTHER','false','none',100,'normal','wood','none',90,1000,0,'false',0,1,'etc_branch_blue_i00',1,1,1),
(687,'Darin''s Letter','OTHER','false','quest',0,'normal','paper','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(688,'Roxxy''s Kerchief','OTHER','false','quest',0,'normal','cloth','none',100,0,0,'false',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(689,'Poetry Book','OTHER','false','quest',0,'normal','paper','none',100,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(690,'Lyrics Book','OTHER','false','quest',0,'normal','paper','none',100,0,0,'false',0,1,'item_normal06',1,1,1),
(691,'Romance Novel','OTHER','false','quest',0,'normal','paper','none',100,0,0,'false',0,1,'item_normal07',1,1,1),
(692,'Arujien''s Letter','OTHER','false','quest',0,'normal','paper','none',100,0,0,'false',0,1,'item_canuse37',1,1,1),
(693,'Greenis''s Letter','OTHER','false','quest',0,'normal','paper','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(694,'Ingredient List','OTHER','false','quest',0,'normal','paper','none',100,0,0,'false',0,1,'item_normal37',1,1,1),
(695,'Omen Beast''s Blood','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse48',1,1,1),
(696,'Mana Seeker''s Husk','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal30',1,1,1),
(697,'Gargoyle''s Horn','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal24',1,1,1),
(698,'Gilbert''s List','OTHER','false','quest',0,'normal','steel','none',100,0,0,'false',0,1,'item_normal37',1,1,1),
(699,'Orc''s Nose','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse05',1,1,1),
(700,'Hobgoblin Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal05',1,1,1),
(701,'Fungus Juice','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse28',1,1,1),
(702,'Wolf Pelt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leather_brown_i00',1,1,1),
(703,'Poison Sac','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(704,'Fever Medicine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_purple_i00',1,1,1),
(705,'Orc''s Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal48',1,1,1),
(706,'Basilisk''s Claw','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal141',1,1,1),
(707,'Spore Sac','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(708,'Sylph Headband','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_system03',1,1,1),
(709,'Leather Shirt','OTHER','false','none',400,'normal','leather','none',100,0,0,'false',0,1,'armor_leather_shirt_i00',1,1,1),
(710,'Hard Leather Shirt','OTHER','false','none',400,'normal','leather','none',100,0,0,'false',0,1,'icon.armor_leather_shirt_i00',1,1,1),
(711,'Piece Bone Breastplate','OTHER','false','none',800,'normal','bone','none',100,0,0,'false',0,1,'icon.armor_mithril_banded_mail_i00',1,1,1),
(712,'Half Plate Armor','OTHER','false','none',1200,'normal','steel','none',100,0,0,'false',0,1,'icon.armor_dwarven_scale_mail_i00',1,1,1),
(713,'Leather Pants','OTHER','false','none',250,'normal','leather','none',100,0,0,'false',0,1,'armor_squires_pants_i00',1,1,1),
(714,'Hard Leather Pants','OTHER','false','none',300,'normal','leather','none',100,0,0,'false',0,1,'armor_leather_pants_i00',1,1,1),
(715,'Piece Bone Gaiters','OTHER','false','none',500,'normal','bone','none',100,0,0,'false',0,1,'icon.armor_mithril_banded_gaiters_i00',1,1,1),
(716,'Plate Gaiters','OTHER','false','none',800,'normal','steel','none',100,0,0,'false',0,1,'icon.armor_dwarven_scale_mail_i00',1,1,1),
(717,'Leather Gloves','OTHER','false','none',100,'normal','leather','none',100,0,0,'false',0,1,'icon.armor_gauntlet_i00',1,1,1),
(718,'Hard Leather Gloves','OTHER','false','none',150,'normal','leather','none',100,0,0,'false',0,1,'armor_gauntlet_i00',1,1,1),
(719,'Crafted Leather Gloves','OTHER','false','none',150,'normal','leather','none',100,0,0,'false',0,1,'icon.armor_gauntlet_i00',1,1,1),
(720,'Reinforced Gloves','OTHER','false','none',200,'normal','steel','none',100,0,0,'false',0,1,'armor_gauntlet_i00',1,1,1),
(721,'Leather Boots','OTHER','false','none',150,'normal','leather','none',100,0,0,'false',0,1,'icon.armor_iron_boots_i00',1,1,1),
(722,'Hard Leather Boots','OTHER','false','none',150,'normal','leather','none',100,0,0,'false',0,1,'armor_iron_boots_i00',1,1,1),
(723,'Crafted Leather Boots','OTHER','false','none',200,'normal','leather','none',100,0,0,'false',0,1,'armor_feet99',1,1,1),
(724,'Reinforced Boots','OTHER','false','none',250,'normal','steel','none',100,0,0,'false',0,1,'armor_iron_boots_i00',1,1,1),
(725,'Healing Drug','CONSUMABLE','false','potion',180,'stackable','liquid','none',0,50,0,'true',2002,1,'etc_potion_red_i00',1,1,1),
(726,'Mana Drug','CONSUMABLE','false','potion',180,'stackable','liquid','none',0,80,0,'true',2003,1,'etc_potion_blue_i00',1,1,1),
(727,'Healing Potion','CONSUMABLE','false','potion',180,'stackable','liquid','none',0,1000,0,'true',0,1,'icon.item_system03',1,1,1),
(728,'Mana Potion','CONSUMABLE','false','potion',180,'stackable','liquid','none',0,2000,0,'true',9007,1,'etc_reagent_blue_i00',1,1,1),
(729,'Scroll: Enchant Weapon (A)','OTHER','false','scroll',120,'stackable','paper','none',0,1800000,0,'true',0,1,'etc_scroll_of_enchant_weapon_i04',1,1,1),
(730,'Scroll: Enchant Armor (A)','OTHER','false','scroll',120,'stackable','paper','none',0,240000,0,'true',0,1,'etc_scroll_of_enchant_armor_i04',1,1,1),
(731,'Crystal Scroll: Enchant Weapon (A)','OTHER','false','scroll',120,'stackable','paper','none',0,240000,0,'true',0,1,'etc_scroll_of_enchant_weapon_i01',1,1,1),
(732,'Crystal Scroll: Enchant Armor (A)','OTHER','false','scroll',120,'stackable','paper','none',0,240000,0,'true',0,1,'etc_scroll_of_enchant_armor_i01',1,1,1),
(733,'Endeavor Potion','CONSUMABLE','false','potion',180,'stackable','liquid','none',0,500,0,'true',0,1,'etc_lesser_potion_yellow_i00',1,1,1),
(734,'Haste Potion','CONSUMABLE','false','potion',20,'stackable','liquid','none',0,1200,0,'true',2011,1,'etc_potion_green_i00',1,1,1),
(735,'Potion of Alacrity','CONSUMABLE','false','potion',20,'stackable','liquid','none',0,2400,0,'true',2012,1,'etc_reagent_green_i00',1,1,1),
(736,'Scroll of Escape','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,400,0,'true',2013,1,'etc_scroll_of_return_i00',1,1,1),
(737,'Scroll of Resurrection','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,2000,0,'true',2014,1,'etc_scroll_of_resurrection_i00',1,1,1),
(739,'Broken Sword Handle','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_small_sword_i00',1,1,1),
(740,'Broken Blade Bottom','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_great_sword_i00',1,1,1),
(741,'Broken Blade Top','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_sword_body_i00',1,1,1),
(742,'Altran''s Note','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(745,'Cobendell Medicine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal40',1,1,1),
(746,'Alberius''s List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(750,'Kinship Crystal','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal45',1,1,1),
(751,'Cracked Kinship Crystal','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse07',1,1,1),
(752,'Orc Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_feather_gold_i00',1,1,1),
(753,'Silverleaf Brooch','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal12',1,1,1),
(755,'Colleen''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(756,'Mandragora Root','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal17',1,1,1),
(757,'Mandragora Essence','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse28',1,1,1),
(758,'Colleen''s Receipt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal50',1,1,1),
(759,'Etched Rune Sword','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_1hs21',1,1,1),
(760,'Macabre Sword','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_1hs20',1,1,1),
(761,'Thanatos Sword','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_2hs02',1,1,1),
(762,'Gray Bone Chip','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal05',1,1,1),
(763,'Esther''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(764,'Arbon''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(765,'Conspirator List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse15',1,1,1),
(766,'Sabrin''s Signet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'armor_finger02',1,1,1),
(767,'Sealed Scroll','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse15',1,1,1),
(768,'Oyen''s Key','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal26',1,1,1),
(769,'Ricardo''s Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'armor_head15',1,1,1),
(770,'Shield of Honor','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_voodoo_doll_i00',1,1,1),
(771,'Saythus''s Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal05',1,1,1),
(772,'Trayer''s Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal05',1,1,1),
(773,'Falimar''s Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal05',1,1,1),
(774,'Fallen Sword of Honor','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_1hs04',1,1,1),
(775,'Sword of Honor','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_1hs05',1,1,1),
(776,'Nameless Sword','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_1hs23',1,1,1),
(777,'Sword of Black Ice','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_1hs11',1,1,1),
(778,'Arodin''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(779,'Sabrin''s Ring','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'armor_finger01',1,1,1),
(780,'Arbon''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(781,'Madclaw''s Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'armor_neck02',1,1,1),
(782,'Alex''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(783,'Alex''s Receipt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal50',1,1,1),
(784,'Glass Dagger','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_ss02',1,1,1),
(785,'Broken Glass Dagger','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_ss03',1,1,1),
(786,'Shadowguard Dagger','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_ss04',1,1,1),
(787,'Coroli''s Key','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal26',1,1,1),
(788,'Midnight Onyx Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'armor_neck01',1,1,1),
(789,'Song: Moonlight Whisper','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse34',1,1,1),
(790,'Bloodsteel Kris','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_ss09',1,1,1),
(791,'Karlun''s Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'armor_head15',1,1,1),
(792,'Karlun''s Rib Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal05',1,1,1),
(793,'Karlun''s Thigh Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal05',1,1,1),
(794,'Saint''s Ash Urn','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal40',1,1,1),
(795,'Mace of Athebaldt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_mace13',1,1,1),
(796,'Roien''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(797,'Manuel''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal06',1,1,1),
(798,'Varan''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(799,'Groot''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(800,'Tome of Nassen','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal07',1,1,1),
(801,'Cursed Tome of Nassen','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal06',1,1,1),
(802,'Bloodthirsty Dagger','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_ss09',1,1,1),
(803,'Bloody Dagger','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_ss03',1,1,1),
(804,'Staff of Shane','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_mace24',1,1,1),
(805,'Pinter''s Bill','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal50',1,1,1),
(806,'Drake''s Claw','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal36',1,1,1),
(807,'Flawless Drake''s Claw','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal24',1,1,1),
(808,'Pushkin''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(809,'Bone Fragment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_white_i00',1,1,1),
(810,'Altran''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal06',1,1,1),
(811,'Oil Paper','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal37',1,1,1),
(812,'Adamantium Ore','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal47',1,1,1),
(813,'Heart Stone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal42',1,1,1),
(814,'Pushkin''s Receipt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal50',1,1,1),
(815,'Leather Strap','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal01',1,1,1),
(816,'Widow Maker','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.weapon_1hs20',1,1,1),
(817,'Mithril Bottle','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse22',1,1,1),
(818,'Grace Unicorn''s Horn','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal11',1,1,1),
(819,'Drake''s Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal05',1,1,1),
(820,'Zahak Fluids','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse28',1,1,1),
(821,'Bone Knife','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_ss04',1,1,1),
(822,'Drake Knife','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_ss10',1,1,1),
(823,'Dull Dagger','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_ss01',1,1,1),
(824,'Siriel''s Note','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal50',1,1,1),
(825,'Raien''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(826,'Silver Spores','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse40',1,1,1),
(827,'Star Dust','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal40',1,1,1),
(828,'Song of Awakening','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse15',1,1,1),
(829,'Spirit Dagger','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_ss09',1,1,1),
(830,'Medallion of Kwyllinas','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'armor_neck03',1,1,1),
(831,'Echo Crystal','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse09',1,1,1),
(832,'Green Echo Crystal','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal16',1,1,1),
(833,'Red Echo Crystal','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal44',1,1,1),
(834,'Aquamarine Echo Crystal','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal19',1,1,1),
(835,'Blue Echo Crystal','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal47',1,1,1),
(836,'Book of Kwyllinas','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal07',1,1,1),
(837,'Fairy Dust','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse43',1,1,1),
(838,'Vellior''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(839,'Icarus''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(840,'Drevanul Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'armor_head15',1,1,1),
(841,'Icarus''s Order Form','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(842,'Basilisk Ink','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse27',1,1,1),
(843,'Book of Aklantoth','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal06',1,1,1),
(844,'Book of Aklantoth P1 ~ P10','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal07',1,1,1),
(937,'Directions to Ruins','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(938,'Deck','OTHER','false','quest',0,'normal','silver','none',95,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(939,'Gara''s Quest Item #11','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal52',1,1,1),
(940,'Gara''s Quest Item #12','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal52',1,1,1),
(941,'Gara''s Proof of Bravery','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal52',1,1,1),
(942,'Gara''s Proof of Justice','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal52',1,1,1),
(943,'Gara''s Proof of Despair','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal52',1,1,1),
(944,'Deathknight Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'armor_head15',1,1,1),
(947,'Scroll: Enchant Weapon (B)','OTHER','false','scroll',120,'stackable','paper','none',0,500000,0,'true',0,1,'etc_scroll_of_enchant_weapon_i03',1,1,1),
(948,'Scroll: Enchant Armor (B)','OTHER','false','scroll',120,'stackable','paper','none',0,80000,0,'true',0,1,'etc_scroll_of_enchant_armor_i03',1,1,1),
(949,'Crystal Scroll: Enchant Weapon (B)','OTHER','false','scroll',120,'stackable','paper','none',0,80000,0,'true',0,1,'etc_scroll_of_enchant_weapon_i01',1,1,1),
(950,'Crystal Scroll: Enchant Armor (B)','OTHER','false','scroll',120,'stackable','paper','none',0,80000,0,'true',0,1,'etc_scroll_of_enchant_armor_i01',1,1,1),
(951,'Scroll: Enchant Weapon (C)','OTHER','false','scroll',120,'stackable','paper','none',0,110000,0,'true',0,1,'etc_scroll_of_enchant_weapon_i02',1,1,1),
(952,'Scroll: Enchant Armor (C)','OTHER','false','scroll',120,'stackable','paper','none',0,15000,0,'true',0,1,'etc_scroll_of_enchant_armor_i02',1,1,1),
(953,'Crystal Scroll: Enchant Weapon (C)','OTHER','false','scroll',120,'stackable','paper','none',0,15000,0,'true',0,1,'etc_scroll_of_enchant_weapon_i01',1,1,1),
(954,'Crystal Scroll: Enchant Armor (C)','OTHER','false','scroll',120,'stackable','paper','none',0,15000,0,'true',0,1,'etc_scroll_of_enchant_armor_i01',1,1,1),
(955,'Scroll: Enchant Weapon (D)','OTHER','false','scroll',120,'stackable','paper','none',0,50000,0,'true',0,1,'etc_scroll_of_enchant_weapon_i01',1,1,1),
(956,'Scroll: Enchant Armor (D)','OTHER','false','scroll',120,'stackable','paper','none',0,6000,0,'true',0,1,'etc_scroll_of_enchant_armor_i01',1,1,1),
(957,'Crystal Scroll: Enchant Weapon (D)','OTHER','false','scroll',120,'stackable','paper','none',0,6000,0,'true',0,1,'etc_scroll_of_enchant_weapon_i01',1,1,1),
(958,'Crystal Scroll: Enchant Armor (D)','OTHER','false','scroll',120,'stackable','paper','none',0,6000,0,'true',0,1,'etc_scroll_of_enchant_armor_i01',1,1,1),
(959,'Scroll: Enchant Weapon (S)','OTHER','false','scroll',120,'stackable','paper','none',0,5000000,0,'true',0,1,'etc_scroll_of_enchant_weapon_i05',1,1,1),
(960,'Scroll: Enchant Armor (S)','OTHER','false','scroll',120,'stackable','paper','none',0,500000,0,'true',0,1,'etc_scroll_of_enchant_armor_i05',1,1,1),
(961,'Crystal Scroll: Enchant Weapon (S)','OTHER','false','scroll',120,'stackable','paper','none',0,500000,0,'true',0,1,'etc_scroll_of_enchant_weapon_i01',1,1,1),
(962,'Crystal Scroll: Enchant Armor (S)','OTHER','false','scroll',120,'stackable','paper','none',0,500000,0,'true',0,1,'etc_scroll_of_enchant_armor_i01',1,1,1),
(963,'Orcish Arrowhead','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_winged_spear_i00',1,1,1),
(964,'Alberius''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(965,'Evergreen Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_near_forest_necklace_i00',1,1,1),
(966,'Dryad''s Tears','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_green_i00',1,1,1),
(967,'Cobendell Medicine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse24',1,1,1),
(968,'Karrod''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(969,'Cecktinon''s First Voucher','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(970,'Cecktinon''s Second Voucher','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(971,'Soul Catcher','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_voodoo_doll_i00',1,1,1),
(972,'Preserving Oil','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_clear_i00',1,1,1),
(973,'Zombie Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(974,'Steelbender Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(976,'1st Mark of Sentinel','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_system03',1,1,1),
(977,'2nd Mark of Sentinel','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_system03',1,1,1),
(978,'Skullcrusher Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal145',1,1,1),
(979,'Bloodspear Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal89',1,1,1),
(980,'0','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.weapon_mace23',1,1,1),
(982,'Esrandell''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(983,'Kendell''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(984,'1st Onyx Talisman','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_sages_necklace_i00',1,1,1),
(985,'2nd Onyx Talisman','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_sages_necklace_i00',1,1,1),
(986,'Ancient Scroll','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(987,'Ancient Clay Tablet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_plate_glay_i00',1,1,1),
(988,'Kartia''s Translation','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(1001,'Book of Aklantoth - Part 4','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal07',1,1,1),
(1002,'Book of Aklantoth - Part 5','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal07',1,1,1),
(1003,'Book of Aklantoth - Part 6','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal07',1,1,1),
(1004,'Book of Aklantoth - Part 7','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal07',1,1,1),
(1005,'Book of Aklantoth - Part 8','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal07',1,1,1),
(1006,'Book of Aklantoth - Part 9','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal07',1,1,1),
(1007,'Book of Aklantoth - Part 10','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal07',1,1,1),
(1008,'Harrys''s 1st Receipt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(1009,'Harrys''s 2nd Receipt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(1010,'Golem Shard','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lump_black_i00',1,1,1),
(1011,'Tool Box','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(1012,'Delivery List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1013,'Heavy Wood Box','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(1014,'Cloth Bundle','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_cloth_blue_i00',1,1,1),
(1015,'Clay Pot','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(1016,'Jackson''s Receipt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1017,'Silvia''s Receipt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(1018,'Rant''s Receipt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(1019,'official Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1020,'Flame Shard','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(1021,'Ice Shard','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(1022,'Lilith''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1023,'Theon''s Diary','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(1024,'Adamantite Ore','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_plate_blue_i00',1,1,1),
(1025,'Clay Tablet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_plate_glay_i00',1,1,1),
(1026,'Silvery Spidersilk','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skein_white_i00',1,1,1),
(1027,'Unoren''s Receipt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(1028,'Creamees''s Ticket','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ticket_blue_i00',1,1,1),
(1029,'Nightshade Leaf','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_herb_blue_i00',1,1,1),
(1030,'Cracked Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(1031,'Perfect Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(1032,'Fox Fur','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_mane_i00',1,1,1),
(1033,'Fox Fur Yarn','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skein_gray_i00',1,1,1),
(1034,'Maiden Doll','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_red_i00',1,1,1),
(1035,'Plague Dust','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_powder_red_i00',1,1,1),
(1036,'Andellia''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(1037,'Fruit of The Mother Tree','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fruit_green_i00',1,1,1),
(1038,'Rumiel''s 1st Poem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(1039,'Rumiel''s 2nd Poem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(1040,'Rumiel''s 3rd Poem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(1041,'Rumiel''s 4th Poem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(1042,'Wererat''s Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1043,'Varool Foulclaw''s Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(1044,'Kirunak Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(1045,'Zombie''s Skin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bark_gold_i00',1,1,1),
(1046,'Nightmare Crystal','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_black_i00',1,1,1),
(1047,'Spellbook: Light','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,100,0,'true',0,1,'etc_spell_books_blue_i00',1,1,1),
(1048,'Spellbook: Might','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,100,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1049,'Spellbook: Ice Bolt','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,100,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(1050,'Spellbook: Battle Heal','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,100,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(1051,'Spellbook: Vampiric Touch','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,100,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(1052,'Spellbook: Flame Strike','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,500,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(1053,'Spellbook: Cure Poison','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,500,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(1054,'Spellbook: Group Heal','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,500,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(1055,'Spellbook: Curse: Poison','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,500,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(1056,'Spellbook: Curse: Weakness','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,500,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(1057,'Spellbook: Summon Meal','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,500,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1058,'Spellbook: Shield','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,500,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1059,'Spellbook: Know Enemy','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,500,0,'true',0,1,'etc_spell_books_blue_i00',1,1,1),
(1060,'Lesser Healing Potion','CONSUMABLE','false','potion',5,'stackable','liquid','none',0,90,0,'true',2031,1,'etc_lesser_potion_red_i00',1,1,1),
(1061,'Healing Potion','CONSUMABLE','false','potion',5,'stackable','liquid','none',0,330,0,'true',2032,1,'etc_potion_scarlet_i00',1,1,1),
(1062,'Haste Potion','CONSUMABLE','false','potion',180,'stackable','liquid','none',0,5000,0,'true',2033,1,'icon.etc_reagent_green_i00',1,1,1),
(1063,'Tutorial Parchment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse15',1,1,1),
(1064,'Tutorial Parchment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse15',1,1,1),
(1065,'Tutorial Parchment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse15',1,1,1),
(1066,'Tutorial Parchment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse15',1,1,1),
(1067,'Recommendation','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(1068,'Recommendation','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(1069,'Leaf of the Mother Tree','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leaf_green_i00',1,1,1),
(1070,'Blood of Mitraell','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spirit_bullet_red_i00',1,1,1),
(1071,'Hyacinth Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_green_i00',1,1,1),
(1072,'Hyacinth Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_green_i00',1,1,1),
(1073,'Beginner''s Potion','CONSUMABLE','false','potion',5,'stackable','liquid','none',0,0,0,'false',2001,1,'etc_potion_red_i00',1,1,1),
(1074,'Boat Ticket: Talking Island to Gludin','OTHER','false','none',20,'stackable','paper','none',0,2000,0,'true',0,1,'etc_ticket_red_i00',1,1,1),
(1075,'Boat Ticket: Gludin to Talking Island','OTHER','false','none',20,'stackable','paper','none',0,2000,0,'true',0,1,'etc_ticket_blue_i00',1,1,1),
(1076,'Carlon''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(1077,'Venom Sac','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(1078,'Wind Shard','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_white_i00',1,1,1),
(1079,'Darin''s Receipt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1080,'Baulro''s Potion','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_blue_i00',1,1,1),
(1081,'Omen Beast''s Eye','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(1082,'Taint Stone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_black_i00',1,1,1),
(1083,'Succubus Blood','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_red_i00',1,1,1),
(1084,'Gludio Lord''s Mark','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_gold_i00',1,1,1),
(1085,'Orc''s Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_necklace_of_anguish_i00',1,1,1),
(1086,'Werewolf''s Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1087,'Giant Spider Leg','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(1088,'Undrias''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(1089,'Ceremonial Dagger','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_mystic_knife_i00',1,1,1),
(1090,'Dreviant Wine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_purple_i00',1,1,1),
(1091,'Garmiel''s Scripture','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(1092,'Arujien''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(1093,'Arujien''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(1094,'Arujien''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1095,'Spellbook: Attack Aura','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,75,0,'true',0,1,'etc_spell_books_defighter_i00',1,1,1),
(1096,'Spellbook: Elemental Heal','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,550,0,'true',0,1,'etc_spell_books_efighter_i00',1,1,1),
(1097,'Spellbook: Drain Health','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,550,0,'true',0,1,'etc_spell_books_defighter_i00',1,1,1),
(1098,'Spellbook: Wind Walk','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,500,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1099,'Spellbook: Wind Shackle','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,500,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(1106,'Norman''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(1107,'Bone Fragment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_white_i00',1,1,1),
(1108,'Arbon''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(1109,'Roien''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal20',1,1,1),
(1110,'Bone Fragment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal05',1,1,1),
(1111,'Adamantite Ore','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal49',1,1,1),
(1112,'Leaf of the Mother Tree','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leaf_green_i00',1,1,1),
(1113,'Blood of Mitraell','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse48',1,1,1),
(1114,'Orc Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_feather_gold_i00',1,1,1),
(1115,'Orc''s Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_necklace_of_anguish_i00',1,1,1),
(1116,'Orc Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_feather_gold_i00',1,1,1),
(1117,'Orc''s Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_necklace_of_anguish_i00',1,1,1),
(1118,'Spore Sac','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(1130,'Cobendell''s Medicine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_green_i00',1,1,1),
(1131,'Cobendell''s Medicine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_green_i00',1,1,1),
(1132,'Cobendell''s Medicine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_green_i00',1,1,1),
(1133,'Cobendell''s Medicine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_green_i00',1,1,1),
(1134,'Cobendell''s Medicine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_green_i00',1,1,1),
(1135,'Spiritbound Wand','OTHER','false','quest',0,'normal','steel','none',100,0,0,'false',0,1,'weapon_club_i01',1,1,1),
(1136,'Spiritbound Wand','OTHER','false','quest',0,'normal','steel','none',100,0,0,'false',0,1,'weapon_club_i01',1,1,1),
(1137,'Spiritbound Wand','OTHER','false','quest',0,'normal','steel','none',100,0,0,'false',0,1,'weapon_club_i01',1,1,1),
(1138,'Auron''s Letter','OTHER','false','quest',0,'normal','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(1139,'Warrior Guild Mark','OTHER','false','quest',0,'normal','steel','none',100,0,0,'false',0,1,'etc_badge_gold_i00',1,1,1),
(1140,'Rusted Bronze Sword','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_broad_sword_i00',1,1,1),
(1141,'Rusted Bronze Sword','OTHER','false','quest',0,'normal','steel','none',100,0,0,'false',0,1,'weapon_broad_sword_i00',1,1,1),
(1143,'Simplon''s Letter','OTHER','false','quest',0,'normal','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(1144,'Venomous Spider Leg','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(1145,'Medallion of Warrior','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_earing_of_protection_i00',1,1,1),
(1150,'Spellbook: Wind Strike','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,50,0,'true',0,1,'etc_spell_books_blue_i00',1,1,1),
(1151,'Spellbook: Self Heal','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,50,0,'true',0,1,'etc_spell_books_blue_i00',1,1,1),
(1152,'Spellbook: Heal','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,100,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(1153,'Jenna''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(1154,'Sentry Blade','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_bastard_sword_i00',1,1,1),
(1155,'Sentry Blade','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_bastard_sword_i00',1,1,1),
(1156,'Sentry Blade','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_bastard_sword_i00',1,1,1),
(1157,'Old Bronze Sword','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_crimson_sword_i00',1,1,1),
(1158,'Bone Fragment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_red_i00',1,1,1),
(1159,'Elf Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(1160,'Dark Bezoar','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_gold_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(1161,'Sword of Ritual','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_flamberge_i00',1,1,1),
(1162,'Coin of Lords','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_silver_i00',1,1,1),
(1163,'Coin of Lords','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_silver_i00',1,1,1),
(1164,'Coin of Lords','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_silver_i00',1,1,1),
(1165,'Coin of Lords','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_silver_i00',1,1,1),
(1166,'Coin of Lords','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_silver_i00',1,1,1),
(1167,'Coin of Lords','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_silver_i00',1,1,1),
(1168,'Gludio Guard''s 1st Badge','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_badge_silver_i00',1,1,1),
(1169,'Bugbear Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_necklace_red_i00',1,1,1),
(1170,'Einhasad''s 1st Temple Badge','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_earing_of_holy_spirit_i00',1,1,1),
(1171,'Einhasad''s Crucifix','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_necklace_of_knowledge_i00',1,1,1),
(1172,'Gludio Guard''s 2nd Badge','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_badge_silver_i00',1,1,1),
(1173,'Venomous Spider Leg','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(1174,'Einhasad''s 2nd Temple Badge','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_earing_of_holy_spirit_i00',1,1,1),
(1175,'Lizardman''s Totem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_green_i00',1,1,1),
(1176,'Gludio Guard''s 3rd Badge','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_badge_silver_i00',1,1,1),
(1177,'Giant Spider''s Husk','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leather_gray_i00',1,1,1),
(1178,'Einhasad''s 3rd Temple Badge','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_earing_of_holy_spirit_i00',1,1,1),
(1179,'Skull of Silent Horror','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(1180,'Bezique''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(1183,'Spartoi''s Bones','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_black_i00',1,1,1),
(1184,'Horseshoe of Light','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_red_cresent_earing_i00',1,1,1),
(1185,'Most Wanted List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(1186,'Stolen Jewelry','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(1187,'Stolen Tomes','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(1188,'Stolen Ring','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_ring_of_grace_i00',1,1,1),
(1189,'Stolen Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_necklace_of_blessing_i00',1,1,1),
(1190,'Bezique''s Recommendation','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1191,'1st Letter of Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(1192,'2nd Letter of Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(1193,'Lionel''s Book','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(1194,'Book of Vivyan','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(1195,'Book of Simplon','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(1196,'Book of Praga','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(1197,'Certificate of Gallint','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(1198,'Pendant of Mother','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_blessed_earing_i00',1,1,1),
(1199,'Necklace of Mother','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_blessed_necklace_i00',1,1,1),
(1200,'Lionel''s Covenant','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1201,'Mark of Faith','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_earing_of_wisdom_i00',1,1,1),
(1202,'Sorius''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(1203,'Kluto Box','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(1204,'Elven Knight Brooch','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_elven_earing_i00',1,1,1),
(1205,'Topaz Piece','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_gold_i00',1,1,1),
(1206,'Emerald Piece','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_green_i00',1,1,1),
(1207,'Reisa''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(1208,'Prias''s 1st Torn Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(1209,'Prias''s 2nd Torn Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(1210,'Prias''s 3rd Torn Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(1211,'Prias''s 4th Torn Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(1212,'Moretti''s Herb','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_herb_green_i00',1,1,1),
(1214,'Moretti''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(1215,'Prias''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1216,'Honorary Guard','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1217,'Reisa''s Recommendation','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(1218,'Rosella''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(1219,'Red Down','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_mane_i00',1,1,1),
(1220,'Magical Powers Ruby','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(1221,'Pure Aquamarine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_blue_i00',1,1,1),
(1222,'Appetizing Apple','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fruit_red_i00',1,1,1),
(1223,'Gold Leaves','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leaf_gold_i00',1,1,1),
(1224,'Immortal Love','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(1225,'Amethyst','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(1226,'Nobility Amethyst','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(1227,'Rosella''s Recommendation','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal131',1,1,1),
(1228,'Peridot','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal16',1,1,1),
(1229,'Fertility Peridot','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_green_i00',1,1,1),
(1230,'Eternity Diamond','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_silver_i00',1,1,1),
(1231,'Crystal Medallion','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_blue_diamond_necklace_i00',1,1,1),
(1232,'Swindler''s Money','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_gold_i00',1,1,1),
(1233,'Allana''s Diary','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(1234,'Lizard Captain Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(1235,'Leaf of Oracle','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leaf_green_i00',1,1,1),
(1236,'Half of Diary','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(1237,'Palus Talisman','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_earing_of_grace_i00',1,1,1),
(1238,'Lycanthrope Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(1239,'Virgil''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(1240,'Morte Talisman','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_necklace_of_binding_i00',1,1,1),
(1241,'Predator''s Carapace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bark_blue_i00',1,1,1),
(1242,'Arachnid Tracker Silk','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skein_gray_i00',1,1,1),
(1243,'Coffin of Eternal Rest','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_tower_shield_i00',1,1,1),
(1244,'Gaze of Abyss','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(1245,'Shilen''s Call','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(1246,'Arkenia''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1247,'Leikan''s Note','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(1248,'Moonstone Beast''s Molar','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_molar_white_i00',1,1,1),
(1249,'Leikan''s Knife','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_ss09',1,1,1),
(1250,'Shilen''s Tears','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_blue_i00',1,1,1),
(1251,'Arkenia''s Recommendation','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1252,'Iron Heart','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_earing_of_mana_i00',1,1,1),
(1253,'Seed of Anger','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_red_i00',1,1,1),
(1254,'Seed of Despair','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_silver_i00',1,1,1),
(1255,'Seed of Horror','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_gold_i00',1,1,1),
(1256,'Seed of Lunacy','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_green_i00',1,1,1),
(1257,'Family''s Remains','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ashes_black_i00',1,1,1),
(1258,'Varika''s Liquor','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_canuse47',1,1,1),
(1259,'Knee Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_black_i00',1,1,1),
(1260,'Heart of Lunacy','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(1261,'Dark Jewel','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_necklace_of_phantom_i00',1,1,1),
(1262,'Sidra''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(1263,'Blank Sheet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(1264,'Bloody Rune','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(1265,'Garmiel Book','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(1266,'Prayer of Adonius','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(1267,'Penitent''s Mark','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_earing_of_holy_spirit_i00',1,1,1),
(1268,'Ashen Bones','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_black_i00',1,1,1),
(1269,'Andariel Book','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(1270,'Orb of Abyss','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_blue_i00',1,1,1),
(1271,'Mark of Esquire','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_earing_of_wisdom_i00',1,1,1),
(1272,'Charm of Grain','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_aquastone_necklace_i00',1,1,1),
(1273,'Sap of the Mother Tree','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_green_i00',1,1,1),
(1274,'Lucky Potpourri','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(1275,'Tamil''s Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_necklace_green_i00',1,1,1),
(1276,'Kluto''s Memo','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(1277,'Lucky Key','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_key_i00',1,1,1),
(1278,'Candle','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spirit_bullet_white_i00',1,1,1),
(1279,'Hub Scent','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(1280,'Map of Luster','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(1281,'Key of Flame','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_key_i00',1,1,1),
(1282,'Flame Earring','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_earing_of_mana_i00',1,1,1),
(1283,'Broken Bronze Mirror','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_mirror_i00',1,1,1),
(1284,'Wind Feather','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_feather_white_i00',1,1,1),
(1285,'Wind Bangle','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_blue_coral_ring_i00',1,1,1),
(1286,'Rama''s Diary','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(1287,'Sparkle Pebble','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_white_i00',1,1,1),
(1288,'Water Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_necklace_of_assistance_i00',1,1,1),
(1289,'Rust Gold Coin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_gold_i00',1,1,1),
(1290,'Red Soil','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_powder_red_i00',1,1,1),
(1291,'Earth Ring','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_ring_of_firefly_i00',1,1,1),
(1292,'Bead of Season','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_green_i00',1,1,1),
(1293,'Rusted Key','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_key_i00',1,1,1),
(1294,'Spellbook: Defense Aura','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,75,0,'true',0,1,'etc_spell_books_efighter_i00',1,1,1),
(1334,'Predator''s Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1335,'Goblin Club','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_club_i00',1,1,1),
(1336,'Glass Shard','OTHER','false','none',80,'stackable','liquid','none',0,200,0,'true',0,1,'etc_crystal_ball_blue_i00',1,1,1),
(1337,'Emerald','OTHER','false','none',80,'stackable','liquid','none',0,10000,0,'true',0,1,'etc_jewel_green_i00',1,1,1),
(1338,'Blue Onyx','OTHER','false','none',80,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_jewel_blue_i00',1,1,1),
(1339,'Onyx','OTHER','false','none',80,'stackable','liquid','none',0,600,0,'true',0,1,'etc_bead_red_i00',1,1,1),
(1340,'Silvery Leaf','OTHER','false','none',3,'stackable','liquid','none',0,20,0,'true',0,1,'etc_feather_white_i00',1,1,1),
(1341,'Bone Arrow','EQUIPMENT','false','arrow',5,'stackable','bone','d',0,3,0,'true',0,1,'etc_bone_quiver_i00',1,1,1),
(1342,'Iron Arrow','EQUIPMENT','false','arrow',4,'stackable','fine_steel','c',0,5,0,'true',0,1,'etc_fine_steel_quiver_i00',1,1,1),
(1343,'Silver Arrow','EQUIPMENT','false','arrow',4,'stackable','silver','b',0,7,0,'true',0,1,'etc_silver_quiver_i00',1,1,1),
(1344,'Mithril Arrow','EQUIPMENT','false','arrow',3,'stackable','mithril','a',0,8,0,'true',0,1,'etc_mithril_quiver_i00',1,1,1),
(1345,'Shining Arrow','EQUIPMENT','false','arrow',3,'stackable','adamantaite','s',0,10,0,'true',0,1,'etc_shining_quiver_i00',1,1,1),
(1346,'Golem''s Stoneheart','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_squares_gray_i00',1,1,1),
(1347,'Monster Eye Carcass','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bark_gold_i00',1,1,1),
(1348,'Basilisk''s Gizzard','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(1349,'Anatomy Diagram','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(1350,'Zombie Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(1351,'Zombie Heart','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bodypart_heart_i00',1,1,1),
(1352,'Zombie Liver','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bodypart_liver_i00',1,1,1),
(1353,'Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(1354,'Rib Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_rib_white_i00',1,1,1),
(1355,'Spine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_red_i00',1,1,1),
(1356,'Arm Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_black_i00',1,1,1),
(1357,'Thigh Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_white_i00',1,1,1),
(1358,'Complete Skeleton','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ashes_white_i00',1,1,1),
(1359,'Red Cross Badge','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(1360,'Blue Cross Badge','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_blue_i00',1,1,1),
(1361,'Black Cross Badge','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_gold_i00',1,1,1),
(1362,'Spider''s Carapace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal72',1,1,1),
(1363,'Spider Silk','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'item_normal168',1,1,1),
(1364,'Spider Venom Sac','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'true',0,1,'item_canuse28',1,1,1),
(1365,'Broken Stoneheart','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_plate_glay_i00',1,1,1),
(1366,'Monster Eye''s Lens','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_white_i00',1,1,1),
(1367,'Wolf Claw','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1368,'Imp Shackles','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_cerberuss_earing_i00',1,1,1),
(1369,'Black Lion Mark','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_badge_black_i00',1,1,1),
(1370,'Spellbook: Aqua Swirl','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(1371,'Spellbook: Twister','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(1372,'Spellbook: Blaze','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(1373,'Magic Gem','OTHER','false','none',80,'stackable','liquid','none',0,600,0,'false',0,1,'etc_crystal_ball_white_i00',1,1,1),
(1374,'Greater Haste Potion','CONSUMABLE','false','potion',20,'stackable','liquid','none',0,3000,0,'true',2034,1,'etc_lesser_potion_green_i00',1,1,1),
(1375,'Greater Swift Attack Potion','CONSUMABLE','false','potion',20,'stackable','liquid','none',0,6000,0,'true',2035,1,'etc_lesser_potion_purple_i00',1,1,1),
(1377,'Spellbook: Poison Recovery','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_efighter_i00',1,1,1),
(1378,'Spellbook: Divine Heal','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1550,0,'true',0,1,'etc_spell_books_hfighter_i00',1,1,1),
(1379,'Spellbook: Cure Bleeding','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1150,0,'true',0,1,'etc_spell_books_efighter_i00',1,1,1),
(1380,'Spellbook: Entangle','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,500,0,'true',0,1,'etc_spell_books_efighter_i00',1,1,1),
(1381,'Spellbook: Freezing Strike','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2600,0,'true',0,1,'etc_spell_books_defighter_i00',1,1,1),
(1382,'Spellbook: Power Break','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2600,0,'true',0,1,'etc_spell_books_defighter_i00',1,1,1),
(1383,'Spellbook: Poison','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_defighter_i00',1,1,1),
(1384,'Spellbook: Sprint','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2600,0,'true',0,1,'etc_spell_books_efighter_i00',1,1,1),
(1385,'Spellbook: Recharge','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1800,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(1386,'Spellbook: Disrupt Undead','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(1387,'Spellbook: Resist Poison','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2450,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1388,'Spellbook: Mental Shield','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1389,'Spellbook: Holy Weapon','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(1390,'Spellbook: Regeneration','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2450,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1391,'Spellbook: Empower','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1392,'Spellbook: Berserker Spirit','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2450,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1393,'Spellbook: Quickness','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_blue_i00',1,1,1),
(1394,'Spellbook: Sleep','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1800,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1395,'Spellbook: Surrender to Water','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_blue_i00',1,1,1),
(1396,'Spellbook: Surrender to Wind','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_blue_i00',1,1,1),
(1397,'Spellbook: Peace','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2450,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1398,'Spellbook: Focus','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1399,'Spellbook: Concentration','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1400,'Spellbook: Surrender To Fire','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(1401,'Spellbook: Acumen','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1402,'Spellbook: Agility','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1403,'Spellbook: Summon Kat the Cat','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(1404,'Spellbook: Servitor Recharge','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(1405,'Spellbook: Servitor Heal','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(1406,'Spellbook: Servitor Wind Walk','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2450,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(1407,'Spellbook: Servitor Magic Boost','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2450,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(1408,'Spellbook: Mighty Servitor','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2450,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(1409,'Spellbook: Slow','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2450,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(1410,'Spellbook: Poisonous Cloud','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(1411,'Spellbook: Aura Burn','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(1412,'Spellbook: Resist Aqua','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2450,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1413,'Spellbook: Resist Wind','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2450,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1414,'Spellbook: Resist Fire','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1800,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1415,'Spellbook: Dryad Root','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1416,'Spellbook: Curse of Chaos','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2450,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(1417,'Spellbook: Surrender To Earth','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(1418,'Spellbook: Surrender To Poison','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(1419,'Blood Mark','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'false',0,1,'etc_broken_crystal_red_i00',1,1,1),
(1420,'Ingredient List','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1421,'Sonia''s Botany Book','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(1422,'Red Mandragora Root','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(1423,'White Mandragora Root','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(1424,'Red Mandragora Sap','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_potion_red_i00',1,1,1),
(1425,'White Mandragora Sap','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_potion_clear_i00',1,1,1),
(1426,'Jacob''s Insect Book','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(1427,'Nectar','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_reagent_gold_i00',1,1,1),
(1428,'Royal Jelly','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_reagent_white_i00',1,1,1),
(1429,'Honey','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_potion_yellow_i00',1,1,1),
(1430,'Golden Honey','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_potion_gold_i00',1,1,1),
(1431,'Pano''s Contract','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(1432,'Hobgoblin Amulet','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_feather_black_i00',1,1,1),
(1433,'Dionian Potato','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(1434,'Glyvka''s Botany Book','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(1435,'Green Marsh Moss','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_branch_green_i00',1,1,1),
(1436,'Brown Marsh Moss','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_branch_gold_i00',1,1,1),
(1437,'Green Moss Bundle','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_bark_green_i00',1,1,1),
(1438,'Brown Moss Bundle','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_bark_gold_i00',1,1,1),
(1439,'Rollant''s Creature Book','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(1440,'Body of Monster Eye','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_leather_brown_i00',1,1,1),
(1441,'Meat of Monster Eye','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(1442,'Jonas''s 1st Steak Dish','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(1443,'Jonas''s 2nd Steak Dish','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(1444,'Jonas''s 3rd Steak Dish','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(1445,'Jonas''s 4th Steak Dish','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(1446,'Jonas''s 5th Steak Dish','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(1447,'Mirien''s Review','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1448,'Mirien''s Review','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'item_normal129',1,1,1),
(1449,'Mirien''s Review','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'item_normal129',1,1,1),
(1450,'Mirien''s Review','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'item_normal129',1,1,1),
(1451,'Mirien''s Review','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'item_normal129',1,1,1),
(1452,'Harpy Feather','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_feather_white_i00',1,1,1),
(1453,'Medusa Venom','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_potion_green_i00',1,1,1),
(1454,'Wyrm''s Tooth','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1455,'Jonas''s Salad Recipe','OTHER','false','quest',0,'stackable','paper','none',0,9000,0,'false',0,1,'item_canuse39',1,1,1),
(1456,'Jonas''s Sauce Recipe','OTHER','false','quest',0,'stackable','paper','none',0,11250,0,'false',0,1,'item_canuse39',1,1,1),
(1457,'Jonas''s Steak Recipe','OTHER','false','quest',0,'stackable','paper','none',0,13500,0,'false',0,1,'item_canuse39',1,1,1),
(1458,'Crystal: D-Grade','CONSUMABLE','false','none',0,'stackable','paper','d',0,650,0,'true',0,1,'etc_crystal_blue_i00',1,1,1),
(1459,'Crystal: C-Grade','CONSUMABLE','false','none',0,'stackable','paper','c',0,3000,0,'true',0,1,'etc_crystal_green_i00',1,1,1),
(1460,'Crystal: B-Grade','CONSUMABLE','false','none',0,'stackable','paper','b',0,9000,0,'true',0,1,'etc_crystal_red_i00',1,1,1),
(1461,'Crystal: A-Grade','CONSUMABLE','false','none',0,'stackable','paper','a',0,15000,0,'true',0,1,'etc_crystal_silver_i00',1,1,1),
(1462,'Crystal: S Grade','CONSUMABLE','false','none',0,'stackable','paper','s',0,25000,0,'true',0,1,'etc_crystal_gold_i00',1,1,1),
(1463,'Soulshot: D-grade','CONSUMABLE','false','none',3,'stackable','paper','d',0,10,0,'true',0,1,'etc_spirit_bullet_blue_i00',1,1,1),
(1464,'Soulshot: C-grade','CONSUMABLE','false','none',3,'stackable','paper','c',0,15,0,'true',0,1,'etc_spirit_bullet_green_i00',1,1,1),
(1465,'Soulshot: B-grade','CONSUMABLE','false','none',2,'stackable','paper','b',0,50,0,'true',0,1,'etc_spirit_bullet_red_i00',1,1,1),
(1466,'Soulshot: A-grade','CONSUMABLE','false','none',2,'stackable','paper','a',0,80,0,'true',0,1,'etc_spirit_bullet_silver_i00',1,1,1),
(1467,'Soulshot: S-grade','CONSUMABLE','false','none',2,'stackable','paper','s',0,100,0,'true',0,1,'etc_spirit_bullet_gold_i00',1,1,1),
(1468,'Gludin Panacen','OTHER','false','quest',0,'stackable','paper','s',0,0,0,'false',0,1,'etc_reagent_gold_i00',1,1,1),
(1469,'Gludin Vermouth','OTHER','false','quest',0,'stackable','paper','s',0,0,0,'false',0,1,'etc_fruit_green_i00',1,1,1),
(1470,'Artemeter','OTHER','false','quest',0,'stackable','paper','s',0,0,0,'false',0,1,'etc_leaf_green_i00',1,1,1),
(1473,'Kasha Wolf Fang','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1474,'Grave Robber''s Head','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(1475,'Black Soulstone','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_bead_gold_i00',1,1,1),
(1476,'Red Soulstone','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_crystal_ball_red_i00',1,1,1),
(1477,'Maraku Werewolf Head','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(1478,'Darkwing Bat Fang','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(1479,'Varangka''s Parasite','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_totem_black_i00',1,1,1),
(1480,'Kasha Parasite','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_totem_black_i00',1,1,1),
(1481,'Kasha Crystal','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(1482,'Black Wolf Pelt','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_leather_gray_i00',1,1,1),
(1483,'Goblin Necklace','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_totem_necklace_black_i00',1,1,1),
(1484,'Goblin Pendant','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_totem_necklace_red_i00',1,1,1),
(1485,'Goblin Lord Pendant','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_totem_necklace_green_i00',1,1,1),
(1486,'Suspicious Memo','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(1487,'Suspicious Contract','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(1488,'Chrysolite Ore','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_plate_blue_i00',1,1,1),
(1489,'Torn Map Fragment','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(1490,'Hidden Ore Map','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(1491,'Bat Fang','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1492,'Floating Stone','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_crystal_ball_blue_i00',1,1,1),
(1493,'Tarantula Spider Silk','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_skein_white_i00',1,1,1),
(1494,'Tarantula Spinnerette','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(1495,'Giant Spider Skin','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_leather_gray_i00',1,1,1),
(1496,'Voucher of Flame','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_scroll_of_enchant_weapon_i01',1,1,1),
(1497,'Necklace of Flame','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'item_normal142',1,1,1),
(1498,'License of Miner','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(1499,'Laferon''s Recommendation','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'item_canuse15',1,1,1),
(1500,'Totem of Hestui','OTHER','false','none',10,'stackable','liquid','none',0,11000,0,'true',0,1,'etc_totem_black_i00',1,1,1),
(1501,'Maraku Werewolf Totem','OTHER','false','none',10,'stackable','liquid','none',0,1200,0,'true',0,1,'etc_totem_green_i00',1,1,1),
(1502,'Grandma''s Pearl','OTHER','false','none',10,'stackable','liquid','none',0,10000,0,'true',0,1,'etc_crystal_ball_silver_i00',1,1,1),
(1503,'Grandma''s Mirror','OTHER','false','none',10,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_mirror_i00',1,1,1),
(1504,'Grandma''s Necklace','OTHER','false','none',10,'stackable','liquid','none',0,600,0,'true',0,1,'accessary_aquastone_necklace_i00',1,1,1),
(1505,'Grandma''s Hairpin','OTHER','false','none',10,'stackable','liquid','none',0,200,0,'true',0,1,'etc_jewel_white_i00',1,1,1),
(1512,'Spellbook: Confusion','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1150,0,'true',0,1,'etc_spell_books_defighter_i00',1,1,1),
(1513,'Spellbook: Charm','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_efighter_i00',1,1,1),
(1514,'Spellbook: Resurrection','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(1515,'Spellbook: Kiss of Eva','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(1516,'Spellbook: Corpse Life Drain','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1800,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(1517,'Spellbook: Body To Mind','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(1518,'Amulet: Flame Chant','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1800,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1519,'Amulet: Pa''agrio''s Gift','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1800,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1520,'Amulet: Pa''agrio''s Blessing','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2450,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1521,'Amulet: Chant of Fire','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1522,'Amulet: Chant of Battle','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,500,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1523,'Amulet: Chant of Shielding','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1524,'Amulet: Soul Shield','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,100,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1525,'Amulet: Life Drain','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,100,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1526,'Amulet: Fear','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,500,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1527,'Amulet: Venom','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,100,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1528,'Amulet: Seal of Chaos','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1800,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1529,'Amulet: Dreaming Spirit','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,100,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1530,'Amulet: Seal of Slow','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2450,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1531,'Amulet: Chill Flame','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,100,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1532,'Amulet: Blaze Quake','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1533,'Amulet: Aura Sink','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1534,'Amulet: Madness','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1535,'Amulet: Frost Flame','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1536,'Amulet: Seal of Binding','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1537,'Amulet: Seal of Poison','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1538,'Blessed Scroll of Escape','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,150000,0,'true',2036,1,'etc_scroll_of_return_i01',1,1,1),
(1539,'Greater Healing Potion','CONSUMABLE','false','potion',5,'stackable','liquid','none',0,900,0,'true',2037,1,'etc_reagent_white_i00',1,1,1),
(1540,'Quick Healing Potion','CONSUMABLE','false','potion',180,'stackable','liquid','none',0,10000,0,'true',2038,1,'etc_potion_gold_i00',1,1,1),
(1541,'Honey Khandar','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_potion_gold_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(1542,'Bear Fur Cloak','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(1543,'Bloody Axe','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'weapon_tomahawk_i00',1,1,1),
(1544,'Ancestor Skull','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(1545,'Spider Dust','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_powder_white_i00',1,1,1),
(1546,'Deep Sea Orb','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_crystal_ball_silver_i00',1,1,1),
(1547,'Bolter''s List','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1548,'Mining Boots','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'armor_apprentices_shoes_i00',1,1,1),
(1549,'Miner''s Pick','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'weapon_guard_spear_i00',1,1,1),
(1550,'Boomboom Powder','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_powder_black_i00',1,1,1),
(1551,'Redstone Beer','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_potion_scarlet_i00',1,1,1),
(1552,'Bolter''s Smelly Socks','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'armor_cotton_shoes_i00',1,1,1),
(1553,'Hatos''s 1st Order','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1554,'Hatos''s 2nd Order','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(1555,'Hatos''s 3rd Order','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(1556,'Letter to Dark Elf','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1557,'Letter to Human','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(1558,'Letter to Elf','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(1559,'Gouph''s Contract','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(1560,'Reep''s Contract','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1561,'Elven Wine','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_lesser_potion_purple_i00',1,1,1),
(1562,'Brunon''s Dice','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_squares_silver_i00',1,1,1),
(1563,'Brunon''s Contract','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(1564,'Aquamarine','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_jewel_green_i00',1,1,1),
(1565,'Chrysoberyl','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_jewel_blue_i00',1,1,1),
(1566,'Gem Box','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(1567,'Coal Piece','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_plate_black_i00',1,1,1),
(1568,'Brunon''s Letter','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(1569,'Berry Tart','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(1570,'Bat Diagram','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(1571,'Star Diamond','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_jewel_silver_i00',1,1,1),
(1572,'Starstone','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(1573,'Starstone','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(1574,'Mirien''s Review','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1575,'Mirien''s Review','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1576,'Mirien''s Review','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1577,'Mirien''s Review','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1578,'Green Blood','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_reagent_green_i00',1,1,1),
(1579,'Goblin Dwelling Map','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(1580,'Kuruka Ratman Tooth','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1581,'Betrayer''s Report','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1582,'Betrayer''s Report','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1583,'Betrayer''s Report','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1584,'Betrayer''s Report','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1585,'Betrayer''s Report','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1586,'Betrayer''s Report','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1587,'Betrayer''s Report','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1588,'Betrayer''s Report','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1589,'Betrayer''s Report','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1590,'Betrayer''s Report','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1591,'Head of Betrayer','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(1592,'Mark of Raider','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'accessary_earing_of_black_ore_i00',1,1,1),
(1593,'Pomegranate','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_fruit_red_i00',1,1,1),
(1594,'1st Leather Pouch','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(1595,'2nd Leather Pouch','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(1596,'3rd Leather Pouch','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(1597,'1st Leather Pouch (Full)','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(1598,'2nd Leather Pouch (Full)','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(1599,'3rd Leather Pouch (Full)','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(1600,'Kasha Bear Claw','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1601,'Kasha Blade Spider Talon','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(1602,'Scarlet Salamander Scale','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(1603,'Fiery Spirit Scroll','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(1604,'Rosheek''s Letter','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(1605,'Gantaki''s Letter of Recommendation','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1606,'Fig','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_fruit_yellow_i00',1,1,1),
(1607,'4th Leather Pouch','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(1608,'4th Leather Pouch (Full)','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(1609,'Vuku Orc Tusk','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_molar_white_i00',1,1,1),
(1610,'Ratman Fang','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1611,'Langk Lizardman Tooth','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(1612,'Felim Lizardman Tooth','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(1613,'Iron Will Scroll','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(1614,'Toruku''s Letter','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(1615,'Khavatari Totem','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_orcish_talisman_i00',1,1,1),
(1616,'Fire Charm','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1617,'Kasha Bear Pelt','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_leather_brown_i00',1,1,1),
(1618,'Kasha Blade Spider Husk','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_leather_gray_i00',1,1,1),
(1619,'1st Fiery Egg','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_crystal_ball_red_i00',1,1,1),
(1620,'Hestui Mask','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_orcish_talisman_i00',1,1,1),
(1621,'2nd Fiery Egg','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_crystal_ball_red_i00',1,1,1),
(1622,'Totem Spirit Claw','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1623,'Tataru''s Letter of Recommendation','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(1624,'Flame Charm','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1625,'Grizzly Blood','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_reagent_red_i00',1,1,1),
(1626,'Blood Cauldron','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(1627,'Spirit Net','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1628,'Bound Durka Spirit','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_crystal_ball_silver_i00',1,1,1),
(1629,'Durka Parasite','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_totem_red_i00',1,1,1),
(1630,'Totem Spirit Blood','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_potion_red_i00',1,1,1),
(1631,'Mask of Medium','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(1632,'Silvera''s Ring','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'accessary_ring_of_assistance_i00',1,1,1),
(1633,'1st Pass Certificate','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(1634,'2nd Pass Certificate','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(1635,'Final Pass Certificate','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(1636,'Boogle Ratman Tooth','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1637,'Boogle Ratman Leader''s Tooth','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(1638,'Kluto''s Letter','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(1639,'Footprint of Thief','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_leather_brown_i00',1,1,1),
(1640,'Stolen Secret Box','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(1641,'Secret Box','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(1642,'Ring of Raven','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'accessary_ring_of_raccoon_i00',1,1,1),
(1643,'Pippi''s Letter of Recommendation','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(1644,'Raut''s Teleport Scroll','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_scroll_of_return_i00',1,1,1),
(1645,'Succubus Undies','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(1646,'Mion''s Letter','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(1647,'Bronk''s Ingot','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_plate_glay_i00',1,1,1),
(1648,'Shari''s Axe','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'weapon_tomahawk_i00',1,1,1),
(1649,'Zimenf''s Potion','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_potion_blue_i00',1,1,1),
(1650,'Bronk''s Pay','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_coins_gold_i00',1,1,1),
(1651,'Shari''s Pay','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_coins_gold_i00',1,1,1),
(1652,'Zimenf''s Pay','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_coins_gold_i00',1,1,1),
(1653,'Bear Picture','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(1654,'Tarantula Picture','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(1655,'Honey Jar','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_potion_gold_i00',1,1,1),
(1656,'Bead','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_crystal_ball_blue_i00',1,1,1),
(1657,'Bead Parcel','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'accessary_mage_earing_i00',1,1,1),
(1658,'Gatekeeper Charm','OTHER','false','none',10,'stackable','liquid','none',0,0,0,'false',0,1,'etc_totem_red_i00',1,1,1),
(1659,'Gatekeeper Token','OTHER','false','none',10,'stackable','liquid','none',0,0,0,'false',0,1,'etc_coins_silver_i00',1,1,1),
(1661,'Thief Key','OTHER','false','none',10,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_key_i00',1,1,1),
(1662,'Wood','OTHER','false','none',2,'stackable','liquid','none',0,20,0,'true',0,1,'etc_squares_wood_i00',1,1,1),
(1663,'(Not used) Trunk','OTHER','false','none',2,'stackable','liquid','none',0,20,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(1664,'Steel Powder','OTHER','false','none',2,'stackable','liquid','none',0,80,0,'true',0,1,'etc_powder_gray_i00',1,1,1),
(1665,'World Map','OTHER','false','none',0,'normal','liquid','none',0,1000,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1666,'Recipe: Wooden Arrow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,600,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1667,'Spellbook: Summon Shadow','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(1668,'Spellbook: Summon Mew the Cat','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(1669,'Spellbook: Summon Boxer the Unicorn','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(1670,'Spellbook: Summon Mirage the Unicorn','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(1671,'Spellbook: Summon Silhouette','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(1672,'__','OTHER','false','none',40,'normal','paper','none',0,800,0,'false',0,1,'item_normal06',1,1,1),
(1673,'__','OTHER','false','none',40,'normal','paper','none',0,800,0,'false',0,1,'item_normal06',1,1,1),
(1674,'Twig of Treant','MATHERIALS','false','material',2,'stackable','liquid','none',0,80,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(1675,'Beast Blood','MATHERIALS','false','material',2,'stackable','liquid','none',0,40,0,'true',0,1,'etc_reagent_red_i00',1,1,1),
(1676,'Beast Bone','MATHERIALS','false','material',2,'stackable','liquid','none',0,20,0,'true',0,1,'etc_piece_bone_white_i00',1,1,1),
(1677,'Hot Oil','MATHERIALS','false','material',2,'stackable','liquid','none',0,40,0,'true',0,1,'etc_oil_pot_black_i00',1,1,1),
(1678,'(Not used) Thread','MATHERIALS','false','material',2,'stackable','liquid','none',0,10,0,'true',0,1,'etc_skein_white_i00',1,1,1),
(1679,'Bronze','MATHERIALS','false','material',2,'stackable','liquid','none',0,150,0,'true',0,1,'etc_lump_gray_i00',1,1,1),
(1680,'Fur','MATHERIALS','false','material',2,'stackable','liquid','none',0,40,0,'true',0,1,'etc_leather_brown_i00',1,1,1),
(1681,'Elf Stone','MATHERIALS','false','material',2,'stackable','liquid','none',0,1500,0,'true',0,1,'etc_crystal_ball_green_i00',1,1,1),
(1682,'Tear of Holy Spirit','MATHERIALS','false','material',2,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_lesser_potion_clear_i00',1,1,1),
(1683,'Mithril','MATHERIALS','false','material',2,'stackable','liquid','none',0,400,0,'true',0,1,'etc_squares_silver_i00',1,1,1),
(1684,'Durable Stem','MATHERIALS','false','material',2,'stackable','liquid','none',0,220,0,'true',0,1,'etc_herb_green_i00',1,1,1),
(1685,'Wooden Frame','MATHERIALS','false','material',2,'stackable','liquid','none',0,2000,0,'true',0,1,'etc_squares_wood_i00',1,1,1),
(1686,'Bark of Treant','MATHERIALS','false','material',2,'stackable','liquid','none',0,480,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(1687,'(Not used) Coarse Bone Powder','MATHERIALS','false','material',2,'stackable','liquid','none',0,80,0,'true',0,1,'etc_powder_white_i00',1,1,1),
(1688,'Refined Steel','MATHERIALS','false','material',2,'stackable','liquid','none',0,480,0,'true',0,1,'etc_plate_black_i00',1,1,1),
(1689,'(Not used) Leather','MATHERIALS','false','material',2,'stackable','liquid','none',0,300,0,'true',0,1,'etc_leather_brown_i00',1,1,1),
(1690,'Bowstring','MATHERIALS','false','material',2,'stackable','liquid','none',0,300,0,'true',0,1,'etc_skein_white_i00',1,1,1),
(1691,'Steel Frame','MATHERIALS','false','material',2,'stackable','liquid','none',0,4400,0,'true',0,1,'etc_mold_i00',1,1,1),
(1692,'(Not used) Cord','MATHERIALS','false','material',2,'stackable','liquid','none',0,45,0,'true',0,1,'etc_skein_gray_i00',1,1,1),
(1693,'Refined Bronze','MATHERIALS','false','material',2,'stackable','liquid','none',0,890,0,'true',0,1,'etc_plate_blue_i00',1,1,1),
(1694,'Treant Potion','MATHERIALS','false','material',2,'stackable','liquid','none',0,800,0,'true',0,1,'etc_potion_green_i00',1,1,1),
(1695,'Spell Paper','MATHERIALS','false','material',2,'stackable','liquid','none',0,580,0,'true',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(1696,'Flaming Oil','MATHERIALS','false','material',2,'stackable','liquid','none',0,500,0,'true',0,1,'etc_oil_pot_black_i00',1,1,1),
(1697,'Magic Powder','MATHERIALS','false','material',2,'stackable','liquid','none',0,3080,0,'true',0,1,'etc_powder_gray_i00',1,1,1),
(1698,'Refined Mithril','MATHERIALS','false','material',2,'stackable','liquid','none',0,2100,0,'true',0,1,'etc_plate_white_i00',1,1,1),
(1699,'Fortified Steel','MATHERIALS','false','material',2,'stackable','liquid','none',0,1860,0,'true',0,1,'etc_squares_silver_i00',1,1,1),
(1700,'(Not used) Oriharukon','MATHERIALS','false','material',2,'stackable','liquid','none',0,6300,0,'true',0,1,'etc_squares_wood_i00',1,1,1),
(1701,'Spell Solution','MATHERIALS','false','material',2,'stackable','liquid','none',0,8160,0,'true',0,1,'etc_potion_gold_i00',1,1,1),
(1702,'Metal Frame','MATHERIALS','false','material',2,'stackable','liquid','none',0,12500,0,'true',0,1,'etc_mold_i00',1,1,1),
(1703,'Steel of The Highest Grade','MATHERIALS','false','material',2,'stackable','liquid','none',0,3720,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(1704,'Stone of Anguish','PIECES','false','material',60,'stackable','liquid','none',0,157,0,'true',0,1,'etc_bead_red_i00',1,1,1),
(1705,'Sprig of Wisdom','PIECES','false','material',60,'stackable','liquid','none',0,258,0,'true',0,1,'etc_leaf_gold_i00',1,1,1),
(1706,'Blue Diamond Fragment','PIECES','false','material',60,'stackable','liquid','none',0,471,0,'true',0,1,'etc_crystal_ball_blue_i00',1,1,1),
(1707,'Saint''s Molar','PIECES','false','material',60,'stackable','liquid','none',0,568,0,'true',0,1,'etc_molar_white_i00',1,1,1),
(1708,'Smoky Quartz','PIECES','false','material',60,'stackable','liquid','none',0,1136,0,'true',0,1,'etc_bead_white_i00',1,1,1),
(1709,'Blood of Manticore','PIECES','false','material',60,'stackable','liquid','none',0,568,0,'true',0,1,'etc_reagent_gold_i00',1,1,1),
(1710,'Tiger''s Eye Crystal','PIECES','false','material',60,'stackable','liquid','none',0,3215,0,'true',0,1,'etc_crystal_ball_gold_i00',1,1,1),
(1711,'Claw of Leopard','PIECES','false','material',60,'stackable','liquid','none',0,402,0,'true',0,1,'etc_claw_i00',1,1,1),
(1712,'Leather Shoes Material','PIECES','false','material',60,'stackable','liquid','none',0,87,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1713,'Leather Tunic Material','PIECES','false','material',60,'stackable','liquid','none',0,261,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1714,'Leather Stockings Material','PIECES','false','material',60,'stackable','liquid','none',0,129,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1715,'Leather Helmet Material','PIECES','false','material',60,'stackable','liquid','none',0,240,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1716,'Leather Gloves Texture','PIECES','false','material',60,'stackable','liquid','none',0,226,0,'true',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(1717,'Leather Gloves Lining','PIECES','false','material',60,'stackable','liquid','none',0,113,0,'true',0,1,'icon.etc_piece_of_cloth_green_i00',1,1,1),
(1718,'Black Bone Fragment','PIECES','false','material',60,'stackable','liquid','none',0,693,0,'true',0,1,'etc_piece_bone_black_i00',1,1,1),
(1719,'Hard Leather Shirt Material','PIECES','false','material',60,'stackable','liquid','none',0,963,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1720,'Blue-Black Bone Fragment','PIECES','false','material',60,'stackable','liquid','none',0,1493,0,'true',0,1,'etc_piece_bone_black_i00',1,1,1),
(1721,'Hard Leather Gaiter Material','PIECES','false','material',60,'stackable','liquid','none',0,500,0,'true',0,1,'etc_piece_of_cloth_blue_i00',1,1,1),
(1722,'Boots Material','PIECES','false','material',60,'stackable','liquid','none',0,271,0,'true',0,1,'etc_leather_brown_i00',1,1,1),
(1723,'Leather Boots Material','PIECES','false','material',60,'stackable','liquid','none',0,364,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1724,'Skull Fragment','PIECES','false','material',60,'stackable','liquid','none',0,512,0,'true',0,1,'etc_skull_black_i00',1,1,1),
(1725,'Dark Stockings Material','PIECES','false','material',60,'stackable','liquid','none',0,632,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1726,'Crafted Leather Gloves Lining','PIECES','false','material',60,'stackable','liquid','none',0,523,0,'true',0,1,'icon.etc_piece_of_cloth_blue_i00',1,1,1),
(1727,'Crafted Leather Gloves Texture','PIECES','false','material',60,'stackable','liquid','none',0,261,0,'true',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(1728,'Steel Scale','PIECES','false','material',60,'stackable','liquid','none',0,1790,0,'true',0,1,'etc_plate_glay_i00',1,1,1),
(1729,'Pure White Cloth','PIECES','false','material',60,'stackable','liquid','none',0,833,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1730,'Purifying Potion','PIECES','false','material',60,'stackable','liquid','none',0,3330,0,'true',0,1,'etc_potion_clear_i00',1,1,1),
(1731,'Steel Scale Gaiters','PIECES','false','material',60,'stackable','liquid','none',0,1148,0,'true',0,1,'etc_plate_blue_i00',1,1,1),
(1732,'Leather Fittings','PIECES','false','material',60,'stackable','liquid','none',0,1520,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1733,'Large Sheet Iron','PIECES','false','material',60,'stackable','liquid','none',0,1900,0,'true',0,1,'etc_plate_black_i00',1,1,1),
(1734,'Small Leather Fittings','PIECES','false','material',60,'stackable','liquid','none',0,952,0,'true',0,1,'etc_leather_brown_i00',1,1,1),
(1735,'Small Sheet Iron','PIECES','false','material',60,'stackable','liquid','none',0,1190,0,'true',0,1,'etc_plate_glay_i00',1,1,1),
(1736,'Iron Boots Binding','PIECES','false','material',60,'stackable','liquid','none',0,635,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(1737,'Iron Boots Frame','PIECES','false','material',60,'stackable','liquid','none',0,508,0,'true',0,1,'etc_mold_i00',1,1,1),
(1738,'Wide Blade','PIECES','false','material',60,'stackable','liquid','none',0,625,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(1739,'Broadsword Mold','PIECES','false','material',60,'stackable','liquid','none',0,1250,0,'true',0,1,'etc_mold_i00',1,1,1),
(1740,'Crafted Willow Branch','PIECES','false','material',60,'stackable','liquid','none',0,833,0,'true',0,1,'etc_branch_blue_i00',1,1,1),
(1741,'Stave','PIECES','false','material',60,'stackable','liquid','none',0,900,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(1742,'Red Cedar Branch','PIECES','false','material',60,'stackable','liquid','none',0,1797,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(1743,'Dirk Blade','PIECES','false','material',60,'stackable','liquid','none',0,1082,0,'true',0,1,'icon.etc_sword_body_i00',1,1,1),
(1744,'Dirk Mold','PIECES','false','material',60,'stackable','liquid','none',0,5410,0,'true',0,1,'etc_mold_i00',1,1,1),
(1745,'Brandish Blade','PIECES','false','material',60,'stackable','liquid','none',0,1880,0,'true',0,1,'icon.etc_sword_body_i00',1,1,1),
(1746,'Short Spear Blade','PIECES','false','material',60,'stackable','liquid','none',0,3000,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(1747,'Shining Blade','PIECES','false','material',60,'stackable','liquid','none',0,1700,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(1748,'Sword of Reflection Mold','PIECES','false','material',60,'stackable','liquid','none',0,13600,0,'true',0,1,'etc_mold_i00',1,1,1),
(1749,'Branch of The Mother Tree','PIECES','false','material',60,'stackable','liquid','none',0,72914,0,'true',0,1,'icon.etc_branch_green_i00',1,1,1),
(1750,'Dark Forest Leaf','PIECES','false','material',60,'stackable','liquid','none',0,2267,0,'true',0,1,'etc_herb_blue_i00',1,1,1),
(1751,'Lump of Iron','PIECES','false','material',60,'stackable','liquid','none',0,5278,0,'true',0,1,'etc_bead_silver_i00',1,1,1),
(1752,'Piece of Sword Breaker','PIECES','false','material',60,'stackable','liquid','none',0,3050,0,'true',0,1,'etc_bark_gold_i00',1,1,1),
(1753,'Sword Breaker Mold','PIECES','false','material',60,'stackable','liquid','none',0,24400,0,'true',0,1,'etc_mold_i00',1,1,1),
(1754,'Steel Bow Mold','PIECES','false','material',60,'stackable','liquid','none',0,4067,0,'true',0,1,'etc_mold_i00',1,1,1),
(1755,'Metal Stave','PIECES','false','material',60,'stackable','liquid','none',0,8133,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(1756,'Spirit of The Saber Smith','PIECES','false','material',60,'stackable','liquid','none',0,4544,0,'true',0,1,'etc_skull_black_i00',1,1,1),
(1757,'Saber Blade','PIECES','false','material',60,'stackable','liquid','none',0,5453,0,'true',0,1,'icon.etc_sword_body_i00',1,1,1),
(1758,'Saber Mold','PIECES','false','material',60,'stackable','liquid','none',0,13633,0,'true',0,1,'etc_mold_i00',1,1,1),
(1759,'Blood of Assassin','PIECES','false','material',60,'stackable','liquid','none',0,4544,0,'true',0,1,'etc_reagent_red_i00',1,1,1),
(1760,'Assassin Blade','PIECES','false','material',60,'stackable','liquid','none',0,5453,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(1761,'Assassin Mold','PIECES','false','material',60,'stackable','liquid','none',0,27267,0,'true',0,1,'etc_mold_i00',1,1,1),
(1762,'Piece of Trident','PIECES','false','material',60,'stackable','liquid','none',0,6850,0,'true',0,1,'etc_bark_blue_i00',1,1,1),
(1763,'Ruby Fragment','PIECES','false','material',60,'stackable','liquid','none',0,5113,0,'true',0,1,'etc_powder_red_i00',1,1,1),
(1764,'Deep Sea Water','PIECES','false','material',60,'stackable','liquid','none',0,10225,0,'true',0,1,'etc_potion_blue_i00',1,1,1),
(1765,'Spinebone Fragment','PIECES','false','material',60,'stackable','liquid','none',0,6440,0,'true',0,1,'etc_piece_bone_white_i00',1,1,1),
(1766,'Spinebone Pattern','PIECES','false','material',60,'stackable','liquid','none',0,12880,0,'true',0,1,'etc_mold_i00',1,1,1),
(1767,'Piece of Mace of Judgment','PIECES','false','material',60,'stackable','liquid','none',0,7156,0,'true',0,1,'etc_bark_gold_i00',1,1,1),
(1768,'Pattern of Judgment','PIECES','false','material',60,'stackable','liquid','none',0,10733,0,'true',0,1,'etc_mold_i00',1,1,1),
(1769,'Piece of Conjuror''s Staff','PIECES','false','material',60,'stackable','liquid','none',0,6440,0,'true',0,1,'etc_bark_blue_i00',1,1,1),
(1770,'Magic Flute','PIECES','false','material',60,'stackable','liquid','none',0,12880,0,'true',0,1,'etc_flute_i00',1,1,1),
(1771,'Elven Stave','PIECES','false','material',60,'stackable','liquid','none',0,21467,0,'true',0,1,'etc_branch_green_i00',1,1,1),
(1772,'Leaf of the Mother Tree','PIECES','false','material',60,'stackable','liquid','none',0,5367,0,'true',0,1,'etc_herb_green_i00',1,1,1),
(1773,'Piece of Dwarven Trident','PIECES','false','material',60,'stackable','liquid','none',0,8613,0,'true',0,1,'etc_bark_green_i00',1,1,1),
(1774,'Piece of Two-Handed Sword','PIECES','false','material',60,'stackable','liquid','none',0,5688,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(1775,'Two-Handed Sword Mold','PIECES','false','material',60,'stackable','liquid','none',0,96700,0,'true',0,1,'etc_mold_i00',1,1,1),
(1776,'Piece of Spiked Club','PIECES','false','material',60,'stackable','liquid','none',0,32233,0,'true',0,1,'etc_bark_blue_i00',1,1,1),
(1777,'Steel Piece of Club','PIECES','false','material',60,'stackable','liquid','none',0,6447,0,'true',0,1,'etc_plate_glay_i00',1,1,1),
(1778,'Shilen Bone','PIECES','false','material',60,'stackable','liquid','none',0,6447,0,'true',0,1,'etc_piece_bone_white_i00',1,1,1),
(1779,'Shilen Mane','PIECES','false','material',60,'stackable','liquid','none',0,64467,0,'true',0,1,'etc_mane_i00',1,1,1),
(1780,'Purity Bronze','PIECES','false','material',60,'stackable','liquid','none',0,9210,0,'true',0,1,'etc_plate_blue_i00',1,1,1),
(1781,'Gastraphetes Stave','PIECES','false','material',60,'stackable','liquid','none',0,32233,0,'true',0,1,'weapon_short_bow_i00',1,1,1),
(1782,'Gastraphetes Addendum','PIECES','false','material',60,'stackable','liquid','none',0,6447,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1783,'Blood of Fiend','PIECES','false','material',60,'stackable','liquid','none',0,10744,0,'true',0,1,'etc_reagent_gold_i00',1,1,1),
(1784,'Cursed Leather','PIECES','false','material',60,'stackable','liquid','none',0,10744,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1785,'Soul Ore','MATHERIALS','false','material',10,'stackable','liquid','none',0,250,0,'true',0,1,'etc_crystal_white_i00',1,1,1),
(1786,'Recipe: Broad Sword','RECIPIES','false','recipe',30,'stackable','liquid','none',0,250,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1787,'Recipe: Willow Staff','RECIPIES','false','recipe',30,'stackable','liquid','none',0,250,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1788,'Recipe: Bow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,250,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1789,'Recipe: Cedar Staff','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1082,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1790,'Recipe: Dirk','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1082,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1791,'Recipe: Brandish','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1082,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1792,'Recipe: Short Spear','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2720,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1793,'Recipe: Sword of Reflection','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2720,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1794,'Recipe: Forest Bow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2720,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1795,'Recipe:Leather Shoes','RECIPIES','false','recipe',30,'stackable','liquid','none',0,53,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1796,'Recipe: Leather Tunic','RECIPIES','false','recipe',30,'stackable','liquid','none',0,159,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1797,'Recipe: Leather Stockings','RECIPIES','false','recipe',30,'stackable','liquid','none',0,99,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1798,'Recipe: Leather Helmet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,204,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1799,'Recipe: Leather Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,135,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1800,'Recipe: Piece Bone Breastplate','RECIPIES','false','recipe',30,'stackable','liquid','none',0,636,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1801,'Recipe: Piece Bone Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,397,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1802,'Recipe: Necklace of Anguish','RECIPIES','false','recipe',30,'stackable','liquid','none',0,93,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1803,'Recipe: Necklace of Wisdom','RECIPIES','false','recipe',30,'stackable','liquid','none',0,238,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1804,'Recipe: Soulshot: D-Grade','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(1805,'Recipe: Soulshot: C-Grade','RECIPIES','false','recipe',30,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(1806,'Recipe: Soulshot: B-Grade','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(1807,'Recipe: Soulshot: A-Grade','RECIPIES','false','recipe',30,'stackable','liquid','none',0,150000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(1808,'Recipe: Soulshot: S Grade','RECIPIES','false','recipe',30,'stackable','liquid','none',0,450000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(1809,'Recipe: Durable Stem','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1810,'Recipe: Wooden Frame','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1811,'Recipe: Bark of Treant','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1812,'Recipe: Coarse Bone Powder','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1813,'Recipe: Refined Steel','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1814,'Recipe: Leather','RECIPIES','false','recipe',30,'stackable','liquid','none',0,380,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1815,'Recipe: Bowstring','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1816,'Recipe: Steel Frame','RECIPIES','false','recipe',30,'stackable','liquid','none',0,500,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1817,'Recipe: Cord','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1818,'Recipe: Refined Bronze','RECIPIES','false','recipe',30,'stackable','liquid','none',0,500,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1819,'Recipe: Treant Potion','RECIPIES','false','recipe',30,'stackable','liquid','none',0,500,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1820,'Recipe: Spell Paper','RECIPIES','false','recipe',30,'stackable','liquid','none',0,500,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1821,'Recipe: Flaming Oil','RECIPIES','false','recipe',30,'stackable','liquid','none',0,500,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(1822,'Recipe: Magic Powder','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(1823,'Recipe: Refined Mythril','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(1824,'Recipe: Fortified Steel','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(1825,'Recipe: Oriharukon','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2800,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(1826,'Recipe: Spell Solution','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(1827,'Recipe: Metal Frame','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(1828,'Recipe: Steel of Highest Grade','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(1829,'Scroll of Escape: Clan Hall','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,500,0,'true',2040,1,'etc_scroll_of_return_agit_i00',1,1,1),
(1830,'Scroll of Escape: Castle','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,500,0,'true',2041,1,'etc_scroll_of_return_castle_i00',1,1,1),
(1831,'Antidote','CONSUMABLE','false','potion',20,'stackable','liquid','none',0,75,0,'true',2042,1,'etc_herb_green_i00',1,1,1),
(1832,'Greater Antidote','CONSUMABLE','false','potion',20,'stackable','liquid','none',0,180,0,'true',2043,1,'etc_reagent_green_i00',1,1,1),
(1833,'Bandage','CONSUMABLE','false','potion',20,'stackable','liquid','none',0,75,0,'true',2044,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1834,'Emergency Dressing','CONSUMABLE','false','potion',20,'stackable','liquid','none',0,180,0,'true',2045,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1835,'Soulshot: No Grade','CONSUMABLE','false','none',4,'stackable','paper','none',0,7,0,'true',0,1,'etc_spirit_bullet_white_i00',1,1,1),
(1836,'Kendell''s 1st Order','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(1837,'Kendell''s 2nd Order','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(1838,'Kendell''s 3rd Order','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(1839,'Kendell''s 4th Order','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(1840,'Kendell''s 5th Order','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(1841,'Kendell''s 6th Order','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(1842,'Kendell''s 7th Order','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(1843,'Kendell''s 8th Order','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(1844,'Kaboo Chief''s 1st Torque','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'accessary_necklace_of_black_ore_i00',1,1,1),
(1845,'Kaboo Chief''s 2nd Torque','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'accessary_necklace_of_black_ore_i00',1,1,1),
(1846,'Turek Dog Tag','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_totem_necklace_black_i00',1,1,1),
(1847,'Turek Medallion','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_totem_necklace_green_i00',1,1,1),
(1848,'Clay Urn Fragment','OTHER','false','none',10,'stackable','liquid','none',0,200,0,'false',0,1,'etc_broken_crystal_white_i00',1,1,1),
(1849,'Brass Trinket Piece','OTHER','false','none',10,'stackable','liquid','none',0,240,0,'false',0,1,'etc_broken_crystal_gold_i00',1,1,1),
(1850,'Bronze Mirror Piece','OTHER','false','none',10,'stackable','liquid','none',0,240,0,'false',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(1851,'Jade Necklace Bead','OTHER','false','none',10,'stackable','liquid','none',0,280,0,'false',0,1,'etc_debris_i00',1,1,1),
(1852,'Ancient Clay Urn','OTHER','false','none',10,'stackable','liquid','none',0,1800,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(1853,'Ancient Brass Tiara','OTHER','false','none',10,'stackable','liquid','none',0,2100,0,'false',0,1,'etc_ancient_crown_i03',1,1,1),
(1854,'Ancient Bronze Mirror','OTHER','false','none',10,'stackable','liquid','none',0,2100,0,'false',0,1,'etc_mirror_i00',1,1,1),
(1855,'Ancient Jade Necklace','OTHER','false','none',10,'stackable','liquid','none',0,2550,0,'false',0,1,'etc_leash_i00',1,1,1),
(1856,'Amulet: Chant of Life','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(1857,'Keltir Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1858,'Keltir Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1859,'Keltir Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1860,'Keltir Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1861,'Keltir Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1862,'Keltir Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(1863,'Map: Elmore','OTHER','false','none',0,'normal','liquid','none',0,1000,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1864,'Stem','MATHERIALS','false','material',2,'stackable','liquid','none',0,100,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(1865,'Varnish','MATHERIALS','false','material',2,'stackable','liquid','none',0,200,0,'true',0,1,'etc_pouch_yellow_i00',1,1,1),
(1866,'Suede','MATHERIALS','false','material',2,'stackable','liquid','none',0,300,0,'true',0,1,'etc_suede_i00',1,1,1),
(1867,'Animal Skin','MATHERIALS','false','material',2,'stackable','liquid','none',0,150,0,'true',0,1,'etc_leather_brown_i00',1,1,1),
(1868,'Thread','MATHERIALS','false','material',2,'stackable','liquid','none',0,100,0,'true',0,1,'etc_skein_white_i00',1,1,1),
(1869,'Iron Ore','MATHERIALS','false','material',2,'stackable','liquid','none',0,200,0,'true',0,1,'etc_lump_gray_i00',1,1,1),
(1870,'Coal','MATHERIALS','false','material',2,'stackable','liquid','none',0,200,0,'true',0,1,'etc_coal_i00',1,1,1),
(1871,'Charcoal','MATHERIALS','false','material',2,'stackable','liquid','none',0,200,0,'true',0,1,'etc_charcoal_i00',1,1,1),
(1872,'Animal Bone','MATHERIALS','false','material',2,'stackable','liquid','none',0,150,0,'true',0,1,'etc_piece_bone_white_i00',1,1,1),
(1873,'Silver Nugget','MATHERIALS','false','material',2,'stackable','liquid','none',0,500,0,'true',0,1,'etc_silver_i00',1,1,1),
(1874,'Oriharukon Ore','MATHERIALS','false','material',2,'stackable','liquid','none',0,3000,0,'true',0,1,'etc_oriharukon_ore_i00',1,1,1),
(1875,'Stone of Purity','MATHERIALS','false','material',2,'stackable','liquid','none',0,3000,0,'true',0,1,'etc_crystal_ball_white_i00',1,1,1),
(1876,'Mithril Ore','MATHERIALS','false','material',2,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_mithril_ore_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(1877,'Adamantite Nugget','MATHERIALS','false','material',2,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_adamantite_i00',1,1,1),
(1878,'Braided Hemp','MATHERIALS','false','material',2,'stackable','liquid','none',0,500,0,'true',0,1,'etc_braided_hemp_i00',1,1,1),
(1879,'Cokes','MATHERIALS','false','material',2,'stackable','liquid','none',0,1200,0,'true',0,1,'etc_oil_pot_black_i00',1,1,1),
(1880,'Steel','MATHERIALS','false','material',2,'stackable','liquid','none',0,2000,0,'true',0,1,'etc_lump_black_i00',1,1,1),
(1881,'Coarse Bone Powder','MATHERIALS','false','material',2,'stackable','liquid','none',0,1500,0,'true',0,1,'etc_powder_white_i00',1,1,1),
(1882,'Leather','MATHERIALS','false','material',2,'stackable','liquid','none',0,900,0,'true',0,1,'etc_leather_i00',1,1,1),
(1883,'Steel Mold','MATHERIALS','false','material',2,'stackable','liquid','none',0,4500,0,'true',0,1,'etc_mold_i00',1,1,1),
(1884,'Cord','MATHERIALS','false','material',2,'stackable','liquid','none',0,325,0,'true',0,1,'etc_skein_gray_i00',1,1,1),
(1885,'High Grade Suede','MATHERIALS','false','material',2,'stackable','liquid','none',0,2400,0,'true',0,1,'etc_pouch_yellow_i00',1,1,1),
(1886,'Silver Mold','MATHERIALS','false','material',2,'stackable','liquid','none',0,13500,0,'true',0,1,'etc_silver_mold_i00',1,1,1),
(1887,'Varnish of Purity','MATHERIALS','false','material',2,'stackable','liquid','none',0,8100,0,'true',0,1,'etc_potion_clear_i00',1,1,1),
(1888,'Synthetic Cokes','MATHERIALS','false','material',2,'stackable','liquid','none',0,6600,0,'true',0,1,'etc_synthetic_cokes_i00',1,1,1),
(1889,'Compound Braid','MATHERIALS','false','material',2,'stackable','liquid','none',0,3000,0,'true',0,1,'etc_compound_braid_i00',1,1,1),
(1890,'Mithril Alloy','MATHERIALS','false','material',2,'stackable','liquid','none',0,13100,0,'true',0,1,'etc_lump_white_i00',1,1,1),
(1891,'Artisan''s Frame','MATHERIALS','false','material',2,'stackable','liquid','none',0,95000,0,'true',0,1,'etc_artisans_frame_i00',1,1,1),
(1892,'Blacksmith''s Frame','MATHERIALS','false','material',2,'stackable','liquid','none',0,64000,0,'true',0,1,'etc_blacksmiths_frame_i00',1,1,1),
(1893,'Oriharukon','MATHERIALS','false','material',2,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_oriharukon_i00',1,1,1),
(1894,'Crafted Leather','MATHERIALS','false','material',2,'stackable','liquid','none',0,5700,0,'true',0,1,'etc_crafted_leather_i00',1,1,1),
(1895,'Metallic Fiber','MATHERIALS','false','material',2,'stackable','liquid','none',0,700,0,'true',0,1,'etc_metallic_fiber_i00',1,1,1),
(1896,'Necklace of Anguish Chain','PIECES','false','material',60,'stackable','liquid','none',0,472,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(1897,'Necklace of Wisdom Chain','PIECES','false','material',60,'stackable','liquid','none',0,840,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(1898,'Blue Diamond Necklace Gem','PIECES','false','material',60,'stackable','liquid','none',0,1947,0,'true',0,1,'etc_gem_blue_i00',1,1,1),
(1899,'Necklace of Devotion Chain','PIECES','false','material',60,'stackable','liquid','none',0,1280,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(1900,'Enchanted Necklace Chain','PIECES','false','material',60,'stackable','liquid','none',0,1828,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(1901,'Tiger''s Eye Earring Stone','PIECES','false','material',60,'stackable','liquid','none',0,1448,0,'true',0,1,'etc_jewel_gold_i00',1,1,1),
(1902,'Elven Earring Beads','PIECES','false','material',60,'stackable','liquid','none',0,1974,0,'true',0,1,'etc_crystal_ball_green_i00',1,1,1),
(1903,'Elven Ring Piece','PIECES','false','material',60,'stackable','liquid','none',0,1199,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(1904,'Elven Necklace Beads','PIECES','false','material',60,'stackable','liquid','none',0,2143,0,'true',0,1,'etc_crystal_ball_green_i00',1,1,1),
(1905,'Omen Beast''s Eye Earring Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,2056,0,'true',0,1,'etc_bead_silver_i00',1,1,1),
(1906,'Mithril Ring Wire','PIECES','false','material',60,'stackable','liquid','none',0,1455,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(1907,'Necklace of Darkness Gem','PIECES','false','material',60,'stackable','liquid','none',0,2875,0,'true',0,1,'etc_gem_black_i00',1,1,1),
(1908,'Moonstone Earring Wire','PIECES','false','material',60,'stackable','liquid','none',0,2112,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(1909,'Aquastone Ring Wire','PIECES','false','material',60,'stackable','liquid','none',0,1481,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(1910,'Aquastone Necklace Chain','PIECES','false','material',60,'stackable','liquid','none',0,2656,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(1911,'Earring of Protection Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,2689,0,'true',0,1,'etc_gem_yellow_i00',1,1,1),
(1912,'Ring of Protection Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,1856,0,'true',0,1,'etc_gem_yellow_i00',1,1,1),
(1913,'Necklace of Protection Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,3289,0,'true',0,1,'etc_gem_yellow_i00',1,1,1),
(1914,'Earring of Binding Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,3560,0,'true',0,1,'etc_gem_clear_i00',1,1,1),
(1915,'Ring of Ages Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,2270,0,'true',0,1,'etc_gem_clear_i00',1,1,1),
(1916,'Necklace of Mermaid Teardrop','PIECES','false','material',60,'stackable','liquid','none',0,4700,0,'true',0,1,'etc_reagent_white_i00',1,1,1),
(1917,'Sage''s Necklace Chain','PIECES','false','material',60,'stackable','liquid','none',0,5845,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(1918,'Nassen''s Earring Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,4618,0,'true',0,1,'etc_gem_red_i00',1,1,1),
(1919,'Ring of Sage Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,3482,0,'true',0,1,'etc_bead_silver_i00',1,1,1),
(1920,'Necklace of Binding Chain','PIECES','false','material',60,'stackable','liquid','none',0,5845,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(1921,'Leather Shoes Texture','PIECES','false','material',60,'stackable','liquid','none',0,310,0,'true',0,1,'etc_leather_yellow_i00',1,1,1),
(1922,'Leather Tunic Pattern','PIECES','false','material',60,'stackable','liquid','none',0,784,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1923,'Leather Stocking Pattern','PIECES','false','material',60,'stackable','liquid','none',0,488,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1924,'Leather Helmet Design','PIECES','false','material',60,'stackable','liquid','none',0,620,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(1925,'Leather Gloves Lining','PIECES','false','material',60,'stackable','liquid','none',0,305,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1926,'Piece Bone Breastplate Fragment','PIECES','false','material',60,'stackable','liquid','none',0,1980,0,'true',0,1,'etc_piece_bone_black_i00',1,1,1),
(1927,'Hard Leather Shirt Pattern','PIECES','false','material',60,'stackable','liquid','none',0,2507,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1928,'Piece Bone Gaiters Fragment','PIECES','false','material',60,'stackable','liquid','none',0,1373,0,'true',0,1,'etc_piece_bone_black_i00',1,1,1),
(1929,'Hard Leather Gaiters Material','PIECES','false','material',60,'stackable','liquid','none',0,1550,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1930,'Boot Lining','PIECES','false','material',60,'stackable','liquid','none',0,780,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1931,'Leather Boot Lining','PIECES','false','material',60,'stackable','liquid','none',0,1530,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1932,'Bone Helmet Design','PIECES','false','material',60,'stackable','liquid','none',0,1260,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(1933,'Dark Stocking Fabric','PIECES','false','material',60,'stackable','liquid','none',0,1700,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1934,'Crafted Leather Gloves Lining','PIECES','false','material',60,'stackable','liquid','none',0,1530,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1935,'Scale Mail Fragment','PIECES','false','material',60,'stackable','liquid','none',0,3580,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1936,'White Tunic Pattern','PIECES','false','material',60,'stackable','liquid','none',0,2444,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1937,'Scale Gaiters Fragment','PIECES','false','material',60,'stackable','liquid','none',0,2328,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1938,'Mithril Banded Mail Material','PIECES','false','material',60,'stackable','liquid','none',0,2975,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1939,'Mithril Banded Gaiters Material','PIECES','false','material',60,'stackable','liquid','none',0,2277,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1940,'Iron Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,1340,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(1941,'Brigandine Temper','PIECES','false','material',60,'stackable','liquid','none',0,5029,0,'true',0,1,'etc_plate_glay_i00',1,1,1),
(1942,'Manticore Skin Shirt Texture','PIECES','false','material',60,'stackable','liquid','none',0,3921,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1943,'Manticore Skin Gaiters Pattern','PIECES','false','material',60,'stackable','liquid','none',0,2518,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(1944,'Mithril Tunic Fabric','PIECES','false','material',60,'stackable','liquid','none',0,3921,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1945,'Mithril Stocking Design','PIECES','false','material',60,'stackable','liquid','none',0,2518,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1946,'Rip Gauntlets Pattern','PIECES','false','material',60,'stackable','liquid','none',0,1480,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1947,'Kite Shield Fragment','PIECES','false','material',60,'stackable','liquid','none',0,1389,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1948,'Boots of Power Pattern','PIECES','false','material',60,'stackable','liquid','none',0,1480,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1949,'Mithril Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,1792,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(1950,'Half Plate Temper','PIECES','false','material',60,'stackable','liquid','none',0,6162,0,'true',0,1,'etc_plate_glay_i00',1,1,1),
(1951,'Plate Gaiters Part','PIECES','false','material',60,'stackable','liquid','none',0,3962,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1952,'Salamander Skin Mail Texture','PIECES','false','material',60,'stackable','liquid','none',0,6244,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1953,'Sage''s Rag Lining','PIECES','false','material',60,'stackable','liquid','none',0,6244,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1954,'Karmian Stocking Design','PIECES','false','material',60,'stackable','liquid','none',0,3762,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1955,'Chain Helmet Design','PIECES','false','material',60,'stackable','liquid','none',0,2481,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(1956,'Square Shield Fragment','PIECES','false','material',60,'stackable','liquid','none',0,1762,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1957,'Assault Boots Part','PIECES','false','material',60,'stackable','liquid','none',0,1792,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1958,'Mithril Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,2225,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(1959,'Chain Mail Shirt Material','PIECES','false','material',60,'stackable','liquid','none',0,7425,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1960,'Chain Gaiters Part','PIECES','false','material',60,'stackable','liquid','none',0,3650,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1961,'Mithril Shirt Fabric','PIECES','false','material',60,'stackable','liquid','none',0,6250,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1962,'Karmian Tunic Pattern','PIECES','false','material',60,'stackable','liquid','none',0,6250,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1963,'Ogre Power Gauntlets Part','PIECES','false','material',60,'stackable','liquid','none',0,1792,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1964,'Eldarake Temper','PIECES','false','material',60,'stackable','liquid','none',0,2475,0,'true',0,1,'etc_plate_glay_i00',1,1,1),
(1965,'Metal Plate Helmet Material','PIECES','false','material',60,'stackable','liquid','none',0,2967,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1966,'Plated Leather Fragment','PIECES','false','material',60,'stackable','liquid','none',0,5478,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1967,'Plated Leather Gaiters Material','PIECES','false','material',60,'stackable','liquid','none',0,3667,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1968,'Dwarven Chain Mail Shirt Material','PIECES','false','material',60,'stackable','liquid','none',0,8300,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1969,'Dwarven Chain Gaiters Material','PIECES','false','material',60,'stackable','liquid','none',0,5233,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1970,'Robe of Seal Fabric','PIECES','false','material',60,'stackable','liquid','none',0,8956,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1971,'Great Helmet Material','PIECES','false','material',60,'stackable','liquid','none',0,3267,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1972,'Knight''s Shield Fragment','PIECES','false','material',60,'stackable','liquid','none',0,2500,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1973,'Pa''agrian Hand Design','PIECES','false','material',60,'stackable','liquid','none',0,2378,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(1974,'Crimson Boot Fabric','PIECES','false','material',60,'stackable','liquid','none',0,2378,0,'true',0,1,'etc_piece_of_cloth_red_i00',1,1,1),
(1975,'Rind Leather Armor Design','PIECES','false','material',60,'stackable','liquid','none',0,6089,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(1976,'Rind Leather Gaiters Material','PIECES','false','material',60,'stackable','liquid','none',0,3289,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1977,'Composite Armor Temper','PIECES','false','material',60,'stackable','liquid','none',0,13520,0,'true',0,1,'etc_plate_glay_i00',1,1,1),
(1978,'Tower Shield Fragment','PIECES','false','material',60,'stackable','liquid','none',0,3120,0,'true',0,1,'etc_plate_glay_i00',1,1,1),
(1979,'Demon''s Tunic Fabric','PIECES','false','material',60,'stackable','liquid','none',0,8240,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1980,'Demon''s Stocking Pattern','PIECES','false','material',60,'stackable','liquid','none',0,4700,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1981,'Mithril Gauntlets Design','PIECES','false','material',60,'stackable','liquid','none',0,3400,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(1982,'Forgotten Boots Pattern','PIECES','false','material',60,'stackable','liquid','none',0,3400,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1983,'Shining Circlet Pattern','PIECES','false','material',60,'stackable','liquid','none',0,4560,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1984,'Theca Leather Armor Pattern','PIECES','false','material',60,'stackable','liquid','none',0,9330,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1985,'Theca Leather Gaiters Pattern','PIECES','false','material',60,'stackable','liquid','none',0,5800,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1986,'Full Plate Armor Temper','PIECES','false','material',60,'stackable','liquid','none',0,18927,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1987,'Drake Leather Armor Texture','PIECES','false','material',60,'stackable','liquid','none',0,13109,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1988,'Divine Tunic Fabric','PIECES','false','material',60,'stackable','liquid','none',0,10409,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(1989,'Divine Stocking Pattern','PIECES','false','material',60,'stackable','liquid','none',0,6636,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1990,'Mithril Helmet Design','PIECES','false','material',60,'stackable','liquid','none',0,5782,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1991,'Cap of Mana Pattern','PIECES','false','material',60,'stackable','liquid','none',0,5782,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(1992,'Paradia Hood Material','PIECES','false','material',60,'stackable','liquid','none',0,5782,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1993,'Hood of Solar Eclipse Texture','PIECES','false','material',60,'stackable','liquid','none',0,5782,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1994,'Hood of Summoning Texture','PIECES','false','material',60,'stackable','liquid','none',0,5782,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1995,'Elemental Hood Material','PIECES','false','material',60,'stackable','liquid','none',0,5782,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1996,'Hood of Grace Texture','PIECES','false','material',60,'stackable','liquid','none',0,5782,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(1997,'Phoenix Hood Material','PIECES','false','material',60,'stackable','liquid','none',0,5782,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1998,'Hood of Aid Material','PIECES','false','material',60,'stackable','liquid','none',0,5782,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(1999,'Flame Helm Design','PIECES','false','material',60,'stackable','liquid','none',0,5782,0,'true',0,1,'etc_pouch_yellow_i00',1,1,1),
(2000,'Tallum Helm Design','PIECES','false','material',60,'stackable','liquid','none',0,68831,0,'true',0,1,'etc_pouch_yellow_i00',1,1,1),
(2001,'Helm of Avadon Design','PIECES','false','material',60,'stackable','liquid','none',0,5782,0,'true',0,1,'etc_pouch_yellow_i00',1,1,1),
(2002,'Helmet of Pledge Pattern','PIECES','false','material',60,'stackable','liquid','none',0,5782,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(2003,'Gauntlets of Ghost Pattern','PIECES','false','material',60,'stackable','liquid','none',0,3673,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(2004,'Adamantite Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,3673,0,'true',0,1,'etc_pouch_yellow_i00',1,1,1),
(2005,'Broadsword Blade','PIECES','false','material',60,'stackable','liquid','none',0,2800,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2006,'Willow Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,2800,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2007,'Bow Shaft','PIECES','false','material',60,'stackable','liquid','none',0,2800,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2008,'Cedar Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,5140,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2009,'Dirk Blade','PIECES','false','material',60,'stackable','liquid','none',0,5640,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2010,'Brandish Blade','PIECES','false','material',60,'stackable','liquid','none',0,5140,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2011,'Short Spear Edge','PIECES','false','material',60,'stackable','liquid','none',0,8767,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2012,'Sword of Reflection Blade','PIECES','false','material',60,'stackable','liquid','none',0,9600,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2013,'Forest Bow Shaft','PIECES','false','material',60,'stackable','liquid','none',0,9267,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2014,'Iron Hammer Head','PIECES','false','material',60,'stackable','liquid','none',0,17400,0,'true',0,1,'etc_squares_silver_i00',1,1,1),
(2015,'Sword Breaker Edge','PIECES','false','material',60,'stackable','liquid','none',0,16400,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2016,'Composite Bow Shaft','PIECES','false','material',60,'stackable','liquid','none',0,17067,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2017,'Saber Blade','PIECES','false','material',60,'stackable','liquid','none',0,15050,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2018,'Assassin Knife Edge','PIECES','false','material',60,'stackable','liquid','none',0,15050,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2019,'Trident Edge','PIECES','false','material',60,'stackable','liquid','none',0,9300,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2020,'Temptation of Abyss Piece','PIECES','false','material',60,'stackable','liquid','none',0,11425,0,'true',0,1,'etc_oriharukon_ore_i00',1,1,1),
(2021,'Spinebone Sword Blade','PIECES','false','material',60,'stackable','liquid','none',0,15840,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2022,'Mace of Judgment Head','PIECES','false','material',60,'stackable','liquid','none',0,12840,0,'true',0,1,'etc_squares_silver_i00',1,1,1),
(2023,'Conjuror''s Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,16140,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2024,'Elven Bow Shaft','PIECES','false','material',60,'stackable','liquid','none',0,14040,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2025,'Dwarven Trident Edge','PIECES','false','material',60,'stackable','liquid','none',0,14440,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2026,'Two-Handed Sword Edge','PIECES','false','material',60,'stackable','liquid','none',0,16617,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2027,'Spiked Club Head','PIECES','false','material',60,'stackable','liquid','none',0,15267,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2028,'Shilen Knife Edge','PIECES','false','material',60,'stackable','liquid','none',0,16833,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2029,'Gastraphetes Shaft','PIECES','false','material',60,'stackable','liquid','none',0,16767,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2030,'Tome of Blood Page','PIECES','false','material',60,'stackable','liquid','none',0,17100,0,'true',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(2031,'Morning Star Head','PIECES','false','material',60,'stackable','liquid','none',0,19757,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2032,'Goat Head Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,21643,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2033,'Winged Spear Blade','PIECES','false','material',60,'stackable','liquid','none',0,17929,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2034,'Sword of Revolution Blade','PIECES','false','material',60,'stackable','liquid','none',0,18929,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2035,'Tarbar Head','PIECES','false','material',60,'stackable','liquid','none',0,19757,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2036,'Skull Breaker Head','PIECES','false','material',60,'stackable','liquid','none',0,19757,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2037,'Heavy Bone Club Head','PIECES','false','material',60,'stackable','liquid','none',0,19757,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2038,'Maingauche Edge','PIECES','false','material',60,'stackable','liquid','none',0,18929,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2039,'Bich''Hwa Edge','PIECES','false','material',60,'stackable','liquid','none',0,19757,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2040,'Strengthened Long Bow Shaft','PIECES','false','material',60,'stackable','liquid','none',0,17286,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2041,'War Pick Head','PIECES','false','material',60,'stackable','liquid','none',0,17929,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2042,'Crucifix of Blood Piece','PIECES','false','material',60,'stackable','liquid','none',0,21643,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2043,'Eye of Infinity Stone','PIECES','false','material',60,'stackable','liquid','none',0,21643,0,'true',0,1,'etc_crystal_ball_gold_i00',1,1,1),
(2044,'Cursed Maingauche Edge','PIECES','false','material',60,'stackable','liquid','none',0,18929,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2045,'Blue Crystal Skull Part','PIECES','false','material',60,'stackable','liquid','none',0,21786,0,'true',0,1,'etc_skull_red_i00',1,1,1),
(2046,'Demon Fangs Part','PIECES','false','material',60,'stackable','liquid','none',0,21786,0,'true',0,1,'etc_horn_i00',1,1,1),
(2047,'Claymore Blade','PIECES','false','material',60,'stackable','liquid','none',0,22750,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2048,'Bonebreaker Head','PIECES','false','material',60,'stackable','liquid','none',0,24188,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2049,'Atuba Hammer Head','PIECES','false','material',60,'stackable','liquid','none',0,24188,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2050,'Ghost Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,22812,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2051,'Staff of Life Shaft','PIECES','false','material',60,'stackable','liquid','none',0,22812,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2052,'Mithril Dagger Blade','PIECES','false','material',60,'stackable','liquid','none',0,23062,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2053,'Scallop Jamadhr Edge','PIECES','false','material',60,'stackable','liquid','none',0,24188,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2054,'Light Crossbow Shaft','PIECES','false','material',60,'stackable','liquid','none',0,23500,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2055,'Glaive Edge','PIECES','false','material',60,'stackable','liquid','none',0,24188,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2056,'Vajra Wand Frame','PIECES','false','material',60,'stackable','liquid','none',0,22812,0,'true',0,1,'etc_mold_i00',1,1,1),
(2057,'Ancient Reagent Remnant','PIECES','false','material',60,'stackable','liquid','none',0,22812,0,'true',0,1,'etc_potion_clear_i00',1,1,1),
(2058,'Atuba Mace Head','PIECES','false','material',60,'stackable','liquid','none',0,24188,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2059,'Flamberge Blade','PIECES','false','material',60,'stackable','liquid','none',0,26925,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2060,'Stormbringer Blade','PIECES','false','material',60,'stackable','liquid','none',0,25188,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2061,'Big Hammer Head','PIECES','false','material',60,'stackable','liquid','none',0,25875,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2062,'Scythe Edge','PIECES','false','material',60,'stackable','liquid','none',0,25500,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2063,'Battle Axe Head','PIECES','false','material',60,'stackable','liquid','none',0,25875,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2064,'Silver Axe Head','PIECES','false','material',60,'stackable','liquid','none',0,25875,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2065,'Skull Graver Head','PIECES','false','material',60,'stackable','liquid','none',0,25875,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2066,'Heavy Doom Hammer Head','PIECES','false','material',60,'stackable','liquid','none',0,25500,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2067,'Crystal Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,27750,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2068,'Stick of Faith Shaft','PIECES','false','material',60,'stackable','liquid','none',0,27750,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2069,'Heavy Doom Axe Blade','PIECES','false','material',60,'stackable','liquid','none',0,25500,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2070,'Cursed Dagger Blade','PIECES','false','material',60,'stackable','liquid','none',0,25188,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2071,'Wolverine Needle Edge','PIECES','false','material',60,'stackable','liquid','none',0,25188,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2072,'Dark Elven Dagger Edge','PIECES','false','material',60,'stackable','liquid','none',0,25188,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2073,'Chakram Edge','PIECES','false','material',60,'stackable','liquid','none',0,25875,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2074,'Crystallized Ice Bow Shaft','PIECES','false','material',60,'stackable','liquid','none',0,28238,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2075,'Orcish Glaive Blade','PIECES','false','material',60,'stackable','liquid','none',0,25500,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2076,'Body Slasher Blade','PIECES','false','material',60,'stackable','liquid','none',0,25500,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2077,'Shamshir Blade','PIECES','false','material',60,'stackable','liquid','none',0,30100,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2078,'Katana Blade','PIECES','false','material',60,'stackable','liquid','none',0,30100,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2079,'Bec De Corbin Blade','PIECES','false','material',60,'stackable','liquid','none',0,29111,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2080,'Spirit Sword Blade','PIECES','false','material',60,'stackable','liquid','none',0,30100,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2081,'Raid Sword Blade','PIECES','false','material',60,'stackable','liquid','none',0,30100,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2082,'Cursed Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,28378,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2083,'Stiletto Edge','PIECES','false','material',60,'stackable','liquid','none',0,30100,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2084,'Soulfire Dirk Blade','PIECES','false','material',60,'stackable','liquid','none',0,30100,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2085,'Crossbow Shaft','PIECES','false','material',60,'stackable','liquid','none',0,28911,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2086,'Elven Bow of Nobility Shaft','PIECES','false','material',60,'stackable','liquid','none',0,28911,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2087,'Tears of Fairy Drop','PIECES','false','material',60,'stackable','liquid','none',0,28378,0,'true',0,1,'etc_lesser_potion_clear_i00',1,1,1),
(2088,'Horn of Glory Fragment','PIECES','false','material',60,'stackable','liquid','none',0,28378,0,'true',0,1,'etc_claw_i00',1,1,1),
(2089,'Caliburs Edge','PIECES','false','material',60,'stackable','liquid','none',0,36700,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2090,'Delusional Blade','PIECES','false','material',60,'stackable','liquid','none',0,36700,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2091,'Tsurugi Blade','PIECES','false','material',60,'stackable','liquid','none',0,36700,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2092,'Homunkulus''s Sword Blade','PIECES','false','material',60,'stackable','liquid','none',0,36700,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2093,'Poleaxe Blade','PIECES','false','material',60,'stackable','liquid','none',0,36800,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2094,'Sword of Limit Blade','PIECES','false','material',60,'stackable','liquid','none',0,36700,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2095,'Sword of Nightmare Blade','PIECES','false','material',60,'stackable','liquid','none',0,36700,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2096,'Sword of Whispering Death Blade','PIECES','false','material',60,'stackable','liquid','none',0,36700,0,'true',0,1,'icon.etc_sword_body_i00',1,1,1),
(2097,'War Axe Blade','PIECES','false','material',60,'stackable','liquid','none',0,37340,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2098,'Nirvana Axe Blade','PIECES','false','material',60,'stackable','liquid','none',0,37340,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2099,'Stick of Eternity Shaft','PIECES','false','material',60,'stackable','liquid','none',0,35480,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2100,'Paradia Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,35480,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2101,'Inferno Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,35480,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2102,'Pa''agrian Hammer Head','PIECES','false','material',60,'stackable','liquid','none',0,36800,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2103,'Sage''s Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,35480,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2104,'Club of Nature Head','PIECES','false','material',60,'stackable','liquid','none',0,35480,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2105,'Mace of The Underworld Head','PIECES','false','material',60,'stackable','liquid','none',0,37340,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2106,'Grace Dagger Edge','PIECES','false','material',60,'stackable','liquid','none',0,36700,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2107,'Dark Screamer Edge','PIECES','false','material',60,'stackable','liquid','none',0,36700,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2108,'Fisted Blade Piece','PIECES','false','material',60,'stackable','liquid','none',0,37340,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2109,'Akat Longbow Shaft','PIECES','false','material',60,'stackable','liquid','none',0,35670,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2110,'Heathen''s Book Page','PIECES','false','material',60,'stackable','liquid','none',0,35480,0,'true',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(2111,'Hex Doll Fragment','PIECES','false','material',60,'stackable','liquid','none',0,35480,0,'true',0,1,'etc_bark_gold_i00',1,1,1),
(2112,'Pa''agrian Axe Blade','PIECES','false','material',60,'stackable','liquid','none',0,41300,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2113,'Scorpion Blade','PIECES','false','material',60,'stackable','liquid','none',0,41300,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2114,'Widowmaker Head','PIECES','false','material',60,'stackable','liquid','none',0,41300,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2115,'Samurai Longsword Blade','PIECES','false','material',60,'stackable','liquid','none',0,43655,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2116,'Deadman''s Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,42509,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2117,'Ghoul''s Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,42509,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2118,'Demon''s Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,42509,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2119,'Crystal Dagger Blade','PIECES','false','material',60,'stackable','liquid','none',0,43891,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2120,'Great Pata Blade','PIECES','false','material',60,'stackable','liquid','none',0,41636,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2121,'Eminence Bow Shaft','PIECES','false','material',60,'stackable','liquid','none',0,43491,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(2122,'Orcish Poleaxe Blade','PIECES','false','material',60,'stackable','liquid','none',0,43818,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2123,'Candle of Wisdom Model','PIECES','false','material',60,'stackable','liquid','none',0,42509,0,'true',0,1,'etc_mold_i00',1,1,1),
(2124,'Blessed Branch Splinter','PIECES','false','material',60,'stackable','liquid','none',0,42509,0,'true',0,1,'etc_branch_blue_i00',1,1,1),
(2125,'Phoenix Feather Piece','PIECES','false','material',60,'stackable','liquid','none',0,42509,0,'true',0,1,'etc_feather_gold_i00',1,1,1),
(2126,'Cerberus Eye Fragment','PIECES','false','material',60,'stackable','liquid','none',0,42509,0,'true',0,1,'etc_eyeball_i00',1,1,1),
(2127,'Scroll of Destruction Page','PIECES','false','material',60,'stackable','liquid','none',0,42509,0,'true',0,1,'etc_scroll_gray_i00',1,1,1),
(2128,'Claws of Black Dragon Piece','PIECES','false','material',60,'stackable','liquid','none',0,42509,0,'true',0,1,'etc_claw_i00',1,1,1),
(2129,'Three Eyed Crow''s Feather Piece','PIECES','false','material',60,'stackable','liquid','none',0,42509,0,'true',0,1,'etc_feather_black_i00',1,1,1),
(2130,'Gemstone D','MATHERIALS','false','material',2,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_crystal_ball_silver_i00',1,1,1),
(2131,'Gemstone C','MATHERIALS','false','material',2,'stackable','liquid','none',0,3000,0,'true',0,1,'etc_crystal_ball_green_i00',1,1,1),
(2132,'Gemstone B','MATHERIALS','false','material',2,'stackable','liquid','none',0,10000,0,'true',0,1,'etc_bead_green_i00',1,1,1),
(2133,'Gemstone A','MATHERIALS','false','material',2,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_bead_red_i00',1,1,1),
(2134,'Gemstone S','MATHERIALS','false','material',2,'stackable','liquid','none',0,100000,0,'true',0,1,'etc_bead_silver_i00',1,1,1),
(2135,'Recipe: Braided Hemp','RECIPIES','false','recipe',30,'stackable','liquid','none',0,680,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2136,'Recipe: Cokes','RECIPIES','false','recipe',30,'stackable','liquid','none',0,680,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2137,'Recipe: Steel','RECIPIES','false','recipe',30,'stackable','liquid','none',0,680,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2138,'Recipe: Coarse Bone Powder (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,680,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2139,'Recipe: Steel Mold','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2140,'Recipe: High Grade Suede','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2141,'Recipe: Silver Mold','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2142,'Recipe: Varnish of Purity','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2143,'Recipe: Synthetic Cokes','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2144,'Recipe: Compound Braid','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2145,'Recipe: Mithril Alloy','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2800,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2146,'Recipe: Artisan''s frame','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2800,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2147,'Recipe: Blacksmith''s frame','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2800,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2148,'Recipe: Crafted Leather','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2800,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2149,'Recipe: Metallic Fiber','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2800,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2150,'Recipe: Blue Diamond Necklace','RECIPIES','false','recipe',30,'stackable','liquid','none',0,426,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2151,'Recipe: Necklace of Devotion','RECIPIES','false','recipe',30,'stackable','liquid','none',0,718,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2152,'Recipe: Enchanted Necklace','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1136,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2153,'Recipe: Tiger''s Eye Earring','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1286,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2154,'Recipe: Elven Earring','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1868,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2155,'Recipe: Elven Ring','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1246,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2156,'Recipe: Elven Necklace','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2500,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2157,'Recipe: Omen Beast''s Eye Earring','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2420,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2158,'Recipe: Mithril Ring','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1616,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2159,'Recipe: Necklace of Darkness','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3240,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2160,'Recipe: Moonstone Earring','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3100,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2161,'Recipe: Aquastone Ring','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2060,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2162,'Recipe: Aquastone Necklace','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4140,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2163,'Recipe: Earring of Protection','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3920,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2164,'Recipe: Ring of Protection','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2165,'Recipe: Necklace of Protection','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5220,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2166,'Recipe: Earrings of Binding (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5900,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2167,'Recipe: Ring of Ages','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3920,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2168,'Recipe: Necklace of Mermaid','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7860,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2169,'Recipe: Necklace of Binding','RECIPIES','false','recipe',30,'stackable','liquid','none',0,11300,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2170,'Recipe: Nassen''s Earring','RECIPIES','false','recipe',30,'stackable','liquid','none',0,8480,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2171,'Recipe: Sage''s Ring','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5640,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(2172,'Recipe: Sage''s Necklace','RECIPIES','false','recipe',30,'stackable','liquid','none',0,11300,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(2173,'Recipe: Hard Leather Shirt','RECIPIES','false','recipe',30,'stackable','liquid','none',0,738,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2174,'Recipe: Hard Leather Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,460,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2175,'Recipe: Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,246,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2176,'Recipe: Leather Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,418,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2177,'Recipe: Bone Helmet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,626,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2178,'Recipe: Dark Stockings','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1250,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2179,'Recipe: Crafted Leather Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,418,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2180,'Recipe: Scale Mail','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2660,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2181,'Recipe: White Tunic','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1998,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2182,'Recipe: Scale Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1666,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2183,'Recipe: Mithril Banded Mail','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3040,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2184,'Recipe: Mithril Banded Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1904,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2185,'Recipe: Iron Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1016,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2186,'Recipe: Brigandine Tunic','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5980,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2187,'Recipe: Manticore Skin Shirt','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4480,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2188,'Recipe: Manticore Skin Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2800,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2189,'Recipe: Mithril Tunic','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4480,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2190,'Recipe: Mithril Stockings','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2800,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2191,'Recipe: RIP Gauntlets','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1494,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2192,'Recipe: Kite Shield','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1568,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2193,'Recipe: Boots of Power','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1494,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2194,'Recipe: Mithril Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1956,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2195,'Recipe: Half Plate Armor','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7820,0,'true',0,1,'etc_recipe_blue_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(2196,'Recipe: Plate Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4880,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2197,'Recipe: Salamander Skin Mail','RECIPIES','false','recipe',30,'stackable','liquid','none',0,9540,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2198,'Recipe: Sage''s Rag','RECIPIES','false','recipe',30,'stackable','liquid','none',0,9540,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2199,'Recipe: Karmian Stockings','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4740,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2200,'Recipe: Chain Helmet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2940,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2201,'Recipe: Square Shield','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2060,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2202,'Recipe: Assault Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1956,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2203,'Recipe: Mithril Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,918,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2204,'Recipe: Chain Mail Shirt','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10100,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2205,'Recipe: Chain Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,6320,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2206,'Recipe: Mithril Shirt','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7580,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2207,'Recipe: Karmian Tunic','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7580,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2208,'Recipe: Ogre Power Gauntlets','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1956,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2209,'Recipe: Eldarake','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2660,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2210,'Recipe: Steel Plate Helmet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4120,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2211,'Recipe: Plated Leather Armor','RECIPIES','false','recipe',30,'stackable','liquid','none',0,8920,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2212,'Recipe: Plated Leather Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5580,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2213,'Recipe: Dwarven Chain Mail Shirt','RECIPIES','false','recipe',30,'stackable','liquid','none',0,12880,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2214,'Recipe: Dwarven Chain Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,8060,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2215,'Recipe: Robe of Seal','RECIPIES','false','recipe',30,'stackable','liquid','none',0,15700,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2216,'Recipe: Great Helmet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4840,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2217,'Recipe: Knight''s Shield','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3380,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2218,'Recipe: Pa''agrian Hand','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3220,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2219,'Recipe: Crimson Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3220,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2220,'Recipe: Rind Leather Armor','RECIPIES','false','recipe',30,'stackable','liquid','none',0,9660,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2221,'Recipe: Rind Leather Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,6040,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2222,'Recipe: Composite Armor','RECIPIES','false','recipe',30,'stackable','liquid','none',0,32000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2223,'Recipe: Tower Shield','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5160,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2224,'Recipe: Demon''s Tunic','RECIPIES','false','recipe',30,'stackable','liquid','none',0,14720,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2225,'Recipe: Demon''s Stockings','RECIPIES','false','recipe',30,'stackable','liquid','none',0,9200,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2226,'Recipe: Mithril Gauntlets','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4900,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2227,'Recipe: Forgotten Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4900,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2228,'Recipe: Shining Circlet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7360,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2229,'Recipe: Theca Leather Armor','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16500,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2230,'Recipe: Theca Leather Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10320,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2231,'Recipe: Full Plate Armor','RECIPIES','false','recipe',30,'stackable','liquid','none',0,46400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2232,'Recipe: Drake Leather Armor','RECIPIES','false','recipe',30,'stackable','liquid','none',0,34800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2233,'Recipe: Divine Tunic','RECIPIES','false','recipe',30,'stackable','liquid','none',0,21400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2234,'Recipe: Divine Stockings','RECIPIES','false','recipe',30,'stackable','liquid','none',0,13420,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2235,'Recipe: Mithril Helmet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10720,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2236,'Recipe: Cap of Mana','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10720,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2237,'Recipe: Paradia Hood','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10720,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2238,'Recipe: Hood of Solar Eclipse','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10720,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2239,'Recipe: Hood of Summoning','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10720,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2240,'Recipe: Elemental Hood','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10720,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2241,'Recipe: Hood of Grace','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10720,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2242,'Recipe: Phoenix Hood','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10720,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2243,'Recipe: Hood of Aid','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10720,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2244,'Recipe: Flame Helm','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10720,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2245,'Recipe: Tallum Helm','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10720,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(2246,'Recipe: Helm of Avadon','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10720,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2247,'Recipe: Helmet of Pledge','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10720,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2248,'Recipe: Gauntlets of Ghost','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7160,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2249,'Recipe: Adamantite Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7160,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2250,'Recipe: Bone Arrow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,800,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2251,'Recipe: Steel Arrow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1200,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2252,'Recipe: Iron Hammer','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4880,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2253,'Recipe: Sword Breaker','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4880,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2254,'Recipe: Composite Bow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4880,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(2255,'Recipe: Saber','RECIPIES','false','recipe',30,'stackable','liquid','none',0,8180,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2256,'Recipe: Assassin Knife','RECIPIES','false','recipe',30,'stackable','liquid','none',0,8180,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2257,'Recipe: Trident','RECIPIES','false','recipe',30,'stackable','liquid','none',0,8180,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2258,'Recipe: Temptation of Abyss','RECIPIES','false','recipe',30,'stackable','liquid','none',0,8180,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2259,'Recipe: Spinebone Sword','RECIPIES','false','recipe',30,'stackable','liquid','none',0,12880,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2260,'Recipe: Mace of Judgment','RECIPIES','false','recipe',30,'stackable','liquid','none',0,12880,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2261,'Recipe: Conjuror''s Staff','RECIPIES','false','recipe',30,'stackable','liquid','none',0,12880,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2262,'Recipe: Elven Bow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,12880,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2263,'Recipe: Dwarven Trident','RECIPIES','false','recipe',30,'stackable','liquid','none',0,12880,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2264,'Recipe: Two-handed Sword','RECIPIES','false','recipe',30,'stackable','liquid','none',0,19340,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2265,'Recipe: Spiked Club','RECIPIES','false','recipe',30,'stackable','liquid','none',0,19340,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2266,'Recipe: Shilen Knife','RECIPIES','false','recipe',30,'stackable','liquid','none',0,19340,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2267,'Recipe: Gastraphetes','RECIPIES','false','recipe',30,'stackable','liquid','none',0,19340,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2268,'Recipe: Tome of Blood','RECIPIES','false','recipe',30,'stackable','liquid','none',0,19340,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2269,'Recipe: Morning Star','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2270,'Recipe: Goat Head Staff','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2271,'Recipe: Winged Spear','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2272,'Recipe: Sword of Revolution','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2273,'Recipe: Tarbar','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2274,'Recipe: Skull Breaker','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2275,'Recipe: Heavy Bone Club','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2276,'Recipe: Maingauche','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2277,'Recipe: Bich''hwa','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2278,'Recipe: Strengthened Long Bow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2279,'Recipe: War Pick','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2280,'Recipe: Crucifix of Blood','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2281,'Recipe: Eye of Infinity','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2282,'Recipe: Cursed Maingauche','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2283,'Recipe: Blue Crystal Skull','RECIPIES','false','recipe',30,'stackable','liquid','none',0,30400,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2284,'Recipe: Demon Fangs','RECIPIES','false','recipe',30,'stackable','liquid','none',0,30400,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2285,'Recipe: Claymore','RECIPIES','false','recipe',30,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2286,'Recipe: Bonebreaker','RECIPIES','false','recipe',30,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2287,'Recipe: Atuba Hammer','RECIPIES','false','recipe',30,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2288,'Recipe: Ghost Staff','RECIPIES','false','recipe',30,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2289,'Recipe: Staff of Life','RECIPIES','false','recipe',30,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2290,'Recipe: Mithril Dagger','RECIPIES','false','recipe',30,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2291,'Recipe: Scallop Jamadhr','RECIPIES','false','recipe',30,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2292,'Recipe: Light Crossbow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2293,'Recipe: Glaive','RECIPIES','false','recipe',30,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2294,'Recipe: Vajra Wands','RECIPIES','false','recipe',30,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2295,'Recipe: Ancient Reagent','RECIPIES','false','recipe',30,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2296,'Recipe: Atuba Mace','RECIPIES','false','recipe',30,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2297,'Recipe: Flamberge','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2298,'Recipe: Stormbringer','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2299,'Recipe: Big Hammer','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2300,'Recipe: Scythe','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2301,'Recipe: Battle Axe','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2302,'Recipe: Silver Axe','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2303,'Recipe: Skull Graver','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2304,'Recipe: Heavy Doom Hammer','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2305,'Recipe: Crystal Staff','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2306,'Recipe: Stick of Faith','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2307,'Recipe: Heavy Doom Axe','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2308,'Recipe: Cursed Dagger','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2309,'Recipe: Wolverine Needle','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2310,'Recipe: Dark Elven Dagger','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2311,'Recipe: Chakram','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2312,'Recipe: Crystallized Ice Bow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2313,'Recipe: Orcish Glaive','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2314,'Recipe: Body Slasher','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45800,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2315,'Recipe: Shamshir','RECIPIES','false','recipe',30,'stackable','liquid','none',0,57400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2316,'Recipe: Katana','RECIPIES','false','recipe',30,'stackable','liquid','none',0,57400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2317,'Recipe: Bec de Corbin','RECIPIES','false','recipe',30,'stackable','liquid','none',0,57400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2318,'Recipe: Spirit Sword','RECIPIES','false','recipe',30,'stackable','liquid','none',0,57400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2319,'Recipe: Raid Sword','RECIPIES','false','recipe',30,'stackable','liquid','none',0,57400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2320,'Recipe: Cursed Staff','RECIPIES','false','recipe',30,'stackable','liquid','none',0,57400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2321,'Recipe: Stiletto','RECIPIES','false','recipe',30,'stackable','liquid','none',0,57400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2322,'Recipe: Soulfire Dirk','RECIPIES','false','recipe',30,'stackable','liquid','none',0,57400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2323,'Recipe: Elemental Bow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,57400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2324,'Recipe: Elven Bow of Nobility','RECIPIES','false','recipe',30,'stackable','liquid','none',0,57400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2325,'Recipe: Tears of Fairy','RECIPIES','false','recipe',30,'stackable','liquid','none',0,57400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2326,'Recipe: Horn of Glory','RECIPIES','false','recipe',30,'stackable','liquid','none',0,57400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2327,'Recipe: Caliburs','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2328,'Recipe: Sword of Delusion','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2329,'Recipe: Tsurugi','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2330,'Recipe: Homunkulus''s Sword','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2331,'Recipe: Poleaxe','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2332,'Recipe: Sword of Limit','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2333,'Recipe: Sword of Nightmare','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2334,'Recipe: Sword of Whispering Death','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2335,'Recipe: War Axe','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2336,'Recipe: Nirvana Axe','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2337,'Recipe: Stick of Eternity','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2338,'Recipe: Paradia Staff','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2339,'Recipe: Inferno Staff','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2340,'Recipe: Pa''agrian Hammer','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2341,'Recipe: Sage''s Staff','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2342,'Recipe: Club of Nature','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2343,'Recipe: Mace of the Underworld','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2344,'Recipe: Grace Dagger','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2345,'Recipe: Dark Screamer','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2346,'Recipe: Fisted Blade','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2347,'Recipe: Akat Long Bow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2348,'Recipe: Heathen''s Book','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2349,'Recipe: Hex Doll','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2350,'Recipe: Pa''agrian Axe','RECIPIES','false','recipe',30,'stackable','liquid','none',0,95600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2351,'Recipe: Scorpion','RECIPIES','false','recipe',30,'stackable','liquid','none',0,95600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2352,'Recipe: Widow Maker','RECIPIES','false','recipe',30,'stackable','liquid','none',0,95600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2353,'Recipe: Samurai Longsword','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2354,'Recipe: Deadman''s Staff','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2355,'Recipe: Ghoul''s Staff','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2356,'Recipe: Demon''s Staff','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2357,'Recipe: Crystal Dagger','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2358,'Recipe: Great Pata','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2359,'Recipe: Eminence Bow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2360,'Recipe: Orcish Poleaxe','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2361,'Recipe: Candle of Wisdom','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2362,'Recipe: Blessed Branch','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2363,'Recipe: Phoenix Feather','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2364,'Recipe: Cerberus Eye','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2365,'Recipe: Scroll of Destruction','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2366,'Recipe: Claws of Black Dragon','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2367,'Recipe: Three Eyed Crow''s Feather','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2375,'Wolf Collar','OTHER','false','pet_collar',10,'normal','leather','none',0,0,0,'false',0,1,'etc_prefect_belt_i00',1,1,1),
(2508,'Cursed Bone','CONSUMABLE','false','material',3,'stackable','liquid','none',0,240,0,'true',0,1,'etc_piece_bone_red_i00',1,1,1),
(2509,'Spiritshot: No Grade','CONSUMABLE','false','none',5,'stackable','paper','none',0,15,0,'true',0,1,'etc_spell_shot_white_i00',1,1,1),
(2510,'Spiritshot: D-grade','CONSUMABLE','false','none',5,'stackable','paper','d',0,18,0,'true',0,1,'etc_spell_shot_blue_i00',1,1,1),
(2511,'Spiritshot: C-grade','CONSUMABLE','false','none',3,'stackable','paper','c',0,35,0,'true',0,1,'etc_spell_shot_green_i00',1,1,1),
(2512,'Spiritshot: B-grade','CONSUMABLE','false','none',3,'stackable','paper','b',0,100,0,'true',0,1,'etc_spell_shot_red_i00',1,1,1),
(2513,'Spiritshot: A-grade','CONSUMABLE','false','none',2,'stackable','paper','a',0,120,0,'true',0,1,'etc_spell_shot_silver_i00',1,1,1),
(2514,'Spiritshot: S-grade','CONSUMABLE','false','none',2,'stackable','paper','s',0,150,0,'true',0,1,'etc_spell_shot_gold_i00',1,1,1),
(2515,'Food For Wolves','OTHER','false','none',10,'stackable','liquid','none',0,100,0,'true',0,1,'etc_pouch_yellow_i00',1,1,1),
(2627,'Mark of Challenger','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_silver_i00',1,1,1),
(2628,'Letter of Kash','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(2629,'Watcher''s 1st Eye','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(2630,'Watcher''s 2nd Eye','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(2631,'Scroll of Shyslassys','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_weapon_i01',1,1,1),
(2632,'Broken Key','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_mold_i00',1,1,1),
(2633,'Mark of Duty','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_necklace_of_holy_spirit_i00',1,1,1),
(2634,'Letter of Dustin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(2635,'Knights Tear','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_red_i00',1,1,1),
(2636,'Mirror of Orpic','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_mirror_i00',1,1,1),
(2637,'Tear of Confession','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_white_i00',1,1,1),
(2638,'Report Piece','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leather_gray_i00',1,1,1),
(2639,'Report Piece','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(2640,'Tear of Loyalty','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_silver_i00',1,1,1),
(2641,'Militas Article','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(2642,'Saints Ashes Urn','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(2643,'Athebaldt''s Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(2644,'Athebaldt''s Ribs','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_rib_white_i00',1,1,1),
(2645,'Athebaldt''s Shin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_white_i00',1,1,1),
(2646,'Letter of Windawood','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(2647,'Dufners Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(2648,'Terry''s 1st Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_resurrection_i01',1,1,1),
(2649,'Terry''s 2nd Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_return_i00',1,1,1),
(2650,'Terry''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(2651,'Viktor''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(2652,'Hawkeye''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(2653,'Mysterious Runestone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(2654,'Ol Mahum Runestone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(2655,'Turek Runestone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_silver_i00',1,1,1),
(2656,'Ant Runestone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_white_i00',1,1,1),
(2657,'Turak Bugbear Runestone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_gold_i00',1,1,1),
(2658,'Terry''s Box','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(2659,'Viktor''s Request','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_armor_i01',1,1,1),
(2660,'Medusa Scales','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_parasite_i00',1,1,1),
(2661,'Shilen''s Runestone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(2662,'Analysis Request','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(2663,'Marina''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(2664,'Experiment Tools','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_squares_wood_i00',1,1,1),
(2665,'Analysis Result','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(2666,'Terry''s 3rd Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_weapon_i01',1,1,1),
(2667,'List of Host','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(2668,'Abyss Runestone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(2669,'Abyss Runestone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_silver_i00',1,1,1),
(2670,'Abyss Runestone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_white_i00',1,1,1),
(2671,'Abyss Runestone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(2672,'Terry''s Report','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_weapon_i00',1,1,1),
(2673,'Mark of Seeker','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_green_i00',1,1,1),
(2674,'Mark of Scholar','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_blue_i00',1,1,1),
(2675,'Mirien''s 1st Sigil','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_shield_of_mana_i00',1,1,1),
(2676,'Mirien''s 2nd Sigil','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_shield_of_pledge_i00',1,1,1),
(2677,'Mirien''s 3rd Sigil','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_round_shield_i00',1,1,1),
(2678,'Mirien''s Instruction','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(2679,'Maria''s 1st Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(2680,'Maria''s 2nd Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(2681,'Lucas''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(2682,'Lucilla''s Handbag','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(2683,'Creta''s 1st Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(2684,'Creta''s Painting1','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_armor_i00',1,1,1),
(2685,'Creta''s Painting2','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_resurrection_i00',1,1,1),
(2686,'Creta''s Painting3','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_return_i00',1,1,1),
(2687,'Brown Scroll Scrap','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_map_piece_yellow_i00',1,1,1),
(2688,'Crystal of Purity','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_clear_i00',1,1,1),
(2689,'High Priest''s Sigil','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_sages_shield_i01',1,1,1),
(2690,'Grand Magister''s Sigil','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_doom_shield_i00',1,1,1),
(2691,'Crono''s Sigil','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_another_worlds_shield_i01',1,1,1),
(2692,'Sylvain''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(2693,'Symbol of Sylvain','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_blue_i00',1,1,1),
(2694,'Jurek''s List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(2695,'Monster Eye Destroyer Skin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leather_yellow_i00',1,1,1),
(2696,'Shaman''s Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_necklace_red_i00',1,1,1),
(2697,'Shackle''s Scalp','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leather_brown_i00',1,1,1),
(2698,'Symbol of Jurek','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_gold_i00',1,1,1),
(2699,'Cronos Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(2700,'Dieter''s Key','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_key_i00',1,1,1),
(2701,'Creta''s 2nd Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(2702,'Dieter''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(2703,'Dieter''s Diary','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(2704,'Raut''s Letter Envelope','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_plate_silver_i00',1,1,1),
(2705,'Triff''s Ring','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_aquastone_ring_i00',1,1,1),
(2706,'Scripture Chapter 1','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(2707,'Scripture Chapter 2','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(2708,'Scripture Chapter 3','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_apprentices_spellbook_i00',1,1,1),
(2709,'Scripture Chapter 4','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_apprentices_spellbook_i01',1,1,1),
(2710,'Valkon''s Request','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(2711,'Poitan''s Notes','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_apprentices_spellbook_i01',1,1,1),
(2712,'Scriptures of Knowledge','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(2713,'Strong Liquor','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_gold_i00',1,1,1),
(2714,'Crystal of Purity','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_clear_i00',1,1,1),
(2715,'Casian''s List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(2716,'Ghoul''s Skin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leather_gray_i00',1,1,1),
(2717,'Medusa''s Blood','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_scarlet_i00',1,1,1),
(2718,'Fettered Soul''s Ichor','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_reagent_red_i00',1,1,1),
(2719,'Enchanted Gargoyle''s Nail','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(2720,'Symbol of Cronos','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_silver_i00',1,1,1),
(2721,'Mark of Pilgrim','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_silver_i00',1,1,1),
(2722,'Book of Sage','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(2723,'Voucher of Trial','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_necklace_black_i00',1,1,1),
(2724,'Spirit of Flame','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_red_i00',1,1,1),
(2725,'Essence of Flame','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_red_i00',1,1,1),
(2726,'Book of Gerald','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_apprentices_spellbook_i00',1,1,1),
(2727,'Gray Badge','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_badge_black_i00',1,1,1),
(2728,'Picture of Nahir','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_plate_black_i00',1,1,1),
(2729,'Hair of Nahir','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_mane_i00',1,1,1),
(2730,'Statue of Einhasad','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(2731,'Book of Darkness','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(2732,'Debris of Willow','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bark_gold_i00',1,1,1),
(2733,'Tag of Rumor','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(2734,'Mark of Trust','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_green_i00',1,1,1),
(2735,'Letter to Elf','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_armor_i00',1,1,1),
(2736,'Letter to Darkelf','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_weapon_i00',1,1,1),
(2737,'Letter to Dwarf','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_resurrection_i00',1,1,1),
(2738,'Letter to Orc','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_return_i00',1,1,1),
(2739,'Letter to Seresin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(2740,'Scroll of Dark Elf Trust','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_weapon_i01',1,1,1),
(2741,'Scroll of Elf Trust','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_armor_i01',1,1,1),
(2742,'Scroll of Dwarf Trust','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_resurrection_i01',1,1,1),
(2743,'Scroll of Orc Trust','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_return_i01',1,1,1),
(2744,'Recommendation of Hollint','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(2745,'Order of Asterios','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(2746,'Breath of Winds','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_green_i00',1,1,1),
(2747,'Seed of Verdure','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_broken_crystal_green_i00',1,1,1),
(2748,'Letter from Thifiell','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(2749,'Blood of Guardian Basilisk','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_reagent_red_i00',1,1,1),
(2750,'Giant Aphid','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_reagent_green_i00',1,1,1),
(2751,'Stakatos Fluids','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_reagent_blue_i00',1,1,1),
(2752,'Basilisk Plasma','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_red_i00',1,1,1),
(2753,'Honey Dew','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_gold_i00',1,1,1),
(2754,'Stakato Ichor','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_blue_i00',1,1,1),
(2755,'Order of Clayton','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(2756,'Parasite of Lota','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_black_i00',1,1,1),
(2757,'Letter to Manakia','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(2758,'Letter of Manakia','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(2759,'Letter to Nikola','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(2760,'Order of Nikola','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(2761,'Heartstone of Porta','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_poison_pouch_i00',1,1,1),
(2762,'Mark of Duelist','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(2763,'Order Gludio','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_armor_i01',1,1,1),
(2764,'Order Dion','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_weapon_i01',1,1,1),
(2765,'Order Giran','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_resurrection_i01',1,1,1),
(2766,'Order Oren','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_return_i01',1,1,1),
(2767,'Order Aden','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_armor_i00',1,1,1),
(2768,'Puncher''s Shard','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_stone_black_i00',1,1,1),
(2769,'Noble Ant''s Feeler','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_insect_leg_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(2770,'Drone''s Chitin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_red_i00',1,1,1),
(2771,'Dead Seeker Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_gray_i00',1,1,1),
(2772,'Overlord Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_necklace_of_anguish_i00',1,1,1),
(2773,'Fettered Soul''s Chain','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_necklace_red_i00',1,1,1),
(2774,'Chief''s Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_orcish_talisman_i00',1,1,1),
(2775,'Enchanted Eye Meat','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_meat_i00',1,1,1),
(2776,'Tamrin Orc''s Ring','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_cerberuss_ring_i00',1,1,1),
(2777,'Tamrin Orc''s Arrow','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_wooden_arrow_i01',1,1,1),
(2778,'Final Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(2779,'Excuro''s Skin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leather_brown_i00',1,1,1),
(2780,'Krator''s Shard','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_stone_gray_i00',1,1,1),
(2781,'Grandi''s Skin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leather_gray_i00',1,1,1),
(2782,'Timak Orc''s Belt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(2783,'Lakin''s Mace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_spike_club_i00',1,1,1),
(2784,'Luther''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(2785,'Alex''s Warrant','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(2786,'Leirynn''s 1st Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(2787,'Delu Totem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_necklace_green_i00',1,1,1),
(2788,'Leirynn''s 2nd Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(2789,'Chief Kalki''s Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_ivory_i00',1,1,1),
(2790,'Leirynn''s Report','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(2791,'Strange Map','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_map_yellow_i00',1,1,1),
(2792,'Lambert''s Map','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_map_yellow_i00',1,1,1),
(2793,'Alex''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(2794,'Alex''s Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(2795,'Wine Catalog','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(2796,'Tyra''s Contract','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(2797,'Red Spore Dust','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_powder_red_i00',1,1,1),
(2798,'Malrukian Wine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_purple_i00',1,1,1),
(2799,'Old Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(2800,'Jax''s Diary','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(2801,'1st Torn Map Piece','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_map_piece_yellow_i00',1,1,1),
(2802,'2nd Torn Map Piece','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_map_piece_yellow_i00',1,1,1),
(2803,'Solt''s Map','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_map_yellow_i00',1,1,1),
(2804,'Makel''s Map','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_map_yellow_i00',1,1,1),
(2805,'Combined Map','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_map_ivory_i00',1,1,1),
(2806,'Rusted Key','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_key_i00',1,1,1),
(2807,'Gold Bar','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lump_yellow_i00',1,1,1),
(2808,'Alex''s Recommend','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(2809,'Mark of Searcher','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_badge_gold_i00',1,1,1),
(2810,'Report of Perrin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(2811,'Kristina''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(2812,'Picture of Windy','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_plate_white_i00',1,1,1),
(2813,'Golden Statue','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_orcish_talisman_i00',1,1,1),
(2814,'Windy''s Pebbles','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_stone_gray_i00',1,1,1),
(2815,'Order of Sorius','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(2816,'1st Secret Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(2817,'2nd Secret Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(2818,'3rd Secret Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_scroll_of_wisdom_i00',1,1,1),
(2819,'4th Secret Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_scroll_of_wisdom_i01',1,1,1),
(2820,'Mark of Healer','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_white_i00',1,1,1),
(2821,'Mark of Reformer','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_gold_i00',1,1,1),
(2822,'Book of Reform','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_apprentices_spellbook_i01',1,1,1),
(2823,'Letter of Introduction','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_armor_i00',1,1,1),
(2824,'Sla''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(2825,'Greetings','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(2826,'Ol Mahum''s Money','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_silver_i00',1,1,1),
(2827,'Katari''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(2828,'Nyakuri''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(2829,'Undead List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(2830,'Ramus''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(2831,'Ripped Diary','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_map_piece_ivory_i00',1,1,1),
(2832,'Huge Nail','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_heavy_chisel_i00',1,1,1),
(2833,'Letter of Betrayer','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(2834,'Bone Fragment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_rib_black_i00',1,1,1),
(2835,'Bone Fragment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_white_i00',1,1,1),
(2836,'Bone Fragment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_molar_black_i00',1,1,1),
(2837,'Bone Fragment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_molar_white_i00',1,1,1),
(2838,'Bone Fragment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_rib_white_i00',1,1,1),
(2839,'Bone Fragment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_rib_black_i00',1,1,1),
(2840,'Mark of Magus','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_mark_yellow_i00',1,1,1),
(2841,'Rukal''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(2842,'Parina''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(2843,'Lilac Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_badge_gold_i00',1,1,1),
(2844,'1st Golden Seed','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(2845,'2nd Golden Seed','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(2846,'3rd Golden Seed','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(2847,'Score of Elements','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(2848,'Dazzling Drop','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_blue_i00',1,1,1),
(2849,'Flame Crystal','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_red_i00',1,1,1),
(2850,'Harpy''s Feather','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_feather_white_i00',1,1,1),
(2851,'Wyrm''s Wingbone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_red_i00',1,1,1),
(2852,'Windsus Mane','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_mane_i00',1,1,1),
(2853,'Enchanted Monster Eye Shell','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bark_gold_i00',1,1,1),
(2854,'Enchanted Stone Golem Powder','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_powder_gray_i00',1,1,1),
(2855,'Enchanted Iron Golem Scrap','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_stone_black_i00',1,1,1),
(2856,'Tone of Water','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_armor_i01',1,1,1),
(2857,'Tone of Fire','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_weapon_i01',1,1,1),
(2858,'Tone of Wind','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_return_i01',1,1,1),
(2859,'Tone of Earth','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_resurrection_i01',1,1,1),
(2860,'Salamander Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_cloth_red_i00',1,1,1),
(2861,'Sylph Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(2862,'Undine Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_cloth_blue_i00',1,1,1),
(2863,'Serpent Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_cloth_green_i00',1,1,1),
(2864,'Recommendation of Balanki','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(2865,'Recommendation of Filaur','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(2866,'Recommendation of Arin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(2867,'Mark of Maestro','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_badge_silver_i00',1,1,1),
(2868,'Letter of Solder Detachment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_of_return_i01',1,1,1),
(2869,'Paint of Kamuru','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(2870,'Necklace of Kamuru','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_necklace_of_darkness_i00',1,1,1),
(2871,'Paint of Teleport Device','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(2872,'Teleport Device','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_squares_gray_i00',1,1,1),
(2873,'Architecture of Cruma','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(2874,'Report of Cruma','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(2875,'Ingredients of Antidote','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(2876,'Stinger Wasp Needle','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(2877,'Marsh Spider''s Web','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skein_white_i00',1,1,1),
(2878,'Blood of Leech','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_reagent_red_i00',1,1,1),
(2879,'Mark of Warspirit','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(2880,'Vendetta Totem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_orcish_talisman_i00',1,1,1),
(2881,'Tamlin Orc Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(2882,'Warspirit Totem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_another_worlds_necklace_i00',1,1,1),
(2883,'Orim''s Contract','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(2884,'Porta''s Eye','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(2885,'Excuro''s Scale','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_parasite_i00',1,1,1),
(2886,'Mordeos Talon','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(2887,'Braki''s Remains','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ashes_black_i00',1,1,1),
(2888,'Pekiron''s Totem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_black_i00',1,1,1),
(2889,'Tonar''s Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(2890,'Tonar''s Rib Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_rib_black_i00',1,1,1),
(2891,'Tonar''s Spine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ginseng_gray_i00',1,1,1),
(2892,'Tonar''s Arm Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_black_i00',1,1,1),
(2893,'Tonar''s Thigh Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_black_i00',1,1,1),
(2894,'Tonar''s Remains','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ashes_black_i00',1,1,1),
(2895,'Manakia''s Totem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_green_i00',1,1,1),
(2896,'Hermodt''s Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(2897,'Hermodt''s Rib Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_rib_red_i00',1,1,1),
(2898,'Hermodt''s Spine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ginseng_red_i00',1,1,1),
(2899,'Hermodt''s Arm Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_red_i00',1,1,1),
(2900,'Hermodt''s Thigh Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_red_i00',1,1,1),
(2901,'Hermodt''s Remains','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ashes_red_i00',1,1,1),
(2902,'Racoy''s Totem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_red_i00',1,1,1),
(2903,'Vivyan''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(2904,'Insect Diagram Book','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(2905,'Kiruna''s Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(2906,'Kiruna''s Rib Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_rib_white_i00',1,1,1),
(2907,'Kiruna''s Spine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ginseng_yellow_i00',1,1,1),
(2908,'Kiruna''s Arm Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_white_i00',1,1,1),
(2909,'Kiruna''s Thigh Bone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_bone_white_i00',1,1,1),
(2910,'Kiruna''s Remains','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ashes_white_i00',1,1,1),
(2911,'Braki''s Remains','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(2912,'Tonar''s Remains','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(2913,'Hermodt''s Remains','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(2914,'Kiruna''s Remains','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(2916,'Broken Teleport Device','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_plate_silver_i00',1,1,1),
(2917,'Ring of Binding Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,3482,0,'true',0,1,'etc_bead_silver_i00',1,1,1),
(2918,'Mithril Scale Gaiters Material','PIECES','false','material',60,'stackable','liquid','none',0,3371,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(2919,'Brigandine Gaiters Material','PIECES','false','material',60,'stackable','liquid','none',0,3371,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(2920,'Elven Mithril Tunic Pattern','PIECES','false','material',60,'stackable','liquid','none',0,3921,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(2921,'Elven Mithril Stockings Pattern','PIECES','false','material',60,'stackable','liquid','none',0,2518,0,'true',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(2922,'Brigandine Helmet Design','PIECES','false','material',60,'stackable','liquid','none',0,5193,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2923,'Manticore Skin Boot Lining','PIECES','false','material',60,'stackable','liquid','none',0,1480,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(2924,'Brigandine Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,1480,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2925,'Elven Mithril Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,1480,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2926,'Manticore Skin Gloves Lining','PIECES','false','material',60,'stackable','liquid','none',0,1480,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(2927,'Brigandine Gauntlets Pattern','PIECES','false','material',60,'stackable','liquid','none',0,1480,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(2928,'Elven Mithril Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,1480,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2929,'Brigandine Shield Fragment','PIECES','false','material',60,'stackable','liquid','none',0,1389,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(2930,'Plate Helmet Design','PIECES','false','material',60,'stackable','liquid','none',0,2481,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2931,'Salamander Skin Boot Lining','PIECES','false','material',60,'stackable','liquid','none',0,1792,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(2932,'Plate Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,1792,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2933,'Sage''s Worn Gloves Lining','PIECES','false','material',60,'stackable','liquid','none',0,1792,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(2934,'Plate Shield Fragment','PIECES','false','material',60,'stackable','liquid','none',0,1762,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(2935,'Tempered Mithril Gaiters Fragment','PIECES','false','material',60,'stackable','liquid','none',0,3762,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(2936,'Chain Hood Pattern','PIECES','false','material',60,'stackable','liquid','none',0,2725,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(2937,'Chain Boots Part','PIECES','false','material',60,'stackable','liquid','none',0,2225,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(2938,'Karmian Boots Fabric','PIECES','false','material',60,'stackable','liquid','none',0,2225,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(2939,'Plate Leather Boot Lining','PIECES','false','material',60,'stackable','liquid','none',0,2225,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(2940,'Dwarven Chain Boots Part','PIECES','false','material',60,'stackable','liquid','none',0,2225,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(2941,'Boots of Seal Pattern','PIECES','false','material',60,'stackable','liquid','none',0,2225,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(2942,'Reinforced Mithril Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,2225,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2943,'Chain Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,2225,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2944,'Karmian Gloves Fabric','PIECES','false','material',60,'stackable','liquid','none',0,2225,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(2945,'Chain Shield Fragment','PIECES','false','material',60,'stackable','liquid','none',0,2475,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(2946,'Plate Leather Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,3578,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2947,'Dwarven Chain Shield Fragment','PIECES','false','material',60,'stackable','liquid','none',0,2800,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(2948,'Rind Leather Boot Lining','PIECES','false','material',60,'stackable','liquid','none',0,2378,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(2949,'Dwarven Chain Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,2378,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2950,'Gloves of Seal Pattern','PIECES','false','material',60,'stackable','liquid','none',0,2378,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(2951,'Rind Leather Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,2378,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2952,'Demon''s Boots Fabric','PIECES','false','material',60,'stackable','liquid','none',0,3400,0,'true',0,1,'etc_piece_of_cloth_red_i00',1,1,1),
(2953,'Demon''s Gloves Fabric','PIECES','false','material',60,'stackable','liquid','none',0,3400,0,'true',0,1,'etc_piece_of_cloth_red_i00',1,1,1),
(2954,'Theca Leather Boots Texture','PIECES','false','material',60,'stackable','liquid','none',0,3160,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(2955,'Theca Leather Gloves Texture','PIECES','false','material',60,'stackable','liquid','none',0,3160,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(2956,'Composite Boots Part','PIECES','false','material',60,'stackable','liquid','none',0,3400,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(2957,'Composite Helmet Design','PIECES','false','material',60,'stackable','liquid','none',0,4560,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2958,'Divine Boots Fabric','PIECES','false','material',60,'stackable','liquid','none',0,3673,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(2959,'Full Plate Helmet Design','PIECES','false','material',60,'stackable','liquid','none',0,5782,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2960,'Drake Leather Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,3673,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2961,'Full Plate Boots Part','PIECES','false','material',60,'stackable','liquid','none',0,3673,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(2962,'Drake Leather Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,3673,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(2963,'Full Plate Gauntlets Part','PIECES','false','material',60,'stackable','liquid','none',0,3673,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(2964,'Divine Gloves Pattern','PIECES','false','material',60,'stackable','liquid','none',0,3673,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(2965,'Blessed Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,3673,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(2966,'Full Plate Shield Fragment','PIECES','false','material',60,'stackable','liquid','none',0,3655,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(2967,'Elven Long Sword Blade','PIECES','false','material',60,'stackable','liquid','none',0,23062,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(2968,'Dwarven Warhammer Head','PIECES','false','material',60,'stackable','liquid','none',0,29644,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2969,'Yaksa Mace Head','PIECES','false','material',60,'stackable','liquid','none',0,41636,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(2970,'Recipe: Ring of Binding','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5640,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2971,'Recipe: Mithril Scale Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3740,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2972,'Recipe: Brigandine Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3740,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2973,'Recipe: Elven Mithril Tunic','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4480,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2974,'Recipe: Elven Mithril Stockings','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2800,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2975,'Recipe: Brigandine Helmet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2240,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2976,'Recipe: Manticore Skin Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1494,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2977,'Recipe: Brigandine Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1494,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2978,'Recipe: Elven Mithril Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1494,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2979,'Recipe: Manticore Skin Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1494,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2980,'Recipe: Brigandine Gauntlets','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1494,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2981,'Recipe: Elven Mithril Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1494,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2982,'Recipe: Brigandine Shield','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1568,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2983,'Recipe: Plate Helmet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2940,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2984,'Recipe: Salamander Skin Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1956,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2985,'Recipe: Plate Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1956,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2986,'Recipe: Sage''s Worn Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1956,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2987,'Recipe: Plate Shield','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2060,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(2988,'Recipe: Tempered Mithril Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4740,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2989,'Recipe: Chain Hood','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3780,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2990,'Recipe: Chain Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2520,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2991,'Recipe: Karmian Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2520,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2992,'Recipe: Plated Leather Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2520,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2993,'Recipe: Dwarven Chain Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2520,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2994,'Recipe: Boots of Seal','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2520,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2995,'Recipe: Reinforced Mithril Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2520,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2996,'Recipe: Chain Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2520,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2997,'Recipe: Karmian Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2520,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2998,'Recipe: Chain Shield','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2660,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(2999,'Recipe: Plated Leather Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,2980,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3000,'Recipe: Dwarven Chain Shield','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3120,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3001,'Recipe: Rind Leather Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3220,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3002,'Recipe: Dwarven Chain Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3220,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3003,'Recipe: Gloves of Seal','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3220,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3004,'Recipe: Rind Leather Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,3220,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3005,'Recipe: Demon''s Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4900,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3006,'Recipe: Demon''s Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4900,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3007,'Recipe: Theca Leather Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5500,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3008,'Recipe: Theca Leather Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5500,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3009,'Recipe: Composite Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4900,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3010,'Recipe: Composite Helmet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7360,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3011,'Recipe: Divine Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7160,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3012,'Recipe: Full Plate Helmet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10720,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3013,'Recipe: Drake Leather Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7160,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3014,'Recipe: Full Plate Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7160,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3015,'Recipe: Drake Leather Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7160,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3016,'Recipe: Full Plate Gauntlets','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7160,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3017,'Recipe: Divine Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7160,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3018,'Recipe: Blessed Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7160,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3019,'Recipe: Full Plate Shield','RECIPIES','false','recipe',30,'stackable','liquid','none',0,7500,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3020,'Recipe: Elven Long Sword','RECIPIES','false','recipe',30,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(3021,'Recipe: Dwarven War Hammer','RECIPIES','false','recipe',30,'stackable','liquid','none',0,57400,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3022,'Recipe: Yaksa Mace','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3023,'Recipe: Titan Key','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(3024,'Recipe: Journeyman Ring','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(3025,'Recipe: Amber Bead','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(3030,'Key of Titan','OTHER','false','none',10,'stackable','bronze','none',0,0,0,'false',0,1,'etc_key_i00',1,1,1),
(3031,'Spirit Ore','MATHERIALS','false','material',5,'stackable','liquid','none',0,400,0,'true',0,1,'etc_stone_gray_i00',1,1,1),
(3032,'Recipe: Spiritshot D','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(3033,'Recipe: Spiritshot C','RECIPIES','false','recipe',30,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3034,'Recipe: Spiritshot B','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(3035,'Recipe: Spiritshot A','RECIPIES','false','recipe',30,'stackable','liquid','none',0,150000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(3036,'Recipe: Spiritshot S','RECIPIES','false','recipe',30,'stackable','liquid','none',0,450000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(3037,'Kakan''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3038,'Blueprint: Summon Mechanic Golem','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1550,0,'true',0,1,'etc_plan_i00',1,1,1),
(3039,'Spellbook: Summon Storm Cubic','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(3040,'Spellbook: Summon Vampiric Cubic','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3700,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(3041,'Spellbook: Summon Phantom Cubic','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(3042,'Spellbook: Life Scavenge','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_hfighter_i00',1,1,1),
(3043,'Spellbook: Holy Strike','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4250,0,'true',0,1,'etc_spell_books_hfighter_i00',1,1,1),
(3044,'Spellbook: Horror','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4250,0,'true',0,1,'etc_spell_books_hfighter_i00',1,1,1),
(3045,'Spellbook: Summon Life Cubic','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3700,0,'true',0,1,'etc_spell_books_defighter_i00',1,1,1),
(3046,'Spellbook: Sacrifice','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,5400,0,'true',0,1,'etc_spell_books_hfighter_i00',1,1,1),
(3047,'Spellbook: Iron Will','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3700,0,'true',0,1,'etc_spell_books_hfighter_i00',1,1,1),
(3048,'Spellbook: Reflect Damage','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_hfighter_i00',1,1,1),
(3049,'Spellbook: Corpse Plague','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4250,0,'true',0,1,'etc_spell_books_hfighter_i00',1,1,1),
(3050,'Spellbook: Hex','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_defighter_i00',1,1,1),
(3051,'Spellbook: Spirit Barrier','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_efighter_i00',1,1,1),
(3052,'Spellbook: Hamstring','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3700,0,'true',0,1,'etc_spell_books_hfighter_i00',1,1,1),
(3053,'Spellbook: Holy Blessing','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_hfighter_i00',1,1,1),
(3054,'Spellbook: Summon Viper Cubic','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4800,0,'true',0,1,'etc_spell_books_defighter_i00',1,1,1),
(3055,'Spellbook: Lightning Strike','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_defighter_i00',1,1,1),
(3056,'Spellbook: Summon Dark Panther','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_hfighter_i00',1,1,1),
(3057,'Spellbook: Summon Reanimated Man','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(3058,'Spellbook: Summon Corrupted Man','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(3059,'Spellbook: Corpse Burst','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(3060,'Spellbook: Forget','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(3061,'Spellbook: Curse Discord','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(3062,'Spellbook: Curse Fear','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(3063,'Spellbook: Anchor','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(3064,'Spellbook: Silence','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(3065,'Spellbook: Death Spike','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(3066,'Spellbook: Curse Death Link','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,5400,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(3067,'Spellbook: Vampiric Claw','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(3068,'Spellbook: Vitalize','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(3069,'Spellbook: Repose','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(3070,'Spellbook: Hold Undead','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(3071,'Spellbook: Requiem','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(3072,'Spellbook: Purify','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(3073,'Spellbook: Might of Heaven','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(3074,'Spellbook: Surrender to Wind','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3075,'Spellbook: Blazing Circle','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3076,'Spellbook: Prominence','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3077,'Spellbook: Blazing Skin','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3078,'Spellbook: Decay','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3079,'Spellbook: Cancel','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(3080,'Spellbook: Sleeping Cloud','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(3081,'Spellbook: Aura Flare','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3082,'Spellbook: Surrender to Water','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3083,'Spellbook: Frost Wall','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,5400,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3084,'Spellbook: Freezing Shackle','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3085,'Spellbook: Hydro Blast','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3086,'Spellbook: Frost Bolt','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3087,'Spellbook: Ice Dagger','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3088,'Spellbook: Freezing Skin','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3089,'Spellbook: Tempest','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3090,'Spellbook: Hurricane','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(3091,'Spellbook: Servitor Magic Shield','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(3092,'Spellbook: Servitor Physical Shield','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(3093,'Spellbook: Servitor Haste','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(3094,'Spellbook: Invigor','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(3095,'Spellbook: Magic Barrier','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(3096,'Spellbook: Blessed Body','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(3097,'Spellbook: Blessed Soul','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(3098,'Spellbook: Return','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(3099,'Spellbook: Haste','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(3100,'Spellbook: Guidance','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(3101,'Spellbook: Death Whisper','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(3102,'Spellbook: Bless Shield','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(3103,'Amulet: Pa''agrio''s Wisdom','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3104,'Amulet: Pa''agrio''s Glory','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3105,'Amulet: Seal of Winter','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3106,'Amulet: Seal of Flame','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3107,'Amulet: Seal of Gloom','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3108,'Amulet: Seal of Mirage','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3109,'Amulet: Seal of Silence','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3110,'Amulet: Seal of Scourge','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3111,'Amulet: Seal of Suspension','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3112,'Amulet: Pa''agrio''s Vision','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3113,'Amulet: Pa''agrio''s Protection','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3114,'Amulet: Steal Essence','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3115,'Amulet: Freezing Flame','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3116,'Amulet: Chant of Fury','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3117,'Amulet: Chant of Evasion','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3118,'Amulet: Chant of Rage','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3119,'Mark of Guildsman','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_badge_gold_i00',1,1,1),
(3120,'Valkon''s Recommendation','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3121,'Mandragora Berry','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fruit_red_i00',1,1,1),
(3122,'Altran''s Instructions','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3123,'Altran''s 1st Recommendation','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3124,'Altran''s 2nd Recommendation','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(3125,'Norman''s Instructions','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(3126,'Norman''s Receipt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3127,'Duning''s Instructions','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3128,'Duning''s Key','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_key_i00',1,1,1),
(3129,'Norman''s List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(3130,'Gray Bone Powder','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_powder_gray_i00',1,1,1),
(3131,'Granite Whetstone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_plate_black_i00',1,1,1),
(3132,'Red Pigment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_scarlet_i00',1,1,1),
(3133,'Braided Yarn','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skein_gray_i00',1,1,1),
(3134,'Journeyman Gem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(3135,'Pinter''s Instructions','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(3136,'Amber Bead','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_red_i00',1,1,1),
(3137,'Amber Lump','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(3138,'Journeyman Deco Beads','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_red_i00',1,1,1),
(3139,'Journeyman Ring','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_ring_of_blessing_i00',1,1,1),
(3140,'Mark of Life','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_herb_green_i00',1,1,1),
(3141,'Cardien''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3142,'Camomile Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_near_forest_necklace_i00',1,1,1),
(3143,'Hierarch''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(3144,'Moonflower Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_paradia_ring_i00',1,1,1),
(3145,'Grail Diagram','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_red_i00',1,1,1),
(3146,'Thalia''s 1st Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(3147,'Thalia''s 2nd Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3148,'Thalia''s Instructions','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3149,'Pushkin''s List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(3150,'Pure Mithril Cup','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(3151,'Arkenia''s Contract','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3152,'Arkenia''s Instructions','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3153,'Adonius''s list','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3154,'Andariel Scripture Copy','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(3155,'Stardust','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_powder_orange_i00',1,1,1),
(3156,'Isael''s Instructions','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(3157,'Isael''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3158,'Grail of Purity','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(3159,'Tears of Unicorn','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_blue_i00',1,1,1),
(3160,'Water of Life','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_blue_i00',1,1,1),
(3161,'Pure Mithril Ore','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_stone_gray_i00',1,1,1),
(3162,'Ant Soldier Acid','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_reagent_silver_i00',1,1,1),
(3163,'Wyrm''s Talon','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(3164,'Spider Ichor','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_reagent_green_i00',1,1,1),
(3165,'Harpy''s Down','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_feather_white_i00',1,1,1),
(3166,'Talin''s Spear Blade','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_sword_body_i00',1,1,1),
(3167,'Talin''s Spear Shaft','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_club_i00',1,1,1),
(3168,'Talin''s Ruby','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_red_i00',1,1,1),
(3169,'Talin''s Aquamarine','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_blue_i00',1,1,1),
(3170,'Talin''s Amethyst','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_clear_i00',1,1,1),
(3171,'Talin''s Peridot','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_green_i00',1,1,1),
(3172,'Mark of Fate','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_blue_i00',1,1,1),
(3173,'Kaira''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3174,'Metheus''s Funeral Jar','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(3175,'Kasandra''s Remains','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ashes_white_i00',1,1,1),
(3176,'Herbalism Textbook','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(3177,'Ixia''s List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(3178,'Medusa''s Ichor','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_reagent_blue_i00',1,1,1),
(3179,'Marsh Spider Fluids','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_scarlet_i00',1,1,1),
(3180,'Dead Seeker Dung','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_powder_black_i00',1,1,1),
(3181,'Tyrant''s Blood','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_scarlet_i00',1,1,1),
(3182,'Nightshade Root','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ginseng_gray_i00',1,1,1),
(3183,'Belladonna','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_purple_i00',1,1,1),
(3184,'Alder''s Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(3185,'Alders Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(3186,'Alder''s Receipt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ticket_red_i00',1,1,1),
(3187,'Revelations Manuscript','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_red_i00',1,1,1),
(3188,'Kaira''s Instructions','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3189,'Kaira''s Recommendation','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3190,'Palus Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_onyxbeastseye_earing_i00',1,1,1),
(3191,'Thifiell''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(3192,'Arkenia''s Note','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3193,'Pixy Garnet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_red_i00',1,1,1),
(3194,'Grandis''s Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ashes_red_i00',1,1,1),
(3195,'Karul Bugbear Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(3196,'Breka Overlord Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(3197,'Leto Overlord Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3198,'Red Fairy Dust','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_powder_red_i00',1,1,1),
(3199,'Blight Treant Seed','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fruit_yellow_i00',1,1,1),
(3200,'Black Willow Leaf','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leaf_gold_i00',1,1,1),
(3201,'Blight Treant Sap','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_reagent_gold_i00',1,1,1),
(3202,'Arkenia''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3203,'Mark of Glory','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_badge_gold_i00',1,1,1),
(3204,'Vokian''s Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3205,'Manashen Shard','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(3206,'Tyrant Talon','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(3207,'Guardian Basilisk Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_red_i00',1,1,1),
(3208,'Vokian''s Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(3209,'Necklace of Authority','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_necklace_of_binding_i00',1,1,1),
(3210,'Chianta''s 1st Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3211,'Scepter of Breka','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_buzdygan_i01',1,1,1),
(3212,'Scepter of Enku','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_buzdygan_i01',1,1,1),
(3213,'Scepter of Vuku','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_buzdygan_i01',1,1,1),
(3214,'Scepter of Turek','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_buzdygan_i01',1,1,1),
(3215,'Scepter of Tunath','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_buzdygan_i01',1,1,1),
(3216,'Chianta''s 2nd Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3217,'Chianta''s 3rd Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3218,'Tamlin Orc Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3219,'Timak Orc Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(3220,'Scepter Box','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(3221,'Pashika''s Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(3222,'Vultus'' Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(3223,'Glove of Voltar','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'armor_short_leather_gloves_i00',1,1,1),
(3224,'Enku Overlord Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3225,'Glove of Kepra','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'armor_short_leather_gloves_i00',1,1,1),
(3226,'Makum Bugbear Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(3227,'Glove of Burai','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'armor_short_leather_gloves_i00',1,1,1),
(3228,'Manakia''s 1st Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(3229,'Manakia''s 2nd Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(3230,'Kasman''s 1st Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(3231,'Kasman''s 2nd Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(3232,'Kasman''s 3rd Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(3233,'Driko''s Contract','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3234,'Stakato Drone Husk','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_parasite_i00',1,1,1),
(3235,'Tanapi''s Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(3236,'Scepter of Tantos','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_buzdygan_i01',1,1,1),
(3237,'Ritual Box','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(3238,'Mark of Prosperity','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_gold_i00',1,1,1),
(3239,'1st Ring of Testimony','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_ring_of_assistance_i00',1,1,1),
(3240,'2nd Ring of Testimony','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_aquastone_ring_i00',1,1,1),
(3241,'Old Account Book','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(3242,'Blessed Seed','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fruit_yellow_i00',1,1,1),
(3243,'Emily''s Recipe','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3244,'Lilith''s Elven Wafer','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lump_white_i00',1,1,1),
(3245,'Maphr Tablet Fragment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_plate_blue_i00',1,1,1),
(3246,'Collection License','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3247,'Lockirin''s 1st Notice','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(3248,'Lockirin''s 2nd Notice','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(3249,'Lockirin''s 3rd Notice','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(3250,'Lockirin''s 4th Notice','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(3251,'Lockirin''s 5th Notice','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(3252,'Contribution of Shari','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(3253,'Contribution of Mion','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(3254,'Contribution of Maryse','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(3255,'Maryse''s Request','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(3256,'Contribution of Toma','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(3257,'Receipt of Bolter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ticket_blue_i00',1,1,1),
(3258,'1st Receipt of Contribution','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ticket_red_i00',1,1,1),
(3259,'2nd Receipt of Contribution','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ticket_red_i00',1,1,1),
(3260,'3rd Receipt of Contribution','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ticket_red_i00',1,1,1),
(3261,'4th Receipt of Contribution','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ticket_red_i00',1,1,1),
(3262,'5th Receipt of Contribution','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ticket_red_i00',1,1,1),
(3263,'Procuration of Torocco','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3264,'Bright''s List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3265,'Mandragora Petal','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_herb_red_i00',1,1,1),
(3266,'Crimson Moss','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_powder_red_i00',1,1,1),
(3267,'Mandragora Bouquet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_branch_gold_i00',1,1,1),
(3268,'Parman''s Instructions','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3269,'Parman''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3270,'Clay Dough','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_powder_black_i00',1,1,1),
(3271,'Pattern of Keyhole','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_plate_black_i00',1,1,1),
(3272,'Nikolas'' List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(3273,'Stakato Shell','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_parasite_i00',1,1,1),
(3274,'Toad Lord Sac','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_poison_pouch_i00',1,1,1),
(3275,'Spider Thorn','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(3276,'Mark of Champion','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_gold_i00',1,1,1),
(3277,'Ascalon''s 1st Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3278,'Mason''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(3279,'Iron Rose Ring','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_magic_ring_i00',1,1,1),
(3280,'Ascalon''s 2nd Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3281,'White Rose Insignia','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_knight_shield_i01',1,1,1),
(3282,'Groot''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(3283,'Ascalon''s 3rd Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3284,'Mouen''s 1st Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(3285,'Mouen''s 2nd Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(3286,'Mouen''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(3287,'Harpy''s Egg','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_white_i00',1,1,1),
(3288,'Medusa''s Venom','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_reagent_green_i00',1,1,1),
(3289,'Windsus Bile','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_scarlet_i00',1,1,1),
(3290,'Bloody Axe Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3291,'Road Ratman Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(3292,'Leto Lizardman Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_gray_i00',1,1,1),
(3293,'Mark of Sagittarius','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_wooden_arrow_i01',1,1,1),
(3294,'Bernard''s Introduction','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3295,'Hamil''s 1st Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3296,'Hamil''s 2nd Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3297,'Hamil''s 3rd Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3298,'Hunter''s 1st Rune','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_mold_i00',1,1,1),
(3299,'Hunter''s 2nd Rune','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_mold_i00',1,1,1),
(3300,'Talisman of Kadesh','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_red_cresent_earing_i00',1,1,1),
(3301,'Talisman of Snake','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_dragon_necklace_i00',1,1,1),
(3302,'Mithril Clip','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_ring_of_knowledge_i00',1,1,1),
(3303,'Stakato Chitin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_parasite_i00',1,1,1),
(3304,'Reinforced Bowstring','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skein_white_i00',1,1,1),
(3305,'Manashen''s Horn','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(3306,'Blood of Lizardman','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_reagent_green_i00',1,1,1),
(3307,'Mark of Witchcraft','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(3308,'Orim''s Diagram','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(3309,'Alexandria''s Book','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(3310,'Iker''s List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(3311,'Dire Wyrm Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_gray_i00',1,1,1),
(3312,'Leto Lizardman Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_necklace_green_i00',1,1,1),
(3313,'Enchanted Golem Heartstone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_stone_black_i00',1,1,1),
(3314,'Lara''s Memo','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(3315,'Nestle''s Memo','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3316,'Leopold''s Journal','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(3317,'Aklantoth 1st Gem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_silver_i00',1,1,1),
(3318,'Aklantoth 2nd Gem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_red_i00',1,1,1),
(3319,'Aklantoth 3rd Gem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_green_i00',1,1,1),
(3320,'Aklantoth 4th Gem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_gold_i00',1,1,1),
(3321,'Aklantoth 5th Gem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_blue_i00',1,1,1),
(3322,'Aklantoth 6th Gem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_red_i00',1,1,1),
(3323,'1st Brimstone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_powder_orange_i00',1,1,1),
(3324,'Orim''s Instructions','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(3325,'Orim''s 1st Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3326,'Orim''s 2nd Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3327,'Sir Vasper''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3328,'Vadin''s Crucifix','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_earing_of_wisdom_i00',1,1,1),
(3329,'Tamlin Orc Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_necklace_red_i00',1,1,1),
(3330,'Vadin''s Sanctions','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3331,'Iker''s Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_necklace_of_grace_i00',1,1,1),
(3332,'Soultrap Crystal','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_blue_i00',1,1,1),
(3333,'Purgatory Key','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_key_i00',1,1,1),
(3334,'Zeruel Bind Crystal','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_red_i00',1,1,1),
(3335,'2nd Brimstone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_powder_orange_i00',1,1,1),
(3336,'Mark of Summoner','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_apprentices_rod_i01',1,1,1),
(3337,'Leto Lizardman Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_necklace_green_i00',1,1,1),
(3338,'Sac of Redspores','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(3339,'Karul Bugbear Totem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_black_i00',1,1,1),
(3340,'Shards of Manashen','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(3341,'Breka Orc Totem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_red_i00',1,1,1),
(3342,'Crimson Bloodstone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_red_i00',1,1,1),
(3343,'Talons of Tyrant','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(3344,'Wings of Droneant','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_feather_black_i00',1,1,1),
(3345,'Tusk of Windsus','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(3346,'Fangs of Wyrm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_red_i00',1,1,1),
(3347,'Lara''s 1st List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3348,'Lara''s 2nd List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3349,'Lara''s 3rd List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3350,'Lara''s 4th List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3351,'Lara''s 5th List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3352,'Galatea''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3353,'Beginner''s Arcana','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ticket_blue_i00',1,1,1),
(3354,'Almors''s Arcana','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_dark_dragon_shield_i01',1,1,1),
(3355,'Camoniell''s Arcana','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_dark_dragon_shield_i01',1,1,1),
(3356,'Belthus''s Arcana','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_dark_dragon_shield_i01',1,1,1),
(3357,'Basillia''s Arcana','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_dark_dragon_shield_i01',1,1,1),
(3358,'Celestiel''s Arcana','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_dark_dragon_shield_i01',1,1,1),
(3359,'Brynthea''s Arcana','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_dark_dragon_shield_i01',1,1,1),
(3360,'1st Crystal of Starting','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_blue_i00',1,1,1),
(3361,'1st Crystal of Inprogress','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_clear_i00',1,1,1),
(3362,'1st Crystal of Foul','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_black_i00',1,1,1),
(3363,'1st Crystal of Defeat','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_red_i00',1,1,1),
(3364,'1st Crystal of Victory','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_green_i00',1,1,1),
(3365,'2nd Crystal of Starting','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_blue_i00',1,1,1),
(3366,'2nd Crystal of Inprogress','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_clear_i00',1,1,1),
(3367,'2nd Crystal of Foul','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_black_i00',1,1,1),
(3368,'2nd Crystal of Defeat','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_red_i00',1,1,1),
(3369,'2nd Crystal of Victory','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_green_i00',1,1,1),
(3370,'3rd Crystal of Starting','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_blue_i00',1,1,1),
(3371,'3rd Crystal of Inprogress','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_clear_i00',1,1,1),
(3372,'3rd Crystal of Foul','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_black_i00',1,1,1),
(3373,'3rd Crystal of Defeat','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_red_i00',1,1,1),
(3374,'3rd Crystal of Victory','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_green_i00',1,1,1),
(3375,'4th Crystal of Starting','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_blue_i00',1,1,1),
(3376,'4th Crystal of Inprogress','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_clear_i00',1,1,1),
(3377,'4th Crystal of Foul','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_black_i00',1,1,1),
(3378,'4th Crystal of Defeat','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_red_i00',1,1,1),
(3379,'4th Crystal of Victory','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_green_i00',1,1,1),
(3380,'5th Crystal of Starting','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_blue_i00',1,1,1),
(3381,'5th Crystal of Inprogress','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_clear_i00',1,1,1),
(3382,'5th Crystal of Foul','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_black_i00',1,1,1),
(3383,'5th Crystal of Defeat','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_red_i00',1,1,1),
(3384,'5th Crystal of Victory','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_green_i00',1,1,1),
(3385,'6th Crystal of Starting','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_blue_i00',1,1,1),
(3386,'6th Crystal of Inprogress','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_clear_i00',1,1,1),
(3387,'6th Crystal of Foul','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_black_i00',1,1,1),
(3388,'6th Crystal of Defeat','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_red_i00',1,1,1),
(3389,'6th Crystal of Victory','OTHER','false','none',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_green_i00',1,1,1),
(3390,'Mark of Lord','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_orcish_talisman_i00',1,1,1),
(3391,'Ordeal Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_another_worlds_necklace_i00',1,1,1),
(3392,'Varkee''s Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_earing_of_black_ore_i00',1,1,1),
(3393,'Tantus''s Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_earing_of_blessing_i00',1,1,1),
(3394,'Hatos''s Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_coral_earing_i00',1,1,1),
(3395,'Takuna''s Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_another_worlds_earing_i00',1,1,1),
(3396,'Chianta''s Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_cerberuss_earing_i00',1,1,1),
(3397,'Manakia''s Orders','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3398,'Breka Orc Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_ivory_i00',1,1,1),
(3399,'Manakia''s Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_paradia_earing_i00',1,1,1),
(3400,'Huge Orc Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(3401,'Sumari''s Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(3402,'Urutu Blade','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_sword_body_i00',1,1,1),
(3403,'Timak Orc Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3404,'Sword Into Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(3405,'Neruga Axe Blade','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_heavy_bone_club_i00',1,1,1),
(3406,'Axe of Ceremony','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_battle_axe_i00',1,1,1),
(3407,'Marsh Spider Feeler','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ginseng_gray_i00',1,1,1),
(3408,'Marsh Spider Feet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_insect_leg_i00',1,1,1),
(3409,'Handiwork Spider Brooch','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'shield_doom_shield_i01',1,1,1),
(3410,'Cornea of Enchanted Monster Eye','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_blue_i00',1,1,1),
(3411,'Monster Eye Woodcarving','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_parasite_i00',1,1,1),
(3412,'Bear Fang Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_necklace_of_binding_i00',1,1,1),
(3413,'Martankus''s Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_inferno_necklace_i00',1,1,1),
(3414,'Ragna Orc Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(3415,'Ragna Chief Notice','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3416,'Immortal Flame','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(3417,'Animal Lover''s List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(3418,'Animal Slayer''s 1st List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3419,'Animal Slayer''s 2nd List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3420,'Animal Slayer''s 3rd List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3421,'Animal Slayer''s 4th List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3422,'Animal Slayer''s 5th List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3423,'Bloody Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_red_i00',1,1,1),
(3424,'Bloody Claw','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_red_i00',1,1,1),
(3425,'Bloody Nail','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_red_i00',1,1,1),
(3426,'Bloody Kasha Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_red_i00',1,1,1),
(3427,'Bloody Tarantula Nail','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_red_i00',1,1,1),
(3428,'Crystal Brooch','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'accessary_elven_necklace_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(3429,'Spellbook: Greater Heal','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(3430,'Spellbook: Greater Battle Heal','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(3431,'Spellbook: Greater Group Heal','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(3432,'Spellbook: Remedy','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_hfighter_i00',1,1,1),
(3433,'Elf Figure','OTHER','false','none',0,'normal','steel','none',100,0,0,'false',0,1,'etc_figure_FElf_i00',1,1,1),
(3434,'Coke','OTHER','false','none',0,'normal','steel','none',100,0,0,'false',0,1,'etc_coke_i00',1,1,1),
(3435,'Nvidia','OTHER','false','none',0,'normal','steel','none',100,0,0,'false',0,1,'etc_nvidia_i00',1,1,1),
(3436,'Mouse','OTHER','false','none',0,'normal','steel','none',100,0,0,'false',0,1,'etc_mouse_i00',1,1,1),
(3437,'Trade Book of Merchant','OTHER','false','none',120,'normal','paper','none',0,20000,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(3438,'Trade Book of Great Merchant','OTHER','false','none',120,'normal','paper','none',0,20000,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(3440,'Cargo Box','OTHER','false','none',20,'stackable','steel','none',0,10,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(3441,'Cargo Box','OTHER','false','none',20,'stackable','steel','none',0,10,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(3442,'Cargo Box','OTHER','false','none',20,'stackable','steel','none',0,10,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(3443,'Cargo Box','OTHER','false','none',20,'stackable','steel','none',0,10,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(3444,'Gludio Apples','OTHER','false','none',20,'stackable','steel','none',0,1000,0,'true',0,1,'etc_fruit_green_i00',1,1,1),
(3445,'Dion Corn Meal','OTHER','false','none',20,'stackable','steel','none',0,1000,0,'true',0,1,'etc_powder_orange_i00',1,1,1),
(3446,'Dire Wolf Pelts','OTHER','false','none',20,'stackable','steel','none',0,1000,0,'true',0,1,'etc_crafted_leather_i00',1,1,1),
(3447,'Moonstone','OTHER','false','none',20,'stackable','steel','none',0,1500,0,'true',0,1,'etc_gem_clear_i00',1,1,1),
(3448,'Gludio Wheat Flour','OTHER','false','none',20,'stackable','steel','none',0,1500,0,'true',0,1,'etc_powder_white_i00',1,1,1),
(3449,'Spidersilk Rope','OTHER','false','none',20,'stackable','steel','none',0,1500,0,'true',0,1,'etc_skein_white_i00',1,1,1),
(3450,'Alexandrite','OTHER','false','none',20,'stackable','steel','none',0,2000,0,'true',0,1,'etc_gem_green_i00',1,1,1),
(3451,'Silver Tea Service','OTHER','false','none',20,'stackable','steel','none',0,2000,0,'true',0,1,'etc_mechanic_box_i00',1,1,1),
(3452,'Mechanic Golem Spare Parts','OTHER','false','none',20,'stackable','steel','none',0,2000,0,'true',0,1,'etc_instrument_i00',1,1,1),
(3453,'Fire Emerald','OTHER','false','none',20,'stackable','steel','none',0,5000,0,'true',0,1,'etc_jewel_red_i00',1,1,1),
(3454,'Avellan Silk Frock','OTHER','false','none',20,'stackable','steel','none',0,5000,0,'true',0,1,'etc_piece_of_cloth_red_i00',1,1,1),
(3455,'Feriotic Porcelain Urn','OTHER','false','none',20,'stackable','steel','none',0,5000,0,'true',0,1,'etc_oil_pot_white_i00',1,1,1),
(3456,'Imperial Diamond','OTHER','false','none',20,'stackable','steel','none',0,20000,0,'true',0,1,'etc_jewel_silver_i00',1,1,1),
(3457,'Statue of Shilen - Head','OTHER','false','none',20,'stackable','steel','none',0,2000,0,'true',0,1,'etc_stone_gray_i00',1,1,1),
(3458,'Statue of Shilen - Torso','OTHER','false','none',20,'stackable','steel','none',0,2000,0,'true',0,1,'etc_debris_i00',1,1,1),
(3459,'Statue of Shilen - Arm','OTHER','false','none',20,'stackable','steel','none',0,2000,0,'true',0,1,'etc_gargoyle_claw_i00',1,1,1),
(3460,'Statue of Shilen - Leg','OTHER','false','none',20,'stackable','steel','none',0,2000,0,'true',0,1,'etc_stone_black_i00',1,1,1),
(3461,'Complete Statue of Shilen','OTHER','false','none',20,'stackable','steel','none',0,20000,0,'true',0,1,'etc_statue_of_einhasad_bronze_i00',1,1,1),
(3462,'Fragment of Ancient Tablet - 1st Piece','OTHER','false','none',20,'stackable','steel','none',0,2000,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(3463,'Fragment of Ancient Tablet - 2nd Piece','OTHER','false','none',20,'stackable','steel','none',0,2000,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(3464,'Fragment of Ancient Tablet - 3rd Piece','OTHER','false','none',20,'stackable','steel','none',0,2000,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(3465,'Fragment of Ancient Tablet - 4th Piece','OTHER','false','none',20,'stackable','steel','none',0,2000,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(3466,'Complete Ancient Tablet','OTHER','false','none',20,'stackable','steel','none',0,20000,0,'true',0,1,'etc_ancient_tablet_i00',1,1,1),
(3467,'Wish Potion','OTHER','false','none',60,'normal','paper','none',0,10,0,'true',0,1,'etc_lesser_potion_blue_i00',1,1,1),
(3468,'Ancient Crown','OTHER','false','none',0,'normal','paper','none',0,1000,0,'true',0,1,'etc_mark_blue_i00',1,1,1),
(3469,'Certificate of Royalty','OTHER','false','none',0,'normal','paper','none',0,10,0,'true',0,1,'etc_crest_red_i00',1,1,1),
(3470,'Gold Bar','OTHER','false','none',0,'stackable','paper','none',0,10000,0,'true',0,1,'etc_lump_yellow_i00',1,1,1),
(3472,'Blood Medusa','OTHER','false','none',0,'stackable','steel','none',0,50,0,'true',0,1,'etc_magic_coin_blood_i00',1,1,1),
(3473,'Blood Werewolf','OTHER','false','none',0,'stackable','steel','none',0,100,0,'true',0,1,'etc_magic_coin_blood_i00',1,1,1),
(3474,'Blood Basilisk','OTHER','false','none',0,'stackable','steel','none',0,150,0,'true',0,1,'etc_magic_coin_blood_i00',1,1,1),
(3475,'Blood Drevanul','OTHER','false','none',0,'stackable','steel','none',0,100,0,'true',0,1,'etc_magic_coin_blood_i00',1,1,1),
(3476,'Blood Succubus','OTHER','false','none',0,'stackable','steel','none',0,150,0,'true',0,1,'etc_magic_coin_blood_i00',1,1,1),
(3477,'Blood Dragon','OTHER','false','none',0,'stackable','steel','none',0,200,0,'true',0,1,'etc_magic_coin_blood_i00',1,1,1),
(3478,'Beleth''s Blood Dragon','OTHER','false','none',0,'stackable','steel','none',0,300,0,'true',0,1,'etc_magic_coin_blood_i01',1,1,1),
(3479,'Manak''s Blood Werewolf','OTHER','false','none',0,'stackable','steel','none',0,150,0,'true',0,1,'etc_magic_coin_blood_i01',1,1,1),
(3480,'Nia''s Blood Medusa','OTHER','false','none',0,'stackable','steel','none',0,100,0,'true',0,1,'etc_magic_coin_blood_i01',1,1,1),
(3481,'Gold Dragon','OTHER','false','none',0,'stackable','steel','none',0,200,0,'true',0,1,'etc_magic_coin_gold_i00',1,1,1),
(3482,'Gold Wyvern','OTHER','false','none',0,'stackable','steel','none',0,50,0,'true',0,1,'etc_magic_coin_gold_i00',1,1,1),
(3483,'Gold Knight','OTHER','false','none',0,'stackable','steel','none',0,100,0,'true',0,1,'etc_magic_coin_gold_i00',1,1,1),
(3484,'Gold Giant','OTHER','false','none',0,'stackable','steel','none',0,150,0,'true',0,1,'etc_magic_coin_gold_i00',1,1,1),
(3485,'Gold Drake','OTHER','false','none',0,'stackable','steel','none',0,100,0,'true',0,1,'etc_magic_coin_gold_i00',1,1,1),
(3486,'Gold Wyrm','OTHER','false','none',0,'stackable','steel','none',0,150,0,'true',0,1,'etc_magic_coin_gold_i00',1,1,1),
(3487,'Beleth''s Gold Dragon','OTHER','false','none',0,'stackable','steel','none',0,300,0,'true',0,1,'etc_magic_coin_gold_i01',1,1,1),
(3488,'Manak''s Gold Giant','OTHER','false','none',0,'stackable','steel','none',0,150,0,'true',0,1,'etc_magic_coin_gold_i01',1,1,1),
(3489,'Nia''s Gold Wyvern','OTHER','false','none',0,'stackable','steel','none',0,100,0,'true',0,1,'etc_magic_coin_gold_i01',1,1,1),
(3490,'Silver Unicorn','OTHER','false','none',0,'stackable','steel','none',0,50,0,'true',0,1,'etc_magic_coin_silver_i00',1,1,1),
(3491,'Silver Fairy','OTHER','false','none',0,'stackable','steel','none',0,100,0,'true',0,1,'etc_magic_coin_silver_i00',1,1,1),
(3492,'Silver Dryad','OTHER','false','none',0,'stackable','steel','none',0,150,0,'true',0,1,'etc_magic_coin_silver_i00',1,1,1),
(3493,'Silver Dragon','OTHER','false','none',0,'stackable','steel','none',0,200,0,'true',0,1,'etc_magic_coin_silver_i00',1,1,1),
(3494,'Silver Golem','OTHER','false','none',0,'stackable','steel','none',0,100,0,'true',0,1,'etc_magic_coin_silver_i00',1,1,1),
(3495,'Silver Undine','OTHER','false','none',0,'stackable','steel','none',0,150,0,'true',0,1,'etc_magic_coin_silver_i00',1,1,1),
(3496,'Beleth''s Silver Dragon','OTHER','false','none',0,'stackable','steel','none',0,300,0,'true',0,1,'etc_magic_coin_silver_i01',1,1,1),
(3497,'Manak''s Silver Dryad','OTHER','false','none',0,'stackable','steel','none',0,150,0,'true',0,1,'etc_magic_coin_silver_i01',1,1,1),
(3498,'Nia''s Silver Fairy','OTHER','false','none',0,'stackable','steel','none',0,100,0,'true',0,1,'etc_magic_coin_silver_i01',1,1,1),
(3499,'Fairy Dust','OTHER','false','quest',0,'normal','steel','none',0,10000,0,'true',0,1,'etc_powder_orange_i00',1,1,1),
(3500,'Dragonflute of Wind','OTHER','false','pet_collar',20,'normal','steel','none',0,1000,0,'false',0,1,'etc_flute_i00',1,1,1),
(3501,'Dragonflute of Star','OTHER','false','pet_collar',20,'normal','steel','none',0,1000,0,'false',0,1,'etc_flute_i00',1,1,1),
(3502,'Dragonflute of Twilight','OTHER','false','pet_collar',20,'normal','steel','none',0,1000,0,'false',0,1,'etc_flute_i00',1,1,1),
(3503,'Deliverymen Decertificate','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_paper_white_i00',1,1,1),
(3504,'Kirunas Horn','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(3505,'Mithril Mold','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_silver_mold_i00',1,1,1),
(3506,'Bloody Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(3507,'Supplies to Alex','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_squares_wood_i00',1,1,1),
(3508,'Supplies to Endrigo','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_squares_wood_i00',1,1,1),
(3509,'Alex''s Coins','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_gold_i00',1,1,1),
(3510,'Wardens Appreciation','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_paper_blue_i00',1,1,1),
(3511,'Blackbox to Orim','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_squares_gray_i00',1,1,1),
(3512,'Deluxe Windsus Ham','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_meat_i00',1,1,1),
(3513,'Heart of Silenos','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_heart_i00',1,1,1),
(3514,'Request Giran','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3515,'Request Gludin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3516,'Request Hunters','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3517,'Delivery Score Red','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ticket_red_i00',1,1,1),
(3518,'Delivery Score Blue','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ticket_blue_i00',1,1,1),
(3519,'Deliverymen Advanced Certificate Super','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_paper_black_i00',1,1,1),
(3520,'1st Confirmation Document','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3521,'2nd Confirmation Document','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3522,'Delivery Goods 01','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_roll_of_paper_blue_i00',1,1,1),
(3523,'Delivery Goods 02','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_envelope_i00',1,1,1),
(3524,'Delivery Goods 03','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_red_i00',1,1,1),
(3525,'Delivery Goods 04','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_paper_white_i00',1,1,1),
(3526,'Delivery Goods 05','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_envelope_i00',1,1,1),
(3527,'Delivery Goods 06','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(3528,'Delivery Goods 07','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_envelope_i00',1,1,1),
(3529,'Delivery Goods 08','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_painting_i00',1,1,1),
(3530,'Delivery Goods 09','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(3531,'Delivery Goods 10','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_squares_gray_i00',1,1,1),
(3532,'Delivery Goods 11','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(3533,'Delivery Goods 12','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_squares_silver_i00',1,1,1),
(3534,'Delivery Goods 13','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_instrument_i00',1,1,1),
(3535,'Delivery Goods 14','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(3536,'Delivery Goods 15','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(3537,'Delivery Goods 16','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_envelope_i00',1,1,1),
(3538,'Delivery Goods 17','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(3539,'Delivery Goods 18','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_holy_statue_bronze_i00',1,1,1),
(3540,'Delivery Goods 19','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_squares_gray_i00',1,1,1),
(3541,'Delivery Goods 20','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_statue_of_einhasad_silver_i00',1,1,1),
(3542,'Delivery Goods 21','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(3543,'Delivery Goods 22','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_paper_white_i00',1,1,1),
(3544,'Delivery Goods 23','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_gold_i00',1,1,1),
(3545,'Delivery Goods 24','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_holy_statue_bronze_i00',1,1,1),
(3546,'Delivery Goods 25','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_synthetic_cokes_i00',1,1,1),
(3547,'Delivery Goods 26','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(3548,'Delivery Goods 27','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_roll_of_paper_white_i00',1,1,1),
(3549,'Delivery Goods 28','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_painting_i00',1,1,1),
(3550,'Delivery Goods 29','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_cloth_blue_i00',1,1,1),
(3551,'Delivery Goods 30','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(3552,'Delivery Goods 31','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_blue_i00',1,1,1),
(3553,'Delivery Goods 32','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(3554,'Delivery Goods 33','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lump_yellow_i00',1,1,1),
(3555,'Delivery Goods 34','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(3556,'Delivery Goods 35','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_envelope_i00',1,1,1),
(3557,'Delivery Goods 36','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_cloth_blue_i00',1,1,1),
(3558,'Delivery Goods 37','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_red_i00',1,1,1),
(3559,'Delivery Goods 38','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_synthetic_cokes_i00',1,1,1),
(3560,'Delivery Goods 39','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_gold_i00',1,1,1),
(3561,'Delivery Goods 40','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_adamantite_i00',1,1,1),
(3562,'Delivery Goods 41','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_paper_white_i00',1,1,1),
(3563,'Delivery Goods 42','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_roll_of_paper_red_i00',1,1,1),
(3564,'Delivery Goods 43','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_paper_white_i00',1,1,1),
(3565,'Delivery Goods 44','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_squares_silver_i00',1,1,1),
(3566,'Delivery Goods 45','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(3567,'Delivery Goods 46','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_key_i00',1,1,1),
(3568,'Delivery Goods 47','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_instrument_i00',1,1,1),
(3569,'Delivery Goods 48','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_paper_white_i00',1,1,1),
(3570,'Delivery Goods 49','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_adamantite_i00',1,1,1),
(3571,'Delivery Goods 50','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(3572,'Delivery Goods 51','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_squares_wood_i00',1,1,1),
(3573,'Delivery Goods 52','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_painting_i00',1,1,1),
(3574,'Delivery Goods 53','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_roll_of_paper_blue_i00',1,1,1),
(3575,'Delivery Goods 54','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_squares_wood_i00',1,1,1),
(3576,'Delivery Goods 55','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(3577,'Delivery Goods 56','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(3578,'Delivery Goods 57','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(3579,'Delivery Goods 58','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_scarlet_i00',1,1,1),
(3580,'Delivery Goods 59','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_roll_of_paper_white_i00',1,1,1),
(3581,'Delivery Goods 60','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_silver_i00',1,1,1),
(3582,'Delivery Goods 61','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_scarlet_i00',1,1,1),
(3583,'Delivery Goods 62','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_roll_of_paper_red_i00',1,1,1),
(3584,'Delivery Goods 63','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_envelope_i00',1,1,1),
(3585,'Delivery Goods 64','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(3586,'Delivery Goods 65','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_parasite_i00',1,1,1),
(3587,'Delivery Goods 66','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(3588,'Delivery Goods 67','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(3589,'Confirmation Document 01','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3590,'Confirmation Document 02','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3591,'Confirmation Document 03','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3592,'Confirmation Document 04','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3593,'Confirmation Document 05','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3594,'Confirmation Document 06','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3595,'Confirmation Document 07','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3596,'Confirmation Document 08','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3597,'Confirmation Document 09','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3598,'Confirmation Document 10','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3599,'Confirmation Document 11','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3600,'Confirmation Document 12','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3601,'Confirmation Document 13','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3602,'Confirmation Document 14','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3603,'Confirmation Document 15','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3604,'Confirmation Document 16','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3605,'Confirmation Document 17','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3606,'Confirmation Document 18','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3607,'Confirmation Document 19','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3608,'Confirmation Document 20','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3609,'Confirmation Document 21','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3610,'Confirmation Document 22','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3611,'Confirmation Document 23','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3612,'Confirmation Document 24','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3613,'Confirmation Document 25','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3614,'Confirmation Document 26','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3615,'Confirmation Document 27','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3616,'Confirmation Document 28','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3617,'Confirmation Document 29','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3618,'Confirmation Document 30','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3619,'Confirmation Document 31','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3620,'Confirmation Document 32','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3621,'Confirmation Document 33','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3622,'Confirmation Document 34','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3623,'Confirmation Document 35','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3624,'Confirmation Document 36','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3625,'Confirmation Document 37','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3626,'Confirmation Document 38','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3627,'Confirmation Document 39','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3628,'Confirmation Document 40','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3629,'Confirmation Document 41','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3630,'Confirmation Document 42','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3631,'Confirmation Document 43','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3632,'Confirmation Document 44','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3633,'Confirmation Document 45','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3634,'Confirmation Document 46','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3635,'Confirmation Document 47','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3636,'Confirmation Document 48','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3637,'Confirmation Document 49','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3638,'Confirmation Document 50','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3639,'Confirmation Document 51','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3640,'Confirmation Document 52','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3641,'Confirmation Document 53','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3642,'Confirmation Document 54','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3643,'Confirmation Document 55','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3644,'Confirmation Document 56','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3645,'Confirmation Document 57','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3646,'Confirmation Document 58','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3647,'Confirmation Document 59','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3648,'Confirmation Document 60','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3649,'Confirmation Document 61','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3650,'Confirmation Document 62','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3651,'Confirmation Document 63','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3652,'Confirmation Document 64','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3653,'Confirmation Document 65','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3654,'Confirmation Document 66','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3655,'Confirmation Document 67','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3656,'Eye of Seer','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(3657,'Pincher Claw','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_gray_i00',1,1,1),
(3658,'Ol Mahum Uniform','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_debris_i00',1,1,1),
(3659,'Enku Orc Champion''s Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3660,'Bloody Bee Stinger','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_sting_a_i00',1,1,1),
(3661,'Ignition of Ghost Fire','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oriharukon_ore_i00',1,1,1),
(3662,'Ethereal Blood','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_clear_i00',1,1,1),
(3663,'Returned Delivery Goods 10','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_squares_gray_i00',1,1,1),
(3664,'Returned Delivery Goods 15','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(3665,'Returned Delivery Goods 30','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(3666,'Returned Delivery Goods 33','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lump_yellow_i00',1,1,1),
(3667,'Returned Delivery Goods 37','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_red_i00',1,1,1),
(3668,'Returned Delivery Goods 45','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(3669,'Returned Delivery Goods 55','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(3670,'Returned Delivery Goods 60','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_silver_i00',1,1,1),
(3671,'Sophya''s 1st Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_roll_of_paper_red_i00',1,1,1),
(3672,'Sophya''s 2nd Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_roll_of_paper_red_i00',1,1,1),
(3673,'Sophya''s 3rd Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_roll_of_paper_red_i00',1,1,1),
(3674,'Sophya''s 4th Order','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_roll_of_paper_red_i00',1,1,1),
(3675,'Lion''s Claw','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(3676,'Lion''s Eye','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(3677,'Guild Coin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_silver_i00',1,1,1),
(3678,'Alchemy Text','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(3679,'Secret Book of Potion','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(3680,'1st Potion Recipe','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(3681,'2nd Potion Recipe','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3682,'Matild''s Orb','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_gold_i00',1,1,1),
(3683,'Forbidden Love Scroll','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(3684,'Amber Scale','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scale_of_medusa_red_i00',1,1,1),
(3685,'Wind Soulstone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_blue_i00',1,1,1),
(3686,'Glass Eye','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(3687,'Horror Ectoplasm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_lesser_potion_clear_i00',1,1,1),
(3688,'Silenos Horn','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(3689,'Ant Soldier Aphid','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_parasite_i00',1,1,1),
(3690,'Tyrant''s Chitin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(3691,'Bugbear Blood','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_red_i00',1,1,1),
(3692,'1st Circle Hunter License','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_paper_red_i00',1,1,1),
(3693,'2nd Circle Hunter License','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_paper_blue_i00',1,1,1),
(3694,'Laurel Leaf Pin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_herb_blue_i00',1,1,1),
(3695,'1st Test Instructions','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3696,'2nd Test Instructions','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3697,'Cybellin''s Request','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3698,'Blood Crystal: Purity 1','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(3699,'Blood Crystal: Purity 2','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(3700,'Blood Crystal: Purity 3','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(3701,'Blood Crystal: Purity 4','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(3702,'Blood Crystal: Purity 5','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(3703,'Blood Crystal: Purity 6','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(3704,'Blood Crystal: Purity 7','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(3705,'Blood Crystal: Purity 8','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(3706,'Blood Crystal: Purity 9','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(3707,'Blood Crystal: Purity 10','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(3708,'Blood Crystal: Broken','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_broken_crystal_red_i00',1,1,1),
(3709,'Guardian Basilisk Scale','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scale_of_medusa_red_i00',1,1,1),
(3710,'Karut Weed','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_branch_green_i00',1,1,1),
(3711,'Haka''s Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(3712,'Jakas'' Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3713,'Marka''s Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(3714,'Windsus Aleph Skin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leather_brown_i00',1,1,1),
(3715,'Indigo Runestone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(3716,'Sporesea Seed','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_seed_yellow_i00',1,1,1),
(3717,'Timak Orc Totem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_black_i00',1,1,1),
(3718,'Trisalim Silk','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_cobweb_i00',1,1,1),
(3719,'Ambrosius Fruit','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fruit_red_i00',1,1,1),
(3720,'Balefire Crystal','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_red_i00',1,1,1),
(3721,'Imperial Arrowhead','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_arrowhead_i02',1,1,1),
(3722,'Athu''s Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3723,'Lanka''s Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3724,'Triska''s Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3725,'Motura''s Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3726,'Kalath''s Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3727,'1st Circle Request: 1C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3728,'1st Circle Request: 2C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3729,'1st Circle Request: 3C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3730,'1st Circle Request: 4C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3731,'1st Circle Request: 5C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3732,'1st Circle Request: 6C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3733,'1st Circle Request: 7C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3734,'1st Circle Request: 8C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3735,'1st Circle Request: 9C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3736,'1st Circle Request: 10C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3737,'1st Circle Request: 11C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3738,'1st Circle Request: 12C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3739,'1st Circle Request: 1B','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3740,'1st Circle Request: 2B','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3741,'1st Circle Request: 3B','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3742,'1st Circle Request: 4B','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3743,'1st Circle Request: 5B','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3744,'1st Circle Request: 6B','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3745,'1st Circle Request: 1A','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3746,'1st Circle Request: 2A','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3747,'1st Circle Request: 3A','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3748,'2nd Circle Request: 1C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3749,'2nd Circle Request 2C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3750,'2nd Circle Request 3C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3751,'2nd Circle Request: 4C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3752,'2nd Circle Request: 5C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3753,'2nd Circle Request: 6C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3754,'2nd Circle Request: 7C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3755,'2nd Circle Request: 8C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3756,'2nd Circle Request: 9C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3757,'2nd Circle Request: 10C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3758,'2nd Circle Request: 11C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3759,'2nd Circle Request: 12C','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3760,'2nd Circle Request: 1B','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3761,'2nd Circle Request: 2B','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(3762,'2nd Circle Request: 3B','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3763,'2nd Circle Request: 4B','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3764,'2nd Circle Request: 5B','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3765,'2nd Circle Request: 6B','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3766,'2nd Circle Request: 1A','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3767,'2nd Circle Request: 2A','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3768,'2nd Circle Request: 3A','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3769,'Charm of Kadesh','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_parasite_i00',1,1,1),
(3770,'Timak Jade Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_necklace_black_i00',1,1,1),
(3771,'Enchanted Golem Shard','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(3772,'Giant Monster Eye Meat','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_meat_of_monstereye_i00',1,1,1),
(3773,'Dire Wyrm Egg','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_dragon_egg_i01',1,1,1),
(3774,'Grd Basilisk Talon','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(3775,'Revenant''s Chains','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_chain_i00',1,1,1),
(3776,'Windsus Tusk','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(3777,'Grandis Skull','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(3778,'Taik Obsidian Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_necklace_black_i00',1,1,1),
(3779,'Karul Bugbear Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3780,'Tamlin Ivory Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_stick_i00',1,1,1),
(3781,'Fang of Narak','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(3782,'Enchanted Gargoyle Horn','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gargoyle_claw_i00',1,1,1),
(3783,'Coiled Serpent Totem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_parasite_i00',1,1,1),
(3784,'Totem of Kadesh','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_parasite_i00',1,1,1),
(3785,'Kaiki''s Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(3786,'Kronbe Venom Sac','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_poison_pouch_i00',1,1,1),
(3787,'Eva''s Charm','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_statue_of_einhasad_gold_i00',1,1,1),
(3788,'Titan''s Tablet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_ancient_tablet_i00',1,1,1),
(3789,'Book of Shunaiman','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(3790,'Rotting Tree Spores','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_seed_red_i00',1,1,1),
(3791,'Trisalim Venom Sac','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_poison_pouch_i00',1,1,1),
(3792,'Taik Orc Totem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_green_i00',1,1,1),
(3793,'Harit Barbed Necklace','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leash_i00',1,1,1),
(3794,'Coin of Old Empire','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_blue_i00',1,1,1),
(3795,'Skin of Farcran','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leather_i00',1,1,1),
(3796,'Tempest Shard','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_clear_i00',1,1,1),
(3797,'Tsunami Shard','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_blue_i00',1,1,1),
(3798,'Satyr Mane','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_mane_i00',1,1,1),
(3799,'Hamadryad Shard','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_green_i00',1,1,1),
(3800,'Vanor Silenos Mane','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_mane_i00',1,1,1),
(3801,'Talk Bugbear Totem','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_totem_red_i00',1,1,1),
(3802,'Okun''s Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_black_i00',1,1,1),
(3803,'Kakran''s Head','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3804,'Narcissus''s Soulstone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_crystal_ball_blue_i00',1,1,1),
(3805,'Deprive Eye','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(3806,'Unicorn''s Horn','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_unicorn_horn_i00',1,1,1),
(3807,'Kerunos''s Gold Mane','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_mane_i00',1,1,1),
(3808,'Skull of Executed','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(3809,'Bust of Travis','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_holy_statue_silver_i00',1,1,1),
(3810,'Sword of Cadmus','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_sword_of_watershadow_i00',1,1,1),
(3811,'Coin Diagram','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(3812,'Kaldis Gold Dragon','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_magic_coin_gold_i00',1,1,1),
(3813,'Coin Collector Membership 1','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_blue_i00',1,1,1),
(3814,'Coin Collector Membership 2','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3815,'Coin Collector Membership 3','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(3816,'Fairy Stone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_red_i00',1,1,1),
(3817,'Deluxe Fairy Stone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_gem_clear_i00',1,1,1),
(3818,'Fairy Stone List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3819,'Deluxe Fairy Stone List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3820,'Toad Lord Back Skin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leather_gray_i00',1,1,1),
(3821,'Juice of Monkshood','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_potion_green_i00',1,1,1),
(3822,'Scale of Drake Exarion','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scale_of_medusa_blue_i00',1,1,1),
(3823,'Egg of Drake Exarion','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_dragon_egg_i02',1,1,1),
(3824,'Scale of Drake Zwov','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scale_of_medusa_green_i00',1,1,1),
(3825,'Egg of Drake Zwov','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_dragon_egg_i04',1,1,1),
(3826,'Scale of Drake Kalibran','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scale_of_medusa_red_i00',1,1,1),
(3827,'Egg of Drake Kalibran','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_dragon_egg_i01',1,1,1),
(3828,'Scale of Wyvern Suzet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_seed_yellow_i00',1,1,1),
(3829,'Egg of Wyvern Suzet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_dragon_egg_i03',1,1,1),
(3830,'Scale of Wyvern Shamhai','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_seed_red_i00',1,1,1),
(3831,'Egg of Wyvern Shamhai','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_dragon_egg_i00',1,1,1),
(3832,'Herb of Harit','OTHER','false','none',0,'normal','steel','none',0,0,0,'false',0,1,'etc_herb_red_i00',1,1,1),
(3833,'Herb of Vanor','OTHER','false','none',0,'normal','steel','none',0,0,0,'false',0,1,'etc_herb_green_i00',1,1,1),
(3834,'Herb of Oel Mahum','OTHER','false','none',0,'normal','steel','none',0,0,0,'false',0,1,'etc_herb_blue_i00',1,1,1),
(3835,'Blood of Eva','OTHER','false','none',0,'normal','steel','none',0,0,0,'false',0,1,'etc_dragon_blood_i00',1,1,1),
(3836,'Athrea''s Coin','OTHER','false','quest',0,'normal','steel','none',0,0,0,'false',0,1,'etc_coins_gold_i00',1,1,1),
(3837,'Symbol of Loyalty','OTHER','false','none',0,'normal','steel','none',0,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(3838,'Recipe: Titan''s Powerstone','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(3839,'Mist Drake Egg','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_dragon_egg_i02',1,1,1),
(3840,'Blitz Wyrm Egg','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_dragon_egg_i01',1,1,1),
(3841,'Drake Egg','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_dragon_egg_i00',1,1,1),
(3842,'Thunder Wyrm Egg','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_dragon_egg_i03',1,1,1),
(3843,'Brooch of the Magpie','OTHER','false','quest',0,'normal','steel','none',0,1000,0,'false',0,1,'etc_feather_black_i00',1,1,1),
(3844,'Nebulite Crystals','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(3845,'Broken Titan''s Powerstone','MATHERIALS','false','quest',0,'stackable','steel','none',0,500,0,'false',0,1,'etc_instrument_i00',1,1,1),
(3846,'Titan''s Powerstone','MATHERIALS','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_mechanic_box_i00',1,1,1),
(3847,'Imperial Key','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_key_i00',1,1,1),
(3848,'Undead Ash','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_powder_gray_i00',1,1,1),
(3849,'Bloody Axe Insignia','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_badge_black_i00',1,1,1),
(3850,'Delu Lizardman Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_ivory_i00',1,1,1),
(3851,'Stakato Talon','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(3852,'Feather of Gabrielle','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_feather_gold_i00',1,1,1),
(3853,'Marsh Stalker Horn','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(3854,'Marsh Drake Talons','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(3855,'Kranrot Skin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leather_brown_i00',1,1,1),
(3856,'Hamrut Leg','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_insect_leg_i00',1,1,1),
(3857,'Remains of Sacrified','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(3858,'Totem of Land Dragon','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_parasite_i00',1,1,1),
(3859,'1st Fragment of Abyss Jewel','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_broken_crystal_blue_i00',1,1,1),
(3860,'2nd Fragment of Abyss Jewel','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_broken_crystal_red_i00',1,1,1),
(3861,'3rd Fragment of Abyss Jewel','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_broken_crystal_gold_i00',1,1,1),
(3862,'Mara Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_ivory_i00',1,1,1),
(3863,'Musfel Fang','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_fang_red_i00',1,1,1),
(3864,'Mark of Watchman','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(3865,'Portal Stone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_plate_blue_i00',1,1,1),
(3866,'Gustav''s 1st Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3867,'Gustav''s 2nd Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3868,'Gustav''s 3rd Letter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(3869,'Scepter of Judgment','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_royal_seal_of_lord_i04',1,1,1),
(3870,'Seal of Aspiration','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_paper_blue_i00',1,1,1),
(3871,'Black Anvil Coin','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_coins_blue_i00',1,1,1),
(3872,'Antidote Recipe List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(3873,'Voucher of Faith','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(3874,'Alliance Manifesto','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_paper_white_i00',1,1,1),
(3875,'L2Day - A','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_a_i00',1,1,1),
(3876,'L2Day - C','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_c_i00',1,1,1),
(3877,'L2Day - E','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_e_i00',1,1,1),
(3878,'L2Day - F','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_f_i00',1,1,1),
(3879,'L2Day - G','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_g_i00',1,1,1),
(3880,'L2Day - H','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_h_i00',1,1,1),
(3881,'L2Day - I','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_i_i00',1,1,1),
(3882,'L2Day - L','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_l_i00',1,1,1),
(3883,'L2Day - N','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_n_i00',1,1,1),
(3884,'L2Day - O','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_o_i00',1,1,1),
(3885,'L2Day - R','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_r_i00',1,1,1),
(3886,'L2Day - S','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_s_i00',1,1,1),
(3887,'L2Day - T','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_t_i00',1,1,1),
(3888,'L2Day - II','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_ii_i00',1,1,1),
(3889,'Potion of Recovery','CONSUMABLE','false','potion',180,'stackable','liquid','none',100,0,0,'false',2060,1,'etc_herb_green_i00',1,1,1),
(3890,'Herald of Slayer','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_badge_silver_i00',1,1,1),
(3926,'L2Day - Scroll of Guidance','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,0,0,'false',2050,1,'etc_scroll_white_i00',1,1,1),
(3927,'L2Day - Scroll of Death Whisper','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,0,0,'false',2051,1,'etc_scroll_white_i00',1,1,1),
(3928,'L2Day - Scroll of Focus','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,0,0,'false',2052,1,'etc_scroll_white_i00',1,1,1),
(3929,'L2Day - Scroll of Greater Acumen','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,0,0,'false',2053,1,'etc_scroll_white_i00',1,1,1),
(3930,'L2Day - Scroll of Haste','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,0,0,'false',2054,1,'etc_scroll_white_i00',1,1,1),
(3931,'L2Day - Scroll of Agility','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,0,0,'false',2055,1,'etc_scroll_white_i00',1,1,1),
(3932,'L2Day - Scroll of Mystic Empower','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,0,0,'false',2056,1,'etc_scroll_white_i00',1,1,1),
(3933,'L2Day - Scroll of Might','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,0,0,'false',2057,1,'etc_scroll_white_i00',1,1,1),
(3934,'L2Day - Scroll of Windwalk','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,0,0,'false',2058,1,'etc_scroll_white_i00',1,1,1),
(3935,'L2Day - Scroll of Shield','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,0,0,'false',2059,1,'etc_scroll_white_i00',1,1,1),
(3936,'Blessed Scroll of Resurrection','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,400000,0,'true',2049,1,'etc_scroll_of_resurrection_i01',1,1,1),
(3940,'Blueprint: Summon Siege Golem','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4800,0,'true',0,1,'etc_plan_i00',1,1,1),
(3941,'Spellbook: Mass Resurrection','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(3942,'Spellbook: Party Return','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(3943,'Amulet: Pa''agrio''s Heart','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(3944,'Spellbook: Decrease Weight','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,2450,0,'true',0,1,'etc_spell_books_blue_i00',1,1,1),
(3945,'Boat Ticket: Talking Island to Giran','OTHER','false','none',20,'stackable','paper','none',0,8000,0,'true',0,1,'etc_ticket_red_i00',1,1,1),
(3946,'Boat Ticket: Giran to Talking Island','OTHER','false','none',20,'stackable','paper','none',0,8000,0,'true',0,1,'etc_ticket_blue_i00',1,1,1),
(3947,'Blessed Spiritshot: No Grade','CONSUMABLE','false','shot',5,'stackable','paper','none',0,35,0,'true',0,1,'etc_spell_shot_white_i01',1,1,1),
(3948,'Blessed Spiritshot: D-Grade','CONSUMABLE','false','shot',5,'stackable','paper','d',0,45,0,'true',0,1,'etc_spell_shot_blue_i01',1,1,1),
(3949,'Blessed Spiritshot: C-Grade','CONSUMABLE','false','shot',3,'stackable','paper','c',0,90,0,'true',0,1,'etc_spell_shot_green_i01',1,1,1),
(3950,'Blessed Spiritshot: B-Grade','CONSUMABLE','false','shot',3,'stackable','paper','b',0,245,0,'true',0,1,'etc_spell_shot_red_i01',1,1,1),
(3951,'Blessed Spiritshot: A-Grade','CONSUMABLE','false','shot',2,'stackable','paper','a',0,290,0,'true',0,1,'etc_spell_shot_silver_i01',1,1,1),
(3952,'Blessed Spiritshot: S Grade','CONSUMABLE','false','shot',2,'stackable','paper','s',0,350,0,'true',0,1,'etc_spell_shot_gold_i01',1,1,1),
(3953,'Recipe: Blessed Spiritshot D','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(3954,'Recipe: Blessed Spiritshot C','RECIPIES','false','recipe',30,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(3955,'Recipe: Blessed Spiritshot B','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(3956,'Recipe: Blessed Spiritshot A','RECIPIES','false','recipe',30,'stackable','liquid','none',0,150000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(3957,'Recipe: Blessed Spiritshot S','RECIPIES','false','recipe',30,'stackable','liquid','none',0,450000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(3958,'L2Day - Blessed Escape Effect','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,0,0,'false',2036,2,'etc_scroll_of_return_i01',1,1,1),
(3959,'L2Day - Blessed Resurrection Effect','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,0,0,'false',2062,1,'etc_scroll_of_resurrection_i01',1,1,1),
(3960,'Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(3961,'Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(3962,'Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(3963,'Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(3964,'Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(3965,'Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(3966,'Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(3967,'Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(3968,'Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(3969,'Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(3970,'Mercenary Posting Ticket (Teleporter1)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(3971,'Mercenary Posting Ticket (Teleporter2)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(3972,'Mercenary Posting Ticket (Teleporter3)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(3973,'Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(3974,'Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(3975,'Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(3976,'Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(3977,'Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(3978,'Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(3979,'Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(3980,'Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(3981,'Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(3982,'Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(3983,'Mercenary Posting Ticket (Teleporter1)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(3984,'Mercenary Posting Ticket (Teleporter2)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(3985,'Mercenary Posting Ticket (Teleporter3)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(3986,'Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(3987,'Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(3988,'Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(3989,'Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(3990,'Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(3991,'Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(3992,'Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(3993,'Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(3994,'Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(3995,'Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(3996,'Mercenary Posting Ticket (Teleporter1)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(3997,'Mercenary Posting Ticket (Teleporter2)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(3998,'Mercenary Posting Ticket (Teleporter3)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(3999,'Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(4000,'Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(4001,'Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(4002,'Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(4003,'Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(4004,'Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(4005,'Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(4006,'Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(4007,'Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(4008,'Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(4009,'Mercenary Posting Ticket (Teleporter1)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(4010,'Mercenary Posting Ticket (Teleporter2)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(4011,'Mercenary Posting Ticket (Teleporter3)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(4012,'Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(4013,'Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(4014,'Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(4015,'Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(4016,'Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(4017,'Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(4018,'Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(4019,'Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(4020,'Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(4021,'Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(4022,'Mercenary Posting Ticket (Teleporter1)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(4023,'Mercenary Posting Ticket (Teleporter2)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(4024,'Mercenary Posting Ticket (Teleporter3)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(4025,'Mercenary Posting Ticket (Teleporter4)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(4026,'Mercenary Posting Ticket (Teleporter5)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(4029,'Red Paper','OTHER','false','quest',0,'stackable','paper','none',0,1,0,'false',0,1,'etc_paper_red_i00',1,1,1),
(4030,'Orange Paper','OTHER','false','quest',0,'stackable','paper','none',0,1,0,'false',0,1,'etc_paper_red_i00',1,1,1),
(4031,'Yellow Paper','OTHER','false','quest',0,'stackable','paper','none',0,1,0,'false',0,1,'etc_paper_red_i00',1,1,1),
(4032,'Green Paper','OTHER','false','quest',0,'stackable','paper','none',0,1,0,'false',0,1,'etc_paper_red_i00',1,1,1),
(4033,'Blue Paper','OTHER','false','quest',0,'stackable','paper','none',0,1,0,'false',0,1,'etc_paper_red_i00',1,1,1),
(4034,'Purple Paper','OTHER','false','quest',0,'stackable','paper','none',0,1,0,'false',0,1,'etc_paper_red_i00',1,1,1),
(4035,'White Paper','OTHER','false','quest',0,'stackable','paper','none',0,1,0,'false',0,1,'etc_paper_red_i00',1,1,1),
(4036,'Black Paper','OTHER','false','quest',0,'stackable','paper','none',0,1,0,'false',0,1,'etc_paper_red_i00',1,1,1),
(4037,'Coin of Luck','OTHER','false','none',0,'stackable','paper','none',0,1,0,'false',0,1,'etc_coins_gold_i00',0,0,1),
(4038,'Food For Hatchling','OTHER','false','none',10,'stackable','liquid','none',0,150,0,'true',0,1,'etc_pouch_yellow_i00',1,1,1),
(4039,'Mold Glue','MATHERIALS','false','material',2,'stackable','liquid','none',0,6000,0,'true',0,1,'etc_reagent_red_i00',1,1,1),
(4040,'Mold Lubricant','MATHERIALS','false','material',2,'stackable','liquid','none',0,10000,0,'true',0,1,'etc_reagent_gold_i00',1,1,1),
(4041,'Mold Hardener','MATHERIALS','false','material',2,'stackable','liquid','none',0,23000,0,'true',0,1,'etc_reagent_blue_i00',1,1,1),
(4042,'Enria','MATHERIALS','false','material',2,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_gem_red_i00',1,1,1),
(4043,'Asofe','MATHERIALS','false','material',2,'stackable','liquid','none',0,6000,0,'true',0,1,'etc_gem_blue_i00',1,1,1),
(4044,'Thons','MATHERIALS','false','material',2,'stackable','liquid','none',0,6000,0,'true',0,1,'etc_gem_clear_i00',1,1,1),
(4045,'Maestro Holder','MATHERIALS','false','material',2,'stackable','liquid','none',0,411000,0,'true',0,1,'etc_lump_yellow_i00',1,1,1),
(4046,'Maestro Anvil Lock','MATHERIALS','false','material',2,'stackable','liquid','none',0,90400,0,'true',0,1,'etc_lump_dark_gray_i00',1,1,1),
(4047,'Craftsman Mold','MATHERIALS','false','material',2,'stackable','liquid','none',0,710000,0,'true',0,1,'etc_mold_i00',1,1,1),
(4048,'Maestro Mold','MATHERIALS','false','material',2,'stackable','liquid','none',0,154000,0,'true',0,1,'etc_silver_mold_i00',1,1,1),
(4049,'Adamantite Earring Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,3813,0,'true',0,1,'etc_crystal_ball_gold_i00',1,1,1),
(4050,'Adamantite Ring Wire','PIECES','false','material',60,'stackable','liquid','none',0,3228,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(4051,'Adamantite Necklace Chain','PIECES','false','material',60,'stackable','liquid','none',0,5157,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(4052,'Earring of Black Ore Piece','PIECES','false','material',60,'stackable','liquid','none',0,5649,0,'true',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(4053,'Ring of Black Ore Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,4666,0,'true',0,1,'etc_gem_black_i00',1,1,1),
(4054,'Necklace of Black Ore Beads','PIECES','false','material',60,'stackable','liquid','none',0,10154,0,'true',0,1,'etc_bead_silver_i00',1,1,1),
(4055,'Composite Shield Fragment','PIECES','false','material',60,'stackable','liquid','none',0,3120,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(4056,'Zubei''s Breastplate Part','PIECES','false','material',60,'stackable','liquid','none',0,11050,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(4057,'Zubei''s Gaiter Material','PIECES','false','material',60,'stackable','liquid','none',0,7150,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4058,'Implosion Boots Part','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(4059,'Boots of Silence Fabric','PIECES','false','material',60,'stackable','liquid','none',0,3843,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4060,'Guardian''s Boots Fabric','PIECES','false','material',60,'stackable','liquid','none',0,3843,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4061,'Paradia Boots Pattern','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(4062,'Elemental Boots Lining','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4063,'Boots of Grace Lining','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4064,'Avadon Breastplate Part','PIECES','false','material',60,'stackable','liquid','none',0,11050,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(4065,'Avadon Gaiters Material','PIECES','false','material',60,'stackable','liquid','none',0,7150,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4066,'Zubei''s Leather Shirt Fabric','PIECES','false','material',60,'stackable','liquid','none',0,8483,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4067,'Zubei''s Leather Gaiter Texture','PIECES','false','material',60,'stackable','liquid','none',0,5587,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4068,'Avadon Leather Armor Lining','PIECES','false','material',60,'stackable','liquid','none',0,11042,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4069,'Tunic of Zubei Fabric','PIECES','false','material',60,'stackable','liquid','none',0,8483,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4070,'Stockings of Zubei Fabric','PIECES','false','material',60,'stackable','liquid','none',0,5587,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4071,'Avadon Robe Fabric','PIECES','false','material',60,'stackable','liquid','none',0,11042,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4072,'Avadon Circlet Pattern','PIECES','false','material',60,'stackable','liquid','none',0,4453,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(4073,'Avadon Gloves Part','PIECES','false','material',60,'stackable','liquid','none',0,3843,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(4074,'Chain Gloves of Silence Design','PIECES','false','material',60,'stackable','liquid','none',0,3843,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(4075,'Guardian''s Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,3843,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(4076,'Gloves of Blessing Pattern','PIECES','false','material',60,'stackable','liquid','none',0,3843,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(4077,'Doom Shield Fragment','PIECES','false','material',60,'stackable','liquid','none',0,4446,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(4078,'Blue Wolf Breastplate Part','PIECES','false','material',60,'stackable','liquid','none',0,13692,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(4079,'Boots of Blessing Design','PIECES','false','material',60,'stackable','liquid','none',0,3843,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(4080,'Blue Wolf Gaiters Material','PIECES','false','material',60,'stackable','liquid','none',0,9723,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4081,'Doom Plate Armor Temper','PIECES','false','material',60,'stackable','liquid','none',0,20292,0,'true',0,1,'etc_lump_white_i00',1,1,1),
(4082,'Blue Wolf Leather Armor Texture','PIECES','false','material',60,'stackable','liquid','none',0,17700,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4083,'Leather Armor of Doom Design','PIECES','false','material',60,'stackable','liquid','none',0,17700,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(4084,'Blue Wolf Tunic Fabric','PIECES','false','material',60,'stackable','liquid','none',0,11508,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4085,'Tunic of Doom Pattern','PIECES','false','material',60,'stackable','liquid','none',0,11508,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(4086,'Blue Wolf Stockings Pattern','PIECES','false','material',60,'stackable','liquid','none',0,8523,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(4087,'Stockings of Doom Pattern','PIECES','false','material',60,'stackable','liquid','none',0,8523,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(4088,'Blue Wolf Helmet Design','PIECES','false','material',60,'stackable','liquid','none',0,5292,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(4089,'Doom Helmet Pattern','PIECES','false','material',60,'stackable','liquid','none',0,5292,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(4090,'Blue Wolf Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(4091,'Doom Gloves Part','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(4092,'Elemental Gloves Lining','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4093,'Gloves of Grace Lining','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4094,'Implosion Gauntlet Fabric','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4095,'Paradia Gloves Pattern','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(4096,'Blue Wolf Gloves Fabric','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(4097,'Zubei''s Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,3843,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(4098,'Avadon Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,3843,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(4099,'Doom Boots Part','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(4100,'Zubei''s Gauntlets Part','PIECES','false','material',60,'stackable','liquid','none',0,3843,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(4101,'Zubei''s Shield Fragment','PIECES','false','material',60,'stackable','liquid','none',0,3450,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(4102,'Zubei''s Helmet Design','PIECES','false','material',60,'stackable','liquid','none',0,4453,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(4103,'Pata Blade','PIECES','false','material',60,'stackable','liquid','none',0,32950,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(4104,'Great Sword Blade','PIECES','false','material',60,'stackable','liquid','none',0,34950,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(4105,'Heavy War Axe Head','PIECES','false','material',60,'stackable','liquid','none',0,34950,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(4106,'Sprite''s Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,35533,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(4107,'Keshanberk Blade','PIECES','false','material',60,'stackable','liquid','none',0,35500,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(4108,'Sword of Valhalla Blade','PIECES','false','material',60,'stackable','liquid','none',0,35500,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(4109,'Kris Edge','PIECES','false','material',60,'stackable','liquid','none',0,35500,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(4110,'Hell Knife Edge','PIECES','false','material',60,'stackable','liquid','none',0,35500,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(4111,'Arthro Nail Blade','PIECES','false','material',60,'stackable','liquid','none',0,34950,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(4112,'Dark Elven Longbow Shaft','PIECES','false','material',60,'stackable','liquid','none',0,35325,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(4113,'Great Axe Head','PIECES','false','material',60,'stackable','liquid','none',0,38867,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(4114,'Sword of Damascus Blade','PIECES','false','material',60,'stackable','liquid','none',0,45692,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(4115,'Lance Blade','PIECES','false','material',60,'stackable','liquid','none',0,45846,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(4116,'Deadman''s Glory Stone','PIECES','false','material',60,'stackable','liquid','none',0,45769,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(4117,'Art of Battle Axe Blade','PIECES','false','material',60,'stackable','liquid','none',0,45769,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(4118,'Evil Spirit Head','PIECES','false','material',60,'stackable','liquid','none',0,48308,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(4119,'Demon Dagger Edge','PIECES','false','material',60,'stackable','liquid','none',0,45692,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(4120,'Bellion Cestus Edge','PIECES','false','material',60,'stackable','liquid','none',0,45769,0,'true',0,1,'etc_sword_body_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(4121,'Bow of Peril Shaft','PIECES','false','material',60,'stackable','liquid','none',0,45923,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(4122,'Recipe: Maestro Holder','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4500,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(4123,'Recipe: Maestro Anvil Lock','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4500,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(4124,'Recipe: Craftsman Mold','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4500,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(4125,'Recipe: Maestro Mold','RECIPIES','false','recipe',30,'stackable','liquid','none',0,4500,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(4126,'Recipe: Adamantite Earrings','RECIPIES','false','recipe',30,'stackable','liquid','none',0,12120,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4127,'Recipe: Adamantite Ring','RECIPIES','false','recipe',30,'stackable','liquid','none',0,8080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4128,'Recipe: Adamantite Necklace','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16160,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4129,'Recipe: Earrings of Black Ore','RECIPIES','false','recipe',30,'stackable','liquid','none',0,18480,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4130,'Recipe: Ring of Black Ore','RECIPIES','false','recipe',30,'stackable','liquid','none',0,12320,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4131,'Recipe: Necklace of Black Ore','RECIPIES','false','recipe',30,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4132,'Recipe: Composite Shield','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5160,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(4133,'Recipe: Zubei''s Breastplate','RECIPIES','false','recipe',30,'stackable','liquid','none',0,41600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4134,'Recipe: Zubei''s Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,26000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4135,'Recipe: Implosion Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4136,'Recipe: Boots of Silence','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4137,'Recipe: Guardian''s Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4138,'Recipe: Paradia Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4139,'Recipe: Elemental Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4140,'Recipe: Boots of Grace','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4141,'Recipe: Avadon Breastplate','RECIPIES','false','recipe',30,'stackable','liquid','none',0,41600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4142,'Recipe: Avadon Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,26000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4143,'Recipe: Zubei''s Leather Shirt','RECIPIES','false','recipe',30,'stackable','liquid','none',0,31200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4144,'Recipe: Zubei''s Leather Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,19460,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4145,'Recipe: Avadon Leather Armor','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4146,'Recipe: Tunic of Zubei','RECIPIES','false','recipe',30,'stackable','liquid','none',0,31200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4147,'Recipe: Stockings of Zubei','RECIPIES','false','recipe',30,'stackable','liquid','none',0,19460,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4148,'Recipe: Avadon Robe','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4149,'Recipe: Avadon Circlet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,15560,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4150,'Recipe: Avadon Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4151,'Recipe: Chain Gloves of Silence','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4152,'Recipe: Guardian''s Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4153,'Recipe: Gloves of Blessing','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4154,'Recipe: Doom Shield','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16900,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4155,'Recipe: Blue Wolf Breastplate','RECIPIES','false','recipe',30,'stackable','liquid','none',0,64400,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4156,'Recipe: Boots of Blessing','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4157,'Recipe: Blue Wolf Gaiters','RECIPIES','false','recipe',30,'stackable','liquid','none',0,40200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4158,'Recipe: Doom Plate Armor','RECIPIES','false','recipe',30,'stackable','liquid','none',0,94200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4159,'Recipe: Blue Wolf Leather Armor','RECIPIES','false','recipe',30,'stackable','liquid','none',0,70600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4160,'Recipe: Leather Armor of Doom','RECIPIES','false','recipe',30,'stackable','liquid','none',0,70600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4161,'Recipe: Blue Wolf Tunic','RECIPIES','false','recipe',30,'stackable','liquid','none',0,48200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4162,'Recipe: Tunic of Doom','RECIPIES','false','recipe',30,'stackable','liquid','none',0,48200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4163,'Recipe: Blue Wolf Stockings','RECIPIES','false','recipe',30,'stackable','liquid','none',0,30200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4164,'Recipe: Stockings of Doom','RECIPIES','false','recipe',30,'stackable','liquid','none',0,30200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4165,'Recipe: Blue Wolf Helmet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,24200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4166,'Recipe: Doom Helmet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,24200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4167,'Recipe: Blue Wolf Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4168,'Recipe: Doom Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4169,'Recipe: Elemental Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4170,'Recipe: Gloves of Grace','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4171,'Recipe: Implosion Gauntlets','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4172,'Recipe: Paradia Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4173,'Recipe: Blue Wolf Gloves','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4174,'Recipe: Zubei''s Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4175,'Recipe: Avadon Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4176,'Recipe: Doom Boots','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4177,'Recipe: Zubei''s Gauntlets','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4178,'Recipe: Zubei''s Shield (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10900,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4179,'Recipe: Zubei''s Helmet','RECIPIES','false','recipe',30,'stackable','liquid','none',0,15560,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4180,'Recipe: Silver Arrow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,1800,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4181,'Recipe: Pata','RECIPIES','false','recipe',30,'stackable','liquid','none',0,156600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(4182,'Recipe: Great Sword','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4183,'Recipe: Heavy War Axe','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4184,'Recipe: Sprite''s Staff','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4185,'Recipe: Keshanberk','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4186,'Recipe: Sword of Valhalla','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4187,'Recipe: Kris','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4188,'Recipe: Hell Knife','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4189,'Recipe: Arthro Nail','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4190,'Recipe: Dark Elven Long Bow','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4191,'Recipe: Great Axe','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4192,'Recipe: Sword of Damascus','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4193,'Recipe: Lance','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4194,'Recipe: Deadman''s Glory','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4195,'Recipe: Art of Battle Axe','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4196,'Recipe: Staff of Evil Spirits','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4197,'Recipe: Demon Dagger','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4198,'Recipe: Bellion Cestus','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4199,'Recipe: Bow of Peril','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4200,'Spellbook: Restore Life','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_defighter_i00',1,1,1),
(4201,'Spellbook: Resist Shock','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(4203,'Spellbook: Life Leech','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_defighter_i00',1,1,1),
(4204,'Amulet: Pa''agrio''s Tact','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(4205,'Amulet: Pa''agrio''s Rage','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(4206,'Spellbook: Transfer Pain','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(4207,'Spellbook: Mana Regeneration','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(4208,'Spellbook: Curse Gloom','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(4209,'Change of Heart - Piece 1','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_heart_i01',1,1,1),
(4210,'Change of Heart - Piece 2','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_heart_i02',1,1,1),
(4211,'Change of Heart - Piece 3','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_heart_i03',1,1,1),
(4212,'Change of Heart - Piece 4','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_heart_i04',1,1,1),
(4213,'Change of Heart - Piece 5','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_heart_i05',1,1,1),
(4214,'Change of Heart - Piece 6','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_heart_i06',1,1,1),
(4215,'Change of Heart - Piece 7','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_heart_i07',1,1,1),
(4216,'Change of Heart - Piece 8','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_heart_i08',1,1,1),
(4217,'Change of Heart - Piece 9','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_heart_i09',1,1,1),
(4218,'L2 Day - Scroll of Mana Regeneration','OTHER','false','scroll',120,'stackable','paper','none',0,0,0,'false',2064,1,'etc_scroll_white_i00',1,1,1),
(4232,'Dice','OTHER','false','quest',0,'normal','steel','none',0,0,0,'false',0,1,'etc_dice_a_i00',1,1,1),
(4239,'Blade Mold','OTHER','false','quest',0,'stackable','liquid','none',100,0,0,'false',0,1,'etc_artisans_frame_i00',1,1,1),
(4240,'Tyra''s Bill','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(4241,'Ranger''s Report - Part 1','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_report_i00',1,1,1),
(4242,'Ranger''s Report - Part 2','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_report_i00',1,1,1),
(4243,'Ranger''s Report - Part 3','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_report_i00',1,1,1),
(4244,'Ranger''s Report - Part 4','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_report_i00',1,1,1),
(4245,'Weapons Trade Contract','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_paper_red_i00',1,1,1),
(4246,'Attack Directives','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_roll_of_paper_red_i00',1,1,1),
(4247,'Certificate of the Silver Scale Guild','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_crest_yellow_i00',1,1,1),
(4248,'Rolento''s Cargobox','OTHER','false','quest',0,'stackable','wood','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(4249,'Ol Mahum Captain''s Head','OTHER','false','quest',0,'stackable','leather','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(4250,'Jade Crystal','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_gem_green_i00',1,1,1),
(4251,'Ancient Statue of Goddess','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_statue_of_einhasad_gold_i00',1,1,1),
(4252,'GalfRedo Romer''s Bust','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_holy_statue_silver_i00',1,1,1),
(4253,'Eye of the Shadow','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(4254,'Certificate of Participation: Battle Royal','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_paper_white_i00',1,1,1),
(4255,'Trade Cargo','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(4256,'Agnes''s Holy Symbol','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_statue_of_einhasad_bronze_i00',1,1,1),
(4257,'Agnes''s Rosary','OTHER','false','quest',0,'stackable','wood','none',100,0,0,'false',0,1,'etc_evil_necklace_i00',1,1,1),
(4258,'Sinister Totem','OTHER','false','quest',0,'stackable','wood','none',100,0,0,'false',0,1,'etc_totem_black_i00',1,1,1),
(4259,'Bear Skin','OTHER','false','quest',0,'stackable','leather','none',100,0,0,'false',0,1,'etc_leather_brown_i00',1,1,1),
(4260,'Enku Orc''s Head','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(4261,'Orc Heads Bouquet -1','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_flower_bouquet_i00',1,1,1),
(4262,'Orc Heads Bouquet -2','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_flower_bouquet_i00',1,1,1),
(4263,'Orc Heads Bouquet -3','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_flower_bouquet_i00',1,1,1),
(4264,'Orc Heads Bouquet -4','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_flower_bouquet_i00',1,1,1),
(4265,'Orc Heads Bouquet -5','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_flower_bouquet_i00',1,1,1),
(4266,'Orc Heads Bouquet -6','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_flower_bouquet_i00',1,1,1),
(4267,'Orc Heads Bouquet -7','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_flower_bouquet_i00',1,1,1),
(4268,'Jennifer''s Box','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(4269,'Articles of Dead Heroes','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_squares_gray_i00',1,1,1),
(4270,'Old Key','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_old_key_i03',1,1,1),
(4271,'Old Hilt','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_hilt_i00',1,1,1),
(4272,'Totem Necklace','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_totem_necklace_black_i00',1,1,1),
(4273,'Einhasad Crucifix','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_magic_coin_silver_i01',1,1,1),
(4274,'Victim''s Arm Bone','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_piece_bone_black_i00',1,1,1),
(4275,'Victim''s Thigh Bone','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_piece_bone_white_i00',1,1,1),
(4276,'Victim''s Skull','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(4277,'Victim''s Rib Bone','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_rib_white_i00',1,1,1),
(4278,'Victim''s Spine','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_piece_bone_red_i00',1,1,1),
(4279,'Jar of Bones','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(4280,'Useless Bone Pieces','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_mithril_ore_i00',1,1,1),
(4281,'Powder to Summon Dead Souls','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_powder_black_i00',1,1,1),
(4282,'Sack of the Dead','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(4283,'Frog Prince','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_q_frog_green_i00',1,1,1),
(4284,'Fly Powder','OTHER','false','quest',0,'stackable','liquid','none',100,0,0,'false',0,1,'etc_powder_gray_i00',1,1,1),
(4285,'Calculator','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_calculator_i00',1,1,1),
(4286,'Gemstone Beast''s Crystal','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_crystal_ball_silver_i00',1,1,1),
(4287,'Titan''s Powerstone','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_instrument_i00',1,1,1),
(4288,'Hanellin''s 1st Letter','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(4289,'Hanellin''s 2nd Letter','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(4290,'Hanellin''s 3rd Letter','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(4291,'1st Key of Ark','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_old_key_i01',1,1,1),
(4292,'2nd Key of Ark','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_old_key_i00',1,1,1),
(4293,'3rd Key of Ark','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_old_key_i03',1,1,1),
(4294,'White Fabric','OTHER','false','quest',0,'stackable','cloth','none',100,0,0,'false',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(4295,'Blooded Fabric','OTHER','false','quest',0,'stackable','cloth','none',100,0,0,'false',0,1,'etc_piece_of_cloth_red_i00',1,1,1),
(4296,'Order of Gosta','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_paper_white_i00',1,1,1),
(4297,'Lizard Fang','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_molar_white_i00',1,1,1),
(4298,'Barrel of League','OTHER','false','quest',0,'stackable','wood','none',100,0,0,'false',0,1,'etc_wine_barrel_i00',1,1,1),
(4299,'Operation Document - 1/10','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(4300,'Operation Document - 2/10','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(4301,'Operation Document - 3/10','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(4302,'Operation Document - 4/10','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(4303,'Operation Document - 5/10','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(4304,'Operation Document - 6/10','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(4305,'Operation Document - 7/10','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(4306,'Operation Document - 8/10','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(4307,'Operation Document - 9/10','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(4308,'Operation Document - 10/10','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(4309,'Completed Operation Order','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(4310,'Bill of Iason Heine','OTHER','false','material',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_paper_black_i00',1,1,1),
(4311,'Gillian''s Diary','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(4312,'Gillian''s Notes','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(4313,'Unfinished Music','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_musical_note_i01',1,1,1),
(4314,'Gillian''s Heart','OTHER','false','quest',0,'stackable','leather','none',100,0,0,'false',0,1,'etc_bodypart_heart_i00',1,1,1),
(4315,'Gandi Tribe''s Relic','OTHER','false','quest',0,'stackable','wood','none',100,0,0,'false',0,1,'etc_royal_seal_of_lord_i00',1,1,1),
(4316,'Swan''s Flute','OTHER','false','quest',0,'stackable','wood','none',100,0,0,'false',0,1,'etc_dragon_flute_i00',1,1,1),
(4317,'Swan''s Letter','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(4318,'Event Clothes','OTHER','false','quest',0,'stackable','cloth','none',100,0,0,'false',0,1,'etc_ladys_dress_i00',1,1,1),
(4319,'Nanarin''s Flute','OTHER','false','quest',0,'stackable','wood','none',100,0,0,'false',0,1,'etc_dragon_flute_i00',1,1,1),
(4320,'Sabrin''s Black Beer','OTHER','false','quest',0,'stackable','liquid','none',100,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(4321,'Stolen Black Beer','OTHER','false','quest',0,'stackable','liquid','none',100,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(4322,'Stolen Event Clothes','OTHER','false','quest',0,'stackable','cloth','none',100,0,0,'false',0,1,'etc_ladys_dress_i00',1,1,1),
(4323,'Clothes Chest Key','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_old_key_i01',1,1,1),
(4324,'Beer Chest Key','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_old_key_i02',1,1,1),
(4325,'Fairy Leaf','OTHER','false','quest',0,'stackable','wood','none',100,0,0,'false',0,1,'etc_leaf_green_i00',1,1,1),
(4326,'Ratman Scavenger''s Skull','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_pet_arms_i04',1,1,1),
(4327,'Turek War Hound''s Tail','OTHER','false','quest',0,'stackable','bone','none',100,0,0,'false',0,1,'etc_mane_i00',1,1,1),
(4328,'Tyrant Kingpin''s Heart','OTHER','false','quest',0,'stackable','leather','none',100,0,0,'false',0,1,'etc_heart_i00',1,1,1),
(4329,'Trisalim Tarantula''s Venom Sac','OTHER','false','quest',0,'stackable','cloth','none',100,0,0,'false',0,1,'etc_poison_pouch_i00',1,1,1),
(4330,'Penitent''s Manacles','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_leash_i00',0,1,0),
(4331,'Manual of Manacles','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_recipe_red_i00',0,1,0),
(4332,'Tarlk Amulet','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_orcish_talisman_i00',1,1,1),
(4333,'Contest Certificate','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_paper_black_i00',1,1,1),
(4334,'Ant''s Ichor','OTHER','false','quest',0,'stackable','liquid','none',100,0,0,'false',0,1,'etc_reagent_red_i00',1,1,1),
(4335,'Noble Ant''s Nerve Tissue','OTHER','false','quest',0,'stackable','liquid','none',100,0,0,'false',0,1,'etc_bodypart_brain_i00',1,1,1),
(4336,'Casian''s Enzyme','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_spell_shot_silver_i00',1,1,1),
(4337,'Alligator Leather','OTHER','false','quest',0,'stackable','leather','none',100,0,0,'false',0,1,'etc_scale_of_medusa_green_i00',1,1,1),
(4338,'Blue Back Alligator Leather','OTHER','false','quest',0,'stackable','leather','none',100,0,0,'false',0,1,'etc_scale_of_medusa_blue_i00',1,1,1),
(4339,'Jewel Studded Alligator Leather','OTHER','false','quest',0,'stackable','leather','none',100,0,0,'false',0,1,'etc_scale_of_medusa_red_i00',1,1,1),
(4340,'Certificate of Approval to Create a Belt','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4341,'Certificate of Approval to Create a Purse','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(4342,'Water Crystal','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_gem_blue_i00',1,1,1),
(4343,'Fire Crystal','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_gem_red_i00',1,1,1),
(4344,'Wind Crystal','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_gem_green_i00',1,1,1),
(4345,'Earth Crystal','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_gem_yellow_i00',1,1,1),
(4346,'Dark Crystal','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_gem_clear_i00',1,1,1),
(4347,'Crystal of Light','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_gem_black_i00',1,1,1),
(4348,'Jade Crystal','OTHER','false','quest',1,'stackable','crystal','none',0,50,0,'false',0,1,'etc_gem_green_i00',1,1,1),
(4349,'Bust of Ancient Goddess','OTHER','false','quest',5,'stackable','wood','none',0,50,0,'false',0,1,'etc_holy_statue_silver_i00',1,1,1),
(4350,'The Work of the ancient sculptor Berona','OTHER','false','quest',5,'stackable','wood','none',0,1700,0,'false',0,1,'etc_statue_of_einhasad_gold_i00',1,1,1),
(4351,'Ancient Statue of Goddess - Prototype','OTHER','false','quest',5,'stackable','wood','none',0,17000,0,'true',0,1,'etc_statue_of_einhasad_gold_i00',1,1,1),
(4352,'Ancient Statue of Goddess - Original','OTHER','false','quest',5,'stackable','wood','none',0,3400,0,'true',0,1,'etc_statue_of_einhasad_gold_i00',1,1,1),
(4353,'Ancient Statue of Goddess - Replica','OTHER','false','quest',5,'stackable','wood','none',0,850,0,'true',0,1,'etc_statue_of_einhasad_gold_i00',1,1,1),
(4354,'Ancient Statue of Goddess - Forgery','OTHER','false','quest',5,'stackable','wood','none',0,560,0,'true',0,1,'etc_statue_of_einhasad_gold_i00',1,1,1),
(4355,'Blue Eva','OTHER','false','quest',0,'stackable','steel','none',0,100,0,'false',0,1,'etc_magic_coin_blue_i01',1,1,1),
(4356,'Gold Einhasad','OTHER','false','quest',0,'stackable','steel','none',0,100,0,'false',0,1,'etc_magic_coin_gold_i02',1,1,1),
(4357,'Silver Shilen','OTHER','false','quest',0,'stackable','steel','none',0,100,0,'false',0,1,'etc_magic_coin_silver_i02',1,1,1),
(4358,'Bloody Pa''agrio','OTHER','false','quest',0,'stackable','steel','none',0,100,0,'false',0,1,'etc_magic_coin_blood_i02',1,1,1),
(4359,'Barrel of Liquor','OTHER','false','none',2000,'normal','wood','none',0,4000,0,'false',0,1,'etc_wine_barrel_i00',1,1,1),
(4360,'Precious Scarab','OTHER','false','quest',0,'normal','crystal','none',0,15000,0,'false',0,1,'etc_beetle_i00',1,1,1),
(4361,'Simbelmyne','OTHER','false','quest',0,'normal','wood','none',0,2000,0,'false',0,1,'etc_flower_i00',1,1,1),
(4362,'Odd (looking) Doll','OTHER','false','none',500,'normal','steel','none',0,8000,0,'false',0,1,'etc_totem_black_i00',1,1,1),
(4363,'Scarlet Dress','OTHER','false','none',20,'normal','cloth','none',0,30000,0,'false',0,1,'etc_ladys_dress_i00',1,1,1),
(4364,'Nebulite Orb','OTHER','false','quest',2,'stackable','crystal','none',0,10,0,'false',0,1,'etc_crystal_ball_red_i00',1,1,1),
(4365,'Ectoplasm Liqueur','OTHER','false','quest',10,'normal','crystal','none',0,200,0,'false',0,1,'etc_dragon_blood_i00',1,1,1),
(4366,'Prince''s Trophy','OTHER','false','quest',20,'stackable','steel','none',0,100,0,'false',0,1,'etc_trophy_i00',1,1,1),
(4367,'Prince''s Autobiography','OTHER','false','quest',10,'stackable','paper','none',0,100,0,'false',0,1,'etc_spellbook_red_i00',1,1,1),
(4368,'Prince''s Bust','OTHER','false','quest',20,'stackable','steel','none',0,100,0,'false',0,1,'etc_holy_statue_gold_i00',1,1,1),
(4369,'Silk Handkerchief','OTHER','false','quest',5,'stackable','cloth','none',0,100,0,'false',0,1,'etc_kerchief_i00',1,1,1),
(4370,'Luxurious Goblet','OTHER','false','quest',10,'stackable','steel','none',0,100,0,'false',0,1,'etc_holy_grail_i01',1,1,1),
(4371,'Scepter of Darkness','OTHER','false','quest',10,'stackable','steel','none',0,100,0,'false',0,1,'etc_imperial_scepter_i02',1,1,1),
(4372,'Succubus Perfume','OTHER','false','quest',5,'stackable','liquid','none',0,100,0,'false',0,1,'etc_dragons_blood_i02',1,1,1),
(4373,'Succubus Mirror','OTHER','false','quest',10,'stackable','liquid','none',0,100,0,'false',0,1,'etc_mirror_i00',1,1,1),
(4374,'Heart of Darkness','OTHER','false','quest',30,'stackable','wood','none',0,100,0,'false',0,1,'etc_heart_i00',1,1,1),
(4375,'Royal Orc Totem','OTHER','false','quest',30,'stackable','wood','none',0,100,0,'false',0,1,'etc_totem_red_i00',1,1,1),
(4376,'Pearl Trodden/Trampled By A Wild Hog','OTHER','false','quest',5,'stackable','crystal','none',0,100,0,'false',0,1,'etc_crystal_ball_silver_i00',1,1,1),
(4377,'Boar''s Tusk','OTHER','false','quest',10,'stackable','bone','none',0,100,0,'false',0,1,'etc_horn_i00',1,1,1),
(4378,'Sweet Potato','OTHER','false','quest',5,'stackable','bone','none',0,100,0,'false',0,1,'etc_seed_yellow_i00',1,1,1),
(4379,'Beast''s Claws','OTHER','false','quest',5,'stackable','bone','none',0,100,0,'false',0,1,'etc_fang_ivory_i00',1,1,1),
(4380,'Beast''s Mane','OTHER','false','quest',10,'stackable','leather','none',0,100,0,'false',0,1,'etc_metallic_fiber_i00',1,1,1),
(4381,'Ginseng Root','OTHER','false','quest',5,'stackable','wood','none',0,100,0,'false',0,1,'etc_ginseng_red_i00',1,1,1),
(4382,'Honey Jar','OTHER','false','quest',10,'stackable','steel','none',0,100,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(4383,'Bear''s Gall','OTHER','false','quest',5,'stackable','liquid','none',0,100,0,'false',0,1,'etc_bodypart_liver_i00',1,1,1),
(4384,'Fresh Samon','OTHER','false','quest',5,'stackable','bone','none',0,100,0,'false',0,1,'etc_fish_seawater_i01',1,1,1),
(4385,'Sushi Riceball','OTHER','false','quest',5,'stackable','liquid','none',0,100,0,'false',0,1,'etc_meat_i00',1,1,1),
(4386,'Avellan Spice','OTHER','false','quest',5,'stackable','liquid','none',0,100,0,'false',0,1,'etc_powder_red_i00',1,1,1),
(4387,'Lucky Rabbit Weed','OTHER','false','quest',5,'stackable','wood','none',0,100,0,'false',0,1,'etc_herb_green_i00',1,1,1),
(4388,'Malcom''s Check','OTHER','false','quest',10,'stackable','paper','none',0,100,0,'false',0,1,'etc_paper_blue_i00',1,1,1),
(4389,'Deposit Box Key','OTHER','false','quest',10,'stackable','steel','none',0,100,0,'false',0,1,'etc_old_key_i03',1,1,1),
(4390,'Dwarven Royal Seal','OTHER','false','quest',20,'stackable','steel','none',0,100,0,'false',0,1,'etc_royal_seal_of_lord_i04',1,1,1),
(4391,'Dwarven Royal Crown','OTHER','false','quest',20,'stackable','steel','none',0,100,0,'false',0,1,'etc_ancient_crown_i02',1,1,1),
(4392,'Dwarven Dance Manual','OTHER','false','quest',20,'stackable','paper','none',0,100,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(4393,'Calculator','OTHER','false','none',20,'normal','steel','none',0,100,0,'false',0,1,'etc_calculator_i00',1,1,1),
(4394,'Hanellin''s White Flower','OTHER','false','quest',0,'normal','wood','none',0,0,0,'false',0,1,'etc_flower_i00',1,1,1),
(4395,'Hanellin''s Red Flower','OTHER','false','quest',0,'normal','wood','none',0,0,0,'false',0,1,'etc_flower_i01',1,1,1),
(4396,'Hanellin''s Yellow Flower','OTHER','false','quest',0,'normal','wood','none',0,0,0,'false',0,1,'etc_flower_i02',1,1,1),
(4397,'Book of Saint','OTHER','false','none',20,'normal','paper','none',0,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(4398,'Blood of Saint','OTHER','false','none',20,'normal','liquid','none',0,0,0,'false',0,1,'etc_dragons_blood_i00',1,1,1),
(4399,'Bough of Saint','OTHER','false','none',20,'normal','wood','none',0,0,0,'false',0,1,'etc_branch_gold_i00',1,1,1),
(4400,'White Fabric','OTHER','false','quest',0,'stackable','cloth','none',0,0,0,'false',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(4401,'Green Dimensional Stone','OTHER','false','none',10,'stackable','crystal','none',0,100000,0,'false',0,1,'etc_gem_green_i00',1,1,1),
(4402,'Blue Dimensional Stone','OTHER','false','none',10,'stackable','crystal','none',0,100000,0,'true',0,1,'etc_gem_blue_i00',1,1,1),
(4403,'Red Dimensional Stone','OTHER','false','none',10,'stackable','crystal','none',0,100000,0,'true',0,1,'etc_gem_red_i00',1,1,1),
(4404,'Green Dimensional Stone - Shard','OTHER','false','none',10,'stackable','crystal','none',0,10,0,'false',0,1,'etc_broken_crystal_green_i00',1,1,1),
(4405,'Blue Dimensional Stone - Shard','OTHER','false','none',10,'stackable','crystal','none',0,10,0,'false',0,1,'etc_broken_crystal_blue_i00',1,1,1),
(4406,'Red Dimensional Stone - Shard','OTHER','false','none',10,'stackable','crystal','none',0,10,0,'false',0,1,'etc_broken_crystal_red_i00',1,1,1),
(4407,'Bill of Iason Heine','OTHER','false','quest',0,'stackable','paper','none',0,10,0,'false',0,1,'etc_paper_black_i00',1,1,1),
(4408,'Musical Score - Theme of Love','OTHER','false','none',20,'stackable','paper','none',0,500,0,'false',0,1,'etc_musical_note_i01',1,1,1),
(4409,'Musical Score - Theme of Battle','OTHER','false','none',20,'stackable','paper','none',0,500,0,'false',0,1,'etc_musical_note_i01',1,1,1),
(4410,'Musical Score - Theme of Journey','OTHER','false','none',20,'stackable','paper','none',0,500,0,'false',0,1,'etc_musical_note_i01',1,1,1),
(4411,'Echo Crystal - Theme of Journey','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i00',1,1,1),
(4412,'Echo Crystal - Theme of Battle','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i01',1,1,1),
(4413,'Echo Crystal - Theme of Love','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i02',1,1,1),
(4414,'Echo Crystal - Theme of Solitude','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i03',1,1,1),
(4415,'Echo Crystal - Theme of the Feast','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i04',1,1,1),
(4416,'Echo Crystal - Theme of Celebration','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i00',1,1,1),
(4417,'Echo Crystal - Theme of Comedy','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i01',1,1,1),
(4418,'Musical Score - Theme of Celebration','OTHER','false','none',20,'stackable','paper','none',0,500,0,'false',0,1,'etc_musical_note_i01',1,1,1),
(4419,'Musical Score - Theme of Comedy','OTHER','false','none',20,'stackable','paper','none',0,500,0,'false',0,1,'etc_musical_note_i01',1,1,1),
(4420,'Musical Score - Theme of Solitude','OTHER','false','none',20,'stackable','paper','none',0,500,0,'false',0,1,'etc_musical_note_i01',1,1,1),
(4421,'Musical Score - Theme of the Feast','OTHER','false','none',20,'stackable','paper','none',0,500,0,'false',0,1,'etc_musical_note_i02',1,1,1),
(4422,'Dragon Bugle of Wind','OTHER','false','pet_collar',20,'normal','steel','none',0,2000,0,'false',0,1,'etc_bugle_i00',1,1,1),
(4423,'Dragon Bugle of Star','OTHER','false','pet_collar',20,'normal','steel','none',0,2000,0,'false',0,1,'etc_bugle_i00',1,1,1),
(4424,'Dragon Bugle of Dusk','OTHER','false','pet_collar',20,'normal','steel','none',0,2000,0,'false',0,1,'etc_bugle_i00',1,1,1),
(4425,'Penitent''s Manacles','OTHER','false','pet_collar',800,'normal','steel','none',0,0,0,'false',0,1,'etc_leash_i00',1,1,1),
(4426,'Manacles of Penitent','OTHER','false','none',50,'normal','steel','none',0,22000,0,'false',0,1,'etc_leash_i00',1,1,1),
(4427,'Alligator Leather Belt','OTHER','false','none',20,'normal','leather','none',0,100,0,'false',0,1,'etc_prefect_belt_i00',1,1,1),
(4428,'Blue Alligator Leather Belt','OTHER','false','none',20,'normal','leather','none',0,2000,0,'false',0,1,'etc_prefect_belt_i00',1,1,1),
(4429,'Bejeweled Leather Belt','OTHER','false','none',20,'normal','leather','none',0,10000,0,'false',0,1,'etc_prefect_belt_i00',1,1,1),
(4430,'Alligator Leather Purse','OTHER','false','none',20,'normal','leather','none',0,200,0,'false',0,1,'etc_handbag_i00',1,1,1),
(4431,'Blue Alligator Leather Purse','OTHER','false','none',20,'normal','leather','none',0,4000,0,'false',0,1,'etc_handbag_i00',1,1,1),
(4432,'Bejeweled Purse','OTHER','false','none',20,'normal','leather','none',0,20000,0,'false',0,1,'etc_handbag_i00',1,1,1),
(4433,'Elemental Stone Powder','OTHER','false','none',10,'stackable','crystal','none',0,50,0,'true',0,1,'etc_powder_white_i00',1,1,1),
(4434,'Elemental Stone Shards','OTHER','false','none',100,'stackable','crystal','none',0,500,0,'true',0,1,'etc_broken_crystal_green_i00',1,1,1),
(4435,'Elemental Stone Lump','OTHER','false','none',1000,'stackable','crystal','none',0,5000,0,'true',0,1,'etc_crystal_green_i00',1,1,1),
(4436,'Bentley''s Request','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(4437,'Carson''s Request','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(4438,'Knuckle Duster Edge','PIECES','false','material',60,'stackable','liquid','none',0,28044,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(4439,'Avadon Shield Fragment','PIECES','false','material',60,'stackable','liquid','none',0,2900,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(4440,'Recipe: Knuckle Duster','RECIPIES','false','recipe',30,'stackable','liquid','none',0,57400,0,'false',0,1,'etc_recipe_yellow_i00',1,1,1),
(4441,'Recipe: Avadon Shield','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10900,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4442,'Lottery Ticket','OTHER','false','lotto',20,'normal','paper','none',0,2,0,'false',0,1,'etc_lottery_card_i00',1,1,1),
(4443,'Monster Race Ticket - Single','OTHER','false','race_ticket',20,'normal','paper','none',0,10,0,'false',0,1,'etc_ticket_i00',1,1,1),
(4444,'Monster Race Ticket - Double','OTHER','false','race_ticket',20,'normal','paper','none',0,10,0,'false',0,1,'etc_ticket_i00',1,1,1),
(4445,'Dye of STR <Str+1 Con-3>','MISC','false','dye',150,'stackable','liquid','none',0,5100,0,'false',0,1,'etc_str_hena_i00',1,1,1),
(4446,'Dye of STR <Str+1 Dex-3>','MISC','false','dye',150,'stackable','liquid','none',0,5100,0,'true',0,1,'etc_str_hena_i00',1,1,1),
(4447,'Dye of CON <Con+1 Str-3>','MISC','false','dye',150,'stackable','liquid','none',0,5100,0,'true',0,1,'etc_con_hena_i00',1,1,1),
(4448,'Dye of CON <Con+1 Dex-3>','MISC','false','dye',150,'stackable','liquid','none',0,5100,0,'true',0,1,'etc_con_hena_i00',1,1,1),
(4449,'Dye of DEX <Dex+1 Str-3>','MISC','false','dye',150,'stackable','liquid','none',0,5100,0,'true',0,1,'etc_dex_hena_i00',1,1,1),
(4450,'Dye of DEX <Dex+1 Con-3>','MISC','false','dye',150,'stackable','liquid','none',0,5100,0,'true',0,1,'etc_dex_hena_i00',1,1,1),
(4451,'Dye of INT <Int+1 Men-3>','MISC','false','dye',150,'stackable','liquid','none',0,5100,0,'true',0,1,'etc_int_hena_i00',1,1,1),
(4452,'Dye of INT <Int+1 Wit-3>','MISC','false','dye',150,'stackable','liquid','none',0,5100,0,'true',0,1,'etc_int_hena_i00',1,1,1),
(4453,'Dye of MEN <Men+1 Int-3>','MISC','false','dye',150,'stackable','liquid','none',0,5100,0,'true',0,1,'etc_men_hena_i00',1,1,1),
(4454,'Dye of MEN <Men+1 Wit-3>','MISC','false','dye',150,'stackable','liquid','none',0,5100,0,'true',0,1,'etc_men_hena_i00',1,1,1),
(4455,'Dye of WIT <Wit+1 Int-3>','MISC','false','dye',150,'stackable','liquid','none',0,5100,0,'true',0,1,'etc_wit_hena_i00',1,1,1),
(4456,'Dye of WIT <Wit+1 Men-3>','MISC','false','dye',150,'stackable','liquid','none',0,5100,0,'true',0,1,'etc_wit_hena_i00',1,1,1),
(4457,'Dye of STR <Str+1 Con-2>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_str_hena_i00',1,1,1),
(4458,'Dye of STR <Str+1 Dex-2>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_str_hena_i00',1,1,1),
(4459,'Dye of CON <Con+1 Str-2>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_con_hena_i00',1,1,1),
(4460,'Dye of CON <Con+1 Dex-2>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_con_hena_i00',1,1,1),
(4461,'Dye of DEX <Dex+1 Str-2>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_dex_hena_i00',1,1,1),
(4462,'Dye of DEX <Dex+1 Con-2>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_dex_hena_i00',1,1,1),
(4463,'Dye of INT <Int+1 Men-2>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_int_hena_i00',1,1,1),
(4464,'Dye of INT <Int+1 Wit-2>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_int_hena_i00',1,1,1),
(4465,'Dye of MEN <Men+1 Int-2>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_men_hena_i00',1,1,1),
(4466,'Dye of MEN <Men+1 Wit-2>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_men_hena_i00',1,1,1),
(4467,'Dye of WIT <Wit+1 Int-2>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_wit_hena_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(4468,'Dye of WIT <Wit+1 Men-2>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_wit_hena_i00',1,1,1),
(4469,'Dye of STR <Str+1 Con-1>','MISC','false','dye',150,'stackable','liquid','none',0,35000,0,'true',0,1,'etc_str_hena_i00',1,1,1),
(4470,'Dye of STR <Str+1 Dex-1>','MISC','false','dye',150,'stackable','liquid','none',0,35000,0,'true',0,1,'etc_str_hena_i00',1,1,1),
(4471,'Dye of CON <Con+1 Str-1>','MISC','false','dye',150,'stackable','liquid','none',0,35000,0,'true',0,1,'etc_con_hena_i00',1,1,1),
(4472,'Dye of CON <Con+1 Dex-1>','MISC','false','dye',150,'stackable','liquid','none',0,35000,0,'true',0,1,'etc_con_hena_i00',1,1,1),
(4473,'Dye of DEX <Dex+1 Str-1>','MISC','false','dye',150,'stackable','liquid','none',0,35000,0,'true',0,1,'etc_dex_hena_i00',1,1,1),
(4474,'Dye of DEX <Dex+1 Con-1>','MISC','false','dye',150,'stackable','liquid','none',0,35000,0,'true',0,1,'etc_dex_hena_i00',1,1,1),
(4475,'Dye of INT <Int+1 Men-1>','MISC','false','dye',150,'stackable','liquid','none',0,35000,0,'true',0,1,'etc_int_hena_i00',1,1,1),
(4476,'Dye of INT <Int+1 Wit-1>','MISC','false','dye',150,'stackable','liquid','none',0,35000,0,'true',0,1,'etc_int_hena_i00',1,1,1),
(4477,'Dye of MEN <Men+1 Int-1>','MISC','false','dye',150,'stackable','liquid','none',0,35000,0,'true',0,1,'etc_men_hena_i00',1,1,1),
(4478,'Dye of MEN <Men+1 Wit-1>','MISC','false','dye',150,'stackable','liquid','none',0,35000,0,'true',0,1,'etc_men_hena_i00',1,1,1),
(4479,'Dye of WIT <Wit+1 Int-1>','MISC','false','dye',150,'stackable','liquid','none',0,35000,0,'true',0,1,'etc_wit_hena_i00',1,1,1),
(4480,'Dye of WIT <Wit+1 Men-1>','MISC','false','dye',150,'stackable','liquid','none',0,35000,0,'true',0,1,'etc_wit_hena_i00',1,1,1),
(4481,'Greater Dye of STR <Str+1 Con-3>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4482,'Greater Dye of STR <Str+1 Dex-3>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4483,'Greater Dye of CON<Con+1 Str-3>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4484,'Greater Dye of CON<Con+1 Dex-3>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4485,'Greater Dye of DEX <Dex+1 Str-3>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4486,'Greater Dye of DEX <Dex+1 Con-3>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4487,'Greater Dye of INT <Int+1 Men-3>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4488,'Greater Dye of INT <Int+1 Wit-3>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4489,'Greater Dye of MEN <Men+1 Int-3>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4490,'Greater Dye of MEN <Men+1 Wit-3>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4491,'Greater Dye of WIT <Wit+1 Int-3>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4492,'Greater Dye of WIT <Wit+1 Men-3>','MISC','false','dye',150,'stackable','liquid','none',0,12000,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4493,'Greater Dye of STR <Str+1 Con-2>','MISC','false','dye',150,'stackable','liquid','none',0,21000,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4494,'Greater Dye of STR <Str+1 Dex-2>','MISC','false','dye',150,'stackable','liquid','none',0,21000,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4495,'Greater Dye of CON <Con+1 Str-2>','MISC','false','dye',150,'stackable','liquid','none',0,21000,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4496,'Greater Dye of CON <Con+1 Dex-2>','MISC','false','dye',150,'stackable','liquid','none',0,21000,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4497,'Greater Dye of DEX <Dex+1 Str-2>','MISC','false','dye',150,'stackable','liquid','none',0,21000,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4498,'Greater Dye of DEX <Dex+1 Con-2>','MISC','false','dye',150,'stackable','liquid','none',0,21000,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4499,'Greater Dye of INT <Int+1 Men-2>','MISC','false','dye',150,'stackable','liquid','none',0,21000,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4500,'Greater Dye of INT <Int+1 Wit-2>','MISC','false','dye',150,'stackable','liquid','none',0,21000,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4501,'Greater Dye of MEN <Men+1 Int-2>','MISC','false','dye',150,'stackable','liquid','none',0,21000,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4502,'Greater Dye of MEN <Men+1 Wit-2>','MISC','false','dye',150,'stackable','liquid','none',0,21000,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4503,'Greater Dye of WIT <Wit+1 Int-2>','MISC','false','dye',150,'stackable','liquid','none',0,21000,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4504,'Greater Dye of WIT <Wit+1 Men-2>','MISC','false','dye',150,'stackable','liquid','none',0,21000,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4505,'Greater Dye of STR <Str+2 Con-4>','MISC','false','dye',150,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4506,'Greater Dye of STR <Str+2 Dex-4>','MISC','false','dye',150,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4507,'Greater Dye of CON <Con+2 Str-4>','MISC','false','dye',150,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4508,'Greater Dye of CON <Con+2 Dex-4>','MISC','false','dye',150,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4509,'Greater Dye of DEX <Dex+2 Str-4>','MISC','false','dye',150,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4510,'Greater Dye of DEX <Dex+2 Con-4>','MISC','false','dye',150,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4511,'Greater Dye of INT <Int+2 Men-4>','MISC','false','dye',150,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4512,'Greater Dye of INT <Int+2 Wit-4>','MISC','false','dye',150,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4513,'Greater Dye of MEN <Men+2 Int-4>','MISC','false','dye',150,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4514,'Greater Dye of MEN <Men+2 Wit-4>','MISC','false','dye',150,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4515,'Greater Dye of WIT <Wit+2 Int-4>','MISC','false','dye',150,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4516,'Greater Dye of WIT <Wit+2 Men-4>','MISC','false','dye',150,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4517,'Greater Dye of STR <Str+2 Con-3>','MISC','false','dye',150,'stackable','liquid','none',0,27000,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4518,'Greater Dye of STR <Str+2 Dex-3>','MISC','false','dye',150,'stackable','liquid','none',0,27000,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4519,'Greater Dye of CON <Con+2 Str-3>','MISC','false','dye',150,'stackable','liquid','none',0,27000,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4520,'Greater Dye of CON <Con+2 Dex-3>','MISC','false','dye',150,'stackable','liquid','none',0,27000,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4521,'Greater Dye of DEX <Dex+2 Str-3>','MISC','false','dye',150,'stackable','liquid','none',0,27000,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4522,'Greater Dye of DEX <Dex+2 Con-3>','MISC','false','dye',150,'stackable','liquid','none',0,27000,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4523,'Greater Dye of INT <Int+2 Men-3>','MISC','false','dye',150,'stackable','liquid','none',0,27000,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4524,'Greater Dye of INT <Int+2 Wit-3>','MISC','false','dye',150,'stackable','liquid','none',0,27000,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4525,'Greater Dye of MEN <Men+2 Int-3>','MISC','false','dye',150,'stackable','liquid','none',0,27000,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4526,'Greater Dye of MEN <Men+2 Wit-3>','MISC','false','dye',150,'stackable','liquid','none',0,27000,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4527,'Greater Dye of WIT <Wit+2 Int-3>','MISC','false','dye',150,'stackable','liquid','none',0,27000,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4528,'Greater Dye of WIT <Wit+2 Men-3>','MISC','false','dye',150,'stackable','liquid','none',0,27000,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4529,'Greater Dye of STR <Str+3 Con-5>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4530,'Greater Dye of STR <Str+3 Dex-5>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4531,'Greater Dye of CON <Con+3 Str-5>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4532,'Greater Dye of CON <Con+3 Dex-5>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4533,'Greater Dye of DEX <Dex+3 Str-5>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4534,'Greater Dye of DEX <Dex+3 Con-5>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4535,'Greater Dye of INT <Int+3 Men-5>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4536,'Greater Dye of INT <Int+3 Wit-5>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4537,'Greater Dye of MEN <Men+3 Int-5>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4538,'Greater Dye of MEN <Men+3 Wit-5>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4539,'Greater Dye of WIT <Wit+3 Int-5>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4540,'Greater Dye of WIT <Wit+3 Men-5>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4541,'Greater Dye of STR <Str+3 Con-4>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4542,'Greater Dye of STR <Str+3 Dex-4>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4543,'Greater Dye of CON <Con+3 Str-4>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4544,'Greater Dye of CON <Con+3 Dex-4>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4545,'Greater Dye of DEX <Dex+3 Str-4>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4546,'Greater Dye of DEX <Dex+3 Con-4>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4547,'Greater Dye of INT <Int+3 Men-4>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4548,'Greater Dye of INT <Int+3 Wit-4>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4549,'Greater Dye of MEN <Men+3 Int-4>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4550,'Greater Dye of MEN <Men+3 Wit-4>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4551,'Greater Dye of WIT <Wit+3 Int-4>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4552,'Greater Dye of WIT <Wit+3 Men-4>','MISC','false','dye',150,'stackable','liquid','none',0,30000,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4553,'Greater Dye of STR <Str+1 Con-1>','MISC','false','dye',150,'stackable','liquid','none',0,50000,0,'true',0,1,'etc_str_hena_i02',1,1,1),
(4554,'Greater Dye of STR <Str+1 Dex-1>','MISC','false','dye',150,'stackable','liquid','none',0,50000,0,'true',0,1,'etc_str_hena_i02',1,1,1),
(4555,'Greater Dye of CON <Con+1 Str-1>','MISC','false','dye',150,'stackable','liquid','none',0,50000,0,'true',0,1,'etc_con_hena_i02',1,1,1),
(4556,'Greater Dye of CON <Con+1 Dex-1>','MISC','false','dye',150,'stackable','liquid','none',0,50000,0,'true',0,1,'etc_con_hena_i02',1,1,1),
(4557,'Greater Dye of DEX <Dex+1 Str-1>','MISC','false','dye',150,'stackable','liquid','none',0,50000,0,'true',0,1,'etc_dex_hena_i02',1,1,1),
(4558,'Greater Dye of DEX <Dex+1 Con-1>','MISC','false','dye',150,'stackable','liquid','none',0,50000,0,'true',0,1,'etc_dex_hena_i02',1,1,1),
(4559,'Greater Dye of INT <Int+1 Men-1>','MISC','false','dye',150,'stackable','liquid','none',0,50000,0,'true',0,1,'etc_int_hena_i02',1,1,1),
(4560,'Greater Dye of INT <Int+1 Wit-1>','MISC','false','dye',150,'stackable','liquid','none',0,50000,0,'true',0,1,'etc_int_hena_i02',1,1,1),
(4561,'Greater Dye of MEN <Men+1 Int-1>','MISC','false','dye',150,'stackable','liquid','none',0,50000,0,'true',0,1,'etc_men_hena_i02',1,1,1),
(4562,'Greater Dye of MEN <Men+1 Wit-1>','MISC','false','dye',150,'stackable','liquid','none',0,50000,0,'true',0,1,'etc_men_hena_i02',1,1,1),
(4563,'Greater Dye of WIT <Wit+1 Int-1>','MISC','false','dye',150,'stackable','liquid','none',0,50000,0,'true',0,1,'etc_wit_hena_i02',1,1,1),
(4564,'Greater Dye of WIT <Wit+1 Men-1>','MISC','false','dye',150,'stackable','liquid','none',0,50000,0,'true',0,1,'etc_wit_hena_i02',1,1,1),
(4565,'Greater Dye of STR <Str+4 Con-6>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4566,'Greater Dye of STR <Str+4 Dex-6>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4567,'Greater Dye of CON <Con+4 Str-6>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4568,'Greater Dye of CON <Con+4 Dex-6>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4569,'Greater Dye of DEX <Dex+4 Str-6>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4570,'Greater Dye of DEX <Dex+4 Con-6>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4571,'Greater Dye of INT <Int+4 Men-6>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4572,'Greater Dye of INT <Int+4 Wit-6>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4573,'Greater Dye of MEN <Men+4 Int-6>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4574,'Greater Dye of MEN <Men+4 Wit-6>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4575,'Greater Dye of WIT <Wit+4 Int-6>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4576,'Greater Dye of WIT <Wit+4 Men-6>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4577,'Greater Dye of STR <Str+4 Con-5>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4578,'Greater Dye of STR <Str+4 Dex-5>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_str_hena_i01',1,1,1),
(4579,'Greater Dye of CON <Con+4 Str-5>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4580,'Greater Dye of CON <Con+4 Dex-5>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_con_hena_i01',1,1,1),
(4581,'Greater Dye of DEX <Dex+4 Str-5>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4582,'Greater Dye of DEX <Dex+4 Con-5>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_dex_hena_i01',1,1,1),
(4583,'Greater Dye of INT <Int+4 Men-5>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4584,'Greater Dye of INT <Int+4 Wit-5>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_int_hena_i01',1,1,1),
(4585,'Greater Dye of MEN <Men+4 Int-5>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4586,'Greater Dye of MEN <Men+4 Wit-5>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_men_hena_i01',1,1,1),
(4587,'Greater Dye of WIT <Wit+4 Int-5>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4588,'Greater Dye of WIT <Wit+4 Men-5>','MISC','false','dye',150,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_wit_hena_i01',1,1,1),
(4589,'Greater Dye of STR <Str+2 Con-2>','MISC','false','dye',150,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_str_hena_i02',1,1,1),
(4590,'Greater Dye of STR <Str+2 Dex-2>','MISC','false','dye',150,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_str_hena_i02',1,1,1),
(4591,'Greater Dye of CON <Con+2 Str-2>','MISC','false','dye',150,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_con_hena_i02',1,1,1),
(4592,'Greater Dye of CON <Con+2 Dex-2>','MISC','false','dye',150,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_con_hena_i02',1,1,1),
(4593,'Greater Dye of DEX <Dex+2 Str-2>','MISC','false','dye',150,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_dex_hena_i02',1,1,1),
(4594,'Greater Dye of DEX <Dex+2 Con-2>','MISC','false','dye',150,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_dex_hena_i02',1,1,1),
(4595,'Greater Dye of INT <Int+2 Men-2>','MISC','false','dye',150,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_int_hena_i02',1,1,1),
(4596,'Greater Dye of INT <Int+2 Wit-2>','MISC','false','dye',150,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_int_hena_i02',1,1,1),
(4597,'Greater Dye of MEN <Men+2 Int-2>','MISC','false','dye',150,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_men_hena_i02',1,1,1),
(4598,'Greater Dye of MEN <Men+2 Wit-2>','MISC','false','dye',150,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_men_hena_i02',1,1,1),
(4599,'Greater Dye of WIT <Wit+2 Int-2>','MISC','false','dye',150,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_wit_hena_i02',1,1,1),
(4600,'Greater Dye of WIT <Wit+2 Men-2>','MISC','false','dye',150,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_wit_hena_i02',1,1,1),
(4601,'Greater Dye of STR <Str+3 Con-3>','MISC','false','dye',150,'stackable','liquid','none',0,90000,0,'true',0,1,'etc_str_hena_i02',1,1,1),
(4602,'Greater Dye of STR <Str+3 Dex-3>','MISC','false','dye',150,'stackable','liquid','none',0,90000,0,'true',0,1,'etc_str_hena_i02',1,1,1),
(4603,'Greater Dye of CON <Con+3 Str-3>','MISC','false','dye',150,'stackable','liquid','none',0,90000,0,'true',0,1,'etc_con_hena_i02',1,1,1),
(4604,'Greater Dye of CON <Con+3 Dex-3>','MISC','false','dye',150,'stackable','liquid','none',0,90000,0,'true',0,1,'etc_con_hena_i02',1,1,1),
(4605,'Greater Dye of DEX <Dex+3 Str-3>','MISC','false','dye',150,'stackable','liquid','none',0,90000,0,'true',0,1,'etc_dex_hena_i02',1,1,1),
(4606,'Greater Dye of DEX <Dex+3 Con-3>','MISC','false','dye',150,'stackable','liquid','none',0,90000,0,'true',0,1,'etc_dex_hena_i02',1,1,1),
(4607,'Greater Dye of INT <Int+3 Men-3>','MISC','false','dye',150,'stackable','liquid','none',0,90000,0,'true',0,1,'etc_int_hena_i02',1,1,1),
(4608,'Greater Dye of INT <Int+3 Wit-3>','MISC','false','dye',150,'stackable','liquid','none',0,90000,0,'true',0,1,'etc_int_hena_i02',1,1,1),
(4609,'Greater Dye of MEN <Men+3 Int-3>','MISC','false','dye',150,'stackable','liquid','none',0,90000,0,'true',0,1,'etc_men_hena_i02',1,1,1),
(4610,'Greater Dye of MEN <Men+3 Wit-3>','MISC','false','dye',150,'stackable','liquid','none',0,90000,0,'true',0,1,'etc_men_hena_i02',1,1,1),
(4611,'Greater Dye of WIT <Wit+3 Int-3>','MISC','false','dye',150,'stackable','liquid','none',0,90000,0,'true',0,1,'etc_wit_hena_i02',1,1,1),
(4612,'Greater Dye of WIT <Wit+3 Men-3>','MISC','false','dye',150,'stackable','liquid','none',0,90000,0,'true',0,1,'etc_wit_hena_i02',1,1,1),
(4613,'Greater Dye of STR <Str+4 Con-4>','MISC','false','dye',150,'stackable','liquid','none',0,145000,0,'true',0,1,'etc_str_hena_i02',1,1,1),
(4614,'Greater Dye of STR <Str+4 Dex-4>','MISC','false','dye',150,'stackable','liquid','none',0,145000,0,'true',0,1,'etc_str_hena_i02',1,1,1),
(4615,'Greater Dye of CON <Con+4 Str-4>','MISC','false','dye',150,'stackable','liquid','none',0,145000,0,'true',0,1,'etc_con_hena_i02',1,1,1),
(4616,'Greater Dye of CON <Con+4 Dex-4>','MISC','false','dye',150,'stackable','liquid','none',0,145000,0,'true',0,1,'etc_con_hena_i02',1,1,1),
(4617,'Greater Dye of DEX <Dex+4 Str-4>','MISC','false','dye',150,'stackable','liquid','none',0,145000,0,'true',0,1,'etc_dex_hena_i02',1,1,1),
(4618,'Greater Dye of DEX <Dex+4 Con-4>','MISC','false','dye',150,'stackable','liquid','none',0,145000,0,'true',0,1,'etc_dex_hena_i02',1,1,1),
(4619,'Greater Dye of INT <Int+4 Men-4>','MISC','false','dye',150,'stackable','liquid','none',0,145000,0,'true',0,1,'etc_int_hena_i02',1,1,1),
(4620,'Greater Dye of INT <Int+4 Wit-4>','MISC','false','dye',150,'stackable','liquid','none',0,145000,0,'true',0,1,'etc_int_hena_i02',1,1,1),
(4621,'Greater Dye of MEN <Men+4 Int-4>','MISC','false','dye',150,'stackable','liquid','none',0,145000,0,'true',0,1,'etc_men_hena_i02',1,1,1),
(4622,'Greater Dye of MEN <Men+4 Wit-4>','MISC','false','dye',150,'stackable','liquid','none',0,145000,0,'true',0,1,'etc_men_hena_i02',1,1,1),
(4623,'Greater Dye of WIT <Wit+4 Int-4>','MISC','false','dye',150,'stackable','liquid','none',0,145000,0,'true',0,1,'etc_wit_hena_i02',1,1,1),
(4624,'Greater Dye of WIT <Wit+4 Men-4>','MISC','false','dye',150,'stackable','liquid','none',0,145000,0,'true',0,1,'etc_wit_hena_i02',1,1,1),
(4625,'Dice (Heart)','OTHER','false','none',0,'normal','steel','none',0,500,0,'true',0,1,'etc_dice_a_i00',1,1,1),
(4626,'Dice (Spade)','OTHER','false','none',0,'normal','steel','none',0,500,0,'true',0,1,'etc_dice_b_i00',1,1,1),
(4627,'Dice (Clover)','OTHER','false','none',0,'normal','steel','none',0,500,0,'false',0,1,'etc_dice_c_i00',1,1,1),
(4628,'Dice (Diamond)','OTHER','false','none',0,'normal','steel','none',0,500,0,'false',0,1,'etc_dice_d_i00',1,1,1),
(4629,'Red Soul Crystal','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(4630,'Red Soul Crystal - Stage 1','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(4631,'Red Soul Crystal - Stage 2','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(4632,'Red Soul Crystal - Stage 3','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(4633,'Red Soul Crystal - Stage 4','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(4634,'Red Soul Crystal - Stage 5','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(4635,'Red Soul Crystal - Stage 6','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(4636,'Red Soul Crystal - Stage 7','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(4637,'Red Soul Crystal - Stage 8','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(4638,'Red Soul Crystal - Stage 9','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(4639,'Red Soul Crystal - Stage 10','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(4640,'Green Soul Crystal','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(4641,'Green Soul Crystal - Stage 1','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(4642,'Green Soul Crystal - Stage 2','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(4643,'Green Soul Crystal - Stage 3','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(4644,'Green Soul Crystal - Stage 4','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(4645,'Green Soul Crystal - Stage 5','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(4646,'Green Soul Crystal - Stage 6','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(4647,'Green Soul Crystal - Stage 7','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(4648,'Green Soul Crystal - Stage 8','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(4649,'Green Soul Crystal - Stage 9','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(4650,'Green Soul Crystal - Stage 10','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(4651,'Blue Soul Crystal','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(4652,'Blue Soul Crystal - Stage 1','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(4653,'Blue Soul Crystal - Stage 2','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(4654,'Blue Soul Crystal - Stage 3','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(4655,'Blue Soul Crystal - Stage 4','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(4656,'Blue Soul Crystal - Stage 5','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(4657,'Blue Soul Crystal - Stage 6','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(4658,'Blue Soul Crystal - Stage 7','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(4659,'Blue Soul Crystal - Stage 8','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(4660,'Blue Soul Crystal - Stage 9','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(4661,'Blue Soul Crystal - Stage 10','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(4662,'Broken Red Soul Crystal','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_broken_crystal_red_i00',1,1,1),
(4663,'Broken Green Soul Crystal','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_broken_crystal_green_i00',1,1,1),
(4664,'Broken Blue Soul Crystal','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_broken_crystal_blue_i00',1,1,1),
(4666,'Reiria''s Soul Orb','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_bead_white_i00',1,1,1),
(4667,'Kernon''s Infernium Scepter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_imperial_scepter_i02',1,1,1),
(4668,'Golkonda''s Infernium Scepter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_imperial_scepter_i01',1,1,1),
(4669,'Hallate''s Infernium Scepter','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_imperial_scepter_i00',1,1,1),
(4670,'Maestro Reorin''s Hammer','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_iron_hammer_i01',1,1,1),
(4671,'Maestro Reorin''s Mold','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_artisans_frame_i00',1,1,1),
(4672,'Infernium Varnish','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_powder_red_i00',1,1,1),
(4673,'Red Pipette Knife','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'weapon_knife_i01',1,1,1),
(4674,'Medal of Honor','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_magic_coin_gold_i00',1,1,1),
(4675,'Medal of Friendship','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_magic_coin_silver_i00',1,1,1),
(4676,'Medal of Victory','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_magic_coin_blood_i00',1,1,1),
(4677,'Potion of Critical Escape','CONSUMABLE','false','potion',120,'stackable','paper','none',0,120,0,'false',0,1,'etc_potion_red_i00',1,1,1),
(4678,'Decrease Haste Potion','CONSUMABLE','false','potion',180,'stackable','liquid','none',0,5000,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(4679,'Bless of Eva','CONSUMABLE','false','potion',180,'stackable','liquid','none',0,500,0,'true',2076,1,'etc_bless_of_eva_i00',1,1,1),
(4680,'Potion of Revenge','CONSUMABLE','false','potion',180,'stackable','liquid','none',0,150,0,'false',0,1,'etc_potion_blue_i00',1,1,1),
(4906,'Spellbook: Solar Spark','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(4907,'Spellbook: Solar Flare','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(4908,'Spellbook: Shadow Spark','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1250,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(4909,'Spellbook: Shadow Flare','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(4910,'Spellbook: Vampiric Rage','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,1800,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(4911,'Spellbook: Curse Disease','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(4912,'Spellbook: Benediction','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,8200,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(4913,'Spellbook: Word of Fear','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(4914,'Spellbook: Serenade of Eva','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(4915,'Blueprint: Summon Wild Hog Cannon','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_plan_i00',1,1,1),
(4916,'Spellbook: Energy Bolt','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,800,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(4917,'Spellbook: Aura Bolt','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(4918,'Spellbook: Summon Kai the Cat','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(4919,'Spellbook: Summon Merrow the Unicorn','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(4920,'Spellbook: Summon Soulless','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(4921,'Blueprint: Summon Big Boom','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_plan_i00',1,1,1),
(4922,'Spellbook: Summon Binding Cubic','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(4923,'Spellbook: Summon Aqua Cubic','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(4924,'Spellbook: Summon Spark Cubic','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(4925,'Amulet: Pa''agrio''s Haste','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(4926,'Amulet: Soul Guard','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(4927,'Amulet: Chant of Revenge','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7700,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(4928,'Spellbook: Seed of Fire','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7200,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(4929,'Spellbook: Seed of Water','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7200,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(4930,'Spellbook: Seed of Wind','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7200,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(4931,'Spellbook: Aura Symphony','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(4932,'Spellbook: Inferno','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(4933,'Spellbook: Blizzard','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(4934,'Spellbook: Demon Wind','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(4935,'Spellbook: Elemental Symphony','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(4936,'Recipe: Avadon Shield (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10900,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4937,'Recipe: Adamantite Earrings (70%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,12120,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4938,'Recipe: Adamantite Ring (70%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,8080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4939,'Recipe: Adamantite Necklace (70%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16160,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4940,'Recipe: Zubei''s Breastplate (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,41600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4941,'Recipe: Zubei''s Gaiters (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,26000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4942,'Recipe: Boots of Silence (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4943,'Recipe: Guardian''s Boots (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4944,'Recipe: Avadon Breastplate (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,41600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4945,'Recipe: Avadon Gaiters (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,26000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4946,'Recipe: Zubei''s Leather Shirt (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,31200,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4947,'Recipe: Zubei''s Leather Gaiters (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,19460,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4948,'Recipe: Avadon Leather Armor (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45600,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4949,'Recipe: Tunic of Zubei (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,31200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4950,'Recipe: Stockings of Zubei (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,19460,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4951,'Recipe: Avadon Robe (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,45600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4952,'Recipe: Avadon Circlet (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,15560,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4953,'Recipe: Avadon Gloves (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4954,'Recipe: Chain Gloves of Silence (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4955,'Recipe: Guardian''s Gloves (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4956,'Recipe: Gloves of Blessing (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4957,'Recipe: Boots of Blessing (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4958,'Recipe: Zubei''s Boots (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4959,'Recipe: Avadon Boots (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4960,'Recipe: Zubei''s Gauntlets (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10380,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4961,'Recipe: Zubei''s Shield (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,10900,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4962,'Recipe: Zubei''s Helmet (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,15560,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4963,'Recipe: Great Sword (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4964,'Recipe: Heavy War Axe (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4965,'Recipe: Sprite''s Staff (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4966,'Recipe: Keshanberk (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4967,'Recipe: Sword of Valhalla (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4968,'Recipe: Kris (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4969,'Recipe: Hell Knife (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4970,'Recipe: Arthro Nail (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4971,'Recipe: Dark Elven Long Bow (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4972,'Recipe: Great Axe (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4973,'Recipe: Earring of Black Ore (70%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,18480,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4974,'Recipe: Ring of Black Ore (70%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,12320,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4975,'Recipe: Necklace of Black Ore (70%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,24600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4976,'Recipe: Implosion Boots (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4977,'Recipe: Paradia Boots (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4978,'Recipe: Elemental Boots (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4979,'Recipe: Boots of Grace (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4980,'Recipe: Doom Shield (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16900,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4981,'Recipe: Blue Wolf Breastplate (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,64400,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4982,'Recipe: Blue Wolf Gaiters (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,40200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4983,'Recipe: Doom Plate Armor (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,94200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4984,'Recipe: Blue Wolf Leather Armor (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,70600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4985,'Recipe: Leather Armor of Doom (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,70600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4986,'Recipe: Blue Wolf Tunic (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,48200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4987,'Recipe: Tunic of Doom (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,48200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4988,'Recipe: Blue Wolf Stockings (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,30200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4989,'Recipe: Stockings of Doom (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,30200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4990,'Recipe: Blue Wolf Helmet (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,24200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4991,'Recipe: Doom Helmet (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,24200,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4992,'Recipe: Blue Wolf Boots (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4993,'Recipe: Doom Gloves (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4994,'Recipe: Elemental Gloves (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4995,'Recipe: Gloves of Grace (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4996,'Recipe: Implosion Gauntlets (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4997,'Recipe: Paradia Gloves (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(4998,'Recipe: Blue Wolf Gloves (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(4999,'Recipe: Doom Boots (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,16080,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(5000,'Recipe: Sword of Damascus (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(5001,'Recipe: Lance (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(5002,'Recipe: Deadman''s Glory (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(5003,'Recipe: Art of Battle Axe (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(5004,'Recipe: Staff of Evil Spirits (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(5005,'Recipe: Demon Dagger (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(5006,'Recipe: Bellion Cestus (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(5007,'Recipe: Bow of Peril (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(5008,'Recipe: Pata (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,156600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(5009,'Trophy of Alliance','OTHER','false','quest',0,'normal','steel','none',0,50,0,'false',0,1,'etc_trophy_i01',1,1,1),
(5010,'Echo Crystal - Theme of Victory','OTHER','false','none',10,'stackable','paper','none',0,100,0,'false',0,1,'etc_echo_crystal_i02',1,1,1),
(5011,'Star of Destiny','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_badge_gold_i00',1,1,1),
(5012,'Leikan''s Letter','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(5013,'Spellbook: Elemental Assault','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(5014,'Spellbook: Elemental Symphony','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(5015,'Spellbook: Elemental Storm','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7200,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(5016,'Seed: Dark Coda','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5017,'Seed: Red Coda','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5018,'Seed: Chilly Coda','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5019,'Seed: Blue Coda','OTHER','false','seed',1,'stackable','paper','none',0,10,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5020,'Seed: Golden Coda','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5021,'Seed: Lute Coda','OTHER','false','seed',1,'stackable','paper','none',0,30,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5022,'Seed: Desert Coda','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5023,'Seed: Blue Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5024,'Seed: Blue Coda','OTHER','false','seed',1,'stackable','paper','none',0,10,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(5025,'Seed: Golden Coda','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5026,'Seed: Lute Coda','OTHER','false','seed',1,'stackable','paper','none',0,30,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5027,'Seed: Desert Coda','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5028,'Seed: Red Cobol','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5029,'Seed: Chilly Cobol','OTHER','false','seed',1,'stackable','paper','none',0,25,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5030,'Seed: Thorn Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5031,'Seed: Golden Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5032,'Seed: Great Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5033,'Seed: Red Cobol','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5034,'Seed: Chilly Cobol','OTHER','false','seed',1,'stackable','paper','none',0,25,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5035,'Seed: Blue Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5036,'Seed: Thorn Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5037,'Seed: Golden Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5038,'Seed: Great Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5039,'Seed: Red Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5040,'Seed: Twin Codra','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(5041,'Seed: Desert Codran','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(5042,'Seed: Dark Coda','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5043,'Seed: Red Coda','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5044,'Seed: Blue Coda','OTHER','false','seed',1,'stackable','paper','none',0,10,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5045,'Seed: Red Cobol','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5046,'Seed: Chilly Cobol','OTHER','false','seed',1,'stackable','paper','none',0,25,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5047,'Seed: Blue Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5048,'Seed: Thorn Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5049,'Seed: Sea Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5050,'Seed: Chilly Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5051,'Seed: Blue Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5052,'Seed: Twin Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5053,'Seed: Thorn Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5054,'Seed: Golden Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_cobol_seed_i00',1,1,1),
(5055,'Seed: Great Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5056,'Seed: Red Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5057,'Seed: Chilly Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5058,'Seed: Blue Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5059,'Seed: Twin Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5060,'Seed: Great Codran','OTHER','false','seed',1,'stackable','paper','none',0,75,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5061,'Seed: Desert Codran','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5062,'Trash','OTHER','false','seed',20,'stackable','paper','none',0,1,0,'false',0,1,'icon.etc_coda_seed_i00',1,1,1),
(5063,'Trash','OTHER','false','seed',20,'stackable','paper','none',0,1,0,'false',0,1,'icon.etc_cobol_seed_i00',1,1,1),
(5064,'Trash','OTHER','false','seed',20,'stackable','paper','none',0,1,0,'false',0,1,'icon.etc_codran_seed_i00',1,1,1),
(5065,'Chilly Coda','OTHER','false','seed',2,'stackable','paper','none',0,50,0,'false',0,1,'etc_coda_i00',1,1,1),
(5066,'Burning Coda','OTHER','false','seed',2,'stackable','paper','none',0,0,0,'false',0,1,'etc_coda_i01',1,1,1),
(5067,'Blue Coda','OTHER','false','seed',2,'stackable','paper','none',0,100,0,'false',0,1,'etc_coda_i02',1,1,1),
(5068,'Red Coda','OTHER','false','seed',2,'stackable','paper','none',0,50,0,'true',0,1,'etc_coda_i03',1,1,1),
(5069,'Golden Coda','OTHER','false','seed',2,'stackable','paper','none',0,200,0,'false',0,1,'etc_coda_i04',1,1,1),
(5070,'Desert Coda','OTHER','false','seed',2,'stackable','paper','none',0,200,0,'false',0,1,'etc_coda_i05',1,1,1),
(5071,'Lute Coda','OTHER','false','seed',2,'stackable','paper','none',0,300,0,'false',0,1,'etc_coda_i06',1,1,1),
(5072,'Twin Coda','OTHER','false','seed',2,'stackable','paper','none',0,0,0,'false',0,1,'etc_coda_i07',1,1,1),
(5073,'Dark Coda','OTHER','false','seed',2,'stackable','paper','none',0,50,0,'true',0,1,'etc_coda_i08',1,1,1),
(5074,'Shining Coda','OTHER','false','seed',2,'stackable','paper','none',0,0,0,'false',0,1,'etc_coda_i09',1,1,1),
(5075,'Chilly Cobol','OTHER','false','seed',2,'stackable','paper','none',0,250,0,'true',0,1,'etc_cobol_i00',1,1,1),
(5076,'Burning Cobol','OTHER','false','seed',2,'stackable','paper','none',0,0,0,'false',0,1,'etc_cobol_i01',1,1,1),
(5077,'Blue Cobol','OTHER','false','seed',2,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i02',1,1,1),
(5078,'Red Cobol','OTHER','false','seed',2,'stackable','paper','none',0,200,0,'false',0,1,'etc_cobol_i03',1,1,1),
(5079,'Golden Cobol','OTHER','false','seed',2,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i04',1,1,1),
(5080,'Desert Cobol','OTHER','false','seed',2,'stackable','paper','none',0,0,0,'false',0,1,'etc_cobol_i05',1,1,1),
(5081,'Sea Cobol','OTHER','false','seed',2,'stackable','paper','none',0,0,0,'false',0,1,'etc_cobol_i06',1,1,1),
(5082,'Thorn Cobol','OTHER','false','seed',2,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i07',1,1,1),
(5083,'Dapple Cobol','OTHER','false','seed',2,'stackable','paper','none',0,0,0,'false',0,1,'etc_cobol_i08',1,1,1),
(5084,'Great Cobol','OTHER','false','seed',2,'stackable','paper','none',0,500,0,'true',0,1,'etc_cobol_i09',1,1,1),
(5085,'Chilly Codran','OTHER','false','seed',2,'stackable','paper','none',0,400,0,'false',0,1,'etc_codran_i00',1,1,1),
(5086,'Burning Codran','OTHER','false','seed',2,'stackable','paper','none',0,0,0,'false',0,1,'etc_codran_i01',1,1,1),
(5087,'Blue Codran','OTHER','false','seed',2,'stackable','paper','none',0,500,0,'false',0,1,'etc_codran_i02',1,1,1),
(5088,'Red Codran','OTHER','false','seed',2,'stackable','paper','none',0,400,0,'false',0,1,'etc_codran_i03',1,1,1),
(5089,'Dapple Codran','OTHER','false','seed',2,'stackable','paper','none',0,0,0,'false',0,1,'etc_codran_i04',1,1,1),
(5090,'Desert Codran','OTHER','false','seed',2,'stackable','paper','none',0,1000,0,'false',0,1,'etc_codran_i05',1,1,1),
(5091,'Sea Codran','OTHER','false','seed',2,'stackable','paper','none',0,500,0,'false',0,1,'etc_codran_i06',1,1,1),
(5092,'Twin Codran','OTHER','false','seed',2,'stackable','paper','none',0,500,0,'false',0,1,'etc_codran_i07',1,1,1),
(5093,'Thorn Codran','OTHER','false','seed',2,'stackable','paper','none',0,0,0,'false',0,1,'etc_codran_i08',1,1,1),
(5094,'Great Codran','OTHER','false','seed',2,'stackable','paper','none',0,750,0,'true',0,1,'etc_codran_i09',1,1,1),
(5095,'Mature Chilly Coda','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_coda_i00',1,1,1),
(5096,'Mature Burning Coda','OTHER','false','seed',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_coda_i01',1,1,1),
(5097,'Mature Blue Coda','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'false',0,1,'etc_coda_i02',1,1,1),
(5098,'Mature Red Coda','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_coda_i03',1,1,1),
(5099,'Mature Golden Coda','OTHER','false','seed',1,'stackable','paper','none',0,200,0,'false',0,1,'etc_coda_i04',1,1,1),
(5100,'Mature Desert Coda','OTHER','false','seed',1,'stackable','paper','none',0,200,0,'false',0,1,'etc_coda_i05',1,1,1),
(5101,'Mature Lute Coda','OTHER','false','seed',1,'stackable','paper','none',0,300,0,'false',0,1,'etc_coda_i06',1,1,1),
(5102,'Mature Twin Coda','OTHER','false','seed',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_coda_i07',1,1,1),
(5103,'Mature Dark Coda','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_coda_i08',1,1,1),
(5104,'Mature Shining Coda','OTHER','false','seed',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_coda_i09',1,1,1),
(5105,'Mature Chilly Cobol','OTHER','false','seed',1,'stackable','paper','none',0,250,0,'false',0,1,'etc_cobol_i00',1,1,1),
(5106,'Mature Burning Cobol','OTHER','false','seed',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_cobol_i01',1,1,1),
(5107,'Mature Blue Cobol','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i02',1,1,1),
(5108,'Mature Red Cobol','OTHER','false','seed',1,'stackable','paper','none',0,200,0,'false',0,1,'etc_cobol_i03',1,1,1),
(5109,'Mature Golden Cobol','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i04',1,1,1),
(5110,'Mature Desert Cobol','OTHER','false','seed',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_cobol_i05',1,1,1),
(5111,'Mature Sea Cobol','OTHER','false','seed',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_cobol_i06',1,1,1),
(5112,'Mature Thorn Cobol','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i07',1,1,1),
(5113,'Mature Dapple Cobol','OTHER','false','seed',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_cobol_i08',1,1,1),
(5114,'Mature Great Cobol','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i09',1,1,1),
(5115,'Mature Chilly Codran','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'false',0,1,'etc_codran_i00',1,1,1),
(5116,'Mature Burning Codran','OTHER','false','seed',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_codran_i01',1,1,1),
(5117,'Mature Blue Codran','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_codran_i02',1,1,1),
(5118,'Mature Red Codran','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'false',0,1,'etc_codran_i03',1,1,1),
(5119,'Mature Dapple Codran','OTHER','false','seed',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_codran_i04',1,1,1),
(5120,'Mature Desert Codran','OTHER','false','seed',1,'stackable','paper','none',0,1000,0,'false',0,1,'etc_codran_i05',1,1,1),
(5121,'Mature Sea Codran','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_codran_i06',1,1,1),
(5122,'Mature Twin Codran','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_codran_i07',1,1,1),
(5123,'Mature Thorn Codran','OTHER','false','seed',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_codran_i08',1,1,1),
(5124,'Mature Great Codran','OTHER','false','seed',1,'stackable','paper','none',0,750,0,'false',0,1,'etc_codran_i09',1,1,1),
(5125,'Harvester','OTHER','false','harvest',20,'normal','steel','none',0,500,0,'false',0,1,'etc_reaper_i00',1,1,1),
(5126,'Dualsword Craft Stamp','OTHER','false','none',20,'stackable','paper','none',0,10000,0,'true',0,1,'etc_letter_blue_i00',1,1,1),
(5134,'Compressed Package of Soulshots: No Grade','OTHER','false','none',600,'normal','steel','none',0,2300,0,'true',2078,1,'etc_pouch_yellow_i00',1,1,1),
(5135,'Compressed Package of Soulshots: D-grade','OTHER','false','none',450,'normal','steel','none',0,3300,0,'true',2079,1,'etc_pouch_yellow_i00',1,1,1),
(5136,'Compressed Package of Soulshots: C-grade','OTHER','false','none',450,'normal','steel','none',0,4950,0,'true',2080,1,'etc_pouch_yellow_i00',1,1,1),
(5137,'Compressed Package of Soulshots: B-grade','OTHER','false','none',300,'normal','steel','none',0,16500,0,'true',2081,1,'etc_pouch_yellow_i00',1,1,1),
(5138,'Compressed Package of Soulshots: A-grade','OTHER','false','none',300,'normal','steel','none',0,26400,0,'true',2082,1,'etc_pouch_yellow_i00',1,1,1),
(5139,'Compressed Package of Soulshots: S-grade','OTHER','false','none',300,'normal','steel','none',0,33000,0,'true',2083,1,'etc_pouch_yellow_i00',1,1,1),
(5140,'Compressed Package of Spiritshots: No Grade','OTHER','false','none',750,'normal','steel','none',0,4950,0,'true',2084,1,'etc_pouch_yellow_i00',1,1,1),
(5141,'Compressed Package of Spiritshots: D-grade','OTHER','false','none',750,'normal','steel','none',0,5940,0,'true',2085,1,'etc_pouch_yellow_i00',1,1,1),
(5142,'Compressed Package of Spiritshots: C-grade','OTHER','false','none',450,'normal','steel','none',0,11550,0,'true',2086,1,'etc_pouch_yellow_i00',1,1,1),
(5143,'Compressed Package of Spiritshots: B-grade','OTHER','false','none',450,'normal','steel','none',0,33000,0,'true',2087,1,'etc_pouch_yellow_i00',1,1,1),
(5144,'Compressed Package of Spiritshots: A-grade','OTHER','false','none',300,'normal','steel','none',0,39600,0,'true',2088,1,'etc_pouch_yellow_i00',1,1,1),
(5145,'Compressed Package of Spiritshots: S-grade','OTHER','false','none',300,'normal','steel','none',0,49500,0,'true',2089,1,'etc_pouch_yellow_i00',1,1,1),
(5146,'Compressed Package of Blessed Spiritshots: No Grade','OTHER','false','none',750,'normal','steel','none',0,11550,0,'true',2090,1,'etc_pouch_yellow_i00',1,1,1),
(5147,'Compressed Package of Blessed Spiritshots: D-grade','OTHER','false','none',750,'normal','steel','none',0,14850,0,'true',2091,1,'etc_pouch_yellow_i00',1,1,1),
(5148,'Compressed Package of Blessed Spiritshots: C-grade','OTHER','false','none',450,'normal','steel','none',0,29700,0,'true',2092,1,'etc_pouch_yellow_i00',1,1,1),
(5149,'Compressed Package of Blessed Spiritshots: B-grade','OTHER','false','none',450,'normal','steel','none',0,80850,0,'true',2093,1,'etc_pouch_yellow_i00',1,1,1),
(5150,'Compressed Package of Blessed Spiritshots: A-grade','OTHER','false','none',300,'normal','steel','none',0,95700,0,'true',2094,1,'etc_pouch_yellow_i00',1,1,1),
(5151,'Compressed Package of Blessed Spiritshots: S-grade','OTHER','false','none',300,'normal','steel','none',0,115500,0,'true',2095,1,'etc_pouch_yellow_i00',1,1,1),
(5152,'Magic Compressor','OTHER','false','none',10,'normal','steel','none',0,100,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(5153,'Recipe: Soulshot (D) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(5154,'Recipe: Soulshot (C) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(5155,'Recipe: Soulshot (B) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(5156,'Recipe: Soulshot (A) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,150000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5157,'Recipe: Soulshot (S) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,450000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(5158,'Recipe: Spiritshot (D) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(5159,'Recipe: Spiritshot (C) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(5160,'Recipe: Spiritshot (B) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(5161,'Recipe: Spiritshot (A) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,150000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5162,'Recipe: Spiritshot (S) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,450000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(5163,'Recipe: Blessed Spiritshot (D) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(5164,'Recipe: Blessed Spiritshot (C) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(5165,'Recipe: Blessed Spiritshot (B) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(5166,'Recipe: Blessed Spiritshot (A) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,150000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5167,'Recipe: Blessed Spiritshot (S) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,450000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(5168,'Food for Strider','OTHER','false','none',10,'stackable','liquid','none',0,200,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(5169,'Deluxe Food for Strider','OTHER','false','none',10,'stackable','liquid','none',0,300,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(5192,'Rope of Magic: D-Grade','OTHER','false','none',2,'stackable','paper','none',0,100,0,'true',0,1,'etc_braided_hemp_i00',1,1,1),
(5193,'Rope of Magic: C-Grade','OTHER','false','none',2,'stackable','paper','none',0,150,0,'true',0,1,'etc_braided_hemp_i00',1,1,1),
(5194,'Rope of Magic: B-Grade','OTHER','false','none',2,'stackable','paper','none',0,250,0,'true',0,1,'etc_braided_hemp_i00',1,1,1),
(5195,'Rope of Magic: A-Grade','OTHER','false','none',2,'stackable','paper','none',0,400,0,'true',0,1,'etc_braided_hemp_i00',1,1,1),
(5196,'Rope of Magic: S Grade','OTHER','false','none',2,'stackable','paper','none',0,1500,0,'true',0,1,'etc_braided_hemp_i00',1,1,1),
(5197,'Chest Key - Grade 8','OTHER','false','none',10,'stackable','liquid','none',0,70,0,'true',0,1,'etc_key_i00',1,1,1),
(5198,'Chest Key - Grade 7','OTHER','false','none',10,'stackable','liquid','none',0,760,0,'true',0,1,'etc_key_i00',1,1,1),
(5199,'Chest Key - Grade 6','OTHER','false','none',10,'stackable','liquid','none',0,1200,0,'true',0,1,'etc_key_i00',1,1,1),
(5200,'Chest Key - Grade 5','OTHER','false','none',10,'stackable','liquid','none',0,1900,0,'true',0,1,'etc_key_i00',1,1,1),
(5201,'Chest Key - Grade 4','OTHER','false','none',10,'stackable','liquid','none',0,3200,0,'true',0,1,'etc_key_i00',1,1,1),
(5202,'Chest Key - Grade 3','OTHER','false','none',10,'stackable','liquid','none',0,5100,0,'true',0,1,'etc_key_i00',1,1,1),
(5203,'Chest Key - Grade 2','OTHER','false','none',10,'stackable','liquid','none',0,7400,0,'true',0,1,'etc_key_i00',1,1,1),
(5204,'Chest Key - Grade 1','OTHER','false','none',10,'stackable','liquid','none',0,10000,0,'true',0,1,'etc_key_i00',1,1,1),
(5205,'Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(5206,'Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(5207,'Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(5208,'Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(5209,'Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(5210,'Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(5211,'Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(5212,'Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(5213,'Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(5214,'Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(5215,'Mercenary Posting Ticket (Teleporter1)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(5218,'Mercenary Posting Ticket (Teleporter2)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(5219,'Mercenary Posting Ticket (Teleporter3)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(5220,'Metal Hardener','MATHERIALS','false','material',2,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_plate_blue_i00',1,1,1),
(5221,'Seed: Chilly Cobol','OTHER','false','seed',1,'stackable','paper','none',0,25,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5222,'Seed: Blue Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5223,'Seed: Thorn Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5224,'Seed: Golden Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5225,'Seed: Great Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_cobol_seed_i00',1,1,1),
(5226,'Seed: Red Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5227,'Seed: Sea Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5228,'Trash','OTHER','false','seed',20,'stackable','paper','none',0,250,0,'false',0,1,'icon.etc_codran_seed_i00',1,1,1),
(5229,'Trash','OTHER','false','seed',20,'stackable','paper','none',0,1,0,'false',0,1,'icon.etc_codran_seed_i00',1,1,1),
(5230,'Recipe: Mithril Arrow (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,150000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5231,'Recipe: Metal Hardener (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,2800,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(5232,'White Fabric','OTHER','false','quest',0,'stackable','cloth','none',100,0,0,'false',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(5234,'Mystery Potion','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,10000,0,'true',2103,1,'etc_lesser_potion_clear_i00',1,1,1),
(5235,'Facelifting Potion - A','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,20000,0,'true',0,1,'etc_lesser_potion_purple_i00',1,1,1),
(5236,'Facelifting Potion - B','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,20000,0,'true',0,1,'etc_lesser_potion_purple_i00',1,1,1),
(5237,'Facelifting Potion - C','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,20000,0,'true',0,1,'etc_lesser_potion_purple_i00',1,1,1),
(5238,'Dye Potion - A','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,20000,0,'true',0,1,'etc_lesser_potion_scarlet_i00',1,1,1),
(5239,'Dye Potion - B','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,20000,0,'true',0,1,'etc_lesser_potion_scarlet_i00',1,1,1),
(5240,'Dye Potion - C','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,20000,0,'true',0,1,'etc_lesser_potion_scarlet_i00',1,1,1),
(5241,'Dye Potion - D','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,20000,0,'true',0,1,'etc_lesser_potion_scarlet_i00',1,1,1),
(5242,'Hair Style Change Potion - A','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,20000,0,'true',0,1,'etc_lesser_potion_green_i00',1,1,1),
(5243,'Hair Style Change Potion - B','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,20000,0,'true',0,1,'etc_lesser_potion_green_i00',1,1,1),
(5244,'Hair Style Change Potion - C','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,20000,0,'true',0,1,'etc_lesser_potion_green_i00',1,1,1),
(5245,'Hair Style Change Potion - D','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,20000,0,'true',0,1,'etc_lesser_potion_green_i00',1,1,1),
(5246,'Hair Style Change Potion - E','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,20000,0,'true',0,1,'etc_lesser_potion_green_i00',1,1,1),
(5247,'Hair Style Change Potion - F','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,20000,0,'true',0,1,'etc_lesser_potion_green_i00',1,1,1),
(5248,'Hair Style Change Potion - G','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,20000,0,'true',0,1,'etc_lesser_potion_green_i00',1,1,1),
(5249,'Commemorative Item: First Anniversary of Lineage II Service','OTHER','false','none',0,'normal','cloth','none',100,0,0,'false',0,1,'etc_l2_i00',1,1,1),
(5250,'Greater Compressed Package of Soulshots: No-grade','OTHER','false','none',600,'normal','steel','none',0,7700,0,'true',2104,1,'etc_pouch_gray_i00',1,1,1),
(5251,'Greater Compressed Package of Soulshots: D-grade','OTHER','false','none',450,'normal','steel','none',0,11000,0,'true',2105,1,'etc_pouch_gray_i00',1,1,1),
(5252,'Greater Compressed Package of Soulshots: C-grade','OTHER','false','none',450,'normal','steel','none',0,16500,0,'true',2106,1,'etc_pouch_gray_i00',1,1,1),
(5253,'Greater Compressed Package of Soulshots: B-grade','OTHER','false','none',300,'normal','steel','none',0,55000,0,'true',2107,1,'etc_pouch_gray_i00',1,1,1),
(5254,'Greater Compressed Package of Soulshots: A-grade','OTHER','false','none',300,'normal','steel','none',0,88000,0,'true',2108,1,'etc_pouch_gray_i00',1,1,1),
(5255,'Greater Compressed Package of Soulshots: S-grade','OTHER','false','none',300,'normal','steel','none',0,120000,0,'true',2109,1,'etc_pouch_gray_i00',1,1,1),
(5256,'Greater Compressed Package of Spiritshots: No-grade','OTHER','false','none',750,'normal','steel','none',0,16500,0,'true',2110,1,'etc_pouch_gray_i00',1,1,1),
(5257,'Greater Compressed Package of Spiritshots: D-grade','OTHER','false','none',750,'normal','steel','none',0,19800,0,'true',2111,1,'etc_pouch_gray_i00',1,1,1),
(5258,'Greater Compressed Package of Spiritshots: C-grade','OTHER','false','none',450,'normal','steel','none',0,38500,0,'true',2112,1,'etc_pouch_gray_i00',1,1,1),
(5259,'Greater Compressed Package of Spiritshots: B-grade','OTHER','false','none',450,'normal','steel','none',0,110000,0,'true',2113,1,'etc_pouch_gray_i00',1,1,1),
(5260,'Greater Compressed Package of Spiritshots: A-grade','OTHER','false','none',300,'normal','steel','none',0,132000,0,'true',2114,1,'etc_pouch_gray_i00',1,1,1),
(5261,'Greater Compressed Package of Spiritshots: S-grade','OTHER','false','none',300,'normal','steel','none',0,180000,0,'true',2115,1,'etc_pouch_gray_i00',1,1,1),
(5262,'Greater Compressed Package of Blessed Spiritshots: No-grade','OTHER','false','none',750,'normal','steel','none',0,38500,0,'true',2116,1,'etc_pouch_gray_i00',1,1,1),
(5263,'Greater Compressed Package of Blessed Spiritshots: D-grade','OTHER','false','none',750,'normal','steel','none',0,49500,0,'true',2117,1,'etc_pouch_gray_i00',1,1,1),
(5264,'Greater Compressed Package of Blessed Spiritshots: C-grade','OTHER','false','none',450,'normal','steel','none',0,99000,0,'true',2118,1,'etc_pouch_gray_i00',1,1,1),
(5265,'Greater Compressed Package of Blessed Spiritshots: B-grade','OTHER','false','none',450,'normal','steel','none',0,269500,0,'true',2119,1,'etc_pouch_gray_i00',1,1,1),
(5266,'Greater Compressed Package of Blessed Spiritshots: A-grade','OTHER','false','none',300,'normal','steel','none',0,319000,0,'true',2120,1,'etc_pouch_gray_i00',1,1,1),
(5267,'Greater Compressed Package of Blessed Spiritshots: S-grade','OTHER','false','none',300,'normal','steel','none',0,419000,0,'true',2121,1,'etc_pouch_gray_i00',1,1,1),
(5268,'Recipe: Greater Soulshot (D) Compressed Package (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(5269,'Recipe: Greater Soulshot (C) Compressed Package(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(5270,'Recipe: Greater Soulshot (B) Compressed Package(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(5271,'Recipe: Greater Soulshot (A) Compressed Package(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,150000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5272,'Recipe: Greater Soulshot (S) Compressed Package(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,450000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(5273,'Recipe: Greater Spiritshot (D) Compressed Package(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(5274,'Recipe: Greater Spiritshot (C) Compressed Package(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(5275,'Recipe: Greater Spiritshot (B) Compressed Package(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(5276,'Recipe: Greater Spiritshot (A) Compressed Package(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,150000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5277,'Recipe: Greater Spiritshot (S) Compressed Package(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,450000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(5278,'Recipe: Greater Blessed Spiritshot (D) Compressed Package(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(5279,'Recipe: Greater Blessed Spiritshot (C) Compressed Package(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,60000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(5280,'Recipe: Greater Blessed Spiritshot (B) Compressed Package(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,100000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(5281,'Recipe: Greater Blessed Spiritshot (A) Compressed Package(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,150000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5282,'Recipe: Greater Blessed Spiritshot (S) Compressed Package(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,450000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(5283,'Rice Cake','CONSUMABLE','false','potion',0,'stackable','liquid','none',0,0,0,'false',0,1,'etc_mochi_i00',1,1,1),
(5332,'Recipe: Sealed Dark Crystal Leather Armor(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,69400,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5333,'Recipe: Sealed Dark Crystal Leather Armor(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,69400,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5334,'Recipe: Sealed Tallum Leather Armor(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,101600,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5335,'Recipe: Sealed Tallum Leather Armor(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,101600,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5336,'Recipe: Sealed Leather Armor of Nightmare(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,154600,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5337,'Recipe: Sealed Leather Armor of Nightmare(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,154600,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5338,'Recipe: Sealed Majestic Leather Armor(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,154600,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5339,'Recipe: Sealed Majestic Leather Armor(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,154600,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5340,'Recipe: Sealed Dark Crystal Leggings(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,43400,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5341,'Recipe: Sealed Dark Crystal Leggings(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,43400,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5342,'Recipe: Phoenix Earring(70%)','RECIPIES','false','recipe',20,'stackable','paper','none',0,1,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(5343,'Recipe: Phoenix Earring(100%)','RECIPIES','false','recipe',20,'stackable','paper','none',0,1,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(5344,'Recipe: Inferno Earring(70%)','RECIPIES','false','recipe',20,'stackable','paper','none',0,1,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(5345,'Recipe: Inferno Earring(70%)','RECIPIES','false','recipe',20,'stackable','paper','none',0,1,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(5346,'Recipe: Sealed Tallum Tunic(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,69400,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5347,'Recipe: Sealed Tallum Tunic(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,69400,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5348,'Recipe: Sealed Dark Crystal Robe(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,101600,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5349,'Recipe: Sealed Dark Crystal Robe(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,101600,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5350,'Recipe: Sealed Nightmare Robe(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,154600,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5351,'Recipe: Sealed Nightmare Robe(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,154600,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5352,'Recipe: Sealed Majestic Robe(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,154600,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5353,'Recipe: Sealed Majestic Robe(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,154600,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5354,'Recipe: Sealed Tallum Stockings(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,43400,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5355,'Recipe: Sealed Tallum Stockings(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,43400,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5356,'Recipe: Phoenix Necklace(70%)','RECIPIES','false','recipe',20,'stackable','paper','none',0,1,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(5357,'Recipe: Phoenix Necklace(100%)','RECIPIES','false','recipe',20,'stackable','paper','none',0,1,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(5358,'Recipe: Inferno Necklace(70%)','RECIPIES','false','recipe',20,'stackable','paper','none',0,1,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(5359,'Recipe: Inferno Necklace(100%)','RECIPIES','false','recipe',20,'stackable','paper','none',0,1,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(5360,'Recipe: Phoenix Ring(70%)','RECIPIES','false','recipe',20,'stackable','paper','none',0,1,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(5361,'Recipe: Phoenix Ring(100%)','RECIPIES','false','recipe',20,'stackable','paper','none',0,1,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(5362,'Recipe: Inferno Ring(70%)','RECIPIES','false','recipe',20,'stackable','paper','none',0,1,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(5363,'Recipe: Inferno Ring(100%)','RECIPIES','false','recipe',20,'stackable','paper','none',0,1,0,'false',0,1,'etc_recipe_blue_i00',1,1,1),
(5364,'Recipe: Sealed Dark Crystal Shield(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,24400,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5365,'Recipe: Sealed Dark Crystal Shield(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,24400,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5366,'Recipe: Sealed Shield of Nightmare(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,37000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5367,'Recipe: Sealed Shield of Nightmare(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,37000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5368,'Recipe: Sealed Dark Crystal Boots(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5369,'Recipe: Sealed Dark Crystal Boots(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5370,'Recipe: Sealed Tallum Boots(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5371,'Recipe: Sealed Tallum Boots(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5372,'Recipe: Sealed Boots of The Underworld(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5373,'Recipe: Sealed Boots of The Underworld(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5374,'Recipe: Sealed Gust Boots(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5375,'Recipe: Sealed Gust Boots(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5376,'Recipe: Sealed Red Flame Boots(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5377,'Recipe: Sealed Red Flame Boots(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5378,'Recipe: Sealed Phoenix Boots(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5379,'Recipe: Sealed Phoenix Boots(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5380,'Recipe: Sealed Boots of Nightmare(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5381,'Recipe: Sealed Boots of Nightmare(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5382,'Recipe: Sealed Majestic Boots(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5383,'Recipe: Sealed Majestic Boots(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5384,'Recipe: Sealed Dark Legion Boots(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5385,'Recipe: Sealed Dark Legion Boots(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5386,'Recipe: Sealed Boots of Phantom(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5387,'Recipe: Sealed Boots of Phantom(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5388,'Recipe: Sealed Cerberus Boots(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5389,'Recipe: Sealed Cerberus Boots(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5390,'Recipe: Sealed Dasparion''s Boots Boots(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5391,'Recipe: Sealed Dasparion''s Boots Boots(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5392,'Recipe: Sealed Dark Crystal Gloves(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5393,'Recipe: Sealed Dark Crystal Gloves(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5394,'Recipe: Sealed Tallum Gloves(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5395,'Recipe: Sealed Tallum Gloves(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5396,'Recipe: Sealed Gloves of The Underworld(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(5397,'Recipe: Sealed Gloves of The Underworld(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5398,'Recipe: Sealed Gust Bracer(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5399,'Recipe: Sealed Gust Bracer(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5400,'Recipe: Sealed Gloves of Black Ore(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5401,'Recipe: Sealed Gloves of Black Ore(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5402,'Recipe: Sealed Phoenix Gloves(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5403,'Recipe: Sealed Phoenix Gloves(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,23200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5404,'Recipe: Sealed Gauntlets of Nightmare(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5405,'Recipe: Sealed Gauntlets of Nightmare(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5406,'Recipe: Sealed Majestic Gauntlets(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5407,'Recipe: Sealed Majestic Gauntlets(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5408,'Recipe: Sealed Dark Legion Gloves(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5409,'Recipe: Sealed Dark Legion Gloves(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5410,'Recipe: Sealed Gloves of Phantom(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5411,'Recipe: Sealed Gloves of Phantom(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5412,'Recipe: Sealed Cerberus Gloves(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5413,'Recipe: Sealed Cerberus Gloves(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5414,'Recipe: Sealed Dasparion''s Gloves(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5415,'Recipe: Sealed Dasparion''s Gloves(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,35200,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5416,'Recipe: Sealed Dark Crystal Breastplate(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,92600,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5417,'Recipe: Sealed Dark Crystal Breastplate(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,92600,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5418,'Recipe: Sealed Tallum Plate Armor(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,135400,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5419,'Recipe: Sealed Tallum Plate Armor(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,135400,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5420,'Recipe: Sealed Armor of Nightmare(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,206000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5421,'Recipe: Sealed Armor of Nightmare(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,206000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5422,'Recipe: Sealed Majestic Plate Armor(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,206000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5423,'Recipe: Sealed Majestic Plate Armor(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,206000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5424,'Recipe: Sealed Dark Crystal Gaiters(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,57800,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5425,'Recipe: Sealed Dark Crystal Gaiters(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,57800,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5426,'Recipe: Sealed Dark Crystal Helmet(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,34800,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5427,'Recipe: Sealed Dark Crystal Helmet(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,34800,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5428,'Recipe: Sealed Tallum Helmet(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,34800,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5429,'Recipe: Sealed Tallum Helmet(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,34800,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5430,'Recipe: Sealed Helm of Nightmare(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,52800,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5431,'Recipe: Sealed Helm of Nightmare(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,52800,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5432,'Recipe: Sealed Majestic Circlet (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,52800,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5433,'Recipe: Sealed Majestic Circlet (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,52800,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5434,'Recipe: Dragon Slayer(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5435,'Recipe: Dragon Slayer(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5436,'Recipe: Berserker Blade(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(5437,'Recipe: Heavy Sword(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,8180,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(5438,'Recipe: Meteor Shower(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5439,'Recipe: Meteor Shower(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5440,'Recipe: Elysian(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5441,'Recipe: Elysian(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5442,'Recipe: Soul Bow(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5443,'Recipe: Soul Bow(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5444,'Recipe: Carnage Bow(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5445,'Recipe: Carnage Bow(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5446,'Recipe: Bloody Orchid(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5447,'Recipe: Bloody Orchid(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5448,'Recipe: Soul Separator(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5449,'Recipe: Soul Separator(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5450,'Recipe: Dragon Grinder(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5451,'Recipe: Dragon Grinder(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5452,'Recipe: Blood Tornado(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5453,'Recipe: Blood Tornado(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5454,'Recipe: Orcish Halberd(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,426000,0,'false',0,1,'etc_recipe_black_i00',1,1,1),
(5455,'Recipe: Orcish Halberd(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,426000,0,'false',0,1,'etc_recipe_black_i00',1,1,1),
(5456,'Recipe: Tallum Glaive(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5457,'Recipe: Tallum Glaive(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5458,'Recipe: Halberd(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5459,'Recipe: Halberd(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5460,'Recipe: Dasparion''s Staff(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5461,'Recipe: Dasparion''s Staff(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5462,'Recipe: Branch of The Mother Tree(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5463,'Recipe: Branch of The Mother Tree(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5464,'Recipe: Dark Legion''s Edge(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5465,'Recipe: Dark Legion''s Edge(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5466,'Recipe: Sword of Miracles(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5467,'Recipe: Sword of Miracles(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,540000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5468,'Recipe: Elemental Sword(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5469,'Recipe: Elemental Sword(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5470,'Recipe: Tallum Blade(60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(5471,'Recipe: Tallum Blade(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,366000,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5472,'Recipe: Metallic Thread(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,2800,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(5473,'Recipe: Durable Metal Plate(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,2800,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(5474,'Recipe: Reorin''s Mold(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,4800,0,'false',0,1,'etc_recipe_yellow_i00',1,1,1),
(5475,'Recipe: Warsmith''s Mold(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,7700,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5476,'Recipe: Arcsmith''s Anvil(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,10600,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5477,'Recipe: Warsmith''s Holder(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5478,'Sealed Dark Crystal Leather Armor Pattern','PIECES','false','material',60,'stackable','liquid','none',0,23784,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(5479,'Sealed Tallum Leather Armor Pattern','PIECES','false','material',60,'stackable','liquid','none',0,33800,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(5480,'Sealed Leather Armor of Nightmare Fabric','PIECES','false','material',60,'stackable','liquid','none',0,44571,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(5481,'Sealed Majestic Leather Armor Fabric','PIECES','false','material',60,'stackable','liquid','none',0,44571,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(5482,'Sealed Dark Crystal Leggings Design','PIECES','false','material',60,'stackable','liquid','none',0,15153,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5483,'Phoenix Earring Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,7215,0,'true',0,1,'etc_gem_blue_i00',1,1,1),
(5484,'Inferno Earring Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,9100,0,'true',0,1,'etc_gem_blue_i00',1,1,1),
(5485,'Sealed Tallum Tunic Texture','PIECES','false','material',60,'stackable','liquid','none',0,23784,0,'true',0,1,'etc_leather_yellow_i00',1,1,1),
(5486,'Sealed Dark Crystal Robe Fabric','PIECES','false','material',60,'stackable','liquid','none',0,33800,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(5487,'Sealed Nightmare Robe Fabric','PIECES','false','material',60,'stackable','liquid','none',0,44414,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(5488,'Sealed Majestic Robe Fabric','PIECES','false','material',60,'stackable','liquid','none',0,44414,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(5489,'Sealed Tallum Stockings Fabric','PIECES','false','material',60,'stackable','liquid','none',0,15153,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(5490,'Phoenix Necklace Beads','PIECES','false','material',60,'stackable','liquid','none',0,9185,0,'true',0,1,'etc_crystal_ball_green_i00',1,1,1),
(5491,'Inferno Necklace Beads','PIECES','false','material',60,'stackable','liquid','none',0,13114,0,'true',0,1,'etc_crystal_ball_green_i00',1,1,1),
(5492,'Phoenix Ring Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,5228,0,'true',0,1,'etc_gem_blue_i00',1,1,1),
(5493,'Inferno Ring Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,6414,0,'true',0,1,'etc_gem_blue_i00',1,1,1),
(5494,'Sealed Dark Crystal Shield Fragment','PIECES','false','material',60,'stackable','liquid','none',0,9523,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(5495,'Sealed Shield of Nightmare Fragment','PIECES','false','material',60,'stackable','liquid','none',0,13171,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(5496,'Sealed Dark Crystal Boots Lining','PIECES','false','material',60,'stackable','liquid','none',0,8530,0,'true',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(5497,'Sealed Tallum Boots Lining','PIECES','false','material',60,'stackable','liquid','none',0,8530,0,'true',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(5498,'Sealed Boots of the Underworld Lining','PIECES','false','material',60,'stackable','liquid','none',0,5738,0,'true',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(5499,'Sealed Gust Boots Lining','PIECES','false','material',60,'stackable','liquid','none',0,5738,0,'true',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(5500,'Sealed Red Flame Boots Lining','PIECES','false','material',60,'stackable','liquid','none',0,5738,0,'true',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(5501,'Sealed Phoenix Boots Lining','PIECES','false','material',60,'stackable','liquid','none',0,5738,0,'true',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(5502,'Sealed Boots of Nightmare Lining','PIECES','false','material',60,'stackable','liquid','none',0,11842,0,'true',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(5503,'Sealed Majestic Boots Lining','PIECES','false','material',60,'stackable','liquid','none',0,11842,0,'true',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(5504,'Sealed Dark Legion Boots Lining','PIECES','false','material',60,'stackable','liquid','none',0,8993,0,'true',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(5505,'Sealed Boots of Phantom Lining','PIECES','false','material',60,'stackable','liquid','none',0,8993,0,'true',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(5506,'Sealed Cerberus Boots Lining','PIECES','false','material',60,'stackable','liquid','none',0,8993,0,'true',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(5507,'Sealed Dasparion''s Boots Lining','PIECES','false','material',60,'stackable','liquid','none',0,8993,0,'true',0,1,'etc_piece_of_cloth_black_i00',1,1,1),
(5508,'Sealed Dark Crystal Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,8530,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5509,'Sealed Tallum Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,8530,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5510,'Sealed Gloves of the Underworld Design','PIECES','false','material',60,'stackable','liquid','none',0,5738,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5511,'Sealed Gust Bracer design','PIECES','false','material',60,'stackable','liquid','none',0,5738,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5512,'Sealed Gloves of Black Ore Design','PIECES','false','material',60,'stackable','liquid','none',0,5738,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5513,'Sealed Phoenix Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,5738,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5514,'Sealed Gauntlets of Nightmare Design','PIECES','false','material',60,'stackable','liquid','none',0,11842,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5515,'Sealed Majestic Gauntlets Design','PIECES','false','material',60,'stackable','liquid','none',0,11842,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5516,'Sealed Dark Legion Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,8993,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5517,'Sealed Gloves of Phantom Design','PIECES','false','material',60,'stackable','liquid','none',0,8993,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5518,'Sealed Cerberus Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,8993,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5519,'Sealed Dasparion''s Gloves Design','PIECES','false','material',60,'stackable','liquid','none',0,8993,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5520,'Sealed Dark Crystal Breastplate Pattern','PIECES','false','material',60,'stackable','liquid','none',0,31015,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(5521,'Sealed Tallum Plate Armor Pattern','PIECES','false','material',60,'stackable','liquid','none',0,43953,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(5522,'Sealed Armor of Nightmare Pattern','PIECES','false','material',60,'stackable','liquid','none',0,58728,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(5523,'Sealed Majestic Plate Armor Pattern','PIECES','false','material',60,'stackable','liquid','none',0,58728,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(5524,'Sealed Dark Crystal Gaiters Pattern','PIECES','false','material',60,'stackable','liquid','none',0,20292,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(5525,'Sealed Dark Crystal Helmet Design','PIECES','false','material',60,'stackable','liquid','none',0,12938,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5526,'Sealed Tallum Helm Design','PIECES','false','material',60,'stackable','liquid','none',0,12938,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5527,'Sealed Helm of Nightmare Design','PIECES','false','material',60,'stackable','liquid','none',0,16728,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5528,'Sealed Majestic Circlet Design','PIECES','false','material',60,'stackable','liquid','none',0,16728,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5529,'Dragon Slayer Edge','PIECES','false','material',60,'stackable','liquid','none',0,72900,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(5530,'Berserker Blade Edge','PIECES','false','material',60,'stackable','liquid','none',0,43600,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(5531,'Heavy Sword Edge','PIECES','false','material',60,'stackable','liquid','none',0,11912,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(5532,'Meteor Shower Head','PIECES','false','material',60,'stackable','liquid','none',0,59308,0,'true',0,1,'etc_squares_silver_i00',1,1,1),
(5533,'Elysian Head','PIECES','false','material',60,'stackable','liquid','none',0,72914,0,'true',0,1,'etc_squares_silver_i00',1,1,1),
(5534,'Soul Bow Stave','PIECES','false','material',60,'stackable','liquid','none',0,72850,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(5535,'Carnage Bow Stave','PIECES','false','material',60,'stackable','liquid','none',0,58615,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(5536,'Bloody Orchid Head','PIECES','false','material',60,'stackable','liquid','none',0,58785,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(5537,'Soul Separator Head','PIECES','false','material',60,'stackable','liquid','none',0,72900,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(5538,'Dragon Grinder Edge','PIECES','false','material',60,'stackable','liquid','none',0,72914,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(5539,'Blood Tornado Edge','PIECES','false','material',60,'stackable','liquid','none',0,59308,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(5540,'Orcish Halberd Edge','PIECES','false','material',60,'stackable','liquid','none',0,66231,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(5541,'Tallum Glaive Edge','PIECES','false','material',60,'stackable','liquid','none',0,72929,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(5542,'Halberd Edge','PIECES','false','material',60,'stackable','liquid','none',0,59308,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(5543,'Dasparion''s Staff Edge','PIECES','false','material',60,'stackable','liquid','none',0,58754,0,'true',0,1,'etc_squares_silver_i00',1,1,1),
(5544,'Branch of The Mother Tree Head','PIECES','false','material',60,'stackable','liquid','none',0,72986,0,'true',0,1,'etc_squares_silver_i00',1,1,1),
(5545,'Dark Legion''s Edge Blade','PIECES','false','material',60,'stackable','liquid','none',0,72900,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(5546,'Sword of Miracles Edge','PIECES','false','material',60,'stackable','liquid','none',0,66369,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(5547,'Elemental Sword Edge','PIECES','false','material',60,'stackable','liquid','none',0,58785,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(5548,'Tallum Blade Edge','PIECES','false','material',60,'stackable','liquid','none',0,58785,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(5549,'Metallic Thread','MATHERIALS','false','material',2,'stackable','liquid','none',0,2000,0,'true',0,1,'etc_skein_gray_i00',1,1,1),
(5550,'Durable Metal Plate','MATHERIALS','false','material',2,'stackable','liquid','none',0,15000,0,'true',0,1,'etc_squares_wood_i00',1,1,1),
(5551,'Leolin''s Mold','MATHERIALS','false','material',2,'stackable','liquid','none',0,238000,0,'true',0,1,'etc_blacksmiths_frame_i00',1,1,1),
(5552,'Warsmith''s Mold','MATHERIALS','false','material',2,'stackable','liquid','none',0,385000,0,'true',0,1,'etc_blacksmiths_frame_i00',1,1,1),
(5553,'Arcsmith''s Anvil','MATHERIALS','false','material',2,'stackable','liquid','none',0,531200,0,'true',0,1,'etc_blacksmiths_frame_i00',1,1,1),
(5554,'Warsmith''s Holder','MATHERIALS','false','material',2,'stackable','liquid','none',0,884000,0,'true',0,1,'etc_blacksmiths_frame_i00',1,1,1),
(5555,'Token of Love','OTHER','false','quest',0,'stackable','paper','none',0,1,0,'false',0,1,'etc_x_mas_2004_i00',1,1,1),
(5556,'Star Ornament','MATHERIALS','false','material',0,'stackable','liquid','none',0,1,0,'false',0,1,'etc_deco_star_i00',1,1,1),
(5557,'Bead Ornament','MATHERIALS','false','material',0,'stackable','liquid','none',0,1,0,'false',0,1,'etc_deco_bead_i00',1,1,1),
(5558,'Fir Tree Branch','MATHERIALS','false','material',0,'stackable','liquid','none',0,1,0,'false',0,1,'etc_fir_spring_i00',1,1,1),
(5559,'Flower Pot','MATHERIALS','false','material',0,'stackable','liquid','none',0,1,0,'false',0,1,'etc_flowerpot_i00',1,1,1),
(5560,'Christmas Tree','CONSUMABLE','false','potion',0,'stackable','paper','none',0,1,0,'false',0,1,'etc_x_mas_tree_i00',1,1,1),
(5561,'Special Christmas Tree','CONSUMABLE','false','potion',0,'stackable','paper','none',0,1,0,'false',0,1,'etc_x_mas_tree_i00',1,1,1),
(5562,'Echo Crystal - 1st Carol','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i00',1,1,1),
(5563,'Echo Crystal - 2nd Carol','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i01',1,1,1),
(5564,'Echo Crystal - 3rd Carol','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i02',1,1,1),
(5565,'Echo Crystal - 4th Carol','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i03',1,1,1),
(5566,'Echo Crystal - 5th Carol','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i04',1,1,1),
(5567,'Letter of Greetings','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(5568,'Letter of Greetings','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(5569,'Water Rune','OTHER','false','quest',0,'stackable','gold','none',0,0,0,'false',0,1,'etc_water_rune_i00',1,1,1),
(5570,'Water Mantra','OTHER','false','quest',0,'stackable','gold','none',0,0,0,'false',0,1,'etc_water_mantra_i00',1,1,1),
(5571,'Wind Rune','OTHER','false','quest',0,'stackable','gold','none',0,0,0,'false',0,1,'etc_wind_rune_i00',1,1,1),
(5572,'Wind Mantra','OTHER','false','quest',0,'stackable','gold','none',0,0,0,'false',0,1,'etc_wind_mantra_i00',1,1,1),
(5573,'Fire Rune','OTHER','false','quest',0,'stackable','gold','none',0,0,0,'false',0,1,'etc_fire_rune_i00',1,1,1),
(5574,'Fire Mantra','OTHER','false','quest',0,'stackable','gold','none',0,0,0,'false',0,1,'etc_fire_mantra_i00',1,1,1),
(5575,'Ancient Adena','OTHER','false','none',0,'stackable','gold','none',0,0,0,'false',0,1,'etc_ancient_adena_i00',1,1,1),
(5577,'Red Soul Crystal - Stage 11','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(5578,'Green Soul Crystal - Stage 11','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(5579,'Blue Soul Crystal - Stage 11','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(5580,'Red Soul Crystal - Stage 12','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(5581,'Green Soul Crystal - Stage 12','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(5582,'Blue Soul Crystal - Stage 12','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(5583,'Echo Crystal - 6th Carol','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i00',1,1,1),
(5584,'Echo Crystal - 7th Carol','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i01',1,1,1),
(5585,'Echo Crystal - 8th Carol','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i02',1,1,1),
(5586,'Echo Crystal - 9th Carol','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i03',1,1,1),
(5587,'Echo Crystal - 10th Carol','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i04',1,1,1),
(5588,'Tutorial Guide','OTHER','false','none',10,'normal','liquid','none',0,1,0,'true',0,1,'etc_spellbook_gray_i00',0,1,0),
(5589,'Energy Stone','CONSUMABLE','false','potion',10,'stackable','liquid','none',0,100,0,'true',2165,1,'etc_energy_stone_i00',1,1,1),
(5591,'CP Potion','CONSUMABLE','false','potion',25,'stackable','liquid','none',0,200,0,'true',2166,1,'etc_cp_potion_i00',1,1,1),
(5592,'Greater CP Potion','CONSUMABLE','false','potion',100,'stackable','liquid','none',0,500,0,'true',2166,2,'etc_cp_potion_i01',1,1,1),
(5593,'SP Scroll: Low Grade','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,2000,0,'true',2167,1,'etc_sp_scroll1_i00',1,1,1),
(5594,'SP Scroll: Medium Grade','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,20000,0,'true',2167,2,'etc_sp_scroll2_i00',1,1,1),
(5595,'SP Scroll: High Grade','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,400000,0,'true',2167,3,'etc_sp_scroll3_i00',1,1,1),
(5650,'Alternative Dark Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5651,'Alternative Red Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5652,'Alternative Chilly Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5653,'Alternative Blue Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,10,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5654,'Alternative Golden Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5655,'Alternative Lute Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,30,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5656,'Alternative Desert Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5657,'Alternative Blue Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5658,'Alternative Blue Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,10,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5659,'Alternative Golden Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5660,'Alternative Lute Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,30,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5661,'Alternative Desert Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5662,'Alternative Red Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5663,'Alternative Chilly Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,25,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5664,'Alternative Thorn Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5665,'Alternative Golden Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5666,'Alternative Great Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5667,'Alternative Red Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5668,'Alternative Chilly Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,25,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5669,'Alternative Blue Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5670,'Alternative Thorn Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5671,'Alternative Golden Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5672,'Alternative Great Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5673,'Alternative Red Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5674,'Alternative Twin Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5675,'Alternative Desert Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5676,'Alternative Dark Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5677,'Alternative Red Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5678,'Alternative Blue Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,10,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(5679,'Alternative Red Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5680,'Alternative Chilly Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,25,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5681,'Alternative Blue Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5682,'Alternative Thorn Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5683,'Alternative Sea Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5684,'Alternative Chilly Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5685,'Alternative Blue Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5686,'Alternative Twin Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5687,'Alternative Thorn Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5688,'Alternative Golden Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5689,'Alternative Great Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5690,'Alternative Red Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5691,'Alternative Chilly Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5692,'Alternative Blue Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5693,'Alternative Twin Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5694,'Alternative Great Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,75,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5695,'Alternative Desert Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5696,'Alternative Chilly Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,25,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5697,'Alternative Blue Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5698,'Alternative Thorn Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5699,'Alternative Golden Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5700,'Alternative Great Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(5701,'Alternative Red Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5702,'Alternative Sea Codran Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(5703,'Lucky Charm','OTHER','false','scroll',10,'stackable','paper','none',0,100,0,'true',2168,1,'etc_charm_of_luck_i00',1,1,1),
(5707,'Record of Seven Signs','OTHER','false','none',0,'normal','liquid','none',0,500,0,'true',0,1,'etc_ssq_scroll_i00',1,1,1),
(5708,'Lord of the Manor''s Certificate of Approval','OTHER','false','none',0,'normal','liquid','none',0,0,0,'false',0,1,'etc_permit_card_i00',1,1,1),
(5741,'Recipe: Sealed Zubei''s Gauntlets (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(5742,'Recipe: Zubei''s Gauntlets (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(5743,'Recipe: Sealed Avadon Gloves (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(5744,'Recipe: Sealed Avadon Gloves (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(5745,'Recipe: Sealed Blue Wolf Gloves (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5746,'Recipe: Sealed Blue Wolf Gloves (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5747,'Recipe: Sealed Doom Gloves (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5748,'Recipe: Sealed Doom Gloves (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5749,'Recipe: Sealed Zubei''s Boots (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(5750,'Recipe: Sealed Zubei''s Boots (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(5751,'Recipe: Sealed Avadon Boots (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(5752,'Recipe: Sealed Avadon Boots (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_red_i00',1,1,1),
(5753,'Recipe: Sealed Blue Wolf Boots (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5754,'Recipe: Sealed Blue Wolf Boots (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5755,'Recipe: Sealed Boots of Doom (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5756,'Recipe: Sealed Boots of Doom (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17700,0,'false',0,1,'etc_recipe_violet_i00',1,1,1),
(5757,'Sealed Zubei''s Gauntlet Part','PIECES','false','material',60,'stackable','liquid','none',0,3843,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(5758,'Sealed Avadon Gloves Part','PIECES','false','material',60,'stackable','liquid','none',0,3843,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(5759,'Sealed Blue Wolf Gloves Fabric','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(5760,'Sealed Doom Gloves Part','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(5761,'Sealed Zubei''s Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,3843,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(5762,'Sealed Avadon Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,3843,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(5763,'Sealed Blue Wolf Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(5764,'Sealed Doom Boots Part','PIECES','false','material',60,'stackable','liquid','none',0,4455,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(5789,'Soulshot: No Grade for Beginners','CONSUMABLE','false','none',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_soulshot_none_for_rookie_i00',0,1,0),
(5790,'Spiritshot: No Grade for Beginners','CONSUMABLE','false','none',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_spiritshot_none_for_rookie_i00',0,1,0),
(5803,'Lucky Charm: D-Grade','OTHER','false','scroll',10,'stackable','paper','none',0,330,0,'true',2168,2,'etc_charm_of_luck_i00',1,1,1),
(5804,'Lucky Charm: C-Grade','OTHER','false','scroll',10,'stackable','paper','none',0,660,0,'true',2168,3,'etc_charm_of_luck_i00',1,1,1),
(5805,'Lucky Charm: B-Grade','OTHER','false','scroll',10,'stackable','paper','none',0,1300,0,'true',2168,4,'etc_charm_of_luck_i00',1,1,1),
(5806,'Lucky Charm: A-Grade','OTHER','false','scroll',10,'stackable','paper','none',0,2700,0,'true',2168,5,'etc_charm_of_luck_i00',1,1,1),
(5807,'Lucky Charm: S Grade','OTHER','false','scroll',10,'stackable','paper','none',0,5000,0,'true',2168,6,'etc_charm_of_luck_i00',1,1,1),
(5809,'Spellbook: Aqua Splash','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(5810,'Spellbook: Rain of Fire','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(5811,'Spellbook: Mass Slow','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7700,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(5812,'Spellbook: Servitor Empowerment','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,5400,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(5813,'Spellbook: Servitor Cure','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(5814,'Spellbook: Servitor Blessing','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7700,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(5815,'Spellbook: Wild Magic','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7700,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(5816,'Spellbook: Advanced Block','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(5818,'Alternative Dark Coda','OTHER','false','seed',2,'stackable','paper','none',0,50,0,'false',0,1,'etc_coda_i08',1,1,1),
(5819,'Alternative Red Coda','OTHER','false','seed',2,'stackable','paper','none',0,50,0,'false',0,1,'etc_coda_i03',1,1,1),
(5820,'Alternative Chilly Coda','OTHER','false','seed',2,'stackable','paper','none',0,50,0,'false',0,1,'etc_coda_i00',1,1,1),
(5821,'Alternative Blue Coda','OTHER','false','seed',2,'stackable','paper','none',0,100,0,'false',0,1,'etc_coda_i02',1,1,1),
(5822,'Alternative Golden Coda','OTHER','false','seed',2,'stackable','paper','none',0,200,0,'false',0,1,'etc_coda_i04',1,1,1),
(5823,'Alternative Lute Coda','OTHER','false','seed',2,'stackable','paper','none',0,300,0,'false',0,1,'etc_coda_i06',1,1,1),
(5824,'Alternative Desert Coda','OTHER','false','seed',2,'stackable','paper','none',0,200,0,'false',0,1,'etc_coda_i05',1,1,1),
(5825,'Alternative Red Cobol','OTHER','false','seed',2,'stackable','paper','none',0,200,0,'false',0,1,'etc_cobol_i03',1,1,1),
(5826,'Alternative Chilly Cobol','OTHER','false','seed',2,'stackable','paper','none',0,250,0,'false',0,1,'etc_cobol_i00',1,1,1),
(5827,'Alternative Blue Cobol','OTHER','false','seed',2,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i02',1,1,1),
(5828,'Alternative Thorn Cobol','OTHER','false','seed',2,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i07',1,1,1),
(5829,'Alternative Golden Cobol','OTHER','false','seed',2,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i04',1,1,1),
(5830,'Alternative Great Cobol','OTHER','false','seed',2,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i09',1,1,1),
(5831,'Alternative Red Codran','OTHER','false','seed',2,'stackable','paper','none',0,400,0,'false',0,1,'etc_codran_i03',1,1,1),
(5832,'Alternative Sea Codran','OTHER','false','seed',2,'stackable','paper','none',0,500,0,'false',0,1,'etc_codran_i06',1,1,1),
(5833,'Alternative Chilly Codran','OTHER','false','seed',2,'stackable','paper','none',0,400,0,'false',0,1,'etc_codran_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(5834,'Alternative Blue Codran','OTHER','false','seed',2,'stackable','paper','none',0,500,0,'false',0,1,'etc_codran_i02',1,1,1),
(5835,'Alternative Twin Codran','OTHER','false','seed',2,'stackable','paper','none',0,500,0,'false',0,1,'etc_codran_i07',1,1,1),
(5836,'Alternative Great Codran','OTHER','false','seed',2,'stackable','paper','none',0,750,0,'false',0,1,'etc_codran_i09',1,1,1),
(5837,'Alternative Desert Codran','OTHER','false','seed',2,'stackable','paper','none',0,1000,0,'false',0,1,'etc_codran_i05',1,1,1),
(5838,'Mature Alternative Dark Coda','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_coda_i08',1,1,1),
(5839,'Mature Alternative Red Coda','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_coda_i03',1,1,1),
(5840,'Mature Alternative Chilly Coda','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_coda_i00',1,1,1),
(5841,'Mature Alternative Blue Coda','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'false',0,1,'etc_coda_i02',1,1,1),
(5842,'Mature Alternative Golden Coda','OTHER','false','seed',1,'stackable','paper','none',0,200,0,'false',0,1,'etc_coda_i04',1,1,1),
(5843,'Mature Alternative Lute Coda','OTHER','false','seed',1,'stackable','paper','none',0,300,0,'false',0,1,'etc_coda_i06',1,1,1),
(5844,'Mature Alternative Desert Coda','OTHER','false','seed',1,'stackable','paper','none',0,200,0,'false',0,1,'etc_coda_i05',1,1,1),
(5845,'Mature Alternative Red Cobol','OTHER','false','seed',1,'stackable','paper','none',0,200,0,'false',0,1,'etc_cobol_i03',1,1,1),
(5846,'Mature Alternative Chilly Cobol','OTHER','false','seed',1,'stackable','paper','none',0,250,0,'false',0,1,'etc_cobol_i00',1,1,1),
(5847,'Mature Alternative Blue Cobol','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i02',1,1,1),
(5848,'Mature Alternative Thorn Cobol','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i07',1,1,1),
(5849,'Mature Alternative Golden Cobol','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i04',1,1,1),
(5850,'Mature Alternative Great Cobol','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_cobol_i09',1,1,1),
(5851,'Mature Alternative Red Codran','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'false',0,1,'etc_codran_i03',1,1,1),
(5852,'Mature Alternative Sea Codran','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_codran_i06',1,1,1),
(5853,'Mature Alternative Chilly Codran','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'false',0,1,'etc_codran_i00',1,1,1),
(5854,'Mature Alternative Blue Codran','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_codran_i02',1,1,1),
(5855,'Mature Alternative Twin Codran','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_codran_i07',1,1,1),
(5856,'Mature Alternative Great Codran','OTHER','false','seed',1,'stackable','paper','none',0,750,0,'false',0,1,'etc_codran_i09',1,1,1),
(5857,'Mature Alternative Desert Codran','OTHER','false','seed',1,'stackable','paper','none',0,1000,0,'false',0,1,'etc_codran_i05',1,1,1),
(5858,'Blessed Scroll of Escape: Clan Hall','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,100000,0,'true',2177,1,'etc_scroll_of_return_agit_i01',1,1,1),
(5859,'Blessed Scroll of Escape: Castle','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,80000,0,'false',2178,1,'etc_scroll_of_return_castle_i01',1,1,1),
(5860,'Lienrik Egg','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_dragon_egg_i02',1,1,1),
(5861,'Lienrik Egg','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_dragon_egg_i01',1,1,1),
(5862,'Stone of Contract','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_bead_silver_i00',1,1,1),
(5863,'Alligator Tooth','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_fang_red_i00',1,1,1),
(5864,'Mysterious Map Piece','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_map_piece_ivory_i00',1,1,1),
(5865,'Carnivore Spore','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(5866,'Herbivorous Spore','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(5867,'Jade Crystal','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_gem_green_i00',1,1,1),
(5868,'Snake Scale','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_scale_of_medusa_blue_i00',1,1,1),
(5869,'Remains of Aden Residents','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_ashes_white_i00',1,1,1),
(5870,'Receipt of Supply','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(5871,'Suspicious Document Piece','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_piece_of_report_i00',1,1,1),
(5872,'Supply Items','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_squares_wood_i00',1,1,1),
(5873,'Pirate''s Treasure Chest','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(5874,'Sairon''s Silver Hair','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(5875,'Titan Lamp','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_bead_gold_i00',1,1,1),
(5876,'Titan Lamp','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_bead_silver_i00',1,1,1),
(5877,'Titan Lamp','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_bead_silver_i00',1,1,1),
(5878,'Titan Lamp','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_bead_silver_i00',1,1,1),
(5879,'Titan Lamp','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_bead_white_i00',1,1,1),
(5880,'Broken Titan Lamp','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(5881,'Blade Stakato Fang','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(5882,'Flare Shard','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_echo_crystal_i00',1,1,1),
(5883,'Freezing Shard','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_echo_crystal_i01',1,1,1),
(5884,'Cave Beast Tooth','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_fang_red_i00',1,1,1),
(5885,'Death Wave Light','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_crystal_ball_green_i00',1,1,1),
(5886,'Sealed Mysterious Stone','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_dragon_egg_i02',1,1,1),
(5887,'Mysterious Stone','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_dragon_egg_i00',1,1,1),
(5888,'Karik Horn','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'icon.etc_horn_i00',1,1,1),
(5889,'Cave Howler Skull','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(5890,'Mysterious Book','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(5891,'Ancient Language Dictionary: Basic Level','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(5892,'Ancient Language Dictionary: Intermediate Level','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_spellbook_red_i00',1,1,1),
(5893,'Leaf of Eucalyptus','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_herb_red_i00',1,1,1),
(5894,'Stone of Chill','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_crystal_ball_blue_i00',1,1,1),
(5895,'Ritron''s Fruit','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_cobol_i05',1,1,1),
(5896,'Moon Face Flower','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_flower_i00',1,1,1),
(5897,'Leech Fluids','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_reagent_red_i00',1,1,1),
(5898,'Royal Membership','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_royal_membership_i00',1,1,1),
(5899,'Kail''s Coin','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_magic_coin_blood_i00',1,1,1),
(5900,'Coin Collecting Album','OTHER','false','quest',0,'stackable','liquid','none',0,10000,0,'false',0,1,'etc_magic_book_black_i00',1,1,1),
(5901,'Blood Offering','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_dragon_blood_i00',1,1,1),
(5902,'Scroll of Ancient Magic','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_scroll_of_enchant_weapon_i01',1,1,1),
(5903,'Ancient Ash Urn','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(5904,'Wesley''s Mixing Stone','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_gem_green_i00',1,1,1),
(5905,'Magister''s Mixing Stone','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_gem_blue_i00',1,1,1),
(5906,'(Not used) Red Soul Crystal: Grade 11','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(5907,'(Not used) Red Soul Crystal: Grade 12','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(5908,'Red Soul Crystal: Grade 13','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(5909,'(Not used) Green Soul Crystal: Grade 11','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(5910,'(Not used) Green Soul Crystal: Grade 12','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(5911,'Green Soul Crystal: Grade 13','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_green_i00',1,1,1),
(5912,'(Not used) Blue Soul Crystal: Grade 11','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(5913,'(Not used) Blue Soul Crystal: Grade 12','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(5914,'Blue Soul Crystal: Grade 13','OTHER','false','scroll',20,'normal','crystal','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(5915,'Pirate''s Treasure Map','OTHER','false','quest',0,'stackable','liquid','none',0,200,0,'false',0,1,'etc_map_ivory_i00',1,1,1),
(5916,'Spellbook Page','OTHER','false','quest',0,'stackable','liquid','none',0,100,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(5917,'Kranvel''s Spellbook: Chapter of Fire','OTHER','false','quest',0,'stackable','liquid','none',0,100,0,'false',0,1,'etc_paper_red_i00',1,1,1),
(5918,'Kranvel''s Spellbook: Chapter of Water','OTHER','false','quest',0,'stackable','liquid','none',0,100,0,'false',0,1,'etc_paper_blue_i00',1,1,1),
(5919,'Kranvel''s Spellbook: Chapter of Wind','OTHER','false','quest',0,'stackable','liquid','none',0,100,0,'false',0,1,'etc_paper_white_i00',1,1,1),
(5920,'Kranvel''s Spellbook: Chapter of Earth','OTHER','false','quest',0,'stackable','liquid','none',0,100,0,'false',0,1,'etc_paper_black_i00',1,1,1),
(5921,'Worthless Piece of Paper','OTHER','false','quest',0,'stackable','liquid','none',0,100,0,'false',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(5922,'Blueprint: Giants Golem 1','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_black_i00',1,1,1),
(5923,'Blueprint: Giants Golem 2','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_black_i00',1,1,1),
(5924,'Blueprint: Giants Golem 3','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_black_i00',1,1,1),
(5925,'Blueprint: Giants Golem 4','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_black_i00',1,1,1),
(5926,'Blueprint: Giants Golem 5','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_black_i00',1,1,1),
(5927,'Book: Basics of Giants Magic,Chapter 1','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_blue_i00',1,1,1),
(5928,'Book: Basics of Giants Magic,Chapter 2','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_blue_i00',1,1,1),
(5929,'Book: Basics of Giants Magic,Chapter 3','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_blue_i00',1,1,1),
(5930,'Book: Basics of Giants Magic,Chapter 4','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_blue_i00',1,1,1),
(5931,'Book: Basics of Giants Magic,Chapter 5','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_blue_i00',1,1,1),
(5932,'Handbook: Giants Architecture,Chapter 1','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_red_i00',1,1,1),
(5933,'Handbook: Giants Architecture,Chapter 2','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_red_i00',1,1,1),
(5934,'Handbook: Giants Architecture,Chapter 3','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_red_i00',1,1,1),
(5935,'Handbook: Giants Architecture,Chapter 4','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_red_i00',1,1,1),
(5936,'Handbook: Giants Architecture,Chapter 5','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_red_i00',1,1,1),
(5937,'Book: Giants Medical Science,Chapter 1','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_white_i00',1,1,1),
(5938,'Book: Giants Medical Science,Chapter 2','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_white_i00',1,1,1),
(5939,'Book: Giants Medical Science,Chapter 3','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_white_i00',1,1,1),
(5940,'Book: Giants Medical Science,Chapter 4','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_white_i00',1,1,1),
(5941,'Book: Giants Medical Science,Chapter 5','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_paper_white_i00',1,1,1),
(5942,'Giant''s Love Letter','OTHER','false','none',0,'stackable','liquid','none',0,200,0,'true',0,1,'etc_piece_of_report_i00',1,1,1),
(5943,'Giants'' Doodle','OTHER','false','none',0,'stackable','liquid','none',0,200,0,'true',0,1,'etc_painting_i00',1,1,1),
(5944,'Ancient Parchment','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_roll_of_paper_black_i00',1,1,1),
(5945,'Book: Giants Science & Technology,Chapter 1','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(5946,'Book: Giants Science & Technology,Chapter 2','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(5947,'Book: Giants Science & Technology,Chapter 3','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(5948,'Book: Giants Science & Technology,Chapter 4','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(5949,'Book: Giants Science & Technology,Chapter 5','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(5950,'Almanac: Titan Culture,Chapter 1','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(5951,'Almanac: Titan Culture,Chapter 2','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(5952,'Almanac: Titan Culture,Chapter 3','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(5953,'Almanac: Titan Culture,Chapter 4','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(5954,'Almanac: Titan Culture,Chapter 5','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(5955,'Ancient Titan Book','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(5956,'15 Year Old Wine','OTHER','false','none',20,'stackable','liquid','none',0,5900,0,'true',0,1,'etc_luxury_wine_a_i00',1,1,1),
(5957,'30 Year Old Wine','OTHER','false','none',20,'stackable','liquid','none',0,7900,0,'true',0,1,'etc_luxury_wine_b_i00',1,1,1),
(5958,'60 Year Old Wine','OTHER','false','none',20,'stackable','liquid','none',0,30900,0,'true',0,1,'etc_luxury_wine_c_i00',1,1,1),
(5959,'Ritron''s Dessert Recipe','OTHER','false','none',10,'normal','liquid','none',0,40000,0,'false',0,1,'etc_paper_white_i00',1,1,1),
(5960,'Ritron Jelly','OTHER','false','none',10,'normal','liquid','none',0,920,0,'true',0,1,'etc_cobol_i04',1,1,1),
(5961,'Kail''s Silver Basilisk','OTHER','false','none',0,'stackable','liquid','none',0,1000,0,'false',0,1,'etc_kyles_silver_basilisk_i00',1,1,1),
(5962,'Kail''s Gold Golem','OTHER','false','none',0,'stackable','liquid','none',0,1000,0,'false',0,1,'etc_kyles_gold_golem_i00',1,1,1),
(5963,'Kail''s Blood Dragon','OTHER','false','none',0,'stackable','liquid','none',0,1000,0,'false',0,1,'etc_kyles_blood_dragon_i00',1,1,1),
(5964,'Warehouse Keeper''s Medal','OTHER','false','quest',0,'stackable','liquid','none',0,100,0,'false',0,1,'etc_irongate_medal_i00',1,1,1),
(5965,'Blank Scroll','OTHER','false','none',0,'stackable','liquid','none',0,500,0,'true',0,1,'etc_scroll_gray_i00',1,1,1),
(5966,'Ancient Red Papyrus','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_paper_red_i00',1,1,1),
(5967,'Ancient Blue Papyrus','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_paper_blue_i00',1,1,1),
(5968,'Ancient Black Papyrus','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_paper_black_i00',1,1,1),
(5969,'Ancient White Papyrus','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_paper_white_i00',1,1,1),
(5970,'Ancient Chain Letter','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(5971,'Ancient Joke Book','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_piece_of_paper_black_i00',1,1,1),
(5972,'Revelation of the Seals: Chapter of Avarice','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(5973,'Revelation of the Seals: Chapter of Gnosis','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(5974,'Revelation of the Seals: Chapter of Strife','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(5975,'Revelation of the Seals: Chapter of Vengeance','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(5976,'Revelation of the Seals: Chapter of Awakening','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(5977,'Revelation of the Seals: Chapter of Calamity','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(5978,'Revelation of the Seals: Chapter of Descent','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(5979,'Ancient Epic,Chapter 1','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(5980,'Ancient Epic,Chapter 2','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(5981,'Ancient Epic,Chapter 3','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(5982,'Ancient Epic,Chapter 4','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(5983,'Ancient Epic,Chapter 5','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(5984,'Imperial Genealogy 1','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(5985,'Imperial Genealogy 2','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(5986,'Imperial Genealogy 3','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(5987,'Imperial Genealogy 4','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(5988,'Imperial Genealogy 5','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(5989,'Blueprint: Tower of Insolence,1st Floor','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_blue_i00',1,1,1),
(5990,'Blueprint: Tower of Insolence,2nd Floor','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_blue_i00',1,1,1),
(5991,'Blueprint: Tower of Insolence,3rd Floor','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_blue_i00',1,1,1),
(5992,'Blueprint: Tower of Insolence,4th Floor','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_blue_i00',1,1,1),
(5993,'Blueprint: Tower of Insolence,5th Floor','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_blue_i00',1,1,1),
(5994,'Blueprint: Tower of Insolence,6th Floor','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_blue_i00',1,1,1),
(5995,'Blueprint: Tower of Insolence,7th Floor','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_blue_i00',1,1,1),
(5996,'Blueprint: Tower of Insolence,8th Floor','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_blue_i00',1,1,1),
(5997,'Blueprint: Tower of Insolence,9th Floor','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_blue_i00',1,1,1),
(5998,'Blueprint: Tower of Insolence,10th Floor','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_blue_i00',1,1,1),
(5999,'Blueprint: Tower of Insolence,11th Floor','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_blue_i00',1,1,1),
(6000,'Blueprint: Tower of Insolence,12th Floor','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_blue_i00',1,1,1),
(6001,'Blueprint: Tower of Insolence,13th Floor','OTHER','false','none',0,'stackable','liquid','none',0,400,0,'true',0,1,'etc_letter_blue_i00',1,1,1),
(6002,'Ancient Porcelain','OTHER','false','none',10,'stackable','liquid','none',0,8000,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(6003,'Ancient Porcelain: Excellent','OTHER','false','none',10,'stackable','liquid','none',0,80000,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(6004,'Ancient Porcelain: High Quality','OTHER','false','none',10,'stackable','liquid','none',0,16000,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(6005,'Ancient Porcelain: Low Quality','OTHER','false','none',10,'stackable','liquid','none',0,4000,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(6006,'Ancient Porcelain: Lowest Quality','OTHER','false','none',10,'stackable','liquid','none',0,2640,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(6007,'Reagent Pouch','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(6008,'Reagent Pouch','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(6009,'Reagent Pouch','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(6010,'Reagent Box','OTHER','false','none',0,'stackable','liquid','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(6011,'Wyrm''s Blood','OTHER','false','none',0,'stackable','liquid','none',0,200,0,'false',0,1,'etc_reagent_red_i00',1,1,1),
(6012,'Lava Stone','OTHER','false','none',0,'stackable','liquid','none',0,200,0,'true',0,1,'etc_inf_ore_high_i00',1,1,1),
(6013,'Moonstone Shard','OTHER','false','none',0,'stackable','liquid','none',0,200,0,'true',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(6014,'Rotten Bone Piece','OTHER','false','none',0,'stackable','liquid','none',0,200,0,'true',0,1,'etc_piece_bone_black_i00',1,1,1),
(6015,'Demon''s Blood','OTHER','false','none',0,'stackable','liquid','none',0,200,0,'false',0,1,'etc_reagent_green_i00',1,1,1),
(6016,'Infernium Ore','OTHER','false','none',0,'stackable','liquid','none',0,200,0,'true',0,1,'etc_inf_ore_least_i00',1,1,1),
(6017,'Blood Root','OTHER','false','none',0,'stackable','liquid','none',0,200,0,'false',0,1,'etc_ginseng_red_i00',1,1,1),
(6018,'Volcanic Ash','OTHER','false','none',0,'stackable','liquid','none',0,100,0,'true',0,1,'etc_powder_gray_i00',1,1,1),
(6019,'Quicksilver','OTHER','false','none',0,'stackable','liquid','none',0,200,0,'false',0,1,'etc_reagent_silver_i00',1,1,1),
(6020,'Sulfur','OTHER','false','none',0,'stackable','liquid','none',0,200,0,'false',0,1,'etc_powder_orange_i00',1,1,1),
(6021,'Dracoplasm','OTHER','false','none',0,'stackable','liquid','none',0,1200,0,'false',0,1,'etc_dragons_blood_i05',1,1,1),
(6022,'Magma Dust','OTHER','false','none',0,'stackable','liquid','none',0,2500,0,'false',0,1,'etc_powder_red_i00',1,1,1),
(6023,'Moon Dust','OTHER','false','none',0,'stackable','liquid','none',0,2500,0,'false',0,1,'etc_powder_white_i00',1,1,1),
(6024,'Necroplasm','OTHER','false','none',0,'stackable','liquid','none',0,2500,0,'false',0,1,'etc_potion_purpel_i00',1,1,1),
(6025,'Demonplasm','OTHER','false','none',0,'stackable','liquid','none',0,2500,0,'false',0,1,'etc_potion_green_i00',1,1,1),
(6026,'Inferno Dust','OTHER','false','none',0,'stackable','liquid','none',0,2500,0,'false',0,1,'etc_powder_black_i00',1,1,1),
(6027,'Draconic Essence','OTHER','false','none',0,'stackable','liquid','none',0,2500,0,'false',0,1,'etc_dragon_blood_i00',1,1,1),
(6028,'Fire Essence','OTHER','false','none',0,'stackable','liquid','none',0,2500,0,'false',0,1,'etc_dragons_blood_i00',1,1,1),
(6029,'Lunargent','OTHER','false','none',0,'stackable','liquid','none',0,2500,0,'false',0,1,'etc_mithril_ore_i00',1,1,1),
(6030,'Midnight Oil','OTHER','false','none',0,'stackable','liquid','none',0,2500,0,'false',0,1,'etc_dragons_blood_i02',1,1,1),
(6031,'Demonic Essence','OTHER','false','none',0,'stackable','liquid','none',0,2500,0,'false',0,1,'etc_dragons_blood_i05',1,1,1),
(6032,'Abyss Oil','OTHER','false','none',0,'stackable','liquid','none',0,2500,0,'false',0,1,'etc_dragons_blood_i04',1,1,1),
(6033,'Hellfire Oil','OTHER','false','none',0,'stackable','liquid','none',0,5000,0,'false',0,1,'etc_luxury_wine_b_i00',1,1,1),
(6034,'Nightmare Oil','OTHER','false','none',0,'stackable','liquid','none',0,5000,0,'false',0,1,'etc_luxury_wine_c_i00',1,1,1),
(6035,'Magic Haste Potion','CONSUMABLE','false','potion',20,'stackable','liquid','none',0,2400,0,'true',2169,1,'etc_potion_of_acumen2_i00',1,1,1),
(6036,'Greater Magic Haste Potion','CONSUMABLE','false','potion',20,'stackable','liquid','none',0,6000,0,'true',2169,2,'etc_potion_of_acumen3_i00',1,1,1),
(6037,'Waking Scroll','CONSUMABLE','false','scroll',5,'stackable','paper','none',0,100,0,'true',2170,1,'etc_piece_of_paper_white_i00',1,1,1),
(6038,'Greater Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6039,'Greater Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6040,'Greater Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6041,'Greater Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6042,'Greater Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6043,'Greater Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6044,'Greater Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6045,'Greater Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6046,'Greater Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6047,'Greater Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6048,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_sword_fix_i00',0,1,0),
(6049,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_pole_fix_i00',0,1,0),
(6050,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_bow_fix_i00',0,1,0),
(6051,'Greater Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6052,'Greater Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6053,'Greater Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6054,'Greater Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6055,'Greater Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6056,'Greater Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6057,'Greater Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6058,'Greater Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_move_i00',1,1,1),
(6059,'Greater Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6060,'Greater Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6061,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_cleric_fix_i00',0,1,0),
(6062,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_wizard_fix_i00',0,1,0),
(6063,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_sword_move_i00',0,1,0),
(6064,'Greater Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6065,'Greater Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6066,'Greater Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6067,'Greater Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6068,'Greater Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6069,'Greater Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6070,'Greater Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6071,'Greater Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6072,'Greater Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6073,'Greater Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6074,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_pole_move_i00',0,1,0),
(6075,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_bow_move_i00',0,1,0),
(6076,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_cleric_move_i00',0,1,0),
(6077,'Greater Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6078,'Greater Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6079,'Greater Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6080,'Greater Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6081,'Greater Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6082,'Greater Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6083,'Greater Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6084,'Greater Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6085,'Greater Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6086,'Greater Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6087,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_wizard_move_i00',0,1,0),
(6088,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_sword_fix_i00',0,1,0),
(6089,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_pole_fix_i00',0,1,0),
(6090,'Greater Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6091,'Greater Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6092,'Greater Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6093,'Greater Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6094,'Greater Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6095,'Greater Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6096,'Greater Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6097,'Greater Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6098,'Greater Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6099,'Greater Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6100,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_bow_fix_i00',0,1,0),
(6101,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_cleric_fix_i00',0,1,0),
(6102,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_wizard_fix_i00',0,1,0),
(6103,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_sword_move_i00',0,1,0),
(6104,'Trash','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'icon.mticket_pole_move_i00',0,1,0),
(6105,'Greater Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6106,'Greater Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6107,'Greater Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6108,'Greater Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6109,'Greater Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6110,'Greater Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6111,'Greater Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6112,'Greater Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6113,'Greater Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6114,'Greater Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6115,'Dawn Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6116,'Dawn Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6117,'Dawn Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6118,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6119,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6120,'Dawn Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6121,'Dawn Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6122,'Dawn Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6123,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6124,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6125,'Dawn Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6126,'Dawn Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6127,'Dawn Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6128,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6129,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6130,'Dawn Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6131,'Dawn Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6132,'Dawn Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6133,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6134,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6135,'Dawn Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6136,'Dawn Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6137,'Dawn Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6138,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6139,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6140,'Dawn Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_move_i00',0,1,0);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(6141,'Dawn Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6142,'Dawn Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6143,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6144,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6145,'Dawn Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6146,'Dawn Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6147,'Dawn Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6148,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6149,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6150,'Dawn Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6151,'Dawn Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6152,'Dawn Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6153,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6154,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6155,'Dawn Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6156,'Dawn Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6157,'Dawn Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6158,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6159,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6160,'Dawn Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6161,'Dawn Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6162,'Dawn Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6163,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6164,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6165,'Dawn Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6166,'Dawn Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6167,'Dawn Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6168,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6169,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6170,'Dawn Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6171,'Dawn Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6172,'Dawn Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6173,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6174,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6175,'Greater Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6176,'Greater Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6177,'Greater Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6178,'Greater Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6179,'Greater Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6180,'Greater Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6181,'Greater Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6182,'Greater Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6183,'Greater Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6184,'Greater Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6185,'Greater Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6186,'Greater Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6187,'Greater Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6188,'Greater Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6189,'Greater Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6190,'Greater Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6191,'Greater Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6192,'Greater Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6193,'Greater Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6194,'Greater Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6195,'Greater Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6196,'Greater Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6197,'Greater Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6198,'Greater Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6199,'Greater Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6200,'Greater Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6201,'Greater Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6202,'Greater Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6203,'Greater Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6204,'Greater Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6205,'Greater Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6206,'Greater Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6207,'Greater Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6208,'Greater Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6209,'Greater Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6210,'Greater Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6211,'Greater Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6212,'Greater Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6213,'Greater Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6214,'Greater Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6215,'Greater Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6216,'Greater Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6217,'Greater Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6218,'Greater Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6219,'Greater Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6220,'Greater Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6221,'Greater Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6222,'Greater Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6223,'Greater Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6224,'Greater Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6225,'Greater Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6226,'Greater Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6227,'Greater Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6228,'Greater Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6229,'Greater Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6230,'Greater Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6231,'Greater Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6232,'Greater Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6233,'Greater Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6234,'Greater Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6235,'Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6236,'Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6237,'Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6238,'Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6239,'Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6240,'Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6241,'Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6242,'Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6243,'Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6244,'Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6245,'Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6246,'Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6247,'Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6248,'Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6249,'Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6250,'Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6251,'Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6252,'Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6253,'Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6254,'Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6255,'Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6256,'Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6257,'Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6258,'Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6259,'Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6260,'Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6261,'Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6262,'Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6263,'Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6264,'Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6265,'Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6266,'Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6267,'Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6268,'Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6269,'Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6270,'Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6271,'Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6272,'Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6273,'Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6274,'Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6275,'Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6276,'Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6277,'Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6278,'Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6279,'Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6280,'Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6281,'Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6282,'Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6283,'Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6284,'Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6285,'Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6286,'Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6287,'Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6288,'Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6289,'Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6290,'Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6291,'Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6292,'Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6293,'Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6294,'Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6295,'Nephilim Warrior Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,2500000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6296,'Nephilim Shaman Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,5000000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6297,'Nephilim Warrior Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,2500000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6298,'Nephilim Shaman Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,5000000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6299,'Nephilim Warrior Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,2500000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6300,'Nephilim Shaman Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,5000000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6301,'Nephilim Warrior Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,2500000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6302,'Nephilim Shaman Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,5000000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6303,'Nephilim Warrior Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,2500000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6304,'Nephilim Shaman Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,5000000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6305,'Nephilim Warrior Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,2500000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6306,'Nephilim Shaman Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,5000000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6316,'Food for Wyvern','OTHER','false','none',10,'stackable','liquid','none',0,300,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(6317,'Mixing Manual','OTHER','false','none',20,'normal','liquid','none',0,1,0,'false',0,1,'etc_spellbook_red_i00',1,1,1),
(6318,'Blood Fire','OTHER','false','none',50,'stackable','liquid','none',0,500,0,'false',0,1,'etc_potion_red_i00',1,1,1),
(6319,'Mimir''s Elixir','OTHER','false','none',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_lesser_potion_yellow_i00',0,1,0),
(6320,'Pure Silver','OTHER','false','none',0,'stackable','liquid','none',0,500,0,'false',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(6321,'True Gold','OTHER','false','none',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_broken_crystal_gold_i00',1,1,1),
(6322,'Sage''s Stone','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_bead_silver_i00',1,1,1),
(6329,'Recipe: Sealed Phoenix Necklace(70%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,34800,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(6330,'Recipe: Sealed Phoenix Necklace(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,34800,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(6331,'Recipe: Sealed Phoenix Earring(70%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,26200,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(6332,'Recipe: Sealed Phoenix Earring(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,26200,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(6333,'Recipe: Sealed Phoenix Ring(70%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17420,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(6334,'Recipe: Sealed Phoenix Ring(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,17420,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(6335,'Recipe: Sealed Majestic Necklace(70%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,52000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(6336,'Recipe: Sealed Majestic Necklace(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,52000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(6337,'Recipe: Sealed Majestic Earring(70%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,39000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(6338,'Recipe: Sealed Majestic Earring(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,39000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(6339,'Recipe: Sealed Majestic Ring(70%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,26000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(6340,'Recipe: Sealed Majestic Ring(100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',90,26000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(6341,'Sealed Phoenix Earring Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,7231,0,'true',0,1,'etc_gem_blue_i00',1,1,1),
(6342,'Sealed Majestic Earring Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,8829,0,'true',0,1,'etc_gem_blue_i00',1,1,1),
(6343,'Sealed Phoenix Necklace Beads','PIECES','false','material',60,'stackable','liquid','none',0,9354,0,'true',0,1,'etc_crystal_ball_green_i00',1,1,1),
(6344,'Sealed Majestic Necklace Beads','PIECES','false','material',60,'stackable','liquid','none',0,13643,0,'true',0,1,'etc_crystal_ball_green_i00',1,1,1),
(6345,'Sealed Phoenix Ring Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,5228,0,'true',0,1,'etc_gem_blue_i00',1,1,1),
(6346,'Sealed Majestic Ring Gemstone','PIECES','false','material',60,'stackable','liquid','none',0,6143,0,'true',0,1,'etc_gem_blue_i00',1,1,1),
(6350,'Amulet: Pa''agrio''s Honor','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,8700,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(6351,'Amulet: Ritual of Life','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,8200,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(6352,'Spellbook: Prayer','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,8700,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(6353,'Blue Gemstone','OTHER','false','quest',0,'stackable','liquid','none',0,0,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(6360,'Blue Seal Stone','OTHER','false','none',0,'stackable','gold','none',0,3,0,'true',0,1,'etc_water_rune_i00',1,1,1),
(6361,'Green Seal Stone','OTHER','false','none',0,'stackable','gold','none',0,5,0,'true',0,1,'etc_wind_rune_i00',1,1,1),
(6362,'Red Seal Stone','OTHER','false','none',0,'stackable','gold','none',0,10,0,'true',0,1,'etc_fire_rune_i00',1,1,1),
(6363,'Stolen Infernium Ore','OTHER','false','quest',0,'stackable','steel','none',0,200,0,'true',0,1,'etc_inf_ore_high_i00',1,1,1),
(6387,'Blessed Scroll of Resurrection for Pets','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,5000,0,'true',2179,1,'etc_scroll_of_resurrection_pet_i01',1,1,1),
(6388,'Lord of the Manor''s Certificate of Approval','OTHER','false','quest',0,'stackable','liquid','none',0,0,0,'false',0,1,'etc_permit_card_i00',1,1,1),
(6389,'Squash Seed','OTHER','false','none',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_gourd_i00',1,1,1),
(6390,'Large Squash Seed','OTHER','false','none',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_gourd_i01',1,1,1),
(6391,'Pollen','OTHER','false','none',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_nectar_i00',1,1,1),
(6392,'Event - Medal','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_event_medal_i00',1,1,1),
(6393,'Event - Glittering Medal','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_event_glitter_medal_i00',1,1,1),
(6395,'Amulet: Chant of Predator','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(6396,'Amulet: Chant of Eagle','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(6397,'Amulet: Chant of Vampire','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3850,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(6398,'Spellbook: Body of Avatar','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,4600,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(6399,'Badge of Rabbit','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_paper_black_i00',1,1,1),
(6400,'Badge of Hyena','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_paper_red_i00',1,1,1),
(6401,'Badge of Fox','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_paper_red_i00',1,1,1),
(6402,'Badge of Wolf','OTHER','false','quest',0,'stackable','crystal','none',100,0,0,'false',0,1,'etc_paper_red_i00',1,1,1),
(6403,'Star Shard','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',2023,1,'etc_fairy_fire_i00',1,1,1),
(6404,'Gunpowder','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_powder_black_i00',1,1,1),
(6405,'Magnesium','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(6406,'Firework','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',2024,1,'etc_small_ultra_bomb_i00',1,1,1),
(6407,'Large Firework','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',2025,1,'etc_ultra_bomb_i00',1,1,1),
(6409,'2006 Battle Tournament - CP Potion','CONSUMABLE','false','potion',500,'stackable','liquid','none',0,0,0,'false',0,1,'etc_cp_potion_i01',1,1,1),
(6410,'2006 Battle Tournament - Quick Healing Potion','CONSUMABLE','false','potion',180,'stackable','liquid','none',0,0,0,'false',0,1,'etc_potion_gold_i00',1,1,1),
(6411,'Small Nimble Green Fish','OTHER','false','none',100,'stackable','fish','none',0,138,0,'false',0,1,'etc_tuna_i06',1,1,1),
(6412,'Small Ugly Green Fish','OTHER','false','none',100,'stackable','fish','none',0,141,0,'false',0,1,'etc_angler_i06',1,1,1),
(6413,'Small Pudgy Green Fish','OTHER','false','none',100,'stackable','fish','none',0,153,0,'false',0,1,'etc_bream_i06',1,1,1),
(6414,'Nimble Green Fish','OTHER','false','none',100,'stackable','fish','none',0,167,0,'false',0,1,'etc_tuna_i06',1,1,1),
(6415,'Ugly Green Fish','OTHER','false','none',100,'stackable','fish','none',0,187,0,'false',0,1,'etc_angler_i06',1,1,1),
(6416,'Pudgy Green Fish','OTHER','false','none',100,'stackable','fish','none',0,208,0,'false',0,1,'etc_bream_i06',1,1,1),
(6417,'Large Nimble Green Fish','OTHER','false','none',100,'stackable','fish','none',0,225,0,'false',0,1,'etc_tuna_i06',1,1,1),
(6418,'Large Ugly Green Fish','OTHER','false','none',100,'stackable','fish','none',0,248,0,'false',0,1,'etc_angler_i06',1,1,1),
(6419,'Large Pudgy Green Fish','OTHER','false','none',100,'stackable','fish','none',0,265,0,'false',0,1,'etc_bream_i06',1,1,1),
(6420,'Small Jade Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,285,0,'false',0,1,'etc_tuna_i07',1,1,1),
(6421,'Small Jade Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,295,0,'false',0,1,'etc_angler_i07',1,1,1),
(6422,'Small Jade Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,310,0,'false',0,1,'etc_bream_i07',1,1,1),
(6423,'Jade Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,325,0,'false',0,1,'etc_tuna_i07',1,1,1),
(6424,'Jade Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,340,0,'false',0,1,'etc_angler_i07',1,1,1),
(6425,'Jade Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,355,0,'false',0,1,'etc_bream_i07',1,1,1),
(6426,'Big Jade Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,365,0,'false',0,1,'etc_tuna_i07',1,1,1),
(6427,'Big Jade Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,375,0,'false',0,1,'etc_angler_i07',1,1,1),
(6428,'Big Jade Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,385,0,'false',0,1,'etc_bream_i07',1,1,1),
(6429,'Small Blue Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,395,0,'false',0,1,'etc_tuna_i01',1,1,1),
(6430,'Small Blue Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,400,0,'false',0,1,'etc_angler_i01',1,1,1),
(6431,'Small Blue Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,410,0,'false',0,1,'etc_bream_i01',1,1,1),
(6432,'Blue Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,415,0,'false',0,1,'etc_tuna_i01',1,1,1),
(6433,'Blue Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,418,0,'false',0,1,'etc_angler_i01',1,1,1),
(6434,'Blue Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,420,0,'false',0,1,'etc_bream_i01',1,1,1),
(6435,'Big Blue Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,425,0,'false',0,1,'etc_tuna_i01',1,1,1),
(6436,'Big Blue Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,431,0,'false',0,1,'etc_angler_i01',1,1,1),
(6437,'Big Blue Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,435,0,'false',0,1,'etc_bream_i01',1,1,1),
(6438,'Small Yellow Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,442,0,'false',0,1,'etc_tuna_i02',1,1,1),
(6439,'Small Yellow Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,447,0,'false',0,1,'etc_angler_i02',1,1,1),
(6440,'Small Yellow Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,452,0,'false',0,1,'etc_bream_i02',1,1,1),
(6441,'Yellow Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,540,0,'false',0,1,'etc_tuna_i02',1,1,1),
(6442,'Yellow Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,553,0,'false',0,1,'etc_angler_i02',1,1,1),
(6443,'Yellow Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,568,0,'false',0,1,'etc_bream_i02',1,1,1),
(6444,'Big Yellow Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,580,0,'false',0,1,'etc_tuna_i02',1,1,1),
(6445,'Big Yellow Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,594,0,'false',0,1,'etc_angler_i02',1,1,1),
(6446,'Big Yellow Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,608,0,'false',0,1,'etc_bream_i02',1,1,1),
(6447,'Small Orange Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,622,0,'false',0,1,'etc_tuna_i08',1,1,1),
(6448,'Small Orange Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,635,0,'false',0,1,'etc_angler_i08',1,1,1),
(6449,'Small Orange Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,649,0,'false',0,1,'etc_bream_i08',1,1,1),
(6450,'Orange Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,663,0,'false',0,1,'etc_tuna_i08',1,1,1),
(6451,'Orange Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,776,0,'false',0,1,'etc_angler_i08',1,1,1),
(6452,'Orange Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,792,0,'false',0,1,'etc_bream_i08',1,1,1),
(6453,'Big Orange Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,816,0,'false',0,1,'etc_tuna_i08',1,1,1),
(6454,'Big Orange Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,840,0,'false',0,1,'etc_angler_i08',1,1,1),
(6455,'Big Orange Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,858,0,'false',0,1,'etc_bream_i08',1,1,1),
(6456,'Small Purple Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,875,0,'false',0,1,'etc_tuna_i04',1,1,1),
(6457,'Small Purple Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,893,0,'false',0,1,'etc_angler_i04',1,1,1),
(6458,'Small Purple Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,910,0,'false',0,1,'etc_bream_i04',1,1,1),
(6459,'Purple Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,930,0,'false',0,1,'etc_tuna_i04',1,1,1),
(6460,'Purple Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,948,0,'false',0,1,'etc_angler_i04',1,1,1),
(6461,'Purple Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,1090,0,'false',0,1,'etc_bream_i04',1,1,1),
(6462,'Big Purple Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,1111,0,'false',0,1,'etc_tuna_i04',1,1,1),
(6463,'Big Purple Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,1133,0,'false',0,1,'etc_angler_i04',1,1,1),
(6464,'Big Purple Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,1157,0,'false',0,1,'etc_bream_i04',1,1,1),
(6465,'Small Red Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,1277,0,'false',0,1,'etc_tuna_i03',1,1,1),
(6466,'Small Red Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,1301,0,'false',0,1,'etc_angler_i03',1,1,1),
(6467,'Small Red Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,1326,0,'false',0,1,'etc_bream_i03',1,1,1),
(6468,'Red Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,1351,0,'false',0,1,'etc_tuna_i03',1,1,1),
(6469,'Red Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,1376,0,'false',0,1,'etc_angler_i03',1,1,1),
(6470,'Red Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,1402,0,'false',0,1,'etc_bream_i03',1,1,1),
(6471,'Big Red Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,1577,0,'false',0,1,'etc_tuna_i03',1,1,1),
(6472,'Big Red Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,1608,0,'false',0,1,'etc_angler_i03',1,1,1),
(6473,'Big Red Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,1715,0,'false',0,1,'etc_bream_i03',1,1,1),
(6474,'Small White Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,1747,0,'false',0,1,'etc_tuna_i00',1,1,1),
(6475,'Small White Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,1781,0,'false',0,1,'etc_angler_i00',1,1,1),
(6476,'Small White Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,1814,0,'false',0,1,'etc_bream_i00',1,1,1),
(6477,'White Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,1849,0,'false',0,1,'etc_tuna_i00',1,1,1),
(6478,'White Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,1887,0,'false',0,1,'etc_angler_i00',1,1,1),
(6479,'White Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,1923,0,'false',0,1,'etc_bream_i00',1,1,1),
(6480,'Big White Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,1961,0,'false',0,1,'etc_tuna_i00',1,1,1),
(6481,'Big White Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,2000,0,'false',0,1,'etc_angler_i00',1,1,1),
(6482,'Big White Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,2039,0,'false',0,1,'etc_bream_i00',1,1,1),
(6483,'Small Black Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,2081,0,'false',0,1,'etc_tuna_i05',1,1,1),
(6484,'Small Black Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,2123,0,'false',0,1,'etc_angler_i05',1,1,1),
(6485,'Small Black Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,2166,0,'false',0,1,'etc_bream_i05',1,1,1),
(6486,'Black Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,2309,0,'false',0,1,'etc_tuna_i05',1,1,1),
(6487,'Black Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,2357,0,'false',0,1,'etc_angler_i05',1,1,1),
(6488,'Black Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,2403,0,'false',0,1,'etc_bream_i05',1,1,1),
(6489,'Big Black Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,2452,0,'false',0,1,'etc_tuna_i05',1,1,1),
(6490,'Big Black Ugly Fish','OTHER','false','none',100,'stackable','fish','none',0,2502,0,'false',0,1,'etc_angler_i05',1,1,1),
(6491,'Big Black Fat Fish','OTHER','false','none',100,'stackable','fish','none',0,2552,0,'false',0,1,'etc_bream_i05',1,1,1),
(6492,'Small Green Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,153,0,'false',0,1,'etc_treasure_box_i06',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(6493,'Green Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,208,0,'false',0,1,'etc_treasure_box_i06',1,1,1),
(6494,'Big Green Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,265,0,'false',0,1,'etc_treasure_box_i06',1,1,1),
(6495,'Small Jade Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,285,0,'false',0,1,'etc_treasure_box_i07',1,1,1),
(6496,'Jade Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,315,0,'false',0,1,'etc_treasure_box_i07',1,1,1),
(6497,'Big Jade Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,345,0,'false',0,1,'etc_treasure_box_i07',1,1,1),
(6498,'Small Blue Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,395,0,'false',0,1,'etc_treasure_box_i01',1,1,1),
(6499,'Blue Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,419,0,'false',0,1,'etc_treasure_box_i01',1,1,1),
(6500,'Big Blue Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,435,0,'false',0,1,'etc_treasure_box_i01',1,1,1),
(6501,'Small Yellow Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,452,0,'false',0,1,'etc_treasure_box_i02',1,1,1),
(6502,'Yellow Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,568,0,'false',0,1,'etc_treasure_box_i02',1,1,1),
(6503,'Big Yellow Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,608,0,'false',0,1,'etc_treasure_box_i02',1,1,1),
(6504,'Small Orange Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,649,0,'false',0,1,'etc_treasure_box_i08',1,1,1),
(6505,'Orange Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,792,0,'false',0,1,'etc_treasure_box_i08',1,1,1),
(6506,'Big Orange Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,858,0,'false',0,1,'etc_treasure_box_i08',1,1,1),
(6507,'Small Purple Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,910,0,'false',0,1,'etc_treasure_box_i04',1,1,1),
(6508,'Purple Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,1090,0,'false',0,1,'etc_treasure_box_i04',1,1,1),
(6509,'Big Purple Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,1157,0,'false',0,1,'etc_treasure_box_i04',1,1,1),
(6510,'Small Red Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,1326,0,'false',0,1,'etc_treasure_box_i03',1,1,1),
(6511,'Red Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,1402,0,'false',0,1,'etc_treasure_box_i03',1,1,1),
(6512,'Big Red Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,1715,0,'false',0,1,'etc_treasure_box_i03',1,1,1),
(6513,'Small White Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,1814,0,'false',0,1,'etc_treasure_box_i00',1,1,1),
(6514,'White Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,1923,0,'false',0,1,'etc_treasure_box_i00',1,1,1),
(6515,'Big White Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,2039,0,'false',0,1,'etc_treasure_box_i00',1,1,1),
(6516,'Small Black Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,2166,0,'false',0,1,'etc_treasure_box_i05',1,1,1),
(6517,'Black Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,2403,0,'false',0,1,'etc_treasure_box_i05',1,1,1),
(6518,'Big Black Treasure Chest','OTHER','false','none',100,'stackable','fish','none',0,2552,0,'false',0,1,'etc_treasure_box_i05',1,1,1),
(6519,'Green Colored Lure - Low Grade','EQUIPMENT','false','bait',5,'stackable','liquid','none',0,100,0,'true',0,1,'etc_bait_i00',1,1,1),
(6520,'Green Colored Lure','EQUIPMENT','false','bait',4,'stackable','liquid','none',0,120,0,'true',0,1,'etc_bait_i00',1,1,1),
(6521,'Green Colored Lure - High Grade','EQUIPMENT','false','bait',3,'stackable','liquid','none',0,150,0,'true',0,1,'etc_bait_i00',1,1,1),
(6522,'Purple Colored Lure - Low Grade','EQUIPMENT','false','bait',5,'stackable','liquid','none',0,150,0,'true',0,1,'etc_bait_i01',1,1,1),
(6523,'Purple Colored Lure','EQUIPMENT','false','bait',4,'stackable','liquid','none',0,180,0,'true',0,1,'etc_bait_i01',1,1,1),
(6524,'Purple Colored Lure - High Grade','EQUIPMENT','false','bait',3,'stackable','liquid','none',0,200,0,'true',0,1,'etc_bait_i01',1,1,1),
(6525,'Yellow Colored Lure - Low Grade','EQUIPMENT','false','bait',5,'stackable','liquid','none',0,120,0,'true',0,1,'etc_bait_i02',1,1,1),
(6526,'Yellow Colored Lure','EQUIPMENT','false','bait',4,'stackable','liquid','none',0,150,0,'true',0,1,'etc_bait_i02',1,1,1),
(6527,'Yellow Colored Lure - High Grade','EQUIPMENT','false','bait',3,'stackable','liquid','none',0,180,0,'true',0,1,'etc_bait_i02',1,1,1),
(6528,'Event bait','EQUIPMENT','false','bait',3,'stackable','liquid','none',0,100,0,'false',0,1,'etc_special_bait_i00',1,1,1),
(6535,'Fishing Shot: non-grade','OTHER','false','none',3,'stackable','paper','none',0,3,0,'true',0,1,'etc_spirit_bullet_fish_i00',1,1,1),
(6536,'Fishing Shot: D-grade','OTHER','false','none',3,'stackable','paper','d',0,5,0,'true',0,1,'etc_spirit_bullet_fish_i01',1,1,1),
(6537,'Fishing Shot: C-grade','OTHER','false','none',3,'stackable','paper','c',0,7,0,'true',0,1,'etc_spirit_bullet_fish_i02',1,1,1),
(6538,'Fishing Shot: B-grade','OTHER','false','none',3,'stackable','paper','b',0,25,0,'true',0,1,'etc_spirit_bullet_fish_i03',1,1,1),
(6539,'Fishing Shot: A-grade','OTHER','false','none',3,'stackable','paper','a',0,40,0,'true',0,1,'etc_spirit_bullet_fish_i04',1,1,1),
(6540,'Fishing Shot: S-grade','OTHER','false','none',3,'stackable','paper','s',0,50,0,'true',0,1,'etc_spirit_bullet_fish_i05',1,1,1),
(6541,'Blue Coba','OTHER','false','seed',2,'stackable','paper','none',0,1250,0,'false',0,1,'etc_blue_coba_i00',1,1,1),
(6542,'Red Coba','OTHER','false','seed',2,'stackable','paper','none',0,1500,0,'false',0,1,'etc_red_coba_i00',1,1,1),
(6543,'Gold Coba','OTHER','false','seed',2,'stackable','paper','none',0,1750,0,'false',0,1,'etc_golden_coba_i00',1,1,1),
(6544,'Desert Coba','OTHER','false','seed',2,'stackable','paper','none',0,2000,0,'false',0,1,'etc_desert_coba_i00',1,1,1),
(6545,'Sea Coba','OTHER','false','seed',2,'stackable','paper','none',0,2250,0,'false',0,1,'etc_sea_coba_i00',1,1,1),
(6546,'Twin Coba','OTHER','false','seed',2,'stackable','paper','none',0,2500,0,'false',0,1,'etc_twin_coba_i00',1,1,1),
(6547,'King Coba','OTHER','false','seed',2,'stackable','paper','none',0,2750,0,'false',0,1,'etc_great_coba_i00',1,1,1),
(6548,'Alternative Blue Coba','OTHER','false','seed',2,'stackable','paper','none',0,1250,0,'false',0,1,'etc_blue_coba_i00',1,1,1),
(6549,'Alternative Red Coba','OTHER','false','seed',2,'stackable','paper','none',0,1500,0,'false',0,1,'etc_red_coba_i00',1,1,1),
(6550,'Alternative Gold Coba','OTHER','false','seed',2,'stackable','paper','none',0,1750,0,'false',0,1,'etc_golden_coba_i00',1,1,1),
(6551,'Alternative Desert Coba','OTHER','false','seed',2,'stackable','paper','none',0,2000,0,'false',0,1,'etc_desert_coba_i00',1,1,1),
(6552,'Alternative Sea Coba','OTHER','false','seed',2,'stackable','paper','none',0,2250,0,'false',0,1,'etc_sea_coba_i00',1,1,1),
(6553,'Alternative Twin Coba','OTHER','false','seed',2,'stackable','paper','none',0,2500,0,'false',0,1,'etc_twin_coba_i00',1,1,1),
(6554,'Alternative King Coba','OTHER','false','seed',2,'stackable','paper','none',0,2750,0,'false',0,1,'etc_great_coba_i00',1,1,1),
(6555,'Ripe Blue Coba','OTHER','false','seed',1,'stackable','paper','none',0,1250,0,'false',0,1,'etc_blue_coba_i00',1,1,1),
(6556,'Ripe Red Coba','OTHER','false','seed',1,'stackable','paper','none',0,1500,0,'false',0,1,'etc_red_coba_i00',1,1,1),
(6557,'Ripe Gold Coba','OTHER','false','seed',1,'stackable','paper','none',0,1750,0,'false',0,1,'etc_golden_coba_i00',1,1,1),
(6558,'Ripe Desert Coba','OTHER','false','seed',1,'stackable','paper','none',0,2000,0,'false',0,1,'etc_desert_coba_i00',1,1,1),
(6559,'Ripe Sea Coba','OTHER','false','seed',1,'stackable','paper','none',0,2250,0,'false',0,1,'etc_sea_coba_i00',1,1,1),
(6560,'Ripe Twin Coba','OTHER','false','seed',1,'stackable','paper','none',0,2500,0,'false',0,1,'etc_twin_coba_i00',1,1,1),
(6561,'Ripe King Coba','OTHER','false','seed',1,'stackable','paper','none',0,2750,0,'false',0,1,'etc_great_coba_i00',1,1,1),
(6562,'Ripe Alternative Blue Coba','OTHER','false','seed',1,'stackable','paper','none',0,1250,0,'false',0,1,'etc_blue_coba_i00',1,1,1),
(6563,'Ripe Alternative Red Coba','OTHER','false','seed',1,'stackable','paper','none',0,1500,0,'false',0,1,'etc_red_coba_i00',1,1,1),
(6564,'Ripe Alternative Gold Coba','OTHER','false','seed',1,'stackable','paper','none',0,1750,0,'false',0,1,'etc_golden_coba_i00',1,1,1),
(6565,'Ripe Alternative Desert Coba','OTHER','false','seed',1,'stackable','paper','none',0,2000,0,'false',0,1,'etc_desert_coba_i00',1,1,1),
(6566,'Ripe Alternative Sea Coba','OTHER','false','seed',1,'stackable','paper','none',0,2250,0,'false',0,1,'etc_sea_coba_i00',1,1,1),
(6567,'Ripe Alternative Twin Coba','OTHER','false','seed',1,'stackable','paper','none',0,2500,0,'false',0,1,'etc_twin_coba_i00',1,1,1),
(6568,'Ripe Alternative King Coba','OTHER','false','seed',1,'stackable','paper','none',0,2750,0,'false',0,1,'etc_great_coba_i00',1,1,1),
(6569,'Blessed Scroll: Enchant Weapon (A)','OTHER','false','scroll',120,'stackable','paper','none',0,15000000,0,'true',0,1,'etc_blessed_scrl_of_ench_wp_a_i04',1,1,1),
(6570,'Blessed Scroll: Enchant Armor (A)','OTHER','false','scroll',120,'stackable','paper','none',0,1800000,0,'true',0,1,'etc_blessed_scrl_of_ench_am_a_i04',1,1,1),
(6571,'Blessed Scroll: Enchant Weapon (B)','OTHER','false','scroll',120,'stackable','paper','none',0,7000000,0,'true',0,1,'etc_blessed_scrl_of_ench_wp_b_i03',1,1,1),
(6572,'Blessed Scroll: Enchant Armor (B)','OTHER','false','scroll',120,'stackable','paper','none',0,750000,0,'true',0,1,'etc_blessed_scrl_of_ench_am_b_i03',1,1,1),
(6573,'Blessed Scroll: Enchant Weapon (C)','OTHER','false','scroll',120,'stackable','paper','none',0,3000000,0,'true',0,1,'etc_blessed_scrl_of_ench_wp_c_i02',1,1,1),
(6574,'Blessed Scroll: Enchant Armor (C)','OTHER','false','scroll',120,'stackable','paper','none',0,350000,0,'true',0,1,'etc_blessed_scrl_of_ench_am_c_i02',1,1,1),
(6575,'Blessed Scroll: Enchant Weapon (D)','OTHER','false','scroll',120,'stackable','paper','none',0,900000,0,'true',0,1,'etc_blessed_scrl_of_ench_wp_d_i01',1,1,1),
(6576,'Blessed Scroll: Enchant Armor (D)','OTHER','false','scroll',120,'stackable','paper','none',0,100000,0,'true',0,1,'etc_blessed_scrl_of_ench_am_d_i01',1,1,1),
(6577,'Blessed Scroll: Enchant Weapon (S)','OTHER','false','scroll',120,'stackable','paper','none',0,30000000,0,'true',0,1,'etc_blessed_scrl_of_ench_wp_s_i05',1,1,1),
(6578,'Blessed Scroll: Enchant Armor (S)','OTHER','false','scroll',120,'stackable','paper','none',0,4500000,0,'true',0,1,'etc_blessed_scrl_of_ench_am_s_i05',1,1,1),
(6622,'Secret Book of Giants','OTHER','false','none',10,'normal','paper','none',0,500000,0,'false',0,1,'etc_codex_of_giant_i00',1,1,1),
(6623,'Dummy - Quest Item 1','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i00',1,1,1),
(6624,'Dummy - Quest Item 2','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i00',1,1,1),
(6625,'Dummy - Quest Item 3','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i00',1,1,1),
(6626,'Dummy - Quest Item 4','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i00',1,1,1),
(6627,'Dummy - Quest Item 5','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i00',1,1,1),
(6628,'Dummy - Quest Item 6','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i00',1,1,1),
(6629,'Dummy - Quest Item 7','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i00',1,1,1),
(6630,'Dummy - Quest Item 8','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i00',1,1,1),
(6631,'Dummy - Quest Item 9','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i00',1,1,1),
(6632,'Dummy - Quest Item 10','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i00',1,1,1),
(6633,'Dummy - General Item 1','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i01',1,1,1),
(6634,'Dummy - General Item 2','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i01',1,1,1),
(6635,'Dummy - General Item 3','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i01',1,1,1),
(6636,'Dummy - General Item 4','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i01',1,1,1),
(6637,'Dummy - General Item 5','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i01',1,1,1),
(6638,'Dummy - General Item 6','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i01',1,1,1),
(6639,'Dummy - General Item 7','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i01',1,1,1),
(6640,'Dummy - General Item 8','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i01',1,1,1),
(6641,'Dummy - General Item 9','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i01',1,1,1),
(6642,'Dummy - General Item 10','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_socks_i01',1,1,1),
(6643,'Golden Spice','OTHER','false','none',40,'stackable','paper','none',0,50,0,'true',2188,1,'etc_pouch_yellow_i00',1,1,1),
(6644,'Crystal Spice','OTHER','false','none',40,'stackable','paper','none',0,50,0,'true',2189,1,'etc_pouch_brown_i00',1,1,1),
(6645,'Beast Soulshot','CONSUMABLE','false','none',1,'stackable','paper','none',0,20,0,'true',0,1,'etc_beast_soul_shot_i00',1,1,1),
(6646,'Beast Spiritshot','CONSUMABLE','false','none',2,'stackable','paper','none',0,40,0,'true',0,1,'etc_beast_spirit_shot_i00',1,1,1),
(6647,'Blessed Beast Spiritshot','CONSUMABLE','false','none',2,'stackable','paper','none',0,100,0,'true',0,1,'etc_blessed_beast_spirit_shot_i00',1,1,1),
(6648,'Baby Buffalo Panpipe','OTHER','false','pet_collar',20,'normal','leather','none',0,100000,0,'false',0,1,'etc_buffalo_panpipe_i00',1,1,1),
(6649,'Baby Cougar Chime','OTHER','false','pet_collar',20,'normal','leather','none',0,100000,0,'false',0,1,'etc_cougar_chime_i00',1,1,1),
(6650,'Baby Kookaburra Ocarina','OTHER','false','pet_collar',20,'normal','leather','none',0,100000,0,'false',0,1,'etc_kukaburo_ocarina_i00',1,1,1),
(6651,'Noblesse Gate Pass','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_nobless_teleport_coupon_i00',1,1,1),
(6652,'Scroll: Protection of Valakas','SPELLBOOKS','false','spellbook',10,'stackable','paper','none',0,100000,0,'false',0,1,'etc_blesscharm_ward_val_i00',1,1,1),
(6653,'Scroll: Flames of Valakas','SPELLBOOKS','false','spellbook',10,'stackable','paper','none',0,5000,0,'false',0,1,'etc_aidcharm_cancel_deathfire_i00',1,1,1),
(6654,'Scroll: Flames of Valakas','SPELLBOOKS','false','spellbook',10,'stackable','paper','none',0,40000,0,'false',0,1,'etc_aidcharm_cancel_valbreath_i00',1,1,1),
(6655,'Scroll: Slay Valakas','SPELLBOOKS','false','spellbook',10,'stackable','paper','none',0,80000,0,'false',0,1,'etc_blesscharm_slay_val_i00',1,1,1),
(6663,'Scroll of Escape: Orc Village','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,100000,0,'true',0,1,'etc_scroll_of_return_agit_i00',1,1,0),
(6664,'Scroll of Escape: Silenos Village','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,100000,0,'true',0,1,'etc_scroll_of_return_agit_i00',1,1,0),
(6665,'Deluxe Chest Key - Grade 1','OTHER','false','none',10,'stackable','steel','none',0,130,0,'true',2065,1,'etc_old_key_i00',1,1,1),
(6666,'Deluxe Chest Key - Grade 2','OTHER','false','none',10,'stackable','steel','none',0,200,0,'true',2065,2,'etc_old_key_i00',1,1,1),
(6667,'Deluxe Chest Key - Grade 3','OTHER','false','none',10,'stackable','steel','none',0,320,0,'true',2065,3,'etc_old_key_i00',1,1,1),
(6668,'Deluxe Chest Key - Grade 4','OTHER','false','none',10,'stackable','steel','none',0,560,0,'true',2065,4,'etc_old_key_i00',1,1,1),
(6669,'Deluxe Chest Key - Grade 5','OTHER','false','none',10,'stackable','steel','none',0,860,0,'true',2065,5,'etc_old_key_i00',1,1,1),
(6670,'Deluxe Chest Key - Grade 6','OTHER','false','none',10,'stackable','steel','none',0,1200,0,'true',2065,6,'etc_old_key_i00',1,1,1),
(6671,'Deluxe Chest Key - Grade 7','OTHER','false','none',10,'stackable','steel','none',0,1800,0,'true',2065,7,'etc_old_key_i00',1,1,1),
(6672,'Deluxe Chest Key - Grade 8','OTHER','false','none',10,'stackable','steel','none',0,2400,0,'true',2065,8,'etc_old_key_i00',1,1,1),
(6673,'Festival Adena','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_coin_of_fair_i00',1,1,1),
(6688,'Forgotten Blade Edge','PIECES','false','material',60,'stackable','liquid','none',0,92529,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(6689,'Basalt Battlehammer Head','PIECES','false','material',60,'stackable','liquid','none',0,94306,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(6690,'Imperial Staff Head','PIECES','false','material',60,'stackable','liquid','none',0,92353,0,'true',0,1,'etc_bark_blue_i00',1,1,1),
(6691,'Angel Slayer Blade','PIECES','false','material',60,'stackable','liquid','none',0,92529,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(6692,'Shining Bow Shaft','PIECES','false','material',60,'stackable','liquid','none',0,91471,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(6693,'Dragon Hunter Axe Blade','PIECES','false','material',60,'stackable','liquid','none',0,90882,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(6694,'Saint Spear Blade','PIECES','false','material',60,'stackable','liquid','none',0,90882,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(6695,'Demon Splinter Blade','PIECES','false','material',60,'stackable','liquid','none',0,94306,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(6696,'Heavens Divider Edge','PIECES','false','material',60,'stackable','liquid','none',0,91082,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(6697,'Arcana Mace Head','PIECES','false','material',60,'stackable','liquid','none',0,94306,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(6698,'Sealed Tateossian Earring Part','PIECES','false','material',60,'stackable','liquid','none',0,10182,0,'true',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(6699,'Sealed Tateossian Ring Gem','PIECES','false','material',60,'stackable','liquid','none',0,9176,0,'true',0,1,'etc_crystal_ball_gold_i00',1,1,1),
(6700,'Sealed Tateossian Necklace Chain','PIECES','false','material',60,'stackable','liquid','none',0,16706,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(6701,'Sealed Imperial Crusader Breastplate Part','PIECES','false','material',60,'stackable','liquid','none',0,37565,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(6702,'Sealed Imperial Crusader Gaiters Pattern','PIECES','false','material',60,'stackable','liquid','none',0,29182,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(6703,'Sealed Imperial Crusader Gauntlets Design','PIECES','false','material',60,'stackable','liquid','none',0,14047,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(6704,'Sealed Imperial Crusader Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,14047,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(6705,'Sealed Imperial Crusader Shield Part','PIECES','false','material',60,'stackable','liquid','none',0,14341,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(6706,'Sealed Imperial Crusader Helmet Pattern','PIECES','false','material',60,'stackable','liquid','none',0,12329,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(6707,'Sealed Draconic Leather Armor Part','PIECES','false','material',60,'stackable','liquid','none',0,40365,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(6708,'Sealed Draconic Leather Gloves Fabric','PIECES','false','material',60,'stackable','liquid','none',0,14047,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(6709,'Sealed Draconic Leather Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,14047,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(6710,'Sealed Draconic Leather Helmet Pattern','PIECES','false','material',60,'stackable','liquid','none',0,12329,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(6711,'Sealed Major Arcana Robe Part','PIECES','false','material',60,'stackable','liquid','none',0,40365,0,'true',0,1,'etc_plate_silver_i00',1,1,1),
(6712,'Sealed Major Arcana Gloves fabric','PIECES','false','material',60,'stackable','liquid','none',0,14047,0,'true',0,1,'etc_leather_gray_i00',1,1,1),
(6713,'Sealed Major Arcana Boots Design','PIECES','false','material',60,'stackable','liquid','none',0,14047,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(6714,'Sealed Major Arcana Circlet Pattern','PIECES','false','material',60,'stackable','liquid','none',0,12329,0,'true',0,1,'etc_pouch_brown_i00',1,1,1),
(6727,'Seed: Alternative Great Coba','OTHER','false','seed',1,'stackable','paper','none',0,1200,0,'false',0,1,'etc_great_coba_seed_i00',1,1,1),
(6728,'Seed: Alternative Sea Coba','OTHER','false','seed',1,'stackable','paper','none',0,900,0,'false',0,1,'etc_sea_coba_seed_i00',1,1,1),
(6729,'Seed: Alternative Sea Coba','OTHER','false','seed',1,'stackable','paper','none',0,900,0,'false',0,1,'etc_sea_coba_seed_i00',1,1,1),
(6730,'Seed: Alternative Sea Coba','OTHER','false','seed',1,'stackable','paper','none',0,900,0,'false',0,1,'etc_sea_coba_seed_i00',1,1,1),
(6731,'Seed: Alternative Red Coba','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_red_coba_seed_i00',1,1,1),
(6732,'Seed: Alternative Red Coba','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_red_coba_seed_i00',1,1,1),
(6733,'Seed: Alternative Red Coba','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_red_coba_seed_i00',1,1,1),
(6734,'Seed: Alternative Red Coba','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_red_coba_seed_i00',1,1,1),
(6735,'Seed: Alternative Red Coba','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_red_coba_seed_i00',1,1,1),
(6736,'Seed: Alternative Desert Coba','OTHER','false','seed',1,'stackable','paper','none',0,750,0,'false',0,1,'etc_desert_coba_seed_i00',1,1,1),
(6737,'Seed: Alternative Desert Coba','OTHER','false','seed',1,'stackable','paper','none',0,750,0,'false',0,1,'etc_desert_coba_seed_i00',1,1,1),
(6738,'Seed: Alternative Desert Coba','OTHER','false','seed',1,'stackable','paper','none',0,750,0,'false',0,1,'etc_desert_coba_seed_i00',1,1,1),
(6739,'Seed: Alternative Desert Coba','OTHER','false','seed',1,'stackable','paper','none',0,750,0,'false',0,1,'etc_desert_coba_seed_i00',1,1,1),
(6740,'Seed: Alternative Desert Coba','OTHER','false','seed',1,'stackable','paper','none',0,750,0,'false',0,1,'etc_desert_coba_seed_i00',1,1,1),
(6741,'Seed: Alternative Twin Coba','OTHER','false','seed',1,'stackable','paper','none',0,1000,0,'false',0,1,'etc_twin_coba_seed_i00',1,1,1),
(6742,'Seed: Alternative Blue Coba','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'false',0,1,'etc_blue_coba_seed_i00',1,1,1),
(6743,'Seed: Alternative Blue Coba','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'false',0,1,'etc_blue_coba_seed_i00',1,1,1),
(6744,'Seed: Alternative Blue Coba','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'false',0,1,'etc_blue_coba_seed_i00',1,1,1),
(6745,'Seed: Alternative Blue Coba','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'false',0,1,'etc_blue_coba_seed_i00',1,1,1),
(6746,'Seed: Alternative Blue Coba','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'false',0,1,'etc_blue_coba_seed_i00',1,1,1),
(6747,'Seed: Alternative Golden Coba','OTHER','false','seed',1,'stackable','paper','none',0,650,0,'false',0,1,'etc_golden_coba_seed_i00',1,1,1),
(6748,'Seed: Alternative Golden Coba','OTHER','false','seed',1,'stackable','paper','none',0,650,0,'false',0,1,'etc_golden_coba_seed_i00',1,1,1),
(6749,'Seed: Alternative Golden Coba','OTHER','false','seed',1,'stackable','paper','none',0,650,0,'false',0,1,'etc_golden_coba_seed_i00',1,1,1),
(6750,'Seed: Alternative Golden Coba','OTHER','false','seed',1,'stackable','paper','none',0,650,0,'false',0,1,'etc_golden_coba_seed_i00',1,1,1),
(6751,'Seed: Alternative Golden Coba','OTHER','false','seed',1,'stackable','paper','none',0,650,0,'false',0,1,'etc_golden_coba_seed_i00',1,1,1),
(6752,'Seed: Alternative Golden Coba','OTHER','false','seed',1,'stackable','paper','none',0,650,0,'false',0,1,'etc_golden_coba_seed_i00',1,1,1),
(6753,'Seed: Great Coba','OTHER','false','seed',1,'stackable','paper','none',0,1200,0,'false',0,1,'etc_great_coba_seed_i00',1,1,1),
(6754,'Seed: Sea Coba','OTHER','false','seed',1,'stackable','paper','none',0,900,0,'false',0,1,'etc_sea_coba_seed_i00',1,1,1),
(6755,'Seed: Sea Coba','OTHER','false','seed',1,'stackable','paper','none',0,900,0,'false',0,1,'etc_sea_coba_seed_i00',1,1,1),
(6756,'Seed: Sea Coba','OTHER','false','seed',1,'stackable','paper','none',0,900,0,'false',0,1,'etc_sea_coba_seed_i00',1,1,1),
(6757,'Seed: Red Coba','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_red_coba_seed_i00',1,1,1),
(6758,'Seed: Red Coba','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_red_coba_seed_i00',1,1,1),
(6759,'Seed: Red Coba','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_red_coba_seed_i00',1,1,1),
(6760,'Seed: Red Coba','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_red_coba_seed_i00',1,1,1),
(6761,'Seed: Red Coba','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'false',0,1,'etc_red_coba_seed_i00',1,1,1),
(6762,'Seed: Desert Coba','OTHER','false','seed',1,'stackable','paper','none',0,750,0,'false',0,1,'etc_desert_coba_seed_i00',1,1,1),
(6763,'Seed: Desert Coba','OTHER','false','seed',1,'stackable','paper','none',0,750,0,'false',0,1,'etc_desert_coba_seed_i00',1,1,1),
(6764,'Seed: Desert Coba','OTHER','false','seed',1,'stackable','paper','none',0,750,0,'false',0,1,'etc_desert_coba_seed_i00',1,1,1),
(6765,'Seed: Desert Coba','OTHER','false','seed',1,'stackable','paper','none',0,750,0,'false',0,1,'etc_desert_coba_seed_i00',1,1,1),
(6766,'Seed: Desert Coba','OTHER','false','seed',1,'stackable','paper','none',0,750,0,'false',0,1,'etc_desert_coba_seed_i00',1,1,1),
(6767,'Seed: Twin Coba','OTHER','false','seed',1,'stackable','paper','none',0,1000,0,'false',0,1,'etc_twin_coba_seed_i00',1,1,1),
(6768,'Seed: Blue Coba','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'false',0,1,'etc_blue_coba_seed_i00',1,1,1),
(6769,'Seed: Blue Coba','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'false',0,1,'etc_blue_coba_seed_i00',1,1,1),
(6770,'Seed: Blue Coba','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'false',0,1,'etc_blue_coba_seed_i00',1,1,1),
(6771,'Seed: Blue Coba','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'false',0,1,'etc_blue_coba_seed_i00',1,1,1),
(6772,'Seed: Blue Coba','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'false',0,1,'etc_blue_coba_seed_i00',1,1,1),
(6773,'Seed: Golden Coba','OTHER','false','seed',1,'stackable','paper','none',0,650,0,'false',0,1,'etc_golden_coba_seed_i00',1,1,1),
(6774,'Seed: Golden Coba','OTHER','false','seed',1,'stackable','paper','none',0,650,0,'false',0,1,'etc_golden_coba_seed_i00',1,1,1),
(6775,'Seed: Golden Coba','OTHER','false','seed',1,'stackable','paper','none',0,650,0,'false',0,1,'etc_golden_coba_seed_i00',1,1,1),
(6776,'Seed: Golden Coba','OTHER','false','seed',1,'stackable','paper','none',0,650,0,'false',0,1,'etc_golden_coba_seed_i00',1,1,1),
(6777,'Seed: Golden Coba','OTHER','false','seed',1,'stackable','paper','none',0,650,0,'false',0,1,'etc_golden_coba_seed_i00',1,1,1),
(6778,'Seed: Golden Coba','OTHER','false','seed',1,'stackable','paper','none',0,650,0,'false',0,1,'etc_golden_coba_seed_i00',1,1,1),
(6779,'Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6780,'Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6781,'Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6782,'Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6783,'Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6784,'Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6785,'Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6786,'Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6787,'Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6788,'Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6789,'Mercenary Posting Ticket (Teleporter1)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(6790,'Mercenary Posting Ticket (Teleporter2)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(6791,'Mercenary Posting Ticket (Teleporter3)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(6792,'Greater Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6793,'Greater Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6794,'Greater Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6795,'Greater Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6796,'Greater Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6797,'Greater Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6798,'Greater Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6799,'Greater Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6800,'Greater Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6801,'Greater Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6802,'Dawn Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6803,'Dawn Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6804,'Dawn Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6805,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6806,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6807,'Dawn Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6808,'Dawn Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6809,'Dawn Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6810,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6811,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6812,'Greater Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6813,'Greater Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6814,'Greater Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6815,'Greater Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(6816,'Greater Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6817,'Greater Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6818,'Greater Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6819,'Greater Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6820,'Greater Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6821,'Greater Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6822,'Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(6823,'Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(6824,'Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(6825,'Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_fix_i00',1,1,1),
(6826,'Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(6827,'Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6828,'Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(6829,'Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(6830,'Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(6831,'Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6832,'Nephilim Warrior Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,2500000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(6833,'Nephilim Shaman Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,5000000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(6847,'Recipe: Sealed Tateossian Earring (70%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,74000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6848,'Recipe: Sealed Tateossian Earring (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,74000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6849,'Recipe: Sealed Tateossian Ring(70%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,49400,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6850,'Recipe: Sealed Tateossian Ring(100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,49400,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6851,'Recipe: Sealed Tateossian Necklace(70%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,98800,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6852,'Recipe: Sealed Tateossian Necklace(100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,98800,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6853,'Recipe: Sealed Imperial Crusader Breastplate (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,286000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6854,'Recipe: Sealed Imperial Crusader Breastplate (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,286000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6855,'Recipe: Sealed Imperial Crusader Gaiters (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,179200,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6856,'Recipe: Sealed Imperial Crusader Gaiters (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,179200,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6857,'Recipe: Sealed Imperial Crusader Gauntlets (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,71600,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6858,'Recipe: Sealed Imperial Crusader Gauntlets (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,71600,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6859,'Recipe: Sealed Imperial Crusader Boots (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,71600,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6860,'Recipe: Sealed Imperial Crusader Boots (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,71600,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6861,'Recipe: Sealed Imperial Crusader Shield (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,75200,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6862,'Recipe: Sealed Imperial Crusader Shield (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,75200,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6863,'Recipe: Sealed Imperial Crusader Helmet (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,107400,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6864,'Recipe: Sealed Imperial Crusader Helmet (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,107400,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6865,'Recipe: Sealed Draconic Leather Armor (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,348000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6866,'Recipe: Sealed Draconic Leather Armor (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,348000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6867,'Recipe: Sealed DraconicA LeatherA Gloves (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,71600,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6868,'Recipe: Sealed DraconicA LeatherA Gloves (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,71600,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6869,'Recipe: Sealed DraconicA LeatherA Boots (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,71600,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6870,'Recipe: Sealed DraconicA LeatherA Boots (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,71600,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6871,'Recipe: Sealed Draconic Leather Helmet (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,107400,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6872,'Recipe: Sealed Draconic Leather Helmet (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,107400,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6873,'Recipe: Sealed Major Arcana Robe (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,348000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6874,'Recipe: Sealed Major Arcana Robe (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,348000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6875,'Recipe: Sealed Major Arcana Gloves (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,71600,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6876,'Recipe: Sealed Major Arcana Gloves (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,71600,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6877,'Recipe: Sealed Major Arcana Boots (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,71600,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6878,'Recipe: Sealed Major Arcana Boots (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,71600,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6879,'Recipe: Sealed Major Arcana Circlet (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,107400,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6880,'Recipe: Sealed Major Arcana Circlet (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,107400,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6881,'Recipe: Forgotten Blade (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6882,'Recipe: Forgotten Blade (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6883,'Recipe: Basalt Battlehammer (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6884,'Recipe: Basalt Battlehammer (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6885,'Recipe: Imperial Staff (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6886,'Recipe: Imperial Staff(100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6887,'Recipe: Angel Slayer (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6888,'Recipe: Angel Slayer (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6889,'Recipe: Shining Bow (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6890,'Recipe: Shining Bow (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6891,'Recipe: Dragon Hunter Axe (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6892,'Recipe: Dragon Hunter Axe (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6893,'Recipe: Saint Spear (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6894,'Recipe: Saint Spear (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(6895,'Recipe: Demon Splinter (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6896,'Recipe: Demon Splinter (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6897,'Recipe: Heavens Divider (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6898,'Recipe: Heavens Divider (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6899,'Recipe: Arcana Mace (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6900,'Recipe: Arcana Mace (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6901,'Recipe: Shining Arrow (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,200000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(6903,'Music Box M','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_m_i00',1,1,1),
(6904,'Party Mask Fabric','PIECES','false','material',60,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_piece_of_cloth_blue_i00',1,1,1),
(6905,'Hair Pin Piece','PIECES','false','material',60,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_broken_crystal_green_i00',1,1,1),
(6906,'Pirate''s Eye Patch Material','PIECES','false','material',60,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_braided_hemp_i00',1,1,1),
(6907,'Monocle Piece','PIECES','false','material',60,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_bark_blue_i00',1,1,1),
(6908,'Fish Oil','MATHERIALS','false','material',30,'stackable','liquid','none',0,50,0,'true',0,1,'etc_fish_oil_i00',1,1,1),
(6909,'Greater Fish Oil','MATHERIALS','false','material',30,'stackable','liquid','none',0,250,0,'true',0,1,'etc_fish_oil_i01',1,1,1),
(6910,'Premium Fish Oil','MATHERIALS','false','material',30,'stackable','liquid','none',0,1250,0,'true',0,1,'etc_fish_oil_i02',1,1,1),
(6911,'Fish Scale','MATHERIALS','false','material',30,'stackable','liquid','none',0,200,0,'true',0,1,'etc_fish_scale_i00',1,1,1),
(6912,'Shiny Fish Scale','MATHERIALS','false','material',30,'stackable','liquid','none',0,300,0,'true',0,1,'etc_fish_scale_i01',1,1,1),
(6913,'Fish Gem','MATHERIALS','false','material',30,'stackable','liquid','none',0,500,0,'true',0,1,'etc_fish_gem_i00',1,1,1),
(6914,'Shiny Fish Gem','MATHERIALS','false','material',30,'stackable','liquid','none',0,1000,0,'true',0,1,'etc_fish_gem_i01',1,1,1),
(6915,'Thin Fish Bone','MATHERIALS','false','material',30,'stackable','liquid','none',0,300,0,'true',0,1,'etc_fang_gray_i00',1,1,1),
(6916,'Thick Fish Bone','MATHERIALS','false','material',30,'stackable','liquid','none',0,450,0,'true',0,1,'etc_fang_ivory_i00',1,1,1),
(6920,'Recipe: Greater Fish Oil (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,50,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6921,'Recipe: Premium Fish Oil(100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,250,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6922,'Recipe: Party Mask (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,100000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6923,'Recipe: Lady''s Hair Pin (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,100000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6924,'Recipe: Pirate''s Eye Patch (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,100000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6925,'Recipe: Monocle (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,100000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6926,'Recipe: Lesser Healing Potion (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,18,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6927,'Recipe: Healing Potion (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,66,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6928,'Recipe: Greater Healing Potion (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,180,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6929,'Recipe: Antidote (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,15,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6930,'Recipe: Greater Antidote (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,36,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6931,'Recipe: Bandage (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,15,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6932,'Recipe: Emergency Dressing (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,36,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6933,'Recipe: Haste Potion (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,240,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6934,'Recipe: Potion of Alacrity (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,480,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6935,'Recipe: Greater Haste Potion (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,600,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6936,'Recipe: Greater Swift Attack Potion (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,1200,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6937,'Recipe: Magic Haste Potion (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,480,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6938,'Recipe: Greater Magic Haste Potion (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,1200,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6939,'Recipe: Mystery Potion (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,2000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6940,'Recipe: Facelifting Potion - A (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,4000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6941,'Recipe: Facelifting Potion - B (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,4000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6942,'Recipe: Facelifting Potion - C (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,4000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6943,'Recipe: Dye Potion - A (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,4000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6944,'Recipe: Dye Potion - B (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,4000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6945,'Recipe: Dye Potion - C (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,4000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6946,'Recipe: Dye Potion - D (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,4000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6947,'Recipe: Hair Style Change Potion - A (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,4000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6948,'Recipe: Hair Style Change Potion - B (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,4000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6949,'Recipe: Hair Style Change Potion - C (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,4000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6950,'Recipe: Hair Style Change Potion - D (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,4000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6951,'Recipe: Hair Style Change Potion - E (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,4000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6952,'Recipe: Hair Style Change Potion - F (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,4000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6953,'Recipe: Hair Style Change Potion - G (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,4000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6954,'Recipe: Dye of STR <Str+1 Con-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,7000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6955,'Recipe: Dye of STR <Str+1 Dex-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,7000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6956,'Recipe: Dye of CON <Con+1 Str-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,7000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6957,'Recipe: Dye of CON <Con+1 Dex-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,7000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6958,'Recipe: Dye of DEX <Dex+1 Str-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,7000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6959,'Recipe: Dye of DEX <Dex+1 Con-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,7000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6960,'Recipe: Dye of INT <Int+1 Men-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,7000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6961,'Recipe: Dye of INT <Int+1 Wit-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,7000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6962,'Recipe: Dye of MEN <Men+1 Int-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,7000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6963,'Recipe: Dye of MEN <Men+1 Wit-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,7000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6964,'Recipe: Dye of WIT<Wit+1 Int-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,7000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6965,'Recipe: Dye of WIT<Wit+1 Men-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,7000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6966,'Recipe: Greater Dye of STR <Str+1 Con-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,10000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6967,'Recipe: Greater Dye of STR <Str+1 Dex-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,10000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6968,'Recipe: Greater Dye of CON <Con+1 Str-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,10000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6969,'Recipe: Greater Dye of CON <Con+1 Dex-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,10000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6970,'Recipe: Greater Dye of DEX <Dex+1 Str-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,10000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6971,'Recipe: Greater Dye of DEX <Dex+1 Con-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,10000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6972,'Recipe: Greater Dye of INT <Int+1 Men-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,10000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6973,'Recipe: Greater Dye of INT <Int+1 Wit-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,10000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6974,'Recipe: Greater Dye of MEN <Men+1 Int-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,10000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6975,'Recipe: Greater Dye of MEN <Men+1 Wit-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,10000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6976,'Recipe: Greater Dye of WIT<Wit+1 Int-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,10000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6977,'Recipe: Greater Dye of WIT<Wit+1 Men-1> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,10000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6978,'Recipe: Greater Dye of STR <Str+2 Con-2> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,12000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6979,'Recipe: Greater Dye of STR <Str+2 Dex-2> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,12000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6980,'Recipe: Greater Dye of CON <Con+2 Str-2> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,12000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6981,'Recipe: Greater Dye of CON <Con+2 Dex-2> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,12000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6982,'Recipe: Greater Dye of DEX <Dex+2 Str-2> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,12000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6983,'Recipe: Greater Dye of DEX <Dex+2 Con-2> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,12000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6984,'Recipe: Greater Dye of INT <Int+2 Men-2> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,12000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6985,'Recipe: Greater Dye of INT <Int+2 Wit-2> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,12000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6986,'Recipe: Greater Dye of MEN <Men+2 Int-2> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,12000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6987,'Recipe: Greater Dye of MEN <Men+2 Wit-2> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,12000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6988,'Recipe: Greater Dye of WIT<Wit+2 Int-2> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,12000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6989,'Recipe: Greater Dye of WIT<Wit+2 Men-2> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,12000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6990,'Recipe: Greater Dye of STR <Str+3 Con-3> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,18000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6991,'Recipe: Greater Dye of STR <Str+3 Dex-3> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,18000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6992,'Recipe: Greater Dye of CON <Con+3 Str-3> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,18000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6993,'Recipe: Greater Dye of CON <Con+3 Dex-3> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,18000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6994,'Recipe: Greater Dye of DEX <Dex+3 Str-3> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,18000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6995,'Recipe: Greater Dye of DEX <Dex+3 Con-3> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,18000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6996,'Recipe: Greater Dye of INT <Int+3 Men-3> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,18000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6997,'Recipe: Greater Dye of INT <Int+3 Wit-3> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,18000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6998,'Recipe: Greater Dye of MEN <Men+3 Int-3> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,18000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(6999,'Recipe: Greater Dye of MEN <Men+3 Wit-3> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,18000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7000,'Recipe: Greater Dye of WIT<Wit+3 Int-3> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,18000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7001,'Recipe: Greater Dye of WIT<Wit+3 Men-3> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,18000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7002,'Recipe: Greater Dye of STR <Str+4 Con-4> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,29000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7003,'Recipe: Greater Dye of STR <Str+4 Dex-4> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,29000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7004,'Recipe: Greater Dye of CON <Con+4 Str-4> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,29000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7005,'Recipe: Greater Dye of CON <Con+4 Dex-4> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,29000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7006,'Recipe: Greater Dye of DEX <Dex+4 Str-4> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,29000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7007,'Recipe: Greater Dye of DEX <Dex+4 Con-4> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,29000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7008,'Recipe: Greater Dye of INT <Int+4 Men-4> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,29000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7009,'Recipe: Greater Dye of INT <Int+4 Wit-4> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,29000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7010,'Recipe: Greater Dye of MEN <Men+4 Int-4> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,29000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7011,'Recipe: Greater Dye of MEN <Men+4 Wit-4> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,29000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7012,'Recipe: Greater Dye of WIT<Wit+4 Int-4> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,29000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7013,'Recipe: Greater Dye of WIT<Wit+4 Men-4> (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,29000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7016,'Seed: Blue Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(7017,'Seed: Blue Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7018,'Seed: Blue Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7019,'Seed: Chilly Cobol','OTHER','false','seed',1,'stackable','paper','none',0,25,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(7020,'Seed: Chilly Coda','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(7021,'Seed: Chilly Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7022,'Seed: Chilly Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7023,'Seed: Desert Codran','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7024,'Seed: Desert Codran','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7025,'Seed: Golden Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(7026,'Seed: Golden Coda','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(7027,'Seed: Great Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(7028,'Seed: Great Codran','OTHER','false','seed',1,'stackable','paper','none',0,75,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7029,'Seed: Great Codran','OTHER','false','seed',1,'stackable','paper','none',0,75,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7030,'Seed: Alternative Blue Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(7031,'Seed: Alternative Blue Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7032,'Seed: Alternative Blue Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7033,'Seed: Alternative Chilly Cobol','OTHER','false','seed',1,'stackable','paper','none',0,25,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(7034,'Seed: Alternative Chilly Coda','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(7035,'Seed: Alternative Chilly Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7036,'Seed: Alternative Chilly Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7037,'Seed: Alternative Desert Codran','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7038,'Seed: Alternative Desert Codran','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7039,'Seed: Alternative Golden Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(7040,'Seed: Alternative Golden Coda','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_coda_seed_i00',1,1,1),
(7041,'Seed: Alternative Great Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(7042,'Seed: Alternative Great Codran','OTHER','false','seed',1,'stackable','paper','none',0,75,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7043,'Seed: Alternative Great Codran','OTHER','false','seed',1,'stackable','paper','none',0,75,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7044,'Seed: Alternative Red Cobol','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(7045,'Seed: Alternative Red Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7046,'Seed: Alternative Red Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7047,'Seed: Alternative Sea Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7048,'Seed: Alternative Sea Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7049,'Seed: Alternative Sea Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7050,'Seed: Alternative Twin Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7051,'Seed: Red Cobol','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'false',0,1,'etc_cobol_seed_i00',1,1,1),
(7052,'Seed: Red Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7053,'Seed: Red Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7054,'Seed: Sea Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7055,'Seed: Sea Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7056,'Seed: Sea Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7057,'Seed: Twin Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'false',0,1,'etc_codran_seed_i00',1,1,1),
(7061,'Echo Crystal - Theme of Birthday','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i00',1,1,1),
(7062,'Echo Crystal - Theme of Wedding','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i01',1,1,1),
(7063,'Map - Forest of the Dead','OTHER','false','quest',1,'normal','paper','none',0,0,0,'false',0,1,'etc_map_ivory_i00',1,1,1),
(7064,'Lidia''s Diary','OTHER','false','quest',1,'normal','paper','none',0,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(7065,'Lidia''s Letter','OTHER','false','quest',1,'normal','paper','none',0,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(7066,'Contract','OTHER','false','quest',1,'normal','paper','none',0,0,0,'false',0,1,'etc_permit_card_i00',1,1,1),
(7067,'Special Bait 1','EQUIPMENT','false','bait',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_ultra_bomb_i00',1,1,1),
(7068,'Special Bait 2','EQUIPMENT','false','bait',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_ultra_bomb_i00',1,1,1),
(7069,'Special Bait 3','EQUIPMENT','false','bait',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_ultra_bomb_i00',1,1,1),
(7070,'Special Bait 4','EQUIPMENT','false','bait',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_ultra_bomb_i00',1,1,1),
(7071,'Special Fish 1','EQUIPMENT','false','bait',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(7072,'Special Fish 2','EQUIPMENT','false','bait',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(7073,'Special Fish 3','EQUIPMENT','false','bait',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(7074,'Special Fish 4','EQUIPMENT','false','bait',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(7075,'Entrance Pass to the Sepulcher','OTHER','false','scroll',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_bead_silver_i00',1,1,1),
(7076,'Mysterious Cloth','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_piece_of_cloth_white_i00',1,1,1),
(7077,'Jewel Box','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_treasure_box_i02',1,1,1),
(7078,'Sewing Kit','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_treasure_box_i00',1,1,1),
(7079,'Dimensional Fragment','OTHER','false','none',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_broken_crystal_blue_i00',1,1,1),
(7080,'Ice Crystal','OTHER','false','quest',0,'normal','paper','none',0,20000,0,'false',0,1,'etc_crystal_blue_i00',1,1,1),
(7081,'Divine Stone of Wisdom','OTHER','false','quest',10,'normal','paper','none',0,10000,0,'false',0,1,'etc_stone_gray_i00',1,1,1),
(7082,'Guild Report','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_magic_book_red_i00',1,1,1),
(7083,'Guild Report','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_magic_book_red_i00',1,1,1),
(7084,'Guild Report','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_magic_book_red_i00',1,1,1),
(7085,'Guild Report','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_magic_book_red_i00',1,1,1),
(7086,'Guild Report','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_magic_book_red_i00',1,1,1),
(7087,'Tattered Book','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(7088,'Tattered Book','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(7089,'Tattered Book','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(7090,'Tattered Book','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(7091,'Guild Report','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(7092,'Guild Report','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(7093,'Sculpture of the Fallen Knight','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(7094,'Record of Mother Tree Guardian','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(7095,'Criticism of Biel''s Song','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(7096,'The Last Days of Swordsman Iron','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(7097,'Contemplation of White Wing Army','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(7098,'Record of Traitor Muhark','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(7099,'Secret Book of Khavatari','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(7100,'Importance of Strain','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(7101,'Danger of Ice Spirit','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(7102,'Guardian Angel of the Tablet - Vol. 1','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(7103,'Guardian Angel of the Tablet - Vol. 1','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(7104,'Guardian Angel of the Tablet - Vol. 1','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_spellbook_gray_i00',1,1,1),
(7105,'Guardian Angel of the Tablet - Vol. 2','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_magic_book_red_i00',1,1,1),
(7106,'Guardian Angel of the Tablet - Vol. 2','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_magic_book_red_i00',1,1,1),
(7107,'Guardian Angel of the Tablet - Vol. 2','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_magic_book_red_i00',1,1,1),
(7108,'Guild''s Secret Report','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_magic_book_red_i00',1,1,1),
(7109,'Guild''s Secret Report','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_magic_book_red_i00',1,1,1),
(7110,'Research Report','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_magic_book_red_i00',1,1,1),
(7111,'Research Report','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_magic_book_red_i00',1,1,1),
(7112,'Research Report','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'etc_magic_book_red_i00',1,1,1),
(7113,'Dress Shoe Box','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(7114,'Voucher - Buffalo','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ticket_i00',1,1,1),
(7115,'Voucher - Cougar','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ticket_blue_i00',1,1,1),
(7116,'Voucher - Kookaburra','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ticket_red_i00',1,1,1),
(7117,'Scroll of Escape: Talking Island','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,1,'etc_scroll_of_return_i00',1,1,0),
(7118,'Scroll of Escape: Elven Village','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,2,'etc_scroll_of_return_i00',1,1,0),
(7119,'Scroll of Escape: Dark Elf Village','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,3,'etc_scroll_of_return_i00',1,1,0),
(7120,'Scroll of Escape: Orc Village','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,4,'etc_scroll_of_return_i00',1,1,0),
(7121,'Scroll of Escape: Dwarven Village','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,5,'etc_scroll_of_return_i00',1,1,0),
(7122,'Scroll of Escape: Gludin Village','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,6,'etc_scroll_of_return_i00',1,1,0),
(7123,'Scroll of Escape: the Town of Gludio','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,7,'etc_scroll_of_return_i00',1,1,0),
(7124,'Scroll of Escape: the Town of Dion','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,8,'etc_scroll_of_return_i00',1,1,0),
(7125,'Scroll of Escape: Floran','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,9,'etc_scroll_of_return_i00',1,1,0),
(7126,'Scroll of Escape: Giran Castle Town','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,10,'etc_scroll_of_return_i00',1,1,0),
(7127,'Scroll of Escape: Hardin''s Private Academy','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,11,'etc_scroll_of_return_i00',1,1,0),
(7128,'Scroll of Escape: Heine','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,12,'etc_scroll_of_return_i00',1,1,0),
(7129,'Scroll of Escape: the Town of Oren','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,13,'etc_scroll_of_return_i00',1,1,0),
(7130,'Scroll of Escape: Ivory Tower','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,14,'etc_scroll_of_return_i00',1,1,0),
(7131,'Scroll of Escape: Hunters Village','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,15,'etc_scroll_of_return_i00',1,1,0),
(7132,'Scroll of Escape: Aden Castle Town','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,16,'etc_scroll_of_return_i00',1,1,0),
(7133,'Scroll of Escape: the Town of Goddard','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,17,'etc_scroll_of_return_i00',1,1,0),
(7134,'Scroll of Escape: the Rune Township','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,18,'etc_scroll_of_return_i00',1,1,0),
(7135,'Scroll of Escape: the Town of Schuttgart.','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,19,'etc_scroll_of_return_i00',1,1,0),
(7136,'Fruit Basket','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_handbag_i00',1,1,1),
(7137,'Avellan Spice','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_dragon_blood_i00',1,1,1),
(7138,'Honey Pouch','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_seed_yellow_i00',1,1,1),
(7139,'Bracelet of Lizardman','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_leash_i00',1,1,1),
(7140,'Cross of Einhasad','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_cross_of_einhasad_i00',1,1,1),
(7141,'Cross of Einhasad','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_cross_of_einhasad_i00',1,1,1),
(7142,'Lost Skull of Elf','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(7143,'Letter of Innocentin','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_letter_envelope_i00',1,1,1),
(7144,'Jewel of Adventurer','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_green_i00',1,1,1),
(7145,'Jewel of Adventurer','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(7146,'Sealed Report Box','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(7147,'Report Box','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(7148,'Lidia''s Hairpin','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_flower_i00',1,1,1),
(7149,'Silver Key','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_old_key_i03',1,1,1),
(7150,'Silver Spear','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'weapon_winged_spear_i01',1,1,1),
(7151,'Suspicious Totem Doll','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_totem_necklace_black_i00',1,1,1),
(7152,'Flower Bouquet','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_flower_bouquet_i01',1,1,1),
(7153,'Silver Cross of Einhasad','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_cross_of_einhasad_i00',1,1,1),
(7154,'Broken Silver Cross of Einhasad','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_cross_of_einhasad_i01',1,1,1),
(7155,'Lidia''s Dress','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ladys_dress_i00',1,1,1),
(7156,'Suspicious Totem Doll','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_totem_necklace_black_i00',1,1,1),
(7157,'Gemstone Key','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_old_key_i00',1,1,1),
(7158,'Suspicious Totem Doll','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_totem_necklace_black_i00',1,1,1),
(7159,'Box of Cookies','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(7160,'Luxury Wine','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_luxury_wine_a_i00',1,1,1),
(7161,'Skein of Yarn','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_skein_white_i00',1,1,1),
(7162,'Rough Jewel','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_stone_gray_i00',1,1,1),
(7163,'Enchanted Iron','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_lump_blue_i00',1,1,1),
(7164,'Signet Ring','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_royal_seal_of_lord_i04',1,1,1),
(7165,'Map','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_map_yellow_i00',1,1,1),
(7166,'Medicinal Herb','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ginseng_red_i00',1,1,1),
(7167,'Crystal of Seal','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(7168,'Blood of Saint','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_dragon_blood_i00',1,1,1),
(7169,'Blood of Saint','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_dragons_blood_i01',1,1,1),
(7170,'Seal of Light','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_white_i00',1,1,1),
(7171,'Bead of Obedience','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_crystal_ball_silver_i00',1,1,1),
(7172,'Gem of Saints','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_crystal_ball_silver_i00',1,1,1),
(7173,'Feather Ornament','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_feather_white_i00',1,1,1),
(7174,'Tooth of Totem','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(7175,'Tooth of Dragon','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_claw_i00',1,1,1),
(7176,'Letter of Iris','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_letter_envelope_i00',1,1,1),
(7177,'Letter of Rohmer','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(7178,'Black Bone Necklace','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_totem_necklace_black_i00',1,1,1),
(7179,'Red Bone Necklace','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_totem_necklace_red_i00',1,1,1),
(7180,'Incense Pouch','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(7181,'Gem of Maille Lizardman','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_crystal_ball_blue_i00',1,1,1),
(7182,'Patrol''s Report','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_roll_of_paper_black_i00',1,1,1),
(7183,'Shining Gem','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_crystal_ball_blue_i00',1,1,1),
(7184,'Shining Red Gem','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_bead_red_i00',1,1,1),
(7185,'Jewel of Innocence','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_crystal_ball_white_i00',1,1,1),
(7186,'Horn of Buffalo','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(7187,'Nepenthes Seed','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_seed_green_i00',1,1,1),
(7188,'Proof of Avenger','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_blue_i00',1,1,1),
(7189,'Eye of Darkness','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7190,'Evil Spirit of Darkness','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_bead_silver_i00',1,1,1),
(7191,'Broken Crystal','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(7192,'Unfinished Summon Crystal','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_crystal_ball_silver_i00',1,1,1),
(7193,'Summon Crystal','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_crystal_ball_gold_i00',1,1,1),
(7194,'Essence of Daimon','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_stone_black_i00',1,1,1),
(7195,'Boiled Eggs','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_egg_bundle_i00',1,1,1),
(7196,'Fee of Boiled Egg','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_coins_gold_i00',1,1,1),
(7197,'Special Drink','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_winebottle_white_i00',1,1,1),
(7198,'Fee of Special Drink','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_coins_gold_i00',1,1,1),
(7199,'Leaf of Flava','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_herb_green_i00',1,1,1),
(7200,'Buffalo Meat','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_meat_i00',1,1,1),
(7201,'Antelope Horn','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_horn_i00',1,1,1),
(7202,'Trunk of Nepenthes','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ginseng_gray_i00',1,1,1),
(7203,'Foot of Bandersnatchling','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_meat_i00',1,1,1),
(7204,'Secret Spice','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_lesser_potion_purple_i00',1,1,1),
(7205,'Soy Sauce Jar','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(7206,'Boiled Eggs for Delivery','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_egg_bundle_i00',1,1,1),
(7207,'Special Drink for Delivery','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_winebottle_white_i00',1,1,1),
(7208,'Hot Food Box','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(7209,'Food for Bumbalump','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_food_dish_i00',1,1,1),
(7210,'Special Yeti Meat','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_meat_i00',1,1,1),
(7211,'Mark of Ketra''s Alliance - Level 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ketra_friendship_1_i00',1,1,1),
(7212,'Mark of Ketra''s Alliance - Level 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ketra_friendship_2_i00',1,1,1),
(7213,'Mark of Ketra''s Alliance - Level 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ketra_friendship_3_i00',1,1,1),
(7214,'Mark of Ketra''s Alliance - Level 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ketra_friendship_4_i00',1,1,1),
(7215,'Mark of Ketra''s Alliance - Level 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ketra_friendship_5_i00',1,1,1),
(7216,'Varka''s Badge - Soldier','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_barka_badge_grunt_i00',1,1,1),
(7217,'Varka''s Badge - Captain','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_barka_badge_captin_i01',1,1,1),
(7218,'Varka''s Badge - General','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_barka_badge_officer_i02',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(7219,'Totem of Valor','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_royal_seal_of_lord_i00',1,1,1),
(7220,'Totem of Wisdom','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_imperial_scepter_i02',1,1,1),
(7221,'Mark of Varka''s Alliance - Level 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_barka_friendship_1_i00',1,1,1),
(7222,'Mark of Varka''s Alliance - Level 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_barka_friendship_2_i00',1,1,1),
(7223,'Mark of Varka''s Alliance - Level 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_barka_friendship_3_i00',1,1,1),
(7224,'Mark of Varka''s Alliance - Level 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_barka_friendship_4_i00',1,1,1),
(7225,'Mark of Varka''s Alliance - Level 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_barka_friendship_5_i00',1,1,1),
(7226,'Ketra''s Badge - Soldier','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ketra_badge_grunt_i00',1,1,1),
(7227,'Ketra''s Badge - Captain','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ketra_badge_captn_i01',1,1,1),
(7228,'Ketra''s Badge - General','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ketra_badge_officer_i02',1,1,1),
(7229,'Feather of Valor','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_royal_seal_of_lord_i00',1,1,1),
(7230,'Feather of Wisdom','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_imperial_scepter_i02',1,1,1),
(7231,'Munitions Box','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_squares_wood_i00',1,1,1),
(7232,'Munitions Box','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_squares_wood_i00',1,1,1),
(7233,'Varka''s Mane','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_mane_i00',1,1,1),
(7234,'Molar of Ketra Orc','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_molar_white_i00',1,1,1),
(7235,'Head of Shadith','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(7236,'Head of Mos','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(7237,'Stolen Green Totem','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_totem_green_i00',1,1,1),
(7238,'Green Totem','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_totem_green_i00',1,1,1),
(7239,'Ice Heart of Ashutar','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_blue_i00',1,1,1),
(7240,'Head of Hekaton','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_skull_white_i00',1,1,1),
(7241,'Head of Tayr','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_skull_red_i00',1,1,1),
(7242,'Stolen Red Totem','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_totem_red_i00',1,1,1),
(7243,'Red Totem','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_totem_red_i00',1,1,1),
(7244,'Fire Heart of Nastron','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_red_i00',1,1,1),
(7245,'Supply Box','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_squares_wood_i00',1,1,1),
(7246,'Golden Ram Badge - Recruit','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_badge_silver_i00',1,1,1),
(7247,'Golden Ram Badge - Soldier','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_badge_gold_i00',1,1,1),
(7248,'Splinter Stakato Chitin','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_scale_of_medusa_green_i00',1,1,1),
(7249,'Needle Stakato Chitin','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_scale_of_medusa_blue_i00',1,1,1),
(7250,'Talon of Stakato','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_fang_ivory_i00',1,1,1),
(7251,'Golden Ram Coin','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ticket_blue_i00',1,1,1),
(7252,'Krorin''s Journal','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(7253,'Letter to Archaeologist','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(7254,'Broken Relic Part','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(7255,'Sealed Box','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(7256,'Goblet of Alectia','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_holy_grail_i00',1,1,1),
(7257,'Goblet of Tishas','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_holy_grail_i01',1,1,1),
(7258,'Goblet of Mekara','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_holy_grail_i02',1,1,1),
(7259,'Goblet of Morigul','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_holy_grail_i03',1,1,1),
(7260,'Chapel Key','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_key_i00',1,1,1),
(7261,'Used Grave Pass','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_bead_white_i00',1,1,1),
(7262,'Antique Brooch','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_silver_i00',1,1,1),
(7263,'Package to Vulcan','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(7264,'Torch','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_torch_on_i00',1,1,1),
(7265,'Vacualite Ore','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(7266,'Vacualite','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_vacualite_noglow_white_i00',1,1,1),
(7267,'Floating Stone','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_vacualite_glowing_white_i00',1,1,1),
(7268,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7269,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7270,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7271,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7272,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7273,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7274,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7275,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7276,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7277,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7278,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7279,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7280,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7281,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7282,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7283,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7284,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7285,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7286,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7287,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7288,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7289,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7290,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7291,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7292,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7293,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7294,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7295,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7296,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7297,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7298,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7299,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7300,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7301,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7302,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7303,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7304,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7305,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7306,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7307,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7308,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7309,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7310,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7311,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7312,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7313,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7314,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7315,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7316,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7317,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7318,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7319,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7320,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7321,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7322,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7323,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7324,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7325,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7326,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7327,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7328,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7329,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7330,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7331,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7332,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7333,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7334,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7335,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7336,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7337,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7338,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7339,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7340,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7341,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7342,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7343,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7344,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7345,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7346,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7347,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7348,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7349,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7350,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7351,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7352,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7353,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7354,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7355,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7356,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7357,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7358,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7359,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7360,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7361,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7362,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7363,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7364,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7365,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7366,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7367,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7368,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7369,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7370,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7371,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7372,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7373,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7374,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7375,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7376,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7377,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7378,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7379,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7380,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7381,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7382,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7383,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7384,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7385,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7386,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7387,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7388,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7389,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7390,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7391,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7392,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7393,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7394,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7395,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7396,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7397,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7398,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7399,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7400,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7401,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7402,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7403,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7404,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7405,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7406,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7407,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7408,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7409,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7410,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7411,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7412,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7413,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7414,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7415,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7416,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7417,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7418,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7419,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7420,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7421,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7422,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7423,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7424,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7425,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7426,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7427,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7428,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7429,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7430,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7431,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7432,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7433,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7434,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7435,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7436,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7437,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7438,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7439,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7440,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7441,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7442,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7443,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7444,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7445,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7446,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7447,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7448,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7449,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7450,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7451,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7452,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7453,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7454,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7455,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7456,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7457,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7458,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7459,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7460,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7461,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7462,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7463,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7464,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7465,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7466,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7467,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7468,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7469,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7470,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7471,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7472,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7473,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7474,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7475,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7476,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7477,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7478,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7479,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7480,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7481,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7482,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7483,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7484,'Resonance Amulet - 7','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_resonance_amulet_i00',1,1,1),
(7485,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7486,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7487,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7488,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7489,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7490,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7491,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7492,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7493,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7494,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7495,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7496,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7497,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7498,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7499,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7500,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7501,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7502,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7503,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7504,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7505,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7506,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7507,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7508,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7509,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7510,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7511,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7512,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7513,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7514,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7515,'Halisha''s Mark','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7516,'Ice Wine','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_luxury_wine_c_i00',1,1,1),
(7517,'Donath''s'' Dish','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_fish_seawater_i02',1,1,1),
(7518,'Donath''s'' Note - Vol.1','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_spell_books_hfighter_i00',1,1,1),
(7519,'Shaved Ice','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_broken_crystal_white_i00',1,1,1),
(7520,'Ice Cream','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_cobol_i00',1,1,1),
(7521,'Ice Crystal Gemstone','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_deco_beed_i00',1,1,1),
(7522,'Offering','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(7523,'Offering','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(7524,'Offering','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(7525,'Offering','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(7526,'Ancient Language Dictionary','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(7527,'Ancient Language Dictionary','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(7528,'Spinneret','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_squares_silver_i00',1,1,1),
(7529,'Investigative Report','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(7530,'Investigative Report','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(7531,'Investigative Report','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(7532,'Investigative Report','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(7533,'Investigative Report','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_spell_books_red_i00',1,1,1),
(7534,'Ice Cold Flower','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_flower_i02',1,1,1),
(7535,'Pure Ice','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i01',1,1,1),
(7536,'Bitter Cold Beer','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_oil_pot_black_i00',1,1,1),
(7537,'Multiple Course Meal','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(7538,'Dead Souls Fish Soup','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_fish_seawater_i02',1,1,1),
(7539,'Bitter Cold Vodka','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_luxury_wine_c_i00',1,1,1),
(7540,'Silver Crystal','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_crystal_silver_i00',1,1,1),
(7541,'Red Crystal','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_crystal_red_i00',1,1,1),
(7542,'Vampire''s Heart','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_bodypart_heart_i00',1,1,1),
(7543,'Zombie''s Brain','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_bodypart_brain_i00',1,1,1),
(7544,'Rib Bone of a Black Magus','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_rib_black_i00',1,1,1),
(7545,'Zombie''s Liver','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_bodypart_liver_i00',1,1,1),
(7546,'Top Quality Meat','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_meat_of_monstereye_i00',1,1,1),
(7547,'Young Wild Beast Meat','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_meat_i00',1,1,1),
(7548,'Map Piece','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_map_piece_yellow_i00',1,1,1),
(7549,'Yellow Map','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_map_yellow_i00',1,1,1),
(7550,'Map Piece','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_map_piece_ivory_i00',1,1,1),
(7551,'Ivory Colored Map','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_map_ivory_i00',1,1,1),
(7552,'Broken Gemstone Fragment','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_broken_crystal_gold_i00',1,1,1),
(7553,'Gold Colored Gemstone','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_gem_yellow_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(7554,'Scroll of Escape: Talking Island','CONSUMABLE','false','scroll',0,'normal','paper','none',0,0,0,'false',2214,1,'etc_scroll_of_return_i00',1,1,0),
(7555,'Scroll of Escape: Elven Village','CONSUMABLE','false','scroll',0,'normal','paper','none',0,0,0,'false',2214,2,'etc_scroll_of_return_i00',1,1,0),
(7556,'Scroll of Escape: Dark Elf Village','CONSUMABLE','false','scroll',0,'normal','paper','none',0,0,0,'false',2214,3,'etc_scroll_of_return_i00',1,1,0),
(7557,'Scroll of Escape: Orc Village','CONSUMABLE','false','scroll',0,'normal','paper','none',0,0,0,'false',2214,4,'etc_scroll_of_return_i00',1,1,0),
(7558,'Scroll of Escape: Dwarven Village','CONSUMABLE','false','scroll',0,'normal','paper','none',0,0,0,'false',2214,5,'etc_scroll_of_return_i00',1,1,0),
(7559,'Scroll of Escape: Giran Castle Town','CONSUMABLE','false','scroll',0,'normal','paper','none',0,0,0,'false',2214,10,'etc_scroll_of_return_i00',1,1,0),
(7561,'Fishing Manual','OTHER','false','none',0,'normal','paper','none',0,100,0,'false',0,1,'etc_spellbook_blue_i00',1,1,1),
(7562,'Dimensional Diamond','OTHER','false','none',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_gem_clear_i00',1,1,1),
(7563,'Gwains (Document)','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(7564,'Gwains (Document)','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(7565,'Gwains (Document)','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(7566,'Purified Magic Necklace','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_evil_necklace_i00',1,1,1),
(7567,'Gemstone Powder','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_powder_orange_i00',1,1,1),
(7568,'Magic Sword Hilt','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_hilt_i00',1,1,1),
(7569,'Four-leaf Golden Clover Coin','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_gold_knight_i00',1,1,1),
(7570,'Mark of Traveler','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_crest_yellow_i00',1,1,1),
(7571,'Baulro''s Letter','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(7572,'Ariel''s Recommendation','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(7573,'Roselyn''s Note','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_paper_black_i00',1,1,1),
(7574,'Very Expensive Necklace','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'accessary_necklace_of_devotion_i00',1,1,1),
(7579,'Draconic Bow Shaft','PIECES','false','material',60,'stackable','liquid','none',0,91471,0,'true',0,1,'etc_branch_gold_i00',1,1,1),
(7580,'Recipe: Draconic Bow (60%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'false',0,1,'etc_recipe_black_i00',1,1,1),
(7581,'Recipe: Draconic Bow (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,976000,0,'false',0,1,'etc_recipe_black_i00',1,1,1),
(7582,'Baby Spice','OTHER','false','none',10,'stackable','liquid','none',0,100,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(7583,'Pet Exchange Ticket: Buffalo','OTHER','false','none',20,'stackable','paper','none',0,500000,0,'false',0,1,'etc_ticket_red_i00',1,1,1),
(7584,'Pet Exchange Ticket: Cougar','OTHER','false','none',20,'stackable','paper','none',0,500000,0,'false',0,1,'etc_ticket_red_i00',1,1,1),
(7585,'Pet Exchange Ticket: Kookaburra','OTHER','false','none',20,'stackable','paper','none',0,500000,0,'false',0,1,'etc_ticket_red_i00',1,1,1),
(7586,'Sweet Fluid','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_potion_gold_i00',1,1,1),
(7587,'Legend of Seventeen','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_piece_of_paper_gray_i00',1,1,1),
(7588,'Faded Poetry Book','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_spellbook_red_i00',1,1,1),
(7589,'Echo Crystal - Forgotten Song','OTHER','false','quest',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i02',1,1,1),
(7590,'Strand of Golden Hair','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_braided_hemp_i00',1,1,1),
(7591,'Ring of Goddess: Waterbinder','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'accessary_elven_ring_i00',1,1,1),
(7592,'Necklace of Goddess: EverGreen','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'accessary_elemental_necklace_i00',1,1,1),
(7593,'Staff of Goddess: Rain Song','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'weapon_sprites_staff_i00',1,1,1),
(7594,'Relic Box','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_treasure_box_i01',1,1,1),
(7595,'Orb of Binding','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_crystal_ball_silver_i00',1,1,1),
(7596,'Sorcery Ingredient','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_oil_pot_white_i00',1,1,1),
(7597,'Malruk Succubus Claw','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_fang_gray_i00',1,1,1),
(7598,'Crimson Moss','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_powder_red_i00',1,1,1),
(7599,'Rahorakti''s Miraculous Medicine','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_potion_scarlet_i00',1,1,1),
(7600,'Worn Tarot Card - Wealth','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_piece_of_report_i00',1,1,1),
(7601,'Worn Tarot Card - Power','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_piece_of_report_i00',1,1,1),
(7602,'Worn Tarot Card - Love','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_piece_of_report_i00',1,1,1),
(7603,'Worn Tarot Card - Knowledge','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_piece_of_report_i00',1,1,1),
(7604,'Summoner Keats'' Letter','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_paper_white_i00',1,1,1),
(7605,'Miracle Potion of Transferred Life','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_bless_of_eva_i00',1,1,1),
(7606,'Kamilen''s Antidote','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_dragons_blood_i04',1,1,1),
(7607,'Coolant of the Repaired Wilma #3','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_mechanic_box_i00',1,1,1),
(7608,'Sealed Envelope','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_scroll_white_i00',1,1,1),
(7609,'Proof of Catching a Fish','OTHER','false','none',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ticket_i00',1,1,1),
(7610,'Wind Fishing Lure','EQUIPMENT','false','bait',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(7611,'Icy Air Fishing Lure','EQUIPMENT','false','bait',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_broken_crystal_blue_i00',1,1,1),
(7612,'Earth Fishing Lure','EQUIPMENT','false','bait',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_broken_crystal_gold_i00',1,1,1),
(7613,'Flaming Fishing Lure','EQUIPMENT','false','bait',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_broken_crystal_red_i00',1,1,1),
(7614,'Chest Caught by Wind Fishing Lure','OTHER','false','none',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_treasure_box_i00',1,1,1),
(7615,'Chest Caught by Icy Air Fishing Lure','OTHER','false','none',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_treasure_box_i00',1,1,1),
(7616,'Chest Caught by Earth Fishing Lure','OTHER','false','none',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_treasure_box_i00',1,1,1),
(7617,'Chest Caught by using a Flaming Fishing Lure','OTHER','false','none',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_treasure_box_i00',1,1,1),
(7618,'Scroll of Escape: Ketra Orc Village','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,20,'etc_scroll_of_return_i00',1,1,0),
(7619,'Scroll of Escape: Varka Silenos Village','CONSUMABLE','false','scroll',30,'stackable','paper','none',0,35000,0,'false',2213,21,'etc_scroll_of_return_i00',1,1,0),
(7620,'Trash','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'icon.etc_dragons_blood_i01',1,1,1),
(7621,'Essence of Wind','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i01',1,1,1),
(7622,'Lost Bait Ingredient','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_codran_i00',1,1,1),
(7623,'Eye of Tarlk Basilisk','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(7624,'Crimson Drake Heart','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_inf_ore_high_i00',1,1,1),
(7625,'Strange Golem Blueprint','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ssq_scroll_i00',1,1,1),
(7626,'Kiki''s Letter','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_permit_card_i00',1,1,1),
(7627,'Small Glass Box','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_silver_mold_i00',1,1,1),
(7628,'Rukal''s Musical Score','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_ssq_i00',1,1,1),
(7629,'Looted Goods - White Cargo box','OTHER','false','quest',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_treasure_box_i00',1,1,1),
(7630,'Looted Goods - Blue Cargo box','OTHER','false','quest',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_treasure_box_i01',1,1,1),
(7631,'Looted Goods - Yellow Cargo box','OTHER','false','quest',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_treasure_box_i02',1,1,1),
(7632,'Looted Goods - Red Filing Cabinet','OTHER','false','quest',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_royal_seal_of_lord_i00',1,1,1),
(7633,'Looted Goods - Purple Filing Cabinet','OTHER','false','quest',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_royal_seal_of_lord_i03',1,1,1),
(7634,'Looted Goods - Brown Pouch','OTHER','false','quest',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(7635,'Looted Goods - Gray Pouch','OTHER','false','quest',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(7636,'Booty - Yellow Pouch','OTHER','false','quest',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_pouch_yellow_i00',1,1,1),
(7637,'Booty - Brown Pouch','OTHER','false','quest',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_pouch_brown_i00',1,1,1),
(7638,'Spellbook - Mass Summon Storm Cubic','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(7639,'Spellbook - Mass Summon Aqua Cubic','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(7640,'Spellbook - Mass Summon Phantom Cubic','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(7641,'Spellbook - Summon Feline Queen','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(7642,'Spellbook - Summon Unicorn Seraphim','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(7643,'Spellbook - Summon Nightshade','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(7644,'Spellbook - Summon Cursed Man','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,3200,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(7645,'Spellbook - Balance Life','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(7646,'Spellbook - Curse of Doom','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(7647,'Spellbook - Curse of Abyss','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(7648,'Spellbook - Arcane Chaos','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(7649,'Spellbook - Fire Vortex','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(7650,'Spellbook - Ice Vortex','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(7651,'Spellbook - Wind Vortex','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(7652,'Spellbook - Light Vortex','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_white_i00',1,1,1),
(7653,'Spellbook - Dark Vortex','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(7654,'Spellbook - Mass Warrior Bane','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(7655,'Spellbook - Mass Mage Bane','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(7656,'Spellbook - Warrior Servitor','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(7657,'Spellbook - Wizard Servitor','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(7658,'Spellbook - Assassin Servitor','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(7659,'Spellbook - Final Servitor','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(7660,'Spellbook - Warrior Bane','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(7661,'Spellbook - Mage Bane','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_element_i00',1,1,1),
(7662,'Spellbook - Elemental Protection','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(7663,'Spellbook - Divine Protection','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(7664,'Spellbook - Arcane Protection','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(7665,'Spellbook - Prophecy of Water','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(7666,'Spellbook - Prophecy of Fire','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(7667,'Spellbook - Prophecy of Wind','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(7668,'Spellbook - Block Shield','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(7669,'Spellbook - Block Wind Walk','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(7670,'Spellbook - Mass Block Shield','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(7671,'Spellbook - Mass Block Wind Walk','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(7672,'Amulet - Chant of Spirit','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(7673,'Amulet - Chant of Victory','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(7674,'Amulet - Pa''agrio''s Eye','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(7675,'Amulet - Pa''agrio''s Soul','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(7676,'Amulet - Seal of Despair','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(7677,'Virgil''s Letter','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_letter_envelope_i00',1,1,1),
(7678,'Caradine''s Letter','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_letter_envelope_i00',1,1,1),
(7679,'Caradine''s Letter','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_letter_envelope_i00',1,1,1),
(7684,'Raccoon Ears Fabric','PIECES','false','material',60,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_piece_of_cloth_blue_i00',1,1,1),
(7685,'Outlaw''s Eyepatch Strap','PIECES','false','material',60,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_braided_hemp_i00',1,1,1),
(7686,'Maiden''s Hairpin Piece','PIECES','false','material',60,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_broken_crystal_green_i00',1,1,1),
(7687,'Rabbit Ears Fabric','PIECES','false','material',60,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_piece_of_cloth_blue_i00',1,1,1),
(7688,'Cat Ears Fabric','PIECES','false','material',60,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_piece_of_cloth_blue_i00',1,1,1),
(7689,'Recipe - Raccoon Ears (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,100000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7690,'Recipe - Outlaw''s Eyepatch (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,100000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7691,'Recipe - Maiden''s Hairpin (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,100000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7692,'Recipe - Rabbit Ears (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,100000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7693,'Recipe - Cat Ears (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,100000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7697,'Piece of Forget-me-not Hairpin','PIECES','false','material',60,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_broken_crystal_green_i00',1,1,1),
(7698,'Piece of Daisy Hairpin','PIECES','false','material',60,'stackable','liquid','none',0,5000,0,'true',0,1,'etc_broken_crystal_green_i00',1,1,1),
(7699,'Recipe: Forget-me-not Hairpin (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,100000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7700,'Recipe: Daisy Hairpin (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,100000,0,'false',0,1,'etc_recipe_green_i00',1,1,1),
(7725,'Loot - Gray Pouch','OTHER','false','none',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_pouch_gray_i00',1,1,1),
(7726,'Small Nimble Green Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,69,0,'false',0,1,'etc_tuna_i06',1,1,1),
(7727,'Small Ugly Green Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,71,0,'false',0,1,'etc_angler_i06',1,1,1),
(7728,'Small Pudgy Green Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,77,0,'false',0,1,'etc_bream_i06',1,1,1),
(7729,'Nimble Green Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,84,0,'false',0,1,'etc_tuna_i06',1,1,1),
(7730,'Ugly Green Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,94,0,'false',0,1,'etc_angler_i06',1,1,1),
(7731,'Pudgy Green Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,104,0,'false',0,1,'etc_bream_i06',1,1,1),
(7732,'Large Nimble Green Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,113,0,'false',0,1,'etc_tuna_i06',1,1,1),
(7733,'Large Ugly Green Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,124,0,'false',0,1,'etc_angler_i06',1,1,1),
(7734,'Large Pudgy Green Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,133,0,'false',0,1,'etc_bream_i06',1,1,1),
(7735,'Small Jade Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,143,0,'false',0,1,'etc_tuna_i07',1,1,1),
(7736,'Small Jade Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,167,0,'false',0,1,'etc_angler_i07',1,1,1),
(7737,'Small Jade Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,167,0,'false',0,1,'etc_bream_i07',1,1,1),
(7738,'Jade Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,166,0,'false',0,1,'etc_tuna_i07',1,1,1),
(7739,'Jade Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,165,0,'false',0,1,'etc_angler_i07',1,1,1),
(7740,'Jade Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,165,0,'false',0,1,'etc_bream_i07',1,1,1),
(7741,'Large Jade Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,164,0,'false',0,1,'etc_tuna_i07',1,1,1),
(7742,'Large Jade Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,164,0,'false',0,1,'etc_angler_i07',1,1,1),
(7743,'Large Jade Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,163,0,'false',0,1,'etc_bream_i07',1,1,1),
(7744,'Small Blue Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,163,0,'false',0,1,'etc_tuna_i01',1,1,1),
(7745,'Small Blue Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,163,0,'false',0,1,'etc_angler_i01',1,1,1),
(7746,'Small Blue Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,198,0,'false',0,1,'etc_bream_i01',1,1,1),
(7747,'Blue Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,202,0,'false',0,1,'etc_tuna_i01',1,1,1),
(7748,'Blue Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,197,0,'false',0,1,'etc_angler_i01',1,1,1),
(7749,'Blue Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,210,0,'false',0,1,'etc_bream_i01',1,1,1),
(7750,'Large Blue Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,213,0,'false',0,1,'etc_tuna_i01',1,1,1),
(7751,'Large Blue Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,216,0,'false',0,1,'etc_angler_i01',1,1,1),
(7752,'Large Blue Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,218,0,'false',0,1,'etc_bream_i01',1,1,1),
(7753,'Small Yellow Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,221,0,'false',0,1,'etc_tuna_i02',1,1,1),
(7754,'Small Yellow Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,224,0,'false',0,1,'etc_angler_i02',1,1,1),
(7755,'Small Yellow Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,226,0,'false',0,1,'etc_bream_i02',1,1,1),
(7756,'Yellow Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,270,0,'false',0,1,'etc_tuna_i02',1,1,1),
(7757,'Yellow Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,277,0,'false',0,1,'etc_angler_i02',1,1,1),
(7758,'Yellow Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,284,0,'false',0,1,'etc_bream_i02',1,1,1),
(7759,'Large Yellow Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,290,0,'false',0,1,'etc_tuna_i02',1,1,1),
(7760,'Large Yellow Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,297,0,'false',0,1,'etc_angler_i02',1,1,1),
(7761,'Large Yellow Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,304,0,'false',0,1,'etc_bream_i02',1,1,1),
(7762,'Small Orange Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,311,0,'false',0,1,'etc_tuna_i08',1,1,1),
(7763,'Small Orange Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,318,0,'false',0,1,'etc_angler_i08',1,1,1),
(7764,'Small Orange Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,325,0,'false',0,1,'etc_bream_i08',1,1,1),
(7765,'Orange Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,332,0,'false',0,1,'etc_tuna_i08',1,1,1),
(7766,'Orange Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,388,0,'false',0,1,'etc_angler_i08',1,1,1),
(7767,'Orange Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,396,0,'false',0,1,'etc_bream_i08',1,1,1),
(7768,'Large Orange Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,408,0,'false',0,1,'etc_tuna_i08',1,1,1),
(7769,'Large Orange Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,420,0,'false',0,1,'etc_angler_i08',1,1,1),
(7770,'Large Orange Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,429,0,'false',0,1,'etc_bream_i08',1,1,1),
(7771,'Small Purple Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,438,0,'false',0,1,'etc_tuna_i04',1,1,1),
(7772,'Small Purple Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,447,0,'false',0,1,'etc_angler_i04',1,1,1),
(7773,'Small Purple Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,455,0,'false',0,1,'etc_bream_i04',1,1,1),
(7774,'Purple Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,465,0,'false',0,1,'etc_tuna_i04',1,1,1),
(7775,'Purple Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,474,0,'false',0,1,'etc_angler_i04',1,1,1),
(7776,'Purple Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,545,0,'false',0,1,'etc_bream_i04',1,1,1),
(7777,'Large Purple Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,556,0,'false',0,1,'etc_tuna_i04',1,1,1),
(7778,'Large Purple Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,567,0,'false',0,1,'etc_angler_i04',1,1,1),
(7779,'Large Purple Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,579,0,'false',0,1,'etc_bream_i04',1,1,1),
(7780,'Small Red Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,639,0,'false',0,1,'etc_tuna_i03',1,1,1),
(7781,'Small Red Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,651,0,'false',0,1,'etc_angler_i03',1,1,1),
(7782,'Small Red Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,663,0,'false',0,1,'etc_bream_i03',1,1,1),
(7783,'Red Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,676,0,'false',0,1,'etc_tuna_i03',1,1,1),
(7784,'Red Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,688,0,'false',0,1,'etc_angler_i03',1,1,1),
(7785,'Red Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,701,0,'false',0,1,'etc_bream_i03',1,1,1),
(7786,'Large Red Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,789,0,'false',0,1,'etc_tuna_i03',1,1,1),
(7787,'Large Red Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,804,0,'false',0,1,'etc_angler_i03',1,1,1),
(7788,'Large Red Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,858,0,'false',0,1,'etc_bream_i03',1,1,1),
(7789,'Small White Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,874,0,'false',0,1,'etc_tuna_i00',1,1,1),
(7790,'Small White Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,891,0,'false',0,1,'etc_angler_i00',1,1,1),
(7791,'Small White Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,907,0,'false',0,1,'etc_bream_i00',1,1,1),
(7792,'White Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,925,0,'false',0,1,'etc_tuna_i00',1,1,1),
(7793,'White Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,944,0,'false',0,1,'etc_angler_i00',1,1,1),
(7794,'White Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,962,0,'false',0,1,'etc_bream_i00',1,1,1),
(7795,'Large White Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,981,0,'false',0,1,'etc_tuna_i00',1,1,1),
(7796,'Large White Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,1000,0,'false',0,1,'etc_angler_i00',1,1,1),
(7797,'Large White Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,1020,0,'false',0,1,'etc_bream_i00',1,1,1),
(7798,'Small Black Nimble Fish: For Beginners','OTHER','false','none',100,'stackable','fish','none',0,1041,0,'false',0,1,'etc_tuna_i05',1,1,1),
(7799,'Small Black Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,1062,0,'false',0,1,'etc_angler_i05',1,1,1),
(7800,'Small Black Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,1083,0,'false',0,1,'etc_bream_i05',1,1,1),
(7801,'Black Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,1155,0,'false',0,1,'etc_tuna_i05',1,1,1),
(7802,'Black Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,1179,0,'false',0,1,'etc_angler_i05',1,1,1),
(7803,'Black Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,1202,0,'false',0,1,'etc_bream_i05',1,1,1),
(7804,'Large Black Nimble Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,1226,0,'false',0,1,'etc_tuna_i05',1,1,1),
(7805,'Large Black Ugly Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,1251,0,'false',0,1,'etc_angler_i05',1,1,1),
(7806,'Large Black Fat Fish - For Beginners','OTHER','false','none',100,'stackable','fish','none',0,1276,0,'false',0,1,'etc_bream_i05',1,1,1),
(7807,'Green Colored Lure - For Beginners','EQUIPMENT','false','bait',5,'stackable','liquid','none',0,50,0,'false',0,1,'etc_bait_i00',1,1,1),
(7808,'Purple Colored Lure - For Beginners','EQUIPMENT','false','bait',5,'stackable','liquid','none',0,70,0,'false',0,1,'etc_bait_i01',1,1,1),
(7809,'Yellow Colored Lure - For Beginners','EQUIPMENT','false','bait',5,'stackable','liquid','none',0,60,0,'false',0,1,'etc_bait_i02',1,1,1),
(7832,'Apprentice Adventurer''s Weapon Exchange Coupon','OTHER','false','none',1,'normal','paper','none',0,0,0,'false',0,1,'etc_lottery_card_i00',1,1,1),
(7833,'Adventurer''s Weapon Exchange Coupon','OTHER','false','none',1,'normal','paper','none',0,0,0,'false',0,1,'etc_lottery_card_i00',1,1,1),
(7835,'Amulet: Seal of Disease','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,11600,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(7904,'Boat Ticket: Rune to Gludin','OTHER','false','none',20,'stackable','paper','none',0,5000,0,'true',0,1,'etc_ticket_red_i00',1,1,1),
(7905,'Boat Ticket: Gludin to Rune','OTHER','false','none',20,'stackable','paper','none',0,5000,0,'true',0,1,'etc_ticket_red_i00',1,1,1),
(7906,'Blessing of Fire','OTHER','false','none',20,'stackable','liquid','none',0,0,0,'false',2248,1,'etc_fire_crystal_i00',1,1,1),
(7907,'Blessing of Water','OTHER','false','none',20,'stackable','liquid','none',0,0,0,'false',2249,1,'etc_water_crystal_i00',1,1,1),
(7908,'Blessing of Wind','OTHER','false','none',20,'stackable','liquid','none',0,0,0,'false',2250,1,'etc_wind_crystal_i00',1,1,1),
(7909,'Blessing of Earth','OTHER','false','none',20,'stackable','liquid','none',0,0,0,'false',2251,1,'etc_earth_crystal_i00',1,1,1),
(7910,'Blessing of Darkness','OTHER','false','none',20,'stackable','liquid','none',0,0,0,'false',2252,1,'etc_unholy_crystal_i00',1,1,1),
(7911,'Blessing of Sanctity','OTHER','false','none',20,'stackable','liquid','none',0,0,0,'false',2253,1,'etc_holy_crystal_i00',1,1,1),
(7912,'Fire Crystal','OTHER','false','none',20,'stackable','liquid','none',0,0,0,'false',2254,1,'etc_fire_crystal_i00',1,1,1),
(7913,'Water Crystal','OTHER','false','none',20,'stackable','liquid','none',0,0,0,'false',2255,1,'etc_water_crystal_i00',1,1,1),
(7914,'Wind Crystal','OTHER','false','none',20,'stackable','liquid','none',0,0,0,'false',2256,1,'etc_wind_crystal_i00',1,1,1),
(7915,'Earth Crystal','OTHER','false','none',20,'stackable','liquid','none',0,0,0,'false',2257,1,'etc_earth_crystal_i00',1,1,1),
(7916,'Dark Crystal','OTHER','false','none',20,'stackable','liquid','none',0,0,0,'false',2258,1,'etc_unholy_crystal_i00',1,1,1),
(7917,'Sanctity Crystal','OTHER','false','none',20,'stackable','liquid','none',0,0,0,'false',2259,1,'etc_holy_crystal_i00',1,1,1),
(7918,'Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,30000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(7919,'Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(7920,'Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(7921,'Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(7922,'Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(7923,'Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(7924,'Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(7925,'Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(7926,'Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(7927,'Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(7928,'Mercenary Posting Ticket (Teleporter1)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(7929,'Mercenary Posting Ticket (Teleporter2)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(7930,'Mercenary Posting Ticket (Teleporter3)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(7931,'Greater Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(7932,'Greater Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(7933,'Greater Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(7934,'Greater Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(7935,'Greater Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(7936,'Greater Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(7937,'Greater Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(7938,'Greater Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(7939,'Greater Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(7940,'Greater Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(7941,'Dawn Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(7942,'Dawn Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(7943,'Dawn Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(7944,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(7945,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(7946,'Dawn Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(7947,'Dawn Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(7948,'Dawn Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(7949,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(7950,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(7951,'Greater Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(7952,'Greater Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(7953,'Greater Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(7954,'Greater Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(7955,'Greater Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(7956,'Greater Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(7957,'Greater Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(7958,'Greater Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(7959,'Greater Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(7960,'Greater Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(7961,'Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(7962,'Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(7963,'Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(7964,'Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(7965,'Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(7966,'Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(7967,'Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(7968,'Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(7969,'Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(7970,'Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(7971,'Nephilim Warrior Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,2500000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(7972,'Nephilim Shaman Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,5000000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(7973,'Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_fix_i00',1,1,1),
(7974,'Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(7975,'Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(7976,'Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(7977,'Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(7978,'Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(7979,'Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(7980,'Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(7981,'Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(7982,'Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(7983,'Mercenary Posting Ticket (Teleporter1)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(7984,'Mercenary Posting Ticket (Teleporter2)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(7985,'Mercenary Posting Ticket (Teleporter3)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(7986,'Mercenary Posting Ticket (Teleporter4)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(7987,'Mercenary Posting Ticket (Teleporter5)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_teleporter_fix_i00',0,1,0),
(7988,'Greater Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(7989,'Greater Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(7990,'Greater Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(7991,'Greater Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(7992,'Greater Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(7993,'Greater Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,80000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(7994,'Greater Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,100000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(7995,'Greater Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,120000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(7996,'Greater Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(7997,'Greater Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,250000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(7998,'Dawn Mercenary Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(7999,'Dawn Mercenary Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(8000,'Dawn Mercenary Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(8001,'Dawn Mercenary Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(8002,'Dawn Mercenary Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(8003,'Dawn Mercenary Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,140000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(8004,'Dawn Mercenary Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,170000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(8005,'Dawn Mercenary Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,200000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(8006,'Dawn Mercenary Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(8007,'Dawn Mercenary Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,350000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(8008,'Greater Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(8009,'Greater Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(8010,'Greater Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(8011,'Greater Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(8012,'Greater Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(8013,'Greater Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,70000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(8014,'Greater Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,90000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(8015,'Greater Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,110000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(8016,'Greater Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(8017,'Greater Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,230000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(8018,'Recruit Posting Ticket (Sword/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_fix_i00',0,1,0),
(8019,'Recruit Posting Ticket (Spear/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_fix_i00',0,1,0),
(8020,'Recruit Posting Ticket (Bow/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_fix_i00',0,1,0),
(8021,'Recruit Posting Ticket (Cleric/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_fix_i00',0,1,0),
(8022,'Recruit Posting Ticket (Wizard/Stationary)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_fix_i00',0,1,0),
(8023,'Recruit Posting Ticket (Sword/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,40000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(8024,'Recruit Posting Ticket (Spear/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,50000,0,'false',0,1,'mticket_pole_move_i00',0,1,0),
(8025,'Recruit Posting Ticket (Bow/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,60000,0,'false',0,1,'mticket_bow_move_i00',0,1,0),
(8026,'Recruit Posting Ticket (Cleric/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_cleric_move_i00',0,1,0),
(8027,'Recruit Posting Ticket (Wizard/Mobile)','OTHER','false','mticket',0,'stackable','paper','none',0,150000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(8028,'Nephilim Warrior Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,2500000,0,'false',0,1,'mticket_sword_move_i00',0,1,0),
(8029,'Nephilim Shaman Posting Ticket','OTHER','false','mticket',0,'stackable','paper','none',0,5000000,0,'false',0,1,'mticket_wizard_move_i00',0,1,0),
(8030,'Hot Spring Nectar','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_hot_spring_nectar_i00',0,1,0),
(8031,'Hot Spring Mineral Water','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_hot_spring_mineral_i00',0,1,0),
(8032,'Hot Spring Water','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_hot_spring_fountain_i00',0,1,0),
(8033,'Hot Spring Sulfur','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_hot_spring_sulfur_i00',0,1,0),
(8034,'Rainbow Springs Clan Hall War Decree','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_hs_agit_war_joining_certificate_i00',1,1,1),
(8035,'Hot Spring Letter A','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_a_i00',0,1,0),
(8036,'Hot Spring Letter B','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_b_i00',0,1,0),
(8037,'Hot Spring Letter C','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_c_i00',0,1,0),
(8038,'Hot Spring Letter D','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_d_i00',0,1,0),
(8039,'Hot Spring Letter E','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_e_i00',0,1,0),
(8040,'Hot Spring Letter F','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_f_i00',0,1,0),
(8041,'Hot Spring Letter G','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_g_i00',0,1,0),
(8042,'Hot Spring Letter H','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_h_i00',0,1,0),
(8043,'Hot Spring Letter I','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_i_i00',0,1,0),
(8044,'Hot Spring Letter J','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'',0,1,0),
(8045,'Hot Spring Letter K','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_k_i00',0,1,0),
(8046,'Hot Spring Letter L','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_l_i00',0,1,0),
(8047,'Hot Spring Letter N','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_n_i00',0,1,0),
(8048,'Hot Spring Letter O','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_o_i00',0,1,0),
(8049,'Hot Spring Letter P','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_p_i00',0,1,0),
(8050,'Hot Spring Letter R','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_r_i00',0,1,0),
(8051,'Hot Spring Letter S','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_s_i00',0,1,0),
(8052,'Hot Spring letter T','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_t_i00',0,1,0),
(8053,'Hot Spring Letter U','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_u_i00',0,1,0),
(8054,'Hot Spring Letter W','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_w_i00',0,1,0),
(8055,'Hot Spring Letter Y','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_alphabet_y_i00',0,1,0),
(8056,'Key of Splendor Room','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',2238,1,'etc_old_key_i02',1,1,1),
(8057,'Silver Hemocyte','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'etc_lesser_potion_clear_i00',1,1,1),
(8058,'Lockup Research Report','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_magic_book_blue_i00',1,1,1),
(8059,'Research Report','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_magic_book_blue_i00',1,1,1),
(8060,'Key of Enigma','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_key_i00',1,1,1),
(8061,'Scribbled Memo','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_memopad_i00',1,1,1),
(8062,'Blood of Maille Lizardman','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'true',0,1,'etc_lesser_potion_purple_i00',1,1,1),
(8063,'Leg of King Araneid','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'true',0,1,'etc_sting_b_i00',1,1,1),
(8064,'Visitor''s Mark','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_red_rose_i00',1,1,1),
(8065,'Faded Visitor''s Mark','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_white_rose_i00',1,1,1),
(8066,'Necromancer''s Heart','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_bodypart_heart_i00',1,1,1),
(8067,'Pagan''s Mark','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_totem_necklace_red_i00',1,1,1),
(8068,'Pagan Totem','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_totem_necklace_green_i00',1,1,1),
(8069,'Monk''s Scripture','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_magic_book_white_i00',1,1,1),
(8070,'Water Bottle','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_potion_yellow_i00',1,1,1),
(8071,'Bottle of water from the Holy Grail','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_potion_yellow_i00',1,1,1),
(8072,'Antelope Skin','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_leather_brown_i00',1,1,1),
(8073,'Frintezza''s Magic Force Field Removal Scroll','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_scroll_gray_i00',1,1,1),
(8074,'Watching Eyes','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_eyeball_i00',1,1,1),
(8075,'Roughly Hewn Rock Golem Shard','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_debris_i00',1,1,1),
(8076,'Delu Lizardman''s Scale','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_scale_of_medusa_green_i00',1,1,1),
(8077,'Silver Ice Crystal','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_broken_crystal_silver_i00',1,1,1),
(8078,'Black Ice Crystal','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_gem_black_i00',1,1,1),
(8079,'Misa''s Letter','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_letter_red_i00',1,1,1),
(8080,'Rafforty''s Letter','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_letter_envelope_i00',1,1,1),
(8081,'Piece of Tablet','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_broken_tablet_fragment_i00',1,1,1),
(8082,'Report Piece','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_report_i00',1,1,1),
(8083,'Scout''s Memo','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_piece_of_report_i00',1,1,1),
(8084,'Crystal of Purity','OTHER','false','none',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_crystal_ball_white_i00',1,1,1),
(8085,'Fang of Stakato','OTHER','false','none',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_fang_red_i00',1,1,1),
(8086,'Box Containing the Fire of Holy Spirit','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_jewel_box_i00',1,1,1),
(8087,'Cursed Doll','OTHER','false','none',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_totem_red_i00',1,1,1),
(8088,'Orc Grave Goods','OTHER','false','none',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_orcish_talisman_i00',1,1,1),
(8089,'Cursed Grave Goods','OTHER','false','none',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_totem_black_i00',1,1,1),
(8090,'Electric Wave Detector','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'weapon_the_staff_of_hero_i00',1,1,1),
(8091,'Electric Wave Detector','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'weapon_the_staff_of_hero_i01',1,1,1),
(8092,'Telescope Golem''s Corpse','OTHER','false','none',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_debris_i00',1,1,1),
(8093,'Golem''s Dispatcher','OTHER','false','none',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_mechanic_box_i00',1,1,1),
(8094,'Storage Medium','OTHER','false','none',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_calculator_i00',1,1,1),
(8095,'Storage Medium','OTHER','false','none',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_calculator_i00',1,1,1),
(8096,'Ginzu Golem''s Black Box','OTHER','false','none',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_mechanic_box_i00',1,1,1),
(8097,'X-688','OTHER','false','none',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_map_ivory_i00',1,1,1),
(8098,'Supplying Goods for Railroad Worker','OTHER','false','none',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_squares_wood_i00',1,1,1),
(8099,'Thief Guild''s Mark','OTHER','false','none',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_fang_ivory_i00',1,1,1),
(8100,'Destroyed Golem Shards','OTHER','false','quest',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_debris_i00',1,1,1),
(8101,'Dwarf''s Favor','OTHER','false','none',0,'stackable','paper','none',100,0,0,'false',0,1,'etc_letter_white_i00',1,1,1),
(8153,'Adventurer''s Guide Book','OTHER','false','none',0,'normal','paper','none',0,0,0,'false',0,1,'etc_spell_books_blue_i00',1,1,1),
(8154,'Herb of Life','CONSUMABLE','false','potion',0,'normal','paper','none',0,0,0,'false',2244,1,'',1,1,1),
(8155,'Herb of Mana','CONSUMABLE','false','potion',0,'normal','paper','none',0,0,0,'false',2245,1,'',1,1,1),
(8156,'Herb of Power','CONSUMABLE','false','potion',0,'normal','paper','none',0,0,0,'false',2246,1,'',1,1,1),
(8157,'Herb of Magic','CONSUMABLE','false','potion',0,'normal','paper','none',0,0,0,'false',2247,1,'',1,1,1),
(8158,'Memento Mori: C-Grade','OTHER','false','none',0,'stackable','paper','none',0,25000,0,'false',0,1,'etc_raid_a_i02',1,1,1),
(8159,'Memento Mori: B-Grade','OTHER','false','none',0,'stackable','paper','none',0,45000,0,'false',0,1,'etc_raid_a_i01',1,1,1),
(8160,'Memento Mori: A-Grade','OTHER','false','none',0,'stackable','paper','none',0,50000,0,'false',0,1,'etc_raid_a_i00',1,1,1),
(8161,'Dragon Heart: C-Grade','OTHER','false','none',0,'stackable','paper','none',0,25000,0,'false',0,1,'etc_raid_b_i02',1,1,1),
(8162,'Dragon Heart: B-Grade','OTHER','false','none',0,'stackable','paper','none',0,45000,0,'false',0,1,'etc_raid_b_i01',1,1,1),
(8163,'Dragon Heart: A-Grade','OTHER','false','none',0,'stackable','paper','none',0,50000,0,'false',0,1,'etc_raid_b_i00',1,1,1),
(8164,'Earth Egg: C-Grade','OTHER','false','none',0,'stackable','paper','none',0,25000,0,'false',0,1,'etc_raid_c_i02',1,1,1),
(8165,'Earth Egg: B-Grade','OTHER','false','none',0,'stackable','paper','none',0,45000,0,'false',0,1,'etc_raid_c_i01',1,1,1),
(8166,'Earth Egg: A-Grade','OTHER','false','none',0,'stackable','paper','none',0,50000,0,'false',0,1,'etc_raid_c_i00',1,1,1),
(8167,'Nonliving Nucleus: C-Grade','OTHER','false','none',0,'stackable','paper','none',0,25000,0,'false',0,1,'etc_raid_d_i02',1,1,1),
(8168,'Nonliving Nucleus: B-Grade','OTHER','false','none',0,'stackable','paper','none',0,45000,0,'false',0,1,'etc_raid_d_i01',1,1,1),
(8169,'Nonliving Nucleus: A-Grade','OTHER','false','none',0,'stackable','paper','none',0,50000,0,'false',0,1,'etc_raid_d_i00',1,1,1),
(8170,'Angelic Essence: C-Grade','OTHER','false','none',0,'stackable','paper','none',0,25000,0,'false',0,1,'etc_raid_e_i02',1,1,1),
(8171,'Angelic Essence: B-Grade','OTHER','false','none',0,'stackable','paper','none',0,45000,0,'false',0,1,'etc_raid_e_i01',1,1,1),
(8172,'Angelic Essence: A-Grade','OTHER','false','none',0,'stackable','paper','none',0,50000,0,'false',0,1,'etc_raid_e_i00',1,1,1),
(8173,'Cradle of Creation: C-Grade (Not used)','OTHER','false','none',0,'stackable','paper','none',0,0,0,'false',0,1,'',1,1,1),
(8174,'Cradle of Creation: B-Grade (Not used)','OTHER','false','none',0,'stackable','paper','none',0,0,0,'false',0,1,'',1,1,1),
(8175,'Cradle of Creation','OTHER','false','none',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_raid_g_i00',1,1,1),
(8176,'Destruction Tombstone','OTHER','false','none',0,'stackable','paper','none',0,50000,0,'false',0,1,'etc_raid_f_i00',1,1,1),
(8192,'Breaking Arrow','OTHER','false','none',3,'stackable','gold','none',0,0,0,'false',0,1,'etc_destory_soul_arrow_i00',1,1,1),
(8193,'Fisherman''s Potion - Green','OTHER','false','none',100,'stackable','liquid','none',0,5000,0,'true',2274,1,'etc_oblivion_green_i00',1,1,1),
(8194,'Fisherman''s Potion - Jade','OTHER','false','none',100,'stackable','liquid','none',0,5000,0,'true',2274,2,'etc_oblivion_jade_i00',1,1,1),
(8195,'Fisherman''s Potion - Blue','OTHER','false','none',100,'stackable','liquid','none',0,5000,0,'true',2274,3,'etc_oblivion_blue_i00',1,1,1),
(8196,'Fisherman''s Potion - Yellow','OTHER','false','none',100,'stackable','liquid','none',0,5000,0,'true',2274,4,'etc_oblivion_yellow_i00',1,1,1),
(8197,'Fisherman''s Potion - Orange','OTHER','false','none',100,'stackable','liquid','none',0,5000,0,'true',2274,5,'etc_oblivion_orange_i00',1,1,1),
(8198,'Fisherman''s Potion - Purple','OTHER','false','none',100,'stackable','liquid','none',0,5000,0,'true',2274,6,'etc_oblivion_violet_i00',1,1,1),
(8199,'Fisherman''s Potion - Red','OTHER','false','none',100,'stackable','liquid','none',0,5000,0,'true',2274,7,'etc_oblivion_red_i00',1,1,1),
(8200,'Fisherman''s Potion - White','OTHER','false','none',100,'stackable','liquid','none',0,5000,0,'true',2274,8,'etc_oblivion_white_i00',1,1,1),
(8201,'Fisherman''s Potion - Black','OTHER','false','none',100,'stackable','liquid','none',0,5000,0,'true',2274,9,'etc_oblivion_black_i00',1,1,1),
(8202,'Fishing Potion','OTHER','false','none',100,'stackable','liquid','none',0,5000,0,'true',2275,1,'etc_oblivion_black_i00',1,1,1),
(8223,'Seed: Twin Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8224,'Seed: Great Codran','OTHER','false','seed',1,'stackable','paper','none',0,75,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8225,'Seed: Desert Codran','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8226,'Seed: Blue Coba','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'true',0,1,'etc_blue_coba_seed_i00',1,1,1),
(8227,'Seed: Red Coba','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'true',0,1,'etc_red_coba_seed_i00',1,1,1),
(8228,'Seed: Golden Coba','OTHER','false','seed',1,'stackable','paper','none',0,650,0,'true',0,1,'etc_golden_coba_seed_i00',1,1,1),
(8229,'Seed: Desert Coba','OTHER','false','seed',1,'stackable','paper','none',0,750,0,'true',0,1,'etc_desert_coba_seed_i00',1,1,1),
(8230,'Seed: Alternative Twin Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8231,'Seed: Alternative Great Codran','OTHER','false','seed',1,'stackable','paper','none',0,75,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8232,'Seed: Alternative Desert Codran','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8233,'Seed: Alternative Blue Coba','OTHER','false','seed',1,'stackable','paper','none',0,400,0,'true',0,1,'etc_blue_coba_seed_i00',1,1,1),
(8234,'Seed: Alternative Red Coba','OTHER','false','seed',1,'stackable','paper','none',0,500,0,'true',0,1,'etc_red_coba_seed_i00',1,1,1),
(8235,'Seed: Alternative Golden Coba','OTHER','false','seed',1,'stackable','paper','none',0,650,0,'true',0,1,'etc_golden_coba_seed_i00',1,1,1),
(8236,'Seed: Alternative Desert Coba','OTHER','false','seed',1,'stackable','paper','none',0,750,0,'true',0,1,'etc_desert_coba_seed_i00',1,1,1),
(8237,'Seed: Dark Coda','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(8238,'Seed: Red Coda','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(8239,'Seed: Chilly Coda','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(8240,'Seed: Blue Coda','OTHER','false','seed',1,'stackable','paper','none',0,10,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(8241,'Seed: Golden Coda','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(8242,'Seed: Lute Coda','OTHER','false','seed',1,'stackable','paper','none',0,30,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(8243,'Seed: Desert Coda','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(8244,'Seed: Red Cobol','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'true',0,1,'etc_cobol_seed_i00',1,1,1),
(8245,'Seed: Chilly Cobol','OTHER','false','seed',1,'stackable','paper','none',0,25,0,'true',0,1,'etc_cobol_seed_i00',1,1,1),
(8246,'Seed: Blue Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_cobol_seed_i00',1,1,1),
(8247,'Seed: Thorn Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_cobol_seed_i00',1,1,1),
(8248,'Seed: Golden Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_cobol_seed_i00',1,1,1),
(8249,'Seed: Great Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_cobol_seed_i00',1,1,1),
(8250,'Seed: Red Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8251,'Seed: Sea Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8252,'Seed: Chilly Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8253,'Seed: Blue Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8254,'Seed: Twin Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8255,'Alternative Dark Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(8256,'Alternative Red Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(8257,'Seed: Alternative Chilly Coda','OTHER','false','seed',1,'stackable','paper','none',0,5,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(8258,'Alternative Blue Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,10,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(8259,'Seed: Alternative Golden Coda','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(8260,'Alternative Lute Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,30,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(8261,'Alternative Desert Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,20,0,'true',0,1,'etc_coda_seed_i00',1,1,1),
(8262,'Seed: Alternative Red Cobol','OTHER','false','seed',1,'stackable','paper','none',0,100,0,'true',0,1,'etc_cobol_seed_i00',1,1,1),
(8263,'Seed: Alternative Chilly Cobol','OTHER','false','seed',1,'stackable','paper','none',0,25,0,'true',0,1,'etc_cobol_seed_i00',1,1,1),
(8264,'Seed: Alternative Blue Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_cobol_seed_i00',1,1,1),
(8265,'Alternative Thorn Cobol Seed','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_cobol_seed_i00',1,1,1),
(8266,'Seed: Alternative Golden Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_cobol_seed_i00',1,1,1),
(8267,'Seed: Alternative Great Cobol','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_cobol_seed_i00',1,1,1),
(8268,'Seed: Alternative Red Codran','OTHER','false','seed',1,'stackable','paper','none',0,40,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8269,'Seed: Alternative Sea Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8270,'Seed: Alternative Chilly Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8271,'Seed: Alternative Blue Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8272,'Seed: Alternative Twin Codran','OTHER','false','seed',1,'stackable','paper','none',0,50,0,'true',0,1,'etc_codran_seed_i00',1,1,1),
(8273,'Anteroom Key','OTHER','false','none',0,'stackable','steel','none',0,0,0,'true',2235,1,'etc_old_key_i03',1,1,1),
(8274,'Chapel Key','OTHER','false','none',0,'stackable','steel','none',0,0,0,'true',2236,1,'etc_old_key_i01',1,1,1),
(8275,'Key of Darkness','OTHER','false','none',0,'stackable','steel','none',0,0,0,'true',2237,1,'etc_old_key_i02',1,1,1),
(8276,'Sekina''s Scale','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_scale_of_medusa_blue_i00',1,1,1),
(8277,'Themis'' Scale','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_scale_of_medusa_red_i00',1,1,1),
(8278,'Vermilion Shard','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_bark_gold_i00',1,1,1),
(8279,'Nucleus of Hekaton Prime','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_bead_silver_i00',1,1,1),
(8280,'Tiphon Shard','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_gargoyle_claw_i00',1,1,1),
(8281,'Glaki''s Necleus','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_bead_gold_i00',1,1,1),
(8282,'Rahha''s Fang','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'false',0,1,'etc_fang_red_i00',1,1,1),
(8283,'Sting of Giant Poison Bee','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_sting_a_i00',1,1,1),
(8284,'Cloudy Gem','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_oriharukon_ore_i00',1,1,1),
(8285,'Talon of Young Araneid','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_claw_i00',1,1,1),
(8286,'Fairy Breath','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_dragons_blood_i01',1,1,1),
(8287,'Starstone','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_crystal_blue_i00',1,1,1),
(8288,'Yumi''s Letter','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_letter_red_i00',1,1,1),
(8289,'Starstone','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_crystal_blue_i00',1,1,1),
(8290,'Flower of Pavel','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_flower_i02',1,1,1),
(8291,'Heart of Atlanta','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_inf_ore_medium_i00',1,1,1),
(8292,'Wendy''s Necklace','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'accessary_necklace_of_devotion_i00',1,1,1),
(8293,'Trainer License','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_paper_red_i00',1,1,1),
(8294,'Recipe: Steel Sword (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,8180,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(8295,'Recipe: Titan Sword (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,36000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(8296,'Recipe: Pa''agrian Sword (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,86000,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(8297,'Recipe: Guardian''s Sword (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8298,'Recipe: Guardian''s Sword (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,246000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8299,'Recipe: Infernal Master (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,466000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(8300,'Recipe: Infernal Master (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,366000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(8301,'Recipe: Priest Sword (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,37700,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(8302,'Recipe: Sword of Magic Fog (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,37700,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(8303,'Recipe: Mysterious Sword (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,175600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(8304,'Recipe: Ecliptic Sword (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,172600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(8305,'Recipe: Wizard''s Tear (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8306,'Recipe: Wizard''s Tear (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8307,'Recipe: Priest Mace (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,38000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(8308,'Recipe: Ecliptic Axe (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,122600,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(8309,'Recipe: Spell Breaker (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8310,'Recipe: Spell Breaker (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8311,'Recipe: Kaim Vanul''s Bones (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8312,'Recipe: Kaim Vanul''s Bones (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,262000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8313,'Recipe: Spiritual Eye (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,416000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(8314,'Recipe: Spiritual Eye (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,366000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(8315,'Recipe: Flaming Dragon Skull (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,620000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(8316,'Recipe: Flaming Dragon Skull (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,540000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(8317,'Recipe: Titan Hammer (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,28000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(8318,'Recipe: Dwarven Hammer (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,137700,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(8319,'Recipe: Karik Horn (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,136700,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(8320,'Recipe: Destroyer Hammer (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,540000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(8321,'Recipe: Ice Storm Hammer (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,273600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8322,'Recipe: Ice Storm Hammer (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,173600,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8323,'Recipe: Star Buster (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,462000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8324,'Recipe: Star Buster (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,362000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8325,'Recipe: Doom Crusher (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,640000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(8326,'Recipe: Doom Crusher (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,540000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(8327,'Steel Sword Blade','PIECES','false','material',60,'stackable','liquid','none',0,11912,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(8328,'Titan Sword Blade','PIECES','false','material',60,'stackable','liquid','none',0,18929,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(8329,'Pa''agrian Sword Blade','PIECES','false','material',60,'stackable','liquid','none',0,36700,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(8330,'Guardian Sword Blade','PIECES','false','material',60,'stackable','liquid','none',0,45692,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(8331,'Infernal Master Blade','PIECES','false','material',60,'stackable','liquid','none',0,58785,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(8332,'Priest Sword Blade','PIECES','false','material',60,'stackable','liquid','none',0,5453,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(8333,'Sword of Magic Fog Blade','PIECES','false','material',60,'stackable','liquid','none',0,18929,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(8334,'Mysterious Sword Blade','PIECES','false','material',60,'stackable','liquid','none',0,25188,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(8335,'Ecliptic Sword Blade','PIECES','false','material',60,'stackable','liquid','none',0,43655,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(8336,'Blade of the Wizard''s Tear','PIECES','false','material',60,'stackable','liquid','none',0,45692,0,'true',0,1,'etc_sword_body_i00',1,1,1),
(8337,'Priest Mace Head','PIECES','false','material',60,'stackable','liquid','none',0,19757,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(8338,'Axe of Eclipse Head','PIECES','false','material',60,'stackable','liquid','none',0,41636,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(8339,'Spell Breaker Head','PIECES','false','material',60,'stackable','liquid','none',0,34950,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(8340,'Bones Head of Kaim Vanul','PIECES','false','material',60,'stackable','liquid','none',0,45769,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(8341,'Spiritual Eye Piece','PIECES','false','material',60,'stackable','liquid','none',0,59308,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(8342,'Flaming Dragon Skull Piece','PIECES','false','material',60,'stackable','liquid','none',0,72914,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(8343,'Titan Hammer Piece','PIECES','false','material',60,'stackable','liquid','none',0,21643,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(8344,'Dwarven Hammer Piece','PIECES','false','material',60,'stackable','liquid','none',0,42509,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(8345,'Karik Horn Piece','PIECES','false','material',60,'stackable','liquid','none',0,35480,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(8346,'Hammer Piece of Destroyer','PIECES','false','material',60,'stackable','liquid','none',0,58754,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(8347,'Ice Storm Hammer Head','PIECES','false','material',60,'stackable','liquid','none',0,35533,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(8348,'Star Buster Head','PIECES','false','material',60,'stackable','liquid','none',0,48308,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(8349,'Doom Crusher Head','PIECES','false','material',60,'stackable','liquid','none',0,72914,0,'true',0,1,'etc_squares_gray_i00',1,1,1),
(8351,'Black Colored Fish Scale','MATHERIALS','false','material',10,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_scale_i00',1,1,1),
(8352,'Red Colored Fish Scale','MATHERIALS','false','material',10,'stackable','liquid','none',0,0,0,'true',0,1,'etc_dion_fish_scale_i00',1,1,1),
(8353,'Green Colored Fish Scale','MATHERIALS','false','material',10,'stackable','liquid','none',0,0,0,'true',0,1,'etc_giran_fish_scale_i00',1,1,1),
(8354,'Yellow Colored Fish Scale','MATHERIALS','false','material',10,'stackable','liquid','none',0,0,0,'true',0,1,'etc_oren_fish_scale_i00',1,1,1),
(8355,'Blue Colored Fish Scale','MATHERIALS','false','material',10,'stackable','liquid','none',0,0,0,'true',0,1,'etc_aden_fish_scale_i00',1,1,1),
(8356,'White Colored Fish Scale','MATHERIALS','false','material',10,'stackable','liquid','none',0,0,0,'true',0,1,'etc_innadrile_fish_scale_i00',1,1,1),
(8357,'Orange Colored Fish Scale','MATHERIALS','false','material',10,'stackable','liquid','none',0,0,0,'true',0,1,'etc_godad_fish_scale_i00',1,1,1),
(8358,'Purple Colored Fish Scale','MATHERIALS','false','material',10,'stackable','liquid','none',0,0,0,'true',0,1,'etc_rune_fish_scale_i00',1,1,1),
(8359,'Jade Colored Fish Scale','MATHERIALS','false','material',10,'stackable','liquid','none',0,0,0,'true',0,1,'etc_schuttgart_fish_scale_i00',1,1,1),
(8360,'Adventurer''s Box - C Accessory','OTHER','false','none',20,'stackable','steel','none',0,0,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(8361,'Adventurer''s Box - B Accessory','OTHER','false','none',20,'stackable','steel','none',0,0,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(8362,'Adventurer''s Box - Hair Accessory','OTHER','false','none',20,'stackable','steel','none',0,0,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(8363,'Adventurer''s Box - Cradle of Creation','OTHER','false','none',20,'stackable','steel','none',0,0,0,'true',0,1,'etc_jewel_box_i00',1,1,1),
(8364,'Recipe: Party Hat (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,0,0,'true',0,1,'etc_recipe_green_i00',1,1,1),
(8365,'Recipe: Party Hat (70%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,0,0,'true',0,1,'etc_recipe_green_i00',1,1,1),
(8366,'Recipe: Feathered Hat (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,0,0,'true',0,1,'etc_recipe_green_i00',1,1,1),
(8367,'Recipe: Feathered Hat (70%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,0,0,'true',0,1,'etc_recipe_green_i00',1,1,1),
(8368,'Recipe: Artisan''s Goggles (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,0,0,'true',0,1,'etc_recipe_green_i00',1,1,1),
(8369,'Recipe: Artisan''s Goggles (70%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,0,0,'true',0,1,'etc_recipe_green_i00',1,1,1),
(8370,'Recipe: Red Horn of Victory (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,0,0,'true',0,1,'etc_recipe_green_i00',1,1,1),
(8371,'Recipe: Little Angel Wings (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,100000,0,'true',0,1,'etc_recipe_green_i00',1,1,1),
(8372,'Recipe: Fairy Antennae (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,0,0,'true',0,1,'etc_recipe_green_i00',1,1,1),
(8373,'Party Hat Fabric','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'etc_leather_yellow_i00',1,1,1),
(8374,'Feathered Hat Fabric','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'etc_leather_yellow_i00',1,1,1),
(8375,'Artisan''s Goggles Fabric','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'etc_leather_yellow_i00',1,1,1),
(8376,'Red Horn of Victory Fragment','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'etc_broken_crystal_red_i00',1,1,1),
(8377,'Little Angel Wings Piece','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'etc_broken_crystal_green_i00',1,1,1),
(8378,'Fairy Antennae Piece','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'etc_broken_crystal_green_i00',1,1,1),
(8379,'Petrification Scroll','OTHER','false','scroll',120,'stackable','paper','none',0,0,0,'true',0,1,'etc_piece_of_paper_white_i00',1,1,1),
(8380,'Spellbook: Betray','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6250,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(8381,'Spellbook: Mass Curse Fear','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(8382,'Spellbook: Mass Curse Gloom','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(8383,'Spellbook: Mass Surrender to Fire','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(8384,'Spellbook: Mass Surrender to Water','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(8385,'Spellbook: Mass Surrender to Wind','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(8386,'Spellbook - Arcane Disruption','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6250,0,'true',0,1,'etc_spell_books_summon_i00',1,1,1),
(8387,'Spellbook - Summon Cursed Bones','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7200,0,'true',0,1,'etc_spell_books_black_i00',1,1,1),
(8388,'Spellbook: Greater Might','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(8389,'Spellbook: Greater Shield','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(8390,'Amulet: War Chant','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(8391,'Amulet: Earth Chant','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_orcish_talisman_i00',1,1,1),
(8392,'Spellbook: Holy Resistance','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(8393,'Spellbook: Unholy Resistance','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(8394,'Spellbook: Trance','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(8395,'Spellbook: Erase','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(8396,'Spellbook: Magical Backfire','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(8397,'Spellbook: Clarity','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(8398,'Spellbook: Mana Burn','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(8399,'Spellbook: Mana Storm','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(8400,'Spellbook: Turn Undead','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(8401,'Spellbook: Major Heal','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(8402,'Spellbook: Major Group Heal','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'etc_spell_books_assistance_i00',1,1,1),
(8403,'Small Nimble Green Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i06',1,1,1),
(8404,'Small Ugly Green Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i06',1,1,1),
(8405,'Small Pudgy Green Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i06',1,1,1),
(8406,'Nimble Green Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i06',1,1,1),
(8407,'Ugly Green Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i06',1,1,1),
(8408,'Pudgy Green Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i06',1,1,1),
(8409,'Large Nimble Green Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i06',1,1,1),
(8410,'Large Ugly Green Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i06',1,1,1),
(8411,'Large Pudgy Green Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i06',1,1,1),
(8412,'Small Jade Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i07',1,1,1),
(8413,'Small Jade Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i07',1,1,1),
(8414,'Small Jade Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i07',1,1,1),
(8415,'Jade Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i07',1,1,1),
(8416,'Jade Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i07',1,1,1),
(8417,'Jade Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i07',1,1,1),
(8418,'Large Jade Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i07',1,1,1),
(8419,'Large Jade Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i07',1,1,1),
(8420,'Large Jade Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i07',1,1,1),
(8421,'Small Blue Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i01',1,1,1),
(8422,'Small Blue Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i01',1,1,1),
(8423,'Small Blue Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i01',1,1,1),
(8424,'Blue Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i01',1,1,1),
(8425,'Blue Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i01',1,1,1),
(8426,'Blue Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i01',1,1,1),
(8427,'Large Blue Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i01',1,1,1),
(8428,'Large Blue Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i01',1,1,1),
(8429,'Large Blue Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i01',1,1,1),
(8430,'Small Yellow Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i02',1,1,1),
(8431,'Small Yellow Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i02',1,1,1),
(8432,'Small Yellow Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i02',1,1,1),
(8433,'Yellow Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i02',1,1,1),
(8434,'Yellow Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i02',1,1,1),
(8435,'Yellow Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i02',1,1,1),
(8436,'Large Yellow Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i02',1,1,1),
(8437,'Large Yellow Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i02',1,1,1),
(8438,'Large Yellow Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i02',1,1,1),
(8439,'Small Orange Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i08',1,1,1),
(8440,'Small Orange Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i08',1,1,1),
(8441,'Small Orange Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i08',1,1,1),
(8442,'Orange Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i08',1,1,1),
(8443,'Orange Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i08',1,1,1),
(8444,'Orange Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i08',1,1,1),
(8445,'Large Orange Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i08',1,1,1),
(8446,'Large Orange Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i08',1,1,1),
(8447,'Large Orange Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i08',1,1,1),
(8448,'Small Purple Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i04',1,1,1),
(8449,'Small Purple Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i04',1,1,1),
(8450,'Small Purple Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i04',1,1,1),
(8451,'Purple Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i04',1,1,1),
(8452,'Purple Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i04',1,1,1),
(8453,'Purple Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i04',1,1,1),
(8454,'Large Purple Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i04',1,1,1),
(8455,'Large Purple Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i04',1,1,1),
(8456,'Large Purple Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i04',1,1,1),
(8457,'Small Red Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i03',1,1,1),
(8458,'Small Red Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i03',1,1,1),
(8459,'Small Red Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i03',1,1,1),
(8460,'Red Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i03',1,1,1),
(8461,'Red Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i03',1,1,1),
(8462,'Red Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i03',1,1,1),
(8463,'Large Red Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i03',1,1,1),
(8464,'Large Red Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i03',1,1,1),
(8465,'Large Red Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i03',1,1,1),
(8466,'Small White Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i00',1,1,1),
(8467,'Small White Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i00',1,1,1),
(8468,'Small White Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i00',1,1,1),
(8469,'White Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i00',1,1,1),
(8470,'White Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i00',1,1,1),
(8471,'White Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i00',1,1,1),
(8472,'High Grade - Large White Nimble Fish','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i00',1,1,1),
(8473,'Large White Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i00',1,1,1),
(8474,'Large White Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i00',1,1,1),
(8475,'Small Black Nimble Fish: Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i05',1,1,1),
(8476,'Small Black Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i05',1,1,1),
(8477,'Small Black Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i05',1,1,1),
(8478,'Black Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i05',1,1,1),
(8479,'Black Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i05',1,1,1),
(8480,'Black Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i05',1,1,1),
(8481,'Large Black Nimble Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_tuna_i05',1,1,1),
(8482,'Large Black Ugly Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_angler_i05',1,1,1),
(8483,'Large Black Fat Fish - Upper Grade','OTHER','false','none',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_bream_i05',1,1,1),
(8484,'Prize-Winning Fishing Lure','EQUIPMENT','false','bait',4,'stackable','liquid','none',0,240,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8485,'Prize-Winning Night Fishing Lure','EQUIPMENT','false','bait',4,'stackable','liquid','none',0,240,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8486,'Prize-Winning Novice Fishing Lure','EQUIPMENT','false','bait',5,'stackable','liquid','none',0,100,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8487,'Recipe: Destroyer Hammer (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,366000,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(8488,'Engraved Hammer','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'weapon_big_hammer_i00',1,1,1),
(8489,'Daimon''s Eyes','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_eyeball_i00',1,1,1),
(8490,'Hestia''s Fairy Stone','OTHER','false','none',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_crystal_gold_i00',1,1,1),
(8491,'Nucleus of Lesser Golem','OTHER','false','none',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_bead_white_i00',1,1,1),
(8492,'Falston''s Fang','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_fang_ivory_i00',1,1,1),
(8493,'Shaid''s Talon','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_claw_i00',1,1,1),
(8494,'Nucleus of Flamestone Giant','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_bead_red_i00',1,1,1),
(8495,'Book of Grey Star','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_memopad_i00',1,1,1),
(8496,'Gludio''s Luminous Lure','EQUIPMENT','false','bait',5,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8497,'Dion''s Luminous Lure','EQUIPMENT','false','bait',4,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8498,'Giran''s Luminous Lure','EQUIPMENT','false','bait',3,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8499,'Oren''s Luminous Lure','EQUIPMENT','false','bait',5,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8500,'Aden''s Luminous Lure','EQUIPMENT','false','bait',4,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8501,'Innadril''s Luminous Lure','EQUIPMENT','false','bait',3,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8502,'Goddard''s Luminous Lure','EQUIPMENT','false','bait',5,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8503,'Rune''s Luminous Lure','EQUIPMENT','false','bait',4,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8504,'Schuttgart''s Luminous Lure','EQUIPMENT','false','bait',3,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8505,'Green Luminous Lure - Low Grade','EQUIPMENT','false','bait',5,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8506,'Green Luminous Lure','EQUIPMENT','false','bait',4,'stackable','liquid','none',0,120,0,'true',0,1,'etc_bait_i00',1,1,1),
(8507,'Green Colored Lure - High Grade','EQUIPMENT','false','bait',3,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8508,'Purple Luminous Lure - Low Grade','EQUIPMENT','false','bait',5,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8509,'Purple Luminous Lure','EQUIPMENT','false','bait',4,'stackable','liquid','none',0,180,0,'true',0,1,'etc_bait_i01',1,1,1),
(8510,'Purple Luminous Lure - High Grade','EQUIPMENT','false','bait',3,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8511,'Yellow Luminous Lure - Low Grade','EQUIPMENT','false','bait',5,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8512,'Yellow Luminous Lure','EQUIPMENT','false','bait',4,'stackable','liquid','none',0,150,0,'true',0,1,'etc_bait_i02',1,1,1),
(8513,'Yellow Luminous Lure - High Grade','EQUIPMENT','false','bait',3,'stackable','liquid','none',0,0,0,'true',0,1,'etc_gludio_fish_lure_i00',1,1,1),
(8514,'Remnants of Old Dwarves'' Dreams','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_inf_ore_high_i00',1,1,1),
(8515,'Charm of Courage: No Grade','CONSUMABLE','false','scroll',10,'stackable','paper','none',0,2000,0,'true',0,1,'etc_charm_of_courage_i00',1,1,1),
(8516,'Charm of Courage: D-Grade','CONSUMABLE','false','scroll',10,'stackable','paper','d',0,6600,0,'true',0,1,'etc_charm_of_courage_i01',1,1,1),
(8517,'Charm of Courage: C-Grade','CONSUMABLE','false','scroll',10,'stackable','paper','c',0,13200,0,'true',0,1,'etc_charm_of_courage_i02',1,1,1),
(8518,'Charm of Courage: B-Grade','CONSUMABLE','false','scroll',10,'stackable','paper','b',0,26000,0,'true',0,1,'etc_charm_of_courage_i03',1,1,1),
(8519,'Charm of Courage: A-Grade','CONSUMABLE','false','scroll',10,'stackable','paper','a',0,54000,0,'true',0,1,'etc_charm_of_courage_i04',1,1,1),
(8520,'Charm of Courage: S-Grade','CONSUMABLE','false','scroll',10,'stackable','paper','s',0,100000,0,'true',0,1,'etc_charm_of_courage_i05',1,1,1),
(8521,'Seed: Sea Coba','OTHER','false','seed',1,'stackable','paper','none',0,900,0,'true',0,1,'etc_sea_coba_seed_i00',1,1,1),
(8522,'Seed: Alternative Sea Coba','OTHER','false','seed',1,'stackable','paper','none',0,900,0,'true',0,1,'etc_sea_coba_seed_i00',1,1,1),
(8523,'Seed: Twin Coba','OTHER','false','seed',1,'stackable','paper','none',0,1000,0,'true',1000,1,'etc_twin_coba_seed_i00',1,1,1),
(8524,'Seed: Alternative Twin Coba','OTHER','false','seed',1,'stackable','paper','none',0,1000,0,'true',0,1,'etc_twin_coba_seed_i00',1,1,1),
(8525,'Seed: Great Coba','OTHER','false','seed',1,'stackable','paper','none',0,1200,0,'true',0,1,'etc_great_coba_seed_i00',1,1,1),
(8526,'Seed: Alternative Great Coba','OTHER','false','seed',1,'stackable','paper','none',0,1200,0,'true',0,1,'etc_great_coba_seed_i00',1,1,1),
(8534,'Adventurer''s Box: C-Grade Accessory (Low Grade)','OTHER','false','none',20,'stackable','steel','none',0,0,0,'true',0,1,'etc_box_of_adventure_1_i00',1,1,1),
(8535,'Adventurer''s Box: C-Grade Accessory (Medium Grade)','OTHER','false','none',20,'stackable','steel','none',0,0,0,'true',0,1,'etc_box_of_adventure_1_i00',1,1,1),
(8536,'Adventurer''s Box: C-Grade Accessory (High Grade)','OTHER','false','none',20,'stackable','steel','none',0,0,0,'true',0,1,'etc_box_of_adventure_1_i00',1,1,1),
(8537,'Adventurer''s Box: B-Grade Accessory (Low Grade)','OTHER','false','none',20,'stackable','steel','none',0,0,0,'true',0,1,'etc_box_of_adventure_2_i00',1,1,1),
(8538,'Adventurer''s Box: B-Grade Accessory (High Grade)','OTHER','false','none',20,'stackable','steel','none',0,0,0,'true',0,1,'etc_box_of_adventure_3_i00',1,1,1),
(8539,'Adventurer''s Box: Hair Accessory','OTHER','false','none',20,'stackable','steel','none',0,0,0,'true',0,1,'etc_box_of_adventure_4_i00',1,1,1),
(8540,'Adventurer''s Box: Cradle of Creation','OTHER','false','none',20,'stackable','steel','none',0,0,0,'true',0,1,'etc_box_of_adventure_5_i00',1,1,1),
(8542,'Newbie Travel Token','OTHER','false','none',10,'stackable','liquid','none',0,0,0,'false',0,1,'etc_coins_gold_i00',0,1,0),
(8543,'Bead Parcel','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'true',0,1,'accessary_mage_earing_i00',1,1,1),
(8544,'Timora Orc''s Head','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_skull_red_i00',1,1,1),
(8545,'Kasha Spider''s Tooth','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_claw_i00',1,1,1),
(8546,'Horn of Baar Dre Vanul','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_horn_i00',1,1,1),
(8547,'Old Box','OTHER','false','quest',100,'stackable','fish','none',0,0,0,'true',0,1,'etc_box_of_adventure_1_i00',1,1,1),
(8548,'Hot Springs Lure','EQUIPMENT','false','bait',3,'stackable','liquid','none',0,200,0,'true',0,1,'etc_bait_i02',1,1,1),
(8549,'Bruin Lizardman Blood','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_lesser_potion_purple_i00',1,1,1),
(8550,'Picot Araneid''s Leg','OTHER','false','quest',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_sting_b_i00',1,1,1),
(8551,'Box of Cheerleading Gear Used to encourage victory.','OTHER','false','none',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_box_of_adventure_1_i00',1,1,1),
(8553,'Red Mask of Victory,Fabric','PIECES','false','material',60,'stackable','paper','none',0,500000,0,'true',0,1,'etc_piece_of_cloth_red_i00',1,1,1),
(8554,'Recipe: Red Mask of Victory (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,50000,0,'true',0,1,'etc_recipe_green_i00',1,1,1),
(8555,'Echo Crystal - Viva Victory Korea','OTHER','false','none',10,'stackable','paper','none',0,0,0,'false',0,1,'etc_echo_crystal_i00',1,1,1),
(8556,'Dewdrop of Destruction','OTHER','false','none',3,'stackable','gold','none',0,0,0,'true',0,1,'etc_lesser_potion_red_i00',1,1,1),
(8570,'Event Gift Box','OTHER','false','none',20,'stackable','steel','none',0,0,0,'false',0,1,'etc_box_of_adventure_3_i00',1,1,1),
(8571,'Event Gift Box','OTHER','false','none',20,'stackable','steel','none',0,0,0,'false',0,1,'etc_box_of_adventure_3_i00',1,1,1),
(8572,'Event Gift Box','OTHER','false','none',20,'stackable','steel','none',0,0,0,'false',0,1,'etc_box_of_adventure_3_i00',1,1,1),
(8573,'Event Gift Box','OTHER','false','none',20,'stackable','steel','none',0,0,0,'false',0,1,'etc_box_of_adventure_3_i00',1,1,1),
(8574,'Event Gift Box','OTHER','false','none',20,'stackable','steel','none',0,0,0,'false',0,1,'etc_box_of_adventure_3_i00',1,1,1),
(8575,'Event Gift Box','OTHER','false','none',20,'stackable','steel','none',0,0,0,'false',0,1,'etc_box_of_adventure_3_i00',1,1,1),
(8592,'Weapon Exchange Coupon - No Grade','OTHER','false','none',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_lottery_card_i00',1,1,1),
(8593,'Weapon Exchange Coupon - D Grade','OTHER','false','none',1,'stackable','paper','none',0,0,0,'false',0,1,'etc_lottery_card_i00',1,1,1),
(8594,'Scroll: Recovery (No Grade)','CONSUMABLE','false','potion',10,'stackable','paper','none',0,2000,0,'true',2286,1,'etc_penalty_recovery_i00',1,1,1),
(8595,'Scroll: Recovery (Grade D)','CONSUMABLE','false','potion',10,'stackable','paper','d',0,4800,0,'true',2286,2,'etc_penalty_recovery_i01',1,1,1),
(8596,'Scroll: Recovery (Grade C)','CONSUMABLE','false','potion',10,'stackable','paper','c',0,14000,0,'true',2286,3,'etc_penalty_recovery_i02',1,1,1),
(8597,'Scroll: Recovery (Grade B)','CONSUMABLE','false','potion',10,'stackable','paper','b',0,28000,0,'true',2286,4,'etc_penalty_recovery_i03',1,1,1),
(8598,'Scroll: Recovery (Grade A)','CONSUMABLE','false','potion',10,'stackable','paper','a',0,48000,0,'true',2286,5,'etc_penalty_recovery_i04',1,1,1),
(8599,'Scroll: Recovery (Grade S)','CONSUMABLE','false','potion',10,'stackable','paper','s',0,80000,0,'true',2286,6,'etc_penalty_recovery_i05',1,1,1),
(8600,'Herb of Life','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',2278,1,'',1,1,1),
(8601,'Greater Herb of Life','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',2278,2,'',1,1,1),
(8602,'Superior Herb of Life','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',2278,3,'',1,1,1),
(8603,'Herb of Mana','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',2279,1,'',1,1,1),
(8604,'Greater Herb of Mana','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',2279,2,'',1,1,1),
(8605,'Superior Herb of Mana','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',2279,3,'',1,1,1),
(8606,'Herb of Power','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',2280,1,'',1,1,1),
(8607,'Herb of Magic','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',2281,1,'',1,1,1),
(8608,'Herb of Atk. Spd.','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',2282,1,'etc_attack_sp_herb_i00',1,1,1),
(8609,'Herb of Casting Spd.','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',2283,1,'etc_magic_sp_herb_i00',1,1,1),
(8610,'Herb of Critical Attack.','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',2284,1,'etc_critical_herb_i00',1,1,1),
(8611,'Herb of Speed','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',2285,1,'etc_move_herb_i00',1,1,1),
(8612,'Herb of the Warrior','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',0,1,'etc_warrior_set_i00',1,1,1),
(8613,'Herb of the Mystic','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',0,1,'etc_magic_set_i00',1,1,1),
(8614,'Herb of Recovery','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',0,1,'etc_recovery_set_i00',1,1,1),
(8615,'Summoning Crystal','CONSUMABLE','false','potion',10,'stackable','crystal','none',0,41562,0,'true',0,1,'etc_recall_crystal_i00',1,1,1),
(8616,'Spellbook: Summon Friend','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6250,0,'true',0,1,'etc_party_sommons_i00',1,1,1),
(8617,'Spellbook: Word of Invitation','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'etc_party_sommons_i01',1,1,1),
(8618,'Ancient Book - Divine Inspiration (Modern Language Version)','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'etc_add_buffslot_i00',1,1,1),
(8619,'Ancient Book - Divine Inspiration (Original Language Version)','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'etc_add_buffslot_i01',1,1,1),
(8620,'Ancient Book - Divine Inspiration (Manuscript)','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'etc_add_buffslot_i02',1,1,1),
(8621,'Ancient Book - Divine Inspiration (Original Version)','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'etc_add_buffslot_i03',1,1,1),
(8622,'Elixir of Life (No Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','none',0,1544,0,'true',2287,1,'etc_super_hp_potion_i00',1,1,1),
(8623,'Elixir of Life (D-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','d',0,4097,0,'true',2287,2,'etc_super_hp_potion_i01',1,1,1),
(8624,'Elixir of Life (C-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','c',0,8550,0,'true',2287,3,'etc_super_hp_potion_i02',1,1,1),
(8625,'Elixir of Life (B-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','b',0,10450,0,'true',2287,4,'etc_super_hp_potion_i03',1,1,1),
(8626,'Elixir of Life (A-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','a',0,13350,0,'true',2287,5,'etc_super_hp_potion_i04',1,1,1),
(8627,'Elixir of Life (S-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','s',0,17350,0,'true',2287,6,'etc_super_hp_potion_i05',1,1,1),
(8628,'Elixir of Mental Strength (No Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','none',0,1700,0,'true',2288,1,'etc_super_mp_potion_i00',1,1,1),
(8629,'Elixir of Mental Strength (D-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','d',0,3700,0,'true',2288,2,'etc_super_mp_potion_i01',1,1,1),
(8630,'Elixir of Mental Strength (C-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','c',0,8700,0,'true',2288,3,'etc_super_mp_potion_i02',1,1,1),
(8631,'Elixir of Mental Strength (B-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','b',0,11600,0,'true',2288,4,'etc_super_mp_potion_i03',1,1,1),
(8632,'Elixir of Mental Strength (A-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','a',0,14400,0,'true',2288,5,'etc_super_mp_potion_i04',1,1,1),
(8633,'Elixir of Mental Strength (S-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','s',0,16800,0,'true',2288,6,'etc_super_mp_potion_i05',1,1,1),
(8634,'Elixir of CP (No Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','none',0,712,0,'true',2289,1,'etc_super_cp_potion_i00',1,1,1),
(8635,'Elixir of CP (D-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','d',0,1663,0,'true',2289,2,'etc_super_cp_potion_i01',1,1,1),
(8636,'Elixir of CP (C-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','c',0,3563,0,'true',2289,3,'etc_super_cp_potion_i02',1,1,1),
(8637,'Elixir of CP (B-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','b',0,4750,0,'true',2289,4,'etc_super_cp_potion_i03',1,1,1),
(8638,'Elixir of CP (A-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','a',0,5938,0,'true',2289,5,'etc_super_cp_potion_i04',1,1,1),
(8639,'Elixir of CP (S-Grade)','CONSUMABLE','false','potion',5,'stackable','liquid','s',0,7125,0,'true',2289,6,'etc_super_cp_potion_i05',1,1,1),
(8640,'Recipe: Elixir of Life (No Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,500,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(8641,'Recipe: Elixir of Life (D-Grade)','RECIPIES','false','recipe',30,'stackable','paper','none',0,1000,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(8642,'Recipe: Elixir of Life (C-Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,1500,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(8643,'Recipe: Elixir of Life (B-Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,2000,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8644,'Recipe: Elixir of Life (A-Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,2500,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(8645,'Recipe: Elixir of Life (S-Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,3000,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(8646,'Recipe: Elixir of Mental Strength (No Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,640,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(8647,'Recipe: Elixir of Mental Strength (D-Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,1200,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(8648,'Recipe: Elixir of Mental Strength (C-Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,1760,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(8649,'Recipe: Elixir of Mental Strength (B-Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,2320,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8650,'Recipe: Elixir of Mental Strength (A-Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,2880,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(8651,'Recipe: Elixir of Mental Strength (S-Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,3440,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(8652,'Recipe: Elixir of CP (No Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,0,0,'true',0,1,'etc_recipe_white_i00',1,1,1),
(8653,'Recipe: Elixir of CP (D-Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,0,0,'true',0,1,'etc_recipe_blue_i00',1,1,1),
(8654,'Recipe: Elixir of CP (C-Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,0,0,'true',0,1,'etc_recipe_yellow_i00',1,1,1),
(8655,'Recipe: Elixir of CP (B-Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,0,0,'true',0,1,'etc_recipe_red_i00',1,1,1),
(8656,'Recipe: Elixir of CP (A-Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,0,0,'true',0,1,'etc_recipe_violet_i00',1,1,1),
(8657,'Recipe: Elixir of CP (S-Grade) (100%)','RECIPIES','false','recipe',30,'stackable','paper','none',0,0,0,'true',0,1,'etc_recipe_black_i00',1,1,1),
(8658,'Mysterious Solvent','MATHERIALS','false','material',2,'stackable','liquid','none',0,200,0,'true',0,1,'etc_dragon_blood_i00',1,1,1),
(8659,'Coffer of Shadows','OTHER','false','none',0,'stackable','paper','none',0,0,0,'true',0,1,'etc_box_of_adventure_1_i00',1,1,1),
(8663,'Mystery Potion (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_clear_i00',1,1,1),
(8664,'Facelifting Potion - A (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_purple_i00',1,1,1),
(8665,'Facelifting Potion - B (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_purple_i00',1,1,1),
(8666,'Facelifting Potion - C (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_purple_i00',1,1,1),
(8667,'Dye Potion - A (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_scarlet_i00',1,1,1),
(8668,'Dye Potion - B (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_scarlet_i00',1,1,1),
(8669,'Dye Potion - C (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_scarlet_i00',1,1,1),
(8670,'Dye Potion - D (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_scarlet_i00',1,1,1),
(8671,'Hair Style Change Potion - A (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_green_i00',1,1,1),
(8672,'Hair Style Change Potion - B (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_green_i00',1,1,1),
(8673,'Hair Style Change Potion - C (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_green_i00',1,1,1),
(8674,'Hair Style Change Potion - D (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_green_i00',1,1,1),
(8675,'Hair Style Change Potion - E (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_green_i00',1,1,1),
(8676,'Hair Style Change Potion - F (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_green_i00',1,1,1),
(8677,'Hair Style Change Potion - G (Event)','CONSUMABLE','false','potion',50,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_lesser_potion_green_i00',1,1,1),
(8690,'Recipe: Sirra''s Blade (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8691,'Recipe: Sirra''s Blade (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8692,'Recipe: Sword of Ipos (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8693,'Recipe: Sword of Ipos (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8694,'Recipe: Barakiel''s Axe (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8695,'Recipe: Barakiel''s Axe (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8696,'Recipe: Behemoth''s Tuning Fork (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8697,'Recipe: Behemoth''s Tuning Fork (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8698,'Recipe: Naga Storm (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8699,'Recipe: Naga Storm (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8700,'Recipe: Tiphon''s Spear (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8701,'Recipe: Tiphon''s Spear (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8702,'Recipe: Shyeed''s Bow (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8703,'Recipe: Shyeed''s Bow (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8704,'Recipe: Sobekk''s Hurricane (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8705,'Recipe: Sobekk''s Hurricane (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8706,'Recipe: Themis'' Tongue (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8707,'Recipe: Themis'' Tongue (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8708,'Recipe: Cabrio''s Hand (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8709,'Recipe: Cabrio''s Hand (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8710,'Recipe: Daimon Crystal (60%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8711,'Recipe: Daimon Crystal (100%)','RECIPIES','false','recipe',30,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_recipe_violet_i00',1,1,1),
(8712,'Sirra''s Blade Edge','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_sword_body_i00',1,1,1),
(8713,'Sword of Ipos Blade','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_sword_body_i00',1,1,1),
(8714,'Barakiel''s Axe Piece','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_bark_gold_i00',1,1,1),
(8715,'Behemoth''s Tuning Fork Piece','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_bark_gold_i00',1,1,1),
(8716,'Naga Storm Piece','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_bark_gold_i00',1,1,1),
(8717,'Tiphon''s Spear Edge','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_sword_body_i00',1,1,1),
(8718,'Shyeed''s Bow Shaft','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_branch_gold_i00',1,1,1),
(8719,'Sobekk''s Hurricane Edge','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_sword_body_i00',1,1,1),
(8720,'Themis'' Tongue Piece','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_bark_gold_i00',1,1,1),
(8721,'Cabrio''s Hand Head','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_squares_gray_i00',1,1,1),
(8722,'Daimon Crystal Fragment','PIECES','false','material',60,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_bark_gold_i00',1,1,1),
(8723,'Life Stone: level 46','MISC','false','material',2,'stackable','liquid','none',0,3000,0,'true',0,1,'icon.etc_mineral_general_i00',1,1,1),
(8724,'Life Stone: level 49','MISC','false','material',2,'stackable','liquid','none',0,4500,0,'true',0,1,'icon.etc_mineral_general_i00',1,1,1),
(8725,'Life Stone: level 52','MISC','false','material',2,'stackable','liquid','none',0,6000,0,'true',0,1,'icon.etc_mineral_general_i01',1,1,1),
(8726,'Life Stone: level 55','MISC','false','material',2,'stackable','liquid','none',0,7500,0,'true',0,1,'icon.etc_mineral_general_i01',1,1,1),
(8727,'Life Stone: level 58','MISC','false','material',2,'stackable','liquid','none',0,10000,0,'true',0,1,'icon.etc_mineral_general_i01',1,1,1),
(8728,'Life Stone: level 61','MISC','false','material',2,'stackable','liquid','none',0,12500,0,'true',0,1,'icon.etc_mineral_general_i02',1,1,1),
(8729,'Life Stone: level 64','MISC','false','material',2,'stackable','liquid','none',0,15000,0,'true',0,1,'icon.etc_mineral_general_i02',1,1,1),
(8730,'Life Stone: level 67','MISC','false','material',2,'stackable','liquid','none',0,20000,0,'true',0,1,'icon.etc_mineral_general_i02',1,1,1),
(8731,'Life Stone: level 70','MISC','false','material',2,'stackable','liquid','none',0,25000,0,'true',0,1,'icon.etc_mineral_general_i02',1,1,1),
(8732,'Life Stone: level 76','MISC','false','material',2,'stackable','liquid','none',0,30000,0,'true',0,1,'icon.etc_mineral_general_i03',1,1,1),
(8733,'Mid-Grade Life Stone: level 46','MISC','false','material',2,'stackable','liquid','none',0,30000,0,'true',0,1,'icon.etc_mineral_special_i00',1,1,1),
(8734,'Mid-Grade Life Stone: level 49','MISC','false','material',2,'stackable','liquid','none',0,35000,0,'true',0,1,'icon.etc_mineral_special_i00',1,1,1),
(8735,'Mid-Grade Life Stone: level 52','MISC','false','material',2,'stackable','liquid','none',0,40000,0,'true',0,1,'icon.etc_mineral_special_i01',1,1,1),
(8736,'Mid-Grade Life Stone: level 55','MISC','false','material',2,'stackable','liquid','none',0,45000,0,'true',0,1,'icon.etc_mineral_special_i01',1,1,1),
(8737,'Mid-Grade Life Stone: level 58','MISC','false','material',2,'stackable','liquid','none',0,50000,0,'true',0,1,'icon.etc_mineral_special_i01',1,1,1),
(8738,'Mid-Grade Life Stone: level 61','MISC','false','material',2,'stackable','liquid','none',0,55000,0,'true',0,1,'icon.etc_mineral_special_i02',1,1,1),
(8739,'Mid-Grade Life Stone: level 64','MISC','false','material',2,'stackable','liquid','none',0,60000,0,'true',0,1,'icon.etc_mineral_special_i02',1,1,1),
(8740,'Mid-Grade Life Stone: level 67','MISC','false','material',2,'stackable','liquid','none',0,65000,0,'true',0,1,'icon.etc_mineral_special_i02',1,1,1),
(8741,'Mid-Grade Life Stone: level 70','MISC','false','material',2,'stackable','liquid','none',0,70000,0,'true',0,1,'icon.etc_mineral_special_i02',1,1,1),
(8742,'Mid-Grade Life Stone: level 76','MISC','false','material',2,'stackable','liquid','none',0,75000,0,'true',0,1,'icon.etc_mineral_special_i03',1,1,1),
(8743,'High-Grade Life Stone: level 46','MISC','false','material',2,'stackable','liquid','none',0,50000,0,'true',0,1,'icon.etc_mineral_rare_i00',1,1,1),
(8744,'High-Grade Life Stone: level 49','MISC','false','material',2,'stackable','liquid','none',0,55000,0,'true',0,1,'icon.etc_mineral_rare_i00',1,1,1),
(8745,'High-Grade Life Stone: level 52','MISC','false','material',2,'stackable','liquid','none',0,60000,0,'true',0,1,'icon.etc_mineral_rare_i01',1,1,1),
(8746,'High-Grade Life Stone: level 55','MISC','false','material',2,'stackable','liquid','none',0,65000,0,'true',0,1,'icon.etc_mineral_rare_i01',1,1,1),
(8747,'High-Grade Life Stone: level 58','MISC','false','material',2,'stackable','liquid','none',0,70000,0,'true',0,1,'icon.etc_mineral_rare_i01',1,1,1),
(8748,'High-Grade Life Stone: level 61','MISC','false','material',2,'stackable','liquid','none',0,75000,0,'true',0,1,'icon.etc_mineral_rare_i02',1,1,1),
(8749,'High-Grade Life Stone: level 64','MISC','false','material',2,'stackable','liquid','none',0,80000,0,'true',0,1,'icon.etc_mineral_rare_i02',1,1,1),
(8750,'High-Grade Life Stone: level 67','MISC','false','material',2,'stackable','liquid','none',0,90000,0,'true',0,1,'icon.etc_mineral_rare_i02',1,1,1),
(8751,'High-Grade Life Stone: level 70','MISC','false','material',2,'stackable','liquid','none',0,100000,0,'true',0,1,'icon.etc_mineral_rare_i02',1,1,1),
(8752,'High-Grade Life Stone: level 76','MISC','false','material',2,'stackable','liquid','none',0,110000,0,'true',0,1,'icon.etc_mineral_rare_i03',1,1,1),
(8753,'Top-Grade Life Stone: level 46','MISC','false','material',2,'stackable','liquid','none',0,80000,0,'true',0,1,'icon.etc_mineral_unique_i00',1,1,1);
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(8754,'Top-Grade Life Stone: level 49','MISC','false','material',2,'stackable','liquid','none',0,85000,0,'true',0,1,'icon.etc_mineral_unique_i00',1,1,1),
(8755,'Top-Grade Life Stone: level 52','MISC','false','material',2,'stackable','liquid','none',0,90000,0,'true',0,1,'icon.etc_mineral_unique_i01',1,1,1),
(8756,'Top-Grade Life Stone: level 55','MISC','false','material',2,'stackable','liquid','none',0,95000,0,'true',0,1,'icon.etc_mineral_unique_i01',1,1,1),
(8757,'Top-Grade Life Stone: level 58','MISC','false','material',2,'stackable','liquid','none',0,100000,0,'true',0,1,'icon.etc_mineral_unique_i01',1,1,1),
(8758,'Top-Grade Life Stone: level 61','MISC','false','material',2,'stackable','liquid','none',0,110000,0,'true',0,1,'icon.etc_mineral_unique_i02',1,1,1),
(8759,'Top-Grade Life Stone: level 64','MISC','false','material',2,'stackable','liquid','none',0,120000,0,'true',0,1,'icon.etc_mineral_unique_i02',1,1,1),
(8760,'Top-Grade Life Stone: level 67','MISC','false','material',2,'stackable','liquid','none',0,130000,0,'true',0,1,'icon.etc_mineral_unique_i02',1,1,1),
(8761,'Top-Grade Life Stone: level 70','MISC','false','material',2,'stackable','liquid','none',0,140000,0,'true',0,1,'icon.etc_mineral_unique_i02',1,1,1),
(8762,'Top-Grade Life Stone: level 76','MISC','false','material',2,'stackable','liquid','none',0,150000,0,'true',0,1,'icon.etc_mineral_unique_i03',1,1,1),
(8764,'Trap Stone','MATHERIALS','false','material',2,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_capture_stone_i00',1,1,1),
(8765,'Red Gem','OTHER','false','quest',0,'stackable','liquid','none',0,0,0,'false',0,1,'icon.etc_bead_red_i00',1,1,1),
(8766,'Spirit Bead','OTHER','false','quest',0,'stackable','liquid','none',0,0,0,'false',0,1,'icon.etc_bead_blue_i00',1,1,1),
(8767,'Tyrannosaurus Claw','OTHER','false','quest',0,'stackable','liquid','none',0,0,0,'false',0,1,'icon.etc_claw_i00',1,1,1),
(8768,'Diary Fragment','OTHER','false','quest',0,'stackable','liquid','none',0,0,0,'false',0,1,'icon.etc_piece_of_paper_white_i00',1,1,1),
(8769,'Expedition Member''s Letter','OTHER','false','quest',0,'normal','paper','none',0,0,0,'false',0,1,'icon.etc_letter_envelope_i00',1,1,1),
(8770,'Ornithomimus Claw','OTHER','false','quest',0,'stackable','liquid','none',0,0,0,'false',0,1,'icon.etc_claw_i00',1,1,1),
(8771,'Deinonychus Bone','OTHER','false','quest',0,'stackable','liquid','none',0,0,0,'false',0,1,'icon.etc_piece_bone_red_i00',1,1,1),
(8772,'Pachycephalosaurus Skin','OTHER','false','quest',0,'stackable','liquid','none',0,0,0,'false',0,1,'icon.etc_leather_yellow_i00',1,1,1),
(8773,'Practice Elrokian Trap','MATHERIALS','false','material',0,'stackable','liquid','none',0,0,0,'true',0,1,'icon.weapon_seize_mace_i00',1,1,1),
(8774,'Dinosaur Tissue','MATHERIALS','false','material',0,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_bodypart_heart_i00',1,1,1),
(8775,'Dinosaur Egg','MATHERIALS','false','material',0,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_dragon_egg_i05',1,1,1),
(8776,'Bones of a Plains Dinosaur','MATHERIALS','false','material',0,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_piece_bone_black_i00',1,1,1),
(8777,'Ancient Creatures and How I Long To Be With Them','MATHERIALS','false','material',0,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_spellbook_gray_i00',1,1,1),
(8778,'Mantarasa Egg','MATHERIALS','false','material',0,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_dragon_egg_i03',1,1,1),
(8779,'Ornithomimus Claw','OTHER','false','quest',0,'stackable','liquid','none',0,0,0,'false',0,1,'icon.etc_claw_i00',1,1,1),
(8780,'Deinonychus Bone Fragment','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'icon.etc_fang_red_i00',1,1,1),
(8781,'Epitaph of Wisdom','MATHERIALS','false','material',0,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_ancient_tablet_i00',1,1,1),
(8782,'Gazkh Fragment','MATHERIALS','false','material',0,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_piece_of_gazk_i00',1,1,1),
(8783,'Bone Powder','MATHERIALS','false','material',0,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_piece_of_gazk_i00',1,1,1),
(8784,'Gazkh','MATHERIALS','false','material',0,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_head_of_gazk_i00',1,1,1),
(8785,'Dinosaur Fang Necklace','OTHER','false','none',0,'stackable','steel','none',0,0,0,'false',0,1,'icon.etc_ketra_friendship_1_i00',1,1,1),
(8786,'Primeval Potion','CONSUMABLE','false','potion',2,'stackable','liquid','none',0,5000,0,'true',2305,1,'icon.etc_potion_red_i00',1,1,1),
(8787,'Sprigant''s Fruit','MATHERIALS','false','material',2,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_fruit_green_i00',1,1,1),
(8868,'Ziggo''s Gemstone','MATHERIALS','false','material',2,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_jewel_red_i00',1,1,1),
(8869,'Shadow Item Exchange Coupon: D Grade','OTHER','false','none',0,'stackable','paper','none',0,0,0,'false',0,1,'icon.etc_lottery_card_i00',0,1,0),
(8870,'Shadow Item Exchange Coupon: C Grade','OTHER','false','none',0,'stackable','paper','none',0,0,0,'false',0,1,'icon.etc_lottery_card_i00',0,1,0),
(8871,'Strategy Guide','OTHER','false','none',20,'normal','liquid','none',0,45000,0,'true',0,1,'icon.etc_paper_black_i00',1,1,1),
(8872,'Flash Gunpowder','OTHER','false','none',20,'stackable','steel','none',0,1500,0,'false',0,1,'icon.etc_powder_gray_i00',1,1,1),
(8873,'Phoenix Blood','MATHERIALS','false','material',20,'stackable','liquid','none',0,20000,0,'true',0,1,'icon.etc_feather_gold_i00',1,1,1),
(8874,'Einhasad''s Holy Water','MATHERIALS','false','material',20,'stackable','liquid','none',0,20000,0,'true',0,1,'icon.etc_holy_grail_i00',1,1,1),
(8875,'Battle Symbol','MATHERIALS','false','material',20,'stackable','liquid','none',0,20000,0,'true',0,1,'icon.etc_debris_i00',1,1,1),
(8876,'Magic Symbol','MATHERIALS','false','material',20,'stackable','liquid','none',0,20000,0,'true',0,1,'icon.etc_dragon_egg_i02',1,1,1),
(8877,'Spellbook: Soul of the Phoenix','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_element_i00',1,1,1),
(8878,'Spellbook: Summon Feline King','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_summon_i00',1,1,1),
(8879,'Spellbook: Summon Magnus the Unicorn','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_summon_i00',1,1,1),
(8880,'Spellbook: Summon Spectral Knight','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_summon_i00',1,1,1),
(8881,'Spellbook: Cleanse','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_assistance_i00',1,1,1),
(8882,'Spellbook: Salvation','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_assistance_i00',1,1,1),
(8883,'Spellbook: Mystic Immunity','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_assistance_i00',1,1,1),
(8884,'Spellbook: Spell Turning','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_assistance_i00',1,1,1),
(8885,'Amulet: Magnus'' Chant','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_orcish_talisman_i00',1,1,1),
(8886,'Amulet: Victories of Pa''agrio','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_orcish_talisman_i00',1,1,1),
(8887,'Amulet: Pa''agrio''s Emblem','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_orcish_talisman_i00',1,1,1),
(8888,'Amulet: Pa''agrio''s Fist','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_orcish_talisman_i00',1,1,1),
(8889,'Amulet: Gate Chant','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_orcish_talisman_i00',1,1,1),
(8890,'Spellbook: Summon Attractive Cubic','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,7700,0,'true',0,1,'icon.etc_spell_books_summon_i00',1,1,1),
(8891,'Spellbook: Aura Flash','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6750,0,'true',0,1,'icon.etc_spell_books_white_i00',1,1,1),
(8892,'Ancient Tactical Manual: Symbol of Defense','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_assistance_i00',1,1,1),
(8893,'Ancient Tactical Manual: Symbol of Noise','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_assistance_i00',1,1,1),
(8894,'Ancient Tactical Manual: Symbol of Resistance','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_assistance_i00',1,1,1),
(8895,'Ancient Tactical Manual: Symbol of Honor','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_assistance_i00',1,1,1),
(8896,'Ancient Tactical Manual: Symbol of Energy','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_assistance_i00',1,1,1),
(8897,'Ancient Tactical Manual: Symbol of the Sniper','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_assistance_i00',1,1,1),
(8898,'Ancient Tactical Manual: Symbol of the Assassin','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_assistance_i00',1,1,1),
(8899,'Ancient Spellbook: Volcano','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_element_i00',1,1,1),
(8900,'Ancient Spellbook: Cyclone','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_element_i00',1,1,1),
(8901,'Ancient Spellbook: Raging Waves','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_element_i00',1,1,1),
(8902,'Ancient Spellbook: Day of Doom','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_element_i00',1,1,1),
(8903,'Ancient Spellbook: Gehenna','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_element_i00',1,1,1),
(8904,'Ancient Spellbook: Anti-Summoning Field','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_element_i00',1,1,1),
(8905,'Ancient Spellbook: Purification Field','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_element_i00',1,1,1),
(8906,'Ancient Spellbook: Miracle','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_element_i00',1,1,1),
(8907,'Ancient Spellbook: Flames of Invincibility','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_element_i00',1,1,1),
(8908,'Ancient Spellbook: Mass Recharge','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,0,0,'true',0,1,'icon.etc_spell_books_element_i00',1,1,1),
(8909,'Blueprint: Summon Swoop Cannon','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,9600,0,'true',0,1,'icon.etc_plan_i00',1,1,1),
(8924,'Boat Ticket: Primeval Isle to Rune.','OTHER','false','none',20,'stackable','paper','none',0,37500,0,'true',0,1,'icon.etc_ticket_red_i00',1,1,1),
(8925,'Boat Ticket: Rune to Primeval Isle.','OTHER','false','none',20,'stackable','paper','none',0,37500,0,'true',0,1,'icon.etc_ticket_blue_i00',1,1,1),
(8939,'Dominic''s Mark','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'icon.etc_leash_i00',1,1,1),
(8940,'Mark of the Future: Human','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'icon.etc_jewel_green_i00',1,1,1),
(8941,'Mark of the Future: Dwarf','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'icon.etc_jewel_gold_i00',1,1,1),
(8942,'Mark of the Future: Elf','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'icon.etc_jewel_silver_i00',1,1,1),
(8943,'Mark of the Future: Dark Elf','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'icon.etc_jewel_white_i00',1,1,1),
(8944,'Mark of the Future: Orc','OTHER','false','quest',0,'stackable','steel','none',0,0,0,'false',0,1,'icon.etc_jewel_red_i00',1,1,1),
(8945,'Spellbook: Celestial Shield','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,8100,0,'true',0,1,'icon.etc_spell_books_element_i00',1,1,1),
(8946,'Spellbook: Invocation','SPELLBOOKS','false','spellbook',120,'stackable','paper','none',0,6250,0,'true',0,1,'icon.etc_spell_books_element_i00',1,1,1),
(8952,'Greater Herb of Life','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',0,1,'',1,1,1),
(8953,'Greater Herb of Mana','OTHER','false','herb',0,'normal','paper','none',0,0,0,'false',0,1,'',1,1,1),
(8954,'Blue Primeval Crystal','OTHER','false','none',10,'stackable','steel','none',0,0,0,'true',2306,1,'icon.etc_sp_crystal_i00',1,1,1),
(8955,'Green Primeval Crystal','OTHER','false','none',10,'stackable','steel','none',0,0,0,'true',2306,2,'icon.etc_sp_crystal_i02',1,1,1),
(8956,'Red Primeval Crystal','OTHER','false','none',10,'stackable','steel','none',0,0,0,'true',2306,3,'icon.etc_sp_crystal_i01',1,1,1),
(8957,'Attack Orders','OTHER','false','none',1,'normal','paper','none',0,0,0,'false',0,1,'icon.etc_lottery_card_i00',1,1,1),
(8958,'Defense Orders','OTHER','false','none',1,'normal','paper','none',0,0,0,'false',0,1,'icon.etc_lottery_card_i00',1,1,1),
(8959,'Supply Orders','OTHER','false','none',1,'normal','paper','none',0,0,0,'false',0,1,'icon.etc_lottery_card_i00',1,1,1),
(8960,'No Grade Shadow Armor Set Box','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(8961,'D-Grade Shadow Armor Set Box','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(8962,'C-Grade Shadow Armor Set Box','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(8963,'B-Grade Shadow Armor Set Box','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(8964,'A-Grade Shadow Armor Set Box','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(8965,'S-Grade Shadow Armor Set Box','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(8966,'No Grade Item Set Box (Warrior Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(8967,'D Grade Item Set Box (Warrior Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(8968,'C Grade Item Set Box (Warrior Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(8969,'B Grade Item Set Box (Warrior Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(8970,'A Grade Item Set Box (Warrior Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(8971,'A,S Grade Item Set Box (Warrior Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9104,'Composite Bow and Wooden Arrow','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9105,'Gastraphetes and Bone Arrow','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9106,'Akat Long Bow and Steel Arrow','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9107,'Dark Elven Long Bow and Silver Arrow','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9108,'Carnage Bow and Mithril Arrow','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9109,'Soul Bow and Mithril Arrow','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9110,'No Grade Shadow Armor Set Box (Heavy Armor Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9111,'D-Grade Shadow Armor Set Box (Heavy Armor Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9112,'C-Grade Shadow Armor Set Box (Heavy Armor Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9113,'B-Grade Shadow Armor Set Box (Heavy Armor Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9114,'Low A-Grade Shadow Armor Set Box (Heavy Armor Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9115,'High A-Grade Shadow Armor Set Box (Heavy Armor Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9116,'No Grade Shadow Armor Set Box (Light Armor Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9117,'D-Grade Shadow Armor Set Box (Light Armor Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9118,'C-Grade Shadow Armor Set Box (Light Armor Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9119,'B-Grade Shadow Armor Set Box (Light Armor Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9120,'Low A-Grade Shadow Armor Set Box (Light Armor Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9121,'High A-Grade Shadow Armor Set Box (Light Armor Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9122,'No Grade Shadow Armor Set Box (Robe Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9123,'D-Grade Shadow Armor Set Box (Robe Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9124,'C-Grade Shadow Armor Set Box (Robe Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9125,'B-Grade Shadow Armor Set Box (Robe Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9126,'Low A-Grade Shadow Armor Set Box (Robe Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9127,'High A-Grade Shadow Armor Set Box (Robe Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9130,'No Grade Item Set Box (Magic Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9131,'D Grade Item Set Box (Magic Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9132,'C Grade Item Set Box (Magic Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9133,'B Grade Item Set Box (Magic Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9134,'A Grade Item Set Box (Magic Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9135,'A,S Grade Item Set Box (Magic Use)','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',0,1,'icon.etc_box_of_adventure_1_i00',1,1,1),
(9139,'Santa''s Hat','OTHER','false','none',10,'normal','paper','none',0,0,0,'false',0,1,'icon.accessory_santas_cap_i00',1,1,1),
(9142,'Apiga','OTHER','false','none',0,'stackable','gold','none',0,1,0,'false',0,1,'icon.etc_pig_adena_i00',1,1,1),
(9143,'Golden Apiga','OTHER','false','none',0,'stackable','gold','none',0,1,0,'false',0,1,'icon.etc_pig_adena_i01',0,1,0),
(9144,'Pirate''s Booty','OTHER','false','none',100,'stackable','steel','none',0,0,0,'true',2309,1,'icon.etc_adena_i00',1,1,1),
(9146,'Scroll of Guidance (Event)','OTHER','false','scroll',120,'stackable','paper','none',0,0,0,'true',2310,1,'icon.etc_scroll_white_i00',1,1,1),
(9147,'Scroll of Death Whisper (Event)','OTHER','false','scroll',120,'stackable','paper','none',0,0,0,'true',2311,1,'icon.etc_scroll_white_i00',1,1,1),
(9148,'Scroll of Focus (Event)','OTHER','false','scroll',120,'stackable','paper','none',0,0,0,'true',2312,1,'icon.etc_scroll_white_i00',1,1,1),
(9149,'Scroll of Acumen (Event)','OTHER','false','scroll',120,'stackable','paper','none',0,0,0,'true',2313,1,'icon.etc_scroll_white_i00',1,1,1),
(9150,'Scroll of Haste (Event)','OTHER','false','scroll',120,'stackable','paper','none',0,0,0,'true',2314,1,'icon.etc_scroll_white_i00',1,1,1),
(9151,'Scroll of Agility (Event)','OTHER','false','scroll',120,'stackable','paper','none',0,0,0,'true',2315,1,'icon.etc_scroll_white_i00',1,1,1),
(9152,'Scroll of Empower (Event)','OTHER','false','scroll',120,'stackable','paper','none',0,0,0,'true',2316,1,'icon.etc_scroll_white_i00',1,1,1),
(9153,'Scroll of Might (Event)','OTHER','false','scroll',120,'stackable','paper','none',0,0,0,'true',2317,1,'icon.etc_scroll_white_i00',1,1,1),
(9154,'Scroll of Wind Walk (Event)','OTHER','false','scroll',120,'stackable','paper','none',0,0,0,'true',2318,1,'icon.etc_scroll_white_i00',1,1,1),
(9155,'Scroll of Shield (Event)','OTHER','false','scroll',120,'stackable','paper','none',0,0,0,'true',2319,1,'icon.etc_scroll_white_i00',1,1,1),
(9156,'Blessed Scroll of Escape (Event)','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,0,0,'true',2320,1,'icon.etc_scroll_of_return_i01',1,1,1),
(9157,'Blessed Scroll of Resurrection (Event)','CONSUMABLE','false','scroll',120,'stackable','paper','none',0,0,0,'true',2321,1,'icon.etc_scroll_of_resurrection_i01',1,1,1),
(9162,'Red Philosopher''s Stone Transmutation Circle','RECIPIES','false','recipe',10,'stackable','liquid','none',0,0,0,'true',0,1,'icon.sign_i00',0,1,0),
(9163,'Blue Philosopher''s Stone Transmutation Circle','RECIPIES','false','recipe',10,'stackable','liquid','none',0,0,0,'true',0,1,'icon.sign_i00',0,1,0),
(9164,'Orange Philosopher''s Stone Transmutation Circle','RECIPIES','false','recipe',10,'stackable','liquid','none',0,0,0,'true',0,1,'icon.sign_i00',0,1,0),
(9165,'Black Philosopher''s Stone Transmutation Circle','RECIPIES','false','recipe',10,'stackable','liquid','none',0,0,0,'true',0,1,'icon.sign_i00',0,1,0),
(9166,'White Philosopher''s Stone Transmutation Circle','RECIPIES','false','recipe',10,'stackable','liquid','none',0,0,0,'true',0,1,'icon.sign_i00',0,1,0),
(9167,'Green Philosopher''s Stone Transmutation Circle','RECIPIES','false','recipe',10,'stackable','liquid','none',0,0,0,'true',0,1,'icon.sign_i00',0,1,0),
(9168,'Philosopher''s Stone Ore','MATHERIALS','false','material',2,'stackable','liquid','none',0,0,0,'true',0,1,'icon.stone_piece_i00',0,1,0),
(9169,'Philosopher''s Stone Conversion Formula','MATHERIALS','false','material',2,'stackable','liquid','none',0,0,0,'true',0,1,'icon.trans_form_i00',0,1,0),
(9170,'Magic Reagents','MATHERIALS','false','material',2,'stackable','liquid','none',0,0,0,'true',0,1,'icon.madicine_bottle_i00',0,1,0),
(9171,'Red Philosopher''s Stone','OTHER','false','none',20,'stackable','paper','none',0,0,0,'true',0,1,'icon.wise_man_stone_i00',0,1,0),
(9172,'Blue Philosopher''s Stone','OTHER','false','none',20,'stackable','paper','none',0,0,0,'true',0,1,'icon.wise_man_stone_i01',0,1,0),
(9173,'Orange Philosopher''s Stone','OTHER','false','none',20,'stackable','paper','none',0,0,0,'true',0,1,'icon.wise_man_stone_i03',0,1,0),
(9174,'Black Philosopher''s Stone','OTHER','false','none',20,'stackable','paper','none',0,0,0,'true',0,1,'icon.wise_man_stone_i04',0,1,0),
(9175,'White Philosopher''s Stone','OTHER','false','none',20,'stackable','paper','none',0,0,0,'true',0,1,'icon.wise_man_stone_i05',0,1,0),
(9176,'Green Philosopher''s Stone','OTHER','false','none',20,'stackable','paper','none',0,0,0,'true',0,1,'icon.wise_man_stone_i02',0,1,0),
(9205,'Alchemist''s Chest Key','OTHER','false','none',10,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_old_key_i02',0,1,0),
(9206,'Greater Healing Potion (Event)','CONSUMABLE','false','potion',5,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_reagent_white_i00',0,1,0),
(9207,'Quick Healing Potion (Event)','CONSUMABLE','false','potion',5,'stackable','liquid','none',0,0,0,'true',0,1,'icon.etc_potion_gold_i00',0,1,0);
/* ********
(9678,'Magic Gem','OTHER','false','none',80,'stackable','liquid','none',0,600,0,'false',0,1,'icon.etc_magical_stone_i00',1,1,1),
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(9707,'Enuma Elish Key','OTHER','false','none',10,'stackable','liquid','none',0,1000,0,'true',0,1,'icon.etc_old_key_i03',1,1,1),
(9708,'Prahnah Key','OTHER','false','none',10,'stackable','liquid','none',0,1000,0,'true',0,1,'icon.etc_old_key_i03',1,1,1),
(9710,'Leopold Key','OTHER','false','none',10,'stackable','liquid','none',0,1000,0,'true',0,1,'icon.etc_old_key_i03',1,1,1),
(9722,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9723,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9724,'Resonance Amulet - 1','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9725,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9726,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9727,'Resonance Amulet - 2','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9728,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9729,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9730,'Resonance Amulet - 3','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9731,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9732,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9733,'Resonance Amulet - 4','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9734,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9735,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9736,'Resonance Amulet - 5','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9737,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9738,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9739,'Resonance Amulet - 6','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_resonance_amulet_i00',1,1,1),
(9740,'Halisha''s Mark','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_eyeball_i00',1,1,1),
(9741,'Halisha''s Mark','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_eyeball_i00',1,1,1),
Somnenie proverit`(9742,'Halisha''s Mark','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_eyeball_i00',1,1,1),
Pod somnenie(10112,'Dark Seed','OTHER','false','none',0,'stackable','steel','none',200,0,0,'false',0,1,'icon.etc_coda_i08',0,1,0),
******** */
INSERT INTO `etcitem` (`item_id`,`name`,`class`,`crystallizable`,`item_type`,`weight`,`consume_type`,`material`,`crystal_type`,`durability`,`price`,`crystal_count`,`sellable`,`skill_id`,`skill_level`,`icon`,`dropable`,`destroyable`,`tradeable`) VALUES
(10163,'Wolf Collar','OTHER','false','pet_collar',10,'normal','leather','none',0,0,0,'false',0,1,'icon.etc_prefect_belt_i00',1,1,1),
(10164,'Animal Slayer''s List','OTHER','false','quest',0,'stackable','steel','none',100,0,0,'false',0,1,'icon.etc_letter_white_i00',1,1,1),
(10171,'Seed: Dark Coda','OTHER','false','seed',1,'stackable','paper','none',0,2200,0,'true',0,1,'icon.etc_coda_seed_i00',1,1,1),
(10172,'Seed: Red Coda','OTHER','false','seed',1,'stackable','paper','none',0,2200,0,'true',0,1,'icon.etc_coda_seed_i00',1,1,1),
(10173,'Seed: Chilly Coda','OTHER','false','seed',1,'stackable','paper','none',0,2200,0,'true',0,1,'icon.etc_coda_seed_i00',1,1,1),
(10174,'Seed: Blue Coda','OTHER','false','seed',1,'stackable','paper','none',0,2200,0,'true',0,1,'icon.etc_coda_seed_i00',1,1,1),
(10197,'Alternative Dark Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,2200,0,'true',0,1,'icon.etc_coda_seed_i00',1,1,1),
(10198,'Alternative Red Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,2200,0,'true',0,1,'icon.etc_coda_seed_i00',1,1,1),
(10199,'Seed: Alternative Chilly Coda','OTHER','false','seed',1,'stackable','paper','none',0,2200,0,'true',0,1,'icon.etc_coda_seed_i00',1,1,1),
(10200,'Alternative Blue Coda Seed','OTHER','false','seed',1,'stackable','paper','none',0,2200,0,'true',0,1,'icon.etc_coda_seed_i00',1,1,1),
(10201,'Seed: Alternative Golden Coda','OTHER','false','seed',1,'stackable','paper','none',0,2200,0,'true',0,1,'icon.etc_coda_seed_i00',1,1,1),
(10202,'Seed: Golden Coda','OTHER','false','seed',1,'stackable','paper','none',0,2200,0,'true',0,1,'icon.etc_coda_seed_i00',1,1,1);
