DROP TABLE IF EXISTS `npc`;
CREATE TABLE `npc` (
  `ordinal` smallint(4) unsigned NOT NULL default '0',
  `id` int(11) unsigned NOT NULL default '0',
  `name` varchar(45) default NULL,
  `title` varchar(25) NOT NULL default '',
  `class` varchar(50) default NULL,
  `collision_radius` decimal(5,2) default NULL,
  `collision_height` decimal(5,2) default NULL,
  `level` int(11) default NULL,
  `sex` varchar(6) default NULL,
  `type` varchar(20) default NULL,
  `ai_type` varchar(50) default NULL,
  `attackrange` int(11) default NULL,
  `hp` int(11) default NULL,
  `base_hp_regen` double(11,3) NOT NULL default '0.000',
  `mp` int(11) default NULL,
  `base_mp_regen` double(11,3) NOT NULL default '0.000',
  `str` int(11) default NULL,
  `con` int(11) default NULL,
  `dex` int(11) default NULL,
  `int` int(11) default NULL,
  `wit` int(11) default NULL,
  `men` int(11) default NULL,
  `exp` int(11) default NULL,
  `sp` int(11) default NULL,
  `patk` int(11) default NULL,
  `pdef` int(11) default NULL,
  `matk` int(11) default NULL,
  `mdef` int(11) default NULL,
  `atkspd` int(11) default NULL,
  `aggro` int(11) default NULL,
  `matkspd` int(11) default NULL,
  `rhand` int(11) default NULL,
  `lhand` int(11) default NULL,
  `armor` int(11) default NULL,
  `walkspd` int(11) default NULL,
  `runspd` int(11) default NULL,
  `faction_id` varchar(40) default NULL,
  `faction_range` int(11) default NULL,
  `last_editor` varchar(50) default 'Local',
  `last_changed` varchar(20) default NULL,
  `displayId` int(11) NOT NULL default '0',
  `shield_defense_rate` int(11) default NULL,
  `shield_defense` int(11) default NULL,
  `corpse_time` int(11) default NULL,
  `base_rand_dam` int(11) default NULL,
  `base_critical` int(11) default NULL,
  `physical_hit_modify` int(11) default NULL,
  `base_reuse_delay` int(11) default NULL,
  `physical_avoid_modify` int(11) default NULL,
  `hit_time_factor` double(11,2) default '0.00',
  `isDropHerbs` enum('false','true') NOT NULL default 'true',
  `map_flag` tinyint(1) NOT NULL default '0',
  `boss_flag` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `map_flag` (`map_flag`,`boss_flag`)
) ENGINE=MyISAM;


INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(1,20001,'Gremlin','','gremlin',10.00,15.00,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,20,50,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2,20002,'Rabbit','','rabbit',5.00,4.50,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,50,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'true',0,0),
(3,20003,'Goblin','','goblin',10.00,16.50,5,'male','L2Monster','Fighter',40,126,2.000,77,0.900,40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,4,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.32,'true',1,0),
(4,20004,'Imp','','imp',10.00,24.00,6,'male','L2Monster','Fighter',40,147,2.000,85,0.900,40,43,30,21,20,10,213,6,15,50,5,41,278,0,253,0,0,0,60,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(5,20005,'Imp Elder','','imp',10.00,24.00,7,'male','L2Monster','Fighter',40,171,2.000,94,0.900,40,43,30,21,20,10,249,8,18,48,6,43,278,0,253,0,0,0,60,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(6,20006,'Orc Archer','','orc_archer',14.00,25.00,8,'male','L2Monster','Ranger',500,197,2.000,102,0.900,40,43,30,21,20,10,293,10,41,55,6,45,249,0,227,14,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(7,20007,'Green Fungus','','walking_fungus',15.00,22.50,9,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,321,11,22,53,7,47,278,0,253,0,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(8,20008,'Felim Lizardman','','virud_lizardman',10.00,23.00,14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,498,19,30,80,12,59,278,0,253,1,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(9,20009,'Vuku Orc','','orc',10.00,21.00,14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,498,19,33,73,12,59,278,0,253,156,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'true',1,0),
(10,20010,'Felim Lizardman Scout','','virud_lizardman',10.00,23.00,15,'male','L2Monster','Ranger',40,390,2.500,165,1.200,40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,16,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(11,20011,'Vuku Orc Archer','','orc_archer',14.00,25.00,15,'male','L2Monster','Ranger',500,390,2.500,165,1.200,40,43,30,21,20,10,550,22,82,76,14,62,249,0,227,14,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(12,20012,'Gora Werewolf','','werewolf',10.00,26.00,16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,582,23,44,72,15,64,278,500,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.43,'true',1,0),
(13,20013,'Dryad','','dryad',9.00,20.00,13,'female','L2Monster','Fighter',40,339,2.500,147,1.200,40,43,30,21,20,10,462,18,27,77,11,56,278,0,253,0,0,0,40,110,'elemental1_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(14,20014,'Felim Lizardman Warrior','','virud_lizardman_warrior',12.00,30.00,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,605,25,48,75,17,67,278,0,253,16,0,0,52,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.59,'true',1,0),
(15,20015,'Marsh Zombie','','zombie',13.00,21.00,13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,654,26,33,63,11,56,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(16,20016,'Stone Golem','','stone_golem',20.00,31.00,13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,654,26,30,70,11,56,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(17,20017,'Vuku Orc Fighter','','orc_fighter',12.00,22.00,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(18,20018,'Carnivorous Fungus','','walking_fungus',15.00,22.50,14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,424,16,37,66,12,59,278,500,253,0,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',0,0),
(19,20019,'Dryad Elder','','dryad',9.00,20.00,14,'female','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,498,19,30,80,12,59,278,0,253,0,0,0,40,110,'elemental1_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(20,20020,'Marsh Zombie Lord','','zombie',13.00,21.00,14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,705,27,30,80,12,59,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(21,20021,'Red Bear','','grizzly',21.00,40.00,14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,498,19,37,66,12,59,278,0,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(22,20022,'Misery Skeleton','','skeleton',11.00,25.00,14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,424,16,32,66,12,59,317,500,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,35,7,10,8,0,0,-6,0.30,'true',1,0),
(23,20023,'Shadow Beast','','onyx_beast',14.00,14.50,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.24,'true',1,0),
(24,20024,'Langk Lizardman Warrior','','virud_lizardman_warrior',12.00,30.00,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,16,0,0,52,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.59,'true',1,0),
(25,20025,'Lesser Dark Horror','','dark_horror',20.00,35.00,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,545,22,36,76,14,62,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(26,20026,'Ruin Zombie','','zombie',13.00,21.00,15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,755,31,40,69,14,62,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(27,20027,'Langk Lizardman Scout','','virud_lizardman',10.00,23.00,16,'male','L2Monster','Ranger',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,16,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(28,20028,'Pincher','','giant_spider',26.00,26.50,16,'male','L2Monster','Mystic',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(29,20029,'Ruin Zombie Leader','','zombie',13.00,21.00,16,'male','L2Monster','Mystic',40,417,2.500,174,1.200,40,43,30,21,20,10,807,33,36,87,15,64,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(30,20030,'Langk Lizardman','','virud_lizardman',10.00,23.00,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,534,22,36,76,14,62,278,0,253,1,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(31,20031,'Omen Beast','','onyx_beast',14.00,14.50,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,504,21,48,75,17,67,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.24,'true',1,0),
(32,20032,'Pinrul','','giant_spider',26.00,26.50,17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,605,25,48,75,17,67,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(33,20033,'Shade Horror','','dark_horror',20.00,35.00,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,504,21,48,75,17,67,278,0,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(34,20034,'Prowler','','giant_spider',26.00,26.50,17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(35,20035,'Tracker Skeleton','','skeleton',11.00,25.00,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,605,25,42,75,17,67,317,0,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,39,7,10,8,0,0,-6,0.30,'true',1,0),
(36,20036,'Lirein','','sylph',11.00,35.00,18,'female','L2Monster','Mystic',40,476,2.500,193,1.200,40,43,30,21,20,10,652,28,53,79,19,70,278,500,253,0,0,0,60,60,'elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(37,20037,'Mana Seeker','','mana_vampire',11.00,20.00,18,'male','L2Monster','Mystic',40,476,5.000,193,1.200,40,43,30,21,20,10,496,21,44,95,19,70,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.39,'false',0,0),
(38,20038,'Venomous Spider','','poison_spider',27.00,25.50,18,'male','L2Monster','Mystic',40,476,2.500,193,1.200,40,43,30,21,20,10,704,31,53,79,19,70,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.65,'true',1,0),
(39,20039,'Scavenger Wererat','','wererat',14.00,25.00,18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,640,28,46,79,19,70,317,0,289,12,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.61,'true',1,0),
(40,20040,'Sukar Wererat','','wererat',14.00,25.00,18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,533,23,46,79,19,70,317,0,289,216,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.61,'true',1,0),
(41,20041,'Tainted Zombie','','zombie',13.00,21.00,18,'male','L2Monster','Mystic',40,476,2.500,193,1.200,40,43,30,21,20,10,754,33,44,95,19,70,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(42,20042,'Tracker Skeleton Leader','','skeleton',11.00,25.00,18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,652,28,46,79,19,70,317,500,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,40,7,10,8,0,0,-6,0.30,'true',1,0),
(43,20043,'Arachnid Tracker','','poison_spider',27.00,25.50,19,'male','L2Monster','Mystic',40,508,2.500,203,1.200,40,43,30,21,20,10,760,34,48,99,21,73,278,500,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.65,'true',1,0),
(44,20044,'Lirein Elder','','sylph',11.00,35.00,19,'female','L2Monster','Mystic',40,508,2.500,203,1.200,40,43,30,21,20,10,691,31,58,82,21,73,278,500,253,0,0,0,60,60,'elemental1_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(45,20045,'Skeleton Scout','','skeleton_archer',11.00,27.00,19,'male','L2Monster','Ranger',500,508,2.500,203,1.200,40,43,30,21,20,10,698,31,107,99,21,73,249,0,227,275,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(46,20046,'Stink Zombie','','zombie',13.00,21.00,19,'male','L2Monster','Mystic',40,508,2.500,203,1.200,40,43,30,21,20,10,799,36,48,99,21,73,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(47,20047,'Sukar Wererat Leader','','wererat',14.00,25.00,19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,576,26,42,99,21,73,317,500,289,216,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.61,'true',1,0),
(48,20048,'Lesser Succubus','','succubus',10.00,36.00,20,'female','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,605,27,57,94,23,76,278,500,253,0,0,0,60,100,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(49,20049,'Lycanthrope','','werewolf',10.00,26.00,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,726,32,63,86,23,76,278,500,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.43,'true',1,0),
(50,20050,'Arachnid Predator','','poison_spider',27.00,25.50,20,'male','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,799,35,63,86,23,76,278,500,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.65,'true',1,0),
(51,20051,'Skeleton Bowman','','skeleton_archer',11.00,27.00,20,'male','L2Monster','Ranger',500,541,2.500,213,1.200,40,43,30,21,20,10,734,32,117,104,23,76,249,0,227,275,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(52,20052,'Lesser Succubus Turen','','succubus',10.00,36.00,21,'female','L2Monster','Mystic',40,575,3.500,227,1.500,40,43,30,21,20,10,649,30,69,89,25,80,278,500,253,0,0,0,60,100,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(53,20053,'Ol Mahum Patrol','','ol_mahum_archer',14.00,25.00,21,'male','L2Monster','Ranger',500,575,3.500,227,1.500,40,43,30,21,20,10,787,36,140,98,25,80,249,0,227,14,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.93,'true',1,0),
(54,20054,'Ruin Spartoi','','spartoi',11.00,27.00,21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,764,35,57,108,25,80,278,0,253,73,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(55,20055,'Wandering Eye','','monster_eye',21.00,43.00,21,'male','L2Monster','Mystic',40,575,3.500,227,1.500,40,43,30,21,20,10,764,35,57,108,25,80,278,0,253,0,0,0,90,159,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(56,20056,'Dre Vanul Disposer','','dre_vanul',14.00,36.00,22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,767,36,75,93,28,83,278,500,253,0,0,0,80,80,'demonic_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.35,'true',1,0),
(57,20057,'Lesser Succubus Tilfo','','succubus',10.00,36.00,22,'female','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,698,33,75,93,28,83,278,500,253,0,0,0,60,100,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(58,20058,'Ol Mahum Guard','','ol_mahum',13.50,25.00,22,'male','L2Monster','OlMahumGuard',40,611,3.500,242,1.500,40,43,30,21,20,10,821,39,75,93,28,83,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(59,20059,'Hungry Eye','','monster_eye',21.00,43.00,22,'male','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,821,39,75,93,28,83,278,0,253,0,0,0,90,159,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(60,20060,'Raging Spartoi','','spartoi',11.00,27.00,22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,837,40,54,113,28,83,317,500,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,46,7,10,8,0,0,-6,0.30,'true',1,0),
(61,20061,'Ol Mahum Straggler','','ol_mahum',13.50,25.00,23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,895,43,75,107,31,87,278,500,253,2,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(62,20062,'Tumran Bugbear','','bugbear',17.00,35.00,23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,878,42,68,117,31,87,278,0,253,156,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(63,20063,'Ol Mahum Shooter','','ol_mahum_archer',14.00,25.00,24,'male','L2Monster','Ranger',500,687,3.500,272,1.500,40,43,30,21,20,10,963,47,181,111,34,90,249,0,227,14,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.93,'true',1,0),
(64,20064,'Tumran Bugbear Warrior','','bugbear',17.00,35.00,24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,954,47,89,101,34,90,278,500,253,88,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(65,20065,'Ol Mahum Patrolman','','ol_mahum',13.50,25.00,25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,826,41,80,127,37,94,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(66,20066,'Ol Mahum Captain','','ol_mahum_champion',14.00,27.00,25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,1052,53,97,105,37,94,278,500,253,69,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.63,'true',1,0),
(67,20067,'Monster Eye Watcher','','monster_eye',21.00,43.00,25,'male','L2Monster','Mystic',40,728,3.500,287,1.500,40,43,30,21,20,10,992,50,80,127,37,94,278,0,253,0,0,0,90,159,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(68,20068,'Monster Eye Destroyer','','monster_eye',21.00,43.00,26,'male','L2Monster','Mystic',40,770,3.500,303,1.500,40,43,30,21,20,10,1078,54,87,132,41,98,278,500,253,0,0,0,90,159,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(69,20069,'Selu Lizardman Scout','','virud_lizardman',10.00,23.00,26,'male','L2Monster','Ranger',40,770,3.500,303,1.500,40,43,30,21,20,10,880,44,87,132,41,98,278,0,253,16,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',0,0),
(70,20070,'Lesser Basilisk','','lesser_basilisk',34.00,25.00,27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,1124,58,114,114,45,102,278,500,253,0,0,0,35,131,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(71,20071,'Selu Lizardman Warrior','','virud_lizardman_warrior',12.00,30.00,27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,946,48,114,114,45,102,278,500,253,16,0,0,52,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.59,'true',0,0),
(72,20072,'Basilisk','','lesser_basilisk',34.00,25.00,28,'male','L2Monster','Fighter',40,859,3.500,334,1.500,40,43,30,21,20,10,1189,62,102,143,49,106,278,500,253,0,0,0,35,131,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(73,20073,'Ol Mahum Legionnaire','','ol_mahum',13.50,25.00,28,'male','L2Monster','Fighter',40,859,3.500,334,1.500,40,43,30,21,20,10,981,52,113,130,49,106,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(74,20074,'Androscorpio','','onyx_beast',14.00,14.50,29,'male','L2Monster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1243,67,122,135,53,110,278,0,253,0,0,0,30,120,'scropio_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.24,'true',1,0),
(75,20075,'Ant Larva','','ant_larva',12.00,8.00,29,'male','L2Monster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1139,61,111,149,53,110,278,0,253,0,0,0,40,60,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.35,'true',1,0),
(76,20076,'Ol Mahum Commander','','ol_mahum_champion',14.00,27.00,29,'male','L2Monster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1319,71,134,123,53,110,278,500,253,69,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.63,'true',1,0),
(77,20077,'Androscorpio Hunter','','onyx_beast',14.00,14.50,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1308,72,145,128,58,114,278,0,253,0,0,0,30,120,'scropio_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.24,'true',1,0),
(78,20078,'Whispering Wind','','sylph_100_bi',20.00,70.00,30,'female','L2Monster','Mystic',40,954,3.500,365,1.500,40,43,30,21,20,10,1308,72,120,155,58,114,278,0,253,0,0,0,60,60,'elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(79,20079,'Ant','','ant',26.00,15.00,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1308,72,145,128,58,114,278,0,253,0,0,0,40,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(80,20080,'Ant Captain','','ant',26.00,15.00,31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,1425,79,157,133,64,118,278,500,253,0,0,0,40,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(81,20081,'Ant Overseer','','ant',26.00,15.00,32,'male','L2Monster','Fighter',40,1056,9.000,397,1.800,40,43,30,21,20,10,1200,67,169,138,69,123,278,0,253,0,0,0,40,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.26,'false',1,0),
(82,20082,'Ant Recruit','','ant_soldier',35.00,17.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(83,20083,'Granite Golem','','stone_golem',20.00,31.00,33,'male','L2Monster','Mystic',40,1109,4.500,413,1.800,40,43,30,21,20,10,2239,129,151,173,75,128,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(84,20084,'Ant Patrol','','ant_soldier',35.00,17.00,34,'male','L2Monster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1667,97,196,148,82,132,278,0,253,0,0,0,80,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(85,20085,'Puncher','','stone_golem',20.00,31.00,34,'male','L2Monster','Mystic',40,1164,4.500,430,1.800,40,43,30,21,20,10,2424,142,196,148,82,132,278,500,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(86,20086,'Ant Guard','','ant_soldier',35.00,17.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1484,88,192,169,89,137,278,0,253,0,0,0,80,174,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(87,20087,'Ant Soldier','','ant_soldier',35.00,17.00,35,'male','L2Monster','Fighter',40,1220,9.000,446,1.800,40,43,30,21,20,10,1780,105,192,169,89,137,278,500,253,0,0,0,80,174,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',1,0),
(88,20088,'Ant Warrior Captain','','ant_soldier',35.00,17.00,36,'male','L2Monster','Fighter',40,1279,9.000,463,1.800,40,43,30,21,20,10,1984,120,227,159,96,142,278,500,253,0,0,0,80,174,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',1,0),
(89,20089,'Noble Ant','','noble_ant',20.00,48.00,37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,1659,102,222,182,104,147,278,0,253,0,0,0,80,174,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(90,20090,'Noble Ant Leader','','noble_ant',20.00,48.00,38,'male','L2Monster','Fighter',40,1400,9.000,497,1.800,40,43,30,21,20,10,1829,114,261,171,112,153,278,500,253,0,0,0,80,174,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',1,0),
(91,20091,'Young Fox','','fox',9.50,10.00,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(92,20092,'Monster Eye','','monster_eye',21.00,43.00,10,'male','L2Monster','Mystic',40,257,2.000,120,0.900,40,43,30,21,20,10,294,10,22,61,8,49,278,0,253,0,0,0,90,134,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.30,'true',1,0),
(93,20093,'Orc Fighter','','orc_fighter',12.00,22.00,10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,363,12,22,61,8,49,278,500,253,1,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(94,20094,'Orc Marksman','','orc_archer',14.00,25.00,10,'male','L2Monster','Ranger',500,257,2.000,120,0.900,40,43,30,21,20,10,305,10,56,55,8,49,249,0,227,14,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',0,0),
(95,20095,'Vampire Bat','','vampire_bat',10.00,33.50,10,'male','L2Monster','Mystic',40,257,2.000,120,0.900,40,43,30,21,20,10,296,10,22,61,8,49,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.50,'true',1,0),
(96,20096,'Orc Lieutenant','','orc_fighter',12.00,22.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,391,15,23,70,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(97,20097,'Drill Bat','','vampire_bat',10.00,33.50,11,'male','L2Monster','Mystic',40,292,2.500,129,1.200,40,43,30,21,20,10,326,12,27,58,9,52,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.50,'true',1,0),
(98,20098,'Orc Fighter Leader','','orc_fighter',12.00,22.00,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,447,17,30,60,10,54,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(99,20099,'Skeleton','','skeleton',11.00,25.00,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,33,7,10,8,0,0,-6,0.30,'true',1,0),
(100,20100,'Skeleton Archer','','skeleton_archer',11.00,27.00,13,'male','L2Monster','Ranger',500,339,2.500,147,1.200,40,43,30,21,20,10,405,16,74,63,11,56,249,500,227,14,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(101,20101,'Crasher','','stone_golem',20.00,31.00,14,'male','L2Monster','Mystic',40,364,2.500,156,1.200,40,43,30,21,20,10,705,27,30,80,12,59,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(102,20102,'Skeleton Marksman','','skeleton_archer',11.00,27.00,14,'male','L2Monster','Ranger',500,364,2.500,156,1.200,40,43,30,21,20,10,428,17,82,66,12,59,249,0,227,14,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(103,20103,'Giant Spider','','giant_spider',26.00,26.50,15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,545,22,40,69,14,62,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(104,20104,'Skeleton Lord','','skeleton',11.00,25.00,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,445,18,29,84,14,62,317,0,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,36,7,10,8,0,0,-6,0.30,'true',1,0),
(105,20105,'Dark Horror','','dark_horror',20.00,35.00,16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,576,23,44,72,15,64,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(106,20106,'Talon Spider','','giant_spider',26.00,26.50,16,'male','L2Monster','Mystic',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(107,20107,'Wererat','','wererat',14.00,25.00,16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,475,19,40,79,15,64,278,0,253,0,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.61,'true',1,0),
(108,20108,'Blade Spider','','giant_spider',26.00,26.50,17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(109,20109,'Salamander','','salamander',16.00,6.80,17,'male','L2Monster','Fighter',40,446,5.000,184,1.200,40,43,30,21,20,10,494,21,44,83,17,67,278,0,253,0,0,0,64,96,'elemental3_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.20,'false',1,0),
(110,20110,'Undine','','undine',12.00,27.00,17,'female','L2Monster','Mystic',40,446,5.000,184,1.200,40,43,30,21,20,10,479,20,44,83,17,67,278,500,253,0,0,0,60,60,'elemental4_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.35,'false',1,0),
(111,20111,'Wererat Leader','','wererat',14.00,25.00,17,'male','L2Monster','Fighter',40,446,5.000,184,1.200,40,43,30,21,20,10,479,20,40,91,17,67,278,500,253,1,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(112,20112,'Salamander Elder','','salamander',16.00,6.80,18,'male','L2Monster','Fighter',40,476,5.000,193,1.200,40,43,30,21,20,10,496,21,53,79,19,70,278,0,253,0,0,0,64,96,'elemental3_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.20,'false',1,0),
(113,20113,'Undine Elder','','undine',12.00,27.00,18,'female','L2Monster','Mystic',40,476,5.000,193,1.200,40,43,30,21,20,10,505,22,44,95,19,70,278,500,253,0,0,0,60,60,'elemental4_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.35,'false',1,0),
(114,20114,'Salamander Noble','','salamander',16.00,6.80,19,'male','L2Monster','Fighter',40,508,5.000,203,1.200,40,43,30,21,20,10,525,23,58,82,21,73,278,0,253,0,0,0,64,96,'elemental3_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.20,'false',1,0),
(115,20115,'Undine Noble','','undine',12.00,27.00,19,'female','L2Monster','Mystic',40,508,5.000,203,1.200,40,43,30,21,20,10,536,24,58,82,21,73,278,500,253,0,0,0,60,60,'elemental4_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.35,'false',1,0),
(116,20116,'Fox','','fox',9.50,10.00,2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,58,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(117,20117,'Dre Vanul','','dre_vanul',14.00,36.00,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,666,29,63,86,23,76,278,500,253,0,0,0,80,80,'demonic_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.35,'true',1,0),
(118,20118,'Dre Vanul Scout','','dre_vanul',14.00,36.00,21,'male','L2Minion','Ranger',40,575,3.500,227,1.500,40,43,30,21,20,10,649,30,69,89,25,80,278,500,253,0,0,0,80,80,'demonic_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.35,'true',1,0),
(119,20119,'Elder Fox','','fox',9.50,10.00,3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(120,20120,'Wolf','','wolf',13.00,9.00,4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(121,20121,'Giant Toad','','poison_toad',20.00,10.00,5,'male','L2Monster','Fighter',40,126,2.000,77,0.900,40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,0,0,0,50,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'true',1,0),
(122,20130,'Orc','','orc',10.00,21.00,6,'male','L2Monster','Fighter',40,147,2.000,85,0.900,40,43,30,21,20,10,213,6,15,50,5,41,278,0,253,156,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'true',1,0),
(123,20131,'Orc Grunt','','orc',10.00,21.00,7,'male','L2Monster','Fighter',40,171,2.000,94,0.900,40,43,30,21,20,10,249,8,17,53,6,43,278,0,253,4,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'true',1,0),
(124,20132,'Werewolf','','werewolf',10.00,26.00,9,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,321,11,20,58,7,47,278,0,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.43,'true',1,0),
(125,20133,'Bugbear','','bugbear',17.00,35.00,21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,649,30,63,98,25,80,278,500,253,4,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',0,0),
(126,20134,'Cave Maiden','','cave_maiden',25.00,65.00,59,'female','L2Monster','Fighter',40,2971,6.500,1117,2.400,40,43,30,21,20,10,5112,437,902,326,453,291,278,500,253,68,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'false',1,0),
(127,20135,'Alligator','','crocodile',28.00,11.50,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2373,153,300,183,131,164,278,500,253,0,0,0,70,174,'croc_clan2',300,'Magister','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(128,20136,'Death Knight','','death_knight',12.00,30.00,50,'male','L2Monster','Fighter',40,2245,11.000,830,2.100,40,43,30,21,20,10,4651,350,616,230,264,226,278,500,253,75,0,0,27,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(129,20137,'Drake','','drake',30.00,100.00,57,'male','L2Monster','Mystic',40,2806,6.500,1052,2.400,40,43,30,21,20,10,4819,401,817,309,405,276,278,500,253,0,0,0,70,174,'dragon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(130,20138,'Gargoyle','','gargoyle',16.00,50.00,27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,946,48,104,125,45,102,278,500,253,0,0,0,140,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(131,20139,'Giant Bee','','giant_bee',8.00,24.50,16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,471,19,40,79,15,64,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',0,0),
(132,20140,'Giant Leech','','giant_leech',70.00,29.00,24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,795,39,81,111,34,90,278,500,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.65,'true',0,0),
(133,20141,'Giant Wild Hog','','giant_wild_hog',25.00,27.00,47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,2730,196,427,253,216,206,278,500,253,0,0,0,35,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'true',0,0),
(134,20142,'Griffon','','griffin',20.00,44.00,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,593,26,57,94,23,76,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(135,20143,'Grizzly','','grizzly',21.00,40.00,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,436,16,27,66,10,54,278,500,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(136,20144,'Hangman Tree','','hanged_man_ripper',35.00,80.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1817,108,192,169,89,137,278,500,253,0,0,0,55,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(137,20145,'Harpy','','harpy',10.00,42.00,32,'female','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1504,84,154,151,69,123,278,500,253,0,0,0,60,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.65,'true',1,0),
(138,20146,'Headless Knight','','headless_knight',21.00,31.00,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3708,279,463,306,264,226,278,500,253,124,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',1,0),
(139,20147,'Hobgoblin','','hobgoblin',12.00,24.00,21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,764,35,63,98,25,80,278,0,253,4,0,0,45,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.41,'true',1,0),
(140,20148,'Hungry Spirit','','hungry_spirit',13.00,40.00,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,1958,126,300,183,131,164,278,500,253,0,0,0,15,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',0,0),
(141,20149,'Iron Golem','','iron_golem',18.00,34.00,38,'male','L2Monster','Mystic',40,1400,4.500,497,1.800,40,43,30,21,20,10,2524,157,216,207,112,153,278,500,253,0,0,0,20,20,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',0,0),
(142,20150,'King Bugbear','','king_bugbear',15.00,40.00,32,'male','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1265,71,169,138,69,123,278,500,253,88,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',0,0),
(143,20151,'Kobold','','kobold',10.00,15.00,4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,118,3,12,46,4,37,278,0,253,4,0,0,47,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.54,'true',0,0),
(144,20152,'Lizardman','','virud_lizardman',10.00,23.00,19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,565,25,53,90,21,73,278,0,253,291,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',0,0),
(145,20153,'Magical Weaver','','magical_weaver',11.00,20.00,11,'male','L2Monster','Mystic',40,292,2.500,129,1.200,40,43,30,21,20,10,391,15,27,58,9,52,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(146,20154,'Mandragora Sprout','','manadragora',14.00,17.80,21,'female','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,764,35,63,98,25,80,278,0,253,0,0,0,80,80,'mandragora_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'true',1,0),
(147,20155,'Mandragora Sapling','','mandragora_a',15.00,26.00,23,'female','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,895,43,82,97,31,87,278,500,253,0,0,0,80,120,'mandragora_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.20,'true',1,0),
(148,20156,'Mandragora Blossom','','mandragora_b',12.00,25.50,25,'female','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,1012,51,97,105,37,94,278,500,253,0,0,0,80,120,'mandragora_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.13,'true',1,0),
(149,20157,'Marsh Stakato','','marsh_stakato',10.00,20.00,29,'male','L2Monster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1509,81,117,123,53,110,317,500,289,223,0,0,21,120,'stakato_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.74,'true',1,0),
(150,20158,'Medusa','','medusa',10.00,25.00,34,'female','L2Monster','Mystic',40,1164,4.500,430,1.800,40,43,30,21,20,10,1714,100,178,163,82,132,278,500,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',1,0),
(151,20159,'Minotaur','','minotaur',21.00,45.50,43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,2263,153,365,202,163,181,278,500,253,300,0,0,40,120,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.59,'true',0,0),
(152,20160,'Neer Crawler','','neer_crawler',14.00,22.00,28,'male','L2Monster','Fighter',40,859,3.500,334,1.500,40,43,30,21,20,10,1201,63,124,118,49,106,278,500,253,0,0,0,50,90,'neer_crawler_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(153,20161,'Oel Mahum','','oel_mahum',20.00,37.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4167,328,602,304,319,247,278,500,253,0,0,0,70,174,'oel_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(154,20162,'Ogre','','ogre',21.00,44.00,41,'male','L2Monster','Fighter',40,1593,5.500,560,2.100,40,43,30,21,20,10,2057,135,446,189,141,169,200,500,182,98,0,0,22,80,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.69,'true',0,0),
(155,20163,'Ol Mahum','','ol_mahum',13.50,25.00,23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,731,35,82,97,31,87,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(156,20164,'Ol Mahum Archer','','ol_mahum_archer',14.00,25.00,25,'male','L2Monster','Ranger',500,728,3.500,287,1.500,40,43,30,21,20,10,868,44,216,105,37,94,249,500,227,14,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.93,'true',0,0),
(157,20165,'Ol Mahum Champion','','ol_mahum_champion',14.00,27.00,29,'male','L2Monster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1257,67,134,123,53,110,278,500,253,69,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.63,'true',0,0),
(158,20166,'Succubus','','succubus',10.00,36.00,32,'female','L2Monster','Mystic',40,1056,4.500,397,1.800,40,43,30,21,20,10,1265,71,154,151,69,123,278,500,253,0,0,0,60,100,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',0,0),
(159,20167,'Serpent Slave','','serpent_slave',17.00,46.00,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,1977,128,273,201,131,164,278,500,253,73,0,0,70,110,'serpent_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(160,20168,'Silenos','','silenos',14.00,32.50,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1308,72,132,140,58,114,278,0,253,88,0,0,70,110,'silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.50,'true',1,0),
(161,20169,'Skeleton Royal Guard','','skeleton_royal_guard',11.00,28.50,26,'male','L2Monster','Fighter',40,770,3.500,303,1.500,40,43,30,21,20,10,898,45,92,109,41,98,317,500,289,946,945,0,80,120,'skeleton_clan',300,'Local','',0,20,52,7,10,8,0,0,-6,0.52,'true',0,0),
(162,20170,'Spartoi','','spartoi',11.00,27.00,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,454,19,35,69,14,62,317,500,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,36,7,10,8,0,0,-6,0.30,'true',0,0),
(163,20171,'Specter','','dark_horror',20.00,35.00,26,'male','L2Monster','Fighter',40,770,3.500,303,1.500,40,43,30,21,20,10,1078,54,96,120,41,98,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(164,20172,'Sylph','','sylph',11.00,35.00,10,'female','L2Monster','Mystic',40,257,2.000,120,0.900,40,43,30,21,20,10,296,10,25,55,8,49,278,0,253,0,0,0,60,60,'elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',0,0),
(165,20173,'Troll','','troll',21.00,35.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1332,76,182,143,75,128,278,500,253,0,0,0,55,110,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.61,'true',0,0),
(166,20174,'Two-Headed Giant','','twin_headed_giant',17.00,39.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1499,89,174,186,89,137,278,500,253,4,0,0,45,100,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.46,'true',0,0),
(167,20175,'Walking Fungus','','walking_fungus',15.00,22.50,8,'male','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,237,8,18,55,6,45,278,0,253,0,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',0,0),
(168,20176,'Wyrm','','wyrm',29.00,72.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1817,108,211,154,89,137,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.19,'true',1,0),
(169,20177,'Zombie','','zombie',13.00,21.00,6,'male','L2Monster','Mystic',40,147,2.000,85,0.900,40,43,30,21,20,10,178,5,15,50,5,41,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',0,0),
(170,20189,'Puma','','onyx_beast',14.00,14.50,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,441,18,40,69,14,62,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.24,'true',0,0),
(171,20190,'Skeleton Marauder','','skeleton_archer',11.00,27.00,29,'male','L2Monster','Ranger',500,906,3.500,349,1.500,40,43,30,21,20,10,1306,70,299,123,53,110,249,500,227,14,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(172,20191,'Skeleton Raider','','skeleton',11.00,25.00,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1335,73,127,128,58,114,317,500,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,59,7,10,8,0,0,-6,0.30,'true',1,0),
(173,20192,'Tyrant','','grave',15.00,29.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1781,105,211,154,89,137,278,0,253,0,0,0,70,174,'tyrant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(174,20193,'Tyrant Kingpin','','grave',15.00,29.00,36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,1922,116,227,159,96,142,278,500,253,0,0,0,70,174,'tyrant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(175,20194,'Queen Undine','','undine',12.00,27.00,50,'female','L2Monster','Mystic',40,2245,5.500,830,2.100,40,43,30,21,20,10,3090,233,560,253,264,226,278,500,253,0,0,0,60,60,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'true',0,0),
(176,20197,'Sorrow Maiden','','sylph',11.00,35.00,27,'female','L2Monster','Mystic',40,813,3.500,318,1.500,40,43,30,21,20,10,1102,56,104,125,45,102,278,0,253,0,0,0,60,60,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(177,20198,'Neer Ghoul Berserker','','neer_crawler',14.00,22.00,29,'male','L2Monster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1268,68,134,123,53,110,278,500,253,0,0,0,50,90,'neer_crawler_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(178,20199,'Amber Basilisk','','lesser_basilisk',34.00,25.00,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1557,85,120,155,58,114,278,0,253,0,0,0,35,131,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(179,20200,'Strain','','hungry_spirit',13.00,40.00,31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,1383,77,157,133,64,118,278,0,253,0,0,0,15,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(180,20201,'Ghoul','','zombie',13.00,21.00,32,'male','L2Monster','Mystic',40,1056,4.500,397,1.800,40,43,30,21,20,10,2085,117,169,138,69,123,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(181,20202,'Dead Seeker','','vampire_bat',10.00,33.50,34,'male','L2Monster','Mystic',40,1164,4.500,430,1.800,40,43,30,21,20,10,1664,97,178,163,82,132,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(182,20203,'Dion Grizzly','','grizzly',21.00,40.00,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,705,31,52,104,23,76,278,0,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(183,20204,'Bloody Bee','','giant_bee',8.00,24.50,23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,956,46,82,97,31,87,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(184,20205,'Dire Wolf','','dire_wolf',13.00,11.00,24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,954,47,89,101,34,90,278,500,253,0,0,0,24,110,'wolf_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(185,20206,'Kadif Werewolf','','werewolf',10.00,26.00,25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,982,49,97,105,37,94,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(186,20207,'Ol Mahum Guerilla','','ol_mahum',13.50,25.00,26,'male','L2Monster','Fighter',40,770,7.000,303,1.500,40,43,30,21,20,10,982,49,87,132,41,98,278,0,253,2,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,52,7,30,4,4,0,-6,0.46,'false',1,0),
(187,20208,'Ol Mahum Raider','','ol_mahum',13.50,25.00,27,'male','L2Monster','Fighter',40,813,7.000,318,1.500,40,43,30,21,20,10,1035,53,83,138,45,102,317,0,289,10,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.46,'false',1,0),
(188,20209,'Ol Mahum Marksman','','ol_mahum_archer',14.00,25.00,28,'male','L2Monster','Ranger',500,859,7.000,334,1.500,40,43,30,21,20,10,1128,59,276,118,49,106,249,0,227,275,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.93,'false',1,0),
(189,20210,'Ol Mahum Sergeant','','ol_mahum',13.50,25.00,29,'male','L2Monster','Fighter',40,906,7.000,349,1.500,40,43,30,21,20,10,1156,62,111,149,53,110,278,0,253,68,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,57,7,30,4,4,0,-6,0.46,'false',1,0),
(190,20211,'Ol Mahum Captain','','ol_mahum_champion',14.00,27.00,30,'male','L2Monster','Fighter',40,954,7.000,365,1.500,40,43,30,21,20,10,1241,68,145,128,58,114,278,500,253,123,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,59,7,30,4,4,0,-6,0.63,'false',1,0),
(191,20212,'Bloody Axe Turmak','Ol Mahum Lord','ol_mahum_champion',14.00,27.00,34,'male','L2Monster','Fighter',40,1164,9.000,430,1.800,40,43,30,21,20,10,1469,86,196,148,82,132,278,500,253,69,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,66,7,30,4,4,0,-6,0.63,'false',0,0),
(192,20213,'Porta','','stone_golem',20.00,31.00,40,'male','L2Monster','Mystic',40,1527,9.000,531,1.800,40,43,30,21,20,10,2364,152,248,222,131,164,278,0,253,0,0,0,23,23,'porta_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.41,'false',1,0),
(193,20214,'Excuro','','mana_vampire',11.00,20.00,41,'male','L2Monster','Mystic',40,1593,11.000,560,2.100,40,43,30,21,20,10,2028,132,265,229,141,169,278,0,253,0,0,0,90,174,'porta_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.39,'false',1,0),
(194,20215,'Mordeo','','onyx_beast',14.00,14.50,42,'male','L2Monster','Fighter',40,1660,11.000,589,2.100,40,43,30,21,20,10,2625,175,342,196,152,175,278,500,253,0,0,0,30,174,'beast_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.24,'false',1,0),
(195,20216,'Ricenseo','','monster_eye',21.00,43.00,43,'male','L2Monster','Mystic',40,1728,11.000,618,2.100,40,43,30,21,20,10,2104,142,332,223,163,181,278,0,253,0,0,0,90,174,'porta_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.30,'false',1,0),
(196,20217,'Krator','','stone_golem',20.00,31.00,44,'male','L2Monster','Mystic',40,1799,11.000,648,2.100,40,43,30,21,20,10,2688,184,322,253,176,187,278,500,253,0,0,0,23,23,'porta_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.41,'false',1,0),
(197,20218,'Premo','','troll',21.00,35.00,45,'male','L2Monster','Fighter',40,1870,11.000,677,2.100,40,43,30,21,20,10,2812,195,415,216,188,193,278,0,253,0,0,0,55,174,'porta_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.61,'false',1,0),
(198,20219,'Validus','','grave',15.00,29.00,46,'male','L2Monster','Fighter',40,1943,11.000,707,2.100,40,43,30,21,20,10,2408,170,365,270,202,199,278,0,253,0,0,0,70,174,'torfe_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.30,'false',1,0),
(199,20220,'Dicor','','mandragora_b',12.00,25.50,47,'female','L2Monster','Fighter',40,2016,11.000,738,2.100,40,43,30,21,20,10,2867,205,469,230,216,206,278,500,253,0,0,0,80,174,'torfe_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.13,'false',1,0),
(200,20221,'Perum','','iron_golem',18.00,34.00,48,'male','L2Monster','Mystic',40,2091,11.000,768,2.100,40,43,30,21,20,10,3438,251,412,288,231,212,278,500,253,0,0,0,20,20,'torfe_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.41,'false',1,0),
(201,20222,'Torfe','','grave',15.00,29.00,49,'male','L2Monster','Fighter',40,2168,11.000,799,2.100,40,43,30,21,20,10,3025,223,529,245,247,219,278,0,253,0,0,0,70,174,'torfe_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.30,'false',1,0),
(202,20223,'Mandragora Sprout','','manadragora',14.00,17.80,20,'female','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,783,35,63,86,23,76,278,0,253,0,0,0,80,80,'mandragora_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'true',1,0),
(203,20224,'Ol Mahum Ranger','','ol_mahum_archer',14.00,25.00,22,'male','L2Monster','Ranger',500,611,3.500,242,1.500,40,43,30,21,20,10,1059,50,139,113,28,83,249,0,227,13,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.93,'true',1,0),
(204,20225,'Giant Mist Leech','','giant_leech',70.00,29.00,25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,992,50,88,116,37,94,278,0,253,0,0,0,50,110,'giant_leech_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.65,'true',1,0),
(205,20226,'Gray Ant','','ant',26.00,15.00,26,'male','L2Monster','Fighter',40,770,3.500,303,1.500,40,43,30,21,20,10,1056,53,87,132,41,98,278,0,253,0,0,0,40,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(206,20227,'Horror Mist Ripper','','dark_horror',20.00,35.00,27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,1124,58,114,114,45,102,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(207,20228,'Giant Crimson Ant','','ant_soldier',35.00,17.00,28,'male','L2Monster','Fighter',40,859,3.500,334,1.500,40,43,30,21,20,10,1296,68,124,118,49,106,278,0,253,0,0,0,80,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(208,20229,'Stinger Wasp','','giant_bee',8.00,24.50,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1454,79,120,155,58,114,278,500,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(209,20230,'Marsh Stakato Worker','','marsh_stakato_worker',9.00,21.00,31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,1663,92,142,146,64,118,278,0,253,153,0,0,20,140,'stakato_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.59,'true',1,0),
(210,20231,'Toad Lord','','poison_toad',20.00,10.00,32,'male','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1622,91,140,167,69,123,278,0,253,0,0,0,50,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'true',1,0),
(211,20232,'Marsh Stakato Soldier','','marsh_stakato_soldier',10.00,25.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1583,91,132,173,75,128,317,0,289,217,0,0,30,155,'stakato_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.74,'true',1,0),
(212,20233,'Marsh Spider','','poison_spider',27.00,25.50,34,'male','L2Monster','Mystic',40,1164,4.500,430,1.800,40,43,30,21,20,10,1867,109,178,163,82,132,278,500,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.65,'true',1,0),
(213,20234,'Marsh Stakato Drone','','marsh_stakato_drone',9.00,24.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1889,112,185,154,89,137,317,500,289,219,0,0,80,174,'stakato_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.39,'true',1,0),
(214,20235,'Shackle','','hungry_spirit',13.00,40.00,45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,2974,207,343,262,188,193,278,500,253,0,0,0,15,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(215,20236,'Cave Servant','','skeleton',11.00,25.00,46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,3077,218,365,270,202,199,278,0,253,79,945,0,60,174,'cave_servant_clan',300,'Local','',0,20,91,7,30,4,4,0,-6,0.30,'true',1,0),
(216,20237,'Cave Servant Archer','','skeleton_archer',11.00,27.00,47,'male','L2Monster','Ranger',500,2016,5.500,738,2.100,40,43,30,21,20,10,4143,297,1043,230,216,206,249,0,227,14,0,0,40,174,'cave_servant_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(217,20238,'Cave Servant Warrior','','skeleton',11.00,25.00,48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,3987,291,498,238,231,212,278,0,253,77,2495,0,60,174,'cave_servant_clan',300,'Local','',0,20,95,7,30,4,4,0,-6,0.30,'true',1,0),
(218,20239,'Cave Servant Captain','','spartoi',11.00,27.00,49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,4238,313,437,297,247,219,278,500,253,73,2495,0,60,174,'cave_servant_clan',300,'Local','',0,20,97,7,30,4,4,0,-6,0.30,'true',1,0),
(219,20240,'Royal Cave Servant','','skeleton_royal_guard',11.00,28.50,51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,4546,347,429,315,281,232,317,0,289,946,945,0,80,174,'cave_servant_clan',400,'Local','',0,20,102,7,10,8,0,0,-6,0.52,'true',1,0),
(220,20241,'Hunter Gargoyle','','hunter_gargoyle',25.00,65.00,52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,4633,358,627,268,300,239,278,0,253,0,0,0,100,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(221,20242,'Dustwind Gargoyle','','hunter_gargoyle',25.00,65.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4813,378,547,334,319,247,278,0,253,0,0,0,100,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(222,20243,'Thunder Wyrm','','wyrm',29.00,72.00,54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,4283,341,699,284,339,254,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.19,'true',1,0),
(223,20244,'Malruk Succubus','','succubus',10.00,36.00,55,'female','L2Monster','Mystic',40,2643,6.500,987,2.400,40,43,30,21,20,10,4399,355,737,292,360,261,278,0,253,0,0,0,60,174,'succubus_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(224,20245,'Malruk Succubus Turen','','succubus',10.00,36.00,56,'female','L2Monster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,4560,375,777,301,382,269,278,0,253,0,0,0,60,174,'succubus_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(225,20246,'Cave Keeper','','serpent_slave',17.00,46.00,58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'cave_servant_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.46,'true',1,0),
(226,20248,'Turak Bugbear','','bugbear',17.00,35.00,31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,1397,78,129,161,64,118,278,0,253,88,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(227,20249,'Turak Bugbear Warrior','','bugbear',17.00,35.00,33,'male','L2Monster','Fighter',40,1109,9.000,413,1.800,40,43,30,21,20,10,1502,86,151,173,75,128,278,500,253,73,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',1,0),
(228,20250,'Glass Jaguar','','onyx_beast',14.00,14.50,27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,1102,56,114,114,45,102,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.24,'true',1,0),
(229,20251,'Delu Lizardman','','virud_lizardman',10.00,23.00,28,'male','L2Monster','Fighter',40,859,3.500,334,1.500,40,43,30,21,20,10,1166,61,102,143,49,106,278,0,253,1,19,0,43,130,'',0,'Local','',0,20,55,7,30,4,4,0,-6,0.48,'true',1,0),
(230,20252,'Delu Lizardman Scout','','virud_lizardman',10.00,23.00,29,'male','L2Monster','Ranger',40,906,3.500,349,1.500,40,43,30,21,20,10,1231,66,134,123,53,110,278,0,253,123,0,0,43,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(231,20253,'Delu Lizardman Warrior','','virud_lizardman_warrior',12.00,30.00,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1321,72,120,155,58,114,278,500,253,16,0,0,52,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.59,'true',1,0),
(232,20254,'Skeleton Axeman','','skeleton',11.00,25.00,28,'male','L2Monster','Fighter',40,859,3.500,334,1.500,40,43,30,21,20,10,1201,63,113,130,49,106,278,500,253,86,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.30,'true',1,0),
(233,20255,'Batur Orc','','batur_orc',9.00,21.50,31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,1164,65,129,161,64,118,278,0,253,123,0,0,80,130,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(234,20256,'Batur Orc Archer','','batur_orc_archer',11.00,21.50,32,'male','L2Monster','Ranger',500,1056,4.500,397,1.800,40,43,30,21,20,10,1600,90,311,167,69,123,249,0,227,13,0,0,45,130,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.96,'true',0,0),
(235,20257,'Batur Orc Warrior','','batur_orc_warrior',10.00,20.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1602,92,182,143,75,128,278,500,253,123,19,0,80,120,'orc_clan',300,'Local','',0,20,64,7,30,4,4,0,-6,0.30,'true',0,0),
(236,20258,'Batur Orc Shaman','','batur_orc_shaman',11.00,16.00,34,'male','L2Monster','Priest',40,1164,4.500,430,1.800,40,43,30,21,20,10,1401,82,196,148,82,132,278,0,253,7,0,0,50,120,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.30,'true',0,0),
(237,20259,'Batur Orc Overlord','','batur_orc_overlord',12.00,24.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1802,107,211,154,89,137,278,500,253,79,0,0,80,140,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'true',0,0),
(238,20260,'Orc Champion','','orc_champion',10.00,23.00,14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,435,17,30,80,12,59,278,500,253,2,0,0,45,130,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.76,'true',0,0),
(239,20261,'Orc Shaman','','orc_shaman',9.00,22.00,17,'male','L2Monster','Priest',40,446,2.500,184,1.200,40,43,30,21,20,10,504,21,40,91,17,67,278,0,253,7,0,0,45,120,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.26,'true',0,0),
(240,20265,'Monster Eye Searcher','','monster_eye',21.00,43.00,22,'male','L2Monster','Mystic',40,611,7.000,242,1.500,40,43,30,21,20,10,763,36,75,93,28,83,278,0,253,0,0,0,90,159,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.30,'true',1,0),
(241,20266,'Monster Eye Gazer','','monster_eye',21.00,43.00,25,'male','L2Monster','Mystic',40,728,3.500,287,1.500,40,43,30,21,20,10,992,50,80,127,37,94,278,0,253,0,0,0,90,159,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(242,20267,'Breka Orc','','batur_orc',9.00,21.50,31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,1397,78,113,161,64,118,317,0,289,215,0,0,80,130,'orc_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.46,'true',1,0),
(243,20268,'Breka Orc Archer','','batur_orc_archer',11.00,21.50,32,'male','L2Monster','Ranger',500,1056,4.500,397,1.800,40,43,30,21,20,10,1920,108,311,167,69,123,249,0,227,275,0,0,45,130,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.96,'true',1,0),
(244,20269,'Breka Orc Shaman','','batur_orc_shaman',11.00,16.00,34,'male','L2Monster','Priest',40,1164,4.500,430,1.800,40,43,30,21,20,10,1681,98,162,179,82,132,278,0,253,7,0,0,50,120,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.30,'true',1,0),
(245,20270,'Breka Orc Overlord','','batur_orc_overlord',12.00,24.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,2380,141,211,154,89,137,278,500,253,79,0,0,80,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'true',1,0),
(246,20271,'Breka Orc Warrior','','batur_orc_warrior',10.00,20.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1922,110,182,143,75,128,278,500,253,123,20,0,80,120,'orc_clan',300,'Local','',0,20,64,7,30,4,4,0,-6,0.30,'true',1,0),
(247,20272,'Cave Servant','','skeleton',11.00,25.00,46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,2564,182,365,270,202,199,278,0,253,79,945,0,60,140,'cave_servant_clan',300,'Local','',0,20,91,7,30,4,4,0,-6,0.30,'false',0,0),
(248,20273,'Cave Servant Archer','','skeleton_archer',11.00,27.00,47,'male','L2Monster','Ranger',500,2016,5.500,738,2.100,40,43,30,21,20,10,2757,198,1043,230,216,206,249,0,227,275,0,0,40,140,'cave_servant_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'false',0,0),
(249,20274,'Cave Servant Warrior','','skeleton',11.00,25.00,48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,2792,204,498,238,231,212,278,0,253,77,0,0,60,140,'cave_servant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(250,20275,'Cave Servant Captain','','spartoi',11.00,27.00,49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,2968,219,437,297,247,219,278,500,253,73,0,0,60,140,'cave_servant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(251,20276,'Royal Cave Servant','','skeleton_royal_guard',11.00,28.50,51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,3152,240,429,315,281,232,317,0,289,946,945,0,80,120,'cave_servant_clan',300,'Local','',0,20,102,7,10,8,0,0,-6,0.52,'false',0,0),
(252,20277,'Cave Keeper','','serpent_slave',17.00,46.00,58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,4077,344,751,318,428,284,317,0,289,223,0,0,70,110,'cave_servant_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.46,'false',0,0),
(253,20279,'Shackle','','hungry_spirit',13.00,40.00,45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,2478,172,343,262,188,193,278,500,253,0,0,0,15,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(254,20280,'Headless Knight','','headless_knight',21.00,31.00,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3090,233,463,306,264,226,278,500,253,124,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(255,20281,'Dustwind Gargoyle','','hunter_gargoyle',25.00,65.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,3370,265,547,334,319,247,278,0,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(256,20282,'Thunder Wyrm','','wyrm',29.00,72.00,54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,3569,285,699,284,339,254,278,500,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.19,'false',0,0),
(257,20283,'Malruk Succubus','','succubus',10.00,36.00,55,'female','L2Monster','Mystic',40,2643,6.500,987,2.400,40,43,30,21,20,10,3666,296,737,292,360,261,278,0,253,0,0,0,60,100,'succubus_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'false',0,0),
(258,20284,'Malruk Succubus Turen','','succubus',10.00,36.00,56,'female','L2Monster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,3800,312,777,301,382,269,278,0,253,0,0,0,60,100,'succubus_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'false',0,0),
(259,20285,'Drake','','drake',30.00,100.00,57,'male','L2Monster','Mystic',40,2806,6.500,1052,2.400,40,43,30,21,20,10,4016,334,817,309,405,276,278,500,253,0,0,0,70,70,'dragon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'false',0,0),
(260,20286,'Hunter Gargoyle','','hunter_gargoyle',25.00,65.00,52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,3244,251,627,268,300,239,278,0,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(261,20287,'Cave Maiden','','cave_maiden',25.00,65.00,59,'female','L2Monster','Fighter',40,2971,6.500,1117,2.400,40,43,30,21,20,10,4260,364,902,326,453,291,278,500,253,68,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(262,20291,'Enku Orc Champion','','orc_champion',10.00,23.00,21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,927,43,57,108,25,80,278,500,253,2,0,0,45,130,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.76,'true',1,0),
(263,20292,'Enku Orc Shaman','','orc_shaman',9.00,22.00,20,'male','L2Monster','Priest',40,541,2.500,213,1.200,40,43,30,21,20,10,813,36,52,104,23,76,278,0,253,7,0,0,45,120,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.26,'true',1,0),
(264,20293,'Virud Lizardman','','virud_lizardman',10.00,23.00,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,593,26,52,104,23,76,278,0,253,291,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',0,0),
(265,20294,'Virud Lizardman Matriarch','','virud_lizardman_matriarch',13.00,37.00,24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,951,47,89,101,34,90,278,500,253,2,19,0,56,130,'lizardman_clan',300,'Local','',0,20,49,7,30,4,4,0,-6,0.65,'true',0,0),
(266,20295,'Virud Lizardman Warrior','','virud_lizardman_warrior',12.00,30.00,22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,698,33,75,93,28,83,278,500,253,16,0,0,52,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.59,'true',0,0),
(267,20296,'Virud Lizardman Scout','','virud_lizardman_scout',10.00,22.00,21,'male','L2Monster','Ranger',500,575,3.500,227,1.500,40,43,30,21,20,10,656,30,127,108,25,80,249,0,227,2507,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.72,'true',0,0),
(268,20297,'Virud Lizardman Shaman','','virud_lizardman_shaman',10.00,29.00,23,'male','L2Monster','Priest',40,648,3.500,257,1.500,40,43,30,21,20,10,731,35,68,117,31,87,278,0,253,7,0,0,43,120,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'true',0,0),
(269,20298,'Virud Lizardman Shaman','','virud_lizardman_shaman',10.00,29.00,23,'male','L2Monster','Priest',40,648,3.500,257,1.500,40,43,30,21,20,10,731,35,68,117,31,87,278,0,253,7,0,0,43,120,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'true',0,0),
(270,20299,'Zenta Lizardman','','zenta_lizardman',11.00,32.00,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,1939,125,248,222,131,164,278,0,253,68,0,0,37,140,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'true',0,0),
(271,20300,'Zenta Lizardman Matriarch','','zenta_lizardman_matriarch',20.00,40.00,44,'male','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,2848,195,341,209,176,187,317,500,289,221,0,0,53,140,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.46,'true',0,0),
(272,20301,'Zenta Lizardman Scout','','zenta_lizardman_scout',11.00,30.00,41,'male','L2Monster','Ranger',500,1593,5.500,560,2.100,40,43,30,21,20,10,2098,137,589,229,141,169,249,0,227,14,0,0,37,150,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.93,'true',0,0),
(273,20302,'Zenta Lizardman Warrior','','zenta_lizardman_warrior',13.00,35.00,42,'male','L2Monster','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,2180,145,342,196,152,175,278,500,253,16,0,0,40,140,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',0,0),
(274,20303,'Zenta Lizardman Shaman','','zenta_lizardman_shaman',13.00,35.00,43,'male','L2Monster','Priest',40,1728,5.500,618,2.100,40,43,30,21,20,10,2240,152,302,245,163,181,278,0,253,7,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.63,'true',0,0),
(275,20304,'Marsh Stakato Queen','','marsh_stakato_queen',15.00,37.00,36,'female','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,1906,115,227,159,96,142,278,500,253,74,0,0,130,130,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',0,0),
(276,20305,'Grave','','grave',15.00,29.00,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,1958,126,300,183,131,164,278,500,253,0,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',0,0),
(277,20307,'Garum Werewolf','','werewolf',10.00,26.00,9,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,321,11,22,53,7,47,278,0,253,5,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.43,'true',1,0),
(278,20308,'Hook Spider','','giant_spider',26.00,26.50,16,'male','L2Monster','Mystic',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(279,20309,'Brown Fox','','fox',9.50,10.00,2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,58,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(280,20310,'Brown Bear','','grizzly_bi',21.00,50.00,16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,576,23,36,87,15,64,278,500,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(281,20311,'Rakeclaw Imp','','imp',10.00,24.00,6,'male','L2Monster','Fighter',40,147,2.000,85,0.900,40,43,30,21,20,10,213,6,16,46,5,41,278,0,253,0,0,0,60,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(282,20312,'Rakeclaw Imp Hunter','','imp',10.00,24.00,7,'male','L2Monster','Fighter',40,171,2.000,94,0.900,40,43,30,21,20,10,249,8,18,48,6,43,278,0,253,0,0,0,60,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(283,20313,'Rakeclaw Imp Chieftain','','imp_bi',10.00,30.00,10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,363,12,25,55,8,49,278,500,253,0,0,0,60,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(284,20314,'Great White Shark','','great_white_shark',20.00,7.00,42,'male','L2Monster','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,2180,145,342,196,152,175,278,500,253,0,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(285,20316,'Darkwing Bat','','vampire_bat',10.00,33.50,11,'male','L2Monster','Mystic',40,292,2.500,129,1.200,40,43,30,21,20,10,391,15,27,58,9,52,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(286,20317,'Black Wolf','','wolf',13.00,9.00,4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(287,20318,'Black Timber Wolf','','wolf_bi',13.00,10.80,6,'male','L2Monster','Fighter',40,147,2.000,85,0.900,40,43,30,21,20,10,211,6,15,50,5,41,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(288,20319,'Goblin Grave Robber','','goblin',10.00,16.50,5,'male','L2Monster','Fighter',40,126,2.000,77,0.900,40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,4,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.32,'true',1,0),
(289,20320,'Goblin Tomb Raider Leader','','goblin_bi',10.00,21.40,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,427,16,24,66,10,54,317,0,289,12,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.32,'true',1,0),
(290,20321,'Goblin Thief','','goblin_bi',10.00,21.40,10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,356,12,20,61,8,49,317,0,289,217,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.32,'true',1,0),
(291,20322,'Goblin Brigand','','goblin',10.00,16.50,8,'male','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,284,10,18,55,6,45,278,0,253,4,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.32,'true',1,0),
(292,20323,'Goblin Brigand Leader','','goblin_bi',10.00,21.40,14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,508,20,29,73,12,59,317,500,289,217,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.32,'true',1,0),
(293,20324,'Goblin Brigand Lieutenant','','goblin',10.00,16.50,10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,363,12,20,61,8,49,317,500,289,10,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.32,'true',1,0),
(294,20325,'Goblin Raider','','goblin',10.00,16.50,5,'male','L2Monster','Fighter',40,126,2.000,77,0.900,40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,4,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.32,'true',1,0),
(295,20326,'Goblin Scout','','goblin',10.00,16.50,8,'male','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,284,10,18,55,6,45,278,0,253,4,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.32,'true',1,0),
(296,20327,'Goblin Snooper','','goblin',10.00,16.50,5,'male','L2Monster','Fighter',40,126,2.000,77,0.900,40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,4,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.32,'true',1,0),
(297,20328,'Goblin Lookout','','goblin',10.00,16.50,8,'male','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,284,10,16,55,6,45,317,0,289,12,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.32,'true',1,0),
(298,20329,'Ghost Guardian','','human_ghost',8.00,22.00,21,'male','L2Monster','Mystic',40,575,3.500,227,1.500,40,43,30,21,20,10,643,30,63,98,25,80,278,500,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(299,20330,'Mineshaft Bat','','vampire_bat',10.00,33.50,11,'male','L2Monster','Mystic',40,292,2.500,129,1.200,40,43,30,21,20,10,326,12,27,58,9,52,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(300,20331,'Monster Eye Tracker','','monster_eye',21.00,43.00,10,'male','L2Monster','Mystic',40,257,2.000,120,0.900,40,43,30,21,20,10,296,10,20,67,8,49,278,0,253,0,0,0,90,134,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(301,20333,'Greystone Golem','','stone_golem',20.00,31.00,13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,654,26,27,77,11,56,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(302,20334,'Gremlin Scavenger','','gremlin',10.00,15.00,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,20,50,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(303,20335,'Grizzly Bear','','grizzly_bi',21.00,50.00,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,599,25,40,91,17,67,278,0,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(304,20336,'Green Dryad','','dryad_sm',6.00,15.00,8,'female','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,284,10,18,55,6,45,278,0,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(305,20337,'Longtail Fox','','fox',9.50,10.00,2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,58,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(306,20338,'Nightmare Weaver','','magical_weaver',11.00,20.00,21,'male','L2Monster','Mystic',40,575,3.500,227,1.500,40,43,30,21,20,10,707,33,69,89,25,80,278,500,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(307,20340,'Slave Skeleton','','skeleton',11.00,25.00,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(308,20341,'Undead Slave','','zombie',13.00,21.00,19,'male','L2Monster','Mystic',40,508,2.500,203,1.200,40,43,30,21,20,10,799,36,58,82,21,73,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(309,20342,'Werewolf Chieftain','','werewolf_bi',11.00,29.70,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,436,16,30,60,10,54,278,500,253,5,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.43,'true',1,0),
(310,20343,'Werewolf Hunter','','werewolf',10.00,26.00,10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,363,12,25,55,8,49,278,500,253,5,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.43,'true',1,0),
(311,20345,'Dark Terror','','dark_horror',20.00,35.00,16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,533,22,44,72,15,64,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(312,20346,'Darkstone Golem','','stone_golem',20.00,31.00,13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,545,21,27,77,11,56,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(313,20347,'Doom Wraith','','death_blader',15.00,45.00,55,'male','L2Monster','Fighter',40,2643,6.500,987,2.400,40,43,30,21,20,10,3739,302,737,292,360,261,278,500,253,1472,0,0,100,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',0,0),
(314,20348,'Cave Spider','','giant_spider',26.00,26.50,15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,445,18,40,69,14,62,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(315,20349,'Cave Bat','','vampire_bat',10.00,33.50,13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,385,15,33,63,11,56,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(316,20350,'Cave Fang Spider','','giant_spider',26.00,26.50,16,'male','L2Monster','Mystic',40,417,2.500,174,1.200,40,43,30,21,20,10,485,20,44,72,15,64,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(317,20351,'Dre Vanul Tracker','','dre_vanul',14.00,36.00,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,605,27,63,86,23,76,278,500,253,0,0,0,80,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.35,'true',1,0),
(318,20352,'Dre Vanul Slayer','','dre_vanul',14.00,36.00,22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,767,36,75,93,28,83,278,500,253,0,0,0,80,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.35,'true',0,0),
(319,20353,'Dre Vanul Beholder','','dre_vanul',14.00,36.00,21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,649,30,69,89,25,80,278,500,253,0,0,0,80,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.35,'true',1,0),
(320,20354,'Dwarf Ghost','','dwarf_ghost',9.00,16.50,20,'male','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,605,27,63,86,23,76,278,500,253,0,0,0,80,140,'ghost_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',0,0),
(321,20356,'Langk Lizardman Leader','','virud_lizardman_warrior_bi',12.00,34.50,25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,1012,51,80,127,37,94,278,500,253,16,0,0,52,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.59,'true',1,0),
(322,20357,'Langk Lizardman Lieutenant','','virud_lizardman_warrior',12.00,30.00,22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,821,39,62,113,28,83,278,0,253,16,0,0,52,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.59,'true',1,0),
(323,20358,'Ratman Hunter','','wererat',14.00,25.00,18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,640,28,38,95,19,70,317,0,289,11,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.61,'true',1,0),
(324,20359,'Ratman Warrior','','wererat',14.00,25.00,19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,678,30,58,82,21,73,278,0,253,2,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(325,20360,'Ratman Spy','','wererat_sm',14.00,18.70,16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,39,72,15,64,317,0,289,12,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.61,'true',1,0),
(326,20361,'Tunath Orc Marksman','','orc_archer',14.00,25.00,10,'male','L2Monster','Ranger',500,257,2.000,120,0.900,40,43,30,21,20,10,305,10,51,61,8,49,249,0,227,14,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(327,20362,'Tunath Orc Warrior','','orc_fighter',12.00,22.00,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,363,13,25,73,10,54,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(328,20363,'Maraku Werewolf','','werewolf',10.00,26.00,9,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,321,11,22,53,7,47,278,0,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(329,20364,'Maraku Werewolf Chieftain','','werewolf_bi',11.00,29.70,14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,508,20,32,66,12,59,317,500,289,217,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.43,'true',1,0),
(330,20365,'Mountain Fungus','','walking_fungus',15.00,22.50,8,'male','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,284,10,20,50,6,45,278,0,253,0,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(331,20367,'Merkenis Escort','','spartoi',11.00,27.00,20,'male','L2Minion','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,605,27,52,104,23,76,278,500,253,68,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(332,20368,'Grave Keeper','','stone_golem',20.00,31.00,13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,545,21,27,77,11,56,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(333,20369,'Moonstone Beast','','onyx_beast',14.00,14.50,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,599,25,48,75,17,67,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.24,'true',1,0),
(334,20370,'Barbed Bat','','vampire_bat',10.00,33.50,12,'male','L2Monster','Mystic',40,315,2.500,138,1.200,40,43,30,21,20,10,427,16,30,60,10,54,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(335,20371,'Mist Terror','','dark_horror',20.00,35.00,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,454,19,40,69,14,62,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(336,20372,'Baraq Orc Fighter','','orc_fighter',12.00,22.00,10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,302,10,25,55,8,49,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(337,20373,'Baraq Orc Warrior Leader','','orc_fighter',12.00,22.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,326,12,27,58,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(338,20374,'Baranka''s Guard','','spartoi',11.00,27.00,22,'male','L2Minion','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,910,43,62,113,28,83,278,500,253,68,0,0,60,140,'skeleton_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(339,20375,'Baranka''s Escort','','spartoi',11.00,27.00,21,'male','L2Minion','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,649,30,50,108,25,80,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local',NULL,0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(340,20376,'Varikan Brigand Leader','','goblin_bi',10.00,21.40,10,'male','L2Monster','Fighter',40,257,4.000,120,0.900,40,43,30,21,20,10,503,17,22,61,8,49,278,500,253,12,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.32,'false',0,0),
(341,20377,'Varika''s Bandit','','goblin',10.00,16.50,7,'male','L2Minion','Fighter',40,171,1.000,94,0.900,40,43,30,21,20,10,334,12,20,44,6,43,278,0,253,0,0,0,40,110,'goblin_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,0.32,'true',0,0),
(342,20378,'Stone Giant','','stone_golem',20.00,31.00,13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,545,21,27,77,11,56,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.41,'true',1,0),
(343,20379,'Stone Soldier','','stone_golem',20.00,31.00,14,'male','L2Monster','Mystic',40,364,2.500,156,1.200,40,43,30,21,20,10,705,27,30,80,12,59,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(344,20380,'Stone Guardian','','stone_golem',20.00,31.00,16,'male','L2Monster','Mystic',40,417,2.500,174,1.200,40,43,30,21,20,10,807,33,36,87,15,64,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(345,20381,'Vaiss Orc','','orc',10.00,21.00,10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,296,10,22,61,8,49,278,0,253,156,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'true',1,0),
(346,20382,'Vaiss Orc Warrior Leader','','orc_fighter',12.00,22.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,326,12,27,58,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(347,20383,'Arachnid Hunter','','binding',12.00,21.00,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1223,67,120,155,58,114,278,500,253,0,0,0,10,140,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'true',0,0),
(348,20385,'Balor Orc Archer','','orc_archer',14.00,25.00,8,'male','L2Monster','Ranger',500,197,2.000,102,0.900,40,43,30,21,20,10,293,10,41,55,6,45,249,0,227,14,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(349,20386,'Balor Orc Fighter','','orc_fighter',12.00,22.00,10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,363,12,25,55,8,49,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(350,20387,'Balor Orc Fighter Leader','','orc_fighter',12.00,22.00,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,436,16,30,60,10,54,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(351,20388,'Balor Orc Lieutenant','','orc_fighter',12.00,22.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,391,15,27,58,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(352,20389,'Boogle Ratman','','wererat',14.00,25.00,16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,475,19,39,72,15,64,317,0,289,12,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.61,'true',1,0),
(353,20390,'Boogle Ratman Leader','','wererat',14.00,25.00,18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,533,23,46,79,19,70,317,0,289,12,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.61,'true',1,0),
(354,20391,'Red Fox','','fox',9.50,10.00,2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,58,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(355,20392,'Redeye Bat','','vampire_bat_bi',10.00,42.00,15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(356,20393,'Red Scavenger Spider','','giant_spider',26.00,26.50,16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(357,20394,'Crimson Tarantula','','giant_spider',26.00,26.50,15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,449,18,40,69,14,62,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',0,0),
(358,20398,'Vrykolakas','','werewolf_bi',11.00,29.70,15,'male','L2Monster','Fighter',40,390,5.000,165,1.200,40,43,30,21,20,10,692,28,40,69,14,62,278,500,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.43,'false',0,0),
(359,20399,'Vrykolakas Wolfkin','','wolf_bi',13.00,10.80,9,'male','L2Minion','Fighter',40,226,1.000,111,0.900,40,43,30,21,20,10,354,12,25,48,7,47,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.39,'true',0,0),
(360,20400,'Blood Fungus','','walking_fungus',15.00,22.50,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,427,16,30,60,10,54,278,0,253,0,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(361,20401,'Veelan Bugbear','','bugbear',17.00,35.00,23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,878,42,68,117,31,87,278,0,253,156,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(362,20402,'Veelan Bugbear Warrior','','bugbear',17.00,35.00,24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,954,47,89,101,34,90,278,500,253,88,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(363,20403,'Hunter Tarantula','','giant_spider',26.00,26.50,16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(364,20404,'Silent Horror','','dark_horror',20.00,35.00,16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,485,20,44,72,15,64,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.37,'true',1,0),
(365,20405,'Young Brown Fox','','fox',9.50,10.00,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,10,36,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(366,20406,'Young Red Fox','','fox',9.50,10.00,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,10,36,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(367,20407,'Young Crimson Fox','','fox',9.50,10.00,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,10,36,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(368,20410,'Scavenger Spider','','giant_spider',26.00,26.50,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,545,22,40,69,14,62,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(369,20411,'Scavenger Bat','','vampire_bat',10.00,33.50,18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,640,28,53,79,19,70,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(370,20412,'Susceptor','','susceptor',20.00,35.00,49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,2910,215,437,297,247,219,278,500,253,0,0,0,27,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',0,0),
(371,20415,'Scarlet Salamander','','salamander',16.00,6.80,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,555,23,48,75,17,67,278,0,253,0,0,0,64,96,'elemental3_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.20,'true',1,0),
(372,20416,'Scarlet Salamander Elder','','salamander',16.00,6.80,18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,586,26,53,79,19,70,278,0,253,0,0,0,64,96,'elemental3_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.20,'true',1,0),
(373,20418,'Crystalline Beast','','onyx_beast',14.00,14.50,18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,633,28,53,79,19,70,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.24,'true',1,0),
(374,20419,'Akaste Succubus','','succubus',10.00,36.00,20,'female','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,605,27,63,86,23,76,278,500,253,0,0,0,60,100,'succubus_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',0,0),
(375,20420,'Akaste Succubus Turen','','succubus',10.00,36.00,21,'female','L2Monster','Mystic',40,575,3.500,227,1.500,40,43,30,21,20,10,649,30,69,89,25,80,278,500,253,0,0,0,60,100,'succubus_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(376,20421,'Akaste Succubus Tilfo','','succubus_bi',10.00,43.20,22,'female','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,698,33,75,93,28,83,278,500,253,0,0,0,60,100,'succubus_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(377,20422,'Akaste Bone Warlord','','skeleton',11.00,25.00,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,612,26,48,75,17,67,278,500,253,2,18,0,60,140,'skeleton_clan',300,'Local','',0,20,39,7,30,4,4,0,-6,0.30,'true',1,0),
(378,20423,'Akaste Bone Archer','','skeleton_archer',11.00,27.00,14,'male','L2Monster','Ranger',500,364,2.500,156,1.200,40,43,30,21,20,10,428,17,68,80,12,59,249,0,227,275,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(379,20424,'Akaste Bone Lord','','skeleton',11.00,25.00,19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,592,26,58,82,21,73,278,500,253,68,19,0,60,140,'skeleton_clan',300,'Local','',0,20,42,7,30,4,4,0,-6,0.30,'true',1,0),
(380,20425,'Akaste Bone Soldier','','skeleton',11.00,25.00,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(381,20426,'Evil Eye','','monster_eye',21.00,43.00,10,'male','L2Monster','Mystic',40,257,2.000,120,0.900,40,43,30,21,20,10,356,12,20,67,8,49,278,0,253,0,0,0,90,134,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(382,20427,'Evil Eye Watcher','','monster_eye',21.00,43.00,10,'male','L2Monster','Mystic',40,257,2.000,120,0.900,40,43,30,21,20,10,296,10,20,67,8,49,278,0,253,0,0,0,90,134,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(383,20428,'Evil Eye Patroller','','monster_eye',21.00,43.00,14,'male','L2Monster','Mystic',40,364,2.500,156,1.200,40,43,30,21,20,10,498,19,30,80,12,59,278,0,253,0,0,0,90,134,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(384,20429,'Evil Eye Lookout','','monster_eye',21.00,43.00,14,'male','L2Monster','Mystic',40,364,2.500,156,1.200,40,43,30,21,20,10,415,16,30,80,12,59,278,0,253,0,0,0,90,134,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(385,20431,'Elf Ghost','','elf_ghost',7.00,21.00,20,'male','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,605,27,52,104,23,76,278,500,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',0,0),
(386,20432,'Elpy','','elpy',5.00,4.50,1,'male','L2Monster','Elpy',40,62,2.000,44,0.900,40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,50,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'true',1,0),
(387,20433,'Festering Bat','','vampire_bat',10.00,33.50,13,'male','L2Monster','NightAgressionMystic',40,339,2.500,147,1.200,40,43,30,21,20,10,462,18,33,63,11,56,278,500,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(388,20435,'Opal Beast','','onyx_beast',14.00,14.50,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,449,18,40,69,14,62,278,500,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.24,'true',1,0),
(389,20436,'Ol Mahum Supplier','','ol_mahum_bi',13.50,29.20,23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,878,42,68,117,31,87,278,0,253,2,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,47,7,30,4,4,0,-6,0.46,'true',1,0),
(390,20437,'Ol Mahum Recruit','','ol_mahum',13.50,25.00,21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,764,35,57,108,25,80,278,0,253,68,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,44,7,30,4,4,0,-6,0.46,'true',1,0),
(391,20438,'Ol Mahum General','','ol_mahum_champion',14.00,27.00,26,'male','L2Monster','OlMahumGeneral',40,770,3.500,303,1.500,40,43,30,21,20,10,1078,54,105,109,41,98,278,500,253,67,102,0,50,110,'ol_mahum_clan',300,'Local','',0,20,52,7,30,4,4,0,-6,0.63,'true',1,0),
(392,20439,'Ol Mahum Officer','','ol_mahum',13.50,25.00,24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,935,46,74,122,34,90,278,0,253,66,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(393,20440,'Elder Brown Fox','','fox',9.50,10.00,3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(394,20441,'Elder Longtail Fox','','fox',9.50,10.00,3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(395,20442,'Elder Wolf','','wolf',13.00,9.00,5,'male','L2Monster','Fighter',40,126,2.000,77,0.900,40,43,30,21,20,10,176,5,13,48,4,39,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(396,20443,'Elder Red Fox','','fox',9.50,10.00,3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(397,20444,'Elder Prairie Fox','','fox',9.50,10.00,3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(398,20445,'Uthanka Pirate','','orc',10.00,21.00,7,'male','L2Monster','Fighter',40,171,1.000,94,0.900,40,43,30,21,20,10,307,10,20,44,6,43,278,0,253,3,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',0,0),
(399,20446,'Utuku Orc','','orc',10.00,21.00,6,'male','L2Monster','Fighter',40,147,2.000,85,0.900,40,43,30,21,20,10,213,6,15,50,5,41,278,0,253,156,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'true',1,0),
(400,20447,'Utuku Orc Archer','','orc_archer',14.00,25.00,8,'male','L2Monster','Ranger',500,197,2.000,102,0.900,40,43,30,21,20,10,293,10,41,55,6,45,249,0,227,14,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(401,20448,'Utuku Orc Grunt','','orc',10.00,21.00,7,'male','L2Monster','Fighter',40,171,2.000,94,0.900,40,43,30,21,20,10,249,8,17,53,6,43,278,0,253,3,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(402,20449,'Will-O-Wisp','','will_o_wisp',13.00,22.00,15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,533,22,40,69,14,62,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.10,'true',1,0),
(403,20450,'Relic Werewolf','','werewolf',10.00,26.00,9,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,267,9,22,53,7,47,278,0,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.43,'true',1,0),
(404,20451,'Relic Spartoi','','spartoi',11.00,27.00,21,'male','L2Monster','Fighter',40,575,7.000,227,1.500,40,43,30,21,20,10,592,27,57,108,25,80,278,0,253,68,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(405,20453,'Human Ghost','','human_ghost',8.00,22.00,20,'male','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,605,27,52,104,23,76,278,500,253,0,0,0,80,140,'ghost_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',0,0),
(406,20454,'Oblivion Watcher','','monster_eye',21.00,43.00,17,'male','L2Monster','Mystic',40,446,1.250,184,1.200,40,43,30,21,20,10,454,20,53,68,17,67,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.30,'true',0,0),
(407,20455,'Doom Soldier','','skeleton',11.00,25.00,14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,424,16,32,66,12,59,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(408,20456,'Ashen Wolf','','wolf',13.00,9.00,4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(409,20457,'Zombie Soldier','','zombie',13.00,21.00,19,'male','L2Monster','Mystic',40,508,2.500,203,1.200,40,43,30,21,20,10,958,43,58,82,21,73,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(410,20458,'Zombie Warrior','','zombie_bi',13.00,27.50,22,'male','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,1184,56,75,93,28,83,278,500,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(411,20460,'Crimson Spider','','giant_spider',26.00,26.50,15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,545,22,40,69,14,62,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(412,20461,'Dungeon Spider','','giant_spider',26.00,26.50,15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,454,19,40,69,14,62,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.26,'true',1,0),
(413,20462,'Cave Blade Spider','','giant_spider',26.00,26.50,17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,515,22,48,75,17,67,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.26,'true',1,0),
(414,20463,'Dungeon Skeleton Archer','','skeleton_archer',11.00,27.00,13,'male','L2Monster','Ranger',500,339,2.500,147,1.200,40,43,30,21,20,10,397,16,61,77,11,56,249,0,227,275,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(415,20464,'Dungeon Skeleton','','skeleton',11.00,25.00,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(416,20465,'Prairie Fox','','fox',9.50,10.00,2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,58,2,11,38,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(417,20466,'Pincer Spider','','giant_spider',26.00,26.50,17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(418,20468,'Kaboo Orc','','orc',10.00,21.00,6,'male','L2Monster','Fighter',40,147,2.000,85,0.900,40,43,30,21,20,10,213,6,15,50,5,41,278,0,253,156,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'true',1,0),
(419,20469,'Kaboo Orc Archer','','orc_archer',14.00,25.00,8,'male','L2Monster','Ranger',500,197,2.000,102,0.900,40,43,30,21,20,10,293,10,41,55,6,45,249,0,227,14,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(420,20470,'Kaboo Orc Grunt','','orc',10.00,21.00,7,'male','L2Monster','Fighter',40,171,2.000,94,0.900,40,43,30,21,20,10,249,8,17,53,6,43,278,0,253,3,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(421,20471,'Kaboo Orc Fighter','','orc_fighter',12.00,22.00,10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,363,12,20,67,8,49,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(422,20472,'Kaboo Orc Fighter Leader','','orc_fighter',12.00,22.00,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,436,16,25,73,10,54,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(423,20473,'Kaboo Orc Fighter Lieutenant','','orc_fighter',12.00,22.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,391,15,23,70,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(424,20474,'Kasha Spider','','giant_spider',26.00,26.50,15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(425,20475,'Kasha Wolf','','wolf',13.00,9.00,4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(426,20476,'Kasha Fang Spider','','giant_spider',26.00,26.50,16,'male','L2Monster','Mystic',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(427,20477,'Kasha Timber Wolf','','wolf_bi',13.00,10.80,6,'male','L2Monster','Fighter',40,147,2.000,85,0.900,40,43,30,21,20,10,211,6,15,50,5,41,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(428,20478,'Kasha Blade Spider','','giant_spider',26.00,26.50,17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,666,28,48,75,17,67,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(429,20479,'Kasha Bear','','grizzly_bi',21.00,50.00,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,539,22,33,84,14,62,278,500,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(430,20480,'Blade Bat','','vampire_bat',10.00,33.50,10,'male','L2Monster','Mystic',40,257,2.000,120,0.900,40,43,30,21,20,10,356,12,25,55,8,49,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(431,20481,'Bearded Keltir','','keltir',13.00,10.00,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(432,20483,'Corpse Candle','','will_o_wisp',13.00,22.00,17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,604,25,40,91,17,67,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.10,'true',1,0),
(433,20487,'Kuruka Ratman','','wererat',14.00,25.00,16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,475,19,32,87,15,64,317,0,289,216,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.61,'true',1,0),
(434,20488,'Kuruka Ratman Hunter','','wererat',14.00,25.00,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,504,21,40,91,17,67,278,0,253,3,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(435,20489,'Quicksilver Beast','','onyx_beast',14.00,14.50,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,449,18,40,69,14,62,278,500,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.24,'true',1,0),
(436,20490,'Death Doll','','crimson_doll',15.00,38.00,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2175,141,300,183,131,164,278,500,253,0,0,0,60,150,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.67,'true',0,0),
(437,20491,'Crypt Horror','','dark_horror',20.00,35.00,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,454,19,40,69,14,62,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(438,20492,'Kirunak''s Guards','','spartoi',11.00,27.00,21,'male','L2Minion','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,636,29,57,108,25,80,278,0,253,68,0,0,60,140,'kirunak_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(439,20494,'Turek War Hound','','dire_wolf',13.00,11.00,24,'male','L2Monster','Fighter',40,687,7.000,272,1.500,40,43,30,21,20,10,869,43,89,101,34,90,278,0,253,0,0,0,24,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(440,20495,'Turek Orc Warlord','','orc_champion',10.00,23.00,30,'male','L2Monster','Fighter',40,954,7.000,365,1.500,40,43,30,21,20,10,1390,76,120,155,58,114,278,500,253,127,0,0,45,130,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',1,0),
(441,20496,'Turek Orc Archer','','orc_archer',14.00,25.00,27,'male','L2Monster','Ranger',500,813,7.000,318,1.500,40,43,30,21,20,10,1076,55,231,125,45,102,249,0,227,14,0,0,45,110,'orc_clan',400,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'false',1,0),
(442,20497,'Turek Orc Skirmisher','','orc_fighter',12.00,22.00,28,'male','L2Monster','Fighter',40,859,7.000,334,1.500,40,43,30,21,20,10,1117,58,102,143,49,106,278,500,253,121,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(443,20498,'Turek Orc Supplier','','orc_fighter',12.00,22.00,27,'male','L2Monster','Fighter',40,813,7.000,318,1.500,40,43,30,21,20,10,1035,53,83,138,45,102,317,0,289,11,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.46,'false',1,0),
(444,20499,'Turek Orc Footman','','orc',10.00,21.00,26,'male','L2Monster','Fighter',40,770,7.000,303,1.500,40,43,30,21,20,10,982,49,96,120,41,98,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(445,20500,'Turek Orc Sentinel','','orc',10.00,21.00,25,'male','L2Monster','Fighter',40,728,7.000,287,1.500,40,43,30,21,20,10,922,46,88,116,37,94,278,0,253,3,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(446,20501,'Turek Orc Shaman','','orc_shaman',9.00,22.00,29,'male','L2Monster','Priest',40,906,7.000,349,1.500,40,43,30,21,20,10,1156,62,111,149,53,110,278,0,253,7,0,0,45,120,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.26,'false',1,0),
(447,20502,'Twink Puma','','onyx_beast',14.00,14.50,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,539,22,40,69,14,62,278,500,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.24,'true',1,0),
(448,20504,'Dread Soldier','','skeleton',11.00,25.00,14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,424,16,32,66,12,59,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(449,20505,'Ruin Bat','','vampire_bat_bi',10.00,42.00,20,'male','L2Monster','NightAgressionMystic',40,541,2.500,213,1.200,40,43,30,21,20,10,712,32,63,86,23,76,278,500,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(450,20506,'Ruin Imp','','imp_bi',10.00,30.00,17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,605,25,48,75,17,67,278,0,253,0,0,0,60,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(451,20507,'Ruin Imp Elder','','imp_bi',10.00,30.00,21,'male','L2Monster','Mystic',40,575,3.500,227,1.500,40,43,30,21,20,10,779,36,69,89,25,80,278,500,253,0,0,0,60,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(452,20508,'Plunder Tarantula','','giant_spider',26.00,26.50,17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(453,20509,'Spore Fungus','','walking_fungus',15.00,22.50,9,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,321,11,22,53,7,47,278,0,253,0,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(454,20510,'Puma','','onyx_beast',14.00,14.50,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,423,16,30,60,10,54,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.24,'true',1,0),
(455,20511,'Pitchstone Golem','','stone_golem',20.00,31.00,19,'male','L2Monster','Mystic',40,508,2.500,203,1.200,40,43,30,21,20,10,799,36,48,99,21,73,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(456,20512,'Field Stalker','','field_stalker',15.00,30.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1812,107,211,154,89,137,278,500,253,0,0,0,70,110,'monster_eye_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',0,0),
(457,20513,'Skeleton Knight','','skeleton_knight',10.00,25.00,32,'male','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1265,71,140,167,69,123,278,500,253,150,0,0,40,160,'skeleton_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.17,'true',0,0),
(458,20514,'Shield Skeleton','','skeleton',11.00,25.00,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,157,103,0,60,140,'skeleton_clan',300,'Local','',0,20,36,7,50,1,9,0,-6,0.30,'true',1,0),
(459,20515,'Skeleton Infantryman','','skeleton',11.00,25.00,16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,157,18,0,60,140,'skeleton_clan',300,'Local','',0,20,38,7,50,1,9,0,-6,0.30,'true',1,0),
(460,20516,'Skeleton Sentinel','','skeleton_bi',11.00,31.00,14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,424,16,32,66,12,59,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.30,'true',0,0),
(461,20517,'Skeleton Hunter','','skeleton',11.00,25.00,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(462,20518,'Skeleton Hunter Archer','','skeleton_archer',11.00,27.00,13,'male','L2Monster','Fighter',500,339,2.500,147,1.200,40,43,30,21,20,10,397,16,61,77,11,56,249,0,227,275,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(463,20519,'Skeleton Pikeman','','skeleton_pikeman',10.00,28.00,27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,946,48,114,114,45,102,278,500,253,299,0,0,50,155,'skeleton_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.21,'true',0,0),
(464,20520,'Pirate Captain Uthanka','','orc_fighter_bi',12.00,26.40,10,'male','L2Monster','Fighter',40,257,4.000,120,0.900,40,43,30,21,20,10,463,16,20,67,8,49,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.46,'false',0,0),
(465,20521,'Whinstone Golem','','stone_golem',20.00,31.00,14,'male','L2Monster','Mystic',40,364,2.500,156,1.200,40,43,30,21,20,10,705,27,30,80,12,59,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(466,20522,'White Fang','','wolf_bi',13.00,10.80,10,'male','L2Monster','Fighter',40,257,4.000,120,0.900,40,43,30,21,20,10,458,15,22,61,8,49,278,500,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.39,'false',0,0),
(467,20524,'Grey Wolf Elder','','wolf',13.00,9.00,7,'male','L2Minion','Fighter',40,171,1.000,94,0.900,40,43,30,21,20,10,304,10,20,44,6,43,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.39,'true',0,0),
(468,20525,'Gray Wolf','','wolf',13.00,9.00,4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(469,20526,'Obsidian Golem','','stone_golem',20.00,31.00,15,'male','L2Monster','Mystic',40,390,2.500,165,1.200,40,43,30,21,20,10,755,31,33,84,14,62,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(470,20527,'White Wolf','','dire_wolf',13.00,11.00,4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,121,3,13,42,4,37,278,500,253,0,0,0,24,110,'wolf_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',0,0),
(471,20528,'Goblin Lord','','goblin',10.00,16.50,13,'male','L2Monster','Fighter',40,339,2.500,147,1.200,40,43,30,21,20,10,458,18,29,63,11,56,317,0,289,217,0,0,40,110,'',0,'Local','',0,0,0,7,10,8,0,0,0,0.32,'true',1,0),
(472,20529,'Young Brown Keltir','','keltir',13.00,10.00,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(473,20530,'Young Red Keltir','','keltir',13.00,10.00,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(474,20531,'Young Prairie Keltir','','keltir',13.00,10.00,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(475,20532,'Brown Keltir','','keltir',13.00,10.00,2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,70,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(476,20533,'Longtail Keltir','','keltir',13.00,10.00,2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,70,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(477,20534,'Red Keltir','','keltir',13.00,10.00,2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,70,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(478,20535,'Prairie Keltir','','keltir',13.00,10.00,2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,70,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(479,20536,'Elder Brown Keltir','','keltir',13.00,10.00,3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,105,2,11,44,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(480,20537,'Elder Red Keltir','','keltir',13.00,10.00,3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,105,2,11,44,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(481,20538,'Elder Prairie Keltir','','keltir',13.00,10.00,3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,105,2,11,44,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(482,20539,'Elder Longtail Keltir','','keltir',13.00,10.00,3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,105,2,11,44,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(483,20540,'Gemstone Beast','','onyx_beast',14.00,14.50,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,352,13,25,73,10,54,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.24,'true',1,0),
(484,20541,'Ore Bat','','vampire_bat',10.00,33.50,17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,499,21,48,75,17,67,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(485,20542,'Skeleton Longbowman','','skeleton_archer',11.00,27.00,19,'male','L2Monster','Ranger',500,508,2.500,203,1.200,40,43,30,21,20,10,587,26,129,82,21,73,249,500,227,275,0,0,40,140,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(486,20543,'Ghost','','human_ghost',8.00,22.00,20,'male','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,599,27,63,86,23,76,278,500,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(487,20544,'Elder Keltir','','keltir',13.00,10.00,3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,105,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(488,20545,'Young Keltir','','keltir',13.00,10.00,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(489,20546,'Turek Orc Elder','','orc_shaman',9.00,22.00,34,'male','L2Monster','Priest',40,1164,4.500,430,1.800,40,43,30,21,20,10,1714,100,162,179,82,132,278,500,253,7,0,0,45,120,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.26,'true',1,0),
(490,20547,'Ol Mahum Reserve','','ol_mahum_bi',13.50,29.20,23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,878,42,68,117,31,87,278,0,253,2,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,47,7,30,4,4,0,-6,0.46,'true',1,0),
(491,20548,'Ol Mahum Deserter','','ol_mahum',13.50,25.00,23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,895,43,75,107,31,87,278,500,253,2,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(492,20549,'Ol Mahum Lord','','ol_mahum_champion',14.00,27.00,34,'male','L2Monster','Fighter',40,1164,9.000,430,1.800,40,43,30,21,20,10,1763,103,196,148,82,132,278,500,253,69,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,66,7,30,4,4,0,-6,0.63,'false',1,0),
(493,20550,'Guardian Basilisk','','lesser_basilisk',34.00,25.00,36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,1960,118,206,175,96,142,278,0,253,0,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(494,20551,'Road Scavenger','','wererat',14.00,25.00,37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,1991,122,194,154,104,147,317,0,289,221,0,0,80,174,'',0,'Local','',0,0,0,7,10,8,0,0,10,0.61,'true',1,0),
(495,20552,'Fettered Soul','','binding',12.00,21.00,38,'male','L2Monster','Fighter',40,1400,9.000,497,1.800,40,43,30,21,20,10,2146,134,238,188,112,153,278,0,253,0,0,0,10,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'true',1,0),
(496,20553,'Windsus','','giant_wild_hog',25.00,27.00,39,'male','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,2212,141,255,195,121,158,278,0,253,0,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'true',1,0),
(497,20554,'Grandis','','twin_headed_giant',17.00,39.00,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2585,167,273,201,131,164,278,500,253,0,0,0,45,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(498,20555,'Giant Fungus','','walking_fungus_bi',15.00,31.30,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2327,150,273,201,131,164,278,0,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(499,20556,'Giant Monstereye','','monster_eye_bi',29.00,60.00,41,'male','L2Monster','Mystic',40,1593,5.500,560,2.100,40,43,30,21,20,10,2444,160,321,189,141,169,278,0,253,0,0,0,90,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(500,20557,'Dire Wyrm','','wyrm',29.00,72.00,42,'male','L2Monster','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,2590,173,283,237,152,175,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.19,'true',1,0),
(501,20558,'Rotting tree','','hanged_man_ripper',35.00,80.00,43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,2662,180,302,245,163,181,278,0,253,0,0,0,55,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(502,20559,'Rotting Golem','','stone_golem_bi_one',22.00,43.40,44,'male','L2Monster','Mystic',40,1799,5.500,648,2.100,40,43,30,21,20,10,3942,270,322,253,176,187,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(503,20560,'Trisalim Spider','','giant_spider',26.00,26.50,45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,2916,203,415,216,188,193,278,0,253,0,0,0,72,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(504,20561,'Trisalim Tarantula','','poison_spider',27.00,25.50,46,'male','L2Monster','Mystic',40,1943,5.500,707,2.100,40,43,30,21,20,10,3452,245,365,270,202,199,278,500,253,0,0,0,60,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.65,'true',1,0),
(505,20562,'Spore Zombie','','zombie_bi',13.00,27.50,47,'male','L2Monster','Mystic',40,2016,5.500,738,2.100,40,43,30,21,20,10,3591,257,469,230,216,206,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(506,20563,'Manashen Gargoyle','','gargoyle',16.00,50.00,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2769,179,300,183,131,164,278,0,253,0,0,0,140,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(507,20564,'Enchanted Monstereye','','monster_eye',21.00,43.00,41,'male','L2Monster','Mystic',40,1593,5.500,560,2.100,40,43,30,21,20,10,2493,163,321,189,141,169,278,500,253,0,0,0,90,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(508,20565,'Enchanted Stone Golem','','stone_golem_bi',20.00,40.30,42,'male','L2Monster','Mystic',40,1660,5.500,589,2.100,40,43,30,21,20,10,3627,242,342,196,152,175,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(509,20566,'Enchanted Iron Golem','','iron_golem',18.00,34.00,43,'male','L2Monster','Mystic',40,1728,5.500,618,2.100,40,43,30,21,20,10,3802,257,302,245,163,181,278,0,253,0,0,0,20,20,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(510,20567,'Enchanted Gargoyle','','gargoyle',16.00,50.00,44,'male','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,3350,229,390,209,176,187,278,0,253,0,0,0,140,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(511,20568,'Formor','','troll',21.00,35.00,45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,2945,205,377,238,188,193,278,0,253,0,0,0,55,174,'beast_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(512,20569,'Formor Elder','','troll',21.00,35.00,46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,3200,227,401,245,202,199,278,0,253,0,0,0,55,174,'beast_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(513,20570,'Tarlk Bugbear','','bugbear',17.00,35.00,47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,3212,230,427,253,216,206,278,0,253,88,0,0,55,174,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(514,20571,'Tarlk Bugbear Warrior','','bugbear',17.00,35.00,48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,3793,277,453,261,231,212,278,500,253,169,0,0,55,174,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(515,20572,'Tarlk Bugbear High Warrior','','king_bugbear',15.00,40.00,49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,4155,307,529,245,247,219,278,0,253,160,0,0,55,174,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(516,20573,'Tarlk Basilisk','','lesser_basilisk',34.00,25.00,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3600,271,463,306,264,226,278,0,253,0,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(517,20574,'Elder Tarlk Basilisk','','lesser_basilisk',34.00,25.00,51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,3820,291,593,260,281,232,278,500,253,0,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(518,20575,'Oel Mahum Warrior','','oel_mahum_warrior',20.00,38.00,54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,4241,338,699,284,339,254,278,0,253,72,0,0,70,174,'oel_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.65,'true',1,0),
(519,20576,'Oel Mahum Witch Doctor','','oel_mahum_witch_doctor',15.00,34.00,55,'male','L2Monster','Mystic',40,2643,13.000,987,2.400,40,43,30,21,20,10,4401,355,609,354,360,261,278,0,253,201,0,0,70,174,'oel_mahum_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.26,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(520,20577,'Leto Lizardman','','zenta_lizardman',11.00,32.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1781,105,192,169,89,137,278,0,253,66,0,0,37,174,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'true',1,0),
(521,20578,'Leto Lizardman Archer','','zenta_lizardman_scout',11.00,30.00,36,'male','L2Monster','Ranger',500,1279,4.500,463,1.800,40,43,30,21,20,10,1941,117,417,193,96,142,249,0,227,14,0,0,37,174,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.93,'true',1,0),
(522,20579,'Leto Lizardman Soldier','','zenta_lizardman',11.00,32.00,37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,2030,125,222,182,104,147,278,500,253,68,0,0,37,174,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'true',1,0),
(523,20580,'Leto Lizardman Warrior','','zenta_lizardman_warrior',13.00,35.00,38,'male','L2Monster','Fighter',40,1400,9.000,497,1.800,40,43,30,21,20,10,1953,121,261,171,112,153,278,0,253,93,0,0,40,174,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(524,20581,'Leto Lizardman Shaman','','zenta_lizardman_shaman',13.00,35.00,39,'male','L2Monster','Priest',40,1462,4.500,514,1.800,40,43,30,21,20,10,2212,141,280,177,121,158,278,0,253,159,0,0,43,174,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.63,'true',1,0),
(525,20582,'Leto Lizardman Overlord','','zenta_lizardman_matriarch',20.00,40.00,40,'male','L2Monster','Fighter',40,1527,9.000,531,1.800,40,43,30,21,20,10,2207,142,217,222,131,164,317,500,289,221,0,0,53,174,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.46,'false',1,0),
(526,20583,'Timak Orc','','batur_orc',9.00,21.50,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2327,150,300,183,131,164,278,0,253,2,0,0,80,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(527,20584,'Timak Orc Archer','','batur_orc_archer',11.00,21.50,41,'male','L2Monster','Ranger',500,1593,5.500,560,2.100,40,43,30,21,20,10,3152,206,589,229,141,169,249,0,227,14,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.96,'true',1,0),
(528,20585,'Timak Orc Soldier','','batur_orc',9.00,21.50,42,'male','L2Monster','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,3114,207,311,215,152,175,278,500,253,66,0,0,80,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(529,20586,'Timak Orc Warrior','','batur_orc_warrior',10.00,20.00,43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,2984,202,332,223,163,181,278,0,253,68,0,0,80,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(530,20587,'Timak Orc Shaman','','batur_orc_shaman',11.00,16.00,44,'male','L2Monster','Priest',40,1799,5.500,648,2.100,40,43,30,21,20,10,2815,193,390,209,176,187,278,0,253,179,0,0,50,174,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.30,'true',1,0),
(531,20588,'Timak Orc Overlord','','batur_orc_overlord',12.00,24.00,45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,3701,257,415,216,188,193,278,500,253,127,0,0,80,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'true',1,0),
(532,20589,'Fline','','sylph',11.00,35.00,45,'female','L2Monster','Mystic',40,1870,11.000,677,2.100,40,43,30,21,20,10,2766,192,343,262,188,193,278,0,253,0,0,0,60,174,'elemental_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(533,20590,'Liele','','undine',12.00,27.00,46,'female','L2Monster','Mystic',40,1943,11.000,707,2.100,40,43,30,21,20,10,2862,203,365,270,202,199,278,0,253,0,0,0,60,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',1,0),
(534,20591,'Valley Treant','','ti_mi_tran',23.00,90.00,47,'male','L2Monster','Fighter',40,2016,11.000,738,2.100,40,43,30,21,20,10,4224,303,388,279,216,206,278,0,253,0,0,0,12,12,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',1,0),
(535,20592,'Satyr','','pan',14.00,35.00,48,'male','L2Monster','Fighter',40,2091,16.500,768,2.100,40,43,30,21,20,10,3076,224,412,288,231,212,278,500,253,291,0,0,45,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.58,'false',1,0),
(536,20593,'Unicorn','','unicorn',14.00,30.00,49,'male','L2Monster','Mystic',40,2168,16.500,799,2.100,40,43,30,21,20,10,3299,244,437,297,247,219,278,0,253,0,0,0,46,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.74,'false',1,0),
(537,20594,'Forest Runner','','mandragora_b',12.00,25.50,50,'female','L2Monster','Fighter',40,2245,11.000,830,2.100,40,43,30,21,20,10,3381,254,463,306,264,226,278,0,253,0,0,0,80,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.13,'false',1,0),
(538,20595,'Fline Elder','','sylph',11.00,35.00,51,'female','L2Monster','Mystic',40,2323,13.000,861,2.400,40,43,30,21,20,10,3518,268,593,260,281,232,278,0,253,0,0,0,60,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(539,20596,'Liele Elder','','undine',12.00,27.00,52,'female','L2Monster','Mystic',40,2402,13.000,892,2.400,40,43,30,21,20,10,3730,288,627,268,300,239,278,500,253,0,0,0,60,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',1,0),
(540,20597,'Valley Treant Elder','','ti_mi_tran',23.00,90.00,53,'male','L2Monster','Fighter',40,2481,19.500,923,2.400,40,43,30,21,20,10,5199,408,662,276,319,247,278,0,253,0,0,0,12,12,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',1,0),
(541,20598,'Satyr Elder','','pan',14.00,35.00,54,'male','L2Monster','Fighter',40,2562,19.500,955,2.400,40,43,30,21,20,10,3816,304,699,284,339,254,278,0,253,297,0,0,45,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.58,'false',1,0),
(542,20599,'Unicorn Elder','','unicorn',14.00,30.00,55,'male','L2Monster','Mystic',40,2643,19.500,987,2.400,40,43,30,21,20,10,3959,319,737,292,360,261,278,0,253,0,0,0,46,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.74,'false',1,0),
(543,20600,'Karul Bugbear','','bugbear',17.00,35.00,40,'male','L2Monster','KarulBugbear',40,1527,4.500,531,1.800,40,43,30,21,20,10,2741,177,300,183,131,164,278,0,253,88,0,0,55,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(544,20601,'Tamlin Orc','','batur_orc',9.00,21.50,41,'male','L2Monster','Fighter',40,1593,5.500,560,2.100,40,43,30,21,20,10,2444,160,291,208,141,169,278,0,253,2,0,0,80,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(545,20602,'Tamlin Orc Archer','','batur_orc_archer',11.00,21.50,42,'male','L2Monster','Ranger',500,1660,5.500,589,2.100,40,43,30,21,20,10,3308,220,692,215,152,175,249,0,227,14,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.96,'true',1,0),
(546,20603,'Kronbe Spider','','giant_spider',26.00,26.50,43,'male','L2Monster','Mystic',40,1728,5.500,618,2.100,40,43,30,21,20,10,2715,184,302,245,163,181,278,500,253,0,0,0,72,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(547,20604,'Lakin','','twin_headed_giant',17.00,39.00,44,'male','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,3317,227,390,209,176,187,278,0,253,89,0,0,45,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.46,'true',1,0),
(548,20605,'Weird Drake','','drake',30.00,100.00,45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(549,20606,'Kuran Kobold','','kobold',10.00,15.00,27,'male','L2Monster','Fighter',40,813,7.000,318,1.500,40,43,30,21,20,10,950,48,94,138,45,102,278,0,253,0,0,0,47,110,'kobold_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',1,0),
(550,20607,'Kuran Kobold Warrior','','kobold',10.00,15.00,28,'male','L2Monster','Fighter',40,859,7.000,334,1.500,40,43,30,21,20,10,1006,53,124,118,49,106,278,0,253,0,0,0,47,110,'kobold_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',1,0),
(551,20608,'Patin Archer','','skeleton_archer',11.00,27.00,29,'male','L2Monster','Ranger',500,906,7.000,349,1.500,40,43,30,21,20,10,1022,55,271,135,53,110,249,500,227,14,0,0,40,140,'',0,'DRIVER','',0,0,0,7,10,8,0,1500,0,0.80,'false',1,0),
(552,20609,'Lakin Salamander','','salamander',16.00,6.80,30,'male','L2Monster','Fighter',40,954,7.000,365,1.500,40,43,30,21,20,10,1068,58,120,155,58,114,278,0,253,0,0,0,64,96,'elemental_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,0,0.20,'false',1,0),
(553,20610,'Sentinel Of Water','','monster_eye',21.00,43.00,31,'male','L2Monster','Mystic',40,1004,9.000,381,1.800,40,43,30,21,20,10,1083,60,157,133,64,118,278,0,253,0,0,0,90,90,'elemental_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.30,'false',1,0),
(554,20611,'Dre Vanul Warrior','','dre_vanul',14.00,36.00,32,'male','L2Monster','Fighter',40,1056,9.000,397,1.800,40,43,30,21,20,10,1154,65,169,138,69,123,278,0,253,0,0,0,80,80,'demonic_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.35,'false',1,0),
(555,20612,'Salamander Rowin','','salamander',16.00,6.80,33,'male','L2Monster','Fighter',40,1109,9.000,413,1.800,40,43,30,21,20,10,1319,75,151,173,75,128,278,500,253,0,0,0,64,96,'elemental_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,0,0.20,'false',1,0),
(556,20613,'Lafi Lizardman','','virud_lizardman',10.00,23.00,27,'male','L2Monster','Fighter',40,813,7.000,318,1.500,40,43,30,21,20,10,950,48,104,125,45,102,278,0,253,291,0,0,43,130,'lizardman_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(557,20614,'Lafi Lizardman Scout','','virud_lizardman_scout',10.00,22.00,28,'male','L2Monster','Ranger',500,859,7.000,334,1.500,40,43,30,21,20,10,940,49,228,143,49,106,249,0,227,2507,0,0,43,130,'lizardman_clan',300,'DRIVER','',0,0,0,7,10,8,0,1500,0,0.72,'false',1,0),
(558,20615,'Ritmal Swordsman','','spartoi',11.00,27.00,29,'male','L2Monster','Fighter',40,906,7.000,349,1.500,40,43,30,21,20,10,1094,58,122,135,53,110,278,500,253,73,0,0,60,140,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.30,'false',1,0),
(559,20616,'Lakin Undine','','undine',12.00,27.00,30,'female','L2Monster','Mystic',40,954,7.000,365,1.500,40,43,30,21,20,10,1434,78,145,128,58,114,278,0,253,0,0,0,60,60,'elemental_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,0,0.35,'false',1,0),
(560,20617,'Sentinel Of Water','','magical_weaver',11.00,20.00,31,'male','L2Monster','Mystic',40,1004,9.000,381,1.800,40,43,30,21,20,10,1093,60,129,161,64,118,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(561,20618,'Kanil Succubus','','succubus',10.00,36.00,32,'female','L2Monster','Mystic',40,1056,9.000,397,1.800,40,43,30,21,20,10,1216,68,169,138,69,123,278,0,253,0,0,0,60,100,'demonic_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.84,'false',1,0),
(562,20619,'Rowin Undine','','undine',12.00,27.00,33,'female','L2Monster','Mystic',40,1109,9.000,413,1.800,40,43,30,21,20,10,1252,72,151,173,75,128,278,500,253,0,0,0,60,60,'elemental_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,0,0.35,'false',1,0),
(563,20620,'Cave Beast','','troll',21.00,35.00,61,'male','L2Monster','Fighter',40,3137,22.500,1184,2.700,40,43,30,21,20,10,4304,378,992,344,505,307,278,500,253,0,0,0,55,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',1,0),
(564,20621,'Death Wave','','will_o_wisp',13.00,22.00,62,'male','L2Monster','Mystic',40,3219,22.500,1217,2.700,40,43,30,21,20,10,4639,413,1038,353,532,315,278,500,253,0,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.10,'false',1,0),
(565,20622,'Malruk Soldier','','skeleton_royal_guard',11.00,28.50,63,'male','L2Monster','Fighter',40,3302,22.500,1251,2.700,40,43,30,21,20,10,4953,447,950,362,560,323,317,500,289,221,0,0,80,174,'malruk_clan',500,'Local','',0,0,0,7,10,8,0,0,0,0.52,'false',1,0),
(566,20623,'Plando','','virud_lizardman_scout',10.00,22.00,64,'male','L2Monster','Ranger',500,3384,30.000,1285,2.700,40,43,30,21,20,10,4953,453,2084,449,589,331,249,500,227,2507,0,0,43,174,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.72,'false',1,0),
(567,20624,'Cave Howler','','twin_headed_giant',17.00,39.00,65,'male','L2Monster','Fighter',40,3465,30.000,1319,2.700,40,43,30,21,20,10,5037,468,979,460,619,340,278,500,253,0,0,0,45,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(568,20625,'Malruk Knight','','skeleton_knight',10.00,25.00,66,'male','L2Monster','Fighter',40,3546,30.000,1353,2.700,40,43,30,21,20,10,5030,473,1020,471,649,348,278,500,253,78,0,0,40,174,'malruk_clan',500,'Local','',0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(569,20626,'Malruk Berserker','','death_knight',12.00,30.00,67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,7220,687,1415,362,681,356,278,500,253,77,0,0,27,174,'malruk_clan',500,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(570,20627,'Malruk Lord','','death_blader',15.00,45.00,68,'male','L2Monster','Fighter',40,3706,37.500,1423,2.700,40,43,30,21,20,10,4964,479,1217,449,713,365,278,500,253,1472,0,0,100,174,'malruk_clan',500,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(571,20628,'Limal Karinness','','bloody_queen',14.00,40.00,69,'female','L2Monster','Mystic',40,3784,37.500,1458,2.700,40,43,30,21,20,10,5349,523,1392,418,746,373,278,500,253,0,0,0,80,174,'malruk_clan',500,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(572,20629,'Karik','','karik',25.00,90.00,70,'male','L2Monster','Fighter',40,3862,37.500,1493,2.700,40,43,30,21,20,10,6584,652,1445,427,780,382,278,500,253,0,0,0,37,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(573,20630,'Taik Orc','','ketra_orc',12.00,29.00,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2327,150,273,201,131,164,278,0,253,127,0,0,45,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(574,20631,'Taik Orc Archer','','ketra_orc_archer',12.00,27.00,41,'male','L2Monster','Ranger',500,1593,5.500,560,2.100,40,43,30,21,20,10,3152,206,589,195,141,169,249,0,227,14,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.91,'true',1,0),
(575,20632,'Taik Orc Warrior','','ketra_orc_warrior',12.00,24.00,42,'male','L2Monster','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,3144,209,342,196,152,175,278,500,253,75,0,0,36,174,'orc_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.54,'true',1,0),
(576,20633,'Taik Orc Shaman','','ketra_orc_shaman',10.00,23.00,43,'male','L2Monster','Priest',40,1728,5.500,618,2.100,40,43,30,21,20,10,3068,207,302,245,163,181,278,0,253,9,0,0,10,174,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.34,'true',1,0),
(577,20634,'Taik Orc Captain','','ketra_orc_warrior',12.00,24.00,44,'male','L2Monster','Fighter',40,1799,11.000,648,2.100,40,43,30,21,20,10,2943,201,322,253,176,187,278,500,253,75,104,0,36,174,'orc_clan',300,'Local','',0,20,86,7,30,4,4,0,-6,0.54,'false',1,0),
(578,20635,'Carinkain','','mana_vampire',11.00,20.00,45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,2974,207,415,216,188,193,278,500,253,0,0,0,90,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(579,20636,'Forest of Mirrors Ghost','','dwarf_ghost',9.00,16.50,46,'male','L2Monster','Mystic',40,1943,5.500,707,2.100,40,43,30,21,20,10,3310,235,442,223,202,199,278,500,253,0,0,0,80,174,'mirrorforest_clan',200,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(580,20637,'Forest of Mirrors Ghost','','elf_ghost',7.00,21.00,47,'male','L2Monster','Mystic',40,2016,5.500,738,2.100,40,43,30,21,20,10,3456,248,469,230,216,206,278,500,253,0,0,0,80,174,'mirrorforest_clan',200,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(581,20638,'Forest of Mirrors Ghost','','human_ghost',8.00,22.00,48,'male','L2Monster','Mystic',40,2091,5.500,768,2.100,40,43,30,21,20,10,3605,263,498,238,231,212,278,500,253,0,0,0,80,174,'mirrorforest_clan',200,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(582,20639,'Mirror','','mirror',26.00,52.00,49,'male','L2Monster','Mystic',40,2168,11.000,799,2.100,40,43,30,21,20,10,4254,314,437,297,247,219,278,0,253,0,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(583,20640,'Harit Lizardman','','zenta_lizardman',11.00,32.00,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3636,274,509,278,264,226,278,0,253,88,945,0,37,174,'lizardman_clan',300,'Local','',0,20,100,7,50,1,9,0,-6,0.28,'true',1,0),
(584,20641,'Harit Lizardman Grunt','','zenta_lizardman',11.00,32.00,51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,4501,343,539,286,281,232,278,0,253,70,0,0,37,174,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'true',1,0),
(585,20642,'Harit Lizardman Archer','','zenta_lizardman_scout',11.00,30.00,52,'male','L2Monster','Ranger',500,2402,6.500,892,2.400,40,43,30,21,20,10,4214,326,1152,324,300,239,249,500,227,14,0,0,37,174,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.93,'true',1,0),
(586,20643,'Harit Lizardman Warrior','','zenta_lizardman_warrior',13.00,35.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4332,341,662,276,319,247,278,0,253,291,0,0,40,174,'lizardman_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(587,20644,'Harit Lizardman Shaman','','zenta_lizardman_shaman',13.00,35.00,54,'male','L2Monster','Priest',40,2562,6.500,955,2.400,40,43,30,21,20,10,4241,338,699,284,339,254,278,0,253,9,0,0,43,174,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.63,'true',1,0),
(588,20645,'Harit Lizardman Matriarch','','zenta_lizardman_matriarch',20.00,40.00,55,'male','L2Monster','Fighter',40,2643,13.000,987,2.400,40,43,30,21,20,10,4768,385,609,354,360,261,278,500,253,221,0,0,53,174,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(589,20646,'Halingka','','saber_toothed_tiger',34.00,28.00,55,'male','L2Monster','Fighter',40,2643,13.000,987,2.400,40,43,30,21,20,10,3592,290,737,292,360,261,278,0,253,0,0,0,60,170,'beast_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.45,'false',1,0),
(590,20647,'Yintzu','','field_stalker',15.00,30.00,56,'male','L2Monster','Fighter',40,2724,13.000,1019,2.400,40,43,30,21,20,10,3605,296,777,301,382,269,278,500,253,0,0,0,70,110,'beast_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.41,'false',1,0),
(591,20648,'Paliote','','will_o_wisp',13.00,22.00,57,'male','L2Monster','Mystic',40,2806,13.000,1052,2.400,40,43,30,21,20,10,4094,340,817,309,405,276,278,0,253,0,0,0,80,140,'beast_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.10,'false',1,0),
(592,20649,'Hamrut','','poison_spider',27.00,25.50,58,'male','L2Monster','Mystic',40,2889,13.000,1084,2.400,40,43,30,21,20,10,4075,344,859,318,428,284,278,500,253,0,0,0,60,140,'beast_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.65,'false',1,0),
(593,20650,'Kranrot','','crimson_bear',19.00,36.00,59,'male','L2Monster','Fighter',40,2971,13.000,1117,2.400,40,43,30,21,20,10,4410,377,902,326,453,291,278,500,253,0,0,0,37,170,'beast_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.45,'false',1,0),
(594,20651,'Gamlin','','gamlin',11.00,32.00,60,'male','L2Monster','Fighter',40,3054,13.000,1150,2.400,40,43,30,21,20,10,4097,355,782,405,478,299,278,0,253,0,0,0,80,170,'giant_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.46,'false',1,0),
(595,20652,'Leogul','','leogul',15.00,35.00,61,'male','L2Monster','Fighter',40,3137,15.000,1184,2.700,40,43,30,21,20,10,4320,380,819,416,505,307,278,500,253,0,0,0,80,170,'giant_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.72,'false',1,0),
(596,20653,'Lesser Giant','','lesser_giant',21.00,44.00,61,'male','L2Monster','Fighter',40,3137,22.500,1184,2.700,40,43,30,21,20,10,4058,357,901,378,505,307,278,0,253,3937,0,0,15,180,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.58,'false',0,0),
(597,20654,'Lesser Giant Soldier','','lesser_giant',21.00,44.00,62,'male','L2Monster','Fighter',40,3219,22.500,1217,2.700,40,43,30,21,20,10,6224,554,1142,321,532,315,278,0,253,3937,0,0,15,180,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.58,'false',1,0),
(598,20655,'Lesser Giant Shooter','','lesser_giant_shooter',21.00,44.00,63,'male','L2Monster','Fighter',500,3302,22.500,1251,2.700,40,43,30,21,20,10,5085,459,2194,398,560,323,249,500,227,4028,0,0,80,180,'giant_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.63,'false',1,0),
(599,20656,'Lesser Giant Scout','','lesser_giant_shooter',21.00,44.00,63,'male','L2Monster','Ranger',500,3302,22.500,1251,2.700,40,43,30,21,20,10,4639,419,2194,338,560,323,249,500,227,4028,0,0,80,180,'giant_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.63,'false',1,0),
(600,20657,'Lesser Giant Mage','','lesser_giant_mage',21.00,44.00,64,'male','L2Monster','Mystic',40,3384,15.000,1285,2.700,40,43,30,21,20,10,5511,504,1135,371,589,331,278,0,253,3938,0,0,15,180,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(601,20658,'Lesser Giant Elder','','lesser_giant_mage',21.00,44.00,65,'male','L2Monster','Mystic',40,3465,15.000,1319,2.700,40,43,30,21,20,10,5324,494,1184,380,619,340,278,0,253,3938,0,0,15,180,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(602,20659,'Grave Wanderer','','zombie',13.00,21.00,45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,4123,287,377,238,188,193,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(603,20660,'Archer of Greed','','skeleton_archer',11.00,27.00,46,'male','L2Monster','Ranger',500,1943,5.500,707,2.100,40,43,30,21,20,10,4048,287,982,190,202,199,249,500,227,14,0,0,40,174,'',0,'Local','',0,0,0,7,10,8,0,1500,10,0.80,'true',1,0),
(604,20661,'Hatar Ratman Thief','','wererat',14.00,25.00,47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,3823,274,373,253,216,206,317,0,289,946,0,0,80,174,'hatar_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.61,'true',1,0),
(605,20662,'Hatar Ratman Boss','','wererat',14.00,25.00,48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,3987,291,396,261,231,212,317,0,289,221,0,0,80,174,'hatar_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.61,'true',1,0),
(606,20663,'Hatar Hanishee','','medusa',10.00,25.00,49,'female','L2Monster','Mystic',40,2168,5.500,799,2.100,40,43,30,21,20,10,3492,258,529,245,247,219,278,0,253,0,0,0,50,174,'hatar_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',1,0),
(607,20664,'Deprive','','field_stalker',15.00,30.00,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3672,277,560,253,264,226,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(608,20665,'Taik Orc Supply','','ketra_orc',12.00,29.00,51,'male','L2Monster','Priest',40,2323,6.500,861,2.400,40,43,30,21,20,10,4501,343,490,315,281,232,278,0,253,69,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(609,20666,'Taik Orc Seeker','','ketra_orc',12.00,29.00,52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,4679,362,627,268,300,239,278,0,253,72,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(610,20667,'Farcran','','crimson_bear',19.00,36.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4813,378,602,304,319,247,278,0,253,0,0,0,37,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(611,20668,'Grave Guard','','gargoyle',16.00,50.00,54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,4283,341,578,344,339,254,278,500,253,0,0,0,140,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',1,0),
(612,20669,'Taik Orc Supply Leader','','ketra_orc_warrior',12.00,24.00,55,'male','L2Monster','Priest',40,2643,6.500,987,2.400,40,43,30,21,20,10,5340,431,737,292,360,261,278,500,253,75,0,0,36,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',1,0),
(613,20670,'Crimson Drake','','drake',30.00,100.00,61,'male','L2Monster','Mystic',40,3137,7.500,1184,2.700,40,43,30,21,20,10,5465,481,992,344,505,307,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.84,'false',1,0),
(614,20671,'Kadios','','devastator',35.00,35.00,62,'male','L2Monster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,5702,508,1038,353,532,315,278,500,253,0,0,0,25,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'false',1,0),
(615,20672,'Trives','','serpent_slave',17.00,46.00,63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,5772,521,897,438,560,323,278,0,253,127,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(616,20673,'Falibati','','cave_maiden',25.00,65.00,64,'female','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,6016,551,938,449,589,331,278,500,253,73,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'false',1,0),
(617,20674,'Doom Knight','','death_blader',15.00,45.00,65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,8649,804,1184,380,619,340,278,500,253,1472,0,0,100,174,'doom_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(618,20675,'Tairim','','will_o_wisp',13.00,22.00,50,'male','L2Monster','Mystic',40,2245,5.500,830,2.100,40,43,30,21,20,10,3817,288,463,306,264,226,278,0,253,0,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.10,'false',1,0),
(619,20676,'Judge of Marsh','','hanged_man_ripper',35.00,80.00,65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6205,577,1184,380,619,340,278,500,253,0,0,0,55,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(620,20677,'Tulben','','vampire_bat',10.00,33.50,66,'male','L2Monster','Mystic',40,3546,7.500,1353,2.700,40,43,30,21,20,10,6968,656,1123,428,649,348,278,0,253,0,0,0,60,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(621,20678,'Tortured Undead','','hungry_spirit',13.00,40.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4085,321,662,276,319,247,278,0,253,0,0,0,15,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(622,20679,'Marsh Stalker','','gargoyle',16.00,50.00,54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,4199,335,636,313,339,254,278,0,253,0,0,0,140,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(623,20680,'Marsh Drake','','drake',30.00,100.00,55,'male','L2Monster','Mystic',40,2643,6.500,987,2.400,40,43,30,21,20,10,4443,359,737,292,360,261,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(624,20681,'Vanor Silenos','','heltor_silenos',13.00,29.00,45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,3092,215,377,238,188,193,278,0,253,88,0,0,34,174,'silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.46,'true',1,0),
(625,20682,'Vanor Silenos Grunt','','heltor_silenos',13.00,29.00,46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,3077,218,401,245,202,199,278,0,253,158,18,0,34,174,'silenos_clan',300,'Local','',0,20,91,7,50,1,9,0,-6,0.46,'true',1,0),
(626,20683,'Vanor Silenos Scout','','heltor_silenos',13.00,29.00,47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,4004,287,388,279,216,206,278,500,253,5,0,0,34,174,'silenos_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.46,'true',1,0),
(627,20684,'Vanor Silenos Warrior','','heltor_silenos_warrior',13.00,31.00,48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,4188,306,498,238,231,212,278,0,253,160,0,0,36,174,'silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.39,'true',1,0),
(628,20685,'Vanor Silenos Shaman','','heltor_silenos_shaman',13.00,32.00,49,'male','L2Monster','Priest',40,2168,5.500,799,2.100,40,43,30,21,20,10,3492,258,529,245,247,219,278,0,253,9,0,0,29,174,'silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.22,'true',1,0),
(629,20686,'Vanor Silenos Chieftain','','heltor_silenos_chieftain',13.00,31.50,50,'male','L2Monster','Fighter',40,2245,11.000,830,2.100,40,43,30,21,20,10,3637,274,463,306,264,226,278,0,253,75,0,0,27,174,'silenos_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(630,20738,'Kobold Looter Bepook','','kobold_bi',15.00,24.00,13,'male','L2Monster','Fighter',40,339,5.000,147,1.200,40,43,30,21,20,10,663,26,33,63,11,56,278,500,253,4,0,0,47,110,'partisan_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.54,'false',0,0),
(631,20739,'Bepook''s Pet','','wolf',13.00,9.00,10,'male','L2Minion','Fighter',40,257,1.000,120,0.900,40,43,30,21,20,10,439,14,27,50,8,49,278,0,253,0,0,0,24,110,'partisan_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,0.39,'true',0,0),
(632,20742,'Mystical Weaver','','magical_weaver',11.00,20.00,22,'male','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,684,32,62,113,28,83,278,0,253,0,0,0,90,90,'partisan_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',0,0),
(633,20743,'Howler','','werewolf',10.00,26.00,25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,843,42,80,127,37,94,278,500,253,0,0,0,50,120,'partisan_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',0,0),
(634,20744,'Red Eye Vampire Bat','','vampire_bat',10.00,33.50,22,'male','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,684,32,75,93,28,83,278,0,253,0,0,0,60,80,'partisan_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',0,0),
(635,20745,'Gigantiops','','ant_soldier',35.00,17.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,2681,159,174,186,89,137,278,500,253,0,0,0,80,174,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(636,20746,'Young Gigantiops','','ant',26.00,15.00,31,'male','L2Minion','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,2062,114,157,133,64,118,278,0,253,0,0,0,40,139,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(637,20747,'Roxide','','succubus',10.00,36.00,32,'female','L2Monster','Mystic',40,1056,9.000,397,1.800,40,43,30,21,20,10,1459,82,169,138,69,123,278,500,253,0,0,0,60,159,'demonic_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.84,'false',1,0),
(638,20748,'Roxide Cohort','','spartoi',11.00,27.00,29,'male','L2Minion','Fighter',40,906,7.000,349,1.500,40,43,30,21,20,10,1349,72,111,149,53,110,278,0,253,73,0,0,60,159,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',1,0),
(639,20749,'Death Fire','','dre_vanul',14.00,36.00,32,'male','L2Monster','Fighter',40,1056,9.000,397,1.800,40,43,30,21,20,10,1459,82,169,138,69,123,278,500,253,0,0,0,80,159,'demonic_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.35,'false',1,0),
(640,20750,'Fire Archer','','skeleton_archer',11.00,27.00,29,'male','L2Minion','Ranger',500,906,7.000,349,1.500,40,43,30,21,20,10,1397,75,247,149,53,110,249,0,227,14,0,0,40,159,'demonic_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'false',1,0),
(641,20751,'Snipe','','onyx_beast',14.00,14.50,44,'male','L2Monster','Fighter',40,1799,11.000,648,2.100,40,43,30,21,20,10,3387,232,390,209,176,187,278,500,253,0,0,0,30,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.24,'false',1,0),
(642,20752,'Snipe Cohort','','onyx_beast',14.00,14.50,42,'male','L2Minion','Fighter',40,1660,11.000,589,2.100,40,43,30,21,20,10,3290,219,283,237,152,175,278,0,253,0,0,0,30,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.24,'false',1,0),
(643,20753,'Dark Lord','','death_blader',15.00,45.00,50,'male','L2Monster','Fighter',40,2245,11.000,830,2.100,40,43,30,21,20,10,4282,322,463,306,264,226,278,500,253,1472,0,0,100,174,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.45,'false',1,0),
(644,20754,'Dark Knight','','death_knight',12.00,30.00,48,'male','L2Minion','Fighter',40,2091,11.000,768,2.100,40,43,30,21,20,10,4960,362,498,238,231,212,278,0,253,127,0,0,27,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(645,20755,'Talakin','','ol_mahum_champion',14.00,27.00,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1970,108,120,155,58,114,278,500,253,2,0,0,50,133,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.63,'true',1,0),
(646,20756,'Talakin Archer','','ol_mahum_archer',14.00,25.00,28,'male','L2Minion','Ranger',500,859,3.500,334,1.500,40,43,30,21,20,10,1884,99,228,143,49,106,249,0,227,14,0,0,50,133,'ol_mahum_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.93,'true',1,0),
(647,20757,'Talakin Raider','','ol_mahum',13.50,25.00,27,'male','L2Minion','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,1380,71,114,114,45,102,278,0,253,3,0,0,50,133,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(648,20758,'Dragon Bearer Chief','','spartoi',11.00,27.00,49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,5255,389,437,297,247,219,278,500,253,123,945,0,60,174,'cave_servant_clan',300,'Local','',0,20,97,7,30,4,4,0,-6,0.30,'true',1,0),
(649,20759,'Dragon Bearer Warrior','','skeleton',11.00,25.00,48,'male','L2Minion','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,4944,361,498,238,231,212,278,0,253,2,945,0,60,174,'cave_servant_clan',300,'Local','',0,20,95,7,30,4,4,0,-6,0.30,'true',1,0),
(650,20760,'Dragon Bearer Archer','','skeleton_archer',11.00,27.00,47,'male','L2Minion','Ranger',500,2016,5.500,738,2.100,40,43,30,21,20,10,5137,368,862,279,216,206,249,0,227,14,0,0,40,174,'cave_servant_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(651,20761,'Pytan','','bloody_queen',14.00,40.00,69,'female','L2Monster','Mystic',40,3784,22.500,1458,2.700,40,43,30,21,20,10,6633,649,1392,418,746,373,278,500,253,0,0,0,80,174,'malruk_clan',500,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(652,20762,'Pytan Knight','','death_blader',15.00,45.00,68,'male','L2Minion','Fighter',40,3706,15.000,1423,2.700,40,43,30,21,20,10,7021,678,1106,494,713,365,278,0,253,1472,0,0,100,174,'malruk_clan',500,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(653,20763,'Lord of the Plains','','zenta_lizardman_matriarch',20.00,40.00,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,3869,250,217,222,131,164,317,500,289,221,0,0,53,174,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.46,'true',1,0),
(654,20764,'Shaman of the Plains','','zenta_lizardman_shaman',13.00,35.00,39,'male','L2Minion','Priest',40,1462,4.500,514,1.800,40,43,30,21,20,10,3457,220,231,214,121,158,278,0,253,179,0,0,43,174,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.63,'true',1,0),
(655,20765,'Warrior of the Plains','','zenta_lizardman_warrior',13.00,35.00,38,'male','L2Minion','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,2992,187,261,171,112,153,278,0,253,16,0,0,40,174,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(656,20766,'Scout of the Plains','','zenta_lizardman_scout',11.00,30.00,36,'male','L2Minion','Ranger',500,1279,4.500,463,1.800,40,43,30,21,20,10,2659,161,417,193,96,142,249,0,227,14,0,0,37,174,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.93,'true',1,0),
(657,20767,'Timak Orc Troop Leader','','batur_orc_overlord',12.00,24.00,45,'male','L2Monster','TimakOrcTroopLeader',40,1870,5.500,677,2.100,40,43,30,21,20,10,4801,334,415,216,188,193,278,0,253,79,0,0,80,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'true',1,0),
(658,20768,'Timak Orc Troop Shaman','','batur_orc_shaman',11.00,16.00,44,'male','L2Monster','Priest',40,1799,5.500,648,2.100,40,43,30,21,20,10,4632,317,390,209,176,187,278,0,253,7,0,0,50,174,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.30,'true',0,0),
(659,20769,'Timak Orc Troop Warrior','','batur_orc_warrior',10.00,20.00,43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,3684,249,365,202,163,181,278,0,253,123,19,0,80,174,'orc_clan',300,'Local','',0,20,84,7,30,4,4,0,-6,0.30,'true',0,0),
(660,20770,'Timak Orc Troop Archer','','batur_orc_archer',11.00,21.50,41,'male','L2Monster','Ranger',500,1593,5.500,560,2.100,40,43,30,21,20,10,4319,283,713,189,141,169,249,0,227,13,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.96,'true',0,0),
(661,20771,'Barif','','lesser_giant_mage',21.00,44.00,64,'male','L2Monster','Mystic',40,3384,15.000,1285,2.700,40,43,30,21,20,10,6515,596,938,449,589,331,278,500,253,3938,0,0,15,180,'giant_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(662,20772,'Barif''s Pet','','leogul',15.00,35.00,61,'male','L2Minion','Fighter',40,3137,15.000,1184,2.700,40,43,30,21,20,10,6332,557,992,344,505,307,278,0,253,0,0,0,80,170,'giant_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,0.72,'false',1,0),
(663,20773,'Conjurer Bat Lord','','vampire_bat',10.00,33.50,72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,10535,1070,1284,540,849,399,278,500,253,0,0,0,60,174,'giant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(664,20774,'Conjurer Bat','','vampire_bat',10.00,33.50,70,'male','L2Minion','Mystic',40,3862,7.500,1493,2.700,40,43,30,21,20,10,11140,1105,1194,517,780,382,278,0,253,0,0,0,60,174,'giant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(665,20775,'Bugbear Raider','','bugbear',17.00,35.00,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,599,25,48,75,17,67,278,0,253,0,0,0,55,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.28,'true',1,0),
(666,20776,'Dark Succubus','','succubus',10.00,36.00,20,'female','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,783,35,57,94,23,76,278,0,253,0,0,0,60,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(667,20777,'Hunter Bear','','grizzly',21.00,40.00,14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,498,19,37,66,12,59,278,0,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(668,20778,'Ragna Orc Overlord','','orc_champion',10.00,23.00,39,'male','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,2477,157,231,214,121,158,278,0,253,2,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.76,'true',1,0),
(669,20779,'Ragna Orc Seer','','orc_shaman',9.00,22.00,39,'male','L2Monster','Priest',40,1462,4.500,514,1.800,40,43,30,21,20,10,2212,141,231,214,121,158,278,0,253,7,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.26,'true',1,0),
(670,20780,'Bloody Axe Elite','','ol_mahum_champion',14.00,27.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1799,106,174,186,89,137,278,500,253,2,0,0,50,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.63,'true',1,0),
(671,20781,'Delu Lizardman Shaman','','virud_lizardman_shaman',10.00,29.00,35,'male','L2Monster','Priest',40,1220,4.500,446,1.800,40,43,30,21,20,10,1781,105,211,154,89,137,278,0,253,7,0,0,43,174,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'true',1,0),
(672,20782,'Ol Mahum Novice','','ol_mahum',13.50,25.00,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,44,83,17,67,278,500,253,1,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(673,20783,'Dread Wolf','','dire_wolf',13.00,11.00,35,'male','L2Monster','Fighter',40,1220,2.250,446,1.800,40,43,30,21,20,10,1635,96,256,127,89,137,278,500,253,0,0,0,24,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(674,20784,'Tasaba Lizardman','','virud_lizardman_scout',10.00,22.00,36,'male','L2Monster','Ranger',500,1279,2.250,463,1.800,40,43,30,21,20,10,1852,112,505,159,96,142,249,0,227,2507,0,0,43,140,'lizardman_clan1',300,'Magister','',0,0,0,7,10,8,0,1500,0,0.72,'true',1,0),
(675,20785,'Tasaba Lizardman Shaman','','virud_lizardman_shaman',10.00,29.00,37,'male','L2Monster','Priest',40,1338,2.250,480,1.800,40,43,30,21,20,10,1791,110,244,140,104,147,278,0,253,7,0,0,43,140,'lizardman_clan1',300,'Magister','',0,0,0,7,50,1,9,0,10,0.48,'true',1,0),
(676,20786,'Lienrik','','lienrik',12.00,50.00,39,'male','L2Monster','Fighter',40,1462,2.250,514,1.800,40,43,30,21,20,10,1990,126,297,146,121,158,317,0,289,0,0,0,100,150,'lienrik_clan',300,'Magister','',0,0,0,7,10,8,0,0,0,0.46,'true',1,0),
(677,20787,'Lienrik Lad','','lienrik',12.00,50.00,40,'male','L2Monster','Fighter',40,1527,2.250,531,1.800,40,43,30,21,20,10,2421,156,317,151,131,164,317,500,289,0,0,0,100,174,'lienrik_clan',300,'Magister','',0,0,0,7,10,8,0,0,0,0.46,'true',1,0),
(678,20788,'Rakul','','rakul',30.00,39.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,2120,125,192,169,89,137,278,0,253,3,0,0,60,174,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.59,'true',1,0),
(679,20789,'Crokian','','crokian',18.00,29.00,36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,1999,121,187,193,96,142,278,500,253,5128,0,0,18,174,'croc_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.78,'true',1,0),
(680,20790,'Dailaon','','dailaon',20.00,28.00,37,'male','L2Monster','Fighter',500,1338,4.500,480,1.800,40,43,30,21,20,10,2567,158,448,200,104,147,249,0,227,5127,0,0,18,174,'croc_clan',300,'Magister','',0,0,0,7,10,8,0,1500,0,0.91,'true',1,0),
(681,20791,'Crokian Warrior','','crokian',18.00,29.00,38,'male','L2Monster','Fighter',40,1400,9.000,497,1.800,40,43,30,21,20,10,2211,138,261,171,112,153,278,500,253,5128,0,0,18,174,'croc_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.78,'false',1,0),
(682,20792,'Farhite','','farhite',16.00,31.00,39,'male','L2Monster','Fighter',40,1462,9.000,514,1.800,40,43,30,21,20,10,2057,131,280,150,121,158,278,0,253,5131,0,0,15,174,'croc_clan',300,'Magister','',0,0,0,7,50,1,9,0,10,0.74,'false',1,0),
(683,20793,'Nos','','nos',26.00,42.00,40,'male','L2Monster','Fighter',40,1527,9.000,531,1.800,40,43,30,21,20,10,2251,145,300,183,131,164,278,500,253,5130,0,0,18,174,'croc_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.78,'false',1,0),
(684,20794,'Blade Stakato','','blade_stakato',15.00,36.00,41,'male','L2Monster','Fighter',40,1593,11.000,560,2.100,40,43,30,21,20,10,2103,137,265,229,141,169,278,0,253,223,0,0,25,174,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(685,20795,'Blade Stakato Worker','','blade_stakato_worker',13.00,40.00,42,'male','L2Monster','Fighter',40,1660,11.000,589,2.100,40,43,30,21,20,10,1988,132,272,215,152,175,317,0,289,226,0,0,25,174,'stakato_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.76,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(686,20796,'Blade Stakato Warrior','','blade_stakato_soldier',15.00,38.00,43,'male','L2Monster','Fighter',40,1728,11.000,618,2.100,40,43,30,21,20,10,2125,143,365,202,163,181,278,500,253,232,0,0,25,174,'stakato_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.74,'false',1,0),
(687,20797,'Blade Stakato Drone','','blade_stakato_drone',15.00,39.00,44,'male','L2Monster','Fighter',40,1799,16.500,648,2.100,40,43,30,21,20,10,2154,147,390,178,176,187,278,0,253,74,0,0,25,174,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.58,'false',1,0),
(688,20798,'Water Giant','','water_giant',13.00,44.00,45,'male','L2Monster','Fighter',40,1870,11.000,677,2.100,40,43,30,21,20,10,2612,181,343,262,188,193,278,500,253,5132,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(689,20799,'Queen Undine Lad','','undine',12.00,27.00,46,'female','L2Monster','Mystic',40,1943,11.000,707,2.100,40,43,30,21,20,10,2630,186,442,190,202,199,278,0,253,0,0,0,60,174,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.35,'false',1,0),
(690,20800,'Eva''s Seeker','','field_stalker',15.00,30.00,47,'male','L2Monster','Fighter',40,2016,11.000,738,2.100,40,43,30,21,20,10,2465,176,388,279,216,206,278,0,253,0,0,0,70,174,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.41,'false',1,0),
(691,20801,'Theeder Piker','','theeder',9.00,32.00,48,'male','L2Monster','Fighter',80,2091,11.000,768,2.100,40,43,30,21,20,10,2972,217,481,288,231,212,237,500,216,302,0,0,80,174,'theeder_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(692,20802,'Theeder Mage','','theeder',9.00,32.00,49,'male','L2Monster','Mystic',40,2168,11.000,799,2.100,40,43,30,21,20,10,3025,223,529,208,247,219,278,0,253,192,0,0,80,174,'theeder_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.45,'false',1,0),
(693,20803,'Doll Master','','doll_master',20.00,42.00,50,'male','L2Monster','Fighter',40,2245,16.500,830,2.100,40,43,30,21,20,10,3949,297,616,230,264,226,278,500,253,0,0,0,80,174,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(694,20804,'Crokian Lad','','crokian_100_bi',36.00,61.00,41,'male','L2Monster','Fighter',40,1593,11.000,560,2.100,40,43,30,21,20,10,2574,168,291,208,141,169,278,500,253,5128,0,0,18,174,'croc_clan2',300,'Magister','',0,0,0,7,30,4,4,0,0,0.78,'false',1,0),
(695,20805,'Dailaon Lad','','dailaon_100_bi',40.00,58.00,42,'male','L2Monster','Fighter',500,1660,11.000,589,2.100,40,43,30,21,20,10,2790,186,762,196,152,175,249,0,227,5127,0,0,18,174,'croc_clan2',300,'Magister','',0,0,0,7,10,8,0,1500,0,0.91,'false',1,0),
(696,20806,'Crokian Lad Warrior','','crokian_100_bi',36.00,61.00,43,'male','L2Monster','Fighter',40,1728,11.000,618,2.100,40,43,30,21,20,10,2678,181,365,202,163,181,278,500,253,5128,0,0,18,174,'croc_clan2',300,'Magister','',0,0,0,7,30,4,4,0,0,0.78,'false',1,0),
(697,20807,'Farhite Lad','','farhite_50_bi',24.00,48.00,44,'male','L2Monster','Fighter',40,1799,11.000,648,2.100,40,43,30,21,20,10,2817,193,390,178,176,187,278,0,253,5131,0,0,15,174,'croc_clan2',300,'Magister','',0,0,0,7,50,1,9,0,10,0.74,'false',1,0),
(698,20808,'Nos Lad','','nos_100_bi',52.00,86.00,45,'male','L2Monster','Fighter',40,1870,11.000,677,2.100,40,43,30,21,20,10,3487,242,343,262,188,193,278,500,253,128,0,0,18,174,'croc_clan2',300,'Magister','',0,0,0,7,30,4,4,0,0,0.78,'false',1,0),
(699,20809,'Ghost of the Tower','','human_ghost',8.00,22.00,60,'male','L2Monster','Mystic',40,3054,19.500,1150,2.400,40,43,30,21,20,10,4045,351,860,368,478,299,278,500,253,0,0,0,80,143,'tower_ghost_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.39,'false',1,0),
(700,20810,'Seer of Hallate','','field_stalker',15.00,30.00,60,'male','L2Monster','Fighter',40,3054,19.500,1150,2.400,40,43,30,21,20,10,4045,351,946,335,478,299,278,500,253,0,0,0,70,170,'hallate_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.41,'false',1,0),
(701,20811,'Ghastly Warrior','','unpleasant_humming',12.00,26.00,61,'male','L2Monster','Fighter',40,3137,22.500,1184,2.700,40,43,30,21,20,10,4769,419,717,416,505,307,317,500,289,0,0,0,21,150,'tower_ghost_clan',400,'Magister','',0,0,0,7,10,8,0,0,0,0.59,'false',1,0),
(702,20812,'Archer of Despair','','skeleton_archer',11.00,27.00,61,'male','L2Monster','Ranger',500,3137,22.500,1184,2.700,40,43,30,21,20,10,4708,414,2204,292,505,307,249,500,227,284,0,0,40,160,'tower_ghost_clan',400,'Magister','',0,0,0,7,10,8,0,1500,10,0.80,'false',1,0),
(703,20813,'Crendion','','liviona',15.00,28.00,62,'male','L2Monster','Fighter',40,3219,22.500,1217,2.700,40,43,30,21,20,10,4276,381,944,388,532,315,278,500,253,0,0,0,80,160,'tower_ghost_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(704,20814,'Blader of Despair','','spartoi',11.00,27.00,62,'male','L2Monster','Fighter',80,3219,22.500,1217,2.700,40,43,30,21,20,10,4938,440,1212,353,532,315,237,500,216,79,0,0,60,143,'tower_ghost_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,0.30,'false',1,0),
(705,20815,'Hound Dog of Hallate','','dire_wolf',13.00,11.00,63,'male','L2Monster','Fighter',40,3302,30.000,1251,2.700,40,43,30,21,20,10,4583,413,897,438,560,323,278,500,253,0,0,0,24,165,'hallate_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.39,'false',1,0),
(706,20816,'Hallate''s Royal Guard','','skeleton_royal_guard',11.00,28.50,63,'male','L2Monster','Fighter',40,3302,22.500,1251,2.700,40,43,30,21,20,10,5098,460,785,438,560,323,317,500,289,946,945,0,80,164,'hallate_clan',400,'Magister',NULL,0,20,131,7,10,8,0,0,-6,0.52,'false',1,0),
(707,20817,'Corrupt Sage','','vale_master',12.00,40.00,64,'male','L2Monster','Mystic',40,3384,22.500,1285,2.700,40,43,30,21,20,10,5315,486,1135,315,589,331,278,500,253,210,0,0,70,160,'tower_ghost_clan',400,'Magister','',0,0,0,7,50,1,9,0,10,0.74,'false',1,0),
(708,20818,'Hallate''s Warrior','','skeleton_knight',10.00,25.00,64,'male','L2Monster','Fighter',40,3384,22.500,1285,2.700,40,43,30,21,20,10,4926,451,1135,371,589,331,278,500,253,78,0,0,40,160,'hallate_clan',400,'Magister',NULL,0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(709,20819,'Archer of Abyss','','fiend_archer',17.00,55.00,65,'male','L2Monster','Ranger',500,3465,22.500,1319,2.700,40,43,30,21,20,10,4889,454,2632,380,619,340,249,500,227,0,0,0,70,165,'tower_ghost_clan',400,'Magister','',0,0,0,7,10,8,0,1500,0,0.76,'false',1,0),
(710,20820,'Hallate''s Knight','','death_knight',12.00,30.00,65,'male','L2Monster','Fighter',40,3465,30.000,1319,2.700,40,43,30,21,20,10,7310,679,979,460,619,340,278,500,253,80,0,0,27,160,'hallate_clan',400,'Magister',NULL,0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(711,20821,'Erin Ediunce','','banshee',9.00,23.00,66,'female','L2Monster','Mystic',40,3546,30.000,1353,2.700,40,43,30,21,20,10,5335,502,1020,401,649,348,278,500,253,3939,0,0,80,165,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(712,20822,'Hallate''s Maid','','bloody_queen',14.00,40.00,66,'female','L2Monster','Mystic',40,3546,30.000,1353,2.700,40,43,30,21,20,10,4964,467,893,471,649,348,317,500,289,0,0,0,80,160,'hallate_clan',400,'Magister',NULL,0,0,0,7,10,8,0,0,0,0.50,'false',1,0),
(713,20823,'Platinum Tribe Soldier','','kel_mahum',13.00,26.00,67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,5764,549,1126,399,681,356,317,500,289,242,0,0,50,160,'tower_guard_clan',400,'Magister','',0,0,0,7,10,8,0,0,0,0.52,'false',1,0),
(714,20824,'Hallate''s Commander','','death_blader',15.00,45.00,67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,5184,493,1286,399,681,356,278,500,253,1472,0,0,100,170,'hallate_clan',400,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.45,'false',1,0),
(715,20825,'Hallate''s Inspector','','karik_25_bi',31.00,110.00,68,'male','L2Monster','Fighter',40,3706,30.000,1423,2.700,40,43,30,21,20,10,5414,523,1339,408,713,365,278,500,253,0,0,0,37,170,'hallate_clan',400,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.45,'false',1,0),
(716,20826,'Platinum Tribe Archer','','kel_mahum_archer',13.00,27.00,68,'male','L2Monster','Ranger',500,3706,22.500,1423,2.700,40,43,30,21,20,10,7650,739,2975,347,713,365,249,500,227,288,0,0,50,160,'tower_guard_clan',400,'Magister','',0,0,0,7,10,8,0,1500,10,0.91,'false',1,0),
(717,20827,'Platinum Tribe Warrior','','kel_mahum_warrior',13.00,28.00,69,'male','L2Monster','Fighter',40,3784,30.000,1458,2.700,40,43,30,21,20,10,5991,586,1150,506,746,373,278,500,253,148,0,0,50,160,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(718,20828,'Platinum Tribe Shaman','','kel_mahum_witch_doctor',13.00,25.00,70,'male','L2Minion','Priest',40,3862,37.500,1493,2.700,40,43,30,21,20,10,5881,583,1445,427,780,382,278,500,253,202,0,0,50,160,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.28,'false',1,0),
(719,20829,'Platinum Tribe Overlord','','kel_mahum_champion',13.00,32.00,71,'male','L2Monster','Fighter',40,3938,42.500,1529,3.000,40,43,30,21,20,10,8449,847,1239,529,814,390,278,500,253,147,0,0,50,170,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(720,20830,'Guardian Angel','','angel',13.50,36.50,72,'male','L2Minion','PolimorphingAngel',40,4013,34.000,1565,3.000,40,43,30,21,20,10,0,0,1710,406,849,399,278,500,253,148,0,0,30,170,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(721,20831,'Seal Angel','','angel',13.50,36.50,73,'male','L2Minion','PolimorphingAngel',40,4086,42.500,1601,3.000,40,43,30,21,20,10,0,0,1770,415,885,407,278,500,253,148,0,0,30,170,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(722,20832,'Zaken''s Pikeman','','skeleton_pikeman',10.00,28.00,43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,2720,184,249,252,163,181,278,500,253,292,0,0,50,174,'undead_clan1',300,'Local',NULL,0,0,0,7,30,4,4,0,10,0.21,'true',1,0),
(723,20833,'Zaken''s Archer','','skeleton_archer',11.00,27.00,44,'male','L2Monster','Ranger',500,1799,5.500,648,2.100,40,43,30,21,20,10,3025,207,592,260,176,187,249,0,227,279,0,0,40,174,'undead_clan1',300,'Local',NULL,0,0,0,7,10,8,0,1500,10,0.80,'true',1,0),
(724,20834,'Mardian','','giant_spider',26.00,26.50,42,'male','L2Monster','Mystic',40,1660,11.000,589,2.100,40,43,30,21,20,10,2251,150,342,196,152,175,278,500,253,0,0,0,72,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'false',0,0),
(725,20835,'Zaken''s Seer','','liviona',15.00,28.00,45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,2478,172,283,269,188,193,278,500,253,0,0,0,80,174,NULL,0,'Local',NULL,0,0,0,7,50,1,9,0,10,0.34,'true',1,0),
(726,20836,'Pirate Zombie','','pirates_zombie',10.00,23.00,44,'male','L2Monster','Mystic',40,1799,11.000,648,2.100,40,43,30,21,20,10,2832,194,341,209,176,187,317,0,289,225,0,0,11,174,'undead_clan1',300,'Local','',0,0,0,7,10,8,0,0,0,0.74,'false',1,0),
(727,20837,'Tainted Ogre','','ogre',21.00,44.00,45,'male','L2Monster','Fighter',40,1870,11.000,677,2.100,40,43,30,21,20,10,2565,178,577,216,188,193,200,500,182,194,0,0,22,174,'undead_clan1',300,'Local','',0,0,0,7,50,1,9,0,0,0.69,'false',0,0),
(728,20838,'Bloody Bat','','vampire_bat',10.00,33.50,45,'male','L2Monster','Mystic',40,1870,11.000,677,2.100,40,43,30,21,20,10,2405,167,300,262,188,193,317,0,289,0,0,0,60,174,'',0,'Local','',0,0,0,7,10,8,0,0,0,0.50,'false',0,0),
(729,20839,'Unpleasant Humming','','unpleasant_humming',12.00,26.00,46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,2877,204,301,327,202,199,278,500,253,0,0,0,21,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.59,'true',1,0),
(730,20840,'Death Flyer','','dark_horror',20.00,35.00,47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,2971,213,320,287,216,206,278,0,253,0,0,0,100,174,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.37,'true',1,0),
(731,20841,'Fiend Archer','','fiend_archer',17.00,55.00,48,'male','L2Monster','Ranger',500,2091,5.500,768,2.100,40,43,30,21,20,10,3052,223,757,296,231,212,249,500,227,0,0,0,70,174,'demonic_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.76,'true',1,0),
(732,20842,'Musveren','','field_stalker',15.00,30.00,49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,2910,215,361,359,247,219,278,0,253,0,0,0,70,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(733,20843,'Zaken''s Royal Guard','','skeleton_royal_guard',11.00,28.50,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3677,277,335,370,264,226,317,500,289,225,945,0,80,174,'undead_clan',300,'Local',NULL,0,20,100,7,10,8,0,0,-6,0.52,'true',1,0),
(734,20844,'Kaim Vanul','','kaim_vanul',24.00,40.00,51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,3279,250,405,381,281,232,278,0,253,0,0,0,37,174,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(735,20845,'Pirate''s Zombie Captain','','pirates_zombie_captain',17.00,28.00,52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,4954,383,375,393,300,239,317,500,289,232,0,0,14,174,'zaken_clan',300,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76,'true',1,0),
(736,20846,'Doll Blader','','doll_blader',6.00,12.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,3931,309,396,344,319,247,317,0,289,5129,5129,0,22,174,'zaken_clan',300,'Local','',0,0,93,7,10,8,0,0,10,0.50,'true',1,0),
(737,20847,'Vale Master','','vale_master',12.00,40.00,54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,3750,299,477,354,339,254,278,500,253,0,0,0,70,174,'zaken_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.74,'true',1,0),
(738,20848,'Light Bringer','','light_bringer',10.00,23.00,46,'male','L2Monster','Fighter',40,1943,11.000,707,2.100,40,43,30,21,20,10,2432,172,401,245,202,199,278,500,253,0,0,0,60,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'false',1,0),
(739,20849,'Light Worm','','light_worm',5.00,16.00,41,'male','L2Monster','Fighter',40,1593,11.000,560,2.100,40,43,30,21,20,10,1932,126,265,229,141,169,278,500,253,0,0,0,60,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.06,'false',1,0),
(740,20850,'Golden Stag Lord','','golden_stag_lord',25.00,30.00,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3152,237,509,278,264,226,278,0,253,0,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.63,'true',0,0),
(741,20851,'Theeder','','theeder',9.00,32.00,47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,2841,204,498,253,216,206,237,500,216,0,0,0,80,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.45,'true',0,0),
(742,20852,'Banshee','','banshee',9.00,23.00,60,'female','L2Monster','Mystic',40,3054,6.500,1150,2.400,40,43,30,21,20,10,4450,386,828,335,478,299,317,500,289,3939,0,0,80,174,'',0,'Local','',0,0,0,7,10,8,0,0,0,0.56,'true',0,0),
(743,20853,'Kel Mahum','','kel_mahum',13.00,26.00,65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7824,727,942,418,619,340,317,500,289,242,0,0,50,174,'kel_mahum_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.52,'true',0,0),
(744,20854,'Kel Mahum Warrior','','kel_mahum_warrior',13.00,28.00,66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,7686,723,1235,389,649,348,278,500,253,148,0,0,50,174,'kel_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',0,0),
(745,20855,'Kel Mahum Archer','','kel_mahum_archer',13.00,27.00,67,'male','L2Monster','Ranger',500,3626,7.500,1388,2.700,40,43,30,21,20,10,8900,848,2859,339,681,356,249,0,227,288,0,0,50,174,'kel_mahum_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.91,'true',0,0),
(746,20856,'Kel Mahum Shaman','','kel_mahum_witch_doctor',13.00,25.00,68,'male','L2Monster','Priest',40,3706,7.500,1423,2.700,40,43,30,21,20,10,6390,617,1339,347,713,365,278,500,253,202,0,0,50,174,'kel_mahum_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.28,'true',0,0),
(747,20857,'Kel Mahum Champion','','kel_mahum_champion',13.00,32.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,8149,808,1445,427,780,382,278,500,253,147,0,0,50,174,'kel_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',0,0),
(748,20858,'Angel','','angel',13.50,36.50,72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,9102,925,1554,446,849,399,278,500,253,148,0,0,30,174,'tower_guard_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',0,0),
(749,20859,'Guardian Angel','','angel',13.50,36.50,72,'male','L2Monster','Fighter',40,4013,34.000,1565,3.000,40,43,30,21,20,10,12443,1264,1554,446,849,399,278,500,253,148,0,0,30,170,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(750,20860,'Seal Angel','','angel',13.50,36.50,73,'male','L2Monster','Fighter',40,4086,42.500,1601,3.000,40,43,30,21,20,10,13949,1435,1330,552,885,407,278,500,253,148,0,0,30,170,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(751,20861,'Oel Mahum Champion','','oel_mahum_champion',23.00,61.00,56,'male','L2Monster','Fighter',40,2724,6.500,1019,2.400,40,43,30,21,20,10,5533,454,777,301,382,269,278,500,253,127,0,0,67,174,'oel_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(752,20862,'Death Lord','','death_lord',21.00,40.00,75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,7774,820,1720,475,957,425,278,0,253,78,0,0,40,174,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',0,0),
(753,20919,'Maille Lizardman','','virud_lizardman',10.00,23.00,20,'male','L2Monster','Fighter',40,541,1.250,213,1.200,40,43,30,21,20,10,641,28,57,94,23,76,278,0,253,291,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'true',1,0),
(754,20920,'Maille Lizardman Scout','','virud_lizardman_scout',10.00,22.00,22,'male','L2Monster','Ranger',500,611,1.750,242,1.500,40,43,30,21,20,10,1187,56,153,102,28,83,249,0,227,2507,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.72,'true',1,0),
(755,20921,'Maille Lizardman Guard','','virud_lizardman',10.00,23.00,24,'male','L2Monster','Fighter',40,687,1.750,272,1.500,40,43,30,21,20,10,858,42,81,111,34,90,278,500,253,291,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'true',1,0),
(756,20922,'Maille Lizardman Warrior','','virud_lizardman_warrior',12.00,30.00,26,'male','L2Monster','Fighter',40,770,1.750,303,1.500,40,43,30,21,20,10,951,48,96,120,41,98,278,0,253,16,0,0,52,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.59,'true',1,0),
(757,20923,'Maille Lizardman Shaman','','virud_lizardman_shaman',10.00,29.00,28,'male','L2Monster','Priest',40,859,1.750,334,1.500,40,43,30,21,20,10,1392,74,113,130,49,106,278,0,253,7,0,0,43,120,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'true',1,0),
(758,20924,'Maille Lizardman Matriarch','','virud_lizardman_matriarch',13.00,37.00,30,'male','L2Monster','Fighter',40,954,1.750,365,1.500,40,43,30,21,20,10,1708,94,132,140,58,114,278,500,253,69,627,0,56,130,'lizardman_clan',300,'Local','',0,20,59,7,50,1,9,0,-6,0.65,'true',1,0),
(759,20925,'Giant Araneid','','giant_spider',26.00,26.50,24,'male','L2Monster','Mystic',40,687,1.750,272,1.500,40,43,30,21,20,10,875,44,81,94,34,90,278,0,253,0,0,0,72,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.26,'true',1,0),
(760,20926,'Poison Araneid','','poison_spider',27.00,25.50,25,'male','L2Monster','Mystic',40,728,1.750,287,1.500,40,43,30,21,20,10,1012,50,88,98,37,94,278,0,253,0,0,0,60,140,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.65,'true',1,0),
(761,20927,'King of the Araneid','','giant_spider_50_bi',39.00,38.00,27,'male','L2Monster','Mystic',40,813,1.750,318,1.500,40,43,30,21,20,10,1453,74,104,106,45,102,278,500,253,0,0,0,72,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.26,'true',1,0),
(762,20928,'Hatu Weird Bee','','giant_bee',8.00,24.50,30,'male','L2Monster','Fighter',40,954,1.750,365,1.500,40,43,30,21,20,10,1468,80,132,140,58,114,278,500,253,0,0,0,90,120,'hatu_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.50,'true',1,0),
(763,20929,'Hatu Dire Wolf','','dire_wolf',13.00,11.00,32,'male','L2Monster','Fighter',40,1056,2.250,397,1.800,40,43,30,21,20,10,1393,78,154,151,69,123,278,0,253,0,0,0,24,110,'hatu_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.39,'true',1,0),
(764,20930,'Hatu Brown Bear','','grizzly',21.00,40.00,34,'male','L2Monster','Fighter',40,1164,2.250,430,1.800,40,43,30,21,20,10,2195,128,178,163,82,132,278,500,253,0,0,0,40,143,'hatu_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.34,'true',1,0),
(765,20931,'Hatu Onyx Beast','','onyx_beast',14.00,14.50,36,'male','L2Monster','Fighter',40,1279,2.250,463,1.800,40,43,30,21,20,10,2035,124,206,175,96,142,278,0,253,0,0,0,30,174,'hatu_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.24,'true',1,0),
(766,20932,'Hatu Crimson Bear','','crimson_bear',19.00,36.00,38,'male','L2Monster','Fighter',40,1400,2.250,497,1.800,40,43,30,21,20,10,2688,168,238,188,112,153,278,0,253,0,0,0,37,174,'hatu_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.45,'true',1,0),
(767,20933,'Hatu Windsus','','giant_wild_hog',25.00,27.00,40,'male','L2Monster','Fighter',40,1527,2.250,531,1.800,40,43,30,21,20,10,3080,198,273,201,131,164,278,500,253,0,0,0,35,174,'hatu_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.54,'true',1,0),
(768,20934,'Wasp Worker','','giant_bee_bi',8.00,32.00,35,'male','L2Minion','Fighter',40,1220,2.250,446,1.800,40,43,30,21,20,10,1651,98,192,144,89,137,278,0,253,0,0,0,90,174,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.50,'true',1,0),
(769,20935,'Wasp Leader','','giant_bee_100_bi',16.00,49.00,37,'male','L2Monster','Fighter',40,1338,2.250,480,1.800,40,43,30,21,20,10,1809,112,222,154,104,147,278,500,253,0,0,0,90,174,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.50,'true',1,0),
(770,20936,'Tanor Silenos','','heltor_silenos',13.00,29.00,40,'male','L2Monster','Fighter',40,1527,2.250,531,1.800,40,43,30,21,20,10,3443,222,273,201,131,164,278,0,253,88,0,0,34,174,'silenos_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,0,0.46,'true',0,0),
(771,20937,'Tanor Silenos Grunt','','heltor_silenos',13.00,29.00,42,'male','L2Minion','Fighter',40,1660,2.750,589,2.100,40,43,30,21,20,10,4498,300,311,215,152,175,278,0,253,158,18,0,34,174,'silenos_clan',300,'Local','',0,20,82,7,50,1,9,0,-6,0.46,'true',0,0),
(772,20938,'Tanor Silenos Scout','','heltor_silenos',13.00,29.00,44,'male','L2Minion','Ranger',40,1799,2.750,648,2.100,40,43,30,21,20,10,4937,338,354,230,176,187,278,0,253,5,0,0,34,174,'silenos_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,0,0.46,'false',0,0),
(773,20939,'Tanor Silenos Warrior','','heltor_silenos_warrior',13.00,31.00,46,'male','L2Minion','Fighter',40,1943,2.750,707,2.100,40,43,30,21,20,10,5504,390,401,245,202,199,278,500,253,160,0,0,36,174,'silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.39,'true',1,0),
(774,20940,'Tanor Silenos Shaman','','heltor_silenos_shaman',13.00,32.00,48,'male','L2Minion','Priest',40,2091,2.750,768,2.100,40,43,30,21,20,10,6707,490,453,261,231,212,278,0,253,9,0,0,29,174,'silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.22,'true',1,0),
(775,20941,'Tanor Silenos Chieftain','','heltor_silenos_chieftain',13.00,31.50,50,'male','L2Monster','Fighter',40,2245,2.750,830,2.100,40,43,30,21,20,10,6503,490,509,278,264,226,278,500,253,75,0,0,27,174,'silenos_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,0,0.39,'true',1,0),
(776,20942,'Nightmare Guide','','harpy',10.00,42.00,43,'female','L2Minion','Fighter',40,1728,2.750,618,2.100,40,43,30,21,20,10,3282,222,332,189,163,181,278,0,253,0,0,0,60,174,'',0,'DRIVER','',0,0,0,7,50,1,9,0,10,0.65,'true',1,0),
(777,20943,'Nightmare Keeper','','harpy',10.00,42.00,45,'female','L2Minion','Fighter',40,1870,2.750,677,2.100,40,43,30,21,20,10,4721,328,377,202,188,193,278,0,253,0,0,0,60,174,'',0,'DRIVER','',0,0,0,7,50,1,9,0,10,0.65,'true',1,0),
(778,20944,'Nightmare Lord','','succubus_100_bi',20.00,75.00,47,'female','L2Monster','Fighter',40,2016,2.750,738,2.100,40,43,30,21,20,10,4000,286,427,215,216,206,278,500,253,0,0,0,60,174,'',0,'DRIVER','',0,0,0,7,50,1,9,0,10,0.84,'true',1,0),
(779,20945,'Cadeine','','hobgoblin',12.00,24.00,50,'male','L2Monster','Fighter',40,2245,2.750,830,2.100,40,43,30,21,20,10,4483,338,509,278,264,226,278,0,253,127,625,0,45,174,'green_clan',300,'Local','',0,20,100,7,50,1,9,0,-6,0.41,'true',0,0),
(780,20946,'Sanhidro','','troll',21.00,35.00,52,'male','L2Monster','Fighter',40,2402,3.250,892,2.400,40,43,30,21,20,10,6896,534,570,295,300,239,278,0,253,0,0,0,55,174,'green_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.61,'true',0,0),
(781,20947,'Connabi','','bugbear',17.00,35.00,54,'male','L2Monster','Fighter',40,2562,3.250,955,2.400,40,43,30,21,20,10,7437,592,636,313,339,254,278,0,253,88,0,0,55,174,'green_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(782,20948,'Bartal','','liviona',15.00,28.00,56,'male','L2Minion','Fighter',40,2724,3.250,1019,2.400,40,43,30,21,20,10,7385,606,706,331,382,269,278,0,253,0,0,0,80,174,'green_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.34,'true',1,0),
(783,20949,'Luminun','','twin_headed_giant',17.00,39.00,58,'male','L2Minion','Fighter',40,2889,3.250,1084,2.400,40,43,30,21,20,10,8700,734,781,349,428,284,278,0,253,157,0,0,45,174,'green_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.46,'true',1,0),
(784,20950,'Innersen','','king_bugbear',15.00,40.00,60,'male','L2Monster','Fighter',40,3054,3.250,1150,2.400,40,43,30,21,20,10,9365,812,860,368,478,299,278,500,253,160,0,0,55,174,'green_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(785,20951,'Pobby''s Maid','','manadragora',14.00,17.80,53,'female','L2Minion','Fighter',40,2481,3.250,923,2.400,40,43,30,21,20,10,5037,396,602,258,319,247,278,0,253,0,0,0,80,174,'green_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,10,0.28,'true',1,0),
(786,20952,'Pobby Escort','','mandragora_b',12.00,25.50,55,'female','L2Minion','Fighter',40,2643,3.250,987,2.400,40,43,30,21,20,10,9101,734,670,273,360,261,278,0,253,0,0,0,80,174,'green_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.13,'true',1,0),
(787,20953,'Pobby','','mandragora_a',15.00,26.00,57,'female','L2Monster','Fighter',40,2806,3.250,1052,2.400,40,43,30,21,20,10,8452,702,743,289,405,276,278,500,253,0,0,0,80,174,'green_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.20,'true',1,0),
(788,20954,'Hungered Corpse','','skeleton',11.00,25.00,60,'male','L2Minion','Fighter',40,3054,3.250,1150,2.400,40,43,30,21,20,10,9985,866,860,368,478,299,278,0,253,123,945,0,60,180,'bloody_clan',300,'Local','',0,20,123,7,50,1,9,0,-6,0.30,'false',1,0),
(789,20955,'Ghostly Warrior','','skeleton_pikeman',10.00,28.00,62,'male','L2Minion','Fighter',40,3219,3.750,1217,2.700,40,43,30,21,20,10,10662,950,944,388,532,315,278,0,253,299,0,0,50,180,'bloody_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.21,'false',1,0),
(790,20956,'Past Knight','','skeleton_knight',10.00,25.00,64,'male','L2Monster','Fighter',40,3384,3.750,1285,2.700,40,43,30,21,20,10,11588,1060,1031,408,589,331,278,500,253,150,103,0,40,174,'bloody_clan',300,'Local','',0,20,133,7,50,1,9,0,-6,0.17,'false',1,0),
(791,20957,'Nihil Invader','','skeleton_royal_guard',11.00,28.50,66,'male','L2Minion','Fighter',40,3546,3.750,1353,2.700,40,43,30,21,20,10,12082,1138,1123,428,649,348,278,0,253,946,945,0,80,185,'bloody_clan',300,'Local','',0,20,138,7,50,1,9,0,-6,0.52,'false',1,0),
(792,20958,'Death Agent','','death_blader',15.00,45.00,68,'male','L2Minion','Fighter',40,3706,3.750,1423,2.700,40,43,30,21,20,10,9018,872,1217,449,713,365,278,0,253,1472,0,0,100,195,'bloody_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.45,'false',1,0),
(793,20959,'Dark Guard','','headless_knight',21.00,31.00,70,'male','L2Monster','Fighter',40,3862,3.750,1493,2.700,40,43,30,21,20,10,13863,1374,1314,470,780,382,278,500,253,124,0,0,70,170,'bloody_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(794,20960,'Bloody Ghost','','succubus',10.00,36.00,64,'female','L2Minion','Mystic',40,3384,3.750,1285,2.700,40,43,30,21,20,10,7988,732,1031,347,589,331,278,0,253,0,0,0,60,175,'bloody_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.84,'false',1,0),
(795,20961,'Bloody Knight','','doll_blader',6.00,12.00,65,'male','L2Minion','Fighter',40,3465,3.750,1319,2.700,40,43,30,21,20,10,11719,1088,1077,355,619,340,278,0,253,5129,5129,0,22,175,'bloody_clan',300,'Local','',0,0,119,7,50,1,9,0,10,0.50,'false',1,0),
(796,20962,'Bloody Priest','','bloody_queen',14.00,40.00,66,'female','L2Minion','Priest',40,3546,3.750,1353,2.700,40,43,30,21,20,10,13045,1228,1123,364,649,348,278,0,253,0,0,0,80,185,'bloody_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.50,'false',1,0),
(797,20963,'Bloody Lord','','banshee',9.00,23.00,68,'female','L2Monster','Fighter',40,3706,3.750,1423,2.700,40,43,30,21,20,10,9382,906,1217,382,713,365,278,500,253,3939,0,0,80,180,'bloody_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(798,20964,'Huge Footmark','','stone_golem',20.00,31.00,70,'male','L2Minion','Mystic',40,3862,3.750,1493,2.700,40,43,30,21,20,10,13513,1340,1314,470,780,382,278,0,253,0,0,0,23,23,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.41,'true',0,0),
(799,20965,'Chimera Piece','','saber_toothed_tiger',34.00,28.00,72,'male','L2Minion','Fighter',40,4013,4.250,1565,3.000,40,43,30,21,20,10,14379,1460,1413,491,849,399,278,0,253,0,0,0,60,174,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.45,'true',1,0),
(800,20966,'Black Shadow','','drake',30.00,100.00,74,'male','L2Monster','Mystic',40,4158,4.250,1637,3.000,40,43,30,21,20,10,15493,1616,1513,512,921,416,278,500,253,0,0,0,70,185,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.84,'true',1,0),
(801,20967,'Past Creature','','gamlin',11.00,32.00,76,'male','L2Minion','Fighter',40,4297,4.250,1710,3.000,40,43,30,21,20,10,16021,1712,1614,534,994,433,278,0,253,0,0,0,80,170,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.46,'true',0,0),
(802,20968,'Nonexistent Man','','susceptor',20.00,35.00,78,'male','L2Minion','Fighter',40,4428,4.250,1784,3.000,40,43,30,21,20,10,15583,1706,1715,555,1069,451,278,0,253,0,0,0,27,150,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.43,'true',0,0),
(803,20969,'Giant''s Shadow','','lesser_giant_shooter',21.00,44.00,79,'male','L2Monster','Fighter',500,4490,4.250,1821,3.000,40,43,30,21,20,10,13043,1446,3921,566,1107,459,249,500,227,4028,0,0,80,190,'giant_clan',300,'Local',NULL,0,0,0,7,10,8,0,1500,0,0.63,'true',1,0),
(804,20970,'Soldier of Ancient Times','','lesser_giant',21.00,44.00,73,'male','L2Minion','Fighter',40,4086,4.250,1601,3.000,40,43,30,21,20,10,10913,1122,1463,426,885,407,278,0,253,3937,0,0,15,190,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.58,'true',0,0),
(805,20971,'Warrior of Ancient Times','','lesser_giant',21.00,44.00,75,'male','L2Minion','Fighter',40,4229,4.250,1673,3.000,40,43,30,21,20,10,15602,1646,1563,445,957,425,278,0,253,3937,0,0,15,185,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.58,'true',0,0),
(806,20972,'Shaman of Ancient Times','','lesser_giant_mage',21.00,44.00,75,'male','L2Minion','Mystic',40,4229,4.250,1673,3.000,40,43,30,21,20,10,10970,1158,1563,445,957,425,278,0,253,3938,0,0,15,195,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'true',0,0),
(807,20973,'Forgotten Ancient People','','lesser_giant_mage',21.00,44.00,77,'male','L2Monster','Mystic',40,4364,4.250,1747,3.000,40,43,30,21,20,10,16958,1836,1664,463,1031,442,278,500,253,3938,0,0,15,185,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'true',1,0),
(808,20974,'Spiteful Soul Leader','','skeleton_royal_guard_bi',16.00,44.00,65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,11772,1094,1077,418,619,340,278,0,253,946,945,0,80,174,'undead_clan',300,'Magister','',0,20,135,7,30,4,4,0,-6,0.52,'true',1,0),
(809,20975,'Spiteful Soul Wizard','','elf_ghost_50_bi',10.00,32.00,63,'male','L2Minion','Mystic',40,3302,7.500,1251,2.700,40,43,30,21,20,10,10499,948,987,398,560,323,278,0,253,0,0,0,80,174,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(810,20976,'Spiteful Soul Fighter','','human_ghost_50_bi',12.00,33.00,62,'male','L2Minion','Mystic',40,3219,7.500,1217,2.700,40,43,30,21,20,10,8911,794,944,388,532,315,278,0,253,0,0,0,80,174,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(811,20977,'Elmoradan''s Lady','','banshee_50_bi',13.50,38.00,65,'female','L2Monster','Mystic',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7513,698,979,460,619,340,278,500,253,3939,0,0,80,160,'tower_ghost_clan',400,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(812,20978,'Elmoradan''s Archer Escort','','skeleton_archer',11.00,27.00,64,'male','L2Minion','Ranger',500,3384,15.000,1285,2.700,40,43,30,21,20,10,7470,684,2522,315,589,331,249,0,227,284,0,0,40,140,'tower_ghost_clan',400,'Magister',NULL,0,0,0,7,10,8,0,1500,10,0.80,'false',1,0),
(813,20979,'Elmoradan''s Maid','','doll_blader',6.00,12.00,64,'male','L2Minion','Fighter',40,3384,15.000,1285,2.700,40,43,30,21,20,10,7141,654,1135,371,589,331,278,0,253,5129,5129,0,22,170,'tower_ghost_clan',400,'Magister',NULL,0,0,137,7,30,4,4,0,0,0.50,'false',1,0),
(814,20980,'Hallate''s Follower Mul','','vale_master',12.00,40.00,68,'male','L2Monster','Fighter',40,3706,15.000,1423,2.700,40,43,30,21,20,10,7606,735,1339,408,713,365,278,500,253,210,0,0,70,170,'hallate_clan',400,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.74,'false',1,0),
(815,20981,'Mul''s Wizard','','kaim_vanul_50_bi',36.00,60.00,67,'male','L2Minion','Mystic',40,3626,15.000,1388,2.700,40,43,30,21,20,10,7564,720,1063,483,681,356,278,0,253,0,0,0,37,160,'hallate_clan',400,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.45,'false',1,0),
(816,20982,'Mul''s Knight','','dre_vanul_100_bi',28.00,75.00,67,'male','L2Minion','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,6676,636,1126,399,681,356,317,0,289,0,0,0,80,143,'hallate_clan',400,'Magister',NULL,0,0,0,7,10,8,0,0,0,0.35,'false',1,0),
(817,20983,'Binder','','kel_mahum_champion_50_bi',19.00,48.00,73,'male','L2Monster','Fighter',40,4086,17.000,1601,3.000,40,43,30,21,20,10,10342,1064,1609,456,885,407,278,500,253,147,0,0,50,170,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(818,20984,'Bound Warrior','','kel_mahum_warrior',13.00,28.00,72,'male','L2Monster','Fighter',40,4013,17.000,1565,3.000,40,43,30,21,20,10,9719,987,1554,446,849,399,278,0,253,148,0,0,50,160,'tower_guard_clan',50,'Magister','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(819,20985,'Bound Archer','','kel_mahum_archer',13.00,27.00,72,'male','L2Minion','Ranger',500,4013,17.000,1565,3.000,40,43,30,21,20,10,9647,980,3454,379,849,399,249,0,227,288,0,0,50,170,'tower_guard_clan',50,'Magister','',0,0,0,7,10,8,0,1500,10,0.91,'false',0,0),
(820,20986,'Sairon','','doll_blader_50_bi',9.00,20.50,54,'male','L2Monster','Fighter',40,2562,13.000,955,2.400,40,43,30,21,20,10,5524,440,636,313,339,254,278,500,253,5129,5129,0,22,174,'demonic_clan',300,'Local','',0,0,112,7,30,4,4,0,0,0.50,'false',1,0),
(821,20987,'Sairon''s Doll','','doll_blader',6.00,12.00,53,'male','L2Minion','Fighter',40,2481,13.000,923,2.400,40,43,30,21,20,10,5025,395,602,304,319,247,278,0,253,5129,5129,0,22,174,NULL,0,'Local',NULL,0,0,110,7,30,4,4,0,0,0.50,'false',1,0),
(822,20988,'Sairon''s Puppet','','doll_blader',6.00,12.00,53,'male','L2Minion','Fighter',40,2481,13.000,923,2.400,40,43,30,21,20,10,5527,434,602,304,319,247,278,0,253,5129,5129,0,22,174,NULL,0,'Local',NULL,0,0,110,7,30,4,4,0,0,0.50,'false',1,0),
(823,20989,'Lageos','','marsh_stakato_drone_50_bi',13.00,37.00,38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,2749,171,238,188,112,153,278,0,253,182,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(824,20990,'Pageos','','marsh_stakato_soldier',10.00,25.00,38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,2609,163,238,188,112,153,278,0,253,128,0,0,30,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.74,'true',0,0),
(825,20991,'Swamp Tribe','','farhite_50_bi',24.00,48.00,45,'male','L2Monster','Fighter',40,1870,11.000,677,2.100,40,43,30,21,20,10,5139,357,377,238,188,193,278,500,253,5131,0,0,15,174,'croc_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.74,'false',1,0),
(826,20992,'Swamp Alligator','','crokian',18.00,29.00,44,'male','L2Minion','Fighter',40,1799,11.000,648,2.100,40,43,30,21,20,10,4600,315,354,230,176,187,278,0,253,5128,0,0,18,174,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.78,'false',1,0),
(827,20993,'Swamp Warrior','','dailaon',20.00,28.00,44,'male','L2Minion','Fighter',500,1799,11.000,648,2.100,40,43,30,21,20,10,4881,334,788,230,176,187,249,0,227,5127,0,0,18,174,'',0,'Magister','',0,0,0,7,10,8,0,1500,0,0.91,'false',1,0),
(828,20994,'Garden Guard Leader','','doll_master_50_bi',30.00,63.00,50,'male','L2Monster','Fighter',40,2245,11.000,830,2.100,40,43,30,21,20,10,6194,466,560,253,264,226,278,500,253,0,0,0,80,174,'theeder_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(829,20995,'Garden Guard','','theeder',9.00,32.00,48,'male','L2Minion','Fighter',40,2091,11.000,768,2.100,40,43,30,21,20,10,4222,308,453,261,231,212,278,0,253,94,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(830,20996,'Spiteful Ghost of Ruins','','zombie',13.00,21.00,50,'male','L2Monster','Mystic',40,2245,5.500,830,2.100,40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.43,'false',1,0),
(831,20997,'Soldier of Grief','','unpleasant_humming',12.00,26.00,51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,3782,288,593,260,281,232,278,0,253,0,0,0,21,150,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.59,'false',1,0),
(832,20998,'Cruel Punisher','','hungry_spirit',13.00,40.00,52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,4168,322,518,324,300,239,278,0,253,0,0,0,15,120,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.45,'false',1,0),
(833,20999,'Roving Soul','','skeleton',11.00,25.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,75,0,0,60,160,'undead_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.30,'false',1,0),
(834,21000,'Soul of Ruins','','human_ghost',8.00,22.00,54,'male','L2Monster','Mystic',40,2562,6.500,955,2.400,40,43,30,21,20,10,4325,345,578,344,339,254,278,500,253,0,0,0,80,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(835,21001,'Wretched Archer','','skeleton_archer',11.00,27.00,55,'male','L2Monster','Ranger',500,2643,6.500,987,2.400,40,43,30,21,20,10,5856,473,1639,292,360,261,249,0,227,282,0,0,40,174,'undead_clan',300,'Magister','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(836,21002,'Doom Scout','','skeleton_royal_guard',11.00,28.50,56,'male','L2Monster','Fighter',40,2724,6.500,1019,2.400,40,43,30,21,20,10,5163,424,679,301,382,269,317,500,289,242,2496,0,80,174,'doom_clan',300,'Magister','',0,20,114,7,10,8,0,0,-6,0.52,'true',1,0),
(837,21003,'Grave Lich','','liviona',15.00,28.00,57,'male','L2Monster','Fighter',40,2806,6.500,1052,2.400,40,43,30,21,20,10,4725,393,675,374,405,276,278,0,253,0,0,0,80,174,'undead_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(838,21004,'Dismal Pole','','hanged_man_ripper',35.00,80.00,58,'male','L2Monster','Fighter',80,2889,6.500,1084,2.400,40,43,30,21,20,10,5239,443,828,384,428,284,237,500,216,0,0,0,55,174,'undead_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(839,21005,'Grave Predator','','devastator',35.00,35.00,59,'male','L2Monster','Fighter',40,2971,6.500,1117,2.400,40,43,30,21,20,10,5732,490,902,326,453,291,278,500,253,0,0,0,25,174,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(840,21006,'Doom Servant','','hungry_spirit',13.00,40.00,60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,5447,473,946,335,478,299,278,500,253,0,0,0,15,174,'doom_clan',300,'Magister','',0,0,0,7,50,1,9,0,0,0.45,'true',1,0),
(841,21007,'Doom Guard','','hungry_spirit',13.00,40.00,61,'male','L2Monster','Fighter',40,3137,7.500,1184,2.700,40,43,30,21,20,10,5844,514,992,344,505,307,278,0,253,0,0,0,15,174,'doom_clan',300,'Magister','',0,0,0,7,50,1,9,0,0,0.45,'true',1,0),
(842,21008,'Doom Archer','','skeleton_archer',11.00,27.00,62,'male','L2Monster','Ranger',500,3219,7.500,1217,2.700,40,43,30,21,20,10,7471,666,2308,353,532,315,249,500,227,286,0,0,40,174,'doom_clan',300,'Magister','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(843,21009,'Doom Trooper','','skeleton_pikeman',10.00,28.00,63,'male','L2Monster','Fighter',80,3302,7.500,1251,2.700,40,43,30,21,20,10,7966,719,1267,362,560,323,237,0,216,301,0,0,50,174,'doom_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.21,'true',1,0),
(844,21010,'Doom Warrior','','skeleton_knight',10.00,25.00,64,'male','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,6380,584,993,371,589,331,317,0,289,71,0,0,40,174,'doom_clan',300,'Magister','',0,0,0,7,10,8,0,0,0,0.17,'true',1,0),
(845,21011,'Ol Mahum Van Grunt','','ol_mahum',13.50,25.00,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1308,72,132,140,58,114,278,0,253,5,0,0,50,150,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(846,21012,'Magical Eye','','magical_weaver',11.00,20.00,31,'male','L2Monster','Mystic',40,1004,4.500,381,1.800,40,43,30,21,20,10,1736,96,129,161,64,118,278,500,253,0,0,0,90,150,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(847,21013,'Ol Mahum Van Archer','','ol_mahum_archer',14.00,25.00,32,'male','L2Monster','Ranger',500,1056,4.500,397,1.800,40,43,30,21,20,10,1920,108,376,138,69,123,249,0,227,273,0,0,50,150,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.93,'true',1,0),
(848,21014,'Lesser Warlike Tyrant','','grave',15.00,29.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1987,114,151,173,75,128,278,500,253,0,0,0,70,150,'kinpin_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(849,21015,'Ol Mahum Van Leader','','ol_mahum_champion',14.00,27.00,34,'male','L2Monster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,2040,119,196,148,82,132,278,500,253,67,0,0,50,150,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.63,'true',1,0),
(850,21016,'Warlike Tyrant','','grave',15.00,29.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,2192,130,211,154,89,137,278,0,253,0,0,0,70,174,'kinpin_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(851,21017,'Fallen Orc','','ketra_orc',12.00,29.00,55,'male','L2Monster','Fighter',40,2643,6.500,987,2.400,40,43,30,21,20,10,4399,355,737,292,360,261,278,0,253,127,0,0,45,174,'fallen_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(852,21018,'Ancient Gargoyle','','hunter_gargoyle',25.00,65.00,56,'male','L2Monster','Fighter',40,2724,6.500,1019,2.400,40,43,30,21,20,10,5536,455,642,364,382,269,278,500,253,0,0,0,100,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(853,21019,'Fallen Orc Archer','','ketra_orc_archer',12.00,27.00,57,'male','L2Monster','Ranger',500,2806,6.500,1052,2.400,40,43,30,21,20,10,6093,506,1501,374,405,276,249,0,227,279,0,0,45,174,'fallen_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.91,'true',1,0),
(854,21020,'Fallen Orc Shaman','','ketra_orc_shaman',10.00,23.00,58,'male','L2Monster','Priest',40,2889,6.500,1084,2.400,40,43,30,21,20,10,6898,583,710,384,428,284,278,0,253,9,0,0,10,174,'fallen_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.34,'true',1,0),
(855,21021,'Sharp Talon Tiger','','saber_toothed_tiger',34.00,28.00,59,'male','L2Monster','Fighter',40,2971,6.500,1117,2.400,40,43,30,21,20,10,6353,543,902,277,453,291,278,500,253,0,0,0,60,174,'fallen_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.45,'true',1,0),
(856,21022,'Fallen Orc Captain','','ketra_orc_warrior',12.00,24.00,60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,6462,561,946,285,478,299,278,500,253,160,0,0,36,174,'fallen_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,10,0.54,'true',1,0),
(857,21023,'Sobbing Wind','','sylph',11.00,35.00,26,'female','L2Monster','Mystic',40,770,3.500,303,1.500,40,43,30,21,20,10,1056,53,87,132,41,98,278,0,253,0,0,0,60,150,'elemental2_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.56,'true',1,0),
(858,21024,'Babbling Wind','','sylph',11.00,35.00,27,'female','L2Monster','Mystic',40,813,3.500,318,1.500,40,43,30,21,20,10,1113,57,94,138,45,102,278,0,253,0,0,0,60,150,'elemental2_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.56,'true',1,0),
(859,21025,'Giggling Wind','','sylph',11.00,35.00,28,'female','L2Monster','Mystic',40,859,3.500,334,1.500,40,43,30,21,20,10,1178,62,102,143,49,106,278,0,253,0,0,0,60,150,'elemental2_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.56,'true',1,0),
(860,21026,'Singing Wind','','sylph',11.00,35.00,29,'female','L2Monster','Mystic',40,906,3.500,349,1.500,40,43,30,21,20,10,1268,68,111,149,53,110,278,500,253,0,0,0,60,150,'elemental2_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.56,'true',1,0),
(861,21034,'Ogre','','ogre',21.00,44.00,38,'male','L2Monster','Fighter',40,1400,2.250,497,1.800,40,43,30,21,20,10,3594,224,440,141,112,153,200,500,182,98,0,0,22,174,'lizardman_clan1',300,'Local','',0,0,0,7,50,1,9,0,0,0.69,'true',1,0),
(862,21035,'Catherok','','marsh_stakato_soldier',10.00,25.00,42,'male','L2Monster','Fighter',40,1660,11.000,589,2.100,40,43,30,21,20,10,2275,151,342,196,152,175,278,500,253,127,0,0,30,174,'beast_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.74,'false',1,0),
(863,21036,'Shindebarn','','magical_weaver',11.00,20.00,44,'male','L2Monster','Mystic',40,1799,11.000,648,2.100,40,43,30,21,20,10,2869,196,390,209,176,187,278,500,253,0,0,0,90,174,'porta_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(864,21037,'Ossiud','','field_stalker',15.00,30.00,47,'male','L2Monster','Fighter',40,2016,11.000,738,2.100,40,43,30,21,20,10,3326,238,469,230,216,206,278,500,253,0,0,0,70,174,'torfe_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.41,'false',1,0),
(865,21038,'Liangma','','will_o_wisp',13.00,22.00,49,'male','L2Monster','Mystic',40,2168,11.000,799,2.100,40,43,30,21,20,10,2926,216,529,245,247,219,278,500,253,0,0,0,80,174,'undead_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.10,'false',1,0),
(866,21039,'Snipe Cohort','','onyx_beast',14.00,14.50,43,'male','L2Monster','Fighter',40,1728,11.000,618,2.100,40,43,30,21,20,10,3041,205,302,245,163,181,278,0,253,0,0,0,30,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.24,'false',0,0),
(867,21040,'Soldier of Darkness','','death_knight',12.00,30.00,49,'male','L2Minion','Fighter',40,2168,11.000,799,2.100,40,43,30,21,20,10,5077,375,581,223,247,219,278,0,253,127,0,0,27,174,'',0,'DRIVER','',0,0,0,7,50,1,9,0,0,0.71,'false',0,0),
(868,21058,'Beast Lord','','saber_toothed_tiger',34.00,28.00,60,'male','L2Monster','Fighter',40,3054,13.000,1150,2.400,40,43,30,21,20,10,7880,684,946,335,478,299,278,500,253,0,0,0,60,174,'beast_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.45,'false',1,0),
(869,21059,'Beast Guardian','','onyx_beast',14.00,14.50,59,'male','L2Minion','Fighter',40,2971,13.000,1117,2.400,40,43,30,21,20,10,6289,537,902,326,453,291,278,0,253,0,0,0,30,174,'beast_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.24,'false',1,0),
(870,21060,'Beast Seer','','field_stalker',15.00,30.00,59,'male','L2Minion','Fighter',40,2971,13.000,1117,2.400,40,43,30,21,20,10,6289,537,745,395,453,291,278,0,253,0,0,0,70,174,'beast_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.41,'false',1,0),
(871,21061,'Hallate''s Guardian','','kaim_vanul',24.00,40.00,69,'male','L2Minion','Fighter',40,3784,30.000,1458,2.700,40,43,30,21,20,10,6396,625,1392,418,746,373,278,500,253,0,0,0,37,174,'hallate_clan',400,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.45,'false',1,0),
(872,21062,'Messenger Angel','','angel',13.50,36.50,70,'male','L2Monster','PolimorphingAngel',40,3862,30.000,1493,2.700,40,43,30,21,20,10,0,0,1590,388,780,382,278,500,253,148,0,0,30,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(873,21063,'Messenger Angel','','angel',13.50,36.50,70,'male','L2Monster','Fighter',40,3862,30.000,1493,2.700,40,43,30,21,20,10,13079,1297,1194,517,780,382,278,500,253,148,0,0,30,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.52,'false',0,0),
(874,21064,'Platinum Guardian Archer','','kel_mahum_archer',13.00,27.00,71,'male','L2Minion','Ranger',500,3938,34.000,1529,3.000,40,43,30,21,20,10,8009,803,3332,371,814,390,249,500,227,288,0,0,50,174,'tower_guard_clan',400,'Magister','',0,0,0,7,10,8,0,1500,10,0.91,'false',1,0),
(875,21065,'Platinum Guardian Warrior','','kel_mahum_warrior',13.00,28.00,72,'male','L2Minion','Fighter',40,4013,42.500,1565,3.000,40,43,30,21,20,10,6036,613,1284,540,849,399,278,500,253,148,0,0,50,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.34,'false',1,0),
(876,21066,'Platinum Guardian Shaman','','kel_mahum_witch_doctor',13.00,25.00,73,'male','L2Minion','Priest',40,4086,42.500,1601,3.000,40,43,30,21,20,10,6529,672,1609,456,885,407,278,500,253,202,0,0,50,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.28,'false',1,0),
(877,21067,'Guardian Archangel','','angel',13.50,36.50,74,'male','L2Monster','PolimorphingAngel',40,4158,42.500,1637,3.000,40,43,30,21,20,10,0,0,1831,423,921,416,278,500,253,148,0,0,30,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(878,21068,'Guardian Archangel','','angel',13.50,36.50,74,'male','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,14206,1481,1664,466,921,416,278,500,253,148,0,0,30,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.52,'false',0,0),
(879,21069,'Platinum Guardian Prefect','','kel_mahum_champion',13.00,32.00,74,'male','L2Minion','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,8909,928,1831,423,921,416,278,500,253,147,0,0,50,174,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(880,21070,'Seal Archangel','','angel',13.50,36.50,75,'male','L2Monster','PolimorphingAngel',40,4229,42.500,1673,3.000,40,43,30,21,20,10,0,0,1892,432,957,425,278,500,253,148,0,0,30,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(881,21071,'Seal Archangel','','angel',13.50,36.50,75,'male','L2Monster','Fighter',40,4229,42.500,1673,3.000,40,43,30,21,20,10,14733,1554,1421,575,957,425,278,500,253,148,0,0,30,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.52,'false',0,0),
(882,21072,'Platinum Guardian Chief','','kel_mahum_witch_doctor',13.00,25.00,75,'male','L2Monster','Fighter',40,4229,42.500,1673,3.000,40,43,30,21,20,10,6752,712,1720,475,957,425,278,500,253,202,0,0,50,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.28,'false',1,0),
(883,21073,'Guardian Warrior of Elmoreden','','skeleton_knight',10.00,25.00,64,'male','L2Minion','Fighter',40,3384,15.000,1285,2.700,40,43,30,21,20,10,7040,644,1135,371,589,331,278,0,253,84,0,0,40,174,'tower_ghost_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(884,21074,'Bound Shaman','','kel_mahum_witch_doctor',13.00,25.00,72,'male','L2Minion','Priest',40,4013,17.000,1565,3.000,40,43,30,21,20,10,9651,980,1284,540,849,399,278,0,253,202,0,0,50,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.28,'false',0,0),
(885,21075,'Slaughter Bathin','','death_knight',12.00,30.00,63,'male','L2Monster','Fighter',40,3302,15.000,1251,2.700,40,43,30,21,20,10,6995,631,1086,362,560,323,278,500,253,84,0,0,27,174,'hallate_clan',200,'Magister','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(886,21076,'Bathin''s Knight','','skeleton_knight',10.00,25.00,62,'male','L2Minion','Fighter',40,3219,15.000,1217,2.700,40,43,30,21,20,10,6881,613,1038,353,532,315,278,0,253,78,0,0,40,174,'hallate_clan',200,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.17,'false',1,0),
(887,21077,'Bathin''s Wizard','','banshee',9.00,23.00,62,'female','L2Minion','Mystic',40,3219,15.000,1217,2.700,40,43,30,21,20,10,6669,594,1038,353,532,315,278,0,253,3939,0,0,80,174,'hallate_clan',200,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(888,21078,'Magus Valac','','vale_master',12.00,40.00,70,'male','L2Monster','Mystic',40,3862,15.000,1493,2.700,40,43,30,21,20,10,8481,841,1445,427,780,382,278,500,253,198,0,0,70,174,'hallate_clan',200,'Magister','',0,0,0,7,50,1,9,0,0,0.74,'false',1,0),
(889,21079,'Valac''s Creature','','serpent_slave',17.00,46.00,69,'male','L2Minion','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,7707,754,1392,418,746,373,278,0,253,150,0,0,70,174,'hallate_clan',200,'Magister',NULL,0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(890,21080,'Valac''s Guardian Spirit','','shadow',10.00,30.00,69,'male','L2Minion','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,7123,697,1006,506,746,373,317,0,289,0,0,0,80,174,'hallate_clan',200,'Magister',NULL,0,0,0,7,10,8,0,0,0,0.54,'false',1,0),
(891,21081,'Power Angel Amon','','angel',13.50,36.50,75,'male','L2Monster','Fighter',40,4229,17.000,1673,3.000,40,43,30,21,20,10,8887,937,1720,475,957,425,278,500,253,4700,0,0,30,174,'tower_guard_clan',200,'Magister','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(892,21082,'Amon''s Captain of the Guards','','kel_mahum_champion',13.00,32.00,74,'male','L2Minion','Fighter',40,4158,17.000,1637,3.000,40,43,30,21,20,10,8546,891,1664,466,921,416,278,0,253,150,0,0,50,174,'tower_guard_clan',200,'Magister',NULL,0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(893,21083,'Amon''s Spirits','','pixy',5.00,25.00,74,'female','L2Minion','Fighter',40,4158,17.000,1637,3.000,40,43,30,21,20,10,10096,1052,1664,466,921,416,278,0,253,0,0,0,80,174,'tower_guard_clan',200,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.72,'false',1,0),
(894,21084,'Bloody Lady','','bloody_queen',14.00,40.00,60,'female','L2Monster','Mystic',40,3054,19.500,1150,2.400,40,43,30,21,20,10,4112,357,946,335,478,299,278,500,253,0,0,0,80,174,'bloody_clan',400,'stiff_l2wh','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(895,21085,'Bloody Sniper','','fiend_archer',17.00,55.00,71,'male','L2Monster','Ranger',500,3938,42.500,1529,3.000,40,43,30,21,20,10,5574,559,3332,437,814,390,249,500,227,0,0,0,70,174,'bloody_clan',400,'Local','',0,0,0,7,10,8,0,1500,0,0.76,'false',1,0),
(896,21086,'Bloody Liviona','','liviona',15.00,28.00,72,'male','L2Monster','Fighter',40,4013,42.500,1565,3.000,40,43,30,21,20,10,5566,565,1413,491,849,399,278,500,253,0,0,0,80,174,'bloody_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(897,21087,'Bloody Knight','','death_knight',12.00,30.00,73,'male','L2Monster','Fighter',40,4086,42.500,1601,3.000,40,43,30,21,20,10,8932,919,1770,415,885,407,278,500,253,137,0,0,27,174,'bloody_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(898,21088,'Bloody Banshee','','banshee',9.00,23.00,74,'female','L2Monster','Mystic',40,4158,42.500,1637,3.000,40,43,30,21,20,10,5879,612,1513,512,921,416,278,500,253,3939,0,0,80,174,'bloody_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(899,21089,'Bloody Lord','','karik',25.00,90.00,75,'male','L2Monster','Fighter',40,4229,42.500,1673,3.000,40,43,30,21,20,10,6817,719,1720,475,957,425,278,500,253,0,0,0,37,174,'bloody_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(900,21090,'Bloody Guardian','','death_blader',15.00,45.00,75,'male','L2Monster','Fighter',40,4229,25.500,1673,3.000,40,43,30,21,20,10,8734,921,1720,475,957,425,278,500,253,1472,0,0,100,174,'bloody_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(901,21091,'Bloody Keeper','','kaim_vanul',24.00,40.00,74,'male','L2Minion','Fighter',40,4158,17.000,1637,3.000,40,43,30,21,20,10,8831,920,1513,512,921,416,278,0,253,0,0,0,37,174,'bloody_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(902,21092,'Bloody Mystic','','banshee',9.00,23.00,74,'female','L2Minion','Mystic',40,4158,17.000,1637,3.000,40,43,30,21,20,10,8627,899,1513,512,921,416,278,0,253,3939,0,0,80,174,'bloody_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(903,21093,'Ratman Sub Chieftain','','wererat',14.00,25.00,19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,691,31,58,70,21,73,278,400,253,216,0,0,80,150,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.61,'true',1,0),
(904,21094,'Ratman Chieftain','','wererat',14.00,25.00,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,712,32,52,104,23,76,278,0,253,3,0,0,80,155,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(905,21095,'Giant Poison Bee','','giant_bee',8.00,24.50,21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,840,39,55,83,25,80,317,0,289,0,0,0,90,90,'',0,'Local','',0,0,0,7,10,8,0,0,10,0.50,'true',1,0),
(906,21096,'Cloudy Beast','','onyx_beast',14.00,14.50,22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,837,40,68,87,28,83,278,400,253,0,0,0,30,140,'beast_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.24,'true',1,0),
(907,21097,'Young Araneid','','poison_spider',27.00,25.50,23,'male','L2Monster','Mystic',40,648,3.500,257,1.500,40,43,30,21,20,10,985,48,75,107,31,87,278,400,253,0,0,0,60,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.65,'true',1,0),
(908,21098,'Plain Grizzly','','grizzly',21.00,40.00,24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,935,46,81,111,34,90,278,0,253,0,0,0,40,115,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(909,21099,'Cloudy Beast Turen','','onyx_beast',14.00,14.50,25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,1012,51,88,98,37,94,278,400,253,0,0,0,30,145,'beast_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.24,'true',1,0),
(910,21100,'Langk Lizardman Sentinel','','virud_lizardman',10.00,23.00,19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,691,31,53,90,21,73,278,500,253,2,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(911,21101,'Langk Lizardman Shaman','','virud_lizardman_shaman',10.00,29.00,24,'male','L2Monster','Priest',40,687,3.500,272,1.500,40,43,30,21,20,10,935,46,81,94,34,90,278,0,253,6,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.48,'true',1,0),
(912,21102,'Watchman of the Plains','','magical_weaver',11.00,20.00,30,'male','L2Monster','Mystic',40,954,3.500,365,1.500,40,43,30,21,20,10,1335,73,132,119,58,114,278,500,253,0,0,0,90,160,'monster_eye_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.39,'true',1,0),
(913,21103,'Roughly Hewn Rock Golem','','stone_golem_bi',20.00,40.30,31,'male','L2Monster','Mystic',40,1004,4.500,381,1.800,40,43,30,21,20,10,1397,78,142,146,64,118,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.41,'true',1,0),
(914,21104,'Delu Lizardman Supplier','','virud_lizardman',10.00,23.00,32,'male','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1754,99,134,151,69,123,317,0,289,223,0,0,43,135,'',0,'Local','',0,0,0,7,10,8,0,0,0,0.48,'true',1,0),
(915,21105,'Delu Lizardman Special Agent','','virud_lizardman_scout',10.00,22.00,33,'male','L2Monster','DeluLizardmanSpecialAgent',500,1109,4.500,413,1.800,40,43,30,21,20,10,2022,116,406,143,75,128,249,0,227,2507,0,0,43,135,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.72,'true',1,0),
(916,21106,'Cursed Seer','','magical_weaver',11.00,20.00,34,'male','L2Monster','Mystic',40,1164,4.500,430,1.800,40,43,30,21,20,10,1714,100,178,138,82,132,278,500,253,0,0,0,90,160,'monster_eye_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.39,'true',1,0),
(917,21107,'Delu Lizardman Commander','','virud_lizardman_warrior',12.00,30.00,35,'male','L2Monster','Fighter',40,1220,9.000,446,1.800,40,43,30,21,20,10,1814,107,192,169,89,137,278,0,253,93,0,0,52,135,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.59,'false',1,0),
(918,21108,'Glow Wisp','','will_o_wisp',13.00,22.00,67,'male','L2Monster','Mystic',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6528,622,1169,439,681,356,278,0,253,0,0,0,80,160,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.10,'true',1,0),
(919,21109,'Hames Orc Scout','','ketra_orc',12.00,29.00,68,'male','L2Monster','Fighter',40,3706,7.500,1423,2.700,40,43,30,21,20,10,8082,781,1065,382,713,365,317,0,289,229,0,0,45,185,'orc_clan',400,'Local','',0,0,0,7,10,8,0,0,10,0.46,'true',1,0),
(920,21110,'Marsh Predator','','devastator',35.00,35.00,69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,6890,674,1265,460,746,373,278,0,253,0,0,0,25,175,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(921,21111,'Lava Wyrm','','wyrm',29.00,72.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,7197,714,1314,470,780,382,278,500,253,0,0,0,70,175,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.19,'true',1,0),
(922,21112,'Hames Orc Footman','','ketra_orc',12.00,29.00,71,'male','L2Monster','Fighter',40,3938,8.500,1529,3.000,40,43,30,21,20,10,8724,875,1363,481,814,390,278,0,253,233,110,0,45,180,'orc_clan',300,'Local','',0,20,150,7,30,4,4,0,-6,0.46,'true',1,0),
(923,21113,'Hames Orc Sniper','','ketra_orc_archer',12.00,27.00,72,'male','L2Monster','Ranger',500,4013,8.500,1565,3.000,40,43,30,21,20,10,9722,988,3140,417,849,399,249,0,227,287,0,0,45,160,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.91,'true',1,0),
(924,21114,'Cursed Guardian','','death_blader',15.00,45.00,73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,9231,950,1463,426,885,407,278,0,253,1472,0,0,100,175,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.45,'true',1,0),
(925,21115,'Hames Orc Shaman','','ketra_orc_shaman',10.00,23.00,74,'male','L2Monster','Priest',40,4158,8.500,1637,3.000,40,43,30,21,20,10,8043,838,1513,435,921,416,278,0,253,186,0,0,10,145,'orc_clan',400,'Local','',0,0,0,7,50,1,9,0,10,0.34,'true',1,0),
(926,21116,'Hames Orc Overlord','','ketra_orc_warrior',12.00,24.00,75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,12699,1340,1720,475,957,425,278,500,253,75,103,0,36,175,'orc_clan',500,'Local','',0,20,159,7,30,4,4,0,-6,0.54,'true',1,0),
(927,21117,'Kasha Imp','','imp_bi',10.00,30.00,19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,678,30,53,77,21,73,278,0,253,0,0,0,60,85,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.34,'true',1,0),
(928,21118,'Baar Dre Vanul','','dre_vanul',14.00,36.00,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,726,32,57,94,23,76,278,400,253,0,0,0,80,85,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.35,'true',1,0),
(929,21119,'Hobgoblin','','hobgoblin',12.00,24.00,21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,764,35,63,98,25,80,278,0,253,4,0,0,45,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.41,'true',1,0),
(930,21120,'Kasha Imp Turen','','imp_bi',10.00,30.00,22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,996,47,75,79,28,83,278,400,253,0,0,0,60,85,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.34,'true',1,0),
(931,21121,'Kasha Dire Wolf','','dire_wolf',13.00,11.00,23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,895,43,75,91,31,87,278,400,253,0,0,0,24,135,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.39,'true',1,0),
(932,21122,'Kasha Bugbear','','bugbear',17.00,35.00,24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,954,47,81,111,34,90,278,400,253,169,0,0,55,130,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(933,21123,'Baar Dre Vanul Destroyer','','dre_vanul',14.00,36.00,25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,1267,63,97,105,37,94,278,400,253,0,0,0,80,85,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.35,'true',1,0),
(934,21124,'Red Eye Barbed Bat','','vampire_bat',10.00,33.50,18,'male','L2Monster','Mystic',40,476,2.500,193,1.200,40,43,30,21,20,10,640,28,48,73,19,70,278,0,253,0,0,0,60,90,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.50,'true',1,0),
(935,21125,'Northern Trimden','','poison_spider',27.00,25.50,19,'male','L2Monster','Mystic',40,508,2.500,203,1.200,40,43,30,21,20,10,684,31,53,90,21,73,278,400,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.65,'true',1,0),
(936,21126,'Kerope Werewolf','','werewolf_bi',11.00,29.70,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,712,32,57,80,23,76,278,0,253,0,0,0,50,125,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.43,'true',1,0),
(937,21127,'Northern Goblin','','northern_goblin',21.00,20.00,21,'male','L2Monster','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,764,35,63,98,25,80,278,0,253,152,0,0,30,120,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.45,'true',1,0),
(938,21128,'Spine Golem','','stone_golem_bi',20.00,40.30,22,'male','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,821,39,68,102,28,83,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.41,'true',1,0),
(939,21129,'Kerope Werewolf Chief','','werewolf_bi',11.00,29.70,23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,895,43,82,82,31,87,278,400,253,0,0,0,50,140,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.43,'true',1,0),
(940,21130,'Northern Goblin Leader','','northern_goblin',21.00,20.00,24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,954,47,81,111,34,90,278,400,253,66,102,0,30,125,'goblin_clan',300,'Local','',0,20,49,7,50,1,9,0,-6,0.45,'true',1,0),
(941,21131,'Enchanted Spine Golem','','stone_golem_bi',20.00,40.30,25,'male','L2Monster','Mystic',40,728,3.500,287,1.500,40,43,30,21,20,10,992,50,97,105,37,94,278,0,253,0,0,0,23,29,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.41,'true',1,0),
(942,21132,'Underground Kobold','','kobold',10.00,15.00,24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,779,38,81,94,34,90,278,0,253,0,0,0,47,110,'kobold_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.54,'true',1,0),
(943,21133,'Dead Pit Skeleton Archer','','skeleton_archer',11.00,27.00,25,'male','L2Monster','Ranger',500,728,3.500,287,1.500,40,43,30,21,20,10,851,43,197,98,37,94,249,0,227,274,0,0,40,130,'undead_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.80,'true',1,0),
(944,21134,'Dead Pit Spartoi','','spartoi',11.00,27.00,26,'male','L2Monster','Fighter',40,770,3.500,303,1.500,40,43,30,21,20,10,898,45,96,102,41,98,278,400,253,219,0,0,60,145,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.30,'true',1,0),
(945,21135,'Underground Kobold Warrior','','kobold',10.00,15.00,27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,1103,56,114,114,45,102,278,0,253,0,0,0,47,115,'kobold_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'true',1,0),
(946,21136,'Dead Pit Horror','','dark_horror',20.00,35.00,28,'male','L2Monster','Fighter',40,859,3.500,334,1.500,40,43,30,21,20,10,981,52,113,110,49,106,278,0,253,0,0,0,100,100,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.37,'true',1,0),
(947,21137,'Iron Ore Golem','','iron_golem',18.00,34.00,29,'male','L2Monster','Mystic',40,906,3.500,349,1.500,40,43,30,21,20,10,1057,57,111,149,53,110,278,400,253,0,0,0,20,21,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.41,'true',1,0),
(948,21138,'Greedy Geist','','hungry_spirit',13.00,40.00,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1134,62,132,119,58,114,278,0,253,0,0,0,15,150,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.45,'true',1,0),
(949,21139,'Catacomb Barbed Bat','','vampire_bat',10.00,33.50,23,'male','L2Monster','Mystic',40,648,14.000,257,1.500,40,43,30,21,20,10,655,31,75,91,31,87,278,500,253,0,0,0,60,130,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(950,21140,'Catacomb Wisp','','will_o_wisp',13.00,22.00,26,'male','L2Monster','Mystic',40,770,14.000,303,1.500,40,43,30,21,20,10,788,39,96,102,41,98,278,500,253,0,0,0,80,120,'c_dungeon_clan',300,'Magister','',0,0,0,7,50,1,9,0,10,0.10,'false',1,0),
(951,21141,'Catacomb Serpent','','serpent_slave',17.00,46.00,28,'male','L2Monster','Fighter',40,859,14.000,334,1.500,40,43,30,21,20,10,926,48,113,110,49,106,278,500,253,73,0,0,70,130,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,10,0.46,'false',1,0),
(952,21142,'Grave Keeper Spartoi','','spartoi',11.00,27.00,29,'male','L2Monster','Fighter',40,906,14.000,349,1.500,40,43,30,21,20,10,927,49,111,149,53,110,278,500,253,221,0,0,60,140,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',1,0),
(953,21143,'Catacomb Scavenger Bat','','vampire_bat',10.00,33.50,31,'male','L2Monster','Fighter',40,1004,18.000,381,1.800,40,43,30,21,20,10,1042,57,142,124,64,118,278,500,253,0,0,0,60,140,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(954,21144,'Catacomb Shadow','','shadow',10.00,30.00,34,'male','L2Monster','Mystic',40,1164,18.000,430,1.800,40,43,30,21,20,10,1254,73,178,138,82,132,278,500,253,0,0,0,80,130,'c_dungeon_clan',300,'Magister','',0,0,0,7,50,1,9,0,10,0.54,'false',1,0),
(955,21145,'Catacomb Stakato Soldier','','blade_stakato_soldier',15.00,38.00,38,'male','L2Monster','Fighter',40,1400,18.000,497,1.800,40,43,30,21,20,10,1611,100,238,160,112,153,278,500,253,232,0,0,25,150,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,10,0.74,'false',1,0),
(956,21146,'Grave Keeper Dark Horror','','dark_horror',20.00,35.00,40,'male','L2Monster','Fighter',40,1527,18.000,531,1.800,40,43,30,21,20,10,1735,112,248,222,131,164,278,500,253,0,0,0,100,160,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'false',1,0),
(957,21147,'Catacomb Gargoyle','','gargoyle',16.00,50.00,43,'male','L2Monster','Fighter',40,1728,22.000,618,2.100,40,43,30,21,20,10,2114,143,332,223,163,181,278,500,253,0,0,0,140,170,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',1,0),
(958,21148,'Catacomb Liviona','','liviona',15.00,28.00,44,'male','L2Monster','Fighter',40,1799,22.000,648,2.100,40,43,30,21,20,10,2100,143,354,196,176,187,278,500,253,0,0,0,80,140,'c_dungeon_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.34,'false',1,0),
(959,21149,'Decayed Ancient Pikeman','','skeleton_pikeman',10.00,28.00,46,'male','L2Monster','Fighter',40,1943,22.000,707,2.100,40,43,30,21,20,10,2419,171,401,245,202,199,278,500,253,96,0,0,50,170,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.21,'false',1,0),
(960,21150,'Decayed Ancient Soldier','','skeleton_knight',10.00,25.00,49,'male','L2Monster','Fighter',40,2168,22.000,799,2.100,40,43,30,21,20,10,2745,203,480,270,247,219,278,500,253,125,0,0,40,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(961,21151,'Decayed Ancient Knight','','skeleton_royal_guard',11.00,28.50,50,'male','L2Monster','Fighter',40,2245,22.000,830,2.100,40,43,30,21,20,10,2858,215,509,278,264,226,278,500,253,227,0,0,80,170,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(962,21152,'Purgatory Wisp','','will_o_wisp',13.00,22.00,53,'male','L2Monster','Mystic',40,2481,26.000,923,2.400,40,43,30,21,20,10,3047,239,602,258,319,247,278,500,253,0,0,0,80,150,'c_dungeon_clan',300,'Magister','',0,0,0,7,50,1,9,0,10,0.10,'false',1,0),
(963,21153,'Purgatory Serpent','','serpent_slave',17.00,46.00,56,'male','L2Monster','Fighter',40,2724,26.000,1019,2.400,40,43,30,21,20,10,3586,294,706,281,382,269,278,500,253,73,0,0,70,175,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,10,0.46,'false',1,0),
(964,21154,'Hell Keeper Medusa','','medusa',10.00,25.00,58,'female','L2Monster','Mystic',40,2889,26.000,1084,2.400,40,43,30,21,20,10,3753,317,710,384,428,284,278,500,253,0,0,0,50,165,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(965,21155,'Purgatory Conjurer','','vampire_bat',10.00,33.50,59,'male','L2Monster','Mystic',40,2971,26.000,1117,2.400,40,43,30,21,20,10,3776,322,820,305,453,291,278,500,253,0,0,0,60,175,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(966,21156,'Purgatory Shadow','','shadow',10.00,30.00,61,'male','L2Monster','Mystic',40,3137,30.000,1184,2.700,40,43,30,21,20,10,4036,355,901,321,505,307,278,500,253,0,0,0,80,155,'c_dungeon_clan',300,'Magister','',0,0,0,7,50,1,9,0,10,0.54,'false',1,0),
(967,21157,'Purgatory Tarantula','','poison_spider',27.00,25.50,64,'male','L2Monster','Mystic',40,3384,30.000,1285,2.700,40,43,30,21,20,10,4569,418,1031,347,589,331,278,500,253,0,0,0,60,175,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.65,'false',1,0),
(968,21158,'Hell Keeper Crimson Doll','','crimson_doll',15.00,38.00,67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,5133,488,1063,483,681,356,278,500,253,0,0,0,60,180,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.67,'false',1,0),
(969,21159,'Purgatory Gargoyle','','gargoyle',16.00,50.00,68,'male','L2Monster','Fighter',40,3706,30.000,1423,2.700,40,43,30,21,20,10,5287,510,1217,449,713,365,278,500,253,0,0,0,140,175,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',1,0),
(970,21160,'Purgatory Liviona','','liviona',15.00,28.00,71,'male','L2Monster','Fighter',40,3938,34.000,1529,3.000,40,43,30,21,20,10,5468,548,1363,408,814,390,278,500,253,0,0,0,80,160,'c_dungeon_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.34,'false',1,0),
(971,21161,'Lesser Ancient Soldier','','medusa',10.00,25.00,73,'female','L2Monster','Fighter',40,4086,34.000,1601,3.000,40,43,30,21,20,10,5945,611,1463,502,885,407,278,500,253,0,0,0,50,180,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(972,21162,'Lesser Ancient Scout','','blade_stakato_drone',15.00,39.00,74,'male','L2Monster','Ranger',40,4158,34.000,1637,3.000,40,43,30,21,20,10,5940,619,1513,512,921,416,278,500,253,135,0,0,25,160,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.58,'false',1,0),
(973,21163,'Lesser Ancient Shaman','','silhouette',8.00,23.00,76,'female','L2Monster','Priest',40,4297,34.000,1710,3.000,40,43,30,21,20,10,6265,669,1614,454,994,433,278,500,253,0,0,0,80,200,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,10,0.54,'false',1,0),
(974,21164,'Guardian Spirit of Ancient Holy Ground','','death_lord',21.00,40.00,79,'male','L2Monster','Fighter',40,4490,34.000,1821,3.000,40,43,30,21,20,10,7136,791,1765,566,1107,459,278,500,253,78,0,0,40,190,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(975,21165,'Lesser Ancient Warrior','','shadeless',7.00,28.00,80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'c_dungeon_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.61,'false',1,0),
(976,21166,'Lith Scout','','temple_guard_a_20_sm',12.00,33.60,21,'male','L2Monster','Fighter',40,575,14.000,227,1.500,40,43,30,21,20,10,594,27,66,69,25,80,317,0,289,5795,0,0,53,130,'c_dungeon_clan',400,'Local','',0,0,0,7,10,8,0,0,10,0.48,'false',1,0),
(977,21167,'Lith Witch','','temple_savant_a_20_sm',8.00,32.00,24,'male','L2Monster','Mystic',40,687,14.000,272,1.500,40,43,30,21,20,10,690,34,98,92,34,90,278,0,253,5797,0,0,25,110,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(978,21168,'Lith Warrior','','temple_guard_b_20_sm',12.00,33.60,27,'male','L2Monster','Fighter',40,813,14.000,318,1.500,40,43,30,21,20,10,855,43,126,103,45,102,278,0,253,5796,0,0,53,130,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(979,21169,'Lith Guard','','temple_guard_a',15.00,42.00,30,'male','L2Monster','Fighter',40,954,14.000,365,1.500,40,43,30,21,20,10,1133,62,140,99,58,114,317,0,289,5795,0,0,53,140,'c_dungeon_clan',400,'Local','',0,0,0,7,10,8,0,0,10,0.48,'false',1,0),
(980,21170,'Lith Medium','','temple_savant_a',10.00,40.00,33,'male','L2Monster','Fighter',40,1109,18.000,413,1.800,40,43,30,21,20,10,1307,75,201,130,75,128,278,0,253,5797,0,0,25,120,'c_dungeon_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(981,21171,'Lith Overlord','','temple_guard_b',15.00,42.00,36,'male','L2Monster','Fighter',40,1279,18.000,463,1.800,40,43,30,21,20,10,1669,101,250,145,96,142,278,0,253,5796,0,0,53,140,'c_dungeon_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(982,21172,'Lith Patrolman','','temple_guard_a',15.00,42.00,39,'male','L2Monster','Fighter',40,1462,18.000,514,1.800,40,43,30,21,20,10,1972,125,270,137,121,158,317,0,289,5795,0,0,53,150,'c_dungeon_clan',400,'Magister','',0,0,0,7,10,8,0,0,10,0.48,'false',1,0),
(983,21173,'Lith Shaman','','temple_savant_a',10.00,40.00,42,'male','L2Monster','Priest',40,1660,22.000,589,2.100,40,43,30,21,20,10,2118,141,377,178,152,175,278,0,253,5798,0,0,25,130,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(984,21174,'Lith Commander','','temple_guard_b',15.00,42.00,45,'male','L2Monster','Fighter',40,1870,22.000,677,2.100,40,43,30,21,20,10,2731,190,457,196,188,193,278,0,253,5796,0,0,53,150,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(985,21175,'Lilim Butcher','','lilim_assassin_10_sm',11.00,36.00,48,'male','L2Monster','Fighter',40,2091,22.000,768,2.100,40,43,30,21,20,10,3093,226,480,183,231,212,317,0,289,232,232,0,36,170,'c_dungeon_clan',400,'Local','',0,0,83,7,10,8,0,0,10,0.46,'false',1,0),
(986,21176,'Lilim Magus','','lilim_wizard_10_sm',8.00,30.60,51,'female','L2Monster','Mystic',40,2323,26.000,861,2.400,40,43,30,21,20,10,3123,238,652,237,281,232,278,0,253,0,0,0,50,140,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.50,'false',1,0),
(987,21177,'Lilim Knight Errant','','lilim_knight_10_sm',11.00,45.00,54,'male','L2Monster','Fighter',40,2562,26.000,955,2.400,40,43,30,21,20,10,4385,349,769,258,339,254,278,0,253,5800,5799,0,56,170,'c_dungeon_clan',400,'Local','',0,20,109,7,30,4,4,0,-6,0.46,'false',1,0),
(988,21178,'Lilim Marauder','','lilim_assassin_10_sm',11.00,36.00,57,'male','L2Monster','Fighter',40,2806,26.000,1052,2.400,40,43,30,21,20,10,4697,390,786,239,405,276,317,0,289,229,229,0,36,180,'c_dungeon_clan',400,'Local','',0,0,102,7,10,8,0,0,10,0.46,'false',1,0),
(989,21179,'Lilim Priest','','lilim_wizard_10_sm',8.00,30.60,60,'female','L2Monster','Priest',40,3054,26.000,1150,2.400,40,43,30,21,20,10,4322,375,1041,304,478,299,278,0,253,0,0,0,50,160,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.50,'false',1,0),
(990,21180,'Lilim Knight','','lilim_knight_10_sm',11.00,45.00,63,'male','L2Monster','Fighter',40,3302,30.000,1251,2.700,40,43,30,21,20,10,6489,586,1194,329,560,323,278,0,253,5800,5799,0,56,180,'c_dungeon_clan',400,'Local','',0,20,131,7,30,4,4,0,-6,0.46,'false',1,0),
(991,21181,'Lilim Assassin','','lilim_assassin_10_bi',13.00,44.00,66,'male','L2Monster','Fighter',40,3546,30.000,1353,2.700,40,43,30,21,20,10,6868,646,1189,301,649,348,317,0,289,234,234,0,36,190,'c_dungeon_clan',400,'Local','',0,0,121,7,10,8,0,0,10,0.46,'false',1,0),
(992,21182,'Lilim Soldier','','lilim_wizard_10_bi',10.00,37.50,69,'female','L2Monster','Fighter',40,3784,30.000,1458,2.700,40,43,30,21,20,10,5717,559,1531,380,746,373,278,0,253,0,0,0,50,170,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.50,'false',1,0),
(993,21183,'Lilim Knight Banneret','','lilim_knight_10_bi',13.00,55.00,72,'male','L2Monster','Fighter',40,4013,34.000,1565,3.000,40,43,30,21,20,10,8475,861,1710,406,849,399,278,0,253,5800,5799,0,56,190,'c_dungeon_clan',400,'Local','',0,20,152,7,30,4,4,0,-6,0.46,'false',1,0),
(994,21184,'Lilim Slayer','','lilim_assassin_10_bi',13.00,44.00,75,'male','L2Monster','Ranger',40,4229,34.000,1673,3.000,40,43,30,21,20,10,8869,935,1655,367,957,425,317,0,289,236,236,0,36,200,'c_dungeon_clan',400,'Local','',0,0,140,7,10,8,0,0,10,0.46,'false',1,0),
(995,21185,'Lilim Great Mystic','','lilim_wizard_10_bi',10.00,37.50,78,'female','L2Monster','Mystic',40,4428,34.000,1784,3.000,40,43,30,21,20,10,7305,799,2075,459,1069,451,278,0,253,0,0,0,50,180,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.50,'false',1,0),
(996,21186,'Lilim Court Knight','','lilim_knight_10_bi',13.00,55.00,80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,10464,1174,2195,476,1144,468,278,0,253,5800,5799,0,56,200,'c_dungeon_clan',400,'Local','',0,20,170,7,30,4,4,0,-6,0.46,'false',1,0),
(997,21187,'Gigant Slave','','tomb_guard_a_20_sm',8.00,32.00,21,'male','L2Monster','Fighter',40,575,14.000,227,1.500,40,43,30,21,20,10,594,27,76,69,25,80,278,0,253,5791,0,0,49,130,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(998,21188,'Gigant Acolyte','','tomb_savant_a_20_sm',8.00,32.00,24,'male','L2Monster','Fighter',40,687,14.000,272,1.500,40,43,30,21,20,10,690,34,98,92,34,90,278,0,253,5793,0,0,49,110,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(999,21189,'Gigant Overseer','','tomb_guard_b_20_sm',12.00,34.00,27,'male','L2Monster','Fighter',40,813,14.000,318,1.500,40,43,30,21,20,10,855,43,126,103,45,102,278,0,253,5792,0,0,49,130,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1000,21190,'Gigant Footman','','tomb_guard_a',10.00,40.00,30,'male','L2Monster','Fighter',40,954,14.000,365,1.500,40,43,30,21,20,10,1133,62,160,99,58,114,278,0,253,5791,0,0,49,140,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(1001,21191,'Gigant Cleric','','tomb_savant_a',10.00,40.00,33,'male','L2Monster','Priest',40,1109,18.000,413,1.800,40,43,30,21,20,10,1307,75,201,130,75,128,278,0,253,5793,0,0,49,120,'c_dungeon_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(1002,21192,'Gigant Officer','','tomb_guard_b',15.00,42.50,36,'male','L2Monster','Fighter',40,1279,18.000,463,1.800,40,43,30,21,20,10,1669,101,250,145,96,142,278,0,253,5792,0,0,49,140,'c_dungeon_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1003,21193,'Gigant Raider','','tomb_guard_a',10.00,40.00,39,'male','L2Monster','Fighter',40,1462,18.000,514,1.800,40,43,30,21,20,10,1972,125,308,137,121,158,278,0,253,5791,0,0,49,150,'c_dungeon_clan',400,'Magister','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(1004,21194,'Gigant Confessor','','tomb_savant_a',10.00,40.00,42,'male','L2Monster','Fighter',40,1660,22.000,589,2.100,40,43,30,21,20,10,2118,141,377,178,152,175,278,0,253,5794,0,0,49,130,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(1005,21195,'Gigant Commander','','tomb_guard_b',15.00,42.50,45,'male','L2Monster','Fighter',40,1870,22.000,677,2.100,40,43,30,21,20,10,2731,190,457,196,188,193,278,0,253,5792,0,0,49,150,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1006,21196,'Nephilim Sentinel','','nephilim_slayer_10_sm',11.00,32.40,48,'male','L2Monster','Fighter',40,2091,22.000,768,2.100,40,43,30,21,20,10,3093,226,548,183,231,212,278,0,253,0,0,0,65,170,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,10,0.63,'false',1,0),
(1007,21197,'Nephilim Priest','','nephilim_priest_10_sm',21.00,36.50,51,'male','L2Monster','Priest',40,2323,26.000,861,2.400,40,43,30,21,20,10,3391,258,652,237,281,232,278,0,253,0,0,0,50,140,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(1008,21198,'Nephilim Swordsman','','nephilim_lord_10_sm',9.00,37.40,54,'male','L2Monster','Fighter',40,2562,26.000,955,2.400,40,43,30,21,20,10,4385,349,769,258,339,254,278,0,253,0,0,0,65,170,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.63,'false',1,0),
(1009,21199,'Nephilim Guard','','nephilim_slayer_10_sm',11.00,32.40,57,'male','L2Monster','Fighter',40,2806,26.000,1052,2.400,40,43,30,21,20,10,4697,390,899,239,405,276,278,0,253,0,0,0,65,180,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,10,0.63,'false',1,0),
(1010,21200,'Nephilim Bishop','','nephilim_priest_10_sm',21.00,36.50,60,'male','L2Monster','Priest',40,3054,26.000,1150,2.400,40,43,30,21,20,10,4694,407,1041,304,478,299,278,0,253,0,0,0,50,160,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(1011,21201,'Nephilim Centurion','','nephilim_lord_10_sm',9.00,37.40,63,'male','L2Monster','Fighter',40,3302,30.000,1251,2.700,40,43,30,21,20,10,6489,586,1194,329,560,323,278,0,253,0,0,0,65,180,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.63,'false',1,0),
(1012,21202,'Nephilim Scout','','nephilim_slayer_10_bi',13.00,39.60,66,'male','L2Monster','Ranger',40,3546,30.000,1353,2.700,40,43,30,21,20,10,6868,646,1358,301,649,348,278,0,253,0,0,0,65,190,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,10,0.63,'false',1,0),
(1013,21203,'Nephilim Archbishop','','nephilim_priest_10_bi',21.00,44.00,69,'male','L2Monster','Priest',40,3784,30.000,1458,2.700,40,43,30,21,20,10,6208,607,1531,380,746,373,278,0,253,0,0,0,50,170,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(1014,21204,'Nephilim Praetorian','','nephilim_lord_10_bi',11.00,45.30,72,'male','L2Monster','Fighter',40,4013,34.000,1565,3.000,40,43,30,21,20,10,8475,861,1710,406,849,399,278,0,253,0,0,0,65,190,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.63,'false',1,0),
(1015,21205,'Nephilim Royal Guard','','nephilim_slayer_10_bi',13.00,39.60,75,'male','L2Monster','Fighter',40,4229,34.000,1673,3.000,40,43,30,21,20,10,8869,935,1892,367,957,425,278,0,253,0,0,0,65,200,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,10,0.63,'false',1,0),
(1016,21206,'Nephilim Cardinal','','nephilim_priest_10_bi',21.00,44.00,78,'male','L2Monster','Priest',40,4428,34.000,1784,3.000,40,43,30,21,20,10,7933,868,2075,459,1069,451,278,0,253,0,0,0,50,180,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(1017,21207,'Nephilim Commander','','nephilim_lord_10_bi',11.00,45.30,80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,10464,1174,2195,476,1144,468,278,0,253,0,0,0,65,200,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.63,'false',1,0),
(1018,21208,'Hallowed Watchman','','skeleton',11.00,25.00,20,'male','L2Monster','Fighter',40,541,10.000,213,1.200,40,43,30,21,20,10,521,23,57,94,23,76,278,0,253,216,111,0,60,130,'c_dungeon_clan',300,'Local','',0,20,43,7,30,4,4,0,-6,0.30,'false',1,0),
(1019,21209,'Hallowed Seer','','binding',12.00,21.00,22,'male','L2Monster','Fighter',40,611,14.000,242,1.500,40,43,30,21,20,10,612,29,68,87,28,83,278,500,253,0,0,0,10,110,'c_dungeon_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.54,'false',1,0),
(1020,21210,'Vault Guardian','','dre_vanul',14.00,36.00,25,'male','L2Monster','Fighter',40,728,14.000,287,1.500,40,43,30,21,20,10,780,39,88,116,37,94,278,500,253,0,0,0,60,130,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(1021,21211,'Vault Seer','','succubus',10.00,36.00,27,'female','L2Monster','Mystic',40,813,14.000,318,1.500,40,43,30,21,20,10,830,42,104,106,45,102,278,500,253,0,0,0,60,110,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.84,'false',1,0),
(1022,21212,'Hallowed Sentinel','','skeleton_bi',11.00,31.00,30,'male','L2Monster','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(1023,21213,'Hallowed Monk','','binding_20_bi',14.00,25.30,32,'male','L2Monster','Fighter',40,1056,18.000,397,1.800,40,43,30,21,20,10,1110,62,154,129,69,123,278,500,253,0,0,0,10,110,'c_dungeon_clan',300,'Magister','',0,0,0,7,50,1,9,0,10,0.54,'false',1,0),
(1024,21214,'Vault Sentinel','','imp_bi',10.00,30.00,35,'male','L2Monster','Fighter',40,1220,18.000,446,1.800,40,43,30,21,20,10,1400,83,192,169,89,137,278,500,253,0,0,0,60,140,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(1025,21215,'Vault Monk','','succubus_bi',10.00,43.20,37,'female','L2Monster','Mystic',40,1338,18.000,480,1.800,40,43,30,21,20,10,1485,91,222,154,104,147,278,500,253,0,0,0,60,120,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,10,0.84,'false',1,0),
(1026,21216,'Overlord of the Holy Lands','','skeleton_knight_20_bi',12.00,30.50,40,'male','L2Monster','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(1027,21217,'Hallowed Priest','','banshee_20_bi',10.00,27.50,42,'female','L2Monster','Priest',40,1660,22.000,589,2.100,40,43,30,21,20,10,1913,127,311,183,152,175,278,500,253,0,0,0,80,135,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.56,'false',1,0),
(1028,21218,'Vault Overlord','','death_blader_10_sm',14.00,40.50,45,'male','L2Monster','Fighter',40,1870,22.000,677,2.100,40,43,30,21,20,10,2315,161,415,216,188,193,278,500,253,297,0,0,100,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(1029,21219,'Vault Priest','','bloody_queen_10_sm',13.00,38.00,47,'female','L2Monster','Priest',40,2016,22.000,738,2.100,40,43,30,21,20,10,2396,171,427,215,216,206,278,500,253,0,0,0,80,135,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(1030,21220,'Sepulcher Archon','','skeleton_knight_30_bi',13.00,33.00,50,'male','L2Monster','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(1031,21221,'Sepulcher Inquisitor','','banshee_30_bi',11.00,30.00,52,'female','L2Monster','Mystic',40,2402,26.000,892,2.400,40,43,30,21,20,10,2933,227,570,251,300,239,278,500,253,0,0,0,80,145,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.56,'false',1,0),
(1032,21222,'Sepulcher Archon','','death_blader_10_bi',16.00,49.50,55,'male','L2Monster','Fighter',40,2643,26.000,987,2.400,40,43,30,21,20,10,3459,279,737,292,360,261,278,500,253,298,0,0,100,170,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(1033,21223,'Sepulcher Inquisitor','','bloody_queen_10_bi',15.00,46.00,57,'female','L2Monster','Mystic',40,2806,26.000,1052,2.400,40,43,30,21,20,10,3524,293,743,289,405,276,278,500,253,0,0,0,80,145,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(1034,21224,'Sepulcher Guardian','','skeleton_royal_guard_20_bi',13.00,34.50,60,'male','L2Monster','Fighter',40,3054,26.000,1150,2.400,40,43,30,21,20,10,3828,332,828,335,478,299,317,0,289,233,0,0,80,190,'c_dungeon_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.52,'false',1,0),
(1035,21225,'Sepulcher Sage','','vale_master_10_bi',13.00,44.00,62,'male','L2Monster','Fighter',40,3219,30.000,1217,2.700,40,43,30,21,20,10,4169,371,944,330,532,315,278,500,253,311,0,0,70,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.74,'false',1,0),
(1036,21226,'Sepulcher Guardian','','death_knight',12.00,30.00,65,'male','L2Monster','Fighter',40,3465,30.000,1319,2.700,40,43,30,21,20,10,4831,448,1184,380,619,340,278,500,253,0,0,0,27,190,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(1037,21227,'Sepulcher Sage','','doll_master',20.00,42.00,67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,5444,518,1169,373,681,356,278,500,253,0,0,0,80,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.56,'false',1,0),
(1038,21228,'Sepulcher Guard','','skeleton_royal_guard_30_bi',14.00,37.50,70,'male','L2Monster','Fighter',40,3862,30.000,1493,2.700,40,43,30,21,20,10,5211,516,1265,427,780,382,317,0,289,236,0,0,80,200,'c_dungeon_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.52,'false',1,0),
(1039,21229,'Sepulcher Preacher','','vale_master_30_bi',15.00,52.00,72,'male','L2Monster','Fighter',40,4013,34.000,1565,3.000,40,43,30,21,20,10,5623,571,1413,417,849,399,278,500,253,326,0,0,70,165,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.74,'false',1,0),
(1040,21230,'Sepulcher Guard','','death_knight',12.00,30.00,75,'male','L2Monster','Fighter',40,4229,34.000,1673,3.000,40,43,30,21,20,10,6432,678,1720,475,957,425,278,500,253,0,0,0,27,200,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(1041,21231,'Sepulcher Preacher','','doll_master_20_bi',24.00,50.40,77,'male','L2Monster','Fighter',40,4364,34.000,1747,3.000,40,43,30,21,20,10,6431,696,1664,463,1031,442,278,500,253,0,0,0,80,165,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.56,'false',1,0),
(1042,21232,'Barrow Guardian','','skeleton',11.00,25.00,20,'male','L2Monster','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(1043,21233,'Barrow Seer','','binding',12.00,21.00,22,'male','L2Monster','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(1044,21234,'Grave Guardian','','imp',10.00,24.00,25,'male','L2Monster','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(1045,21235,'Grave Seer','','succubus',10.00,36.00,27,'male','L2Monster','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(1046,21236,'Barrow Sentinel','','skeleton_bi',11.00,31.00,30,'male','L2Monster','Fighter',40,954,14.000,365,1.500,40,43,30,21,20,10,957,52,132,140,58,114,278,0,253,69,0,0,60,140,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',1,0),
(1047,21237,'Barrow Monk','','binding_20_bi',14.00,25.30,32,'male','L2Monster','Fighter',40,1056,18.000,397,1.800,40,43,30,21,20,10,1110,62,154,129,69,123,278,500,253,0,0,0,10,110,'c_dungeon_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.54,'false',1,0),
(1048,21238,'Grave Sentinel','','imp_bi',10.00,30.00,35,'male','L2Monster','Fighter',40,1220,18.000,446,1.800,40,43,30,21,20,10,1400,83,192,169,89,137,278,500,253,0,0,0,60,140,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(1049,21239,'Grave Monk','','succubus_bi',10.00,43.20,37,'female','L2Monster','Mystic',40,1338,18.000,480,1.800,40,43,30,21,20,10,1485,91,222,154,104,147,278,500,253,0,0,0,60,120,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.84,'false',1,0),
(1050,21240,'Barrow Overlord','','skeleton_knight_20_bi',12.00,30.50,40,'male','L2Monster','Fighter',40,1527,18.000,531,1.800,40,43,30,21,20,10,1701,110,300,183,131,164,278,0,253,129,0,0,40,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(1051,21241,'Barrow Priest','','banshee_20_bi',10.00,27.50,42,'female','L2Monster','Priest',40,1660,22.000,589,2.100,40,43,30,21,20,10,1913,127,311,183,152,175,278,500,253,0,0,0,80,135,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.56,'false',1,0),
(1052,21242,'Grave Overlord','','death_blader_10_sm',14.00,40.50,45,'male','L2Monster','Fighter',40,1870,22.000,677,2.100,40,43,30,21,20,10,2315,161,415,216,188,193,278,500,253,297,0,0,100,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(1053,21243,'Grave Priest','','bloody_queen_10_sm',13.00,38.00,47,'female','L2Monster','Priest',40,2016,22.000,738,2.100,40,43,30,21,20,10,2396,171,427,215,216,206,278,500,253,0,0,0,80,135,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(1054,21244,'Crypt Archon','','skeleton_knight_30_bi',13.00,33.00,50,'male','L2Monster','Fighter',40,2245,22.000,830,2.100,40,43,30,21,20,10,2658,200,560,253,264,226,278,0,253,131,0,0,40,170,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(1055,21245,'Crypt Inquisitor','','banshee_30_bi',11.00,30.00,52,'female','L2Monster','Mystic',40,2402,26.000,892,2.400,40,43,30,21,20,10,2933,227,570,251,300,239,278,500,253,0,0,0,80,145,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.56,'false',1,0),
(1056,21246,'Tomb Archon','','death_blader_10_bi',16.00,49.50,55,'male','L2Monster','Fighter',40,2643,26.000,987,2.400,40,43,30,21,20,10,3459,279,737,292,360,261,278,500,253,298,0,0,100,170,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(1057,21247,'Tomb Inquisitor','','bloody_queen_10_bi',15.00,46.00,57,'female','L2Monster','Mystic',40,2806,26.000,1052,2.400,40,43,30,21,20,10,3524,293,743,289,405,276,278,500,253,0,0,0,80,145,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(1058,21248,'Crypt Guardian','','skeleton_royal_guard_20_bi',13.00,34.50,60,'male','L2Monster','Fighter',40,3054,26.000,1150,2.400,40,43,30,21,20,10,3828,332,828,335,478,299,317,0,289,233,0,0,80,190,'c_dungeon_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.52,'false',1,0),
(1059,21249,'Crypt Sage','','vale_master_10_bi',13.00,44.00,62,'male','L2Monster','Fighter',40,3219,30.000,1217,2.700,40,43,30,21,20,10,4169,371,944,330,532,315,278,500,253,311,0,0,70,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.74,'false',1,0),
(1060,21250,'Tomb Guardian','','death_knight',12.00,30.00,65,'male','L2Monster','Fighter',40,3465,30.000,1319,2.700,40,43,30,21,20,10,4831,448,1184,380,619,340,278,500,253,0,0,0,27,190,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(1061,21251,'Tomb Sage','','doll_master',20.00,42.00,67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,5444,518,1169,373,681,356,278,500,253,0,0,0,80,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.56,'false',1,0),
(1062,21252,'Crypt Guard','','skeleton_royal_guard_30_bi',14.00,37.50,70,'male','L2Monster','Fighter',40,3862,30.000,1493,2.700,40,43,30,21,20,10,5211,516,1265,427,780,382,317,0,289,236,0,0,80,200,'c_dungeon_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.52,'false',1,0),
(1063,21253,'Crypt Preacher','','vale_master_30_bi',15.00,52.00,72,'male','L2Monster','Fighter',40,4013,34.000,1565,3.000,40,43,30,21,20,10,5623,571,1413,417,849,399,278,500,253,326,0,0,70,165,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.74,'false',1,0),
(1064,21254,'Tomb Guard','','death_knight',12.00,30.00,75,'male','L2Monster','Fighter',40,4229,34.000,1673,3.000,40,43,30,21,20,10,6432,678,1720,475,957,425,278,500,253,78,0,0,27,200,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(1065,21255,'Tomb Preacher','','doll_master_20_bi',24.00,50.40,77,'male','L2Monster','Fighter',40,4364,34.000,1747,3.000,40,43,30,21,20,10,7190,778,1664,463,1031,442,278,500,253,0,0,0,80,165,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,10,0.56,'false',1,0),
(1066,21256,'Underground Werewolf','','werewolf_bi',11.00,29.70,23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,754,36,75,91,31,87,278,400,253,0,0,0,50,135,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.43,'true',1,0),
(1067,21257,'Evil Eye Seer','','monster_eye',21.00,43.00,18,'male','L2Monster','Mystic',40,476,2.500,193,1.200,40,43,30,21,20,10,646,28,48,73,19,70,278,0,253,0,0,0,90,155,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.30,'true',1,0),
(1068,21258,'Fallen Orc Shaman','','ketra_orc_shaman',10.00,23.00,58,'male','L2Monster','PolimorphingShaman',40,2889,6.500,1084,2.400,40,43,30,21,20,10,0,0,781,297,428,284,278,0,253,9,0,0,10,130,'fallen_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.34,'true',1,0),
(1069,21259,'Fallen Orc Shaman','','Saber_toothed_Tiger',34.00,28.00,59,'male','L2Monster','Fighter',40,2971,6.500,1117,2.400,40,43,30,21,20,10,12983,1110,820,305,453,291,278,500,253,0,0,0,60,180,'fallen_clan',1000,'SYS','',0,0,0,7,30,4,4,0,10,0.45,'true',0,0),
(1070,21260,'Betrayer Orc Hero','','Ketra_Orc_Warrior',12.00,24.00,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3691,278,509,278,264,226,278,0,253,74,0,0,36,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'true',0,0),
(1071,21261,'Ol Mahum Transcender','','ol_mahum',13.50,25.00,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,4284,323,509,236,264,226,278,0,253,127,0,0,50,130,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.46,'true',1,0),
(1072,21262,'Ol Mahum Transcender','','ol_mahum_champion',14.00,27.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,7732,608,602,304,319,247,278,500,253,127,0,0,50,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.63,'true',0,0),
(1073,21263,'Ol Mahum Transcender','','oel_mahum',20.00,37.00,55,'male','L2Monster','Fighter',40,2643,6.500,987,2.400,40,43,30,21,20,10,11790,952,670,322,360,261,278,500,253,127,0,0,70,150,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',0,0),
(1074,21264,'Ol Mahum Transcender','','kel_mahum',13.00,26.00,58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,19082,1612,781,349,428,284,278,500,253,127,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',0,0),
(1075,21265,'Cave Ant Larva','','ant_larva',12.00,8.00,36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,1586,96,206,175,96,142,278,0,253,0,0,0,40,60,'ant_clan',500,'Local','',0,0,0,7,30,4,4,0,0,0.35,'true',0,0),
(1076,21266,'Cave Ant Larva','','ant_larva',12.00,8.00,36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,278,0,253,0,0,0,40,60,'ant_clan',500,'Local','',0,0,0,7,30,4,4,0,0,0.35,'true',0,0),
(1077,21267,'Cave Ant Larva','','ant_larva',12.00,8.00,36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,278,0,253,0,0,0,40,60,'ant_clan',500,'Local','',0,0,0,7,30,4,4,0,0,0.35,'true',0,0),
(1078,21268,'Cave Ant Larva','','ant_larva',12.00,8.00,36,'male','L2Monster','Fighter',40,1279,9.000,463,1.800,40,43,30,21,20,10,1475,89,187,193,96,142,278,0,253,0,0,0,40,60,'ant_clan',500,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',0,0),
(1079,21269,'Cave Ant','','ant',26.00,15.00,37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,3368,207,222,154,104,147,278,500,253,0,0,0,40,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.26,'true',0,0),
(1080,21270,'Cave Ant Soldier','','ant_soldier',35.00,17.00,38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,3891,243,238,188,112,153,278,500,253,0,0,0,80,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',0,0),
(1081,21271,'Cave Ant','','ant',26.00,15.00,37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,2298,141,222,154,104,147,278,500,253,0,0,0,40,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.26,'true',0,0),
(1082,21272,'Cave Ant Soldier','','ant_soldier',35.00,17.00,38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,4085,255,238,188,112,153,278,500,253,0,0,0,80,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',0,0),
(1083,21273,'Cave Noble Ant','','noble_ant',20.00,48.00,39,'male','L2Monster','Fighter',40,1462,9.000,514,1.800,40,43,30,21,20,10,5918,376,280,177,121,158,278,500,253,0,0,0,80,174,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(1084,21274,'Kookaburra','','youth_ostrich',8.00,26.40,67,'male','L2Monster','Fighter',40,3626,3.750,1388,2.700,40,43,30,21,20,10,8356,796,1169,373,681,356,278,0,253,0,0,0,23,190,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.54,'true',1,0),
(1085,21275,'Kookaburra','','youth_ostrich',8.00,26.40,67,'male','L2Monster','Fighter',40,3626,3.750,1388,2.700,40,43,30,21,20,10,8356,796,1415,308,681,356,278,0,253,0,0,0,23,190,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.54,'true',1,0),
(1086,21276,'Kookaburra','','youth_ostrich',8.00,26.40,67,'male','L2Monster','Fighter',40,3626,3.750,1388,2.700,40,43,30,21,20,10,8356,796,1063,410,681,356,278,0,253,0,0,0,23,190,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.54,'true',1,0),
(1087,21277,'Kookaburra','','youth_ostrich',8.00,26.40,67,'male','L2Monster','Fighter',40,3626,3.750,1388,2.700,40,43,30,21,20,10,5875,560,1169,373,681,356,278,0,253,0,0,0,23,190,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.54,'true',1,0),
(1088,21278,'Antelope','','antelope',17.00,34.00,68,'male','L2Monster','Fighter',40,3706,3.750,1423,2.700,40,43,30,21,20,10,8608,832,1217,449,713,365,278,0,253,0,0,0,45,185,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1089,21279,'Antelope','','antelope',17.00,34.00,68,'male','L2Monster','Fighter',40,3706,3.750,1423,2.700,40,43,30,21,20,10,8608,832,1106,494,713,365,278,0,253,0,0,0,45,165,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1090,21280,'Antelope','','antelope',17.00,34.00,68,'male','L2Monster','Mystic',40,3706,3.750,1423,2.700,40,43,30,21,20,10,8608,832,1473,371,713,365,278,0,253,0,0,0,45,165,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1091,21281,'Antelope','','antelope',17.00,34.00,68,'male','L2Monster','Fighter',40,3706,3.750,1423,2.700,40,43,30,21,20,10,6052,584,1217,449,713,365,278,0,253,0,0,0,45,165,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1092,21282,'Bandersnatch','','bandersnatch',18.00,25.00,69,'male','L2Monster','Fighter',40,3784,3.750,1458,2.700,40,43,30,21,20,10,9040,884,1757,460,746,373,200,150,182,0,0,0,30,170,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.49,'true',1,0),
(1093,21283,'Bandersnatch','','bandersnatch',18.00,25.00,69,'male','L2Monster','Fighter',40,3784,3.750,1458,2.700,40,43,30,21,20,10,9040,884,2127,380,746,373,200,150,182,0,0,0,30,170,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.49,'true',1,0),
(1094,21284,'Bandersnatch','','bandersnatch',18.00,25.00,69,'male','L2Monster','Fighter',40,3784,3.750,1458,2.700,40,43,30,21,20,10,9040,884,1598,506,746,373,200,150,182,0,0,0,30,170,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.49,'true',1,0),
(1095,21285,'Bandersnatch','','bandersnatch',18.00,25.00,69,'male','L2Monster','Mystic',40,3784,3.750,1458,2.700,40,43,30,21,20,10,6356,622,1757,460,746,373,200,0,182,0,0,0,30,170,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.49,'true',1,0),
(1096,21286,'Buffalo','','buffalo',22.00,31.00,70,'male','L2Monster','Fighter',40,3862,3.750,1493,2.700,40,43,30,21,20,10,9121,904,1825,470,780,382,200,0,182,0,0,0,20,170,'animal_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.46,'true',1,0),
(1097,21287,'Buffalo','','buffalo',22.00,31.00,70,'male','L2Monster','Fighter',40,3862,3.750,1493,2.700,40,43,30,21,20,10,9121,904,1659,517,780,382,200,0,182,0,0,0,20,170,'animal_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.46,'true',1,0),
(1098,21288,'Buffalo','','buffalo',22.00,31.00,70,'male','L2Monster','Fighter',40,3862,3.750,1493,2.700,40,43,30,21,20,10,9121,904,2209,388,780,382,200,0,182,0,0,0,20,170,'animal_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.46,'true',1,0),
(1099,21289,'Buffalo','','buffalo',22.00,31.00,70,'male','L2Monster','Fighter',40,3862,3.750,1493,2.700,40,43,30,21,20,10,6413,636,1825,470,780,382,200,0,182,0,0,0,20,170,'animal_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.46,'true',1,0),
(1100,21290,'Grendel','','bionic_bear',15.00,39.00,71,'male','L2Monster','Fighter',40,3938,4.250,1529,3.000,40,43,30,21,20,10,9572,960,1894,481,814,390,200,150,182,0,0,0,36,160,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1101,21291,'Grendel','','bionic_bear',15.00,39.00,71,'male','L2Monster','Fighter',40,3938,4.250,1529,3.000,40,43,30,21,20,10,9572,960,1721,529,814,390,200,150,182,0,0,0,36,160,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1102,21292,'Grendel','','bionic_bear',15.00,39.00,71,'male','L2Monster','Fighter',40,3938,4.250,1529,3.000,40,43,30,21,20,10,9572,960,2291,397,814,390,200,150,182,0,0,0,36,160,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1103,21293,'Grendel','','bionic_bear',15.00,39.00,71,'male','L2Monster','Mystic',40,3938,4.250,1529,3.000,40,43,30,21,20,10,6730,676,1894,481,814,390,200,0,182,0,0,0,36,160,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1104,21294,'Canyon Antelope','','antelope',17.00,34.00,68,'male','L2Monster','Fighter',40,3706,15.000,1423,2.700,40,43,30,21,20,10,6893,666,1217,449,713,365,278,0,253,0,0,0,45,185,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1105,21295,'Canyon Antelope Slave','','antelope',17.00,34.00,69,'male','L2Monster','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,7311,715,1265,460,746,373,278,150,253,0,0,0,45,165,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1106,21296,'Canyon Bandersnatch','','bandersnatch',18.00,25.00,70,'male','L2Monster','Fighter',40,3862,22.500,1493,2.700,40,43,30,21,20,10,7244,718,2429,353,780,382,200,150,182,0,0,0,30,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.49,'false',1,0),
(1107,21297,'Canyon Bandersnatch Slave','','bandersnatch',18.00,25.00,71,'male','L2Monster','Fighter',40,3938,25.500,1529,3.000,40,43,30,21,20,10,7275,730,1721,529,814,390,200,150,182,0,0,0,30,170,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.49,'false',1,0),
(1108,21298,'Eye of Restrainer','','monster_eye',21.00,43.00,71,'male','L2Monster','Mystic',40,3938,17.000,1529,3.000,40,43,30,21,20,10,7023,705,1239,449,814,390,278,150,253,0,0,0,90,140,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,10,0.30,'false',1,0),
(1109,21299,'Buffalo Slave','','buffalo_ec',22.00,31.00,72,'male','L2Monster','Fighter',40,4013,25.500,1565,3.000,40,43,30,21,20,10,7481,760,2159,446,849,399,200,150,182,0,0,0,20,160,'eye_clan',400,'Local','',0,0,0,7,50,1,9,0,0,0.46,'false',1,0),
(1110,21300,'Eye of Guide','','parasitic_eye_20_sm',20.00,50.50,72,'male','L2Monster','Mystic',40,4013,25.500,1565,3.000,40,43,30,21,20,10,7360,747,1168,505,849,399,278,0,253,0,0,0,30,155,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(1111,21301,'Gaze of Nightmare','','field_stalker',15.00,30.00,72,'male','L2Monster','Fighter',40,4013,34.000,1565,3.000,40,43,30,21,20,10,6624,673,1061,654,849,399,278,0,253,0,0,0,70,195,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.41,'false',1,0),
(1112,21302,'Eye of Watchman','','parasitic_eye',25.00,63.00,73,'male','L2Monster','Mystic',40,4086,25.500,1601,3.000,40,43,30,21,20,10,7105,731,1770,352,885,407,278,150,253,0,0,0,30,160,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(1113,21303,'Homunculus','','homunculus_20_sm',10.00,26.00,73,'male','L2Monster','Fighter',40,4086,25.500,1601,3.000,40,43,30,21,20,10,7185,739,1947,320,885,407,278,150,253,0,0,0,30,185,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(1114,21304,'Grendel Slave','','bionic_bear',15.00,39.00,74,'male','L2Monster','Fighter',40,4158,34.000,1637,3.000,40,43,30,21,20,10,7918,825,2312,466,921,416,200,150,182,0,0,0,36,140,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1115,21305,'Eye of Pilgrim','','parasitic_eye_20_sm',20.00,50.50,74,'male','L2Monster','Mystic',40,4158,25.500,1637,3.000,40,43,30,21,20,10,7775,810,1375,479,921,416,278,0,253,0,0,0,30,165,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(1116,21306,'Disciples of Protection','','apostle_warrior',8.00,30.00,74,'female','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,8441,880,1579,682,921,416,200,150,182,6717,0,0,50,160,'divine_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1117,21307,'Elder Homunculus','','homunculus',12.00,32.50,75,'male','L2Monster','Mystic',40,4229,34.000,1673,3.000,40,43,30,21,20,10,7394,780,1892,367,957,425,278,150,253,0,0,0,30,200,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(1118,21308,'Disciples of Punishment','','apostle_warrior',8.00,30.00,75,'female','L2Monster','Fighter',40,4229,42.500,1673,3.000,40,43,30,21,20,10,7860,829,2389,475,957,425,200,150,182,6717,0,0,50,190,'divine_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1119,21309,'Disciples of Punishment','','apostle_warrior',8.00,30.00,75,'female','L2Monster','Fighter',40,4229,42.500,1673,3.000,40,43,30,21,20,10,8192,864,1795,633,957,425,200,150,182,6717,0,0,50,190,'divine_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1120,21310,'Disciples of Authority','','apostle_mage',11.00,38.50,76,'male','L2Monster','Mystic',40,4297,42.500,1710,3.000,40,43,30,21,20,10,8071,863,1775,412,994,433,278,150,253,6718,0,0,50,155,'divine_clan',600,'Local','',0,0,0,7,50,1,9,0,10,0.48,'false',1,0),
(1121,21311,'Disciples of Authority','','apostle_mage',11.00,38.50,76,'male','L2Monster','Mystic',40,4297,42.500,1710,3.000,40,43,30,21,20,10,7441,795,1334,549,994,433,278,150,253,6718,0,0,50,155,'divine_clan',600,'Local','',0,0,0,7,50,1,9,0,10,0.48,'false',1,0),
(1122,21312,'Eye of Ruler','','parasitic_eye',25.00,63.00,74,'male','L2Monster','Mystic',40,4158,25.500,1637,3.000,40,43,30,21,20,10,10752,1121,1375,479,921,416,278,150,253,0,0,0,30,160,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',1,0),
(1123,21313,'Sly Hound Dog','','bandersnatch',18.00,25.00,72,'male','L2Minion','Fighter',40,4013,25.500,1565,3.000,40,43,30,21,20,10,10294,1046,2375,406,849,399,200,0,182,0,0,0,30,185,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.49,'false',1,0),
(1124,21314,'Hot Springs Bandersnatchling','','bandersnatch',18.00,25.00,73,'male','L2Monster','HotSpringsBandersnatchling',40,4086,17.000,1601,3.000,40,43,30,21,20,10,8609,886,2032,502,885,407,200,150,182,0,0,0,30,170,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.49,'false',1,0),
(1125,21315,'Hot Springs Buffalo','','buffalo',22.00,31.00,73,'male','L2Monster','Fighter',40,4086,26.860,1601,3.090,40,43,30,21,20,10,8971,923,2032,502,885,407,200,0,333,0,0,0,22,187,'',0,'Magister','',0,0,0,7,50,1,9,0,0,0.46,'false',1,0),
(1126,21316,'Hot Springs Flava','','flava',18.00,34.00,74,'male','L2Monster','HotSpringsFlava',40,4158,17.000,1637,3.000,40,43,30,21,20,10,10556,1100,1513,512,921,416,278,150,253,0,0,0,30,165,'',0,'Magister','',0,0,0,7,50,1,9,0,0,0.45,'false',1,0),
(1127,21317,'Hot Springs Atroxspawn','','kailiharim',57.00,39.00,74,'male','L2Monster','HotSpringsAtroxspawn',40,4158,26.860,1637,3.090,40,43,30,21,20,10,8846,922,2102,512,921,416,200,150,333,0,0,0,115,192,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1128,21318,'Hot Springs Antelope','','antelope',17.00,34.00,74,'male','L2Monster','Fighter',40,4158,17.000,1637,3.000,40,43,30,21,20,10,9247,964,1513,512,921,416,278,0,253,0,0,0,45,185,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1129,21319,'Hot Springs Nepenthes','','nephenthes',28.00,43.50,75,'male','L2Monster','HotSpringsNepenthes',40,4229,26.860,1673,3.090,40,43,30,21,20,10,11636,1227,2172,523,957,425,200,150,333,0,0,0,52,187,'',0,'Magister','',0,0,0,7,50,1,9,0,0,0.47,'false',1,0),
(1130,21320,'Hot Springs Yeti','','yeti_20_bi',18.00,32.00,75,'male','L2Monster','Fighter',40,4229,17.000,1673,3.000,40,43,30,21,20,10,9470,999,1563,523,957,425,278,0,253,0,0,0,16,170,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1131,21321,'Hot Springs Atrox','','kailiharim',57.00,39.00,76,'male','L2Monster','HotSpringsAtrox',40,4297,17.000,1710,3.000,40,43,30,21,20,10,11135,1190,2242,534,994,433,200,150,182,0,0,0,105,175,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1132,21322,'Hot Springs Bandersnatch','','bandersnatch',18.00,25.00,76,'male','L2Monster','HotSpringsBandersnatch',40,4297,17.000,1710,3.000,40,43,30,21,20,10,11135,1190,2242,534,994,433,200,150,182,0,0,0,30,170,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.49,'false',1,0),
(1133,21323,'Hot Springs Grendel','','bionic_bear',15.00,39.00,76,'male','L2Monster','Fighter',40,4297,26.860,1710,3.090,40,43,30,21,20,10,9753,1042,2242,534,994,433,200,0,333,0,0,0,39,181,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1134,21324,'Ketra Orc Footman','','ketra_orc',12.00,29.00,77,'male','L2Monster','Fighter',40,4364,17.000,1747,3.000,40,43,30,21,20,10,9323,1009,1664,544,1031,442,278,150,253,79,0,0,45,175,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1135,21325,'Ketra''s War Hound','','bandersnatch',18.00,25.00,77,'male','L2Monster','Fighter',40,4364,17.000,1747,3.000,40,43,30,21,20,10,9015,975,2543,495,1031,442,200,150,182,0,0,0,30,185,'ketra_orc_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.49,'false',1,0),
(1136,21326,'Grazing Kookaburra','','youth_ostrich',8.00,26.40,77,'male','L2Monster','Fighter',40,4364,17.000,1747,3.000,40,43,30,21,20,10,9015,975,1375,560,1031,442,278,150,253,0,0,0,23,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.54,'false',1,0),
(1137,21327,'Ketra Orc Raider','','ketra_orc_warrior',12.00,24.00,78,'male','L2Monster','Fighter',40,4428,17.000,1784,3.000,40,43,30,21,20,10,10240,1120,2075,459,1069,451,278,150,253,79,6919,0,36,175,'ketra_orc_clan',300,'Local','',0,20,166,7,30,4,4,0,-6,0.54,'false',1,0),
(1138,21328,'Ketra Orc Scout','','ketra_orc_archer',12.00,27.00,78,'male','L2Monster','Ranger',500,4428,17.000,1784,3.000,40,43,30,21,20,10,9816,1074,3464,611,1069,451,249,150,227,288,0,0,45,175,'ketra_orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.91,'false',1,0),
(1139,21329,'Ketra Orc Shaman','','ketra_orc_shaman',10.00,23.00,79,'male','L2Monster','Priest',40,4490,17.000,1821,3.000,40,43,30,21,20,10,9955,1103,1765,481,1107,459,278,150,253,92,0,0,10,150,'ketra_orc_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.34,'false',1,0),
(1140,21330,'Grazing Buffalo','','buffalo',22.00,31.00,79,'male','L2Monster','Fighter',40,4490,17.000,1821,3.000,40,43,30,21,20,10,9489,1051,2026,685,1107,459,200,150,182,0,0,0,20,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.46,'false',1,0),
(1141,21331,'Ketra Orc Warrior','','ketra_orc_warrior',12.00,24.00,80,'male','L2Monster','Fighter',40,4550,17.000,1859,3.000,40,43,30,21,20,10,9304,1044,1996,524,1144,468,278,150,253,79,6919,0,36,175,'ketra_orc_clan',300,'Local','',0,20,170,7,30,4,4,0,-6,0.54,'false',1,0),
(1142,21332,'Ketra Orc Lieutenant','','ketra_orc_chieftain',11.00,38.50,80,'male','L2Monster','Fighter',40,4550,17.000,1859,3.000,40,43,30,21,20,10,10420,1169,2291,634,1144,468,200,150,182,6719,0,0,24,175,'ketra_orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.51,'false',1,0),
(1143,21333,'Grazing Windsus','','giant_wild_hog',25.00,27.00,80,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,9976,1133,1540,710,1182,477,278,150,253,0,0,0,35,170,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.54,'false',1,0),
(1144,21334,'Ketra Orc Medium','','ketra_orc_shaman',10.00,23.00,80,'male','L2Monster','Priest',40,4608,17.000,1896,3.000,40,43,30,21,20,10,14933,1695,1863,499,1182,477,278,150,253,92,0,0,10,150,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.34,'false',1,0),
(1145,21335,'Ketra Orc Elite Soldier','','ketra_orc',12.00,29.00,80,'male','L2Monster','Fighter',40,4663,17.000,1934,3.000,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,79,0,0,45,175,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1146,21336,'Ketra Orc White Captain','','ketra_orc_overload_20_bi',14.00,28.80,80,'male','L2Monster','Fighter',40,4663,17.000,1934,3.000,40,43,30,21,20,10,11317,1300,1738,657,1220,485,278,150,253,80,0,0,33,175,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1147,21337,'Grazing Elder Buffalo','','buffalo',22.00,31.00,80,'male','L2Monster','Fighter',40,4716,17.000,1972,3.000,40,43,30,21,20,10,10475,1217,2249,736,1258,494,200,150,182,0,0,0,20,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.46,'false',1,0),
(1148,21338,'Ketra Orc Seer','','ketra_orc_shaman',10.00,23.00,80,'male','L2Monster','Priest',40,4716,17.000,1972,3.000,40,43,30,21,20,10,13783,1602,2155,470,1258,494,278,150,253,213,0,0,10,160,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.34,'false',1,0),
(1149,21339,'Ketra Orc General','','ketra_orc_chieftain_20_bi',17.00,46.20,80,'male','L2Monster','Fighter',40,4766,17.000,2011,3.000,40,43,30,21,20,10,10494,1234,3372,511,1296,502,200,150,182,6719,0,0,24,175,'ketra_orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.51,'false',1,0),
(1150,21340,'Ketra Orc Battalion Commander','','ketra_orc_warlord',12.00,30.00,80,'male','L2Monster','Fighter',40,4766,17.000,2011,3.000,40,43,30,21,20,10,10494,1234,2006,619,1296,502,278,150,253,80,6919,0,27,175,'ketra_orc_clan',300,'Local','',0,20,178,7,30,4,4,0,-6,0.48,'false',1,0),
(1151,21341,'Grazing Elder Kookaburra','','youth_ostrich',8.00,26.40,80,'male','L2Monster','Fighter',40,4813,17.000,2049,3.000,40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,150,253,0,0,0,23,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.54,'false',1,0),
(1152,21342,'Ketra Orc Grand Seer','','ketra_orc_shaman',10.00,23.00,80,'male','L2Monster','Priest',40,4813,17.000,2049,3.000,40,43,30,21,20,10,14456,1720,2052,629,1333,511,278,150,253,213,0,0,10,160,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(1153,21343,'Ketra Commander','','ketra_orc_warlord_20_bi',14.00,36.00,80,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,16400,1862,1630,587,1182,477,317,150,289,80,6919,0,27,175,'ketra_orc_clan',300,'Local','',0,20,172,7,10,8,0,0,-6,0.48,'false',1,0),
(1154,21344,'Ketra Elite Guard','','ketra_orc_overload',12.00,24.00,80,'male','L2Monster','Fighter',40,4550,17.000,1859,3.000,40,43,30,21,20,10,11138,1250,2195,476,1144,468,278,0,253,80,0,0,33,180,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(1155,21345,'Ketra''s Head Shaman','','ketra_orc_shaman',10.00,23.00,80,'male','L2Monster','Priest',40,4813,17.000,2049,3.000,40,43,30,21,20,10,12360,1471,2257,572,1333,511,278,150,253,210,0,0,10,175,'ketra_orc_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,0.34,'false',1,0),
(1156,21346,'Ketra''s Head Guard','','ketra_orc_chieftain',11.00,38.50,80,'male','L2Minion','Fighter',40,4766,17.000,2011,3.000,40,43,30,21,20,10,12279,1444,2303,749,1296,502,200,0,182,6719,0,0,24,175,'ketra_orc_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,0.51,'false',1,0),
(1157,21347,'Ketra Prophet','','ketra_orc_shaman',10.00,23.00,80,'male','L2Monster','Priest',40,4899,17.000,2127,3.000,40,43,30,21,20,10,18779,2289,2141,650,1406,528,278,150,253,213,0,0,10,175,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(1158,21348,'Prophet''s Guard','','ketra_orc_chieftain',11.00,38.50,80,'male','L2Minion','Fighter',40,4858,17.000,2088,3.000,40,43,30,21,20,10,12871,1550,2913,639,1370,519,200,0,182,6719,0,0,24,180,'ketra_orc_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,0.51,'false',1,0),
(1159,21349,'Prophet''s Aide','','ketra_orc_shaman',10.00,23.00,80,'male','L2Minion','Priest',40,4858,17.000,2088,3.000,40,43,30,21,20,10,13071,1574,2097,639,1370,519,278,0,253,210,0,0,10,180,'ketra_orc_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,0.34,'false',1,0),
(1160,21350,'Varka Silenos Recruit','','barka_silenos_hunter',16.00,38.00,77,'male','L2Monster','Fighter',40,4364,17.000,1747,3.000,40,43,30,21,20,10,9851,1066,1664,544,1031,442,278,150,253,2504,0,0,44,175,'varka_silenos_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1161,21351,'Varka Silenos Footman','','barka_silenos_warrior',16.00,41.00,77,'male','L2Monster','Fighter',40,4364,17.000,1747,3.000,40,43,30,21,20,10,8487,918,1831,495,1031,442,278,150,253,2504,0,0,34,185,'varka_silenos_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1162,21352,'Grazing Antelope','','antelope',17.00,34.00,77,'male','L2Monster','Fighter',40,4364,17.000,1747,3.000,40,43,30,21,20,10,9015,975,1375,560,1031,442,278,150,253,0,0,0,45,185,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.46,'false',1,0),
(1163,21353,'Varka Silenos Scout','','barka_silenos_hunter',16.00,38.00,78,'male','L2Monster','Fighter',40,4428,17.000,1784,3.000,40,43,30,21,20,10,9906,1084,2075,459,1069,451,278,150,253,142,6918,0,44,175,'varka_silenos_clan',300,'Local','',0,20,166,7,30,4,4,0,-6,0.48,'false',1,0),
(1164,21354,'Varka Silenos Hunter','','barka_silenos_archer',8.00,37.50,78,'male','L2Monster','Fighter',500,4428,17.000,1784,3.000,40,43,30,21,20,10,9816,1074,3464,611,1069,451,249,150,227,6917,0,0,30,175,'varka_silenos_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.59,'false',1,0),
(1165,21355,'Varka Silenos Shaman','','barka_silenos_shaman',14.00,39.50,79,'male','L2Monster','Priest',40,4490,17.000,1821,3.000,40,43,30,21,20,10,9492,1052,2451,481,1107,459,200,150,182,6716,0,0,36,150,'varka_silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.49,'false',1,0),
(1166,21356,'Grazing Nepenthes','','nephenthes',28.00,43.50,79,'male','L2Monster','Fighter',40,4490,17.000,1821,3.000,40,43,30,21,20,10,9489,1051,2026,685,1107,459,200,150,182,0,0,0,48,170,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.47,'false',1,0),
(1167,21357,'Varka Silenos Priest','','barka_silenos_priest',9.00,41.50,80,'male','L2Monster','Priest',40,4550,17.000,1859,3.000,40,43,30,21,20,10,10277,1153,1996,524,1144,468,278,150,253,6716,0,0,36,175,'varka_silenos_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.47,'false',1,0),
(1168,21358,'Varka Silenos Warrior','','barka_silenos_warrior',16.00,41.00,80,'male','L2Monster','Fighter',40,4550,17.000,1859,3.000,40,43,30,21,20,10,10771,1209,1649,634,1144,468,278,150,253,142,6918,0,34,175,'varka_silenos_clan',300,'Local','',0,20,170,7,30,4,4,0,-6,0.48,'false',1,0),
(1169,21359,'Grazing Bandersnatch','','bandersnatch',18.00,25.00,80,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,9976,1133,2139,710,1182,477,200,150,182,0,0,0,30,175,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.49,'false',1,0),
(1170,21360,'Varka Silenos Medium','','barka_silenos_shaman',14.00,39.50,80,'male','L2Monster','Priest',40,4608,17.000,1896,3.000,40,43,30,21,20,10,15892,1804,2588,499,1182,477,200,150,182,6716,0,0,36,150,'varka_silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.49,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(1171,21361,'Varka Silenos Magus','','barka_silenos_mage_20_bi',11.00,55.20,80,'male','L2Monster','Mystic',40,4663,17.000,1934,3.000,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'varka_silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.45,'false',1,0),
(1172,21362,'Varka Silenos Officer','','barka_silenos_chieftain',18.00,42.50,80,'male','L2Monster','Fighter',40,4663,17.000,1934,3.000,40,43,30,21,20,10,11317,1300,2414,657,1220,485,200,150,182,2504,0,0,25,175,'varka_silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(1173,21363,'Grazing Flava','','flava',18.00,34.00,80,'male','L2Monster','Fighter',40,4716,17.000,1972,3.000,40,43,30,21,20,10,10475,1217,1619,736,1258,494,278,150,253,0,0,0,30,165,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(1174,21364,'Varka Silenos Seer','','barka_silenos_shaman',14.00,39.50,80,'male','L2Monster','Priest',40,4716,17.000,1972,3.000,40,43,30,21,20,10,13272,1543,2994,470,1258,494,200,150,182,6716,0,0,36,160,'varka_silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.49,'false',1,0),
(1175,21365,'Varka Silenos Great Magus','','barka_silenos_warrior_20_bi',20.00,49.20,80,'male','L2Monster','Fighter',40,4766,17.000,2011,3.000,40,43,30,21,20,10,11525,1355,2428,511,1296,502,278,150,253,2500,0,0,34,175,'varka_silenos_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1176,21366,'Varka Silenos General','','barka_silenos_chieftain',18.00,42.50,80,'male','L2Monster','Fighter',40,4766,17.000,2011,3.000,40,43,30,21,20,10,12718,1496,2787,619,1296,502,200,150,182,2500,0,0,25,175,'varka_silenos_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1177,21367,'Grazing Elder Antelope','','antelope',17.00,34.00,80,'male','L2Monster','Fighter',40,4813,17.000,2049,3.000,40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,150,253,0,0,0,45,185,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.46,'false',1,0),
(1178,21368,'Varka Silenos Great Seer','','barka_silenos_shaman',14.00,39.50,80,'male','L2Monster','Priest',40,4813,17.000,2049,3.000,40,43,30,21,20,10,16964,2019,2851,629,1333,511,200,150,182,6716,0,0,36,160,'varka_silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.49,'false',1,0),
(1179,21369,'Varka''s Commander','','barka_silenos_chieftain_20_bi',22.00,51.00,80,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,15953,1811,2588,587,1182,477,200,150,182,2500,0,0,25,175,'varka_silenos_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1180,21370,'Varka''s Elite Guard','','barka_silenos_warrior',16.00,41.00,80,'male','L2Minion','Fighter',40,4550,17.000,1859,3.000,40,43,30,21,20,10,11565,1298,2195,476,1144,468,278,0,253,2500,0,0,34,180,'varka_silenos_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1181,21371,'Varka''s Head Magus','','barka_silenos_shaman',14.00,39.50,80,'male','L2Monster','Priest',40,4813,17.000,2049,3.000,40,43,30,21,20,10,12360,1471,3136,572,1333,511,200,150,182,6716,0,0,36,175,'varka_silenos_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,0.49,'false',1,0),
(1182,21372,'Varka''s Head Guard','','barka_silenos_hunter',16.00,38.00,80,'male','L2Minion','Fighter',40,4766,17.000,2011,3.000,40,43,30,21,20,10,12279,1444,1658,749,1296,502,278,0,253,2500,6918,0,44,175,'varka_silenos_clan',300,'Local',NULL,0,20,178,7,30,4,4,0,-6,0.48,'false',1,0),
(1183,21373,'Varka''s Prophet','','barka_silenos_shaman_20_bi',17.00,47.50,80,'male','L2Monster','Priest',40,4899,17.000,2127,3.000,40,43,30,21,20,10,18082,2204,2973,650,1406,528,200,150,182,6716,0,0,36,175,'varka_silenos_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,0.54,'false',1,0),
(1184,21374,'Prophet Guard','','barka_silenos_warrior',16.00,41.00,80,'male','L2Minion','Fighter',40,4858,17.000,2088,3.000,40,43,30,21,20,10,12871,1550,2097,639,1370,519,278,0,253,2500,6918,0,34,180,'varka_silenos_clan',300,'Local','',0,20,182,7,30,4,4,0,-6,0.48,'false',1,0),
(1185,21375,'Disciple of Prophet','','barka_silenos_priest',9.00,41.50,80,'male','L2Minion','Priest',40,4858,17.000,2088,3.000,40,43,30,21,20,10,12404,1494,2097,639,1370,519,278,0,253,6716,0,0,36,180,'varka_silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.47,'false',1,0),
(1186,21376,'Scarlet Stakato Walker','','blade_stakato_worker',13.00,40.00,78,'male','L2Monster','Fighter',40,4428,42.500,1784,3.000,40,43,30,21,20,10,7054,772,1886,505,1069,451,278,150,253,235,0,0,25,130,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',1,0),
(1187,21377,'Scarlet Stakato Soldier','','blade_stakato_soldier',15.00,38.00,78,'male','L2Monster','Fighter',40,4428,42.500,1784,3.000,40,43,30,21,20,10,6904,755,1886,429,1069,451,278,150,253,148,0,0,25,180,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.74,'false',1,0),
(1188,21378,'Scarlet Stakato Noble','','blade_stakato_drone',15.00,39.00,79,'male','L2Monster','Fighter',40,4490,42.500,1821,3.000,40,43,30,21,20,10,9829,1089,1941,514,1107,459,278,150,253,235,0,0,25,180,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.58,'false',1,0),
(1189,21379,'Tepra Scorpion','','scorpion_20_sm',24.00,52.80,79,'male','L2Monster','Fighter',40,4490,42.500,1821,3.000,40,43,30,21,20,10,7098,786,1698,514,1107,459,317,150,289,0,0,0,37,125,'fire_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.54,'false',1,0),
(1190,21380,'Tepra Scarab','','scarab',14.00,22.00,79,'male','L2Monster','Fighter',40,4490,42.500,1821,3.000,40,43,30,21,20,10,7237,802,1941,514,1107,459,278,150,253,0,0,0,45,175,'fire_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(1191,21381,'Assassin Beetle','','tera_beetle',19.00,54.50,80,'male','L2Monster','Fighter',40,4550,42.500,1859,3.000,40,43,30,21,20,10,8414,944,1996,524,1144,468,278,150,253,0,0,0,45,145,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.59,'false',1,0),
(1192,21382,'Mercenary of Destruction','','skeleton_knight',10.00,25.00,80,'male','L2Monster','Fighter',40,4550,42.500,1859,3.000,40,43,30,21,20,10,10380,1165,1996,524,1144,468,278,150,253,150,103,0,40,165,'fire_clan',300,'Local','',0,20,170,7,30,4,4,0,-6,0.17,'false',1,0),
(1193,21383,'Knight of Destruction','','skeleton_royal_guard',11.00,28.50,80,'male','L2Monster','Fighter',40,4550,42.500,1859,3.000,40,43,30,21,20,10,10396,1167,1996,524,1144,468,278,150,253,946,945,0,80,185,'fire_clan',300,'Local','',0,20,170,7,30,4,4,0,-6,0.52,'false',1,0),
(1194,21384,'Necromancer of Destruction','','vale_master_20_bi',14.50,48.00,80,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,8915,1012,2050,454,1182,477,278,150,253,0,0,0,70,145,'fire_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.74,'false',1,0),
(1195,21385,'Lavastone Golem','','stone_golem',20.00,31.00,80,'male','L2Monster','Mystic',40,4608,42.500,1896,3.000,40,43,30,21,20,10,8585,975,2050,534,1182,477,278,150,253,0,0,0,23,40,'fire_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.41,'false',1,0),
(1196,21386,'Magma Golem','','lava_golem',22.00,45.00,80,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,9174,1041,2847,534,1182,477,200,150,182,0,0,0,13,60,'fire_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.47,'false',1,0),
(1197,21387,'Arimanes of Destruction','','ahrimanes',14.00,57.75,80,'male','L2Monster','Mystic',40,4663,42.500,1934,3.000,40,43,30,21,20,10,7314,840,2921,543,1220,485,200,150,182,6722,0,0,35,185,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1198,21388,'Iblis of Destruction','','fiend_archer',17.00,55.00,80,'male','L2Monster','Ranger',40,4663,51.000,1934,3.000,40,43,30,21,20,10,9221,1059,2103,543,1220,485,278,150,253,0,0,0,70,150,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',1,0),
(1199,21389,'Balrog of Destruction','','kaim_vanul',24.00,40.00,80,'male','L2Monster','Fighter',40,4716,51.000,1972,3.000,40,43,30,21,20,10,9888,1149,2155,553,1258,494,278,150,253,0,0,0,37,155,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(1200,21390,'Ashuras of Destruction','','ashuras_30_bi',17.00,49.00,80,'male','L2Monster','Fighter',40,4766,51.000,2011,3.000,40,43,30,21,20,10,11408,1342,2207,562,1296,502,278,150,253,0,0,0,41,190,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1201,21391,'Lavasillisk','','lesser_basilisk',12.00,22.00,80,'male','L2Monster','Fighter',40,4716,51.000,1972,3.000,40,43,30,21,20,10,7886,916,2155,553,1258,494,278,150,253,0,0,0,35,140,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(1202,21392,'Blazing Ifrit','','ifrit_30_bi',13.00,55.00,80,'male','L2Monster','Mystic',40,4766,51.000,2011,3.000,40,43,30,21,20,10,11251,1323,2207,562,1296,502,278,150,253,0,0,0,38,150,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1203,21393,'Magma Drake','','inferno_drake_20_bi',29.00,42.00,80,'male','L2Monster','Mystic',40,4813,51.000,2049,3.000,40,43,30,21,20,10,9494,1130,2257,572,1333,511,278,150,253,0,0,0,57,195,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1204,21394,'Lavasaurus','','magmagoil',15.00,75.00,79,'male','L2Monster','Fighter',500,4490,42.500,1821,3.000,40,43,30,21,20,10,8988,996,5991,437,1107,459,179,150,163,0,0,0,1,1,'fire_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.48,'false',1,0),
(1205,21395,'Elder Lavasaurus','','magmagoil_lad',15.00,75.00,78,'male','L2Monster','Fighter',500,4716,51.000,1972,3.000,40,43,30,21,20,10,9760,1134,6652,470,1258,494,179,150,163,0,0,0,0,0,'fire_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.48,'false',1,0),
(1206,21396,'Carrion Scarab','','scarab',14.00,22.00,78,'male','L2Monster','Fighter',40,4428,25.500,1784,3.000,40,43,30,21,20,10,8182,895,1417,672,1069,451,278,0,253,0,0,0,45,130,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(1207,21397,'Carrion Scarab','','scarab',14.00,22.00,78,'male','L2Monster','Fighter',40,4428,25.500,1784,3.000,40,43,30,21,20,10,7103,777,2282,417,1069,451,278,0,253,0,0,0,45,130,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(1208,21398,'Soldier Scarab','','scarab',14.00,22.00,78,'male','L2Monster','Fighter',40,4428,51.000,1784,3.000,40,43,30,21,20,10,6744,738,1715,555,1069,451,278,150,253,0,0,0,45,180,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(1209,21399,'Soldier Scarab','','scarab',14.00,22.00,78,'male','L2Monster','Fighter',40,4428,42.500,1784,3.000,40,43,30,21,20,10,7736,846,1715,555,1069,451,278,150,253,0,0,0,45,180,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(1210,21400,'Hexa Beetle','','tera_beetle',19.00,54.50,79,'male','L2Monster','Fighter',40,4490,42.500,1821,3.000,40,43,30,21,20,10,6611,732,1765,566,1107,459,278,0,253,0,0,0,45,145,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.59,'false',1,0),
(1211,21401,'Hexa Beetle','','tera_beetle',19.00,54.50,79,'male','L2Monster','Fighter',40,4490,34.000,1821,3.000,40,43,30,21,20,10,7271,806,1941,514,1107,459,278,150,253,0,0,0,45,145,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.59,'false',1,0),
(1212,21402,'Katraxis','','scorpion_20_sm',24.00,52.80,79,'male','L2Monster','Fighter',40,4490,34.000,1821,3.000,40,43,30,21,20,10,7503,831,1544,566,1107,459,317,150,289,0,0,0,37,165,'tomb_clan',300,'Magister','',0,0,0,7,10,8,0,0,0,0.54,'false',0,0),
(1213,21403,'Katraxis','','scorpion_20_sm',24.00,52.80,79,'male','L2Monster','Fighter',40,4490,42.500,1821,3.000,40,43,30,21,20,10,6928,767,1544,566,1107,459,317,150,289,0,0,0,37,165,'tomb_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.54,'false',0,0),
(1214,21404,'Tera Beetle','','tera_beetle',19.00,54.50,80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,14906,1673,1649,634,1144,468,278,0,253,0,0,0,45,185,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(1215,21405,'Tera Beetle','','tera_beetle',19.00,54.50,80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,7146,802,1814,576,1144,468,278,0,253,0,0,0,45,185,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(1216,21406,'Knight of Empire','','skeleton_knight',10.00,25.00,80,'male','L2Monster','Fighter',40,4550,42.500,1859,3.000,40,43,30,21,20,10,8454,949,1814,576,1144,468,278,150,253,150,103,0,40,145,'tomb_clan',300,'DRIVER','',0,20,170,7,30,4,4,0,-6,0.17,'false',1,0),
(1217,21407,'Knight of Empire','','skeleton_knight',10.00,25.00,80,'male','L2Monster','Fighter',40,4550,25.500,1859,3.000,40,43,30,21,20,10,9017,1012,1814,576,1144,468,278,150,253,150,103,0,40,145,'tomb_clan',300,'Local','',0,20,170,7,30,4,4,0,-6,0.17,'false',1,0),
(1218,21408,'Royal Guard of Empire','','skeleton_pikeman',10.00,28.00,80,'male','L2Monster','Fighter',40,4550,42.500,1859,3.000,40,43,30,21,20,10,7358,825,1996,524,1144,468,278,150,253,304,0,0,50,190,'tomb_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.21,'false',1,0),
(1219,21409,'Royal Guard of Empire','','skeleton_pikeman',10.00,28.00,80,'male','L2Monster','Fighter',40,4550,51.000,1859,3.000,40,43,30,21,20,10,6857,769,1499,698,1144,468,278,150,253,304,0,0,50,190,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.21,'false',1,0),
(1220,21410,'Guardian Scarab','','scarab_20_bi',17.00,26.50,80,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,7602,863,1863,587,1182,477,278,0,253,0,0,0,45,195,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(1221,21411,'Guardian Scarab','','scarab_20_bi',17.00,26.50,80,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,7584,861,1863,587,1182,477,278,0,253,0,0,0,45,195,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(1222,21412,'Ustralith','','scorpion',28.00,66.00,80,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,9682,1099,1347,710,1182,477,317,150,289,0,0,0,37,130,'tomb_clan',300,'Magister','',0,0,0,7,10,8,0,0,0,0.54,'false',0,0),
(1223,21413,'Ustralith','','scorpion',28.00,66.00,80,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,7445,845,1793,534,1182,477,317,150,289,0,0,0,37,130,'tomb_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.54,'false',0,0),
(1224,21414,'Assassin of Empire','','skeleton_royal_guard',11.00,28.50,80,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,7236,821,1973,485,1182,477,317,0,289,946,945,0,80,175,'tomb_clan',300,'DRIVER','',0,20,172,7,10,8,0,0,-6,0.52,'false',0,0),
(1225,21415,'Assassin of Empire','','skeleton_royal_guard',11.00,28.50,80,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,7299,828,1482,646,1182,477,317,0,289,946,945,0,80,175,'tomb_clan',300,'Local','',0,20,172,7,10,8,0,0,-6,0.52,'false',0,0),
(1226,21416,'Imperial Commander','','imperial_warlord_zombie',7.00,30.00,80,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,8637,980,1863,587,1182,477,278,150,253,134,6721,0,39,140,'tomb_clan',300,'DRIVER','',0,20,172,7,30,4,4,0,-6,0.48,'false',1,0),
(1227,21417,'Imperial Commander','','imperial_warlord_zombie',7.00,30.00,80,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,12557,1425,2255,485,1182,477,278,150,253,134,6721,0,39,140,'tomb_clan',300,'Local','',0,20,172,7,30,4,4,0,-6,0.48,'false',1,0),
(1228,21418,'Imperial Royal Guard','','death_knight',12.00,30.00,80,'male','L2Monster','Fighter',40,4663,34.000,1934,3.000,40,43,30,21,20,10,8030,922,1912,598,1220,485,278,0,253,142,0,0,27,160,'tomb_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(1229,21419,'Imperial Royal Guard','','death_knight',12.00,30.00,80,'male','L2Monster','Fighter',40,4663,34.000,1934,3.000,40,43,30,21,20,10,8173,939,1912,598,1220,485,278,0,253,142,0,0,27,160,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(1230,21420,'Ashuras','','ashuras',13.00,37.50,80,'male','L2Monster','Fighter',40,4663,42.500,1934,3.000,40,43,30,21,20,10,7704,885,1912,598,1220,485,278,150,253,0,0,0,41,200,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(1231,21421,'Ashuras','','ashuras',13.00,37.50,80,'male','L2Monster','Fighter',40,4663,42.500,1934,3.000,40,43,30,21,20,10,7231,830,1912,598,1220,485,278,150,253,0,0,0,41,200,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(1232,21422,'Dancer of Empire','','banshee',9.00,23.00,80,'female','L2Monster','Mystic',40,4663,51.000,1934,3.000,40,43,30,21,20,10,6913,794,2103,543,1220,485,278,0,253,0,0,0,80,120,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(1233,21423,'Dancer of Empire','','banshee',9.00,23.00,80,'female','L2Monster','Mystic',40,4663,51.000,1934,3.000,40,43,30,21,20,10,7328,842,2103,543,1220,485,278,150,253,0,0,0,80,120,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(1234,21424,'Ashkenas','','ashuras',13.00,37.50,80,'male','L2Monster','Fighter',40,4663,51.000,1934,3.000,40,43,30,21,20,10,9288,1067,2544,449,1220,485,278,0,253,0,0,0,41,190,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1235,21425,'Ashkenas','','ashuras',13.00,37.50,80,'male','L2Monster','Fighter',40,4663,51.000,1934,3.000,40,43,30,21,20,10,9444,1085,2544,449,1220,485,278,150,253,0,0,0,41,190,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1236,21426,'Abraxion','','erinyes',21.00,50.00,80,'male','L2Monster','Fighter',40,4716,34.000,1972,3.000,40,43,30,21,20,10,16312,1896,2722,608,1258,494,200,150,182,0,0,0,31,130,'tomb_clan',300,'Magister','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(1237,21427,'Abraxion','','erinyes',21.00,50.00,80,'male','L2Monster','Fighter',40,4716,34.000,1972,3.000,40,43,30,21,20,10,9587,1114,2722,608,1258,494,200,150,182,0,0,0,31,130,'tomb_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(1238,21428,'Hasturan','','erinyes',21.00,50.00,80,'male','L2Monster','Fighter',40,4716,42.500,1972,3.000,40,43,30,21,20,10,7324,851,2994,553,1258,494,200,150,182,0,0,0,31,150,'tomb_clan',300,'Magister','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(1239,21429,'Hasturan','','erinyes',21.00,50.00,80,'male','L2Monster','Fighter',40,4716,42.500,1972,3.000,40,43,30,21,20,10,7647,889,2474,669,1258,494,200,150,182,0,0,0,31,150,'tomb_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(1240,21430,'Arimanes','','ahrimanes',14.00,57.75,80,'male','L2Monster','Mystic',40,4716,51.000,1972,3.000,40,43,30,21,20,10,8801,1023,3293,503,1258,494,200,0,182,6722,0,0,35,210,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1241,21431,'Arimanes','','ahrimanes',14.00,57.75,80,'male','L2Monster','Mystic',40,4716,51.000,1972,3.000,40,43,30,21,20,10,7507,872,2249,736,1258,494,200,0,182,6722,0,0,35,210,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1242,21432,'Chakram Beetle','','tera_beetle',19.00,54.50,80,'male','L2Monster','Fighter',40,4550,51.000,1859,3.000,40,43,30,21,20,10,12155,1364,1814,576,1144,468,278,0,253,0,0,0,45,170,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.59,'false',1,0),
(1243,21433,'Jamadar Beetle','','tera_beetle_20_sm',15.00,43.60,79,'male','L2Monster','Fighter',40,4490,51.000,1821,3.000,40,43,30,21,20,10,11788,1306,1765,566,1107,459,278,0,253,0,0,0,45,175,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(1244,21434,'Seer of Blood','','erinyes',21.00,50.00,82,'male','L2Monster','Fighter',40,4663,51.000,1934,3.000,40,43,30,21,20,10,23561,2707,2655,598,1220,485,200,0,182,0,0,0,31,150,'tomb_clan',300,'Magister','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(1245,21435,'Guide of Offering','','imperial_warlord_zombie',7.00,30.00,80,'male','L2Monster','Fighter',40,4550,51.000,1859,3.000,40,43,30,21,20,10,11922,1338,1814,576,1144,468,278,0,253,134,6721,0,39,150,'',0,'DRIVER','',0,20,170,7,30,4,4,0,-6,0.48,'false',0,0),
(1246,21436,'Leader of Offering','','imperial_warlord_zombie',7.00,30.00,80,'male','L2Monster','Fighter',40,4550,51.000,1859,3.000,40,43,30,21,20,10,12367,1388,1814,576,1144,468,278,0,253,134,6721,0,39,150,'',0,'DRIVER','',0,20,170,7,30,4,4,0,-6,0.48,'false',0,0),
(1247,21437,'Offering Bug','','scarab',14.00,22.00,79,'male','L2Monster','Fighter',40,4490,34.000,1821,3.000,40,43,30,21,20,10,7489,830,1765,566,1107,459,278,0,253,0,0,0,45,180,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(1248,21438,'Heathen Warrior','','skeleton_royal_guard',11.00,28.50,65,'male','L2Monster','Fighter',40,3465,1.880,1319,2.700,40,43,30,21,20,10,5966,556,1140,346,619,340,317,150,289,946,945,0,80,175,'undead_clan',300,'Magister','',0,20,135,7,10,8,0,0,-6,0.52,'true',1,0),
(1249,21439,'Heathen Executed','','hungry_spirit',13.00,40.00,66,'male','L2Monster','Fighter',40,3546,1.880,1353,2.700,40,43,30,21,20,10,6151,580,1358,301,649,348,278,150,253,0,0,0,15,175,'undead_clan',300,'Magister','',0,0,0,7,30,4,4,0,10,0.45,'true',1,0),
(1250,21440,'Heathen Archer','','skeleton_archer',11.00,27.00,67,'male','L2Monster','Ranger',500,3626,1.880,1388,2.700,40,43,30,21,20,10,6735,640,3145,308,681,356,249,0,227,284,0,0,40,155,'undead_clan',300,'Magister','',0,0,0,7,10,8,0,1500,10,0.80,'true',1,0),
(1251,21441,'Heathen Grunt','','skeleton_pikeman',10.00,28.00,68,'male','L2Monster','Fighter',40,3706,1.880,1423,2.700,40,43,30,21,20,10,6530,632,1473,371,713,365,278,150,253,96,0,0,50,170,'undead_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,0.21,'true',1,0),
(1252,21442,'Heathen Knight','','skeleton_knight',10.00,25.00,69,'male','L2Monster','Fighter',40,3784,1.880,1458,2.700,40,43,30,21,20,10,6723,656,1531,380,746,373,278,150,253,150,103,0,40,165,'undead_clan',300,'Magister','',0,20,145,7,30,4,4,0,-6,0.17,'true',1,0),
(1253,21443,'Raider of Pastureland','','dark_mahum',13.00,26.00,63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,7006,633,649,530,560,323,317,150,289,153,0,0,50,165,'nonpet_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.52,'true',1,0),
(1254,21444,'Raider of Pastureland','','dark_mahum',13.00,26.00,63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,5887,532,741,530,560,323,278,150,253,153,0,0,50,165,'nonpet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',1,0),
(1255,21445,'Alpen Bandersnatch','','bandersnatch',18.00,25.00,64,'male','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,6076,556,1302,449,589,331,200,150,182,0,0,0,30,170,'nonpet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.49,'true',1,0),
(1256,21446,'Raider of Pastureland','','dark_mahum',13.00,26.00,64,'male','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,7476,684,678,543,589,331,317,150,289,160,0,0,50,165,'nonpet_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.52,'true',1,0),
(1257,21447,'Raider of Pastureland','','dark_mahum',13.00,26.00,66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,7689,724,738,570,649,348,317,150,289,229,0,0,50,165,'nonpet_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.52,'true',1,0),
(1258,21448,'Raider of Pastureland','','dark_mahum',13.00,26.00,66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,6462,608,843,570,649,348,278,150,253,229,0,0,50,165,'nonpet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',1,0),
(1259,21449,'Raider of Pastureland','','dark_mahum',13.00,26.00,68,'male','L2Monster','Fighter',40,3706,7.500,1423,2.700,40,43,30,21,20,10,8440,815,800,598,713,365,317,150,289,234,0,0,50,165,'nonpet_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.52,'true',1,0),
(1260,21450,'Alpen Grendel','','bionic_bear',15.00,39.00,68,'male','L2Monster','Fighter',40,3706,7.500,1423,2.700,40,43,30,21,20,10,8162,789,1690,449,713,365,200,150,182,0,0,0,36,155,'nonpet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1261,21451,'Alpen Kookaburra','','baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast','Fighter',40,3465,3.750,1319,2.700,40,43,30,21,20,10,5530,514,1077,418,619,340,278,0,253,0,0,0,13,110,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1262,21452,'Alpen Kookaburra','','baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7312,679,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(1263,21453,'Alpen Kookaburra','','baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6144,571,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(1264,21454,'Alpen Kookaburra','','baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7312,679,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(1265,21455,'Alpen Kookaburra','','baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6144,571,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(1266,21456,'Alpen Kookaburra','','baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7312,679,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(1267,21457,'Alpen Kookaburra','','baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6144,571,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(1268,21458,'Alpen Kookaburra','','baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7312,679,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(1269,21459,'Alpen Kookaburra','','baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6144,571,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(1270,21460,'Alpen Kookaburra','','youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(1271,21461,'Alpen Kookaburra','','youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7963,740,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(1272,21462,'Alpen Kookaburra','','youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(1273,21463,'Alpen Kookaburra','','youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7367,684,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(1274,21464,'Alpen Kookaburra','','youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(1275,21465,'Alpen Kookaburra','','youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7963,740,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(1276,21466,'Alpen Kookaburra','','youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(1277,21467,'Alpen Kookaburra','','youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,7367,684,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(1278,21468,'Alpen Kookaburra','','rough_ostrich',10.00,33.00,65,'male','L2FeedableBeast','Fighter',40,3465,30.000,1319,2.700,40,43,30,21,20,10,6457,600,1433,314,619,340,278,150,253,0,0,0,23,210,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(1279,21469,'Alpen Kookaburra','','rough_ostrich',10.00,33.00,65,'male','L2FeedableBeast','Fighter',40,3465,30.000,1319,2.700,40,43,30,21,20,10,6159,572,1433,314,619,340,278,150,253,0,0,0,23,210,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(1280,21470,'Alpen Buffalo','','baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast','Fighter',40,3626,3.750,1388,2.700,40,43,30,21,20,10,5875,560,1169,439,681,356,278,0,253,0,0,0,30,110,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',1,0),
(1281,21471,'Alpen Buffalo','','baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,7769,740,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',0,0),
(1282,21472,'Alpen Buffalo','','baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6528,622,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',0,0),
(1283,21473,'Alpen Buffalo','','baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,7769,740,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',0,0),
(1284,21474,'Alpen Buffalo','','baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6528,622,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',0,0),
(1285,21475,'Alpen Buffalo','','baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,7769,740,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',0,0),
(1286,21476,'Alpen Buffalo','','baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6528,622,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',0,0),
(1287,21477,'Alpen Buffalo','','baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,7769,740,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',0,0),
(1288,21478,'Alpen Buffalo','','baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6528,622,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.48,'false',0,0),
(1289,21479,'Alpen Buffalo','','youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.47,'false',0,0),
(1290,21480,'Alpen Buffalo','','youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,8460,806,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.47,'false',0,0),
(1291,21481,'Alpen Buffalo','','youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.47,'false',0,0),
(1292,21482,'Alpen Buffalo','','youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,7828,745,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.47,'false',0,0),
(1293,21483,'Alpen Buffalo','','youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.47,'false',0,0),
(1294,21484,'Alpen Buffalo','','youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,8460,806,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.47,'false',0,0),
(1295,21485,'Alpen Buffalo','','youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.47,'false',0,0),
(1296,21486,'Alpen Buffalo','','youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,7828,745,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.47,'false',0,0),
(1297,21487,'Alpen Buffalo','','buffalo',22.00,31.00,67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,6861,653,2162,329,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.46,'false',0,0),
(1298,21488,'Alpen Buffalo','','buffalo',22.00,31.00,67,'male','L2Monster','Fighter',40,3626,30.000,1388,2.700,40,43,30,21,20,10,6544,623,2162,329,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.46,'false',0,0),
(1299,21489,'Alpen Cougar','','baby_tiger',11.00,15.70,69,'male','L2FeedableBeast','Fighter',40,3784,3.750,1458,2.700,40,43,30,21,20,10,6231,610,1265,460,746,373,278,0,253,0,0,0,28,110,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1300,21490,'Alpen Cougar','','baby_tiger',11.00,15.70,69,'male','L2FeedableBeast','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(1301,21491,'Alpen Cougar','','baby_tiger',11.00,15.70,69,'male','L2FeedableBeast','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(1302,21492,'Alpen Cougar','','baby_tiger',11.00,15.70,69,'male','L2FeedableBeast','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(1303,21493,'Alpen Cougar','','baby_tiger',11.00,15.70,69,'male','L2FeedableBeast','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(1304,21494,'Alpen Cougar','','baby_tiger',11.00,15.70,69,'male','L2FeedableBeast','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(1305,21495,'Alpen Cougar','','baby_tiger',11.00,15.70,69,'male','L2FeedableBeast','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(1306,21496,'Alpen Cougar','','baby_tiger',11.00,15.70,69,'male','L2FeedableBeast','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(1307,21497,'Alpen Cougar','','baby_tiger',11.00,15.70,69,'male','L2FeedableBeast','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(1308,21498,'Alpen Cougar','','youth_tiger',16.00,17.20,69,'male','L2FeedableBeast','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(1309,21499,'Alpen Cougar','','youth_tiger',16.00,17.20,69,'male','L2FeedableBeast','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8973,878,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(1310,21500,'Alpen Cougar','','youth_tiger',16.00,17.20,69,'male','L2FeedableBeast','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(1311,21501,'Alpen Cougar','','youth_tiger',16.00,17.20,69,'male','L2FeedableBeast','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8302,812,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(1312,21502,'Alpen Cougar','','youth_tiger',16.00,17.20,69,'male','L2FeedableBeast','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(1313,21503,'Alpen Cougar','','youth_tiger',16.00,17.20,69,'male','L2FeedableBeast','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8973,878,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(1314,21504,'Alpen Cougar','','youth_tiger',16.00,17.20,69,'male','L2FeedableBeast','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(1315,21505,'Alpen Cougar','','youth_tiger',16.00,17.20,69,'male','L2FeedableBeast','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,8302,812,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(1316,21506,'Alpen Cougar','','saber_toothed_tiger',13.00,28.00,69,'male','L2FeedableBeast','Fighter',40,3784,30.000,1458,2.700,40,43,30,21,20,10,7276,712,1684,345,746,373,278,150,253,0,0,0,60,200,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(1317,21507,'Alpen Cougar','','saber_toothed_tiger',12.00,22.00,69,'male','L2FeedableBeast','Fighter',40,3784,30.000,1458,2.700,40,43,30,21,20,10,6941,679,1684,345,746,373,278,150,253,0,0,0,60,200,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(1318,21508,'Splinter Stakato','','blade_stakato',15.00,36.00,66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,8452,796,1123,364,649,348,278,150,253,235,0,0,25,175,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.46,'true',1,0),
(1319,21509,'Splinter Stakato Walker','','blade_stakato_worker',13.00,40.00,67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,7445,709,1286,339,681,356,278,150,253,0,0,0,25,180,'stakato_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.76,'true',1,0),
(1320,21510,'Splinter Stakato Soldier','','blade_stakato_soldier',15.00,38.00,68,'male','L2Monster','Fighter',40,3706,7.500,1423,2.700,40,43,30,21,20,10,8972,867,1473,371,713,365,278,150,253,148,0,0,25,180,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.74,'true',1,0),
(1321,21511,'Splinter Stakato Drone','','blade_stakato_drone',15.00,39.00,69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,9944,973,1265,460,746,373,278,150,253,132,0,0,25,185,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.58,'true',1,0),
(1322,21512,'Splinter Stakato Drone','','blade_stakato_drone',15.00,39.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,12636,1253,1086,569,780,382,278,0,253,132,0,0,25,185,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.58,'true',1,0),
(1323,21513,'Needle Stakato','','blade_stakato',15.00,36.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,9507,943,1314,399,780,382,278,150,253,235,0,0,25,185,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.46,'true',1,0),
(1324,21514,'Needle Stakato Walker','','blade_stakato_worker',13.00,40.00,71,'male','L2Monster','Fighter',40,3938,8.500,1529,3.000,40,43,30,21,20,10,8360,839,1499,371,814,390,278,150,253,0,0,0,25,190,'stakato_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.76,'true',1,0),
(1325,21515,'Needle Stakato Soldier','','blade_stakato_soldier',15.00,38.00,72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,10059,1022,1710,406,849,399,278,150,253,148,0,0,25,190,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.74,'true',1,0),
(1326,21516,'Needle Stakato Drone','','blade_stakato_drone',15.00,39.00,73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,10340,1064,1463,502,885,407,278,150,253,132,0,0,25,195,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.58,'true',1,0),
(1327,21517,'Needle Stakato Drone','','blade_stakato_drone',15.00,39.00,74,'male','L2Monster','Fighter',40,4158,8.500,1637,3.000,40,43,30,21,20,10,14121,1472,1250,620,921,416,278,0,253,132,0,0,25,195,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.58,'true',1,0),
(1328,21518,'Frenzy Stakato Soldier','','blade_stakato_soldier',15.00,38.00,68,'male','L2Monster','Fighter',40,3706,7.500,1423,2.700,40,43,30,21,20,10,8002,773,1417,337,713,365,317,0,289,235,0,0,25,185,'stakato_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.74,'true',0,0),
(1329,21519,'Frenzy Stakato Drone','','blade_stakato_drone',15.00,39.00,72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,8972,912,1645,369,849,399,317,0,289,235,0,0,25,195,'stakato_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.58,'true',0,0),
(1330,21520,'Eye of Splendor','','kel_mahum',13.00,26.00,60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,7466,648,860,368,478,299,278,0,253,326,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(1331,21521,'Claws of Splendor','','kel_mahum_warrior',13.00,28.00,60,'male','L2Monster','ClawsOfSplendor',40,3054,6.500,1150,2.400,40,43,30,21,20,10,7340,637,711,446,478,299,278,0,253,326,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(1332,21522,'Claws of Splendor','','dark_fencer',7.00,13.00,60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,8748,759,1041,259,478,299,278,0,253,0,0,0,25,155,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.20,'true',0,0),
(1333,21523,'Flash of Splendor','','kel_mahum_witch_doctor',13.00,25.00,61,'male','L2Monster','Fighter',40,3137,7.500,1184,2.700,40,43,30,21,20,10,7529,663,901,378,505,307,278,150,253,326,0,0,50,150,'saint_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(1334,21524,'Blade of Splendor','','kel_mahum',13.00,26.00,61,'male','L2Monster','BladeOfSplendor',40,3137,7.500,1184,2.700,40,43,30,21,20,10,8028,707,1200,284,505,307,278,0,253,242,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',1,0),
(1335,21525,'Blade of Splendor','','kel_mahum',13.00,26.00,61,'male','L2Monster','RndTeleportFighter',40,3137,7.500,1184,2.700,40,43,30,21,20,10,8028,707,901,378,505,307,278,0,253,242,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',0,0),
(1336,21526,'Wisdom of Splendor','','kel_mahum_warrior',13.00,28.00,62,'male','L2Monster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,9220,822,944,388,532,315,278,150,253,193,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(1337,21527,'Anger of Splendor','','kel_mahum_champion',13.00,32.00,63,'male','L2Monster','AngerOfSplendor',40,3302,7.500,1251,2.700,40,43,30,21,20,10,8132,734,987,398,560,323,278,0,253,193,0,0,50,150,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(1338,21528,'Anger of Splendor','','dark_fencer',7.00,13.00,63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,9645,871,987,398,560,323,278,0,253,0,0,0,25,155,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.20,'true',0,0),
(1339,21529,'Soul of Splendor','','kel_mahum_witch_doctor',13.00,25.00,63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,7377,666,987,398,560,323,278,150,253,193,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(1340,21530,'Victory of Splendor','','kel_mahum',13.00,26.00,64,'male','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,8006,733,1031,408,589,331,278,0,253,196,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',1,0),
(1341,21531,'Punishment of Splendor','','kel_mahum_warrior',13.00,28.00,64,'male','L2Monster','RndTeleportFighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,8837,809,1373,306,589,331,278,0,253,242,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(1342,21532,'Shout of Splendor','','kel_mahum_champion',13.00,32.00,65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,9456,879,1077,418,619,340,278,150,253,196,0,0,50,150,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(1343,21533,'Alliance of Splendor','','kel_mahum_witch_doctor',13.00,25.00,65,'male','L2Monster','AllianceOfSplendor',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7767,722,890,430,619,340,278,0,253,196,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.28,'true',1,0),
(1344,21534,'Alliance of Splendor','','dark_fencer',7.00,13.00,65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,10267,954,1303,346,619,340,278,0,253,0,0,0,25,155,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.20,'true',0,0),
(1345,21535,'Signet of Splendor','','kel_mahum_warrior',13.00,28.00,66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,9331,878,1123,428,649,348,278,150,253,189,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(1346,21536,'Crown of Splendor','','kel_mahum_champion',13.00,32.00,66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,9487,893,1123,428,649,348,278,0,253,189,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(1347,21537,'Fang of Splendor','','kel_mahum_witch_doctor',13.00,25.00,67,'male','L2Monster','FangOfSplendor',40,3626,7.500,1388,2.700,40,43,30,21,20,10,8905,848,966,451,681,356,278,0,253,189,0,0,50,155,'saint_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.28,'true',1,0),
(1348,21538,'Fang of Splendor','','dark_fencer',7.00,13.00,67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,10908,1039,1415,362,681,356,278,0,253,0,0,0,25,155,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.20,'true',0,0),
(1349,21539,'Wailing of Splendor','','kel_mahum',13.00,26.00,67,'male','L2Monster','WailingOfSplendor',40,3626,7.500,1388,2.700,40,43,30,21,20,10,9685,922,1557,329,681,356,278,0,253,242,0,0,50,170,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',1,0),
(1350,21540,'Wailing of Splendor','','kel_mahum',13.00,26.00,67,'male','L2Monster','RndTeleportFighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,9685,922,1169,439,681,356,278,0,253,242,0,0,50,170,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',0,0),
(1351,21541,'Pilgrim of Splendor','','kel_mahum_witch_doctor',13.00,25.00,63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,9944,898,987,338,560,323,278,150,253,315,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.28,'true',1,0),
(1352,21542,'Disciple of Pilgrim','','kel_mahum_warrior',13.00,28.00,62,'male','L2Monster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,6932,618,1038,353,532,315,278,0,253,193,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',0,0),
(1353,21543,'Page of Pilgrim','','kel_mahum',13.00,26.00,62,'male','L2Monster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,7909,705,858,427,532,315,278,0,253,326,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',0,0),
(1354,21544,'Judge of Splendor','','kel_mahum_champion',13.00,32.00,67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,11331,1079,1169,439,681,356,278,150,253,150,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(1355,21545,'Judge of Fire','','kel_mahum_witch_doctor',13.00,25.00,66,'male','L2Minion','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,7855,739,1235,331,649,348,278,0,253,189,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.28,'true',1,0),
(1356,21546,'Judge of Light','','kel_mahum',13.00,26.00,66,'male','L2Minion','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,8963,844,1020,471,649,348,278,0,253,196,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',1,0),
(1357,21547,'Corrupted Knight','','skeleton_knight',10.00,25.00,63,'male','L2Monster','RndTeleportFighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,8116,733,987,398,560,323,278,0,253,150,103,0,40,165,'necro_clan',300,'Local','',0,20,131,30,30,4,4,0,-6,0.17,'true',1,0),
(1358,21548,'Resurrected Knight','','skeleton_knight',10.00,25.00,63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,7019,634,987,398,560,323,278,0,253,150,103,0,40,165,'necro_clan',300,'Local','',0,20,131,30,30,4,4,0,-6,0.17,'true',1,0),
(1359,21549,'Corrupted Guard','','skeleton_royal_guard',11.00,28.50,64,'male','L2Monster','Fighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,8375,767,902,408,589,331,317,0,289,946,0,0,80,175,'necro_clan',300,'Local','',0,0,0,30,10,8,0,0,0,0.52,'true',1,0),
(1360,21550,'Corrupted Guard','','skeleton_royal_guard',11.00,28.50,64,'male','L2Monster','RndTeleportFighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,8543,782,1201,306,589,331,317,150,289,946,945,0,80,175,'necro_clan',300,'Local','',0,20,133,30,10,8,0,0,-6,0.52,'true',1,0),
(1361,21551,'Resurrected Guard','','skeleton_royal_guard',11.00,28.50,66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,9541,898,982,428,649,348,317,0,289,221,0,0,80,175,'necro_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.52,'true',1,0),
(1362,21552,'Resurrected Guard','','skeleton_royal_guard',11.00,28.50,66,'male','L2Monster','RndTeleportFighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,9085,855,1307,322,649,348,317,150,289,221,945,0,80,175,'necro_clan',300,'Local','',0,20,138,7,10,8,0,0,-6,0.52,'true',1,0),
(1363,21553,'Trampled Man','','zombie',13.00,21.00,65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6267,582,1077,355,619,340,278,0,253,0,0,0,15,40,'necro_clan',300,'Local','',0,0,0,30,30,4,4,0,10,0.43,'true',1,0),
(1364,21554,'Trampled Man','','zombie',13.00,21.00,65,'male','L2Monster','RndTeleportFighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6267,582,1303,294,619,340,278,0,253,0,0,0,15,40,'necro_clan',300,'Local','',0,0,0,30,30,4,4,0,10,0.43,'true',1,0),
(1365,21555,'Slaughter Executioner','','dark_horror',20.00,35.00,65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7619,708,979,391,619,340,278,0,253,0,0,0,100,160,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.37,'true',1,0),
(1366,21556,'Slaughter Executioner','','dark_horror',20.00,35.00,65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,7435,691,1077,355,619,340,278,0,253,0,0,0,100,160,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.37,'true',1,0),
(1367,21557,'Bone Snatcher','','black_magician',8.00,30.00,66,'male','L2Monster','Mystic',40,3546,7.500,1353,2.700,40,43,30,21,20,10,8774,826,1123,428,649,348,278,0,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1368,21558,'Bone Snatcher','','black_magician',8.00,30.00,66,'male','L2Monster','Mystic',40,3546,7.500,1353,2.700,40,43,30,21,20,10,8774,826,1123,428,649,348,278,0,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1369,21559,'Bone Maker','','black_magician',8.00,30.00,66,'male','L2Monster','Mystic',40,3546,7.500,1353,2.700,40,43,30,21,20,10,9596,903,1020,471,649,348,278,150,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1370,21560,'Bone Shaper','','black_magician',8.00,30.00,66,'male','L2Monster','Mystic',40,3546,7.500,1353,2.700,40,43,30,21,20,10,9596,903,1020,471,649,348,278,150,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1371,21561,'Sacrificed Man','','zombie',13.00,21.00,67,'male','L2Monster','RndTeleportFighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,8057,767,1063,410,681,356,278,150,253,0,0,0,15,40,'necro_clan',300,'Local','',0,0,0,30,30,4,4,0,10,0.43,'true',1,0),
(1372,21562,'Guillotine''s Ghost','','liviona',15.00,28.00,67,'male','L2Monster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,8344,795,1169,373,681,356,278,150,253,0,0,0,80,150,'necro_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,10,0.34,'true',1,0),
(1373,21563,'Bone Collector','','black_magician',8.00,30.00,67,'male','L2Monster','Mystic',40,3626,7.500,1388,2.700,40,43,30,21,20,10,9695,923,1286,399,681,356,278,0,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1374,21564,'Skull Collector','','black_magician',8.00,30.00,67,'male','L2Monster','Mystic',40,3626,7.500,1388,2.700,40,43,30,21,20,10,9223,878,1286,399,681,356,278,150,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1375,21565,'Bone Animator','','black_magician',8.00,30.00,68,'male','L2Monster','Mystic',40,3706,7.500,1423,2.700,40,43,30,21,20,10,9314,900,1339,408,713,365,278,0,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1376,21566,'Skull Animator','','black_magician',8.00,30.00,68,'male','L2Monster','Mystic',40,3706,7.500,1423,2.700,40,43,30,21,20,10,10186,984,1339,408,713,365,278,150,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1377,21567,'Bone Slayer','','black_magician',8.00,30.00,68,'male','L2Monster','Mystic',40,3706,7.500,1423,2.700,40,43,30,21,20,10,12175,1176,1106,494,713,365,278,150,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1378,21568,'Devil Bat','','vampire_bat',10.00,33.50,68,'male','L2Monster','Mystic',40,3706,7.500,1423,2.700,40,43,30,21,20,10,10440,1009,1473,315,713,365,278,150,253,0,0,0,60,170,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.50,'true',1,0),
(1379,21569,'Devil Bat','','vampire_bat',10.00,33.50,68,'male','L2Monster','Mystic',40,3706,7.500,1423,2.700,40,43,30,21,20,10,8108,783,1217,382,713,365,278,150,253,0,0,0,60,170,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.50,'true',1,0),
(1380,21570,'Ghost of Betrayer','','binding',12.00,21.00,69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,7557,739,1150,506,746,373,278,150,253,0,0,0,10,174,'necro_clan',300,'Local','',0,0,0,30,30,4,4,0,0,0.54,'true',1,0),
(1381,21571,'Ghost of Rebellion Soldier','','skeleton_knight',10.00,25.00,69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,10718,1049,1265,460,746,373,278,150,253,150,103,0,40,165,'necro_clan',300,'Local','',0,20,145,7,30,4,4,0,-6,0.17,'true',1,0),
(1382,21572,'Bone Sweeper','','black_magician',8.00,30.00,69,'male','L2Monster','Mystic',40,3784,7.500,1458,2.700,40,43,30,21,20,10,10282,1006,1392,418,746,373,278,0,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1383,21573,'Atrox','','kailiharim',57.00,39.00,69,'male','L2Monster','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,11456,1121,2127,380,746,373,200,150,182,0,0,0,105,185,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1384,21574,'Bone Grinder','','black_magician',8.00,30.00,70,'male','L2Monster','Mystic',40,3862,7.500,1493,2.700,40,43,30,21,20,10,12902,1279,1194,517,780,382,278,150,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1385,21575,'Bone Grinder','','black_magician',8.00,30.00,70,'male','L2Monster','Mystic',40,3862,7.500,1493,2.700,40,43,30,21,20,10,7269,721,1314,470,780,382,278,150,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1386,21576,'Ghost of Guillotine','','liviona',15.00,28.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,9350,927,1590,330,780,382,278,0,253,0,0,0,80,150,'vampire_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.34,'true',1,0),
(1387,21577,'Ghost of Guillotine','','liviona',15.00,28.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,8195,813,1314,399,780,382,278,0,253,0,0,0,80,150,'vampire_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.34,'true',1,0),
(1388,21578,'Behemoth Zombie','','giant_zombie',13.00,40.50,71,'male','L2Monster','RndTeleportFighter',40,3938,8.500,1529,3.000,40,43,30,21,20,10,10308,1034,1239,529,814,390,278,0,253,0,0,0,20,90,'necro_clan',300,'Local','',0,0,0,30,30,4,4,0,0,0.48,'true',1,0),
(1389,21579,'Ghost of Rebellion Leader','','skeleton_royal_guard',11.00,28.50,71,'male','L2Monster','Fighter',40,3938,8.500,1529,3.000,40,43,30,21,20,10,10843,1088,1193,481,814,390,317,0,289,221,945,0,80,175,'necro_clan',300,'Local','',0,20,150,7,10,8,0,0,-6,0.52,'true',1,0),
(1390,21580,'Bone Caster','','black_magician',8.00,30.00,71,'male','L2Monster','Mystic',40,3938,8.500,1529,3.000,40,43,30,21,20,10,10154,1019,1499,437,814,390,278,0,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1391,21581,'Bone Puppeteer','','black_magician',8.00,30.00,71,'male','L2Monster','Mystic',40,3938,8.500,1529,3.000,40,43,30,21,20,10,11105,1114,1499,437,814,390,278,150,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1392,21582,'Vampire Soldier','','vampire_soldier',8.00,23.50,71,'male','L2Monster','Fighter',40,3938,8.500,1529,3.000,40,43,30,21,20,10,11891,1193,1649,397,814,390,278,0,253,234,0,0,60,190,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(1393,21583,'Bone Scavenger','','black_magician',8.00,30.00,72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,11196,1137,1554,446,849,399,278,0,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1394,21584,'Bone Scavenger','','black_magician',8.00,30.00,72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,10442,1061,1284,540,849,399,278,0,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1395,21585,'Vampire Magician','','vampire_witch',6.00,21.50,72,'female','L2Monster','Mystic',40,4013,8.500,1565,3.000,40,43,30,21,20,10,9628,978,1710,406,849,399,278,150,253,946,0,0,64,180,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(1396,21586,'Vampire Adept','','vampire_wizard',5.50,28.00,72,'female','L2Monster','Mystic',40,4013,8.500,1565,3.000,40,43,30,21,20,10,11374,1156,1710,406,849,399,278,150,253,99,0,0,46,180,'vampire_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1397,21587,'Vampire Warrior','','vampire_soldier_20_bi',10.00,29.00,72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,11852,1204,1710,406,849,399,278,0,253,234,0,0,60,190,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(1398,21588,'Vampire Wizard','','vampire_witch',6.00,21.50,73,'female','L2Monster','RndTeleportFighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,9936,1022,1947,377,885,407,278,0,253,946,0,0,64,180,'vampire_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(1399,21589,'Vampire Wizard','','vampire_witch',6.00,21.50,73,'female','L2Monster','RndTeleportFighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,10168,1046,1099,668,885,407,278,0,253,946,0,0,64,180,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(1400,21590,'Vampire Magister','','vampire_wizard',5.50,28.00,73,'female','L2Monster','Mystic',40,4086,8.500,1601,3.000,40,43,30,21,20,10,9936,1022,1770,415,885,407,278,0,253,99,0,0,46,180,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1401,21591,'Vampire Magister','','vampire_wizard',5.50,28.00,73,'female','L2Monster','Mystic',40,4086,8.500,1601,3.000,40,43,30,21,20,10,11462,1179,1770,415,885,407,278,0,253,99,0,0,46,180,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1402,21592,'Vampire Magister','','vampire_wizard',5.50,28.00,73,'female','L2Monster','Mystic',40,4086,8.500,1601,3.000,40,43,30,21,20,10,7750,797,1330,552,885,407,278,0,253,99,0,0,46,180,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1403,21593,'Vampire Warlord','','vampire_warrior',9.00,31.50,73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,13346,1373,2459,415,885,407,200,0,182,6723,0,0,43,190,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.60,'true',1,0),
(1404,21594,'Vampire Warlord','','vampire_warrior',9.00,31.50,73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,12571,1294,2459,415,885,407,200,0,182,6723,0,0,43,190,'vampire_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'true',1,0),
(1405,21595,'Vampire Warlord','','vampire_warrior',9.00,31.50,73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,9161,943,1847,552,885,407,200,0,182,6723,0,0,43,190,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.60,'true',1,0),
(1406,21596,'Requiem Lord','','black_magician',8.00,30.00,68,'male','L2Monster','Fighter',40,3706,7.500,1423,2.700,40,43,30,21,20,10,12038,1163,1106,494,713,365,278,150,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1407,21597,'Requiem Behemoth','','giant_zombie',13.00,40.50,67,'male','L2Minion','RndTeleportFighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,8265,787,1286,399,681,356,278,0,253,0,0,0,20,100,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1408,21598,'Requiem Behemoth','','giant_zombie',13.00,40.50,67,'male','L2Minion','RndTeleportFighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,9179,874,1286,399,681,356,278,0,253,0,0,0,20,100,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(1409,21599,'Requiem Priest','','black_magician',8.00,30.00,71,'male','L2Monster','Priest',40,3938,8.500,1529,3.000,40,43,30,21,20,10,12750,1279,1239,529,814,390,278,150,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1410,21600,'Requiem Behemoth','','giant_zombie',13.00,40.50,70,'male','L2Minion','RndTeleportFighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,9022,895,1445,427,780,382,278,0,253,0,0,0,20,100,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1411,21601,'Requiem Behemoth','','giant_zombie',13.00,40.50,70,'male','L2Minion','RndTeleportFighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,10732,1064,1445,427,780,382,278,0,253,0,0,0,20,100,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(1412,21602,'Zaken''s Pikeman','','skeleton_pikeman',10.00,28.00,43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,3693,250,332,223,163,181,278,150,253,292,0,0,50,174,'undead_clan1',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.21,'true',0,0),
(1413,21603,'Zaken''s Pikeman','','skeleton_pikeman',10.00,28.00,43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,5230,354,442,167,163,181,278,150,253,292,0,0,50,174,'undead_clan1',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.21,'true',0,0),
(1414,21604,'Zaken''s Elite Pikeman','','skeleton_pikeman_20_bi',12.00,33.60,43,'male','L2Monster','Fighter',40,1728,22.000,618,2.100,40,43,30,21,20,10,2114,143,332,223,163,181,278,150,253,292,0,0,50,174,'undead_clan1',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.21,'false',1,0),
(1415,21605,'Zaken''s Archer','','skeleton_archer',11.00,27.00,44,'male','L2Monster','Ranger',500,1799,5.500,648,2.100,40,43,30,21,20,10,4109,281,788,230,176,187,249,0,227,279,0,0,40,174,'undead_clan1',300,'Local',NULL,0,0,0,7,10,8,0,1500,0,0.80,'true',0,0),
(1416,21606,'Zaken''s Archer','','skeleton_archer',11.00,27.00,44,'male','L2Monster','Ranger',500,1799,5.500,648,2.100,40,43,30,21,20,10,5818,398,1048,173,176,187,249,0,227,279,0,0,40,174,'undead_clan1',300,'Local',NULL,0,0,0,7,10,8,0,1500,0,0.80,'true',0,0),
(1417,21607,'Zaken''s Elite Archer','','skeleton_archer_20_bi',13.00,32.50,44,'male','L2Monster','Ranger',500,1799,22.000,648,2.100,40,43,30,21,20,10,2273,155,788,230,176,187,249,0,227,279,0,0,40,174,'undead_clan1',300,'Local',NULL,0,0,0,7,10,8,0,1500,0,0.80,'false',1,0),
(1418,21608,'Zaken''s Watchman','','liviona',15.00,28.00,45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,3365,234,377,202,188,193,278,150,253,0,0,0,80,174,NULL,0,'Local',NULL,0,0,0,7,50,1,9,0,10,0.34,'true',0,0),
(1419,21609,'Zaken''s Watchman','','liviona',15.00,28.00,45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,4766,331,502,152,188,193,278,150,253,0,0,0,80,174,NULL,0,'Local',NULL,0,0,0,7,50,1,9,0,10,0.34,'true',0,0),
(1420,21610,'Zaken''s High Grade Watchman','','liviona_20_bi',18.00,33.60,45,'male','L2Monster','Fighter',40,1870,22.000,677,2.100,40,43,30,21,20,10,2174,151,377,202,188,193,278,150,253,0,0,0,80,174,NULL,0,'Local',NULL,0,0,0,7,50,1,9,0,10,0.34,'false',1,0),
(1421,21611,'Unpleasant Humming','','unpleasant_humming',12.00,26.00,46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,3907,277,401,245,202,199,278,150,253,0,0,0,21,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.59,'true',0,0),
(1422,21612,'Unpleasant Humming','','unpleasant_humming',12.00,26.00,46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,5533,392,534,184,202,199,278,150,253,0,0,0,21,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.59,'true',0,0),
(1423,21613,'Unpleasant Shout','','unpleasant_humming_20_bi',13.50,31.20,46,'male','L2Monster','Fighter',40,1943,22.000,707,2.100,40,43,30,21,20,10,2360,167,401,245,202,199,278,150,253,0,0,0,21,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.59,'false',1,0),
(1424,21614,'Death Flyer','','dark_horror',20.00,35.00,47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,4035,289,427,253,216,206,278,0,253,0,0,0,100,174,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.37,'true',0,0),
(1425,21615,'Death Flyer','','dark_horror',20.00,35.00,47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,5714,410,568,190,216,206,278,0,253,0,0,0,100,174,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.37,'true',0,0),
(1426,21616,'Gigantic Flyer','','dark_horror_bi',20.00,42.00,47,'male','L2Monster','Fighter',40,2016,22.000,738,2.100,40,43,30,21,20,10,2607,187,427,253,216,206,278,0,253,0,0,0,100,174,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.37,'false',1,0),
(1427,21617,'Fiend Archer','','fiend_archer',17.00,55.00,48,'male','L2Monster','Ranger',500,2091,5.500,768,2.100,40,43,30,21,20,10,4103,300,1007,222,231,212,249,150,227,0,0,0,70,174,'',0,'Local','',0,0,0,7,10,8,0,1500,10,0.76,'true',0,0),
(1428,21618,'Fiend Archer','','fiend_archer',17.00,55.00,48,'male','L2Monster','Ranger',500,2091,5.500,768,2.100,40,43,30,21,20,10,5811,425,1341,167,231,212,249,150,227,0,0,0,70,174,'',0,'Local','',0,0,0,7,10,8,0,1500,10,0.76,'true',0,0),
(1429,21619,'Pit Archer','','fiend_archer_20_bi',20.00,66.00,48,'male','L2Monster','Ranger',500,2091,22.000,768,2.100,40,43,30,21,20,10,2651,193,1007,222,231,212,249,150,227,0,0,0,70,174,'',0,'Local','',0,0,0,7,10,8,0,1500,10,0.76,'false',1,0),
(1430,21620,'Musveren','','field_stalker',15.00,30.00,49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,3951,292,480,270,247,219,278,0,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',0,0),
(1431,21621,'Musveren','','field_stalker',15.00,30.00,49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,5595,414,640,202,247,219,278,0,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',0,0),
(1432,21622,'Greater Musveren','','field_stalker_20_bi',18.00,36.00,49,'male','L2Monster','Fighter',40,2168,22.000,799,2.100,40,43,30,21,20,10,2553,188,480,270,247,219,278,0,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'false',1,0),
(1433,21623,'Zaken''s Guard','','skeleton_royal_guard',11.00,28.50,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,4994,376,445,278,264,226,317,150,289,225,945,0,80,174,'undead_clan',300,'Local',NULL,0,20,100,7,10,8,0,0,-6,0.52,'true',0,0),
(1434,21624,'Zaken''s Guard','','skeleton_royal_guard',11.00,28.50,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,7072,533,593,209,264,226,317,150,289,225,945,0,80,174,'undead_clan',300,'Local',NULL,0,20,100,7,10,8,0,0,-6,0.52,'true',0,0),
(1435,21625,'Zaken''s Elite Guard','','skeleton_royal_guard_20_bi',13.00,34.50,50,'male','L2Monster','Fighter',40,2245,22.000,830,2.100,40,43,30,21,20,10,2858,215,445,278,264,226,317,150,289,225,945,0,80,174,'undead_clan',300,'Local',NULL,0,20,100,7,10,8,0,0,-6,0.52,'false',1,0),
(1436,21626,'Kaim Vanul','','kaim_vanul',24.00,40.00,51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,4453,340,539,286,281,232,278,0,253,0,0,0,37,174,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',0,0),
(1437,21627,'Kaim Vanul','','kaim_vanul',24.00,40.00,51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,6306,481,718,215,281,232,278,0,253,0,0,0,37,174,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',0,0),
(1438,21628,'Kaim Vanul Lad','','kaim_vanul_20_bi',28.00,48.00,51,'male','L2Monster','Fighter',40,2323,26.000,861,2.400,40,43,30,21,20,10,2877,219,539,286,281,232,278,0,253,0,0,0,37,174,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(1439,21629,'Pirate Zombie Captain','','pirates_zombie_captain',17.00,28.00,52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,6727,520,499,295,300,239,317,150,289,232,0,0,14,174,'zaken_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.76,'true',0,0),
(1440,21630,'Pirate Zombie Captain','','pirates_zombie_captain',17.00,28.00,52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,9526,737,664,221,300,239,317,150,289,232,0,0,14,174,'zaken_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.76,'true',0,0),
(1441,21631,'Zombie Captain''s Spiritual Body','','pirates_zombie_captain_20_bi',20.00,33.60,52,'male','L2Monster','Fighter',40,2402,26.000,892,2.400,40,43,30,21,20,10,3948,305,499,295,300,239,317,150,289,232,0,0,14,174,'zaken_clan',300,'Local',NULL,0,0,0,7,10,8,0,0,0,0.76,'false',1,0),
(1442,21632,'Doll Blader','','doll_blader',6.00,12.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,5339,420,527,258,319,247,317,0,289,5129,5129,0,22,174,'zaken_clan',300,'Local','',0,0,93,7,10,8,0,0,10,0.50,'true',0,0),
(1443,21633,'Doll Blader','','doll_blader',6.00,12.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,7560,594,701,194,319,247,317,0,289,5129,5129,0,22,174,'zaken_clan',300,'Local','',0,0,93,7,10,8,0,0,10,0.50,'true',0,0),
(1444,21634,'Crimson Doll Blader','','doll_blader_20_bi',7.00,15.00,53,'male','L2Monster','Fighter',40,2481,26.000,923,2.400,40,43,30,21,20,10,3450,271,527,258,319,247,317,0,289,5129,5129,0,22,174,'zaken_clan',300,'Local','',0,0,93,7,10,8,0,0,10,0.50,'false',1,0),
(1445,21635,'Vale Master','','vale_master',12.00,40.00,54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,5093,406,636,266,339,254,278,150,253,0,0,0,70,174,'zaken_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.74,'true',0,0),
(1446,21636,'Vale Master','','vale_master',12.00,40.00,54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,7212,575,846,199,339,254,278,150,253,0,0,0,70,174,'zaken_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.74,'true',0,0),
(1447,21637,'Crimson Vale Master','','vale_master_20_bi',14.50,48.00,54,'male','L2Monster','Fighter',40,2562,26.000,955,2.400,40,43,30,21,20,10,3291,262,636,266,339,254,278,150,253,0,0,0,70,174,'zaken_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.74,'false',1,0),
(1448,21638,'Dread Wolf','','dire_wolf',13.00,11.00,35,'male','L2Monster','Fighter',40,1220,2.250,446,1.800,40,43,30,21,20,10,2303,136,211,154,89,137,278,150,253,0,0,0,24,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(1449,21639,'Tasaba Lizardman','','virud_lizardman_scout',10.00,22.00,36,'male','L2Monster','Ranger',500,1279,2.250,463,1.800,40,43,30,21,20,10,2725,164,417,193,96,142,249,0,227,2507,0,0,43,140,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.72,'true',1,0),
(1450,21640,'Tasaba Lizardman Shaman','','virud_lizardman_shaman',10.00,29.00,37,'male','L2Monster','Priest',40,1338,2.250,480,1.800,40,43,30,21,20,10,2003,124,295,116,104,147,278,0,253,7,0,0,43,140,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.48,'true',1,0),
(1451,21641,'Ogre','','ogre',21.00,44.00,38,'male','L2Monster','Fighter',40,1400,2.250,497,1.800,40,43,30,21,20,10,3555,222,300,207,112,153,200,150,182,98,0,0,22,174,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.69,'true',1,0),
(1452,21642,'Tasaba Lizardman Sniper','','virud_lizardman_scout',10.00,22.00,39,'male','L2Monster','Ranger',500,1462,2.250,514,1.800,40,43,30,21,20,10,3263,208,566,165,121,158,249,150,227,2507,0,0,43,140,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.72,'true',1,0),
(1453,21643,'Tasaba Lizardman Sniper','','virud_lizardman_scout',10.00,22.00,39,'male','L2Monster','Ranger',500,1462,2.250,514,1.800,40,43,30,21,20,10,4146,264,685,137,121,158,249,150,227,2507,0,0,43,140,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.72,'true',1,0),
(1454,21644,'Lienrik','','lienrik',12.00,50.00,39,'male','L2Monster','Fighter',40,1462,2.250,514,1.800,40,43,30,21,20,10,1990,126,297,146,121,158,317,0,289,0,0,0,100,150,'lienrik_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.46,'true',1,0),
(1455,21645,'Lienrik Lad','','lienrik',12.00,50.00,40,'male','L2Monster','Fighter',40,1527,2.250,531,1.800,40,43,30,21,20,10,3836,248,317,151,131,164,317,150,289,0,0,0,100,174,'lienrik_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.46,'true',1,0),
(1456,21646,'Grave Scarab','','scarab',14.00,22.00,73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,10206,1050,1463,502,885,407,278,0,253,0,0,0,45,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',1,0),
(1457,21647,'Scavenger Scarab','','scarab',14.00,22.00,73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,8609,886,1463,502,885,407,278,150,253,0,0,0,45,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',1,0),
(1458,21648,'Grave Ant','','ant_soldier',35.00,17.00,74,'male','L2Monster','Fighter',40,4158,8.500,1637,3.000,40,43,30,21,20,10,9383,978,1513,512,921,416,278,0,253,0,0,0,80,150,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(1459,21649,'Scavenger Ant','','ant_soldier',35.00,17.00,74,'male','L2Monster','Fighter',40,4158,8.500,1637,3.000,40,43,30,21,20,10,11099,1157,1513,512,921,416,278,150,253,0,0,0,80,150,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(1460,21650,'Shrine Knight','','skeleton_knight',10.00,25.00,75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,10149,1071,1563,523,957,425,278,0,253,150,103,0,40,165,'',0,'Local','',0,20,159,7,30,4,4,0,-6,0.17,'true',1,0),
(1461,21651,'Shrine Guard','','skeleton_pikeman',10.00,28.00,75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,9695,1023,1563,523,957,425,278,0,253,98,0,0,50,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.21,'true',1,0),
(1462,21652,'Scarlet Stakato Noble','','blade_stakato_drone',15.00,39.00,79,'male','L2Monster','Fighter',40,4490,42.500,1821,3.000,40,43,30,21,20,10,9382,1039,1544,566,1107,459,317,150,289,235,0,0,25,165,'fire_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.58,'false',1,0),
(1463,21653,'Assassin Beetle','','tera_beetle',19.00,54.50,80,'male','L2Monster','Fighter',40,4550,42.500,1859,3.000,40,43,30,21,20,10,6804,763,1814,576,1144,468,278,150,253,0,0,0,45,165,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.59,'false',1,0),
(1464,21654,'Necromancer of Destruction','','vale_master_20_bi',14.50,48.00,80,'male','L2Monster','Fighter',40,4608,42.500,1896,3.000,40,43,30,21,20,10,8042,913,1863,587,1182,477,278,150,253,0,0,0,70,140,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.74,'false',1,0),
(1465,21655,'Arimanes of Destruction','','ahrimanes',14.00,57.75,80,'male','L2Monster','Mystic',40,4663,42.500,1934,3.000,40,43,30,21,20,10,7148,821,2655,598,1220,485,200,150,182,6722,0,0,35,185,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1466,21656,'Ashuras of Destruction','','ashuras_30_bi',17.00,49.00,80,'male','L2Monster','Fighter',40,4766,51.000,2011,3.000,40,43,30,21,20,10,10463,1230,2006,619,1296,502,278,150,253,0,0,0,41,190,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1467,21657,'Magma Drake','','inferno_drake_20_bi',29.00,42.00,80,'male','L2Monster','Mystic',40,4813,51.000,2049,3.000,40,43,30,21,20,10,9062,1078,2052,629,1333,511,278,150,253,0,0,0,57,185,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1468,21658,'Punishment of Splendor','','kel_mahum_warrior',13.00,28.00,64,'male','L2Monster','RndTeleportFighter',40,3384,7.500,1285,2.700,40,43,30,21,20,10,8837,809,1031,408,589,331,278,0,253,242,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',0,0),
(1469,21659,'Otherworldly Invader Soldier','','neer_crawler',14.00,22.00,30,'male','L2Monster','Fighter',40,954,10.500,365,1.500,40,43,30,21,20,10,1457,79,115,119,58,114,317,0,289,0,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.37,'false',1,0),
(1470,21660,'Otherworldly Invader Soldier','','neer_crawler',14.00,22.00,35,'male','L2Monster','Fighter',40,1220,13.500,446,1.800,40,43,30,21,20,10,2073,122,126,191,89,137,317,150,289,0,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.37,'false',1,0),
(1471,21661,'Otherworldly Invader Archer','','skeleton_archer',11.00,27.00,33,'male','L2Monster','Ranger',500,1109,13.500,413,1.800,40,43,30,21,20,10,1492,85,491,100,75,128,249,150,227,275,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.80,'false',1,0),
(1472,21662,'Otherworldly Invader Elite Soldier','','dark_horror',20.00,35.00,35,'male','L2Monster','Fighter',40,1220,13.500,446,1.800,40,43,30,21,20,10,1726,102,192,144,89,137,278,150,253,0,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.37,'false',1,0),
(1473,21663,'Otherworldly Invader Shaman','','dark_horror',20.00,35.00,33,'male','L2Monster','Fighter',40,1109,13.500,413,1.800,40,43,30,21,20,10,1884,108,166,134,75,128,278,150,253,0,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.37,'false',1,0),
(1474,21664,'Otherworldly Invader Priest','','dark_horror',20.00,35.00,30,'male','L2Monster','Priest',40,954,7.000,365,1.500,40,43,30,21,20,10,1511,82,132,119,58,114,278,0,253,0,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.37,'false',1,0),
(1475,21665,'Otherworldly Invader Magus','','dark_horror',20.00,35.00,35,'male','L2Monster','Fighter',40,1220,13.500,446,1.800,40,43,30,21,20,10,1362,80,256,108,89,137,278,150,253,0,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.37,'false',1,0),
(1476,21666,'Otherworldly Invader Martyrs','','dark_horror',20.00,35.00,30,'male','L2Monster','Fighter',40,954,10.500,365,1.500,40,43,30,21,20,10,1018,55,132,119,58,114,278,0,253,0,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.37,'false',1,0),
(1477,21667,'Otherworldly Invader Warrior','','skeleton',11.00,25.00,33,'male','L2Monster','Fighter',40,1109,13.500,413,1.800,40,43,30,21,20,10,1211,69,145,157,75,128,317,150,289,220,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.30,'false',1,0),
(1478,21668,'Otherworldly Invader Soldier','','neer_crawler',14.00,22.00,30,'male','L2Monster','Fighter',40,954,10.500,365,1.500,40,43,30,21,20,10,1071,58,115,119,58,114,317,150,289,0,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.37,'false',1,0),
(1479,21669,'Otherworldly Invader Discipline','','skeleton',11.00,25.00,33,'male','L2Monster','Fighter',40,1109,13.500,413,1.800,40,43,30,21,20,10,1275,73,145,157,75,128,317,0,289,220,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.30,'false',1,0),
(1480,21670,'Otherworldly Invader Berserker','','skeleton',11.00,25.00,35,'male','L2Monster','Fighter',40,1220,13.500,446,1.800,40,43,30,21,20,10,1785,105,139,205,89,137,317,150,289,220,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.30,'false',1,0),
(1481,21671,'Otherworldly Invader Food','','mimic',8.50,8.50,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1308,72,132,140,58,114,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(1482,21672,'Otherworldly Invader Elite Soldier','','skeleton_pikeman',10.00,28.00,35,'male','L2Monster','Fighter',40,1220,27.000,446,1.800,40,43,30,21,20,10,1599,94,192,169,89,137,278,150,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.21,'false',1,0),
(1483,21673,'Otherworldly Invader Elite Soldier','','skeleton_pikeman',10.00,28.00,35,'male','L2Monster','Fighter',40,1220,27.000,446,1.800,40,43,30,21,20,10,1629,96,192,169,89,137,278,150,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.21,'false',1,0),
(1484,21674,'Otherworldly Invader Elite Soldier','','skeleton_pikeman',10.00,28.00,35,'male','L2Monster','Fighter',40,1220,1.130,446,1.800,40,43,30,21,20,10,1525,92,192,169,89,137,278,0,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.21,'true',1,0),
(1485,21675,'Otherworldly Invader Elite Soldier','','skeleton_pikeman',10.00,28.00,30,'male','L2Monster','Fighter',40,954,1.750,365,1.500,40,43,30,21,20,10,1555,84,132,140,58,114,278,0,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.21,'true',1,0),
(1486,21676,'Otherworldly Invader Warrior','','skeleton',11.00,25.00,33,'male','L2Monster','Fighter',40,1109,27.000,413,1.800,40,43,30,21,20,10,1452,83,145,157,75,128,317,150,289,220,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.30,'false',1,0),
(1487,21677,'Otherworldly Invader Elite Soldier','','skeleton_pikeman',10.00,28.00,30,'male','L2Monster','Fighter',40,954,21.000,365,1.500,40,43,30,21,20,10,1164,63,109,170,58,114,278,150,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.21,'false',1,0),
(1488,21678,'Otherworldly Invader Elite Soldier','','skeleton_pikeman',10.00,28.00,33,'male','L2Monster','Fighter',40,1109,27.000,413,1.800,40,43,30,21,20,10,1409,80,201,130,75,128,278,150,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.21,'false',1,0),
(1489,21679,'Otherworldly Invader Elite Soldier','','skeleton_pikeman',10.00,28.00,30,'male','L2Monster','Fighter',40,954,21.000,365,1.500,40,43,30,21,20,10,1148,62,109,170,58,114,278,150,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.21,'false',1,0),
(1490,21680,'Otherworldly Invader Elite Soldier','','skeleton_pikeman',10.00,28.00,35,'male','L2Monster','Fighter',40,1220,27.000,446,1.800,40,43,30,21,20,10,1562,92,232,140,89,137,278,150,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.21,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(1491,21681,'Otherworldly Invader Magus','','dark_horror',20.00,35.00,33,'male','L2Monster','Fighter',40,1109,27.000,413,1.800,40,43,30,21,20,10,1343,77,166,157,75,128,278,0,253,0,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',1,0),
(1492,21682,'Dimension Invader Soldier','','neer_crawler',14.00,22.00,40,'male','L2Monster','Fighter',40,1527,13.500,531,1.800,40,43,30,21,20,10,2590,167,238,171,131,164,317,0,289,0,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.37,'false',1,0),
(1493,21683,'Dimension Invader Soldier','','neer_crawler',14.00,22.00,45,'male','L2Monster','Fighter',40,1870,16.500,677,2.100,40,43,30,21,20,10,3427,238,248,269,188,193,317,150,289,0,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.37,'false',1,0),
(1494,21684,'Dimension Invader Archer','','skeleton_archer',11.00,27.00,43,'male','L2Monster','Ranger',500,1728,16.500,618,2.100,40,43,30,21,20,10,2534,171,984,142,163,181,249,150,227,279,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.80,'false',1,0),
(1495,21685,'Dimension Invader Elite Soldier','','crimson_doll',15.00,38.00,45,'male','L2Monster','Fighter',40,1870,16.500,677,2.100,40,43,30,21,20,10,2853,198,377,202,188,193,278,150,253,0,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.67,'false',1,0),
(1496,21686,'Dimension Invader Shaman','','crimson_doll',15.00,38.00,43,'male','L2Monster','Fighter',40,1728,16.500,618,2.100,40,43,30,21,20,10,3199,216,332,189,163,181,278,150,253,0,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.67,'false',1,0),
(1497,21687,'Dimension Invader Priest','','crimson_doll',15.00,38.00,40,'male','L2Monster','Fighter',40,1527,9.000,531,1.800,40,43,30,21,20,10,2686,173,273,171,131,164,278,0,253,0,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.67,'false',1,0),
(1498,21688,'Dimension Invader Magus','','crimson_doll',15.00,38.00,45,'male','L2Monster','Fighter',40,1870,16.500,677,2.100,40,43,30,21,20,10,2253,156,502,152,188,193,278,150,253,0,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.67,'false',1,0),
(1499,21689,'Dimension Invader Martyrs','','crimson_doll',15.00,38.00,40,'male','L2Monster','Fighter',40,1527,13.500,531,1.800,40,43,30,21,20,10,1809,117,273,171,131,164,278,0,253,0,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.67,'false',1,0),
(1500,21690,'Dimension Invader Warrior','','skeleton_knight',10.00,25.00,43,'male','L2Monster','Fighter',40,1728,16.500,618,2.100,40,43,30,21,20,10,2057,139,332,223,163,181,278,150,253,70,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(1501,21691,'Dimension Invader Soldier','','neer_crawler',14.00,22.00,40,'male','L2Monster','Fighter',40,1527,13.500,531,1.800,40,43,30,21,20,10,1905,123,238,171,131,164,317,150,289,0,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.37,'false',1,0),
(1502,21692,'Dimension Invader Discipline','','skeleton_knight',10.00,25.00,43,'male','L2Monster','Fighter',40,1728,16.500,618,2.100,40,43,30,21,20,10,2166,146,332,223,163,181,278,0,253,70,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(1503,21693,'Dimension Invader Berserker','','skeleton_knight',10.00,25.00,45,'male','L2Monster','Fighter',40,1870,16.500,677,2.100,40,43,30,21,20,10,2951,205,312,288,188,193,278,150,253,70,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(1504,21694,'Dimension Invader Food','','mimic',8.50,8.50,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2327,150,273,201,131,164,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(1505,21695,'Dimension Invader Elite Soldier','','headless_knight',21.00,31.00,45,'male','L2Monster','Fighter',40,1870,33.000,677,2.100,40,43,30,21,20,10,2643,183,377,238,188,193,278,150,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(1506,21696,'Dimension Invader Elite Soldier','','headless_knight',21.00,31.00,45,'male','L2Monster','Fighter',40,1870,33.000,677,2.100,40,43,30,21,20,10,2693,187,377,238,188,193,278,150,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(1507,21697,'Dimension Invader Elite Soldier','','headless_knight',21.00,31.00,45,'male','L2Monster','Fighter',40,1870,1.380,677,2.100,40,43,30,21,20,10,2521,176,377,238,188,193,278,0,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',1,0),
(1508,21698,'Dimension Invader Elite Soldier','','headless_knight',21.00,31.00,40,'male','L2Monster','Fighter',40,1527,2.250,531,1.800,40,43,30,21,20,10,2764,178,273,201,131,164,278,0,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',1,0),
(1509,21699,'Dimension Invader Warrior','','skeleton_knight',10.00,25.00,43,'male','L2Monster','Fighter',40,1728,33.000,618,2.100,40,43,30,21,20,10,2466,166,332,223,163,181,278,150,253,70,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(1510,21700,'Dimension Invader Elite Soldier','','headless_knight',21.00,31.00,40,'male','L2Monster','Fighter',40,1527,27.000,531,1.800,40,43,30,21,20,10,2070,133,225,244,131,164,278,150,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(1511,21701,'Dimension Invader Elite Soldier','','headless_knight',21.00,31.00,43,'male','L2Monster','Fighter',40,1728,33.000,618,2.100,40,43,30,21,20,10,2392,161,402,184,163,181,278,150,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(1512,21702,'Dimension Invader Elite Soldier','','headless_knight',21.00,31.00,40,'male','L2Monster','Fighter',40,1527,27.000,531,1.800,40,43,30,21,20,10,2041,131,225,244,131,164,278,150,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(1513,21703,'Dimension Invader Elite Soldier','','headless_knight',21.00,31.00,45,'male','L2Monster','Fighter',40,1870,33.000,677,2.100,40,43,30,21,20,10,2583,179,457,196,188,193,278,150,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(1514,21704,'Dimension Invader Magus','','crimson_doll',15.00,38.00,43,'male','L2Monster','Fighter',40,1728,33.000,618,2.100,40,43,30,21,20,10,2281,154,332,223,163,181,278,0,253,0,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.67,'false',1,0),
(1515,21705,'Purgatory Invader Soldier','','doll_blader',6.00,12.00,50,'male','L2Monster','Fighter',40,2245,16.500,830,2.100,40,43,30,21,20,10,4047,305,445,236,264,226,317,0,289,5129,5129,0,22,165,'ssq_clan',300,'Local','',0,0,87,7,10,8,0,0,10,0.50,'false',1,0),
(1516,21706,'Purgatory Invader Soldier','','doll_blader',6.00,12.00,55,'male','L2Monster','Fighter',40,2643,19.500,987,2.400,40,43,30,21,20,10,5120,413,440,364,360,261,317,150,289,5129,5129,0,22,165,'ssq_clan',300,'Local','',0,0,98,7,10,8,0,0,10,0.50,'false',1,0),
(1517,21707,'Purgatory Invader Archer','','skeleton_archer',11.00,27.00,53,'male','L2Monster','Ranger',500,2481,19.500,923,2.400,40,43,30,21,20,10,3850,302,1782,194,319,247,249,150,227,282,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.80,'false',1,0),
(1518,21708,'Purgatory Invader Elite Soldier','','banshee',9.00,23.00,55,'female','L2Monster','Mystic',40,2643,19.500,987,2.400,40,43,30,21,20,10,4262,344,670,273,360,261,278,150,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(1519,21709,'Purgatory Invader Shaman','','banshee',9.00,23.00,53,'female','L2Monster','Mystic',40,2481,19.500,923,2.400,40,43,30,21,20,10,4861,382,602,258,319,247,278,150,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(1520,21710,'Purgatory Invader Priest','','banshee',9.00,23.00,50,'female','L2Monster','Priest',40,2245,11.000,830,2.100,40,43,30,21,20,10,4198,316,509,236,264,226,278,0,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(1521,21711,'Purgatory Invader Magus','','banshee',9.00,23.00,55,'female','L2Monster','Mystic',40,2643,19.500,987,2.400,40,43,30,21,20,10,3365,271,892,205,360,261,278,150,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(1522,21712,'Purgatory Invader Martyrs','','banshee',9.00,23.00,50,'female','L2Monster','Mystic',40,2245,16.500,830,2.100,40,43,30,21,20,10,2828,213,509,236,264,226,278,0,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(1523,21713,'Purgatory Invader Warrior','','skeleton_royal_guard',11.00,28.50,53,'male','L2Monster','Fighter',40,2481,19.500,923,2.400,40,43,30,21,20,10,3125,245,527,304,319,247,317,150,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,107,7,10,8,0,0,-6,0.52,'false',1,0),
(1524,21714,'Purgatory Invader Soldier','','doll_blader',6.00,12.00,50,'male','L2Monster','Fighter',40,2245,16.500,830,2.100,40,43,30,21,20,10,2977,224,445,236,264,226,317,150,289,5129,5129,0,22,165,'ssq_clan',300,'Local','',0,0,87,7,10,8,0,0,10,0.50,'false',1,0),
(1525,21715,'Purgatory Invader Disciples','','skeleton_royal_guard',11.00,28.50,53,'male','L2Monster','Fighter',40,2481,19.500,923,2.400,40,43,30,21,20,10,3291,258,527,304,319,247,317,0,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,107,7,10,8,0,0,-6,0.52,'false',1,0),
(1526,21716,'Purgatory Invader Berserker','','skeleton_royal_guard',11.00,28.50,55,'male','L2Monster','Fighter',40,2643,19.500,987,2.400,40,43,30,21,20,10,4409,356,484,389,360,261,317,150,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,111,7,10,8,0,0,-6,0.52,'false',1,0),
(1527,21717,'Purgatory Invader Food','','mimic',8.50,8.50,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3636,274,509,278,264,226,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(1528,21718,'Purgatory Invader Elite Soldier','','bloody_queen',14.00,40.00,55,'female','L2Monster','Mystic',40,2643,39.000,987,2.400,40,43,30,21,20,10,3949,318,670,322,360,261,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1529,21719,'Purgatory Invader Elite Soldier','','bloody_queen',14.00,40.00,55,'female','L2Monster','Mystic',40,2643,39.000,987,2.400,40,43,30,21,20,10,4023,324,670,322,360,261,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1530,21720,'Purgatory Invader Elite Soldier','','bloody_queen',14.00,40.00,55,'female','L2Monster','Mystic',40,2643,1.630,987,2.400,40,43,30,21,20,10,3766,304,670,322,360,261,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(1531,21721,'Purgatory Invader Elite Soldier','','bloody_queen',14.00,40.00,50,'female','L2Monster','Mystic',40,2245,2.750,830,2.100,40,43,30,21,20,10,4319,326,509,278,264,226,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(1532,21722,'Purgatory Invader Warrior','','skeleton_royal_guard',11.00,28.50,53,'male','L2Monster','Fighter',40,2481,39.000,923,2.400,40,43,30,21,20,10,3746,294,527,304,319,247,317,150,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,107,7,10,8,0,0,-6,0.52,'false',1,0),
(1533,21723,'Purgatory Invader Elite Soldier','','bloody_queen',14.00,40.00,50,'female','L2Monster','Mystic',40,2245,33.000,830,2.100,40,43,30,21,20,10,3235,243,421,336,264,226,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1534,21724,'Purgatory Invader Elite Soldier','','bloody_queen',14.00,40.00,53,'female','L2Monster','Mystic',40,2481,39.000,923,2.400,40,43,30,21,20,10,3635,285,729,251,319,247,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1535,21725,'Purgatory Invader Elite Soldier','','bloody_queen',14.00,40.00,50,'female','L2Monster','Mystic',40,2245,33.000,830,2.100,40,43,30,21,20,10,3189,240,421,336,264,226,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1536,21726,'Purgatory Invader Elite Soldier','','bloody_queen',14.00,40.00,55,'female','L2Monster','Mystic',40,2643,39.000,987,2.400,40,43,30,21,20,10,3859,311,811,266,360,261,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1537,21727,'Purgatory Invader Magus','','banshee',9.00,23.00,53,'female','L2Monster','Mystic',40,2481,39.000,923,2.400,40,43,30,21,20,10,3465,272,602,258,319,247,278,0,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(1538,21728,'Forbidden Path Invader Elite Soldier','','doll_blader',6.00,12.00,60,'male','L2Monster','Fighter',40,3054,19.500,1150,2.400,40,43,30,21,20,10,5828,506,753,313,478,299,317,0,289,5129,5129,0,22,165,'ssq_clan',300,'Local','',0,0,108,7,10,8,0,0,10,0.50,'false',1,0),
(1539,21729,'Forbidden Path Invader Elite Soldier','','doll_blader',6.00,12.00,65,'male','L2Monster','Fighter',40,3465,22.500,1319,2.700,40,43,30,21,20,10,7151,664,708,473,619,340,317,150,289,5129,5129,0,22,165,'ssq_clan',300,'Local','',0,0,119,7,10,8,0,0,10,0.50,'false',1,0),
(1540,21730,'Forbidden Path Invader Archer','','skeleton_archer',11.00,27.00,63,'male','L2Monster','Ranger',500,3302,22.500,1251,2.700,40,43,30,21,20,10,5439,491,2920,254,560,323,249,150,227,284,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.80,'false',1,0),
(1541,21731,'Forbidden Path Invader Elite Soldier','','banshee',9.00,23.00,65,'female','L2Monster','Mystic',40,3465,22.500,1319,2.700,40,43,30,21,20,10,5952,553,1077,355,619,340,278,150,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(1542,21732,'Forbidden Path Invader Shaman','','banshee',9.00,23.00,63,'female','L2Monster','Mystic',40,3302,22.500,1251,2.700,40,43,30,21,20,10,6868,620,987,338,560,323,278,150,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(1543,21733,'Forbidden Path Invader Priest','','banshee',9.00,23.00,60,'female','L2Monster','Priest',40,3054,13.000,1150,2.400,40,43,30,21,20,10,6045,525,860,313,478,299,278,0,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(1544,21734,'Forbidden Path Invader Magus','','banshee',9.00,23.00,65,'female','L2Monster','Mystic',40,3465,22.500,1319,2.700,40,43,30,21,20,10,4700,436,1433,267,619,340,278,150,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(1545,21735,'Forbidden Path Invader Martyrs','','banshee',9.00,23.00,60,'female','L2Monster','Mystic',40,3054,19.500,1150,2.400,40,43,30,21,20,10,4072,353,860,313,478,299,278,0,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(1546,21736,'Forbidden Path Invader Warrior','','skeleton_royal_guard',11.00,28.50,63,'male','L2Monster','Fighter',40,3302,22.500,1251,2.700,40,43,30,21,20,10,4415,398,864,398,560,323,317,150,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,131,7,10,8,0,0,-6,0.52,'false',1,0),
(1547,21737,'Forbidden Path Invader Soldier','','doll_blader',6.00,12.00,60,'male','L2Monster','Fighter',40,3054,19.500,1150,2.400,40,43,30,21,20,10,4287,372,753,313,478,299,317,150,289,5129,5129,0,22,165,'ssq_clan',300,'Local','',0,0,108,7,10,8,0,0,10,0.50,'false',1,0),
(1548,21738,'Forbidden Path Invader Disciple','','skeleton_royal_guard',11.00,28.50,63,'male','L2Monster','Fighter',40,3302,22.500,1251,2.700,40,43,30,21,20,10,4650,419,864,398,560,323,317,0,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,131,7,10,8,0,0,-6,0.52,'false',1,0),
(1549,21739,'Forbidden Path Invader Berserker','','skeleton_royal_guard',11.00,28.50,65,'male','L2Monster','Fighter',40,3465,22.500,1319,2.700,40,43,30,21,20,10,6158,572,778,506,619,340,317,150,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,135,7,10,8,0,0,-6,0.52,'false',1,0),
(1550,21740,'Forbidden Path Invader Food','','mimic',8.50,8.50,60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,5235,454,860,368,478,299,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(1551,21741,'Forbidden Path Invader Elite Soldier','','bloody_queen',14.00,40.00,65,'female','L2Monster','Mystic',40,3465,45.000,1319,2.700,40,43,30,21,20,10,5515,512,1077,418,619,340,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1552,21742,'Forbidden Path Invader Elite Soldier','','bloody_queen',14.00,40.00,65,'female','L2Monster','Mystic',40,3465,45.000,1319,2.700,40,43,30,21,20,10,5620,522,1077,418,619,340,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1553,21743,'Forbidden Path Invader Elite Soldier','','bloody_queen',14.00,40.00,65,'female','L2Monster','Mystic',40,3465,1.880,1319,2.700,40,43,30,21,20,10,5259,488,1077,418,619,340,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(1554,21744,'Forbidden Path Invader Elite Soldier','','bloody_queen',14.00,40.00,60,'female','L2Monster','Mystic',40,3054,3.250,1150,2.400,40,43,30,21,20,10,6220,540,860,368,478,299,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(1555,21745,'Forbidden Path Invader Warrior','','skeleton_royal_guard',11.00,28.50,63,'male','L2Monster','Fighter',40,3302,45.000,1251,2.700,40,43,30,21,20,10,5294,478,864,398,560,323,317,150,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,131,7,10,8,0,0,-6,0.52,'false',1,0),
(1556,21746,'Forbidden Path Invader Elite Soldier','','bloody_queen',14.00,40.00,60,'female','L2Monster','Mystic',40,3054,39.000,1150,2.400,40,43,30,21,20,10,4658,404,711,446,478,299,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1557,21747,'Forbidden Path Invader Elite Soldier','','bloody_queen',14.00,40.00,63,'female','L2Monster','Mystic',40,3302,45.000,1251,2.700,40,43,30,21,20,10,5136,463,1194,329,560,323,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1558,21748,'Forbidden Path Invader Elite Soldier','','bloody_queen',14.00,40.00,60,'female','L2Monster','Mystic',40,3054,39.000,1150,2.400,40,43,30,21,20,10,4592,398,711,446,478,299,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1559,21749,'Forbidden Path Invader Elite Soldier','','bloody_queen',14.00,40.00,65,'female','L2Monster','Mystic',40,3465,45.000,1319,2.700,40,43,30,21,20,10,5390,500,1303,346,619,340,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1560,21750,'Forbidden Path Invader Magus','','banshee',9.00,23.00,63,'female','L2Monster','Mystic',40,3302,45.000,1251,2.700,40,43,30,21,20,10,4897,442,987,338,560,323,278,0,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(1561,21751,'Dark Omen Invader Soldier','','giant_zombie',13.00,40.00,70,'male','L2Monster','Mystic',40,3862,22.500,1493,2.700,40,43,30,21,20,10,7933,786,1314,470,780,382,278,0,253,0,0,0,20,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1562,21752,'Dark Omen Invader Soldier','','giant_zombie',13.00,40.00,75,'male','L2Monster','Mystic',40,4229,25.500,1673,3.000,40,43,30,21,20,10,9521,1004,1175,696,957,425,278,150,253,0,0,0,20,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1563,21753,'Dark Omen Invader Archer','','skeleton_archer',11.00,27.00,73,'male','L2Monster','Ranger',500,4086,25.500,1601,3.000,40,43,30,21,20,10,7303,751,4327,320,885,407,249,150,227,288,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.80,'false',1,0),
(1564,21754,'Dark Omen Invader Elite Soldier','','doll_master',20.00,42.00,75,'male','L2Monster','Fighter',40,4229,25.500,1673,3.000,40,43,30,21,20,10,7925,836,1368,445,957,425,317,150,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.56,'false',1,0),
(1565,21755,'Dark Omen Invader Shaman','','doll_master',20.00,42.00,73,'male','L2Monster','Fighter',40,4086,25.500,1601,3.000,40,43,30,21,20,10,9222,949,1280,426,885,407,317,150,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.56,'false',1,0),
(1566,21756,'Dark Omen Invader Priest','','doll_master',20.00,42.00,70,'male','L2Monster','Priest',40,3862,15.000,1493,2.700,40,43,30,21,20,10,8228,816,1150,399,780,382,317,0,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.56,'false',1,0),
(1567,21757,'Dark Omen Invader Magus','','doll_master',20.00,42.00,75,'male','L2Monster','Fighter',40,4229,25.500,1673,3.000,40,43,30,21,20,10,6258,660,1821,334,957,425,317,150,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.56,'false',1,0),
(1568,21758,'Dark Omen Invader Martyrs','','doll_master',20.00,42.00,70,'male','L2Monster','Fighter',40,3862,22.500,1493,2.700,40,43,30,21,20,10,5542,549,1150,399,780,382,317,0,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.56,'false',1,0),
(1569,21759,'Dark Omen Invader Warrior','','imperial_warlord_zombie',7.00,30.00,73,'male','L2Monster','Fighter',40,4086,25.500,1601,3.000,40,43,30,21,20,10,5929,610,1463,502,885,407,278,150,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,155,7,30,4,4,0,-6,0.48,'false',1,0),
(1570,21760,'Dark Omen Invader Soldier','','giant_zombie',13.00,40.00,70,'male','L2Monster','Mystic',40,3862,22.500,1493,2.700,40,43,30,21,20,10,5835,578,1314,470,780,382,278,150,253,0,0,0,20,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1571,21761,'Dark Omen Invader Disciple','','imperial_warlord_zombie',7.00,30.00,73,'male','L2Monster','Fighter',40,4086,25.500,1601,3.000,40,43,30,21,20,10,6243,642,1463,502,885,407,278,0,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,155,7,30,4,4,0,-6,0.48,'false',1,0),
(1572,21762,'Dark Omen Invader Berserker','','imperial_warlord_zombie',7.00,30.00,75,'male','L2Monster','Fighter',40,4229,25.500,1673,3.000,40,43,30,21,20,10,8198,864,1292,633,957,425,278,150,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,159,7,30,4,4,0,-6,0.48,'false',1,0),
(1573,21763,'Dark Omen Invader Food','','mimic',8.50,8.50,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,7126,707,1314,470,780,382,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(1574,21764,'Dark Omen Invader Elite Soldier','','death_blader',15.00,45.00,75,'male','L2Monster','Fighter',40,4229,51.000,1673,3.000,40,43,30,21,20,10,7343,774,1563,523,957,425,278,150,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(1575,21765,'Dark Omen Invader Elite Soldier','','death_blader',15.00,45.00,75,'male','L2Monster','Fighter',40,4229,51.000,1673,3.000,40,43,30,21,20,10,7482,789,1563,523,957,425,278,150,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(1576,21766,'Dark Omen Invader Elite Soldier','','death_blader',15.00,45.00,75,'male','L2Monster','Fighter',40,4229,2.130,1673,3.000,40,43,30,21,20,10,7002,740,1563,523,957,425,278,0,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(1577,21767,'Dark Omen Invader Elite Soldier','','death_blader',15.00,45.00,70,'male','L2Monster','Fighter',40,3862,3.750,1493,2.700,40,43,30,21,20,10,8466,840,1314,470,780,382,278,0,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(1578,21768,'Dark Omen Invader Warrior','','imperial_warlord_zombie',7.00,30.00,73,'male','L2Monster','Fighter',40,4086,51.000,1601,3.000,40,43,30,21,20,10,7108,731,1463,502,885,407,278,150,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,155,7,30,4,4,0,-6,0.48,'false',1,0),
(1579,21769,'Dark Omen Invader Elite Soldier','','death_blader',15.00,45.00,70,'male','L2Monster','Fighter',40,3862,45.000,1493,2.700,40,43,30,21,20,10,6341,628,1086,569,780,382,278,150,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(1580,21770,'Dark Omen Invader Elite Soldier','','death_blader',15.00,45.00,73,'male','L2Monster','Fighter',40,4086,51.000,1601,3.000,40,43,30,21,20,10,6896,709,1770,415,885,407,278,150,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(1581,21771,'Dark Omen Invader Elite Soldier','','death_blader',15.00,45.00,70,'male','L2Monster','Fighter',40,3862,45.000,1493,2.700,40,43,30,21,20,10,6251,619,1086,569,780,382,278,150,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(1582,21772,'Dark Omen Invader Elite Soldier','','death_blader',15.00,45.00,75,'male','L2Monster','Fighter',40,4229,51.000,1673,3.000,40,43,30,21,20,10,7176,757,1892,432,957,425,278,150,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(1583,21773,'Dark Omen Invader Magus','','doll_master',20.00,42.00,73,'male','L2Monster','Fighter',40,4086,51.000,1601,3.000,40,43,30,21,20,10,6575,676,1280,426,885,407,317,0,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.56,'false',1,0),
(1584,21774,'Messenger Invader Soldier','','giant_zombie',13.00,40.00,80,'male','L2Monster','Mystic',40,4550,25.500,1859,3.000,40,43,30,21,20,10,10362,1163,1814,576,1144,468,278,0,253,0,0,0,20,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1585,21775,'Messenger Invader Soldier','','giant_zombie',13.00,40.00,80,'male','L2Monster','Mystic',40,4813,25.500,2049,3.000,40,43,30,21,20,10,12230,1455,1542,837,1333,511,278,150,253,0,0,0,20,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1586,21776,'Messenger Invader Archer','','skeleton_archer',11.00,27.00,80,'male','L2Monster','Ranger',500,4716,25.500,1972,3.000,40,43,30,21,20,10,9442,1097,5796,388,1258,494,249,150,227,289,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,0.80,'false',1,0),
(1587,21777,'Messenger Invader Elite Soldier','','doll_master',20.00,42.00,80,'male','L2Monster','Fighter',40,4813,25.500,2049,3.000,40,43,30,21,20,10,10179,1211,1796,535,1333,511,317,150,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.56,'false',1,0),
(1588,21778,'Messenger Invader Shaman','','doll_master',20.00,42.00,80,'male','L2Monster','Fighter',40,4716,25.500,1972,3.000,40,43,30,21,20,10,11921,1386,1714,517,1258,494,317,150,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.56,'false',1,0),
(1589,21779,'Messenger Invader Priest','','doll_master',20.00,42.00,80,'male','L2Monster','Priest',40,4550,17.000,1859,3.000,40,43,30,21,20,10,10747,1206,1587,490,1144,468,317,0,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.56,'false',1,0),
(1590,21780,'Messenger Invader Magus','','doll_master',20.00,42.00,80,'male','L2Monster','Fighter',40,4813,25.500,2049,3.000,40,43,30,21,20,10,8038,957,2390,402,1333,511,317,150,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.56,'false',1,0),
(1591,21781,'Messenger Invader Martyrs','','doll_master',20.00,42.00,80,'male','L2Monster','Fighter',40,4550,25.500,1859,3.000,40,43,30,21,20,10,7239,812,1587,490,1144,468,317,0,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.56,'false',1,0),
(1592,21782,'Messenger Invader Warrior','','imperial_warlord_zombie',7.00,30.00,80,'male','L2Monster','Fighter',40,4716,25.500,1972,3.000,40,43,30,21,20,10,7664,891,1959,608,1258,494,278,150,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,176,7,30,4,4,0,-6,0.48,'false',1,0),
(1593,21783,'Messenger Invader Soldier','','giant_zombie',13.00,40.00,80,'male','L2Monster','Mystic',40,4550,25.500,1859,3.000,40,43,30,21,20,10,7621,855,1814,576,1144,468,278,150,253,0,0,0,20,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1594,21784,'Messenger Invader Disciple','','imperial_warlord_zombie',7.00,30.00,80,'male','L2Monster','Fighter',40,4716,25.500,1972,3.000,40,43,30,21,20,10,8071,938,1959,608,1258,494,278,0,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,176,7,30,4,4,0,-6,0.48,'false',1,0),
(1595,21785,'Messenger Invader Berserker','','imperial_warlord_zombie',7.00,30.00,80,'male','L2Monster','Fighter',40,4813,25.500,2049,3.000,40,43,30,21,20,10,10530,1253,1696,761,1333,511,278,150,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,180,7,30,4,4,0,-6,0.48,'false',1,0),
(1596,21786,'Messenger Invader Food','','mimic',8.50,8.50,80,'male','L2Monster','Fighter',40,4550,8.500,1859,3.000,40,43,30,21,20,10,9308,1045,1814,576,1144,468,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(1597,21787,'Messenger Invader Elite Soldier','','death_lord',21.00,40.00,80,'male','L2Monster','Fighter',40,4813,51.000,2049,3.000,40,43,30,21,20,10,9432,1122,2052,629,1333,511,278,150,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1598,21788,'Messenger Invader Elite Soldier','','death_lord',21.00,40.00,80,'male','L2Monster','Fighter',40,4813,51.000,2049,3.000,40,43,30,21,20,10,9610,1144,2052,629,1333,511,278,150,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1599,21789,'Messenger Invader Elite Soldier','','death_lord',21.00,40.00,80,'male','L2Monster','Fighter',40,4813,2.130,2049,3.000,40,43,30,21,20,10,8994,1072,2052,629,1333,511,278,0,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(1600,21790,'Messenger Invader Elite Soldier','','death_lord',21.00,40.00,80,'male','L2Monster','Fighter',40,4550,4.250,1859,3.000,40,43,30,21,20,10,11058,1242,1814,576,1144,468,278,0,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',1,0),
(1601,21791,'Messenger Invader Warrior','','imperial_warlord_zombie',7.00,30.00,80,'male','L2Monster','Fighter',40,4716,51.000,1972,3.000,40,43,30,21,20,10,9189,1068,1959,608,1258,494,278,150,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,176,7,30,4,4,0,-6,0.48,'false',1,0),
(1602,21792,'Messenger Invader Elite Soldier','','death_lord',21.00,40.00,80,'male','L2Monster','Fighter',40,4550,51.000,1859,3.000,40,43,30,21,20,10,8282,929,1499,698,1144,468,278,150,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1603,21793,'Messenger Invader Elite Soldier','','death_lord',21.00,40.00,80,'male','L2Monster','Fighter',40,4716,51.000,1972,3.000,40,43,30,21,20,10,8915,1036,2371,503,1258,494,278,150,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1604,21794,'Messenger Invader Elite Soldier','','death_lord',21.00,40.00,80,'male','L2Monster','Fighter',40,4550,51.000,1859,3.000,40,43,30,21,20,10,8165,916,1499,698,1144,468,278,150,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1605,21795,'Messenger Invader Elite Soldier','','death_lord',21.00,40.00,80,'male','L2Monster','Fighter',40,4813,51.000,2049,3.000,40,43,30,21,20,10,9217,1097,2483,520,1333,511,278,150,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(1606,21796,'Messenger Invader Magus','','doll_master',20.00,42.00,80,'male','L2Monster','Fighter',40,4716,51.000,1972,3.000,40,43,30,21,20,10,8499,988,1714,517,1258,494,317,0,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,0.56,'false',1,0),
(1607,21797,'Spirit of Timiniel','','pixy',5.00,25.00,55,'female','L2Monster','Fighter',40,2643,3.250,987,2.400,40,43,30,21,20,10,3959,320,554,331,360,261,278,0,253,0,0,0,80,165,'timiniel_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.72,'true',1,0),
(1608,21798,'Ghost of a Gatekeeper','','skeleton_knight',10.00,25.00,76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,7104,759,1614,534,994,433,278,0,253,150,103,0,40,165,'',0,'DRIVER','',0,20,161,7,30,4,4,0,-6,0.17,'false',1,0),
(1609,21799,'Ghost of a Gatekeeper','','skeleton_knight',10.00,25.00,76,'male','L2Monster','Fighter',40,4297,25.500,1710,3.000,40,43,30,21,20,10,8710,931,1614,534,994,433,278,0,253,150,103,0,40,165,'',0,'DRIVER','',0,20,161,7,30,4,4,0,-6,0.17,'false',1,0),
(1610,21800,'Vassal Ghost','','zombie',13.00,21.00,77,'male','L2Monster','Mystic',40,4364,17.000,1747,3.000,40,43,30,21,20,10,6616,716,1664,544,1031,442,278,0,253,0,0,0,15,165,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.43,'false',1,0),
(1611,21801,'Treasure Chest','','mimic',8.50,8.50,21,'male','L2Chest','Fighter',40,575,3.500,227,1.500,40,43,30,21,20,10,630,29,63,98,25,80,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1612,21802,'Treasure Chest','','mimic',8.50,8.50,24,'male','L2Chest','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,771,38,81,111,34,90,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1613,21803,'Treasure Chest','','mimic',8.50,8.50,27,'male','L2Chest','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,918,47,104,125,45,102,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1614,21804,'Treasure Chest','','mimic',8.50,8.50,30,'male','L2Chest','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1080,59,132,140,58,114,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1615,21805,'Treasure Chest','','mimic',8.50,8.50,33,'male','L2Chest','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1306,75,166,157,75,128,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1616,21806,'Treasure Chest','','mimic',8.50,8.50,36,'male','L2Chest','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,1555,94,206,175,96,142,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1617,21807,'Treasure Chest','','mimic',8.50,8.50,39,'male','L2Chest','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,1825,116,255,195,121,158,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1618,21808,'Treasure Chest','','mimic',8.50,8.50,42,'male','L2Chest','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,2116,141,311,215,152,175,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1619,21809,'Treasure Chest','','mimic',8.50,8.50,45,'male','L2Chest','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,2430,169,377,238,188,193,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1620,21810,'Treasure Chest','','mimic',8.50,8.50,48,'male','L2Chest','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,2764,202,453,261,231,212,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1621,21811,'Treasure Chest','','mimic',8.50,8.50,51,'male','L2Chest','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,3121,238,539,286,281,232,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1622,21812,'Treasure Chest','','mimic',8.50,8.50,54,'male','L2Chest','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,3499,279,636,313,339,254,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1623,21813,'Treasure Chest','','mimic',8.50,8.50,57,'male','L2Chest','Fighter',40,2806,6.500,1052,2.400,40,43,30,21,20,10,3898,324,743,340,405,276,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1624,21814,'Treasure Chest','','mimic',8.50,8.50,60,'male','L2Chest','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,4320,375,860,368,478,299,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1625,21815,'Treasure Chest','','mimic',8.50,8.50,63,'male','L2Chest','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,4762,430,987,398,560,323,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1626,21816,'Treasure Chest','','mimic',8.50,8.50,66,'male','L2Chest','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,5227,492,1123,428,649,348,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1627,21817,'Treasure Chest','','mimic',8.50,8.50,69,'male','L2Chest','Fighter',40,3784,7.500,1458,2.700,40,43,30,21,20,10,5713,559,1265,460,746,373,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1628,21818,'Treasure Chest','','mimic',8.50,8.50,72,'male','L2Chest','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,6220,632,1413,491,849,399,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1629,21819,'Treasure Chest','','mimic',8.50,8.50,75,'male','L2Chest','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,6750,712,1563,523,957,425,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1630,21820,'Treasure Chest','','mimic',8.50,8.50,78,'male','L2Chest','Fighter',40,4428,8.500,1784,3.000,40,43,30,21,20,10,7300,799,1715,555,1069,451,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1631,21821,'Treasure Chest','','mimic',8.50,8.50,81,'male','L2Chest','Fighter',40,4608,8.500,1896,3.000,40,43,30,21,20,10,7873,894,1863,587,1182,477,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1632,21822,'Treasure Chest','','mimic',8.50,8.50,84,'male','L2Chest','Fighter',40,4766,8.500,2011,3.000,40,43,30,21,20,10,8467,996,2006,619,1296,502,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1633,21823,'Executor of Sacrificial Offerings','','imperial_warlord_zombie',7.00,30.00,80,'male','L2Monster','Fighter',40,4550,51.000,1859,3.000,40,43,30,21,20,10,12042,1351,1814,576,1144,468,278,0,253,134,6721,0,39,190,'tomb_clan',300,'DRIVER','',0,20,170,7,30,4,4,0,-6,0.48,'false',0,0),
(1634,21824,'Alpen Kookaburra','','rough_ostrich',20.00,31.00,65,'male','L2FeedableBeast','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(1635,21825,'Alpen Kookaburra','','rough_ostrich',20.00,31.00,65,'male','L2FeedableBeast','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(1636,21826,'Alpen Buffalo','','buffalo',20.00,31.00,67,'male','L2FeedableBeast','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(1637,21827,'Alpen Buffalo','','buffalo',20.00,31.00,67,'male','L2FeedableBeast','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(1638,21828,'Alpen Cougar','','saber_toothed_tiger',20.00,31.00,69,'male','L2FeedableBeast','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(1639,21829,'Alpen Cougar','','saber_toothed_tiger',20.00,31.00,69,'male','L2FeedableBeast','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(1640,22001,'Grim Wolf','','dire_wolf',13.00,11.00,25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,826,41,80,127,37,94,278,0,253,2,0,0,50,110,'',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1641,22002,'Grim Grizzly','','grizzly',21.00,40.00,26,'male','L2Monster','Fighter',40,770,3.500,303,1.500,40,43,30,21,20,10,1078,54,87,132,41,98,278,500,253,0,0,0,90,159,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(1642,22003,'Grave Robber Scout','','e_traderB_Fdwarf_mon',6.00,18.00,27,'female','L2Monster','Fighter',40,813,7.500,1493,2.700,40,43,30,21,20,10,1162,59,131,119,45,112,278,0,333,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'true',1,0),
(1643,22004,'Grave Robber Lookout','','dwarf_ghost',10.00,18.70,27,'male','L2Monster','Fighter',40,813,3.500,318,1.500,40,43,30,21,20,10,1124,58,114,114,45,102,278,500,253,0,0,0,35,131,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(1644,22005,'Grave Robber Ranger','','e_collector_teacher_Fdwarf_mon',8.00,17.50,28,'female','L2Monster','Ranger',40,859,7.500,1493,2.700,40,43,30,21,20,10,1230,64,131,170,58,107,278,0,333,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'true',1,0),
(1645,22006,'Grave Robber Guard','','e_collector_teacher_Mdwarf_mon',8.00,17.50,29,'male','L2Monster','Fighter',40,906,7.500,1493,2.700,40,43,30,21,20,10,1298,68,146,137,63,112,278,0,333,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'true',1,0),
(1646,22007,'Ghost of a Soldier','','orc',10.00,21.00,29,'male','L2Monster','Fighter',40,906,14.000,349,1.500,40,43,30,21,20,10,927,49,111,149,53,110,278,500,253,221,0,0,60,140,'',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(1647,22008,'Grave Robber Fighter','','e_collector_teacher_Mdwarf_mon',8.00,17.50,30,'male','L2Monster','Fighter',40,954,7.500,1493,2.700,40,43,30,21,20,10,1367,74,131,125,58,114,278,0,333,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'true',1,0),
(1648,22009,'Ghost of a Loyal Vassal','','orc_shaman',9.00,22.00,31,'male','L2Monster','Mystic',40,1004,9.000,381,1.800,40,43,30,21,20,10,1083,60,157,133,64,118,278,0,253,0,0,0,90,90,'',300,'','',0,0,0,7,30,4,4,0,0,0.30,'true',1,0),
(1649,22010,'Ghost of a General','','orc_fighter',12.00,22.00,32,'male','L2Monster','Fighter',40,1056,9.000,397,1.800,40,43,30,21,20,10,1200,67,169,138,69,123,278,0,253,0,0,0,40,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(1650,22011,'Ghost of a Batur Chief','','orc_champion',10.00,23.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(1651,22012,'Ghost of a Batur Chief','','orc_champion',10.00,23.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(1652,22013,'Ghost of a Morek Chief','','orc_champion',10.00,23.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(1653,22014,'Ghost of a Morek Chief','','orc_champion',10.00,23.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(1654,22015,'Ghost of a Turka Chief','','orc_champion',10.00,23.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(1655,22016,'Ghost of a Turka Chief','','orc_champion',10.00,23.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(1656,22017,'Bandit Sweeper','','northern_goblin',4.00,15.00,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1308,72,145,128,58,114,278,0,253,0,0,0,30,120,'',300,'Local','',0,0,0,7,30,4,4,0,0,0.24,'true',1,0),
(1657,22018,'Bandit Hound','','dire_wolf',13.00,11.00,31,'male','L2Monster','Fighter',40,1004,4.500,381,1.800,40,43,30,21,20,10,1425,79,157,133,64,118,278,500,253,0,0,0,40,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(1658,22019,'Bandit Watchman','','ol_mahum_archer_04te',15.00,32.00,32,'male','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1265,71,169,138,69,123,278,500,253,274,0,0,55,130,'',300,'Magister','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(1659,22020,'Snow Lynx','','onyx_beast',14.00,14.50,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1332,76,182,143,75,128,278,500,253,0,0,0,55,110,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.61,'true',1,0),
(1660,22021,'Bandit Undertaker','','northern_goblin_110p',6.00,16.60,34,'male','L2Monster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1667,97,196,148,82,132,278,0,253,0,0,0,80,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(1661,22022,'Bandit Assassin','','wererat_01te',14.00,25.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,1484,88,192,169,89,137,278,0,253,0,0,0,80,174,'',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(1662,22023,'Bandit Warrior','','ol_mahum_04te',13.50,25.00,36,'male','L2Monster','Fighter',40,1279,9.000,463,1.800,40,43,30,21,20,10,1984,120,227,159,96,142,278,500,253,0,0,0,80,174,'',300,'Magister','',0,0,0,7,30,4,4,0,0,0.61,'true',1,0),
(1663,22024,'Bandit Inspector','','northern_goblin_120p',7.00,18.50,37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,1991,122,194,154,104,147,317,0,289,221,0,0,80,174,'',0,'Local','',0,0,0,7,10,8,0,0,10,0.61,'true',1,0),
(1664,22025,'Frozen Wasteland Werewolf','','werewolf',10.00,26.00,38,'male','L2Monster','Fighter',40,1400,9.000,497,1.800,40,43,30,21,20,10,2146,134,238,188,112,153,278,0,253,0,0,0,50,120,'werewolf_clan',0,'Magister','',0,0,0,7,30,4,4,0,0,0.54,'true',1,0),
(1665,22026,'Bandit Captain','','ol_mahum_champion_04te',14.00,27.00,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2585,167,273,201,131,164,278,500,253,69,19,0,45,174,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1666,22027,'Forgotten Crewman','','dwarf_ghost',10.00,18.70,39,'male','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,3760,240,231,214,121,158,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',1,0),
(1667,22028,'Vagabond of the Ruins','','a_mageguild_teacher_Mhuman_mon',8.00,23.00,40,'male','L2Monster','Fighter',40,1527,2.250,531,1.800,40,43,30,21,20,10,4842,312,317,151,131,164,317,500,289,0,0,0,100,174,'',300,'','',0,0,0,7,10,8,0,0,0,0.46,'true',1,0),
(1668,22029,'Ragna Orc','','batur_orc_03te',9.00,21.50,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2585,167,273,201,131,164,278,500,253,0,0,0,45,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1669,22030,'Ragna Orc Shaman','','batur_orc_shaman_a_03te',11.00,16.00,42,'male','L2Monster','Mystic',40,1660,11.000,589,2.100,40,43,30,21,20,10,2251,150,342,196,152,175,278,500,253,0,0,0,72,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'true',0,0),
(1670,22031,'Ragna Orc Archer','','batur_orc_archer_03te',11.00,21.50,43,'male','L2Monster','Ranger',40,1728,5.500,618,2.100,40,43,30,21,20,10,2263,153,365,202,163,181,278,500,253,300,0,0,40,120,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.59,'true',1,0),
(1671,22032,'Ragna Orc Warrior','','batur_orc_warrior_03te',10.00,20.00,44,'male','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,3350,229,390,209,176,187,278,0,253,0,0,0,140,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(1672,22033,'Ragna Orc Mage','','batur_orc_shaman_a_01te',11.00,16.00,45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(1673,22034,'Ragna Orc Mage','','batur_orc_shaman_a_01te',11.00,16.00,45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(1674,22035,'Ragna Orc Mage','','batur_orc_shaman_a_01te',11.00,16.00,45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(1675,22036,'Ragna Orc Mage','','batur_orc_shaman_a_01te',11.00,16.00,45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',1,0),
(1676,22037,'Ragna Orc Healer','','batur_orc_shaman_a_03te',11.00,16.00,45,'male','L2Monster','Mystic',40,1870,5.500,677,2.100,40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.84,'true',0,0),
(1677,22038,'Ragna Orc Hero','','batur_orc_overlord_03te',12.00,24.00,48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,3987,291,396,261,231,212,317,0,289,221,0,0,80,174,'',300,'Local','',0,0,0,7,10,8,0,0,0,0.61,'true',1,0),
(1678,22039,'Ragna Orc Commander','','batur_orc_overlord_01te',12.00,24.00,49,'male','L2Monster','Fighter',40,2168,5.500,799,2.100,40,43,30,21,20,10,3951,292,480,270,247,219,278,0,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(1679,22040,'Ragna Orc Sniper','','batur_orc_archer_01te',11.00,21.50,47,'male','L2Monster','Ranger',40,2016,5.500,738,2.100,40,43,30,21,20,10,4004,287,388,279,216,206,278,500,253,5,0,0,34,174,'',400,'Local','',0,0,0,7,50,1,9,0,0,0.46,'true',1,0),
(1680,22041,'Ragna Orc Sorcerer','','batur_orc_shaman_a_01te',11.00,16.00,50,'male','L2Monster','Mystic',40,2245,5.500,830,2.100,40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'',300,'Local','',0,0,0,7,50,1,9,0,0,0.43,'true',1,0),
(1681,22042,'Ragna Orc Sorcerer','','batur_orc_shaman_a_01te',11.00,16.00,50,'male','L2Monster','Mystic',40,2245,5.500,830,2.100,40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'',300,'Local','',0,0,0,7,50,1,9,0,0,0.43,'true',1,0),
(1682,22043,'Ragna Orc Sorcerer','','batur_orc_shaman_a_01te',11.00,16.00,50,'male','L2Monster','Mystic',40,2245,5.500,830,2.100,40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'',300,'Local','',0,0,0,7,50,1,9,0,0,0.43,'true',1,0),
(1683,22044,'Ragna Orc Sorcerer','','batur_orc_shaman_a_01te',11.00,16.00,50,'male','L2Monster','Mystic',40,2245,5.500,830,2.100,40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'',300,'Local','',0,0,0,7,50,1,9,0,0,0.43,'true',1,0),
(1684,22045,'Dark Corpse','','zombie_02te',13.00,21.00,40,'male','L2Monster','Fighter',40,381,4.500,531,1.800,40,43,30,21,20,10,1088,71,300,183,131,164,278,500,253,0,0,0,60,150,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.67,'true',1,0),
(1685,22046,'Varangka''s Dre Vanul','','dre_vanul',14.00,36.00,46,'male','L2Monster','Fighter',40,485,11.000,707,2.100,40,43,30,21,20,10,1204,85,365,270,202,199,278,0,253,0,0,0,70,174,'',400,'Local','',0,0,0,7,50,1,9,0,0,0.30,'true',1,0),
(1686,22047,'Guardian of the Ghost Town','','monster_eye_05te',21.00,43.00,44,'male','L2Monster','Mystic',40,449,11.000,648,2.100,40,43,30,21,20,10,1344,92,322,253,176,187,278,500,253,0,0,0,23,23,'',400,'Local','',0,0,0,7,50,1,9,0,0,0.41,'true',1,0),
(1687,22048,'Dark Spider','','giant_spider_04te',26.00,25.50,42,'male','L2Monster','Fighter',40,415,11.000,589,2.100,40,43,30,21,20,10,1313,88,342,196,152,175,278,500,253,0,0,0,30,174,'',400,'Local','',0,0,0,7,50,1,9,0,0,0.24,'true',1,0),
(1688,22049,'Varangka''s Succubus','','succubus_05te',10.00,36.00,49,'male','L2Monster','Fighter',40,542,11.000,799,2.100,40,43,30,21,20,10,1513,112,529,245,247,219,278,0,253,0,0,0,70,174,'',300,'Local','',0,0,0,7,50,1,9,0,0,0.30,'true',1,0),
(1689,22050,'Probe Golem Prodigy IV','','golem_microscout',12.00,43.50,46,'male','L2Monster','Fighter',40,1943,11.000,707,2.100,40,43,30,21,20,10,2408,170,365,270,202,199,278,0,253,0,0,0,70,174,'',400,'Local','',0,0,0,7,50,1,9,0,0,0.30,'true',1,0),
(1690,22051,'Spelunking Spider','','giant_spider_05te',26.00,25.50,47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,3212,230,427,253,216,206,278,0,253,0,0,0,55,174,'',300,'Magister','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(1691,22052,'Menacing Jackhammer Golem','','golem_prop',23.00,32.80,47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,3212,230,427,253,216,206,278,0,253,0,0,0,55,174,'',300,'Magister','',0,0,0,7,50,1,9,0,0,0.28,'true',1,0),
(1692,22053,'Horrifying Cannon Golem I','','golem_cannon_catapult',23.50,34.70,48,'male','L2Monster','Fighter',40,2091,16.500,768,2.100,40,43,30,21,20,10,3076,224,412,288,231,212,278,0,253,0,0,0,45,174,'',300,'Magister','',0,0,0,7,30,4,4,0,0,0.58,'true',1,0),
(1693,22054,'Horrifying Cannon Golem IV','','golem_cannon_catapult',23.50,34.70,48,'male','L2Monster','Fighter',40,2091,16.500,768,2.100,40,43,30,21,20,10,3076,224,412,288,231,212,278,0,253,0,0,0,45,174,'',300,'Magister','',0,0,0,7,30,4,4,0,0,0.58,'true',1,0),
(1694,22055,'Cruel Vice Golem','','golem_repair',23.00,32.80,49,'male','L2Monster','Fighter',40,2168,8.690,878,2.140,40,43,30,21,20,10,3659,270,490,267,247,219,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(1695,22056,'Probe Golem Champion I','','golem_microscout',12.00,43.50,49,'male','L2Monster','Fighter',40,2168,8.690,799,2.140,40,43,30,21,20,10,3659,270,490,267,247,219,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(1696,22057,'Spelunking Ant','','ant_soldier',35.00,17.00,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3030,228,560,253,264,226,278,0,253,0,0,0,45,120,'ant_clan',300,'Magiste','',0,0,0,7,30,4,4,0,0,0.58,'true',1,0),
(1697,22058,'Horrifying Excavator Golem III','','golem_carrier',23.00,32.80,51,'male','L2Monster','Fighter',40,2323,10.270,861,2.450,40,43,30,21,20,10,3841,293,602,280,281,232,278,0,333,0,0,0,88,132,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(1698,22059,'Bloodthirsty Ginzu Golem VII','','golem_guardian_090p',16.00,37.20,51,'male','L2Monster','Fighter',40,2323,10.270,861,2.450,40,43,30,21,20,10,3841,293,602,280,281,232,278,0,333,0,0,0,88,132,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(1699,22060,'Horrifying Cannon Golem','','golem_cannon_catapult_a',23.50,34.70,52,'male','L2Monster','Fighter',40,2402,10.270,892,2.450,40,43,30,21,20,10,2198,170,561,306,300,239,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1700,22061,'Horrifying Cannon Golem III','','golem_microscout_a',12.00,43.50,51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,3820,291,593,260,281,232,278,0,253,0,0,0,35,174,'',0,'Abaddon','',0,0,0,7,30,4,4,0,0,0.39,'true',0,0),
(1701,22062,'Horrifying Jackhammer Golem','','golem_prop',23.00,32.80,52,'male','L2Monster','Fighter',40,2402,10.270,892,2.450,40,43,30,21,20,10,2198,170,561,306,300,239,278,0,333,0,0,0,88,132,'',300,'Abaddon','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1702,22063,'Ginzu Golem Prodigy X','','golem_guardian_090p',16.00,37.20,52,'male','L2Monster','Fighter',40,2402,6.500,892,2.400,40,43,30,21,20,10,2198,170,561,306,300,239,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1703,22064,'Bloodthirsty Ginzu Golem II','','golem_guardian_a_090p',16.00,37.20,52,'male','L2Monster','Fighter',40,2402,10.270,892,2.450,40,43,30,21,20,10,2198,170,561,306,300,239,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1704,22065,'Horrifying Ginzu Golem V','','golem_guardian',18.00,41.50,53,'male','L2Monster','Fighter',40,2481,10.270,923,2.450,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,88,132,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(1705,22066,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p',21.00,30.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(1706,22067,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p',21.00,30.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,0.30,'true',0,0),
(1707,22068,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p',21.00,30.00,53,'male','L2Monster','Fighter',40,2481,10.270,923,2.450,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(1708,22069,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p',21.00,30.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(1709,22070,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p',21.00,30.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(1710,22071,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p',21.00,30.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(1711,22072,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p',21.00,30.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,0.30,'true',0,0),
(1712,22073,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p',21.00,30.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(1713,22074,'Epic Cannon Golem','','golem_cannon_catapult_a_090p',21.00,30.00,53,'male','L2Monster','Fighter',40,2481,10.270,923,2.450,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(1714,22075,'Epic Cannon Golem Adjunct','','golem_microscout_a',12.00,43.50,52,'male','L2Monster','Fighter',40,2402,10.270,892,2.450,40,43,30,21,20,10,2198,170,561,306,300,239,278,0,333,0,0,0,88,132,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(1715,22076,'Deadly Ginzu Golem V','','golem_guardian',18.00,41.50,53,'male','L2Monster','Fighter',40,2481,10.270,923,2.450,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,10,8,0,0,0,0.30,'false',1,0),
(1716,22077,'Horrifying Ginzu Golem VIII','','golem_guardian_a',18.00,41.50,54,'male','L2Monster','Fighter',40,2562,10.270,955,2.450,40,43,30,21,20,10,4370,348,667,293,339,254,278,0,333,0,0,0,88,132,'',300,'Abaddon','',0,0,0,7,30,4,4,0,10,0.74,'false',1,0),
(1717,22078,'Deadly Ginzu Golem VIII','','golem_guardian_a',18.00,41.50,54,'male','L2Monster','Fighter',40,2562,6.500,955,2.400,40,43,30,21,20,10,4370,348,667,293,339,254,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,30,4,4,0,10,0.74,'false',1,0),
(1718,22079,'Lost Bandersnatch','','bandersnatch_c',18.00,25.00,53,'male','L2Minion','Fighter',40,1240,10.270,923,2.450,40,43,30,21,20,10,3578,275,636,283,319,247,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1719,22080,'Massive Maze Bandersnatch','','bandersnatch',18.00,25.00,54,'male','L2Monster','Fighter',40,1281,10.270,923,2.450,40,43,30,21,20,10,3925,307,667,293,339,254,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1720,22081,'Lost Watcher','','field_stalker',16.00,36.00,53,'male','L2Monster','Mystic',40,2481,10.270,1061,2.450,40,43,30,21,20,10,4813,378,636,283,319,247,278,0,333,0,0,0,88,132,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(1721,22082,'Elder Lost Watcher','','field_stalker_110p',15.00,30.00,54,'male','L2Monster','Mystic',40,2562,10.270,1050,2.450,40,43,30,21,20,10,4370,348,667,293,339,254,278,0,333,0,0,0,88,132,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.19,'true',1,0),
(1722,22083,'Baby Panthera','','saber_toothed_tiger_080p',29.00,22.70,55,'male','L2Minion','Fighter',40,1321,10.270,923,2.450,40,43,30,21,20,10,4519,365,733,302,360,261,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1723,22084,'Panthera','','saber_toothed_tiger',28.00,29.00,56,'male','L2Monster','Fighter',40,1362,10.270,923,2.450,40,43,30,21,20,10,4896,402,730,310,382,269,278,500,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,30,4,4,0,0,0.48,'true',1,0),
(1724,22085,'Lost Gargoyle','','gargoyle_02te',16.00,50.00,55,'female','L2Monster','Fighter',40,2643,10.270,1086,2.450,40,43,30,21,20,10,4519,365,733,302,360,261,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,50,1,9,0,10,0.72,'true',1,0),
(1725,22086,'Lost Gargoyle Youngling','','gargoyle_02te_110p',17.50,56.00,56,'female','L2Monster','Mystic',40,2724,10.270,1121,2.450,40,43,30,21,20,10,4896,402,730,310,382,269,278,500,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,50,1,9,0,0,0.41,'true',1,0),
(1726,22087,'Pronghorn Spirit','','antelope',17.00,34.00,56,'female','L2Minion','Fighter',40,2724,10.270,1121,2.450,40,43,30,21,20,10,4896,402,730,310,382,269,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,50,1,9,0,0,0.41,'true',1,0),
(1727,22088,'Pronghorn','','antelope_110p',19.00,37.80,57,'female','L2Monster','Fighter',40,2806,10.270,1157,2.450,40,43,30,21,20,10,4087,340,861,298,405,276,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,50,1,9,0,10,0.20,'true',1,0),
(1728,22089,'Ice Tarantula','','giant_spider',26.00,25.50,57,'male','L2Monster','Fighter',40,2806,10.270,1052,2.450,40,43,30,21,20,10,4087,340,861,298,405,276,278,0,333,0,0,0,80,132,'',300,'Magister','',0,0,0,7,50,1,9,0,10,0.20,'true',1,0),
(1729,22090,'Frost Tarantula','','giant_spider_110p',32.00,28.00,58,'male','L2Monster','Fighter',40,2889,10.270,1084,2.450,40,43,30,21,20,10,5053,427,834,325,428,284,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,10,8,0,0,0,0.46,'true',1,0),
(1730,22091,'Lost Iron Golem','','iron_golem_120p',22.00,42.50,58,'male','L2Minion','Fighter',40,1444,10.270,1192,2.450,40,43,30,21,20,10,5053,427,834,325,428,284,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1731,22092,'Frost Iron Golem','','iron_golem_130p',25.00,46.40,59,'male','L2Monster','Fighter',40,1485,10.270,287,2.450,40,43,30,21,20,10,6134,524,866,324,453,291,278,500,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1732,22093,'Lost Buffalo','','buffalo',22.00,31.00,60,'male','L2Monster','Fighter',40,3054,10.270,1265,2.450,40,43,30,21,20,10,5522,479,868,349,478,299,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,50,1,9,0,0,0.46,'true',0,0),
(1733,22094,'Frost Buffalo','','buffalo_a_110p',24.00,34.70,61,'male','L2Monster','Fighter',40,3137,11.850,1301,2.780,40,43,30,21,20,10,5254,462,1050,348,505,307,278,500,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,50,1,9,0,0,0.58,'true',1,0),
(1734,22095,'Ursus Cub','','grizzly',21.00,40.00,61,'male','L2Minion','Fighter',40,1568,11.850,1301,2.780,40,43,30,21,20,10,5254,462,1050,348,505,307,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,50,1,9,0,0,0.30,'true',1,0),
(1735,22096,'Ursus','','grizzly_120p',20.00,48.80,62,'male','L2Monster','Fighter',40,1609,11.850,1338,2.780,40,43,30,21,20,10,6303,562,1095,360,532,315,278,0,333,0,0,0,88,132,'',0,'Magister','',0,0,0,7,50,1,9,0,0,0.41,'true',1,0),
(1736,22097,'Lost Yeti','','yeti',15.00,27.50,62,'male','L2Monster','Fighter',40,3219,11.850,1338,2.780,40,43,30,21,20,10,6303,562,1095,360,532,315,278,0,333,0,0,0,88,132,'',300,'Magister','',0,0,0,7,50,1,9,0,0,0.58,'true',1,0),
(1737,22098,'Frost Yeti','','yeti_110p',20.00,29.80,63,'male','L2Monster','Fighter',40,3302,11.850,1375,2.780,40,43,30,21,20,10,6277,567,1136,384,560,323,278,0,333,0,0,0,88,132,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1738,22099,'Freya''s Buffalo','','buffalo',22.00,31.00,57,'male','L2Monster','Fighter',40,2806,6.500,1052,2.400,40,43,30,21,20,10,37800,3144,675,374,405,276,278,0,253,0,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',0,0),
(1739,22100,'Freya''s Gardener','','field_stalker',16.00,36.00,58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,46576,3936,751,318,428,284,317,0,289,223,0,0,70,174,'',0,'Local','',0,0,0,7,10,8,0,0,0,0.46,'true',0,0),
(1740,22101,'Freya''s Servant','','gargoyle_02te',16.00,50.00,58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,46576,3936,751,318,428,284,317,0,289,223,0,0,70,174,'',0,'Local','',0,0,0,7,10,8,0,0,0,0.46,'true',0,0),
(1741,22102,'Freya''s Servant','','gargoyle_02te',16.00,50.00,58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,46576,3936,751,318,428,284,317,0,289,223,0,0,70,174,'',0,'Local','',0,0,0,7,10,8,0,0,0,0.46,'true',0,0),
(1742,22103,'Freya''s White Bear','','grizzly',21.00,40.00,57,'male','L2Monster','Fighter',40,2806,6.500,1052,2.400,40,43,30,21,20,10,37800,3144,675,374,405,276,278,0,253,0,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',0,0),
(1743,22104,'Freya''s Dog','','bandersnatch',18.00,25.00,58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,46576,3936,751,318,428,284,317,0,289,223,0,0,70,174,'',0,'Local','',0,0,0,7,10,8,0,0,0,0.46,'true',0,0),
(1744,22105,'Spiked Stakato','','blade_stakato_120p',18.00,43.20,72,'male','L2Monster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,6427,622,1681,540,454,399,278,500,333,0,0,0,80,132,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(1745,22106,'Spiked Stakato Worker','','blade_stakato_worker_120p',22.00,48.30,73,'male','L2Monster','Fighter',40,4086,42.500,1601,3.000,40,43,30,21,20,10,6607,648,1747,456,885,407,278,500,333,148,0,0,80,132,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(1746,22107,'Spiked Stakato Guard','','spike_stakato',16.00,22.80,74,'male','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,6790,674,1831,501,921,416,278,500,333,147,0,0,80,132,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(1747,22108,'Female Spiked Stakato','','spike_stakato_soldier',17.00,30.00,74,'male','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,9418,944,1831,501,921,416,278,500,333,148,0,0,80,132,'',0,'Magister','',0,0,0,7,50,1,9,0,0,0.52,'false',0,0),
(1748,22109,'Male Spiked Stakato','','marsh_stakato_soldier_120p',18.00,31.00,74,'male','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,5413,469,1831,501,921,416,278,500,333,148,0,0,80,132,'',0,'Magister','',0,0,0,7,50,1,9,0,0,0.52,'false',0,0),
(1749,22110,'Male Spiked Stakato','','marsh_stakato_soldier_tran',16.00,28.40,74,'male','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,5413,469,1831,501,921,416,278,500,333,148,0,0,80,132,'',0,'Magister','',0,0,0,7,50,1,9,0,0,0.52,'false',0,0),
(1750,22111,'Spiked Stakato Sorcerer','','blade_stakato_queen_120p',24.00,43.60,75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,6804,683,1683,488,957,425,278,0,333,148,0,0,80,132,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(1751,22112,'Cannibalistic Stakato Follower','','spike_stakato_worker',17.00,24.00,74,'male','L2Monster','Fighter',40,4158,42.500,1637,3.000,40,43,30,21,20,10,6368,496,1608,501,921,416,278,500,333,148,0,0,80,132,'',0,'Magister','',0,0,0,7,50,1,9,0,0,0.52,'false',0,0),
(1752,22113,'Cannibalistic Stakato Leader','','cannibal_stakato_leader_120p',24.00,48.80,75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,10777,1091,1720,488,957,425,278,0,333,0,0,0,80,132,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(1753,22114,'Cannibalistic Stakato Leader','','cannibal_stakato_leader_tran',40.00,42.00,75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,7774,820,1720,488,957,425,278,0,333,0,0,0,80,132,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(1754,22115,'Spiked Stakato Soldier','','blade_stakato_120p',18.00,43.20,76,'male','L2Monster','Fighter',40,4297,4.250,1710,3.000,40,43,30,21,20,10,8521,712,1824,506,994,433,278,0,333,0,0,0,80,132,'',0,'Magister','',0,0,0,7,50,1,9,0,0,0.46,'false',0,0),
(1755,22116,'Spiked Stakato Drone','','blade_stakato_drone_120p',28.00,47.30,77,'male','L2Monster','Fighter',40,4364,34.000,1747,3.000,40,43,30,21,20,10,6431,446,1711,513,1031,442,278,500,333,0,0,0,80,132,'',0,'Magister','',0,0,0,7,30,4,4,0,10,0.56,'false',0,0),
(1756,22117,'Spiked Stakato Captain','','marsh_stakato_drone_120p',14.00,29.10,78,'male','L2Monster','Fighter',40,4428,4.250,1784,3.000,40,43,30,21,20,10,8083,706,2115,522,1069,451,278,0,333,0,0,0,80,132,'',0,'Magister','',0,0,0,7,50,1,9,0,0,0.43,'false',0,0),
(1757,22118,'Spiked Stakato Nurse','','marsh_stakato_queen_120p',26.00,43.80,79,'male','L2Monster','Fighter',40,4490,17.000,1821,3.000,40,43,30,21,20,10,9489,801,2215,685,1107,459,278,150,333,0,0,0,80,132,'',0,'Magister','',0,0,0,7,50,1,9,0,0,0.46,'false',0,0),
(1758,22119,'Spiked Stakato Nurse','','marsh_stakato_queen_tran',16.00,28.40,79,'male','L2Monster','Fighter',40,4490,17.000,1821,3.000,40,43,30,21,20,10,9489,801,2215,685,1107,459,278,150,333,0,0,0,80,132,'',0,'Magister','',0,0,0,7,50,1,9,0,0,0.46,'false',0,0),
(1759,22120,'Spiked Stakato Baby','','spike_stakato_drone',16.00,29.00,79,'male','L2Monster','Fighter',40,4490,17.000,1821,3.000,40,43,30,21,20,10,9489,1051,2214,685,1107,459,278,150,333,0,0,0,80,132,'',0,'Magister','',0,0,0,7,50,1,9,0,0,0.46,'false',0,0),
(1760,22121,'Spiked Stakato Shaman','','blade_stakato_queen_120p',24.00,43.60,80,'male','L2Monster','Mystic',40,4550,25.500,1859,3.000,40,43,30,21,20,10,10362,913,1890,556,1144,468,278,0,333,0,0,0,20,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(1761,22122,'Monastic Pilgrim','','angel_080p',12.00,27.80,80,'male','L2Minion','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,7761,871,2195,476,1144,468,278,0,253,148,0,0,48,200,NULL,0,'SYS','',0,0,0,7,50,1,9,0,0,0.61,'false',1,0),
(1762,22123,'Monastic Crusader','','archangel_050p',13.00,37.50,80,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,9976,1133,1540,710,1182,477,278,150,253,97,0,0,35,170,'mos_clan',400,'SYS','',0,0,0,7,50,1,9,0,0,0.54,'false',1,0),
(1763,22124,'Solina Brother','','solina_brother',9.00,23.40,80,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,9976,1133,2139,710,1182,477,200,150,182,8212,0,0,30,175,'mos_clan',400,'SYS','',0,0,0,7,30,4,4,0,0,0.49,'false',1,0),
(1764,22125,'Solina Lay Brother','','solina_brother',9.00,23.40,80,'male','L2Monster','Fighter',40,4663,34.000,1934,3.000,40,43,30,21,20,10,8173,939,1912,598,1220,485,278,0,253,8212,0,0,27,160,'mos_clan',400,'SYS','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(1765,22126,'Silent Seeker','','solina_father',11.00,25.40,80,'male','L2Monster','Fighter',40,4663,34.000,1934,3.000,40,43,30,21,20,10,8173,939,1912,598,1220,485,278,0,253,8213,0,0,27,160,'mos_clan',400,'SYS','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(1766,22127,'Silent Brother','','solina_father',11.00,25.40,80,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,9976,1133,2139,710,1182,477,200,150,182,0,0,0,30,175,'mos_clan',400,'SYS','',0,0,0,7,30,4,4,0,0,0.49,'false',1,0),
(1767,22128,'Monastery Guardian','','grail_protection',9.00,15.60,80,'male','L2Monster','RndTeleportFighter',40,4716,17.000,1972,3.000,40,43,30,21,20,10,10475,1217,1619,736,1258,494,278,150,253,0,0,0,30,165,'mos_clan',400,'SYS','',0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(1768,22129,'Warrior Monk','','monk_warrior',12.00,28.40,80,'male','L2Monster','Fighter',40,4766,17.000,2011,3.000,40,43,30,21,20,10,11525,1355,2428,511,1296,502,278,150,253,8211,8210,0,34,175,'mos_clan',400,'SYS','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1769,22130,'Divine Advocate','','apostle_warrior',8.00,30.00,80,'male','L2Minion','Fighter',40,4813,17.000,2049,3.000,40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,0,253,6717,0,0,45,185,NULL,0,'SYS','',0,0,0,7,50,1,9,0,10,0.46,'false',1,0),
(1770,22131,'Pilgrim of Light','','apostle_mage',11.00,38.50,80,'male','L2Minion','Mystic',40,4813,17.000,2049,3.000,40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,0,253,6718,0,0,45,185,NULL,0,'SYS','',0,0,0,7,50,1,9,0,10,0.46,'false',1,0),
(1771,22132,'Judge of Light','','apostle_grail_a',13.00,47.00,80,'male','L2Monster','Ranger',500,4858,17.000,2088,3.000,40,43,30,21,20,10,11031,1550,2199,625,1373,519,278,0,333,8220,0,0,88,132,'mos_clan',400,'Magister',NULL,0,0,0,7,50,1,9,0,0,0.51,'false',1,0),
(1772,22133,'Guardian of the Grail','','will_o_wisp',13.00,22.00,80,'male','L2Monster','RndTeleportFighter',40,4858,17.000,2088,3.000,40,43,30,21,20,10,12871,1550,2913,639,1370,519,200,0,182,0,0,0,24,180,'mos_clan',400,'SYS',NULL,0,0,0,7,50,1,9,0,0,0.51,'true',1,0),
(1773,22134,'Guardian of the Holy Land','','solina_priest',14.00,34.50,80,'male','L2Monster','Fighter',40,4899,17.000,2088,3.000,40,43,30,21,20,10,13871,1750,2963,639,1470,519,200,0,182,8214,0,0,24,180,'mos_clan',400,'SYS',NULL,0,0,0,7,50,1,9,0,0,0.51,'false',1,0),
(1774,22135,'Beholder of Light','','apostle_grail',13.00,47.00,80,'male','L2Monster','Fighter',40,4899,17.000,2088,3.000,40,43,30,21,20,10,13871,1750,2963,639,1470,519,200,0,182,6718,0,0,24,180,'mos_clan',400,'SYS',NULL,0,0,0,7,50,1,9,0,0,0.51,'false',1,0),
(1775,22136,'Gatekeeper Zombie','','zombie_gateguard',17.00,30.50,83,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(1776,22137,'Penance Guard','','zombie_gateguard_brd',40.00,30.50,80,'male','L2Monster','PaganGuard',40,4608,13.430,1338,3.090,40,43,30,21,20,10,13824,658,2475,1127,1544,780,300,100,555,8217,0,0,50,120,'pagan_clan',500,'SYS','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(1777,22138,'Chapel Guard','','zombie_gateguard_brd',40.00,30.50,80,'male','L2Monster','PaganGuard',40,4812,13.430,1338,3.090,40,43,30,21,20,10,14436,688,2475,793,1144,780,300,100,600,8217,0,0,50,120,'pagan_clan',500,'SYS','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(1778,22139,'Old Aristocrat''s Soldier','','zombie_enlisted_man',17.00,22.30,80,'male','L2Monster','Mystic',40,4609,13.430,1380,3.090,40,43,26,21,20,10,13826,658,1719,1108,1144,780,300,0,555,8216,0,0,50,120,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.43,'false',1,0),
(1779,22140,'Zombie Worker','','zombie_laborer',11.00,24.60,80,'male','L2Monster','Mystic',40,4550,13.430,1380,3.090,40,43,26,21,20,10,13652,650,1886,1108,1144,780,300,0,555,8218,0,0,60,130,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.43,'false',1,0),
(1780,22141,'Forgotten Victim','','zombie_laborer',11.00,24.60,80,'male','L2Monster','Mystic',40,4550,13.430,1380,3.090,40,43,26,21,20,10,13652,650,1886,1108,1144,780,300,0,555,8219,0,0,60,130,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.43,'false',1,0),
(1781,22142,'Triol''s Layperson','','heretic_privates_a',7.70,28.40,80,'male','L2Monster','NoRndWalkFighter',40,4609,13.430,1380,3.090,40,43,26,21,20,10,13826,658,1652,793,1144,780,300,0,555,8207,8207,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(1782,22143,'Triol''s Believer','','heretic_privates',7.70,28.40,80,'male','L2Monster','NoRndWalkMystic',40,3731,13.430,1380,3.090,40,43,26,21,20,10,11193,533,1652,793,1211,780,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(1783,22144,'Resurrected Temple Knight','','zombie_enlisted_man',17.00,22.30,80,'male','L2Monster','Fighter',40,4664,13.430,1380,3.090,40,43,26,21,20,10,13991,667,1698,1108,1144,780,550,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(1784,22145,'Ritual Sacrifice','','self_blaster',9.00,25.80,81,'male','L2Monster','Fighter',40,4609,13.430,1380,3.090,40,43,26,21,20,10,13826,658,1719,793,1144,780,300,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1785,22146,'Triol''s Priest','','heretic_privates',7.70,28.40,84,'male','L2Monster','Mystic',40,4766,13.430,1380,3.090,40,43,26,21,20,10,14299,681,1719,793,1211,780,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1786,22147,'Ritual Offering','','zombie_enlisted_man',17.00,22.30,80,'male','L2Monster','Fighter',40,4717,13.430,1380,3.090,40,43,26,21,20,10,14150,674,1517,793,1144,780,400,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1787,22148,'Triol''s Believer','','heretic_privates',7.70,28.40,82,'male','L2Monster','Fighter',40,5830,13.430,1380,3.090,40,43,26,21,20,10,17489,830,1719,793,1144,780,300,0,555,8207,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1788,22149,'Ritual Offering','','zombie_enlisted_man',17.00,22.30,80,'male','L2Monster','Fighter',40,4664,13.430,1380,3.090,40,43,26,21,20,10,13991,667,1517,793,1144,780,400,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',1,0),
(1789,22150,'Triol''s Believer','','heretic_privates',7.70,28.40,83,'male','L2Monster','Fighter',40,4717,13.430,1380,3.090,40,43,26,21,20,10,14150,674,1719,793,1144,780,300,0,555,8207,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1790,22151,'Triol''s Priest','','heretic_privates',7.70,28.40,85,'male','L2Monster','Mystic',40,4814,13.430,1380,3.090,40,43,26,21,20,10,14441,688,1719,793,1144,780,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1791,22152,'Temple Guard','','zombie_em_knight',17.00,22.30,84,'male','L2Monster','Fighter',40,4767,13.430,1380,3.090,40,43,26,21,20,10,14300,682,1869,793,1144,780,500,0,555,8219,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1792,22153,'Temple Guard Captain','','zombie_em_knight',17.00,22.30,84,'male','L2Monster','Fighter',40,4767,13.430,1380,3.090,40,43,26,21,20,10,14300,682,1899,793,1144,780,350,0,555,8218,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1793,22154,'Ritual Sacrifice','','self_blaster',9.00,25.80,85,'male','L2Monster','Fighter',40,4814,13.430,1380,3.090,40,43,26,21,20,10,14441,688,1719,677,1144,780,300,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1794,22155,'Triol''s High Priest','','heretic_priest_a',7.70,28.40,85,'male','L2Monster','Fighter',40,4814,13.430,1380,3.090,40,43,26,21,20,10,14441,688,1883,793,1244,780,300,0,555,8206,8206,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1795,22156,'Triol''s Priest','','heretic_privates',7.70,28.40,86,'male','L2Monster','Mystic',40,4858,13.430,1380,3.090,40,43,26,21,20,10,14574,694,1719,793,1144,780,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1796,22157,'Triol''s Priest','','heretic_privates',7.70,28.40,85,'male','L2Monster','Mystic',40,4814,13.430,1380,3.090,40,43,26,21,20,10,14441,688,1719,793,1144,780,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1797,22158,'Triol''s Believer','','heretic_privates_a',7.70,28.40,85,'male','L2Monster','Fighter',40,4814,13.430,1380,3.090,40,43,26,21,20,10,14441,688,1650,793,1214,780,300,0,555,8207,8207,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1798,22159,'Triol''s High Priest','','heretic_priest_a',7.70,28.40,86,'male','L2Monster','Fighter',40,4858,13.430,1380,3.090,40,43,26,21,20,10,14574,694,1883,793,1144,780,300,0,555,8206,8206,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1799,22160,'Triol''s Priest','','heretic_privates',7.70,28.40,86,'male','L2Monster','Mystic',40,4858,13.430,1380,3.090,40,43,26,21,20,10,14574,694,1719,793,1144,780,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1800,22161,'Ritual Sacrifice','','self_blaster',9.00,25.80,85,'male','L2Monster','Fighter',40,4814,13.430,1380,3.090,40,43,26,21,20,10,14441,688,1719,793,1144,780,300,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1801,22162,'Triol''s Believer','','heretic_privates_a',7.70,28.40,85,'male','L2Monster','Fighter',40,4814,13.430,1380,3.090,40,43,26,21,20,10,14441,688,1883,793,1214,780,300,0,555,8207,8207,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1802,22163,'Triol''s High Priest','','heretic_priest',8.00,19.60,86,'male','L2Monster','Fighter',40,4858,13.430,1380,3.090,40,43,26,21,20,10,14574,694,1719,793,1144,780,300,0,555,8206,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1803,22164,'Triol''s Believer','','heretic_privates_a',7.70,28.40,86,'male','L2Monster','Fighter',40,4858,13.430,1380,3.090,40,43,26,21,20,10,14574,694,1916,793,1301,780,300,0,555,8207,8207,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1804,22165,'Triol''s Priest','','heretic_privates',7.70,28.40,85,'male','L2Monster','Mystic',40,4814,13.430,1380,3.090,40,43,26,21,20,10,14441,688,1719,793,1144,780,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1805,22166,'Triol''s Believer','','heretic_privates',7.70,28.40,85,'male','L2Monster','Mystic',40,4814,13.430,1380,3.090,40,43,26,21,20,10,14441,688,1916,793,1301,780,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1806,22167,'Triol''s High Priest','','heretic_priest_a',7.70,28.40,87,'male','L2Monster','Fighter',40,4900,13.430,1380,3.090,40,43,26,21,20,10,14699,700,1883,793,1144,780,300,0,555,8206,8206,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1807,22168,'Triol''s Priest','','heretic_privates',7.70,28.40,87,'male','L2Monster','Mystic',40,4900,13.430,1380,3.090,40,43,26,21,20,10,14699,700,1719,793,1144,780,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1808,22169,'Ritual Sacrifice','','self_blaster',9.00,25.80,86,'male','L2Monster','Fighter',40,4858,13.430,1380,3.090,40,43,26,21,20,10,14574,694,1719,793,1144,780,300,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1809,22170,'Triol''s Believer','','heretic_privates_a',7.70,28.40,86,'male','L2Monster','Fighter',40,4858,13.430,1380,3.090,40,43,26,21,20,10,14574,694,2033,793,1301,780,300,0,555,8207,8207,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1810,22171,'Triol''s High Priest','','heretic_priest',8.00,19.60,87,'male','L2Monster','Fighter',40,4900,13.430,1380,3.090,40,43,26,21,20,10,14699,700,1719,793,1144,780,300,0,555,8206,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1811,22172,'Ritual Sacrifice','','self_blaster',9.00,25.80,86,'male','L2Monster','Fighter',40,4858,13.430,1380,3.090,40,43,26,21,20,10,14574,694,1719,793,1144,780,300,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1812,22173,'Triol''s Priest','','heretic_privates',7.70,28.40,86,'male','L2Monster','Mystic',40,4858,13.430,1380,3.090,40,43,26,21,20,10,14574,694,1719,793,1144,780,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(1813,22174,'Triol''s Priest','','heretic_privates',7.70,28.40,85,'male','L2Monster','Mystic',40,4814,13.430,1380,3.090,40,43,26,21,20,10,14441,688,1719,793,1144,780,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1814,22175,'Andreas'' Captain of the Royal Guard','','zombie_em_knight',17.00,22.30,85,'male','L2Monster','Fighter',40,4812,13.430,1380,3.090,40,43,26,21,20,10,14436,688,1719,793,1144,780,500,0,555,8218,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1815,22176,'Andreas'' Royal Guards','','zombie_em_knight',17.00,22.30,85,'male','L2Monster','Fighter',40,4812,13.430,1380,3.090,40,43,26,21,20,10,14436,688,2475,1108,1144,780,300,0,555,8218,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1816,22188,'Andreas'' Captain of the Royal Guard','','heretic_priest_120p',13.00,23.20,87,'male','L2Monster','Fighter',40,4899,13.430,1380,3.090,40,43,26,21,20,10,14698,700,2682,960,1566,780,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1817,22189,'Andreas'' Royal Guards','','heretic_privates_120p',13.00,34.00,86,'male','L2Monster','Mystic',40,4858,13.430,1380,3.090,40,43,26,21,20,10,14574,694,2682,960,1566,780,460,0,555,8205,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1818,22190,'Ritual Sacrifice','','self_blaster',9.00,25.80,86,'male','L2Monster','Fighter',40,4858,13.430,1380,3.090,40,43,26,21,20,10,14574,694,1883,793,1144,780,300,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1819,22191,'Andreas'' Captain of the Royal Guard','','heretic_priest_120p',13.00,23.20,87,'male','L2Monster','Fighter',40,7350,13.430,1380,3.090,40,43,26,21,20,10,22049,1050,1719,793,1144,780,300,0,555,8206,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1820,22192,'Andreas'' Royal Guards','','heretic_privates_120p',13.00,34.00,86,'male','L2Monster','Fighter',40,9716,13.430,1380,3.090,40,43,26,21,20,10,29148,1388,1719,793,1144,780,300,0,555,8206,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1821,22193,'Andreas'' Royal Guards','','heretic_privates_120p',13.00,34.00,86,'male','L2Monster','Fighter',40,9716,13.430,1380,3.090,40,43,26,21,20,10,29148,1388,1719,793,1144,780,600,0,555,8206,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(1822,22194,'Penance Guard','','zombie_gateguard_slp',40.00,22.00,80,'male','L2Monster','PaganGuard',40,4608,13.430,1338,3.090,40,43,30,21,20,10,13824,658,2475,1108,1544,780,300,100,555,8217,0,0,50,120,'pagan_clan',500,'SYS','',0,0,0,7,30,4,4,0,0,0.00,'false',1,0),
(1823,22195,'Ritual Sacrifice','','self_blaster',20.00,31.00,99,'male','L2Monster','Mystic',80,100000,13.430,9999,3.090,40,43,30,21,20,10,12332,2000,3109,755,1839,651,278,NULL,333,NULL,NULL,NULL,88,132,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',0,0),
(1824,22196,'Velociraptor','','velociraptor',19.00,47.20,86,'male','L2Monster','Fighter',80,25106,13.430,2296,3.090,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1825,22197,'Velociraptor','','velociraptor',19.00,47.20,86,'male','L2Minion','Fighter',80,12553,13.430,2296,3.090,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1826,22198,'Velociraptor','','velociraptor',19.00,47.20,86,'male','L2Minion','Fighter',80,25106,13.430,2296,3.090,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1827,22199,'Pterosaur','','rhamphorhynchus',36.00,43.70,87,'male','L2Monster','Fighter',80,101430,13.430,2339,3.090,40,43,30,21,20,10,11031,1401,2269,635,1413,531,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1828,22200,'Ornithomimus','','ornithomimus',15.00,37.20,84,'male','L2Monster','Fighter',80,12305,13.430,2211,3.090,40,43,30,21,20,10,11031,1310,2298,612,1296,502,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1829,22201,'Ornithomimus','','ornithomimus',15.00,37.20,84,'male','L2Minion','Fighter',80,12305,13.430,2211,3.090,40,43,30,21,20,10,11031,1310,2298,612,1296,502,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1830,22202,'Ornithomimus','','ornithomimus',15.00,37.20,84,'male','L2Minion','Fighter',80,12305,13.430,2211,3.090,40,43,30,21,20,10,11031,1310,2298,612,1296,502,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1831,22203,'Deinonychus','','deinonychus',14.00,14.30,83,'male','L2Monster','Fighter',80,12184,13.430,2168,3.090,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1832,22204,'Deinonychus','','deinonychus',14.00,14.30,83,'male','L2Minion','Fighter',80,12184,13.430,2168,3.090,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1833,22205,'Deinonychus','','deinonychus',14.00,14.30,83,'male','L2Minion','Fighter',80,12184,13.430,2168,3.090,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1834,22208,'Pachycephalosaurus','','pachycephalosaurus',22.00,40.00,85,'male','L2Monster','Fighter',80,12428,13.430,2253,3.090,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1835,22209,'Pachycephalosaurus','','pachycephalosaurus',22.00,40.00,85,'male','L2Minion','Fighter',80,12428,13.430,2253,3.090,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1836,22210,'Pachycephalosaurus','','pachycephalosaurus',22.00,40.00,85,'male','L2Minion','Fighter',80,12428,13.430,2253,3.090,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1837,22211,'Wild Strider','','wild_giant_strider',32.00,44.20,85,'male','L2Monster','Fighter',80,12428,13.430,2253,3.090,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1838,22212,'Wild Strider','','wild_giant_strider',32.00,44.20,85,'male','L2Minion','Fighter',80,12428,13.430,2253,3.090,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1839,22213,'Wild Strider','','wild_giant_strider',32.00,44.20,85,'male','L2Minion','Fighter',80,12428,13.430,2253,3.090,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1840,22214,'Elroki','','Crokian_Officer',25.00,33.00,85,'male','L2Monster','Fighter',80,24857,13.430,2253,3.090,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,0),
(1841,22215,'Tyrannosaurus','','tyranosaurus',60.00,89.70,87,'male','L2Monster','Tyrannosaurus',80,306406,13.430,2339,3.090,40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,0),
(1842,22216,'Tyrannosaurus','','tyranosaurus',60.00,89.70,80,'male','L2Monster','Tyrannosaurus',80,327855,13.430,2339,3.090,40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,0),
(1843,22217,'Tyrannosaurus','','tyranosaurus',60.00,89.70,87,'male','L2Monster','Tyrannosaurus',80,306406,13.430,2339,3.090,40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,0),
(1844,22218,'Velociraptor','','velociraptor',19.00,47.20,86,'male','L2Minion','Fighter',80,12553,13.430,2296,3.090,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1845,22219,'Ornithomimus','','ornithomimus',15.00,37.20,84,'male','L2Minion','Fighter',80,12305,13.430,2211,3.090,40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1846,22220,'Deinonychus','','deinonychus',14.00,14.30,83,'male','L2Minion','Fighter',80,12184,13.430,2168,3.090,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1847,22221,'Pachycephalosaurus','','pachycephalosaurus',22.00,40.00,84,'male','L2Minion','Fighter',80,12305,13.430,2211,3.090,40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1848,22222,'Wild Strider','','wild_giant_strider',32.00,44.20,85,'male','L2Minion','Fighter',80,12428,13.430,2253,3.090,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',1,0),
(1849,22223,'Velociraptor','','velociraptor',19.00,47.20,86,'male','L2Monster','Fighter',80,12553,13.430,2296,3.090,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',0,0),
(1850,22224,'Ornithomimus','','ornithomimus',15.00,37.20,84,'male','L2Monster','Fighter',80,12305,13.430,2211,3.090,40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',0,0),
(1851,22225,'Deinonychus','','deinonychus',14.00,14.30,83,'male','L2Monster','Fighter',80,12184,13.430,2168,3.090,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,0,0,0,88,188,'dino',500,'Magister','0',0,0,0,0,0,0,0,0,0,0.00,'true',0,0),
(1852,22226,'Pachycephalosaurus','','pachycephalosaurus',22.00,40.00,85,'male','L2Monster','Fighter',80,12428,13.430,2253,3.090,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,500,333,0,0,0,88,188,'0',0,'Magister','0',0,0,0,0,0,0,0,0,0,0.00,'true',0,0),
(1853,22227,'Wild Strider','','wild_giant_strider',32.00,44.20,85,'male','L2Monster','Fighter',80,12428,13.430,2253,3.090,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,500,333,0,0,0,88,188,'0',0,'Magister','0',0,0,0,0,0,0,0,0,0,0.00,'true',0,0),
(1854,22228,'Grey Elpy','','LineageMonster.elpy',13.00,21.00,1,'male','L2Monster','Elpy',40,62,2.000,44,0.900,40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,50,80,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'true',1,0),
(1855,22229,'Young Grey Keltir','','LineageMonster.keltir',13.00,21.00,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(1856,22230,'Grey Keltir','','LineageMonster.keltir',13.00,21.00,2,'male','L2Monster','Fighter',40,75,2.000,52,0.900,40,43,30,21,20,10,70,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(1857,22231,'Dominant Grey Keltir','','LineageMonster.keltir',13.00,21.00,3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,105,2,11,44,3,35,278,0,253,0,0,0,23,110,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(1858,22232,'Black Wolf','','LineageMonster.wolf',13.00,9.00,4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(1859,22233,'Dominant Black Wolf','','LineageMonster.wolf_bi',13.00,10.80,5,'male','L2Monster','Fighter',40,126,2.000,77,0.900,40,43,30,21,20,10,176,5,13,48,4,39,278,0,253,0,0,0,24,110,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.39,'true',1,0),
(1860,22234,'Green Goblin','','LineageMonster.goblin',10.00,16.50,6,'male','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,284,10,18,55,6,45,278,0,253,4,0,0,40,110,'goblin_clan',300,'Magister','',0,0,0,7,50,1,9,0,0,0.32,'true',1,0),
(1861,22235,'Mountain Werewolf','','LineageMonster.werewolf',10.00,26.00,7,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,321,11,20,58,7,47,278,0,253,0,0,0,50,120,'werewolf_clan',300,'Magister','',0,0,0,7,50,1,9,0,0,0.43,'true',1,0),
(1862,22236,'Muertos Archer','','LineageMonster4.Mostro_Gunner',15.00,24.50,8,'male','L2Monster','Ranger',500,339,2.500,147,1.200,40,43,30,21,20,10,397,16,61,77,11,56,249,0,227,9644,0,0,40,140,'muestos_clan',300,'Magister','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(1863,22237,'Mountain Fungus','','LineageMonster.walking_fungus',15.00,22.50,9,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,427,16,30,60,10,54,278,0,253,0,0,0,70,110,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(1864,22238,'Mountain Werewolf Chief','','LineageMonster.werewolf_bi',11.00,29.70,10,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,508,20,32,66,12,59,317,500,289,217,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,10,8,0,0,0,0.43,'true',1,0),
(1865,22239,'Muertos Guard','','LineageMonster4.Mostro_Fighter',15.50,22.50,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,391,15,23,70,9,52,278,0,253,0,0,0,80,120,'muertos_clan',300,'Abaddon','2007-12-12',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1866,22240,'Muertos Scout','','LineageMonster4.Mostro_Fighter',15.50,22.50,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,10,10,436,16,30,60,10,54,278,0,253,0,0,0,80,120,'muertos_clan',300,'Abaddon','2007-12-12',0,0,0,7,30,4,4,0,0,0.43,'true',1,0),
(1867,22241,'Colossus','','LineageMonster.Stone_golem',20.00,31.00,13,'male','L2Monster','Mystic',40,339,2.500,147,1.200,40,43,30,21,20,10,654,26,30,70,11,56,278,0,253,0,0,0,23,23,'',0,'Abaddon','2007-12-12',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(1868,22242,'Muertos Warrior','','LineageMonster4.Mostro_Fighter',15.50,22.50,14,'male','L2Monster','Fighter',40,364,2.500,156,1.200,40,43,30,21,20,10,435,17,30,80,12,59,278,300,253,0,0,0,80,120,'muertos_clan',300,'Abaddon','2007-12-12',0,0,0,7,30,4,4,0,0,0.76,'true',1,0),
(1869,22243,'Muertos Captain','','LineageMonster4.Mostro_Fighter',15.50,22.50,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,445,18,29,84,14,62,317,0,253,0,0,0,80,120,'muertos_clan',250,'Abaddon','2007-12-12',0,0,0,7,10,8,0,0,0,0.30,'true',1,0),
(1870,22244,'Crimson Spider','','LineageMonster.giant_spider_05te',26.00,25.50,16,'male','L2Monster','Fighter',40,417,2.500,174,1.200,40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'crimson_clan',250,'Magister','2007-12-12',0,0,0,7,30,4,4,0,0,0.26,'true',1,0),
(1871,22245,'Muertos Lieutenant','','LineageMonster4.Mostro_Fighter',15.50,22.50,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,618,26,44,83,17,67,278,300,253,0,0,0,80,120,'muertos_clan',300,'Abaddon','2007-12-12',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(1872,22246,'Muertos Commander','','LineageMonster4.Mostro_Fighter',15.50,22.50,18,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'muertos_clan',250,'SYS','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1873,22247,'Grotto Golem','','LineageMonster.Stone_golem',20.00,31.00,19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,799,36,48,99,21,73,278,0,253,0,0,0,23,23,'grotto_clan',250,'Abaddon','2007-12-12',0,0,0,7,30,4,4,0,0,0.41,'false',1,0),
(1874,22248,'Shady Muertos','','LineageMonster4.Mostro_Fighter',15.50,22.50,20,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'muertos_clan',250,'SYS','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(1875,22249,'Shady Muertos Guard','','LineageMonster4.Mostro_Gunner',15.00,24.50,21,'male','L2Monster','Ranger',500,575,3.500,227,1.500,40,43,30,21,20,10,656,30,127,108,25,80,249,250,227,9644,0,0,80,120,'muertos_clan',250,'Abaddon','2007-12-12',0,0,0,7,10,8,0,1500,0,0.72,'false',1,0),
(1876,22250,'Grotto Leopard','','LineageMonster.Onyx_beast',14.00,14.50,22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,837,40,68,87,28,83,278,250,253,0,0,0,30,140,'grotto_clan',250,'Abaddon','2007-12-12',0,0,0,7,30,4,4,0,10,0.24,'true',1,0),
(1877,22251,'Shady Muertos Captain','','LineageMonster4.Mostro_Fighter',15.50,22.50,23,'male','L2Monster','Fighter',40,648,3.500,257,1.500,40,43,30,21,20,10,731,35,82,97,31,87,278,0,253,0,0,0,80,120,'muertos_clan',250,'Abaddon','2007-12-12',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1878,22252,'Grotto Grizzly','','LineageMonster.Grizzly',21.00,40.00,24,'male','L2Monster','Fighter',40,687,3.500,272,1.500,40,43,30,21,20,10,935,46,81,111,34,90,278,0,253,0,0,0,40,115,'grotto_clan',250,'Abaddon','2007-12-12',0,0,0,7,30,4,4,0,0,0.37,'false',1,0),
(1879,22253,'Shady Muertos Warrior','','LineageMonster4.Mostro_Fighter',15.50,22.50,25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,826,41,80,127,37,94,278,0,253,0,0,0,80,120,'muertos_clan',250,'Abaddon','2007-12-12',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1880,22254,'Shady Muertos Archer','','LineageMonster4.Mostro_Gunner',15.00,24.50,25,'male','L2Monster','Ranger',500,728,3.500,287,1.500,40,43,30,21,20,10,851,43,197,98,37,94,249,0,227,9644,0,0,80,120,'muertos_clan',250,'Abaddon','2007-12-12',0,0,0,7,10,8,0,1500,10,0.80,'false',1,0),
(1881,22255,'Shady Muertos Commander','','LineageMonster4.Mostro_Fighter',15.50,22.50,26,'male','L2Monster','Fighter',40,770,7.000,303,1.500,40,43,30,21,20,10,982,49,87,132,41,98,278,0,253,0,0,0,80,120,'muertos_clan',250,'Abaddon','2007-12-12',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(1882,22256,'Shady Muertos Wizard','','LineageMonster4.Mostro_Fighter',15.50,22.50,26,'male','L2Monster','Mystic',40,770,3.500,303,1.500,40,43,30,21,20,10,1056,53,87,132,41,98,278,0,253,0,0,0,80,120,'muertos_clan',250,'Abaddon','2007-12-12',0,0,0,7,50,1,9,0,0,0.56,'false',1,0),
(1894,22268,'Shade','','LineageMonster4.eyeless',36.00,43.50,82,'male','L2Monster','Shade',40,4663,26.860,2444,3.090,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,0,333,0,0,0,49,192,'parnassus_clan',300,'SYS','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(1895,22269,'Shade','','LineageMonster4.eyeless',36.00,43.50,82,'male','L2Monster','Shade',40,4663,26.860,2444,3.090,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,0,333,0,0,0,49,192,'parnassus_clan',300,'SYS','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(1896,22270,'Water Dragon Detractor','','LineageMonster4.Eyeless',36.00,43.50,82,'male','L2Monster','Fighter',40,4663,26.860,2444,3.090,40,43,30,21,20,10,11434,1247,1912,598,1220,485,278,0,333,0,0,0,49,192,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(1897,22271,'Water Dragon Detractor','','LineageMonster4.Eyeless',36.00,43.50,82,'male','L2Monster','Fighter',40,4663,26.860,2444,3.090,40,43,30,21,20,10,11435,1247,1912,598,1220,485,278,0,333,0,0,0,49,192,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(1898,22272,'Beleth''s Minion','','LineageMonster.vale_master',12.00,40.00,82,'male','L2Monster','Fighter',40,9327,26.860,2444,3.090,40,43,30,21,20,10,16529,1728,1958,697,1258,564,278,0,333,0,0,0,49,192,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(1899,22273,'Beleth''s Minion','','LineageMonster.silhouette',8.00,23.00,82,'male','L2Monster','Fighter',40,9327,26.860,2444,3.090,40,43,30,21,20,10,15996,1669,1958,697,1258,564,278,0,333,0,0,0,49,192,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(1900,22274,'Beleth''s Minion','','LineageMonster.shadeless',7.00,28.00,82,'male','L2Monster','Fighter',40,9327,26.860,2444,3.090,40,43,30,21,20,10,16318,1705,1958,697,1258,564,278,0,333,0,0,0,49,192,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(1901,22275,'Gatekeeper Lohan','','LineageMonster3.Jungle_Bleeze',60.00,47.00,81,'male','L2Monster','Fighter',40,52146,26.860,2444,3.090,40,43,30,21,20,10,96832,10723,2235,598,1418,572,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1902,22276,'Gatekeeper of the Square','','LineageMonster4.Crystal_Golem',20.00,47.00,81,'male','L2Monster','Fighter',40,18434,26.860,2444,3.090,40,43,30,21,20,10,28476,3013,2136,575,1398,499,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1903,22277,'Gatekeeper Provo','','LineageMonster2.lava_golem',22.00,45.00,81,'male','L2Monster','Fighter',40,52146,26.860,2444,3.090,40,43,30,21,20,10,96834,10721,2235,598,1418,572,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1904,22278,'Gatekeeper of Fire','','LineageMonster4.Crystal_Golem',20.00,47.00,81,'male','L2Monster','Fighter',40,18434,26.860,2444,3.090,40,43,30,21,20,10,28478,3013,2195,575,1398,478,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1905,22279,'Chromatic Detainee','','LineageMonster3.Crokian_Officer',25.00,33.00,81,'male','L2Monster','Fighter',40,18434,26.860,2444,3.090,40,43,30,21,20,10,27940,2945,2235,598,1418,572,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1906,22280,'Rodo Knight','','LineageMonster4.Crystal_Golem',20.00,47.00,82,'male','L2Monster','Fighter',40,9327,2.000,2444,0.900,40,43,30,21,20,10,15936,1662,2245,575,1426,524,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1907,22281,'Plaza Caiman','','LineageMonster3.Crokian_Officer',25.00,33.00,81,'male','L2Monster','Fighter',40,8675,26.860,2444,3.090,40,43,30,21,20,10,13121,1367,1978,512,1225,497,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1908,22282,'Chromatic Detainee','','LineageMonster3.Crokian_Officer',25.00,33.00,81,'male','L2Monster','Fighter',40,18434,2.000,2444,0.900,40,43,30,21,20,10,27940,2945,2235,598,1418,572,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1909,22283,'Emerald Alligar','','LineageMonster3.Crokian_Officer',25.00,33.00,82,'male','L2Monster','Fighter',40,8675,26.860,2444,3.090,40,43,30,21,20,10,13120,1367,1978,512,1225,497,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1910,22284,'Chromatic Detainee','','LineageMonster.blade_stakato',15.00,36.00,81,'male','L2Monster','Fighter',40,18434,26.860,2444,3.090,40,43,30,21,20,10,27940,2945,2235,598,1418,572,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1911,22285,'Chromatic Detainee','','LineageMonster.blade_stakato',15.00,36.00,81,'male','L2Monster','Fighter',40,18434,26.860,2444,3.090,40,43,30,21,20,10,27940,2945,2235,598,1418,572,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1912,22286,'Plaza Gaviel','','LineageMonster3.Crokian_Officer',25.00,33.00,82,'male','L2Monster','Fighter',40,8675,26.860,2444,3.090,40,43,30,21,20,10,13196,1374,2145,565,1378,468,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1913,22287,'Crystaline Unicorn','','LineageMonster.unicorn',14.00,30.00,82,'female','L2Monster','Fighter',40,27983,26.860,2444,3.090,40,43,30,21,20,10,34702,3603,2765,578,1674,498,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1914,22288,'Emerald Boar','','LineageMonster.giant_wild_hog',25.00,27.00,82,'male','L2Monster','Fighter',40,27983,26.860,2444,3.090,40,43,30,21,20,10,37721,3933,2865,596,1727,512,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1915,22289,'Plaza Helm','','LineageMonster2.ketra_warbeast',20.00,33.50,81,'male','L2Monster','Fighter',40,23319,26.860,2444,3.090,40,43,30,21,20,10,36332,3811,2675,524,1653,487,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1916,22290,'Terod''s Minion','','LineageMonster4.eyeless_080p',20.00,35.00,81,'male','L2Monster','Fighter',40,17351,26.860,2444,3.090,40,43,30,21,20,10,101259,11071,3375,978,2216,775,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1917,22291,'Weylin''s Minion','','LineageMonster4.eyeless_080p',20.00,35.00,1,'male','L2Monster','Fighter',40,17351,26.860,2444,3.090,40,43,30,21,20,10,25745,7954,3015,675,2235,499,278,0,333,0,0,0,80,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1918,22292,'Tourmaline','','LineageMonster4.Crystal_Golem',20.00,47.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1919,22293,'Spinel','','LineageMonster.stone_golem',20.00,31.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1920,22294,'Fire Opal','','LineageMonster4.Crystal_Golem',20.00,47.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1921,22295,'Reef Golem','','LineageMonster4.Crystal_Golem',20.00,47.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1922,22296,'Reef Golem','','LineageMonster4.Crystal_Golem',20.00,47.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1923,22297,'Reef Golem','','LineageMonster4.Crystal_Golem',20.00,47.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1924,22298,'Weylin','','LineageMonster.banshee_30_bi',10.00,27.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1925,22299,'Dolph','','LineageMonster.pan_100_bi',42.00,73.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1926,22300,'Dolph''s Minion','','LineageMonster4.eyeless_080p',20.00,35.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1927,22301,'Ted','','LineageMonster.doll_master_20_bi',24.00,50.40,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1928,22302,'Darnel''s Guardian','','LineageMonster.pixy_bi',10.00,54.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1929,22303,'Guardian of the Square','','LineageMonster3.ice_fairy',16.00,35.60,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1930,22304,'Guardian of the Emerald','','LineageMonster.blue_eye_150p',13.00,26.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1931,22305,'Kechi''s Captain','','LineageMonster.field_stalker_110p',15.00,30.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1932,22306,'Kechi''s Captain','','LineageMonster2.lava_golem',22.00,45.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1933,22307,'Kechi''s Captain','','LineageMonster3.Steel_Trapper',35.00,46.38,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1934,22308,'Kechi''s Guard','','LineageMonster.mana_vampire_120p',11.00,27.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1935,22309,'Kechi''s Guard','','LineageMonster.blade_stakato_soldier',15.00,38.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1936,22310,'Kechi''s Guard','','LineageMonster3.portrait_spirit_150p',23.00,52.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1937,22311,'Parme''s Guardian','','LineageMonster.riba',25.00,72.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1938,22312,'Fafurion''s Henchman','','LineageMonster.raikel',37.00,64.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1939,22313,'Garden Stakato','','LineageMonster.blade_stakato_drone',15.00,39.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1940,22314,'Garden Poison Moth','','LineageMonster4.Anthias',20.00,41.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1941,22315,'Garden Guard','','LineageMonster.water_giant',13.00,44.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1942,22316,'Garden Guardian Tree','','LineageMonster3.Jungle_Bleeze',60.00,47.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1943,22317,'Garden Castalia','','LineageMonster4.tears_d',20.00,27.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1944,22318,'Hall Guard','','LineageMonster4.tears_d',20.00,27.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1945,22319,'Hall Guard','','LineageMonster4.tears_d',20.00,27.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1946,22320,'Junior Watchman','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1947,22321,'Junior Summoner','','LineageMonster2.vampire_witch',6.00,21.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1948,22322,'Subjugated Native','','LineageNPC.a_common_peopleC_Mhuman',8.00,23.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1949,22323,'Charmed Native','','LineageNPC.a_common_peopleC_Mhuman',8.00,23.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1950,22324,'Blind Huntsman','','LineageMonster4.eyeless_080p',20.00,35.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1951,22325,'Blind Watchman','','LineageMonster4.eyeless_080p',20.00,35.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1952,22326,'Hellinark','Naia''s Guardian','LineageMonster.karik',25.00,90.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1953,22327,'Arcane Scout','','LineageMonster.dark_mahum',13.00,26.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,1472,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1954,22328,'Arcane Guardian','','LineageMonster3.Succubus_Raid',12.00,30.70,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1955,22329,'Arcane Watchman','','LineageMonster3.Death_Blader_Raid',15.00,32.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1956,22330,'Remnant Wraith','','LineageMonster3.zombie_laborer',11.00,24.60,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1957,22331,'Remnant Diabolist','','LineageMonster3.spectral_knight',12.50,33.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1958,22332,'Remnant Diviner','','LineageMonster3.Spectral_knight',12.50,33.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1959,22333,'Derek','First Generation Seer','LineageMonster.Skeleton_royal_guard',11.00,28.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1960,22334,'Sand Scorpion','','LineageMonster2.SandScorpion',28.00,66.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1961,22335,'Desert Scorpion','','LineageMonster2.SandScorpion',28.00,66.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1962,22336,'Sand Devil','','LineageMonster2.imperial_warlord_zombie_sand',7.00,30.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1963,22337,'Desiccator','','LineageMonster.skeleton_knight_sand',10.00,25.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1964,22338,'Desert Rose','Sand Worm','LineageMonster4.Sandrose',50.00,22.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1965,22339,'Wandering Caravan','','LineageMonster4.Caravan',33.00,58.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1966,22340,'Sandstorm','','LineageMonster4.SandTourbillon',10.00,28.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1967,22341,'Keltas','','LineageMonster3.Vampire_Troop_Leader',19.00,35.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1968,22342,'Darion''s Executioner','','LineageMonster.silhouette',8.00,23.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1969,22343,'Darion''s Executioner','','LineageMonster.shadeless',7.00,28.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1970,22344,'Quarry Supervior','','LineageMonster2.vampire_warrior',9.00,31.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1971,22345,'Quarry Supervior','','LineageMonster2.vampire_wizard',5.50,28.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1972,22346,'Quarry Foreman','','LineageMonster3.Vampire_Troop_Leader_120p',22.00,43.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1973,22347,'Quarry Patrolman','','LineageMonster4.eyeless_080p',20.00,35.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1974,22348,'Laboratory Guard','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(1975,22349,'Chimera of Earth','','LineageMonster4.Chimera',35.00,36.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1976,22350,'Chimera of Darkness','','LineageMonster4.Chimera',35.00,36.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1977,22351,'Chimera of Wind','','LineageMonster4.Chimera',35.00,36.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1978,22352,'Chimera of Fire','','LineageMonster4.Chimera',35.00,36.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1979,22353,'Celtus','Chimera','LineageMonster4.Chimera',35.00,36.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1980,22354,'Outpost Captain','','LineageMonster.kaim_vanul',24.00,40.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1981,22355,'Enceinte Defender','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1982,22356,'Enceinte Defender','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1983,22357,'Enceinte Defender','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1984,22358,'Enceinte Defender','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1985,22359,'Town Guard','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1986,22360,'Town Patrolman','','LineageMonster.kel_mahum',13.00,26.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1987,22361,'Iron Castle Keymaster','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1988,22362,'Guzen','','LineageMonster4.rah',20.00,40.60,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1989,22363,'Body Destroyer','','LineageMonster.kaim_vanul',24.00,40.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1990,22364,'Soul Dominator','','LineageMonster.kaim_vanul',24.00,40.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1991,22365,'Labyrinth Predator','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1992,22366,'Labyrinth Watchman','','LineageMonster3.zombie_gateguard',17.00,30.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1993,22367,'Labyrinth Magician','','LineageMonster2.vampire_wizard',5.50,28.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1994,22368,'Labyrinth Enchanter','','LineageMonster2.vampire_witch',6.00,21.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1995,22369,'Labyrinth Seer','','LineageMonster.skeleton_royal_guard',11.00,28.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1996,22370,'Passageway Captain','','LineageMonster2.vampire_soldier_20_bi',10.00,29.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1997,22371,'Passageway Guards','','LineageMonster.skeleton_royal_guard',11.00,28.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1998,22372,'Passageway Mystic','','LineageMonster.kaim_vanul',24.00,40.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(1999,22373,'Cosmic Scout','','LineageMonster4.rahuu',33.00,49.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2000,22374,'Cosmic Watcher','','LineageMonster4.rah',20.00,40.60,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2001,22375,'Cosmic Priest','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2002,22376,'Cosmic Lord','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2003,22377,'Master Zelos','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2004,22378,'Master''s Minion','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2005,22379,'Master''s Minion','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2006,22380,'Master Festina','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2007,22381,'Master''s Guard','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2008,22382,'Master''s Guard','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2009,22383,'Tully''s Toy','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2010,22384,'Mystic''s Toy','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2011,22385,'Tully''s Golem Guard','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2012,22386,'Foundry Mystic','','LineageMonster4.rahuu',33.00,49.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2013,22387,'Foundry Mystic','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2014,22388,'Foundry Spirit Guard','','LineageMonster3.Kernon_Raid',45.00,42.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2015,22389,'Foundry Spirit Guard','','LineageMonster4.rahuu',33.00,49.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2016,22390,'Foundry Foreman','','LineageMonster3.zombie_gateguard',17.00,30.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2017,22391,'Foundry Assistant Overseer','','LineageMonster4.rahuu',33.00,49.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2018,22392,'Failed Experimental Timetwister Golem','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2019,22393,'Beleth''s Follower','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2020,22394,'Beleth''s Devotee','','LineageMonster3.zombie_gateguard',17.00,30.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2021,22395,'Beleth''s Projection','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2022,22396,'Foundry Laborer','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2023,22397,'Foundry Foreman','','LineageMonster.succubus_20_bi',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2024,22398,'Lesser Evil','','LineageMonster3.zombie_gateguard',17.00,30.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2025,22399,'Greater Evil','','LineageMonster3.zombie_gateguard',17.00,30.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2026,22400,'Parme''s Healer','','LineageMonster4.tears_d',20.00,27.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2027,22401,'Parme''s Healer','','LineageMonster4.tears_d',20.00,27.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2028,22402,'Shadow Column','','LineageNpcEV.dark_clouds_chessman',42.00,80.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2029,22403,'Foundry Foreman','','LineageMonster4.rahuu',33.00,49.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2030,22404,'Arcane Captain','','LineageMonster.kaim_vanul',24.00,40.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2031,22405,'Darion''s Faithful Servant','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2032,22406,'Darion''s Faithful Servant','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2033,22407,'Darion''s Faithful Servant','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2034,22408,'Darion''s Faithful Servant','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2035,22409,'Darion''s Faithful Servant','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2036,22410,'Darion''s Faithful Servant','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2037,22411,'Beleth''s Retainer','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2038,22412,'Beleth''s Fighter','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2039,22413,'Beleth''s Low Servant','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2040,22414,'Beleth''s Follower','','LineageMonster3.zombie_gateguard',17.00,30.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2041,22415,'Beleth''s Devotee','','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2042,22416,'Kechi''s Captain','','LineageMonster2.ifrit_30_bi',13.00,55.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2043,22417,'Kechi''s Guard','','LineageMonster3.portrait_spirit_winged_150p',23.00,52.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2044,22418,'Burning Iris','','LineageMonster4.eyeless_080p',20.00,35.00,70,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2045,22419,'Flame Iris','','LineageMonster4.eyeless_080p',20.00,35.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2046,22420,'Brimstone Iris','','LineageMonster4.eyeless_080p',20.00,35.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2047,22421,'Hellbound Native','','LineageNPC.a_common_peopleC_Mhuman',8.00,23.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2048,22422,'Failan''s Guard','','LineageMonster3.Death_Blader_Raid',15.00,32.50,0,'male','L2Monster','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Magister',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',0,0),
(2049,25001,'Greyclaw Kutus','Raid Boss','ol_mahum_champion_50_bi',21.00,43.50,23,'male','L2RaidBoss','Fighter',40,95986,58.000,545,5.000,60,57,73,76,70,80,714843,67170,61,857,6,348,278,0,3819,67,633,0,81,275,'',0,'Magister','',0,20,382,7,30,4,20,0,-18,0.63,'false',1,1),
(2050,25002,'Guard of Kutus','Raid Fighter','ol_mahum',13.50,25.00,22,'male','L2Minion','Fighter',40,6613,18.950,257,4.500,40,43,30,41,20,10,0,0,74,411,9,167,278,0,253,7,0,0,50,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,0.46,'false',1,0),
(2051,25003,'Pawn of Kutus','Raid Fighter','ol_mahum',13.50,25.00,22,'male','L2Minion','Fighter',40,9870,18.950,257,4.500,40,43,30,41,20,10,0,0,111,411,22,167,278,0,253,123,0,0,50,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.46,'false',1,0),
(2052,25004,'Turek Mercenary Captain','Raid Boss','orc_champion_50_bi',15.00,35.00,30,'male','L2RaidBoss','Fighter',40,168366,152.000,763,6.000,60,57,73,76,70,80,1424160,129276,226,1127,70,458,278,0,1972,124,0,0,45,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.76,'false',1,1),
(2053,25005,'Turek Mercenary Archer','Raid Fighter','orc_archer',14.00,25.00,29,'male','L2Minion','Ranger',500,11414,50.200,365,4.500,40,43,30,41,20,10,0,0,604,542,111,220,249,0,227,271,0,0,45,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,0.80,'false',1,0),
(2054,25006,'Turek Mercenary Warrior','Raid Fighter','orc_fighter',12.00,22.00,29,'male','L2Minion','Fighter',40,8518,50.200,365,4.500,40,43,30,41,20,10,0,0,203,542,62,220,278,0,253,2,0,0,45,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,0.46,'false',1,0),
(2055,25007,'Retreat Spider Cletu','Raid Boss','poison_spider',27.00,25.50,42,'male','L2RaidBoss','Mystic',40,331522,210.000,1062,6.000,60,57,73,76,70,80,2299956,251972,746,1728,324,701,278,0,1972,0,0,0,60,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.65,'false',1,1),
(2056,25008,'Cletu''s Retainer','Raid Fighter','giant_spider',26.00,26.50,41,'male','L2Minion','Mystic',40,33216,69.880,514,5.400,40,43,30,41,20,10,0,0,662,835,278,339,278,0,253,0,0,0,72,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.26,'false',1,0),
(2057,25009,'Cletu''s Pawn','Raid Fighter','giant_spider',26.00,26.50,41,'male','L2Minion','Mystic',40,16608,69.880,514,5.400,40,43,30,41,20,10,0,0,662,835,278,339,278,0,253,0,0,0,72,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.26,'false',1,0),
(2058,25010,'Furious Thieles','Raid Boss','ti_mi_tran',23.00,90.00,55,'male','L2RaidBoss','Fighter',40,624464,290.000,2039,8.000,60,57,73,76,70,80,2988757,448385,2471,2576,1817,1046,278,0,1972,0,0,0,12,50,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.61,'false',1,1),
(2059,25011,'Guard of Thieles','Raid Fighter','zenta_lizardman_scout',11.00,30.00,54,'male','L2Minion','Ranger',500,42806,97.460,987,7.200,40,43,30,41,20,10,0,0,6746,1252,2944,508,249,0,227,279,0,0,37,170,'',0,'Local','',0,0,0,7,30,4,20,1500,0,0.93,'false',1,0),
(2060,25012,'Follower of Thieles','Raid Fighter','dryad',9.00,20.00,54,'female','L2Minion','Fighter',40,9909,97.460,987,7.200,40,43,30,41,20,10,0,0,2277,1252,1656,508,278,0,253,0,0,0,40,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.37,'false',1,0),
(2061,25013,'Ghost of Peasant Leader','Raid Boss','skeleton_knight_50_bi',15.00,39.00,50,'male','L2RaidBoss','Fighter',40,507285,259.000,1722,8.000,60,57,73,76,70,80,2494222,346727,1510,2226,862,904,278,0,1972,145,0,0,40,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.17,'false',1,1),
(2062,25014,'Ghost of Peasant','Raid Fighter','skeleton',11.00,25.00,49,'male','L2Minion','Fighter',40,51380,86.860,830,6.300,40,43,30,41,20,10,0,0,2751,1079,3086,438,278,0,253,68,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.30,'false',1,0),
(2063,25015,'Ghost of Peasant','Raid Fighter','skeleton_archer',11.00,27.00,49,'male','L2Minion','Ranger',500,25690,86.860,830,6.300,40,43,30,41,20,10,0,0,1375,1079,771,438,278,0,253,14,0,0,40,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,0.80,'false',1,0),
(2064,25016,'The 3rd Underwater Guardian','Raid Boss','susceptor_100_bi',40.00,73.00,60,'male','L2RaidBoss','Fighter',40,188376,344.000,2368,9.000,60,57,73,76,70,80,3346092,522780,3860,2951,3932,1198,278,0,1972,0,0,0,27,150,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.43,'false',0,1),
(2065,25017,'Escort of the 3rd Guardian','Raid Fighter','will_o_wisp',13.00,22.00,59,'male','L2Minion','Fighter',40,24399,115.940,1150,7.200,40,43,30,41,20,10,0,0,3509,1437,3472,583,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.10,'false',0,0),
(2066,25018,'Support of the 3rd Guardian','Raid Fighter','will_o_wisp',13.00,22.00,59,'male','L2Minion','Fighter',40,12199,115.940,1150,7.200,40,43,30,41,20,10,0,0,3509,1437,3472,583,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.10,'false',0,0),
(2067,25019,'Pan Dryad','Raid Boss','pan_100_bi',42.00,73.00,25,'male','L2RaidBoss','Fighter',40,206185,63.000,606,5.000,60,57,73,76,70,80,730469,69595,146,928,30,377,278,0,1972,291,0,0,45,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.58,'false',1,1),
(2068,25020,'Breka Warlock Pastu','Raid Boss','batur_orc_shaman_100_bi',22.00,35.00,34,'male','L2RaidBoss','Priest',40,156584,88.000,893,6.000,60,57,73,76,70,80,1174184,135023,280,1308,55,531,278,0,1972,8,0,0,50,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.30,'false',1,1),
(2069,25021,'Pastu''s Silhouette','Raid Fighter','silhouette',8.00,23.00,33,'female','L2Minion','Fighter',40,15774,29.040,430,5.400,40,43,30,41,20,10,0,0,258,630,51,256,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.54,'false',1,0),
(2070,25022,'Pastu''s Shadow','Raid Fighter','shadow',10.00,30.00,33,'male','L2Minion','Mystic',40,7887,29.040,430,5.400,40,43,30,41,20,10,0,0,258,630,51,256,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.54,'false',1,0),
(2071,25023,'Stakato Queen Zyrnna','Raid Boss','marsh_stakato_queen_100_bi',30.00,76.00,34,'female','L2RaidBoss','Fighter',40,208019,163.000,1415,7.000,60,57,73,76,70,80,1753455,156895,340,1308,110,531,278,0,1972,150,0,0,50,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.41,'false',1,1),
(2072,25024,'Jeruna''s Guard Captain','Raid Fighter','marsh_stakato_drone',9.00,24.00,33,'male','L2Minion','Fighter',40,20909,53.930,677,6.300,40,43,30,41,20,10,0,0,626,630,408,256,278,0,253,238,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.39,'false',1,0),
(2073,25025,'Jeruna''s Guard','Raid Fighter','marsh_stakato_soldier',10.00,25.00,33,'male','L2Minion','Fighter',40,10454,53.930,677,6.300,40,43,30,41,20,10,0,0,313,630,102,256,278,0,253,257,0,0,30,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.74,'false',1,0),
(2074,25026,'Katu Van Leader Atui','Raid Boss','ketra_orc_overload',12.00,24.00,49,'male','L2RaidBoss','Fighter',40,352421,136.000,1660,7.000,60,57,73,76,70,80,1655129,248433,1147,2160,383,877,278,0,1972,84,0,0,33,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.48,'false',1,1),
(2075,25027,'Katu Van Marksman','Raid Fighter','ketra_orc_archer',12.00,27.00,48,'male','L2Minion','Ranger',500,23911,45.620,799,6.300,40,43,30,41,20,10,0,0,3102,1047,613,425,249,0,227,279,0,0,45,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,0.91,'false',1,0),
(2076,25028,'Katu Van Raider','Raid Fighter','ketra_orc_warrior',12.00,24.00,48,'male','L2Minion','Fighter',40,17844,45.620,799,6.300,40,43,30,41,20,10,0,0,1047,1047,345,425,278,0,253,128,0,0,36,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.54,'false',1,0),
(2077,25029,'Atraiban','Raid Boss','field_stalker_200_bi',45.00,96.00,53,'male','L2RaidBoss','Fighter',40,156190,299.000,1911,8.000,60,57,73,76,70,80,3145490,461913,2344,2433,1974,988,278,0,1972,0,0,0,70,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.41,'false',1,1),
(2078,25030,'Atraiban''s Top Disciple','Raid Fighter','will_o_wisp',13.00,22.00,52,'male','L2Minion','Mystic',40,20135,100.430,923,7.200,40,43,30,41,20,10,0,0,2114,1181,1727,479,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.10,'false',1,0),
(2079,25031,'Atraiban''s Disciple','Raid Fighter','liviona',15.00,28.00,52,'male','L2Minion','Fighter',40,10067,100.430,923,7.200,40,43,30,41,20,10,0,0,2114,1181,1727,479,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.34,'false',1,0),
(2080,25032,'Eva''s Guardian Millenu','Raid Boss','banshee_50_bi',13.50,38.00,65,'female','L2RaidBoss','Mystic',40,229722,406.000,2707,9.000,60,57,73,76,70,80,1820975,806823,5880,3349,7541,1360,278,0,1972,3939,0,0,80,170,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.56,'false',0,1),
(2081,25033,'Millenu Guard Shaman','Raid Fighter','heltor_silenos_shaman',13.00,32.00,64,'male','L2Minion','Priest',40,20074,138.400,1319,8.100,40,43,30,41,20,10,0,0,7473,1634,12940,663,278,0,253,5131,0,0,29,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.22,'false',0,0),
(2082,25034,'Mellenu Guard Warrior','Raid Fighter','skeleton_royal_guard',11.00,28.50,64,'male','L2Minion','Fighter',40,30142,138.400,1319,8.100,40,43,30,41,20,10,0,0,11210,1634,29118,663,278,0,253,946,945,0,80,170,'',0,'Local','',0,20,534,7,30,4,20,0,0,0.52,'false',0,0),
(2083,25035,'Shilen''s Messenger Cabrio','Raid Boss','vale_master_50_bi',18.00,63.00,70,'male','L2RaidBoss','Fighter',40,888658,414.000,3058,10.000,60,57,73,76,70,80,1915900,918808,6981,3764,8986,1528,278,0,1972,189,0,0,70,170,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.74,'false',1,1),
(2084,25036,'Cabrio Captor','Raid Fighter','skeleton_archer',11.00,27.00,69,'male','L2Minion','Ranger',500,62338,141.600,1493,8.100,40,43,30,41,20,10,0,0,19755,1840,15424,747,249,0,227,279,0,0,40,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,0.80,'false',1,0),
(2085,25037,'Cabrio Blader','Raid Fighter','doll_blader',6.00,12.00,69,'male','L2Minion','Fighter',40,46520,141.600,1493,8.100,40,43,30,41,20,10,0,0,6668,1840,8676,747,278,0,253,5129,5129,0,22,170,'',0,'Tigra','',0,0,582,7,30,4,20,0,0,0.50,'false',1,0),
(2086,25038,'Tirak','Raid Boss','dre_vanul_100_bi',28.00,75.00,28,'male','L2RaidBoss','Fighter',40,116581,70.000,699,5.000,60,57,73,76,70,80,750326,74683,96,1044,10,424,278,0,1972,0,0,0,80,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.35,'false',1,1),
(2087,25039,'Tirak''s Guard','Raid Fighter','spartoi',11.00,27.00,27,'male','L2Minion','Fighter',40,11861,23.250,334,4.500,40,43,30,41,20,10,0,0,175,502,38,204,278,0,253,68,0,0,60,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.30,'false',1,0),
(2088,25040,'Tirak''s Knight','Raid Fighter','skeleton',11.00,25.00,27,'male','L2Minion','Fighter',40,5930,23.250,334,4.500,40,43,30,41,20,10,0,0,87,502,9,204,278,0,253,2,945,0,60,170,NULL,0,'Tigra',NULL,0,20,216,7,30,4,20,0,0,0.30,'false',1,0),
(2089,25041,'Remmel','Raid Boss','marsh_stakato_queen_100_bi',30.00,76.00,35,'female','L2RaidBoss','Fighter',40,165289,91.000,927,6.000,60,57,73,76,70,80,1018607,103175,200,1356,28,550,278,0,1972,221,109,0,50,170,'',0,'Magister','',0,20,546,7,30,4,20,0,-18,0.41,'false',1,1),
(2090,25042,'Remmel''s Archer','Raid Fighter','batur_orc_archer',11.00,21.50,34,'male','L2Minion','Ranger',500,11143,30.060,446,5.400,40,43,30,41,20,10,0,0,547,654,46,265,249,0,227,275,0,0,45,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.96,'false',1,0),
(2091,25043,'Remmel''s Guard','Raid Fighter','marsh_stakato',10.00,20.00,34,'male','L2Minion','Fighter',40,8316,30.060,446,5.400,40,43,30,41,20,10,0,0,184,654,26,265,278,0,253,127,0,0,21,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.74,'false',1,0),
(2092,25044,'Barion','Raid Boss','skeleton_knight_50_bi',15.00,39.00,47,'male','L2RaidBoss','Fighter',40,319791,130.000,1296,7.000,60,57,73,76,70,80,1624139,238098,956,2030,296,824,278,0,1972,70,0,0,40,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.17,'false',1,1),
(2093,25045,'Dark Mage''s of Barion','Raid Fighter','batur_orc_shaman',11.00,16.00,46,'male','L2Minion','Priest',40,32280,43.310,618,6.300,40,43,30,41,20,10,0,0,861,983,260,399,278,0,253,159,0,0,50,120,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.30,'false',1,0),
(2094,25046,'Barion''s Grunt','Raid Fighter','spartoi',11.00,27.00,46,'male','L2Minion','Fighter',40,16140,43.310,618,6.300,40,43,30,41,20,10,0,0,861,983,260,399,278,0,253,129,0,0,60,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.30,'false',1,0),
(2095,25047,'Karte','Raid Boss','death_knight_50_bi',18.00,45.00,49,'male','L2RaidBoss','Fighter',40,352421,136.000,1660,7.000,60,57,73,76,70,80,1412364,185123,769,2160,184,877,278,0,1972,131,0,0,27,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.71,'false',1,1),
(2096,25048,'Karte''s Chief Knight','Raid Fighter','skeleton_knight',10.00,25.00,48,'male','L2Minion','Fighter',40,35688,45.620,799,6.300,40,43,30,41,20,10,0,0,1403,1047,664,425,278,0,253,71,0,0,40,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.17,'false',1,0),
(2097,25049,'Karte''s Royal Guard','Raid Fighter','spartoi',11.00,27.00,48,'male','L2Minion','Fighter',40,17844,45.620,799,6.300,40,43,30,41,20,10,0,0,701,1047,166,425,278,0,253,74,0,0,60,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.30,'false',1,0),
(2098,25050,'Verfa','Raid Boss','death_blader_200_bi',45.00,141.00,51,'male','L2RaidBoss','Fighter',40,771340,123.000,2039,8.000,60,57,73,76,70,80,1381165,185853,1700,2294,879,931,278,0,1972,1472,0,0,100,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.45,'false',1,1),
(2099,25051,'Rahha','Raid Boss','Bloody_Queen_Raid',11.00,34.00,65,'female','L2RaidBoss','Mystic',40,818959,330.000,2707,9.000,60,57,73,76,70,80,3674504,679343,4656,3349,4297,1360,278,0,1972,0,0,0,80,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.50,'false',1,1),
(2100,25052,'Priestess of Rahha','Raid Fighter','medusa',10.00,25.00,64,'female','L2Minion','Priest',40,85286,112.570,1319,8.100,40,43,30,41,20,10,0,0,4442,1634,4159,663,278,0,253,0,0,0,50,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.52,'false',1,0),
(2101,25053,'Fanatics of Rahha','Raid Fighter','harpy',10.00,42.00,64,'female','L2Minion','Fighter',40,42643,112.570,1319,8.100,40,43,30,41,20,10,0,0,4442,1634,4159,663,278,0,253,0,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.65,'false',1,0),
(2102,25054,'Kernon','Raid Boss','kaim_vanul',24.00,40.00,75,'male','L2RaidBoss','Fighter',40,945900,416.000,3420,10.000,60,57,73,76,70,80,2238750,1054472,8986,4188,12912,1701,278,0,1972,0,0,0,37,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.45,'false',1,1),
(2103,25055,'Taliadon','Raid Fighter','death_blader',15.00,45.00,74,'male','L2Minion','Fighter',40,99324,142.800,1673,9.000,40,43,30,41,20,10,0,0,17216,2051,49884,833,278,0,253,1472,0,0,100,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.45,'false',1,0),
(2104,25056,'Vemsk','Raid Fighter','death_knight',12.00,30.00,74,'male','L2Minion','Fighter',40,49662,142.800,1673,9.000,40,43,30,41,20,10,0,0,8608,2051,12471,833,278,0,253,142,0,0,27,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.71,'false',1,0),
(2105,25057,'Biconne of Blue Sky','Raid Boss','lienrik',12.00,50.00,45,'male','L2RaidBoss','Fighter',40,288415,123.000,2235,8.000,60,57,73,76,70,80,1358394,171282,538,1905,112,774,278,0,1972,0,0,0,100,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.46,'false',1,1),
(2106,25058,'Biconne''s Shooter','Raid Fighter','skeleton_archer',11.00,27.00,44,'male','L2Minion','Ranger',500,19455,41.020,1084,7.200,40,43,30,41,20,10,0,0,1444,922,176,374,249,0,227,279,0,0,40,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.80,'false',1,0),
(2107,25059,'Biconne''s Warrior','Raid Fighter','skeleton_knight',10.00,25.00,44,'male','L2Minion','Fighter',40,3879,41.020,1084,7.200,40,43,30,41,20,10,0,0,487,922,99,374,278,0,253,150,0,0,40,160,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.17,'false',1,0),
(2108,25060,'Unrequited Kael','Raid Boss','succubus_100_bi',20.00,75.00,24,'female','L2RaidBoss','Mystic',40,99367,51.000,575,5.000,60,57,73,76,70,80,606920,51383,57,892,5,362,278,0,1972,0,0,0,60,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.84,'false',1,1),
(2109,25061,'Kael''s Bead','Raid Fighter','will_o_wisp',13.00,22.00,23,'male','L2Minion','Mystic',40,6830,16.940,272,4.500,40,43,30,41,20,10,0,0,69,428,8,174,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.10,'false',1,0),
(2110,25062,'Kael''s Escort','Raid Fighter','harpy',10.00,42.00,23,'female','L2Minion','Fighter',40,10195,16.940,272,4.500,40,43,30,41,20,10,0,0,103,428,19,174,278,0,253,0,0,0,60,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.65,'false',1,0),
(2111,25063,'Chertuba of Great Soul','Raid Boss','ketra_orc_warrior_100_bi',24.00,51.00,35,'male','L2RaidBoss','Fighter',40,330579,91.000,927,6.000,60,57,73,76,70,80,1018607,103175,401,1356,113,550,278,0,1972,78,0,0,36,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.54,'false',1,1),
(2112,25064,'Wizard of Storm Teruk','Raid Boss','zenta_lizardman_shaman_50_bi',19.00,55.00,40,'male','L2RaidBoss','Priest',40,218810,106.000,1120,7.000,60,57,73,76,70,80,1091654,139773,287,1615,42,656,278,0,1972,90,0,0,43,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.63,'false',1,1),
(2113,25065,'Teruk''s Escort','Raid Fighter','zenta_lizardman',11.00,32.00,39,'male','L2Minion','Fighter',40,6444,35.410,531,5.400,40,43,30,41,20,10,0,0,530,780,157,317,278,0,253,123,0,0,37,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.28,'false',1,0),
(2114,25066,'Teruk''s Knight','Raid Fighter','zenta_lizardman_warrior',13.00,35.00,39,'male','L2Minion','Fighter',40,10980,35.410,531,5.400,40,43,30,41,20,10,0,0,265,780,39,317,278,0,253,291,0,0,40,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.56,'false',1,0),
(2115,25067,'Captain of Red Flag Shaka','Raid Boss','oel_mahum_warrior_50_bi',30.00,60.00,52,'male','L2RaidBoss','Fighter',40,554640,272.000,1598,7.000,60,57,73,76,70,80,2909180,424683,1951,2363,1304,959,278,0,1972,71,0,0,70,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.65,'false',1,1),
(2116,25068,'Shaka''s Shooter','Raid Fighter','ol_mahum_archer',14.00,25.00,51,'male','L2Minion','Ranger',500,37786,91.130,768,6.300,40,43,30,41,20,10,0,0,5307,1147,2104,465,249,0,227,277,0,0,50,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.93,'false',1,0),
(2117,25069,'Shaka''s Follower','Raid Fighter','oel_mahum_champion',23.00,61.00,51,'male','L2Minion','Fighter',40,28199,91.130,768,6.300,40,43,30,41,20,10,0,0,1791,1147,1183,465,278,0,253,128,633,0,67,170,NULL,0,'Tigra',NULL,0,20,409,7,30,4,20,0,0,0.46,'false',1,0),
(2118,25070,'Enchanted Forest Watcher Ruell','Raid Boss','ti_mi_tran',23.00,90.00,55,'male','L2RaidBoss','Fighter',40,451391,156.000,2039,8.000,60,57,73,76,70,80,1707842,285150,1364,2576,435,1046,278,0,1972,0,0,0,12,50,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.61,'false',1,1),
(2119,25071,'Ruell''s Wind','Raid Fighter','sylph',11.00,35.00,54,'female','L2Minion','Mystic',40,7107,52.480,987,7.200,40,43,30,41,20,10,0,0,1676,1252,705,508,278,0,253,0,0,0,60,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.56,'false',1,0),
(2120,25072,'Ruell''s Unicorn','Raid Fighter','unicorn',14.00,30.00,54,'male','L2Minion','Mystic',40,46232,52.480,987,7.200,40,43,30,41,20,10,0,0,2514,1252,1586,508,278,0,253,0,0,0,46,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.74,'false',1,0),
(2121,25073,'Bloody Priest Rudelto','Raid Boss','karik_100_bi',50.00,180.00,69,'male','L2RaidBoss','Priest',40,875948,413.000,2987,9.000,60,57,73,76,70,80,1894878,895518,6751,3680,8676,1494,278,0,1972,0,0,0,37,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.45,'false',1,1),
(2122,25074,'Rudelto''s Banshee','Raid Fighter','banshee',9.00,23.00,68,'female','L2Minion','Mystic',40,91632,141.200,1458,8.100,40,43,30,41,20,10,0,0,6447,1798,8379,730,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.56,'false',1,0),
(2123,25075,'Rudelto''s Dre Vanul','Raid Fighter','dre_vanul',14.00,36.00,68,'male','L2Minion','Fighter',40,45816,141.200,1458,8.100,40,43,30,41,20,10,0,0,6447,1798,8379,730,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.35,'false',1,0),
(2124,25076,'Princess Molrang','Raid Boss','poison_toad_100_bi',40.00,20.00,25,'male','L2RaidBoss','Fighter',40,103092,63.000,606,5.000,60,57,73,76,70,80,730469,69595,73,928,7,377,278,0,1972,0,0,0,50,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.35,'false',1,1),
(2125,25077,'Captain Dogun','Raid Fighter','grizzly',21.00,40.00,24,'male','L2Minion','Fighter',40,10554,20.600,287,4.500,40,43,30,41,20,10,0,0,132,446,27,181,278,0,253,0,0,0,40,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.34,'false',1,0),
(2126,25078,'Princess'' Guard','Raid Fighter','grizzly',21.00,40.00,24,'male','L2Minion','Fighter',40,5277,20.600,287,4.500,40,43,30,41,20,10,0,0,66,446,6,181,278,0,253,0,0,0,40,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.34,'false',1,0),
(2127,25079,'Cat''s Eye Bandit','Raid Boss','Ol_Mahum_Raid',15.00,25.00,30,'male','L2RaidBoss','Fighter',40,168366,141.000,763,6.000,60,57,73,76,70,80,1329219,122342,206,1127,53,458,278,0,1972,216,0,0,50,170,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.63,'false',1,1),
(2128,25080,'Mercenary','Raid Fighter','orc_shaman',9.00,22.00,29,'male','L2Minion','Priest',40,17036,46.620,365,4.500,40,43,30,41,20,10,0,0,185,542,47,220,278,0,253,179,0,0,45,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.26,'false',1,0),
(2129,25081,'Cat''s Eye Bandit','Raid Fighter','ol_mahum',13.50,25.00,29,'male','L2Minion','Fighter',40,8518,46.620,365,4.500,40,43,30,41,20,10,0,0,185,542,47,220,278,0,253,218,0,0,50,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.46,'false',1,0),
(2130,25082,'Leader of Cat Gang','Raid Boss','cat_the_cat_50_bi',13.50,26.00,39,'male','L2RaidBoss','Fighter',40,206753,103.000,1062,6.000,60,57,73,76,70,80,1078255,134578,268,1561,39,634,278,0,1972,0,0,0,80,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.61,'false',1,1),
(2131,25083,'Cat Gang','Raid Fighter','cutie_cat',8.00,15.00,38,'female','L2Minion','Fighter',40,13903,34.310,514,5.400,40,43,30,41,20,10,0,0,330,754,65,306,278,0,253,0,0,0,48,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.34,'false',1,0),
(2132,25084,'Cat Gang','Raid Fighter','cat_the_cat',9.00,16.00,38,'male','L2Minion','Fighter',40,20752,34.310,514,5.400,40,43,30,41,20,10,0,0,495,754,146,306,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.61,'false',1,0),
(2133,25085,'Timak Orc Chief Ranger','Raid Boss','ketra_orc_warrior_100_bi',24.00,51.00,44,'male','L2RaidBoss','Fighter',40,371721,222.000,1355,7.000,60,57,73,76,70,80,2352182,262175,893,1845,414,749,278,0,1972,157,0,0,36,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.54,'false',1,1),
(2134,25086,'Timak Orc Ranger','Raid Fighter','ketra_orc_archer',12.00,27.00,43,'male','L2Minion','Ranger',500,9259,74.070,648,6.300,40,43,30,41,20,10,0,0,2392,892,653,362,249,0,227,14,0,0,45,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,0.91,'false',1,0),
(2135,25087,'Timak Orc Ranger','Raid Fighter','ketra_orc',12.00,29.00,43,'male','L2Minion','Fighter',40,6951,74.070,648,6.300,40,43,30,41,20,10,0,0,807,892,367,362,278,0,253,68,0,0,45,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,0.46,'false',1,0),
(2136,25088,'Crazy Mechanic Golem','Raid Boss','mechanic_golem_200_bi',15.00,63.00,43,'male','L2RaidBoss','Mystic',40,702418,233.000,2039,8.000,60,57,73,76,70,80,2492637,273103,1794,1785,1948,725,278,0,1972,0,0,0,30,150,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.72,'false',1,1),
(2137,25089,'Soulless Wild Boar','Raid Boss','giant_wild_hog',25.00,27.00,59,'male','L2RaidBoss','Fighter',40,512194,169.000,2301,8.000,60,57,73,76,70,80,2072981,415763,2664,2875,1302,1167,278,0,1972,0,0,0,35,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.54,'false',1,1),
(2138,25090,'Soulless Wolf','Raid Fighter','dire_wolf',13.00,11.00,58,'male','L2Minion','Fighter',40,35416,56.900,1117,7.200,40,43,30,41,20,10,0,0,3291,1399,2123,568,278,0,253,0,0,0,24,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'false',1,0),
(2139,25091,'Soulless Bear','Raid Fighter','crimson_bear',19.00,36.00,58,'male','L2Minion','Fighter',40,52860,56.900,1117,7.200,40,43,30,41,20,10,0,0,4936,1399,4777,568,278,0,253,0,0,0,37,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.45,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(2140,25092,'Korim','Raid Boss','heltor_silenos_shaman_50_bi',19.50,51.00,70,'male','L2RaidBoss','Priest',40,888658,336.000,3058,10.000,60,57,73,76,70,80,3859833,738431,5659,3764,5371,1528,278,0,1972,201,0,0,29,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.22,'false',1,1),
(2141,25093,'Korim Chief Guard Kaywon','Raid Fighter','heltor_silenos_warrior',13.00,31.00,69,'male','L2Minion','Fighter',40,93041,114.980,1493,8.100,40,43,30,41,20,10,0,0,10724,1840,20400,747,278,0,253,162,0,0,36,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.39,'false',1,0),
(2142,25094,'Korim Guards','Raid Fighter','heltor_silenos',13.00,29.00,69,'male','L2Minion','Fighter',40,46520,114.980,1493,8.100,40,43,30,41,20,10,0,0,5362,1840,5100,747,278,0,253,86,0,0,34,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.46,'false',1,0),
(2143,25095,'Elf Renoa','Raid Boss','elf_ghost',7.00,21.00,29,'male','L2RaidBoss','Mystic',40,121941,73.000,731,5.000,60,57,73,76,70,80,755659,76955,104,1085,11,440,278,0,1972,0,0,0,80,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.41,'false',1,1),
(2144,25096,'Renoa''s Elpy','Raid Fighter','elpy',13.00,13.00,28,'male','L2Minion','Fighter',40,8296,24.170,349,4.500,40,43,30,41,20,10,0,0,126,522,18,212,278,0,253,0,0,0,50,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.60,'false',1,0),
(2145,25097,'Renoa''s Hog','Raid Fighter','giant_wild_hog',25.00,27.00,28,'male','L2Minion','Fighter',40,12383,24.170,349,4.500,40,43,30,41,20,10,0,0,190,522,41,212,278,0,253,0,0,0,35,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.54,'false',1,0),
(2146,25098,'Sejarr''s Servitor','Raid Boss','dark_fencer_200_bi',30.00,43.00,35,'male','L2RaidBoss','Fighter',40,330579,91.000,927,6.000,60,57,73,76,70,80,1018607,103175,401,1356,113,550,278,0,1972,0,0,0,25,170,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.20,'false',1,1),
(2147,25099,'Rotten Tree Repiro','Raid Boss','hanged_man_ripper',35.00,80.00,44,'male','L2RaidBoss','Fighter',40,273375,120.000,1355,7.000,60,57,73,76,70,80,1344111,167614,493,1845,99,749,278,0,1972,0,0,0,55,55,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.48,'false',1,1),
(2148,25100,'Spirit of Sea of Spores','Raid Fighter','pixy',5.00,25.00,43,'female','L2Minion','Fighter',40,27494,39.880,648,6.300,40,43,30,41,20,10,0,0,318,892,88,362,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.72,'false',1,0),
(2149,25101,'Fighter of Sea of Spores','Raid Fighter','troll',21.00,35.00,43,'male','L2Minion','Fighter',40,13747,39.880,648,6.300,40,43,30,41,20,10,0,0,318,892,88,362,278,0,253,0,0,0,55,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.61,'false',1,0),
(2150,25102,'Shacram','Raid Boss','minotaur_100_bi',42.00,94.00,45,'male','L2RaidBoss','Fighter',40,576831,123.000,1722,8.000,60,57,73,76,70,80,1591877,230991,1603,1905,927,774,278,0,1972,300,0,0,40,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.59,'false',1,1),
(2151,25103,'Sorcerer Isirr','Raid Boss','zenta_lizardman_matriarch_50_bi',30.00,63.00,55,'male','L2RaidBoss','Mystic',40,451391,156.000,2039,8.000,60,57,73,76,70,80,1707842,285150,1364,2576,435,1046,278,0,1972,195,0,0,53,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.46,'false',1,1),
(2152,25104,'Isirr''s Guard','Raid Fighter','zenta_lizardman_warrior',13.00,35.00,54,'male','L2Minion','Fighter',40,46232,52.480,987,7.200,40,43,30,41,20,10,0,0,2514,1252,1586,508,278,0,253,221,0,0,40,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.56,'false',1,0),
(2153,25105,'Isirr''s Guards','Raid Fighter','zenta_lizardman',11.00,32.00,54,'male','L2Minion','Fighter',40,23116,52.480,987,7.200,40,43,30,41,20,10,0,0,1257,1252,396,508,278,0,253,16,0,0,37,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.28,'false',1,0),
(2154,25106,'Ghost of the Well Lidia','Raid Boss','bloody_queen_100_bi',28.00,85.00,60,'female','L2RaidBoss','Mystic',40,526218,176.000,2570,9.000,60,57,73,76,70,80,2414839,561233,3581,3188,2006,1294,278,0,1972,0,0,0,80,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.50,'false',1,1),
(2155,25107,'Lidia''s Archer','Raid Fighter','skeleton_archer',11.00,27.00,59,'male','L2Minion','Ranger',500,36451,59.880,1251,8.100,40,43,30,41,20,10,0,0,9897,1554,3306,631,249,0,227,279,0,0,40,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.80,'false',1,0),
(2156,25108,'Lidia''s Fighter','Raid Fighter','death_blader',15.00,45.00,59,'male','L2Minion','Fighter',40,27202,59.880,1251,8.100,40,43,30,41,20,10,0,0,3340,1554,1859,631,278,0,253,1472,0,0,100,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.45,'false',1,0),
(2157,25109,'Antharas Priest Cloe','Raid Boss','succubus_100_bi',20.00,75.00,74,'female','L2RaidBoss','Priest',40,935092,416.000,3347,10.000,60,57,73,76,70,80,2212304,1028870,8715,4103,12471,1666,278,0,1972,0,0,0,60,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.84,'false',1,1),
(2158,25110,'Cloe''s Servitor','Raid Fighter','silhouette',8.00,23.00,73,'female','L2Minion','Fighter',40,65759,142.400,1637,9.000,40,43,30,41,20,10,0,0,11127,2008,21420,815,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.54,'false',1,0),
(2159,25111,'Cloe''s Servitor','Raid Fighter','shadow',10.00,30.00,73,'male','L2Minion','Mystic',40,98148,142.400,1637,9.000,40,43,30,41,20,10,0,0,16691,2008,48198,815,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.54,'false',1,0),
(2160,25112,'Agent of Beres,Meana','Raid Boss','medusa_100_bi',20.00,53.00,30,'female','L2RaidBoss','Fighter',40,127782,76.000,763,6.000,60,57,73,76,70,80,890100,105037,169,1127,26,458,278,0,1972,0,0,0,50,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.52,'false',1,1),
(2161,25113,'Meana''s Maid','Raid Fighter','succubus',10.00,36.00,29,'female','L2Minion','Mystic',40,8678,25.100,365,4.500,40,43,30,41,20,10,0,0,203,542,41,220,278,0,253,0,0,0,60,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.84,'false',1,0),
(2162,25114,'Meana''s Guard Doll','Raid Fighter','crimson_doll',15.00,38.00,29,'male','L2Minion','Fighter',40,12952,25.100,365,4.500,40,43,30,41,20,10,0,0,305,542,94,220,278,0,253,0,0,0,60,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.67,'false',1,0),
(2163,25115,'Icarus Sample 1','Raid Boss','mana_vampire_200_bi',33.00,51.00,40,'male','L2RaidBoss','Mystic',40,294846,198.000,1120,7.000,60,57,73,76,70,80,1910416,217891,520,1615,177,656,278,0,1972,0,0,0,90,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.39,'false',1,1),
(2164,25116,'Icarus Sample 2','Raid Fighter','skeleton_archer',11.00,27.00,39,'male','L2Minion','Ranger',500,19779,65.750,531,5.400,40,43,30,41,20,10,0,0,1417,780,290,317,249,0,227,273,0,0,40,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,0.80,'false',1,0),
(2165,25117,'Icarus Sample 3','Raid Fighter','magical_weaver',11.00,20.00,39,'male','L2Minion','Mystic',40,5984,65.750,531,5.400,40,43,30,41,20,10,0,0,478,780,163,317,278,0,253,0,0,0,90,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'false',1,0),
(2166,25118,'Guilotine, Warden of the Execution Grounds','Raid Boss','skeleton_pikeman_100_bi',20.00,58.00,35,'male','L2RaidBoss','Fighter',40,330579,91.000,1415,7.000,60,57,73,76,70,80,1193687,138419,601,1356,236,550,278,0,1972,96,0,0,50,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.21,'false',1,1),
(2167,25119,'Messenger of Fairy Queen Berun','Raid Boss','pan_100_bi',42.00,73.00,50,'male','L2RaidBoss','Fighter',40,507285,320.000,1722,8.000,60,57,73,76,70,80,1237500,455390,1918,2226,1530,904,278,0,1972,213,0,0,45,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.58,'false',1,1),
(2168,25120,'Berun''s Officer','Raid Fighter','pan',14.00,35.00,49,'male','L2Minion','Fighter',40,34424,106.800,830,6.300,40,43,30,41,20,10,0,0,2336,1079,2443,438,278,0,253,90,0,0,45,110,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.58,'false',1,0),
(2169,25121,'Berun''s Prattler','Raid Fighter','pixy',5.00,25.00,49,'female','L2Minion','Fighter',40,51380,106.800,830,6.300,40,43,30,41,20,10,0,0,3504,1079,5498,438,278,0,253,0,0,0,80,120,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.72,'false',1,0),
(2170,25122,'Refugee Hopeful Leo','Raid Boss','oel_mahum_witch_doctor_50_bi',22.50,54.00,56,'male','L2RaidBoss','Fighter',40,467209,160.000,2235,8.000,60,57,73,76,70,80,1722981,291015,1459,2649,476,1075,278,0,1972,201,0,0,70,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.26,'false',1,1),
(2171,25123,'Leo''s Servant','Raid Fighter','lesser_giant',21.00,44.00,55,'male','L2Minion','Fighter',40,47946,53.600,1084,7.200,40,43,30,41,20,10,0,0,2694,1288,1740,523,278,0,253,3937,0,0,15,180,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.58,'false',1,0),
(2172,25124,'Leo''s Steward','Raid Fighter','lesser_giant_mage',21.00,44.00,55,'male','L2Minion','Mystic',40,23973,53.600,1084,7.200,40,43,30,41,20,10,0,0,1347,1288,435,523,278,0,253,3938,0,0,15,180,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.56,'false',1,0),
(2173,25125,'Fierce Tiger King Angel','Raid Boss','saber_toothed_tiger_200_bi',72.00,87.00,65,'male','L2RaidBoss','Fighter',40,1637918,406.000,2707,9.000,60,57,73,76,70,80,1820975,806823,11761,3349,30166,1360,278,0,1972,0,0,0,60,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.45,'false',1,1),
(2174,25126,'Longhorn Golkonda','Raid Boss','minotaur_100_bi',42.00,94.00,79,'male','L2RaidBoss','Fighter',40,1974940,414.000,3718,10.000,60,57,73,76,70,80,2346616,1166150,20224,4530,59372,1839,278,0,3819,91,0,0,64,275,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.59,'false',1,1),
(2175,25127,'Langk Matriarch Rashkos','Raid Boss','virud_lizardman_matriarch_50_bi',19.00,57.00,24,'male','L2RaidBoss','Fighter',40,198734,60.000,763,6.000,60,57,73,76,70,80,723779,67853,134,892,27,362,278,0,1972,124,0,0,56,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.65,'false',1,1),
(2176,25128,'Vuku Grand Seer Gharmash','Raid Boss','batur_orc_shaman_100_bi',22.00,35.00,33,'male','L2RaidBoss','Priest',40,148507,85.000,860,6.000,60,57,73,76,70,80,984556,97626,174,1261,24,512,278,0,1972,195,0,0,50,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.30,'false',1,1),
(2177,25129,'Vuku Shaman','Raid Fighter','orc_shaman',9.00,22.00,32,'male','L2Minion','Priest',40,10036,28.030,414,5.400,40,43,30,41,20,10,0,0,213,607,39,246,278,0,253,7,0,0,45,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.26,'false',1,0),
(2178,25130,'Gharmash''s Pet Trimden','Raid Fighter','poison_spider',27.00,25.50,32,'male','L2Minion','Mystic',40,14980,28.030,414,5.400,40,43,30,41,20,10,0,0,320,607,89,246,278,0,253,0,0,0,60,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.65,'false',1,0),
(2179,25131,'Carnage Lord Gato','Raid Boss','oel_mahum_50_bi',30.00,57.00,50,'male','L2RaidBoss','Fighter',40,369009,140.000,1415,7.000,60,57,73,76,70,80,1670250,297042,1243,2226,429,904,278,0,1972,71,0,0,70,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.48,'false',1,1),
(2180,25132,'Gato''s Marksman','Raid Fighter','ol_mahum_archer',14.00,25.00,49,'male','L2Minion','Ranger',500,6112,46.770,677,6.300,40,43,30,41,20,10,0,0,3356,1079,682,438,249,0,227,273,0,0,50,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.93,'false',1,0),
(2181,25133,'Gato''s Troop Leader','Raid Fighter','ol_mahum_champion',14.00,27.00,49,'male','L2Minion','Fighter',40,4588,46.770,677,6.300,40,43,30,41,20,10,0,0,1132,1079,383,438,278,0,253,69,0,0,50,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.63,'false',1,0),
(2182,25134,'Leto Chief Talkin','Raid Boss','Zenta_Lizardman_Raid',30.00,37.50,40,'male','L2RaidBoss','Fighter',40,218810,106.000,1722,8.000,60,57,73,76,70,80,1279280,187517,427,1615,87,656,278,0,1972,221,0,0,53,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.46,'false',1,1),
(2183,25135,'Talkin''s Seer','Raid Fighter','virud_lizardman_shaman',10.00,29.00,39,'male','L2Minion','Priest',40,21961,35.410,830,6.300,40,43,30,41,20,10,0,0,393,780,80,317,278,0,253,7,0,0,43,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48,'false',1,0),
(2184,25136,'Talkin''s Bodyguard','Raid Fighter','zenta_lizardman_warrior',13.00,35.00,39,'male','L2Minion','Fighter',40,10980,35.410,830,6.300,40,43,30,41,20,10,0,0,393,780,80,317,278,0,253,16,0,0,40,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.56,'false',1,0),
(2185,25137,'Beleth''s Seer Sephia','Raid Boss','bloody_queen_100_bi',28.00,85.00,55,'female','L2RaidBoss','Mystic',40,451391,156.000,2039,8.000,60,57,73,76,70,80,2001376,387789,2034,2576,903,1046,278,0,1972,0,0,0,80,170,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.50,'false',1,1),
(2186,25138,'Soul Drinker','Raid Fighter','mana_vampire',11.00,20.00,54,'male','L2Minion','Mystic',40,7107,52.480,987,7.200,40,43,30,41,20,10,0,0,2500,1252,1464,508,278,0,253,0,0,0,90,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'false',1,0),
(2187,25139,'Sephia''s Salve','Raid Fighter','kaim_vanul',24.00,40.00,54,'male','L2Minion','Fighter',40,10671,52.480,987,7.200,40,43,30,41,20,10,0,0,3750,1252,3295,508,278,0,253,0,0,0,37,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.45,'false',1,0),
(2188,25140,'Hekaton Prime','Raid Boss','susceptor',20.00,35.00,65,'male','L2RaidBoss','Fighter',40,818959,330.000,2707,9.000,60,57,73,76,70,80,3674504,679343,4656,3349,4297,1360,278,0,1972,0,0,0,27,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.43,'false',1,1),
(2189,25141,'Hekaton Cottus','Raid Fighter','gamlin',11.00,32.00,64,'male','L2Minion','Fighter',40,85286,112.570,1319,8.100,40,43,30,41,20,10,0,0,8885,1634,16636,663,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.46,'false',1,0),
(2190,25142,'Hekaton Chires','Raid Fighter','lesser_giant',21.00,44.00,64,'male','L2Minion','Fighter',40,42643,112.570,1319,8.100,40,43,30,41,20,10,0,0,4442,1634,4159,663,278,0,253,3937,0,0,15,180,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,0.58,'false',1,0),
(2191,25143,'Fire of Wrath Shuriel','Raid Boss','angel',13.50,36.50,78,'male','L2RaidBoss','Fighter',40,977229,414.000,3718,10.000,60,57,73,76,70,80,2287584,1166150,10051,4503,14666,1828,278,0,1972,2500,0,0,30,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.52,'false',1,1),
(2192,25144,'Shuriel''s Oracle','Raid Fighter','oel_mahum_witch_doctor',15.00,34.00,78,'male','L2Minion','Fighter',40,103799,142.000,1859,9.000,40,43,30,41,20,10,0,0,9703,2222,14332,902,278,0,253,201,0,0,70,170,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,0,0.26,'false',1,0),
(2193,25145,'Shuriel''s Paladin','Raid Fighter','kel_mahum_champion',13.00,32.00,78,'male','L2Minion','Fighter',40,51899,142.000,1859,9.000,40,43,30,41,20,10,0,0,9703,2222,14332,902,278,0,253,147,0,0,50,170,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,0,0.56,'false',1,0),
(2194,25146,'Serpent Demon Bifrons','Raid Boss','serpent_slave_50_bi',25.00,72.00,21,'male','L2RaidBoss','Fighter',40,90169,45.000,485,5.000,60,57,73,76,70,80,578451,45688,42,789,3,320,278,0,1972,73,0,0,70,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.46,'false',1,1),
(2195,25147,'Assassin of Bifrons','Raid Fighter','virud_lizardman_scout',10.00,22.00,20,'male','L2Minion','Ranger',500,6241,14.890,227,4.500,40,43,30,41,20,10,0,0,90,378,3,153,249,0,227,2507,0,0,43,170,'',0,'Local','',0,0,0,7,30,4,20,1500,0,0.72,'false',1,0),
(2196,25148,'Butcher of Bifrons','Raid Fighter','virud_lizardman_warrior',12.00,30.00,20,'male','L2Minion','Fighter',40,4657,14.890,227,4.500,40,43,30,41,20,10,0,0,30,378,2,153,278,0,253,16,0,0,52,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.59,'false',1,0),
(2197,25149,'Zombie Lord Crowl','Raid Boss','zombie_100_bi',26.00,45.00,25,'male','L2RaidBoss','Fighter',40,103092,63.000,606,5.000,60,57,73,76,70,80,856025,92883,110,928,15,377,278,0,1972,0,0,0,15,15,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.43,'false',1,1),
(2198,25150,'Evil Spirit Archer','Raid Fighter','skeleton_archer',11.00,27.00,24,'male','L2Minion','Ranger',500,7071,20.600,287,4.500,40,43,30,41,20,10,0,0,296,446,25,181,249,0,227,14,0,0,40,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,0.80,'false',1,0),
(2199,25151,'Evil Spirit Warrior','Raid Fighter','skeleton',11.00,25.00,24,'male','L2Minion','Fighter',40,5277,20.600,287,4.500,40,43,30,41,20,10,0,0,100,446,14,181,278,0,253,946,0,0,60,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,0.30,'false',1,0),
(2200,25152,'Flame Lord Shadar','Raid Boss','dre_vanul_100_bi',28.00,75.00,35,'male','L2RaidBoss','Fighter',40,165289,91.000,927,6.000,60,57,73,76,70,80,1193687,138419,300,1356,59,550,278,0,1972,0,0,0,80,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.35,'false',1,1),
(2201,25153,'Claws of Shadar','Raid Fighter','imp',10.00,24.00,34,'male','L2Minion','Fighter',40,16632,30.060,446,5.400,40,43,30,41,20,10,0,0,554,654,220,265,278,0,253,0,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.34,'false',1,0),
(2202,25154,'Whip of Shadar','Raid Fighter','succubus',10.00,36.00,34,'female','L2Minion','Mystic',40,8316,30.060,446,5.400,40,43,30,41,20,10,0,0,277,654,55,265,278,0,253,0,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.84,'false',1,0),
(2203,25155,'Shaman King Selu','Raid Boss','batur_orc_overlord_100_bi',24.00,52.00,40,'male','L2RaidBoss','Fighter',40,294846,213.000,1120,7.000,60,57,73,76,70,80,2046864,230791,570,1615,234,656,278,0,1972,79,0,0,80,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.28,'false',1,1),
(2204,25156,'Fanatic Shaman','Raid Fighter','batur_orc_shaman',11.00,16.00,39,'male','L2Minion','Priest',40,19779,70.810,531,5.400,40,43,30,41,20,10,0,0,699,780,383,317,278,0,253,123,19,0,50,170,'',0,'Tigra','',0,20,304,7,30,4,20,0,0,0.30,'false',1,0),
(2205,25157,'Fanatic Soldier','Raid Fighter','batur_orc_warrior',10.00,20.00,39,'male','L2Minion','Fighter',40,29521,70.810,531,5.400,40,43,30,41,20,10,0,0,1048,780,862,317,278,0,253,7,0,0,80,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,0.30,'false',1,0),
(2206,25158,'King Tarlk','Raid Boss','king_bugbear_200_bi',45.00,126.00,48,'male','L2RaidBoss','Fighter',40,920790,247.000,1722,8.000,60,57,73,76,70,80,2448691,283783,2574,2094,2776,850,278,0,1972,160,0,0,55,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.28,'false',1,1),
(2207,25159,'Paniel the Unicorn','Raid Boss','unicorn',14.00,30.00,54,'male','L2RaidBoss','Fighter',40,435256,153.000,1975,8.000,60,57,73,76,70,80,1983647,381736,1898,2504,823,1017,278,0,1972,0,0,0,46,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.74,'false',1,1),
(2208,25160,'Rapini the Unicorn','Raid Fighter','unicorn_boxer',11.00,18.00,53,'male','L2Minion','Mystic',40,44492,51.350,955,7.200,40,43,30,41,20,10,0,0,1736,1216,740,494,278,0,253,0,0,0,27,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.71,'false',1,0),
(2209,25161,'Ririf the Unicorn','Raid Fighter','unicorn_mirage',13.00,17.50,53,'male','L2Minion','Mystic',40,22246,51.350,955,7.200,40,43,30,41,20,10,0,0,1736,1216,740,494,278,0,253,0,0,0,27,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,0.69,'false',1,0),
(2210,25162,'Giant Marpanak','Raid Boss','lesser_giant_100_bi',42.00,91.00,60,'male','L2RaidBoss','Fighter',40,1461912,320.000,2368,9.000,60,57,73,76,70,80,3123036,491139,7025,2951,11841,1198,278,0,1972,3937,0,0,15,180,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.58,'false',1,1),
(2211,25163,'Roaring Skylancer','Raid Boss','Drake_Raid',44.00,51.50,70,'male','L2RaidBoss','Fighter',40,888658,414.000,3058,10.000,60,57,73,76,70,80,1915900,918808,6981,3764,8986,1528,278,0,1972,0,0,0,70,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.84,'false',1,1),
(2212,25166,'Ikuntai','Raid Boss','skeleton_knight_50_bi',15.00,39.00,25,'male','L2RaidBoss','Fighter',40,134813,116.000,606,5.000,60,57,73,76,70,80,1278325,108133,133,928,31,377,278,0,1972,150,0,0,40,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.17,'false',1,1),
(2213,25167,'Ikuntai''s Servitor','Raid Fighter','silhouette',8.00,23.00,24,'female','L2Minion','Priest',40,13786,38.270,287,4.500,40,43,30,41,20,10,0,0,121,446,28,181,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.54,'false',1,0),
(2214,25168,'Pawn of Ikuntai','Raid Fighter','skeleton_pikeman',10.00,28.00,24,'male','L2Minion','Fighter',40,6893,38.270,287,4.500,40,43,30,41,20,10,0,0,121,446,28,181,278,0,253,299,0,0,50,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,0.21,'false',1,0),
(2215,25169,'Ragraman','Raid Boss','batur_orc_overlord_100_bi',24.00,52.00,30,'male','L2RaidBoss','Fighter',40,336732,141.000,763,6.000,60,57,73,76,70,80,1329219,122342,412,1127,212,458,278,0,1972,72,0,0,80,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.28,'false',1,1),
(2216,25170,'Lizardmen Leader Hellion','Raid Boss','zenta_lizardman_matriarch_50_bi',30.00,63.00,38,'male','L2RaidBoss','Fighter',40,195371,100.000,1028,6.000,60,57,73,76,70,80,1064286,131051,251,1508,36,612,278,0,1972,223,0,0,53,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.46,'false',1,1),
(2217,25171,'Hellion''s Archers','Raid Fighter','zenta_lizardman_scout',11.00,30.00,37,'male','L2Minion','Ranger',500,13142,33.230,497,5.400,40,43,30,41,20,10,0,0,686,728,60,295,249,0,227,278,0,0,37,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.93,'false',1,0),
(2218,25172,'Hellion''s Guards','Raid Fighter','zenta_lizardman_warrior',13.00,35.00,37,'male','L2Minion','Fighter',40,9807,33.230,497,5.400,40,43,30,41,20,10,0,0,231,728,34,295,278,0,253,291,0,0,40,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.56,'false',1,0),
(2219,25173,'Tiger King Karuta','Raid Boss','saber_toothed_tiger_200_bi',72.00,87.00,45,'male','L2RaidBoss','Fighter',40,288415,123.000,1415,7.000,60,57,73,76,70,80,1591877,230991,801,1905,231,774,278,0,1972,0,0,0,60,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.45,'false',1,1),
(2220,25174,'Karuta''s Follower','Raid Fighter','heltor_silenos_chieftain',13.00,31.50,44,'male','L2Minion','Fighter',40,7758,41.020,677,6.300,40,43,30,41,20,10,0,0,725,922,205,374,278,0,253,127,0,0,27,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.39,'false',1,0),
(2221,25175,'Karuta''s Inferiors','Raid Fighter','crimson_bear',19.00,36.00,44,'male','L2Minion','Fighter',40,3879,41.020,677,6.300,40,43,30,41,20,10,0,0,725,922,205,374,278,0,253,0,0,0,37,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.45,'false',1,0),
(2222,25176,'Black Lily','Raid Boss','Succubus_Raid',12.00,30.70,55,'female','L2RaidBoss','Mystic',40,451391,156.000,2039,8.000,60,57,73,76,70,80,1707842,285150,1364,2576,435,1046,278,0,1972,0,0,0,80,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.50,'false',1,1),
(2223,25177,'Guardian Knight of Black Lily','Raid Fighter','death_knight',12.00,30.00,54,'male','L2Minion','Fighter',40,46232,52.480,987,7.200,40,43,30,41,20,10,0,0,2514,1252,1586,508,278,0,253,75,0,0,27,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.71,'false',1,0),
(2224,25178,'Servitor of Black Lily','Raid Fighter','silhouette',8.00,23.00,54,'female','L2Minion','Fighter',40,23116,52.480,987,7.200,40,43,30,41,20,10,0,0,1257,1252,396,508,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.54,'false',1,0),
(2225,25179,'Guardian of the Statue of Giant Karum','Raid Boss','lesser_giant_50_bi',31.50,69.00,60,'male','L2RaidBoss','Fighter',40,526218,172.000,2368,9.000,60,57,73,76,70,80,2091330,424759,2895,2951,1474,1198,278,0,1972,3937,0,0,15,180,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.58,'false',1,1),
(2226,25180,'Karum''s Guard','Raid Fighter','lesser_giant_mage',21.00,44.00,59,'male','L2Minion','Mystic',40,36451,57.970,1150,7.200,40,43,30,41,20,10,0,0,3509,1437,2314,583,278,0,253,3938,0,0,15,180,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.56,'false',1,0),
(2227,25181,'Karum''s Warrior','Raid Fighter','susceptor',20.00,35.00,59,'male','L2Minion','Fighter',40,54404,57.970,1150,7.200,40,43,30,41,20,10,0,0,5263,1437,5208,583,278,0,253,0,0,0,27,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.43,'false',1,0),
(2228,25182,'Demon Kurikups','Raid Boss','karik_100_bi',50.00,180.00,65,'male','L2RaidBoss','Fighter',40,512194,178.000,2707,9.000,60,57,73,76,70,80,2460640,581209,3838,3349,2140,1360,278,0,1972,0,0,0,37,200,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.45,'false',1,1),
(2229,25183,'Kurikups'' Wife','Raid Fighter','bloody_queen',14.00,40.00,64,'female','L2Minion','Mystic',40,13187,60.610,1319,8.100,40,43,30,41,20,10,0,0,3661,1634,2071,663,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.50,'false',1,0),
(2230,25184,'Devil Blader of Chaos','Raid Fighter','death_blader',15.00,45.00,64,'male','L2Minion','Fighter',40,6593,60.610,1319,8.100,40,43,30,41,20,10,0,0,3661,1634,2071,663,278,0,253,1472,0,0,100,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.45,'false',1,0),
(2231,25185,'Tasaba Patriarch Hellena','Raid Boss','zenta_lizardman_matriarch',20.00,40.00,35,'male','L2RaidBoss','Fighter',40,165289,91.000,927,6.000,60,57,73,76,70,80,1193687,138419,300,1356,59,550,278,0,1972,225,0,0,53,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.46,'false',1,1),
(2232,25186,'Hellena''s Marksman','Raid Fighter','zenta_lizardman_scout',11.00,30.00,34,'male','L2Minion','Ranger',500,11143,30.060,446,5.400,40,43,30,41,20,10,0,0,821,654,97,265,249,0,227,272,0,0,37,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.93,'false',1,0),
(2233,25187,'Helena''s Soldier','Raid Fighter','zenta_lizardman_warrior',13.00,35.00,34,'male','L2Minion','Fighter',40,8316,30.060,446,5.400,40,43,30,41,20,10,0,0,277,654,55,265,278,0,253,16,0,0,40,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.56,'false',1,0),
(2234,25188,'Apepi','Raid Boss','lienrik',12.00,50.00,30,'male','L2RaidBoss','Fighter',40,255564,76.000,763,6.000,60,57,73,76,70,80,759553,78807,227,1127,50,458,278,0,1972,0,0,0,100,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.46,'false',1,1),
(2235,25189,'Cronos''s Servitor Mumu','Raid Boss','cutie_cat',8.00,15.00,34,'female','L2RaidBoss','Fighter',40,156584,88.000,893,6.000,60,57,73,76,70,80,1001975,100648,187,1308,26,931,278,0,1972,0,0,0,48,170,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.34,'false',1,1),
(2236,25190,'Mumu''s Wizard','Raid Fighter','cutie_cat',8.00,15.00,33,'female','L2Minion','Mystic',40,3355,29.040,430,5.400,40,43,30,41,20,10,0,0,229,630,43,256,278,0,253,0,0,0,48,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.34,'false',1,0),
(2237,25191,'Mumu''s Warrior','Raid Fighter','cat_the_cat',9.00,16.00,33,'male','L2Minion','Fighter',40,5037,29.040,430,5.400,40,43,30,41,20,10,0,0,344,630,97,256,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.61,'false',1,0),
(2238,25192,'Earth Protector Panathen','Raid Boss','farhite',16.00,31.00,43,'male','L2RaidBoss','Fighter',40,258849,116.000,1296,7.000,60,57,73,76,70,80,1557899,221896,673,1785,182,725,278,0,1972,183,0,0,15,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.74,'false',1,1),
(2239,25193,'Panathen''s Knight','Raid Fighter','nos',26.00,42.00,42,'male','L2Minion','Fighter',40,7218,38.750,618,6.300,40,43,30,41,20,10,0,0,1213,864,644,350,278,0,253,5130,0,0,18,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.78,'false',1,0),
(2240,25194,'Panathen''s Protectors','Raid Fighter','dailaon',20.00,28.00,42,'male','L2Minion','Fighter',500,13005,38.750,618,6.300,40,43,30,41,20,10,0,0,606,864,161,350,278,0,253,5127,0,0,18,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.91,'false',1,0),
(2241,25198,'Fafurion''s Herald Lokness','Raid Boss','devastator_200_bi',100.00,105.00,70,'male','L2RaidBoss','Fighter',40,1777317,414.000,2639,9.000,60,57,73,76,70,80,1915900,918808,13963,3764,35947,1528,278,0,1972,0,0,0,70,170,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.84,'false',1,1),
(2242,25199,'Water Dragon Seer Sheshark','Raid Boss','kaim_vanul',24.00,40.00,72,'male','L2RaidBoss','Fighter',40,912634,363.000,2707,9.000,60,57,73,76,70,80,4674309,805512,7164,3933,8915,1597,278,0,1972,181,0,0,43,200,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.48,'false',1,1),
(2243,25200,'Family of Sheshark','Raid Fighter','hunter_gargoyle',25.00,65.00,71,'male','L2Minion','Fighter',40,64111,124.420,1319,8.100,40,43,30,41,20,10,0,0,9147,1924,15345,781,278,0,253,0,0,0,100,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.46,'false',1,0),
(2244,25201,'Guard of Sheshark','Raid Fighter','serpent_slave',17.00,46.00,71,'male','L2Minion','Fighter',40,95688,124.420,1319,8.100,40,43,30,41,20,10,0,0,13720,1924,34528,781,278,0,253,6370,0,0,52,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,0.59,'false',1,0),
(2245,25202,'Krokian Padisha Sobekk','Raid Boss','ant_soldier_200_bi',75.00,54.00,74,'male','L2RaidBoss','Fighter',40,935092,416.000,2777,9.000,60,57,73,76,70,80,2212304,1028870,8715,4103,12471,1666,278,0,1972,5130,0,0,18,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.78,'false',1,1),
(2246,25203,'Parhit Padisha Sobekk','Raid Fighter','aracne',15.00,26.00,73,'male','L2Minion','Fighter',40,98148,142.400,1353,8.100,40,43,30,41,20,10,0,0,8345,2008,12049,815,278,0,253,5131,0,0,15,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.74,'false',1,0),
(2247,25204,'Krokian Padisha Sobekk','Raid Fighter','vampire_bat',10.00,33.50,73,'male','L2Minion','Mystic',40,49074,142.400,1353,8.100,40,43,30,41,20,10,0,0,8345,2008,12049,815,278,0,253,5128,0,0,18,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.78,'false',1,0),
(2248,25205,'Ocean Flame Ashakiel','Raid Boss','saber_toothed_tiger_200_bi',72.00,87.00,76,'male','L2RaidBoss','Fighter',40,956490,364.000,3274,10.000,60,57,73,76,70,80,4888056,961047,8153,4273,10359,1735,278,0,1972,98,0,0,50,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.76,'false',1,1),
(2249,25206,'Ashakiel''s Blade','Raid Fighter','dark_fencer_200_bi',30.00,43.00,75,'female','L2Minion','Fighter',40,100472,124.790,1601,9.000,40,43,30,41,20,10,0,0,15569,2094,39730,850,278,0,253,6717,0,0,50,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.46,'false',1,0),
(2250,25207,'Ashakiel''s Rod','Raid Fighter','unicorn',14.00,30.00,75,'male','L2Minion','Mystic',40,50236,124.790,1601,9.000,40,43,30,41,20,10,0,0,7784,2094,9932,850,278,0,253,6718,0,0,50,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48,'false',1,0),
(2251,25208,'Water Couatle Ateka','Raid Boss','lienrik',12.00,50.00,40,'male','L2RaidBoss','Fighter',40,218810,106.000,1722,8.000,60,57,73,76,70,80,1279280,187517,427,1615,87,656,278,0,1972,0,0,0,100,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.46,'false',1,1),
(2252,25209,'Ateka''s Shaman','Raid Fighter','lienrik',12.00,50.00,39,'male','L2Minion','Priest',40,14713,35.410,830,6.300,40,43,30,41,20,10,0,0,524,780,143,317,278,0,253,0,0,0,100,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.46,'false',1,0),
(2253,25210,'Ateka''s Grunt','Raid Fighter','lienrik',12.00,50.00,39,'male','L2Minion','Fighter',40,21961,35.410,830,6.300,40,43,30,41,20,10,0,0,786,780,323,317,278,0,253,0,0,0,100,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.46,'false',1,0),
(2254,25211,'Sebek','Raid Boss','nos',26.00,42.00,36,'male','L2RaidBoss','Fighter',40,174646,94.000,1975,8.000,60,57,73,76,70,80,1212311,142855,326,1405,65,570,278,0,1972,5130,0,0,18,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.78,'false',1,1),
(2255,25212,'Sebek''s Priest','Raid Fighter','zenta_lizardman_scout',11.00,30.00,35,'male','L2Minion','Priest',500,11763,31.100,955,7.200,40,43,30,41,20,10,0,0,879,678,105,275,249,0,227,279,0,0,37,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.93,'false',1,0),
(2256,25213,'Sebek''s Fanatic','Raid Fighter','dailaon',20.00,28.00,35,'male','L2Minion','Fighter',500,8778,31.100,955,7.200,40,43,30,41,20,10,0,0,296,678,59,275,278,0,253,5127,0,0,18,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.91,'false',1,0),
(2257,25214,'Fafurion''s Page Sika','Raid Boss','water_giant',13.00,44.00,40,'male','L2RaidBoss','Fighter',80,218810,106.000,2368,9.000,60,57,73,76,70,80,1091654,139773,287,1615,42,656,278,0,1972,5132,0,0,35,170,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.45,'false',1,1),
(2258,25215,'Sika''s Wizard','Raid Fighter','undine',12.00,27.00,39,'female','L2Minion','Mystic',40,14713,35.410,1150,7.200,40,43,30,41,20,10,0,0,353,780,69,317,278,0,253,0,0,0,60,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.35,'false',1,0),
(2259,25216,'Sika''s Fighter','Raid Fighter','undine',12.00,27.00,39,'female','L2Minion','Mystic',40,21961,35.410,1150,7.200,40,43,30,41,20,10,0,0,530,780,157,317,278,0,253,0,0,0,60,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.35,'false',1,0),
(2260,25217,'Cursed Clara','Raid Boss','medusa',10.00,25.00,50,'female','L2RaidBoss','Fighter',40,369009,140.000,1722,8.000,60,57,73,76,70,80,1425270,224177,833,2226,206,904,278,0,1972,0,0,0,50,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.52,'false',1,1),
(2261,25218,'Clara''s Marksman','Raid Fighter','virud_lizardman_scout',10.00,22.00,49,'male','L2Minion','Ranger',500,6112,46.770,830,6.300,40,43,30,41,20,10,0,0,2250,1079,328,438,249,0,227,2507,0,0,43,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.72,'false',1,0),
(2262,25219,'Clara''s Pawn','Raid Fighter','virud_lizardman_warrior',12.00,30.00,49,'male','L2Minion','Fighter',40,4588,46.770,830,6.300,40,43,30,41,20,10,0,0,759,1079,184,438,278,0,253,94,0,0,52,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.59,'false',1,0),
(2263,25220,'Death Lord Hallate','Raid Boss','death_lord',21.00,40.00,73,'male','L2RaidBoss','Fighter',40,924022,415.000,3274,10.000,60,57,73,76,70,80,2190219,1002134,8449,4017,12049,1631,278,0,1972,78,0,0,40,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.50,'false',1,1),
(2264,25221,'Death Mage Krician','Raid Fighter','death_blader',15.00,45.00,72,'male','L2Minion','Fighter',40,64948,142.400,1601,9.000,40,43,30,41,20,10,0,0,10780,1966,20691,798,278,0,253,1472,0,0,100,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.45,'false',1,0),
(2265,25222,'Death Fighter Harik','Raid Fighter','death_knight',12.00,30.00,72,'male','L2Minion','Fighter',40,96938,142.400,1601,9.000,40,43,30,41,20,10,0,0,16170,1966,46558,798,278,0,253,75,0,0,27,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.71,'false',1,0),
(2266,25223,'Soul Collector Acheron','Raid Boss','vale_master_50_bi',18.00,63.00,35,'male','L2RaidBoss','Fighter',40,165289,91.000,1237,7.000,60,57,73,76,70,80,1018607,103175,200,1356,28,550,278,0,1972,192,0,0,70,160,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.74,'false',1,1),
(2267,25224,'Soul Slasher','Raid Fighter','dark_horror',20.00,35.00,34,'male','L2Minion','Fighter',40,11143,30.060,589,6.300,40,43,30,41,20,10,0,0,246,654,46,265,278,0,253,0,0,0,100,140,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.37,'false',1,0),
(2268,25225,'Soul Strainer','Raid Fighter','hungry_spirit',13.00,40.00,34,'male','L2Minion','Fighter',40,16632,30.060,531,5.400,40,43,30,41,20,10,0,0,369,654,104,265,278,0,253,0,0,0,15,155,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.45,'false',1,0),
(2269,25226,'Roaring Lord Kastor','Raid Boss','oel_mahum_witch_doctor_50_bi',22.50,54.00,62,'male','L2RaidBoss','Fighter',40,768537,349.000,2502,9.000,60,57,73,76,70,80,3828086,679088,4510,3108,4959,1262,278,0,1972,186,0,0,70,180,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.26,'false',1,1),
(2270,25227,'Kastor''s Seer','Raid Fighter','oel_mahum_witch_doctor',15.00,34.00,61,'male','L2Minion','Fighter',40,79678,118.930,1217,8.100,40,43,30,41,20,10,0,0,4297,1515,4800,615,278,0,253,9,0,0,70,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.26,'false',1,0),
(2271,25228,'Kastor''s Prefect','Raid Fighter','oel_mahum_warrior',20.00,38.00,61,'male','L2Minion','Fighter',40,39839,118.930,1217,8.100,40,43,30,41,20,10,0,0,4297,1515,4800,615,278,0,253,79,0,0,70,190,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.65,'false',1,0),
(2272,25229,'Storm Winged Naga','Raid Boss','wyrm_50_bi',58.00,108.00,75,'male','L2RaidBoss','Fighter',40,1891801,416.000,3420,10.000,60,57,73,76,70,80,2238750,1054472,17973,4188,51648,1701,278,0,1972,0,0,0,70,200,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.19,'false',1,1),
(2273,25230,'Timak Seer Ragoth','Raid Boss','batur_orc_shaman_50_bi',16.00,25.00,57,'male','L2RaidBoss','Priest',40,482650,163.000,2169,8.000,60,57,73,76,70,80,2036961,401639,2325,2723,1079,1106,278,0,1972,201,0,0,50,160,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.30,'false',1,1),
(2274,25231,'Ragoth''s Guard','Raid Fighter','batur_orc_warrior',10.00,20.00,56,'male','L2Minion','Fighter',40,49626,54.710,1052,7.200,40,43,30,41,20,10,0,0,4299,1324,3954,537,278,0,253,74,657,0,80,175,NULL,0,'Tigra',NULL,0,20,456,7,30,4,20,0,0,0.30,'false',1,0),
(2275,25232,'Ragoth''s Herald','Raid Fighter','batur_orc',9.00,21.50,56,'male','L2Minion','Fighter',40,24813,54.710,1052,7.200,40,43,30,41,20,10,0,0,2149,1324,988,537,278,0,253,74,0,0,80,165,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.46,'false',1,0),
(2276,25233,'Spirit of Andras,the Betrayer','Raid Boss','headless_knight_50_bi',30.00,46.50,69,'male','L2RaidBoss','Fighter',40,1256671,181.000,3643,10.000,60,57,73,76,70,80,2558623,621496,8956,3680,10177,1494,278,0,1972,2500,0,0,70,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.52,'false',1,1),
(2277,25234,'Ancient Weird Drake','Raid Boss','drake_50_bi',45.00,150.00,60,'male','L2RaidBoss','Fighter',40,1052436,178.000,2707,9.000,60,57,73,76,70,80,2460640,581209,7676,3349,8563,1360,278,0,1972,0,0,0,70,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.84,'false',1,1),
(2278,25235,'Vanor Chief Kandra','Raid Boss','heltor_silenos_50_bi',19.00,43.50,72,'male','L2RaidBoss','Fighter',40,912634,415.000,3202,10.000,60,57,73,76,70,80,2161728,977072,8186,3933,11639,1597,278,0,1972,135,0,0,34,180,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.46,'false',1,1),
(2279,25236,'Kandra''s Healer','Raid Fighter','heltor_silenos_shaman',13.00,32.00,71,'male','L2Minion','Priest',40,95688,142.000,1565,9.000,40,43,30,41,20,10,0,0,7829,1924,11244,781,278,0,253,200,0,0,29,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.22,'false',1,0),
(2280,25237,'Kandra''s Guard','Raid Fighter','heltor_silenos_warrior',13.00,31.00,71,'male','L2Minion','Fighter',40,47844,142.000,1565,9.000,40,43,30,41,20,10,0,0,7829,1924,11244,781,278,0,253,228,0,0,36,190,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.39,'false',1,0),
(2281,25238,'Abyss Brukunt','Raid Boss','drake_50_bi',45.00,150.00,59,'male','L2RaidBoss','Fighter',40,512194,179.000,2846,9.000,60,57,73,76,70,80,2508399,600107,4130,3513,2312,1427,278,0,1972,0,0,0,70,185,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.84,'false',1,1),
(2282,25239,'Monstrous Beast of Abyss Brukunt','Raid Fighter','hunter_gargoyle',25.00,65.00,58,'male','L2Minion','Priest',40,52860,61.230,1388,8.100,40,43,30,41,20,10,0,0,3923,1715,2213,696,278,0,253,0,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.34,'false',1,0),
(2283,25240,'Wild Beast of Abyss Brukunt','Raid Fighter','saber_toothed_tiger',34.00,28.00,58,'male','L2Minion','Fighter',40,26430,61.230,1388,8.100,40,43,30,41,20,10,0,0,3923,1715,2213,696,278,0,253,0,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.45,'false',1,0),
(2284,25241,'Harit Hero Tamash','Raid Boss','zenta_lizardman_warrior_50_bi',18.00,53.00,55,'male','L2RaidBoss','Fighter',40,624464,290.000,2639,9.000,60,57,73,76,70,80,2988757,448385,2471,2576,1817,1046,278,0,1972,298,0,0,40,175,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.56,'false',1,1),
(2285,25242,'Tamash''s Advisor','Raid Fighter','zenta_lizardman_shaman',13.00,35.00,54,'male','L2Minion','Priest',40,13199,97.460,1285,8.100,40,43,30,41,20,10,0,0,3036,1252,2944,508,278,0,253,193,0,0,43,155,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.63,'false',1,0),
(2286,25243,'Tamash''s Servant','Raid Fighter','zenta_lizardman',11.00,32.00,54,'male','L2Minion','Fighter',40,19818,97.460,1285,8.100,40,43,30,41,20,10,0,0,4554,1252,6625,508,278,0,253,234,0,0,37,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.28,'false',1,0),
(2287,25244,'Last Lesser Giant Olkuth','Raid Boss','lesser_giant_50_bi',31.50,69.00,75,'male','L2RaidBoss','Fighter',40,1891801,364.000,3420,10.000,60,57,73,76,70,80,4832156,847950,15764,4188,39730,1701,278,0,1972,78,0,0,15,140,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.58,'false',1,1),
(2288,25245,'Last Lesser Giant Glaki','Raid Boss','lesser_giant_mage_50_bi',30.00,66.00,78,'male','L2RaidBoss','Mystic',40,977229,337.000,3643,10.000,60,57,73,76,70,80,4671563,943547,7940,4444,8508,1805,278,0,1972,179,0,0,15,95,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.56,'false',1,1),
(2289,25246,'Glaki''s Henchman','Raid Fighter','lesser_giant',21.00,44.00,77,'male','L2Minion','Fighter',40,102704,115.680,1784,9.000,40,43,30,41,20,10,0,0,15250,2179,32949,885,278,0,253,169,0,0,15,150,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.58,'false',1,0),
(2290,25247,'Glaki''s Servant','Raid Fighter','lesser_giant',21.00,44.00,77,'male','L2Minion','Fighter',40,51352,115.680,1784,9.000,40,43,30,41,20,10,0,0,7625,2179,8237,885,278,0,253,166,0,0,15,140,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.58,'false',1,0),
(2291,25248,'Doom Blade Tanatos','Raid Boss','death_blader_bi',15.00,32.50,72,'male','L2RaidBoss','Fighter',40,1825269,337.000,3274,10.000,60,57,73,76,70,80,4362668,764172,13026,3933,26791,1597,278,0,1972,0,0,0,100,180,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.45,'false',1,1),
(2292,25249,'Palatanos of Horrific Power','Raid Boss','Jungle_Bleeze',60.00,47.00,75,'male','L2RaidBoss','Fighter',40,945900,364.000,3420,10.000,60,57,73,76,70,80,4832156,847950,7882,4188,9932,1701,278,0,1972,0,0,0,55,165,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.48,'false',1,1),
(2293,25250,'Man-Eating Plant of Palatanos','Raid Fighter','magical_weaver',11.00,20.00,74,'male','L2Minion','Mystic',40,66547,124.800,1673,9.000,40,43,30,41,20,10,0,0,10072,2051,17077,833,278,0,253,0,0,0,90,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'false',1,0),
(2294,25251,'Sapling of Palatanos','Raid Fighter','skeleton_knight',10.00,25.00,74,'male','L2Minion','Fighter',40,99324,124.800,1673,9.000,40,43,30,41,20,10,0,0,15109,2051,38427,833,278,0,253,145,629,0,40,175,'',0,'Local','',0,20,629,7,30,4,20,0,0,0.17,'false',1,0),
(2295,25252,'Palibati Queen Themis','Raid Boss','cave_maiden_50_bi',37.00,98.00,70,'female','L2RaidBoss','Fighter',40,888658,362.000,3058,10.000,60,57,73,76,70,80,4135551,777993,6222,3764,7141,1528,278,0,1972,234,0,0,70,160,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.43,'false',1,1),
(2296,25253,'Handmaiden of Themis','Raid Fighter','succubus',10.00,36.00,69,'female','L2Minion','Mystic',40,62338,123.830,1493,8.100,40,43,30,41,20,10,0,0,7862,1840,12062,747,278,0,253,0,0,0,60,150,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.84,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(2297,25254,'Themis''s Sentinel','Raid Fighter','death_blader',15.00,45.00,69,'male','L2Minion','Fighter',40,93041,123.830,1493,8.100,40,43,30,41,20,10,0,0,11794,1840,27141,747,278,0,253,1472,0,0,100,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.45,'false',1,0),
(2298,25255,'Gargoyle Lord Tiphon','Raid Boss','hunter_gargoyle_50_bi',37.00,98.00,65,'male','L2RaidBoss','Fighter',40,1637918,330.000,2707,9.000,60,57,73,76,70,80,3674504,679343,9313,3349,17189,1360,278,0,1972,0,0,0,100,180,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.37,'false',1,1),
(2299,25256,'Taik High Prefect Arak','Raid Boss','ketra_orc_warrior_50_bi',18.00,37.00,60,'male','L2RaidBoss','Fighter',40,526218,172.000,2368,9.000,60,57,73,76,70,80,2091330,424759,2895,2951,1474,1198,278,0,1972,71,0,0,36,175,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.54,'false',1,1),
(2300,25257,'Arak''s Archer','Raid Fighter','ketra_orc_archer',12.00,27.00,59,'male','L2Minion','Ranger',500,36451,57.970,1150,7.200,40,43,30,41,20,10,0,0,7797,1437,2314,583,249,0,227,283,0,0,45,160,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,0.91,'false',1,0),
(2301,25258,'Arak''s Footman','Raid Fighter','ketra_orc',12.00,29.00,59,'male','L2Minion','Fighter',40,27202,57.970,1150,7.200,40,43,30,41,20,10,0,0,2632,1437,1302,583,278,0,253,127,0,0,45,175,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.46,'false',1,0),
(2302,25259,'Zaken''s Butcher Krantz','Raid Boss','ogre_50_bi',30.00,66.00,55,'male','L2RaidBoss','Fighter',40,1248928,290.000,2039,8.000,60,57,73,76,70,80,2988757,448385,4942,2576,7268,1046,278,0,1972,297,0,0,22,160,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.82,'false',1,1),
(2303,25260,'Iron Giant Totem','Raid Boss','iron_golem_bi',27.00,52.00,45,'male','L2RaidBoss','Mystic',40,392985,228.000,1722,8.000,60,57,73,76,70,80,2377188,267898,974,1905,466,774,278,0,1972,0,0,0,20,50,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.41,'false',1,1),
(2304,25261,'Totem Guard Archer','Raid Fighter','batur_orc_archer',11.00,21.50,44,'male','L2Minion','Ranger',500,26454,76.180,830,6.300,40,43,30,41,20,10,0,0,2613,922,736,374,249,0,227,282,0,0,45,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,0.96,'false',1,0),
(2305,25262,'Totem Guard','Raid Fighter','batur_orc',9.00,21.50,44,'male','L2Minion','Fighter',40,19741,76.180,830,6.300,40,43,30,41,20,10,0,0,882,922,414,374,278,0,253,215,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.46,'false',1,0),
(2306,25263,'Kernon''s Faithful Servant Kelone','Raid Boss','medusa_100_bi',20.00,53.00,67,'female','L2RaidBoss','Mystic',40,848789,333.000,2846,9.000,60,57,73,76,70,80,3745918,701317,5015,3513,4648,1427,278,0,1972,225,0,0,70,165,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.43,'false',1,1),
(2307,25264,'Kelone''s Assassin','Raid Fighter','skeleton_royal_guard',11.00,28.50,66,'male','L2Minion','Fighter',40,59369,113.710,1388,8.100,40,43,30,41,20,10,0,0,6346,1715,7898,696,278,0,253,229,0,0,80,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.52,'false',1,0),
(2308,25265,'Kelone''s Secret Knight','Raid Fighter','drake',11.00,28.00,66,'male','L2Minion','Mystic',40,88610,113.710,1388,8.100,40,43,30,41,20,10,0,0,9520,1715,17773,696,278,0,253,0,0,0,70,180,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.84,'false',1,0),
(2309,25266,'Bloody Empress Decarbia','Raid Boss','bloody_queen_50_bi',21.00,64.00,75,'female','L2RaidBoss','Mystic',40,945900,416.000,3420,10.000,60,57,73,76,70,80,2238750,1054472,8986,4188,12912,1701,278,0,1972,0,0,0,80,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.50,'false',1,1),
(2310,25267,'Decarbia''s Royal Guard','Raid Fighter','death_knight',12.00,30.00,74,'male','L2Minion','Fighter',40,49662,142.800,1673,9.000,40,43,30,41,20,10,0,0,8608,2051,12471,833,278,0,253,5286,0,0,27,200,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.71,'false',1,0),
(2311,25268,'Decarbia''s Escort','Raid Fighter','skeleton_royal_guard',11.00,28.50,74,'male','L2Minion','Fighter',40,99324,142.800,1673,9.000,40,43,30,41,20,10,0,0,17216,2051,49884,833,278,0,253,234,0,0,80,210,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,0.52,'false',1,0),
(2312,25269,'Beast Lord Behemoth','Raid Boss','Elder_Troll',46.00,71.50,70,'male','L2RaidBoss','Fighter',40,888658,362.000,3058,10.000,60,57,73,76,70,80,4135551,777993,6222,3764,7141,1528,278,0,1972,0,0,0,55,180,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.61,'false',1,1),
(2313,25270,'Behemoth Javeliner','Raid Fighter','virud_lizardman_scout',10.00,22.00,69,'male','L2Minion','Ranger',500,62338,123.830,1493,8.100,40,43,30,41,20,10,0,0,17470,1840,12062,747,249,0,227,2507,0,0,43,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,0.72,'false',1,0),
(2314,25271,'Behemoth Flare','Raid Fighter','will_o_wisp',13.00,22.00,69,'male','L2Minion','Mystic',40,46520,123.830,1493,8.100,40,43,30,41,20,10,0,0,5897,1840,6785,747,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.10,'false',1,0),
(2315,25272,'Partisan Leader Talakin','Raid Boss','ol_mahum_champion_50_bi',21.00,43.50,28,'male','L2RaidBoss','Fighter',40,233163,70.000,1415,7.000,60,57,73,76,70,80,879287,99579,286,1044,86,424,278,0,1972,77,0,0,50,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.63,'false',1,1),
(2316,25273,'Carnamakos','Raid Boss','iron_golem_bi',27.00,52.00,56,'male','L2RaidBoss','Mystic',40,507285,319.000,2104,8.000,60,57,73,76,70,80,3230613,486967,2902,2649,2636,1075,278,0,1972,0,0,0,20,50,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.41,'false',0,1),
(2317,25274,'Carnabarun','Raid Fighter','magical_weaver',11.00,20.00,55,'male','L2Minion','Mystic',40,34424,107.200,1019,7.200,40,43,30,41,20,10,0,0,3572,1288,4283,523,278,0,253,0,0,0,90,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'false',0,0),
(2318,25275,'Carnassiud','Raid Fighter','field_stalker',15.00,30.00,55,'male','L2Minion','Fighter',40,51380,107.200,1019,7.200,40,43,30,41,20,10,0,0,5359,1288,9639,523,278,0,253,0,0,0,70,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,0.41,'false',0,0),
(2319,25276,'Death Lord Ipos','Raid Boss','death_lord_50_bi',31.00,61.50,75,'male','L2RaidBoss','Fighter',40,1891801,416.000,3420,10.000,60,57,73,76,70,80,2238750,1054472,17973,4188,51648,1701,278,0,1972,78,0,0,40,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.50,'false',1,1),
(2320,25277,'Lilith''s Witch Marilion','Raid Boss','bloody_queen_50_bi',21.00,64.00,50,'female','L2RaidBoss','Mystic',40,507285,279.000,1722,8.000,60,57,73,76,70,80,2672375,365590,1658,2226,1143,904,278,0,1972,0,0,0,80,190,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.50,'false',1,1),
(2321,25278,'Dead Soul of Stigma','Raid Fighter','mana_vampire',11.00,20.00,49,'male','L2Minion','Mystic',40,51380,93.540,830,6.300,40,43,30,41,20,10,0,0,1510,1079,1023,438,278,0,253,0,0,0,90,180,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'false',0,0),
(2322,25279,'Evil Spirit of Stigma','Raid Fighter','magical_weaver',11.00,20.00,49,'male','L2Minion','Mystic',40,25690,93.540,830,6.300,40,43,30,41,20,10,0,0,1510,1079,1023,438,278,0,253,0,0,0,90,180,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'false',0,0),
(2323,25280,'Pagan Watcher Cerberon','Raid Boss','kel_mahum_champion_50_bi',19.00,48.00,55,'male','L2RaidBoss','Fighter',40,1248928,313.000,2039,8.000,60,57,73,76,70,80,3202235,477279,5426,2576,9639,1046,278,0,1972,75,0,0,50,210,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.56,'false',1,1),
(2324,25281,'Anakim''s Nemesis Zakaron','Raid Boss','karik_50_bi',37.00,136.50,70,'male','L2RaidBoss','Fighter',40,1777317,362.000,3058,10.000,60,57,73,76,70,80,4135551,777993,12444,3764,28565,1528,278,0,1972,0,0,0,37,215,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.45,'false',1,1),
(2325,25282,'Death Lord Shax','Raid Boss','death_lord_50_bi',31.00,61.50,75,'male','L2RaidBoss','Fighter',40,1891801,416.000,3420,10.000,60,57,73,76,70,80,2238750,1054472,17973,4188,51648,1701,278,0,1972,2500,0,0,40,210,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.50,'false',1,1),
(2326,25283,'Lilith','Raid Boss','lilith',42.50,55.00,80,'female','L2RaidBoss','Fighter',40,1639146,413.000,3793,10.000,60,57,73,76,70,80,2374400,1196456,10404,4615,15367,1874,278,0,3819,0,0,0,45,200,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.50,'false',0,1),
(2327,25284,'Lilith''s Agent','Raid Fighter','lilim_wizard',9.00,34.00,79,'female','L2Minion','Mystic',40,115440,142.000,1859,9.000,40,43,30,41,20,10,0,0,2316,2265,5386,919,278,0,353,0,0,0,50,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.50,'false',0,0),
(2328,25285,'Lilith''s Escort','Raid Fighter','lilim_knight',12.00,50.00,79,'male','L2Minion','Fighter',40,172299,142.000,1859,9.000,40,43,30,41,20,10,0,0,19974,2265,59372,919,338,0,253,5800,5799,0,56,220,NULL,0,'Local',NULL,0,20,674,7,30,4,20,0,0,0.46,'false',0,0),
(2329,25286,'Anakim','Raid Boss','anakim',15.50,29.00,80,'female','L2RaidBoss','Fighter',40,1639146,413.000,3793,10.000,60,57,73,76,70,80,2374400,1196456,10404,4615,15367,1874,278,0,3819,0,0,0,45,200,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.56,'false',0,1),
(2330,25287,'Anakim''s Guardian','Raid Fighter','nephilim_priest',23.00,40.50,79,'male','L2Minion','Priest',40,172299,142.000,1859,9.000,40,43,30,41,20,10,0,0,3987,2265,4703,919,378,0,253,0,0,0,50,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48,'false',0,0),
(2331,25288,'Anakim''s Royal Guard','Raid Fighter','nephilim_lord',10.00,41.50,79,'male','L2Minion','Fighter',40,86149,142.000,1859,9.000,40,43,30,41,20,10,0,0,3987,2265,4703,919,378,0,253,0,0,0,65,220,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.63,'false',0,0),
(2332,25289,'Anakim''s Executor','','nephilim_slayer',12.00,36.00,79,'male','L2Monster','Fighter',40,86149,142.000,1859,9.000,40,43,30,41,20,10,0,0,3987,2265,4703,919,378,0,253,0,0,0,65,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.63,'true',0,0),
(2333,25290,'Daimon the White-Eyed','Raid Boss','hundred_eye',21.00,55.00,78,'male','L2RaidBoss','Fighter',40,977229,414.000,3718,10.000,60,57,73,76,70,80,2318004,1136977,9824,4444,14332,1805,409,0,2901,0,0,0,30,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.54,'false',0,1),
(2334,25291,'Family of Daimon','Raid Fighter','field_stalker',15.00,30.00,77,'male','L2Minion','Fighter',40,22382,142.400,1859,9.000,40,43,30,41,20,10,0,0,12565,2179,24607,885,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.41,'true',0,0),
(2335,25292,'Family of Daimon','Raid Fighter','parasitic_eye',25.00,63.00,77,'male','L2Minion','Mystic',40,33607,142.400,1859,9.000,40,43,30,41,20,10,0,0,9424,2179,13842,885,278,0,253,0,0,0,30,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.50,'true',0,0),
(2336,25293,'Hestia,Guardian Deity of the Hot Springs','Raid Boss','pixy_bi',10.00,54.00,78,'female','L2RaidBoss','Fighter',40,977229,337.000,3718,10.000,60,57,73,76,70,80,4671563,943547,7940,4444,8508,1805,409,0,3819,0,0,0,129,307,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.72,'false',1,1),
(2337,25294,'Fighter of Hestia','Raid Fighter','yeti',15.00,27.50,77,'male','L2Minion','Fighter',40,102704,182.770,1859,9.810,40,43,30,41,20,10,0,0,15250,2179,32949,885,278,0,333,0,0,0,17,209,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.48,'true',1,0),
(2338,25295,'Follower of Hestia','Raid Fighter','yeti',15.00,27.50,77,'male','L2Minion','Fighter',40,51352,182.770,1859,9.810,40,43,30,41,20,10,0,0,7625,2179,8237,885,278,0,333,0,0,0,17,209,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.48,'true',1,0),
(2339,25296,'Icicle Emperor Bumbalump','Raid Boss','yeti_20_bi',18.00,32.00,74,'male','L2RaidBoss','Fighter',40,935092,416.000,3718,10.000,60,57,73,76,70,80,2212304,1028870,8715,4103,12471,1666,409,0,3819,0,0,0,16,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.48,'false',0,1),
(2340,25297,'Icicle Giant','Raid Fighter','stone_golem',20.00,31.00,73,'male','L2Minion','Mystic',40,65759,142.400,1859,9.000,40,43,30,41,20,10,0,0,11127,2008,21420,815,278,0,253,0,0,0,23,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.41,'true',0,0),
(2341,25298,'Icicle Giant','Raid Fighter','stone_golem',20.00,31.00,73,'male','L2Minion','Mystic',40,98148,142.400,1859,9.000,40,43,30,41,20,10,0,0,16691,2008,48198,815,278,0,253,0,0,0,23,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.41,'true',0,0),
(2342,25299,'Ketra''s Hero Hekaton','Raid Boss','ketra_orc_chieftain_20_bi',17.00,46.20,80,'male','L2RaidBoss','Fighter',40,714778,180.000,3718,10.000,60,57,73,76,70,80,3206477,835990,6959,4615,4585,1874,409,0,3819,6719,0,0,24,190,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.51,'false',1,1),
(2343,25300,'Scout of Hekaton','Raid Fighter','ketra_orc_archer',12.00,27.00,79,'male','L2Minion','Ranger',500,50349,62.040,1859,9.000,40,43,30,41,20,10,0,0,19811,2265,7884,919,278,0,253,288,0,0,45,190,'',0,'Local','',0,0,0,7,30,4,20,1500,0,0.91,'true',1,0),
(2344,25301,'Servant of Hekaton','Raid Fighter','ketra_orc',12.00,29.00,79,'male','L2Minion','Fighter',40,37574,62.040,1859,9.000,40,43,30,41,20,10,0,0,6687,2265,4435,919,278,0,253,79,0,0,45,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.46,'true',1,0),
(2345,25302,'Ketra''s Commander Tayr','Raid Boss','ketra_orc_warlord_20_bi',14.00,36.00,84,'male','L2RaidBoss','Fighter',40,743801,177.000,138,10.000,60,57,73,76,70,80,3379556,898478,7856,4952,5408,2011,409,0,3819,80,0,0,43,307,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.48,'false',1,1),
(2346,25303,'Tayr''s Aide','Raid Fighter','ketra_orc_shaman',10.00,23.00,83,'male','L2Minion','Priest',40,52409,61.150,1859,9.000,40,43,30,41,20,10,0,0,10082,2434,9295,988,278,0,253,213,0,0,10,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.34,'true',1,0),
(2347,25304,'Tayr''s Guard','Raid Fighter','ketra_orc',12.00,29.00,83,'male','L2Minion','Fighter',40,78223,61.150,1859,9.000,40,43,30,41,20,10,0,0,15123,2434,20916,988,278,0,253,79,6919,0,45,190,NULL,0,'Local',NULL,0,20,707,7,30,4,20,0,0,0.46,'true',1,0),
(2348,25305,'Ketra''s Chief Brakki','Raid Boss','ketra_warbeast',20.00,33.50,87,'male','L2RaidBoss','Fighter',40,1532678,174.000,138,10.000,60,57,73,76,70,80,3526019,952059,17006,5200,24162,2112,409,0,3819,0,0,0,42,307,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.50,'false',1,1),
(2349,25306,'Soul of Fire Nastron','Raid Boss','ifrit',10.00,42.00,87,'male','L2RaidBoss','Fighter',40,534922,174.000,3718,10.000,60,57,73,76,70,80,3526018,952059,8503,5200,6040,2112,409,0,3819,0,0,0,38,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.48,'false',0,1),
(2350,25307,'Family of Nastron','Raid Fighter','mana_vampire',11.00,20.00,86,'male','L2Minion','Mystic',40,56256,60.140,1859,9.000,40,43,30,41,20,10,0,0,16392,2559,23362,1039,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'true',0,0),
(2351,25308,'Family of Nastron','Raid Fighter','mana_vampire',11.00,20.00,86,'male','L2Minion','Mystic',40,28128,60.140,1859,9.000,40,43,30,41,20,10,0,0,8196,2559,5840,1039,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'true',0,0),
(2352,25309,'Varka''s Hero Shadith','Raid Boss','barka_silenos_shaman_20_bi',17.00,47.50,80,'male','L2RaidBoss','Priest',40,714778,180.000,3718,10.000,60,57,73,76,70,80,3206477,835990,6959,4615,4585,1874,409,0,3819,6716,0,0,36,190,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.54,'false',1,1),
(2353,25310,'Shadith''s Royal Guard Captain','Raid Fighter','barka_silenos_warrior',16.00,41.00,79,'male','L2Minion','Fighter',40,75148,62.040,1859,9.000,40,43,30,41,20,10,0,0,13374,2265,17740,919,278,0,253,142,6918,0,34,190,NULL,0,'Local',NULL,0,20,674,7,30,4,20,0,0,0.48,'true',1,0),
(2354,25311,'Shadith''s Sentinel','Raid Fighter','barka_silenos_hunter',16.00,38.00,79,'male','L2Minion','Ranger',40,37574,62.040,1859,9.000,40,43,30,41,20,10,0,0,6687,2265,4435,919,278,0,253,2504,0,0,44,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48,'true',1,0),
(2355,25312,'Varka''s Commander Mos','Raid Boss','barka_silenos_chieftain_20_bi',22.00,51.00,84,'male','L2RaidBoss','Fighter',40,743801,177.000,138,10.000,60,57,73,76,70,80,3379556,898478,7856,4952,5408,2011,409,0,3819,2500,0,0,40,307,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.48,'false',1,1),
(2356,25313,'Mos'' Aide','Raid Fighter','barka_silenos_priest',9.00,41.50,83,'male','L2Minion','Priest',40,78223,61.150,1859,9.000,40,43,30,41,20,10,0,0,7561,2434,5229,988,278,0,253,6716,0,0,36,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.47,'true',1,0),
(2357,25314,'Mos'' Guard','Raid Fighter','barka_silenos_hunter',16.00,38.00,83,'male','L2Minion','Fighter',40,39111,61.150,1859,9.000,40,43,30,41,20,10,0,0,7561,2434,5229,988,278,0,253,142,0,0,44,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48,'true',1,0),
(2358,25315,'Varka''s Chief Horus','Raid Boss','barka_silenos_chieftain_20_bi',22.00,51.00,87,'male','L2RaidBoss','Fighter',40,1532678,174.000,138,10.000,60,57,73,76,70,80,3526019,952059,17006,5200,24162,2112,409,0,3819,2500,0,0,40,307,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.48,'false',1,1),
(2359,25316,'Soul of Water Ashutar','Raid Boss','undine',12.00,27.00,87,'female','L2RaidBoss','Mystic',40,534922,174.000,3718,10.000,60,57,73,76,70,80,3526018,952059,8503,5200,6040,2112,409,0,3819,0,0,0,60,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.35,'false',0,1),
(2360,25317,'Family of Ashutar','Raid Fighter','magical_weaver',11.00,20.00,86,'male','L2Minion','Mystic',40,56256,60.140,1859,9.000,40,43,30,41,20,10,0,0,16392,2559,23362,1039,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'true',0,0),
(2361,25318,'Family of Ashutar','Raid Fighter','magical_weaver',11.00,20.00,86,'male','L2Minion','Mystic',40,28128,60.140,1859,9.000,40,43,30,41,20,10,0,0,8196,2559,5840,1039,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'true',0,0),
(2362,25319,'Ember','Raid Boss','inferno_drake_100_bi',48.00,73.00,85,'male','L2RaidBoss','Fighter',40,1048567,404.000,1380,10.000,60,57,73,76,70,80,2535975,1356048,11906,5036,18324,2045,409,0,3819,0,0,0,92,307,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.48,'false',1,1),
(2363,25320,'Sentinel of Ember','Raid Fighter','lava_golem',22.00,45.00,84,'male','L2Minion','Fighter',40,73883,139.200,1859,9.000,40,43,30,41,20,10,0,0,15276,2476,31447,1005,278,0,253,0,0,0,13,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.47,'true',1,0),
(2364,25321,'Messenger of Ember','Raid Fighter','ifrit',10.00,42.00,84,'male','L2Minion','Mystic',40,110274,139.200,1859,9.000,40,43,30,41,20,10,0,0,11457,2476,17689,1005,278,0,253,0,0,0,38,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.48,'true',1,0),
(2365,25322,'Demon''s Agent Falston','Raid Boss','vampire_warrior',9.00,31.50,66,'male','L2RaidBoss','Fighter',40,834231,408.000,3718,10.000,60,57,73,76,70,80,1838232,828036,6092,3431,7808,1393,409,0,3819,6723,0,0,43,190,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.60,'false',1,1),
(2366,25323,'Falston''s Disciple','Raid Fighter','vampire_wizard',5.50,28.00,65,'female','L2Minion','Mystic',40,58282,139.200,1859,9.000,40,43,30,41,20,10,0,0,7744,1674,13406,680,278,0,253,99,0,0,46,190,NULL,0,'DRIVER',NULL,0,0,0,7,30,4,20,0,0,0.46,'true',1,0),
(2367,25324,'Servant of Falston','Raid Fighter','black_magician',8.00,30.00,65,'male','L2Minion','Mystic',40,86988,139.200,1859,9.000,40,43,30,41,20,10,0,0,11616,1674,30166,680,278,0,253,178,0,0,19,190,'',0,'DRIVER','',0,0,0,7,30,4,20,0,0,0.48,'true',1,0),
(2368,25325,'Flame of Splendor Barakiel','Raid Boss','apostle_warrior',8.00,30.00,70,'female','L2RaidBoss','Fighter',40,888658,362.000,3718,10.000,60,57,73,76,70,80,4135551,777993,6222,3764,7141,1528,409,0,3819,6717,0,0,50,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.46,'false',1,1),
(2369,25326,'Barakiel''s Disciple','Raid Fighter','apostle_mage',11.00,38.50,69,'male','L2Minion','Mystic',40,93041,123.830,1859,9.000,40,43,30,41,20,10,0,0,11794,1840,27141,747,278,0,253,6718,0,0,50,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48,'true',1,0),
(2370,25327,'Barakiel''s Acolyte','Raid Fighter','apostle_mage',11.00,38.50,69,'male','L2Minion','Mystic',40,46520,123.830,1859,9.000,40,43,30,41,20,10,0,0,5897,1840,6785,747,278,0,253,6718,0,0,50,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48,'true',1,0),
(2371,25328,'Eilhalder von Hellmann','Raid Boss','vampire_lord',7.50,25.80,71,'male','L2RaidBoss','Quest024Fighter',40,900867,414.000,3718,10.000,60,57,73,76,70,80,2142425,952990,7927,3848,11244,1562,409,0,3819,0,0,0,15,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.56,'false',1,1),
(2372,25329,'Violet','Raid Fighter','vampire_witch',6.00,21.50,70,'female','L2Minion','Quest024Mystic',40,63242,142.000,1859,9.000,40,43,30,41,20,10,0,0,9193,1882,15976,764,278,0,253,946,0,0,64,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.50,'true',1,0),
(2373,25330,'Kurstin','Raid Fighter','vampire_witch',6.00,21.50,70,'female','L2Minion','Quest024Mystic',40,63242,142.000,1859,9.000,40,43,30,41,20,10,0,0,9193,1882,15976,764,278,0,253,946,0,0,64,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.50,'true',1,0),
(2374,25331,'Mina','Raid Fighter','vampire_witch',6.00,21.50,70,'female','L2Minion','Quest024Mystic',40,63242,142.000,1859,9.000,40,43,30,41,20,10,0,0,9193,1882,15976,764,278,0,253,946,0,0,64,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.50,'true',1,0),
(2375,25332,'Dorian','Raid Fighter','vampire_soldier',8.00,23.50,70,'male','L2Minion','Quest024Fighter',40,94391,142.000,1859,9.000,40,43,30,41,20,10,0,0,13791,1882,35947,764,278,0,253,234,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.45,'true',1,0),
(2376,25333,'Anakazel','Invaders'' Leader','dre_vanul_bi_one',21.00,54.00,28,'male','L2Monster','Fighter',40,193763,51.790,3718,9.000,60,57,73,76,70,80,629182,56542,163,1044,32,424,409,0,2901,0,0,0,59,307,'',0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.35,'false',1,0),
(2377,25334,'Anakazel','Invaders'' Leader','dre_vanul_bi_one',21.00,54.00,38,'male','L2Monster','Fighter',40,306698,73.530,3718,9.000,60,57,73,76,70,80,892440,99116,425,1508,113,612,409,0,2901,0,0,0,59,307,'',0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.35,'false',1,0),
(2378,25335,'Anakazel','Invaders'' Leader','kaim_vanul_20_bi',28.00,48.00,48,'male','L2Monster','Fighter',40,494363,97.750,3718,9.000,60,57,73,76,70,80,1173349,137957,1205,2094,514,850,409,0,2901,0,0,0,59,307,'',0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.45,'false',1,0),
(2379,25336,'Anakazel','Invaders'' Leader','kaim_vanul_20_bi',28.00,48.00,58,'male','L2Monster','Fighter',40,705074,121.930,3718,9.000,60,57,73,76,70,80,1470377,229005,2848,2798,1790,1136,409,0,2901,0,0,0,59,307,'',0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.45,'false',1,0),
(2380,25337,'Anakazel','Invaders'' Leader','karik',25.00,90.00,68,'male','L2Monster','Fighter',40,865808,132.250,3718,9.000,60,57,73,76,70,80,1812663,349493,4854,3596,3563,1460,409,0,2901,0,0,0,59,307,'',0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.45,'false',1,0),
(2381,25338,'Anakazel','Invaders'' Leader','karik',25.00,90.00,78,'male','L2Monster','Fighter',40,977523,133.250,3718,9.000,60,57,73,76,70,80,2238492,462266,7410,4444,6271,1805,409,0,2901,0,0,0,59,307,'',0,'Local',NULL,0,0,0,7,30,4,20,0,-18,0.45,'false',1,0),
(2382,25339,'Shadow of Halisha','Ruler of Sepulcher','halisha_a',23.00,60.00,81,'female','L2RaidBoss','Ranger',500,503921,151.000,3718,10.000,60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,3819,6720,0,0,43,190,'',0,'Drin','',0,0,0,7,30,4,20,1500,-18,0.48,'false',1,1),
(2383,25340,'Knight of Shadow','','vale_master',12.00,40.00,80,'male','L2Minion','Fighter',40,12829,52.150,1859,9.000,40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.74,'false',1,0),
(2384,25341,'Knight of Shadow','','eligor',21.00,35.00,80,'male','L2Minion','Fighter',40,6414,52.150,1859,9.000,40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,253,0,0,0,35,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.48,'false',1,0),
(2385,25342,'Shadow of Halisha','Ruler of Sepulcher','halisha_b',23.00,60.00,81,'female','L2RaidBoss','Ranger',500,503921,151.000,3718,10.000,60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,3819,6720,0,0,43,190,'',0,'Drin','',0,0,0,7,30,4,20,1500,-18,0.48,'false',1,1),
(2386,25343,'Knight of Shadow','','vale_master',12.00,40.00,80,'male','L2Minion','Fighter',40,12829,52.150,1859,9.000,40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.74,'false',1,0),
(2387,25344,'Knight of Shadow','','fiend_archer',17.00,55.00,80,'male','L2Minion','Ranger',500,8544,52.150,1859,9.000,40,43,30,41,20,10,0,0,12691,2419,3381,982,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,1500,0,0.76,'false',1,0),
(2388,25345,'Knight of shadow','','lilim_wizard',9.00,34.00,80,'female','L2Minion','Fighter',40,8544,52.150,1859,9.000,40,43,30,41,20,10,0,0,5711,2419,3381,982,278,0,253,0,0,0,50,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.50,'false',1,0),
(2389,25346,'Shadow of Halisha','Ruler of Sepulcher','halisha_c',23.00,60.00,81,'female','L2RaidBoss','Ranger',500,503921,151.000,3718,10.000,60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,3819,6720,0,0,43,190,'',0,'Drin','',0,0,0,7,30,4,20,1500,-18,0.48,'false',1,1),
(2390,25347,'Knight of Shadow','','lilim_wizard',9.00,34.00,80,'female','L2Minion','Fighter',40,8544,52.150,1859,9.000,40,43,30,41,20,10,0,0,5711,2419,3381,982,278,0,253,0,0,0,50,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.50,'false',1,0),
(2391,25348,'Knight of Shadow','','death_lord',21.00,40.00,80,'male','L2Minion','Fighter',40,12829,52.150,1859,9.000,40,43,30,41,20,10,0,0,8567,2419,7608,982,278,0,253,78,0,0,40,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.50,'false',1,0),
(2392,25349,'Shadow of Halisha','Ruler of Sepulcher','halisha_d',23.00,60.00,81,'female','L2RaidBoss','Ranger',500,503921,151.000,3718,10.000,60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,3819,6720,0,0,43,190,'',0,'Drin','',0,0,0,7,30,4,20,1500,-18,0.48,'false',1,1),
(2393,25350,'Knight of Shadow','','lilim_wizard',9.00,34.00,80,'female','L2Minion','Fighter',40,8544,52.150,1859,9.000,40,43,30,41,20,10,0,0,5711,2419,3381,982,278,0,253,0,0,0,50,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.50,'false',1,0),
(2394,25351,'Knight of Shadow','','vale_master',12.00,40.00,80,'male','L2Minion','Fighter',40,12829,52.150,1859,9.000,40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.74,'false',1,0),
(2395,25352,'Giant Wasteland Basilisk','Raid Boss','lesser_basilisk',12.00,22.00,30,'male','L2RaidBoss','Fighter',40,127782,65.000,3718,10.000,60,57,73,76,70,80,636918,59660,96,1127,9,458,409,0,3819,0,0,0,35,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.39,'false',1,1),
(2396,25353,'Giant Wasteland Basilisk','Raid Fighter','lesser_basilisk_sm',12.00,22.00,29,'male','L2Minion','Fighter',40,12952,21.520,1859,9.000,40,43,30,41,20,10,0,0,174,542,35,220,278,0,253,0,0,0,35,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'true',1,0),
(2397,25354,'Gargoyle Lord Sirocco','Raid Boss','gargoyle_bi',16.00,65.00,35,'male','L2RaidBoss','Fighter',40,165289,91.000,3718,10.000,60,57,73,76,70,80,1193687,138419,300,1356,59,550,409,0,3819,0,0,0,140,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.37,'false',1,1),
(2398,25355,'Sirocco''s Gargoyle','Raid Fighter','gargoyle',16.00,50.00,34,'male','L2Minion','Fighter',40,8316,30.060,1859,9.000,40,43,30,41,20,10,0,0,277,654,55,265,278,0,253,0,0,0,140,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.37,'true',1,0),
(2399,25356,'Sirocco''s Guards','Raid Fighter','gargoyle',16.00,50.00,34,'male','L2Minion','Fighter',40,16632,30.060,1859,9.000,40,43,30,41,20,10,0,0,554,654,220,265,278,0,253,0,0,0,140,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.37,'true',1,0),
(2400,25357,'Sukar Wererat Chief','Raid Boss','wererat',14.00,25.00,21,'male','L2RaidBoss','Fighter',40,90169,45.000,3718,10.000,60,57,73,76,70,80,578451,45688,42,789,3,320,409,0,3819,216,0,0,80,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.61,'false',1,1),
(2401,25358,'Sukar Wererat Guard','Raid Fighter','wererat_sm',14.00,18.70,20,'male','L2Minion','Fighter',40,9314,14.890,1859,9.000,40,43,30,41,20,10,0,0,60,378,8,153,278,0,253,216,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.61,'true',1,0),
(2402,25359,'Sukar Wererat Priest','Raid Fighter','wererat_sm',14.00,18.70,20,'male','L2Minion','Priest',40,9314,14.890,1859,9.000,40,43,30,41,20,10,0,0,30,378,2,153,278,0,253,179,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.61,'true',1,0),
(2403,25360,'Tiger Hornet','Raid Boss','giant_bee_bi',8.00,32.00,26,'male','L2RaidBoss','Fighter',40,107186,56.000,3718,10.000,60,57,73,76,70,80,621174,53601,67,966,6,392,409,0,3819,0,0,0,90,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.50,'false',1,1),
(2404,25361,'Yellow Hornet','Raid Fighter','giant_bee',8.00,24.50,25,'male','L2Minion','Fighter',40,10950,18.400,1859,9.000,40,43,30,41,20,10,0,0,122,464,23,188,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.50,'true',1,0),
(2405,25362,'Tracker Leader Sharuk','Raid Boss','virud_lizardman_warrior',12.00,30.00,23,'male','L2RaidBoss','Fighter',40,95986,49.000,3718,10.000,60,57,73,76,70,80,599426,50860,52,857,4,348,409,0,3819,291,0,0,52,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.59,'false',1,1),
(2406,25363,'Sharuk''s Tracker','Raid Fighter','virud_lizardman',10.00,23.00,22,'male','L2Minion','Fighter',40,4935,16.240,1859,9.000,40,43,30,41,20,10,0,0,47,411,4,167,278,0,253,2,0,0,43,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48,'true',1,0),
(2407,25364,'Sharuk''s Marksman','Raid Fighter','virud_lizardman_scout',10.00,22.00,22,'male','L2Minion','Ranger',500,6613,16.240,1859,9.000,40,43,30,41,20,10,0,0,140,411,7,167,278,0,253,2507,0,0,43,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,1500,0,0.72,'true',1,0),
(2408,25365,'Patriarch Kuroboros','Raid Boss','virud_lizardman_warrior_bi',12.00,34.50,26,'male','L2RaidBoss','Priest',40,214372,56.000,3718,10.000,60,57,73,76,70,80,621174,53601,135,966,25,392,409,0,3819,93,0,0,52,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.59,'false',1,1),
(2409,25366,'Kuroboros'' Priest','Raid Boss','virud_lizardman_matriarch',13.00,37.00,23,'male','L2RaidBoss','Priest',40,95986,49.000,3718,10.000,60,57,73,76,70,80,599426,50860,52,857,4,348,409,0,3819,2,0,0,56,190,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.65,'false',1,1),
(2410,25367,'Kuroboros'' Follower','Raid Fighter','virud_lizardman',10.00,23.00,22,'male','L2Minion','Fighter',40,9870,16.240,1859,9.000,40,43,30,41,20,10,0,0,94,411,17,167,278,0,253,1,102,0,43,190,NULL,0,'Local',NULL,0,20,185,7,30,4,20,0,0,0.48,'true',1,0),
(2411,25368,'Kuroboros'' Discipline','Raid Fighter','virud_lizardman_shaman',10.00,29.00,22,'male','L2Minion','Priest',40,9870,16.240,1859,9.000,40,43,30,41,20,10,0,0,47,411,4,167,278,0,253,179,0,0,43,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.48,'true',1,0),
(2412,25369,'Soul Scavenger','Raid Boss','dark_horror_bi',20.00,42.00,25,'male','L2RaidBoss','Fighter',40,103092,54.000,3718,10.000,60,57,73,76,70,80,612533,52699,62,928,5,377,409,0,3819,0,0,0,100,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.37,'false',1,1),
(2413,25370,'Corpse Scavenger','Raid Fighter','skeleton_bi',11.00,31.00,24,'male','L2Minion','Fighter',40,10554,17.660,1859,9.000,40,43,30,41,20,10,0,0,112,446,21,181,278,0,253,946,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.30,'true',1,0),
(2414,25371,'Anima Scavenger','Raid Fighter','spartoi',11.00,27.00,24,'male','L2Minion','Fighter',40,5277,17.660,1859,9.000,40,43,30,41,20,10,0,0,56,446,5,181,278,0,253,946,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.30,'true',1,0),
(2415,25372,'Discarded Guardian','Raid Boss','stone_golem_bi',20.00,40.30,20,'male','L2RaidBoss','Mystic',40,175392,43.000,3718,10.000,60,57,73,76,70,80,436632,37265,61,757,8,307,409,0,3819,0,0,0,23,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.41,'false',1,1),
(2416,25373,'Malex Herald of Dagoniel','Raid Boss','dre_vanul_bi_one',14.00,43.20,21,'male','L2RaidBoss','Fighter',40,90169,45.000,3718,10.000,60,57,73,76,70,80,578451,45688,42,789,3,320,409,0,3819,0,0,0,80,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.35,'false',1,1),
(2417,25374,'Abyss Flyer','Raid Fighter','vampire_bat',10.00,33.50,20,'male','L2Minion','Fighter',40,9314,14.890,1859,9.000,40,43,30,41,20,10,0,0,60,378,8,153,278,0,253,0,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.50,'true',1,0),
(2418,25375,'Zombie Lord Farakelsus','Raid Boss','zombie_bi',13.00,27.50,20,'male','L2RaidBoss','Fighter',40,87696,43.000,3718,10.000,60,57,73,76,70,80,436632,37265,30,757,2,307,409,0,3819,0,0,0,15,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.43,'false',1,1),
(2419,25376,'Warrior Zombie of Farakelsus','Raid Fighter','zombie',13.00,21.00,19,'male','L2Minion','Mystic',40,9080,14.240,1859,9.000,40,43,30,41,20,10,0,0,54,363,7,147,278,0,253,0,0,0,15,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.43,'true',1,0),
(2420,25377,'Priest Zombie of Farakelsus','Raid Fighter','zombie',13.00,21.00,19,'male','L2Minion','Priest',40,9080,14.240,1859,9.000,40,43,30,41,20,10,0,0,27,363,1,147,278,0,253,0,0,0,15,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.43,'true',1,0),
(2421,25378,'Madness Beast','Raid Boss','onyx_beast_bi',14.00,18.70,20,'male','L2RaidBoss','Fighter',40,87696,43.000,3718,10.000,60,57,73,76,70,80,436632,37265,30,757,2,307,409,0,3819,0,0,0,30,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.24,'false',1,1),
(2422,25379,'Dementia Beast','Raid Fighter','onyx_beast',14.00,14.50,19,'male','L2Minion','Fighter',40,9080,14.240,1859,9.000,40,43,30,41,20,10,0,0,54,363,7,147,278,0,253,0,0,0,30,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.24,'true',1,0),
(2423,25380,'Kaysha Herald of Icarus','Raid Boss','succubus_bi',10.00,43.20,21,'female','L2RaidBoss','Mystic',40,90169,45.000,3718,10.000,60,57,73,76,70,80,578451,45688,42,789,3,320,409,0,3819,0,0,0,60,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.84,'false',1,1),
(2424,25381,'Nightmare Flyer','Raid Fighter','vampire_bat_bi',10.00,42.00,19,'male','L2Minion','Fighter',40,9080,14.240,1859,9.000,40,43,30,41,20,10,0,0,54,363,7,147,278,0,253,0,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.50,'true',1,0),
(2425,25382,'Hostile Flyer','Raid Fighter','vampire_bat',10.00,33.50,19,'male','L2Minion','Fighter',40,4540,14.240,1859,9.000,40,43,30,41,20,10,0,0,27,363,1,147,278,0,253,0,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.50,'true',1,0),
(2426,25383,'Revenant of Sir Calibus','Raid Boss','death_knight_bi',12.00,30.00,34,'male','L2RaidBoss','Fighter',40,156584,75.000,3718,10.000,60,57,73,76,70,80,840195,76283,158,1308,20,531,409,0,3819,75,0,0,27,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.71,'false',1,1),
(2427,25384,'Servant of Calibus','Raid Fighter','spartoi',11.00,27.00,33,'male','L2Minion','Fighter',40,15774,24.890,1859,9.000,40,43,30,41,20,10,0,0,292,630,75,256,278,0,253,946,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.30,'true',1,0),
(2428,25385,'Evil Spirit Tempest','Raid Boss','dre_vanul_bi_one',21.00,54.00,36,'male','L2RaidBoss','Fighter',40,174646,80.000,3718,10.000,60,57,73,76,70,80,867472,80701,185,1405,24,570,409,0,3819,0,0,0,80,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.35,'false',1,1),
(2429,25386,'Ghost of the Execution Grounds','Raid Fighter','skeleton_bi',11.00,31.00,35,'male','L2Minion','Fighter',40,17556,26.660,1859,9.000,40,43,30,41,20,10,0,0,336,678,87,275,278,0,253,128,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.30,'true',1,0),
(2430,25387,'Malignant Spirit of the Execution Grounds','Raid Fighter','skeleton',11.00,25.00,35,'male','L2Minion','Fighter',40,8778,26.660,1859,9.000,40,43,30,41,20,10,0,0,168,678,21,275,278,0,253,946,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.30,'true',1,0),
(2431,25388,'Red Eye Captain Trakia','Raid Boss','oel_mahum_bi',30.00,55.00,35,'male','L2RaidBoss','Fighter',40,165289,78.000,3718,10.000,60,57,73,76,70,80,854153,78199,170,1356,21,550,409,0,3819,70,0,0,70,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.48,'false',1,1),
(2432,25389,'Red Eye Archer','Raid Fighter','ol_mahum_archer',14.00,25.00,34,'male','L2Minion','Ranger',500,11143,25.770,1859,9.000,40,43,30,41,20,10,0,0,464,654,36,265,278,0,253,279,0,0,50,190,'',0,'Local','',0,0,0,7,30,4,20,1500,0,0.93,'true',1,0),
(2433,25390,'Red Eye Guards','Raid Fighter','ol_mahum_champion',14.00,27.00,34,'male','L2Minion','Fighter',40,8316,25.770,1859,9.000,40,43,30,41,20,10,0,0,156,654,20,265,278,0,253,128,0,0,50,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.63,'true',1,0),
(2434,25391,'Nurka''s Messenger','Raid Boss','ol_mahum_champion_bi',21.00,40.50,33,'male','L2RaidBoss','Fighter',40,297015,73.000,3718,10.000,60,57,73,76,70,80,825587,73993,295,1261,75,512,409,0,3819,127,0,0,50,190,NULL,0,'Magister','',0,0,0,7,30,4,20,0,-18,0.63,'false',1,1),
(2435,25392,'Captain of Queen''s Royal Guards','Raid Boss','marsh_stakato_queen',15.00,37.00,32,'female','L2RaidBoss','Fighter',40,141034,70.000,3718,10.000,60,57,73,76,70,80,810271,71493,137,1215,17,493,409,0,3819,129,0,0,130,190,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.41,'false',1,1),
(2436,25393,'Marsh Stakato Noble','Raid Fighter','marsh_stakato_drone',9.00,24.00,31,'male','L2Minion','Fighter',40,14247,23.170,1859,9.000,40,43,30,41,20,10,0,0,246,585,61,237,278,0,253,223,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'true',1,0),
(2437,25394,'Premo Prime','Raid Boss','twin_headed_giant',17.00,39.00,38,'male','L2RaidBoss','Fighter',40,390743,86.000,3718,10.000,60,57,73,76,70,80,892440,99116,425,1508,113,612,409,0,3819,88,0,0,45,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.46,'false',1,1),
(2438,25395,'Archon Suscepter','Raid Boss','susceptor_prime',45.00,72.00,45,'male','L2RaidBoss','Fighter',40,288415,105.000,3718,10.000,60,57,73,76,70,80,1139085,129941,456,1905,86,774,409,0,3819,0,0,0,78,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.52,'false',1,1),
(2439,25396,'Kusion Suscepter','Raid Fighter','susceptor',20.00,35.00,44,'male','L2Minion','Fighter',40,6649,35.160,1859,9.000,40,43,30,41,20,10,0,0,413,922,76,374,278,0,253,0,0,0,27,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.43,'true',1,0),
(2440,25397,'Gustos Suscepter','Raid Fighter','susceptor',20.00,35.00,44,'male','L2Minion','Fighter',40,29037,35.160,1859,9.000,40,43,30,41,20,10,0,0,826,922,307,374,278,0,253,0,0,0,27,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.43,'true',1,0),
(2441,25398,'Eye of Beleth','Raid Boss','monster_eye',21.00,43.00,35,'male','L2RaidBoss','Mystic',40,165289,78.000,3718,10.000,60,57,73,76,70,80,854153,78199,170,1356,21,550,409,0,3819,0,0,0,90,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.30,'false',1,1),
(2442,25399,'Apprentice of Watchman','Raid Fighter','mana_vampire',11.00,20.00,34,'male','L2Minion','Mystic',40,11143,25.770,1859,9.000,40,43,30,41,20,10,0,0,209,654,36,265,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'true',1,0),
(2443,25400,'Page of Watchman','Raid Fighter','magical_weaver',11.00,20.00,34,'male','L2Minion','Mystic',40,16632,25.770,1859,9.000,40,43,30,41,20,10,0,0,156,654,20,265,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'true',1,0),
(2444,25401,'Skyla','Raid Boss','zenta_lizardman_matriarch_bi',30.00,63.00,32,'male','L2RaidBoss','Fighter',40,141034,70.000,3718,10.000,60,57,73,76,70,80,810271,71493,137,1215,17,493,409,0,3819,215,0,0,53,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.46,'false',1,1),
(2445,25402,'Retainer of Skyla','Raid Fighter','zenta_lizardman',11.00,32.00,31,'male','L2Minion','Fighter',40,14247,23.170,1859,9.000,40,43,30,41,20,10,0,0,246,585,61,237,278,0,253,221,0,0,37,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.28,'true',1,0),
(2446,25403,'Follower of Skyla','Raid Fighter','zenta_lizardman_shaman',13.00,35.00,31,'male','L2Minion','Priest',40,9545,23.170,1859,9.000,40,43,30,41,20,10,0,0,164,585,27,237,278,0,253,180,0,0,43,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.63,'true',1,0),
(2447,25404,'Corsair Captain Kylon','Raid Boss','pirates_zombie_captain',16.00,44.00,33,'male','L2RaidBoss','Fighter',40,148507,73.000,3718,10.000,60,57,73,76,70,80,825587,73993,147,1261,18,512,409,0,3819,231,0,0,14,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.76,'false',1,1),
(2448,25405,'Kylon''s Pirate','Raid Fighter','skeleton_bi_one',16.00,40.00,32,'male','L2Minion','Fighter',40,14980,24.030,1859,9.000,40,43,30,41,20,10,0,0,271,607,69,246,278,0,253,946,945,0,60,190,NULL,0,'Local',NULL,0,20,251,7,30,4,20,0,0,0.30,'true',1,0),
(2449,25406,'Kylon''s Mate','Raid Fighter','skeleton_knight_50_bi',15.00,39.00,32,'male','L2Minion','Fighter',40,14980,24.030,1859,9.000,40,43,30,41,20,10,0,0,271,607,69,246,278,0,253,130,103,0,40,190,NULL,0,'Local',NULL,0,20,251,7,30,4,20,0,0,0.17,'true',1,0),
(2450,25407,'Lord Ishka','Raid Boss','death_blader_bi',22.00,67.00,60,'male','L2RaidBoss','Fighter',40,526218,147.000,3718,10.000,60,57,73,76,70,80,1496444,237315,1642,2951,547,1198,409,0,3819,1472,0,0,100,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.45,'false',1,1),
(2451,25408,'Ishka''s Elite Officer','Raid Fighter','skeleton_royal_guard',11.00,28.50,59,'male','L2Minion','Fighter',40,54404,49.690,1859,9.000,40,43,30,41,20,10,0,0,2999,1437,1951,583,278,0,253,946,945,0,80,190,NULL,0,'Local',NULL,0,20,485,7,30,4,20,0,0,0.52,'true',1,0),
(2452,25409,'Ishka''s Elite Soldier','Raid Fighter','skeleton_knight_20_bi',12.00,30.50,59,'male','L2Minion','Fighter',40,54404,49.690,1859,9.000,40,43,30,41,20,10,0,0,2999,1437,1951,583,278,0,253,150,103,0,40,190,NULL,0,'Local',NULL,0,20,485,7,30,4,20,0,0,0.17,'true',1,0),
(2453,25410,'Road Scavenger Leader','Raid Boss','wererat_bi',21.00,38.00,40,'male','L2RaidBoss','Fighter',40,218810,106.000,3718,10.000,60,57,73,76,70,80,1279280,187517,427,1615,87,656,409,0,3819,88,0,0,80,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.61,'false',1,1);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(2454,25411,'Road Scavenger Henchman','Raid Fighter','kobold_bi',15.00,24.00,39,'male','L2Minion','Fighter',40,21961,35.410,1859,9.000,40,43,30,41,20,10,0,0,786,780,323,317,278,0,253,0,0,0,47,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.54,'true',1,0),
(2455,25412,'Necrosentinel Royal Guard','Raid Boss','skeleton_royal_guard',11.00,28.50,47,'male','L2RaidBoss','Fighter',40,319791,111.000,3718,10.000,60,57,73,76,70,80,1162159,134535,546,2030,111,824,409,0,3819,946,946,0,80,190,'',0,'Magister','',0,0,746,7,30,4,20,0,-18,0.52,'false',1,1),
(2456,25413,'Necrosentinel Archer','Raid Fighter','skeleton_archer',11.00,27.00,46,'male','L2Minion','Ranger',500,21628,37.130,1859,9.000,40,43,30,41,20,10,0,0,1454,983,172,399,278,0,253,279,0,0,40,190,'',0,'Local','',0,0,0,7,30,4,20,1500,0,0.80,'true',1,0),
(2457,25414,'Necrosentinel Soldier','Raid Fighter','skeleton_knight',10.00,25.00,46,'male','L2Minion','Fighter',40,16140,37.130,1859,9.000,40,43,30,41,20,10,0,0,490,983,97,399,278,0,253,150,103,0,40,190,'',0,'Local','',0,20,364,7,30,4,20,0,0,0.17,'true',1,0),
(2458,25415,'Nakondas','Raid Boss','drake_bi',37.00,125.00,35,'male','L2RaidBoss','Fighter',40,218810,78.000,3718,10.000,60,57,73,76,70,80,854153,78199,170,1356,21,550,409,0,3819,0,0,0,70,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.84,'false',1,1),
(2459,25416,'Nakondas'' Slave','Raid Fighter','wyrm',29.00,72.00,34,'male','L2Minion','Fighter',40,14713,25.770,1859,9.000,40,43,30,41,20,10,0,0,209,654,36,265,278,0,253,0,0,0,70,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.19,'true',1,0),
(2460,25417,'Nakondas'' Chain','Raid Fighter','succubus',10.00,36.00,34,'female','L2Minion','Mystic',40,21961,25.770,1859,9.000,40,43,30,41,20,10,0,0,156,654,20,265,278,0,253,0,0,0,60,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.84,'true',1,0),
(2461,25418,'Dread Avenger Kraven','Raid Boss','death_knight_bi',12.00,30.00,44,'male','L2RaidBoss','Fighter',40,273375,103.000,3718,10.000,60,57,73,76,70,80,1127093,127160,418,1845,77,749,409,0,3819,75,0,0,27,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.71,'false',1,1),
(2462,25419,'Dread Panther','Raid Fighter','onyx_beast',14.00,14.50,43,'male','L2Minion','Fighter',40,27494,34.190,1859,9.000,40,43,30,41,20,10,0,0,756,892,272,362,278,0,253,0,0,0,30,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.24,'true',1,0),
(2463,25420,'Orfen''s Handmaiden','Raid Boss','riba',25.00,72.00,48,'female','L2RaidBoss','Fighter',40,335987,133.000,3718,10.000,60,57,73,76,70,80,1639757,244248,1060,2094,345,850,409,0,3819,0,0,0,60,190,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.45,'false',1,1),
(2464,25421,'Trisalim Escort','Raid Fighter','poison_spider_bi',40.00,38.00,47,'male','L2Minion','Mystic',40,22758,44.460,1859,9.000,40,43,30,41,20,10,0,0,1259,1015,526,412,278,0,253,0,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.65,'true',1,0),
(2465,25422,'Page of Rotting Tree','Raid Fighter','hanged_man_ripper',35.00,80.00,47,'male','L2Minion','Fighter',40,33967,44.460,1859,9.000,40,43,30,41,20,10,0,0,945,1015,296,412,278,0,253,0,0,0,55,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.48,'true',1,0),
(2466,25423,'Fairy Queen Timiniel','Raid Boss','pixy_bi',10.00,54.00,56,'female','L2RaidBoss','Fighter',40,539706,160.000,3718,10.000,60,57,73,76,70,80,1722981,291015,1459,2649,476,1075,409,0,3819,0,0,0,80,190,'timiniel_clan',300,'Magister','',0,0,0,7,30,4,20,0,-18,0.72,'false',1,1),
(2467,25424,'Timiniel''s Royal Guards','Raid Fighter','pixy',5.00,25.00,55,'female','L2Minion','Fighter',40,27947,53.600,1859,9.000,40,43,30,41,20,10,0,0,1347,1288,435,523,278,0,253,0,0,0,80,190,'timiniel_clan',300,'Local',NULL,0,0,0,7,30,4,20,0,0,0.72,'true',1,0),
(2468,25425,'Timiniel''s Royal Guard Captain','Raid Fighter','pixy',5.00,25.00,55,'female','L2Minion','Fighter',40,55894,53.600,1859,9.000,40,43,30,41,20,10,0,0,2694,1288,1740,523,278,0,253,0,0,0,80,190,'timiniel_clan',300,'Local',NULL,0,0,0,7,30,4,20,0,0,0.72,'true',1,0),
(2469,25426,'Betrayer of Urutu Freki','Raid Boss','werewolf_bi',11.00,29.70,25,'male','L2RaidBoss','Fighter',40,103092,54.000,3718,10.000,60,57,73,76,70,80,612533,52699,62,928,5,377,409,0,3819,0,0,0,50,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.43,'false',1,1),
(2470,25427,'Freki''s Vampire Bat','Raid Fighter','vampire_bat',10.00,33.50,24,'male','L2Minion','Mystic',40,10554,17.660,1859,9.000,40,43,30,41,20,10,0,0,112,446,21,181,278,0,253,0,0,0,60,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.50,'true',1,0),
(2471,25428,'Freki''s Wild Bear','Raid Fighter','grizzly',21.00,40.00,24,'male','L2Minion','Fighter',40,10554,17.660,1859,9.000,40,43,30,41,20,10,0,0,112,446,21,181,278,0,253,0,0,0,40,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.34,'true',1,0),
(2472,25429,'Mammon Collector Talos','Raid Boss','ashuras',13.00,37.50,25,'male','L2RaidBoss','Fighter',40,103092,54.000,3718,10.000,60,57,73,76,70,80,612533,52699,62,928,5,377,409,0,3819,0,0,0,41,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.50,'false',1,1),
(2473,25430,'Talos'' Cohort','Raid Fighter','dre_vanul',14.00,36.00,22,'male','L2Minion','Fighter',40,9870,16.240,1859,9.000,40,43,30,41,20,10,0,0,94,411,17,167,278,0,253,0,0,0,80,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.35,'true',1,0),
(2474,25431,'Flamestone Golem','Raid Boss','lava_golem',22.00,45.00,44,'male','L2RaidBoss','Fighter',40,273375,103.000,3718,10.000,60,57,73,76,70,80,1127093,127160,418,1845,77,749,409,0,3819,0,0,0,13,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.47,'false',1,1),
(2475,25432,'Elemental of Flame','Raid Fighter','mana_vampire',11.00,20.00,43,'male','L2Minion','Mystic',40,27494,34.190,1859,9.000,40,43,30,41,20,10,0,0,378,892,68,362,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'true',1,0),
(2476,25433,'Elemental of Spark','Raid Fighter','magical_weaver',11.00,20.00,43,'male','L2Minion','Mystic',40,13747,34.190,1859,9.000,40,43,30,41,20,10,0,0,378,892,68,362,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'true',1,0),
(2477,25434,'Bandit Leader Barda','Raid Boss','oel_mahum_warrior_50_bi',30.00,60.00,55,'male','L2RaidBoss','Fighter',40,451391,134.000,3718,10.000,60,57,73,76,70,80,1432099,216652,1156,2576,336,1046,409,0,3819,121,0,0,70,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.65,'false',1,1),
(2478,25435,'Barda''s Bandit','Raid Fighter','oel_mahum',20.00,37.00,54,'male','L2Minion','Fighter',40,46232,44.980,1859,9.000,40,43,30,41,20,10,0,0,2132,1252,1228,508,278,0,253,145,0,0,70,190,NULL,0,'stiff_fix_outofdate_from_867','1145636094',0,0,0,7,30,4,20,0,0,0.48,'true',1,0),
(2479,25436,'Barda''s Shaman','Raid Fighter','oel_mahum_witch_doctor',15.00,34.00,54,'male','L2Minion','Priest',40,30975,44.980,1859,9.000,40,43,30,41,20,10,0,0,1421,1252,546,508,278,0,253,201,0,0,70,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.26,'true',1,0),
(2480,25437,'Timak Orc Gosmos','Raid Boss','batur_orc_overlord_100_bi',24.00,52.00,45,'male','L2RaidBoss','Fighter',40,576831,105.000,3718,10.000,60,57,73,76,70,80,1139085,129941,912,1905,346,774,409,0,3819,145,0,0,80,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.28,'false',1,1),
(2481,25438,'Thief Kelbar','Raid Boss','wererat_100_bi',25.00,50.00,44,'male','L2RaidBoss','Fighter',40,273375,103.000,3718,10.000,60,57,73,76,70,80,1127093,127160,418,1845,77,749,409,0,3819,239,0,0,80,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.61,'false',1,1),
(2482,25439,'Kelbar''s Inferior','Raid Fighter','wererat_bi',21.00,38.00,43,'male','L2Minion','Fighter',40,27494,34.190,1859,9.000,40,43,30,41,20,10,0,0,756,892,272,362,278,0,253,130,0,0,80,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.61,'true',1,0),
(2483,25440,'Kelbar''s Wizard','Raid Fighter','wererat',14.00,25.00,43,'male','L2Minion','Fighter',40,18421,34.190,1859,9.000,40,43,30,41,20,10,0,0,504,892,121,362,278,0,253,99,0,0,80,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.61,'true',1,0),
(2484,25441,'Evil Spirit Cyrion','Raid Boss','drake_50_bi',45.00,150.00,45,'male','L2RaidBoss','Fighter',40,288415,105.000,3718,10.000,60,57,73,76,70,80,1139085,129941,456,1905,86,774,409,0,3819,0,0,0,70,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.84,'false',1,1),
(2485,25442,'Evil Creature of Forest','Raid Fighter','crimson_bear',19.00,36.00,44,'male','L2Minion','Fighter',40,14518,35.160,1859,9.000,40,43,30,41,20,10,0,0,413,922,76,374,278,0,253,0,0,0,37,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.45,'true',1,0),
(2486,25443,'Anger of Forest','Raid Fighter','giant_wild_hog',25.00,27.00,44,'male','L2Minion','Fighter',40,29037,35.160,1859,9.000,40,43,30,41,20,10,0,0,826,922,307,374,278,0,253,0,0,0,35,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.54,'true',1,0),
(2487,25444,'Enmity Ghost Ramdal','Raid Boss','dark_horror_100_bi',40.00,70.00,65,'male','L2RaidBoss','Fighter',40,588136,152.000,3718,10.000,60,57,73,76,70,80,1760714,332726,2176,3349,794,1360,409,0,3819,0,0,0,100,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.37,'false',1,1),
(2488,25445,'Enmity Ghosts','Raid Fighter','crimson_doll',15.00,38.00,64,'male','L2Minion','Fighter',40,30636,51.950,1859,9.000,40,43,30,41,20,10,0,0,2077,1634,769,663,278,0,253,0,0,0,60,190,'',0,'stiff_fix_outofdate_from_875','1145636095',0,0,0,7,30,4,20,0,0,0.67,'true',1,0),
(2489,25446,'Shooter of Enmity','Raid Fighter','skeleton_archer',11.00,27.00,64,'male','L2Minion','Ranger',500,41052,51.950,1859,9.000,40,43,30,41,20,10,0,0,6153,1634,1367,663,278,0,253,279,0,0,40,190,'',0,'Magister','',0,0,0,7,30,4,20,1500,0,0.80,'false',1,0),
(2490,25447,'Immortal Savior Mardil','Raid Boss','banshee_50_bi',13.50,38.00,71,'female','L2RaidBoss','Mystic',40,645953,155.000,3718,10.000,60,57,73,76,70,80,2068252,367642,2947,3848,1195,1562,409,0,3819,3939,0,0,80,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.56,'false',1,1),
(2491,25448,'Immortal Savior','Raid Fighter','binding',12.00,21.00,70,'male','L2Minion','Fighter',40,33847,53.210,1859,9.000,40,43,30,41,20,10,0,0,2611,1882,992,764,278,0,253,0,0,0,10,190,'',0,'stiff_fix_outofdate_from_877','1145636095',0,0,0,7,30,4,20,0,0,0.54,'true',1,0),
(2492,25449,'Immortal Guide','Raid Fighter','liviona',15.00,28.00,70,'male','L2Minion','Fighter',40,67694,53.210,1859,9.000,40,43,30,41,20,10,0,0,2611,1882,992,764,278,0,253,0,0,0,80,190,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.34,'true',1,0),
(2493,25450,'Cherub Galaxia','Raid Boss','archangel_50_bi',22.00,120.00,79,'male','L2RaidBoss','Fighter',40,987470,414.000,3718,10.000,60,57,73,76,70,80,2377821,1136977,9883,4471,14504,1816,409,0,3819,97,0,0,50,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.76,'false',1,1),
(2494,25451,'Galaxia''s Guards','Raid Fighter','angel',13.50,36.50,78,'male','L2Minion','Fighter',40,69545,142.400,1859,9.000,40,43,30,41,20,10,0,0,12640,2192,24904,890,278,0,253,148,0,0,30,190,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,0,0.52,'false',1,0),
(2495,25452,'Messenger of Angel','Raid Fighter','angel',13.50,36.50,79,'male','L2Minion','Fighter',40,104887,142.400,1859,9.000,40,43,30,41,20,10,0,0,9537,2206,14177,895,278,0,253,148,0,0,30,190,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.52,'false',1,0),
(2496,25453,'Meanas Anor','Raid Boss','wyrm_50_bi',58.00,108.00,70,'male','L2RaidBoss','Fighter',40,888658,336.000,3718,10.000,60,57,73,76,70,80,3859833,738431,5659,3764,5371,1528,409,0,3819,0,0,0,70,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.19,'false',1,1),
(2497,25454,'Wyvern of Marsh','Raid Fighter','wyrm',29.00,72.00,69,'male','L2Minion','Fighter',40,62338,114.980,1859,9.000,40,43,30,41,20,10,0,0,7149,1840,9066,747,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.19,'true',1,0),
(2498,25455,'Succubus of Marsh','Raid Fighter','succubus',10.00,36.00,69,'female','L2Minion','Mystic',40,93041,114.980,1859,9.000,40,43,30,41,20,10,0,0,5362,1840,5100,747,278,0,253,0,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.84,'true',1,0),
(2499,25456,'Mirror of Oblivion','Raid Boss','mirror_50_bi',12.00,22.00,49,'male','L2RaidBoss','Mystic',40,352421,117.000,3718,10.000,60,57,73,76,70,80,1184339,140317,652,2160,143,877,409,0,3819,0,0,0,80,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.39,'false',1,1),
(2500,25457,'Shards of Oblivion','Raid Fighter','human_ghost',8.00,22.00,48,'male','L2Minion','Mystic',40,3808,39.100,1859,9.000,40,43,30,41,20,10,0,0,595,1047,128,425,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'true',1,0),
(2501,25458,'Shadow of Oblivion','Raid Fighter','elf_ghost',7.00,21.00,48,'male','L2Minion','Mystic',40,7617,39.100,1859,9.000,40,43,30,41,20,10,0,0,595,1047,128,425,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.41,'true',1,0),
(2502,25459,'Shards of Oblivion','Raid Fighter','dwarf_ghost',9.00,16.50,48,'male','L2Minion','Mystic',40,3808,39.100,1859,9.000,40,43,30,41,20,10,0,0,595,1047,128,425,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.39,'true',1,0),
(2503,25460,'Deadman Ereve','Raid Boss','death_blader_200_bi',45.00,141.00,51,'male','L2RaidBoss','Fighter',40,385670,123.000,3718,10.000,60,57,73,76,70,80,1381165,185853,850,2294,219,931,409,0,3819,194,0,0,100,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.45,'false',1,1),
(2504,25461,'Ereve''s Knight','Raid Fighter','skeleton_knight',10.00,25.00,50,'male','L2Minion','Fighter',40,39195,41.080,1859,9.000,40,43,30,41,20,10,0,0,1395,1113,638,452,278,0,253,70,0,0,40,190,NULL,0,'stiff_fix_outofdate_from_888','1145636095',0,0,0,7,30,4,20,0,0,0.17,'true',1,0),
(2505,25462,'Ereve''s Squire','Raid Fighter','skeleton_pikeman',10.00,28.00,50,'male','L2Minion','Fighter',40,39195,41.080,1859,9.000,40,43,30,41,20,10,0,0,1395,1113,638,452,278,0,253,98,0,0,50,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.21,'true',1,0),
(2506,25463,'Harit Guardian Garangky','Raid Boss','saber_toothed_tiger',72.00,87.00,56,'male','L2RaidBoss','Fighter',40,467209,137.000,3718,10.000,60,57,73,76,70,80,1444796,221098,1237,2649,368,1075,409,0,3819,0,0,0,60,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.45,'false',1,1),
(2507,25464,'Garangky Guard Captain','Raid Fighter','zenta_lizardman_warrior',13.00,35.00,55,'male','L2Minion','Fighter',40,47946,45.940,1859,9.000,40,43,30,41,20,10,0,0,2284,1288,1347,523,278,0,253,303,0,0,40,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.56,'true',1,0),
(2508,25465,'Garangky Guard Shaman','Raid Fighter','zenta_lizardman_shaman',13.00,35.00,55,'male','L2Minion','Priest',40,47946,45.940,1859,9.000,40,43,30,41,20,10,0,0,1142,1288,336,523,278,0,253,206,0,0,43,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.63,'true',1,0),
(2509,25466,'Garangky Guard','Raid Fighter','zenta_lizardman',11.00,32.00,55,'male','L2Minion','Fighter',40,47946,45.940,1859,9.000,40,43,30,41,20,10,0,0,2284,1288,1347,523,278,0,253,77,0,0,37,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.28,'true',1,0),
(2510,25467,'Gorgolos','Raid Boss','field_stalker_200_bi',45.00,96.00,64,'male','L2RaidBoss','Fighter',40,576851,151.000,3718,10.000,60,57,73,76,70,80,1744167,326947,2103,3268,769,1327,409,0,3819,0,0,0,70,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.41,'false',1,1),
(2511,25468,'Cursed Life','Raid Fighter','field_stalker',15.00,30.00,63,'male','L2Minion','Fighter',40,30008,51.650,1859,9.000,40,43,30,41,20,10,0,0,2006,1594,744,647,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.41,'true',1,0),
(2512,25469,'Cursed Soul','Raid Fighter','field_stalker',15.00,30.00,63,'male','L2Minion','Fighter',40,60016,51.650,1859,9.000,40,43,30,41,20,10,0,0,4012,1594,2979,647,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.41,'true',1,0),
(2513,25470,'Last Titan Utenus','Raid Boss','lesser_giant_mage',21.00,44.00,66,'male','L2RaidBoss','Mystic',40,598898,153.200,3718,10.000,60,57,73,76,70,80,1777636,338244,2252,3431,821,1393,409,0,3819,3938,0,0,15,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.56,'false',1,1),
(2514,25471,'Utenus''s Wizard','Raid Fighter','lesser_giant',21.00,44.00,65,'male','L2Minion','Mystic',40,41855,52.230,1859,9.000,40,43,30,41,20,10,0,0,2866,1674,1412,680,278,0,253,0,0,0,15,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.58,'true',1,0),
(2515,25472,'Utenus''s Guard','Raid Fighter','leogul',15.00,35.00,65,'male','L2Minion','Fighter',40,62470,52.230,1859,9.000,40,43,30,41,20,10,0,0,4299,1674,3178,680,278,0,253,0,0,0,80,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.72,'true',1,0),
(2516,25473,'Grave Robber Kim','Raid Boss','batur_orc_warrior_100_bi',20.00,42.00,52,'male','L2RaidBoss','Fighter',40,402319,125.000,3718,10.000,60,57,73,76,70,80,1393971,205212,914,2363,242,959,409,0,3819,160,0,0,80,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.30,'false',1,1),
(2517,25474,'Kim''s Gang','Raid Fighter','batur_orc',9.00,21.50,51,'male','L2Minion','Fighter',40,40965,42.060,1859,9.000,40,43,30,41,20,10,0,0,1679,1147,879,465,278,0,253,89,0,0,80,190,NULL,0,'stiff_fix_outofdate_from_899','1145636095',0,0,0,7,30,4,20,0,0,0.46,'true',1,0),
(2518,25475,'Ghost Knight Kabed','Raid Boss','headless_knight_50_bi',30.00,46.50,55,'male','L2RaidBoss','Fighter',40,451391,134.000,3718,10.000,60,57,73,76,70,80,1393657,221098,1156,2576,336,1046,409,0,3819,145,0,0,70,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.52,'false',1,1),
(2519,25476,'Kabed''s Soldier','Raid Fighter','skeleton_knight',10.00,25.00,54,'male','L2Minion','Fighter',40,23116,44.980,1859,9.000,40,43,30,41,20,10,0,0,1066,1252,307,508,278,0,253,125,0,0,40,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.17,'true',1,0),
(2520,25477,'Kabed''s Archer','Raid Fighter','skeleton_archer',11.00,27.00,54,'male','L2Minion','Ranger',500,30975,44.980,1859,9.000,40,43,30,41,20,10,0,0,3158,1252,546,508,278,0,253,279,0,0,40,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,1500,0,0.80,'true',1,0),
(2521,25478,'Shilen''s Priest Hisilrome','Raid Boss','cave_maiden',25.00,65.00,65,'female','L2RaidBoss','Priest',40,588136,152.000,3718,10.000,60,57,73,76,70,80,1760714,332726,2176,3349,794,1360,409,0,3819,230,0,0,70,190,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.43,'false',1,1),
(2522,25479,'Hisilrome''s Servitor','Raid Fighter','serpent_slave',17.00,46.00,64,'male','L2Minion','Fighter',40,41052,51.950,1859,9.000,40,43,30,41,20,10,0,0,2769,1634,1367,663,278,0,253,68,0,0,70,190,NULL,0,'stiff_fix_outofdate_from_903','1145636095',0,0,0,7,30,4,20,0,0,0.46,'true',1,0),
(2523,25480,'Hisilrome''s Page','Raid Fighter','lienrik',12.00,50.00,64,'male','L2Minion','Fighter',40,61272,51.950,1859,9.000,40,43,30,41,20,10,0,0,2077,1634,769,663,278,0,253,0,0,0,100,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.46,'true',1,0),
(2524,25481,'Magus Kenishee','Raid Boss','banshee_50_bi',13.50,38.00,53,'female','L2RaidBoss','Mystic',40,66938,128.000,3718,10.000,60,57,73,76,70,80,1406722,209570,996,2433,274,988,409,0,3819,3939,0,0,80,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.56,'false',1,1),
(2525,25482,'Shadow of Kenishee','Raid Fighter','shadow',10.00,30.00,52,'male','L2Minion','Mystic',40,8629,43.040,1859,9.000,40,43,30,41,20,10,0,0,1806,1181,969,479,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.54,'true',1,0),
(2526,25483,'Phantom of Kenishee','Raid Fighter','silhouette',8.00,23.00,52,'female','L2Minion','Fighter',40,8629,43.040,1859,9.000,40,43,30,41,20,10,0,0,903,1181,242,479,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.54,'true',1,0),
(2527,25484,'Zaken''s Chief Mate Tillion','Raid Boss','skeleton_knight_50_bi',15.00,39.00,50,'male','L2RaidBoss','Fighter',40,369009,120.000,3718,10.000,60,57,73,76,70,80,1195137,169534,706,2226,159,1204,409,0,3819,160,0,0,40,190,NULL,0,'Magister','',0,0,0,7,30,4,20,0,-18,0.17,'false',1,1),
(2528,25485,'Tillion''s Inferior','Raid Fighter','skeleton_bi',11.00,31.00,49,'male','L2Minion','Fighter',40,7866,40.090,1859,9.000,40,43,30,41,20,10,0,0,1288,1079,572,438,278,0,253,131,0,0,60,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.30,'true',1,0),
(2529,25486,'Tillion''s Bat','Raid Fighter','vampire_bat',10.00,33.50,49,'male','L2Minion','Mystic',40,7866,40.090,1859,9.000,40,43,30,41,20,10,0,0,1288,1079,572,438,278,0,253,0,0,0,60,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,0.50,'true',1,0),
(2530,25487,'Water Spirit Lian','Raid Boss','pixy_bi',15.00,81.00,40,'female','L2RaidBoss','Fighter',40,218810,91.000,3718,10.000,60,57,73,76,70,80,915400,105938,243,1615,32,656,409,0,3819,0,0,0,80,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.72,'false',1,1),
(2531,25488,'Spirit of Gildor','Raid Fighter','pixy',5.00,25.00,39,'female','L2Minion','Fighter',40,14713,30.350,1859,9.000,40,43,30,41,20,10,0,0,299,780,54,317,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.72,'true',1,0),
(2532,25489,'Guardian of Gildor','Raid Fighter','pixy',5.00,25.00,39,'female','L2Minion','Fighter',40,21961,30.350,1859,9.000,40,43,30,41,20,10,0,0,449,780,121,317,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.72,'true',1,0),
(2533,25490,'Gwindorr','Raid Boss','serpent_slave',17.00,46.00,40,'male','L2RaidBoss','Fighter',40,218810,91.000,3718,10.000,60,57,73,76,70,80,915400,105938,243,1615,32,656,409,0,3819,129,0,0,70,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.46,'false',1,1),
(2534,25491,'Guard of Gwindorr','Raid Fighter','virud_lizardman_scout',10.00,22.00,39,'male','L2Minion','Ranger',500,3678,30.350,1859,9.000,40,43,30,41,20,10,0,0,665,780,54,317,278,0,253,2507,0,0,43,190,'',0,'Local','',0,0,0,7,30,4,20,1500,0,0.72,'true',1,0),
(2535,25492,'Follower of Gwindorr','Raid Fighter','virud_lizardman',10.00,23.00,39,'male','L2Minion','Fighter',40,10980,30.350,1859,9.000,40,43,30,41,20,10,0,0,224,780,30,317,278,0,253,2,0,0,43,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.48,'true',1,0),
(2536,25493,'Eva''s Spirit Niniel','Raid Boss','cutie_cat',8.00,15.00,55,'female','L2RaidBoss','Fighter',40,451391,134.000,3718,10.000,60,57,73,76,70,80,1432097,216652,1156,2576,336,1046,409,0,3819,0,0,0,48,190,NULL,0,'Magister','',0,0,0,7,30,4,20,0,-18,0.34,'false',1,1),
(2537,25494,'Spirit of Niniel','Raid Fighter','pixy',5.00,25.00,54,'female','L2Minion','Fighter',40,6091,44.980,1859,9.000,40,43,30,41,20,10,0,0,2187,1252,1685,508,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.72,'true',1,0),
(2538,25495,'Spirit of Niniel','Raid Fighter','pixy',5.00,25.00,54,'female','L2Minion','Fighter',40,23116,44.980,1859,9.000,40,43,30,41,20,10,0,0,1094,1252,420,508,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.72,'true',1,0),
(2539,25496,'Fafurion''s Envoy Pingolpin','Raid Boss','riba',25.00,72.00,52,'female','L2RaidBoss','Fighter',40,402319,125.000,3718,10.000,60,57,73,76,70,80,1393971,205212,914,2363,242,959,409,0,3819,0,0,0,60,190,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.45,'false',1,1),
(2540,25497,'Fafurion''s Envoy','Raid Fighter','marsh_stakato_soldier',10.00,25.00,51,'male','L2Minion','Fighter',40,8373,42.060,1859,9.000,40,43,30,41,20,10,0,0,1679,1147,879,465,278,0,253,76,0,0,30,190,NULL,0,'stiff_fix_outofdate_from_916','1145636095',0,0,0,7,30,4,20,0,0,0.74,'true',1,0),
(2541,25498,'Fafurion''s Henchman Istary','Raid Boss','farhite_50_bi',24.00,48.00,45,'male','L2RaidBoss','Fighter',40,51869,105.000,3718,10.000,60,57,73,76,70,80,1139085,129941,456,1905,86,774,409,0,3819,5131,0,0,15,190,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.74,'false',1,1),
(2542,25499,'Alligator of Istary','Raid Fighter','crocodile',28.00,11.50,44,'male','L2Minion','Fighter',40,6649,35.160,1859,9.000,40,43,30,41,20,10,0,0,826,922,307,374,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.41,'true',1,0),
(2543,25500,'Alligator of Istary','Raid Fighter','crocodile',28.00,11.50,44,'male','L2Minion','Fighter',40,14518,35.160,1859,9.000,40,43,30,41,20,10,0,0,413,922,76,374,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.41,'true',1,0),
-- TODO: no data stats for RB.
(2544,25501,'Boss Akata','Raid Boss','e_collector_teacher_Mdwarf_mon_130p',11.00,23.60,30,'male','L2RaidBoss','Fighter',40,127782,73.000,3718,10.000,60,57,73,76,70,80,636918,59660,96,406,9,554,409,0,2901,0,0,0,35,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,0.39,'false',1,1),
(2545,25502,'Akata''s Thug','Raid Fighter','e_traderB_Fdwarf_mon_120p',8.00,22.00,30,'male','L2Minion','Fighter',40,9093,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,0),
(2546,25503,'Akata''s Lackey','Raid Fighter','e_collector_teacher_Fdwarf_mon_120p',9.00,21.40,30,'male','L2Minion','Fighter',40,6786,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,0),
(2547,25504,'Nellis'' Vengeful Spirit','Raid Boss','a_mageguild_teacher_Mhuman_mon_120p',10.00,28.10,39,'male','L2RaidBoss','Fighter',40,206753,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,1),
(2548,25505,'Nellis'' Follower','Raid Fighter','dwarf_ghost',10.00,18.70,38,'male','L2Minion','Fighter',40,20752,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,0),
(2549,25506,'Rayito the Looter','Raid Boss','ol_mahum_champion_05te_120p',16.00,33.20,37,'male','L2RaidBoss','Fighter',40,184670,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,1),
(2550,25507,'Rayito''s Henchman','Raid Fighter','ol_mahum_05te_110p',14.50,28.00,36,'male','L2Minion','Fighter',40,18550,13.430,4000,3.090,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,134,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,0),
(2551,25508,'Rayito''s Henchman','Raid Fighter','northern_goblin_110p',6.00,16.60,36,'male','L2Minion','Fighter',40,12428,13.430,4000,3.090,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,135,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,0),
(2552,25509,'Dark Shaman Varangka','Raid Boss','batur_orc_shaman_a_01te_120p',13.00,20.80,53,'male','L2RaidBoss','Fighter',40,418874,0.000,0,0.000,40,57,73,76,70,80,440000,40000,8000,1800,6000,7260,300,500,333,0,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,1),
(2553,25510,'Varangka''s Descendant','Raid Fighter','batur_orc_overlord_01te_110p',13.00,26.90,52,'male','L2Minion','Fighter',40,42733,0.000,0,0.000,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,0),
(2554,25511,'Varangka''s Page','Raid Fighter','batur_orc_shaman_a_01te_110p',12.00,18.80,52,'male','L2Minion','Fighter',40,21366,0.000,0,0.000,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,0),
(2555,25512,'Gigantic Chaos Golem','Raid Boss','chaos_golem',31.00,51.80,52,'male','L2RaidBoss','Fighter',40,804638,0.000,0,0.000,40,57,73,76,70,80,440000,40000,9000,1800,6000,7260,300,0,333,0,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,1),
(2556,25514,'Queen Shyeed','Raid Boss','cannibal_stakato_leader_tran_120p',45.00,50.80,80,'male','L2RaidBoss','Fighter',40,714778,368.110,3718,9.810,60,57,73,76,70,80,3206477,835990,6959,1661,4585,2267,409,0,768,0,0,0,58,307,'',0,'Magister','',0,0,0,7,0,0,0,0,0,0.00,'false',1,1),
(2557,25515,'Spiked Stakato','Raid Fighter','spike_stakato_110p',13.00,21.00,79,'male','L2Minion','Fighter',40,50349,96.620,1859,9.810,40,43,30,41,20,10,0,0,10082,2434,9295,988,278,0,333,0,0,0,40,209,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.41,'false',1,0),
(2558,25516,'Spiked Stakato','Raid Fighter','spike_stakato_worker_110p',13.00,22.20,79,'male','L2Minion','Fighter',40,75148,98.020,1859,9.810,40,43,30,41,20,10,0,0,10082,2434,9295,988,278,0,333,0,0,0,40,209,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.41,'false',1,0),
(2559,25517,'Master Anays','Raid Boss','solina_priest_120p',16.00,41.80,87,'male','L2RaidBoss','Fighter',40,1069643,355.430,3718,9.810,60,57,73,76,70,80,3526018,952059,17006,1872,24162,2555,409,500,768,0,0,0,42,307,'',0,'Magister','',0,0,0,7,0,0,0,0,0,0.00,'false',1,1),
(2560,25518,'Splendor Disciple','Raid Fighter','apostle_grail',13.00,47.00,86,'male','L2Minion','Fighter',40,56245,95.020,1859,9.810,40,43,30,41,20,10,0,0,16392,2559,23362,1039,278,500,333,0,0,0,99,209,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.41,'false',1,0),
(2561,25519,'Splendor Worshiper','Raid Fighter','apostle_grail_a',13.00,47.00,86,'male','L2Minion','Fighter',40,75369,95.020,2110,9.810,40,43,30,41,20,10,0,0,11325,2315,18521,1075,278,500,333,0,0,0,99,209,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.41,'false',1,0),
(2562,25523,'Plague Golem','Raid Boss','stone_golem_bi',20.00,40.30,73,'male','L2RaidBoss','Fighter',40,1848045,0.000,0,0.000,40,57,73,76,70,80,440000,40000,9000,1800,6000,7260,300,500,333,0,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,1),
(2563,25524,'Flamestone Giant','Raid Boss','lava_golem',22.00,45.00,76,'male','L2RaidBoss','Fighter',40,956490,742.110,3247,9.810,60,57,73,76,70,80,4888056,961047,8153,1538,10359,2100,278,0,768,0,0,0,81,275,'',0,'Magister','',0,0,0,7,0,0,0,0,0,0.00,'false',1,1),
(2564,25525,'Flame Spirit','Raid Fighter','mana_vampire',11.00,20.00,75,'male','L2Minion','Fighter',40,100472,197.170,1601,9.810,40,43,30,21,20,10,0,0,15569,2094,39730,850,278,0,333,0,0,0,55,187,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.41,'false',1,0),
(2565,25526,'Charged Spirit','Raid Fighter','magical_weaver',11.00,20.00,75,'male','L2Minion','Fighter',40,50236,197.170,1601,9.810,40,43,30,21,20,10,0,0,7784,2094,9932,850,278,0,333,0,0,0,55,187,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.41,'false',1,0),
(2566,25527,'Uruka','Raid Boss','Crokian_Elder',30.00,42.51,87,'male','L2RaidBoss','Fighter',40,1532678,13.430,9999,3.090,40,57,73,76,70,80,440000,40000,9000,1800,6000,7260,300,500,333,0,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,1),
--
(2567,25528,'Tiberias','Prime Inspector','LineageMonster4.K_Examiner',10.00,24.62,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2568,25529,'Garden Guard','Vice Inspector','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2569,25530,'Garden Guard','Vice Inspector','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2570,25531,'Darnel','Square','LineageMonster4.Rah',20.00,40.60,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2571,25532,'Kechi','Fire','LineageMonster4.Keyache',12.00,29.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2572,25533,'Kechi''s Henchman','','LineageMonster3.Death_Blader_Raid',15.00,32.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,1472,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2573,25534,'Tears','Ice','LineageMonster4.tears',20.00,27.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2574,25535,'Tears','Ice','LineageMonster4.tears',20.00,27.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2575,25536,'Hannibal','Raid Boss','LineageMonster4.rah',20.00,40.60,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2576,25537,'Enmity','Raid Fighter','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2577,25538,'Vengeance','Raid Fighter','LineageMonster4.eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2578,25539,'Typhoon','Raid Boss','LineageMonster3.Death_Blader_Raid_sand',15.00,32.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2579,25540,'Demon Prince','Raid Boss','LineageMonster4.Rahuu',33.00,49.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2580,25541,'Fiend','Raid Fighter','LineageMonster3.Self_blaster',9.00,25.80,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2581,25542,'Ranku','Raid Boss','LineageMonster4.LaneCoo',13.00,29.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2582,25543,'Eidolon','Raid Fighter','LineageMonster4.eyeless_080p',20.00,35.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2583,25544,'Tully','Steel Citadel','LineageMonster4.Tollese',19.00,41.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2584,25545,'Tully''s Banshee','Raid Fighter','LineageMonster4.Giga_whirligig',33.00,47.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2585,25546,'Rhianna the Traitor','Forsaken Prisoner','LineageMonster.banshee_50_bi',13.50,38.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2586,25547,'Rhianna''s Escort','','LineageMonster.Binding',12.00,21.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2587,25548,'Rhianna''s Healer','','LineageMonster.Liviona',15.00,28.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2588,25549,'Tesla the Deceiver','Forsaken Prisoner','LineageMonster.Virud_lizardman_shaman',10.00,29.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2589,25550,'Tesla''s Apprentice','','LineageMonster.Zenta_lizardman_warrior',13.00,35.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2590,25551,'Tesla''s Herald','','LineageMonster.Virud_lizardman_warrior',12.00,30.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2591,25552,'Soul Hunter Chakundel','Forsaken Prisoner','LineageMonster3.Death_Blader_Raid',15.00,32.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,1472,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2592,25553,'Durango the Crusher','Forsaken Prisoner','LineageMonster3.Steel_Trapper',35.00,46.38,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2593,25554,'Brutus the Obstinate','Forsaken Prisoner','LineageMonster.Kaim_vanul',24.00,40.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2594,25555,'Brutus'' Right Hand','','LineageMonster.Death_blader',15.00,45.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,1472,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2595,25556,'Brutus'' Left Hand','','LineageMonster.Death_knight',24.00,29.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2596,25557,'Ranger Karankawa','Forsaken Prisoner','LineageMonster3.Jungle_Bleeze',60.00,47.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2597,25558,'Karankawa''s Root','','LineageMonster.mandragora_a',15.00,26.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2598,25559,'Karankawa''s Blossom','','LineageMonster.mandragora_b',12.00,25.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2599,25560,'Sargon the Mad','Forsaken Prisoner','LineageMonster.heltor_silenos_50_bi',19.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2600,25561,'Sargon Attendant','','LineageMonster.Heltor_silenos_shaman',13.00,32.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2601,25562,'Sargon''s Squire','','LineageMonster.Heltor_silenos_warrior',13.00,31.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2602,25563,'Beautiful Atrielle','Forsaken Prisoner','LineageMonster.succubus_100_bi',20.00,75.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2603,25564,'Atrielle''s Follower','','LineageMonster.Bloody_queen',8.00,40.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2604,25565,'Atrielle''s Minion','','LineageMonster.Silhouette',8.00,23.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2605,25566,'Nagen the Tomboy','Forsaken Prisoner','LineageMonster.pixy_bi',10.00,54.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2606,25567,'Nagen''s Cohort','','LineageMonster.Dryad',9.00,20.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2607,25568,'Nagen''s Friend','','LineageMonster.Dryad',9.00,20.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2608,25569,'Jax the Destroyer','Forsaken Prisoner','LineageMonster2.ketra_orc_chieftain_20_bi',17.00,46.20,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2609,25570,'Jax''s Vanguard','','LineageMonster.Ketra_orc_archer',12.00,27.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2610,25571,'Jax''s Raider','','LineageMonster.Ketra_orc',12.00,29.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(2611,25572,'Hager the Outlaw','Forsaken Inmate','LineageMonster.oel_mahum_witch_doctor_50_bi',22.50,54.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2612,25573,'Hager''s Henchman','','LineageMonster.oel_mahum_witch_doctor',15.00,34.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2613,25574,'Hager''s Bodyguard','','LineageMonster.oel_mahum_warrior',20.00,38.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2614,25575,'All-Seeing Rango','Forsaken Inmate','LineageMonster3.Kernon_Raider',33.00,51.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2615,25576,'Rango''s Iris','','LineageMonster.Monster_eye',21.00,43.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2616,25577,'Rango''s Lens','','LineageMonster.Field_stalker',15.00,30.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2617,25578,'Jakard','Forsaken Inmate','LineageMonster.hunter_gargoyle_50_bi',37.00,98.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2618,25579,'Helsing','Forsaken Inmate','LineageMonster3.lidia_von_helmann_120p',14.00,31.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2619,25580,'Helsing''s Guard','','LineageMonster.Death_knight',24.00,29.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2620,25581,'Helsing''s Assassin','','LineageMonster.skeleton_royal_guard',11.00,28.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2621,25582,'Gillien','Forsaken Inmate','LineageMonster2.Vampire_warrior',9.00,31.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2622,25583,'Gillien''s Daughter','','LineageMonster2.Vampire_wizard',5.50,28.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2623,25584,'Gillien''s Attendant','','LineageMonster2.Black_magician',8.00,30.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2624,25585,'Medici','Forsaken Inmate','LineageMonster.medusa_100_bi',20.00,53.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2625,25586,'Medici''s Sister','','LineageMonster2.Lilim_wizard',9.00,34.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2626,25587,'Medici''s Brother','','LineageMonster.Skeleton_royal_guard',11.00,28.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2627,25588,'Immortal Muus','Forsaken Inmate','LineageMonster.headless_knight_50_bi',30.00,46.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2628,25589,'Brand the Exile','Forsaken Inmate','LineageMonster.heltor_silenos_shaman_50_bi',19.50,51.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2629,25590,'Brand''s Chamberlain','','LineageMonster.Heltor_silenos_warrior',13.00,31.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2630,25591,'Brand''s Servant','','LineageMonster.Heltor_silenos_shaman',13.00,32.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2631,25592,'Commander Koenig','Forsaken Inmate','LineageMonster2.Ketra_warbeast',20.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2632,25593,'Gerg the Hunter','Forsaken Inmate','LineageMonster3.Elder_Troll',46.00,71.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2633,25594,'Gerg''s Follower','','LineageMonster.Virud_lizardman_scout',10.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2634,25595,'Gerg''s Henchman','','LineageMonster.Batur_orc',9.00,21.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2635,29001,'Queen Ant','','queen_ant',45.00,53.00,40,'female','L2Boss','Fighter',40,229898,496.000,667,10.000,60,57,73,76,70,80,2179536,140740,329,1615,77,655,278,0,1972,0,0,0,129,372,'queen_ant_clan',1000,'Local','',0,0,0,300,30,7,40,0,-18,0.37,'false',1,1),
(2636,29002,'Queen Ant Larva','','ant_larva',12.00,8.00,38,'male','L2Monster','Fighter',40,935,3.500,349,1.500,40,43,30,21,20,10,0,1,126,140,53,110,282,0,257,0,0,0,40,60,'queen_ant_clan',4500,'Local','',0,0,0,7,30,7,40,0,0,0.35,'true',0,0),
(2637,29003,'Nurse Ant','','ant',26.00,15.00,35,'male','L2Minion','Priest',40,6320,108.000,446,1.800,40,43,30,41,20,10,0,1,947,678,889,275,278,0,253,0,0,0,40,130,'queen_ant_clan',700,'Local','',0,0,0,7,30,7,40,0,0,0.26,'true',1,0),
(2638,29004,'Guard Ant','','ant',26.00,15.00,37,'male','L2Monster','Fighter',40,6861,115.000,480,1.800,40,43,30,41,20,10,0,1,269,728,62,295,278,500,253,0,0,0,40,230,'queen_ant_clan',700,'Local','',0,0,0,7,30,7,40,0,0,0.26,'true',1,0),
(2639,29005,'Royal Guard Ant','','ant',26.00,15.00,39,'male','L2Monster','Fighter',40,11140,122.000,514,1.800,40,43,30,41,20,10,0,1,1827,780,2576,316,278,0,253,0,0,0,40,230,'queen_ant_clan',700,'Local','',0,0,0,7,30,7,40,0,0,0.26,'true',0,0),
(2640,29006,'Core','','core',140.00,75.00,50,'male','L2Boss','Core',40,622493,656.000,575,10.000,60,57,73,76,70,80,2041407,153786,535,2226,500,904,278,0,1972,0,0,0,0,0,'curma_core_clan',2500,'Local','',0,0,0,10,30,7,40,0,-18,0.60,'false',1,1),
(2641,29007,'Death Knight','','death_knight',12.00,30.00,50,'male','L2Minion','Fighter',40,21830,166.000,830,2.100,40,43,30,41,20,10,0,1,683,1113,195,452,278,1050,253,75,0,0,27,110,'curma_core_clan',2300,'Local','',0,0,0,7,30,7,40,0,0,0.71,'true',1,0),
(2642,29008,'Doom Wraith','','death_blader',15.00,45.00,55,'male','L2Minion','Fighter',40,25298,185.000,987,2.400,40,43,30,41,20,10,0,1,812,1288,2170,522,278,950,253,1472,0,0,100,230,'curma_core_clan',700,'Local','',0,0,0,7,30,7,40,0,0,0.45,'true',1,0),
(2643,29009,'Dicor','','mandragora_b',12.00,25.50,47,'female','L2Monster','Fighter',40,19819,154.000,738,2.100,40,43,30,41,20,10,0,1,577,1015,162,412,278,650,253,0,0,0,80,120,'curma_core_clan',800,'Local','',0,0,0,7,30,7,40,0,0,0.13,'true',1,0),
(2644,29010,'Validus','','grave',15.00,29.00,46,'male','L2Monster','Fighter',40,19165,150.000,707,2.100,40,43,30,41,20,10,0,1,545,984,154,400,278,750,253,0,0,0,70,110,'curma_core_clan',1200,'Local','',0,0,0,7,30,7,40,0,0,0.30,'true',1,0),
(2645,29011,'Susceptor','','susceptor',20.00,35.00,49,'male','L2Minion','Fighter',40,21154,162.000,799,2.100,40,43,30,41,20,10,0,1,647,1080,184,438,278,850,253,0,0,0,27,150,'curma_core_clan',1500,'Local','',0,0,0,7,30,7,40,0,0,0.43,'true',1,0),
(2646,29012,'Perum','','iron_golem',18.00,34.00,48,'male','L2Monster','Mystic',40,20483,158.000,768,2.100,40,43,30,41,20,10,0,1,611,1048,173,425,278,750,253,0,0,0,20,20,'curma_core_clan',800,'Local','',0,0,0,7,30,7,40,0,0,0.41,'true',1,0),
(2647,29013,'Premo','','troll',21.00,35.00,45,'male','L2Monster','Fighter',40,18519,146.000,677,2.100,40,43,30,41,20,10,0,1,514,952,144,386,278,0,253,0,0,0,55,110,'curma_core_clan',1200,'Local','',0,0,0,7,30,7,40,0,0,0.61,'true',1,0),
(2648,29014,'Orfen','','orfen',35.00,143.00,50,'female','L2Boss','Fighter',40,622493,656.000,1660,10.000,60,57,73,76,70,80,2041407,153786,553,2226,124,904,278,500,1972,0,0,0,97,372,'orfen_clan',3000,'Tigra','',0,0,0,300,30,7,40,0,-18,0.71,'false',1,1),
(2649,29015,'Raikel','','raikel',37.00,64.00,48,'male','L2Monster','Fighter',40,10241,158.000,768,2.100,40,43,30,41,20,10,0,1,489,1048,109,425,278,0,253,0,0,0,60,230,'orfen_clan',2500,'Local','',0,0,0,7,30,7,40,0,0,0.54,'true',1,0),
(2650,29016,'Raikel Leos','','raikel',37.00,64.00,49,'male','L2Minion','Fighter',40,10576,162.000,799,2.100,40,43,30,41,20,10,0,1,1752,1080,4358,438,278,0,253,0,0,0,60,230,'orfen_clan',2700,'Local','',0,0,0,7,30,15,40,0,0,0.54,'true',1,0),
(2651,29017,'Riba','','riba',25.00,72.00,48,'female','L2Monster','Fighter',40,10241,158.000,768,2.100,40,43,30,41,20,10,0,1,489,1048,109,425,278,0,253,0,0,0,60,230,'orfen_clan',2700,'Local','',0,0,0,7,30,7,40,0,0,0.45,'true',1,0),
(2652,29018,'Riba Iren','','riba',25.00,72.00,49,'female','L2Monster','Fighter',40,21154,162.000,799,2.100,40,43,30,41,20,10,0,1,1752,1080,4358,438,278,500,253,0,0,0,60,230,'orfen_clan',2900,'Local','',0,0,0,7,30,7,40,0,0,0.45,'true',1,0),
(2653,29019,'Antharas','','antaras',300.00,300.00,79,'male','L2Boss','Fighter',40,14518000,2414.000,22197,265.000,60,57,73,76,70,80,262721136,29116376,13308,8064,28099,10000,333,800,2362,0,0,0,81,301,'',0,'Local','',0,0,0,14,30,4,40,0,-18,0.60,'false',1,1),
(2654,29020,'Baium','','baium',65.00,174.00,75,'male','L2Boss','Baium',40,4068372,675.000,3347,10.000,60,57,73,76,70,80,10253419,1081544,6559,6282,4378,9500,333,1000,2362,0,0,0,129,194,'',0,'Local','',0,0,0,13,30,4,40,0,-25,0.60,'false',0,1),
(2655,29021,'Archangel','','archangel',15.00,80.00,74,'male','L2Minion','Fighter',40,295325,158.000,3274,3.000,60,57,73,76,70,80,6571,343,1564,8326,5772,6100,333,0,2362,93,0,0,50,170,'',0,'Local','',0,0,0,7,30,4,40,0,-25,0.76,'false',0,0),
(2656,29022,'Zaken','','zaken',16.00,32.00,60,'male','L2Boss','Zaken',40,858518,825.000,1975,15.000,60,57,73,76,70,80,4879728,423589,7273,2951,19762,1197,333,0,2362,0,0,0,68,275,'',0,'Local','',0,0,0,300,30,4,40,0,-18,0.59,'false',1,1),
(2657,29023,'Doll Blader','','doll_blader',6.00,12.00,58,'male','L2Monster','Fighter',40,2888,6.500,1065,2.400,40,43,30,21,20,25,0,0,779,383,428,359,278,150,253,5129,0,0,22,150,'',0,'Local','',0,0,0,7,30,4,40,0,0,0.50,'true',0,0),
(2658,29024,'Vale master','','vale_master',12.00,40.00,59,'male','L2Monster','Fighter',40,2970,6.500,1102,2.400,40,43,30,21,20,25,0,0,818,395,452,369,278,150,253,0,0,0,70,155,'',0,'Local','',0,0,0,7,30,4,40,0,0,0.74,'true',0,0),
(2659,29025,'Baium','','baium_npc',65.00,82.00,75,'male','L2Npc','BaiumNpc',40,3698520,8.500,3347,3.000,60,57,73,76,70,80,0,0,3483,523,9402,850,409,0,2901,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,-18,0.60,'false',1,0),
(2660,29026,'Pirate Zombie Captain','','pirates_zombie_captain',17.00,28.00,60,'male','L2Monster','Fighter',40,3054,6.500,1029,2.400,40,43,30,21,20,25,0,0,750,405,477,379,317,150,289,232,0,0,14,140,'',0,'Local','',0,0,0,7,10,8,40,0,0,0.76,'true',0,0),
(2661,29027,'Pirate Zombie','','pirates_zombie',10.00,23.00,57,'male','L2Monster','Mystic',40,2806,6.500,747,2.100,40,43,30,21,20,25,0,0,649,373,404,349,317,150,289,225,0,0,11,140,'',0,'Local','',0,0,0,7,10,8,40,0,0,0.74,'true',0,0),
(2662,29028,'Valakas','','valakas',190.00,335.00,85,'male','L2Boss','Fighter',40,16660000,3313.000,22197,265.000,60,57,73,76,70,80,284286410,27215401,14375,7999,36620,10500,333,800,2362,0,0,0,194,486,'valakas_clan',300,'Local','',0,0,0,21,30,4,40,0,-18,0.60,'false',1,1),
(2663,29029,'Lavasaurus Elder','Family of Valakas','golem',13.00,75.00,83,'male','L2Monster','Mystic',500,4868,50.000,1972,4.000,40,43,30,21,20,10,0,0,4354,628,1258,510,249,500,227,0,0,0,1,1,'valakas_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.48,'true',0,0),
(2664,29030,'Fenril Hound Kerinne','Family of Valakas','bandersnatch_20_bi',21.00,30.00,81,'male','L2Monster','Fighter',40,256613,176.000,3793,10.000,60,57,73,76,70,80,2407887,1226568,10699,4700,10558,1908,409,0,2901,0,0,0,30,200,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,-18,0.49,'true',1,0),
(2665,29031,'Kerinne''s Ifrit','','ifrit',10.00,42.00,80,'male','L2Monster','Mystic',40,33984,35.200,1859,4.000,40,43,30,21,20,10,0,0,10275,2307,6886,937,278,0,253,0,0,0,38,170,'fire_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'true',0,0),
(2666,29032,'Kerinne''s Golem','','lava_golem',22.00,45.00,80,'male','L2Monster','Fighter',40,4697,50.000,1859,4.000,40,43,30,21,20,10,0,0,10275,2307,6886,937,278,0,253,0,0,0,13,60,'fire_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.47,'true',0,0),
(2667,29033,'Fenril Hound Freki','Family of Valakas','bandersnatch_20_bi',21.00,30.00,82,'male','L2Monster','Fighter',40,257118,175.500,3869,10.000,60,57,73,76,70,80,2434088,1257012,10997,4784,10896,1943,409,0,2901,0,0,0,30,200,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,-18,0.49,'true',1,0),
(2668,29034,'Freki''s Ifrit','','ifrit',10.00,42.00,81,'male','L2Monster','Mystic',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,14054,2350,12682,954,278,0,253,0,0,0,38,170,'fire_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'true',0,0),
(2669,29035,'Freki''s Golem','','lava_golem',22.00,45.00,81,'male','L2Monster','Fighter',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,253,0,0,0,13,60,'fire_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.47,'true',0,0),
(2670,29036,'Fenril Hound Uruz','Family of Valakas','bandersnatch_20_bi',21.00,30.00,83,'male','L2Monster','Fighter',40,514943,349.000,3945,10.000,60,57,73,76,70,80,2466262,1289662,22594,4869,11233,1977,409,0,2901,0,0,0,30,200,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,-18,0.49,'true',1,0),
(2671,29037,'Fenril Hound Kinaz','Family of Valakas','bandersnatch_20_bi',21.00,30.00,84,'male','L2Monster','Fighter',40,257674,174.000,4022,10.000,60,57,73,76,70,80,2504880,1322688,11600,4952,11569,2011,409,0,2901,0,0,0,30,200,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,-18,0.49,'true',1,0),
(2672,29038,'Kinaz''s Ifrit','','ifrit',10.00,42.00,81,'male','L2Monster','Mystic',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,14054,2350,12682,954,278,0,253,0,0,0,38,170,'fire_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'true',0,0),
(2673,29039,'Kinaz''s Ifrit','','ifrit',10.00,42.00,81,'male','L2Monster','Mystic',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,253,0,0,0,38,170,'fire_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'true',0,0),
(2674,29040,'Wings of Flame,Ixion','Gatekeeper of Valakas','inferno_drake_20_bi',29.00,42.00,85,'male','L2Monster','Fighter',40,515450,346.000,4099,10.000,60,57,73,76,70,80,2535975,1356048,23813,5036,11902,2045,409,0,2901,0,0,0,57,200,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,-18,0.48,'true',1,0),
(2675,29041,'Inferno Golem','','lava_golem',22.00,45.00,81,'male','L2Monster','Fighter',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,21134,2350,28532,954,278,0,253,0,0,0,13,60,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.47,'true',0,0),
(2676,29042,'Inferno Golem','','lava_golem',22.00,45.00,81,'male','L2Monster','Fighter',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,253,0,0,0,13,60,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.47,'true',0,0),
(2677,29043,'Howling Ifrit','','ifrit',10.00,42.00,81,'male','L2Monster','Mystic',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,253,0,0,0,38,170,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',0,0),
(2678,29044,'Howling Ifrit','','ifrit',10.00,42.00,81,'male','L2Monster','Mystic',40,34071,36.000,1896,4.000,40,43,30,21,20,10,0,0,14054,2350,12682,954,278,0,253,0,0,0,38,170,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',0,0),
(2679,29045,'Frintezza','','frintessa',45.00,42.70,90,'female','L2Boss','Fighter',40,753984,725.000,1380,10.000,40,43,30,21,20,10,1470000,13232,6427,4349,673,2933,300,0,333,0,0,0,38,170,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.32,'false',0,1),
(2680,29046,'Scarlet van Halisha','','follower_of_frintessa',45.00,90.70,85,'male','L2Boss','Fighter',40,1666000,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,1),
(2681,29047,'Scarlet van Halisha','','follower_of_frintessa_tran',92.00,112.80,90,'male','L2Boss','Fighter',40,2380000,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,1),
(2682,29048,'Evil Spirit','','Evilate',40.00,100.00,87,'male','L2Monster','Fighter',40,98750,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',0,0),
(2683,29049,'Evil Spirit','','Evilate',40.00,100.00,87,'male','L2Monster','Fighter',40,98750,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',0,0),
(2684,29050,'Breath of Halisha','','portrait_spirit',23.00,40.00,85,'male','L2Monster','Fighter',40,15798,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',0,0),
(2685,29051,'Breath of Halisha','','portrait_spirit_winged',23.00,40.00,85,'male','L2Monster','Fighter',40,15798,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',0,0),
(2686,29052,'Turnament Registration','','ti_mi_tran',23.00,90.00,80,'male','L2Npc','Turnir',40,4550,5.500,1660,2.100,60,57,73,76,70,80,0,0,1032,278,2360,452,409,0,2901,0,0,0,12,12,'all_elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(2687,29053,'','','Follower_Dummy',1.00,58.00,0,'male','L2Monster','Fighter',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(2688,29054,'Benom','Triol''s Leader','benom',20.00,56.00,75,'male','L2RaidBoss','Fighter',40,1352750,414.000,1494,10.000,40,43,30,21,20,10,587900,23560,16973,4188,31648,1701,409,0,3819,8203,8203,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.43,'false',0,1),
(2689,29055,'Teleportation Cubic','','teleport_npc',40.00,80.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(2690,29056,'Ice Fairy Sirra','Raid Boss','ice_fairy',16.00,35.60,60,'male','L2RaidBoss','Fighter',40,188376,335.000,2368,10.000,60,57,73,76,70,80,3446092,525780,3860,811,2006,1447,278,0,1972,0,0,0,50,275,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,0.43,'false',0,1),
(2691,29057,'Sirra''s Page','Raid Fighter','sylph_110p',12.00,39.70,59,'male','L2Minion','Fighter',40,12199,115.940,1150,7.200,40,43,30,41,20,10,0,0,3509,1437,3472,583,278,0,253,0,0,0,50,278,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.10,'false',0,0),
(2692,29058,'Sirra''s Beholder','Raid Fighter','field_stalker_20_bi',18.00,36.00,59,'male','L2Minion','Fighter',40,6099,115.940,1150,7.200,40,43,30,41,20,10,0,0,3509,1437,3472,583,278,0,253,0,0,0,50,278,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.10,'false',0,0),
(2693,29059,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2694,29060,'Captain of the Ice Queen''s Royal Guard','Raid Boss','gargoyle_02te_120p',19.00,61.00,59,'male','L2RaidBoss','Fighter',40,157517,313.000,2368,10.000,40,43,30,21,20,10,3246092,424780,3750,711,1998,1347,278,0,3819,0,0,0,50,275,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.46,'false',0,1),
(2695,29061,'Teleportation Cubic','','teleport_npc_frin',40.00,80.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(2696,29062,'Andreas Van Halter','Seer of Pagan','heretic_priest_110p',9.00,21.30,87,'male','L2RaidBoss','Fighter',40,257369,414.000,1450,10.000,40,57,73,76,70,80,3678541,615125,4112,914,2560,1678,278,0,1972,'','','',50,120,'','','darkevil','',0,'','',7,30,4,20,'','',0.00,'false',1,1),
(2697,29063,'Andreas''Acolyte','RaidFighter','heretic_privates',7.70,28.40,86,'male','L2Minion','Fighter',40,22780,120.000,1200,8.000,40,43,30,21,20,10,0,0,3750,1520,3515,600,278,0,253,0,0,0,50,278,'',0,'darkevil','',0,0,0,7,30,4,20,0,0,0.10,'false',0,0),
(2698,29064,'Andreas''Acolyte','RaidFighter','heretic_privates_a',7.70,28.40,85,'male','L2Minion','Fighter',40,34219,120.000,1200,8.000,40,43,30,21,20,10,0,0,3750,1520,3515,600,278,0,253,0,0,0,50,278,'',0,'darkevil','',0,0,0,7,30,4,20,0,0,0.10,'false',0,0),
(2699,29065,'Sailren','Sealed Evil Power','sailren',100.00,82.10,87,'male','L2RaidBoss','Fighter',40,1532678,414.000,3718,10.000,60,57,73,76,70,80,4526019,852059,17006,1872,24162,2555,409,0,2901,0,0,0,26,190,'0',0,'Magister','0',0,0,0,7,30,4,20,0,-18,0.50,'false',1,1),
(2700,29066,'Antharas','','antaras',300.00,300.00,79,'male','Antharas','Antharas',40,13090000,1000.000,22197,99.000,60,57,73,76,70,80,2627211,291163,13308,8064,28099,1641,333,0,2362,0,0,0,50,186,'',0,'Magister','',0,0,0,14,30,4,40,0,-18,0.60,'false',0,1),
(2701,29067,'Antharas','','antaras',300.00,300.00,79,'male','Antharas','Antharas',40,13090000,1000.000,22197,99.000,60,57,73,76,70,80,2627211,291163,13308,8064,28099,1641,333,0,2362,0,0,0,50,186,'',0,'Magister','',0,0,0,14,30,4,40,0,-18,0.60,'false',0,1),
(2702,29068,'Antharas','','antaras',300.00,300.00,79,'male','Antharas','Antharas',40,13090000,1000.000,22197,99.000,60,57,73,76,70,80,2627211,291163,13308,8064,28099,1641,333,0,2362,0,0,0,50,186,'',0,'Magister','',0,0,0,14,30,4,40,0,-18,0.60,'false',0,1),
(2703,29069,'Behemoth Dragon','','antaras_ex_a',63.00,54.00,78,'male','L2Monster','Fighter',40,350092,5.500,799,2.100,40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.52,'false',0,0),
(2704,29070,'Dragon Bomber','','antaras_ex_b_80p',37.00,28.00,78,'male','L2Monster','Fighter',40,2380,5.500,799,2.100,40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.52,'true',0,0),
(2705,29071,'Dragon Bomber','','antaras_ex_b_80p',37.00,28.00,78,'male','L2Monster','Fighter',40,2380,5.500,799,2.100,40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.52,'true',0,0),
(2706,29072,'Dragon Bomber','','antaras_ex_b_80p',37.00,28.00,78,'male','L2Monster','Fighter',40,2380,5.500,799,2.100,40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.52,'true',0,0),
(2707,29073,'Dragon Bomber','','antaras_ex_b_80p',37.00,28.00,78,'male','L2Monster','Fighter',40,2380,5.500,799,2.100,40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.52,'true',0,0),
(2708,29074,'Dragon Bomber','','antaras_ex_b_80p',37.00,28.00,78,'male','L2Monster','Fighter',40,2380,5.500,799,2.100,40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.52,'true',0,0),
(2709,29075,'Dragon Bomber','','antaras_ex_b_80p',37.00,28.00,78,'male','L2Monster','Fighter',40,2380,5.500,799,2.100,40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.52,'true',0,0),
(2710,29076,'Dragon Bomber','','antaras_ex_b',42.00,34.50,78,'male','L2Monster','Fighter',40,2380,5.500,799,2.100,40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,0.52,'true',0,0),
(2711,29077,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2712,29078,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2713,29079,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2714,29080,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2715,29081,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2716,29082,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2717,29083,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2718,29084,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2719,29085,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2720,29086,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2721,29087,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2722,29088,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2723,29089,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2724,29090,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2725,29091,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2726,29092,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2727,29093,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2728,29094,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(2729,29095,'Gordon','Knight of Destruction','Cruel_Rider',43.00,46.60,87,'male','L2RaidBoss','Gordon',40,2139287,302.000,138,10.000,60,57,73,76,70,80,3626219,962159,17006,1310,24162,1789,409,1000,3819,2500,0,0,40,307,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,0.48,'false',1,1),
(2730,29096,'Anais','Lord of Splendor','solina_priest_120p',16.00,41.80,87,'male','L2RaidBoss','Fighter',40,1069643,488.220,14718,18.000,60,57,73,76,70,80,6859833,1438431,7659,1715,6571,3422,409,0,3819,8214,0,0,60,160,NULL,0,'SYS','0',0,0,0,7,30,4,20,0,-18,0.19,'false',1,1),
(2731,29097,'Splendor Disciple','Raid Fighter','apostle_grail',13.00,47.00,86,'male','L2Minion','Fighter',40,56245,296.000,6245,9.000,60,57,73,76,70,80,159833,31431,5759,3944,2671,2891,278,0,333,8221,0,0,30,190,NULL,0,'SYS','0',0,0,0,7,30,4,20,0,-14,0.19,'false',1,0),
(2732,29098,'Splendor Worshiper','Raid Fighter','apostle_grail_a',13.00,47.00,86,'male','L2Minion','Ranger',500,75369,265.000,3541,9.000,60,57,73,76,70,80,291373,60391,5150,3984,2671,2891,278,0,333,0,0,0,30,190,NULL,0,'SYS','0',0,0,0,7,30,4,20,0,-14,0.19,'false',1,0),
(2733,29099,'Baylor','Warden','LineageMonster4.Barler',54.00,77.50,87,'male','L2RaidBoss','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2734,29100,'Crystal Prison Guard','','LineageMonster4.Eyeless',36.00,43.50,85,'male','L2Minion','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2735,29101,'Crystaline Golem','','LineageMonster4.Crystal_Golem',30.00,47.00,85,'male','L2Minion','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2736,29102,'Crystaline Golem','','LineageMonster4.Crystal_Golem',30.00,47.00,85,'male','L2Minion','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2737,29103,'Baylor','Warden','LineageMonster4.Barler',54.00,77.50,87,'male','L2RaidBoss','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2738,29104,'Crystal Prison Guard','','LineageMonster4.Eyeless',36.00,43.50,85,'male','L2Minion','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2739,29105,'Crystaline Golem','','LineageMonster4.Crystal_Golem',30.00,47.00,85,'male','L2Minion','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2740,29106,'','','LineageNPC.clear_npc',0.10,0.10,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2741,29107,'','','LineageNPC.clear_npc',0.10,0.10,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2742,29108,'','','LineageNPC.clear_npc',0.10,0.10,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2743,29109,'','','LineageNPC.clear_npc',0.10,0.10,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2744,29110,'','','LineageNPC.clear_npc',0.10,0.10,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2745,29111,'','','LineageNPC.clear_npc',0.10,0.10,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2746,29112,'','','LineageNPC.clear_npc',0.10,0.10,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2747,29113,'','','LineageNPC.clear_npc',0.10,0.10,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2748,29114,'','','LineageNPC.clear_npc',0.10,0.10,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2749,29115,'Crystal Prison Guard','','LineageMonster4.eyeless_080p',30.00,35.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2750,29116,'Baylor''s Treasure Chest','','LineageMonster.Mimic_even',8.50,8.50,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2751,29117,'Baylor''s Treasure Chest','','LineageMonster.Mimic_even',8.50,8.50,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(2752,18001,'Blood Queen','','bloody_queen',14.00,40.00,60,'female','L2Monster','Mystic',40,3054,6.500,1150,2.400,40,43,30,21,20,10,4536,394,860,368,478,299,278,500,253,0,0,0,80,160,'cave_servant_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(2753,18002,'Blood Queen','','bloody_queen',14.00,40.00,60,'female','L2Monster','Mystic',40,3054,6.500,1150,2.400,40,43,30,21,20,10,4536,394,860,368,478,299,278,500,253,0,0,0,80,160,'cave_servant_clan',400,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(2754,18003,'Bearded Keltir','','keltir',13.00,10.00,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,4,39,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,8,0,0,0,0.37,'true',0,0),
(2755,18004,'Susceptor Prime','','susceptor_prime',45.00,72.00,49,'male','L2Monster','Fighter',50,2168,5.500,799,2.100,40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,0.52,'true',0,0),
(2756,18005,'Mimic','','mimic',8.50,8.50,52,'male','L2Monster','Fighter',40,2479,6.500,892,2.400,40,43,30,21,20,10,3244,251,588,304,300,239,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,0.56,'true',0,0),
(2757,18006,'Maruk Lord','','death_blader',15.00,45.00,68,'male','L2Monster','Fighter',40,3825,7.500,1423,2.700,40,43,30,21,20,10,6057,586,1256,464,713,365,278,500,253,1472,0,0,100,170,'malruk_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',0,0),
(2758,18007,'Limal Karinness','','bloody_queen',14.00,40.00,69,'female','L2Monster','Mystic',40,3784,7.500,1458,2.700,40,43,30,21,20,10,5951,582,1392,460,821,373,278,500,253,0,0,0,80,140,'malruk_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',0,0),
(2759,18008,'Karik','','karik',25.00,90.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,6370,632,1445,470,858,382,278,500,253,0,0,0,37,200,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',0,0),
(2760,18009,'Offering of Branded Elder','','orc_fighter_bi',12.00,26.40,34,'male','L2FestivalMonster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1754,102,178,163,82,132,278,1000,253,127,0,0,45,30,'mercenary_siege_clan',500,'Local','',0,0,0,3,30,4,4,0,0,0.46,'false',0,0),
(2761,18010,'Offering of the Branded','','orc',10.00,21.00,32,'male','L2FestivalMonster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1523,86,134,129,69,123,237,1000,216,218,0,0,45,30,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.48,'false',0,0),
(2762,18011,'Offering of Branded Archer','','orc_archer',14.00,25.00,28,'male','L2FestivalMonster','Ranger',500,859,3.500,334,1.500,40,43,30,21,20,10,1001,53,251,110,49,106,249,1000,227,14,0,0,45,60,'',0,'Local','',0,0,0,3,10,8,0,1500,10,0.80,'false',0,0),
(2763,18012,'Offering of Branded Warrior','','orc_champion',10.00,23.00,29,'male','L2FestivalMonster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1026,55,122,135,53,110,278,1000,253,125,0,0,45,110,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.76,'false',0,0),
(2764,18013,'Offering of Branded Follower','','orc_fighter',12.00,22.00,29,'male','L2FestivalMonster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1227,66,107,115,53,110,237,1000,216,316,0,0,45,150,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.26,'false',0,0),
(2765,18014,'Offering of Branded Berserker','','orc_champion_20_bi',12.00,27.60,37,'male','L2FestivalMonster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,2276,140,222,182,104,147,278,1000,253,292,0,0,43,115,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.48,'false',0,0),
(2766,18015,'Offering of Branded Zealot','','orc_fighter_bi',12.00,26.40,34,'male','L2FestivalMonster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1650,96,156,138,82,132,237,1000,216,158,0,0,45,155,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2767,18016,'Offering of Branded Marksman','','orc_archer_20_bi',16.00,30.00,32,'male','L2FestivalMonster','Ranger',500,1056,4.500,397,1.800,40,43,30,21,20,10,1265,71,342,129,69,123,249,1000,227,273,0,0,45,130,'',0,'Local','',0,0,0,3,10,8,0,1500,10,0.80,'false',0,0),
(2768,18017,'Offering of Branded Disciple','','batur_orc',9.00,21.50,34,'male','L2FestivalMonster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1650,96,178,163,82,132,278,1000,253,129,0,0,80,165,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.46,'false',0,0),
(2769,18018,'Offering of Branded Saint','','batur_orc_20_bi',10.00,25.30,39,'male','L2FestivalMonster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,2171,138,255,195,121,158,278,1000,253,72,0,0,80,165,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.46,'false',0,0),
(2770,18019,'Apostate''s Offering Elder','','orc_champion_20_bi',12.00,27.60,45,'male','L2FestivalMonster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,3013,210,377,238,188,193,278,1000,253,72,0,0,45,30,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.76,'false',0,0),
(2771,18020,'Apostate''s Offering','','orc_fighter',12.00,22.00,43,'male','L2FestivalMonster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,2751,186,291,189,163,181,237,1000,216,223,0,0,45,30,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2772,18021,'Apostate''s Offering Archer','','batur_orc_archer',11.00,21.50,39,'male','L2FestivalMonster','Ranger',500,1462,4.500,514,1.800,40,43,30,21,20,10,1879,119,566,165,121,158,249,1000,227,275,0,0,45,60,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96,'false',0,0),
(2773,18022,'Apostate''s Offering Warrior','','batur_orc_warrior',10.00,20.00,40,'male','L2FestivalMonster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,1920,124,273,201,131,164,278,1000,253,127,0,0,80,115,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.30,'false',0,0),
(2774,18023,'Apostate''s Offering Follower','','batur_orc',9.00,21.50,40,'male','L2FestivalMonster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2296,148,238,171,131,164,237,1000,216,316,0,0,50,155,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.30,'false',0,0),
(2775,18024,'Apostate''s Offering Berserker','','batur_orc_warrior_20_bi',12.00,24.00,48,'male','L2FestivalMonster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,3832,280,453,261,231,212,278,1000,253,297,0,0,37,120,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2776,18025,'Apostate''s Offering Zealot','','batur_orc_20_bi',10.00,25.30,45,'male','L2FestivalMonster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,2891,201,330,202,188,193,237,1000,216,172,0,0,80,160,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2777,18026,'Apostate''s Offering Marksman','','batur_orc_archer_20_bi',13.00,25.30,43,'male','L2FestivalMonster','Ranger',500,1728,5.500,618,2.100,40,43,30,21,20,10,2285,154,739,189,163,181,249,1000,227,277,0,0,45,135,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96,'false',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(2778,18027,'Apostate''s Offering Disciple','','batur_orc_overlord',12.00,24.00,45,'male','L2FestivalMonster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,2891,201,377,238,188,193,278,1000,253,74,0,0,80,170,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2779,18028,'Apostate''s Offering Saint','','batur_orc_overlord_20_bi',14.00,28.80,50,'male','L2FestivalMonster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3570,269,509,278,264,226,278,1000,253,133,0,0,80,170,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2780,18029,'Witch''s Offering Elder','','batur_orc_warrior_20_bi',12.00,24.00,56,'male','L2FestivalMonster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,4666,383,706,331,382,269,278,1000,253,133,0,0,80,30,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.30,'false',0,0),
(2781,18030,'Witch''s Offering','','batur_orc',9.00,21.50,54,'male','L2FestivalMonster','Mystic',40,2562,6.500,955,2.400,40,43,30,21,20,10,4339,346,556,266,339,254,237,1000,216,226,0,0,80,30,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2782,18031,'Witch''s Offering Archer','','batur_orc_archer',11.00,21.50,50,'male','L2FestivalMonster','Mystic',500,2245,5.500,830,2.100,40,43,30,21,20,10,3090,233,1132,236,264,226,249,1000,227,278,0,0,45,70,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96,'false',0,0),
(2783,18032,'Witch''s Offering Warrior','','batur_orc_warrior',10.00,20.00,51,'male','L2FestivalMonster','Mystic',40,2323,6.500,861,2.400,40,43,30,21,20,10,3121,238,539,286,281,232,278,1000,253,72,0,0,80,120,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.30,'false',0,0),
(2784,18033,'Witch''s Offering Follower','','batur_orc',9.00,21.50,51,'male','L2FestivalMonster','Mystic',40,2323,6.500,861,2.400,40,43,30,21,20,10,3732,285,472,243,281,232,237,1000,216,316,0,0,50,160,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.30,'false',0,0),
(2785,18034,'Witch''s Offering Berserker','','batur_orc_warrior_20_bi',12.00,24.00,59,'male','L2FestivalMonster','Mystic',40,2971,6.500,1117,2.400,40,43,30,21,20,10,5789,495,820,359,453,291,278,1000,253,301,0,0,52,125,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.59,'false',0,0),
(2786,18035,'Witch''s Offering Zealot','','batur_orc_20_bi',10.00,25.30,56,'male','L2FestivalMonster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,4478,368,618,281,382,269,237,1000,216,91,0,0,80,165,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2787,18036,'Witch''s Offering Marksman','','batur_orc_archer_20_bi',13.00,25.30,54,'male','L2FestivalMonster','Mystic',500,2562,6.500,955,2.400,40,43,30,21,20,10,3604,287,1413,266,339,254,249,1000,227,282,0,0,45,140,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96,'false',0,0),
(2788,18037,'Witch''s Offering Disciple','','batur_orc_overlord',12.00,24.00,56,'male','L2FestivalMonster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,4478,368,706,331,382,269,278,1000,253,135,0,0,80,175,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2789,18038,'Witch''s Offering Saint','','batur_orc_overlord_20_bi',14.00,28.80,61,'male','L2FestivalMonster','Mystic',40,3137,7.500,1184,2.700,40,43,30,21,20,10,5313,468,901,378,505,307,278,1000,253,79,0,0,80,175,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2790,18039,'Dark Omen Offering Elder','','batur_orc_warrior_20_bi',12.00,24.00,67,'male','L2FestivalMonster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6679,636,1169,439,681,356,278,1000,253,79,0,0,80,30,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.30,'false',0,0),
(2791,18040,'Dark Omen Offering','','batur_orc',9.00,21.50,65,'male','L2FestivalMonster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6286,584,942,355,619,340,237,1000,216,234,0,0,80,30,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2792,18041,'Dark Omen Offering Archer','','batur_orc_archer',11.00,21.50,61,'male','L2FestivalMonster','Ranger',500,3137,7.500,1184,2.700,40,43,30,21,20,10,4599,405,2004,321,505,307,249,1000,227,283,0,0,45,70,'',0,'Local','',0,0,0,3,10,8,0,1500,10,0.96,'false',0,0),
(2793,18042,'Dark Omen Offering Warrior','','batur_orc_warrior',10.00,20.00,62,'male','L2FestivalMonster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,4612,411,944,388,532,315,278,1000,253,133,0,0,80,125,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.30,'false',0,0),
(2794,18043,'Dark Omen Offering Follower','','batur_orc',9.00,21.50,62,'male','L2FestivalMonster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,5516,492,826,330,532,315,237,1000,216,316,0,0,50,165,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.30,'false',0,0),
(2795,18044,'Dark Omen Offering Berserker','','batur_orc_warrior_20_bi',12.00,24.00,70,'male','L2FestivalMonster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,8149,808,1314,470,780,382,278,1000,253,97,0,0,52,130,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.59,'false',0,0),
(2796,18045,'Dark Omen Offering Zealot','','batur_orc_20_bi',10.00,25.30,67,'male','L2FestivalMonster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6410,610,1023,373,681,356,237,1000,216,2503,0,0,80,170,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2797,18046,'Dark Omen Offering Marksman','','batur_orc_archer_20_bi',13.00,25.30,65,'male','L2FestivalMonster','Ranger',500,3465,7.500,1319,2.700,40,43,30,21,20,10,5222,485,2393,355,619,340,249,1000,227,286,0,0,45,145,'',0,'Local','',0,0,0,3,10,8,0,1500,10,0.96,'false',0,0),
(2798,18047,'Dark Omen Offering Disciple','','batur_orc_overlord',12.00,24.00,67,'male','L2FestivalMonster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6410,610,1169,439,681,356,278,1000,253,142,0,0,80,180,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2799,18048,'Dark Omen Offering Saint','','batur_orc_overlord_20_bi',14.00,28.80,72,'male','L2FestivalMonster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,7402,752,1413,491,849,399,278,1000,253,2500,0,0,80,180,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2800,18049,'Offering of Forbidden Path Elder','','batur_orc_overlord_20_bi',14.00,28.80,78,'male','L2FestivalMonster','Fighter',40,4428,8.500,1784,3.000,40,43,30,21,20,10,9052,991,1715,555,1069,451,278,1000,253,2500,0,0,80,30,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2801,18050,'Offering of Forbidden Path','','batur_orc_warrior',10.00,20.00,76,'male','L2FestivalMonster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,8594,919,1412,454,994,433,237,1000,216,236,0,0,80,30,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.30,'false',0,0),
(2802,18051,'Offering of Forbidden Path Archer','','ketra_orc_archer',12.00,27.00,80,'male','L2FestivalMonster','Ranger',500,4663,8.500,1934,3.000,40,43,30,21,20,10,8310,955,4248,508,1220,485,249,1000,227,287,0,0,45,70,'',0,'Local','',0,0,0,3,10,8,0,1500,10,0.91,'false',0,0),
(2803,18052,'Offering of Forbidden Path Warrior','','ketra_orc_warrior',12.00,24.00,80,'male','L2FestivalMonster','Fighter',40,4550,8.500,1859,3.000,40,43,30,21,20,10,7680,862,1814,576,1144,468,278,1000,253,79,0,0,36,130,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.54,'false',0,0),
(2804,18053,'Offering of Forbidden Path Follower','','ketra_orc',12.00,29.00,80,'male','L2FestivalMonster','Fighter',40,4550,8.500,1859,3.000,40,43,30,21,20,10,9185,1031,1587,490,1144,468,237,1000,216,316,0,0,10,180,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.34,'false',0,0),
(2805,18054,'Offering of Forbidden Path Berserker','','ketra_orc_warrior_20_bi',14.00,28.80,81,'male','L2FestivalMonster','Fighter',40,4608,8.500,1896,3.000,40,43,30,21,20,10,10912,1239,1863,587,1182,477,278,1000,253,305,0,0,40,135,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.56,'false',0,0),
(2806,18055,'Offering of Forbidden Path Zealot','','ketra_orc_20_bi',14.00,34.80,78,'male','L2FestivalMonster','Fighter',40,4428,8.500,1784,3.000,40,43,30,21,20,10,8687,951,1500,472,1069,451,237,1000,216,175,0,0,45,195,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2807,18056,'Offering of Forbidden Path Marksman','','ketra_orc_archer_20_bi',14.00,32.40,76,'male','L2FestivalMonster','Ranger',500,4297,8.500,1710,3.000,40,43,30,21,20,10,7139,763,3587,454,994,433,249,1000,227,289,0,0,45,150,'',0,'Local','',0,0,0,3,10,8,0,1500,10,0.91,'false',0,0),
(2808,18057,'Offering of Forbidden Path Disciple','','ketra_orc_overload',12.00,24.00,78,'male','L2FestivalMonster','Fighter',40,4428,8.500,1784,3.000,40,43,30,21,20,10,8687,951,1715,555,1069,451,278,1000,253,151,0,0,33,195,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.48,'false',0,0),
(2809,18058,'Offering of Forbidden Path Saint','','ketra_orc_overload_20_bi',14.00,28.80,80,'male','L2FestivalMonster','Fighter',40,4716,8.500,1972,3.000,40,43,30,21,20,10,9837,1144,1959,608,1258,494,278,1000,253,2500,0,0,33,195,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.48,'false',0,0),
(2810,18059,'Offering of Branded Elder','','orc_fighter_bi',12.00,26.40,34,'male','L2FestivalMonster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1720,100,178,163,82,132,278,1000,253,127,0,0,45,30,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.46,'false',0,0),
(2811,18060,'Offering of the Branded','','orc',10.00,21.00,32,'male','L2FestivalMonster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,1523,86,134,129,69,123,237,1000,216,218,0,0,45,30,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.48,'false',0,0),
(2812,18061,'Offering of Branded Archer','','orc_archer',14.00,25.00,28,'male','L2FestivalMonster','Ranger',500,859,3.500,334,1.500,40,43,30,21,20,10,1001,53,251,110,49,106,249,1000,227,14,0,0,45,60,'',0,'Local','',0,0,0,3,10,8,0,1500,10,0.80,'false',0,0),
(2813,18062,'Offering of Branded Warrior','','orc_champion',10.00,23.00,29,'male','L2FestivalMonster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1026,55,122,135,53,110,278,1000,253,125,0,0,45,110,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.76,'false',0,0),
(2814,18063,'Offering of Branded Follower','','orc_fighter',12.00,22.00,29,'male','L2FestivalMonster','Fighter',40,906,3.500,349,1.500,40,43,30,21,20,10,1227,66,107,115,53,110,237,1000,216,316,0,0,45,150,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.26,'false',0,0),
(2815,18064,'Offering of Branded Berserker','','orc_champion_20_bi',12.00,27.60,37,'male','L2FestivalMonster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,2276,140,222,182,104,147,278,1000,253,292,0,0,43,115,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.48,'false',0,0),
(2816,18065,'Offering of Branded Zealot','','orc_fighter_bi',12.00,26.40,34,'male','L2FestivalMonster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1650,96,156,138,82,132,237,1000,216,158,0,0,45,155,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2817,18066,'Offering of Branded Marksman','','orc_archer_20_bi',16.00,30.00,32,'male','L2FestivalMonster','Ranger',500,1056,4.500,397,1.800,40,43,30,21,20,10,1265,71,342,129,69,123,249,1000,227,273,0,0,45,130,'',0,'Local','',0,0,0,3,10,8,0,1500,10,0.80,'false',0,0),
(2818,18067,'Offering of Branded Disciple','','batur_orc',9.00,21.50,34,'male','L2FestivalMonster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,1650,96,178,163,82,132,278,1000,253,129,0,0,80,165,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.46,'false',0,0),
(2819,18068,'Offering of Branded Saint','','batur_orc_20_bi',10.00,25.30,39,'male','L2FestivalMonster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,2171,138,255,195,121,158,278,1000,253,72,0,0,80,165,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.46,'false',0,0),
(2820,18069,'Apostate''s Offering Elder','','orc_champion_20_bi',12.00,27.60,45,'male','L2FestivalMonster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,3013,210,377,238,188,193,278,1000,253,72,0,0,45,30,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.76,'false',0,0),
(2821,18070,'Apostate''s Offering','','orc_fighter',12.00,22.00,43,'male','L2FestivalMonster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,2751,186,291,189,163,181,237,1000,216,223,0,0,45,30,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2822,18071,'Apostate''s Offering Archer','','batur_orc_archer',11.00,21.50,39,'male','L2FestivalMonster','Ranger',500,1462,4.500,514,1.800,40,43,30,21,20,10,1879,119,566,165,121,158,249,1000,227,275,0,0,45,60,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96,'false',0,0),
(2823,18072,'Apostate''s Offering Warrior','','batur_orc_warrior',10.00,20.00,40,'male','L2FestivalMonster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,1920,124,273,201,131,164,278,1000,253,127,0,0,80,115,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.30,'false',0,0),
(2824,18073,'Apostate''s Offering Follower','','batur_orc',9.00,21.50,40,'male','L2FestivalMonster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2296,148,238,171,131,164,237,1000,216,316,0,0,50,155,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.30,'false',0,0),
(2825,18074,'Apostate''s Offering Berserker','','batur_orc_warrior_20_bi',12.00,24.00,48,'male','L2FestivalMonster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,3832,280,453,261,231,212,278,1000,253,297,0,0,37,120,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2826,18075,'Apostate''s Offering Zealot','','batur_orc_20_bi',10.00,25.30,45,'male','L2FestivalMonster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,2891,201,330,202,188,193,237,1000,216,172,0,0,80,160,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2827,18076,'Apostate''s Offering Marksman','','batur_orc_archer_20_bi',13.00,25.30,43,'male','L2FestivalMonster','Ranger',500,1728,5.500,618,2.100,40,43,30,21,20,10,2285,154,739,189,163,181,249,1000,227,277,0,0,45,135,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96,'false',0,0),
(2828,18077,'Apostate''s Offering Disciple','','batur_orc_overlord',12.00,24.00,45,'male','L2FestivalMonster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,2891,201,377,238,188,193,278,1000,253,74,0,0,80,170,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2829,18078,'Apostate''s Offering Saint','','batur_orc_overlord_20_bi',14.00,28.80,50,'male','L2FestivalMonster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,3570,269,509,278,264,226,278,1000,253,133,0,0,80,170,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2830,18079,'Witch''s Offering Elder','','batur_orc_warrior_20_bi',12.00,24.00,56,'male','L2FestivalMonster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,4666,383,706,331,382,269,278,1000,253,133,0,0,80,30,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.30,'false',0,0),
(2831,18080,'Witch''s Offering','','batur_orc',9.00,21.50,54,'male','L2FestivalMonster','Mystic',40,2562,6.500,955,2.400,40,43,30,21,20,10,4339,346,556,266,339,254,237,1000,216,226,0,0,80,30,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2832,18081,'Witch''s Offering Archer','','batur_orc_archer',11.00,21.50,50,'male','L2FestivalMonster','Mystic',500,2245,5.500,830,2.100,40,43,30,21,20,10,3090,233,1132,236,264,226,249,1000,227,278,0,0,45,70,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96,'false',0,0),
(2833,18082,'Witch''s Offering Warrior','','batur_orc_warrior',10.00,20.00,51,'male','L2FestivalMonster','Mystic',40,2323,6.500,861,2.400,40,43,30,21,20,10,3121,238,539,286,281,232,278,1000,253,72,0,0,80,120,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.30,'false',0,0),
(2834,18083,'Witch''s Offering Follower','','batur_orc',9.00,21.50,51,'male','L2FestivalMonster','Mystic',40,2323,6.500,861,2.400,40,43,30,21,20,10,3732,285,472,243,281,232,237,1000,216,316,0,0,50,160,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.30,'false',0,0),
(2835,18084,'Witch''s Offering Berserker','','batur_orc_warrior_20_bi',12.00,24.00,59,'male','L2FestivalMonster','Mystic',40,2971,6.500,1117,2.400,40,43,30,21,20,10,5789,495,820,359,453,291,278,1000,253,301,0,0,52,125,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.59,'false',0,0),
(2836,18085,'Witch''s Offering Zealot','','batur_orc_20_bi',10.00,25.30,56,'male','L2FestivalMonster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,4478,368,618,281,382,269,237,1000,216,91,0,0,80,165,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2837,18086,'Witch''s Offering Marksman','','batur_orc_archer_20_bi',13.00,25.30,54,'male','L2FestivalMonster','Mystic',500,2562,6.500,955,2.400,40,43,30,21,20,10,3604,287,1413,266,339,254,249,1000,227,282,0,0,45,140,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,0.96,'false',0,0),
(2838,18087,'Witch''s Offering Disciple','','batur_orc_overlord',12.00,24.00,56,'male','L2FestivalMonster','Mystic',40,2724,6.500,1019,2.400,40,43,30,21,20,10,4478,368,706,331,382,269,278,1000,253,135,0,0,80,175,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2839,18088,'Witch''s Offering Saint','','batur_orc_overlord_20_bi',14.00,28.80,61,'male','L2FestivalMonster','Mystic',40,3137,7.500,1184,2.700,40,43,30,21,20,10,5313,468,901,378,505,307,278,1000,253,79,0,0,80,175,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2840,18089,'Dark Omen Offering Elder','','batur_orc_warrior_20_bi',12.00,24.00,67,'male','L2FestivalMonster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6679,636,1169,439,681,356,278,1000,253,79,0,0,80,30,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.30,'false',0,0),
(2841,18090,'Dark Omen Offering','','batur_orc',9.00,21.50,65,'male','L2FestivalMonster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,6286,584,942,355,619,340,237,1000,216,234,0,0,80,30,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2842,18091,'Dark Omen Offering Archer','','batur_orc_archer',11.00,21.50,61,'male','L2FestivalMonster','Ranger',500,3137,7.500,1184,2.700,40,43,30,21,20,10,4599,405,2004,321,505,307,249,1000,227,283,0,0,45,70,'',0,'Local','',0,0,0,3,10,8,0,1500,10,0.96,'false',0,0),
(2843,18092,'Dark Omen Offering Warrior','','batur_orc_warrior',10.00,20.00,62,'male','L2FestivalMonster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,4612,411,944,388,532,315,278,1000,253,133,0,0,80,125,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.30,'false',0,0),
(2844,18093,'Dark Omen Offering Follower','','batur_orc',9.00,21.50,62,'male','L2FestivalMonster','Fighter',40,3219,7.500,1217,2.700,40,43,30,21,20,10,5516,492,826,330,532,315,237,1000,216,316,0,0,50,165,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.30,'false',0,0),
(2845,18094,'Dark Omen Offering Berserker','','batur_orc_warrior_20_bi',12.00,24.00,70,'male','L2FestivalMonster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,8149,808,1314,470,780,382,278,1000,253,97,0,0,52,130,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.59,'false',0,0),
(2846,18095,'Dark Omen Offering Zealot','','batur_orc_20_bi',10.00,25.30,67,'male','L2FestivalMonster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6410,610,1023,373,681,356,237,1000,216,2503,0,0,80,170,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2847,18096,'Dark Omen Offering Marksman','','batur_orc_archer_20_bi',13.00,25.30,65,'male','L2FestivalMonster','Ranger',500,3465,7.500,1319,2.700,40,43,30,21,20,10,5222,485,2393,355,619,340,249,1000,227,286,0,0,45,145,'',0,'Local','',0,0,0,3,10,8,0,1500,10,0.96,'false',0,0),
(2848,18097,'Dark Omen Offering Disciple','','batur_orc_overlord',12.00,24.00,67,'male','L2FestivalMonster','Fighter',40,3626,7.500,1388,2.700,40,43,30,21,20,10,6410,610,1169,439,681,356,278,1000,253,142,0,0,80,180,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2849,18098,'Dark Omen Offering Saint','','batur_orc_overlord_20_bi',14.00,28.80,72,'male','L2FestivalMonster','Fighter',40,4013,8.500,1565,3.000,40,43,30,21,20,10,7402,752,1413,491,849,399,278,1000,253,2500,0,0,80,180,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2850,18099,'Offering of Forbidden Path Elder','','batur_orc_overlord_20_bi',14.00,28.80,78,'male','L2FestivalMonster','Fighter',40,4428,8.500,1784,3.000,40,43,30,21,20,10,9052,991,1715,555,1069,451,278,1000,253,2500,0,0,80,30,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.28,'false',0,0),
(2851,18100,'Offering of Forbidden Path','','batur_orc_warrior',10.00,20.00,76,'male','L2FestivalMonster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,8594,919,1412,454,994,433,237,1000,216,236,0,0,80,30,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.30,'false',0,0),
(2852,18101,'Offering of Forbidden Path Archer','','ketra_orc_archer',12.00,27.00,80,'male','L2FestivalMonster','Ranger',500,4663,8.500,1934,3.000,40,43,30,21,20,10,8310,955,4248,508,1220,485,249,1000,227,287,0,0,45,70,'',0,'Local','',0,0,0,3,10,8,0,1500,10,0.91,'false',0,0),
(2853,18102,'Offering of Forbidden Path Warrior','','ketra_orc_warrior',12.00,24.00,80,'male','L2FestivalMonster','Fighter',40,4550,8.500,1859,3.000,40,43,30,21,20,10,7680,862,1814,576,1144,468,278,1000,253,79,0,0,36,130,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.54,'false',0,0),
(2854,18103,'Offering of Forbidden Path Follower','','ketra_orc',12.00,29.00,80,'male','L2FestivalMonster','Fighter',40,4550,8.500,1859,3.000,40,43,30,21,20,10,9185,1031,1587,490,1144,468,237,1000,216,316,0,0,10,180,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.34,'false',0,0),
(2855,18104,'Offering of Forbidden Path Berserker','','ketra_orc_warrior_20_bi',14.00,28.80,80,'male','L2FestivalMonster','Fighter',40,4608,8.500,1896,3.000,40,43,30,21,20,10,10912,1239,1863,587,1182,477,278,1000,253,305,0,0,40,135,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.56,'false',0,0),
(2856,18105,'Offering of Forbidden Path Zealot','','ketra_orc_20_bi',14.00,34.80,78,'male','L2FestivalMonster','Fighter',40,4428,8.500,1784,3.000,40,43,30,21,20,10,8687,951,1500,472,1069,451,237,1000,216,175,0,0,45,195,'',0,'Local','',0,0,0,3,10,8,0,0,10,0.46,'false',0,0),
(2857,18106,'Offering of Forbidden Path Marksman','','ketra_orc_archer_20_bi',14.00,32.40,76,'male','L2FestivalMonster','Ranger',500,4297,8.500,1710,3.000,40,43,30,21,20,10,7139,763,3587,454,994,433,249,1000,227,289,0,0,45,150,'',0,'Local','',0,0,0,3,10,8,0,1500,10,0.91,'false',0,0),
(2858,18107,'Offering of Forbidden Path Disciple','','ketra_orc_overload',12.00,24.00,78,'male','L2FestivalMonster','Fighter',40,4428,8.500,1784,3.000,40,43,30,21,20,10,8687,951,1715,555,1069,451,278,1000,253,151,0,0,33,195,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.48,'false',0,0),
(2859,18108,'Offering of Forbidden Path Saint','','ketra_orc_overload_20_bi',14.00,28.80,83,'male','L2FestivalMonster','Fighter',40,4716,8.500,1972,3.000,40,43,30,21,20,10,9837,1144,1959,608,1258,494,278,1000,253,2500,0,0,33,195,'',0,'Local','',0,0,0,3,30,4,4,0,0,0.48,'false',0,0),
(2860,18109,'Treasures of the Festival','','coffer_a',12.00,9.50,30,'male','L2FestivalMonster','Fighter',0,999,3.500,365,1.500,40,43,30,21,20,10,90,0,0,140,0,114,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,0.56,'false',0,0),
(2861,18110,'Treasures of the Festival','','coffer_a',12.00,9.50,41,'male','L2FestivalMonster','Fighter',0,1488,5.500,560,2.100,40,43,30,21,20,10,168,0,0,208,0,169,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,0.56,'false',0,0),
(2862,18111,'Treasures of the Festival','','coffer_a',12.00,9.50,52,'male','L2FestivalMonster','Fighter',0,2058,6.500,892,2.400,40,43,30,21,20,10,270,0,0,295,0,239,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,0.56,'false',0,0),
(2863,18112,'Treasures of the Festival','','coffer_a',12.00,9.50,63,'male','L2FestivalMonster','Fighter',0,2640,7.500,1251,2.700,40,43,30,21,20,10,396,0,0,398,0,323,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,0.56,'false',0,0),
(2864,18113,'Treasures of the Festival','','coffer_a',12.00,9.50,72,'male','L2FestivalMonster','Fighter',0,3063,8.500,1565,3.000,40,43,30,21,20,10,518,0,0,491,0,399,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,0.56,'false',0,0),
(2865,18114,'Treasures of the Festival','','coffer_a',12.00,9.50,30,'male','L2FestivalMonster','Fighter',0,999,3.500,365,1.500,40,43,30,21,20,10,90,0,0,140,0,114,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,0.56,'false',0,0),
(2866,18115,'Treasures of the Festival','','coffer_a',12.00,9.50,41,'male','L2FestivalMonster','Fighter',0,1488,5.500,560,2.100,40,43,30,21,20,10,168,0,0,208,0,169,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,0.56,'false',0,0),
(2867,18116,'Treasures of the Festival','','coffer_a',12.00,9.50,52,'male','L2FestivalMonster','Fighter',0,2058,6.500,892,2.400,40,43,30,21,20,10,270,0,0,295,0,239,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,0.56,'false',0,0),
(2868,18117,'Treasures of the Festival','','coffer_a',12.00,9.50,63,'male','L2FestivalMonster','Fighter',0,2640,7.500,1251,2.700,40,43,30,21,20,10,396,0,0,398,0,323,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,0.56,'false',0,0),
(2869,18118,'Treasures of the Festival','','coffer_a',12.00,9.50,72,'male','L2FestivalMonster','Fighter',0,3063,8.500,1565,3.000,40,43,30,21,20,10,518,0,0,491,0,399,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,0.56,'false',0,0),
(2870,18119,'Corpse of Deadman','','zombie_corpse',13.00,21.00,63,'male','L2DeadMan','Mystic',40,3302,7.500,1251,2.700,40,43,30,21,20,10,0,0,987,398,560,323,278,0,253,0,0,0,15,0,'',0,'Local','',0,0,0,240,30,4,4,0,0,0.43,'false',1,0),
(2871,18120,'Halisha''s Officer','','imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48,'false',1,0),
(2872,18121,'Halisha''s Officer','','imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48,'false',1,0),
(2873,18122,'Halisha''s Officer','','imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster','RndTeleportFighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48,'false',1,0),
(2874,18123,'Halisha''s Officer','','imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48,'false',1,0),
(2875,18124,'Halisha''s Officer','','imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48,'false',1,0),
(2876,18125,'Halisha''s Officer','','imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster','RndTeleportFighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48,'false',1,0),
(2877,18126,'Halisha''s Officer','','imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48,'false',1,0),
(2878,18127,'Halisha''s Officer','','imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48,'false',1,0),
(2879,18128,'Halisha''s Officer','','imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster','RndTeleportFighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48,'false',1,0),
(2880,18129,'Halisha''s Officer','','imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48,'false',1,0),
(2881,18130,'Halisha''s Officer','','imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48,'false',1,0),
(2882,18131,'Halisha''s Officer','','imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster','RndTeleportFighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,0.48,'false',1,0),
(2883,18132,'Imperial Healer','','tera_beetle',19.00,54.50,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9949,1129,1540,782,807,635,278,0,253,0,0,0,45,170,'tomb1_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.59,'false',1,0),
(2884,18133,'Imperial Mosaic','','scorpion',28.00,66.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9190,1043,1630,587,1182,477,237,0,216,0,0,0,37,170,'tomb1_clan',600,'Local','',0,0,0,7,10,8,0,0,0,0.54,'false',1,0),
(2885,18134,'Imperial Mosaic','','scorpion',28.00,66.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6906,784,1630,587,1182,477,237,0,216,0,0,0,37,170,'tomb1_clan',600,'Local','',0,0,0,7,10,8,0,0,0,0.54,'false',1,0),
(2886,18135,'Imperial Mosaic','','scorpion',28.00,66.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9149,1039,1630,587,1182,477,237,0,216,0,0,0,37,170,'tomb1_clan',600,'Local','',0,0,0,7,10,8,0,0,0,0.54,'false',1,0),
(2887,18136,'Imperial Mosaic','','scorpion',28.00,66.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9190,1043,1482,710,977,577,237,0,216,0,0,0,37,170,'tomb1_clan',600,'Local','',0,0,0,7,10,8,0,0,0,0.54,'false',1,0),
(2888,18137,'Imperial Mosaic','','scarab',14.00,22.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6812,773,1863,587,1182,477,278,0,253,0,0,0,45,180,'tomb1_clan',600,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(2889,18138,'Imperial Mosaic','','scarab',14.00,22.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9069,1029,1863,587,1182,477,278,0,253,0,0,0,45,180,'tomb1_clan',600,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(2890,18139,'Imperial Mosaic','','scarab',14.00,22.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,8935,1014,1863,587,1182,477,278,0,253,0,0,0,45,180,'tomb1_clan',600,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(2891,18140,'Imperial Mosaic','','scarab',14.00,22.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9065,1029,1694,710,977,577,278,0,253,0,0,0,45,180,'tomb1_clan',600,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(2892,18141,'Beetle of Grave','','scarab',14.00,22.00,81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(2893,18142,'Beetle of Grave','','scarab',14.00,22.00,81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(2894,18143,'Beetle of Grave','','scarab',14.00,22.00,81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(2895,18144,'Beetle of Grave','','scarab',14.00,22.00,81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(2896,18145,'Beetle of Grave','','scarab',14.00,22.00,81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,7399,840,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(2897,18146,'Beetle of Grave','','scarab',14.00,22.00,81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,7568,859,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(2898,18147,'Beetle of Grave','','scarab',14.00,22.00,81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,7046,800,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(2899,18148,'Beetle of Grave','','scarab',14.00,22.00,81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,8203,931,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(2900,18149,'Beetle of Grave','','scarab',14.00,22.00,81,'male','L2Monster','Fighter',40,4608,34.000,1896,3.000,40,43,30,21,20,10,7247,823,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',1,0),
(2901,18150,'Victim','','a_tombkeeperA',7.00,23.00,81,'female','L2Npc','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(2902,18151,'Victim','','a_tombkeeperA',7.00,23.00,81,'female','L2Npc','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(2903,18152,'Victim','','a_tombkeeperA',7.00,23.00,81,'female','L2Npc','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(2904,18153,'Victim','','a_tombkeeperA',7.00,23.00,81,'female','L2Npc','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(2905,18154,'Victim','','a_tombkeeperA',7.00,23.00,81,'female','L2Npc','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(2906,18155,'Victim','','a_tombkeeperA',7.00,23.00,81,'female','L2Npc','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(2907,18156,'Victim','','a_tombkeeperA',7.00,23.00,81,'female','L2Npc','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(2908,18157,'Victim','','a_tombkeeperA',7.00,23.00,81,'female','L2Npc','npc',40,4608,8.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(2909,18158,'Executioner of Halisha','','erinyes',21.00,50.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2910,18159,'Executioner of Halisha','','erinyes',21.00,50.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2911,18160,'Executioner of Halisha','','erinyes',21.00,50.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2912,18161,'Executioner of Halisha','','erinyes',21.00,50.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2913,18162,'Executioner of Halisha','','erinyes',21.00,50.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2914,18163,'Executioner of Halisha','','erinyes',21.00,50.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2915,18164,'Executioner of Halisha','','erinyes',21.00,50.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2916,18165,'Executioner of Halisha','','erinyes',21.00,50.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2917,18166,'Imperial Guard','','death_knight',12.00,30.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7005,795,2255,534,1731,433,278,0,253,142,0,0,27,110,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(2918,18167,'Imperial Guard','','death_knight',12.00,30.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6906,784,1694,710,977,577,278,0,253,142,0,0,27,110,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(2919,18168,'Imperial Guard','','death_knight',12.00,30.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7099,806,1863,587,1182,477,278,0,253,142,0,0,27,110,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(2920,18169,'Imperial Guard','','death_knight',12.00,30.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6872,780,1694,710,977,577,278,0,253,142,0,0,27,110,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(2921,18170,'Imperial Guard','','death_knight',12.00,30.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6879,781,2170,485,2095,394,237,0,216,0,0,0,80,160,'tomb3_clan',600,'Local','',0,0,0,7,10,8,0,0,0,0.56,'false',1,0),
(2922,18171,'Imperial Guard','','death_knight',12.00,30.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7147,811,1347,782,807,635,237,0,216,0,0,0,80,160,'tomb3_clan',600,'Local','',0,0,0,7,10,8,0,0,0,0.56,'false',1,0),
(2923,18172,'Imperial Guard','','death_knight',12.00,30.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6812,773,1630,587,1182,477,237,0,216,0,0,0,80,160,'tomb3_clan',600,'Local','',0,0,0,7,10,8,0,0,0,0.56,'false',1,0),
(2924,18173,'Halisha''s Foreman','','kaim_vanul',24.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7557,858,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(2925,18174,'Halisha''s Foreman','','kaim_vanul',24.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(2926,18175,'Halisha''s Foreman','','kaim_vanul',24.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7133,810,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(2927,18176,'Halisha''s Foreman','','kaim_vanul',24.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7557,858,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(2928,18177,'Halisha''s Foreman','','kaim_vanul',24.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(2929,18178,'Halisha''s Foreman','','kaim_vanul',24.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7133,810,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(2930,18179,'Halisha''s Foreman','','kaim_vanul',24.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7557,858,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(2931,18180,'Halisha''s Foreman','','kaim_vanul',24.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(2932,18181,'Halisha''s Foreman','','kaim_vanul',24.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7133,810,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(2933,18182,'Halisha''s Foreman','','kaim_vanul',24.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7557,858,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45,'true',1,0),
(2934,18183,'Halisha''s Foreman','','kaim_vanul',24.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(2935,18184,'Halisha''s Foreman','','kaim_vanul',24.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,7133,810,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,0.45,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(2936,18185,'Evil Astrologer','','doll_blader',6.00,12.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9413,1069,1694,710,977,577,278,0,253,5129,5129,0,22,150,'tomb4_clan',600,'Local','',0,0,184,7,30,4,4,0,0,0.50,'false',1,0),
(2937,18186,'Evil Astrologer','','doll_blader',6.00,12.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9467,1075,1694,710,977,577,278,0,253,5129,5129,0,22,150,'tomb4_clan',600,'Local','',0,0,184,7,30,4,4,0,0,0.50,'false',1,0),
(2938,18187,'Knight of Darkness','','death_lord',21.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9190,1043,2255,534,1731,433,278,0,253,78,0,0,40,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(2939,18188,'Knight of Darkness','','death_lord',21.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6906,784,2255,534,1731,433,278,0,253,78,0,0,40,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(2940,18189,'Knight of Darkness','','death_lord',21.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9149,1039,2255,534,1731,433,278,0,253,78,0,0,40,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(2941,18190,'Knight of Darkness','','death_lord',21.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9190,1043,2255,534,1731,433,278,0,253,78,0,0,40,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(2942,18191,'Witch of dust','','banshee',9.00,23.00,81,'female','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6812,773,2255,534,1731,433,278,0,253,3939,0,0,80,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(2943,18192,'Witch of dust','','banshee',9.00,23.00,81,'female','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9069,1029,2255,534,1731,433,278,0,253,3939,0,0,80,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(2944,18193,'Witch of dust','','banshee',9.00,23.00,81,'female','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,8935,1014,2255,534,1731,433,278,0,253,3939,0,0,80,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(2945,18194,'Witch of dust','','banshee',9.00,23.00,81,'female','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9065,1029,2255,534,1731,433,278,0,253,3939,0,0,80,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(2946,18195,'Signet of Emperor','','ant_larva',12.00,8.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6946,788,3001,401,3068,325,278,0,253,0,0,0,40,60,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',1,0),
(2947,18196,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2948,18197,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2949,18198,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2950,18199,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2951,18200,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2952,18201,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2953,18202,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2954,18203,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2955,18204,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2956,18205,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2957,18206,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2958,18207,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2959,18208,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2960,18209,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2961,18210,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2962,18211,'Charm of Corner','','magmagoil_lad',15.00,75.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2963,18212,'Archon of Halisha','','ahrimanes',14.00,57.75,81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2964,18213,'Archon of Halisha','','ahrimanes',14.00,57.75,81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2965,18214,'Archon of Halisha','','ahrimanes',14.00,57.75,81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2966,18215,'Archon of Halisha','','ahrimanes',14.00,57.75,81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2967,18216,'Archon of Halisha','','ahrimanes',14.00,57.75,81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2968,18217,'Archon of Halisha','','ahrimanes',14.00,57.75,81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2969,18218,'Archon of Halisha','','ahrimanes',14.00,57.75,81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2970,18219,'Archon of Halisha','','ahrimanes',14.00,57.75,81,'male','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2971,18220,'Shaman of Darkness','','banshee',9.00,23.00,81,'female','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9467,1075,2050,587,1431,477,278,0,253,3939,0,0,80,160,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(2972,18221,'Shaman of Darkness','','banshee',9.00,23.00,81,'female','L2Monster','Mystic',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9721,1103,2050,587,1431,477,278,0,253,3939,0,0,80,160,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(2973,18222,'Assassin of Darkness','','ashuras',13.00,37.50,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9210,1045,2480,485,2095,394,278,0,253,0,0,0,41,190,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(2974,18223,'Assassin of Darkness','','ashuras',13.00,37.50,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6906,784,1863,587,1182,477,278,0,253,0,0,0,41,190,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(2975,18224,'Assassin of Darkness','','ashuras',13.00,37.50,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9303,1056,2480,485,2095,394,278,0,253,0,0,0,41,190,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(2976,18225,'Assassin of Darkness','','ashuras',13.00,37.50,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9210,1045,1863,587,1182,477,278,0,253,0,0,0,41,190,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(2977,18226,'Caster of Darkness','','vale_master',12.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,6812,773,2480,485,2095,394,278,0,253,0,0,0,70,155,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.74,'false',1,0),
(2978,18227,'Caster of Darkness','','vale_master',12.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11706,1329,1863,587,1182,477,278,0,253,0,0,0,70,155,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.74,'false',1,0),
(2979,18228,'Caster of Darkness','','vale_master',12.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,8801,999,2480,485,2095,394,278,0,253,0,0,0,70,155,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.74,'false',1,0),
(2980,18229,'Caster of Darkness','','vale_master',12.00,40.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,9065,1029,1863,587,1182,477,278,0,253,0,0,0,70,155,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.74,'false',1,0),
(2981,18230,'Signet of Emperor','','ant_larva',12.00,8.00,81,'male','L2Monster','Fighter',40,4608,25.500,1896,3.000,40,43,30,21,20,10,7495,851,3001,401,3068,325,278,0,253,0,0,0,40,60,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',1,0),
(2982,18231,'Statue of Protection','','temple_guard_a',15.00,42.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2983,18232,'Statue of Protection','','temple_guard_a',15.00,42.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2984,18233,'Statue of Protection','','temple_guard_a',15.00,42.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2985,18234,'Statue of Protection','','temple_guard_a',15.00,42.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2986,18235,'Statue of Protection','','temple_guard_a',15.00,42.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2987,18236,'Statue of Protection','','temple_guard_a',15.00,42.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2988,18237,'Statue of Protection','','temple_guard_a',15.00,42.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2989,18238,'Statue of Protection','','temple_guard_a',15.00,42.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2990,18239,'Statue of Protection','','temple_guard_a',15.00,42.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2991,18240,'Statue of Protection','','temple_guard_a',15.00,42.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2992,18241,'Statue of Protection','','temple_guard_a',15.00,42.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2993,18242,'Statue of Protection','','temple_guard_a',15.00,42.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(2994,18243,'Statue of Protection','','temple_guard_a',15.00,42.00,81,'male','L2Monster','Fighter',40,4608,51.000,1896,3.000,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(2995,18244,'Watchman of Grave','','mana_vampire',11.00,20.00,81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,253,0,0,0,90,1,'tomb1_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(2996,18245,'Watchman of Grave','','mana_vampire',11.00,20.00,81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1694,710,977,577,278,0,253,0,0,0,90,1,'tomb1_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(2997,18246,'Watchman of Grave','','mana_vampire',11.00,20.00,81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,90,1,'tomb1_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(2998,18247,'Watchman of Grave','','mana_vampire',11.00,20.00,81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,253,0,0,0,90,1,'tomb2_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(2999,18248,'Watchman of Grave','','mana_vampire',11.00,20.00,81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1694,710,977,577,278,0,253,0,0,0,90,1,'tomb2_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3000,18249,'Watchman of Grave','','mana_vampire',11.00,20.00,81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,90,1,'tomb2_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3001,18250,'Watchman of Grave','','mana_vampire',11.00,20.00,81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,253,0,0,0,90,1,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3002,18251,'Watchman of Grave','','mana_vampire',11.00,20.00,81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1694,710,977,577,278,0,253,0,0,0,90,1,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3003,18252,'Watchman of Grave','','mana_vampire',11.00,20.00,81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,90,1,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3004,18253,'Watchman of Grave','','mana_vampire',11.00,20.00,81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,253,0,0,0,90,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3005,18254,'Watchman of Grave','','mana_vampire',11.00,20.00,81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1694,710,977,577,278,0,253,0,0,0,90,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3006,18255,'Watchman of Grave','','mana_vampire',11.00,20.00,81,'male','L2Monster','Mystic',40,3456,25.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,90,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3007,18256,'Halisha''s Treasure Box','','mimic',8.50,8.50,85,'male','L2Monster','Fighter',40,1,0.000,1,0.000,40,43,30,21,20,10,0,0,2,1,1,1,1,0,1,0,0,0,80,1,NULL,0,'Local',NULL,0,0,0,7,0,0,0,0,0,0.56,'true',0,0),
(3008,18257,'Treasure Chest','','mimic',8.50,8.50,85,'male','L2Chest','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3009,18258,'Treasure Chest','','mimic',8.50,8.50,85,'male','L2Chest','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3010,18259,'Treasure Chest','','mimic',8.50,8.50,85,'male','L2Chest','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3011,18260,'Treasure Chest','','mimic',8.50,8.50,85,'male','L2Chest','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3012,18261,'Treasure Chest','','mimic',8.50,8.50,85,'male','L2Chest','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3013,18262,'Treasure Chest','','mimic',8.50,8.50,85,'male','L2Chest','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3014,18263,'Treasure Chest','','mimic',8.50,8.50,85,'male','L2Chest','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3015,18264,'Treasure Chest','','mimic',8.50,8.50,85,'male','L2Chest','Fighter',40,4969,3.000,2049,3.000,40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3016,18265,'Treasure Chest','','mimic',8.50,8.50,21,'male','L2Chest','Fighter',40,594,1.500,227,1.500,40,43,30,21,20,10,0,0,63,101,25,82,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3017,18266,'Treasure Chest','','mimic',8.50,8.50,24,'male','L2Chest','Fighter',40,710,1.500,272,1.500,40,43,30,21,20,10,0,0,81,115,34,93,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3018,18267,'Treasure Chest','','mimic',8.50,8.50,27,'male','L2Chest','Fighter',40,840,1.500,318,1.500,40,43,30,21,20,10,0,0,104,129,45,105,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3019,18268,'Treasure Chest','','mimic',8.50,8.50,30,'male','L2Chest','Fighter',40,985,1.500,365,1.500,40,43,30,21,20,10,0,0,132,145,58,118,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(3020,18269,'Treasure Chest','','mimic',8.50,8.50,33,'male','L2Chest','Fighter',40,1145,1.800,413,1.800,40,43,30,21,20,10,0,0,166,162,75,132,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(3021,18270,'Treasure Chest','','mimic',8.50,8.50,36,'male','L2Chest','Fighter',40,1320,1.800,463,1.800,40,43,30,21,20,10,0,0,206,181,96,147,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(3022,18271,'Treasure Chest','','mimic',8.50,8.50,39,'male','L2Chest','Fighter',40,1510,1.800,514,1.800,40,43,30,21,20,10,0,0,255,201,121,163,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3023,18272,'Treasure Chest','','mimic',8.50,8.50,42,'male','L2Chest','Fighter',40,1713,2.100,589,2.100,40,43,30,21,20,10,0,0,311,222,152,181,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3024,18273,'Treasure Chest','','mimic',8.50,8.50,45,'male','L2Chest','Fighter',40,1930,2.100,677,2.100,40,43,30,21,20,10,0,0,377,245,188,199,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(3025,18274,'Treasure Chest','','mimic',8.50,8.50,48,'male','L2Chest','Fighter',40,2159,2.100,768,2.100,40,43,30,21,20,10,0,0,453,270,231,219,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(3026,18275,'Treasure Chest','','mimic',8.50,8.50,51,'male','L2Chest','Fighter',40,2398,2.400,861,2.400,40,43,30,21,20,10,0,0,539,296,281,240,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(3027,18276,'Treasure Chest','','mimic',8.50,8.50,54,'male','L2Chest','Fighter',40,2645,2.400,955,2.400,40,43,30,21,20,10,0,0,636,323,339,262,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3028,18277,'Treasure Chest','','mimic',8.50,8.50,57,'male','L2Chest','Fighter',40,2897,2.400,1052,2.400,40,43,30,21,20,10,0,0,743,351,405,285,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3029,18278,'Treasure Chest','','mimic',8.50,8.50,60,'male','L2Chest','Fighter',40,3153,2.400,1150,2.400,40,43,30,21,20,10,0,0,860,380,478,309,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3030,18279,'Treasure Chest','','mimic',8.50,8.50,63,'male','L2Chest','Fighter',40,3408,2.700,1251,2.700,40,43,30,21,20,10,0,0,987,411,560,334,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3031,18280,'Treasure Chest','','mimic',8.50,8.50,66,'male','L2Chest','Fighter',40,3661,2.700,1353,2.700,40,43,30,21,20,10,0,0,1123,442,649,359,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3032,18281,'Treasure Chest','','mimic',8.50,8.50,69,'male','L2Chest','Fighter',40,3906,2.700,1458,2.700,40,43,30,21,20,10,0,0,1265,474,746,385,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3033,18282,'Treasure Chest','','mimic',8.50,8.50,72,'male','L2Chest','Fighter',40,4142,3.000,1565,3.000,40,43,30,21,20,10,0,0,1413,507,849,412,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3034,18283,'Treasure Chest','','mimic',8.50,8.50,75,'male','L2Chest','Fighter',40,4365,3.000,1673,3.000,40,43,30,21,20,10,0,0,1563,540,957,438,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3035,18284,'Treasure Chest','','mimic',8.50,8.50,78,'male','L2Chest','Fighter',40,4571,3.000,1784,3.000,40,43,30,21,20,10,0,0,1715,573,1069,465,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3036,18285,'Treasure Chest','','mimic',8.50,8.50,81,'male','L2Chest','Fighter',40,4757,3.000,1896,3.000,40,43,30,21,20,10,0,0,1863,606,1182,492,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3037,18286,'Treasure Chest','','mimic',8.50,8.50,84,'male','L2Chest','Fighter',40,4920,3.000,2011,3.000,40,43,30,21,20,10,0,0,2006,639,1296,519,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3038,18287,'Otherworldly Invader Food','','mimic',8.50,8.50,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,0,0,166,157,75,128,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(3039,18288,'Otherworldly Invader Food','','mimic',8.50,8.50,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(3040,18289,'Dimension Invader Food','','mimic',8.50,8.50,43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,0,0,332,223,163,181,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(3041,18290,'Dimension Invader Food','','mimic',8.50,8.50,45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(3042,18291,'Purgatory Invader Food','','mimic',8.50,8.50,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,0,0,602,304,319,247,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(3043,18292,'Purgatory Invader Food','','mimic',8.50,8.50,55,'male','L2Monster','Fighter',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(3044,18293,'Forbidden Path Invader Food','','mimic',8.50,8.50,63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,0,0,987,398,560,323,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(3045,18294,'Forbidden Path Invader Food','','mimic',8.50,8.50,65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(3046,18295,'Dark Omen Invader Food','','mimic',8.50,8.50,73,'male','L2Monster','Fighter',40,4086,8.500,1601,3.000,40,43,30,21,20,10,0,0,1463,502,885,407,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(3047,18296,'Dark Omen Invader Food','','mimic',8.50,8.50,75,'male','L2Monster','Fighter',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(3048,18297,'Messenger Invader Food','','mimic',8.50,8.50,83,'male','L2Monster','Fighter',40,4716,8.500,1972,3.000,40,43,30,21,20,10,0,0,1959,608,1258,494,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(3049,18298,'Messenger Invader Food','','mimic',8.50,8.50,85,'male','L2Monster','Fighter',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'true',1,0),
(3050,18299,'Flame of the Branded','','big_boom',6.00,13.00,35,'male','L2Monster','Fighter',40,1220,13.500,446,1.800,40,43,30,21,20,10,1631,96,192,169,89,137,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(3051,18300,'Offering of the Branded,Evoked Spirit','','orc',10.00,21.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1751,100,166,157,75,128,278,0,253,158,0,0,45,155,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',0,0),
(3052,18301,'Flame of Apostates','','big_boom',6.00,13.00,46,'male','L2Monster','Fighter',40,1943,16.500,707,2.100,40,43,30,21,20,10,2817,199,401,245,202,199,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(3053,18302,'Offering of Apostates,Evoked Spirit','','orc_fighter',12.00,22.00,44,'male','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,3113,213,354,230,176,187,278,0,253,172,0,0,45,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3054,18303,'Flame of the Witch','','big_boom',6.00,13.00,57,'male','L2Monster','Mystic',40,2806,19.500,1052,2.400,40,43,30,21,20,10,4326,359,743,340,405,276,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(3055,18304,'Offering of the Witch,Evoked Spirit','','batur_orc',9.00,21.50,55,'male','L2Monster','Mystic',40,2643,6.500,987,2.400,40,43,30,21,20,10,4864,393,670,322,360,261,278,0,253,91,0,0,80,165,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3056,18305,'Flame of Dark Omen','','big_boom',6.00,13.00,68,'male','L2Monster','Fighter',40,3706,22.500,1423,2.700,40,43,30,21,20,10,6157,594,1217,449,713,365,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(3057,18306,'Offering of Dark Omen,Evoked Spirit','','batur_orc',9.00,21.50,66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,7004,659,1123,428,649,348,278,0,253,2503,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3058,18307,'Flame of Forbidden Path','','big_boom',6.00,13.00,79,'male','L2Monster','Fighter',40,4490,25.500,1821,3.000,40,43,30,21,20,10,8311,921,1765,566,1107,459,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(3059,18308,'Offering of /Forbidden Path,Evoked Spirit','','batur_orc_warrior',10.00,20.00,77,'male','L2Monster','Fighter',40,4364,8.500,1747,3.000,40,43,30,21,20,10,9533,1032,1664,544,1031,442,278,0,253,175,0,0,80,175,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',0,0),
(3060,18309,'Flame of the Branded','','big_boom',6.00,13.00,35,'male','L2Monster','Fighter',40,1220,13.500,446,1.800,40,43,30,21,20,10,1631,96,192,169,89,137,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(3061,18310,'Offering of the Branded,Evoked Spirit','','orc',10.00,21.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,1751,100,166,157,75,128,278,0,253,158,0,0,45,155,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',0,0),
(3062,18311,'Flame of Apostates','','big_boom',6.00,13.00,46,'male','L2Monster','Fighter',40,1943,16.500,707,2.100,40,43,30,21,20,10,2817,199,401,245,202,199,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(3063,18312,'Offering of Apostates,Evoked Spirit','','orc_fighter',12.00,22.00,44,'male','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,3113,213,354,230,176,187,278,0,253,172,0,0,45,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3064,18313,'Flame of the Witch','','big_boom',6.00,13.00,57,'male','L2Monster','Mystic',40,2806,19.500,1052,2.400,40,43,30,21,20,10,4326,359,743,340,405,276,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(3065,18314,'Offering of the Witch,Evoked Spirit','','batur_orc',9.00,21.50,55,'male','L2Monster','Mystic',40,2643,6.500,987,2.400,40,43,30,21,20,10,4864,393,670,322,360,261,278,0,253,91,0,0,80,165,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3066,18315,'Flame of Dark Omen','','big_boom',6.00,13.00,68,'male','L2Monster','Fighter',40,3706,22.500,1423,2.700,40,43,30,21,20,10,6157,594,1217,449,713,365,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(3067,18316,'Offering of Dark Omen,Evoked Spirit','','batur_orc',9.00,21.50,66,'male','L2Monster','Fighter',40,3546,7.500,1353,2.700,40,43,30,21,20,10,7004,659,1123,428,649,348,278,0,253,2503,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3068,18317,'Flame of Forbidden Path','','big_boom',6.00,13.00,79,'male','L2Monster','Fighter',40,4490,25.500,1821,3.000,40,43,30,21,20,10,8311,921,1765,566,1107,459,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(3069,18318,'Offering of Forbidden Path,Evoked Spirit','','batur_orc_warrior',10.00,20.00,77,'male','L2Monster','Fighter',40,4364,8.500,1747,3.000,40,43,30,21,20,10,9533,1032,1664,544,1031,442,278,0,253,175,0,0,80,175,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',0,0),
(3070,18319,'Caught Frog','','poison_toad',20.00,10.00,10,'male','L2PenaltyMonster','CaughtFighter',40,257,2.000,120,0.900,40,43,30,21,20,10,421,14,22,52,8,49,278,0,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.35,'false',0,0),
(3071,18320,'Caught Undine','','undine',12.00,27.00,20,'female','L2PenaltyMonster','CaughtMystic',40,541,2.500,213,1.200,40,43,30,21,20,10,843,37,57,80,23,76,278,0,253,0,0,0,60,120,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.35,'false',0,0),
(3072,18321,'Caught Rakul','','rakul',30.00,39.00,30,'male','L2PenaltyMonster','CaughtFighter',40,954,3.500,365,1.500,40,43,30,21,20,10,1550,85,132,119,58,114,278,0,253,156,0,0,60,130,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.59,'false',0,0),
(3073,18322,'Caught Sea Giant','','water_giant',13.00,44.00,40,'male','L2PenaltyMonster','CaughtFighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,2755,178,273,171,131,164,278,0,253,131,0,0,35,140,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.45,'false',0,0),
(3074,18323,'Caught Sea Horse Soldier','','theeder',9.00,32.00,50,'male','L2PenaltyMonster','CaughtFighter',80,2245,5.500,830,2.100,40,43,30,21,20,10,4305,324,509,236,264,226,237,0,216,291,0,0,80,150,'',0,'Local','',0,0,0,7,30,4,0,0,10,0.45,'false',0,0),
(3075,18324,'Caught Homunculus','','homunculus',12.00,32.50,60,'male','L2PenaltyMonster','CaughtFighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,6200,538,860,313,478,299,278,0,253,0,0,0,30,160,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.50,'false',0,0),
(3076,18325,'Caught Flava','','flava',18.00,34.00,70,'male','L2PenaltyMonster','CaughtFighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,8438,837,1314,399,780,382,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.45,'false',0,0),
(3077,18326,'Caught Gigantic Eye','','hundred_eye',21.00,55.00,80,'male','L2PenaltyMonster','CaughtMystic',40,4550,8.500,1859,3.000,40,43,30,21,20,10,11022,1237,1814,490,1144,468,278,0,253,0,0,0,30,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.54,'false',0,0),
(3078,18327,'Freya''s Servant','','gargoyle_02te',16.00,50.00,58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'',300,'Local','',0,0,0,7,10,8,0,0,0,0.46,'true',0,0),
(3079,18328,'Hall Alarm Device','','grave_keeper_key',8.00,21.00,80,'etc','L2Npc','npc',40,158000,2.000,989,0.900,40,43,30,21,20,10,0,0,652,753,358,295,423,0,385,0,0,0,50,120,'',0,'Local','',0,0,0,7,0,4,3,0,0,0.60,'false',0,0),
(3080,18329,'Hall Keeper Captain','','death_lord',21.00,40.00,80,'male','L2Monster','Fighter',40,4716,17.000,1972,3.000,40,43,30,21,20,10,10475,1217,1619,736,1258,494,278,150,253,0,0,0,30,165,'hall_keeper_clan',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',0,0),
(3081,18330,'Hall Keeper Wizard','','vale_master',12.00,40.00,80,'male','L2Monster','Mystic',40,4550,8.500,1859,3.000,40,43,30,21,20,10,11022,1237,1814,490,1144,468,278,0,253,0,0,0,30,180,'hall_keeper_clan',0,'Local','',0,0,0,7,50,1,9,0,10,0.54,'true',0,0),
(3082,18331,'Hall Keeper Guard','','death_knight',12.00,30.00,80,'male','L2Monster','Fighter',40,4663,17.000,1934,3.000,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'hall_keeper_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.45,'true',0,0),
(3083,18332,'Hall Keeper Patrol','','headless_knight',21.00,31.00,80,'male','L2Monster','Fighter',40,4608,17.000,1896,3.000,40,43,30,21,20,10,9976,1133,1540,710,1182,477,278,150,253,0,0,0,35,170,'hall_keeper_clan',0,'Local','',0,0,0,7,50,1,9,0,0,0.54,'true',0,0),
(3084,18333,'Hall Keeper Suicidal Soldier','','self_blaster',9.00,25.80,80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'hall_keeper_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.61,'true',0,0),
(3085,18334,'Dark Choir Captain','','erinyes_cmd',21.00,50.00,85,'male','L2Monster','Fighter',40,4813,17.000,2049,3.000,40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,150,253,0,0,0,23,190,'dark_choir_clan',0,'Local','',0,0,0,7,30,4,4,0,10,0.54,'true',0,0),
(3086,18335,'Dark Choir Prima Donna','','portrait_spirit',23.00,40.00,80,'male','L2Monster','Mystic',40,4663,17.000,1934,3.000,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'dark_choir_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.45,'true',0,0),
(3087,18336,'Dark Choir Lancer','','death_blader',15.00,45.00,80,'male','L2Monster','Fighter',40,4663,17.000,1934,3.000,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'dark_choir_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.45,'true',0,0),
(3088,18337,'Dark Choir Archer','','skeleton_archer_20_bi',13.00,32.50,80,'male','L2Monster','Ranger',500,4663,17.000,1934,3.000,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'dark_choir_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.45,'true',0,0),
(3089,18338,'Dark Choir Witch Doctor','','portrait_spirit_winged',23.00,40.00,80,'male','L2Monster','Mystic',40,4663,17.000,1934,3.000,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'dark_choir_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.45,'true',0,0),
(3090,18339,'Dark Choir Player','','skeleton',11.00,25.00,80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'dark_choir_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.61,'true',0,0),
(3091,18340,'Hall Keeper Suicidal Soldier','','self_blaster',9.00,25.80,80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'',300,'Local','',0,0,0,7,50,1,9,0,0,0.61,'true',0,0),
(3092,18341,'Hall Keeper Suicidal Soldier','','self_blaster',9.00,25.80,80,'male','L2Monster','Fighter',40,4550,34.000,1859,3.000,40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'',300,'Local','',0,0,0,7,50,1,9,0,0,0.61,'true',0,0),
(3093,18342,'Gremlin','','gremlin',10.00,15.00,1,'male','L2Monster','Fighter',40,62,2.000,44,0.900,40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,20,50,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(3094,18343,'Gatekeeper Zombie','','zombie_gateguard',17.00,30.50,80,'male','L2Monster','GatekeeperZombie',40,4716,17.000,1972,3.000,40,43,30,21,20,10,10475,1217,2249,736,1258,494,200,500,182,8217,0,0,20,165,'pagan_clan',1000,'SYS','',0,0,0,7,50,1,9,0,0,0.46,'false',1,0),
(3095,18344,'Ancient Egg','','dinosaur_nest',43.00,33.50,80,'male','L2Monster','NoRndWalkFighter',0,100,4.740,3,3.090,40,43,30,21,20,10,0,0,1,606,1,1182,300,0,333,0,0,0,0,0,'NULL',0,'Local','NULL',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,0),
(3096,18345,'Sprigant','','Arachnoid',45.00,67.00,80,'male','L2Monster','NoRndWalkFighter',40,1179,13.430,2057,3.090,40,43,30,21,20,10,0,0,2129,615,2129,511,300,500,333,0,0,0,0,0,'NULL',0,'Local','NULL',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,0),
(3097,18346,'Sprigant','','Arachnoid',45.00,67.00,80,'male','L2Monster','NoRndWalkFighter',40,1179,13.430,2057,3.090,40,43,30,21,20,10,0,0,2129,615,2129,511,300,500,333,0,0,0,0,0,'NULL',0,'Local','NULL',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',1,0),
(3098,18347,'Garden Guard','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(3099,18348,'Garden Guard','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3100,18349,'Garden Guard','','LineageMonster4.Mostro_Gunner',15.00,24.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3101,18350,'Garden Guard','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3102,18351,'Garden Guard','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3103,18352,'Kamael Guard','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(3104,18353,'Guardian of Records','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3105,18354,'Guardian of Observation','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3106,18355,'Spicula''s Guard','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3107,18356,'Harkilgamed''s Gatekeeper','','LineageMonster4.Mostro_Gunner',15.00,24.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3108,18357,'Rodenpicula''s Gatekeeper','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3109,18358,'Guardian of Secrets','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3110,18359,'Arviterre''s Guardian','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3111,18360,'Katenar''s Gatekeeper','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3112,18361,'Guardian of Prediction','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3113,18362,'Garden Guard','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3114,18363,'Garden Guard','','LineageMonster4.Mostro_Gunner',15.00,24.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3115,18364,'Witch Warder','','LineageMonster.Onyx_beast',14.00,14.50,79,'male','L2Monster','WitchWarder',40,22454,26.860,3680,0.900,40,43,30,21,20,10,0,0,3530,962,2214,918,278,0,333,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(3116,18365,'Witch Warder','','LineageMonster.Onyx_beast',14.00,14.50,80,'male','L2Monster','WitchWarder',40,22754,26.860,3680,0.900,40,43,30,21,20,10,0,0,3450,950,2114,890,278,0,333,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(3117,18366,'Witch Warder','','LineageMonster.Onyx_beast',14.00,14.50,82,'male','L2Monster','WitchWarder',40,23319,26.860,3680,0.900,40,43,30,21,20,10,0,0,4250,1150,2780,1005,278,0,333,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(3120,18369,'Chromatic Crystaline Golem','','LineageMonster4.Crystal_Golem',30.00,47.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3121,18370,'Chromatic Crystaline Golem','','LineageMonster4.Crystal_Golem',30.00,47.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3122,18371,'Beleth Sample','','LineageMonster3.zombie_gateguard',17.00,30.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3123,18372,'Beleth Sample','','LineageMonster3.Zombie_laborer',11.00,24.60,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3124,18373,'Beleth Sample','','LineageMonster3.Zombie_enlisted_man',17.00,22.30,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3125,18374,'Beleth Sample','','LineageMonster3.Zombie_knight',17.00,22.30,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3126,18375,'Beleth Sample','','LineageMonster.Skeleton_royal_guard',11.00,28.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3127,18376,'Beleth Sample','','LineageMonster.Vale_master',16.00,47.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3128,18377,'Beleth Sample','','LineageMonster.Skeleton_knight',10.00,25.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3165,18414,'Warrior''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3166,18415,'Midway Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3167,18416,'Doorman','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3168,18417,'Bridge Keeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3169,18418,'Bridge Keeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3170,18419,'Bridge Keeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3195,18444,'Garden Guard','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3196,18445,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3197,18446,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3198,18447,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3199,18448,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3200,18449,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3201,18450,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3202,18451,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3203,18452,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3204,18453,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3205,18454,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3206,18455,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3207,18456,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3208,18457,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3209,18458,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3210,18459,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3211,18460,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3212,18461,'Tully''s Gatekeeper','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3213,18462,'Remnant Wraith','','LineageMonster3.solina_brother',9.00,23.40,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3214,18463,'Remnant Diabolist','','LineageNPC.e_traderB_Fdwarf_mon_120p',8.00,22.00,1,'female','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3215,18464,'Remnant Diviner','','LineageNPC.a_mageguild_teacher_Mhuman_mon',8.00,23.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3216,18465,'Derek','First Generation Seer','LineageNPC.a_mageguild_teacher_Mhuman_mon_120p',10.00,28.10,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3217,18466,'Outpost Captain','','LineageMonster3.Benom',20.00,56.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3218,18467,'Wounded Land Guard','','LineageMonster4.Eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3219,18468,'Doorman','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3220,18469,'Hall Guard','','LineageMonster.blade_stakato_120p',18.00,43.20,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3221,18470,'Hall Guard','','LineageMonster.blade_stakato_soldier_120p',23.00,45.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3222,18471,'Hall Guard','','LineageMonster4.Anthias',20.00,41.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3223,18472,'Hall Guard','','LineageMonster4.Anthias',20.00,41.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3224,18473,'Hall Captain','','LineageMonster3.cannibal_stakato_leader_120p',20.00,48.80,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3225,18474,'Alarm','','LineageNpcEV.trioll_altar',9.00,33.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3226,18475,'Hall Guard','','LineageMonster.undine',12.00,27.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3227,18476,'Hall Guard','','LineageMonster.lienrik_210p',12.00,50.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3228,18477,'Coral Treasure Chest','','LineageMonster.mimic_even',8.50,8.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3229,18478,'Herb Jar','','LineageNpcEV.herb_pot',8.00,21.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3230,18479,'Inner Castle Sentry','','LineageMonster.kel_mahum',13.00,26.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3231,18480,'Inner Castle Guard','','LineageMonster4.Eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3232,18481,'Inner Castle Seer','','LineageMonster4.Eyeless',36.00,43.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3233,18482,'Fafurion Kindred','','LineageMonster3.Water_Drake',35.00,58.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3234,18483,'Garden Guard','','LineageMonster4.Mostro_Fighter',15.50,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3235,18484,'Naia Failan','','LineageNPC.heart_of_warding',17.00,75.00,0,'female','L2Npc','npc',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',0,0),
(3236,18485,'','','LineageNPC.clear_npc',0.10,0.10,0,'male','L2Npc','npc',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',0,0),
(3237,18486,'','','LineageNPC.clear_npc',0.10,0.10,0,'male','L2Npc','npc',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',0,0),
(3238,18487,'','','LineageNPC.clear_npc',0.10,0.10,0,'male','L2Npc','npc',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',0,0),
(3239,18488,'','','LineageNPC.clear_npc',0.10,0.10,0,'male','L2Npc','npc',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',0,0),
(3240,18489,'','','LineageNPC.clear_npc',0.10,0.10,0,'male','L2Npc','npc',40,2444,0.000,0,0.000,40,43,30,21,20,10,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'true',0,0),
(3241,27001,'Orc Sniper','','orc_archer',14.00,25.00,10,'male','L2Monster','Ranger',500,257,2.000,120,0.900,40,43,30,21,20,10,0,0,51,61,8,49,249,0,227,14,0,0,45,110,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',0,0),
(3242,27002,'Orc Fighter','','orc_fighter',12.00,22.00,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,0,0,27,66,10,54,278,0,253,1,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3243,27003,'Spirit Of Mirrors','Quest Monster','poison_toad',20.00,10.00,9,'male','L2Monster','Fighter',40,226,2.000,111,0.900,40,43,30,21,20,10,0,0,20,58,7,47,278,0,253,0,0,0,50,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',1,0),
(3244,27004,'Spirit Of Mirrors','Quest Monster','orc_fighter',12.00,22.00,10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,278,0,253,0,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(3245,27005,'Spirit Of Mirrors','Quest Monster','werewolf',10.00,26.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'false',1,0),
(3246,27006,'Bhato Bloodspear','','orc_fighter',12.00,22.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3247,27007,'Tanuki Skullcrusher','','orc_fighter',12.00,22.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3248,27008,'Kraacul Blackskull','','orc_fighter',12.00,22.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3249,27009,'Taarq Blackskull','','orc_archer',14.00,25.00,11,'male','L2Monster','Ranger',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.80,'true',0,0),
(3250,27016,'Nerkas','Quest Monster','dre_vanul',14.00,36.00,22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,0,0,68,102,28,83,278,0,253,0,0,0,80,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',1,0),
(3251,27017,'Plague Zombie','Quest Monster','zombie',13.00,21.00,14,'male','L2Monster','Mystic',40,364,2.500,156,1.200,40,43,30,21,20,10,0,0,33,73,12,59,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'false',1,0),
(3252,27018,'Orc Warrior','','orc_fighter',12.00,22.00,10,'male','L2Monster','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,278,0,253,0,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3253,27019,'Orc Warrior Leader','','orc_fighter',12.00,22.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3254,27020,'Varool Foulclaw','Quest Monster','wererat',14.00,25.00,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',1,0),
(3255,27021,'Kirunak','Quest Monster','dre_vanul',14.00,36.00,22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,0,0,68,102,28,83,278,0,253,0,0,0,80,80,'kirunak_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',1,0),
(3256,27022,'Merkenis','Quest Monster','succubus',10.00,36.00,22,'female','L2Monster','Mystic',40,611,3.500,242,1.500,40,43,30,21,20,10,0,0,68,102,28,83,278,0,253,0,0,0,60,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.84,'false',1,0),
(3257,27024,'Undead Priest','Quest Monster','zombie',13.00,21.00,17,'male','L2Monster','Priest',40,446,2.500,184,1.200,40,43,30,21,20,10,0,0,48,75,17,67,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'false',1,0),
(3258,27029,'Phantom Salamander','Quest Monster','salamander',16.00,6.80,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,0,0,48,75,17,67,278,500,253,0,0,0,64,96,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.20,'false',0,0),
(3259,27030,'Water Seer','Quest Monster','monster_eye',21.00,43.00,17,'male','L2Monster','Mystic',40,446,2.500,184,1.200,40,43,30,21,20,10,0,0,48,75,17,67,278,500,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',1,0),
(3260,27031,'Ol Mahum Sentry','Quest Monster','ol_mahum',13.50,25.00,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,0,0,48,75,17,67,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(3261,27032,'Lizardman Warrior','Quest Monster','virud_lizardman_warrior',12.00,30.00,13,'male','L2Monster','Fighter',80,339,2.500,147,1.200,40,43,30,21,20,10,0,0,33,63,11,56,237,500,216,16,0,0,52,130,'',0,'Local','',0,0,0,7,30,4,0,0,0,0.59,'false',0,0),
(3262,27033,'Lizardman Scout','Quest Monster','virud_lizardman',10.00,23.00,12,'male','L2Monster','Ranger',40,315,2.500,138,1.200,40,43,30,21,20,10,0,0,30,60,10,54,278,500,253,1,0,0,43,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3263,27034,'Lizardman','Quest Monster','virud_lizardman',10.00,23.00,11,'male','L2Monster','Fighter',80,292,2.500,129,1.200,40,43,30,21,20,10,0,0,27,58,9,52,237,500,216,291,0,0,43,130,'',0,'Local','',0,0,0,7,30,4,0,0,0,0.48,'false',0,0),
(3264,27035,'Tamil','Quest Monster','bugbear',17.00,35.00,19,'male','L2Monster','Fighter',40,508,2.500,203,1.200,40,43,30,21,20,10,0,0,58,82,21,73,278,500,253,4,0,0,55,130,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.28,'false',0,0),
(3265,27036,'Calpico','Quest Monster','orc_fighter',12.00,22.00,13,'male','L2Monster','Fighter',40,339,2.500,147,1.200,40,43,30,21,20,10,0,0,33,63,11,56,278,0,253,2,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(3266,27037,'Calpico''s Goons','Quest Monster','orc',10.00,21.00,10,'male','L2Minion','Fighter',40,257,2.000,120,0.900,40,43,30,21,20,10,0,0,25,55,8,49,278,0,253,1,0,0,45,110,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(3267,27038,'Cat''s Eye Bandit','Quest Monster','ol_mahum',13.50,25.00,15,'male','L2Monster','Fighter',40,390,2.500,165,1.200,40,43,30,21,20,10,0,0,32,76,14,62,317,0,289,218,0,0,50,110,NULL,0,'Local',NULL,0,0,0,7,10,8,0,0,0,0.46,'false',1,0),
(3268,27041,'Baranka''s Messenger','Quest Monster','orc_fighter',12.00,22.00,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,0,0,25,73,10,54,278,0,253,2,0,0,45,110,'orc_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(3269,27042,'Orc Escort','Quest Monster','orc_fighter',12.00,22.00,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,0,0,25,73,10,54,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',0,0),
(3270,27043,'Varangka''s Tracker','Quest Monster','vampire_bat',10.00,33.50,11,'male','L2Monster','Mystic',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,23,70,9,52,278,500,253,0,0,0,60,80,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(3271,27044,'Kasha Bear Totem Spirit','Quest Monster','grizzly',21.00,40.00,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,0,0,40,91,17,67,278,500,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(3272,27045,'Kuruka Ratman Leader','Quest Monster','wererat',14.00,25.00,18,'male','L2Monster','Fighter',40,476,2.500,193,1.200,40,43,30,21,20,10,0,0,44,95,19,70,278,500,253,1,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(3273,27046,'Sumi','Orc Betrayer','batur_orc',9.00,21.50,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3274,27047,'Wanuk','Orc Betrayer','batur_orc',9.00,21.50,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3275,27048,'Chewba','Orc Betrayer','batur_orc',9.00,21.50,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3276,27049,'Heitafu','Orc Betrayer','batur_orc',9.00,21.50,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3277,27050,'Picubo','Orc Betrayer','batur_orc',9.00,21.50,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3278,27051,'Bumbum','Orc Betrayer','batur_orc',9.00,21.50,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3279,27052,'Minsku','Orc Betrayer','batur_orc',9.00,21.50,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(3280,27053,'Chuchu','Orc Betrayer','batur_orc',9.00,21.50,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3281,27054,'Umbar Orc','Quest Monster','batur_orc',9.00,21.50,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(3282,27055,'Zakan','Orc Betrayer','batur_orc',9.00,21.50,20,'male','L2Monster','Fighter',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3283,27056,'Durka Spirit','Quest Monster','magical_weaver',11.00,20.00,18,'male','L2Monster','Mystic',40,476,2.500,193,1.200,40,43,30,21,20,10,0,0,48,87,19,70,278,500,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3284,27058,'Honey Bear','Quest Monster','grizzly',21.00,40.00,17,'male','L2Monster','Fighter',40,446,2.500,184,1.200,40,43,30,21,20,10,0,0,48,75,17,67,278,0,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(3285,27059,'Uoph','Kaboo Chief','orc_fighter',12.00,22.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(3286,27060,'Kracha','Kaboo Chief','orc_archer',14.00,25.00,11,'male','L2Monster','Ranger',500,292,2.500,129,1.200,40,43,30,21,20,10,0,0,56,64,9,52,249,0,227,275,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(3287,27061,'Batoh','Kaboo Chief','orc_fighter',12.00,22.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,86,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.46,'true',1,0),
(3288,27062,'Tanukia','Kaboo Chief','orc_fighter',12.00,22.00,8,'male','L2Monster','Fighter',40,197,2.000,102,0.900,40,43,30,21,20,10,0,0,18,55,6,45,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(3289,27063,'Tanukia''s Warhound','Quest Monster','wolf',13.00,9.00,4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,0,0,12,46,4,37,278,0,253,0,0,0,24,110,'orc_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3290,27064,'Turel','Kaboo Chief','orc_fighter',12.00,22.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',1,0),
(3291,27065,'Roko','Kaboo Chief','orc_archer',14.00,25.00,8,'male','L2Monster','Ranger',500,197,2.000,102,0.900,40,43,30,21,20,10,0,0,41,55,6,45,249,0,227,275,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(3292,27066,'Roko''s Warhound','Quest Monster','wolf',13.00,9.00,4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,0,0,12,46,4,37,278,0,253,0,0,0,24,110,'orc_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3293,27067,'Kamut','Kaboo Chief','orc_fighter',12.00,22.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,86,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,0.46,'true',1,0),
(3294,27068,'Murtika','Kaboo Chief','orc_archer',14.00,25.00,8,'male','L2Monster','Ranger',500,197,2.000,102,0.900,40,43,30,21,20,10,0,0,41,55,6,45,249,0,227,275,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.80,'true',1,0),
(3295,27069,'Murtika''s Warhound','Quest Monster','wolf',13.00,9.00,4,'male','L2Monster','Fighter',40,107,2.000,68,0.900,40,43,30,21,20,10,0,0,12,46,4,37,278,0,253,0,0,0,24,110,'orc_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3296,27070,'Tumran Orc Brigand','Quest Monster','orc_fighter',12.00,22.00,11,'male','L2Monster','Fighter',40,292,2.500,129,1.200,40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(3297,27077,'Unicorn Of Eva','Quest Monster','unicorn',14.00,30.00,30,'male','L2Monster','Mystic',40,954,3.500,365,1.500,40,43,30,21,20,10,0,0,145,128,58,114,278,0,253,0,0,0,46,150,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.74,'false',1,0),
(3298,27078,'Trimden Lord','Quest Monster','poison_spider',27.00,25.50,39,'male','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,0,0,255,195,121,158,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.65,'false',0,0),
(3299,27079,'Black Willow Lurker','Quest Monster','hanged_man_ripper',35.00,80.00,39,'male','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,0,0,255,195,121,158,278,0,253,0,0,0,55,55,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(3300,27080,'Pashika Son Of Voltar','Quest Monster','batur_orc_warrior',10.00,20.00,37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,222,182,104,147,278,500,253,2,0,0,80,120,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(3301,27081,'Vultus Son Of Voltar','Quest Monster','batur_orc_warrior',10.00,20.00,37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,222,182,104,147,278,500,253,2,0,0,80,120,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(3302,27082,'Enku Orc Overlord','Quest Monster','batur_orc_warrior',10.00,20.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,0,0,182,143,75,128,278,500,253,2,0,0,80,120,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(3303,27083,'Makum Bugbear Thug','Quest Monster','bugbear',17.00,35.00,37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,244,165,104,147,278,500,253,2,0,0,55,130,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3304,27086,'Revenant of Tantos Chief','Quest Monster','batur_orc_overlord',12.00,24.00,39,'male','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,0,0,231,214,121,158,278,0,253,66,0,0,80,140,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3305,27088,'Harpy Matriarch','Quest Monster','harpy',10.00,42.00,34,'female','L2Monster','Fighter',40,1164,4.500,430,1.800,40,43,30,21,20,10,0,0,178,163,82,132,278,500,253,0,0,0,60,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.65,'false',0,0),
(3306,27089,'Road Collector','Quest Monster','wererat',14.00,25.00,36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,278,500,253,12,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(3307,27090,'Serpent Demon Kadesh','Quest Monster','serpent_slave',17.00,46.00,41,'male','L2Monster','Fighter',40,1593,5.500,560,2.100,40,43,30,21,20,10,0,0,291,208,141,169,278,0,253,73,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',0,0),
(3308,27092,'Neer Bodyguard','Quest Monster','neer_crawler',14.00,22.00,33,'male','L2Monster','Fighter',40,1109,4.500,413,1.800,40,43,30,21,20,10,0,0,182,143,75,128,278,500,253,0,0,0,50,90,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(3309,27093,'Delu Chief Kalkis','Quest Monster','virud_lizardman_matriarch',13.00,37.00,37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,244,165,104,147,278,0,253,12,0,0,56,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.65,'false',1,0),
(3310,27094,'Delu Lizardman Assassin','Quest Monster','virud_lizardman',10.00,23.00,36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,227,159,96,142,278,500,253,2,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3311,27095,'Singing Flower Phantasm','Quest Monster','mandragora_b',12.00,25.50,44,'female','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,0,0,322,253,176,187,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.13,'false',1,0),
(3312,27096,'Singing Flower Nightmare','Quest Monster','mandragora_b',12.00,25.50,44,'female','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,0,0,322,253,176,187,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.13,'false',1,0),
(3313,27097,'Singing Flower Darkling','Quest Monster','mandragora_b',12.00,25.50,44,'female','L2Monster','Fighter',40,1799,5.500,648,2.100,40,43,30,21,20,10,0,0,322,253,176,187,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.13,'false',1,0),
(3314,27098,'Ghost Fire','Quest Monster','will_o_wisp',13.00,22.00,42,'male','L2Monster','Mystic',40,1660,5.500,589,2.100,40,43,30,21,20,10,0,0,311,215,152,175,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.10,'false',1,0),
(3315,27099,'Nameless Revenant','Quest Monster','zombie',13.00,21.00,38,'male','L2Monster','Mystic',40,1400,4.500,497,1.800,40,43,30,21,20,10,0,0,261,171,112,153,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'false',1,0),
(3316,27100,'Skeletal Mercenary','Quest Monster','skeleton_knight',10.00,25.00,39,'male','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,0,0,280,177,121,158,278,0,253,69,0,0,40,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(3317,27101,'Drevanul Prince Zeruel','Quest Monster','dre_vanul',14.00,36.00,42,'male','L2Monster','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,0,0,342,196,152,175,278,0,253,0,0,0,80,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',0,0),
(3318,27102,'Pako The Cat','Quest Monster','cat_the_cat',9.00,16.00,38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,0,0,238,188,112,153,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',1,0),
(3319,27103,'Unicorn Racer','Quest Monster','unicorn_boxer',11.00,18.00,38,'male','L2Monster','Mystic',40,1400,4.500,497,1.800,40,43,30,21,20,10,0,0,238,188,112,153,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',1,0),
(3320,27104,'Shadow Turen','Quest Monster','shadow',10.00,30.00,39,'male','L2Monster','Mystic',40,1462,4.500,514,1.800,40,43,30,21,20,10,0,0,255,195,121,158,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',1,0),
(3321,27105,'Mimi The Cat','Quest Monster','cutie_cat',8.00,15.00,39,'female','L2Monster','Fighter',40,1462,4.500,514,1.800,40,43,30,21,20,10,0,0,255,195,121,158,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(3322,27106,'Unicorn Phantasm','Quest Monster','unicorn_mirage',13.00,17.50,40,'male','L2Monster','Mystic',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,273,201,131,164,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.69,'false',1,0),
(3323,27107,'Silhouette Tilfo','Quest Monster','silhouette',8.00,23.00,40,'female','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,273,201,131,164,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',1,0),
(3324,27108,'Stenoa Gorgon Queen','Quest Monster','cave_maiden',25.00,65.00,37,'female','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,244,165,104,147,278,0,253,127,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'false',1,0),
(3325,27109,'Handmaiden Of Stenoa','Quest Monster','medusa',10.00,25.00,33,'female','L2Monster','Mystic',40,1109,4.500,413,1.800,40,43,30,21,20,10,0,0,182,143,75,128,278,0,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(3326,27110,'Shyslassys','Quest Monster','medusa',10.00,25.00,36,'female','L2Monster','Mystic',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,187,193,96,142,278,0,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(3327,27111,'Cave Basilisk','Quest Monster','lesser_basilisk',34.00,25.00,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,0,0,120,155,58,114,278,0,253,0,0,0,35,54,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3328,27112,'Gorr','Quest Monster','medusa',10.00,25.00,36,'female','L2Monster','Mystic',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,227,159,96,142,278,0,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(3329,27113,'Baraham','Quest Monster','medusa',10.00,25.00,36,'female','L2Monster','Mystic',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,227,159,96,142,278,0,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(3330,27114,'Succubus Queen','Quest Monster','succubus',10.00,36.00,34,'female','L2Monster','Mystic',40,1164,4.500,430,1.800,40,43,30,21,20,10,0,0,196,148,82,132,278,0,253,0,0,0,60,100,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'false',1,0),
(3331,27115,'Claw Of Succubus','Quest Monster','succubus',10.00,36.00,28,'female','L2Minion','Mystic',40,859,3.500,334,1.500,40,43,30,21,20,10,0,0,124,118,49,106,278,0,253,0,0,0,60,100,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'false',1,0),
(3332,27116,'Lava Salamander','Quest Monster','salamander',16.00,6.80,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,174,186,89,137,278,0,253,0,0,0,64,96,'elemental3_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.20,'false',1,0),
(3333,27117,'Nahir','Quest Monster','dre_vanul',14.00,36.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,174,186,89,137,278,0,253,0,0,0,80,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',1,0),
(3334,27118,'Black Willow','Quest Monster','hanged_man_ripper',35.00,80.00,30,'male','L2Monster','Fighter',40,954,3.500,365,1.500,40,43,30,21,20,10,0,0,145,128,58,114,278,0,253,0,0,0,55,55,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(3335,27119,'Spirit of Sir Herod','Quest Monster','skeleton_royal_guard',11.00,28.50,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,69,0,0,80,120,'skeleton_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(3336,27120,'Luell Of Zephyr Winds','Quest Monster','sylph',11.00,35.00,37,'female','L2Monster','Mystic',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,222,182,104,147,278,0,253,0,0,0,60,60,'elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3337,27121,'Actea Of Verdant Wilds','Quest Monster','dryad',9.00,20.00,37,'female','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,222,182,104,147,278,0,253,0,0,0,40,110,'elemental1_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(3338,27122,'Leto Lizardman Agent','Quest Monster','zenta_lizardman',11.00,32.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,1,0,0,37,140,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3339,27123,'Leto Lizardman Leader','Quest Monster','zenta_lizardman_warrior',13.00,35.00,38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,0,0,238,188,112,153,278,0,253,66,0,0,40,140,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3340,27124,'Leto Lizardman Assassin','Quest Monster','zenta_lizardman',11.00,32.00,37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,244,165,104,147,278,500,253,217,0,0,37,140,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3341,27125,'Leto Lizardman Sniper','Quest Monster','zenta_lizardman_scout',11.00,30.00,36,'male','L2Monster','Ranger',500,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,417,193,96,142,249,0,227,14,0,0,37,150,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,0.93,'false',0,0),
(3342,27126,'Leto Lizardman Wizard','Quest Monster','zenta_lizardman_shaman',13.00,35.00,39,'male','L2Monster','Priest',40,1462,4.500,514,1.800,40,43,30,21,20,10,0,0,280,177,121,158,278,0,253,7,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.63,'false',0,0),
(3343,27127,'Leto Lizardman Lord','Quest Monster','zenta_lizardman_matriarch',20.00,40.00,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,69,0,0,53,140,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',0,0),
(3344,27128,'Aruraune','Quest Monster','mandragora_b',12.00,25.50,40,'female','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,273,201,131,164,278,500,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.13,'false',0,0),
(3345,27129,'Ol Mahum Inspector','Quest Monster','ol_mahum',13.50,25.00,38,'male','L2Monster','Fighter',40,1400,4.500,497,1.800,40,43,30,21,20,10,0,0,261,171,112,153,278,500,253,2,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',0,0),
(3346,27130,'Ol Mahum Betrayer','Quest Monster','ol_mahum',13.50,25.00,36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,187,193,96,142,278,0,253,12,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',0,0),
(3347,27131,'Crimson Werewolf','Quest Monster','werewolf',10.00,26.00,36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,278,500,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(3348,27132,'Krudel Lizardman','Quest Monster','virud_lizardman',10.00,23.00,36,'male','L2Monster','Fighter',80,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,237,500,216,291,0,0,43,130,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.48,'false',0,0),
(3349,27133,'Evil Eye Lord','Quest Monster','monster_eye',21.00,43.00,37,'male','L2Monster','Fighter',40,1338,4.500,480,1.800,40,43,30,21,20,10,0,0,244,165,104,147,278,500,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',1,0),
(3350,27134,'Tatoma','Quest Monster','king_bugbear',15.00,40.00,32,'male','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,0,0,140,167,69,123,278,500,253,88,0,0,55,130,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3351,27135,'Grima','Quest Monster','devastator',35.00,35.00,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,560,253,264,226,278,500,253,0,0,0,25,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(3352,27136,'Succubus Of Seduction','Quest Monster','succubus',10.00,36.00,40,'female','L2Monster','Mystic',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,0,0,0,60,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.84,'false',0,0),
(3353,27137,'Demon King','Quest Monster','dre_vanul',14.00,36.00,50,'male','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,463,306,264,226,278,500,253,0,0,0,80,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',0,0),
(3354,27138,'Great Demon King','Quest Monster','death_knight',12.00,30.00,60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,0,0,946,335,478,299,278,500,253,127,0,0,27,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(3355,27139,'Secret Keeper Tree','Quest Monster','ti_mi_tran',23.00,90.00,47,'male','L2Monster','Fighter',40,2016,5.500,738,2.100,40,43,30,21,20,10,0,0,388,279,216,206,278,0,253,0,0,0,12,12,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',1,0),
(3356,27140,'Breka Overlord Haka','Quest Monster','batur_orc_overlord',12.00,24.00,36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,187,193,96,142,278,500,253,66,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3357,27141,'Breka Overlord Jaka','Quest Monster','batur_orc_overlord',12.00,24.00,36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,187,193,96,142,278,500,253,66,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3358,27142,'Breka Overlord Marka','Quest Monster','batur_orc_overlord',12.00,24.00,36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,187,193,96,142,278,500,253,66,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3359,27143,'Windsus Aleph','Quest Monster','giant_wild_hog',25.00,27.00,42,'male','L2Monster','Fighter',40,1660,5.500,589,2.100,40,43,30,21,20,10,0,0,342,196,152,175,278,500,253,0,0,0,35,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(3360,27144,'Tarlk Raider Athu','Quest Monster','king_bugbear',15.00,40.00,48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3361,27145,'Tarlk Raider Lanka','Quest Monster','king_bugbear',15.00,40.00,48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3362,27146,'Tarlk Raider Triska','Quest Monster','king_bugbear',15.00,40.00,48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3363,27147,'Tarlk Raider Motura','Quest Monster','king_bugbear',15.00,40.00,48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3364,27148,'Tarlk Raider Kalath','Quest Monster','king_bugbear',15.00,40.00,48,'male','L2Monster','Fighter',40,2091,5.500,768,2.100,40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3365,27149,'Gremlin Filcher','Quest Monster','gremlin',10.00,15.00,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,0,0,25,73,10,54,278,500,253,0,0,0,20,50,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(3366,27150,'Black Legion Stormtrooper','Quest Monster','skeleton_royal_guard',11.00,28.50,43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,0,0,365,202,163,181,278,500,253,217,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(3367,27151,'Delu Lizardman Headhunter','Quest Monster','virud_lizardman_scout',10.00,22.00,28,'male','L2Monster','Fighter',500,859,3.500,334,1.500,40,43,30,21,20,10,0,0,276,118,49,106,249,500,227,2507,0,0,43,130,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.72,'false',0,0),
(3368,27152,'Marsh Stakato Marquess','Quest Monster','marsh_stakato_queen',15.00,37.00,35,'female','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,211,154,89,137,278,500,253,0,0,0,130,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'false',0,0),
(3369,27153,'Alexandro Sanches','Dark Lord','imp',10.00,24.00,3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,0,0,10,48,3,35,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',0,0),
(3370,27154,'Bonaparterius','Abyss King','goblin',10.00,16.50,3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,0,0,10,48,3,35,278,0,253,4,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.32,'true',0,0),
(3371,27155,'Ramsebalius','Evil Overlord','orc',10.00,21.00,3,'male','L2Monster','Fighter',40,90,2.000,60,0.900,40,43,30,21,20,10,0,0,12,40,3,35,278,0,253,2,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'true',0,0),
(3372,27156,'Leto Shaman Ketz','Quest Monster','zenta_lizardman_shaman',13.00,35.00,40,'male','L2Monster','Priest',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,159,0,0,43,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.63,'false',0,0),
(3373,27157,'Leto Chief Narak','Quest Monster','zenta_lizardman_matriarch',20.00,40.00,41,'male','L2Monster','Fighter',40,1593,5.500,560,2.100,40,43,30,21,20,10,0,0,265,229,141,169,278,500,253,221,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',0,0),
(3374,27158,'Timak Raider Kaikee','Quest Monster','batur_orc',9.00,21.50,43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,0,0,365,202,163,181,278,500,253,66,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',0,0),
(3375,27159,'Timak Overlord Okun','Quest Monster','batur_orc_overlord',12.00,24.00,46,'male','L2Monster','Fighter',40,1943,5.500,707,2.100,40,43,30,21,20,10,0,0,442,223,202,199,278,500,253,127,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3376,27160,'Gok Magok','Grandis Chief','twin_headed_giant',17.00,39.00,43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,0,0,302,245,163,181,278,500,253,0,0,0,45,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(3377,27161,'Taik Overlord Kakran','Quest Monster','ketra_orc_warrior',12.00,24.00,45,'male','L2Monster','Fighter',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,415,216,188,193,278,500,253,69,0,0,36,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(3378,27162,'Hatar Chieftain Kubel','Quest Monster','medusa',10.00,25.00,52,'female','L2Monster','Mystic',40,2402,6.500,892,2.400,40,43,30,21,20,10,0,0,518,324,300,239,278,500,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(3379,27163,'Vanor Elder Kerunos','Quest Monster','heltor_silenos_chieftain',13.00,31.50,51,'male','L2Monster','Fighter',40,2323,6.500,861,2.400,40,43,30,21,20,10,0,0,490,315,281,232,278,500,253,179,0,0,27,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3380,27164,'Karul Chief Orooto','Quest Monster','bugbear',17.00,35.00,43,'male','L2Monster','Fighter',40,1728,5.500,618,2.100,40,43,30,21,20,10,0,0,365,202,163,181,278,500,253,88,0,0,55,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(3381,27165,'Abyssal Jewel 1','Quest Monster','mirror',26.00,52.00,60,'male','L2Monster','Mystic',40,3054,58.500,1150,2.400,40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,0,0,0,80,165,'abyss_jewel_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(3382,27166,'Abyssal Jewel 2','Quest Monster','mirror',26.00,52.00,60,'male','L2Monster','Mystic',40,3054,58.500,1150,2.400,40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,0,0,0,80,165,'abyss_jewel_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(3383,27167,'Abyssal Jewel 3','Quest Monster','mirror',26.00,52.00,60,'male','L2Monster','Mystic',40,3054,58.500,1150,2.400,40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,0,0,0,80,165,'abyss_jewel_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3384,27168,'Jewel Guardian Mara','Quest Monster','succubus',10.00,36.00,53,'female','L2Monster','Mystic',40,2481,6.500,923,2.400,40,43,30,21,20,10,0,0,662,276,319,247,278,500,253,0,0,0,60,100,'abyss_jewel_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.84,'false',0,0),
(3385,27169,'Jewel Guardian Musfel','Quest Monster','dre_vanul',14.00,36.00,53,'male','L2Monster','Fighter',40,2481,6.500,923,2.400,40,43,30,21,20,10,0,0,547,334,319,247,278,500,253,0,0,0,80,80,'abyss_jewel_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',0,0),
(3386,27170,'Jewel Guardian Pyton','Quest Monster','serpent_slave',17.00,46.00,58,'male','L2Monster','Fighter',40,2889,6.500,1084,2.400,40,43,30,21,20,10,0,0,710,384,428,284,278,500,253,223,0,0,70,110,'abyss_jewel_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',0,0),
(3387,27171,'Sacrifice Of The Sacrificed','Quest Monster','magical_weaver',11.00,20.00,20,'male','L2Monster','Mystic',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,63,86,23,76,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3388,27172,'Harit Lizardman Zealot','Quest Monster','zenta_lizardman_warrior',13.00,35.00,55,'male','L2Monster','Fighter',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,737,292,360,261,278,500,253,16,0,0,40,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3389,27173,'Box Of Athrea 1','Quest Monster','coffer_a',12.00,9.50,50,'etc','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3390,27174,'Box Of Athrea 2','Quest Monster','coffer_a',12.00,9.50,50,'etc','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3391,27175,'Box Of Athrea 3','Quest Monster','coffer_a',12.00,9.50,50,'etc','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3392,27176,'Box Of Athrea 4','Quest Monster','coffer_a',12.00,9.50,50,'etc','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3393,27177,'Box Of Athrea 5','Quest Monster','coffer_a',12.00,9.50,50,'etc','L2Monster','Fighter',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3394,27178,'Blitz Wyrm','Quest Monster','wyrm',29.00,72.00,60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,0,0,946,335,478,299,278,500,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.19,'false',0,0),
(3395,27179,'Grave Keymaster','Quest Monster','gargoyle',16.00,50.00,65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,979,460,619,340,278,0,253,0,0,0,140,140,'grave_guard_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(3396,27180,'Imperial Slave','Quest Monster','binding',12.00,21.00,56,'male','L2Monster','Fighter',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,642,364,382,269,278,500,253,0,0,0,10,140,'grave_keeper_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(3397,27181,'Imperial Gravekeeper','Quest Monster','death_blader',15.00,45.00,60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,1472,0,0,100,170,'grave_keeper_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(3398,27182,'Ark Guardian Elberoth','Quest Monster','archangel',15.00,80.00,60,'male','L2Monster','Fighter',40,3054,6.500,1150,2.400,40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,6370,0,0,50,200,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3399,27183,'Ark Guardian Shadowfang','Quest Monster','kel_mahum_archer',13.00,27.00,60,'male','L2Monster','Ranger',500,3054,6.500,1150,2.400,40,43,30,21,20,10,0,0,2313,259,478,299,249,0,227,288,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,10,0.91,'false',0,0),
(3400,27184,'Angel Killer','Quest Monster','death_lord',21.00,40.00,60,'male','L2Monster','Fighter',40,3054,58.500,1150,2.400,40,43,30,21,20,10,0,0,711,446,478,299,278,0,253,130,0,0,40,200,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(3401,27185,'Fairy Tree of Wind','Quest Monster','human_tree',35.00,90.00,55,'etc','L2Monster','Quest421FairyTree',40,1673,6.500,890,2.400,40,43,30,21,20,10,0,0,670,273,360,261,278,0,253,0,0,0,50,0,'q421_tree_clan',1000,'Drin','',0,0,0,7,50,1,9,0,10,0.60,'false',1,0),
(3402,27186,'Fairy Tree of Star','Quest Monster','human_tree',35.00,90.00,55,'etc','L2Monster','Quest421FairyTree',40,1673,6.500,890,2.400,40,43,30,21,20,10,0,0,554,389,360,261,278,0,253,0,0,0,50,0,'q421_tree_clan',1000,'Drin','',0,0,0,7,30,4,5,0,0,0.60,'false',1,0),
(3403,27187,'Fairy Tree of Twilight','Quest Monster','human_tree',35.00,90.00,55,'etc','L2Monster','Quest421FairyTree',40,1673,6.500,890,2.400,40,43,30,21,20,10,0,0,737,292,360,261,278,0,253,0,0,0,50,0,'q421_tree_clan',1000,'Drin','',0,0,0,7,30,4,5,0,0,0.60,'false',1,0),
(3404,27188,'Fairy Tree of Abyss','Quest Monster','human_tree',35.00,90.00,55,'etc','L2Monster','Quest421FairyTree',40,1673,6.500,890,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,0,'q421_tree_clan',1000,'Drin','',0,0,0,7,30,4,5,0,0,0.60,'false',1,0),
(3405,27189,'Soul of Tree Guardian','Quest Monster','elf_ghost',7.00,21.00,50,'male','L2Monster','Mystic',40,710,2.750,748,2.100,40,43,30,21,20,10,0,0,509,236,264,226,278,0,253,0,0,0,80,140,'q421_tree_clan',1000,'Drin','',0,0,0,7,30,4,5,0,10,0.41,'false',0,0),
(3406,27190,'Ol Mahum Support Troop','Quest Monster','ol_mahum_champion',14.00,27.00,26,'male','L2Monster','Fighter',40,770,3.500,303,1.500,40,43,30,21,20,10,0,0,96,120,41,98,278,500,253,69,0,0,50,150,'orc_clan',200,'Local','',0,0,0,7,30,4,4,0,0,0.63,'false',0,0),
(3407,27191,'Malcom','Quest Monster','grizzly',21.00,40.00,25,'male','L2Monster','Fighter',40,728,3.500,287,1.500,40,43,30,21,20,10,0,0,103,116,37,94,237,500,216,0,0,0,40,159,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(3408,27192,'Succubus Handmaiden','Quest Monster','succubus',10.00,36.00,18,'female','L2Monster','Mystic',40,476,2.500,193,1.200,40,43,30,21,20,10,0,0,48,87,19,70,278,500,253,0,0,0,60,134,'',0,'stiff_fix_outofdate_from_1028','1145636095',0,0,0,7,30,4,4,0,0,0.84,'false',0,0),
(3409,27193,'Goblin Servant','Quest Monster','goblin',10.00,16.50,12,'male','L2Monster','Fighter',40,315,2.500,138,1.200,40,43,30,21,20,10,0,0,27,56,10,54,278,500,253,0,0,0,40,120,'',0,'stiff_fix_outofdate_from_1029','1145636095',0,0,0,7,30,4,4,0,10,0.32,'false',0,0),
(3410,27194,'Julie the Ripper','Quest Monster','doll_blader',6.00,12.00,40,'male','L2Monster','Fighter',40,1527,9.000,531,1.800,40,43,30,21,20,10,0,0,289,141,131,164,317,500,289,5129,5129,0,22,174,'',0,'stiff_fix_outofdate_from_1030','1145636095',0,0,60,7,10,8,0,0,10,0.50,'false',0,0),
(3411,27195,'Male Ant','Quest Monster','noble_ant',20.00,48.00,32,'male','L2Monster','Fighter',40,1056,4.500,397,1.800,40,43,30,21,20,10,0,0,154,151,69,123,278,0,253,0,0,0,80,150,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(3412,27196,'Bluebacked Alligator','Quest Monster','crocodile',28.00,11.50,40,'male','L2Monster','Fighter',40,1527,9.000,531,1.800,40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,0,0,0,70,110,'croc_clan',200,'Local','',0,0,0,7,30,4,4,0,0,0.41,'false',0,0),
(3413,27197,'Bejewelled Alligator','Quest Monster','crocodile',28.00,11.50,40,'male','L2Monster','Fighter',40,1527,13.500,531,1.800,40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,0,0,0,70,110,'croc_clan',200,'Local','',0,0,0,7,30,4,4,0,0,0.41,'false',0,0),
(3414,27199,'Crimson Werewolf','Quest Monster','werewolf',10.00,26.00,36,'male','L2Monster','Fighter',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,278,0,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.43,'false',1,0),
(3415,27200,'Krudel Lizardman','Quest Monster','virud_lizardman',10.00,23.00,36,'male','L2Monster','Fighter',80,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,237,0,216,291,0,0,43,130,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.48,'false',1,0),
(3416,27201,'','','bugbear',17.00,35.00,10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.28,'false',0,0),
(3417,27202,'','','bugbear',17.00,35.00,10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.28,'false',0,0),
(3418,27203,'','','bugbear',17.00,35.00,10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.28,'false',0,0),
(3419,27204,'','','bugbear',17.00,35.00,10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.28,'false',0,0),
(3420,27205,'','','bugbear',17.00,35.00,10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.28,'false',0,0),
(3421,27206,'','','bugbear',17.00,35.00,10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.28,'false',0,0),
(3422,27207,'','','bugbear',17.00,35.00,10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.28,'false',0,0),
(3423,27208,'','','bugbear',17.00,35.00,10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.28,'false',0,0),
(3424,27209,'','','bugbear',17.00,35.00,10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.28,'false',0,0),
(3425,27210,'','','bugbear',17.00,35.00,10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.28,'false',0,0),
(3426,27211,'','','bugbear',17.00,35.00,10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.28,'false',0,0),
(3427,27212,'','','bugbear',17.00,35.00,10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.28,'false',0,0),
(3428,27213,'','','bugbear',17.00,35.00,10,'male','L2Monster','Fighter',80,257,2.000,120,0.900,40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,0.28,'false',0,0),
(3429,27214,'Guardian of Forbidden Knowledge','Quest Monster','apostle_warrior',8.00,30.00,76,'female','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,80,0,0,50,180,'guard_of_secrets_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(3430,27215,'Guardian of Forbidden Knowledge','Quest Monster','apostle_warrior',8.00,30.00,76,'female','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,80,0,0,50,180,'guard_of_secrets_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(3431,27216,'Guardian of Forbidden Knowledge','Quest Monster','apostle_warrior',8.00,30.00,76,'female','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,80,0,0,50,180,'guard_of_secrets_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(3432,27217,'Soul of Well','Quest Monster','dark_horror',20.00,35.00,63,'male','L2Monster','Fighter',40,3302,7.500,1251,2.700,40,43,30,21,20,10,0,0,987,338,560,323,278,150,253,0,0,0,100,180,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.37,'false',0,0),
(3433,27218,'Triol''s Pawn','Quest Monster','dre_vanul',14.00,36.00,65,'male','L2Monster','Fighter',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,150,253,0,0,0,80,180,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.35,'false',0,0),
(3434,27219,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3435,27220,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3436,27221,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3437,27222,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3438,27223,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3439,27224,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3440,27225,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3441,27226,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3442,27227,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3443,27228,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3444,27229,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(3445,27230,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3446,27231,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3447,27232,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3448,27233,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3449,27234,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3450,27235,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3451,27236,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3452,27237,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3453,27238,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3454,27239,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3455,27240,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3456,27241,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3457,27242,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3458,27243,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3459,27244,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3460,27245,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3461,27246,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3462,27247,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3463,27248,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3464,27249,'Archon of Halisha','Quest Monster','ahrimanes',14.00,57.75,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3465,27250,'Fallen Angel Allector','Quest Monster','karik',25.00,90.00,76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,37,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(3466,27251,'Fallen Angel Allector','Quest Monster','karik',25.00,90.00,76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,37,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(3467,27252,'Fallen Angel Allector','Quest Monster','karik',25.00,90.00,76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,37,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(3468,27253,'Hell Fire','Quest Monster','will_o_wisp',13.00,22.00,76,'male','L2Monster','Mystic',40,4297,4.250,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.10,'false',0,0),
(3469,27254,'Unknown Stopper','Quest Monster','fiend_archer',17.00,55.00,81,'male','L2Monster','Ranger',500,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,4141,499,1182,477,249,150,227,0,0,0,70,180,'',0,'Local','',0,0,0,7,10,8,0,1500,10,0.76,'false',0,0),
(3470,27255,'Unknown Stopper','Quest Monster','fiend_archer',17.00,55.00,81,'male','L2Monster','Ranger',500,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,4141,499,1182,477,249,150,227,0,0,0,70,180,'',0,'Local','',0,0,0,7,10,8,0,1500,10,0.76,'false',0,0),
(3471,27256,'Unknown Stopper','Quest Monster','fiend_archer',17.00,55.00,81,'male','L2Monster','Ranger',500,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,4141,499,1182,477,249,150,227,0,0,0,70,180,'',0,'Local','',0,0,0,7,10,8,0,1500,10,0.76,'false',0,0),
(3472,27257,'Archangel Iconoclasis','Quest Monster','apostle_mage',11.00,38.50,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.48,'false',0,0),
(3473,27258,'Archangel Iconoclasis','Quest Monster','apostle_mage',11.00,38.50,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.48,'false',0,0),
(3474,27259,'Archangel Iconoclasis','Quest Monster','apostle_mage',11.00,38.50,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.48,'false',0,0),
(3475,27260,'Archangel Iconoclasis','Quest Monster','apostle_mage',11.00,38.50,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.48,'false',0,0),
(3476,27261,'Bead of Sacred Flame','Quest Monster','will_o_wisp',13.00,22.00,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,0,0,0,80,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.10,'false',0,0),
(3477,27262,'Death Lord Hallate','Quest Monster','death_lord',21.00,40.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,78,0,0,40,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(3478,27263,'Death Lord Hallate','Quest Monster','death_lord',21.00,40.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,78,0,0,40,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(3479,27264,'Death Lord Hallate','Quest Monster','death_lord',21.00,40.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,78,0,0,40,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(3480,27265,'Lich King Icarus','Quest Monster','vale_master',12.00,40.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,499,1182,477,278,150,253,205,0,0,70,180,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.74,'false',0,0),
(3481,27266,'Fallen Angel Haures','Quest Monster','doll_master',20.00,42.00,76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,0,0,0,80,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',0,0),
(3482,27267,'Fallen Angel Haures','Quest Monster','doll_master',20.00,42.00,76,'male','L2Monster','Fighter',40,4297,17.000,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,0,0,0,80,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',0,0),
(3483,27268,'Guard of Haures','Quest Monster','neer_crawler',14.00,22.00,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1412,454,994,433,317,0,289,0,0,0,50,180,'',0,'Local','',0,0,0,7,10,8,0,0,10,0.37,'false',0,0),
(3484,27269,'Fallen Angel Naverius','Quest Monster','banshee',9.00,23.00,76,'female','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,3939,0,0,80,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',0,0),
(3485,27270,'Fallen Angel Naverius','Quest Monster','banshee',9.00,23.00,76,'female','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,3939,0,0,80,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',0,0),
(3486,27271,'Chimera Golem','Quest Monster','lava_golem',22.00,45.00,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,13,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.47,'false',0,0),
(3487,27272,'Hallate''s Dancer Lillian','Quest Monster','banshee',9.00,23.00,76,'female','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,3939,0,0,80,180,NULL,0,'Local',NULL,0,0,0,7,50,1,9,0,10,0.56,'false',0,0),
(3488,27273,'Assassin Pezel','Quest Monster','skeleton_royal_guard',11.00,28.50,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1630,587,1182,477,317,150,289,242,0,0,80,180,'',0,'Local','',0,0,0,7,10,8,0,0,0,0.52,'false',0,0),
(3489,27274,'Fallen Angel Tanakia','Quest Monster','halisha_d',23.00,60.00,81,'female','L2Monster','Fighter',500,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,227,286,0,0,43,180,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.48,'false',0,0),
(3490,27275,'Fallen Angel Tanakia','Quest Monster','halisha_d',23.00,60.00,81,'female','L2Monster','Fighter',500,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,227,286,0,0,43,180,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.48,'false',0,0),
(3491,27276,'Fallen Angel Tanakia','Quest Monster','halisha_d',23.00,60.00,81,'female','L2Monster','Fighter',500,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,227,286,0,0,43,180,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.48,'false',0,0),
(3492,27277,'Fallen Angel Tanakia','Quest Monster','halisha_d',23.00,60.00,81,'female','L2Monster','Fighter',500,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,227,286,0,0,43,180,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.48,'false',0,0),
(3493,27278,'Shadow of Beleth','Quest Monster','vale_master',12.00,40.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,205,0,0,70,180,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.74,'false',0,0),
(3494,27279,'Cursed Kesadein','Quest Monster','doll_master',20.00,42.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1630,499,1182,477,317,150,289,0,0,0,80,180,'',0,'Local','',0,0,0,7,10,8,0,0,10,0.56,'false',0,0),
(3495,27280,'Fallen Angel Narcissus','Quest Monster','karik',25.00,90.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,37,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(3496,27281,'Fallen Angel Metellus','Quest Monster','karik',25.00,90.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,37,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',0,0),
(3497,27282,'Dark Angel Othiel','Quest Monster','archangel',15.00,80.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3498,27283,'Grandpapa Askalius','Quest Monster','susceptor_prime',45.00,72.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,78,180,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.52,'false',0,0),
(3499,27284,'Flame Evil Spirit Azira','Quest Monster','ifrit',10.00,42.00,81,'male','L2Monster','Mystic',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,38,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3500,27285,'Lizard''s Totem Sharuhi','Quest Monster','serpent_slave',17.00,46.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,72,0,0,70,180,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.46,'false',0,0),
(3501,27286,'Fallen Knight Adhil','Quest Monster','a_guard_MHuman',8.00,24.00,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,79,107,0,50,180,'',0,'Local','',0,20,161,7,30,4,4,0,-6,0.60,'false',0,0),
(3502,27287,'Bound Elf Panacea','Quest Monster','a_guard_MElf',8.00,23.50,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,145,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3503,27288,'Sword Player Biel','Quest Monster','a_patriarch_MElf',8.00,22.50,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,74,74,0,50,180,'',0,'Local','',0,0,167,7,30,4,4,0,0,0.60,'false',0,0),
(3504,27289,'Ancient Sword Master Iron','Quest Monster','lilim_knight_10_bi',13.00,55.00,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,5800,5799,0,56,180,'',0,'Local','',0,20,161,7,30,4,4,0,-6,0.46,'false',0,0),
(3505,27290,'White Wing Commander','Quest Monster','archangel',15.00,80.00,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3506,27291,'White Wing Fighter','Quest Monster','apostle_warrior',8.00,30.00,76,'female','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,80,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',0,0),
(3507,27292,'Fallen Noble Orc Muhark','Quest Monster','ketra_orc_warrior',12.00,24.00,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,7834,0,0,36,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(3508,27293,'Khavatari Uruz','Quest Monster','ketra_orc_warrior',12.00,24.00,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,36,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(3509,27294,'Overlord Atrus','Quest Monster','ketra_orc_chieftain',11.00,38.50,76,'male','L2Monster','Fighter',40,4297,34.000,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,6719,0,0,24,180,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.51,'false',0,0),
(3510,27295,'Sharuhi Mouth Mudaha','Quest Monster','ketra_orc_chieftain',11.00,38.50,76,'male','L2Monster','Fighter',40,4297,34.000,1710,3.000,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,6719,0,0,24,180,'',0,'Local','',0,0,0,7,50,1,9,0,0,0.51,'false',0,0),
(3511,27296,'Monument Watcher Ezekiel','Quest Monster','archangel',15.00,80.00,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3512,27297,'Monument Watcher Ezekiel','Quest Monster','archangel',15.00,80.00,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3513,27298,'Monument Watcher Ezekiel','Quest Monster','archangel',15.00,80.00,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3514,27299,'Monument Watcher Ezekiel','Quest Monster','archangel',15.00,80.00,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3515,27300,'Monument Watcher Ezekiel','Quest Monster','archangel',15.00,80.00,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3516,27301,'Monument Watcher Ezekiel','Quest Monster','archangel',15.00,80.00,76,'male','L2Monster','Fighter',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3517,27302,'Monument Defender Azrael','Quest Monster','archangel',15.00,80.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3518,27303,'Monument Defender Azrael','Quest Monster','archangel',15.00,80.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3519,27304,'Monument Defender Azrael','Quest Monster','archangel',15.00,80.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3520,27305,'Monument Defender Azrael','Quest Monster','archangel',15.00,80.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3521,27306,'Monument Defender Azrael','Quest Monster','archangel',15.00,80.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3522,27307,'Monument Defender Azrael','Quest Monster','archangel',15.00,80.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',0,0),
(3523,27308,'Assassin Frost','Quest Monster','vampire_soldier',8.00,23.50,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1630,587,1182,477,317,150,289,229,0,0,60,180,'',0,'Local','',0,0,0,7,10,8,0,0,0,0.45,'false',0,0),
(3524,27309,'Minervia Van Hacken','Quest Monster','vampire_witch',6.00,21.50,81,'female','L2Monster','Mystic',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1630,499,1182,477,317,150,289,229,0,0,64,180,'',0,'Local','',0,0,0,7,10,8,0,0,10,0.50,'false',0,0),
(3525,27310,'Kitanis Van Hacken','Quest Monster','vampire_lord',7.50,25.80,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,15,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(3526,27311,'Judgment Hound Dog Kelvas','Quest Monster','eligor',21.00,35.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(3527,27312,'Mysterious Servitor','Quest Monster','shadeless',7.00,28.00,81,'male','L2Monster','Fighter',40,4608,76.500,1896,3.000,40,43,30,21,20,10,0,0,1863,499,1182,477,278,150,253,0,0,0,48,180,'',0,'Local','',0,0,0,7,30,4,4,0,10,0.61,'false',0,0),
(3528,27313,'Vision Guardian Shakiel','Quest Monster','apostle_mage',11.00,38.50,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.48,'false',0,0),
(3529,27314,'Vision Guardian Shakiel','Quest Monster','apostle_mage',11.00,38.50,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.48,'false',0,0),
(3530,27315,'Vision Guardian Shakiel','Quest Monster','apostle_mage',11.00,38.50,76,'male','L2Monster','Mystic',40,4297,8.500,1710,3.000,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.48,'false',0,0),
(3531,27316,'Fallen Chieftain Vegus','Quest Monster','ketra_orc_warrior',12.00,24.00,55,'male','L2Monster','Fighter',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,273,360,261,278,0,253,161,0,0,36,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.54,'false',1,0),
(3532,27317,'Restrainer of Glory','Quest Monster','kel_mahum_champion',13.00,32.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,399,780,382,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,0.56,'false',1,0),
(3533,27318,'Wendy''s Guardian','Quest Monster','golem_guardian_090p',16.00,37.20,46,'male','L2Monster','Fighter',40,1943,11.000,707,2.100,40,43,30,21,20,10,2408,170,365,270,202,199,278,0,253,0,0,0,70,174,'',400,'Local','',0,0,0,7,50,1,9,0,0,0.30,'false',0,0),
(3534,27319,'Black Leopard','Quest Monster','onyx_beast',14.00,14.50,18,'male','L2Monster','Fighter',40,476,3.500,287,1.500,40,43,30,21,20,10,1012,51,88,98,37,94,278,400,253,0,0,0,30,145,'beast_clan',300,'Local','',0,0,0,7,30,4,4,0,10,0.24,'false',1,0),
(3535,27320,'Timora Orc','Quest Monster','batur_orc',9.00,21.50,20,'male','L2Monster','Fighter',40,541,2.500,203,1.200,40,43,30,21,20,10,565,25,53,90,21,73,278,0,253,291,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(3536,27321,'Bruin Lizardman','Quest Monster','virud_lizardman',10.00,23.00,20,'male','L2Monster','Fighter',40,541,2.500,203,1.200,40,43,30,21,20,10,565,25,53,90,21,73,278,0,253,291,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(3537,27322,'Picot Araneid','Quest Monster','giant_spider_50_bi',39.00,38.00,27,'male','L2Monster','Mystic',40,813,1.750,318,1.500,40,43,30,21,20,10,1453,74,104,106,45,102,278,500,253,0,0,0,72,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,10,0.26,'false',1,0),
(3538,27323,'Divine Emissary','Quest Monster','LineageMonster.Angel',13.50,36.50,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3539,27324,'Vision Guard Eranus','Quest Monster','LineageMonster2.Apostle_warrior',8.00,30.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3540,27325,'Archon of Halisha','Quest Monster','LineageMonster2.Ahrimanes',14.00,57.75,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3541,27326,'Archangel Kanriel','Quest Monster','LineageMonster.Archangel',15.00,80.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3542,27327,'Zakorel''s Executor','Quest Monster','LineageMonster2.Apostle_mage',11.00,38.50,1,'male','L2Monster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3543,27328,'Zakorel','Quest Monster','LineageMonster3.Apostle_grail',13.00,47.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3544,27329,'Archon of Halisha','Quest Monster','LineageMonster2.Ahrimanes',14.00,57.75,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3545,27330,'Dire Wolf Commander','Quest Monster','LineageMonster.Dire_wolf',13.00,11.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3546,27331,'Dread Wolf Commander','Quest Monster','LineageMonster.Dire_wolf',13.00,11.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3547,27332,'Guardian Angel','Quest Monster','LineageMonster.Angel',13.50,36.50,35,'male','L2Monster','GuardianAngel',40,1220,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3548,27333,'Crimson Duchess','Quest Monster','LineageMonster3.Lidia_von_helmann',10.00,25.40,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3549,27334,'Archon of Halisha','Quest Monster','LineageMonster2.Ahrimanes',14.00,57.75,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3550,27335,'Dark Angel Othiel','Quest Monster','LineageMonster.Archangel',15.00,80.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3551,27336,'Crimson Lady','Quest Monster','LineageMonster.Succubus',10.00,36.00,1,'male','L2Monster','Fighter',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(3552,27337,'Ol Mahum Officer Tak','Quest Monster','LineageMonster.ol_mahum_champion',14.00,27.00,22,'male','L2Monster','Fighter',40,611,3.500,242,1.500,40,43,30,21,20,10,0,0,68,102,28,83,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(3553,30001,'Lector','Trader','a_traderA_MHuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3554,30002,'Jackson','Trader','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3555,30003,'Silvia','Trader','a_traderA_FHuman',8.00,23.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3556,30004,'Katerina','Trader','a_traderB_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3557,30005,'Wilford','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3558,30006,'Roxxy','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3559,30008,'Roien','Grand Master','a_fighterguild_master_Mhuman_old',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3560,30009,'Newbie Helper','','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3561,30010,'Auron','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3562,30014,'Celma','Master','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3563,30017,'Gallint','Grand Magister','a_mageguild_master_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3564,30019,'Newbie Helper','','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3565,30022,'Zigaunt','Priest','a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3566,30026,'Bitz','Grand Master','a_fighterguild_master_Mhuman_old',8.00,23.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3567,30027,'Gwinter','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3568,30028,'Pintage','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3569,30029,'Minia','Master','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3570,30030,'Vivyan','Priestess','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3571,30031,'Biotin','High Priest','a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3572,30032,'Yohanes','Priest','a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3573,30033,'Baulro','Magister','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3574,30034,'Iris','Magister','a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3575,30035,'Harrys','Magister','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3576,30036,'Petron','Priest','a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3577,30037,'Levian','High Priestess','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3578,30039,'Gilbert','Captain','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3579,30040,'Leon','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3580,30041,'Arnold','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3581,30042,'Abellos','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3582,30043,'Johnstone','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3583,30044,'Chiperan','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3584,30045,'Kenyos','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3585,30046,'Hanks','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3586,30047,'Firon','Wharf Manager','a_wharfinger_MHuman',8.00,23.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3587,30048,'Darin','','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3588,30049,'Bonnie','','a_common_peopleB_FHuman',8.00,20.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3589,30050,'Elias','','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3590,30051,'Cristel','','a_common_peopleA_FHuman',8.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3591,30054,'Rant','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3592,30055,'Rolfe','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3593,30057,'Aldo','Warehouse Freightman','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3594,30058,'Holvas','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3595,30059,'Trisha','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3596,30060,'Sabrin','Trader','a_traderA_MHuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3597,30061,'Casey','Trader','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3598,30062,'Sonia','Trader','a_traderA_FHuman',8.00,23.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3599,30063,'Lara','Trader','a_traderB_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3600,30064,'Terry','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3601,30065,'Arnelle','Master','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3602,30066,'Pabris','Grand Master','a_fighterguild_master_Mhuman_old',8.00,23.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3603,30067,'Glyvka','Priestess','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3604,30068,'Shegfield','Priest','a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3605,30069,'Rollant','Magister','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3606,30070,'Sylvain','High Priest','a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3607,30071,'Lucas','Captain','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3608,30072,'Metty','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3609,30073,'Jacob','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(3610,30074,'Harlan','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3611,30075,'Xaber','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3612,30076,'Liam','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3613,30078,'Pano','Grocer','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3614,30079,'Barder','Warehouse Freightman','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3615,30080,'Clarissa','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3616,30081,'Helvetia','Grocer','a_traderB_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3617,30082,'Denkus','Grocer','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3618,30083,'Pochi','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3619,30084,'Graham','Weapons Trader','a_traderA_MHuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3620,30085,'Stanford','Weapons Trader','a_traderA_MHuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3621,30086,'Taurin','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3622,30087,'Peta','Armor Trader','a_traderA_FHuman',8.00,23.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3623,30088,'Radia','Armor Trader','a_traderB_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3624,30090,'Sandra','Jeweler','a_traderB_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3625,30091,'Ellie','Jeweler','a_traderA_FHuman',8.00,23.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3626,30092,'Collob','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3627,30093,'Groot','Magic Trader','a_traderA_MHuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3628,30094,'Gentler','Magic Trader','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3629,30095,'Randolf','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3630,30097,'Galladucci','Trader','a_traderA_MDwarf',8.00,17.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3631,30098,'Alexandria','Trader','a_traderB_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3632,30103,'Valkon','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3633,30104,'Parman','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3634,30105,'Genwitter','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3635,30106,'Dufner','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3636,30107,'Goldian','Master','a_guard_MElf',8.00,23.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3637,30108,'Macken','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3638,30109,'Hannavalt','Grand Master','a_fighterguild_master_Mhuman_old',8.00,23.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3639,30110,'Iker','Magister','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3640,30111,'Dieter','Magister','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3641,30112,'Maurius','Magister','a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3642,30113,'Juris','Magister','a_trader_FElf',8.00,24.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3643,30114,'Roa','Magister','a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3644,30115,'Jurek','Grand Magister','a_mageguild_master_MHuman',8.00,24.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3645,30116,'Dustin','Priest','a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3646,30117,'Primos','Priest','a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3647,30118,'Pupina','Priestess','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3648,30119,'Isabellin','Priestess','a_trader_FElf',8.00,24.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3649,30120,'Maximilian','High Priest','a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3650,30121,'Jeronin','Captain','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3651,30122,'Bane','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3652,30123,'Vesa','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3653,30124,'Zerome','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3654,30125,'Belton','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3655,30126,'Rath','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3656,30128,'Atanas','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3657,30129,'Mitraell','Hierarch','a_clergyman_MDarkElf',8.00,22.30,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3658,30130,'Undrias','Abyssal Celebrant','a_clergyman_MDarkElf',8.00,22.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3659,30131,'Newbie Helper','','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3660,30132,'Cecktinon','Abyssal Celebrant','a_clergyman_MDarkElf',8.00,22.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3661,30133,'Kartia','Abyssal Celebrant','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3662,30134,'Jasmine','Gatekeeper','a_teleporter_FDarkElf',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3663,30135,'Iria','Trader','a_trader_Fdarkelf',8.00,24.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3664,30136,'Payne','Trader','a_trader_MDarkElf',8.00,22.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3665,30137,'Vollodos','Trader','a_trader_MDarkElf',8.00,22.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3666,30138,'Minaless','Trader','a_trader_Fdarkelf',8.00,24.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3667,30139,'Dorankus','Warehouse Keeper','a_trader_MDarkElf',8.00,22.50,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3668,30140,'Erviante','Warehouse Keeper','a_trader_MDarkElf',8.00,22.50,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3669,30141,'Talloth','Tetrarch','a_clergyman_MDarkElf',8.00,22.30,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3670,30143,'Trudy','Master','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3671,30144,'Harne','Magister','a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3672,30145,'Vlasty','Magister','a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3673,30146,'Mirabel','Gatekeeper','a_common_people_FElf',8.00,25.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3674,30147,'Unoren','Trader','a_trader_MElf',8.00,25.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3675,30148,'Ariel','Trader','a_trader_FElf',8.00,24.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3676,30149,'Creamees','Trader','a_trader_MElf',8.00,25.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3677,30150,'Herbiel','Trader','a_trader_MElf',8.00,25.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3678,30151,'Chad','Warehouse Freightman','a_trader_MElf',8.00,25.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3679,30152,'Julia','Warehouse Keeper','a_common_people_FElf',8.00,25.50,70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3680,30153,'Markius','Warehouse Keeper','a_trader_MElf',8.00,25.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3681,30154,'Asterios','Hierarch','a_patriarch_MElf',8.00,22.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3682,30155,'Ellenia','Master','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3683,30156,'Cobendell','Master','a_guard_MElf',8.00,23.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3684,30157,'Greenis','Magister','a_trader_FElf',8.00,24.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3685,30158,'Esrandell','Magister','a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3686,30162,'Karin','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3687,30163,'Rex','Trader','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3688,30164,'Ian','Trader','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3689,30165,'Ralford','Trader','a_trader_FElf',8.00,24.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3690,30166,'Wesley','Magic Trader','a_traderA_MHuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3691,30169,'Marty','Warehouse Freightman','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3692,30170,'Radic','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3693,30171,'Gaius','Magister','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3694,30174,'Arkenias','Grand Magister','a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3695,30175,'Fairen','Grand Magister','a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3696,30176,'Valleria','Grand Magister','a_mageguild_master_FHuman',8.00,23.00,70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3697,30177,'Valentina','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3698,30178,'Zenkin','Trader','a_traderA_MHuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3699,30179,'Raudia','Trader','a_traderB_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3700,30180,'Sara','Trader','a_traderA_FHuman',8.00,23.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3701,30181,'Galibredo','Trader','a_traderA_MHuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3702,30182,'Cliff','Warehouse Freightman','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3703,30183,'Hagger','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3704,30184,'Rigol','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3705,30185,'Taniac Blackbird','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3706,30186,'Bhan','Master','a_guard_MElf',8.00,23.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3707,30187,'Klaus Blackbird','Grand Master','a_fighterguild_master_Mhuman_old',8.00,23.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3708,30188,'Vadin','Priest','a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3709,30189,'Rovia','Magister','a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3710,30190,'Phanovia','Magister','a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3711,30191,'Hollint','High Priest','a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3712,30192,'Darya','Master','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3713,30194,'Gideon','Magister','a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3714,30195,'Brecson','Grand Master','a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3715,30196,'Mouen','Captain','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3716,30197,'Hector','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3717,30198,'Jerin','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3718,30199,'Yates','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3719,30200,'Stan','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3720,30201,'Pinaps','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3721,30207,'Arodin','Trader','a_traderA_MHuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3722,30208,'Damion','Trader','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3723,30209,'Colleen','Trader','a_traderB_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3724,30210,'Norman','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3725,30216,'Wheeler','Sentinel','a_guard_MElf',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3726,30217,'Berros','Sentinel','a_guard_MElf',8.00,23.50,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,276,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3727,30218,'Kendell','Sentinel','a_guard_MElf',8.00,23.50,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,276,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3728,30219,'Veltress','Sentinel','a_guard_MElf',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3729,30220,'Starden','Sentinel','a_guard_MElf',8.00,23.50,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,276,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3730,30221,'Rayen','Sentinel','a_guard_MElf',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3731,30222,'Alshupes','','a_common_people_MElf',6.00,21.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3732,30223,'Arujien','','a_trader_MElf',8.00,25.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3733,30224,'Rayla','Sentry Knight','a_guard_FDarkelf',8.00,25.00,80,'female','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,79,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3734,30230,'Edroc','Trader','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3735,30231,'Garette','Trader','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3736,30232,'Sorint','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3737,30233,'Esmeralda','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3738,30253,'Simplon','Trader','a_traderA_MHuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3739,30254,'Harmony','Trader','a_traderA_FHuman',8.00,23.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3740,30255,'Haprock','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3741,30256,'Bella','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3742,30283,'Altran','Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3743,30284,'Alberius','Sentinel Knight','a_guard_MElf',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,150,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3744,30285,'Gartrandell','Sentinel','a_guard_MElf',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3745,30288,'Rains','Grand Master','a_fighterguild_master_Mhuman_old',8.00,23.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3746,30289,'Raymond','High Priest','a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3747,30290,'Xenos','Grand Master','a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3748,30291,'Alex','Captain','a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,68,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3749,30293,'Manuel','Priest','a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3750,30294,'Varan','Trader','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3751,30297,'Tobias','Grand Master','a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3752,30298,'Pinter','Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3753,30300,'Pushkin','Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3754,30301,'Hally','Trader','a_traderA_FHuman',8.00,23.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3755,30305,'Vellior','Tetrarch','a_clergyman_MDarkElf',8.00,22.30,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3756,30307,'Karrod','Blacksmith','a_common_people_MDarkElf',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3757,30311,'Sir Collin Windawood','','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3758,30312,'Rockswell','Lighthouse Keeper','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3759,30313,'Asha','Trader','a_traderA_FHuman',8.00,23.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3760,30314,'Nestle','Trader','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3761,30315,'Poesia','Trader','a_traderA_FHuman',8.00,23.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3762,30316,'Raut','Warehouse Freightman','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3763,30317,'Kluto','Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3764,30320,'Richlin','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3765,30321,'Sydnia','Trader','a_traderA_FHuman',8.00,23.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3766,30322,'Ballin','Warehouse Freightman','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3767,30325,'Audiberti','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3768,30326,'Leona','Master','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3769,30327,'Sorius','Master','a_guard_MElf',8.00,23.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3770,30328,'Reisa','Master','a_common_people_FElf',8.00,25.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3771,30329,'Virgil','Master','a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3772,30330,'Sidra','Magister','a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3773,30331,'Thoma','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3774,30332,'Bathis','Captain','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3775,30333,'Praga','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3776,30334,'Babenco','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3777,30335,'Brynn','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3778,30336,'Curtis','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3779,30337,'Moretti','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3780,30338,'Melville','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(3781,30342,'Varsak','','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3782,30344,'Rohmer','Magister','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3783,30345,'Ramoniell','Magister','a_trader_FElf',8.00,24.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3784,30346,'Kayleen','Sentry','a_guard_FDarkelf',8.00,25.00,80,'female','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3785,30347,'Marion','Sentry','a_guard_FDarkelf',8.00,25.00,80,'female','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3786,30348,'Nelsya','Sentry','a_guard_FDarkelf',8.00,25.00,80,'female','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3787,30349,'Jenna','Sentry','a_guard_FDarkelf',8.00,25.00,80,'female','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3788,30350,'Carlon','Warehouse Freightman','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3789,30351,'Astaron','','a_common_people_MDarkElf',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3790,30352,'Karina','','a_common_people_FDarkElf',8.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3791,30353,'Jughead','','a_common_people_MDarkElf',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3792,30354,'Jewel','','a_common_people_FDarkElf',8.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3793,30355,'Roselyn','Sentry','a_guard_FDarkelf',8.00,25.00,80,'female','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3794,30356,'Altima','Sentry','a_guard_FDarkelf',8.00,25.00,80,'female','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3795,30357,'Kristin','Sentry','a_guard_FDarkelf',8.00,25.00,80,'female','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3796,30358,'Thifiell','Tetrarch','a_clergyman_MDarkElf',8.00,22.30,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3797,30359,'Kaitar','Tetrarch','a_clergyman_MDarkElf',8.00,22.30,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3798,30360,'Harant','Master','a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3799,30361,'Rizraell','','a_common_people_FElf',8.00,25.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3800,30362,'Andellia','','a_common_people_FElf',8.00,25.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3801,30363,'Aios','Blacksmith','a_trader_MElf',8.00,25.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3802,30368,'Lilith','','a_common_people_FElf',8.00,25.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3803,30369,'Baenedes','Master','a_guard_MElf',8.00,23.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3804,30370,'Nerupa','','aracne',15.00,26.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,64,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(3805,30371,'Thalia','','a_common_people_FElf',8.00,25.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3806,30373,'Ramos','Grand Master','a_fighterguild_master_Mhuman_old',8.00,23.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3807,30374,'Rhodiell','Master','a_common_people_FElf',8.00,25.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3808,30375,'Adonius','Priest','a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3809,30376,'Nell','Magister','a_trader_FElf',8.00,24.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3810,30377,'Talbot','Magister','a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3811,30378,'Estella','Master','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3812,30379,'Bezique','Captain','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,280,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3813,30380,'Plink','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3814,30381,'Alvah','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3815,30382,'Leikan','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3816,30383,'Scott','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3817,30384,'Linus','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3818,30385,'Weisz','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3819,30386,'Luis','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3820,30387,'Clancy','Wharf Manager','a_wharfinger_MHuman',8.00,23.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3821,30391,'Parina','','a_common_peopleB_FHuman',8.00,20.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3822,30400,'Newbie Helper','','a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3823,30401,'Newbie Helper','','a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3824,30402,'Newbie Helper','','a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3825,30403,'Newbie Helper','','a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3826,30404,'Newbie Helper','','a_clergyman_MDarkElf',8.00,22.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3827,30405,'Marius','','a_trader_MElf',8.00,25.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3828,30406,'Matheo','','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3829,30407,'Mesella','','a_common_peopleA_FHuman',8.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3830,30408,'Lionel','','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3831,30409,'Earth Snake','','lesser_basilisk',34.00,25.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,35,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(3832,30410,'Wasteland Lizardman','','virud_lizardman',10.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,43,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(3833,30411,'Flame Salamander','','salamander',16.00,6.80,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,64,96,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.20,'false',1,0),
(3834,30412,'Wind Sylph','','sylph',11.00,35.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,60,60,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(3835,30413,'Water Undine','','undine',12.00,27.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,60,60,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',1,0),
(3836,30414,'Rosella','','a_common_people_FElf',8.00,25.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3837,30415,'Charkeren','','a_common_people_MDarkElf',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3838,30416,'Triskel','','a_common_people_MDarkElf',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3839,30417,'Sir Klaus Vasper','','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3840,30418,'Annika','','a_common_people_FDarkElf',8.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3841,30419,'Arkenia','Witch','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3842,30420,'Tyra','','a_trader_Fdarkelf',8.00,24.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3843,30421,'Varika','Witch','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3844,30422,'Kalinta','Abyssal Celebrant','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3845,30423,'Northwind','','a_trader_MElf',8.00,25.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3846,30424,'Allana','','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3847,30425,'Neti','','a_common_peopleA_FHuman',8.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3848,30426,'Prias','','a_wharfinger_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3849,30427,'Siff','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3850,30428,'Perrin','','a_casino_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3851,30429,'Tiramisa','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3852,30430,'Trionell','Sentinel','a_guard_MElf',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3853,30431,'Eriel','Sentinel','a_guard_MElf',8.00,23.50,80,'male','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3854,30432,'Irene','Sentry','a_guard_FDarkelf',8.00,25.00,80,'female','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3855,30433,'Kathaway','Sentry','a_guard_FDarkelf',8.00,25.00,80,'female','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3856,30434,'Samed','','a_wharfinger_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3857,30435,'Leopold','','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3858,30436,'Sarien','Trader','a_traderA_MHuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3859,30437,'Rolento','Trader','a_traderA_MDwarf',8.00,17.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3860,30452,'Kurt','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3861,30458,'Poitan','Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3862,30459,'Wandius','Master','a_guard_MElf',8.00,23.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3863,30460,'Cardien','Master','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3864,30461,'Mirien','Magister','a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3865,30462,'Tronix','Grand Master','a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3866,30463,'Ixia','Master','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3867,30464,'Clayton','Magister','a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3868,30465,'Herven','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3869,30466,'Bright','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(3870,30469,'Jonas','','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3871,30471,'Rupio','Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3872,30472,'Rosheria','Master','a_common_people_FElf',8.00,25.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3873,30473,'Bandellos','Priest','a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3874,30474,'Angus','Grand Master','a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3875,30475,'Stapin','Master','a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3876,30476,'Kaira','Magister','a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3877,30477,'Sir Ortho Lancer','','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3878,30478,'Reikin','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3879,30483,'Mozella','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3880,30484,'Ponti','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3881,30485,'Capella','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3882,30486,'Hanna','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3883,30487,'Penelope','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3884,30497,'Edmond','','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3885,30498,'Moke','Warehouse Chief','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3886,30499,'Tapoy','Head Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3887,30500,'Osborn','High Prefect','e_guard_MOrc',8.00,27.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3888,30501,'Kasman','Prefect','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3889,30502,'Umos','Seer','e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3890,30503,'Rikadio','Warehouse Chief','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3891,30504,'Mendio','Head Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3892,30505,'Drikus','High Prefect','e_guard_MOrc',8.00,27.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3893,30506,'Buka','Prefect','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3894,30507,'Racoy','Seer','e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3895,30508,'Castor','High Prefect','e_guard_MOrc',8.00,27.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3896,30509,'Dowki','Prefect','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3897,30510,'Somak','Seer','e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3898,30511,'Gesto','Warehouse Chief','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3899,30512,'Kusto','Head Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3900,30513,'Penatus','High Prefect','e_guard_MOrc',8.00,27.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3901,30514,'Vokian','Prefect','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3902,30515,'Manakia','Seer','e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3903,30516,'Reep','Trader','a_traderA_MDwarf',8.00,17.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3904,30517,'Shari','Trader','e_traderA_FDwarf',8.00,19.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3905,30518,'Garita','Trader','a_traderA_MDwarf',8.00,17.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3906,30519,'Mion','Trader','e_traderA_FDwarf',8.00,19.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3907,30520,'Reed','Warehouse Chief','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3908,30521,'Murdoc','Warehouse Freightman','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3909,30522,'Airy','Warehouse Keeper','e_traderA_FDwarf',8.00,19.00,70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3910,30523,'Gouph','Collector','e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3911,30524,'Pippi','Collector','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3912,30525,'Bronk','Head Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3913,30526,'Brunon','Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3914,30527,'Silvera','Blacksmith','e_smith_Fdwarf',8.00,17.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3915,30528,'Laferon','Foreman','e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3916,30529,'Maron','Miner','e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3917,30530,'Newbie Helper','','e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3918,30531,'Lockirin','Iron Gate''s','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3919,30532,'Spiron','Golden Wheel''s','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3920,30533,'Balanki','Silver Scale''s','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3921,30534,'Keef','Bronze Key''s','e_collector_master_MDwarf',8.00,18.40,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3922,30535,'Filaur','Gray Pillar Member','e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3923,30536,'Arin','Black Anvil''s','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3924,30537,'Daichir','Priest of the Earth','e_clergyman_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3925,30538,'Zimenf','Priest of the Earth','e_clergyman_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3926,30539,'Chichirin','Priestess of the Earth','e_traderA_FDwarf',8.00,19.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3927,30540,'Wirphy','Gatekeeper','e_teleporter_FDwarf',8.00,21.30,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3928,30541,'Paion','Protector','e_guard_MDwarf',8.00,19.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,282,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3929,30542,'Runant','Defender','e_guard_MDwarf',8.00,19.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,273,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3930,30543,'Ethan','Defender','e_guard_MDwarf',8.00,19.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,296,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3931,30544,'Cromwell','Defender','e_guard_MDwarf',8.00,19.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,296,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3932,30545,'Proton','Defender','e_guard_MDwarf',8.00,19.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,296,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3933,30546,'Dinkey','Defender','e_guard_MDwarf',8.00,19.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,273,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3934,30547,'Tardyon','Defender','e_guard_MDwarf',8.00,19.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,273,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3935,30548,'Nathan','Defender','e_guard_MDwarf',8.00,19.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,296,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3936,30549,'Ghouliff Droopstone','','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3937,30550,'Gauri Twinklerock','','e_traderA_FDwarf',8.00,19.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3938,30551,'Tink Wandergold','','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3939,30552,'Kiril Sparkystone','','e_traderA_FDwarf',8.00,19.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3940,30553,'Maryse Redbonnet','','e_traderA_FDwarf',8.00,19.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3941,30554,'Bolter','Miner','e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3942,30555,'Torocco','Carrier','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3943,30556,'Toma','Master','e_collector_master_MDwarf',8.00,18.40,70,'male','L2Npc','Toma',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3944,30557,'Torai','','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3945,30558,'Jakal','Trader','e_trader_MOrc',8.00,23.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3946,30559,'Kunai','Trader','e_trader_FOrc',8.00,24.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3947,30560,'Uska','Trader','e_trader_MOrc',8.00,23.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3948,30561,'Papuma','Trader','e_trader_MOrc',8.00,23.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3949,30562,'Grookin','Warehouse Keeper','e_trader_MOrc',8.00,23.50,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3950,30563,'Imantu','Warehouse Freightman','e_trader_MOrc',8.00,23.50,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3951,30564,'Sumari','Blacksmith','e_trader_MOrc',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3952,30565,'Kakai','Flame Lord','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3953,30566,'Varkees','Atuba Chief','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,81,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(3954,30567,'Tantus','Neruga Chief','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,175,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3955,30568,'Hatos','Urutu Chief','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3956,30569,'Brukurse','Prefect','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3957,30570,'Karukia','Prefect','e_trader_FOrc',8.00,24.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3958,30571,'Tanapi','Seer','e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3959,30572,'Livina','Seer','e_clergyman_FOrc',6.50,28.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3960,30573,'Vulkus','Flame Guardian','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3961,30575,'Newbie Helper','','e_clergyman_FOrc',6.50,28.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3962,30576,'Tamil','Gatekeeper','e_teleporter_FOrc',8.00,32.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3963,30577,'Rukain','Praetorian','e_guard_MOrc',8.00,27.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,279,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3964,30578,'Nakusin','Centurion','e_guard_MOrc',8.00,27.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3965,30579,'Tamai','Centurion','e_guard_MOrc',8.00,27.00,80,'male','L2Guard','Guard',1100,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3966,30580,'Parugon','Centurion','e_guard_MOrc',8.00,27.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,91,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3967,30581,'Orinak','Centurion','e_guard_MOrc',8.00,27.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(3968,30582,'Tiku','Centurion','e_guard_MOrc',8.00,27.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,91,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3969,30583,'Petukai','Centurion','e_guard_MOrc',8.00,27.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,91,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3970,30584,'Vapook','Centurion','e_guard_MOrc',8.00,27.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,91,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3971,30585,'Tataru Zu Hestui','','e_common_people_MOrc',8.00,26.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3972,30586,'Anai Zu Neruga','','e_trader_FOrc',8.00,24.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3973,30587,'Gantaki Zu Urutu','','e_common_people_MOrc',8.00,26.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3974,30588,'Takia Zu Duda-Mara','','e_trader_FOrc',8.00,24.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3975,30589,'Kazkin Zu Gandi','','e_trader_MOrc',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(3976,30590,'Rosheek','Khavatari','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3977,30591,'Toruku','Khavatari','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3978,30592,'Hestui Totem Spirit','','grizzly',21.00,40.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(3979,30593,'Duda-Mara Totem Spirit','','giant_spider',26.00,26.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'false',1,0),
(3980,30594,'Ranspo','Warehouse Chief','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3981,30595,'Opix','Head Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3982,30596,'Harkel','Partisan Doorman','ol_mahum',13.50,25.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(3983,30597,'Piotur','','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3984,30598,'Newbie Guide','','a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3985,30599,'Newbie Guide','','a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3986,30600,'Newbie Guide','','a_guild_master_MDarkElf',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3987,30601,'Newbie Guide','','e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3988,30602,'Newbie Guide','','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3989,30608,'Maria','','a_common_peopleB_FHuman',8.00,20.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3990,30609,'Creta','Astrologer','a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3991,30610,'Cronos','Elder','a_mageguild_master_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3992,30611,'Triff','Drunkard','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3993,30612,'Casian','Elder','a_mageguild_master_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3994,30613,'Alders Spirit','','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(3995,30614,'Metheus','Brother','a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(3996,30615,'Voltar','Breka Chief','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,173,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',1,0),
(3997,30616,'Kepra','Enku Chief','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,162,0,0,45,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.76,'false',1,0),
(3998,30617,'Burai','Turek Chief','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,172,0,0,45,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'false',1,0),
(3999,30618,'Harak','Leunt Chief','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,172,0,0,45,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(4000,30619,'Driko','Vuku Chief','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,183,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'false',1,0),
(4001,30620,'Emily','','a_common_peopleA_FHuman',8.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4002,30621,'Nikola','Maestro','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4003,30622,'Box Of Titan','','coffer_b',12.00,9.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4004,30623,'Kaien','Duelist','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,135,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4005,30624,'Ascalon','Veteran','a_wharfinger_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,16,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4006,30625,'Mason','','a_wharfinger_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4007,30626,'Hamil','Sagittarius','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4008,30627,'Tree','','human_tree',35.00,90.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4009,30628,'Strong Wooden Chest','','box',18.00,14.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4010,30629,'Rukal','Bard','a_common_people_MElf',6.00,21.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,4202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4011,30630,'Orim','Shadow','a_hardins_pupil_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4012,30631,'Roderik','Warden','a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4013,30632,'Endrigo','Warden','a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4014,30633,'Evert','Fisher','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4015,30634,'Galatea','High Summoner','a_mageguild_master_FHuman',8.00,23.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4016,30635,'Almors','Summoner','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4017,30636,'Camoniell','Summoner','a_trader_FElf',8.00,24.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4018,30637,'Belthus','Summoner','a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4019,30638,'Basilla','Summoner','a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4020,30639,'Celestiel','Summoner','a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4021,30640,'Brynthea','Summoner','a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4022,30641,'Takuna','Duda-Mara Chief','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4023,30642,'Chianta','Gandi Chief','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,175,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4024,30643,'First Orc','','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4025,30644,'Kash','','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4026,30645,'Martien','','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4027,30646,'Raldo','Champion','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4028,30647,'Chest Of Shyslassys','','coffer_c',12.00,9.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4029,30648,'Santiago','Hermit','a_traderA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4030,30649,'Ancestor Martankus','','orc_head',110.00,103.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4031,30650,'Gerald','Priest of the Earth','e_traderA_FDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4032,30651,'Dorf','Wanderer','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4033,30652,'Uruha','','a_common_people_FDarkElf',8.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4034,30653,'Sir Aron Tanford','','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4035,30654,'Sir Kiel Nighthawk','','a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,74,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4036,30655,'Isael Silvershadow','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4037,30656,'Spirit Of Sir Talianus','','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(4038,30657,'Seresin','Cardinal','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4039,30658,'Gupu','Father','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4040,30659,'Orphan Girl','','e_traderA_FDwarf',8.00,19.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4041,30660,'Windy Shaoring','','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4042,30661,'Mysterious Dark Elf','','a_casino_FDarkElf',8.00,23.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4043,30662,'Piper Longbow','','a_common_people_FElf',8.00,25.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4044,30663,'Slein Shining Blade','','a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,69,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4045,30664,'Kein Flying Knife','','a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,217,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4046,30665,'Kristina','Saint','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4047,30666,'Sla','Preacher','a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4048,30667,'Ramus','','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4049,30668,'Katari','','a_common_people_FDarkElf',8.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4050,30669,'Kakan','','e_trader_FOrc',8.00,24.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4051,30670,'Nyakuri','','e_traderA_FDwarf',8.00,19.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4052,30671,'Croto','Chief','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4053,30672,'Dubabah','Jailer','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4054,30673,'Lorain','Researcher','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4055,30674,'Daurin Hammercrush','','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4056,30675,'Corpse Of Kamur','','e_trader_Morc_death',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4057,30676,'Croop','Warehouse Chief','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4058,30677,'Flutter','Head Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4059,30678,'Helton','Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4060,30679,'Roameria','Master','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4061,30680,'Egnos','Priest','a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4062,30681,'Karia','High Prefect','e_trader_FOrc',8.00,24.00,70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4063,30682,'Pekiron','Seer','e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4064,30683,'Daunt','Prefect','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4065,30684,'Viktor','Trader','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4066,30685,'Baxt','Warehouse Chief','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4067,30686,'Silva','Warehouse Freightman','e_traderA_FDwarf',8.00,19.00,70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4068,30687,'Vergara','Head Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4069,30688,'Duning','Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4070,30689,'Siria','Grand Master','a_fighterguild_master_FHuman',8.00,21.50,70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4071,30690,'Luther','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4072,30691,'Aren Athebalt','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4073,30692,'Stedmiel','Master','a_guard_MElf',8.00,23.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4074,30693,'Queenien','Master','a_common_people_FElf',8.00,25.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4075,30694,'Scraide','Grand Magister','a_mageguild_master_MHuman',8.00,24.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4076,30695,'Moses','Magister','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4077,30696,'Page','Magister','a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4078,30697,'Videlrien','Magister','a_trader_FElf',8.00,24.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4079,30698,'Evelyn','Magister','a_trader_FElf',8.00,24.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4080,30699,'Medown','Grand Master','a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4081,30700,'Prestan','Master','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4082,30701,'Errickin','Magister','a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4083,30702,'Bernard','Guild President','a_casino_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4084,30703,'Colin','Guild President','a_wharfinger_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4085,30704,'Garvarentz','High Prefect','e_guard_MOrc',8.00,27.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4086,30705,'Chakiris','Prefect','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4087,30706,'Lazenby','Seer','e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4088,30707,'Raigen','Captain','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4089,30708,'Nasign','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4090,30709,'Norton','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4091,30710,'Weston','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4092,30711,'Byron','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4093,30712,'Makhis','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4094,30713,'Gardner','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4095,30714,'Paros','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4096,30715,'Marina','Magister','a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4097,30716,'Cecile','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4098,30717,'Gauen','Magister','a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4099,30718,'Joan','Magister','a_trader_FElf',8.00,24.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4100,30719,'Mariell','Gatekeeper','a_common_people_FElf',8.00,25.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4101,30720,'Kaiena','Magister','a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4102,30721,'Ladd','Magister','a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4103,30722,'Merian','Gatekeeper','a_teleporter_FDarkElf',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4104,30723,'Roy','Captain','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4105,30724,'Tavillian','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4106,30725,'Yening','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4107,30726,'Tebose','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4108,30727,'Verona','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4109,30728,'Leirynn','Militiaman','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,93,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4110,30729,'Borys','Drunkard','a_wharfinger_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4111,30730,'Jax','Bodyguard','a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,232,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4112,30731,'Martin','Pet Manager','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4113,30732,'Ol Mahum Pilgrim','','ol_mahum',13.50,25.00,36,'male','L2Npc','npc',40,1279,4.500,463,1.800,40,43,30,21,20,10,0,0,206,175,96,142,278,0,253,1,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'false',0,0),
(4114,30733,'Guard','','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4115,30734,'Supply Box On Wharf','','box',18.00,14.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4116,30735,'Sophya','Mercenary Captain','a_fighterguild_master_FHuman',8.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4117,30736,'Redfoot','Mercenary','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4118,30737,'Morgan','Guildsman','a_traderA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4119,30738,'Matild','Alchemist','e_traderA_FDwarf',8.00,19.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4120,30739,'Keltir','Royal Servant','fox',9.50,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4121,30740,'Toad','Royal Servant','poison_toad',20.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',0,0),
(4122,30741,'Rabbit','Royal Servant','rabbit',5.00,4.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4123,30742,'Rupina','Fairy of Love','pixy',5.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.72,'false',0,0),
(4124,30743,'Wisdom Chest','','coffer_c',12.00,9.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4125,30744,'Grey','Guild Member','a_traderA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4126,30745,'Tor','Guild Member','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4127,30746,'Cybellin','','a_teleporter_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(4128,30747,'Mimyu','Fairy','pixy',5.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.72,'false',1,0),
(4129,30748,'Exarion','Drake','drake',30.00,100.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.84,'false',1,0),
(4130,30749,'Zwov','Drake','drake',30.00,100.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.84,'false',1,0),
(4131,30750,'Kalibran','Drake','drake',30.00,100.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.84,'false',1,0),
(4132,30751,'Suzet','Wyrm','wyrm',29.00,72.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.19,'false',1,0),
(4133,30752,'Shamhai','Wyrm','wyrm',29.00,72.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.19,'false',1,0),
(4134,30753,'Gabrielle','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4135,30754,'Gilmore','Antharas Watchman','skeleton_knight',10.00,25.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,150,0,0,40,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(4136,30755,'Theodric','Antharas Watchman','skeleton_knight',10.00,25.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,127,0,0,40,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(4137,30756,'Sir Kristof Rodemai','','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4138,30757,'Statue Of Offering','','castle_kent_statue_jewel',25.00,98.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4139,30758,'Athrea','Witch','a_hardins_pupil_FHuman',8.00,23.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4140,30759,'Kalis','Witch','a_hardins_pupil_FHuman',8.00,23.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4141,30760,'Sir Gustav Athebaldt','','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,128,632,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4142,30761,'Corpse Of Fritz','','e_guard_MDwarf_death',13.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4143,30762,'Corpse Of Lutz','','e_guard_MDwarf_death',13.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4144,30763,'Corpse Of Kurtz','','e_guard_MDwarf_death',13.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4145,30764,'Balthazar','','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4146,30765,'Imperial Coffer','','coffer_d',12.00,9.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4147,30766,'Cleo','Witch','a_hardins_pupil_FHuman',8.00,23.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4148,30767,'Auctioneer','','a_maidB_FHuman',8.00,22.50,70,'female','L2Auctioneer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4149,30768,'Auctioneer','','a_trader_FElf',8.00,24.00,70,'female','L2Auctioneer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4150,30769,'Auctioneer','','a_maidB_FHuman',8.00,21.50,70,'female','L2Auctioneer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4151,30770,'Auctioneer','','e_traderA_FDwarf',8.00,19.00,70,'female','L2Auctioneer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4152,30771,'Auctioneer','','e_trader_FOrc',8.00,24.00,70,'female','L2Auctioneer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4153,30772,'Wilson','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4154,30773,'Todd','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4155,30827,'Lundy','Pet Manager','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4156,30828,'Waters','Pet Manager','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4157,30829,'Cooper','Pet Manager','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4158,30830,'Joey','Pet Manager','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4159,30831,'Nelson','Pet Manager','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4160,30832,'Hardin','','a_hardin_MHuman',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4161,30833,'Kaspar','Magister','a_hardins_pupil_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4162,30834,'Cema','Magic Trader','a_hardins_pupil_FHuman',8.00,23.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4163,30835,'Icarus','Lich King','liviona',12.00,40.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,212,0,0,70,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.74,'false',1,0),
(4164,30836,'Minerva','Gatekeeper','a_teleporter_FDarkElf',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4165,30837,'Woodrow','Trader','a_traderA_MHuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4166,30838,'Woodley','Trader','a_traderA_MHuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4167,30839,'Holly','Trader','a_traderA_FHuman',8.00,23.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4168,30840,'Lorenzo','Trader','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4169,30841,'Carson','Trader','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4170,30842,'Alexis','Trader','a_trader_FElf',8.00,24.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4171,30843,'Romp','Warehouse Freightman','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4172,30844,'Walderal','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4173,30845,'Klump','Warehouse Chief','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4174,30846,'Wilbert','Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4175,30847,'Ferris','Head Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4176,30848,'Elisa','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4177,30849,'Sedrick','Grand Master','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4178,30850,'Aiken','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4179,30851,'Kendra','Master','a_fighterguild_master_FHuman',8.00,21.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4180,30852,'Sinden','Master','a_guard_MElf',8.00,23.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4181,30853,'Raien','Master','a_common_people_FElf',8.00,25.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4182,30854,'Drikiyan','Grand Magister','a_mageguild_master_MHuman',8.00,24.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4183,30855,'Desmond','Magister','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4184,30856,'Winonin','Magister','a_common_people_FElf',8.00,25.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4185,30857,'Orven','High Priest','a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4186,30858,'Ross','Priest','a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4187,30859,'Vivyan','Priestess','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4188,30860,'Flownia','Priestess','a_trader_FElf',8.00,24.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4189,30861,'Leonard','Priest','a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4190,30862,'Oltlin','Grand Master','a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4191,30863,'Ghest','Master','a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4192,30864,'Hanellin','Magister','a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4193,30865,'Ladanza','High Prefect','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4194,30866,'Marestella','Prefect','e_trader_FOrc',8.00,24.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4195,30867,'Reva','Seer','e_trader_MOrc',8.00,23.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4196,30868,'Sir Eric Rodemai','','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,128,632,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4197,30869,'Lemper','Pet Manager','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4198,30870,'Kurtiz','Captain','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4199,30871,'Bret','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4200,30872,'Conroy','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4201,30873,'Coleman','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4202,30874,'Aldis','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4203,30875,'Carlton','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4204,30876,'Eastan','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4205,30877,'Grayson','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4206,30878,'Angelina','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4207,30879,'Felton','Wharf Manager','a_wharfinger_MHuman',8.00,23.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4208,30880,'Viktor Van Dake','Border Outpost Captain','a_royal_guardA_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,5817,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4209,30881,'Sanders','Border Outpost Aide','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4210,30882,'Frontier Guard','','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,5817,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4211,30883,'Frontier Guard','','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,14,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(4212,30884,'Frontier Guard','','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4213,30885,'Frontier Guard','','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,5817,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,14,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(4214,30886,'Frontier Guard','','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,5817,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4215,30887,'Frontier Guard','','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,14,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(4216,30888,'Frontier Guard','','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,5817,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4217,30889,'Frontier Guard','','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,5817,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,14,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(4218,30890,'Espen','Trader','a_trader_MElf',8.00,25.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4219,30891,'Verona','Trader','a_traderB_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4220,30892,'Enverun','Trader','a_traderA_MHuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4221,30893,'Payel','Trader','a_trader_FElf',8.00,24.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4222,30894,'Natools','Warehouse Chief','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4223,30895,'Kluck','Warehouse Freightman','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4224,30896,'Mia','Warehouse Keeper','e_traderA_FDwarf',8.00,19.00,70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4225,30897,'Roman','Head Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4226,30898,'Morning','Blacksmith','e_smith_Fdwarf',8.00,17.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4227,30899,'Flauen','Gatekeeper','a_common_people_FElf',8.00,25.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4228,30900,'Marcus','Grand Master','a_fighterguild_master_FHuman',8.00,21.50,70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4229,30901,'Arti','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4230,30902,'Karuna','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4231,30903,'Traus','Master','a_guard_MElf',8.00,23.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4232,30904,'Naiel','Master','a_common_people_FElf',8.00,25.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4233,30905,'Squillari','High Priest','a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4234,30906,'Ranton','Priest','a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4235,30907,'Minevia','Magister','a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4236,30908,'Tanios','Priest','a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4237,30909,'Anabel','Magister','a_trader_FElf',8.00,24.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4238,30910,'Xairakin','Grand Master','a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4239,30911,'Brikus','Master','a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4240,30912,'Xenovia','Magister','a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4241,30913,'Tushku','High Prefect','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4242,30914,'Sorbo','Prefect','e_trader_FOrc',8.00,24.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4243,30915,'Takina','Seer','e_mageguild_teacher_FOrc',8.00,28.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4244,30916,'Gosta','Captain','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4245,30917,'Dupuis','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4246,30918,'Kent','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4247,30919,'Rodic','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4248,30920,'Kraisen','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4249,30921,'Timos','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4250,30922,'Cage','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4251,30923,'Dunst','Guard','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4252,30924,'Nedy','Wharf Manager','a_wharfinger_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4253,30925,'Morelyn','High Priestess','a_trader_FElf',8.00,24.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4254,30926,'Restina','Priestess','a_trader_FElf',8.00,24.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4255,30927,'Alicia','Priestess','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4256,30928,'Fenster','Mercenary','e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4257,30929,'Patrin','Antique Dealer','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4258,30930,'Rogent','Antique Appraiser','e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4259,30931,'Bentley','','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4260,30932,'Benica','','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4261,30933,'Braki','','e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4262,30934,'Marsha','Collector','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4263,30935,'Trumpin','Collector','e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4264,30936,'Malcom1','Frog Prince','poison_toad',20.00,10.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'true',0,0),
(4265,30937,'Malcom2','Wild Boar Prince','giant_wild_hog',25.00,27.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,35,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'true',0,0),
(4266,30938,'Malcom3','Orc Prince','ketra_orc',12.00,29.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,45,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.46,'true',0,0),
(4267,30939,'Malcom4','Prince of Darkness','skeleton_royal_guard',11.00,28.50,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'true',0,0),
(4268,30940,'Malcom5','Gremlin Prince','gremlin',10.00,15.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,20,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4269,30941,'Malcom6','Prince of Wild Beast','saber_toothed_tiger',34.00,28.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,60,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'true',0,0),
(4270,30942,'Malcom7','Monster Eye Prince','monster_eye',21.00,43.00,70,'male','L2Monster','Mystic',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,90,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.30,'true',0,0),
(4271,30943,'Malcom8','Rabbit Prince','rabbit',5.00,4.50,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'true',0,0),
(4272,30944,'Malcom9','Human Prince','a_casino_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4273,30945,'Malcom10','Prince','e_collector_master_MDwarf',8.00,18.40,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4274,30946,'Lucianne Tanford','','a_fighterguild_master_FHuman',8.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4275,30947,'Rerikya','','e_trader_FOrc',8.00,24.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4276,30948,'Meridien','','a_common_people_FElf',8.00,25.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4277,30949,'Keplon','Researcher','e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4278,30950,'Euclie','Researcher','e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4279,30951,'Pithgon','Researcher','e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4280,30952,'Dimensional Vortex 1','','broadcasting_tower',13.00,54.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4281,30953,'Dimensional Vortex 2','','broadcasting_tower',13.00,54.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4282,30954,'Dimensional Vortex 3','','broadcasting_tower',13.00,54.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4283,30955,'Gillian''s Revenant','','zombie',13.00,21.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,15,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(4284,30956,'Nanarin','Musician','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,325,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4285,30957,'Swan','Bard','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,4202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4286,30958,'Galion','','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4287,30959,'Barbado','Musician','e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5133,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4288,30960,'Beer Chest','','box',18.00,14.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4289,30961,'Cloth Chest','','coffer_d',12.00,9.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4290,30962,'Statue of Water','','coffer_d',12.00,9.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4291,30963,'Statue of Fire','','coffer_d',12.00,9.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4292,30964,'Statue of Wind','','coffer_d',12.00,9.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4293,30965,'Statue of Earth','','coffer_d',12.00,9.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4294,30966,'Statue of Darkness','','coffer_d',12.00,9.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4295,30967,'Statue of Light','','coffer_d',12.00,9.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4296,30968,'Jennifer','Lady Orc','e_trader_FOrc',8.00,24.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4297,30969,'Iason Heine','','a_chamberlain_MHuman',9.50,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4298,30970,'Dorothy','Locksmith','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4299,30971,'Orpheus','Mad Doctor','e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4300,30972,'Orpheus Resurrecter','','susceptor',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,27,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(4301,30973,'Medium Jar','','pot',10.00,15.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4302,30974,'Oliver','Resurrected Adventurer','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4303,30975,'Clarine','Resurrected Adventurer','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4304,30976,'Resurrected Town Maiden','','a_common_peopleB_FHuman',8.00,20.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4305,30977,'Holy Ark of Secrecy1','','coffer_a',12.00,9.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4306,30978,'Holy Ark of Secrecy2','','coffer_b',12.00,9.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4307,30979,'Holy Ark of Secrecy3','','coffer_c',12.00,9.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4308,30980,'Ark Guardian''s Corpse','','angel_death',25.00,36.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4309,30981,'Black Judge','','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4310,30982,'Sleeping Ant Larva1','','ant_larva',12.00,8.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',0,0),
(4311,30983,'Sleeping Ant Larva2','','ant_larva',12.00,8.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',0,0),
(4312,30984,'Sleeping Ant Larva3','','ant_larva',12.00,8.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',0,0),
(4313,30985,'Sleeping Ant Larva4','','ant_larva',12.00,8.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',0,0),
(4314,30986,'Sleeping Ant Larva5','','ant_larva',12.00,8.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',0,0),
(4315,30987,'Sleeping Ant Larva6','','ant_larva',12.00,8.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',0,0),
(4316,30988,'Verce','Leathersmith','a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4317,30989,'Chest of Bifrons','','coffer_c',12.00,9.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4318,30990,'Lottery Ticket Seller','','a_casino_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4319,30991,'Lottery Ticket Seller','','a_trader_MElf',8.00,25.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4320,30992,'Lottery Ticket Seller','','a_trader_MDarkElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4321,30993,'Lottery Ticket Seller','','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4322,30994,'Lottery Ticket Seller','','e_trader_MOrc',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4323,30995,'Race Manager','','e_teleporter_FDwarf',8.00,21.30,70,'female','L2RaceManager','RaceManager',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4324,31001,'Claudia Athebalt','','a_mageguild_master_FHuman',8.00,23.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4325,31002,'Reorin','Maestro','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4326,31003,'Here I Come','','cat_the_cat',9.00,16.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(4327,31004,'Half Moon Love','','cutie_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4328,31005,'Everlasting','','mechanic_golem',5.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.72,'false',0,0),
(4329,31006,'Dark Side of the Moon','','silhouette',8.00,23.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(4330,31007,'Wind Rider','','unicorn_boxer',11.00,18.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,27,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(4331,31008,'Shooting Star','','unicorn_mirage',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,27,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(4332,31009,'Cyclone Thunder','','dark_fencer',7.00,13.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,25,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.20,'false',0,0),
(4333,31010,'Hungry Baby','','hatchling',9.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.27,'false',0,0),
(4334,31011,'Salty Dog','','pet_wolf',13.00,11.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(4335,31012,'Raging Revolution','','silver_cat',7.00,15.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4336,31013,'Valentine Blue','','blue_eye',11.00,16.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(4337,31014,'Light My Fire','','big_boom',6.00,13.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4338,31015,'Red Bullet','','fox',9.50,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,23,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4339,31016,'Shining Silver','','rabbit',5.00,4.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4340,31017,'Over the top','','ant_larva',12.00,8.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',0,0),
(4341,31018,'Royal Straight','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4342,31019,'All Seven','','wererat',14.00,25.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(4343,31020,'Nasty Green','','dryad',9.00,20.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4344,31021,'Shortcut','','goblin',10.00,16.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.32,'false',0,0),
(4345,31022,'Typhoon Tiger','','giant_bee',8.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,90,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',0,0),
(4346,31023,'Red Hot','','salamander',16.00,6.80,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,64,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.20,'false',0,0),
(4347,31024,'Galaxy Express','','onyx_beast',14.00,14.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.24,'false',0,0),
(4348,31025,'Best Condition','','manadragora',14.00,17.80,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',0,0),
(4349,31026,'Albatross','','orc',10.00,21.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,45,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(4350,31027,'Coffer of the Dead','','coffer_b',12.00,9.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4351,31028,'Chest of Kernon','','coffer_c',12.00,9.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4352,31029,'Chest of Golkonda','','coffer_c',12.00,9.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4353,31030,'Chest of Hallate','','coffer_c',12.00,9.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4354,31031,'Broadcasting Tower','','broadcasting_tower',13.00,54.00,70,'etc','L2Observation','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4355,31032,'Guard','','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','GuardRndWalkAndAnim',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4356,31033,'Sentinel','','a_guard_MElf',8.00,23.50,80,'male','L2Guard','GuardRndWalkAndAnim',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,276,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4357,31034,'Sentry','','a_guard_FDarkelf',8.00,25.00,80,'female','L2Guard','GuardRndWalkAndAnim',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4358,31035,'Defender','','e_guard_MDwarf',8.00,19.00,80,'male','L2Guard','GuardRndWalkAndAnim',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4359,31036,'Centurion','','e_guard_MOrc',8.00,27.00,80,'male','L2Guard','GuardRndWalkAndAnim',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,273,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4360,31042,'Kantabilon','Melody Maestro','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4361,31043,'Octavia','Melody Maestro','e_traderA_FDwarf',8.00,19.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4362,31044,'Galman','Valley Trader','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4363,31045,'Kitzka','Valley Trader','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4364,31046,'Marsden','Symbol Maker','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4365,31047,'Kell','Symbol Maker','a_mageguild_teacher_FHuman',8.00,23.50,70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4366,31048,'McDermott','Symbol Maker','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4367,31049,'Pepper','Symbol Maker','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4368,31050,'Thora','Symbol Maker','a_mageguild_teacher_FHuman',8.00,23.50,70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4369,31051,'Keach','Symbol Maker','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4370,31052,'Heid','Symbol Maker','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4371,31053,'Kidder','Symbol Maker','a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4372,31067,'Rood','Pet Manager','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4373,31074,'Corpse of Hutaku','','e_trader_Morc_death',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4374,31075,'Sales Cat of Ivory Tower','','cat_the_cat',9.00,16.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(4375,31076,'Newbie Guide','','a_common_peopleB_FHuman',8.00,20.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4376,31077,'Newbie Guide','','a_common_peopleB_FHuman',8.00,20.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4377,31078,'Priest of Dawn','','priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4378,31079,'Priest of Dawn','','priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4379,31080,'Priest of Dawn','','priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4380,31081,'Priest of Dawn','','priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4381,31082,'Priest of Dawn','','priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4382,31083,'Priest of Dawn','','priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4383,31084,'Priest of Dawn','','priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4384,31085,'Dusk Priestess','','priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4385,31086,'Dusk Priestess','','priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4386,31087,'Dusk Priestess','','priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4387,31088,'Dusk Priestess','','priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4388,31089,'Dusk Priestess','','priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4389,31090,'Dusk Priestess','','priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4390,31091,'Dusk Priestess','','priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4391,31092,'Black Marketeer of Mammon','','black_market_trader_MDwarf',8.00,18.00,70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4392,31093,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4393,31094,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4394,31095,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4395,31096,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4396,31097,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4397,31098,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4398,31099,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4399,31100,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4400,31101,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4401,31102,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4402,31103,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4403,31104,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4404,31105,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4405,31106,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4406,31107,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4407,31108,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4408,31109,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4409,31110,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4410,31111,'Gatekeeper Spirit','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4411,31112,'Gatekeeper Spirit','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4412,31113,'Merchant of Mammon','','black_market_trader_MDwarf_set',22.00,18.00,70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4413,31114,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4414,31115,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4415,31116,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4416,31117,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4417,31118,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4418,31119,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4419,31120,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4420,31121,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4421,31122,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4422,31123,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4423,31124,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4424,31125,'Gatekeeper Ziggurat','','teleport_npc_sm',7.00,15.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4425,31126,'Blacksmith of Mammon','','e_smith_master_MDwarf',8.00,17.00,70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4426,31127,'Festival Guide','Level 31 and Below','priest_of_dawn',8.00,30.50,70,'male','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4427,31128,'Festival Guide','Level 42 and Below','priest_of_dawn',8.00,30.50,70,'male','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4428,31129,'Festival Guide','Level 53 and Below','priest_of_dawn',8.00,30.50,70,'male','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4429,31130,'Festival Guide','Level 64 and Below','priest_of_dawn',8.00,30.50,70,'male','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4430,31131,'Festival Guide','No Level Limit','priest_of_dawn',8.00,30.50,70,'male','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4431,31132,'Festival Witch','','a_guard_FDarkelf',8.00,25.00,70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4432,31133,'Festival Witch','','a_guard_FDarkelf',8.00,25.00,70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4433,31134,'Festival Witch','','a_guard_FDarkelf',8.00,25.00,70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4434,31135,'Festival Witch','','a_guard_FDarkelf',8.00,25.00,70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4435,31136,'Festival Witch','','a_guard_FDarkelf',8.00,25.00,70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4436,31137,'Festival Guide','Level 31 and Below','priest_of_dusk',8.00,22.00,70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4437,31138,'Festival Guide','Level 42 and Below','priest_of_dusk',8.00,22.00,70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4438,31139,'Festival Guide','Level 53 and Below','priest_of_dusk',8.00,22.00,70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4439,31140,'Festival Guide','Level 64 and Below','priest_of_dusk',8.00,22.00,70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4440,31141,'Festival Guide','No Level Limit','priest_of_dusk',8.00,22.00,70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4441,31142,'Festival Witch','','a_guard_FDarkelf',8.00,25.00,70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4442,31143,'Festival Witch','','a_guard_FDarkelf',8.00,25.00,70,'female','L2FestivalGuide','npc',40,3889,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4443,31144,'Festival Witch','','a_guard_FDarkelf',8.00,25.00,70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4444,31145,'Festival Witch','','a_guard_FDarkelf',8.00,25.00,70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4445,31146,'Festival Witch','','a_guard_FDarkelf',8.00,25.00,70,'female','L2FestivalGuide','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4446,31147,'Sobling','Head Researcher','e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4447,31148,'Pirate''s Chest','','coffer_c',12.00,9.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4448,31149,'Alchemist''s Mixing Urn','','pot',10.00,15.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4449,31168,'Priest of Dawn','','priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4450,31169,'Dusk Priestess','','priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4451,31170,'Crest of Dawn','','flag_ssq',0.01,0.01,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4452,31171,'Crest of Dusk','','flag_ssq',0.01,0.01,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4453,31172,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4454,31173,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4455,31174,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4456,31175,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4457,31176,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4458,31177,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4459,31178,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4460,31179,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4461,31180,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4462,31181,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4463,31182,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4464,31183,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4465,31184,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4466,31185,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4467,31186,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4468,31187,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4469,31188,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4470,31189,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4471,31190,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4472,31191,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4473,31192,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(4474,31193,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4475,31194,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4476,31195,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4477,31196,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4478,31197,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4479,31198,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4480,31199,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4481,31200,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4482,31201,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4483,31202,'Maximus','','pet_wolf',13.00,11.50,70,'male','L2Npc','RndWalkAndAnim',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(4484,31203,'Moon Dancer','','pet_wolf',13.00,11.50,70,'male','L2Npc','RndWalkAndAnim',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(4485,31204,'Georgio','','pet_wolf',13.00,11.50,70,'male','L2Npc','RndWalkAndAnim',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(4486,31205,'Katz','','hatchling',9.00,10.00,70,'male','L2Npc','RndWalkAndAnim',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.27,'false',1,0),
(4487,31206,'Ten Ten','','hatchling',9.00,10.00,70,'male','L2Npc','RndWalkAndAnim',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.27,'false',1,0),
(4488,31207,'Sardinia','','hatchling',9.00,10.00,70,'male','L2Npc','RndWalkAndAnim',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.27,'false',1,0),
(4489,31208,'La Grange','','hatchling',9.00,10.00,70,'male','L2Npc','RndWalkAndAnim',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.27,'false',1,0),
(4490,31209,'Misty Rain','','pet_wolf',13.00,11.50,70,'male','L2Npc','RndWalkAndAnim',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(4491,31210,'Race Track Gatekeeper','','e_teleporter_FDwarf',8.00,21.30,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4492,31211,'Race Track Guide','','e_traderA_FDwarf',8.00,19.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4493,31212,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,199300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4494,31213,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,199300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4495,31214,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,199300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4496,31215,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,199300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4497,31216,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,199300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4498,31217,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,199300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4499,31218,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,199300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4500,31219,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,199300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4501,31220,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,199300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4502,31221,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,199300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4503,31222,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,199300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4504,31223,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,199300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4505,31224,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,199300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4506,31225,'Arena Manager','','e_teleporter_FDwarf',8.00,21.30,70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4507,31226,'Arena Director','','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4508,31227,'Orion the Cat','Event Manager','cat_the_cat',9.00,16.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(4509,31228,'Roy the Cat','Event Manager','cat_the_cat',9.00,16.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(4510,31229,'Winnie the Cat','Event Manager','cutie_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4511,31230,'Louie the Cat','Event Manager','silver_cat',7.00,15.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4512,31231,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4513,31232,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4514,31233,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4515,31234,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4516,31235,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4517,31236,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4518,31237,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4519,31238,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4520,31239,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4521,31240,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4522,31241,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4523,31242,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4524,31243,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4525,31244,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4526,31245,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4527,31246,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(4528,31247,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',0,0),
(4529,31248,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',0,0),
(4530,31249,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',0,0),
(4531,31250,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',0,0),
(4532,31251,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',0,0),
(4533,31252,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',0,0),
(4534,31253,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',0,0),
(4535,31254,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'true',0,0),
(4536,31255,'Orion the Cat','Event Manager','cat_the_cat',9.00,16.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'true',0,0),
(4537,31256,'Leon','Trader','a_traderC_Mhuman',8.00,23.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4538,31257,'Veronica','Trader','a_traderD_Fhuman',8.00,22.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4539,31258,'Helmut','Trader','a_common_peopleC_Mhuman',8.00,23.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4540,31259,'Janne','Trader','a_common_peopleC_Fhuman',7.00,21.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4541,31260,'Judith','Trader','a_traderD_Fhuman',8.00,22.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4542,31261,'Renee','Trader','e_warehouse_keeper_FDwarf',6.00,18.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4543,31262,'Rupert','Trader','a_traderD_Mhuman',7.00,21.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4544,31263,'Liesel','Trader','a_common_peopleC_Fhuman',7.00,21.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4545,31264,'Olsun','Symbol Maker','a_traderC_Mhuman',8.00,23.00,70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4546,31265,'Annette','Pet Manager','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4547,31266,'Kaiser','','youth_tiger',16.00,17.20,70,'male','L2Npc','RndWalkAndAnim',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,60,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.45,'false',1,0),
(4548,31267,'Lietta','Warehouse Keeper','e_warehouse_keeper_FDwarf',6.00,18.00,70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4549,31268,'Hakon','Warehouse Keeper','e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4550,31269,'Mona','Warehouse Chief','e_traderB_FDwarf',6.00,18.00,70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4551,31270,'Stefano','Warehouse Freightman','e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4552,31271,'Hilda','Blacksmith','e_smith_Fdwarf',8.00,17.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,87,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4553,31272,'Noel','Head Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4554,31273,'Borodin','Blueprint Seller','e_mine_teacher_MDwarf',8.00,18.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4555,31274,'Fundin','Mineral Trader','a_smith_MDwarf',7.00,16.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4556,31275,'Tatiana','Gatekeeper','e_teleporter_Fhuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4557,31276,'Bernhard','Grand Master','a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,76,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4558,31277,'Felix','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,125,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4559,31278,'Bronwyn','Master','a_fighterguild_teacher_MElf',7.00,22.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4560,31279,'Gregory','High Priest','a_temple_master_Mhuman',8.00,24.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,193,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4561,31280,'Bastian','Priest','a_temple_teacher_Mhuman',7.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4562,31281,'Cerenas','Priest','a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4563,31282,'Justin','Magister','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4564,31283,'Alminas','Magister','a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4565,31284,'Elena','Spellbook Seller','a_traderD_Fhuman',8.00,22.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4566,31285,'Samael','Grand Master','a_patriarch_MDarkElf',6.00,23.80,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4567,31286,'Drakon','Master','a_guild_master_MDarkElf',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,143,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4568,31287,'Kamilen','Magister','a_casino_FDarkElf',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,204,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4569,31288,'Aklan','High Prefect','e_patriarch_MOrc',8.00,26.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4570,31289,'Lakan','Prefect','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,161,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4571,31290,'Skahi','Seer','e_clergyman_MOrc',8.00,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4572,31291,'Terava','Amulet Seller','e_clergyman_FOrc',6.50,28.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4573,31292,'Andrei','Captain','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,133,632,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4574,31293,'Gunter','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4575,31294,'Sven','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4576,31295,'Henrik','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4577,31296,'Cadmon','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4578,31297,'Bayard','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4579,31298,'Ulrich','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4580,31299,'Eugen','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4581,31300,'Drumond','Trader','e_traderB_master_MDwarf',8.00,17.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4582,31301,'Nils','Trader','a_traderD_Mhuman',7.00,21.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4583,31302,'Vladimir','Trader','a_common_peopleC_Mhuman',8.00,23.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4584,31303,'Alisha','Trader','a_traderD_Fhuman',8.00,22.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4585,31304,'Astrid','Trader','a_traderC_Fhuman',7.00,21.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4586,31305,'Candice','Trader','e_traderA_FDwarf',8.00,19.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4587,31306,'Natasha','Trader','a_traderB_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4588,31307,'Weber','Trader','a_traderD_Mhuman',7.00,21.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4589,31308,'Achim','Symbol Maker','a_traderC_Mhuman',8.00,23.00,70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4590,31309,'Woods','Pet Manager','a_traderD_Mhuman',7.00,21.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4591,31310,'Rafael','','strider',23.00,31.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.25,'false',0,0),
(4592,31311,'Hugin','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4593,31312,'Durin','Warehouse Keeper','a_traderA_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4594,31313,'Lunin','Warehouse Keeper','e_traderB_MDwarf',8.00,17.50,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4595,31314,'Donal','Warehouse Chief','e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4596,31315,'Daisy','Warehouse Freightman','e_warehouse_keeper_FDwarf',6.00,18.00,70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4597,31316,'Vincenz','Blacksmith','a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4598,31317,'Lombert','Head Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4599,31318,'Greta','Blueprint Seller','e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4600,31319,'Hans','Mineral Trader','e_traderB_master_MDwarf',8.00,17.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4601,31320,'Ilyana','Gatekeeper','e_teleporter_Fhuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4602,31321,'Siegmund','Grand Master','a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,76,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4603,31322,'Erian','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,125,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4604,31323,'Beryl','Master','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4605,31324,'Andromeda','Grand Master','a_casino_FDarkElf',8.00,23.00,70,'female','L2WeddingManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,316,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4606,31325,'Themis','Master','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,227,627,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4607,31326,'Lambac','High Prefect','e_patriarch_MOrc',8.00,26.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4608,31327,'Tazki','Prefect','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,161,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4609,31328,'Innocentin','High Priest','a_temple_master_Mhuman',8.00,24.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,193,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4610,31329,'Eliyah','Priest','a_temple_teacher_Mhuman',7.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4611,31330,'Wagner','Priest','a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4612,31331,'Valdis','Grand Magister','a_mageguild_master_MHuman',8.00,24.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4613,31332,'Amelia','Magister','a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4614,31333,'Rumiel','Magister','a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4615,31334,'Tifaren','Grand Magister','a_teleporter_FDarkElf',8.00,25.00,70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4616,31335,'Kayan','Magister','a_clergyman_MDarkElf',8.00,22.30,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,317,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4617,31336,'Rahorakti','Grand Seer','e_clergyman_MOrc',8.00,29.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4618,31337,'Mekara','Seer','e_mageguild_teacher_FOrc',8.00,28.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4619,31338,'Anton','Spellbook Seller','a_traderD_Mhuman',7.00,21.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4620,31339,'Hakran','Amulet Seller','e_mageguild_teacher_MOrc',7.00,27.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4621,31340,'Mathias','Captain','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,133,632,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4622,31341,'Richtor','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4623,31342,'Dimitri','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4624,31343,'Bellard','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4625,31344,'Schmidt','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4626,31345,'Ian','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4627,31346,'Sirius','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4628,31347,'Burke','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4629,31348,'Agripel','High Priest','a_temple_master_Mhuman',8.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4630,31349,'Benedict','Priest','a_temple_master_Mhuman',8.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4631,31350,'Dominic','Priest','a_temple_master_Mhuman',8.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4632,31351,'Volker','Wharf Manager','a_traderC_Mhuman',8.00,23.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4633,31356,'Remy','Porter','a_traderB_MHuman',8.00,24.50,70,'male','L2Npc','Remy',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4634,31357,'Leandro','Secretary','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc','Leandro',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4635,31358,'Kasiel','Bard','a_trader_MElf',8.00,25.00,70,'male','L2Npc','Kasiel',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,4202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4636,31359,'Jaradine','Mother Tree Guardian','a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','Jaradine',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,189,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4637,31360,'Alhena','Tetrarch Agent','a_casino_FDarkElf',8.00,23.00,70,'female','L2Npc','Alhena',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,315,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4638,31361,'Kreed','Tetrarch Executioner','a_trader_MDarkElf',8.00,22.50,70,'male','L2Npc','Kreed',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4639,31362,'Tate','Carrier','a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc','Tate',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4640,31363,'Rogin','Deliveryman','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Npc','Rogin',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4641,31364,'Rokar','Guardian of Flame','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','Rokar',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,203,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4642,31365,'Yakand','Guardian of Flame','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','Yakand',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,203,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4643,31366,'Feed Seller','','a_traderD_Mhuman',7.00,21.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4644,31367,'Voice of Glory','','kel_mahum_witch_doctor',13.00,25.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,193,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.28,'false',1,0),
(4645,31368,'Mikellan','Monk of Silence','a_temple_teacher_Mhuman',7.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(4646,31369,'Mennon','Monk of Silence','a_temple_teacher_Mhuman',7.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4647,31370,'Kadun Zu Ketra','Hierarch','ketra_orc_chieftain',11.00,38.50,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6719,0,0,24,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.51,'false',1,0),
(4648,31371,'Wahkan','Ketra''s Messenger','ketra_orc',12.00,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,175,0,0,45,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.46,'false',1,0),
(4649,31372,'Asefa','Soul Guide','ketra_orc_shaman',10.00,23.00,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,205,0,0,10,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4650,31373,'Atan','Grocer','ketra_orc_warrior',12.00,24.00,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,36,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',1,0),
(4651,31374,'Jaff','Warehouse Keeper','ketra_orc_warrior',12.00,24.00,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,36,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',1,0),
(4652,31375,'Jumara','Trader','ketra_orc_warrior',12.00,24.00,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,36,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',1,0),
(4653,31376,'Kurfa','Gatekeeper','ketra_orc_shaman',10.00,23.00,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,205,0,0,10,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4654,31377,'Ashas Varka Durai','Hierarch','barka_silenos_chieftain',18.00,42.50,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,139,0,0,25,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(4655,31378,'Naran Ashanuk','Varka''s Messenger','barka_silenos_warrior',16.00,41.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,173,0,0,34,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(4656,31379,'Udan Mardui','Soul Guide','barka_silenos_shaman',14.00,39.50,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6716,0,0,36,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.49,'false',1,0),
(4657,31380,'Diyabu','Grocer','barka_silenos_hunter',16.00,38.00,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,44,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(4658,31381,'Hagos','Warehouse Keeper','barka_silenos_warrior',16.00,41.00,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,34,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(4659,31382,'Shikon','Trader','barka_silenos_hunter',16.00,38.00,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,44,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(4660,31383,'Teranu Mardui','Gatekeeper','barka_silenos_shaman',14.00,39.50,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6716,0,0,36,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.49,'false',1,0),
(4661,31384,'Gatekeeper of Fire Dragon','','skeleton_knight',10.00,25.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,84,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.17,'true',1,0),
(4662,31385,'Heart of Volcano','','heart_of_warding',17.00,75.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4663,31386,'Violet','Trader','a_traderD_Fhuman',8.00,22.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4664,31387,'Kurstin','','a_traderB_FHuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4665,31388,'Mina','','a_traderB_FHuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4666,31389,'Dorian','','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,297,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4667,31390,'Dummy - Boy A','Ch4 Test','a_traderA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4668,31391,'Dummy  - Boy B','Ch4 Test','a_traderA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4669,31392,'Dummy  - Boy C','Ch4 Test','a_traderA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4670,31393,'Dummy - Boy D','Ch4 Test','a_traderA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4671,31394,'Dummy - Boy E','Ch4 Test','a_traderA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4672,31395,'Dummy - Lady F','Ch4 Test','a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4673,31396,'Dummy - Lady G','Ch4 Test','a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4674,31397,'Dummy - Lady H','Ch4 Test','a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4675,31398,'Dummy - Lady I','Ch4 Test','a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4676,31399,'Dummy - Lady J','Ch4 Test','a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4677,31400,'Dummy - Sword Guard','Ch4 Test','a_guard_MHuman',8.00,24.00,80,'male','L2Npc','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4678,31401,'Dummy - Bow Guard','Ch4 Test','a_guard_MHuman',8.00,24.00,80,'female','L2Npc','npc',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,14,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4679,31404,'Monster Race Guide','Town of Gludio','e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4680,31405,'Monster Race Guide','Town of Dion','e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4681,31406,'Monster Race Guide','Town of Giran','e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4682,31407,'Monster Race Guide','Heine','e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4683,31408,'Monster Race Guide','Town of Oren','e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4684,31409,'Monster Race Guide','Hunters Village','e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4685,31410,'Monster Race Guide','Town of Aden','e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4686,31411,'Monster Race Guide','Town of Goddard','e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4687,31412,'Monster Race Guide','Rune Township','e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4688,31413,'Antonio','Spellbook Seller','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4689,31414,'Lynn','Spellbook Seller','a_common_people_FElf',8.00,25.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4690,31415,'Triya','Spellbook Seller','a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4691,31416,'Aren','Spellbook Seller','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4692,31417,'Berynel','Spellbook Seller','a_common_people_MElf',6.00,21.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4693,31418,'Rouke','Spellbook Seller','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4694,31419,'Lorel','Spellbook Seller','a_common_people_MElf',6.00,21.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4695,31420,'Tomanel','Spellbook Seller','a_casino_MHuman',8.00,23.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4696,31421,'Ratriya','Spellbook Seller','a_common_people_FElf',8.00,25.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4697,31422,'Migel','Spellbook Seller','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4698,31423,'Romas','Spellbook Seller','a_traderB_MHuman',8.00,24.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4699,31424,'Shantra','Amulet Seller','e_clergyman_FOrc',6.50,28.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4700,31425,'Koram','Amulet Seller','e_mageguild_teacher_MOrc',7.00,27.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4701,31426,'Jaka','Amulet Seller','e_mageguild_teacher_MOrc',7.00,27.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4702,31427,'Urgal','Amulet Seller','e_mageguild_teacher_MOrc',7.00,27.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4703,31428,'Shafa','Amulet Seller','e_clergyman_FOrc',6.50,28.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4704,31429,'Shitara','Amulet Seller','e_clergyman_FOrc',6.50,28.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4705,31430,'Donai','Amulet Seller','e_mageguild_teacher_MOrc',7.00,27.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4706,31431,'Karai','Amulet Seller','e_mageguild_teacher_MOrc',7.00,27.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4707,31432,'Reeya','Blueprint Seller','e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4708,31433,'Ronaldo','Blueprint Seller','e_mine_master_MDwarf',8.00,19.70,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4709,31434,'Shaling','Blueprint Seller','e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4710,31435,'Daeger','Blueprint Seller','e_traderA_master_MDwarf',8.00,18.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4711,31436,'Dani','Blueprint Seller','e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4712,31437,'Luka','Blueprint Seller','e_mine_master_MDwarf',8.00,19.70,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4713,31438,'Lara','Blueprint Seller','e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4714,31439,'Rogen','Mineral Trader','e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4715,31440,'Lanna','Mineral Trader','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4716,31441,'Gordo','Mineral Trader','e_traderB_master_MDwarf',8.00,17.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4717,31442,'Kiki','Mineral Trader','e_traderB_FDwarf',6.00,18.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4718,31443,'Raban','Mineral Trader','e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4719,31444,'Cona','Mineral Trader','e_warehouse_keeper_FDwarf',6.00,18.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4720,31445,'Shutner','Mineral Trader','e_traderB_MDwarf',8.00,17.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4721,31452,'Ghost of Wigoth','','a_temple_master_Mhuman',8.00,24.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4722,31453,'Nameless Spirit','','a_king_MHuman',8.00,21.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4723,31454,'Ghost of Wigoth','','a_temple_master_Mhuman',8.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4724,31455,'Key Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4725,31456,'Key Box','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4726,31457,'Key Box','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4727,31458,'Key Box','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4728,31459,'Key Box','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4729,31460,'Key Box','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4730,31461,'Key Box','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4731,31462,'Key Box','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4732,31463,'Key Box','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4733,31464,'Key Box','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4734,31465,'Key Box','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4735,31466,'Key Box','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4736,31467,'Key Box','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4737,31468,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4738,31469,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4739,31470,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4740,31471,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4741,31472,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4742,31473,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4743,31474,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4744,31475,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4745,31476,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4746,31477,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4747,31478,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4748,31479,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4749,31480,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4750,31481,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4751,31482,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4752,31483,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4753,31484,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4754,31485,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4755,31486,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4756,31487,'Mysterious Box','','mimic',8.50,8.50,70,'male','L2Npc','RoyalRushNpc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4757,31488,'Rift Post Recruit','','a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4758,31489,'Rift Post Private','','a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,304,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4759,31490,'Rift Post Officer','','a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,79,111,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4760,31491,'Rift Post Captain','','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,76,660,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4761,31492,'Rift Post Commander','','a_lord_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,80,655,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4762,31493,'Rift Post Hero','','a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,135,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4763,31494,'Dimensional Gate Keeper','','rift_keeper',38.00,120.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4764,31495,'Dimensional Gate Keeper','','rift_keeper',38.00,120.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4765,31496,'Dimensional Gate Keeper','','rift_keeper',38.00,120.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4766,31497,'Dimensional Gate Keeper','','rift_keeper',38.00,120.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4767,31498,'Dimensional Gate Keeper','','rift_keeper',38.00,120.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4768,31499,'Dimensional Gate Keeper','','rift_keeper',38.00,120.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4769,31500,'Dimensional Gate Keeper','','rift_keeper',38.00,120.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4770,31501,'Dimensional Gate Keeper','','rift_keeper',38.00,120.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4771,31502,'Dimensional Gate Keeper','','rift_keeper',38.00,120.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4772,31503,'Dimensional Gate Keeper','','rift_keeper',38.00,120.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4773,31504,'Dimensional Gate Keeper','','rift_keeper',38.00,120.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4774,31505,'Dimensional Gate Keeper','','rift_keeper',38.00,120.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4775,31506,'Dimensional Gate Keeper','','rift_keeper',38.00,120.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4776,31507,'Dimensional Gate Keeper','','rift_keeper',38.00,120.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4777,31508,'Altar of Saints','','holy_altar',14.00,45.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4778,31509,'Altar of Saints','','holy_altar',14.00,45.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4779,31510,'Altar of Saints','','holy_altar',14.00,45.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4780,31511,'Altar of Saints','','holy_altar',14.00,45.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4781,31512,'Evil Altar','','evil_altar',11.00,45.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4782,31513,'Evil Altar','','evil_altar',11.00,45.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4783,31514,'Evil Altar','','evil_altar',11.00,45.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4784,31515,'Evil Altar','','evil_altar',11.00,45.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4785,31516,'Evil Altar','','evil_altar',11.00,45.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4786,31517,'Hierarch','','a_hardin_MHuman',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4787,31518,'Mysterious Necromancer','','a_hardins_pupil_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4788,31519,'Enfeux','','saints_coffin',20.00,60.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4789,31520,'Leikar','Maid','a_maidA_FHuman',8.00,20.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4790,31521,'Jeremy','Chef','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4791,31522,'Mysterious Wizard','','a_hardin_MHuman',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4792,31523,'Tombstone','','old_tomb_stone',20.00,30.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4793,31524,'Ghost of von Hellmann','','a_temple_master_Mhuman',8.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4794,31525,'Ghost of von Hellmann''s Page','','dark_horror',20.00,35.00,70,'male','L2Npc','GhostOfVonHellmannsPage',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4795,31526,'Broken Bookshelf','','old_bookshelf',15.00,33.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4796,31527,'Well','','umul',33.00,37.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4797,31528,'Ghost of Priest','','elf_ghost',7.00,21.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'false',0,0),
(4798,31529,'Ghost of Adventurer','','human_ghost',8.00,22.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(4799,31530,'Box','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(4800,31531,'Tombstone','','old_tomb_stone',20.00,30.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4801,31532,'Maid of Lidia','','vampire_witch',6.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,64,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(4802,31533,'Broken Bookshelf','','old_bookshelf',15.00,33.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4803,31534,'Broken Bookshelf','','old_bookshelf',15.00,33.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4804,31535,'Broken Bookshelf','','old_bookshelf',15.00,33.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4805,31536,'Coffin','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(4806,31537,'Tunatun','Beast Herder','a_common_peopleC_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4807,31538,'Ghost of Adventurer','','a_traderA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4808,31539,'Vulcan','Blacksmith of Flame','a_smith_MDwarf',7.00,16.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4809,31540,'Klein','Watcher of Valakas','skeleton_royal_guard',11.00,28.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(4810,31541,'Daimon''s Altar','','gianteye_altar',60.00,50.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4811,31542,'Yeti''s Table','','yetis_dinner_table',25.00,15.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Magister',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4812,31543,'Pulin','','e_bath_MDwarf',6.00,16.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4813,31544,'Naff','','e_bath_MDwarf',6.00,16.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4814,31545,'Crocus','','e_bath_MDwarf',6.00,16.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4815,31546,'Kuber','','e_bath_MDwarf',6.00,16.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4816,31547,'Beolin','','e_bath_MDwarf',6.00,16.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4817,31548,'Mysterious Ancient Tablet','','old_tablet',32.00,46.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4818,31549,'Mysterious Ancient Tablet','','old_tablet',32.00,46.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4819,31550,'Mysterious Ancient Tablet','','old_tablet',32.00,46.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4820,31551,'Mysterious Ancient Tablet','','old_tablet',32.00,46.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(4821,31552,'Mysterious Ancient Tablet','','old_tablet',32.00,46.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4822,31553,'Pierce','Mercenary Captain','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,135,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4823,31554,'Kahman','Mercenary','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,161,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4824,31555,'Abercrombie','Mercenary Supplier','e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4825,31556,'Selina','Mercenary Medic','a_traderC_Fhuman',7.00,21.50,70,'female','L2NpcFriend','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,189,659,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4826,31557,'Mercenary Sentry','','a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,298,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4827,31558,'Ketra''s Holy Altar','','orcish_totem',25.00,47.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4828,31559,'Box of Asefa','','coffer_d',12.00,22.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4829,31560,'Varka''s Holy Altar','','silenos_totem',28.00,55.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4830,31561,'Udan Mardui''s Box','','coffer_b',12.00,9.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4831,31562,'Klufe','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4832,31563,'Perelin','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4833,31564,'Mishini','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4834,31565,'Ogord','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4835,31566,'Ropfi','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4836,31567,'Bleaker','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4837,31568,'Pamfus','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4838,31569,'Cyano','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4839,31570,'Lanosco','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4840,31571,'Hufs','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4841,31572,'O''Fulle','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4842,31573,'Monakan','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4843,31574,'Willie','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4844,31575,'Litulon','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4845,31576,'Berix','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4846,31577,'Linnaeus','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4847,31578,'Hilgendorf','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4848,31579,'Klaus','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4849,31580,'Galadrid','Master','a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,132,110,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4850,31581,'Anastia','Magister','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4851,31582,'Mordred','Dark Knight','vampire_soldier',8.00,23.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,137,634,0,60,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.45,'false',1,0),
(4852,31583,'Feynn','Blacksmith','a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,168,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4853,31584,'Valentine','Brewer','e_traderB_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4854,31585,'Sparky the Cat','Keats Servitor','cat_the_cat',9.00,16.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',1,0),
(4855,31586,'Sparky the Cat','Keats Servitor','cat_the_cat',9.00,16.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(4856,31587,'Gedrik','Gemcutter','e_traderB_master_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4857,31588,'Agnes','Saint of Light','a_teleporter_FElf',8.50,23.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4858,31589,'Duda-Mara Totem Spirit','','giant_spider',26.00,26.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,72,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.26,'false',1,0),
(4859,31590,'Truth Scholar Devianne','','a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,192,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4860,31591,'Sunset Guide Luna','','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,189,633,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',0,0),
(4861,31592,'Telson','Chief Golem Crafter','e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4862,31593,'Dorothy','Golem of Telson','mechanic_golem',5.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.72,'false',0,0),
(4863,31594,'Mond','Chief Inspector','e_celebrant_MDwarf',8.00,19.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4864,31595,'Leona Blackbird','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,79,110,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',0,0),
(4865,31596,'Tobald','Master','e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,187,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4866,31597,'Tobald','Master','e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,187,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4867,31598,'Medina Blackheart','','a_trader_Fdarkelf',8.00,24.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,206,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4868,31599,'Disgraced Knight Waldstein','','a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,81,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4869,31600,'Pamela Aprodia','','a_casino_FDarkElf',8.00,23.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4870,31601,'Pamela Aprodia','','a_guard_FDarkelf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4871,31602,'Sharona Artemia','Bodyguard','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,232,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4872,31603,'Black Cat','Hunter Guild Member','a_common_people_FDarkElf',8.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,227,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4873,31604,'Grimst','Information Broker','a_casino_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4874,31605,'Kinsley','Head Summoner','a_mageguild_master_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,212,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4875,31606,'Alice de Catrina','Kinsley''s Servitor','queen_of_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(4876,31607,'Sake Dun Zu Hestui','','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,298,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4877,31608,'Belinda','Summoner','a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4878,31609,'Aurora the Unicorn','Belinda Servitor','unicorn_boxer',11.00,18.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,27,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(4879,31610,'Shiken Gloomdrake','','a_common_people_MDarkElf',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,80,633,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',0,0),
(4880,31611,'Scryde Heartseeker','','a_common_people_MDarkElf',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,81,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4881,31612,'Eternity Wanderer Staris','','a_trader_MElf',8.00,25.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,150,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4882,31613,'Noctisse','Summoner','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,204,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4883,31614,'Radyss','Head Summoner','a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4884,31615,'Hermit','','a_common_peopleC_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4885,31616,'Hermit','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,8,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4886,31617,'Aria Firstmatter','','a_guard_FDarkelf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,236,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4887,31618,'Moon Voice Irene','','a_common_people_FElf',8.00,25.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,109,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4888,31619,'Erica Ken Weber','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,236,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4889,31620,'Verdure Elder Elikia','','a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,189,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4890,31621,'Abyss Saint Elcardia','','a_guard_FDarkelf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,206,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4891,31622,'Keats','Cursed Summoner','poison_toad',20.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.35,'false',1,0),
(4892,31623,'Bavarin','Information Broker','e_bath_MDwarf',6.00,16.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4893,31624,'Donath','Master Chef','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4894,31625,'Yeti','Donath Kitchen Help','yeti_cute',5.00,10.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5129,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4895,31626,'Duncan','Chef','a_smith_MDwarf',7.00,16.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5129,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4896,31627,'Mist','Information Broker','e_bath_MDwarf',6.00,16.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4897,31628,'Lilly','Mist''s Granddaughter','e_traderA_FDwarf',8.00,19.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4898,31629,'Kaleidos the Unicorn','','blue_eye',11.00,16.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(4899,31630,'Kaleidos the Unicorn','','blue_eye',11.00,16.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(4900,31631,'Eric Ramsheart','','a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,79,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4901,31632,'Mysterious Servitor','','shadeless',7.00,28.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(4902,31633,'Winter Hunter Kadyth','','a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,285,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4903,31634,'Winter Hunter Kadyth','','a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,285,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4904,31635,'Winter Hunter Kadyth','','a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,285,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4905,31636,'Flame Successor Akkan','','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,305,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4906,31637,'Khavatari Kashu','','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,267,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4907,31638,'Starling Knight Kastien','','a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,142,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4908,31639,'Kain Van Halter','','a_traderA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,2626,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4909,31640,'Pilgrim of Darkness','','a_hardins_pupil_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,318,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4910,31641,'Pilgrim of Darkness','','a_hardins_pupil_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,318,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4911,31642,'Tarkai Zu Duda-Mara','','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,210,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4912,31643,'Silver Feyshar','','a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,148,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4913,31644,'Dawn Witness Franz','','a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,205,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4914,31645,'Hindemith Truevoice','','a_traderD_Mhuman',7.00,21.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,195,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4915,31646,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4916,31647,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4917,31648,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4918,31649,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4919,31650,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4920,31651,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4921,31652,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4922,31653,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4923,31654,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4924,31655,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4925,31656,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4926,31657,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4927,31658,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4928,31659,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4929,31660,'Tablet of Vision','','codex_stone',7.00,24.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4930,31661,'Forgotten Monument','','old_tablet',32.00,46.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4931,31662,'Forgotten Monument','','old_tablet',32.00,46.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4932,31663,'Forgotten Monument','','old_tablet',32.00,46.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4933,31664,'Forgotten Monument','','old_tablet',32.00,46.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4934,31665,'Corpse of Dwarf','','e_guard_MDwarf_death',13.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4935,31666,'Lumen','Spellbook Seller','a_traderD_Mhuman',7.00,21.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4936,31667,'Raik','Amulet Seller','e_trader_MOrc',8.00,23.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4937,31668,'Tangen','Blueprint Seller','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4938,31669,'Onyx','Mineral Trader','e_mine_teacher_MDwarf',8.00,18.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4939,31670,'Burns','Spellbook Seller','a_traderD_Mhuman',7.00,21.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4940,31671,'Patrol','','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',1100,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,120,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(4941,31672,'Patrol','','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4942,31673,'Patrol','','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',1100,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,120,'',0,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(4943,31674,'Patrol','','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4944,31675,'Viktor Van Deik','Border Outpost Captain','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Guard','Guard',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,128,632,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4945,31676,'Gregory Athebaldt','Border Outpost Captain','a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2Guard','Guard',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,70,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4946,31677,'Border Patrol','','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4947,31678,'Border Patrol','','a_guard_MHuman',8.00,24.00,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4948,31679,'Eustace Van Essen','Frontier Guard Captain','a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2Guard','Guard',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,70,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4949,31680,'Fleming Van Issen','Frontier Guard Captain','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Guard','Guard',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,128,632,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4950,31681,'Frontier Guard','','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4951,31682,'Frontier Guard','','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4952,31683,'Eye of Argos','','argos_eye',120.00,307.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4953,31684,'Eye of Udan Mardui','','mana_vampire',11.00,20.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,90,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(4954,31685,'Asefa''s Eye','','magical_weaver',11.00,20.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,90,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',0,0),
(4955,31686,'Gatekeeper of Fire Dragon','','skeleton_knight',10.00,25.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,84,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(4956,31687,'Gatekeeper of Fire Dragon','','skeleton_knight',10.00,25.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,84,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.17,'false',1,0),
(4957,31688,'Grand Olympiad Manager','','a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2OlympiadManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,70,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4958,31689,'Olympiad Finisher','','a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,70,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4959,31690,'Monument of Heroes','','heroes_obelisk_human',21.00,69.00,70,'etc','L2OlympiadManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4960,31691,'Training Dummy','','training_doll',9.00,22.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4961,31692,'Priest of Dawn','','priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4962,31693,'Priest of Dusk','','priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4963,31694,'Priest of Dawn','','priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4964,31695,'Priest of Dusk','','priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4965,31696,'Platis','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4966,31697,'Eindarkner','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4967,31698,'Arisha','Gatekeeper','e_teleporter_Fhuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4968,31699,'Stanislava','Gatekeeper','e_teleporter_Fhuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4969,31700,'Saint''s Follower','','e_warehouse_keeper_FDwarf',6.00,18.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4970,31701,'Saint''s Follower','','a_common_people_MElf',6.00,21.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4971,31702,'Saint''s Follower','','e_common_people_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(4972,31703,'Saint''s Follower','','a_common_peopleC_Fhuman',7.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4973,31704,'Saint''s Follower','','a_common_peopleA_FHuman',8.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(4974,31705,'Daimon the White-Eyed','','hundred_eye',21.00,55.00,70,'male','L2Npc','DaimonTheWhiteEyed',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.54,'false',1,0),
(4975,31706,'Miki the Cat','','cat_the_cat',9.00,16.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',1,0),
(4976,31707,'Ketra Van Grunt','','ketra_orc_chieftain',11.00,38.50,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6719,0,0,24,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.51,'false',1,0),
(4977,31708,'Ketra Van Shaman','','ketra_orc_shaman',10.00,23.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,92,0,0,10,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(4978,31709,'Ketra Van Captain','','ketra_orc_warlord',12.00,30.00,70,'male','L2Monster','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,80,0,0,27,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(4979,31710,'Ketra Van Commander','','barka_silenos_chieftain',18.00,42.50,70,'male','L2Npc','Fighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,2500,0,0,25,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(4980,31711,'Ketra Van Shaman','','barka_silenos_shaman',14.00,39.50,70,'male','L2Monster','Priest',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6716,0,0,36,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.49,'false',1,0),
(4981,31712,'Varka Raider','','barka_silenos_warrior',16.00,41.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,142,0,0,34,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',1,0),
(4982,31713,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4983,31714,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4984,31715,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4985,31716,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4986,31717,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4987,31718,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4988,31719,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4989,31720,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(4990,31721,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4991,31722,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(4992,31723,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4993,31724,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4994,31725,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4995,31726,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4996,31727,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4997,31728,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(4998,31729,'Adventurer Guildsman','','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(4999,31730,'Adventurer Guildsman','','a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5000,31731,'Adventurer Guildsman','','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5001,31732,'Adventurer Guildsman','','e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5002,31733,'Adventurer Guildsman','','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5003,31734,'Adventurer Guildsman','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(5004,31735,'Adventurer Guildsman','','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5005,31736,'Adventurer Guildsman','','a_trader_MDarkElf',8.00,22.50,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5006,31737,'Adventurer Guildsman','','e_trader_FOrc',8.00,24.00,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5007,31738,'Adventurer Guildsman','','e_common_people_MDwarf',8.00,17.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5008,31739,'Talien','','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,4202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5009,31740,'Caradine','','a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,285,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5010,31741,'Ossian','','a_common_peopleC_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(5011,31742,'Virgil','','e_common_people_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5012,31743,'Kassandra','','e_warehouse_keeper_FDwarf',6.00,18.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5013,31744,'Ogmar','','e_common_people_MOrc',8.00,26.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5014,31745,'Lady of the Lake','','a_teleporter_FElf',8.50,23.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5015,31746,'Fallen Unicorn','','death_unicorn',14.00,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,46,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.74,'false',1,0),
(5016,31747,'Pure White Unicorn','','unicorn',14.00,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,46,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.74,'false',0,0),
(5017,31748,'Cornerstone of Restraining','','grave_keeper',8.00,21.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5018,31750,'Mysterious Woman','','a_teleporter_FElf',8.50,23.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5019,31751,'Mysterious Dark Knight','','death_lord',21.00,40.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,78,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.50,'false',1,0),
(5020,31752,'Corpse of Angel','','angel_death',25.00,36.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5021,31755,'Halaster','Grand Magister','a_mageguild_master_MHuman',8.00,24.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5022,31756,'Mr. Cat','Test Server Helper','cat_the_cat',9.00,16.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',1,0),
(5023,31757,'Miss Queen','Test Server Helper','queen_of_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(5024,31758,'Rafi','','hatchling',9.00,10.00,70,'male','L2Trainer','RndWalkAndAnim',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.27,'false',1,0),
(5025,31759,'Teleportation Cubic','','teleport_npc',40.00,80.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5026,31760,'Miss Queen','Adventurers'' Guide','queen_of_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(5027,31761,'Miss Queen','Adventurers'' Guide','queen_of_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(5028,31762,'Miss Queen','Adventurers'' Guide','queen_of_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(5029,31763,'Miss Queen','Adventurers'' Guide','queen_of_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(5030,31764,'Miss Queen','Adventurers'' Guide','queen_of_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(5031,31765,'Miss Queen','Adventurers'' Guide','queen_of_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(5032,31766,'Miss Queen','Adventurers'' Guide','queen_of_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(5033,31767,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,149300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(5034,31768,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,149300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(5035,31769,'Monument of Heroes','','heroes_obelisk_elf',24.00,77.50,70,'etc','L2OlympiadManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5036,31770,'Monument of Heroes','','heroes_obelisk_darkelf',25.00,77.00,70,'etc','L2OlympiadManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5037,31771,'Monument of Heroes','','heroes_obelisk_orc',21.00,72.50,70,'etc','L2OlympiadManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5038,31772,'Monument of Heroes','','heroes_obelisk_dwarf',23.00,80.00,70,'etc','L2OlympiadManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5039,31773,'Sonin','Warehouse Keeper','e_warehouse_keeper_FDwarf',6.00,18.00,70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5040,31774,'Beryl the Cat','Event Manager','queen_of_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(5041,31775,'Adventure Guildsman','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5042,31776,'Adventure Guildsman','','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5043,31777,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5044,31778,'Adventure Guildsman','','a_trader_MDarkElf',8.00,22.50,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5045,31779,'Adventure Guildsman','','a_trader_MDarkElf',8.00,22.50,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5046,31780,'Adventure Guildsman','','a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5047,31781,'Adventure Guildsman','','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5048,31782,'Adventure Guildsman','','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5049,31783,'Adventure Guildsman','','e_common_people_MDwarf',8.00,17.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5050,31784,'Adventure Guildsman','','e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5051,31785,'Adventure Guildsman','','e_trader_FOrc',8.00,24.00,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5052,31786,'Adventure Guildsman','','e_trader_FOrc',8.00,24.00,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5053,31787,'Adventure Guildsman','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5054,31788,'Adventure Guildsman','','e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5055,31789,'Adventure Guildsman','','e_common_people_MDwarf',8.00,17.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5056,31790,'Adventure Guildsman','','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5057,31791,'Adventure Guildsman','','a_trader_MDarkElf',8.00,22.50,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5058,31792,'Adventure Guildsman','','a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5059,31793,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5060,31794,'Adventure Guildsman','','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5061,31795,'Adventure Guildsman','','e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5062,31796,'Adventure Guildsman','','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5063,31797,'Adventure Guildsman','','e_common_people_MDwarf',8.00,17.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5064,31798,'Adventure Guildsman','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5065,31799,'Adventure Guildsman','','e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5066,31800,'Adventure Guildsman','','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5067,31801,'Adventure Guildsman','','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5068,31802,'Adventure Guildsman','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5069,31803,'Adventure Guildsman','','e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5070,31804,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5071,31805,'Adventure Guildsman','','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5072,31806,'Adventure Guildsman','','a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5073,31807,'Adventure Guildsman','','e_common_people_MDwarf',8.00,17.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5074,31808,'Adventure Guildsman','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5075,31809,'Adventure Guildsman','','e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5076,31810,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5077,31811,'Adventure Guildsman','','a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5078,31812,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5079,31813,'Adventure Guildsman','','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5080,31814,'Adventure Guildsman','','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5081,31815,'Adventure Guildsman','','e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5082,31816,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5083,31817,'Adventure Guildsman','','a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5084,31818,'Adventure Guildsman','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5085,31819,'Adventure Guildsman','','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5086,31820,'Adventure Guildsman','','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5087,31821,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5088,31822,'Adventure Guildsman','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5089,31823,'Adventure Guildsman','','a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5090,31824,'Adventure Guildsman','','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5091,31825,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5092,31826,'Adventure Guildsman','','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5093,31827,'Adventure Guildsman','','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5094,31828,'Adventure Guildsman','','a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5095,31829,'Adventure Guildsman','','a_trader_MDarkElf',8.00,22.50,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5096,31830,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5097,31831,'Adventure Guildsman','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5098,31832,'Adventure Guildsman','','e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5099,31833,'Adventure Guildsman','','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5100,31834,'Adventure Guildsman','','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5101,31835,'Adventure Guildsman','','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5102,31836,'Adventure Guildsman','','a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5103,31837,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5104,31838,'Adventure Guildsman','','e_common_people_MDwarf',8.00,17.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5105,31839,'Adventure Guildsman','','a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5106,31840,'Adventure Guildsman','','e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5107,31841,'Adventure Guildsman','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5108,31842,'Teleportation Cubic','','teleport_cube',30.00,65.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,7,3,0,0,0.60,'false',0,0),
(5109,31843,'Teleportation Cubic','','teleport_cube',30.00,65.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5110,31844,'Aracna','','aracne',15.00,26.00,50,'female','L2Monster','Fighter',40,3381,5.500,1660,2.100,60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,0,0,0,64,120,'all_elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',0,0),
(5111,31845,'Bloody Pixy','','pixy',5.00,25.00,80,'female','L2Guard','GuardRndWalkAndAnim',40,4550,5.500,1660,2.100,60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,0,0,0,80,120,'all_elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.72,'false',1,0),
(5112,31846,'Satyros','','pan',14.00,35.00,50,'male','L2Monster','Fighter',40,3381,5.500,1660,2.100,60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,291,0,0,45,110,'all_elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.58,'true',0,0),
(5113,31847,'Pan','','pan',14.00,35.00,50,'male','L2Monster','Fighter',40,3381,5.500,1660,2.100,60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,291,0,0,45,110,'all_elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.58,'true',0,0),
(5114,31848,'Pixy','','pixy',5.00,25.00,50,'female','L2Guard','GuardRndWalkAndAnim',40,4550,5.500,1660,2.100,60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,0,0,0,80,120,'all_elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.72,'false',1,0),
(5115,31849,'Red Arachne','','aracne',15.00,26.00,50,'female','L2Monster','Fighter',40,3381,5.500,1660,2.100,60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,0,0,0,64,120,'all_elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.50,'true',0,0),
(5116,31850,'Blight Treant','','ti_mi_riran',23.00,90.00,80,'male','L2Guard','GuardRndWalkAndAnim',40,4550,5.500,1660,2.100,60,57,73,76,70,80,0,0,1032,278,2360,452,409,0,2901,0,0,0,12,12,'all_elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',1,0),
(5117,31851,'Treant','','ti_mi_tran',23.00,90.00,80,'male','L2Guard','GuardRndWalkAndAnim',40,4550,5.500,1660,2.100,60,57,73,76,70,80,0,0,1032,278,2360,452,409,0,2901,0,0,0,12,12,'all_elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',1,0),
(5118,31852,'Pixy Murika','','pixy',5.00,25.00,50,'female','L2Guard','GuardRndWalkAndAnim',40,2245,5.500,830,2.100,40,43,30,21,20,10,0,0,509,278,264,226,278,0,253,0,0,0,80,120,'all_elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.72,'false',1,0),
(5119,31853,'Treant Bremec','','ti_mi_tran',23.00,90.00,80,'male','L2Guard','GuardRndWalkAndAnim',40,4550,5.500,1660,2.100,60,57,73,76,70,80,0,0,1032,278,2360,452,409,0,2901,0,0,0,12,12,'all_elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,0.61,'false',1,0),
(5120,31854,'Event Manager','','a_traderB_MHuman',7.00,21.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5121,31855,'Event Manager','','a_trader_FElf',8.00,24.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5122,31856,'Event Manager','','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5123,31857,'Event Manager','','e_traderA_FDwarf',8.00,19.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5124,31858,'Event Manager','','e_trader_FOrc',8.00,24.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5125,31859,'Teleportation Cubic','','teleport_cube',30.00,65.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5126,31860,'Orion the Cat','Event Manager','cat_the_cat',9.00,16.00,70,'male','L2ClassMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',31860,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5127,31861,'Gatekeeper','','a_teleporter_FHuman',8.00,25.00,56,'female','L2CastleTeleporter','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5128,31862,'Angelic Vortex','','alive_castle_aden_controltower_jewel',7.00,35.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5129,31863,'Santa Trainee','','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5130,31864,'Santa Trainee','','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5131,31865,'Guardian of Border','','teleport_npc_sm',7.00,15.00,35,'etc','L2Npc','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5132,31866,'Guardian of Border','','teleport_npc_sm',7.00,15.00,35,'etc','L2Npc','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5133,31867,'Guardian of Border','','teleport_npc_sm',7.00,15.00,35,'etc','L2Npc','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5134,31868,'Guardian of Border','','teleport_npc_sm',7.00,15.00,35,'etc','L2Npc','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5135,31869,'Guardian of Border','','teleport_npc_sm',7.00,15.00,35,'etc','L2Npc','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5136,31870,'Guardian of Border','','teleport_npc_sm',7.00,15.00,35,'etc','L2Npc','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5137,31871,'Guardian of Border','','teleport_npc_sm',7.00,15.00,35,'etc','L2Npc','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5138,31872,'Guardian of Border','','teleport_npc_sm',7.00,15.00,35,'etc','L2Npc','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5139,31873,'Guardian of Border','','teleport_npc_sm',7.00,15.00,35,'etc','L2Npc','npc',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5140,31874,'Guardian of Border','','teleport_npc_sm',7.00,15.00,45,'etc','L2Npc','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5141,31875,'Guardian of Border','','teleport_npc_sm',7.00,15.00,45,'etc','L2Npc','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5142,31876,'Guardian of Border','','teleport_npc_sm',7.00,15.00,45,'etc','L2Npc','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5143,31877,'Guardian of Border','','teleport_npc_sm',7.00,15.00,45,'etc','L2Npc','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5144,31878,'Guardian of Border','','teleport_npc_sm',7.00,15.00,45,'etc','L2Npc','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5145,31879,'Guardian of Border','','teleport_npc_sm',7.00,15.00,45,'etc','L2Npc','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5146,31880,'Guardian of Border','','teleport_npc_sm',7.00,15.00,45,'etc','L2Npc','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5147,31881,'Guardian of Border','','teleport_npc_sm',7.00,15.00,45,'etc','L2Npc','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5148,31882,'Guardian of Border','','teleport_npc_sm',7.00,15.00,45,'etc','L2Npc','npc',40,1870,5.500,677,2.100,40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5149,31883,'Guardian of Border','','teleport_npc_sm',7.00,15.00,55,'etc','L2Npc','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5150,31884,'Guardian of Border','','teleport_npc_sm',7.00,15.00,55,'etc','L2Npc','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5151,31885,'Guardian of Border','','teleport_npc_sm',7.00,15.00,55,'etc','L2Npc','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5152,31886,'Guardian of Border','','teleport_npc_sm',7.00,15.00,55,'etc','L2Npc','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5153,31887,'Guardian of Border','','teleport_npc_sm',7.00,15.00,55,'etc','L2Npc','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5154,31888,'Guardian of Border','','teleport_npc_sm',7.00,15.00,55,'etc','L2Npc','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5155,31889,'Guardian of Border','','teleport_npc_sm',7.00,15.00,55,'etc','L2Npc','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5156,31890,'Guardian of Border','','teleport_npc_sm',7.00,15.00,55,'etc','L2Npc','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5157,31891,'Guardian of Border','','teleport_npc_sm',7.00,15.00,55,'etc','L2Npc','npc',40,2643,6.500,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5158,31892,'Guardian of Border','','teleport_npc_sm',7.00,15.00,65,'etc','L2Npc','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5159,31893,'Guardian of Border','','teleport_npc_sm',7.00,15.00,65,'etc','L2Npc','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(5160,31894,'Guardian of Border','','teleport_npc_sm',7.00,15.00,65,'etc','L2Npc','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5161,31895,'Guardian of Border','','teleport_npc_sm',7.00,15.00,65,'etc','L2Npc','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5162,31896,'Guardian of Border','','teleport_npc_sm',7.00,15.00,65,'etc','L2Npc','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5163,31897,'Guardian of Border','','teleport_npc_sm',7.00,15.00,65,'etc','L2Npc','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5164,31898,'Guardian of Border','','teleport_npc_sm',7.00,15.00,65,'etc','L2Npc','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5165,31899,'Guardian of Border','','teleport_npc_sm',7.00,15.00,65,'etc','L2Npc','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5166,31900,'Guardian of Border','','teleport_npc_sm',7.00,15.00,65,'etc','L2Npc','npc',40,3465,7.500,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5167,31901,'Guardian of Border','','teleport_npc_sm',7.00,15.00,75,'etc','L2Npc','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5168,31902,'Guardian of Border','','teleport_npc_sm',7.00,15.00,75,'etc','L2Npc','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5169,31903,'Guardian of Border','','teleport_npc_sm',7.00,15.00,75,'etc','L2Npc','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5170,31904,'Guardian of Border','','teleport_npc_sm',7.00,15.00,75,'etc','L2Npc','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5171,31905,'Guardian of Border','','teleport_npc_sm',7.00,15.00,75,'etc','L2Npc','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5172,31906,'Guardian of Border','','teleport_npc_sm',7.00,15.00,75,'etc','L2Npc','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5173,31907,'Guardian of Border','','teleport_npc_sm',7.00,15.00,75,'etc','L2Npc','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5174,31908,'Guardian of Border','','teleport_npc_sm',7.00,15.00,75,'etc','L2Npc','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5175,31909,'Guardian of Border','','teleport_npc_sm',7.00,15.00,75,'etc','L2Npc','npc',40,4229,8.500,1673,3.000,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5176,31910,'Guardian of Border','','teleport_npc_sm',7.00,15.00,85,'etc','L2Npc','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5177,31911,'Guardian of Border','','teleport_npc_sm',7.00,15.00,85,'etc','L2Npc','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5178,31912,'Guardian of Border','','teleport_npc_sm',7.00,15.00,85,'etc','L2Npc','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5179,31913,'Guardian of Border','','teleport_npc_sm',7.00,15.00,85,'etc','L2Npc','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5180,31914,'Guardian of Border','','teleport_npc_sm',7.00,15.00,85,'etc','L2Npc','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5181,31915,'Guardian of Border','','teleport_npc_sm',7.00,15.00,85,'etc','L2Npc','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5182,31916,'Guardian of Border','','teleport_npc_sm',7.00,15.00,85,'etc','L2Npc','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5183,31917,'Guardian of Border','','teleport_npc_sm',7.00,15.00,85,'etc','L2Npc','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5184,31918,'Guardian of Border','','teleport_npc_sm',7.00,15.00,85,'etc','L2Npc','npc',40,4813,8.500,2049,3.000,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5185,31919,'Ghost Chamberlain of Elmoreden','','a_tombkeeperA',7.00,23.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5186,31920,'Ghost Chamberlain of Elmoreden','','a_tombkeeperA',7.00,23.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5187,31921,'Conquerors'' Sepulcher Manager','','grave_keeper',8.00,21.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5188,31922,'Emperors'' Sepulcher Manager','','grave_keeper',8.00,21.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5189,31923,'Great Sages'' Sepulcher Manager','','grave_keeper',8.00,21.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5190,31924,'Judges'' Sepulcher Manager','','grave_keeper',8.00,21.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5191,31925,'Baron''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5192,31926,'Viscount''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5193,31927,'Count''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5194,31928,'Marquis'' Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5195,31929,'Duke''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5196,31930,'Baron''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5197,31931,'Viscount''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5198,31932,'Count''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5199,31933,'Marquis'' Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5200,31934,'Duke''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5201,31935,'Baron''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5202,31936,'Viscount''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5203,31937,'Count''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5204,31938,'Marquis'' Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5205,31939,'Duke''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5206,31940,'Baron''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5207,31941,'Viscount''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5208,31942,'Count''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5209,31943,'Marquis'' Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5210,31944,'Duke''s Hall Gatekeeper','','rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5211,31945,'Auzendorff','Trader','e_traderB_MDwarf',8.00,17.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5212,31946,'Hombre','Trader','a_traderD_Mhuman',7.00,21.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5213,31947,'Owaki','Trader','e_trader_MOrc',8.00,23.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5214,31948,'Adrian','Trader','a_traderC_Mhuman',8.00,23.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5215,31949,'Rouge','Trader','a_traderC_Fhuman',7.00,21.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5216,31950,'Mailland','Trader','e_traderB_FDwarf',6.00,18.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5217,31951,'Jose','Trader','a_traderD_Fhuman',8.00,22.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5218,31952,'Pele','Trader','a_common_peopleC_Fhuman',7.00,21.50,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5219,31953,'Rankar','Symbol Maker','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2SymbolMaker','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5220,31954,'Saroyan','Pet Manager','a_traderD_Mhuman',7.00,21.50,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5221,31955,'Ruby','','baby_tiger',11.00,15.70,70,'male','L2Npc','RndWalkAndAnim',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5222,31956,'Rydel','Warehouse Keeper','e_warehouse_keeper_FDwarf',6.00,18.00,70,'female','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5223,31957,'Cherbal','Warehouse Keeper','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5224,31958,'Yasheni','Warehouse Chief','e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5225,31959,'Axel','Warehouse Freightman','e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2Warehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5226,31960,'Byron','Blacksmith','e_smith_Fdwarf',8.00,17.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5227,31961,'Newyear','Head Blacksmith','e_smith_master_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5228,31962,'Altair','Blueprint Seller','a_traderA_MDwarf',8.00,17.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5229,31963,'Hitchi','Mineral Trader','e_traderB_master_MDwarf',8.00,17.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5230,31964,'Bilia','Gatekeeper','a_teleporter_FHuman',8.00,25.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5231,31965,'Hector','Grand Master','a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,76,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5232,31966,'Karamon','Master','a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5233,31967,'Euline','Master','a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5234,31968,'Baryl','High Priest','a_temple_master_Mhuman',8.00,24.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5235,31969,'Evelyn','Priest','a_mageguild_master_FHuman',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5236,31970,'Sinis','Priest','a_mageguild_teacher_MElf',7.00,22.20,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5237,31971,'Otillo','Magister','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5238,31972,'Atraxia','Magister','a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5239,31973,'Raheel','Spellbook Seller','a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5240,31974,'Drizzit','Grand Master','a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5241,31975,'Aerina','Master','a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5242,31976,'Talia','Magister','a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5243,31977,'Shaka','High Prefect','e_patriarch_MOrc',8.00,26.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5244,31978,'Tazeer','Prefect','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,161,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5245,31979,'Moira','Seer','e_clergyman_FOrc',6.50,28.00,70,'female','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5246,31980,'Rumba','Amulet Seller','e_clergyman_FOrc',6.50,28.00,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5247,31981,'Vishotsky','Captain','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,133,632,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(5248,31982,'Glen','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(5249,31983,'Friggar','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(5250,31984,'Sherring','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(5251,31985,'Kosmos','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(5252,31986,'Erstack','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(5253,31987,'Gotter','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4551,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(5254,31988,'Singa','Guard','e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard','Guard',40,4550,8.500,1859,3.000,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(5255,31989,'Batidae','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5256,31990,'Siger','Blacksmith','a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,168,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5257,31991,'Adventure Guildsman','','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5258,31992,'Adventure Guildsman','','a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,50,120,'',0,'Tigra','',0,20,147,7,30,4,4,0,-6,0.60,'false',0,0),
(5259,31993,'Adventure Guildsman','','e_common_people_MDwarf',8.00,17.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5260,31994,'Adventure Guildsman','','e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5261,31995,'Adventure Guildsman','','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,50,120,'',0,'Tigra','',0,20,147,7,30,4,4,0,-6,0.60,'false',0,0),
(5262,31996,'Javier','Grand Magister','a_mageguild_master_MHuman',8.00,24.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5263,31997,'Priest of Dawn','','priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(5264,31998,'Dusk Priestess','','priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(5265,31999,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(5266,32000,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(5267,32001,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(5268,32002,'Preacher of Doom','','dark_horror',20.00,35.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(5269,32003,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(5270,32004,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(5271,32005,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(5272,32006,'Orator of Revelations','','liviona',15.00,28.00,70,'male','L2CabaleBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(5273,32007,'Galba','Fishing Guild Member','a_fisherA_Mhuman',8.00,24.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5274,32008,'Gremory','Priest','a_temple_master_Mhuman',8.00,24.50,70,'male','L2Trainer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5275,32009,'Devorin','Nurse','e_common_people_FDwarf',7.00,17.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5276,32010,'Flauron','Priest','a_temple_master_Mhuman',8.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5277,32011,'Imperial Tomb Guide','','a_tombkeeperA',7.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5278,32012,'Tantan','Retired Adventurer','a_old_people_Mhuman',9.00,17.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5279,32013,'Suki','Wild Maiden','a_common_peopleB_FHuman',8.00,20.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5280,32014,'Ivan','Runaway Youth','a_traderD_Mhuman',7.00,21.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5281,32015,'Scout''s Corpse','','e_guard_MDwarf_death',13.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5282,32016,'Torrant','Beacon Tower Manager','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5283,32017,'Karuda','','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5284,32018,'Misa','','a_maidB_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5285,32019,'Suspicious Man','','a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5286,32020,'Rafforty','','a_common_peopleC_Mhuman',10.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5287,32021,'Ice Sculpture','','ice_sculpture_c',16.00,20.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5288,32022,'Kierre','','ice_sculpture_b',12.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5289,32023,'Ice Shelf','','ice_shelf',35.00,14.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5290,32024,'Mulia','Clan Trader','e_smith_master_MDwarf',8.00,17.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5291,32025,'Ilia','Clan Trader','e_smith_Fdwarf',8.00,17.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5292,32026,'Hestui Guard','','e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5293,32027,'Holy Brazier','','grail_brazier_b',30.00,31.00,78,'male','L2Npc','npc',40,3862,7.500,44285,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'SYS','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5294,32028,'Holy Grail','','holy_grail',6.20,7.00,70,'male','L2Npc','npc',40,3862,7.500,3862,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'SYS','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5295,32029,'Freya''s Steward','','a_common_people_MElf',6.00,21.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5296,32030,'Garden Sculpture','','ice_sculpture_c',16.00,20.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5297,32031,'Ice Fairy Sculpture','','ice_sculpture_b',12.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5298,32032,'Strange Machine','','strange_mechanical_instrument',16.00,15.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5299,32033,'Doctor Chaos','','doctor_chaos',9.00,15.60,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5300,32034,'Temple Gatekeeper','','heretical_sanctuary_gatekeeper_a',80.00,181.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5301,32035,'Temple Gatekeeper','','heretical_sanctuary_openner_a',28.00,70.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5302,32036,'Temple Gatekeeper','','heretical_sanctuary_gatekeeper_b',80.00,203.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5303,32037,'Temple Gatekeeper','','heretical_sanctuary_openner_b',28.00,70.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5304,32038,'Ritual Offering','','a_traderA_Mhuman_deco',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5305,32039,'Triol''s Mirror','','heretical_devil_mirror',28.00,70.00,70,'male','L2TriolsMirror','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5306,32040,'Triol''s Mirror','','heretical_devil_mirror',28.00,70.00,70,'male','L2TriolsMirror','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5307,32041,'Yumi','Collector','e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5308,32042,'Weathermaster','','pavel_weather_controller',14.50,18.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5309,32043,'Weathermaster','','pavel_weather_controller',14.50,18.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5310,32044,'Weathermaster','','Evilate_weather',16.00,18.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5311,32045,'Doctor Chaos'' Secret Bookshelf','','Evilate_doc_chaos',25.00,33.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5312,32046,'Suspicious-Looking Pile of Stones','','susceptor_env',20.00,35.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5313,32047,'Wendy','','e_teleporter_FDwarf',8.00,21.30,70,'female','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5314,32048,'Event Gatekeeper','','cutie_cat',8.00,15.00,70,'female','L2Merchant','npc',40,3862,7.500,149300,200.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(5315,32049,'Rooney','Blacksmith of Wind','a_smith_MDwarf',7.00,16.50,70,'male','L2Npc','Rooney',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5316,32050,'Parts Box','','box',18.00,14.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5317,32051,'Altar Gatekeeper','','trioll_altar',9.00,33.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5318,32052,'Obi','Railroad Worker','e_mine_teacher_MDwarf',8.00,18.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(5319,32053,'Abey','Railroad Worker','e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5320,32054,'Ghost of a Railroad Engineer','','dwarf_ghost',10.00,18.70,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(5321,32055,'Ghost of an Ancient Railroad Engineer','','dwarf_ghost',10.00,18.70,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(5322,32056,'Aren','Khavatari','e_mageguild_teacher_FOrc',8.00,28.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5323,32057,'Totem Spirit of Gandi','','onyx_beast',14.00,14.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(5324,32058,'Triol''s Revelation','','trioll_altar',9.00,33.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5325,32059,'Triol''s Revelation','','trioll_altar',9.00,33.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5326,32060,'Triol''s Revelation','','trioll_altar',9.00,33.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5327,32061,'Triol''s Revelation','','trioll_altar',9.00,33.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5328,32062,'Triol''s Revelation','','trioll_altar',9.00,33.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5329,32063,'Triol''s Revelation','','trioll_altar',9.00,33.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5330,32064,'Triol''s Revelation','','trioll_altar',9.00,33.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5331,32065,'Triol''s Revelation','','trioll_altar',9.00,33.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(5332,32066,'Triol''s Revelation','','trioll_altar',9.00,33.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5333,32067,'Triol''s Revelation','','trioll_altar',9.00,33.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5334,32068,'Triol''s Revelation','','trioll_altar',9.00,33.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5335,32069,'Gutenhagen','Collector','e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(5336,32070,'Adolph','','a_child_people_Mhuman',5.00,12.30,70,'male','L2Npc','EdwinFollower',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,45,'',0,'SYS','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(5337,32071,'Linda','','a_child_people_Fhuman',5.00,12.30,70,'female','L2Npc','EdwinFollower',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,50,'',0,'SYS','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(5338,32072,'Edwin','','a_old_people_Mhuman',9.00,17.30,70,'male','L2Npc','Edwin',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,6,32,'',0,'SYS','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(5339,32073,'Old Female Drifter','','a_old_people_Fhuman',9.00,17.30,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5340,32074,'Gludio Territory Manager','Guild President','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5341,32075,'Sandy the Cat','Tournament Helper','queen_of_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',0,0),
(5342,32076,'Box','','box',18.00,14.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(5343,32077,'Ice Sculpture','','ice_sculpture_c',16.00,20.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(5344,32078,'Ice Sculpture','','ice_sculpture_c',16.00,20.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(5345,32079,'Ice Sculpture','','ice_sculpture_c',16.00,20.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.56,'false',1,0),
(5346,32082,'Dion Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5347,32083,'Giran Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5348,32084,'Oren Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5349,32085,'Aden Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5350,32086,'Innadril Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5351,32087,'Schuttgart Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5352,32088,'Goddard Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5353,32089,'Rune Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Adventurer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5354,32090,'Dead Leopard''s Carcass','','onyx_beast_ns',14.00,14.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',1,0),
(5355,32091,'Omega''s Cat','Event Manager','cutie_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(5356,32092,'Alder','Warehouse Chief','e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5357,32093,'Bolin','Head Blacksmith','e_common_people_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5358,32094,'Schule','Grand Master','a_fighterguild_master_FHuman',8.00,21.50,70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5359,32095,'Marie','High Priest','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5360,32096,'Helminter','Grand Master','a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'male','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5361,32097,'Finker','High Prefect','e_trader_FOrc',8.00,24.00,70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5362,32098,'Celes','Grand Magister','a_mageguild_master_FHuman',8.00,23.00,70,'female','L2VillageMaster','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5363,32099,'Tony the Cat','Event Manager','cutie_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(5364,32100,'Tony the Cat','Event Manager','cutie_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(5365,32101,'Tony the Cat','Event Manager','cutie_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(5366,32102,'Tony the Cat','Event Manager','cutie_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(5367,32103,'Telling the Cat','Event Manager','cutie_cat',8.00,15.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(5368,32104,'Vervato','','Crokian_Sorcerer',25.00,33.00,70,'male','L2Npc','Mystic',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',1,0),
(5369,32105,'Dinn','','a_traderC_Mhuman',8.00,23.00,70,'male','L2Merchant','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',1,0),
(5370,32106,'Singsing','','a_wharfinger_MHuman',8.00,23.00,70,'male','L2Merchant','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',1,0),
(5371,32107,'Teleportation Cubic','','teleport_npc',40.00,80.00,70,'male','L2Merchant','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(5372,32108,'','','rhamphorhynchus_npc',1.00,30.00,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(5373,32109,'Shilen''s Stone Statue','','primeval_raid_teleporter',24.00,72.50,70,'male','L2Merchant','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',1,0),
(5374,32110,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(5375,32111,'Orahochin','','Crokian_Sorcerer',25.00,33.00,70,'male','L2Merchant','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',1,0),
(5376,32112,'Gariachin','','Crokian_Sorcerer',25.00,33.00,70,'male','L2Merchant','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',1,0),
(5377,32113,'Marquez','','a_wharfinger_MHuman',8.00,23.00,70,'male','L2Merchant','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',1,0),
(5378,32114,'Mushika','','Crokian_Elder',25.00,33.00,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',1,0),
(5379,32115,'Asamah','','Crokian_Vice_Elder',45.00,41.50,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',1,0),
(5380,32116,'Kirikachin','','Crokian_Vice_Elder',45.00,41.50,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',1,0),
(5381,32117,'Karakawei','','Crokian_Sorcerer',25.00,33.00,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',1,0),
(5382,32118,'Mantarasa Egg','','dinosaur_nest',43.00,33.50,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,0,0,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',1,0),
(5383,32119,'Ulu Kaimu','','Evilate_doc_chaos',25.00,33.50,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(5384,32120,'Balu Kaimu','','Evilate_doc_chaos',25.00,33.50,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(5385,32121,'Chuta Kaimu','','Evilate_doc_chaos',25.00,33.50,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(5386,32122,'Warrior''s Grave','','Evilate_weather',16.00,18.50,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',1,0),
(5387,32123,'Valakas','','valakas_f',190.00,335.00,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,0.00,'false',0,0),
(5388,32124,'Great Soul','','Soul_Collector_Npc',14.00,25.00,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(5389,32125,'Great Soul','','Soul_Collector_Npc',14.00,25.00,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(5390,32126,'Priest Guard','','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(5391,32127,'Priest Guard','','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(5392,32128,'Guardian Wizard of the Cloth','','a_traderB_FHuman',8.00,25.00,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(5393,32129,'','','valakas_f_dummy',8.00,10.00,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(5394,32130,'Strategist Lucien','Event Manager','king_of_cat',6.00,16.01,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,198,'',0,'Magister','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(5395,32131,'Magic Laboratory Worker','Event Manager','e_smith_Fdwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(5396,32132,'Alchemist''s Servitor','','LineageNPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Npc','npc',40,3862,11.850,1493,2.780,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(5397,32133,'Perwan','Vice Hierarch','LineageNPC2.K_M1_elder',17.00,25.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5398,32134,'Newbie Helper','','LineageNPC2.K_F1_elder',13.00,22.25,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5399,32135,'Newbie Guide','','LineageNPC2.K_M1_elder',17.00,25.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5400,32136,'Basil','Marksman','LineageNPC2.K_M1_guard',13.00,25.00,1,'male','L2Guard','Guard',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,9646,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5401,32137,'Sucrete','Marksman','LineageNPC2.K_M1_guard',13.00,25.00,1,'male','L2Guard','Guard',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,9646,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5402,32138,'Kekropus','Hierarch','LineageNPC2.K_kekrops',18.00,28.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5403,32139,'Casca','Vice Hierarch','LineageNPC2.K_M1_elder',17.00,25.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5404,32140,'Zenya','Vice Hierarch','LineageNPC2.K_F1_elder',13.00,22.25,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5405,32141,'Nerga','Master','LineageNPC2.K_M1_master',15.00,25.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5406,32142,'Tenor','Master','LineageNPC2.K_M1_master',15.00,25.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5407,32143,'Belkis','Master','LineageNPC2.K_F1_master',12.00,23.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5408,32144,'Xonia','Master','LineageNPC2.K_F1_master',12.00,23.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5409,32145,'Maynard','Grand Master','LineageNPC2.K_F1_grand',11.00,22.25,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5410,32146,'Valpor','Grand Master','LineageNPC2.K_M1_grand',13.00,25.00,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5411,32147,'Rivian','Grand Master','LineageNPC.a_mageguild_teacher_FElf',7.00,21.20,1,'female','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5412,32148,'Cindet','Master','LineageNPC.a_fighterguild_teacher_MElf',7.00,22.50,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5413,32149,'Ennear','Magister','LineageNPC.a_fighterguild_teacher_FElf',8.00,22.50,1,'female','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5414,32150,'Took','High Prefect','LineageNPC.e_patriarch_MOrc',8.00,26.00,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5415,32151,'Herz','Prefect','LineageNPC.e_fighterguild_teacher_MOrc',8.00,28.50,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5416,32152,'Henri','Seer','LineageNPC.e_clergyman_FOrc',6.50,28.00,1,'female','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5417,32153,'Prana','High Priest','LineageNPC.a_temple_master_Mhuman',8.00,24.50,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5418,32154,'Aldenia','Grand Master','LineageNPC.a_fighterguild_master_FHuman',8.00,21.50,1,'female','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5419,32155,'Nabot','Priest','LineageNPC.a_temple_teacher_Mhuman',7.00,23.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5420,32156,'Talbot','Master','LineageNPC.a_fighterguild_teacher_MHuman',8.00,23.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5421,32157,'Moka','Head Blacksmith','LineageNPC.e_smith_master_MDwarf',8.00,17.00,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5422,32158,'Fisler','Warehouse Chief','LineageNPC.e_collector_master_MDwarf',8.00,18.40,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5423,32159,'Kincaid','Blacksmith','LineageNPC.a_smith_MDwarf',7.00,16.50,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5424,32160,'Devon','Grand Magister','LineageNPC.a_mageguild_teacher_MDarkElf',8.00,22.00,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5425,32161,'Black','Master','LineageNPC.a_fighterguild_teacher_MDarkElf',8.00,23.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5426,32162,'Martika','Magister','LineageNPC.a_clergyman_FDarkElf',8.00,25.00,1,'female','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5427,32163,'Ragara','Gatekeeper','LineageNPC2.K_F1_teleporter',13.00,23.50,1,'female','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5428,32164,'Erinu','Trader','LineageNPC2.K_M1_normal',13.00,25.00,70,'male','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5429,32165,'Zakone','Trader','LineageNPC2.K_M1_normal',13.00,25.00,70,'male','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5430,32166,'Trevor','Trader','LineageNPC2.K_M1_normal',13.00,25.00,70,'male','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5431,32167,'Nika','Trader','LineageNPC2.K_F1_normal',11.00,22.50,70,'female','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5432,32168,'Zenith','Trader','LineageNPC2.K_F1_normal',11.00,22.50,70,'female','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5433,32169,'Miller','Trader','LineageNPC2.K_F1_normal',11.00,22.50,70,'female','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5434,32170,'Benis','Warehouse Keeper','LineageNPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5435,32171,'Hoffa','Warehouse Chief','LineageNPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5436,32172,'Saylem','Warehouse Freightman','LineageNPC.e_warehouse_keeper_FDwarf',6.00,18.00,70,'female','L2Warehouse','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5437,32173,'Marcela','Zerstorer','LineageNPC2.K_F1_guard_Master',13.00,22.50,70,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,9646,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5438,32174,'Maddy','Marksman','LineageNPC2.K_F1_guard',13.00,22.50,70,'female','L2Guard','Guard',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,9644,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5439,32175,'Bixon','Marksman','LineageNPC2.K_M1_guard',13.00,25.00,70,'male','L2Guard','Guard',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,9646,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5440,32176,'Ambra','Marksman','LineageNPC2.K_F1_guard',13.00,22.50,70,'female','L2Guard','Guard',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,9644,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5441,32177,'Syzar','Marksman','LineageNPC2.K_M1_guard',13.00,25.00,70,'male','L2Guard','Guard',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5442,32178,'Carver','Marksman','LineageNPC2.K_F1_guard',13.00,22.50,70,'male','L2Guard','Guard',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5443,32179,'Putin','Marksman','LineageNPC2.K_M1_guard',13.00,25.00,70,'male','L2Guard','Guard',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5444,32180,'Kato','Marksman','LineageNPC2.K_M1_guard',13.00,25.00,70,'male','L2Guard','Guard',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,9646,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5445,32181,'Mellon','Gatekeeper','LineageNPC2.K_F1_teleporter',13.00,23.50,70,'male','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5446,32182,'Coplan','Master','LineageNPC2.K_M1_master',15.00,25.00,70,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,9646,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5447,32183,'Yunha','Master','LineageNPC2.K_F1_master',12.00,23.00,70,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5448,32184,'Yinir','Gatekeeper','LineageNPC2.K_F1_teleporter',13.00,23.50,70,'male','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5449,32185,'Peregrine','Marksman','LineageNPC2.K_M1_guard',13.00,25.00,70,'male','L2Guard','Guard',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,9646,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5450,32186,'Yung','Gatekeeper','LineageNPC2.K_F1_teleporter',13.00,23.50,70,'male','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5451,32187,'Nadir','Vice Hierarch','LineageNPC2.K_F1_elder',13.00,22.25,70,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5452,32188,'Morelin','Marksman','LineageNPC2.K_F1_guard',13.00,22.50,70,'female','L2Guard','Guard',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,9644,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5453,32189,'Largo','Gatekeeper','LineageNPC2.K_F1_teleporter',13.00,23.50,70,'male','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5454,32190,'Mao','Vice Hierarch','LineageNPC2.K_M1_elder',17.00,25.00,70,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5455,32191,'Hanarin','Grand Master','LineageNPC2.K_F1_grand',11.00,22.25,70,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5456,32192,'Falken','Marksman','LineageNPC2.K_M1_guard',13.00,25.00,70,'male','L2Guard','Guard',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5457,32193,'Yeniche','Grand Master','LineageNPC2.K_F1_grand',11.00,22.25,70,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5458,32194,'Shubain','Master','LineageNPC2.K_M1_master',15.00,25.00,70,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5459,32195,'Sione','Master','LineageNPC2.K_F1_master',12.00,23.00,70,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5460,32196,'Gershwin','Grand Master','LineageNPC2.K_M1_grand',13.00,25.00,70,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5461,32197,'Gwain','Master','LineageNPC2.K_M1_master',15.00,25.00,70,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5462,32198,'Gobie','Master','LineageNPC2.K_F1_master',12.00,23.00,70,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5463,32199,'Holst','Grand Master','LineageNPC2.K_M1_grand',13.00,25.00,70,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5464,32200,'Entien','Master','LineageNPC2.K_M1_master',15.00,25.00,70,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5465,32201,'Rindy','Master','LineageNPC2.K_F1_master',12.00,23.00,70,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5466,32202,'Khadava','Grand Master','LineageNPC2.K_F1_grand',11.00,22.25,70,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5467,32203,'Ramen','Master','LineageNPC2.K_M1_master',15.00,25.00,70,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5468,32204,'Fiske','Master','LineageNPC2.K_F1_master',12.00,23.00,70,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5469,32205,'Aetonic','Grand Master','LineageNPC2.K_M1_grand',13.00,25.00,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5470,32206,'Pieche','Grand Master','LineageNPC2.K_F1_grand',11.00,22.25,1,'female','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5471,32207,'Orkurus','Master','LineageNPC2.K_M1_master',15.00,25.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5472,32208,'Rasha','Master','LineageNPC2.K_F1_master',12.00,23.00,1,'female','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5473,32209,'Ferdinand','Grand Master','LineageNPC2.K_M1_grand',13.00,25.00,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5474,32210,'Eddy','Grand Master','LineageNPC2.K_F1_grand',11.00,22.25,1,'female','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5475,32211,'Jueno','Master','LineageNPC2.K_M1_master',15.00,25.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5476,32212,'Rishtar','Master','LineageNPC2.K_F1_master',12.00,23.00,1,'female','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5477,32213,'Vitus','Grand Master','LineageNPC2.K_M1_grand',13.00,25.00,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5478,32214,'Meldina','Grand Master','LineageNPC2.K_F1_grand',11.00,22.25,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5479,32215,'Tenain','Master','LineageNPC2.K_M1_master',15.00,25.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5480,32216,'Noir','Master','LineageNPC2.K_F1_master',12.00,23.00,1,'female','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5481,32217,'Barta','Grand Master','LineageNPC2.K_M1_grand',13.00,25.00,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5482,32218,'Miya','Grand Master','LineageNPC2.K_F1_grand',11.00,22.25,1,'female','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5483,32219,'Fabnor','Master','LineageNPC2.K_M1_master',15.00,25.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5484,32220,'Selsia','Master','LineageNPC2.K_F1_master',12.00,23.00,1,'female','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5485,32221,'Brome','Grand Master','LineageNPC2.K_M1_grand',13.00,25.00,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5486,32222,'Liane','Grand Master','LineageNPC2.K_F1_grand',11.00,22.25,1,'female','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5487,32223,'Duroga','Master','LineageNPC2.K_M1_master',15.00,25.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5488,32224,'Auren','Master','LineageNPC2.K_F1_master',12.00,23.00,1,'female','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5489,32225,'Taine','Grand Master','LineageNPC2.K_M1_grand',13.00,25.00,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'false',1,0),
(5490,32226,'Rupaul','Grand Master','LineageNPC2.K_F1_grand',11.00,22.25,1,'female','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'false',1,0),
(5491,32227,'Digler','Master','LineageNPC2.K_M1_master',15.00,25.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5492,32228,'Medea','Master','LineageNPC2.K_F1_master',12.00,23.00,1,'female','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5493,32229,'Hagel','Grand Master','LineageNPC2.K_M1_grand',13.00,25.00,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5494,32230,'Ceci','Grand Master','LineageNPC2.K_F1_grand',11.00,22.25,1,'female','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5495,32231,'Ruben','Master','LineageNPC2.K_M1_master',15.00,25.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5496,32232,'Minuet','Master','LineageNPC2.K_F1_master',12.00,23.00,1,'female','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5497,32233,'Zoldart','Grand Master','LineageNPC2.K_M1_grand',13.00,25.00,1,'male','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5498,32234,'Nizer','Grand Master','LineageNPC2.K_F1_grand',11.00,22.25,1,'female','L2VillageMaster','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5499,32235,'Katenar','','LineageNPC2.k_hero_rapire',10.00,24.62,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5500,32236,'Harkilgamed','','LineageNPC2.k_hero_bigsword',11.00,25.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(5501,32237,'Rodenpicula','','LineageNPC2.k_hero_bowgun',9.00,23.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5502,32238,'Rock','','LineageNpcEV.stone_q0236_p',60.00,25.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5503,32239,'Mother Nornil','','LineageNpcEV.mother_nornil',50.00,253.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5504,32240,'Katenar','','LineageNPC2.k_hero_rapire',10.00,24.62,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5505,32241,'Berka','','LineageNPC2.K_M1_master',15.00,25.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5506,32242,'Katenar','','LineageNPC2.k_hero_rapire',10.00,24.62,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5507,32243,'Cargo Box','','LineageNPC.Box',18.00,14.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5508,32244,'Suspicious Man','','LineageNPC2.K_M1_normal',13.00,25.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5509,32245,'Matras','','LineageNPC.e_mine_teacher_MDwarf',8.00,18.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5510,32246,'Rua','','LineageNPC2.a_child_people_Fhuman',5.00,12.30,1,'female','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5511,32247,'Serian','','LineageNPC.a_common_peopleA_FHuman',8.00,21.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5512,32248,'First Reaction','','LineageNPC.a_common_peopleB_MHuman',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5513,32249,'Chief Jarron','','LineageNPC.a_wharfinger_MHuman',8.00,23.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5514,32250,'Ario','','LineageNPC.a_common_peopleA_MHuman',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5515,32251,'Saria','','LineageNPC.a_common_peopleA_FHuman',8.00,21.50,1,'female','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5516,32252,'Caravaner Gort','','LineageNPC2.K_M1_normal',13.00,25.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5517,32253,'Harkilgamed','','LineageNPC2.k_hero_bigsword',11.00,25.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5518,32254,'Harkilgamed','','LineageNPC2.k_hero_bigsword',11.00,25.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5519,32255,'Icon of the Past','','LineageNpcEV.godness_of_the_past',50.00,245.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5520,32256,'Icon of the Present','','LineageNpcEV.godness_of_the_being',50.00,245.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5521,32257,'Icon of the Future','','LineageNpcEV.godness_of_the_come',54.00,245.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5522,32258,'Menacing Machine','','LineageNpcEV.mother_nornil',50.00,253.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5523,32259,'Vault Door Controller','','LineageNPC.teleport_npc_sm',7.00,15.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5524,32260,'Gatemaster of the Past','','LineageNPC.teleport_npc_sm',7.00,15.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5525,32261,'Gatemaster of the Present','','LineageNPC.teleport_npc_sm',7.00,15.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5526,32262,'Gatemaster of the Future','','LineageNPC.teleport_npc_sm',7.00,15.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5527,32263,'Rodenpicula','','LineageNPC2.k_hero_bowgun',9.00,23.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5528,32264,'Kanis','','LineageNPC.a_patriarch_MElf',8.00,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5529,32265,'Witch''s Study','','LineageNPC.training_doll_150p',13.00,40.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5530,32266,'Maiden''s Purse','','LineageNPC.training_doll_150p',13.00,40.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5531,32267,'Maiden''s Cocoa Tree','','LineageNPC.training_doll_150p',13.00,40.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5532,32268,'Altar of the First Water Dragon','','LineageNPC.training_doll_150p',13.00,40.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5533,32269,'Altar of the Second Water Dragon','','LineageNPC.training_doll_150p',13.00,40.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5534,32270,'Altar of the Third Water Dragon','','LineageNPC.training_doll_150p',13.00,40.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5535,32271,'Parme','','LineageNPC.a_teleporter_FElf',8.50,23.50,1,'female','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5536,32272,'Akyaka','','LineageNPC.a_traderA_MDwarf',8.00,17.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5537,32273,'Oracle Guide','','LineageNpcEV.teleport_device',16.00,42.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5538,32274,'Oracle Guide','','LineageNpcEV.teleport_device',16.00,42.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5539,32275,'Oracle Guide','','LineageNpcEV.teleport_device',16.00,42.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5540,32276,'Oracle Guide','','LineageNpcEV.teleport_device',16.00,42.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5541,32277,'Oracle Guide','','LineageNpcEV.teleport_device',16.00,42.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5542,32278,'Oracle Guide','','LineageNpcEV.teleport_device',16.00,42.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5543,32279,'Oracle Guide','','LineageNpcEV.teleport_device',16.00,42.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5544,32280,'Oracle Guide','','LineageNpcEV.teleport_device',16.00,42.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5545,32281,'Oracle Guide','','LineageNpcEV.teleport_device',16.00,42.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5546,32282,'Yiyen','Archaeologist','LineageNPC.e_teleporter_FDwarf',8.00,21.30,1,'female','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5547,32283,'Alarm','','LineageNpcEV.strange_mechanical_instrument',16.00,15.50,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5548,32284,'Eva''s Protector','','LineageNpcEV.teleport_device',16.00,42.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5549,32285,'Eva''s Protector','','LineageNpcEV.teleport_device',16.00,42.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5550,32286,'Eva''s Protector','','LineageNpcEV.teleport_device',16.00,42.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5551,32287,'Eva''s Protector','','LineageNpcEV.teleport_device',16.00,42.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5552,32288,'Symbol of Faith','','LineageNpcEV.dark_clouds_crystal',23.00,37.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5553,32289,'Symbol of Adversity','','LineageNpcEV.dark_clouds_crystal',23.00,37.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5554,32290,'Symbol of Adventure','','LineageNpcEV.dark_clouds_crystal',23.00,37.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5555,32291,'Symbol of Truth','','LineageNpcEV.truth_lie_crystal',23.00,24.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5556,32292,'Galate','','LineageNPC.a_mageguild_teacher_FHuman',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5557,32293,'Girone','','LineageNPC.a_common_peopleC_Mhuman',8.00,23.50,1,'female','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5558,32294,'Budenka','Harbor Caravaner','LineageMonster4.caravan',33.00,58.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5559,32295,'Wounded Land Insurgent','','LineageNPC.a_common_peopleC_Mhuman',8.00,23.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5560,32296,'Seruja','Spirit of the Old Seer','LineageMonster.human_ghost',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5561,32297,'Polk','','LineageMonster4.caravan',33.00,58.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5562,32298,'Hud','Caravan Merchant','LineageMonster4.caravan',33.00,58.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5563,32299,'Quarry Slave','','LineageMonster4.caravan_slave',35.00,47.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5564,32300,'Bernarde','','LineageNPC.a_common_peopleC_Mhuman',8.00,23.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5565,32301,'Kendal','Wandering Ghost','LineageMonster.human_ghost',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5566,32302,'Jerian','','LineageNPC.a_mageguild_teacher_MHuman',8.00,23.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5567,32303,'Machine','','LineageNpcEV.strange_mechanical_instrument',16.00,15.50,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5568,32304,'Oasis','','LineageNPC.training_doll_150p',13.00,40.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5569,32305,'Ranku''s Scapegoat','','LineageMonster4.caravan_slave',35.00,47.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5570,32306,'Native''s Corpse','','LineageMonster.Zombie_corpse',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5571,32307,'Dolmen','','LineageNpcEV.Huge_dolmen',8.00,22.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5572,32308,'Ming','Love Cat','LineageMonster.Cutie_cat',8.00,15.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5573,32309,'Nurba','Gatekeeper','LineageNPC.e_teleporter_Fhuman',8.00,25.00,1,'female','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5574,32310,'Caninja','Gatekeeper','LineageNPC.e_teleporter_Fhuman',8.00,25.00,1,'female','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5575,32311,'Busha','Gatekeeper','LineageNPC.e_teleporter_Fhuman',8.00,25.00,1,'female','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5576,32312,'Rat Hole','','LineageNPC.training_doll_150p',13.00,40.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5577,32313,'Deltuva','','LineageNPC.a_common_peopleC_Mhuman',8.00,23.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5578,32314,'Warpgate','','LineageNpcEV.warp_gate_a',16.00,31.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5579,32315,'Warpgate','','LineageNpcEV.warp_gate_a',16.00,31.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5580,32316,'Warpgate','','LineageNpcEV.warp_gate_b',16.00,31.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5581,32317,'Warpgate','','LineageNpcEV.warp_gate_c',16.00,31.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5582,32318,'Warpgate','','LineageNpcEV.warp_gate_d',16.00,31.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5583,32319,'Warpgate','','LineageNpcEV.warp_gate_e',16.00,31.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5584,32320,'Item Broker','Adventure Guildsman','LineageNPC.a_traderC_Mhuman',8.00,23.00,1,'male','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5585,32321,'Item Broker','Adventure Guildsman','LineageNPC.a_traderC_Mhuman',8.00,23.00,1,'male','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5586,32322,'Item Broker','Adventure Guildsman','LineageNPC.a_traderC_Mhuman',8.00,23.00,1,'male','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5587,32323,'Avant-Garde','Transformation Wizard','LineageNPC.a_traderB_FHuman',8.00,22.00,1,'male','L2Trainer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5588,32324,'Black Stone Monolith','','LineageNpcEV.Dark_clouds_stonehenge',8.00,22.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5589,32325,'Yin','Attribute Master','LineageNPC.Mage_master',8.00,23.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5590,32326,'Yang','Attribute Master','LineageNPC.Mage_master',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5591,32327,'Adventurers'' Guide','','LineageNPC.Sanctuary_teacher',8.00,23.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5592,32328,'Crystaline Golem','','LineageMonster4.Crystal_Golem',30.00,47.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5593,32329,'Fafurion Kindred','','LineageMonster3.Water_Drake',35.00,58.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5594,32330,'Garden Guard','','LineageNPC2.Keny_guard',13.00,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5595,32331,'Arcane Nucleus','','LineageNpcEV.Circle_core',8.00,22.00,1,'etc','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5596,32332,'Katenar','','LineageNPC2.Rapire',10.00,24.62,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5597,32333,'Katenar','','LineageNPC2.Rapire',10.00,24.62,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5598,32334,'Harkilgamed','','LineageNPC2.Rapire',11.00,25.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5599,32335,'Marksman','','LineageNPC2.Keny_guard',13.00,22.50,1,'female','L2Guard','GuardRndWalkAndAnim',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,9644,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'false',1,0),
(5600,32336,'Marksman','','LineageNPC2.Keny_guard',13.00,22.50,1,'female','L2Guard','GuardRndWalkAndAnim',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,9644,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.37,'false',1,0),
(5601,32337,'Adventure Guildsman','','LineageNPC.MElf',6.00,21.00,1,'male','L2Adventurer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5602,32338,'Adventure Guildsman','','LineageNPC.Collector_teacher',8.00,22.00,1,'male','L2Adventurer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5603,32339,'Adventure Guildsman','','LineageNPC.Fighter_teacher',8.00,22.00,1,'male','L2Adventurer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5604,32340,'Adventure Guildsman','','LineageNPC.Markus',8.00,22.00,1,'male','L2Adventurer','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5605,32341,'Herb Jar','','LineageNpcEV.Hero',8.00,21.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5607,32343,'Moonlight Stone','','LineageNPC.Evil',11.00,45.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5608,32344,'Spooky Tombstone','','LineageNPC.Evil',11.00,45.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5609,32345,'Buron','Tailor','LineageNPC.Filemo',8.00,23.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5610,32346,'Kanaf','','LineageNPC.Filemor',8.00,23.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5611,32347,'Shadai','Legendary Blacksmith','LineageNPC.Smith_master',8.00,17.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5612,32348,'Burang','Fishing Guild Member','LineageNPC.Fisher',8.00,24.00,1,'male','L2Merchant','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,7560,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',1,0),
(5613,32349,'Girons','','LineageMonster3.Zombie_guard',17.00,30.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,173,0,0,80,120,'',0,'SYS','',0,0,0,7,30,4,4,0,0,0.37,'false',0,0),
(5614,32350,'Sandstorm','','LineageMonster4.SandTourbillon',10.00,28.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5615,32351,'Enceinte Insurgent','','LineageNPC.Aspero',8.00,23.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5616,32352,'Desert Heatmaster','','LineageNPC.Aspero',0.10,0.10,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5617,32353,'Event Gatekeeper','','LineageMonster.Cutie_cat',8.00,15.00,1,'male','L2Npc','npc',40,2444,2.000,149300,200.700,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5618,32354,'Kief','','LineageNPC.Zomo',8.00,23.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5619,32355,'Solomon','','LineageNPC.Zomo',8.00,23.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5620,32356,'Jude','','LineageMonster4.caravan',33.00,58.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5621,32357,'Native Slave','','LineageNPC.Zomo',8.00,23.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5622,32358,'Native Prisoner','','LineageNPC.Zomo',8.00,23.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5623,32359,'Lahm','Blacksmith of Power','LineageNPC.Zomo',8.00,17.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(5624,32360,'','','LineageNPC.clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(5625,32361,'Caravan Supporter','','LineageNPC.box',18.00,14.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(5626,32362,'Hellios Native','','LineageNPC.a_common_peopleC_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(5627,32363,'Hellios Insurgent','','LineageNPC.a_common_peopleC_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(5628,32364,'Hellios Traitor','','LineageNPC.a_common_peopleC_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(5629,32365,'Snow','Event Manager','LineageNPC2.TP_game_staff',5.00,12.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(5630,35010,'Mercenary','','a_guard_MHuman',8.00,24.00,50,'male','L2SiegeGuard','SiegeGuardFighter',40,2317,6.500,3830,2.400,40,43,30,21,20,10,0,0,1683,687,546,233,416,0,379,128,628,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,20,0,7,30,4,4,0,0,0.60,'false',0,0),
(5631,35011,'Mercenary','','a_guard_MHuman',8.00,24.00,50,'male','L2SiegeGuard','SiegeGuardFighter',80,2317,6.500,3830,2.400,40,43,30,21,20,10,0,0,1798,787,546,233,357,0,325,93,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5632,35012,'Mercenary','','a_guard_MHuman',8.00,24.00,50,'male','L2SiegeGuard','SiegeGuardRanger',1100,2245,6.500,3830,2.400,40,43,30,21,20,10,0,0,1889,544,546,233,322,0,293,280,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,10,8,0,1500,10,0.60,'false',0,0),
(5633,35013,'Mercenary','','a_royal_guardA_MHuman',8.00,24.00,50,'female','L2SiegeGuard','SiegeGuardMystic',800,2245,6.500,4245,5.200,40,43,30,21,20,10,0,0,683,517,1546,233,416,0,379,316,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5634,35014,'Mercenary','','a_royal_guardA_MHuman',8.00,24.00,50,'male','L2SiegeGuard','SiegeGuardMystic',800,2245,6.500,4245,5.200,40,43,30,21,20,10,0,0,683,517,1546,233,416,0,379,179,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5635,35015,'Mercenary','','a_guard_MHuman',8.00,24.00,50,'male','L2SiegeGuard','SiegeGuardFighter',40,2245,8.500,3830,6.500,40,43,30,21,20,10,0,0,1683,687,546,233,416,0,379,128,628,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,20,0,7,30,4,4,0,0,0.60,'false',0,0),
(5636,35016,'Mercenary','','a_guard_MHuman',8.00,24.00,50,'male','L2SiegeGuard','SiegeGuardFighter',80,2317,8.500,3830,6.500,40,43,30,21,20,10,0,0,1798,787,546,233,357,0,325,93,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5637,35017,'Mercenary','','a_guard_MHuman',8.00,24.00,50,'male','L2SiegeGuard','SiegeGuardRanger',1100,2245,8.500,3830,6.500,40,43,30,21,20,10,0,0,1889,544,546,233,322,0,293,280,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,10,8,0,1500,10,0.60,'false',0,0),
(5638,35018,'Mercenary','','a_royal_guardA_MHuman',8.00,24.00,50,'female','L2SiegeGuard','SiegeGuardMystic',800,2245,8.500,4245,7.200,40,43,30,21,20,10,0,0,683,517,1546,233,416,0,379,316,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5639,35019,'Mercenary','','a_royal_guardA_MHuman',8.00,24.00,50,'male','L2SiegeGuard','SiegeGuardMystic',800,2245,8.500,4245,7.200,40,43,30,21,20,10,0,0,683,517,1546,233,416,0,379,179,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5640,35020,'Mercenary of Dawn','','a_guard_MHuman',8.00,24.00,70,'male','L2SiegeGuard','SiegeGuardFighter',40,3986,2.700,1493,2.700,40,43,30,21,20,10,0,0,1763,485,1610,394,416,0,379,150,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5641,35021,'Mercenary of Dawn','','a_guard_MHuman',8.00,24.00,70,'male','L2SiegeGuard','SiegeGuardFighter',80,3986,2.700,1493,2.700,40,43,30,21,20,10,0,0,2058,485,1610,394,357,0,325,97,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5642,35022,'Mercenary of Dawn','','a_guard_MHuman',8.00,24.00,70,'male','L2SiegeGuard','SiegeGuardRanger',1100,3986,2.700,1493,2.700,40,43,30,21,20,10,0,0,2292,412,1610,394,322,0,293,288,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,0.60,'false',0,0),
(5643,35023,'Mercenary of Dawn','','a_royal_guardA_MHuman',8.00,24.00,70,'female','L2SiegeGuard','SiegeGuardMystic',40,3986,2.700,2240,4.100,40,43,30,21,20,10,0,0,1763,536,1610,394,416,0,379,325,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5644,35024,'Mercenary of Dawn','','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2SiegeGuard','SiegeGuardMystic',40,3986,2.700,2240,4.100,40,43,30,21,20,10,0,0,1763,536,1610,394,416,0,379,196,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5645,35025,'Mercenary of Dawn','','a_guard_MHuman',8.00,24.00,70,'male','L2SiegeGuard','SiegeGuardFighter',40,3986,2.700,1493,2.700,40,43,30,21,20,10,0,0,1763,485,1610,394,416,0,379,150,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5646,35026,'Mercenary of Dawn','','a_guard_MHuman',8.00,24.00,70,'male','L2SiegeGuard','SiegeGuardFighter',80,3986,2.700,1493,2.700,40,43,30,21,20,10,0,0,2058,485,1610,394,357,0,325,97,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5647,35027,'Mercenary of Dawn','','a_guard_MHuman',8.00,24.00,70,'male','L2SiegeGuard','SiegeGuardRanger',1100,3986,2.700,1493,2.700,40,43,30,21,20,10,0,0,2292,412,1610,394,322,0,293,288,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,0.60,'false',0,0),
(5648,35028,'Mercenary of Dawn','','a_royal_guardA_MHuman',8.00,24.00,70,'female','L2SiegeGuard','SiegeGuardMystic',40,3986,2.700,2240,4.100,40,43,30,21,20,10,0,0,1763,536,1610,394,416,0,379,325,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5649,35029,'Mercenary of Dawn','','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2SiegeGuard','SiegeGuardMystic',40,3986,2.700,2240,4.100,40,43,30,21,20,10,0,0,1763,536,1610,394,416,0,379,196,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5650,35030,'Elite Mercenary Guild Member','','a_guard_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,3153,2.400,1150,2.400,40,43,30,21,20,10,0,0,1154,380,988,309,416,0,379,132,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5651,35031,'Elite Mercenary Guild Member','','a_guard_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',80,3153,2.400,1150,2.400,40,43,30,21,20,10,0,0,1347,380,988,309,357,0,325,301,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5652,35032,'Elite Mercenary Guild Member','','a_guard_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardRanger',1100,3818,2.400,1150,2.400,40,43,30,21,20,10,0,0,1501,323,988,309,322,0,293,280,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,0.60,'false',0,0),
(5653,35033,'Elite Mercenary Guild Member','','a_royal_guardA_MHuman',8.00,24.00,60,'female','L2SiegeGuard','SiegeGuardMystic',40,3153,2.400,1726,3.600,40,43,30,21,20,10,0,0,1154,420,988,309,416,0,379,316,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5654,35034,'Elite Mercenary Guild Member','','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardMystic',40,3153,2.400,1726,3.600,40,43,30,21,20,10,0,0,1154,420,988,309,416,0,379,325,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5655,35035,'Elite Mercenary Guild Member','','a_guard_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,3153,2.400,1150,2.400,40,43,30,21,20,10,0,0,1154,380,988,309,416,0,379,132,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5656,35036,'Elite Mercenary Guild Member','','a_guard_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',80,3153,2.400,1150,2.400,40,43,30,21,20,10,0,0,1347,380,988,309,357,0,325,301,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5657,35037,'Elite Mercenary Guild Member','','a_guard_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardRanger',1100,3054,2.400,1150,2.400,40,43,30,21,20,10,0,0,1501,323,988,309,322,0,293,280,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,0.60,'false',0,0),
(5658,35038,'Elite Mercenary Guild Member','','a_royal_guardA_MHuman',8.00,24.00,60,'female','L2SiegeGuard','SiegeGuardMystic',40,3153,2.400,1726,3.600,40,43,30,21,20,10,0,0,1154,420,988,309,416,0,379,316,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5659,35039,'Elite Mercenary Guild Member','','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardMystic',40,3153,2.400,1726,3.600,40,43,30,21,20,10,0,0,1154,420,988,309,416,0,379,325,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5660,35040,'Greater Recruit','','a_guard_MHuman',8.00,24.00,55,'male','L2SiegeGuard','SiegeGuardFighter',40,2728,2.400,987,2.400,40,43,30,21,20,10,0,0,899,332,744,270,416,0,379,66,20,0,50,195,'mercenary_siege_clan',1200,'Local','',0,20,0,7,30,4,4,0,0,0.60,'false',0,0),
(5661,35041,'Greater Recruit','','a_guard_MHuman',8.00,24.00,55,'male','L2SiegeGuard','SiegeGuardFighter',80,2728,2.400,987,2.400,40,43,30,21,20,10,0,0,1050,332,744,270,357,0,325,16,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5662,35042,'Greater Recruit','','a_guard_MHuman',8.00,24.00,55,'male','L2SiegeGuard','SiegeGuardRanger',1100,2728,2.400,987,2.400,40,43,30,21,20,10,0,0,1169,282,744,270,322,0,293,274,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,0.60,'false',0,0),
(5663,35043,'Greater Recruit','','a_royal_guardA_MHuman',8.00,24.00,55,'female','L2SiegeGuard','SiegeGuardMystic',40,2728,2.400,1481,3.600,40,43,30,21,20,10,0,0,899,367,744,270,416,0,379,7,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5664,35044,'Greater Recruit','','a_royal_guardA_MHuman',8.00,24.00,55,'male','L2SiegeGuard','SiegeGuardMystic',40,2728,2.400,1481,3.600,40,43,30,21,20,10,0,0,899,367,744,270,416,0,379,154,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5665,35045,'Greater Recruit','','a_guard_MHuman',8.00,24.00,55,'male','L2SiegeGuard','SiegeGuardFighter',40,2728,2.400,987,2.400,40,43,30,21,20,10,0,0,899,332,744,270,416,0,379,66,20,0,50,195,'mercenary_siege_clan',1200,'Local','',0,20,0,7,30,4,4,0,0,0.60,'false',0,0),
(5666,35046,'Greater Recruit','','a_guard_MHuman',8.00,24.00,55,'male','L2SiegeGuard','SiegeGuardFighter',80,2728,2.400,987,2.400,40,43,30,21,20,10,0,0,1050,332,744,270,357,0,325,16,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5667,35047,'Greater Recruit','','a_guard_MHuman',8.00,24.00,55,'male','L2SiegeGuard','SiegeGuardRanger',1100,2728,2.400,987,2.400,40,43,30,21,20,10,0,0,1169,282,744,270,322,0,293,274,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,0.60,'false',0,0),
(5668,35048,'Greater Recruit','','a_royal_guardA_MHuman',8.00,24.00,55,'female','L2SiegeGuard','SiegeGuardMystic',40,2728,2.400,1481,3.600,40,43,30,21,20,10,0,0,899,367,744,270,416,0,379,7,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(5669,35049,'Greater Recruit','','a_royal_guardA_MHuman',8.00,24.00,55,'male','L2SiegeGuard','SiegeGuardMystic',40,2728,2.400,1481,3.600,40,43,30,21,20,10,0,0,899,367,744,270,416,0,379,154,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5670,35050,'Recruit','','a_guard_MHuman',8.00,24.00,45,'male','L2SiegeGuard','SiegeGuardFighter',40,1930,2.100,677,2.100,40,43,30,21,20,10,0,0,506,245,390,199,416,0,379,66,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5671,35051,'Recruit','','a_guard_MHuman',8.00,24.00,45,'male','L2SiegeGuard','SiegeGuardFighter',80,1930,2.100,677,2.100,40,43,30,21,20,10,0,0,591,245,390,199,357,0,325,16,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5672,35052,'Recruit','','a_guard_MHuman',8.00,24.00,45,'male','L2SiegeGuard','SiegeGuardRanger',1100,1930,2.100,677,2.100,40,43,30,21,20,10,0,0,658,209,390,199,322,0,293,14,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,0.60,'false',0,0),
(5673,35053,'Recruit','','a_royal_guardA_MHuman',8.00,24.00,45,'female','L2SiegeGuard','SiegeGuardMystic',40,1930,2.100,1016,3.200,40,43,30,21,20,10,0,0,506,271,390,199,416,0,379,6,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5674,35054,'Recruit','','a_royal_guardA_MHuman',8.00,24.00,45,'male','L2SiegeGuard','SiegeGuardMystic',40,1930,2.100,1016,3.200,40,43,30,21,20,10,0,0,506,271,390,199,416,0,379,99,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5675,35055,'Recruit','','a_guard_MHuman',8.00,24.00,45,'male','L2SiegeGuard','SiegeGuardFighter',40,1930,2.100,677,2.100,40,43,30,21,20,10,0,0,506,245,390,199,416,0,379,66,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5676,35056,'Recruit','','a_guard_MHuman',8.00,24.00,45,'male','L2SiegeGuard','SiegeGuardFighter',80,1930,2.100,677,2.100,40,43,30,21,20,10,0,0,591,245,390,199,357,0,325,16,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5677,35057,'Recruit','','a_guard_MHuman',8.00,24.00,45,'male','L2SiegeGuard','SiegeGuardRanger',1100,1930,2.100,677,2.100,40,43,30,21,20,10,0,0,658,209,390,199,322,0,293,14,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,0.60,'false',0,0),
(5678,35058,'Recruit','','a_royal_guardA_MHuman',8.00,24.00,45,'female','L2SiegeGuard','SiegeGuardMystic',40,1930,2.100,1016,3.200,40,43,30,21,20,10,0,0,506,271,390,199,416,0,379,6,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5679,35059,'Recruit','','a_royal_guardA_MHuman',8.00,24.00,45,'male','L2SiegeGuard','SiegeGuardMystic',40,1930,2.100,1016,3.200,40,43,30,21,20,10,0,0,506,271,390,199,416,0,379,99,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,0.60,'false',0,0),
(5680,35060,'Nephilim Mercenary','','a_guard_MHuman',8.00,24.00,75,'male','L2SiegeGuard','SiegeGuardFighter',40,189460,178.300,855,2.300,84,71,73,76,70,80,0,0,5261,1047,3228,425,526,0,3727,0,0,0,65,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,5,0,-4,0.63,'false',0,0),
(5681,35061,'Nephilim Mercenary','','a_royal_guardA_MHuman',8.00,24.00,72,'male','L2SiegeGuard','SiegeGuardMystic',40,185726,178.000,800,2.300,84,71,73,76,70,80,0,0,4792,983,2909,399,613,0,4347,7,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,5,0,-4,0.48,'false',0,0),
(5682,35062,'Headquarters','','flag_a',15.00,58.00,1,'etc','L2Npc','npc',40,158000,2.000,989,0.900,40,43,30,21,20,10,0,0,652,753,358,295,423,0,385,0,0,0,50,120,'',0,'Local','',35062,0,0,7,0,4,3,0,0,0.60,'false',0,0),
(5683,35063,'Gludio Holy Artifact','','castle_kent_statue_jewel',25.00,98.00,20,'etc','L2Artefact','npc',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5684,35064,'Baron Lewin Waldner','','a_lord_MHuman',8.00,23.00,65,'male','L2SiegeGuard','SiegeGuardFighter',40,55449,7.500,3958,2.700,40,43,30,21,20,10,0,0,4308,418,619,340,278,0,253,79,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5685,35065,'Cronenberg','Sir','a_royal_guardA_MHuman',8.00,24.00,62,'male','L2SiegeGuard','SiegeGuardFighter',40,51515,7.500,3653,2.700,40,43,30,21,20,10,384,1,3777,388,532,315,278,0,253,142,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5686,35066,'Royal Knight','Gludio','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'gludio_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',1,0),
(5687,35067,'Court Sorcerer','Gludio','a_royal_guardA_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5688,35068,'Court Sorcerer','Gludio','a_royal_guardA_MHuman',8.00,24.00,58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5689,35069,'Court Guard','Gludio','a_royal_guardB_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5690,35070,'Guard','Gludio','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5691,35071,'Guard','Gludio','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5692,35072,'Guard','Gludio','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(5693,35073,'Guard','Gludio','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5694,35074,'Guard','Gludio','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5695,35075,'Guard','Gludio','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5696,35076,'Guard','Gludio','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5697,35077,'Guard','Gludio','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5698,35078,'Guard','Gludio','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5699,35079,'Royal Knight','Gludio','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'gludio_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',1,0),
(5700,35080,'Court Sorcerer','Gludio','a_royal_guardA_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5701,35081,'Court Sorcerer','Gludio','a_royal_guardA_MHuman',8.00,24.00,58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5702,35082,'Court Guard','Gludio','a_royal_guardB_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5703,35083,'Guard','Gludio','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5704,35084,'Guard','Gludio','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5705,35085,'Guard','Gludio','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(5706,35086,'Guard','Gludio','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5707,35087,'Guard','Gludio','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5708,35088,'Guard','Gludio','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5709,35089,'Guard','Gludio','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5710,35090,'Guard','Gludio','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5711,35091,'Guard','Gludio','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5712,35092,'Gatekeeper','Gludio','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'gludio_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5713,35093,'Gatekeeper','Gludio','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'gludio_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5714,35094,'Gatekeeper','Gludio','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'gludio_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5715,35095,'Mass Gatekeeper','Gludio','a_guard_MHuman',8.00,24.00,70,'male','L2CastleTeleporter','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5716,35096,'Outer Doorman','Gludio','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5717,35097,'Inner Doorman','Gludio','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5718,35098,'Blacksmith','Gludio','e_smith_master_MDwarf',8.00,17.00,70,'male','L2CastleBlacksmith','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5719,35099,'Warehouse Keeper','Gludio','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2CastleWarehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5720,35100,'Sayres','Chamberlain','a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5721,35101,'Grad','Wyvern Manager','a_traderB_MHuman',8.00,24.50,70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5722,35102,'Greenspan','Mercenary Manager','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5723,35103,'Manor Manager','Gludio','a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5724,35104,'Tyron','Sir','a_guard_MHuman',8.00,24.00,70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,74,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5725,35105,'Dion Holy Artifact','','castle_kent_statue_jewel',25.00,98.00,20,'etc','L2Artefact','npc',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5726,35106,'Duke Byron Ashton','','a_lord_MHuman',8.00,23.00,65,'male','L2SiegeGuard','SiegeGuardFighter',40,55449,7.500,3958,2.700,40,43,30,21,20,10,422,1,4308,418,619,340,278,0,253,79,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5727,35107,'Ivano','Sir','a_royal_guardA_MHuman',8.00,24.00,62,'male','L2SiegeGuard','SiegeGuardFighter',40,51515,7.500,3653,2.700,40,43,30,21,20,10,384,1,3777,388,532,315,278,0,253,142,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5728,35108,'Royal Knight','Dion','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'dion_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',1,0),
(5729,35109,'Court Sorcerer','Dion','a_royal_guardA_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5730,35110,'Court Sorcerer','Dion','a_royal_guardA_MHuman',8.00,24.00,58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5731,35111,'Court Guard','Dion','a_royal_guardB_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5732,35112,'Guard','Dion','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5733,35113,'Guard','Dion','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5734,35114,'Guard','Dion','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(5735,35115,'Guard','Dion','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5736,35116,'Guard','Dion','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5737,35117,'Guard','Dion','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5738,35118,'Guard','Dion','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5739,35119,'Guard','Dion','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5740,35120,'Guard','Dion','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5741,35121,'Royal Knight','Dion','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'dion_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',1,0),
(5742,35122,'Court Sorcerer','Dion','a_royal_guardA_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5743,35123,'Court Sorcerer','Dion','a_royal_guardA_MHuman',8.00,24.00,58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5744,35124,'Court Guard','Dion','a_royal_guardB_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5745,35125,'Court Guard','Dion','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5746,35126,'Court Guard','Dion','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5747,35127,'Court Guard','Dion','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(5748,35128,'Court Guard','Dion','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5749,35129,'Court Guard','Dion','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5750,35130,'Court Guard','Dion','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5751,35131,'Court Guard','Dion','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5752,35132,'Court Guard','Dion','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5753,35133,'Court Guard','Dion','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5754,35134,'Gatekeeper','Dion','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5755,35135,'Gatekeeper','Dion','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5756,35136,'Gatekeeper','Dion','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5757,35137,'Mass Gatekeeper','Dion','a_guard_MHuman',8.00,24.00,70,'male','L2CastleTeleporter','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5758,35138,'Outer Doorman','Dion','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5759,35139,'Inner Doorman','Dion','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5760,35140,'Blacksmith','Dion','e_smith_master_MDwarf',8.00,17.00,70,'male','L2CastleBlacksmith','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5761,35141,'Warehouse Keeper','Dion','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2CastleWarehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5762,35142,'Crosby','Chamberlain','a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5763,35143,'Hodler','Wyvern Manager','a_traderB_MHuman',8.00,24.50,70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5764,35144,'Mercenary Manager Sanford','Mercenary Manager','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5765,35145,'Manor Manager','Dion','a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5766,35146,'Gibbson','Herald','a_guard_MHuman',8.00,24.00,70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,74,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5767,35147,'Giran Holy Artifact','','castle_kent_statue_jewel',25.00,98.00,20,'etc','L2Artefact','npc',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5768,35148,'Baron Carmon Esthus','','a_lord_MHuman',8.00,23.00,65,'male','L2SiegeGuard','SiegeGuardFighter',40,55449,7.500,3958,2.700,40,43,30,21,20,10,0,0,4308,418,619,340,278,0,253,79,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5769,35149,'Ulric','Sir','a_royal_guardA_MHuman',8.00,24.00,62,'male','L2SiegeGuard','SiegeGuardFighter',40,51515,7.500,3653,2.700,40,43,30,21,20,10,0,0,3777,388,532,315,278,0,253,142,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5770,35150,'Royal Knight','Giran','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'giran_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',1,0),
(5771,35151,'Court Sorcerer','Giran','a_royal_guardA_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5772,35152,'Court Sorcerer','Giran','a_royal_guardA_MHuman',8.00,24.00,58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5773,35153,'Court Guard','Giran','a_royal_guardB_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5774,35154,'Guard','Giran','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5775,35155,'Guard','Giran','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5776,35156,'Guard','Giran','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(5777,35157,'Guard','Giran','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5778,35158,'Guard','Giran','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5779,35159,'Guard','Giran','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5780,35160,'Guard','Giran','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5781,35161,'Guard','Giran','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5782,35162,'Guard','Giran','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5783,35163,'Royal Knight','Giran','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'giran_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',1,0),
(5784,35164,'Court Sorcerer','Giran','a_royal_guardA_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5785,35165,'Court Sorcerer','Giran','a_royal_guardA_MHuman',8.00,24.00,58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5786,35166,'Court Guard','Giran','a_royal_guardB_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5787,35167,'Guard','Giran','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5788,35168,'Guard','Giran','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5789,35169,'Guard','Giran','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(5790,35170,'Guard','Giran','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5791,35171,'Guard','Giran','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5792,35172,'Guard','Giran','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5793,35173,'Guard','Giran','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5794,35174,'Guard','Giran','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5795,35175,'Guard','Giran','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5796,35176,'Gatekeeper','Giran','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'giran_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5797,35177,'Gatekeeper','Giran','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'giran_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5798,35178,'Gatekeeper','Giran','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'giran_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5799,35179,'Mass Gatekeeper','Giran','a_guard_MHuman',8.00,24.00,70,'male','L2CastleTeleporter','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5800,35180,'Outer Doorman','Giran','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5801,35181,'Inner Doorman','Giran','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5802,35182,'Blacksmith','Giran','a_smith_MDwarf',7.00,16.50,70,'male','L2CastleBlacksmith','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5803,35183,'Warehouse Keeper','Giran','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2CastleWarehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5804,35184,'Saul','Chamberlain','a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5805,35185,'Bryce','Wyvern Manager','a_traderB_MHuman',8.00,24.50,70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5806,35186,'Arvid','Mercenary Manager','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5807,35187,'Manor Manager','Giran','a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5808,35188,'Holmes','Sir','a_guard_MHuman',8.00,24.00,70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,74,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5809,35189,'Oren Holy Artifact','','castle_kent_statue_jewel',25.00,98.00,20,'etc','L2Artefact','npc',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5810,35190,'Balthus Van Dyke','Duke','a_lord_MHuman',8.00,23.00,65,'male','L2SiegeGuard','SiegeGuardFighter',40,55449,7.500,3958,2.700,40,43,30,21,20,10,422,1,4308,418,619,340,278,0,253,79,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5811,35191,'Quant','Sir','a_royal_guardA_MHuman',8.00,24.00,62,'male','L2SiegeGuard','SiegeGuardFighter',40,51515,7.500,3653,2.700,40,43,30,21,20,10,0,0,3777,388,532,315,278,0,253,142,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5812,35192,'Royal Knight','Oren','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'oren_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',1,0),
(5813,35193,'Court Sorcerer','Oren','a_royal_guardA_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5814,35194,'Court Sorcerer','Oren','a_royal_guardA_MHuman',8.00,24.00,58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5815,35195,'Court Guard','Oren','a_royal_guardB_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5816,35196,'Guard','Oren','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5817,35197,'Guard','Oren','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5818,35198,'Guard','Oren','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(5819,35199,'Guard','Oren','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5820,35200,'Guard','Oren','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5821,35201,'Guard','Oren','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5822,35202,'Guard','Oren','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5823,35203,'Guard','Oren','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5824,35204,'Guard','Oren','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5825,35205,'Royal Knight','Oren','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'oren_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(5826,35206,'Court Sorcerer','Oren','a_royal_guardA_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5827,35207,'Court Sorcerer','Oren','a_royal_guardA_MHuman',8.00,24.00,58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5828,35208,'Court Guard','Oren','a_royal_guardB_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5829,35209,'Guard','Oren','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5830,35210,'Guard','Oren','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5831,35211,'Guard','Oren','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(5832,35212,'Guard','Oren','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5833,35213,'Guard','Oren','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5834,35214,'Guard','Oren','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5835,35215,'Guard','Oren','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5836,35216,'Guard','Oren','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5837,35217,'Guard','Oren','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5838,35218,'Gatekeeper','Oren','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'oren_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5839,35219,'Gatekeeper','Oren','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'oren_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5840,35220,'Gatekeeper','Oren','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'oren_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5841,35221,'Mass Gatekeeper','Oren','a_guard_MHuman',8.00,24.00,70,'male','L2CastleTeleporter','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5842,35222,'Outer Doorman','Oren','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5843,35223,'Inner Doorman','Oren','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5844,35224,'Blacksmith','Oren','a_guard_MHuman',8.00,24.00,56,'male','L2CastleBlacksmith','npc',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5845,35225,'Warehouse Keeper','Oren','a_guard_MHuman',8.00,24.00,56,'male','L2CastleWarehouse','npc',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5846,35226,'Brasseur','Chamberlain','a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5847,35227,'Finrod','Wyvern Manager','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2WyvernManager','npc',40,24436,6.500,3452,2.400,40,43,30,21,20,10,0,0,1721,368,478,299,278,0,253,76,2497,0,50,120,'oren_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',1,0),
(5848,35228,'Morrison','Mercenary Manager','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5849,35229,'Manor Manager','Oren','a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager','npc',40,3862,6.500,3254,2.400,40,43,30,21,20,10,0,0,1562,349,428,284,278,0,253,0,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5850,35230,'Manor Manager','Oren','a_trader_MElf',8.00,25.00,70,'male','L2ManorManager','npc',80,3862,6.500,3254,2.400,40,43,30,21,20,10,0,0,1562,349,428,284,237,0,216,0,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5851,35231,'Manor Manager','Oren','a_common_people_MDarkElf',8.00,23.00,70,'male','L2ManorManager','npc',80,3862,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,0,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5852,35232,'Sherwood','Messenger','a_guard_MHuman',8.00,24.00,70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,74,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5853,35233,'Aden Holy Artifact','','castle_kent_statue_jewel',25.00,98.00,20,'etc','L2Artefact','npc',40,721,2.500,213,1.200,40,43,30,21,20,10,0,0,57,189,23,76,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5854,35234,'Amadeo Cadmus','King','a_lord_MHuman',8.00,23.00,75,'male','L2SiegeGuard','SiegeGuardFighter',40,84582,8.500,6694,3.000,40,43,30,21,20,10,562,1,9383,523,957,425,278,0,253,80,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5855,35235,'Royal Knight','Aden','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2SiegeGuard','SiegeGuardFighter',40,38622,7.500,5975,2.700,40,43,30,21,20,10,0,0,3943,470,780,382,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5856,35236,'Court Sorcerer','Aden','a_royal_guardA_MHuman',8.00,24.00,68,'male','L2SiegeGuard','SiegeGuardMystic',40,37063,7.500,5693,2.700,40,43,30,21,20,10,0,0,3652,449,713,365,278,0,253,7,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(5857,35237,'Court Sorcerer','Aden','a_royal_guardA_MHuman',8.00,24.00,68,'male','L2SiegeGuard','SiegeGuardMystic',40,37063,7.500,5693,2.700,40,43,30,21,20,10,0,0,3652,449,713,365,278,0,253,92,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(5858,35238,'Court Guard','Aden','a_royal_guardB_MHuman',8.00,24.00,68,'male','L2SiegeGuard','SiegeGuardFighter',80,37063,7.500,5693,2.700,40,43,30,21,20,10,0,0,3652,449,713,365,237,0,216,1376,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5859,35239,'Guard','Aden','a_guard_MElf',8.00,23.50,66,'male','L2SiegeGuard','SiegeGuardFighter',80,35465,7.500,5415,2.700,40,43,30,21,20,10,436,1,3369,428,649,348,237,0,216,300,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5860,35240,'Guard','Aden','a_guard_MElf',8.00,23.50,66,'male','L2SiegeGuard','SiegeGuardFighter',40,35465,7.500,5415,2.700,40,43,30,21,20,10,436,1,3369,428,649,348,278,0,253,132,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5861,35241,'Guard','Aden','a_guard_MElf',8.00,23.50,66,'male','L2SiegeGuard','SiegeGuardRanger',1100,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5862,35242,'Guard','Aden','a_guard_FDarkelf',8.00,25.00,66,'female','L2SiegeGuard','SiegeGuardFighter',80,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5863,35243,'Guard','Aden','a_guard_FDarkelf',8.00,25.00,66,'female','L2SiegeGuard','SiegeGuardFighter',40,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5864,35244,'Guard','Aden','a_guard_FDarkelf',8.00,25.00,66,'female','L2SiegeGuard','SiegeGuardRanger',1100,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5865,35245,'Guard','Aden','a_guard_MHuman',8.00,24.00,66,'male','L2SiegeGuard','SiegeGuardFighter',80,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5866,35246,'Guard','Aden','a_guard_MHuman',8.00,24.00,66,'male','L2SiegeGuard','SiegeGuardFighter',40,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5867,35247,'Guard','Aden','a_guard_MHuman',8.00,24.00,66,'male','L2SiegeGuard','SiegeGuardRanger',1100,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5868,35248,'Royal Knight','Aden','a_royal_guardA_MHuman',8.00,24.00,70,'male','L2SiegeGuard','SiegeGuardFighter',40,38622,7.500,5975,2.700,40,43,30,21,20,10,490,1,3943,470,780,382,278,0,253,142,633,0,50,120,'aden_siege_clan',1200,'Local','',0,20,147,7,30,4,4,0,-6,0.60,'false',1,0),
(5869,35249,'Court Sorcerer','Aden','a_royal_guardA_MHuman',8.00,24.00,68,'male','L2SiegeGuard','SiegeGuardMystic',40,37063,7.500,5693,2.700,40,43,30,21,20,10,462,1,3652,449,713,365,278,0,253,326,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5870,35250,'Court Sorcerer','Aden','a_royal_guardA_MHuman',8.00,24.00,68,'female','L2SiegeGuard','SiegeGuardMystic',40,37063,7.500,5693,2.700,40,43,30,21,20,10,462,1,3652,449,713,365,278,0,253,325,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5871,35251,'Court Guard','Aden','a_royal_guardB_MHuman',8.00,24.00,68,'male','L2SiegeGuard','SiegeGuardFighter',80,37063,7.500,5693,2.700,40,43,30,21,20,10,462,1,3652,449,713,365,237,0,216,300,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5872,35252,'Guard','Aden','a_guard_MElf',8.00,23.50,66,'male','L2SiegeGuard','SiegeGuardFighter',80,35465,7.500,5415,2.700,40,43,30,21,20,10,436,1,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5873,35253,'Guard','Aden','a_guard_MElf',8.00,23.50,66,'male','L2SiegeGuard','SiegeGuardFighter',40,35465,7.500,5415,2.700,40,43,30,21,20,10,436,1,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5874,35254,'Guard','Aden','a_guard_MElf',8.00,23.50,66,'male','L2SiegeGuard','SiegeGuardRanger',1100,35465,7.500,5415,2.700,40,43,30,21,20,10,436,1,7486,428,649,348,249,0,227,285,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(5875,35255,'Guard','Aden','a_guard_FDarkelf',8.00,25.00,66,'female','L2SiegeGuard','SiegeGuardFighter',80,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5876,35256,'Guard','Aden','a_guard_FDarkelf',8.00,25.00,66,'female','L2SiegeGuard','SiegeGuardFighter',40,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5877,35257,'Guard','Aden','a_guard_FDarkelf',8.00,25.00,66,'female','L2SiegeGuard','SiegeGuardRanger',1100,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5878,35258,'Guard','Aden','a_guard_MHuman',8.00,24.00,66,'male','L2SiegeGuard','SiegeGuardFighter',80,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5879,35259,'Guard','Aden','a_guard_MHuman',8.00,24.00,66,'male','L2SiegeGuard','SiegeGuardFighter',40,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5880,35260,'Guard','Aden','a_guard_MHuman',8.00,24.00,66,'male','L2SiegeGuard','SiegeGuardRanger',1100,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5881,35261,'Gatekeeper','Aden','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,3633,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5882,35262,'Gatekeeper','Aden','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,3633,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5883,35263,'Gatekeeper','Aden','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,3633,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5884,35264,'Gatekeeper','Aden','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,3633,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5885,35265,'Gatekeeper','Aden','a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter','npc',40,3633,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5886,35266,'Mass Gatekeeper','Aden','a_guard_MHuman',8.00,24.00,70,'male','L2CastleTeleporter','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5887,35267,'Outer Doorman','Aden','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5888,35268,'Inner Doorman','Aden','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5889,35269,'Hall Doorman','Aden','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5890,35270,'Inner Doorman','Aden','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5891,35271,'Gatekeeper','Aden','a_guard_MHuman',8.00,24.00,70,'male','L2CastleTeleporter','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5892,35272,'Blacksmith','Aden','a_guard_FDarkelf',8.00,25.00,66,'female','L2CastleBlacksmith','npc',80,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5893,35273,'Warehouse Keeper','Aden','a_guard_FDarkelf',8.00,25.00,66,'female','L2CastleWarehouse','npc',40,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5894,35274,'Logan','Chamberlain','a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5895,35275,'Kruger','Wyvern Manager','a_guard_MHuman',8.00,24.00,66,'male','L2WyvernManager','npc',80,35465,7.500,5415,2.700,40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5896,35276,'Eldon','Mercenary Manager','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5897,35277,'Manor Manager','Aden','a_guard_MHuman',8.00,24.00,66,'male','L2ManorManager','npc',1100,3862,7.500,5415,2.700,40,43,30,21,20,10,0,0,7486,428,649,0,0,0,227,0,0,0,50,120,'aden_siege_clan',1200,'SYS','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(5898,35278,'Messenger Ruford','Messenger','a_guard_MHuman',8.00,24.00,70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,135,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5899,35279,'Innadril Holy Artifact','','castle_kent_statue_jewel',25.00,98.00,20,'etc','L2Artefact','npc',40,541,2.500,213,1.200,40,43,30,21,20,10,0,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5900,35280,'Baron Lionel Hunter','','a_lord_MHuman',8.00,23.00,65,'male','L2SiegeGuard','SiegeGuardFighter',40,55449,7.500,3958,2.700,40,43,30,21,20,10,422,1,4308,418,619,340,278,0,253,79,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5901,35281,'Schaht','Sir','a_royal_guardA_MHuman',8.00,24.00,62,'male','L2SiegeGuard','SiegeGuardFighter',40,51515,7.500,3653,2.700,40,43,30,21,20,10,384,1,3777,388,532,315,278,0,253,142,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5902,35282,'Royal Knight','Innadril','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'innadrile_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',1,0),
(5903,35283,'Court Sorcerer','Innadril','a_royal_guardA_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5904,35284,'Court Sorcerer','Innadril','a_royal_guardA_MHuman',8.00,24.00,58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5905,35285,'Court Guard','Innadril','a_royal_guardB_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5906,35286,'Guard','Innadril','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5907,35287,'Guard','Innadril','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5908,35288,'Guard','Innadril','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(5909,35289,'Guard','Innadril','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5910,35290,'Guard','Innadril','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5911,35291,'Guard','Innadril','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5912,35292,'Guard','Innadril','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5913,35293,'Guard','Innadril','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5914,35294,'Guard','Innadril','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5915,35295,'Royal Knight','Innadril','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'innadrile_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',1,0),
(5916,35296,'Court Sorcerer','Innadril','a_royal_guardA_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5917,35297,'Court Sorcerer','Innadril','a_royal_guardA_MHuman',8.00,24.00,58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5918,35298,'Court Guard','Innadril','a_royal_guardB_MHuman',8.00,24.00,58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5919,35299,'Guard','Innadril','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5920,35300,'Guard','Innadril','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5921,35301,'Guard','Innadril','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(5922,35302,'Guard','Innadril','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5923,35303,'Guard','Innadril','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5924,35304,'Guard','Innadril','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5925,35305,'Guard','Innadril','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5926,35306,'Guard','Innadril','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5927,35307,'Guard','Innadril','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5928,35308,'Gatekeeper','Innadril','a_guard_MHuman',8.00,24.00,70,'male','L2CastleTeleporter','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5929,35309,'Gatekeeper','Innadril','a_guard_MHuman',8.00,24.00,70,'male','L2CastleTeleporter','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5930,35310,'Gatekeeper','Innadril','a_guard_MHuman',8.00,24.00,70,'male','L2CastleTeleporter','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5931,35311,'Mass Gatekeeper','Innadril','a_guard_MHuman',8.00,24.00,70,'male','L2CastleTeleporter','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5932,35312,'Outer Doorman','Innadril','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5933,35313,'Inner Doorman','Innadril','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5934,35314,'Blacksmith','Innadril','a_smith_MDwarf',7.00,16.50,70,'male','L2CastleBlacksmith','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5935,35315,'Warehouse Keeper','Innadril','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2CastleWarehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5936,35316,'Neurath','Chamberlain','a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5937,35317,'Tate','Wyvern Manager','a_traderB_MHuman',8.00,24.50,70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5938,35318,'Solinus','Mercenary Manager','a_common_peopleA_MHuman',8.00,21.50,70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5939,35319,'Manor Manager','Innadril','a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5940,35320,'Raybell','Sir','a_guard_MHuman',8.00,24.00,70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,74,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(5941,35322,'Altar of Fire','','godad_holything',24.00,65.00,20,'etc','L2Artefact','npc',40,558,1.200,213,1.200,40,43,30,21,20,10,0,0,57,97,23,79,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5942,35323,'Altar of Water','','godad_holything',24.00,65.00,20,'etc','L2Artefact','npc',40,558,1.200,213,1.200,40,43,30,21,20,10,0,0,57,97,23,79,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5943,35324,'Heinz','Royal Guard Captain','teleport_cube',30.00,65.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(5944,35325,'Duke Mora Ken Abygail','','a_lord_MHuman',8.00,23.00,65,'male','L2SiegeGuard','SiegeGuardFighter',40,55449,7.500,3958,2.700,40,43,30,21,20,10,422,1,4308,418,619,340,278,0,253,79,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5945,35326,'Royal Knight','Goddard','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'godad_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',1,0),
(5946,35327,'Court Sorcerer','Goddard','a_patriarch_MElf',8.00,22.50,58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5947,35328,'Court Sorcerer','Goddard','a_mageguild_master_FHuman',8.00,23.00,58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5948,35329,'Guard','Goddard','e_elmore_guard_Mhuman',8.00,23.50,58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,0,0,1562,349,428,284,237,0,216,1376,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5949,35330,'Bodyguard','Goddard','e_guard_MDwarf',8.00,19.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5950,35331,'Bodyguard','Goddard','e_guard_MDwarf',8.00,19.00,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5951,35332,'Bodyguard','Goddard','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5952,35333,'Bodyguard','Goddard','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5953,35334,'Bodyguard','Goddard','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5954,35335,'Bodyguard','Goddard','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5955,35336,'Bodyguard','Goddard','e_guard_MOrc',8.00,27.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5956,35337,'Bodyguard','Goddard','e_guard_MOrc',8.00,27.00,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5957,35338,'Bodyguard','Goddard','a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,280,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5958,35339,'Royal Knight','Goddard','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'godad_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',1,0),
(5959,35340,'Court Sorcerer','Goddard','a_patriarch_MElf',8.00,22.50,58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5960,35341,'Court Sorcerer','Goddard','a_mageguild_master_FHuman',8.00,23.00,58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',1,0),
(5961,35342,'Guard','Goddard','e_elmore_guard_Mhuman',8.00,23.50,58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,0,0,1562,349,428,284,237,0,216,1376,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5962,35343,'Bodyguard','Goddard','e_guard_MDwarf',8.00,19.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',1,0),
(5963,35344,'Bodyguard','Goddard','e_guard_MDwarf',8.00,19.00,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5964,35345,'Bodyguard','Goddard','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5965,35346,'Bodyguard','Goddard','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5966,35347,'Bodyguard','Goddard','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5967,35348,'Bodyguard','Goddard','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',0,0),
(5968,35349,'Bodyguard','Goddard','e_guard_MOrc',8.00,27.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(5969,35350,'Bodyguard','Goddard','e_elmore_guard_Mhuman',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,76,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5970,35351,'Bodyguard','Goddard','e_elmore_guard_Mhuman',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,6.500,3059,2.400,40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,280,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,0.60,'false',1,0),
(5971,35352,'Gatekeeper','Goddard','e_elmore_guard_Mhuman',8.00,23.50,56,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,120,'godad_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5972,35353,'Gatekeeper','Goddard','e_elmore_guard_Mhuman',8.00,23.50,56,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,120,'godad_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5973,35354,'Gatekeeper','Goddard','e_elmore_guard_Mhuman',8.00,23.50,56,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,120,'godad_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(5974,35355,'Mass Gatekeeper','Goddard','e_elmore_guard_Mhuman',8.00,23.50,56,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5975,35356,'Outer Doorman','Goddard','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5976,35357,'Inner Doorman','Goddard','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5977,35358,'Inner Doorman','Goddard','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5978,35359,'Gatekeeper','Goddard','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleTeleporter','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5979,35360,'Gatekeeper','Goddard','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleTeleporter','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5980,35361,'Blacksmith','Goddard','a_smith_MDwarf',7.00,16.50,70,'male','L2CastleBlacksmith','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5981,35362,'Warehouse Keeper','Goddard','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2CastleWarehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5982,35363,'Alfred','Chamberlain','a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(5983,35364,'Hadley','Wyvern Manager','a_common_peopleC_Mhuman',8.00,23.50,70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5984,35365,'Rowell','Manager of Mercenary','a_common_peopleC_Mhuman',8.00,23.50,70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5985,35366,'Manor Manager','Goddard','a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5986,35367,'Daven','Messenger','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,74,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(5987,35368,'Bloody Lord Nurka','','oel_mahum',20.00,37.00,55,'male','L2SiegeBoss','Fighter',40,1264000,40.000,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,282,0,257,72,0,0,70,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,0.48,'true',1,0),
(5988,35369,'Partisan Healer','','batur_orc_shaman',11.00,16.00,40,'male','L2SiegeMonster','Priest',40,1527,4.500,531,5.000,40,43,30,21,20,10,0,0,273,201,131,164,282,0,257,7,0,0,50,120,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,0.30,'true',1,0),
(5989,35370,'Partisan Court Guard','','ol_mahum_champion',14.00,27.00,40,'male','L2SiegeMonster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,273,201,131,164,282,0,257,69,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,0.63,'true',1,0),
(5990,35371,'Partisan Court Guard','','ol_mahum_archer',14.00,25.00,40,'male','L2SiegeMonster','Ranger',1100,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,333,201,131,164,254,0,231,14,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,1500,0,0.93,'true',1,0),
(5991,35372,'Partisan Soldier','','ol_mahum',13.50,25.00,35,'male','L2SiegeMonster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,282,0,257,2,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,0.46,'true',1,0),
(5992,35373,'Partisan Sorcerer','','batur_orc_shaman',11.00,16.00,35,'male','L2SiegeMonster','Mystic',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,282,0,257,7,0,0,50,120,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,0.30,'true',1,0),
(5993,35374,'Partisan Archer','','ol_mahum_archer',14.00,25.00,35,'male','L2SiegeMonster','Ranger',1100,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,427,169,89,137,254,0,231,14,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,1500,0,0.93,'true',1,0),
(5994,35375,'Bloody Lord Nurka','','oel_mahum',20.00,37.00,55,'male','L2Monster','Fighter',40,1264000,60.000,987,2.400,40,43,30,21,20,10,0,0,670,322,360,261,282,0,257,72,0,0,70,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,0.48,'true',0,0),
(5995,35376,'Partisan Healer','','batur_orc_shaman',11.00,16.00,40,'male','L2Monster','Priest',40,1527,4.500,531,5.000,40,43,30,21,20,10,0,0,273,201,131,164,282,0,257,7,0,0,50,120,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,0.30,'true',0,0),
(5996,35377,'Partisan Court Guard','','ol_mahum_champion',14.00,27.00,40,'male','L2Monster','Fighter',40,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,273,201,131,164,282,0,257,69,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,0.63,'true',0,0),
(5997,35378,'Partisan Court Guard','','ol_mahum_archer',14.00,25.00,40,'male','L2Monster','Ranger',1100,1527,4.500,531,1.800,40,43,30,21,20,10,0,0,333,201,131,164,254,0,231,14,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,1500,0,0.93,'true',0,0),
(5998,35379,'Partisan Soldier','','ol_mahum',13.50,25.00,35,'male','L2Monster','Fighter',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,282,0,257,2,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,0.46,'true',0,0),
(5999,35380,'Partisan Sorcerer','','batur_orc_shaman',11.00,16.00,35,'male','L2Monster','Mystic',40,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,192,169,89,137,282,0,257,7,0,0,50,120,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,0.30,'true',0,0),
(6000,35381,'Partisan Archer','','ol_mahum_archer',14.00,25.00,35,'male','L2Monster','Ranger',1100,1220,4.500,446,1.800,40,43,30,21,20,10,0,0,235,169,89,137,254,0,231,14,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,1500,0,0.93,'true',0,0),
(6001,35382,'Brakel','Partisan Herald','ol_mahum_champion',14.00,27.00,70,'male','L2SiegeMessenger','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.63,'false',1,0),
(6002,35383,'Tamutak','Ol Mahum Steward','ol_mahum_champion',14.00,27.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.63,'false',1,0),
(6003,35384,'Black','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6004,35385,'Renny','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,4.500,414,1.800,40,43,30,21,20,10,0,0,171,162,75,128,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,0.56,'false',1,0),
(6005,35386,'Boyer','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6006,35387,'Baback','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,4.500,514,1.800,40,43,30,21,20,10,0,0,263,201,121,158,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,0.56,'false',1,0),
(6007,35388,'Tim','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6008,35389,'Loring','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,5.500,618,2.100,40,43,30,21,20,10,0,0,343,230,163,181,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,0.56,'false',1,0),
(6009,35390,'Dillon','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6010,35391,'Latif','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,5.500,738,2.100,40,43,30,21,20,10,0,0,440,262,216,206,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,0.56,'false',1,0),
(6011,35392,'Bremmer','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6012,35393,'Faolan','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,6.500,892,2.400,40,43,30,21,20,10,0,0,588,304,300,239,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,0.56,'false',1,0),
(6013,35394,'Kalis','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6014,35395,'Kogan','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,3.500,242,1.500,40,43,30,21,20,10,0,0,71,106,28,83,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,0.56,'false',1,0),
(6015,35396,'Winker','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6016,35397,'Merton','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,3.500,318,1.500,40,43,30,21,20,10,0,0,107,129,45,102,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,0.56,'false',1,0),
(6017,35398,'Ruben','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6018,35399,'Luce','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,4.500,381,1.800,40,43,30,21,20,10,0,0,147,151,64,118,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,0.56,'false',1,0),
(6019,35400,'Horner','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6020,35401,'Amiel','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,4.500,414,1.800,40,43,30,21,20,10,0,0,171,162,75,128,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,0.56,'false',1,0),
(6021,35402,'Borna','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,4.500,446,1.800,40,43,30,21,20,10,0,0,198,175,89,137,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,0.56,'false',1,0),
(6022,35403,'Ron','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6023,35404,'Jamal','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,5.500,589,2.100,40,43,30,21,20,10,0,0,321,222,152,175,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,0.56,'false',1,0),
(6024,35405,'Flynn','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6025,35406,'Jabilo','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,5.500,677,2.100,40,43,30,21,20,10,0,0,389,245,188,193,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,0.56,'false',1,0),
(6026,35407,'Seth','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6027,35408,'Dietrich','','headless_knight',21.00,31.00,67,'male','L2SiegeBoss','CHSiegeMonsterFighter',40,16388,7.500,2777,2.700,60,57,73,76,70,80,0,0,3548,438,1510,356,333,0,2362,0,0,0,70,180,'',0,'Local','',0,0,0,1,30,4,40,0,-18,0.52,'false',0,0),
(6028,35409,'Mikhail','','headless_knight',21.00,31.00,67,'male','L2SiegeBoss','CHSiegeMonsterFighter',40,16388,7.500,2777,2.700,60,57,73,76,70,80,0,0,3548,438,1510,356,333,0,2362,0,0,0,70,180,'',0,'Local','',0,0,0,1,30,4,40,0,-18,0.52,'false',0,0),
(6029,35410,'Gustav','','headless_knight',21.00,31.00,70,'male','L2SiegeBoss','CHSiegeMonsterFighter',40,8092000,7.500,2987,2.700,60,57,73,76,70,80,0,0,3987,469,1732,381,333,0,2362,0,0,0,70,180,'',0,'Local','',0,0,0,1,30,4,40,0,-18,0.52,'false',0,0),
(6030,35411,'Doom Servant','','hungry_spirit',13.00,40.00,65,'male','L2SiegeMonster','CHSiegeMonsterFighter',40,9571,7.500,1150,2.700,40,43,30,21,20,10,0,0,2151,417,617,338,278,150,253,0,0,0,15,120,'gustav_clan',1000,'Local','',0,0,0,7,50,1,40,0,0,0.45,'true',0,0),
(6031,35412,'Doom Guard','','hungry_spirit',13.00,40.00,66,'male','L2SiegeMonster','CHSiegeMonsterFighter',50,10639,7.500,1184,2.700,40,43,30,21,20,10,0,0,2243,427,649,347,278,0,253,0,0,0,15,120,'gustav_clan',1000,'Local','',0,0,0,7,50,1,40,0,0,0.45,'true',0,0),
(6032,35413,'Doom Archer','','skeleton_archer',11.00,27.00,67,'male','L2SiegeMonster','CHSiegeMonsterRanger',1100,10879,7.500,1217,2.700,40,43,30,21,20,10,0,0,5191,438,680,356,249,0,227,286,0,0,40,140,'gustav_clan',700,'Local','',0,0,0,7,10,8,40,1500,0,0.80,'true',0,0),
(6033,35414,'Doom Trooper','','skeleton_pikeman',10.00,28.00,68,'male','L2SiegeMonster','CHSiegeMonsterFighter',80,11118,7.500,1251,2.700,40,43,30,21,20,10,0,0,2839,449,713,364,238,0,217,301,0,0,50,155,'gustav_clan',1000,'Local','',0,0,0,7,30,4,40,0,0,0.21,'true',0,0),
(6034,35415,'Doom Warrior','','skeleton_knight',10.00,25.00,69,'male','L2SiegeMonster','CHSiegeMonsterFighter',40,11353,7.500,1285,2.700,40,43,30,21,20,10,0,0,2529,459,745,373,317,150,289,71,0,0,40,160,'gustav_clan',1000,'Local','',0,0,0,7,10,8,40,0,0,0.17,'true',0,0),
(6035,35416,'Doom Knight','','death_blader',15.00,45.00,70,'male','L2SiegeMonster','CHSiegeMonsterFighter',40,11586,7.500,1319,2.700,40,43,30,21,20,10,0,0,2297,469,779,381,278,150,253,1472,0,0,100,170,'gustav_clan',1000,'Local','',0,0,0,7,30,4,40,0,0,0.45,'true',0,0),
(6036,35417,'Doorman of Hell','','dwarf_ghost',10.00,18.70,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.48,'false',1,0),
(6037,35418,'Doorman of Hell','','dwarf_ghost',10.00,18.70,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.48,'false',1,0),
(6038,35419,'Hephaeston','Wyvern Manager','human_ghost',8.00,22.00,70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6039,35420,'Loken','Messenger','human_ghost',8.00,22.00,70,'male','L2SiegeMessenger','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,74,0,0,80,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.39,'false',1,0),
(6040,35421,'Biggerstaff','Steward','elf_ghost',7.00,21.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.41,'true',1,0),
(6041,35422,'Flag of Winner','','azit_a',100.00,72.00,56,'etc','L2Deco','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6042,35423,'Red Flag','','azit_b',75.00,55.00,56,'etc','L2Deco','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6043,35424,'Yellow Flag','','azit_b',75.00,55.00,56,'etc','L2Deco','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6044,35425,'Green Flag','','azit_b',75.00,55.00,56,'etc','L2Deco','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6045,35426,'Blue Flag','','azit_b',75.00,55.00,56,'etc','L2Deco','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6046,35427,'Purple Flag','','azit_b',75.00,55.00,56,'etc','L2Deco','npc',40,2725,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6047,35428,'Oel Mahum Berserker','','oel_mahum_warrior',20.00,38.00,60,'male','L2Monster','Fighter',40,125202,196.000,3420,10.000,60,57,73,76,70,80,0,0,680,1476,5200,598,333,0,2362,0,0,0,70,140,'',0,'Local','',0,0,0,7,30,4,40,0,-18,0.65,'true',1,0),
(6048,35429,'Oel Mahum Scout','','oel_mahum_warrior',20.00,38.00,60,'male','L2Monster','Fighter',40,56341,196.000,3420,10.000,60,57,73,76,70,80,0,0,680,1476,5200,598,333,0,2362,0,0,0,70,140,'',0,'Local','',0,0,0,7,30,4,40,0,-18,0.65,'true',1,0),
(6049,35430,'Oel Mahum Leader','','oel_mahum_witch_doctor',15.00,34.00,60,'male','L2Monster','Fighter',40,62601,196.000,3420,10.000,60,57,73,76,70,80,0,0,680,2953,5200,299,333,0,2362,0,0,0,70,140,'',0,'Local','',0,0,0,7,30,4,40,0,-18,0.26,'true',1,0),
(6050,35431,'Oel Mahum Cleric','','oel_mahum_witch_doctor',15.00,34.00,60,'male','L2Monster','Priest',40,62601,196.000,3420,10.000,60,57,73,76,70,80,0,0,680,738,5200,1197,333,0,2362,0,0,0,70,140,'',0,'Local','',0,0,0,7,30,4,40,0,-18,0.26,'true',1,0),
(6051,35432,'Oel Mahum Thief','','oel_mahum_40_sm',12.00,19.00,60,'male','L2Monster','Fighter',40,50080,156.800,3420,10.000,60,57,73,76,70,80,0,0,544,1181,5200,538,333,0,2362,0,0,0,70,140,'',0,'Local','',0,0,0,7,30,4,40,0,-18,0.48,'true',1,0),
(6052,35433,'Inner Doorman','','oel_mahum',20.00,37.00,70,'male','L2Npc','npc',40,5149,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.48,'false',1,0),
(6053,35434,'Inner Doorman','','oel_mahum',20.00,37.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.48,'false',1,0),
(6054,35435,'Outer Doorman','','oel_mahum',20.00,37.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.48,'false',1,0),
(6055,35436,'Outer Doorman','','oel_mahum',20.00,37.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.48,'false',1,0),
(6056,35437,'Messenger','','oel_mahum',20.00,37.00,56,'male','L2Npc','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,70,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.48,'false',1,0),
(6057,35438,'Chamberlain','','oel_mahum',20.00,37.00,56,'male','L2ClanHallManager','npc',40,2724,6.500,152641,300.000,40,43,30,21,20,10,0,0,706,331,382,268,282,0,2530,0,0,0,70,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,0.48,'false',1,0),
(6058,35439,'Carey','Clan Hall Manager','a_maidB_FHuman',8.00,22.50,70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6059,35440,'Daniel','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6060,35441,'Dianne','Clan Hall Manager','a_maidA_FHuman',8.00,20.50,70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6061,35442,'Jacques','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6062,35443,'Crissy','Clan Hall Manager','a_common_peopleB_FHuman',8.00,20.50,70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6063,35444,'Joff','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6064,35445,'Albert','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6065,35446,'Niels','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6066,35447,'Korgen','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6067,35448,'Rudy','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6068,35449,'DiMaggio','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6069,35450,'Gellar','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6070,35451,'Emma','Clan Hall Manager','a_common_peopleB_FHuman',8.00,20.50,70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6071,35452,'Theobolt','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6072,35453,'Adrienne','Clan Hall Manager','a_maidA_FHuman',8.00,20.50,70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6073,35454,'Rosconne','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6074,35455,'Bianca','Clan Hall Manager','a_maidB_FHuman',8.00,22.50,70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6075,35456,'Stewart','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6076,35457,'Gladys','Clan Hall Manager','a_maidA_FHuman',8.00,20.50,70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6077,35458,'Theron','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6078,35459,'Regina','Clan Hall Manager','a_maidB_FHuman',8.00,22.50,70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6079,35460,'Trey','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6080,35461,'Aida','Clan Hall Manager','a_traderC_Fhuman',7.00,21.50,70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6081,35462,'Kalmer','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6082,35463,'Helga','Clan Hall Manager','a_common_peopleB_FHuman',8.00,20.50,70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6083,35464,'Volfrem','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6084,35465,'Millicent','Clan Hall Manager','a_common_peopleB_FHuman',8.00,20.50,70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6085,35466,'Gerard','Clan Hall Gatekeeper','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6086,35467,'Branhillde','Clan Hall Manager','a_traderC_Fhuman',7.00,21.50,70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6087,35468,'Lambert','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6088,35469,'Gods'' Altar','','rune_holything',46.00,72.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6089,35470,'Astair van Halter','King','a_lord_MHuman',8.00,23.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6090,35471,'Royal Knight','Rune','a_royal_guardA_MHuman',8.00,24.00,68,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'rune_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',0,0),
(6091,35472,'Court Sorcerer','Rune','a_patriarch_MElf',8.00,22.50,68,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(6092,35473,'Court Sorcerer','Rune','a_mageguild_master_FHuman',8.00,23.00,68,'female','L2SiegeGuard','Mystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(6093,35474,'Court Guard','Rune','e_elmore_guard_Mhuman',8.00,23.50,66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6094,35475,'Guard','Rune','e_guard_MDwarf',8.00,19.00,66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6095,35476,'Guard','Rune','e_guard_MDwarf',8.00,19.00,66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6096,35477,'Guard','Rune','a_guard_MElf',8.00,23.50,66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6097,35478,'Guard','Rune','a_guard_FDarkelf',8.00,25.00,66,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6098,35479,'Guard','Rune','a_guard_FDarkelf',8.00,25.00,66,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6099,35480,'Guard','Rune','a_guard_FDarkelf',8.00,25.00,66,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6100,35481,'Guard','Rune','e_guard_MOrc',8.00,27.00,66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6101,35482,'Guard','Rune','e_guard_MOrc',8.00,27.00,66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6102,35483,'Guard','Rune','a_guard_MHuman',8.00,24.00,66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6103,35484,'Royal Knight','Rune','a_royal_guardA_MHuman',8.00,24.00,68,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'rune_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',0,0),
(6104,35485,'Court Sorcerer','Rune','a_patriarch_MElf',8.00,22.50,68,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(6105,35486,'Court Sorcerer','Rune','a_mageguild_master_FHuman',8.00,23.00,68,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(6106,35487,'Court Guard','Rune','e_elmore_guard_Mhuman',8.00,23.50,68,'male','L2SiegeGuard','SiegeGuardFighter',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(6107,35488,'Guard','Rune','e_guard_MDwarf',8.00,19.00,66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6108,35489,'Guard','Rune','e_guard_MDwarf',8.00,19.00,66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6109,35490,'Guard','Rune','a_guard_MElf',8.00,23.50,66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6110,35491,'Guard','Rune','a_guard_FDarkelf',8.00,25.00,66,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6111,35492,'Guard','Rune','a_guard_FDarkelf',8.00,25.00,66,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6112,35493,'Guard','Rune','a_guard_FDarkelf',8.00,25.00,66,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6113,35494,'Guard','Rune','e_guard_MOrc',8.00,27.00,66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6114,35495,'Guard','Rune','e_elmore_guard_Mhuman',8.00,23.50,66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6115,35496,'Guard','Rune','e_elmore_guard_Mhuman',8.00,23.50,66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6116,35497,'Gatekeeper','Rune','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6117,35498,'Gatekeeper','Rune','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6118,35499,'Gatekeeper','Rune','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6119,35500,'Gatekeeper','Rune','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6120,35501,'Gatekeeper','Rune','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6121,35502,'Group Gatekeeper','Rune','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6122,35503,'Outer Doorman','Rune','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6123,35504,'Inner Doorman','Rune','e_elmore_guard_Mhuman',8.00,23.50,0,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6124,35505,'Inner Doorman','Rune','e_elmore_guard_Mhuman',8.00,23.50,0,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6125,35506,'Dungeon Gatekeeper','Rune','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Merchant','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6126,35507,'Blacksmith','Rune','a_smith_MDwarf',7.00,16.50,70,'male','L2CastleBlacksmith','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6127,35508,'Warehouse Keeper','Rune','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2CastleWarehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6128,35509,'Frederick','Chamberlain','a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6129,35510,'Titus','Wyvern Manager','a_fighterguild_teacher_MHuman',8.00,17.00,70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6130,35511,'Gompus','Mercenary Manager','a_common_peopleC_Mhuman',8.00,23.50,70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6131,35512,'Manor Manager','Rune','a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6132,35513,'Sherman','Messenger','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,135,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6133,35514,'Altar of Wind','','godad_holything',24.00,65.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6134,35515,'Altar of Earth','','godad_holything',24.00,65.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6135,35516,'Verus','Royal Guard Captain','big_boom',6.00,13.00,60,'male','L2Pet','npc',40,51515,6.500,1327,2.400,40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6136,35517,'Swain Ken Orwen','Count','a_lord_MHuman',8.00,23.00,65,'male','L2SiegeGuard','SiegeGuardRanger',900,3862,7.500,2987,2.700,60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,750,0,0.60,'false',0,0),
(6137,35518,'Royal Knight','Schuttgart','a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,6.500,3452,2.400,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,0.60,'false',0,0),
(6138,35519,'Court Sorcerer','Schuttgart','a_patriarch_MElf',8.00,22.50,58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(6139,35520,'Court Sorcerer','Schuttgart','a_mageguild_master_FHuman',8.00,23.00,58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,0.60,'false',0,0),
(6140,35521,'Court Guard','Schuttgart','e_elmore_guard_Mhuman',8.00,23.50,58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,6.500,3254,2.400,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6141,35522,'Guard','Schuttgart','e_guard_MDwarf',8.00,19.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6142,35523,'Guard','Schuttgart','e_guard_MDwarf',8.00,19.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6143,35524,'Guard','Schuttgart','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6144,35525,'Guard','Schuttgart','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(6145,35526,'Guard','Schuttgart','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6146,35527,'Guard','Schuttgart','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6147,35528,'Guard','Schuttgart','e_guard_MOrc',8.00,27.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6148,35529,'Guard','Schuttgart','silver_cat',7.00,15.00,42,'male','L2SiegeGuard','SiegeGuardFighter',40,1992,5.500,679,2.100,40,43,30,21,20,25,0,0,374,215,152,202,278,0,253,0,0,0,48,180,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(6149,35530,'Guard','Schuttgart','blue_eye',11.00,16.00,42,'male','L2SiegeGuard','SiegeGuardFighter',40,1992,5.500,679,2.100,40,43,30,21,20,25,0,0,374,215,152,202,278,0,253,0,0,0,48,180,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(6150,35531,'Royal Knight','Schuttgart','shadeless',7.00,28.00,42,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,5.500,679,2.100,40,43,30,21,20,25,0,0,374,215,152,202,278,0,253,0,0,0,48,180,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(6151,35532,'Court Sorcerer','Schuttgart','headless_knight',21.00,22.50,67,'male','L2SiegeGuard','SiegeGuardMystic',900,23114,7.500,2777,2.700,60,57,73,76,70,80,0,0,3548,438,1510,356,333,0,2362,0,0,0,70,180,'',0,'Local','',0,0,0,1,30,4,40,0,-18,0.52,'false',0,0),
(6152,35533,'Court Sorcerer','Schuttgart','headless_knight',21.00,22.50,67,'male','L2SiegeGuard','SiegeGuardMystic',900,23114,7.500,2777,2.700,60,57,73,76,70,80,0,0,3548,438,1510,356,333,0,2362,0,0,0,70,180,'',0,'Local','',0,0,0,1,30,4,40,0,-18,0.52,'false',0,0),
(6153,35534,'Court Guard','Schuttgart','headless_knight',21.00,31.00,70,'male','L2SiegeGuard','SiegeGuardFighter',40,8092000,7.500,2987,2.700,60,57,73,76,70,80,0,0,3987,469,1732,381,333,0,2362,0,0,0,70,180,'',0,'Local','',0,0,0,1,30,4,40,0,-18,0.52,'false',0,0),
(6154,35535,'Guard','Schuttgart','e_guard_MDwarf',8.00,19.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,93,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6155,35536,'Guard','Schuttgart','e_guard_MDwarf',8.00,19.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,2,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6156,35537,'Guard','Schuttgart','a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,14,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6157,35538,'Guard','Schuttgart','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6158,35539,'Guard','Schuttgart','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,2,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6159,35540,'Guard','Schuttgart','a_guard_FDarkelf',8.00,25.00,56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,14,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6160,35541,'Guard','Schuttgart','e_guard_MOrc',8.00,27.00,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6161,35542,'Guard','Schuttgart','e_elmore_guard_Mhuman',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,76,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6162,35543,'Guard','Schuttgart','e_elmore_guard_Mhuman',8.00,23.50,56,'male','L2SiegeGuard','SiegeGuardRanger',900,21799,6.500,3059,2.400,40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,280,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,0.60,'false',0,0),
(6163,35544,'Gatekeeper','Schuttgart','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'schuttgart_siege_clan',600,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6164,35545,'Gatekeeper','Schuttgart','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleTeleporter','npc',40,2724,6.500,1019,2.400,40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'schuttgart_siege_clan',600,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6165,35546,'Gatekeeper','Schuttgart','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleTeleporter','npc',40,5817,7.500,2987,2.700,60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,290,0,0,0,50,160,'',0,'Magister','',0,0,0,7,30,4,4,750,0,0.60,'false',0,0),
(6166,35547,'Group Gatekeeper','Schuttgart','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleTeleporter','npc',40,2724,7.500,2987,2.700,60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,'Magister','',35547,0,0,7,30,4,4,750,0,0.60,'false',1,0),
(6167,35548,'Outer Doorman','Schuttgart','e_elmore_guard_Mhuman',8.00,23.50,70,'female','L2CastleDoormen','npc',40,3862,7.500,2987,2.700,60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,'Magister','',0,0,0,7,30,4,4,750,0,0.60,'false',1,0),
(6168,35549,'Inner Doorman','Schuttgart','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleDoormen','npc',40,3862,7.500,2987,2.700,60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,'Magister','',0,0,0,7,30,4,4,750,0,0.60,'false',1,0),
(6169,35550,'Inner Doorman','Schuttgart','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleDoormen','npc',40,3862,7.500,2987,2.700,60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,'Magister','',0,0,0,7,30,4,4,750,0,0.60,'false',1,0),
(6170,35551,'Doorman','Schuttgart','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6171,35552,'Doorman','Schuttgart','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6172,35553,'Blacksmith','Schuttgart','a_smith_MDwarf',7.00,16.50,70,'male','L2CastleBlacksmith','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6173,35554,'Warehouse Keeper','Schuttgart','a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2CastleWarehouse','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6174,35555,'August','Chamberlain','a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6175,35556,'Gallic','Wyvern Manager','a_common_peopleC_Mhuman',8.00,23.50,70,'male','L2WyvernManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6176,35557,'Kendrew','Mercenary Manager','a_common_peopleC_Mhuman',8.00,23.50,70,'male','L2MercManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6177,35558,'Manor Manager','Schuttgart','a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6178,35559,'Daguerre','Messenger','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6179,35560,'Mass Gatekeeper','','oel_mahum',20.00,37.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6180,35561,'Mass Gatekeeper','','oel_mahum',20.00,37.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6181,35562,'Mass Gatekeeper','','oel_mahum',20.00,37.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6182,35563,'Mass Gatekeeper','','oel_mahum',20.00,37.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6183,35564,'Mass Gatekeeper','','oel_mahum',20.00,37.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6184,35565,'Mass Gatekeeper','','oel_mahum',20.00,37.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6185,35566,'Ronald','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6186,35567,'Emil','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6187,35568,'Wayne','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6188,35569,'Daniel','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6189,35570,'Patty','Clan Hall Manager','a_traderC_Fhuman',7.00,21.50,70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6190,35571,'Dale','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6191,35572,'Jimmy','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6192,35573,'Shawn','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6193,35574,'Michael','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6194,35575,'Ryan','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6195,35576,'Jack','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6196,35577,'Harry','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6197,35578,'Karuto','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6198,35579,'Egon','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6199,35580,'Carol','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6200,35581,'Osho','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6201,35582,'Stanley','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6202,35583,'Walter','Clan Hall Gatekeeper','a_common_peopleB_MHuman',8.00,22.00,70,'male','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6203,35584,'Billy','Clan Hall Manager','a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6204,35585,'Alice','Clan Hall Gatekeeper','a_traderC_Fhuman',7.00,21.50,70,'female','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6205,35586,'Serena','Clan Hall Manager','a_maidA_FHuman',8.00,20.50,70,'female','L2ClanHallManager','npc',40,3862,7.500,152641,300.000,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6206,35587,'Neria','Clan Hall Gatekeeper','a_traderC_Fhuman',7.00,21.50,70,'female','L2ClanHallDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6207,35588,'Hot Springs Gourd','','drop_gourd_50_bi',30.00,31.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6208,35589,'Hot Springs Gourd','','drop_gourd_50_bi',30.00,31.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6209,35590,'Hot Springs Gourd','','drop_gourd_50_bi',30.00,31.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6210,35591,'Hot Springs Gourd','','drop_gourd_50_bi',30.00,31.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6211,35592,'Enraged Yeti','','yeti',15.00,27.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6212,35593,'Treasure Chest','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6213,35594,'Treasure Chest','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6214,35595,'Treasure Chest','','mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6215,35596,'Hot Springs Yeti','Maitre ''D','yeti_cute',5.00,10.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6216,35597,'Hot Springs Yeti','Maitre ''D','yeti_cute',5.00,10.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6217,35598,'Hot Springs Yeti','Maitre ''D','yeti_cute',5.00,10.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6218,35599,'Hot Springs Yeti','Maitre ''D','yeti_cute',5.00,10.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6219,35600,'Manager','','yeti_cute',5.00,10.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6220,35601,'Doorman','','yeti_cute',5.00,10.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6221,35602,'Doorman','','yeti_cute',5.00,10.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6222,35603,'Coordinator','','yeti',15.00,27.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6223,35604,'Messenger','','yeti_cute',5.00,10.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6224,35605,'Angout','Steward','yeti',15.00,27.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6225,35606,'Victor''s Flag','','azit_contest_pile_winner',63.50,97.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6226,35607,'Red Flag','','azit_contest_pile_a',52.00,195.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6227,35608,'Yellow Flag','','azit_contest_pile_b',51.80,108.25,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6228,35609,'Green Flag','','azit_contest_pile_c',51.80,108.25,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6229,35610,'Blue Flag','','azit_contest_pile_d',51.80,108.25,56,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6230,35611,'Purple Flag','','azit_contest_pile_e',51.80,108.25,56,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6231,35612,'Group Gatekeeper','','kel_mahum',13.00,26.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6232,35613,'Group Gatekeeper','','kel_mahum',13.00,26.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6233,35614,'Group Gatekeeper','','kel_mahum',13.00,26.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6234,35615,'Group Gatekeeper','','kel_mahum',13.00,26.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6235,35616,'Group Gatekeeper','','kel_mahum',13.00,26.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6236,35617,'Group Gatekeeper','','kel_mahum',13.00,26.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6237,35618,'Frenzied Cougar','','saber_toothed_tiger',28.00,0.00,60,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6238,35619,'Frenzied Buffalo','','buffalo',22.00,31.00,60,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6239,35620,'Frenzied Kookaburra','','rough_ostrich',10.00,33.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6240,35621,'Frenzied Buffalo Baby','','baby_buffalo',12.00,15.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6241,35622,'Frenzied Baby Cougar','','baby_tiger',11.00,15.70,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6242,35623,'Inner Doorman','','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6243,35624,'Inner Doorman','','kel_mahum_champion',13.00,32.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6244,35625,'Outer Doorman','','a_guard_MHuman',8.00,24.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6245,35626,'Outer Doorman','','kel_mahum_champion',13.00,32.00,70,'male','L2CastleDoormen','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6246,35627,'Messenger','','kel_mahum_champion',13.00,32.00,56,'male','L2SiegeNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(6247,35628,'Quigby','Farm Manager','kel_mahum_champion',13.00,32.00,56,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(6248,35629,'Lidia von Hellmann','','lidia_von_helmann',10.00,25.40,73,'female','L2SiegeBoss','CHSiegeMonsterFighter',40,1869456,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6249,35630,'Alfred von Hellmann','','vampire_warrior',9.00,31.50,72,'male','L2SiegeBoss','CHSiegeMonsterFighter',40,11353,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6250,35631,'Giselle von Hellmann','','vampire_wizard',5.50,28.80,72,'male','L2SiegeBoss','CHSiegeMonsterFighter',40,11118,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6251,35632,'Vampire Adept','','vampire_witch',6.00,21.50,68,'male','L2Npc','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6252,35633,'Vampire Soldier','','vampire_soldier',8.00,23.50,68,'male','L2Npc','npc',40,10639,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6253,35634,'Vampire Caster','','vampire_witch',6.00,21.50,70,'male','L2Npc','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6254,35635,'Vampire Magister','','vampire_wizard',5.50,28.80,71,'male','L2Npc','npc',40,11118,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6255,35636,'Vampire Warlord','','vampire_warrior',9.00,31.50,72,'male','L2Npc','npc',40,11353,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6256,35637,'Vampire Leader','','vampire_lord',7.50,25.80,73,'male','L2Npc','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6257,35638,'Valens','Wyvern Manager','vampire_soldier',8.00,23.50,70,'male','L2WyvernManager','npc',40,10639,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6258,35639,'Jacquard','Messenger','vampire_soldier',8.00,23.50,70,'male','L2SiegeMessenger','npc',40,10639,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6259,35640,'Bandello','Steward','vampire_soldier',8.00,23.50,70,'male','L2Npc','npc',40,10639,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6260,35641,'Fortress Guard','','vampire_soldier',8.00,23.50,70,'male','L2Npc','npc',40,10639,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6261,35642,'Fortress Guard','','vampire_soldier',8.00,23.50,70,'male','L2Npc','npc',40,10639,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6262,35643,'Gate','','farm_hedge',184.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6263,35644,'Manor Manager','Schuttgart','a_traderA_MDwarf',9.50,22.50,70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6264,35645,'Manor Manager','Schuttgart','e_trader_MOrc',9.50,22.50,70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',1,0),
(6265,35646,'Vampire Caster','','vampire_witch',6.00,21.50,70,'male','L2Npc','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6266,35647,'Vampire Leader','','vampire_lord',7.50,25.80,73,'male','L2Npc','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6267,35648,'Court Magician','Gludio','Elite_Mage',6.50,21.96,70,'male','L2Npc','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6268,35649,'Court Magician','Dion','Elite_Mage',6.50,21.96,70,'male','L2Npc','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6269,35650,'Court Magician','Giran','Elite_Mage',6.50,21.96,70,'male','L2Npc','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6270,35651,'Court Magician','Oren','Elite_Mage',6.50,21.96,70,'male','L2Npc','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6271,35652,'Court Magician','Aden','Elite_Mage',6.50,21.96,70,'male','L2Npc','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6272,35653,'Court Magician','Innadril','Elite_Mage',6.50,21.96,70,'male','L2Npc','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6273,35654,'Court Magician','Goddard','Elite_Mage',6.50,21.96,70,'male','L2Npc','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6274,35655,'Court Magician','Rune','Elite_Mage',6.50,21.96,70,'male','L2Npc','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6275,35656,'Court Magician','Schuttgart','Elite_Mage',6.50,21.96,70,'male','L2Npc','npc',40,11586,7.500,1493,2.700,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(6276,35657,'Flagpole','','LineageNpcEV.Rune_holything',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6277,35658,'Foreman','Shanty Fortress','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6278,35659,'Suspicious Merchant','Shanty Fortress','LineageNPC.Guard_MOrc',8.00,27.00,1,'male','L2SiegeFortNpc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6279,35660,'Guard Captain','Shanty Fortress','LineageNPC2.Garrison_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6280,35661,'Archer Captain','Shanty Fortress','LineageNPC2.Archer_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6281,35662,'Support Unit Captain','Shanty Fortress','LineageNPC2.Mage_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6282,35663,'Engineering Manager','Shanty Fortress','LineageNPC.Guard_Dwarf',8.00,19.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6283,35664,'Logistics Officer','Shanty Fortress','LineageNPC.Collector_teacher',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6284,35665,'Supply Box','','LineageMonster.Mimic',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6285,35666,'Detention Camp Warden','Shanty Fortress','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6286,35667,'Doorman','','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6287,35668,'Doorman','','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6288,35669,'Doorman','','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6289,35670,'Rebel Commander','Shanty Fortress','LineageNPC2.Chief_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6290,35671,'Decorated Rebel Soldier','Shanty Fortress','LineageMonster.Shadow',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6291,35672,'Rebel Private','Shanty Fortress','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6292,35673,'Court Guard','Shanty Fortress','LineageNPC.Nugles_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6293,35674,'Guard','Shanty Fortress','LineageNPC.Melf_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6294,35675,'Power Control Unit','Control Room','LineageNpcEV.Strange_mechanical',16.00,15.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6295,35676,'Dwarven Gunnery Sergeant','','LineageNPC2.Bater',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6296,35677,'Guard Captain','Guard','LineageNPC2.Garris',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6297,35678,'Guard','Guard','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6298,35679,'Guard','Guard','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6299,35680,'Support Unit Captain','Support Unit','LineageNPC2.Mage_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6300,35681,'Wizard','Support Unit','LineageNPC.Patriarch_MElf',8.00,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6301,35682,'Healer','Support Unit','LineageNPC.Mage_master',8.00,23.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6302,35683,'Archer Captain','Archer','LineageNPC2.Archer_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6303,35684,'Archer','Archer','LineageNPC.Guard_MElf',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6304,35685,'Ballista','Shanty Fortress','LineageNpcEV.Ballista',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6305,35686,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6306,35687,'Mercenary Private','','LineageNPC.Guard_MOrc',8.00,27.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6307,35688,'Flagpole','','LineageNpcEV.Rune_holything',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6308,35689,'Foreman','Southern Gludio Fortress','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6309,35690,'Suspicious Merchant','Southern Gludio Fortress','LineageNPC.Guard_MOrc',8.00,27.00,1,'male','L2SiegeFortNpc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6310,35691,'Guard Captain','Southern Gludio Fortress','LineageNPC2.Garrison_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6311,35692,'Archer Captain','Southern Gludio Fortress','LineageNPC2.Archer_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6312,35693,'General','Southern Gludio Fortress','LineageNPC2.Officer_of_insurgents_orc',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(6313,35694,'Support Unit Captain','Southern Gludio Fortress','LineageNPC2.Mage_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6314,35695,'Engineering Manager','Southern Gludio Fortress','LineageNPC.Guard_Dwarf',8.00,19.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6315,35696,'Logistics Officer','Southern Gludio Fortress','LineageNPC.Collector_teacher',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6316,35697,'Supply Box','','LineageMonster.Mimic',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6317,35698,'Detention Camp Warden','Southern Gludio Fortress','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6318,35699,'Doorman','','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6319,35700,'Doorman','','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6320,35701,'Doorman','','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6321,35702,'Rebel Commander','Southern Gludio Fortress','LineageNPC2.Chief_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6322,35703,'Decorated Rebel Soldier','Southern Gludio Fortress','LineageMonster.Shadow',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6323,35704,'Rebel Private','Southern Gludio Fortress','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6324,35705,'Court Guard','Southern Gludio Fortress','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6325,35706,'Guard','Southern Gludio Fortress','LineageNPC.Guard_MElf',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6326,35707,'Main Machine','Control Room','LineageNpcEV.Machine_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6327,35708,'Backup Power Unit','Control Room','LineageNpcEV.Strange_mechanical',16.00,15.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6328,35709,'Control Unit','Control Room','LineageNpcEV.Willer',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6329,35710,'Power Control Unit','Control Room','LineageNpcEV.Strange_mechanical',16.00,15.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6330,35711,'Dwarven Gunnery Sergeant','','LineageNPC2.Willer',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6331,35712,'Scout Golem','Control Room','LineageMonster.Mechanic_golem',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6332,35713,'Guard Captain','Guard','LineageNPC2.Garrison_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6333,35714,'Guard','Guard','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6334,35715,'Guard','Guard','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6335,35716,'Support Unit Captain','Support Unit','LineageNPC2.Mage_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6336,35717,'Wizard','Support Unit','LineageNPC.Patriarch_MElf',8.00,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6337,35718,'Healer','Support Unit','LineageNPC.Mage_master',8.00,23.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6338,35719,'Archer Captain','Archer','LineageNPC2.Archer_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6339,35720,'Archer','Archer','LineageNPC.Guard_MElf',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6340,35721,'General','Officer''s Barracks','LineageNPC2.Officer_of_insurgents_orc',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6341,35722,'Minister','Officer''s Barracks','LineageNPC.Guard_MOrc',8.00,27.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6342,35723,'Ballista','Southern Gludio Fortress','LineageNpcEV.Ballista',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6343,35724,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6344,35725,'Mercenary Private','','LineageNPC.Guard_MOrc',8.00,27.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6345,35726,'Flagpole','','LineageNpcEV.Rune_holything',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6346,35727,'Foreman','Hive Fortress','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6347,35728,'Suspicious Merchant','Hive Fortress','LineageNPC.Guard_MOrc',8.00,27.00,1,'male','L2SiegeFortNpc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6348,35729,'Guard Captain','Hive Fortress','LineageNPC2.Garrison_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6349,35730,'Archer Captain','Hive Fortress','LineageNPC2.Archer_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6350,35731,'Support Unit Captain','Hive Fortress','LineageNPC2.mage_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6351,35732,'Engineering Manager','Hive Fortress','LineageNPC.Guard_Dwarf',8.00,19.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6352,35733,'Logistics Officer','Hive Fortress','LineageNPC.Collector_teacher',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6353,35734,'Supply Box','','LineageMonster.Mimic',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6354,35735,'Detention Camp Warden','Hive Fortress','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6355,35736,'Doorman','','LineageNPC.Ventyra_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6356,35737,'Doorman','','LineageNPC.Ventyra_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6357,35738,'Doorman','','LineageNPC.Ventyra_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6358,35739,'Rebel Commander','Hive Fortress','LineageNPC2.Chief_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6359,35740,'Decorated Rebel Soldier','Hive Fortress','LineageMonster.Shadow',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6360,35741,'Rebel Private','Hive Fortress','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6361,35742,'Court Guard','Hive Fortress','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6362,35743,'Guard','Hive Fortress','LineageNPC.Guard_MElf',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6363,35744,'Power Control Unit','Control Room','LineageNpcEV.Strange_mechanical',16.00,15.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6364,35745,'Dwarven Gunnery Sergeant','','LineageNPC2.Batte_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6365,35746,'Guard Captain','Guard','LineageNPC2.Garrison_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6366,35747,'Guard','Guard','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6367,35748,'Guard','Guard','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6368,35749,'Support Unit Captain','Support Unit','LineageNPC2.Mage_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6369,35750,'Wizard','Support Unit','LineageNPC.Patriarch_MElf',8.00,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6370,35751,'Healer','Support Unit','LineageNPC.Mage_master',8.00,23.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6371,35752,'Archer Captain','Archer','LineageNPC2.Archer_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6372,35753,'Archer','Archer','LineageNPC.Guard_MElf',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6373,35754,'Ballista','Hive Fortress','LineageNpcEV.Ballista',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6374,35755,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6375,35756,'Mercenary Private','','LineageNPC.Guard_MOrc',8.00,27.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6376,35757,'Flagpole','','LineageNpcEV.Rune_holything',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6377,35758,'Foreman','Valley Fortress','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6378,35759,'Suspicious Merchant','Valley Fortress','LineageNPC.Guard_MOrc',8.00,27.00,1,'male','L2SiegeFortNpc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6379,35760,'Guard Captain','Valley Fortress','LineageNPC2.Garrison_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6380,35761,'Archer Captain','Valley Fortress','LineageNPC2.Archer_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6381,35762,'General','Valley Fortress','LineageNPC2.Officer_of_insurgents_orc',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6382,35763,'Support Unit Captain','Valley Fortress','LineageNPC2.Mage_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6383,35764,'Engineering Manager','Valley Fortress','LineageNPC.Guard_Dwarf',8.00,19.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6384,35765,'Logistics Officer','Valley Fortress','LineageNPC.Collector_teacher',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6385,35766,'Supply Box','','LineageMonster.Mimic',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6386,35767,'Detention Camp Warden','Valley Fortress','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6387,35768,'Doorman','','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6388,35769,'Doorman','','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6389,35770,'Doorman','','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6390,35771,'Rebel Commander','Valley Fortress','LineageNPC2.Chief_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6391,35772,'Decorated Rebel Soldier','Valley Fortress','LineageMonster.Shadow',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6392,35773,'Rebel Private','Valley Fortress','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6393,35774,'Court Guard','Valley Fortress','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6394,35775,'Guard','Valley Fortress','LineageNPC.Guard_MElf',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6395,35776,'Main Machine','Control Room','LineageNpcEV.Machine_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6396,35777,'Backup Power Unit','Control Room','LineageNpcEV.Strange_mechanical',16.00,15.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6397,35778,'Control Unit','Control Room','LineageNpcEV.Willer',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6398,35779,'Power Control Unit','Control Room','LineageNpcEV.Strange_mechanical',16.00,15.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6399,35780,'Dwarven Gunnery Sergeant','','LineageNPC2.Batte_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6400,35781,'Scout Golem','Control Room','LineageMonster.Mechanic_golem',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6401,35782,'Guard Captain','Guard','LineageNPC2.Garrison_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6402,35783,'Guard','Guard','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6403,35784,'Guard','Guard','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6404,35785,'Support Unit Captain','Support Unit','LineageNPC2.Mage_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6405,35786,'Wizard','Support Unit','LineageNPC.Patriarch_MElf',8.00,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6406,35787,'Healer','Support Unit','LineageNPC.Mage_master',8.00,23.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6407,35788,'Archer Captain','Archer','LineageNPC2.Archer_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6408,35789,'Archer','Archer','LineageNPC.Guard_MElf',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6409,35790,'General','Officer''s Barracks','LineageNPC2.Officer_of_insurgents_orc',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6410,35791,'Minister','Officer''s Barracks','LineageNPC.Guard_MOrc',8.00,27.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6411,35792,'Ballista','Valley Fortress','LineageNpcEV.Ballista',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6412,35793,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6413,35794,'Mercenary Private','','LineageNPC.Guard_MOrc',8.00,27.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6414,35795,'Flagpole','','LineageNpcEV.Rune_holything',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6415,35796,'Foreman','Ivory Tower Fortress','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6416,35797,'Suspicious Merchant','Ivory Tower Fortress','LineageNPC.Guard_MOrc',8.00,27.00,1,'male','L2SiegeFortNpc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6417,35798,'Guard Captain','Ivory Tower Fortress','LineageNPC2.Garrison_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6418,35799,'Archer Captain','Ivory Tower Fortress','LineageNPC2.Archer_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6419,35800,'Support Unit Captain','Ivory Tower Fortress','LineageNPC2.Mage_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6420,35801,'Engineering Manager','Ivory Tower Fortress','LineageNPC.Guard_Dwarf',8.00,19.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6421,35802,'Logistics Officer','Ivory Tower Fortress','LineageNPC.Collector_teacher',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6422,35803,'Supply Box','','LineageMonster.Mimic',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6423,35804,'Detention Camp Warden','Ivory Tower Fortress','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6424,35805,'Doorman','','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6425,35806,'Doorman','','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6426,35807,'Doorman','','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6427,35808,'Rebel Commander','Ivory Tower Fortress','LineageNPC2.Chief_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6428,35809,'Decorated Rebel Soldier','Ivory Tower Fortress','LineageMonster.Shadow',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6429,35810,'Rebel Private','Ivory Tower Fortress','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6430,35811,'Court Guard','Ivory Tower Fortress','LineageNPC.Elmore_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6431,35812,'Guard','Ivory Tower Fortress','LineageNPC.Guard_MElf',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6432,35813,'Power Control Unit','Control Room','LineageNpcEV.Strange_mechanical',16.00,15.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6433,35814,'Dwarven Gunnery Sergeant','','LineageNPC2.Batty_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6434,35815,'Guard Captain','Guard','LineageNPC2.Garrison_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6435,35816,'Guard','Guard','LineageNPC.Royal_guar',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6436,35817,'Guard','Guard','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6437,35818,'Support Unit Captain','Support Unit','LineageNPC2.Mage_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6438,35819,'Wizard','Support Unit','LineageNPC.Patriarch_MElf',8.00,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6439,35820,'Healer','Support Unit','LineageNPC.Mage_master',8.00,23.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6440,35821,'Archer Captain','Archer','LineageNPC2.Archer_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6441,35822,'Archer','Archer','LineageNPC.Guard_MElf',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6442,35823,'Ballista','Ivory Tower Fortress','LineageNpcEV.Ballista',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6443,35824,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6444,35825,'Mercenary Private','','LineageNPC.Guard_MOrc',8.00,27.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6445,35826,'Flagpole','','LineageNpcEV.Rune_holything',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6446,35827,'Foreman','Narsell Fortress','LineageNPC.Royal_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6447,35828,'Suspicious Merchant','Narsell Fortress','LineageNPC.Guard_MOrc',8.00,27.00,1,'male','L2SiegeFortNpc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6448,35829,'Guard Captain','Narsell Fortress','LineageNPC2.Garrison_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6449,35830,'Archer Captain','Narsell Fortress','LineageNPC2.Archer_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6450,35831,'Support Unit Captain','Narsell Fortress','LineageNPC2.Mage_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6451,35832,'Engineering Manager','Narsell Fortress','LineageNPC.Guard_Dwarf',8.00,19.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6452,35833,'Logistics Officer','Narsell Fortress','LineageNPC.Collector_teacher',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6453,35834,'Supply Box','','LineageMonster.Mimic',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6454,35835,'Detention Camp Warden','Narsell Fortress','LineageNPC.Eleno_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6455,35836,'Doorman','','LineageNPC.Eleno_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6456,35837,'Doorman','','LineageNPC.Eleno_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6457,35838,'Doorman','','LineageNPC.Eleno_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6458,35839,'Rebel Commander','Narsell Fortress','LineageNPC2.Chief_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6459,35840,'Decorated Rebel Soldier','Narsell Fortress','LineageMonster.Shadow',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6460,35841,'Rebel Private','Narsell Fortress','LineageNPC.Eleno_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6461,35842,'Court Guard','Narsell Fortress','LineageNPC.Eleno_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6462,35843,'Guard','Narsell Fortress','LineageNPC.Eleno_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6463,35844,'Power Control Unit','Control Room','LineageNpcEV.Strange_mechanical',16.00,15.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6464,35845,'Dwarven Gunnery Sergeant','','LineageNPC2.Batty_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6465,35846,'Guard Captain','Guard','LineageNPC2.Garrison_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6466,35847,'Guard','Guard','LineageNPC.Eleno_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6467,35848,'Guard','Guard','LineageNPC.Eleno_guard',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6468,35849,'Support Unit Captain','Support Unit','LineageNPC2.Mage_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6469,35850,'Wizard','Support Unit','LineageNPC.Patriarch_Elino',8.00,22.50,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6470,35851,'Healer','Support Unit','LineageNPC.Mage_master_Shemon',8.00,23.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6471,35852,'Archer Captain','Archer','LineageNPC2.Archer_of_insurgents',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6472,35853,'Archer','Archer','LineageNPC.Guard_MElf',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6473,35854,'Ballista','Narsell Fortress','LineageNpcEV.Ballista',8.00,22.00,1,'male','L2Npc','npc',40,2444,2.000,2444,0.900,40,43,30,21,20,10,0,0,500,500,500,500,253,0,253,0,0,0,80,120,'',0,'Diamond','',0,0,0,7,30,4,4,0,0,0.37,'true',0,0),
(6474,35855,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6475,35856,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6476,35857,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6477,35858,'Foreman','Bayou Fortress','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6478,35859,'Suspicious Merchant','Bayou Fortress','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2SiegeFortNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6479,35860,'Guard Captain','Bayou Fortress','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(6480,35861,'Archer Captain','Bayou Fortress','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6481,35862,'General','Bayou Fortress','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6482,35863,'Support Unit Captain','Bayou Fortress','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6483,35864,'Engineering Manager','Bayou Fortress','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6484,35865,'Logistics Officer','Bayou Fortress','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6485,35866,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6486,35867,'Detention Camp Warden','Bayou Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6487,35868,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6488,35869,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6489,35870,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6490,35871,'Rebel Commander','Bayou Fortress','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6491,35872,'Decorated Rebel Soldier','Bayou Fortress','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6492,35873,'Rebel Private','Bayou Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6493,35874,'Court Guard','Bayou Fortress','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6494,35875,'Guard','Bayou Fortress','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6495,35876,'Main Machine','Control Room','LineageNpcEV.machine_guard_a',46.00,35.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6496,35877,'Backup Power Unit','Control Room','LineageNpcEV.strange_mechanical_instrume',16.00,15.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6497,35878,'Control Unit','Control Room','LineageNpcEV.door_lock',39.00,42.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6498,35879,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6499,35880,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6500,35881,'Scout Golem','Control Room','LineageMonster.mechanic_golem',5.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6501,35882,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6502,35883,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6503,35884,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6504,35885,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6505,35886,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6506,35887,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6507,35888,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6508,35889,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6509,35890,'General','Officer''s Barracks','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6510,35891,'Minister','Officer''s Barracks','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6511,35892,'Ballista','Bayou Fortress','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6512,35893,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6513,35894,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6514,35895,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6515,35896,'Foreman','White Sands Fortress','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6516,35897,'Suspicious Merchant','White Sands Fortress','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2SiegeFortNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6517,35898,'Guard Captain','White Sands Fortress','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6518,35899,'Archer Captain','White Sands Fortress','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6519,35900,'Support Unit Captain','White Sands Fortress','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6520,35901,'Engineering Manager','White Sands Fortress','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6521,35902,'Logistics Officer','White Sands Fortress','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6522,35903,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6523,35904,'Detention Camp Warden','White Sands Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6524,35905,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6525,35906,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6526,35907,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6527,35908,'Rebel Commander','White Sands Fortress','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6528,35909,'Decorated Rebel Soldier','White Sands Fortress','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6529,35910,'Rebel Private','White Sands Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6530,35911,'Court Guard','White Sands Fortress','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6531,35912,'Guard','White Sands Fortress','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6532,35913,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6533,35914,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6534,35915,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6535,35916,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6536,35917,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6537,35918,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6538,35919,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6539,35920,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6540,35921,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6541,35922,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6542,35923,'Ballista','White Sands Fortress','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6543,35924,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6544,35925,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6545,35926,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6546,35927,'Foreman','Borderland Fortress','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6547,35928,'Suspicious Merchant','Borderland Fortress','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2SiegeFortNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6548,35929,'Guard Captain','Borderland Fortress','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6549,35930,'Archer Captain','Borderland Fortress','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6550,35931,'General','Borderland Fortress','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6551,35932,'Support Unit Captain','Borderland Fortress','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6552,35933,'Engineering Manager','Borderland Fortress','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6553,35934,'Logistics Officer','Borderland Fortress','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6554,35935,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6555,35936,'Detention Camp Warden','Borderland Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6556,35937,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6557,35938,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6558,35939,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6559,35940,'Rebel Commander','Borderland Fortress','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6560,35941,'Decorated Rebel Soldier','Borderland Fortress','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6561,35942,'Rebel Private','Borderland Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6562,35943,'Court Guard','Borderland Fortress','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6563,35944,'Guard','Borderland Fortress','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6564,35945,'Main Machine','Control Room','LineageNpcEV.machine_guard_a',46.00,35.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6565,35946,'Backup Power Unit','Control Room','LineageNpcEV.strange_mechanical_instrume',16.00,15.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6566,35947,'Control Unit','Control Room','LineageNpcEV.door_lock',39.00,42.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6567,35948,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6568,35949,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6569,35950,'Scout Golem','Control Room','LineageMonster.mechanic_golem',5.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6570,35951,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6571,35952,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6572,35953,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6573,35954,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6574,35955,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6575,35956,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6576,35957,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6577,35958,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6578,35959,'General','Officer''s Barracks','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6579,35960,'Minister','Officer''s Barracks','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6580,35961,'Ballista','Borderland Fortress','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6581,35962,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6582,35963,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6583,35964,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6584,35965,'Foreman','Marshland Fortress','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6585,35966,'Suspicious Merchant','Marshland Fortress','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2SiegeFortNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6586,35967,'Guard Captain','Marshland Fortress','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6587,35968,'Archer Captain','Marshland Fortress','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6588,35969,'General','Marshland Fortress','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6589,35970,'Support Unit Captain','Marshland Fortress','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6590,35971,'Engineering Manager','Marshland Fortress','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6591,35972,'Logistics Officer','Marshland Fortress','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6592,35973,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6593,35974,'Detention Camp Warden','Marshland Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6594,35975,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6595,35976,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6596,35977,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6597,35978,'Rebel Commander','Marshland Fortress','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6598,35979,'Decorated Rebel Soldier','Marshland Fortress','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6599,35980,'Rebel Private','Marshland Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6600,35981,'Court Guard','Marshland Fortress','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6601,35982,'Guard','Marshland Fortress','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6602,35983,'Main Machine','Control Room','LineageNpcEV.machine_guard_a',46.00,35.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6603,35984,'Backup Power Unit','Control Room','LineageNpcEV.strange_mechanical_instrume',16.00,15.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6604,35985,'Control Unit','Control Room','LineageNpcEV.door_lock',39.00,42.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6605,35986,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6606,35987,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6607,35988,'Scout Golem','Control Room','LineageMonster.mechanic_golem',5.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6608,35989,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6609,35990,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6610,35991,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6611,35992,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6612,35993,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6613,35994,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6614,35995,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6615,35996,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6616,35997,'General','Officer''s Barracks','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6617,35998,'Minister','Officer''s Barracks','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6618,35999,'Ballista','Marshland Fortress','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6619,36000,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6620,36001,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6621,36002,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6622,36003,'Foreman','Archaic Fortress','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6623,36004,'Suspicious Merchant','Archaic Fortress','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2SiegeFortNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6624,36005,'Guard Captain','Archaic Fortress','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6625,36006,'Archer Captain','Archaic Fortress','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6626,36007,'Support Unit Captain','Archaic Fortress','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6627,36008,'Engineering Manager','Archaic Fortress','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6628,36009,'Logistics Officer','Archaic Fortress','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6629,36010,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6630,36011,'Detention Camp Warden','Archaic Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6631,36012,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6632,36013,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6633,36014,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6634,36015,'Rebel Commander','Archaic Fortress','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6635,36016,'Decorated Rebel Soldier','Archaic Fortress','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6636,36017,'Rebel Private','Archaic Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6637,36018,'Court Guard','Archaic Fortress','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6638,36019,'Guard','Archaic Fortress','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6639,36020,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6640,36021,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6641,36022,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6642,36023,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(6643,36024,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6644,36025,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6645,36026,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6646,36027,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6647,36028,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6648,36029,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6649,36030,'Ballista','Archaic Fortress','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6650,36031,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6651,36032,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6652,36033,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6653,36034,'Foreman','Floran Fortress','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6654,36035,'Suspicious Merchant','Floran Fortress','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6655,36036,'Guard Captain','Floran Fortress','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6656,36037,'Archer Captain','Floran Fortress','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6657,36038,'General','Floran Fortress','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6658,36039,'Support Unit Captain','Floran Fortress','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6659,36040,'Engineering Manager','Floran Fortress','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6660,36041,'Logistics Officer','Floran Fortress','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6661,36042,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6662,36043,'Detention Camp Warden','Floran Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6663,36044,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6664,36045,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6665,36046,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6666,36047,'Rebel Commander','Floran Fortress','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6667,36048,'Decorated Rebel Soldier','Floran Fortress','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6668,36049,'Rebel Private','Floran Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6669,36050,'Court Guard','Floran Fortress','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6670,36051,'Guard','Floran Fortress','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6671,36052,'Main Machine','Control Room','LineageNpcEV.machine_guard_a',46.00,35.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6672,36053,'Backup Power Unit','Control Room','LineageNpcEV.strange_mechanical_instrume',16.00,15.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6673,36054,'Control Unit','Control Room','LineageNpcEV.door_lock',39.00,42.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6674,36055,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6675,36056,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6676,36057,'Scout Golem','Control Room','LineageMonster.mechanic_golem',5.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6677,36058,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6678,36059,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6679,36060,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6680,36061,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6681,36062,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6682,36063,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6683,36064,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6684,36065,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6685,36066,'General','Officer''s Barracks','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6686,36067,'Minister','Officer''s Barracks','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6687,36068,'Ballista','Floran Fortress','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6688,36069,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6689,36070,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6690,36071,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6691,36072,'Foreman','Cloud Mountain','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6692,36073,'Suspicious Merchant','Cloud Mountain','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2SiegeFortNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6693,36074,'Guard Captain','Cloud Mountain','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6694,36075,'Archer Captain','Cloud Mountain','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6695,36076,'General','Cloud Mountain','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6696,36077,'Support Unit Captain','Cloud Mountain','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6697,36078,'Engineering Manager','Cloud Mountain','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6698,36079,'Logistics Officer','Cloud Mountain','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6699,36080,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6700,36081,'Detention Camp Warden','Cloud Mountain','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6701,36082,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6702,36083,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6703,36084,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6704,36085,'Rebel Commander','Cloud Mountain','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6705,36086,'Decorated Rebel Soldier','Cloud Mountain','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6706,36087,'Rebel Private','Cloud Mountain','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6707,36088,'Court Guard','Cloud Mountain','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6708,36089,'Guard','Cloud Mountain','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6709,36090,'Main Machine','Control Room','LineageNpcEV.machine_guard_a',46.00,35.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6710,36091,'Backup Power Unit','Control Room','LineageNpcEV.strange_mechanical_instrume',16.00,15.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6711,36092,'Control Unit','Control Room','LineageNpcEV.door_lock',39.00,42.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6712,36093,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6713,36094,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6714,36095,'Scout Golem','Control Room','LineageMonster.mechanic_golem',5.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6715,36096,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6716,36097,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6717,36098,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6718,36099,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6719,36100,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6720,36101,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6721,36102,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6722,36103,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6723,36104,'General','Officer''s Barracks','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6724,36105,'Minister','Officer''s Barracks','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6725,36106,'Ballista','Cloud Mountain','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6726,36107,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6727,36108,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6728,36109,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6729,36110,'Foreman','Tanor Fortress','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6730,36111,'Suspicious Merchant','Tanor Fortress','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2SiegeFortNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6731,36112,'Guard Captain','Tanor Fortress','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6732,36113,'Archer Captain','Tanor Fortress','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6733,36114,'Support Unit Captain','Tanor Fortress','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6734,36115,'Engineering Manager','Tanor Fortress','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6735,36116,'Logistics Officer','Tanor Fortress','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6736,36117,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6737,36118,'Detention Camp Warden','Tanor Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6738,36119,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6739,36120,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6740,36121,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6741,36122,'Rebel Commander','Tanor Fortress','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6742,36123,'Decorated Rebel Soldier','Tanor Fortress','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6743,36124,'Rebel Private','Tanor Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6744,36125,'Court Guard','Tanor Fortress','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6745,36126,'Guard','Tanor Fortress','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6746,36127,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6747,36128,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6748,36129,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6749,36130,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6750,36131,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6751,36132,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6752,36133,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6753,36134,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6754,36135,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6755,36136,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6756,36137,'Ballista','Tanor Fortress','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6757,36138,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6758,36139,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6759,36140,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6760,36141,'Foreman','Dragonspine Fortress','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6761,36142,'Suspicious Merchant','Dragonspine Fortress','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2SiegeFortNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6762,36143,'Guard Captain','Dragonspine Fortress','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6763,36144,'Archer Captain','Dragonspine Fortress','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6764,36145,'Support Unit Captain','Dragonspine Fortress','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6765,36146,'Engineering Manager','Dragonspine Fortress','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6766,36147,'Logistics Officer','Dragonspine Fortress','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6767,36148,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6768,36149,'Detention Camp Warden','Dragonspine Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6769,36150,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6770,36151,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6771,36152,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6772,36153,'Rebel Commander','Dragonspine Fortress','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2SiegeGuard','SiegeGuardFighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6773,36154,'Decorated Rebel Soldier','Dragonspine Fortress','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2SiegeGuard','SiegeGuardFighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6774,36155,'Rebel Private','Dragonspine Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2SiegeGuard','SiegeGuardFighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6775,36156,'Court Guard','Dragonspine Fortress','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2SiegeGuard','SiegeGuardFighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6776,36157,'Guard','Dragonspine Fortress','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2SiegeGuard','SiegeGuardFighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,9447,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6777,36158,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6778,36159,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6779,36160,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6780,36161,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2SiegeGuard','SiegeGuardFighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,9442,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6781,36162,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2SiegeGuard','SiegeGuardFighter',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,9448,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6782,36163,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6783,36164,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2SiegeGuard','SiegeGuardMystic',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6784,36165,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2SiegeGuard','SiegeGuardMystic',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6785,36166,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6786,36167,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2SiegeGuard','SiegeGuardRanger',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,9445,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6787,36168,'Ballista','Dragonspine Fortress','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2SiegeGuard','SiegeGuardRanger',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,9445,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6788,36169,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6789,36170,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6790,36171,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6791,36172,'Foreman','Antharas'' Fortress','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6792,36173,'Suspicious Merchant','Antharas'' Fortress','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6793,36174,'Guard Captain','Antharas'' Fortress','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6794,36175,'Archer Captain','Antharas'' Fortress','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6795,36176,'General','Antharas'' Fortress','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6796,36177,'Support Unit Captain','Antharas'' Fortress','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6797,36178,'Engineering Manager','Antharas'' Fortress','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6798,36179,'Logistics Officer','Antharas'' Fortress','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6799,36180,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6800,36181,'Detention Camp Warden','Land Dragon Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6801,36182,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6802,36183,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6803,36184,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6804,36185,'Rebel Commander','Antharas'' Fortress','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6805,36186,'Decorated Rebel Soldier','Antharas'' Fortress','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(6806,36187,'Rebel Private','Antharas'' Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6807,36188,'Court Guard','Antharas'' Fortress','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6808,36189,'Guard','Antharas'' Fortress','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6809,36190,'Main Machine','Control Room','LineageNpcEV.machine_guard_a',46.00,35.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6810,36191,'Backup Power Unit','Control Room','LineageNpcEV.strange_mechanical_instrume',16.00,15.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6811,36192,'Control Unit','Control Room','LineageNpcEV.door_lock',39.00,42.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6812,36193,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6813,36194,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6814,36195,'Scout Golem','Control Room','LineageMonster.mechanic_golem',5.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6815,36196,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6816,36197,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6817,36198,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6818,36199,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6819,36200,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6820,36201,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6821,36202,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6822,36203,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6823,36204,'General','Officer''s Barracks','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6824,36205,'Minister','Officer''s Barracks','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6825,36206,'Ballista','Antharas'' Fortress','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6826,36207,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6827,36208,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6828,36209,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6829,36210,'Foreman','Western Fortress','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6830,36211,'Suspicious Merchant','Western Fortress','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2SiegeFortNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6831,36212,'Guard Captain','Western Fortress','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6832,36213,'Archer Captain','Western Fortress','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6833,36214,'General','Western Fortress','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6834,36215,'Support Unit Captain','Western Fortress','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6835,36216,'Engineering Manager','Western Fortress','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6836,36217,'Logistics Officer','Western Fortress','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6837,36218,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6838,36219,'Detention Camp Warden','Western Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6839,36220,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6840,36221,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6841,36222,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6842,36223,'Rebel Commander','Western Fortress','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6843,36224,'Decorated Rebel Soldier','Western Fortress','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6844,36225,'Rebel Private','Western Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6845,36226,'Court Guard','Western Fortress','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6846,36227,'Guard','Western Fortress','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6847,36228,'Main Machine','Control Room','LineageNpcEV.machine_guard_a',46.00,35.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6848,36229,'Backup Power Unit','Control Room','LineageNpcEV.strange_mechanical_instrume',16.00,15.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6849,36230,'Control Unit','Control Room','LineageNpcEV.door_lock',39.00,42.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6850,36231,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6851,36232,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6852,36233,'Scout Golem','Control Room','LineageMonster.mechanic_golem',5.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6853,36234,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6854,36235,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6855,36236,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6856,36237,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6857,36238,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6858,36239,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6859,36240,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6860,36241,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6861,36242,'General','Officer''s Barracks','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6862,36243,'Minister','Officer''s Barracks','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6863,36244,'Ballista','Western Fortress','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6864,36245,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6865,36246,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6866,36247,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6867,36248,'Foreman','Hunter''s Fortress','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6868,36249,'Suspicious Merchant','Hunter''s Fortress','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2SiegeFortNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6869,36250,'Guard Captain','Hunter''s Fortress','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6870,36251,'Archer Captain','Hunter''s Fortress','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6871,36252,'General','Hunter''s Fortress','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6872,36253,'Support Unit Captain','Hunter''s Fortress','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6873,36254,'Engineering Manager','Hunter''s Fortress','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6874,36255,'Logistics Officer','Hunter''s Fortress','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6875,36256,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6876,36257,'Detention Camp Warden','Hunter''s Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6877,36258,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6878,36259,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6879,36260,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6880,36261,'Rebel Commander','Hunter''s Fortress','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6881,36262,'Decorated Rebel Soldier','Hunter''s Fortress','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6882,36263,'Rebel Private','Hunter''s Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6883,36264,'Court Guard','Hunter''s Fortress','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6884,36265,'Guard','Hunter''s Fortress','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6885,36266,'Main Machine','Control Room','LineageNpcEV.machine_guard_a',46.00,35.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6886,36267,'Backup Power Unit','Control Room','LineageNpcEV.strange_mechanical_instrume',16.00,15.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6887,36268,'Control Unit','Control Room','LineageNpcEV.door_lock',39.00,42.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6888,36269,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6889,36270,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6890,36271,'Scout Golem','Control Room','LineageMonster.mechanic_golem',5.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6891,36272,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6892,36273,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6893,36274,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6894,36275,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6895,36276,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6896,36277,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6897,36278,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6898,36279,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6899,36280,'General','Officer''s Barracks','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6900,36281,'Minister','Officer''s Barracks','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6901,36282,'Ballista','Hunter''s Fortress','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6902,36283,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6903,36284,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6904,36285,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6905,36286,'Foreman','Aaru Fortress','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6906,36287,'Suspicious Merchant','Aaru Fortress','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6907,36288,'Guard Captain','Aaru Fortress','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6908,36289,'Archer Captain','Aaru Fortress','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6909,36290,'Support Unit Captain','Aaru Fortress','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6910,36291,'Engineering Manager','Aaru Fortress','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6911,36292,'Logistics Officer','Aaru Fortress','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6912,36293,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6913,36294,'Detention Camp Warden','Aaru Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6914,36295,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6915,36296,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6916,36297,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6917,36298,'Rebel Commander','Aaru Fortress','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6918,36299,'Decorated Rebel Soldier','Aaru Fortress','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6919,36300,'Rebel Private','Aaru Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6920,36301,'Court Guard','Aaru Fortress','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6921,36302,'Guard','Aaru Fortress','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6922,36303,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6923,36304,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6924,36305,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6925,36306,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6926,36307,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6927,36308,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6928,36309,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6929,36310,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6930,36311,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6931,36312,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6932,36313,'Ballista','Aaru Fortress','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6933,36314,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6934,36315,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6935,36316,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6936,36317,'Foreman','Demon Fortress','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6937,36318,'Suspicious Merchant','Demon Fortress','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2SiegeFortNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6938,36319,'Guard Captain','Demon Fortress','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6939,36320,'Archer Captain','Demon Fortress','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6940,36321,'General','Demon Fortress','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6941,36322,'Support Unit Captain','Demon Fortress','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6942,36323,'Engineering Manager','Demon Fortress','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6943,36324,'Logistics Officer','Demon Fortress','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6944,36325,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6945,36326,'Detention Camp Warden','Demon Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6946,36327,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6947,36328,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6948,36329,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6949,36330,'Rebel Commander','Demon Fortress','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6950,36331,'Decorated Rebel Soldier','Demon Fortress','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6951,36332,'Rebel Private','Demon Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6952,36333,'Court Guard','Demon Fortress','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6953,36334,'Guard','Demon Fortress','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6954,36335,'Main Machine','Control Room','LineageNpcEV.machine_guard_a',46.00,35.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6955,36336,'Backup Power Unit','Control Room','LineageNpcEV.strange_mechanical_instrume',16.00,15.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6956,36337,'Control Unit','Control Room','LineageNpcEV.door_lock',39.00,42.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6957,36338,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6958,36339,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6959,36340,'Scout Golem','Control Room','LineageMonster.mechanic_golem',5.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6960,36341,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6961,36342,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6962,36343,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6963,36344,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6964,36345,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6965,36346,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6966,36347,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6967,36348,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(6968,36349,'General','Officer''s Barracks','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6969,36350,'Minister','Officer''s Barracks','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6970,36351,'Ballista','Demon Fortress','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6971,36352,'Mercenary Captain','','LineageMonster3.Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6972,36353,'Mercenary Private','','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6973,36354,'Flagpole','','LineageNpcEV.rune_holything',46.00,72.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6974,36355,'Foreman','Monastic Fortress','LineageNPC.a_royal_guardA_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6975,36356,'Suspicious Merchant','Monastic Fortress','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2SiegeFortNpc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6976,36357,'Guard Captain','Monastic Fortress','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6977,36358,'Archer Captain','Monastic Fortress','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6978,36359,'General','Monastic Fortress','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6979,36360,'Support Unit Captain','Monastic Fortress','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6980,36361,'Engineering Manager','Monastic Fortress','LineageNPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6981,36362,'Logistics Officer','Monastic Fortress','LineageNPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6982,36363,'Supply Box','','LineageMonster.mimic',8.50,8.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6983,36364,'Detention Camp Warden','Monastic Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6984,36365,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6985,36366,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6986,36367,'Doorman','','LineageNPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6987,36368,'Rebel Commander','Monastic Fortress','LineageNPC2.chief_of_insurgents',10.00,26.99,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6988,36369,'Decorated Rebel Soldier','Monastic Fortress','LineageMonster.shadow_50_bi',15.00,45.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6989,36370,'Rebel Private','Monastic Fortress','LineageNPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6990,36371,'Court Guard','Monastic Fortress','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6991,36372,'Guard','Monastic Fortress','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6992,36373,'Main Machine','Control Room','LineageNpcEV.machine_guard_a',46.00,35.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6993,36374,'Backup Power Unit','Control Room','LineageNpcEV.strange_mechanical_instrume',16.00,15.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6994,36375,'Control Unit','Control Room','LineageNpcEV.door_lock',39.00,42.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6995,36376,'Power Control Unit','Control Room','LineageNpcEV.machine_construction_a',54.00,59.50,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6996,36377,'Dwarven Gunnery Sergeant','','LineageNPC2.battery_of_insurgents',13.00,17.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6997,36378,'Scout Golem','Control Room','LineageMonster.mechanic_golem',5.00,19.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6998,36379,'Guard Captain','Guard','LineageNPC2.garrison_of_insurgents',10.00,23.75,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(6999,36380,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7000,36381,'Guard','Guard','LineageNPC.a_royal_guardB_MHuman',8.00,24.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7001,36382,'Support Unit Captain','Support Unit','LineageNPC2.mage_of_insurgents',9.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7002,36383,'Wizard','Support Unit','LineageNPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7003,36384,'Healer','Support Unit','LineageNPC.a_mageguild_master_FHuman',8.00,23.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7004,36385,'Archer Captain','Archer','LineageNPC2.archer_of_insurgents',10.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7005,36386,'Archer','Archer','LineageNPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7006,36387,'General','Officer''s Barracks','LineageNPC2.officer_of_insurgents_orc',14.50,30.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7007,36388,'Minister','Officer''s Barracks','LineageNPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7008,36389,'Ballista','Monastic Fortress','LineageNpcEV.ballista',112.00,59.00,70,'etc','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7009,36390,'Mercenary Captain','','Kight_of_Dawn',12.00,24.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7010,36391,'Mercenary Private','','e_guard_MOrc',8.00,27.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7011,36392,'Improvised Explosive','','orc',10.00,21.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7012,36393,'Special Envoy','Gludio','a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7013,36394,'Special Envoy','Gludio','a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7014,36395,'Special Envoy','Dion','a_maidB_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7015,36396,'Special Envoy','Giran','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7016,36397,'Special Envoy','Oren','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7017,36398,'Special Envoy','Aden','a_maidB_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7018,36399,'Special Envoy','Aden','a_maidB_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7019,36400,'Special Envoy','Innadril','a_teleporter_FElf',8.50,23.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7020,36401,'Special Envoy','Goddard','e_teleporter_Fhuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7021,36402,'Olympiad Host','','a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2OlympiadBuffer','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7022,36403,'Warden','Gludio','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7023,36404,'Warden','Dion','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7024,36405,'Warden','Giran','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7025,36406,'Warden','Oren','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7026,36407,'Warden','Aden','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7027,36408,'Warden','Innadril','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7028,36409,'Warden','Goddard','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7029,36410,'Warden','Rune','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7030,36411,'Warden','Schuttgart','e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7052,36433,'Special Envoy','Rune','a_maidB_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7053,36434,'Special Envoy','Schuttgart','e_traderA_FDwarf',8.00,19.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7054,36435,'Special Envoy','Gludio','a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7055,36436,'Special Envoy','Dion','a_maidB_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7056,36437,'Special Envoy','Gludio','a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7057,36438,'Special Envoy','Oren','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7058,36439,'Special Envoy','Dion','a_maidB_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7059,36440,'Special Envoy','Giran','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7060,36441,'Special Envoy','Dion','a_maidB_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7061,36442,'Special Envoy','Oren','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7062,36443,'Special Envoy','Oren','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7063,36444,'Special Envoy','Giran','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7064,36445,'Special Envoy','Aden','a_maidB_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7065,36446,'Special Envoy','Oren','a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7066,36447,'Special Envoy','Goddard','e_teleporter_Fhuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7067,36448,'Special Envoy','Aden','a_maidB_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7068,36449,'Special Envoy','Giran','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7069,36450,'Special Envoy','Innadril','a_teleporter_FElf',8.50,23.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7070,36451,'Special Envoy','Giran','a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7071,36452,'Special Envoy','Rune','a_maidB_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7072,36453,'Special Envoy','Goddard','e_teleporter_Fhuman',8.00,25.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7073,36454,'Special Envoy','Rune','a_maidB_FHuman',8.00,22.50,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7074,36455,'Special Envoy','Schuttgart','e_traderA_FDwarf',8.00,19.00,70,'female','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7075,36456,'Manor Manager','Aden','K_M1_normal',13.00,25.00,70,'male','L2ManorManager','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',1,0),
(7076,14001,'Reanimated Man','','skeleton',11.00,25.00,46,'male','L2Pet','npc',40,2933,12.690,816,2.730,40,43,30,21,20,25,0,0,481,245,202,229,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7077,14002,'Reanimated Man','','skeleton',11.00,25.00,54,'male','L2Pet','npc',40,3867,15.300,1102,3.360,40,43,30,21,20,25,0,0,761,311,339,292,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7078,14003,'Reanimated Man','','skeleton',11.00,25.00,62,'male','L2Pet','npc',40,4860,18.000,1404,3.990,40,43,30,21,20,25,0,0,1132,388,531,363,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7079,14004,'Reanimated Man','','skeleton',11.00,25.00,66,'male','L2Pet','npc',40,5353,19.440,1561,4.060,40,43,30,21,20,25,0,0,1346,427,649,400,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7080,14005,'Reanimated Man','','skeleton',11.00,25.00,70,'male','L2Pet','npc',40,5830,20.970,1722,4.200,40,43,30,21,20,25,0,0,1576,469,779,439,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7081,14006,'Reanimated Man','','skeleton',11.00,25.00,74,'male','L2Pet','npc',40,6277,22.500,1888,4.760,40,43,30,21,20,25,0,0,1815,511,920,479,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7082,14007,'Reanimated Man','','skeleton',11.00,25.00,76,'male','L2Pet','npc',40,6487,23.310,1972,4.830,40,43,30,21,20,25,0,0,1936,532,993,498,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7083,14008,'Reanimated Man','','skeleton',11.00,25.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2068,555,1069,520,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7084,14009,'Reanimated Man','','skeleton',11.00,25.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2078,555,1069,520,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7085,14010,'Reanimated Man','','skeleton',11.00,25.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2088,555,1069,520,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7086,14011,'Reanimated Man','','skeleton',11.00,25.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2099,555,1069,520,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7087,14012,'Reanimated Man','','skeleton',11.00,25.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2109,555,1069,520,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7088,14013,'Reanimated Man','','skeleton',11.00,25.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2119,555,1069,520,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7089,14014,'Reanimated Man','','skeleton',11.00,25.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2130,555,1069,520,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7090,14015,'Reanimated Man','','skeleton',11.00,25.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2140,555,1069,520,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7091,14016,'Reanimated Man','','skeleton',11.00,25.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2150,555,1069,520,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7092,14017,'Reanimated Man','','skeleton',11.00,25.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2173,558,1082,523,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7093,14018,'Reanimated Man','','skeleton',11.00,25.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2184,558,1082,523,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7094,14019,'Reanimated Man','','skeleton',11.00,25.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2194,558,1082,523,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7095,14020,'Reanimated Man','','skeleton',11.00,25.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2204,558,1082,523,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7096,14021,'Reanimated Man','','skeleton',11.00,25.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2215,558,1082,523,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7097,14022,'Reanimated Man','','skeleton',11.00,25.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2225,558,1082,523,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7098,14023,'Reanimated Man','','skeleton',11.00,25.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2236,558,1082,523,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7099,14024,'Reanimated Man','','skeleton',11.00,25.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2246,558,1082,523,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7100,14025,'Reanimated Man','','skeleton',11.00,25.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2256,558,1082,523,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7101,14026,'Reanimated Man','','skeleton',11.00,25.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2280,562,1095,526,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7102,14027,'Reanimated Man','','skeleton',11.00,25.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2290,562,1095,526,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7103,14028,'Reanimated Man','','skeleton',11.00,25.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2301,562,1095,526,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7104,14029,'Reanimated Man','','skeleton',11.00,25.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2311,562,1095,526,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7105,14030,'Reanimated Man','','skeleton',11.00,25.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2322,562,1095,526,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7106,14031,'Reanimated Man','','skeleton',11.00,25.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2332,562,1095,526,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7107,14032,'Reanimated Man','','skeleton',11.00,25.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2343,562,1095,526,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7108,14033,'Reanimated Man','','skeleton',11.00,25.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2353,562,1095,526,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7109,14034,'Reanimated Man','','skeleton',11.00,25.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2363,562,1095,526,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7110,14035,'Reanimated Man','','skeleton',11.00,25.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2374,562,1095,526,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7111,14036,'Reanimated Man','','skeleton',11.00,25.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2384,562,1095,526,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7112,14037,'Reanimated Man','','skeleton',11.00,25.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,2395,562,1095,526,278,0,333,0,0,0,60,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.30,'false',0,0),
(7113,14038,'Corrupted Man','','zombie',13.00,21.00,42,'male','L2Pet','npc',40,2506,11.520,1019,2.660,40,43,30,21,20,25,0,0,374,214,152,201,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7114,14039,'Corrupted Man','','zombie',13.00,21.00,50,'male','L2Pet','npc',40,3389,13.950,1435,2.870,40,43,30,21,20,25,0,0,610,278,263,259,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7115,14040,'Corrupted Man','','zombie',13.00,21.00,58,'male','L2Pet','npc',40,4361,16.650,1876,3.430,40,43,30,21,20,25,0,0,936,348,428,327,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7116,14041,'Corrupted Man','','zombie',13.00,21.00,64,'male','L2Pet','npc',40,5108,18.720,2223,4.060,40,43,30,21,20,25,0,0,1237,408,588,381,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7117,14042,'Corrupted Man','','zombie',13.00,21.00,68,'male','L2Pet','npc',40,5594,20.250,2462,4.130,40,43,30,21,20,25,0,0,1460,449,713,420,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7118,14043,'Corrupted Man','','zombie',13.00,21.00,72,'male','L2Pet','npc',40,6058,21.780,2707,4.760,40,43,30,21,20,25,0,0,1694,491,848,459,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7119,14044,'Corrupted Man','','zombie',13.00,21.00,78,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2073,554,1068,519,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7120,14045,'Corrupted Man','','zombie',13.00,21.00,78,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2073,554,1068,519,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7121,14046,'Corrupted Man','','zombie',13.00,21.00,78,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2073,554,1068,519,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7122,14047,'Corrupted Man','','zombie',13.00,21.00,78,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2073,554,1068,519,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7123,14048,'Corrupted Man','','zombie',13.00,21.00,78,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2073,554,1068,519,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7124,14049,'Corrupted Man','','zombie',13.00,21.00,78,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2073,554,1068,519,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7125,14050,'Corrupted Man','','zombie',13.00,21.00,78,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2073,554,1068,519,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7126,14051,'Corrupted Man','','zombie',13.00,21.00,78,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2073,554,1068,519,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7127,14052,'Corrupted Man','','zombie',13.00,21.00,78,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2073,554,1068,519,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7128,14053,'Corrupted Man','','zombie',13.00,21.00,79,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2173,558,1082,523,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7129,14054,'Corrupted Man','','zombie',13.00,21.00,79,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2184,558,1082,523,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7130,14055,'Corrupted Man','','zombie',13.00,21.00,79,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2194,558,1082,523,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7131,14056,'Corrupted Man','','zombie',13.00,21.00,79,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2204,558,1082,523,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7132,14057,'Corrupted Man','','zombie',13.00,21.00,79,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2215,558,1082,523,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7133,14058,'Corrupted Man','','zombie',13.00,21.00,79,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2225,558,1082,523,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7134,14059,'Corrupted Man','','zombie',13.00,21.00,79,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2236,558,1082,523,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7135,14060,'Corrupted Man','','zombie',13.00,21.00,79,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2246,558,1082,523,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7136,14061,'Corrupted Man','','zombie',13.00,21.00,79,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2256,558,1082,523,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7137,14062,'Corrupted Man','','zombie',13.00,21.00,80,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2280,562,1095,526,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7138,14063,'Corrupted Man','','zombie',13.00,21.00,80,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2290,562,1095,526,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7139,14064,'Corrupted Man','','zombie',13.00,21.00,80,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2301,562,1095,526,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7140,14065,'Corrupted Man','','zombie',13.00,21.00,80,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2311,562,1095,526,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7141,14066,'Corrupted Man','','zombie',13.00,21.00,80,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2322,562,1095,526,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7142,14067,'Corrupted Man','','zombie',13.00,21.00,80,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2332,562,1095,526,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7143,14068,'Corrupted Man','','zombie',13.00,21.00,80,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2343,562,1095,526,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7144,14069,'Corrupted Man','','zombie',13.00,21.00,80,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2353,562,1095,526,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7145,14070,'Corrupted Man','','zombie',13.00,21.00,80,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2363,562,1095,526,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7146,14071,'Corrupted Man','','zombie',13.00,21.00,80,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2374,562,1095,526,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7147,14072,'Corrupted Man','','zombie',13.00,21.00,80,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2384,562,1095,526,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7148,14073,'Corrupted Man','','zombie',13.00,21.00,80,'male','L2Pet','npc',40,7130,24.120,3086,4.900,40,43,30,21,20,25,0,0,2395,562,1095,526,278,0,333,0,0,0,15,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.43,'false',0,0),
(7149,14074,'Cursed Man','','doll_master',20.00,42.00,58,'male','L2Pet','npc',80,3489,16.650,1251,3.430,40,43,30,21,20,25,0,0,1014,348,428,327,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7150,14075,'Cursed Man','','doll_master',20.00,42.00,62,'male','L2Pet','npc',80,3888,18.000,1404,3.990,40,43,30,21,20,25,0,0,1226,388,531,363,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7151,14076,'Cursed Man','','doll_master',20.00,42.00,66,'male','L2Pet','npc',80,4282,19.440,1561,4.060,40,43,30,21,20,25,0,0,1458,427,649,400,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7152,14077,'Cursed Man','','doll_master',20.00,42.00,70,'male','L2Pet','npc',80,4664,20.970,1722,4.200,40,43,30,21,20,25,0,0,1707,469,779,439,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7153,14078,'Cursed Man','','doll_master',20.00,42.00,72,'male','L2Pet','npc',80,4846,21.780,1804,4.760,40,43,30,21,20,25,0,0,1835,491,848,459,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7154,14079,'Cursed Man','','doll_master',20.00,42.00,74,'male','L2Pet','npc',80,5022,22.500,1888,4.760,40,43,30,21,20,25,0,0,1965,511,920,479,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7155,14080,'Cursed Man','','doll_master',20.00,42.00,76,'male','L2Pet','npc',80,5189,23.310,1972,4.830,40,43,30,21,20,25,0,0,2096,532,993,498,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7156,14081,'Cursed Man','','doll_master',20.00,42.00,78,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2278,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7157,14082,'Cursed Man','','doll_master',20.00,42.00,78,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2278,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7158,14083,'Cursed Man','','doll_master',20.00,42.00,78,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2278,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7159,14084,'Cursed Man','','doll_master',20.00,42.00,78,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2278,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7160,14085,'Cursed Man','','doll_master',20.00,42.00,78,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2278,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7161,14086,'Cursed Man','','doll_master',20.00,42.00,78,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2278,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7162,14087,'Cursed Man','','doll_master',20.00,42.00,78,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2278,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7163,14088,'Cursed Man','','doll_master',20.00,42.00,78,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2278,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7164,14089,'Cursed Man','','doll_master',20.00,42.00,78,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2278,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7165,14090,'Cursed Man','','doll_master',20.00,42.00,79,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2388,558,1082,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7166,14091,'Cursed Man','','doll_master',20.00,42.00,79,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2404,558,1082,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7167,14092,'Cursed Man','','doll_master',20.00,42.00,79,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2420,558,1082,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7168,14093,'Cursed Man','','doll_master',20.00,42.00,79,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2436,558,1082,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7169,14094,'Cursed Man','','doll_master',20.00,42.00,79,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2452,558,1082,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7170,14095,'Cursed Man','','doll_master',20.00,42.00,79,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2468,558,1082,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7171,14096,'Cursed Man','','doll_master',20.00,42.00,79,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2484,558,1082,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7172,14097,'Cursed Man','','doll_master',20.00,42.00,79,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2500,558,1082,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7173,14098,'Cursed Man','','doll_master',20.00,42.00,79,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2517,558,1082,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7174,14099,'Cursed Man','','doll_master',20.00,42.00,80,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2548,562,1095,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7175,14100,'Cursed Man','','doll_master',20.00,42.00,80,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2564,562,1095,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7176,14101,'Cursed Man','','doll_master',20.00,42.00,80,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2580,562,1095,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7177,14102,'Cursed Man','','doll_master',20.00,42.00,80,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2596,562,1095,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7178,14103,'Cursed Man','','doll_master',20.00,42.00,80,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2613,562,1095,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7179,14104,'Cursed Man','','doll_master',20.00,42.00,80,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2629,562,1095,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7180,14105,'Cursed Man','','doll_master',20.00,42.00,80,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2645,562,1095,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7181,14106,'Cursed Man','','doll_master',20.00,42.00,80,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2661,562,1095,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7182,14107,'Cursed Man','','doll_master',20.00,42.00,80,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2678,562,1095,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7183,14108,'Cursed Man','','doll_master',20.00,42.00,80,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2694,562,1095,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7184,14109,'Cursed Man','','doll_master',20.00,42.00,80,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2710,562,1095,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7185,14110,'Cursed Man','','doll_master',20.00,42.00,80,'male','L2Pet','npc',80,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2726,562,1095,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,8,4,0,0,0.56,'false',0,0),
(7186,14111,'Kat the Cat','','cat_the_cat',9.00,16.00,22,'male','L2Pet','npc',40,984,6.210,279,1.610,40,43,30,21,20,25,0,0,67,102,28,95,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7191,14116,'Kat the Cat','','cat_the_cat',9.00,16.00,27,'male','L2Pet','npc',40,1310,7.470,367,1.680,40,43,30,21,20,25,0,0,103,125,45,117,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7187,14112,'Kat the Cat','','cat_the_cat',9.00,16.00,32,'male','L2Pet','npc',40,1700,8.730,458,2.100,40,43,30,21,20,25,0,0,153,151,69,140,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7192,14117,'Kat the Cat','','cat_the_cat',9.00,16.00,37,'male','L2Pet','npc',40,2155,10.080,553,2.170,40,43,30,21,20,25,0,0,220,182,104,169,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7188,14113,'Kat the Cat','','cat_the_cat',9.00,16.00,42,'male','L2Pet','npc',40,2673,11.520,679,2.660,40,43,30,21,20,25,0,0,311,214,152,201,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7193,14118,'Kat the Cat','','cat_the_cat',9.00,16.00,46,'male','L2Pet','npc',40,3128,12.690,816,2.730,40,43,30,21,20,25,0,0,401,245,202,229,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7189,14114,'Kat the Cat','','cat_the_cat',9.00,16.00,50,'male','L2Pet','npc',40,3614,13.950,957,2.870,40,43,30,21,20,25,0,0,508,278,263,259,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7194,14119,'Kat the Cat','','cat_the_cat',9.00,16.00,54,'male','L2Pet','npc',40,4125,15.300,1102,3.360,40,43,30,21,20,25,0,0,634,311,339,292,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7190,14115,'Kat the Cat','','cat_the_cat',9.00,16.00,58,'male','L2Pet','npc',40,4651,16.650,1251,3.430,40,43,30,21,20,25,0,0,781,349,428,327,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7195,14120,'Kat the Cat','','cat_the_cat',9.00,16.00,60,'male','L2Pet','npc',40,4917,17.280,1327,3.500,40,43,30,21,20,25,0,0,860,368,477,345,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7196,14121,'Kat the Cat','','cat_the_cat',9.00,16.00,62,'male','L2Pet','npc',40,5183,18.000,1404,3.990,40,43,30,21,20,25,0,0,944,388,531,363,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7197,14122,'Kat the Cat','','cat_the_cat',9.00,16.00,64,'male','L2Pet','npc',40,5448,18.720,1482,4.060,40,43,30,21,20,25,0,0,1031,408,588,381,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7198,14123,'Kat the Cat','','cat_the_cat',9.00,16.00,66,'male','L2Pet','npc',40,5710,19.440,1561,4.060,40,43,30,21,20,25,0,0,1121,427,649,400,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7199,14124,'Kat the Cat','','cat_the_cat',9.00,16.00,68,'male','L2Pet','npc',40,5967,20.250,1641,4.130,40,43,30,21,20,25,0,0,1217,449,713,420,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7200,14125,'Kat the Cat','','cat_the_cat',9.00,16.00,70,'male','L2Pet','npc',40,6218,20.970,1722,4.200,40,43,30,21,20,25,0,0,1312,469,779,439,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7201,14126,'Kat the Cat','','cat_the_cat',9.00,16.00,72,'male','L2Pet','npc',40,6461,21.780,1804,4.760,40,43,30,21,20,25,0,0,1412,491,848,459,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7202,14127,'Kat the Cat','','cat_the_cat',9.00,16.00,74,'male','L2Pet','npc',40,6695,22.500,1888,4.760,40,43,30,21,20,25,0,0,1511,511,920,479,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7203,14128,'Kat the Cat','','cat_the_cat',9.00,16.00,76,'male','L2Pet','npc',40,6919,23.310,1972,4.830,40,43,30,21,20,25,0,0,1613,532,993,498,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7204,14129,'Kat the Cat','','cat_the_cat',9.00,16.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7205,14130,'Kat the Cat','','cat_the_cat',9.00,16.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7206,14131,'Kat the Cat','','cat_the_cat',9.00,16.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7207,14132,'Kat the Cat','','cat_the_cat',9.00,16.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7208,14133,'Kat the Cat','','cat_the_cat',9.00,16.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7209,14134,'Kat the Cat','','cat_the_cat',9.00,16.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7210,14135,'Kat the Cat','','cat_the_cat',9.00,16.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7211,14136,'Kat the Cat','','cat_the_cat',9.00,16.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7212,14137,'Kat the Cat','','cat_the_cat',9.00,16.00,78,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7213,14138,'Kat the Cat','','cat_the_cat',9.00,16.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7214,14139,'Kat the Cat','','cat_the_cat',9.00,16.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7215,14140,'Kat the Cat','','cat_the_cat',9.00,16.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7216,14141,'Kat the Cat','','cat_the_cat',9.00,16.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7217,14142,'Kat the Cat','','cat_the_cat',9.00,16.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7218,14143,'Kat the Cat','','cat_the_cat',9.00,16.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7219,14144,'Kat the Cat','','cat_the_cat',9.00,16.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7220,14145,'Kat the Cat','','cat_the_cat',9.00,16.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7221,14146,'Kat the Cat','','cat_the_cat',9.00,16.00,79,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7222,14147,'Kat the Cat','','cat_the_cat',9.00,16.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7223,14148,'Kat the Cat','','cat_the_cat',9.00,16.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7224,14149,'Kat the Cat','','cat_the_cat',9.00,16.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7225,14150,'Kat the Cat','','cat_the_cat',9.00,16.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7226,14151,'Kat the Cat','','cat_the_cat',9.00,16.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7227,14152,'Kat the Cat','','cat_the_cat',9.00,16.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7228,14153,'Kat the Cat','','cat_the_cat',9.00,16.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7229,14154,'Kat the Cat','','cat_the_cat',9.00,16.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7230,14155,'Kat the Cat','','cat_the_cat',9.00,16.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7231,14156,'Kat the Cat','','cat_the_cat',9.00,16.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7232,14157,'Kat the Cat','','cat_the_cat',9.00,16.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7233,14158,'Kat the Cat','','cat_the_cat',9.00,16.00,80,'male','L2Pet','npc',40,7085,23.310,2057,4.830,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,333,0,0,0,80,132,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7234,14159,'Mew the Cat','','cutie_cat',8.00,15.00,27,'female','L2Pet','npc',40,1310,7.470,367,1.680,40,43,30,21,20,25,0,0,103,125,45,117,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7235,14160,'Mew the Cat','','cutie_cat',8.00,15.00,37,'female','L2Pet','npc',40,2155,10.080,553,2.170,40,43,30,21,20,25,0,0,220,181,104,169,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7236,14161,'Mew the Cat','','cutie_cat',8.00,15.00,47,'female','L2Pet','npc',40,3128,12.690,816,2.730,40,43,30,21,20,25,0,0,401,245,202,229,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7237,14162,'Mew the Cat','','cutie_cat',8.00,15.00,54,'female','L2Pet','npc',40,4125,15.300,1102,3.360,40,43,30,21,20,25,0,0,634,311,339,292,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7238,14163,'Mew the Cat','','cutie_cat',8.00,15.00,22,'female','L2Pet','npc',40,984,6.210,279,1.610,40,43,30,21,20,25,0,0,67,102,28,95,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7239,14164,'Mew the Cat','','cutie_cat',8.00,15.00,32,'female','L2Pet','npc',40,1700,8.730,458,2.100,40,43,30,21,20,25,0,0,153,151,69,140,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7240,14165,'Mew the Cat','','cutie_cat',8.00,15.00,42,'female','L2Pet','npc',40,2673,11.520,679,2.660,40,43,30,21,20,25,0,0,311,214,152,201,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7241,14166,'Mew the Cat','','cutie_cat',8.00,15.00,50,'female','L2Pet','npc',40,3614,13.950,957,2.870,40,43,30,21,20,25,0,0,508,278,263,259,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7242,14167,'Mew the Cat','','cutie_cat',8.00,15.00,58,'female','L2Pet','npc',40,4651,16.650,1251,3.430,40,43,30,21,20,25,0,0,779,348,428,327,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7243,14168,'Mew the Cat','','cutie_cat',8.00,15.00,60,'female','L2Pet','npc',40,4917,17.280,1327,3.500,40,43,30,21,20,25,0,0,860,368,477,345,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7244,14169,'Mew the Cat','','cutie_cat',8.00,15.00,62,'female','L2Pet','npc',40,5183,18.000,1404,3.990,40,43,30,21,20,25,0,0,944,388,531,363,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7245,14170,'Mew the Cat','','cutie_cat',8.00,15.00,64,'female','L2Pet','npc',40,5448,18.720,1482,4.060,40,43,30,21,20,25,0,0,1031,408,588,381,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7246,14171,'Mew the Cat','','cutie_cat',8.00,15.00,66,'female','L2Pet','npc',40,5710,19.440,1561,4.060,40,43,30,21,20,25,0,0,1121,427,649,400,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7247,14172,'Mew the Cat','','cutie_cat',8.00,15.00,68,'female','L2Pet','npc',40,5967,20.250,1641,4.130,40,43,30,21,20,25,0,0,1217,449,713,420,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7248,14173,'Mew the Cat','','cutie_cat',8.00,15.00,70,'female','L2Pet','npc',40,6218,20.970,1722,4.200,40,43,30,21,20,25,0,0,1312,469,779,439,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7249,14174,'Mew the Cat','','cutie_cat',8.00,15.00,72,'female','L2Pet','npc',40,6461,21.780,1804,4.760,40,43,30,21,20,25,0,0,1412,491,848,459,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7250,14175,'Mew the Cat','','cutie_cat',8.00,15.00,74,'female','L2Pet','npc',40,6695,22.500,1888,4.760,40,43,30,21,20,25,0,0,1511,512,920,479,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7251,14176,'Mew the Cat','','cutie_cat',8.00,15.00,76,'female','L2Pet','npc',40,6919,23.310,1972,4.830,40,43,30,21,20,25,0,0,1613,532,993,498,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7252,14177,'Mew the Cat','','cutie_cat',8.00,15.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7253,14178,'Mew the Cat','','cutie_cat',8.00,15.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7254,14179,'Mew the Cat','','cutie_cat',8.00,15.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7255,14180,'Mew the Cat','','cutie_cat',8.00,15.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7256,14181,'Mew the Cat','','cutie_cat',8.00,15.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7257,14182,'Mew the Cat','','cutie_cat',8.00,15.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7258,14183,'Mew the Cat','','cutie_cat',8.00,15.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7259,14184,'Mew the Cat','','cutie_cat',8.00,15.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7260,14185,'Mew the Cat','','cutie_cat',8.00,15.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7261,14186,'Mew the Cat','','cutie_cat',8.00,15.00,79,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7262,14187,'Mew the Cat','','cutie_cat',8.00,15.00,79,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7263,14188,'Mew the Cat','','cutie_cat',8.00,15.00,79,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7264,14189,'Mew the Cat','','cutie_cat',8.00,15.00,79,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7265,14190,'Mew the Cat','','cutie_cat',8.00,15.00,79,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7266,14191,'Mew the Cat','','cutie_cat',8.00,15.00,79,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7267,14192,'Mew the Cat','','cutie_cat',8.00,15.00,79,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7268,14193,'Mew the Cat','','cutie_cat',8.00,15.00,79,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7269,14194,'Mew the Cat','','cutie_cat',8.00,15.00,79,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7270,14195,'Mew the Cat','','cutie_cat',8.00,15.00,80,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7271,14196,'Mew the Cat','','cutie_cat',8.00,15.00,80,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7272,14197,'Mew the Cat','','cutie_cat',8.00,15.00,80,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7273,14198,'Mew the Cat','','cutie_cat',8.00,15.00,80,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7274,14199,'Mew the Cat','','cutie_cat',8.00,15.00,80,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7275,14200,'Mew the Cat','','cutie_cat',8.00,15.00,80,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7276,14201,'Mew the Cat','','cutie_cat',8.00,15.00,80,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7277,14202,'Mew the Cat','','cutie_cat',8.00,15.00,80,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7278,14203,'Mew the Cat','','cutie_cat',8.00,15.00,80,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7279,14204,'Mew the Cat','','cutie_cat',8.00,15.00,80,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7280,14205,'Mew the Cat','','cutie_cat',8.00,15.00,80,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7281,14206,'Mew the Cat','','cutie_cat',8.00,15.00,80,'female','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7282,14207,'Kai the Cat','','silver_cat',7.00,15.00,42,'male','L2Pet','npc',40,2004,11.520,679,2.660,40,43,30,21,20,25,0,0,342,214,146,201,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7283,14208,'Kai the Cat','','silver_cat',7.00,15.00,46,'male','L2Pet','npc',40,2346,12.690,816,2.730,40,43,30,21,20,25,0,0,442,245,201,229,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7284,14209,'Kai the Cat','','silver_cat',7.00,15.00,50,'male','L2Pet','npc',40,2711,13.950,957,2.870,40,43,30,21,20,25,0,0,560,278,270,259,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7285,14210,'Kai the Cat','','silver_cat',7.00,15.00,54,'male','L2Pet','npc',40,3094,15.300,1102,3.360,40,43,30,21,20,25,0,0,699,311,358,292,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7286,14211,'Kai the Cat','','silver_cat',7.00,15.00,58,'male','L2Pet','npc',40,3489,16.650,1251,3.430,40,43,30,21,20,25,0,0,859,348,465,327,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7287,14212,'Kai the Cat','','silver_cat',7.00,15.00,60,'male','L2Pet','npc',40,3687,17.280,1327,3.500,40,43,30,21,20,25,0,0,948,368,526,345,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7288,14213,'Kai the Cat','','silver_cat',7.00,15.00,62,'male','L2Pet','npc',40,3888,18.000,1404,3.990,40,43,30,21,20,25,0,0,1040,388,592,363,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7289,14214,'Kai the Cat','','silver_cat',7.00,15.00,64,'male','L2Pet','npc',40,4086,18.720,1482,4.060,40,43,30,21,20,25,0,0,1137,408,664,381,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7290,14215,'Kai the Cat','','silver_cat',7.00,15.00,66,'male','L2Pet','npc',40,4282,19.440,1561,4.060,40,43,30,21,20,25,0,0,1235,427,743,400,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7291,14216,'Kai the Cat','','silver_cat',7.00,15.00,68,'male','L2Pet','npc',40,4475,20.250,1641,4.130,40,43,30,21,20,25,0,0,1341,449,826,420,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7292,14217,'Kai the Cat','','silver_cat',7.00,15.00,70,'male','L2Pet','npc',40,4664,20.970,1722,4.200,40,43,30,21,20,25,0,0,1446,469,916,439,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7293,14218,'Kai the Cat','','silver_cat',7.00,15.00,72,'male','L2Pet','npc',40,4846,21.780,1804,4.760,40,43,30,21,20,25,0,0,1556,491,1008,459,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7294,14219,'Kai the Cat','','silver_cat',7.00,15.00,74,'male','L2Pet','npc',40,5022,22.500,1888,4.760,40,43,30,21,20,25,0,0,1667,511,1107,479,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7295,14220,'Kai the Cat','','silver_cat',7.00,15.00,76,'male','L2Pet','npc',40,5189,23.310,1972,4.830,40,43,30,21,20,25,0,0,1779,532,1210,498,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7296,14221,'Kai the Cat','','silver_cat',7.00,15.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,519,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7297,14222,'Kai the Cat','','silver_cat',7.00,15.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7298,14223,'Kai the Cat','','silver_cat',7.00,15.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7299,14224,'Kai the Cat','','silver_cat',7.00,15.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7300,14225,'Kai the Cat','','silver_cat',7.00,15.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7301,14226,'Kai the Cat','','silver_cat',7.00,15.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7302,14227,'Kai the Cat','','silver_cat',7.00,15.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7303,14228,'Kai the Cat','','silver_cat',7.00,15.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7304,14229,'Kai the Cat','','silver_cat',7.00,15.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7305,14230,'Kai the Cat','','silver_cat',7.00,15.00,79,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,1983,558,1192,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7306,14231,'Kai the Cat','','silver_cat',7.00,15.00,79,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,1992,558,1204,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7307,14232,'Kai the Cat','','silver_cat',7.00,15.00,79,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2002,558,1216,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7308,14233,'Kai the Cat','','silver_cat',7.00,15.00,79,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2011,558,1228,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7309,14234,'Kai the Cat','','silver_cat',7.00,15.00,79,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2021,558,1240,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7310,14235,'Kai the Cat','','silver_cat',7.00,15.00,79,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2030,558,1253,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7311,14236,'Kai the Cat','','silver_cat',7.00,15.00,79,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2040,558,1265,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7312,14237,'Kai the Cat','','silver_cat',7.00,15.00,79,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2049,558,1277,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7313,14238,'Kai the Cat','','silver_cat',7.00,15.00,79,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2059,558,1289,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7314,14239,'Kai the Cat','','silver_cat',7.00,15.00,80,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2080,562,1317,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7315,14240,'Kai the Cat','','silver_cat',7.00,15.00,80,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2090,562,1329,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7316,14241,'Kai the Cat','','silver_cat',7.00,15.00,80,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2100,562,1342,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7317,14242,'Kai the Cat','','silver_cat',7.00,15.00,80,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2109,562,1354,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7318,14243,'Kai the Cat','','silver_cat',7.00,15.00,80,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2119,562,1366,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7319,14244,'Kai the Cat','','silver_cat',7.00,15.00,80,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2128,562,1379,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7320,14245,'Kai the Cat','','silver_cat',7.00,15.00,80,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2138,562,1391,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7321,14246,'Kai the Cat','','silver_cat',7.00,15.00,80,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2147,562,1403,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7322,14247,'Kai the Cat','','silver_cat',7.00,15.00,80,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2157,562,1416,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7323,14248,'Kai the Cat','','silver_cat',7.00,15.00,80,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2166,562,1428,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7324,14249,'Kai the Cat','','silver_cat',7.00,15.00,80,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2176,562,1440,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7325,14250,'Kai the Cat','','silver_cat',7.00,15.00,80,'male','L2Pet','npc',40,5314,24.120,2057,4.900,40,43,30,21,20,25,0,0,2185,562,1453,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.34,'false',0,0),
(7326,14251,'Feline Queen','','queen_of_cat',8.00,15.00,58,'female','L2Pet','npc',40,2889,16.650,1251,3.430,40,43,30,21,20,25,0,0,304,348,428,327,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7327,14252,'Feline Queen','','queen_of_cat',8.00,15.00,60,'female','L2Pet','npc',40,3054,17.280,1327,3.500,40,43,30,21,20,25,0,0,335,368,477,345,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7328,14253,'Feline Queen','','queen_of_cat',8.00,15.00,62,'female','L2Pet','npc',40,3219,18.000,1404,3.990,40,43,30,21,20,25,0,0,367,388,531,363,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7329,14254,'Feline Queen','','queen_of_cat',8.00,15.00,64,'female','L2Pet','npc',40,3384,18.720,1482,4.060,40,43,30,21,20,25,0,0,402,408,588,381,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7330,14255,'Feline Queen','','queen_of_cat',8.00,15.00,66,'female','L2Pet','npc',40,3546,19.440,1561,4.060,40,43,30,21,20,25,0,0,437,427,649,400,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7331,14256,'Feline Queen','','queen_of_cat',8.00,15.00,68,'female','L2Pet','npc',40,3706,20.250,1641,4.130,40,43,30,21,20,25,0,0,474,449,713,420,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7332,14257,'Feline Queen','','queen_of_cat',8.00,15.00,70,'female','L2Pet','npc',40,3862,20.970,1722,4.200,40,43,30,21,20,25,0,0,512,469,779,439,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7333,14258,'Feline Queen','','queen_of_cat',8.00,15.00,72,'female','L2Pet','npc',40,4013,21.780,1804,4.760,40,43,30,21,20,25,0,0,550,491,848,459,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7334,14259,'Feline Queen','','queen_of_cat',8.00,15.00,74,'female','L2Pet','npc',40,4158,22.500,1888,4.760,40,43,30,21,20,25,0,0,589,511,920,479,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7335,14260,'Feline Queen','','queen_of_cat',8.00,15.00,76,'female','L2Pet','npc',40,4297,23.310,1972,4.830,40,43,30,21,20,25,0,0,629,532,993,498,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7336,14265,'Feline Queen','','queen_of_cat',8.00,15.00,78,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7337,14266,'Feline Queen','','queen_of_cat',8.00,15.00,78,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7338,14267,'Feline Queen','','queen_of_cat',8.00,15.00,78,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7339,14268,'Feline Queen','','queen_of_cat',8.00,15.00,78,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7340,14269,'Feline Queen','','queen_of_cat',8.00,15.00,78,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7341,14270,'Feline Queen','','queen_of_cat',8.00,15.00,78,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7342,14271,'Feline Queen','','queen_of_cat',8.00,15.00,78,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7343,14272,'Feline Queen','','queen_of_cat',8.00,15.00,78,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7344,14273,'Feline Queen','','queen_of_cat',8.00,15.00,78,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7345,14274,'Feline Queen','','queen_of_cat',8.00,15.00,79,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7346,14275,'Feline Queen','','queen_of_cat',8.00,15.00,79,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7347,14276,'Feline Queen','','queen_of_cat',8.00,15.00,79,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7348,14277,'Feline Queen','','queen_of_cat',8.00,15.00,79,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7349,14278,'Feline Queen','','queen_of_cat',8.00,15.00,79,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7350,14279,'Feline Queen','','queen_of_cat',8.00,15.00,79,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7351,14280,'Feline Queen','','queen_of_cat',8.00,15.00,79,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7352,14281,'Feline Queen','','queen_of_cat',8.00,15.00,79,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7353,14282,'Feline Queen','','queen_of_cat',8.00,15.00,79,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7354,14283,'Feline Queen','','queen_of_cat',8.00,15.00,80,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7355,14284,'Feline Queen','','queen_of_cat',8.00,15.00,80,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7356,14285,'Feline Queen','','queen_of_cat',8.00,15.00,80,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7357,14286,'Feline Queen','','queen_of_cat',8.00,15.00,80,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7358,14287,'Feline Queen','','queen_of_cat',8.00,15.00,80,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7359,14288,'Feline Queen','','queen_of_cat',8.00,15.00,80,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7360,14289,'Feline Queen','','queen_of_cat',8.00,15.00,80,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7361,14290,'Feline Queen','','queen_of_cat',8.00,15.00,80,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7362,14291,'Feline Queen','','queen_of_cat',8.00,15.00,80,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7363,14292,'Feline Queen','','queen_of_cat',8.00,15.00,80,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7364,14293,'Feline Queen','','queen_of_cat',8.00,15.00,80,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7365,14294,'Feline Queen','','queen_of_cat',8.00,15.00,80,'female','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,26,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.48,'false',0,0),
(7366,14295,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,22,'male','L2Pet','npc',40,984,6.210,279,1.610,40,43,30,21,20,25,0,0,67,102,28,95,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7367,14296,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,32,'male','L2Pet','npc',40,1700,8.730,458,2.100,40,43,30,21,20,25,0,0,153,151,69,140,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7368,14297,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,42,'male','L2Pet','npc',40,2673,11.520,679,2.660,40,43,30,21,20,25,0,0,311,214,152,201,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7369,14298,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,50,'male','L2Pet','npc',40,3614,13.950,957,2.870,40,43,30,21,20,25,0,0,508,278,263,259,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7370,14299,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,58,'male','L2Pet','npc',40,4651,16.650,1251,3.430,40,43,30,21,20,25,0,0,779,348,428,327,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7371,14300,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,27,'male','L2Pet','npc',40,1310,7.470,367,1.680,40,43,30,21,20,25,0,0,103,125,45,117,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7372,14301,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,37,'male','L2Pet','npc',40,2155,10.080,553,2.170,40,43,30,21,20,25,0,0,220,181,104,169,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7373,14302,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,46,'male','L2Pet','npc',40,3128,12.690,816,2.730,40,43,30,21,20,25,0,0,401,245,202,229,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7374,14303,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,54,'male','L2Pet','npc',40,4125,15.300,1102,3.360,40,43,30,21,20,25,0,0,634,311,339,292,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7375,14304,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,60,'male','L2Pet','npc',40,4917,17.280,1327,3.500,40,43,30,21,20,25,0,0,860,368,477,345,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7376,14305,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,62,'male','L2Pet','npc',40,5183,18.000,1404,3.990,40,43,30,21,20,25,0,0,944,388,531,363,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7377,14306,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,64,'male','L2Pet','npc',40,5448,18.720,1482,4.060,40,43,30,21,20,25,0,0,1031,408,588,381,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7378,14307,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,66,'male','L2Pet','npc',40,5710,19.440,1561,4.060,40,43,30,21,20,25,0,0,1121,427,649,400,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7379,14308,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,68,'male','L2Pet','npc',40,5967,20.250,1641,4.130,40,43,30,21,20,25,0,0,1217,449,713,420,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7380,14309,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,70,'male','L2Pet','npc',40,6218,20.970,1722,4.200,40,43,30,21,20,25,0,0,1312,469,779,439,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7381,14310,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,72,'male','L2Pet','npc',40,6461,21.780,1804,4.760,40,43,30,21,20,25,0,0,1412,491,848,459,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7382,14311,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,74,'male','L2Pet','npc',40,6695,22.500,1888,4.760,40,43,30,21,20,25,0,0,1511,511,920,479,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7383,14312,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,76,'male','L2Pet','npc',40,6919,23.310,1972,4.830,40,43,30,21,20,25,0,0,1613,532,993,498,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7384,14313,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7385,14314,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7386,14315,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7387,14316,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7388,14317,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7389,14318,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7390,14319,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7391,14320,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7392,14321,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7393,14322,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,79,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7394,14323,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,79,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7395,14324,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,79,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7396,14325,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,79,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7397,14326,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,79,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7398,14327,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,79,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7399,14328,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,79,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7400,14329,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,79,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7401,14330,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,79,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7402,14331,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,80,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7403,14332,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,80,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7404,14333,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,80,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7405,14334,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,80,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7406,14335,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,80,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7407,14336,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,80,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7408,14337,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,80,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7409,14338,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,80,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7410,14339,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,80,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7411,14340,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,80,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7412,14341,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,80,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7413,14342,'Boxer the Unicorn','','unicorn_boxer',11.00,18.00,80,'male','L2Pet','npc',40,7085,24.120,2057,4.900,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7414,14343,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,27,'male','L2Pet','npc',40,1310,7.470,367,1.680,40,43,30,21,20,25,0,0,103,125,45,117,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7415,14344,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,37,'male','L2Pet','npc',40,2155,10.080,553,2.170,40,43,30,21,20,25,0,0,220,181,104,169,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7416,14345,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,47,'male','L2Pet','npc',40,3128,12.690,816,2.730,40,43,30,21,20,25,0,0,401,245,202,229,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7417,14346,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,54,'male','L2Pet','npc',40,4125,15.300,1102,3.360,40,43,30,21,20,25,0,0,634,311,339,292,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7418,14347,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,22,'male','L2Pet','npc',40,984,6.210,279,1.610,40,43,30,21,20,25,0,0,67,102,28,95,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7419,14348,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,32,'male','L2Pet','npc',40,1700,8.730,458,2.100,40,43,30,21,20,25,0,0,153,151,69,140,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7420,14349,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,42,'male','L2Pet','npc',40,2673,11.520,679,2.660,40,43,30,21,20,25,0,0,311,214,152,201,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7421,14350,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,50,'male','L2Pet','npc',40,3614,13.950,957,2.870,40,43,30,21,20,25,0,0,508,278,263,259,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7422,14351,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,58,'male','L2Pet','npc',40,4651,16.650,1251,3.430,40,43,30,21,20,25,0,0,779,348,428,327,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7423,14352,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,60,'male','L2Pet','npc',40,4917,17.280,1327,3.500,40,43,30,21,20,25,0,0,860,368,477,345,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7424,14353,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,62,'male','L2Pet','npc',40,5183,18.000,1404,3.990,40,43,30,21,20,25,0,0,944,388,531,363,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7425,14354,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,64,'male','L2Pet','npc',40,5448,18.720,1482,4.060,40,43,30,21,20,25,0,0,1031,408,588,381,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7426,14355,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,66,'male','L2Pet','npc',40,5710,19.440,1561,4.060,40,43,30,21,20,25,0,0,1121,427,649,400,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7427,14356,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,68,'male','L2Pet','npc',40,5967,20.250,1641,4.130,40,43,30,21,20,25,0,0,1217,449,713,420,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7428,14357,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,70,'male','L2Pet','npc',40,6218,20.970,1722,4.200,40,43,30,21,20,25,0,0,1312,469,779,439,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7429,14358,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,72,'male','L2Pet','npc',40,6461,21.780,1804,4.760,40,43,30,21,20,25,0,0,1412,491,848,459,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7430,14359,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,74,'male','L2Pet','npc',40,6695,22.500,1888,4.760,40,43,30,21,20,25,0,0,1511,511,920,479,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7431,14360,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,76,'male','L2Pet','npc',40,6919,23.310,1972,4.830,40,43,30,21,20,25,0,0,1613,532,993,498,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7432,14361,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7433,14362,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,555,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7434,14363,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,555,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7435,14364,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,555,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7436,14365,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,555,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7437,14366,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,555,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7438,14367,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,555,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7439,14368,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,555,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7440,14369,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,555,1068,519,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7441,14370,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7442,14371,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7443,14372,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7444,14373,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7445,14374,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7446,14375,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7447,14376,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7448,14377,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7449,14378,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7450,14379,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7451,14380,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7452,14381,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7453,14382,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7454,14383,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7455,14384,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7456,14385,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7457,14386,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7458,14387,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7459,14388,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7460,14389,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7461,14390,'Mirage the Unicorn','','unicorn_mirage',13.00,17.50,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7462,14391,'Merrow the Unicorn','','blue_eye',11.00,16.00,42,'male','L2Pet','npc',40,2004,11.520,679,2.660,40,43,30,21,20,25,0,0,342,214,146,201,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7463,14392,'Merrow the Unicorn','','blue_eye',11.00,16.00,46,'male','L2Pet','npc',40,2346,12.690,816,2.730,40,43,30,21,20,25,0,0,442,245,201,229,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7464,14393,'Merrow the Unicorn','','blue_eye',11.00,16.00,50,'male','L2Pet','npc',40,2711,13.950,957,2.870,40,43,30,21,20,25,0,0,560,278,270,259,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7465,14394,'Merrow the Unicorn','','blue_eye',11.00,16.00,54,'male','L2Pet','npc',40,3094,15.300,1102,3.360,40,43,30,21,20,25,0,0,699,311,358,292,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7466,14395,'Merrow the Unicorn','','blue_eye',11.00,16.00,58,'male','L2Pet','npc',40,3489,16.650,1251,3.430,40,43,30,21,20,25,0,0,859,348,465,327,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7467,14396,'Merrow the Unicorn','','blue_eye',11.00,16.00,60,'male','L2Pet','npc',40,3687,17.280,1327,3.500,40,43,30,21,20,25,0,0,948,368,526,345,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7468,14397,'Merrow the Unicorn','','blue_eye',11.00,16.00,62,'male','L2Pet','npc',40,3888,18.000,1404,3.990,40,43,30,21,20,25,0,0,1040,388,592,363,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7469,14398,'Merrow the Unicorn','','blue_eye',11.00,16.00,64,'male','L2Pet','npc',40,4086,18.720,1482,4.060,40,43,30,21,20,25,0,0,1137,408,664,381,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7470,14399,'Merrow the Unicorn','','blue_eye',11.00,16.00,66,'male','L2Pet','npc',40,4282,19.440,1561,4.060,40,43,30,21,20,25,0,0,1235,427,743,400,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7471,14400,'Merrow the Unicorn','','blue_eye',11.00,16.00,68,'male','L2Pet','npc',40,4475,20.250,1641,4.130,40,43,30,21,20,25,0,0,1341,449,826,420,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7472,14401,'Merrow the Unicorn','','blue_eye',11.00,16.00,70,'male','L2Pet','npc',40,4664,20.970,1722,4.200,40,43,30,21,20,25,0,0,1446,469,916,439,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7473,14402,'Merrow the Unicorn','','blue_eye',11.00,16.00,72,'male','L2Pet','npc',40,4846,21.780,1804,4.760,40,43,30,21,20,25,0,0,1556,491,1008,459,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7474,14403,'Merrow the Unicorn','','blue_eye',11.00,16.00,74,'male','L2Pet','npc',40,5022,22.500,1888,4.760,40,43,30,21,20,25,0,0,1667,511,1107,479,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7475,14404,'Merrow the Unicorn','','blue_eye',11.00,16.00,76,'male','L2Pet','npc',40,5189,23.310,1972,4.830,40,43,30,21,20,25,0,0,1779,532,1210,498,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7476,14405,'Merrow the Unicorn','','blue_eye',11.00,16.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,519,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7477,14406,'Merrow the Unicorn','','blue_eye',11.00,16.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,519,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7478,14407,'Merrow the Unicorn','','blue_eye',11.00,16.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,519,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7479,14408,'Merrow the Unicorn','','blue_eye',11.00,16.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,519,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7480,14409,'Merrow the Unicorn','','blue_eye',11.00,16.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,519,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7481,14410,'Merrow the Unicorn','','blue_eye',11.00,16.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,519,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7482,14411,'Merrow the Unicorn','','blue_eye',11.00,16.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,519,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7483,14412,'Merrow the Unicorn','','blue_eye',11.00,16.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,519,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7484,14413,'Merrow the Unicorn','','blue_eye',11.00,16.00,78,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1884,554,1293,519,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7485,14414,'Merrow the Unicorn','','blue_eye',11.00,16.00,79,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1983,558,1293,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7486,14415,'Merrow the Unicorn','','blue_eye',11.00,16.00,79,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,1992,558,1293,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7487,14416,'Merrow the Unicorn','','blue_eye',11.00,16.00,79,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2002,558,1293,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7488,14417,'Merrow the Unicorn','','blue_eye',11.00,16.00,79,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2011,558,1293,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7489,14418,'Merrow the Unicorn','','blue_eye',11.00,16.00,79,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2021,558,1293,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7490,14419,'Merrow the Unicorn','','blue_eye',11.00,16.00,79,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2030,558,1293,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7491,14420,'Merrow the Unicorn','','blue_eye',11.00,16.00,79,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2040,558,1293,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7492,14421,'Merrow the Unicorn','','blue_eye',11.00,16.00,79,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2049,558,1293,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7493,14422,'Merrow the Unicorn','','blue_eye',11.00,16.00,79,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2059,558,1293,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7494,14423,'Merrow the Unicorn','','blue_eye',11.00,16.00,80,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2080,562,1317,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7495,14424,'Merrow the Unicorn','','blue_eye',11.00,16.00,80,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2090,562,1329,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7496,14425,'Merrow the Unicorn','','blue_eye',11.00,16.00,80,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2100,562,1342,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7497,14426,'Merrow the Unicorn','','blue_eye',11.00,16.00,80,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2109,562,1354,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7498,14427,'Merrow the Unicorn','','blue_eye',11.00,16.00,80,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2119,562,1366,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7499,14428,'Merrow the Unicorn','','blue_eye',11.00,16.00,80,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2128,562,1379,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7500,14429,'Merrow the Unicorn','','blue_eye',11.00,16.00,80,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2138,562,1391,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7501,14430,'Merrow the Unicorn','','blue_eye',11.00,16.00,80,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2147,562,1403,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7502,14431,'Merrow the Unicorn','','blue_eye',11.00,16.00,80,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2157,562,1416,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7503,14432,'Merrow the Unicorn','','blue_eye',11.00,16.00,80,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2166,562,1428,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7504,14433,'Merrow the Unicorn','','blue_eye',11.00,16.00,80,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2176,562,1440,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7505,14434,'Merrow the Unicorn','','blue_eye',11.00,16.00,80,'male','L2Pet','npc',40,5358,24.120,2057,4.900,40,43,30,21,20,25,0,0,2185,562,1453,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,10,0.71,'false',0,0),
(7506,14435,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,58,'male','L2Pet','npc',40,2889,16.650,1251,3.430,40,43,30,21,20,25,0,0,304,348,428,327,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7507,14436,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,60,'male','L2Pet','npc',40,3054,17.280,1327,3.500,40,43,30,21,20,25,0,0,335,368,477,345,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7508,14437,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,62,'male','L2Pet','npc',40,3219,18.000,1404,3.990,40,43,30,21,20,25,0,0,368,388,531,363,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7509,14438,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,64,'male','L2Pet','npc',40,3384,18.720,1482,4.060,40,43,30,21,20,25,0,0,402,408,588,381,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7510,14439,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,66,'male','L2Pet','npc',40,3546,19.440,1561,4.060,40,43,30,21,20,25,0,0,437,427,649,400,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7511,14440,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,68,'male','L2Pet','npc',40,3706,20.250,1641,4.130,40,43,30,21,20,25,0,0,474,449,713,420,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7512,14441,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,70,'male','L2Pet','npc',40,3862,20.970,1722,4.200,40,43,30,21,20,25,0,0,512,469,779,439,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7513,14442,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,72,'male','L2Pet','npc',40,4013,21.780,1804,4.760,40,43,30,21,20,25,0,0,550,491,848,459,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7514,14443,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,74,'male','L2Pet','npc',40,4158,22.500,1888,4.760,40,43,30,21,20,25,0,0,589,511,920,479,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7515,14444,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,76,'male','L2Pet','npc',40,4297,23.310,1972,4.830,40,43,30,21,20,25,0,0,629,532,993,498,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.71,'false',0,0),
(7516,14449,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,78,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7517,14450,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,78,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7518,14451,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,78,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7519,14452,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,78,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7520,14453,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,78,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7521,14454,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,78,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7522,14455,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,78,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7523,14456,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,78,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7524,14457,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,78,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7525,14458,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,79,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7526,14459,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,79,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7527,14460,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,79,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7528,14461,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,79,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7529,14462,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,79,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7530,14463,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,79,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7531,14464,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,79,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7532,14465,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,79,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7533,14466,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,79,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7534,14467,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,80,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7535,14468,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,80,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7536,14469,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,80,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7537,14470,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,80,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7538,14471,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,80,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7539,14472,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,80,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7540,14473,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,80,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7541,14474,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,80,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7542,14475,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,80,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7543,14476,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,80,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7544,14477,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,80,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7545,14478,'Unicorn Seraphim','','angelic_unicorn',9.00,25.50,80,'male','L2Pet','npc',40,4428,23.310,2057,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,27,154,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.71,'false',0,0),
(7546,14479,'Shadow','','shadow',10.00,30.00,22,'male','L2Pet','npc',40,984,6.210,279,1.610,40,43,30,21,20,25,0,0,67,102,28,95,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7547,14480,'Shadow','','shadow',10.00,30.00,32,'male','L2Pet','npc',40,1700,8.730,458,2.100,40,43,30,21,20,25,0,0,153,151,69,140,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7548,14481,'Shadow','','shadow',10.00,30.00,42,'male','L2Pet','npc',40,2673,11.520,679,2.660,40,43,30,21,20,25,0,0,311,214,152,201,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7549,14482,'Shadow','','shadow',10.00,30.00,50,'male','L2Pet','npc',40,3614,13.950,957,2.870,40,43,30,21,20,25,0,0,508,278,263,259,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7550,14483,'Shadow','','shadow',10.00,30.00,58,'male','L2Pet','npc',40,4651,16.650,1251,3.430,40,43,30,21,20,25,0,0,779,348,428,327,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7551,14484,'Shadow','','shadow',10.00,30.00,27,'male','L2Pet','npc',40,1310,7.470,367,1.680,40,43,30,21,20,25,0,0,103,125,45,117,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7552,14485,'Shadow','','shadow',10.00,30.00,37,'male','L2Pet','npc',40,2155,10.080,553,2.170,40,43,30,21,20,25,0,0,220,181,104,169,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7553,14486,'Shadow','','shadow',10.00,30.00,46,'male','L2Pet','npc',40,3128,12.690,816,2.730,40,43,30,21,20,25,0,0,401,245,202,229,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7554,14487,'Shadow','','shadow',10.00,30.00,54,'male','L2Pet','npc',40,4125,15.300,1102,3.360,40,43,30,21,20,25,0,0,634,311,339,292,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7555,14488,'Shadow','','shadow',10.00,30.00,60,'male','L2Pet','npc',40,4917,17.280,1327,3.500,40,43,30,21,20,25,0,0,860,368,477,345,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7556,14489,'Shadow','','shadow',10.00,30.00,62,'male','L2Pet','npc',40,5183,18.000,1404,3.990,40,43,30,21,20,25,0,0,944,388,531,363,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7557,14490,'Shadow','','shadow',10.00,30.00,64,'male','L2Pet','npc',40,5448,18.720,1482,4.060,40,43,30,21,20,25,0,0,1031,408,588,381,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7558,14491,'Shadow','','shadow',10.00,30.00,66,'male','L2Pet','npc',40,5710,19.440,1561,4.060,40,43,30,21,20,25,0,0,1121,427,649,400,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7559,14492,'Shadow','','shadow',10.00,30.00,68,'male','L2Pet','npc',40,5967,20.250,1641,4.130,40,43,30,21,20,25,0,0,1217,449,713,420,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7560,14493,'Shadow','','shadow',10.00,30.00,70,'male','L2Pet','npc',40,6218,20.970,1722,4.200,40,43,30,21,20,25,0,0,1312,469,779,439,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7561,14494,'Shadow','','shadow',10.00,30.00,72,'male','L2Pet','npc',40,6461,21.780,1804,4.760,40,43,30,21,20,25,0,0,1412,491,848,459,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7562,14495,'Shadow','','shadow',10.00,30.00,74,'male','L2Pet','npc',40,6695,22.500,1888,4.760,40,43,30,21,20,25,0,0,1511,511,920,479,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7563,14496,'Shadow','','shadow',10.00,30.00,76,'male','L2Pet','npc',40,6919,23.310,1972,4.830,40,43,30,21,20,25,0,0,1613,532,993,498,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7564,14497,'Shadow','','shadow',10.00,30.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7565,14498,'Shadow','','shadow',10.00,30.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7566,14499,'Shadow','','shadow',10.00,30.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7567,14500,'Shadow','','shadow',10.00,30.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7568,14501,'Shadow','','shadow',10.00,30.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7569,14502,'Shadow','','shadow',10.00,30.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7570,14503,'Shadow','','shadow',10.00,30.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7571,14504,'Shadow','','shadow',10.00,30.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7572,14505,'Shadow','','shadow',10.00,30.00,78,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7573,14506,'Shadow','','shadow',10.00,30.00,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7574,14507,'Shadow','','shadow',10.00,30.00,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7575,14508,'Shadow','','shadow',10.00,30.00,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7576,14509,'Shadow','','shadow',10.00,30.00,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7577,14510,'Shadow','','shadow',10.00,30.00,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7578,14511,'Shadow','','shadow',10.00,30.00,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7579,14512,'Shadow','','shadow',10.00,30.00,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7580,14513,'Shadow','','shadow',10.00,30.00,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7581,14514,'Shadow','','shadow',10.00,30.00,79,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7582,14515,'Shadow','','shadow',10.00,30.00,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7583,14516,'Shadow','','shadow',10.00,30.00,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7584,14517,'Shadow','','shadow',10.00,30.00,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7585,14518,'Shadow','','shadow',10.00,30.00,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7586,14519,'Shadow','','shadow',10.00,30.00,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7587,14520,'Shadow','','shadow',10.00,30.00,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7588,14521,'Shadow','','shadow',10.00,30.00,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7589,14522,'Shadow','','shadow',10.00,30.00,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7590,14523,'Shadow','','shadow',10.00,30.00,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7591,14524,'Shadow','','shadow',10.00,30.00,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7592,14525,'Shadow','','shadow',10.00,30.00,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7593,14526,'Shadow','','shadow',10.00,30.00,80,'male','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7642,14575,'Soulless','','shadeless',7.00,28.00,42,'male','L2Pet','npc',40,2008,11.520,679,2.660,40,43,30,21,20,25,0,0,342,214,183,201,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7643,14576,'Soulless','','shadeless',7.00,28.00,46,'male','L2Pet','npc',40,2351,12.690,816,2.730,40,43,30,21,20,25,0,0,441,245,244,229,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7644,14577,'Soulless','','shadeless',7.00,28.00,50,'male','L2Pet','npc',40,2716,13.950,957,2.870,40,43,30,21,20,25,0,0,559,278,319,259,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7645,14578,'Soulless','','shadeless',7.00,28.00,54,'male','L2Pet','npc',40,3100,15.300,1102,3.360,40,43,30,21,20,25,0,0,698,311,410,292,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7646,14579,'Soulless','','shadeless',7.00,28.00,58,'male','L2Pet','npc',40,3496,16.650,1251,3.430,40,43,30,21,20,25,0,0,857,348,518,327,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7647,14580,'Soulless','','shadeless',7.00,28.00,60,'male','L2Pet','npc',40,3695,17.280,1327,3.500,40,43,30,21,20,25,0,0,946,368,578,345,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7648,14581,'Soulless','','shadeless',7.00,28.00,62,'male','L2Pet','npc',40,3895,18.000,1404,3.990,40,43,30,21,20,25,0,0,1038,388,642,363,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7649,14582,'Soulless','','shadeless',7.00,28.00,64,'male','L2Pet','npc',40,4094,18.720,1482,4.060,40,43,30,21,20,25,0,0,1135,408,711,381,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7650,14583,'Soulless','','shadeless',7.00,28.00,66,'male','L2Pet','npc',40,4291,19.440,1561,4.060,40,43,30,21,20,25,0,0,1233,427,785,400,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7651,14584,'Soulless','','shadeless',7.00,28.00,68,'male','L2Pet','npc',40,4484,20.250,1641,4.130,40,43,30,21,20,25,0,0,1338,449,862,420,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7652,14585,'Soulless','','shadeless',7.00,28.00,70,'male','L2Pet','npc',40,4673,20.970,1722,4.200,40,43,30,21,20,25,0,0,1443,469,943,439,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7653,14586,'Soulless','','shadeless',7.00,28.00,72,'male','L2Pet','npc',40,4856,21.780,1804,4.760,40,43,30,21,20,25,0,0,1553,491,1026,459,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7654,14587,'Soulless','','shadeless',7.00,28.00,74,'male','L2Pet','npc',40,5032,22.500,1888,4.760,40,43,30,21,20,25,0,0,1663,511,1113,479,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7655,14588,'Soulless','','shadeless',7.00,28.00,76,'male','L2Pet','npc',40,5200,23.310,1972,4.830,40,43,30,21,20,25,0,0,1775,532,1201,498,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7656,14589,'Soulless','','shadeless',7.00,28.00,78,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,1886,555,1201,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7657,14590,'Soulless','','shadeless',7.00,28.00,78,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,1895,555,1201,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7658,14591,'Soulless','','shadeless',7.00,28.00,78,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,1905,555,1201,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7659,14592,'Soulless','','shadeless',7.00,28.00,78,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,1914,555,1201,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7660,14593,'Soulless','','shadeless',7.00,28.00,78,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,1924,555,1201,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7661,14594,'Soulless','','shadeless',7.00,28.00,78,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,1933,555,1201,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7662,14595,'Soulless','','shadeless',7.00,28.00,78,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,1943,555,1201,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7663,14596,'Soulless','','shadeless',7.00,28.00,78,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,1952,555,1201,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7664,14597,'Soulless','','shadeless',7.00,28.00,78,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,1962,555,1201,520,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7665,14598,'Soulless','','shadeless',7.00,28.00,79,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,1983,558,1201,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7666,14599,'Soulless','','shadeless',7.00,28.00,79,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,1992,558,1204,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7667,14600,'Soulless','','shadeless',7.00,28.00,79,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2002,558,1216,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7668,14601,'Soulless','','shadeless',7.00,28.00,79,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2011,558,1228,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7669,14602,'Soulless','','shadeless',7.00,28.00,79,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2021,558,1240,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7670,14603,'Soulless','','shadeless',7.00,28.00,79,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2030,558,1253,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7671,14604,'Soulless','','shadeless',7.00,28.00,79,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2040,558,1265,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7672,14605,'Soulless','','shadeless',7.00,28.00,79,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2049,558,1277,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7673,14606,'Soulless','','shadeless',7.00,28.00,79,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2059,558,1289,523,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7674,14607,'Soulless','','shadeless',7.00,28.00,80,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2080,562,1317,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7675,14608,'Soulless','','shadeless',7.00,28.00,80,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2090,562,1329,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7676,14609,'Soulless','','shadeless',7.00,28.00,80,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2100,562,1342,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7677,14610,'Soulless','','shadeless',7.00,28.00,80,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2109,562,1354,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7678,14611,'Soulless','','shadeless',7.00,28.00,80,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2119,562,1366,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7679,14612,'Soulless','','shadeless',7.00,28.00,80,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2128,562,1379,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7680,14613,'Soulless','','shadeless',7.00,28.00,80,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2138,562,1391,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7681,14614,'Soulless','','shadeless',7.00,28.00,80,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2147,562,1403,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7682,14615,'Soulless','','shadeless',7.00,28.00,80,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2157,562,1416,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7683,14616,'Soulless','','shadeless',7.00,28.00,80,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2166,562,1428,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7684,14617,'Soulless','','shadeless',7.00,28.00,80,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2176,562,1440,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7685,14618,'Soulless','','shadeless',7.00,28.00,80,'male','L2Pet','npc',40,5314,23.310,2057,4.830,40,43,30,21,20,25,0,0,2185,562,1453,526,278,0,333,0,0,0,48,198,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.61,'false',0,0),
(7594,14527,'Silhouette','','silhouette',8.00,23.00,27,'female','L2Pet','npc',40,1310,7.470,367,1.680,40,43,30,21,20,25,0,0,103,125,45,117,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7595,14528,'Silhouette','','silhouette',8.00,23.00,37,'female','L2Pet','npc',40,2155,10.080,553,2.170,40,43,30,21,20,25,0,0,220,181,104,169,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7596,14529,'Silhouette','','silhouette',8.00,23.00,47,'female','L2Pet','npc',40,3128,12.690,816,2.730,40,43,30,21,20,25,0,0,401,245,202,229,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7597,14530,'Silhouette','','silhouette',8.00,23.00,54,'female','L2Pet','npc',40,4125,15.300,1102,3.360,40,43,30,21,20,25,0,0,634,311,339,292,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7598,14531,'Silhouette','','silhouette',8.00,23.00,22,'female','L2Pet','npc',40,984,6.210,279,1.610,40,43,30,21,20,25,0,0,67,102,28,95,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7599,14532,'Silhouette','','silhouette',8.00,23.00,32,'female','L2Pet','npc',40,1700,8.730,458,2.100,40,43,30,21,20,25,0,0,153,151,69,140,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7600,14533,'Silhouette','','silhouette',8.00,23.00,42,'female','L2Pet','npc',40,2673,11.520,679,2.660,40,43,30,21,20,25,0,0,311,214,152,201,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7601,14534,'Silhouette','','silhouette',8.00,23.00,50,'female','L2Pet','npc',40,3614,13.950,957,2.870,40,43,30,21,20,25,0,0,508,278,263,259,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7602,14535,'Silhouette','','silhouette',8.00,23.00,58,'female','L2Pet','npc',40,4651,16.650,1251,3.430,40,43,30,21,20,25,0,0,779,348,428,327,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7603,14536,'Silhouette','','silhouette',8.00,23.00,60,'female','L2Pet','npc',40,4917,17.280,1327,3.500,40,43,30,21,20,25,0,0,860,368,477,345,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7604,14537,'Silhouette','','silhouette',8.00,23.00,62,'female','L2Pet','npc',40,5183,18.000,1404,3.990,40,43,30,21,20,25,0,0,944,388,531,363,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7605,14538,'Silhouette','','silhouette',8.00,23.00,64,'female','L2Pet','npc',40,5448,18.720,1482,4.060,40,43,30,21,20,25,0,0,1031,408,588,381,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7606,14539,'Silhouette','','silhouette',8.00,23.00,66,'female','L2Pet','npc',40,5710,19.440,1561,4.060,40,43,30,21,20,25,0,0,1121,427,649,400,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7607,14540,'Silhouette','','silhouette',8.00,23.00,68,'female','L2Pet','npc',40,5967,20.250,1641,4.130,40,43,30,21,20,25,0,0,1217,449,713,420,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7608,14541,'Silhouette','','silhouette',8.00,23.00,70,'female','L2Pet','npc',40,6218,20.970,1722,4.200,40,43,30,21,20,25,0,0,1312,469,779,439,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7609,14542,'Silhouette','','silhouette',8.00,23.00,72,'female','L2Pet','npc',40,6461,21.780,1804,4.760,40,43,30,21,20,25,0,0,1412,491,848,459,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7610,14543,'Silhouette','','silhouette',8.00,23.00,74,'female','L2Pet','npc',40,6695,22.500,1888,4.760,40,43,30,21,20,25,0,0,1511,511,920,479,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7611,14544,'Silhouette','','silhouette',8.00,23.00,76,'female','L2Pet','npc',40,6919,23.310,1972,4.830,40,43,30,21,20,25,0,0,1613,532,993,498,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7612,14545,'Silhouette','','silhouette',8.00,23.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7613,14546,'Silhouette','','silhouette',8.00,23.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7614,14547,'Silhouette','','silhouette',8.00,23.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7615,14548,'Silhouette','','silhouette',8.00,23.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7616,14549,'Silhouette','','silhouette',8.00,23.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7617,14550,'Silhouette','','silhouette',8.00,23.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7618,14551,'Silhouette','','silhouette',8.00,23.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7619,14552,'Silhouette','','silhouette',8.00,23.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7620,14553,'Silhouette','','silhouette',8.00,23.00,78,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7621,14554,'Silhouette','','silhouette',8.00,23.00,79,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1802,554,1068,519,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7622,14555,'Silhouette','','silhouette',8.00,23.00,79,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7623,14556,'Silhouette','','silhouette',8.00,23.00,79,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7624,14557,'Silhouette','','silhouette',8.00,23.00,79,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7625,14558,'Silhouette','','silhouette',8.00,23.00,79,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7626,14559,'Silhouette','','silhouette',8.00,23.00,79,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7627,14560,'Silhouette','','silhouette',8.00,23.00,79,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7628,14561,'Silhouette','','silhouette',8.00,23.00,79,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7629,14562,'Silhouette','','silhouette',8.00,23.00,79,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7630,14563,'Silhouette','','silhouette',8.00,23.00,80,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7631,14564,'Silhouette','','silhouette',8.00,23.00,80,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7632,14565,'Silhouette','','silhouette',8.00,23.00,80,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7633,14566,'Silhouette','','silhouette',8.00,23.00,80,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7634,14567,'Silhouette','','silhouette',8.00,23.00,80,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7635,14568,'Silhouette','','silhouette',8.00,23.00,80,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7636,14569,'Silhouette','','silhouette',8.00,23.00,80,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7637,14570,'Silhouette','','silhouette',8.00,23.00,80,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7638,14571,'Silhouette','','silhouette',8.00,23.00,80,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7639,14572,'Silhouette','','silhouette',8.00,23.00,80,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7640,14573,'Silhouette','','silhouette',8.00,23.00,80,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7641,14574,'Silhouette','','silhouette',8.00,23.00,80,'female','L2Pet','npc',40,7130,24.120,2057,4.900,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,333,0,0,0,80,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.54,'false',0,0),
(7686,14619,'Nightshade','','knight_of_shadow',10.00,35.50,58,'male','L2Pet','npc',40,5779,16.650,1251,3.430,40,43,30,21,20,25,0,0,304,348,428,327,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7687,14620,'Nightshade','','knight_of_shadow',10.00,35.50,60,'male','L2Pet','npc',40,6109,17.280,1327,3.500,40,43,30,21,20,25,0,0,335,368,477,345,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7688,14621,'Nightshade','','knight_of_shadow',10.00,35.50,62,'male','L2Pet','npc',40,6439,18.000,1404,3.990,40,43,30,21,20,25,0,0,367,388,531,363,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7689,14622,'Nightshade','','knight_of_shadow',10.00,35.50,64,'male','L2Pet','npc',40,6768,18.720,1482,4.060,40,43,30,21,20,25,0,0,402,408,588,381,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7690,14623,'Nightshade','','knight_of_shadow',10.00,35.50,66,'male','L2Pet','npc',40,7093,19.440,1561,4.060,40,43,30,21,20,25,0,0,437,427,649,400,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7691,14624,'Nightshade','','knight_of_shadow',10.00,35.50,68,'male','L2Pet','npc',40,7412,20.250,1641,4.130,40,43,30,21,20,25,0,0,474,449,713,420,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7692,14625,'Nightshade','','knight_of_shadow',10.00,35.50,70,'male','L2Pet','npc',40,7724,20.970,1722,4.200,40,43,30,21,20,25,0,0,512,469,779,439,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7693,14626,'Nightshade','','knight_of_shadow',10.00,35.50,72,'male','L2Pet','npc',40,8026,21.780,1804,4.760,40,43,30,21,20,25,0,0,550,491,848,459,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7694,14627,'Nightshade','','knight_of_shadow',10.00,35.50,74,'male','L2Pet','npc',40,8317,22.500,1888,4.760,40,43,30,21,20,25,0,0,589,511,920,479,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7695,14628,'Nightshade','','knight_of_shadow',10.00,35.50,76,'male','L2Pet','npc',40,8595,23.310,1972,4.830,40,43,30,21,20,25,0,0,629,532,993,498,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7696,14633,'Nightshade','','knight_of_shadow',10.00,35.50,78,'male','L2Pet','npc',40,8857,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7697,14634,'Nightshade','','knight_of_shadow',10.00,35.50,78,'male','L2Pet','npc',40,8857,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7698,14635,'Nightshade','','knight_of_shadow',10.00,35.50,78,'male','L2Pet','npc',40,8857,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7699,14636,'Nightshade','','knight_of_shadow',10.00,35.50,78,'male','L2Pet','npc',40,8857,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7700,14637,'Nightshade','','knight_of_shadow',10.00,35.50,78,'male','L2Pet','npc',40,8857,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7701,14638,'Nightshade','','knight_of_shadow',10.00,35.50,78,'male','L2Pet','npc',40,8857,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7702,14639,'Nightshade','','knight_of_shadow',10.00,35.50,78,'male','L2Pet','npc',40,8857,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7703,14640,'Nightshade','','knight_of_shadow',10.00,35.50,78,'male','L2Pet','npc',40,8857,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7704,14641,'Nightshade','','knight_of_shadow',10.00,35.50,78,'male','L2Pet','npc',40,8857,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,555,1069,520,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7705,14642,'Nightshade','','knight_of_shadow',10.00,35.50,79,'male','L2Pet','npc',40,8981,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7706,14643,'Nightshade','','knight_of_shadow',10.00,35.50,79,'male','L2Pet','npc',40,8981,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7707,14644,'Nightshade','','knight_of_shadow',10.00,35.50,79,'male','L2Pet','npc',40,8981,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7708,14645,'Nightshade','','knight_of_shadow',10.00,35.50,79,'male','L2Pet','npc',40,8981,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7709,14646,'Nightshade','','knight_of_shadow',10.00,35.50,79,'male','L2Pet','npc',40,8981,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7710,14647,'Nightshade','','knight_of_shadow',10.00,35.50,79,'male','L2Pet','npc',40,8981,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7711,14648,'Nightshade','','knight_of_shadow',10.00,35.50,79,'male','L2Pet','npc',40,8981,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7712,14649,'Nightshade','','knight_of_shadow',10.00,35.50,79,'male','L2Pet','npc',40,8981,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7713,14650,'Nightshade','','knight_of_shadow',10.00,35.50,79,'male','L2Pet','npc',40,8981,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,558,1082,523,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7714,14651,'Nightshade','','knight_of_shadow',10.00,35.50,80,'male','L2Pet','npc',40,9101,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7715,14652,'Nightshade','','knight_of_shadow',10.00,35.50,80,'male','L2Pet','npc',40,9101,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7716,14653,'Nightshade','','knight_of_shadow',10.00,35.50,80,'male','L2Pet','npc',40,9101,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7717,14654,'Nightshade','','knight_of_shadow',10.00,35.50,80,'male','L2Pet','npc',40,9101,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7718,14655,'Nightshade','','knight_of_shadow',10.00,35.50,80,'male','L2Pet','npc',40,9101,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7719,14656,'Nightshade','','knight_of_shadow',10.00,35.50,80,'male','L2Pet','npc',40,9101,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7720,14657,'Nightshade','','knight_of_shadow',10.00,35.50,80,'male','L2Pet','npc',40,9101,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7721,14658,'Nightshade','','knight_of_shadow',10.00,35.50,80,'male','L2Pet','npc',40,9101,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7722,14659,'Nightshade','','knight_of_shadow',10.00,35.50,80,'male','L2Pet','npc',40,9101,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7723,14660,'Nightshade','','knight_of_shadow',10.00,35.50,80,'male','L2Pet','npc',40,9101,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7724,14661,'Nightshade','','knight_of_shadow',10.00,35.50,80,'male','L2Pet','npc',40,9101,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7725,14662,'Nightshade','','knight_of_shadow',10.00,35.50,80,'male','L2Pet','npc',40,9101,23.310,2143,4.830,40,43,30,21,20,25,0,0,629,562,1095,526,278,0,333,0,0,0,30,187,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.59,'false',0,0),
(7726,14663,'Mechanic Golem','','mechanic_golem',5.00,19.00,30,'male','L2Pet','npc',40,1049,8.190,421,1.750,40,43,30,21,20,25,0,0,131,140,58,130,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.72,'false',0,0),
(7727,14664,'Mechanic Golem','','mechanic_golem',5.00,19.00,38,'male','L2Pet','npc',40,1540,10.350,573,2.240,40,43,30,21,20,25,0,0,237,187,112,175,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.72,'false',0,0),
(7728,14665,'Mechanic Golem','','mechanic_golem',5.00,19.00,45,'male','L2Pet','npc',40,2057,12.420,781,2.730,40,43,30,21,20,25,0,0,376,237,188,222,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.72,'false',0,0),
(7729,14666,'Mechanic Golem','','mechanic_golem',5.00,19.00,51,'male','L2Pet','npc',40,2555,14.310,993,3.290,40,43,30,21,20,25,0,0,539,285,281,267,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.72,'false',0,0),
(7730,14667,'Mechanic Golem','','mechanic_golem',5.00,19.00,57,'male','L2Pet','npc',40,3087,16.290,1213,3.430,40,43,30,21,20,25,0,0,742,340,404,317,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.72,'false',0,0),
(7731,14668,'Mechanic Golem','','mechanic_golem',5.00,19.00,62,'male','L2Pet','npc',40,3541,18.000,1404,3.990,40,43,30,21,20,25,0,0,944,388,531,363,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.72,'false',0,0),
(7732,14669,'Mechanic Golem','','mechanic_golem',5.00,19.00,66,'male','L2Pet','npc',40,3901,19.440,1561,4.060,40,43,30,21,20,25,0,0,1121,427,649,400,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.72,'false',0,0),
(7733,14670,'Mechanic Golem','','mechanic_golem',5.00,19.00,70,'male','L2Pet','npc',40,4248,20.970,1722,4.200,40,43,30,21,20,25,0,0,1312,469,779,439,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.72,'false',0,0),
(7734,14671,'Mechanic Golem','','mechanic_golem',5.00,19.00,74,'male','L2Pet','npc',40,4574,22.500,1888,4.760,40,43,30,21,20,25,0,0,1511,511,920,479,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.72,'false',0,0),
(7735,14672,'Mechanic Golem','','mechanic_golem',5.00,19.00,78,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1723,555,1069,520,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7736,14673,'Mechanic Golem','','mechanic_golem',5.00,19.00,78,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1732,555,1069,520,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7737,14674,'Mechanic Golem','','mechanic_golem',5.00,19.00,78,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1740,555,1069,520,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7738,14675,'Mechanic Golem','','mechanic_golem',5.00,19.00,78,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1749,555,1069,520,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7739,14676,'Mechanic Golem','','mechanic_golem',5.00,19.00,78,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1757,555,1069,520,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7740,14677,'Mechanic Golem','','mechanic_golem',5.00,19.00,78,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1766,555,1069,520,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7741,14678,'Mechanic Golem','','mechanic_golem',5.00,19.00,78,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1775,555,1069,520,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7742,14679,'Mechanic Golem','','mechanic_golem',5.00,19.00,78,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1783,555,1069,520,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7743,14680,'Mechanic Golem','','mechanic_golem',5.00,19.00,78,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1792,555,1069,520,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7744,14681,'Mechanic Golem','','mechanic_golem',5.00,19.00,79,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1811,558,1082,523,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7745,14682,'Mechanic Golem','','mechanic_golem',5.00,19.00,79,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1820,558,1082,523,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7746,14683,'Mechanic Golem','','mechanic_golem',5.00,19.00,79,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1828,558,1082,523,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7747,14684,'Mechanic Golem','','mechanic_golem',5.00,19.00,79,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1837,558,1082,523,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7748,14685,'Mechanic Golem','','mechanic_golem',5.00,19.00,79,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1846,558,1082,523,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7749,14686,'Mechanic Golem','','mechanic_golem',5.00,19.00,79,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1854,558,1082,523,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7750,14687,'Mechanic Golem','','mechanic_golem',5.00,19.00,79,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1863,558,1082,523,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7751,14688,'Mechanic Golem','','mechanic_golem',5.00,19.00,79,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1871,558,1082,523,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7752,14689,'Mechanic Golem','','mechanic_golem',5.00,19.00,79,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1880,558,1082,523,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7753,14690,'Mechanic Golem','','mechanic_golem',5.00,19.00,80,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1900,562,1095,526,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7754,14691,'Mechanic Golem','','mechanic_golem',5.00,19.00,80,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1909,562,1095,526,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7755,14692,'Mechanic Golem','','mechanic_golem',5.00,19.00,80,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1917,562,1095,526,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7756,14693,'Mechanic Golem','','mechanic_golem',5.00,19.00,80,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1926,562,1095,526,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7757,14694,'Mechanic Golem','','mechanic_golem',5.00,19.00,80,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1935,562,1095,526,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7758,14695,'Mechanic Golem','','mechanic_golem',5.00,19.00,80,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1943,562,1095,526,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7759,14696,'Mechanic Golem','','mechanic_golem',5.00,19.00,80,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1952,562,1095,526,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7760,14697,'Mechanic Golem','','mechanic_golem',5.00,19.00,80,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1961,562,1095,526,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7761,14698,'Mechanic Golem','','mechanic_golem',5.00,19.00,80,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1969,562,1095,526,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7762,14699,'Mechanic Golem','','mechanic_golem',5.00,19.00,80,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1978,562,1095,526,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7763,14700,'Mechanic Golem','','mechanic_golem',5.00,19.00,80,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1987,562,1095,526,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7764,14701,'Mechanic Golem','','mechanic_golem',5.00,19.00,80,'male','L2Pet','npc',40,5025,22.500,2143,4.760,40,43,30,21,20,25,0,0,1995,562,1095,526,278,0,333,0,0,0,30,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.72,'false',0,0),
(7765,14702,'Big Boom','','big_boom',6.00,13.00,60,'male','L2Pet','npc',40,3054,17.280,1327,3.500,40,43,30,21,20,25,0,0,860,368,477,345,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7766,14703,'Big Boom','','big_boom',6.00,13.00,64,'male','L2Pet','npc',40,3384,18.720,1482,4.060,40,43,30,21,20,25,0,0,1031,408,588,381,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7767,14704,'Big Boom','','big_boom',6.00,13.00,68,'male','L2Pet','npc',40,3706,20.250,1641,4.130,40,43,30,21,20,25,0,0,1217,449,713,420,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7768,14705,'Big Boom','','big_boom',6.00,13.00,72,'male','L2Pet','npc',40,4013,21.780,1804,4.760,40,43,30,21,20,25,0,0,1412,491,848,459,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7769,14706,'Big Boom','','big_boom',6.00,13.00,76,'male','L2Pet','npc',40,4297,23.310,1972,4.830,40,43,30,21,20,25,0,0,1613,532,993,498,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7770,14707,'Big Boom','','big_boom',6.00,13.00,78,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7771,14708,'Big Boom','','big_boom',6.00,13.00,78,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7772,14709,'Big Boom','','big_boom',6.00,13.00,78,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7773,14710,'Big Boom','','big_boom',6.00,13.00,78,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7774,14711,'Big Boom','','big_boom',6.00,13.00,78,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7775,14712,'Big Boom','','big_boom',6.00,13.00,78,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7776,14713,'Big Boom','','big_boom',6.00,13.00,78,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7777,14714,'Big Boom','','big_boom',6.00,13.00,78,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7778,14715,'Big Boom','','big_boom',6.00,13.00,78,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7779,14716,'Big Boom','','big_boom',6.00,13.00,79,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7780,14717,'Big Boom','','big_boom',6.00,13.00,79,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7781,14718,'Big Boom','','big_boom',6.00,13.00,79,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7782,14719,'Big Boom','','big_boom',6.00,13.00,79,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7783,14720,'Big Boom','','big_boom',6.00,13.00,79,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7784,14721,'Big Boom','','big_boom',6.00,13.00,79,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7785,14722,'Big Boom','','big_boom',6.00,13.00,79,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7786,14723,'Big Boom','','big_boom',6.00,13.00,79,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7787,14724,'Big Boom','','big_boom',6.00,13.00,79,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7788,14725,'Big Boom','','big_boom',6.00,13.00,80,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7789,14726,'Big Boom','','big_boom',6.00,13.00,80,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7790,14727,'Big Boom','','big_boom',6.00,13.00,80,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7791,14728,'Big Boom','','big_boom',6.00,13.00,80,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7792,14729,'Big Boom','','big_boom',6.00,13.00,80,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7793,14730,'Big Boom','','big_boom',6.00,13.00,80,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7794,14731,'Big Boom','','big_boom',6.00,13.00,80,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7795,14732,'Big Boom','','big_boom',6.00,13.00,80,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7796,14733,'Big Boom','','big_boom',6.00,13.00,80,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7797,14734,'Big Boom','','big_boom',6.00,13.00,80,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7798,14735,'Big Boom','','big_boom',6.00,13.00,80,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7799,14736,'Big Boom','','big_boom',6.00,13.00,80,'male','L2Pet','npc',40,4550,24.840,2143,4.900,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,48,154,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7800,14737,'Siege Golem','','siege_golem',60.00,140.00,55,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,2592,1205,360,1242,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7801,14738,'Siege Golem','','siege_golem',60.00,140.00,78,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3036,1397,484,1440,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7802,14739,'Siege Golem','','siege_golem',60.00,140.00,78,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3066,1397,484,1440,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7803,14740,'Siege Golem','','siege_golem',60.00,140.00,78,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3096,1397,484,1440,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7804,14741,'Siege Golem','','siege_golem',60.00,140.00,78,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3126,1397,484,1440,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7805,14742,'Siege Golem','','siege_golem',60.00,140.00,78,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3156,1397,484,1440,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7806,14743,'Siege Golem','','siege_golem',60.00,140.00,78,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3186,1397,484,1440,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7807,14744,'Siege Golem','','siege_golem',60.00,140.00,78,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3216,1397,484,1440,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7808,14745,'Siege Golem','','siege_golem',60.00,140.00,78,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3246,1397,484,1440,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7809,14746,'Siege Golem','','siege_golem',60.00,140.00,78,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3276,1397,484,1440,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7810,14747,'Siege Golem','','siege_golem',60.00,140.00,79,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3326,1406,490,1449,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7811,14748,'Siege Golem','','siege_golem',60.00,140.00,79,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3356,1406,490,1449,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7812,14749,'Siege Golem','','siege_golem',60.00,140.00,79,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3386,1406,490,1449,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7813,14750,'Siege Golem','','siege_golem',60.00,140.00,79,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3417,1406,490,1449,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7814,14751,'Siege Golem','','siege_golem',60.00,140.00,79,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3447,1406,490,1449,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7815,14752,'Siege Golem','','siege_golem',60.00,140.00,79,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3477,1406,490,1449,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7816,14753,'Siege Golem','','siege_golem',60.00,140.00,79,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3507,1406,490,1449,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7817,14754,'Siege Golem','','siege_golem',60.00,140.00,79,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3538,1406,490,1449,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7818,14755,'Siege Golem','','siege_golem',60.00,140.00,79,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3568,1406,490,1449,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7819,14756,'Siege Golem','','siege_golem',60.00,140.00,80,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3619,1414,496,1457,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7820,14757,'Siege Golem','','siege_golem',60.00,140.00,80,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3650,1414,496,1457,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7821,14758,'Siege Golem','','siege_golem',60.00,140.00,80,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3680,1414,496,1457,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7822,14759,'Siege Golem','','siege_golem',60.00,140.00,80,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3711,1414,496,1457,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7823,14760,'Siege Golem','','siege_golem',60.00,140.00,80,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3741,1414,496,1457,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7824,14761,'Siege Golem','','siege_golem',60.00,140.00,80,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3772,1414,496,1457,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7825,14762,'Siege Golem','','siege_golem',60.00,140.00,80,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3802,1414,496,1457,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7826,14763,'Siege Golem','','siege_golem',60.00,140.00,80,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3832,1414,496,1457,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7827,14764,'Siege Golem','','siege_golem',60.00,140.00,80,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3863,1414,496,1457,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7828,14765,'Siege Golem','','siege_golem',60.00,140.00,80,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3893,1414,496,1457,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7829,14766,'Siege Golem','','siege_golem',60.00,140.00,80,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3924,1414,496,1457,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7830,14767,'Siege Golem','','siege_golem',60.00,140.00,80,'male','L2Pet','npc',80,795000,15.570,1138,3.360,40,43,30,21,20,25,0,0,3954,1414,496,1457,165,0,333,0,0,0,40,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7831,14768,'Wild Hog Cannon','','range_golem',93.00,90.00,60,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,886,709,477,730,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7832,14769,'Wild Hog Cannon','','range_golem',93.00,90.00,78,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1012,794,601,818,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7833,14770,'Wild Hog Cannon','','range_golem',93.00,90.00,78,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1022,794,601,818,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7834,14771,'Wild Hog Cannon','','range_golem',93.00,90.00,78,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1032,794,601,818,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7835,14772,'Wild Hog Cannon','','range_golem',93.00,90.00,78,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1042,794,601,818,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7836,14773,'Wild Hog Cannon','','range_golem',93.00,90.00,78,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1052,794,601,818,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7837,14774,'Wild Hog Cannon','','range_golem',93.00,90.00,78,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1062,794,601,818,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7838,14775,'Wild Hog Cannon','','range_golem',93.00,90.00,78,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1072,794,601,818,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7839,14776,'Wild Hog Cannon','','range_golem',93.00,90.00,78,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1082,794,601,818,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7840,14777,'Wild Hog Cannon','','range_golem',93.00,90.00,78,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1092,794,601,818,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7841,14778,'Wild Hog Cannon','','range_golem',93.00,90.00,79,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1108,799,608,823,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7842,14779,'Wild Hog Cannon','','range_golem',93.00,90.00,79,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1118,799,608,823,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7843,14780,'Wild Hog Cannon','','range_golem',93.00,90.00,79,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1128,799,608,823,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7844,14781,'Wild Hog Cannon','','range_golem',93.00,90.00,79,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1139,799,608,823,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7845,14782,'Wild Hog Cannon','','range_golem',93.00,90.00,79,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1149,799,608,823,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7846,14783,'Wild Hog Cannon','','range_golem',93.00,90.00,79,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1159,799,608,823,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7847,14784,'Wild Hog Cannon','','range_golem',93.00,90.00,79,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1169,799,608,823,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7848,14785,'Wild Hog Cannon','','range_golem',93.00,90.00,79,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1179,799,608,823,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7849,14786,'Wild Hog Cannon','','range_golem',93.00,90.00,79,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1189,799,608,823,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7850,14787,'Wild Hog Cannon','','range_golem',93.00,90.00,80,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1206,804,615,828,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7851,14788,'Wild Hog Cannon','','range_golem',93.00,90.00,80,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1216,804,615,828,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7852,14789,'Wild Hog Cannon','','range_golem',93.00,90.00,80,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1226,804,615,828,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7853,14790,'Wild Hog Cannon','','range_golem',93.00,90.00,80,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1237,804,615,828,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7854,14791,'Wild Hog Cannon','','range_golem',93.00,90.00,80,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1247,804,615,828,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7855,14792,'Wild Hog Cannon','','range_golem',93.00,90.00,80,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1257,804,615,828,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7856,14793,'Wild Hog Cannon','','range_golem',93.00,90.00,80,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1267,804,615,828,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7857,14794,'Wild Hog Cannon','','range_golem',93.00,90.00,80,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1277,804,615,828,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7858,14795,'Wild Hog Cannon','','range_golem',93.00,90.00,80,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1287,804,615,828,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7859,14796,'Wild Hog Cannon','','range_golem',93.00,90.00,80,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1297,804,615,828,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7860,14797,'Wild Hog Cannon','','range_golem',93.00,90.00,80,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1308,804,615,828,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7861,14798,'Wild Hog Cannon','','range_golem',93.00,90.00,80,'male','L2Pet','npc',40,3153,17.280,1327,3.500,40,43,30,21,20,25,0,0,1318,804,615,828,278,0,333,0,0,0,10,10,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7862,14799,'Dark Panther','','dark_fencer',7.00,13.00,42,'male','L2Pet','npc',40,1837,11.520,679,2.660,40,43,30,21,20,25,0,0,311,214,152,201,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.20,'false',0,0),
(7863,14800,'Dark Panther','','dark_fencer',7.00,13.00,51,'male','L2Pet','npc',40,2571,14.310,993,3.290,40,43,30,21,20,25,0,0,539,285,281,267,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.20,'false',0,0),
(7864,14801,'Dark Panther','','dark_fencer',7.00,13.00,60,'male','L2Pet','npc',40,3381,17.280,1327,3.500,40,43,30,21,20,25,0,0,860,368,477,345,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.20,'false',0,0),
(7865,14802,'Dark Panther','','dark_fencer',7.00,13.00,64,'male','L2Pet','npc',40,3746,18.720,1482,4.060,40,43,30,21,20,25,0,0,1031,408,588,381,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.20,'false',0,0),
(7866,14803,'Dark Panther','','dark_fencer',7.00,13.00,68,'male','L2Pet','npc',40,4102,20.250,1641,4.130,40,43,30,21,20,25,0,0,1217,449,713,420,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.20,'false',0,0),
(7867,14804,'Dark Panther','','dark_fencer',7.00,13.00,72,'male','L2Pet','npc',40,4442,21.780,1804,4.760,40,43,30,21,20,25,0,0,1412,491,848,459,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.20,'false',0,0),
(7868,14805,'Dark Panther','','dark_fencer',7.00,13.00,76,'male','L2Pet','npc',40,4757,23.310,1972,4.830,40,43,30,21,20,25,0,0,1613,532,993,498,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.20,'false',0,0),
(7869,14806,'Dark Panther','','dark_fencer',7.00,13.00,78,'male','L2Pet','npc',40,4871,24.120,2057,4.900,40,43,30,21,20,25,0,0,1713,554,1068,519,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7870,14807,'Dark Panther','','dark_fencer',7.00,13.00,78,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1732,555,1069,520,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7871,14808,'Dark Panther','','dark_fencer',7.00,13.00,78,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1740,555,1069,520,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7872,14809,'Dark Panther','','dark_fencer',7.00,13.00,78,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1749,555,1069,520,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7873,14810,'Dark Panther','','dark_fencer',7.00,13.00,78,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1757,555,1069,520,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7874,14811,'Dark Panther','','dark_fencer',7.00,13.00,78,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1766,555,1069,520,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7875,14812,'Dark Panther','','dark_fencer',7.00,13.00,78,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1775,555,1069,520,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7876,14813,'Dark Panther','','dark_fencer',7.00,13.00,78,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1783,555,1069,520,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7877,14814,'Dark Panther','','dark_fencer',7.00,13.00,78,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1792,555,1069,520,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7878,14815,'Dark Panther','','dark_fencer',7.00,13.00,79,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1811,558,1082,523,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7879,14816,'Dark Panther','','dark_fencer',7.00,13.00,79,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1820,558,1082,523,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7880,14817,'Dark Panther','','dark_fencer',7.00,13.00,79,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1828,558,1082,523,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7881,14818,'Dark Panther','','dark_fencer',7.00,13.00,79,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1837,558,1082,523,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7882,14819,'Dark Panther','','dark_fencer',7.00,13.00,79,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1846,558,1082,523,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7883,14820,'Dark Panther','','dark_fencer',7.00,13.00,79,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1854,558,1082,523,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7884,14821,'Dark Panther','','dark_fencer',7.00,13.00,79,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1863,558,1082,523,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7885,14822,'Dark Panther','','dark_fencer',7.00,13.00,79,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1871,558,1082,523,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7886,14823,'Dark Panther','','dark_fencer',7.00,13.00,79,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1880,558,1082,523,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7887,14824,'Dark Panther','','dark_fencer',7.00,13.00,80,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1900,562,1095,526,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7888,14825,'Dark Panther','','dark_fencer',7.00,13.00,80,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1909,562,1095,526,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7889,14826,'Dark Panther','','dark_fencer',7.00,13.00,80,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1917,562,1095,526,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7890,14827,'Dark Panther','','dark_fencer',7.00,13.00,80,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1926,562,1095,526,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7891,14828,'Dark Panther','','dark_fencer',7.00,13.00,80,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1935,562,1095,526,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7892,14829,'Dark Panther','','dark_fencer',7.00,13.00,80,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1943,562,1095,526,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7893,14830,'Dark Panther','','dark_fencer',7.00,13.00,80,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1952,562,1095,526,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7894,14831,'Dark Panther','','dark_fencer',7.00,13.00,80,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1961,562,1095,526,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7895,14832,'Dark Panther','','dark_fencer',7.00,13.00,80,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1969,562,1095,526,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7896,14833,'Dark Panther','','dark_fencer',7.00,13.00,80,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1978,562,1095,526,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7897,14834,'Dark Panther','','dark_fencer',7.00,13.00,80,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1987,562,1095,526,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7898,14835,'Dark Panther','','dark_fencer',7.00,13.00,80,'male','L2Pet','npc',40,5025,24.120,2143,4.900,40,43,30,21,20,25,0,0,1995,562,1095,526,278,0,333,0,0,0,25,165,'',0,'LEXX','',0,0,0,7,50,4,4,0,0,0.20,'false',0,0),
(7899,14836,'Feline King','','king_of_cat',6.00,16.01,80,'male','L2Pet','npc',40,4550,27.700,2143,7.100,40,43,30,21,20,25,0,0,2647,437,1671,490,278,0,333,0,0,0,52,190,NULL,NULL,'Magister',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(7900,14837,'Magnus the Unicorn','','unicorn_magnus',13.50,17.00,80,'male','L2Pet','npc',40,4550,27.700,2143,7.100,40,43,30,21,20,25,0,0,2647,437,1671,490,278,0,333,0,0,0,52,190,NULL,NULL,'Magister',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(7901,14838,'Spectral Lord','','spectral_knight',12.50,33.50,80,'male','L2Pet','npc',40,4550,27.700,2143,7.100,40,43,30,21,20,25,0,0,2647,437,1671,490,278,0,333,0,0,0,52,190,NULL,NULL,'Magister',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.00,'false',0,0),
(7902,14839,'Swoop Cannon','','toad_cannon',45.00,47.50,68,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7903,14840,'Swoop Cannon','','toad_cannon',45.00,47.50,69,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7904,14841,'Swoop Cannon','','toad_cannon',45.00,47.50,70,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7905,14842,'Swoop Cannon','','toad_cannon',45.00,47.50,71,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7906,14843,'Swoop Cannon','','toad_cannon',45.00,47.50,72,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7907,14844,'Swoop Cannon','','toad_cannon',45.00,47.50,73,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7908,14845,'Swoop Cannon','','toad_cannon',45.00,47.50,74,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7909,14846,'Swoop Cannon','','toad_cannon',45.00,47.50,75,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7910,14847,'Swoop Cannon','','toad_cannon',45.00,47.50,76,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7911,14848,'Swoop Cannon','','toad_cannon',45.00,47.50,77,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7912,14849,'Swoop Cannon','','toad_cannon',45.00,47.50,78,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7913,14850,'Swoop Cannon','','toad_cannon',45.00,47.50,79,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7914,14851,'Swoop Cannon','','toad_cannon',45.00,47.50,80,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7915,14852,'Swoop Cannon','','toad_cannon',45.00,47.50,81,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7916,14853,'Swoop Cannon','','toad_cannon',45.00,47.50,82,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7917,14854,'Swoop Cannon','','toad_cannon',45.00,47.50,83,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7918,14855,'Swoop Cannon','','toad_cannon',45.00,47.50,84,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7919,14856,'Swoop Cannon','','toad_cannon',45.00,47.50,85,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7920,14857,'Swoop Cannon','','toad_cannon',45.00,47.50,86,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7921,14858,'Swoop Cannon','','toad_cannon',45.00,47.50,87,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7922,14859,'Swoop Cannon','','toad_cannon',45.00,47.50,88,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7923,14860,'Swoop Cannon','','toad_cannon',45.00,47.50,89,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7924,14861,'Swoop Cannon','','toad_cannon',45.00,47.50,90,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7925,14862,'Swoop Cannon','','toad_cannon',45.00,47.50,91,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7926,14863,'Swoop Cannon','','toad_cannon',45.00,47.50,92,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7927,14864,'Swoop Cannon','','toad_cannon',45.00,47.50,93,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7928,14865,'Swoop Cannon','','toad_cannon',45.00,47.50,94,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7929,14866,'Swoop Cannon','','toad_cannon',45.00,47.50,95,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7930,14867,'Swoop Cannon','','toad_cannon',45.00,47.50,96,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7931,14868,'Swoop Cannon','','toad_cannon',45.00,47.50,97,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7932,14869,'Swoop Cannon','','toad_cannon',45.00,47.50,98,'male','L2Pet','npc',40,790000,20.250,1138,4.130,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'LEXX','',0,0,0,7,30,4,4,0,0,0.69,'false',0,0),
(7933,16013,'Trained Buffalo','','buffalo',22.00,31.00,67,'male','L2TamedBeast','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,0,0,1169,439,681,356,278,0,253,0,0,0,20,170,'pet_clan',400,'Local','',0,0,0,15,30,4,4,0,0,0.46,'false',0,0),
(7934,16014,'Trained Buffalo','','buffalo',22.00,31.00,67,'male','L2TamedBeast','Fighter',40,3626,15.000,1388,2.700,40,43,30,21,20,10,0,0,1169,439,681,356,278,0,253,0,0,0,20,170,'pet_clan',400,'Local','',0,0,0,15,30,4,4,0,0,0.46,'false',0,0),
(7935,16015,'Trained Cougar','','saber_toothed_tiger',12.00,22.00,69,'male','L2TamedBeast','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,0,0,1265,460,746,373,278,0,253,0,0,0,60,175,'pet_clan',400,'Local','',0,0,0,15,30,4,4,0,0,0.45,'false',0,0),
(7936,16016,'Trained Cougar','','saber_toothed_tiger',12.00,22.00,69,'male','L2TamedBeast','Fighter',40,3784,15.000,1458,2.700,40,43,30,21,20,10,0,0,1265,460,746,373,278,0,253,0,0,0,60,175,'pet_clan',400,'Local','',0,0,0,15,30,4,4,0,0,0.45,'false',0,0),
(7937,16017,'Trained Kookaburra','','pet_ostrich',10.00,33.00,65,'male','L2TamedBeast','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,23,190,'pet_clan',400,'Local','',0,0,0,15,30,4,4,0,0,0.50,'false',0,0),
(7938,16018,'Trained Kookaburra','','pet_ostrich',10.00,33.00,65,'male','L2TamedBeast','Fighter',40,3465,15.000,1319,2.700,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,23,190,'pet_clan',400,'Local','',0,0,0,15,30,4,4,0,0,0.50,'false',0,0),
(7939,16019,'Tiny Baby Buffalo','','baby_buffalo',12.00,15.00,0,'male','L2Pet','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,0.48,'false',1,0),
(7940,16020,'Tame Tiny Baby Buffalo','','baby_buffalo',12.00,15.00,0,'male','L2Pet','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,0.48,'false',0,0),
(7941,16021,'Tiny Baby Cougar','','baby_tiger',11.00,15.70,0,'male','L2Pet','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,28,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,0.48,'false',1,0),
(7942,16022,'Tame Tiny Baby Cougar','','baby_tiger',11.00,15.70,0,'male','L2Pet','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,28,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,0.48,'false',0,0),
(7943,16023,'Tiny Baby Kookaburra','','baby_ostrich',7.00,15.00,0,'male','L2Pet','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,0.48,'false',1,0),
(7944,16024,'Tame Tiny Baby Kookaburra','','baby_ostrich',7.00,15.00,0,'male','L2Pet','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,0.48,'false',0,0),
(7945,16025,'Great Wolf','','Pet_Wolf_B',32.00,21.41,55,'male','L2Pet','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7946,16026,'Beastly Agathion','','Agathion_BF',9.00,11.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7947,16027,'Rainbow Agathion','','Agathion_RA',11.00,6.70,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7948,16028,'Lord Agathion','','Agathion_CL',3.00,9.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7949,16029,'Fortress Agasion','','Agathion_FT',1.00,3.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7950,16030,'Great Wolf','','LineageMonster4.Pet_Wolf_ba','32.00','23.56',80,'male','L2Pet','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7951,12077,'Wolf','','pet_wolf',13.00,11.50,15,'male','L2Pet','npc',40,195,2.500,164,1.200,40,43,30,21,20,25,0,0,9,19,3,17,282,0,257,0,0,0,24,125,'',0,'Local','',0,0,0,1200,7,4,4,0,0,0.39,'false',0,0),
(7952,12311,'Hatchling of the Wind','','hatchling',9.00,10.00,35,'male','L2Pet','npc',40,610,4.500,433,1.800,40,43,30,21,20,25,0,0,48,42,22,39,282,0,257,0,0,0,80,140,'',0,'Local','',0,0,0,1200,7,4,4,0,0,0.27,'false',0,0),
(7953,12312,'Hatchling of the Stars','','hatchling',9.00,10.00,35,'male','L2Pet','npc',40,610,4.500,433,1.800,40,43,30,21,20,25,0,0,48,42,22,39,282,0,257,0,0,0,80,140,'',0,'Local','',0,0,0,1200,7,4,4,0,0,0.27,'false',0,0),
(7954,12313,'Hatchling of Twilight','','hatchling',9.00,10.00,35,'male','L2Pet','npc',40,610,4.500,433,1.800,40,43,30,21,20,25,0,0,48,42,22,39,282,0,257,0,0,0,80,140,'',0,'Local','',0,0,0,1200,7,4,4,0,0,0.27,'false',0,0),
(7955,12526,'Wind Strider','','strider',23.00,31.00,55,'male','L2Pet','npc',40,2728,6.500,1138,2.400,40,43,30,21,20,25,0,0,703,332,360,301,282,0,257,0,0,0,80,170,'',0,'Local','',0,0,0,1200,30,4,4,0,0,0.25,'false',0,0),
(7956,12527,'Star Strider','','strider',23.00,31.00,55,'male','L2Pet','npc',40,2728,6.500,1138,2.400,40,43,30,21,20,25,0,0,703,332,360,301,282,0,257,0,0,0,80,170,'',0,'Local','',0,0,0,1200,30,4,4,0,0,0.25,'false',0,0),
(7957,12528,'Twilight Strider','','strider',23.00,31.00,55,'male','L2Pet','npc',40,2728,6.500,1138,2.400,40,43,30,21,20,25,0,0,703,332,360,301,282,0,257,0,0,0,80,170,'',0,'Local','',0,0,0,1200,30,4,4,0,0,0.25,'false',0,0),
(7958,12564,'Sin Eater','','imp',10.00,24.00,15,'male','L2Pet','npc',40,195,2.500,164,1.200,40,1,30,21,20,25,0,0,9,19,3,17,282,0,257,0,0,0,60,125,'',0,'Local','',0,0,0,1200,7,4,4,0,0,0.34,'false',0,0),
(7959,12621,'Wyvern','','wyvern',60.00,80.00,70,'male','L2Monster','Fighter',40,3862,7.500,1722,2.700,40,43,30,21,20,25,0,0,1335,470,780,440,282,0,257,0,0,0,80,170,'',0,'Local','',0,0,0,1200,30,4,4,0,0,0.60,'true',0,0),
(7960,12780,'Baby Buffalo','','baby_buffalo',12.00,15.00,25,'male','L2Pet','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,0.48,'false',0,0),
(7961,12781,'Baby Kookaburra','','baby_ostrich',7.00,15.00,25,'male','L2Pet','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,13,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,0.50,'false',0,0),
(7962,12782,'Baby Cougar','','baby_tiger',11.00,15.70,25,'male','L2Pet','npc',40,751,1.500,331,1.500,40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,28,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,0.48,'false',0,0),
(7963,12774,'Young Squash','','drop_gourd_50_sm',10.00,10.50,1,'etc','L2Monster','Fighter',40,10,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7964,12775,'High Quality Squash','','drop_gourd',20.00,21.00,1,'etc','L2Monster','Fighter',40,20,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7965,12776,'Low Quality Squash','','drop_gourd_25_sm',15.00,16.00,1,'etc','L2Monster','Fighter',40,20,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7966,12777,'Large Young Squash','','drop_gourd',20.00,21.00,1,'etc','L2Monster','Fighter',40,25,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7967,12778,'High Quality Large Squash','','drop_gourd_50_bi',30.00,31.50,1,'etc','L2Monster','Fighter',40,50,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7968,12779,'Low Quality Large Squash','','drop_gourd_25_bi',25.00,26.50,1,'etc','L2Monster','Fighter',40,50,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7969,13001,'Heart of Warding','','heart_of_warding',17.00,75.00,70,'etc','L2Merchant','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',1,0),
(7970,13002,'Life Control Tower','','alive_castle_aden_controltower_jewel',7.00,35.00,20,'etc','L2ControlTower','npc',40,10000,50.000,213,1.200,40,43,30,21,20,10,40,0,57,837,23,674,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(7971,13003,'Life Control Tower','','dead_castle_aden_controltower_jewel',7.00,35.00,20,'etc','L2FakeTower','npc',40,10000,50.000,213,1.200,40,43,30,21,20,10,40,0,57,837,23,674,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(7972,13004,'Flame Control Tower','','alive_castle_aden_controltower_jewel',7.00,35.00,20,'etc','L2ControlTower','npc',40,10000,50.000,213,1.200,40,43,30,21,20,10,40,0,57,837,23,674,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(7973,13005,'Flame Control Tower','','dead_castle_aden_controltower_jewel',7.00,35.00,20,'etc','L2FakeTower','npc',40,10000,50.000,213,1.200,40,43,30,21,20,10,40,0,57,837,23,674,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,0.60,'false',0,0),
(7974,13006,'Christmas Tree','','x_mas_tree',0.00,0.00,70,'male','L2XmassTree','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7975,13007,'Special Christmas Tree','','x_mas_tree_50_bi',0.00,0.00,70,'male','L2XmassTree','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7976,13014,'','','clear_npc',0.10,0.10,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7977,13015,'','','Evilate_weather',16.00,18.50,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7978,13016,'King Squash','','drop_gourd',20.00,21.00,1,'etc','L2Monster','Fighter',40,75,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7979,13017,'Emperor Squash','','drop_gourd_50_bi',30.00,31.50,1,'etc','L2Monster','Fighter',40,100,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(7980,13018,'','','skill_dummy_00_a',5.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7981,13019,'','','skill_dummy_00_a',5.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7982,13020,'','','skill_dummy_00_a',5.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7983,13021,'','','skill_dummy_00_a',5.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7984,13022,'','','skill_dummy_00_a',5.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7985,13023,'','','skill_dummy_00_a',5.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7986,13024,'','','skill_dummy_00_a',5.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7987,13025,'','','skill_dummy_01_a',5.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7988,13026,'','','skill_dummy_01_a',5.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7989,13027,'','','skill_dummy_01_a',5.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7990,13028,'','','skill_dummy_01_a',5.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7991,13029,'','','skill_dummy_01_a',5.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7992,13030,'','','skill_dummy_01_a',5.00,10.00,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7993,13031,'Huge Pig','','E_pig_ball',15.00,18.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7994,13032,'Huge Pig','','E_pig_ball',15.00,18.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7995,13033,'Huge Pig','','E_pig_ball',15.00,18.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7996,13034,'Super Huge Pig','','E_pig_ball_H',29.00,38.70,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7997,13035,'Golden Pig','','E_pig_ball',15.00,18.30,70,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(7998,13036,'Alchemist''s Chest','','mimic_even',8.50,8.50,1,'etc','L2Monster','Fighter',40,205,0.900,0,0.000,40,43,30,21,20,10,0,0,4,41,3,33,278,0,253,0,0,0,30,80,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.60,'false',0,0),
(8033,13071,'Virtual Image','','Decoy_Medium',8.50,25.00,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(8034,13072,'Virtual Image','','Decoy_Medium',8.50,25.00,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(8035,13073,'Virtual Image','','Decoy_Medium',8.50,25.00,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(8036,13074,'Virtual Image','','Decoy_Medium',8.50,25.00,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(8037,13075,'Virtual Image','','Decoy_Medium',8.50,25.00,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(8038,13076,'Virtual Image','','Decoy_Medium',8.50,25.00,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(8039,13077,'Onyx Beast','','onyx_beast',14.00,14.50,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(8040,13078,'Doom Wraith','','death_blader_tr',13.00,25.00,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(8041,13079,'Grail Apostle','','apostle_grail_tr',10.00,35.00,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(8042,13080,'Grail Apostle','','apostle_warrior',8.00,30.00,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(8043,13081,'Unicorn','','Unicorn_tr',15.00,28.00,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(8044,13082,'Lilim Knight','','lilim_knight_tr',12.00,25.50,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(8045,13083,'Golem Guardian','','golem_guardian_tr',13.00,25.00,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0);
INSERT INTO `npc` (`ordinal`,`id`,`name`,`title`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`ai_type`,`attackrange`,`hp`,`base_hp_regen`,`mp`,`base_mp_regen`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`last_editor`,`last_changed`,`displayId`,`shield_defense_rate`,`shield_defense`,`corpse_time`,`base_rand_dam`,`base_critical`,`physical_hit_modify`,`base_reuse_delay`,`physical_avoid_modify`,`hit_time_factor`,`isDropHerbs`,`map_flag`,`boss_flag`) VALUES
(8048,13086,'Zariche','','Avatar_Z',12.00,31.57,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0),
(8049,13087,'Akamanah','','Avatar_A',10.00,32.73,30,'male','L2Npc','npc',40,3862,7.500,1493,2.700,40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,0.52,'false',0,0);

ALTER TABLE `npc` ADD `shots` ENUM("NONE", "SOUL", "SPIRIT", "BSPIRIT", "SOUL_SPIRIT", "SOUL_BSPIRIT") NOT NULL DEFAULT 'NONE' AFTER `isDropHerbs`;
UPDATE `npc` SET `shots` = 'SOUL' WHERE `id`=21306;

-- Соски для Кетров
-- SELECT id,name,ai_type,shots FROM npc WHERE name like "%Ketra%";
UPDATE npc SET shots = "SOUL" WHERE name like "%Ketra%" AND ai_type = "Fighter";
UPDATE npc SET shots = "SOUL" WHERE name like "%Ketra%" AND ai_type = "Ranger";
UPDATE npc SET shots = "SOUL_BSPIRIT" WHERE name like "%Ketra%" AND ai_type = "Priest";
UPDATE npc SET shots = "NONE" WHERE ID = 21325;

-- Соски для Варки
-- SELECT id,name,ai_type,shots FROM npc WHERE name like "%Varka%";
UPDATE npc SET shots = "SOUL" WHERE name like "%Varka%" AND ai_type = "Fighter";
UPDATE npc SET shots = "SOUL" WHERE name like "%Varka%" AND ai_type = "Ranger";
UPDATE npc SET shots = "SOUL_BSPIRIT" WHERE name like "%Varka%" AND ai_type = "Priest";
UPDATE npc SET shots = "SOUL_BSPIRIT" WHERE name like "%Varka%" AND ai_type = "Mystic";